/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/resources","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/arrays","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/objects","fs","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/uuid","vs/base/common/json","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/process","vs/base/common/map","os","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","child_process","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","util","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/code/electron-browser/sharedProcess/contrib/nodeCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(K){for(var e=[],S=0,k=K.length;S<k;S++)e[S]=Z[K[S]];return e};define(Z[84],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function S(k,A){if(!k)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=S}),define(Z[62],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const S=Object.prototype.hasOwnProperty;function k(R){const f=[];for(let y in R)S.call(R,y)&&f.push(R[y]);return f}e.values=k;function A(R,f){for(let y in R)if(S.call(R,y)&&f({key:y,value:R[y]},function(){delete R[y]})===!1)return}e.forEach=A;function L(R,f){const y=Object.create(null);for(const I of R){const a=f(I);let b=y[a];b||(b=y[a]=[]),b.push(I)}return y}e.groupBy=L;function U(R){const f=Object.create(null);return R&&R.forEach((y,I)=>{f[I]=y}),f}e.fromMap=U;function O(R,f){const y=[],I=[];for(let a of R)f.has(a)||y.push(a);for(let a of f)R.has(a)||I.push(a);return{removed:y,added:I}}e.diffSets=O;function g(R,f){const y=[],I=[];for(let[a,b]of R)f.has(a)||y.push(b);for(let[a,b]of f)R.has(a)||I.push(b);return{removed:y,added:I}}e.diffMaps=g;class v{constructor(){this.map=new Map}add(f,y){let I=this.map.get(f);I||(I=new Set,this.map.set(f,I)),I.add(y)}delete(f,y){const I=this.map.get(f);!I||(I.delete(y),I.size===0&&this.map.delete(f))}forEach(f,y){const I=this.map.get(f);!I||I.forEach(y)}}e.SetMap=v}),define(Z[85],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function S(g){return(v,R,f)=>{let y=null,I=null;if(typeof f.value=="function"?(y="value",I=f.value):typeof f.get=="function"&&(y="get",I=f.get),!I)throw new Error("not supported");f[y]=g(I,R)}}e.createDecorator=S;let k=0;function A(){const g=`$memoize${k++}`;let v;const R=function(y,I,a){let b=null,C=null;if(typeof a.value=="function"?(b="value",C=a.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(b="get",C=a.get),!C)throw new Error("not supported");const E=`${g}:${I}`;a[b]=function(...p){return v=this,this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!0,enumerable:!1,writable:!0,value:C.apply(this,p)}),this[E]}};return R.clear=()=>{typeof v!="undefined"&&Object.getOwnPropertyNames(v).forEach(f=>{f.indexOf(g)===0&&delete v[f]})},R}e.createMemoizer=A;function L(g,v,R){return A()(g,v,R)}e.memoize=L;function U(g,v,R){return S((f,y)=>{const I=`$debounce$${y}`,a=`$debounce$result$${y}`;return function(...b){this[a]||(this[a]=R?R():void 0),clearTimeout(this[I]),v&&(this[a]=v(this[a],...b),b=[this[a]]),this[I]=setTimeout(()=>{f.apply(this,b),this[a]=R?R():void 0},g)}})}e.debounce=U;function O(g,v,R){return S((f,y)=>{const I=`$throttle$timer$${y}`,a=`$throttle$result$${y}`,b=`$throttle$lastRun$${y}`,C=`$throttle$pending$${y}`;return function(...E){if(this[a]||(this[a]=R?R():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),v&&(this[a]=v(this[a],...E)),!this[C]){const p=this[b]+g;p<=Date.now()?(this[b]=Date.now(),f.apply(this,[this[a]]),this[a]=R?R():void 0):(this[C]=!0,this[I]=setTimeout(()=>{this[C]=!1,this[b]=Date.now(),f.apply(this,[this[a]]),this[a]=R?R():void 0},p-Date.now()))}}})}e.throttle=O}),define(Z[11],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=S,e.errorHandler=new S;function k(s){e.errorHandler.setUnexpectedErrorHandler(s)}e.setUnexpectedErrorHandler=k;function A(s){g(s)||e.errorHandler.onUnexpectedError(s)}e.onUnexpectedError=A;function L(s){g(s)||e.errorHandler.onUnexpectedExternalError(s)}e.onUnexpectedExternalError=L;function U(s){if(s instanceof Error){let{name:t,message:i}=s;const n=s.stacktrace||s.stack;return{$isError:!0,name:t,message:i,stack:n}}return s}e.transformErrorForSerialization=U;const O="Canceled";function g(s){return s instanceof Error&&s.name===O&&s.message===O}e.isPromiseCanceledError=g;class v extends Error{constructor(){super(O);this.name=this.message}}e.CancellationError=v;function R(){const s=new Error(O);return s.name=s.message,s}e.canceled=R;function f(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}e.illegalArgument=f;function y(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}e.illegalState=y;function I(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=I;function a(s){const t=new Error(`${s} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function b(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}e.getErrorMessage=b;class C extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=C;class E extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=E;class p extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=p;function m(s){const t=s;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=m;function c(s,t=Object.create(null)){const i=new Error(s);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=c}),define(Z[18],ee([0,1,11]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k($,H=0){return $[$.length-(1+H)]}e.tail=k;function A($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=A;function L($,H,q=(D,T)=>D===T){if($===H)return!0;if(!$||!H||$.length!==H.length)return!1;for(let D=0,T=$.length;D<T;D++)if(!q($[D],H[D]))return!1;return!0}e.equals=L;function U($,H,q){let D=0,T=$.length-1;for(;D<=T;){const F=(D+T)/2|0,N=q($[F],H);if(N<0)D=F+1;else if(N>0)T=F-1;else return F}return-(D+1)}e.binarySearch=U;function O($,H){let q=0,D=$.length;if(D===0)return 0;for(;q<D;){const T=Math.floor((q+D)/2);H($[T])?D=T:q=T+1}return q}e.findFirstInSorted=O;function g($,H,q){if($=$|0,$>=H.length)throw new TypeError("invalid index");let D=H[Math.floor(H.length*Math.random())],T=[],F=[],N=[];for(let V of H){const G=q(V,D);G<0?T.push(V):G>0?F.push(V):N.push(V)}return $<T.length?g($,T,q):$<T.length+N.length?N[0]:g($-(T.length+N.length),F,q)}e.quickSelect=g;function v($,H){const q=[];let D;for(const T of $.slice(0).sort(H))!D||H(D[0],T)!==0?(D=[T],q.push(D)):D.push(T);return q}e.groupBy=v;function R($,H,q){const D=[];function T(V,G,J){if(!(G===0&&J.length===0)){const Q=D[D.length-1];Q&&Q.start+Q.deleteCount===V?(Q.deleteCount+=G,Q.toInsert.push(...J)):D.push({start:V,deleteCount:G,toInsert:J})}}let F=0,N=0;for(;;){if(F===$.length){T(F,0,H.slice(N));break}if(N===H.length){T(F,$.length-F,[]);break}const V=$[F],G=H[N],J=q(V,G);J===0?(F+=1,N+=1):J<0?(T(F,1,[]),F+=1):J>0&&(T(F,0,[G]),N+=1)}return D}e.sortedDiff=R;function f($,H,q){const D=R($,H,q),T=[],F=[];for(const N of D)T.push(...$.slice(N.start,N.start+N.deleteCount)),F.push(...N.toInsert);return{removed:T,added:F}}e.delta=f;function y($,H,q){if(q===0)return[];const D=$.slice(0,q).sort(H);return a($,H,D,q,$.length),D}e.top=y;function I($,H,q,D,T){return q===0?Promise.resolve([]):new Promise((F,N)=>{(async()=>{const V=$.length,G=$.slice(0,q).sort(H);for(let J=q,Q=Math.min(q+D,V);J<V;J=Q,Q=Math.min(Q+D,V)){if(J>q&&await new Promise(ne=>setTimeout(ne)),T&&T.isCancellationRequested)throw(0,S.canceled)();a($,H,G,J,Q)}return G})().then(F,N)})}e.topAsync=I;function a($,H,q,D,T){for(const F=q.length;D<T;D++){const N=$[D];if(H(N,q[F-1])<0){q.pop();const V=O(q,G=>H(N,G)<0);q.splice(V,0,N)}}}function b($){return $.filter(H=>!!H)}e.coalesce=b;function C($){let H=0;for(let q=0;q<$.length;q++)$[q]&&($[H]=$[q],H+=1);$.length=H}e.coalesceInPlace=C;function E($,H,q){$.splice(q,0,$.splice(H,1)[0])}e.move=E;function p($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=p;function m($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=m;function c($,H){if(!H)return $.filter((D,T)=>$.indexOf(D)===T);const q=Object.create(null);return $.filter(D=>{const T=H(D);return q[T]?!1:(q[T]=!0,!0)})}e.distinct=c;function s($){const H=new Set;return $.filter(q=>H.has(q)?!1:(H.add(q),!0))}e.distinctES6=s;function t($){const H=Object.create(null);return q=>{const D=$(q);return H[D]?!1:(H[D]=!0,!0)}}e.uniqueFilter=t;function i($,H){for(let q=$.length-1;q>=0;q--){const D=$[q];if(H(D))return q}return-1}e.lastIndex=i;function n($,H){return $.length>0?$[0]:H}e.firstOrDefault=n;function o($,H,q=(D,T)=>D===T){let D=0;for(let T=0,F=Math.min($.length,H.length);T<F&&q($[T],H[T]);T++)D++;return D}e.commonPrefixLength=o;function r($){return[].concat(...$)}e.flatten=r;function l($,H){let q=typeof H=="number"?$:0;typeof H=="number"?q=$:(q=0,H=$);const D=[];if(q<=H)for(let T=q;T<H;T++)D.push(T);else for(let T=q;T>H;T--)D.push(T);return D}e.range=l;function h($,H,q){return $.reduce((D,T)=>(D[H(T)]=q?q(T):T,D),Object.create(null))}e.index=h;function d($,H){return $.push(H),()=>w($,H)}e.insert=d;function w($,H){const q=$.indexOf(H);if(q>-1)return $.splice(q,1),H}e.remove=w;function u($,H,q){const D=$.slice(0,H),T=$.slice(H);return D.concat(q,T)}e.arrayInsert=u;function P($,H){let q;if(typeof H=="number"){let D=H;q=()=>{const T=Math.sin(D++)*179426549;return T-Math.floor(T)}}else q=Math.random;for(let D=$.length-1;D>0;D-=1){const T=Math.floor(q()*(D+1)),F=$[D];$[D]=$[T],$[T]=F}}e.shuffle=P;function _($,H){const q=$.indexOf(H);q>-1&&($.splice(q,1),$.unshift(H))}e.pushToStart=_;function z($,H){const q=$.indexOf(H);q>-1&&($.splice(q,1),$.push(H))}e.pushToEnd=z;function B($,H){return Array.isArray($)?$.map(H):H($)}e.mapArrayOrNot=B;function M($){return Array.isArray($)?$:[$]}e.asArray=M;function j($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=j;function W($,H){for(const q of $){const D=H(q);if(D!==void 0)return D}}e.mapFind=W}),define(Z[63],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(k){const A=this;let L=!1,U;return function(){return L||(L=!0,U=k.apply(A,arguments)),U}}e.once=S}),define(Z[53],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(k){function A(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}k.is=A;const L=Object.freeze([]);function U(){return L}k.empty=U;function*O(s){yield s}k.single=O;function g(s){return s||L}k.from=g;function v(s){return!s||s[Symbol.iterator]().next().done===!0}k.isEmpty=v;function R(s){return s[Symbol.iterator]().next().value}k.first=R;function f(s,t){for(const i of s)if(t(i))return!0;return!1}k.some=f;function y(s,t){for(const i of s)if(t(i))return i}k.find=y;function*I(s,t){for(const i of s)t(i)&&(yield i)}k.filter=I;function*a(s,t){for(const i of s)yield t(i)}k.map=a;function*b(...s){for(const t of s)for(const i of t)yield i}k.concat=b;function*C(s){for(const t of s)for(const i of t)yield i}k.concatNested=C;function E(s,t,i){let n=i;for(const o of s)n=t(n,o);return n}k.reduce=E;function*p(s,t,i=s.length){for(t<0&&(t+=s.length),i<0?i+=s.length:i>s.length&&(i=s.length);t<i;t++)yield s[t]}k.slice=p;function m(s,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,s];const n=s[Symbol.iterator]();for(let o=0;o<t;o++){const r=n.next();if(r.done)return[i,k.empty()];i.push(r.value)}return[i,{[Symbol.iterator](){return n}}]}k.consume=m;function c(s,t,i=(n,o)=>n===o){const n=s[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const r=n.next(),l=o.next();if(r.done!==l.done)return!1;if(r.done)return!0;if(!i(r.value,l.value))return!1}}k.equals=c})(S=e.Iterable||(e.Iterable={}))}),define(Z[32],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function U(t,i=!1){let n=0,o=t.length,r="",l=0,h=16,d=0;function w(j){let W=0,$=0;for(;W<j;){const H=t.charCodeAt(n);if(H>=48&&H<=57)$=$*16+H-48;else if(H>=65&&H<=70)$=$*16+H-65+10;else if(H>=97&&H<=102)$=$*16+H-97+10;else break;n++,W++}return W<j&&($=-1),$}function u(j){n=j,r="",l=0,h=16,d=0}function P(){const j=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&v(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&v(t.charCodeAt(n)))for(n++;n<t.length&&v(t.charCodeAt(n));)n++;else return d=3,t.substring(j,n);let W=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&v(t.charCodeAt(n))){for(n++;n<t.length&&v(t.charCodeAt(n));)n++;W=n}else d=3;return t.substring(j,W)}function _(){let j="",W=n;for(;;){if(n>=o){j+=t.substring(W,n),d=2;break}const $=t.charCodeAt(n);if($===34){j+=t.substring(W,n),n++;break}if($===92){if(j+=t.substring(W,n),n++,n>=o){d=2;break}switch(t.charCodeAt(n++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:const q=w(4);q>=0?j+=String.fromCharCode(q):d=4;break;default:d=5}W=n;continue}if($>=0&&$<=31)if(g($)){j+=t.substring(W,n),d=2;break}else d=6;n++}return j}function z(){if(r="",d=0,l=n,n>=o)return l=o,h=17;let j=t.charCodeAt(n);if(O(j)){do n++,r+=String.fromCharCode(j),j=t.charCodeAt(n);while(O(j));return h=15}if(g(j))return n++,r+=String.fromCharCode(j),j===13&&t.charCodeAt(n)===10&&(n++,r+=`
`),h=14;switch(j){case 123:return n++,h=1;case 125:return n++,h=2;case 91:return n++,h=3;case 93:return n++,h=4;case 58:return n++,h=6;case 44:return n++,h=5;case 34:return n++,r=_(),h=10;case 47:const W=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<o&&!g(t.charCodeAt(n));)n++;return r=t.substring(W,n),h=12}if(t.charCodeAt(n+1)===42){n+=2;const $=o-1;let H=!1;for(;n<$;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,H=!0;break}n++}return H||(n++,d=1),r=t.substring(W,n),h=13}return r+=String.fromCharCode(j),n++,h=16;case 45:if(r+=String.fromCharCode(j),n++,n===o||!v(t.charCodeAt(n)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=P(),h=11;default:for(;n<o&&B(j);)n++,j=t.charCodeAt(n);if(l!==n){switch(r=t.substring(l,n),r){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return r+=String.fromCharCode(j),n++,h=16}}function B(j){if(O(j)||g(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let j;do j=z();while(j>=12&&j<=15);return j}return{setPosition:u,getPosition:()=>n,scan:i?M:z,getToken:()=>h,getTokenValue:()=>r,getTokenOffset:()=>l,getTokenLength:()=>n-l,getTokenError:()=>d}}e.createScanner=U;function O(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function f(t,i){const n=[],o=new Object;let r;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function d(w,u,P,_){l.value=w,l.offset=u,l.length=P,l.type=_,l.colonOffset=void 0,r=l}try{m(t,{onObjectBegin:(w,u)=>{if(i<=w)throw o;r=void 0,h=i>w,n.push("")},onObjectProperty:(w,u,P)=>{if(i<u||(d(w,u,P,"property"),n[n.length-1]=w,i<=u+P))throw o},onObjectEnd:(w,u)=>{if(i<=w)throw o;r=void 0,n.pop()},onArrayBegin:(w,u)=>{if(i<=w)throw o;r=void 0,n.push(0)},onArrayEnd:(w,u)=>{if(i<=w)throw o;r=void 0,n.pop()},onLiteralValue:(w,u,P)=>{if(i<u||(d(w,u,P,s(w)),i<=u+P))throw o},onSeparator:(w,u,P)=>{if(i<=u)throw o;if(w===":"&&r&&r.type==="property")r.colonOffset=u,h=!1,r=void 0;else if(w===","){const _=n[n.length-1];typeof _=="number"?n[n.length-1]=_+1:(h=!0,n[n.length-1]=""),r=void 0}}})}catch(w){if(w!==o)throw w}return{path:n,previousNode:r,isAtPropertyKey:h,matches:w=>{let u=0;for(let P=0;u<w.length&&P<n.length;P++)if(w[u]===n[P]||w[u]==="*")u++;else if(w[u]!=="**")return!1;return u===w.length}}}e.getLocation=f;function y(t,i=[],n=L.DEFAULT){let o=null,r=[];const l=[];function h(w){Array.isArray(r)?r.push(w):o!==null&&(r[o]=w)}return m(t,{onObjectBegin:()=>{const w={};h(w),l.push(r),r=w,o=null},onObjectProperty:w=>{o=w},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const w=[];h(w),l.push(r),r=w,o=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:h,onError:(w,u,P)=>{i.push({error:w,offset:u,length:P})}},n),r[0]}e.parse=y;function I(t,i=[],n=L.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(w){o.type==="property"&&(o.length=w-o.offset,o=o.parent)}function l(w){return o.children.push(w),w}m(t,{onObjectBegin:w=>{o=l({type:"object",offset:w,length:-1,parent:o,children:[]})},onObjectProperty:(w,u,P)=>{o=l({type:"property",offset:u,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:w,offset:u,length:P,parent:o})},onObjectEnd:(w,u)=>{o.length=w+u-o.offset,o=o.parent,r(w+u)},onArrayBegin:(w,u)=>{o=l({type:"array",offset:w,length:-1,parent:o,children:[]})},onArrayEnd:(w,u)=>{o.length=w+u-o.offset,o=o.parent,r(w+u)},onLiteralValue:(w,u,P)=>{l({type:s(w),offset:u,length:P,parent:o,value:w}),r(u+P)},onSeparator:(w,u,P)=>{o.type==="property"&&(w===":"?o.colonOffset=u:w===","&&r(u))},onError:(w,u,P)=>{i.push({error:w,offset:u,length:P})}},n);const d=o.children[0];return d&&delete d.parent,d}e.parseTree=I;function a(t,i){if(!!t){let n=t;for(let o of i)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const l of n.children)if(Array.isArray(l.children)&&l.children[0].value===o){n=l.children[1],r=!0;break}if(!r)return}else{const r=o;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}}e.findNodeAtLocation=a;function b(t){if(!t.parent||!t.parent.children)return[];const i=b(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;i.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&i.push(n)}return i}e.getNodePath=b;function C(t){switch(t.type){case"array":return t.children.map(C);case"object":const i=Object.create(null);for(let n of t.children){const o=n.children[1];o&&(i[n.children[0].value]=C(o))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=C;function E(t,i,n=!1){return i>=t.offset&&i<t.offset+t.length||n&&i===t.offset+t.length}e.contains=E;function p(t,i,n=!1){if(E(t,i,n)){const o=t.children;if(Array.isArray(o))for(let r=0;r<o.length&&o[r].offset<=i;r++){const l=p(o[r],i,n);if(l)return l}return t}}e.findNodeAtOffset=p;function m(t,i,n=L.DEFAULT){const o=U(t,!1);function r(G){return G?()=>G(o.getTokenOffset(),o.getTokenLength()):()=>!0}function l(G){return G?J=>G(J,o.getTokenOffset(),o.getTokenLength()):()=>!0}const h=r(i.onObjectBegin),d=l(i.onObjectProperty),w=r(i.onObjectEnd),u=r(i.onArrayBegin),P=r(i.onArrayEnd),_=l(i.onLiteralValue),z=l(i.onSeparator),B=r(i.onComment),M=l(i.onError),j=n&&n.disallowComments,W=n&&n.allowTrailingComma;function $(){for(;;){const G=o.scan();switch(o.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:j||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(G){case 12:case 13:j?H(10):B();break;case 16:H(1);break;case 15:case 14:break;default:return G}}}function H(G,J=[],Q=[]){if(M(G),J.length+Q.length>0){let ne=o.getToken();for(;ne!==17;){if(J.indexOf(ne)!==-1){$();break}else if(Q.indexOf(ne)!==-1)break;ne=$()}}}function q(G){const J=o.getTokenValue();return G?_(J):d(J),$(),!0}function D(){switch(o.getToken()){case 11:let G=0;try{G=JSON.parse(o.getTokenValue()),typeof G!="number"&&(H(2),G=0)}catch(J){H(2)}_(G);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return $(),!0}function T(){return o.getToken()!==10?(H(3,[],[2,5]),!1):(q(!1),o.getToken()===6?(z(":"),$(),V()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function F(){h(),$();let G=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(G||H(4,[],[]),z(","),$(),o.getToken()===2&&W)break}else G&&H(6,[],[]);T()||H(4,[],[2,5]),G=!0}return w(),o.getToken()!==2?H(7,[2],[]):$(),!0}function N(){u(),$();let G=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(G||H(4,[],[]),z(","),$(),o.getToken()===4&&W)break}else G&&H(6,[],[]);V()||H(4,[],[4,5]),G=!0}return P(),o.getToken()!==4?H(8,[4],[]):$(),!0}function V(){switch(o.getToken()){case 3:return N();case 1:return F();case 10:return q(!0);default:return D()}}return $(),o.getToken()===17?n.allowEmptyContent?!0:(H(4,[],[]),!1):V()?(o.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=m;function c(t,i){let n=U(t),o=[],r,l=0,h;do switch(h=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:l!==h&&o.push(t.substring(l,h)),i!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,i)),l=n.getPosition();break}while(r!==17);return o.join("")}e.stripComments=c;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),define(Z[46],ee([0,1,32]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(g,v,R){let f,y,I,a,b;if(v){for(a=v.offset,b=a+v.length,I=a;I>0&&!O(g,I-1);)I--;let l=b;for(;l<g.length&&!O(g,l);)l++;y=g.substring(I,l),f=L(y,R)}else y=g,f=0,I=0,a=0,b=g.length;const C=U(R,g);let E=!1,p=0,m;R.insertSpaces?m=A(" ",R.tabSize||4):m="	";const c=(0,S.createScanner)(y,!1);let s=!1;function t(){return C+A(m,f+p)}function i(){let l=c.scan();for(E=!1;l===15||l===14;)E=E||l===14,l=c.scan();return s=l===16||c.getTokenError()!==0,l}const n=[];function o(l,h,d){!s&&h<b&&d>a&&g.substring(h,d)!==l&&n.push({offset:h,length:d-h,content:l})}let r=i();if(r!==17){const l=c.getTokenOffset()+I,h=A(m,f);o(h,I,l)}for(;r!==17;){let l=c.getTokenOffset()+c.getTokenLength()+I,h=i(),d="";for(;!E&&(h===12||h===13);){const u=c.getTokenOffset()+I;o(" ",l,u),l=c.getTokenOffset()+c.getTokenLength()+I,d=h===12?t():"",h=i()}if(h===2)r!==1&&(p--,d=t());else if(h===4)r!==3&&(p--,d=t());else{switch(r){case 3:case 1:p++,d=t();break;case 5:case 12:d=t();break;case 13:E?d=t():d=" ";break;case 6:d=" ";break;case 10:if(h===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?d=" ":h!==5&&h!==17&&(s=!0);break;case 16:s=!0;break}E&&(h===12||h===13)&&(d=t())}const w=c.getTokenOffset()+I;o(d,l,w),r=h}return n}e.format=k;function A(g,v){let R="";for(let f=0;f<v;f++)R+=g;return R}function L(g,v){let R=0,f=0;const y=v.tabSize||4;for(;R<g.length;){const I=g.charAt(R);if(I===" ")f++;else if(I==="	")f+=y;else break;R++}return Math.floor(f/y)}function U(g,v){for(let R=0;R<v.length;R++){const f=v.charAt(R);if(f==="\r")return R+1<v.length&&v.charAt(R+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return g&&g.eol||`
`}e.getEOL=U;function O(g,v){return`\r
`.indexOf(g.charAt(v))!==-1}e.isEOL=O}),define(Z[41],ee([0,1,32,46]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(v,R,f){return L(v,R,void 0,f)}e.removeProperty=A;function L(v,R,f,y,I){const a=R.slice(),b=[],C=(0,S.parseTree)(v,b);let E,p;for(;a.length>0&&(p=a.pop(),E=(0,S.findNodeAtLocation)(C,a),E===void 0&&f!==void 0);)typeof p=="string"?f={[p]:f}:f=[f];if(E)if(E.type==="object"&&typeof p=="string"&&Array.isArray(E.children)){const m=(0,S.findNodeAtLocation)(E,[p]);if(m!==void 0)if(f===void 0){if(!m.parent)throw new Error("Malformed AST");const c=E.children.indexOf(m.parent);let s,t=m.parent.offset+m.parent.length;if(c>0){const i=E.children[c-1];s=i.offset+i.length}else s=E.offset+1,E.children.length>1&&(t=E.children[1].offset);return U(v,{offset:s,length:t-s,content:""},y)}else return U(v,{offset:m.offset,length:m.length,content:JSON.stringify(f)},y);else{if(f===void 0)return[];const c=`${JSON.stringify(p)}: ${JSON.stringify(f)}`,s=I?I(E.children.map(i=>i.children[0].value)):E.children.length;let t;if(s>0){const i=E.children[s-1];t={offset:i.offset+i.length,length:0,content:","+c}}else E.children.length===0?t={offset:E.offset+1,length:0,content:c}:t={offset:E.offset+1,length:0,content:c+","};return U(v,t,y)}}else if(E.type==="array"&&typeof p=="number"&&Array.isArray(E.children))if(f!==void 0){const m=`${JSON.stringify(f)}`;let c;if(E.children.length===0||p===0)c={offset:E.offset+1,length:0,content:E.children.length===0?m:m+","};else{const s=p===-1||p>E.children.length?E.children.length:p,t=E.children[s-1];c={offset:t.offset+t.length,length:0,content:","+m}}return U(v,c,y)}else{const m=p,c=E.children[m];let s;if(E.children.length===1)s={offset:E.offset+1,length:E.length-2,content:""};else if(E.children.length-1===m){const t=E.children[m-1],i=t.offset+t.length,n=E.offset+E.length;s={offset:i,length:n-2-i,content:""}}else s={offset:c.offset,length:E.children[m+1].offset-c.offset,content:""};return U(v,s,y)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${E.type}`);else{if(f===void 0)throw new Error("Can not delete in empty document");return U(v,{offset:C?C.offset:0,length:C?C.length:0,content:JSON.stringify(f)},y)}}e.setProperty=L;function U(v,R,f){let y=O(v,R),I=R.offset,a=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;I>0&&!(0,k.isEOL)(y,I-1);)I--;for(;a<y.length&&!(0,k.isEOL)(y,a);)a++}const b=(0,k.format)(y,{offset:I,length:a-I},f);for(let E=b.length-1;E>=0;E--){const p=b[E];y=O(y,p),I=Math.min(I,p.offset),a=Math.max(a,p.offset+p.length),a+=p.content.length-p.length}const C=v.length-(y.length-a)-I;return[{offset:I,length:C,content:y.substring(I,a)}]}e.withFormatting=U;function O(v,R){return v.substring(0,R.offset)+R.content+v.substring(R.offset+R.length)}e.applyEdit=O;function g(v,R){let f=R.slice(0).sort((I,a)=>{const b=I.offset-a.offset;return b===0?I.length-a.length:b}),y=v.length;for(let I=f.length-1;I>=0;I--){let a=f[I];if(a.offset+a.length<=y)v=O(v,a);else throw new Error("Overlapping edit");y=a.offset}return v}e.applyEdits=g}),define(Z[2],ee([0,1,63,53]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let L=null;function U(m){L=m}if(e.setDisposableTracker=U,A){const m="__is_disposable_tracked__";L=new class{trackDisposable(c){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[m]||console.log(s)},3e3)}markTracked(c){if(c&&c!==b.None)try{c[m]=!0}catch(s){}}}}function O(m){!L||L.markTracked(m)}function g(m){return L&&L.trackDisposable(m),m}e.trackDisposable=g;class v extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=v;function R(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.isDisposable=R;function f(m){if(k.Iterable.is(m)){let c=[];for(const s of m)if(s){O(s);try{s.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new v(c);return Array.isArray(m)?[]:m}else if(m)return O(m),m.dispose(),m}e.dispose=f;function y(...m){return m.forEach(O),I(()=>f(m))}e.combinedDisposable=y;function I(m){const c=g({dispose:()=>{O(c),m()}});return c}e.toDisposable=I;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(O(this),this._isDisposed=!0,this.clear())}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return O(c),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new a,g(this)}dispose(){O(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class C{constructor(){this._isDisposed=!1,g(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var s;this._isDisposed||c===this._value||((s=this._value)===null||s===void 0||s.dispose(),c&&O(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,O(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=C;class E{constructor(){this.references=new Map}acquire(c,...s){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...s)},this.references.set(c,t));const{object:i}=t,n=(0,S.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:i,dispose:n}}}e.ReferenceCollection=E;class p{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=p}),define(Z[64],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(L){this.element=L,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class k{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,U){const O=new S(L);if(this._first===S.Undefined)this._first=O,this._last=O;else if(U){const v=this._last;this._last=O,O.prev=v,v.next=O}else{const v=this._first;this._first=O,O.next=v,v.prev=O}this._size+=1;let g=!1;return()=>{g||(g=!0,this._remove(O))}}shift(){if(this._first!==S.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==S.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==S.Undefined&&L.next!==S.Undefined){const U=L.prev;U.next=L.next,L.next.prev=U}else L.prev===S.Undefined&&L.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):L.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):L.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==S.Undefined;)yield L.element,L=L.next}}e.LinkedList=k});"use strict";(function(){function K(A){const L=[];typeof A=="number"&&L.push("code/timeOrigin",A);function U(g){L.push(g,Date.now())}function O(){const g=[];for(let v=0;v<L.length;v+=2)g.push({name:L[v],startTime:L[v+1]});return g}return{mark:U,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const U of performance.getEntriesByType("mark"))L.push({name:U.name,startTime:Math.round(A+U.startTime)});return L}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function S(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=S(k))})(),define(Z[7],ee([0,1]),function(K,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const k="en";let A=!1,L=!1,U=!1,O=!1,g=!1,v=!1,R=!1,f,y=k,I,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let b;typeof e.globals.vscode!="undefined"?b=e.globals.vscode.process:typeof process!="undefined"&&(b=process);const C=typeof((S=b==null?void 0:b.versions)===null||S===void 0?void 0:S.electron)=="string"&&b.type==="renderer";if(e.isElectronSandboxed=C&&(b==null?void 0:b.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const o=b==null?void 0:b.env.VSCODE_BROWSER_CODE_LOADING;if(typeof o=="string")return o==="none"||o==="code"||o==="bypassHeatCheck"||o==="bypassHeatCheckAndEagerCompile"?o:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!C)a=navigator.userAgent,A=a.indexOf("Windows")>=0,L=a.indexOf("Macintosh")>=0,R=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=a.indexOf("Linux")>=0,v=!0,f=navigator.language,y=f;else if(typeof b=="object"){A=b.platform==="win32",L=b.platform==="darwin",U=b.platform==="linux",O=U&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,f=k,y=k;const o=b.env.VSCODE_NLS_CONFIG;if(o)try{const r=JSON.parse(o),l=r.availableLanguages["*"];f=r.locale,y=l||k,I=r._translationsConfigFile}catch(r){}g=!0}else console.error("Unable to resolve platform.");var E;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function p(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let m=0;L?m=1:A?m=3:U&&(m=2),e.isWindows=A,e.isMacintosh=L,e.isLinux=U,e.isLinuxSnap=O,e.isNative=g,e.isWeb=v,e.isIOS=R,e.platform=m,e.userAgent=a,e.language=y;var c;(function(o){function r(){return e.language}o.value=r;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=l;function h(){return e.language==="en"}o.isDefault=h})(c=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=I,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeSetImmediateId)for(let w=0,u=l.length;w<u;w++){const P=l[w];if(P.id===d.data.vscodeSetImmediateId){l.splice(w,1),P.callback();return}}});let h=0;return d=>{const w=++h;l.push({id:w,callback:d}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof(b==null?void 0:b.nextTick)=="function")return b.nextTick.bind(b);const r=Promise.resolve();return l=>r.then(l)}();var s;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||R?2:A?1:3;let t=!0,i=!1;function n(){if(!i){i=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,t=new Uint16Array(o.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=n}),define(Z[36],ee([0,1,7]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let k;if(typeof S.globals.vscode!="undefined"){const A=S.globals.vscode.process;k={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(L){return(0,S.setImmediate)(L)}}}else typeof process!="undefined"?k={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:k={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},nextTick(A){return(0,S.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick}),define(Z[8],ee([0,1,36]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,A=97,L=90,U=122,O=46,g=47,v=92,R=58,f=63;class y extends Error{constructor(c,s,t){let i;typeof s=="string"&&s.indexOf("not ")===0?(i="must not be",s=s.replace(/^not /,"")):i="must be";const n=c.indexOf(".")!==-1?"property":"argument";let o=`The "${c}" ${n} ${i} of type ${s}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function I(m,c){if(typeof m!="string")throw new y(c,"string",m)}function a(m){return m===g||m===v}function b(m){return m===g}function C(m){return m>=k&&m<=L||m>=A&&m<=U}function E(m,c,s,t){let i="",n=0,o=-1,r=0,l=0;for(let h=0;h<=m.length;++h){if(h<m.length)l=m.charCodeAt(h);else{if(t(l))break;l=g}if(t(l)){if(!(o===h-1||r===1))if(r===2){if(i.length<2||n!==2||i.charCodeAt(i.length-1)!==O||i.charCodeAt(i.length-2)!==O){if(i.length>2){const d=i.lastIndexOf(s);d===-1?(i="",n=0):(i=i.slice(0,d),n=i.length-1-i.lastIndexOf(s)),o=h,r=0;continue}else if(i.length!==0){i="",n=0,o=h,r=0;continue}}c&&(i+=i.length>0?`${s}..`:"..",n=2)}else i.length>0?i+=`${s}${m.slice(o+1,h)}`:i=m.slice(o+1,h),n=h-o-1;o=h,r=0}else l===O&&r!==-1?++r:r=-1}return i}function p(m,c){if(c===null||typeof c!="object")throw new y("pathObject","Object",c);const s=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return s?s===c.root?`${s}${t}`:`${s}${m}${t}`:t}e.win32={resolve(...m){let c="",s="",t=!1;for(let i=m.length-1;i>=-1;i--){let n;if(i>=0){if(n=m[i],I(n,"path"),n.length===0)continue}else c.length===0?n=S.cwd():(n=S.env[`=${c}`]||S.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==c.toLowerCase()&&n.charCodeAt(2)===v)&&(n=`${c}\\`));const o=n.length;let r=0,l="",h=!1;const d=n.charCodeAt(0);if(o===1)a(d)&&(r=1,h=!0);else if(a(d))if(h=!0,a(n.charCodeAt(1))){let w=2,u=w;for(;w<o&&!a(n.charCodeAt(w));)w++;if(w<o&&w!==u){const P=n.slice(u,w);for(u=w;w<o&&a(n.charCodeAt(w));)w++;if(w<o&&w!==u){for(u=w;w<o&&!a(n.charCodeAt(w));)w++;(w===o||w!==u)&&(l=`\\\\${P}\\${n.slice(u,w)}`,r=w)}}}else r=1;else C(d)&&n.charCodeAt(1)===R&&(l=n.slice(0,2),r=2,o>2&&a(n.charCodeAt(2))&&(h=!0,r=3));if(l.length>0)if(c.length>0){if(l.toLowerCase()!==c.toLowerCase())continue}else c=l;if(t){if(c.length>0)break}else if(s=`${n.slice(r)}\\${s}`,t=h,h&&c.length>0)break}return s=E(s,!t,"\\",a),t?`${c}\\${s}`:`${c}${s}`||"."},normalize(m){I(m,"path");const c=m.length;if(c===0)return".";let s=0,t,i=!1;const n=m.charCodeAt(0);if(c===1)return b(n)?"\\":m;if(a(n))if(i=!0,a(m.charCodeAt(1))){let r=2,l=r;for(;r<c&&!a(m.charCodeAt(r));)r++;if(r<c&&r!==l){const h=m.slice(l,r);for(l=r;r<c&&a(m.charCodeAt(r));)r++;if(r<c&&r!==l){for(l=r;r<c&&!a(m.charCodeAt(r));)r++;if(r===c)return`\\\\${h}\\${m.slice(l)}\\`;r!==l&&(t=`\\\\${h}\\${m.slice(l,r)}`,s=r)}}}else s=1;else C(n)&&m.charCodeAt(1)===R&&(t=m.slice(0,2),s=2,c>2&&a(m.charCodeAt(2))&&(i=!0,s=3));let o=s<c?E(m.slice(s),!i,"\\",a):"";return o.length===0&&!i&&(o="."),o.length>0&&a(m.charCodeAt(c-1))&&(o+="\\"),t===void 0?i?`\\${o}`:o:i?`${t}\\${o}`:`${t}${o}`},isAbsolute(m){I(m,"path");const c=m.length;if(c===0)return!1;const s=m.charCodeAt(0);return a(s)||c>2&&C(s)&&m.charCodeAt(1)===R&&a(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let c,s;for(let n=0;n<m.length;++n){const o=m[n];I(o,"path"),o.length>0&&(c===void 0?c=s=o:c+=`\\${o}`)}if(c===void 0)return".";let t=!0,i=0;if(typeof s=="string"&&a(s.charCodeAt(0))){++i;const n=s.length;n>1&&a(s.charCodeAt(1))&&(++i,n>2&&(a(s.charCodeAt(2))?++i:t=!1))}if(t){for(;i<c.length&&a(c.charCodeAt(i));)i++;i>=2&&(c=`\\${c.slice(i)}`)}return e.win32.normalize(c)},relative(m,c){if(I(m,"from"),I(c,"to"),m===c)return"";const s=e.win32.resolve(m),t=e.win32.resolve(c);if(s===t||(m=s.toLowerCase(),c=t.toLowerCase(),m===c))return"";let i=0;for(;i<m.length&&m.charCodeAt(i)===v;)i++;let n=m.length;for(;n-1>i&&m.charCodeAt(n-1)===v;)n--;const o=n-i;let r=0;for(;r<c.length&&c.charCodeAt(r)===v;)r++;let l=c.length;for(;l-1>r&&c.charCodeAt(l-1)===v;)l--;const h=l-r,d=o<h?o:h;let w=-1,u=0;for(;u<d;u++){const _=m.charCodeAt(i+u);if(_!==c.charCodeAt(r+u))break;_===v&&(w=u)}if(u!==d){if(w===-1)return t}else{if(h>d){if(c.charCodeAt(r+u)===v)return t.slice(r+u+1);if(u===2)return t.slice(r+u)}o>d&&(m.charCodeAt(i+u)===v?w=u:u===2&&(w=3)),w===-1&&(w=0)}let P="";for(u=i+w+1;u<=n;++u)(u===n||m.charCodeAt(u)===v)&&(P+=P.length===0?"..":"\\..");return r+=w,P.length>0?`${P}${t.slice(r,l)}`:(t.charCodeAt(r)===v&&++r,t.slice(r,l))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const c=e.win32.resolve(m);if(c.length<=2)return m;if(c.charCodeAt(0)===v){if(c.charCodeAt(1)===v){const s=c.charCodeAt(2);if(s!==f&&s!==O)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(C(c.charCodeAt(0))&&c.charCodeAt(1)===R&&c.charCodeAt(2)===v)return`\\\\?\\${c}`;return m},dirname(m){I(m,"path");const c=m.length;if(c===0)return".";let s=-1,t=0;const i=m.charCodeAt(0);if(c===1)return a(i)?m:".";if(a(i)){if(s=t=1,a(m.charCodeAt(1))){let r=2,l=r;for(;r<c&&!a(m.charCodeAt(r));)r++;if(r<c&&r!==l){for(l=r;r<c&&a(m.charCodeAt(r));)r++;if(r<c&&r!==l){for(l=r;r<c&&!a(m.charCodeAt(r));)r++;if(r===c)return m;r!==l&&(s=t=r+1)}}}}else C(i)&&m.charCodeAt(1)===R&&(s=c>2&&a(m.charCodeAt(2))?3:2,t=s);let n=-1,o=!0;for(let r=c-1;r>=t;--r)if(a(m.charCodeAt(r))){if(!o){n=r;break}}else o=!1;if(n===-1){if(s===-1)return".";n=s}return m.slice(0,n)},basename(m,c){c!==void 0&&I(c,"ext"),I(m,"path");let s=0,t=-1,i=!0,n;if(m.length>=2&&C(m.charCodeAt(0))&&m.charCodeAt(1)===R&&(s=2),c!==void 0&&c.length>0&&c.length<=m.length){if(c===m)return"";let o=c.length-1,r=-1;for(n=m.length-1;n>=s;--n){const l=m.charCodeAt(n);if(a(l)){if(!i){s=n+1;break}}else r===-1&&(i=!1,r=n+1),o>=0&&(l===c.charCodeAt(o)?--o==-1&&(t=n):(o=-1,t=r))}return s===t?t=r:t===-1&&(t=m.length),m.slice(s,t)}for(n=m.length-1;n>=s;--n)if(a(m.charCodeAt(n))){if(!i){s=n+1;break}}else t===-1&&(i=!1,t=n+1);return t===-1?"":m.slice(s,t)},extname(m){I(m,"path");let c=0,s=-1,t=0,i=-1,n=!0,o=0;m.length>=2&&m.charCodeAt(1)===R&&C(m.charCodeAt(0))&&(c=t=2);for(let r=m.length-1;r>=c;--r){const l=m.charCodeAt(r);if(a(l)){if(!n){t=r+1;break}continue}i===-1&&(n=!1,i=r+1),l===O?s===-1?s=r:o!==1&&(o=1):s!==-1&&(o=-1)}return s===-1||i===-1||o===0||o===1&&s===i-1&&s===t+1?"":m.slice(s,i)},format:p.bind(null,"\\"),parse(m){I(m,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return c;const s=m.length;let t=0,i=m.charCodeAt(0);if(s===1)return a(i)?(c.root=c.dir=m,c):(c.base=c.name=m,c);if(a(i)){if(t=1,a(m.charCodeAt(1))){let w=2,u=w;for(;w<s&&!a(m.charCodeAt(w));)w++;if(w<s&&w!==u){for(u=w;w<s&&a(m.charCodeAt(w));)w++;if(w<s&&w!==u){for(u=w;w<s&&!a(m.charCodeAt(w));)w++;w===s?t=w:w!==u&&(t=w+1)}}}}else if(C(i)&&m.charCodeAt(1)===R){if(s<=2)return c.root=c.dir=m,c;if(t=2,a(m.charCodeAt(2))){if(s===3)return c.root=c.dir=m,c;t=3}}t>0&&(c.root=m.slice(0,t));let n=-1,o=t,r=-1,l=!0,h=m.length-1,d=0;for(;h>=t;--h){if(i=m.charCodeAt(h),a(i)){if(!l){o=h+1;break}continue}r===-1&&(l=!1,r=h+1),i===O?n===-1?n=h:d!==1&&(d=1):n!==-1&&(d=-1)}return r!==-1&&(n===-1||d===0||d===1&&n===r-1&&n===o+1?c.base=c.name=m.slice(o,r):(c.name=m.slice(o,n),c.base=m.slice(o,r),c.ext=m.slice(n,r))),o>0&&o!==t?c.dir=m.slice(0,o-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let c="",s=!1;for(let t=m.length-1;t>=-1&&!s;t--){const i=t>=0?m[t]:S.cwd();I(i,"path"),i.length!==0&&(c=`${i}/${c}`,s=i.charCodeAt(0)===g)}return c=E(c,!s,"/",b),s?`/${c}`:c.length>0?c:"."},normalize(m){if(I(m,"path"),m.length===0)return".";const c=m.charCodeAt(0)===g,s=m.charCodeAt(m.length-1)===g;return m=E(m,!c,"/",b),m.length===0?c?"/":s?"./":".":(s&&(m+="/"),c?`/${m}`:m)},isAbsolute(m){return I(m,"path"),m.length>0&&m.charCodeAt(0)===g},join(...m){if(m.length===0)return".";let c;for(let s=0;s<m.length;++s){const t=m[s];I(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(m,c){if(I(m,"from"),I(c,"to"),m===c||(m=e.posix.resolve(m),c=e.posix.resolve(c),m===c))return"";const s=1,t=m.length,i=t-s,n=1,o=c.length-n,r=i<o?i:o;let l=-1,h=0;for(;h<r;h++){const w=m.charCodeAt(s+h);if(w!==c.charCodeAt(n+h))break;w===g&&(l=h)}if(h===r)if(o>r){if(c.charCodeAt(n+h)===g)return c.slice(n+h+1);if(h===0)return c.slice(n+h)}else i>r&&(m.charCodeAt(s+h)===g?l=h:h===0&&(l=0));let d="";for(h=s+l+1;h<=t;++h)(h===t||m.charCodeAt(h)===g)&&(d+=d.length===0?"..":"/..");return`${d}${c.slice(n+l)}`},toNamespacedPath(m){return m},dirname(m){if(I(m,"path"),m.length===0)return".";const c=m.charCodeAt(0)===g;let s=-1,t=!0;for(let i=m.length-1;i>=1;--i)if(m.charCodeAt(i)===g){if(!t){s=i;break}}else t=!1;return s===-1?c?"/":".":c&&s===1?"//":m.slice(0,s)},basename(m,c){c!==void 0&&I(c,"ext"),I(m,"path");let s=0,t=-1,i=!0,n;if(c!==void 0&&c.length>0&&c.length<=m.length){if(c===m)return"";let o=c.length-1,r=-1;for(n=m.length-1;n>=0;--n){const l=m.charCodeAt(n);if(l===g){if(!i){s=n+1;break}}else r===-1&&(i=!1,r=n+1),o>=0&&(l===c.charCodeAt(o)?--o==-1&&(t=n):(o=-1,t=r))}return s===t?t=r:t===-1&&(t=m.length),m.slice(s,t)}for(n=m.length-1;n>=0;--n)if(m.charCodeAt(n)===g){if(!i){s=n+1;break}}else t===-1&&(i=!1,t=n+1);return t===-1?"":m.slice(s,t)},extname(m){I(m,"path");let c=-1,s=0,t=-1,i=!0,n=0;for(let o=m.length-1;o>=0;--o){const r=m.charCodeAt(o);if(r===g){if(!i){s=o+1;break}continue}t===-1&&(i=!1,t=o+1),r===O?c===-1?c=o:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||t===-1||n===0||n===1&&c===t-1&&c===s+1?"":m.slice(c,t)},format:p.bind(null,"/"),parse(m){I(m,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return c;const s=m.charCodeAt(0)===g;let t;s?(c.root="/",t=1):t=0;let i=-1,n=0,o=-1,r=!0,l=m.length-1,h=0;for(;l>=t;--l){const d=m.charCodeAt(l);if(d===g){if(!r){n=l+1;break}continue}o===-1&&(r=!1,o=l+1),d===O?i===-1?i=l:h!==1&&(h=1):i!==-1&&(h=-1)}if(o!==-1){const d=n===0&&s?1:n;i===-1||h===0||h===1&&i===o-1&&i===n+1?c.base=c.name=m.slice(d,o):(c.name=m.slice(d,i),c.base=m.slice(d,o),c.ext=m.slice(i,o))}return n>0?c.dir=m.slice(0,n-1):s&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=S.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S.platform==="win32"?e.win32.join:e.posix.join,e.resolve=S.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=S.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=S.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=S.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=S.platform==="win32"?e.win32.extname:e.posix.extname,e.format=S.platform==="win32"?e.win32.format:e.posix.format,e.parse=S.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=S.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=S.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var k in S)(typeof exports=="object"?exports:K)[k]=S[k]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function S(k){if(e[k])return e[k].exports;var A=e[k]={i:k,l:!1,exports:{}};return K[k].call(A.exports,A,A.exports,S),A.l=!0,A.exports}return S.m=K,S.c=e,S.d=function(k,A,L){S.o(k,A)||Object.defineProperty(k,A,{enumerable:!0,get:L})},S.r=function(k){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},S.t=function(k,A){if(1&A&&(k=S(k)),8&A||4&A&&typeof k=="object"&&k&&k.__esModule)return k;var L=Object.create(null);if(S.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:k}),2&A&&typeof k!="string")for(var U in k)S.d(L,U,function(O){return k[O]}.bind(null,U));return L},S.n=function(k){var A=k&&k.__esModule?function(){return k.default}:function(){return k};return S.d(A,"a",A),A},S.o=function(k,A){return Object.prototype.hasOwnProperty.call(k,A)},S.p="",S(S.s=0)}([function(K,e,S){(function(k){var A;e=K.exports=Q,A=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,U=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],g=e.src=[],v=0,R=v++;g[R]="0|[1-9]\\d*";var f=v++;g[f]="[0-9]+";var y=v++;g[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=v++;g[I]="("+g[R]+")\\.("+g[R]+")\\.("+g[R]+")";var a=v++;g[a]="("+g[f]+")\\.("+g[f]+")\\.("+g[f]+")";var b=v++;g[b]="(?:"+g[R]+"|"+g[y]+")";var C=v++;g[C]="(?:"+g[f]+"|"+g[y]+")";var E=v++;g[E]="(?:-("+g[b]+"(?:\\."+g[b]+")*))";var p=v++;g[p]="(?:-?("+g[C]+"(?:\\."+g[C]+")*))";var m=v++;g[m]="[0-9A-Za-z-]+";var c=v++;g[c]="(?:\\+("+g[m]+"(?:\\."+g[m]+")*))";var s=v++,t="v?"+g[I]+g[E]+"?"+g[c]+"?";g[s]="^"+t+"$";var i="[v=\\s]*"+g[a]+g[p]+"?"+g[c]+"?",n=v++;g[n]="^"+i+"$";var o=v++;g[o]="((?:<|>)?=?)";var r=v++;g[r]=g[f]+"|x|X|\\*";var l=v++;g[l]=g[R]+"|x|X|\\*";var h=v++;g[h]="[v=\\s]*("+g[l]+")(?:\\.("+g[l]+")(?:\\.("+g[l]+")(?:"+g[E]+")?"+g[c]+"?)?)?";var d=v++;g[d]="[v=\\s]*("+g[r]+")(?:\\.("+g[r]+")(?:\\.("+g[r]+")(?:"+g[p]+")?"+g[c]+"?)?)?";var w=v++;g[w]="^"+g[o]+"\\s*"+g[h]+"$";var u=v++;g[u]="^"+g[o]+"\\s*"+g[d]+"$";var P=v++;g[P]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=v++;g[_]="(?:~>?)";var z=v++;g[z]="(\\s*)"+g[_]+"\\s+",O[z]=new RegExp(g[z],"g");var B=v++;g[B]="^"+g[_]+g[h]+"$";var M=v++;g[M]="^"+g[_]+g[d]+"$";var j=v++;g[j]="(?:\\^)";var W=v++;g[W]="(\\s*)"+g[j]+"\\s+",O[W]=new RegExp(g[W],"g");var $=v++;g[$]="^"+g[j]+g[h]+"$";var H=v++;g[H]="^"+g[j]+g[d]+"$";var q=v++;g[q]="^"+g[o]+"\\s*("+i+")$|^$";var D=v++;g[D]="^"+g[o]+"\\s*("+t+")$|^$";var T=v++;g[T]="(\\s*)"+g[o]+"\\s*("+i+"|"+g[h]+")",O[T]=new RegExp(g[T],"g");var F=v++;g[F]="^\\s*("+g[h]+")\\s+-\\s+("+g[h]+")\\s*$";var N=v++;g[N]="^\\s*("+g[d]+")\\s+-\\s+("+g[d]+")\\s*$";var V=v++;g[V]="(<|>)?=?\\s*\\*";for(var G=0;G<35;G++)A(G,g[G]),O[G]||(O[G]=new RegExp(g[G]));function J(X,re){if(X instanceof Q)return X;if(typeof X!="string"||X.length>L||!(re?O[n]:O[s]).test(X))return null;try{return new Q(X,re)}catch(se){return null}}function Q(X,re){if(X instanceof Q){if(X.loose===re)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof Q))return new Q(X,re);A("SemVer",X,re),this.loose=re;var se=X.trim().match(re?O[n]:O[s]);if(!se)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>U||this.major<0)throw new TypeError("Invalid major version");if(this.minor>U||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>U||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var x=+me;if(x>=0&&x<U)return x}return me}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=J,e.valid=function(X,re){var se=J(X,re);return se?se.version:null},e.clean=function(X,re){var se=J(X.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(X){return A("SemVer.compare",this.version,this.loose,X),X instanceof Q||(X=new Q(X,this.loose)),this.compareMain(X)||this.comparePre(X)},Q.prototype.compareMain=function(X){return X instanceof Q||(X=new Q(X,this.loose)),ie(this.major,X.major)||ie(this.minor,X.minor)||ie(this.patch,X.patch)},Q.prototype.comparePre=function(X){if(X instanceof Q||(X=new Q(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],me=X.prerelease[re];if(A("prerelease compare",re,se,me),se===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(se===void 0)return-1;if(se!==me)return ie(se,me)}while(++re)},Q.prototype.inc=function(X,re){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,re,se,me){typeof se=="string"&&(me=se,se=void 0);try{return new Q(X,se).inc(re,me).version}catch(x){return null}},e.diff=function(X,re){if(Ee(X,re))return null;var se=J(X),me=J(re);if(se.prerelease.length||me.prerelease.length){for(var x in se)if((x==="major"||x==="minor"||x==="patch")&&se[x]!==me[x])return"pre"+x;return"prerelease"}for(var x in se)if((x==="major"||x==="minor"||x==="patch")&&se[x]!==me[x])return x},e.compareIdentifiers=ie;var ne=/^[0-9]+$/;function ie(X,re){var se=ne.test(X),me=ne.test(re);return se&&me&&(X=+X,re=+re),se&&!me?-1:me&&!se?1:X<re?-1:X>re?1:0}function ce(X,re,se){return new Q(X,se).compare(new Q(re,se))}function ue(X,re,se){return ce(X,re,se)>0}function ge(X,re,se){return ce(X,re,se)<0}function Ee(X,re,se){return ce(X,re,se)===0}function Ie(X,re,se){return ce(X,re,se)!==0}function Oe(X,re,se){return ce(X,re,se)>=0}function Ae(X,re,se){return ce(X,re,se)<=0}function Ue(X,re,se,me){var x;switch(re){case"===":typeof X=="object"&&(X=X.version),typeof se=="object"&&(se=se.version),x=X===se;break;case"!==":typeof X=="object"&&(X=X.version),typeof se=="object"&&(se=se.version),x=X!==se;break;case"":case"=":case"==":x=Ee(X,se,me);break;case"!=":x=Ie(X,se,me);break;case">":x=ue(X,se,me);break;case">=":x=Oe(X,se,me);break;case"<":x=ge(X,se,me);break;case"<=":x=Ae(X,se,me);break;default:throw new TypeError("Invalid operator: "+re)}return x}function ke(X,re){if(X instanceof ke){if(X.loose===re)return X;X=X.value}if(!(this instanceof ke))return new ke(X,re);A("comparator",X,re),this.loose=re,this.parse(X),this.semver===Ne?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(X,re){return ie(re,X)},e.major=function(X,re){return new Q(X,re).major},e.minor=function(X,re){return new Q(X,re).minor},e.patch=function(X,re){return new Q(X,re).patch},e.compare=ce,e.compareLoose=function(X,re){return ce(X,re,!0)},e.rcompare=function(X,re,se){return ce(re,X,se)},e.sort=function(X,re){return X.sort(function(se,me){return e.compare(se,me,re)})},e.rsort=function(X,re){return X.sort(function(se,me){return e.rcompare(se,me,re)})},e.gt=ue,e.lt=ge,e.eq=Ee,e.neq=Ie,e.gte=Oe,e.lte=Ae,e.cmp=Ue,e.Comparator=ke;var Ne={};function De(X,re){if(X instanceof De)return X.loose===re?X:new De(X.raw,re);if(X instanceof ke)return new De(X.value,re);if(!(this instanceof De))return new De(X,re);if(this.loose=re,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Te(X){return!X||X.toLowerCase()==="x"||X==="*"}function Ge(X,re,se,me,x,te,oe,ae,le,fe,ve,Se,we){return((re=Te(se)?"":Te(me)?">="+se+".0.0":Te(x)?">="+se+"."+me+".0":">="+re)+" "+(ae=Te(le)?"":Te(fe)?"<"+(+le+1)+".0.0":Te(ve)?"<"+le+"."+(+fe+1)+".0":Se?"<="+le+"."+fe+"."+ve+"-"+Se:"<="+ae)).trim()}function Ke(X,re){for(var se=0;se<X.length;se++)if(!X[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<X.length;se++)if(A(X[se].semver),X[se].semver!==Ne&&X[se].semver.prerelease.length>0){var me=X[se].semver;if(me.major===re.major&&me.minor===re.minor&&me.patch===re.patch)return!0}return!1}return!0}function ze(X,re,se){try{re=new De(re,se)}catch(me){return!1}return re.test(X)}function $e(X,re,se,me){var x,te,oe,ae,le;switch(X=new Q(X,me),re=new De(re,me),se){case">":x=ue,te=Ae,oe=ge,ae=">",le=">=";break;case"<":x=ge,te=Oe,oe=ue,ae="<",le="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(X,re,me))return!1;for(var fe=0;fe<re.set.length;++fe){var ve=re.set[fe],Se=null,we=null;if(ve.forEach(function(be){be.semver===Ne&&(be=new ke(">=0.0.0")),Se=Se||be,we=we||be,x(be.semver,Se.semver,me)?Se=be:oe(be.semver,we.semver,me)&&(we=be)}),Se.operator===ae||Se.operator===le||(!we.operator||we.operator===ae)&&te(X,we.semver)||we.operator===le&&oe(X,we.semver))return!1}return!0}ke.prototype.parse=function(X){var re=this.loose?O[q]:O[D],se=X.match(re);if(!se)throw new TypeError("Invalid comparator: "+X);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new Q(se[2],this.loose):this.semver=Ne},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(X){return A("Comparator.test",X,this.loose),this.semver===Ne||(typeof X=="string"&&(X=new Q(X,this.loose)),Ue(X,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(X,re){if(!(X instanceof ke))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new De(X.value,re),ze(this.value,se,re);if(X.operator==="")return se=new De(this.value,re),ze(X.semver,se,re);var me=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),x=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),te=this.semver.version===X.semver.version,oe=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),ae=Ue(this.semver,"<",X.semver,re)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),le=Ue(this.semver,">",X.semver,re)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return me||x||te&&oe||ae||le},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(X){var re=this.loose;X=X.trim(),A("range",X,re);var se=re?O[N]:O[F];X=X.replace(se,Ge),A("hyphen replace",X),X=X.replace(O[T],"$1$2$3"),A("comparator trim",X,O[T]),X=(X=(X=X.replace(O[z],"$1~")).replace(O[W],"$1^")).split(/\s+/).join(" ");var me=re?O[q]:O[D],x=X.split(" ").map(function(te){return function(oe,ae){return A("comp",oe),oe=function(le,fe){return le.trim().split(/\s+/).map(function(ve){return function(Se,we){A("caret",Se,we);var be=we?O[H]:O[$];return Se.replace(be,function(Pe,ye,pe,Ce,Re){var de;return A("caret",Se,Pe,ye,pe,Ce,Re),Te(ye)?de="":Te(pe)?de=">="+ye+".0.0 <"+(+ye+1)+".0.0":Te(Ce)?de=ye==="0"?">="+ye+"."+pe+".0 <"+ye+"."+(+pe+1)+".0":">="+ye+"."+pe+".0 <"+(+ye+1)+".0.0":Re?(A("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),de=ye==="0"?pe==="0"?">="+ye+"."+pe+"."+Ce+Re+" <"+ye+"."+pe+"."+(+Ce+1):">="+ye+"."+pe+"."+Ce+Re+" <"+ye+"."+(+pe+1)+".0":">="+ye+"."+pe+"."+Ce+Re+" <"+(+ye+1)+".0.0"):(A("no pr"),de=ye==="0"?pe==="0"?">="+ye+"."+pe+"."+Ce+" <"+ye+"."+pe+"."+(+Ce+1):">="+ye+"."+pe+"."+Ce+" <"+ye+"."+(+pe+1)+".0":">="+ye+"."+pe+"."+Ce+" <"+(+ye+1)+".0.0"),A("caret return",de),de})}(ve,fe)}).join(" ")}(oe,ae),A("caret",oe),oe=function(le,fe){return le.trim().split(/\s+/).map(function(ve){return function(Se,we){var be=we?O[M]:O[B];return Se.replace(be,function(Pe,ye,pe,Ce,Re){var de;return A("tilde",Se,Pe,ye,pe,Ce,Re),Te(ye)?de="":Te(pe)?de=">="+ye+".0.0 <"+(+ye+1)+".0.0":Te(Ce)?de=">="+ye+"."+pe+".0 <"+ye+"."+(+pe+1)+".0":Re?(A("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),de=">="+ye+"."+pe+"."+Ce+Re+" <"+ye+"."+(+pe+1)+".0"):de=">="+ye+"."+pe+"."+Ce+" <"+ye+"."+(+pe+1)+".0",A("tilde return",de),de})}(ve,fe)}).join(" ")}(oe,ae),A("tildes",oe),oe=function(le,fe){return A("replaceXRanges",le,fe),le.split(/\s+/).map(function(ve){return function(Se,we){Se=Se.trim();var be=we?O[u]:O[w];return Se.replace(be,function(Pe,ye,pe,Ce,Re,de){A("xRange",Se,Pe,ye,pe,Ce,Re,de);var Le=Te(pe),_e=Le||Te(Ce),Fe=_e||Te(Re);return ye==="="&&Fe&&(ye=""),Le?Pe=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Fe?(_e&&(Ce=0),Fe&&(Re=0),ye===">"?(ye=">=",_e?(pe=+pe+1,Ce=0,Re=0):Fe&&(Ce=+Ce+1,Re=0)):ye==="<="&&(ye="<",_e?pe=+pe+1:Ce=+Ce+1),Pe=ye+pe+"."+Ce+"."+Re):_e?Pe=">="+pe+".0.0 <"+(+pe+1)+".0.0":Fe&&(Pe=">="+pe+"."+Ce+".0 <"+pe+"."+(+Ce+1)+".0"),A("xRange return",Pe),Pe})}(ve,fe)}).join(" ")}(oe,ae),A("xrange",oe),oe=function(le,fe){return A("replaceStars",le,fe),le.trim().replace(O[V],"")}(oe,ae),A("stars",oe),oe}(te,re)}).join(" ").split(/\s+/);return this.loose&&(x=x.filter(function(te){return!!te.match(me)})),x=x.map(function(te){return new ke(te,re)})},De.prototype.intersects=function(X,re){if(!(X instanceof De))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(me){return X.set.some(function(x){return x.every(function(te){return me.intersects(te,re)})})})})},e.toComparators=function(X,re){return new De(X,re).set.map(function(se){return se.map(function(me){return me.value}).join(" ").trim().split(" ")})},De.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new Q(X,this.loose));for(var re=0;re<this.set.length;re++)if(Ke(this.set[re],X))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(X,re,se){var me=null,x=null;try{var te=new De(re,se)}catch(oe){return null}return X.forEach(function(oe){te.test(oe)&&(me&&x.compare(oe)!==-1||(x=new Q(me=oe,se)))}),me},e.minSatisfying=function(X,re,se){var me=null,x=null;try{var te=new De(re,se)}catch(oe){return null}return X.forEach(function(oe){te.test(oe)&&(me&&x.compare(oe)!==1||(x=new Q(me=oe,se)))}),me},e.validRange=function(X,re){try{return new De(X,re).range||"*"}catch(se){return null}},e.ltr=function(X,re,se){return $e(X,re,"<",se)},e.gtr=function(X,re,se){return $e(X,re,">",se)},e.outside=$e,e.prerelease=function(X,re){var se=J(X,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(X,re,se){return X=new De(X,se),re=new De(re,se),X.intersects(re)},e.coerce=function(X){if(X instanceof Q)return X;if(typeof X!="string")return null;var re=X.match(O[P]);return re==null?null:J((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,S(1))},function(K,e){var S,k,A=K.exports={};function L(){throw new Error("setTimeout has not been defined")}function U(){throw new Error("clearTimeout has not been defined")}function O(C){if(S===setTimeout)return setTimeout(C,0);if((S===L||!S)&&setTimeout)return S=setTimeout,setTimeout(C,0);try{return S(C,0)}catch(E){try{return S.call(null,C,0)}catch(p){return S.call(this,C,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:L}catch(C){S=L}try{k=typeof clearTimeout=="function"?clearTimeout:U}catch(C){k=U}})();var g,v=[],R=!1,f=-1;function y(){R&&g&&(R=!1,g.length?v=g.concat(v):f=-1,v.length&&I())}function I(){if(!R){var C=O(y);R=!0;for(var E=v.length;E;){for(g=v,v=[];++f<E;)g&&g[f].run();f=-1,E=v.length}g=null,R=!1,function(p){if(k===clearTimeout)return clearTimeout(p);if((k===U||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(p);try{k(p)}catch(m){try{return k.call(null,p)}catch(c){return k.call(this,p)}}}(C)}}function a(C,E){this.fun=C,this.array=E}function b(){}A.nextTick=function(C){var E=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)E[p-1]=arguments[p];v.push(new a(C,E)),v.length!==1||R||O(I)},a.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=b,A.addListener=b,A.once=b,A.off=b,A.removeListener=b,A.removeAllListeners=b,A.emit=b,A.prependListener=b,A.prependOnceListener=b,A.listeners=function(C){return[]},A.binding=function(C){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(C){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(Z[86],ee([0,1,7]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=S.globals.performance&&typeof S.globals.performance.now=="function";class A{constructor(U){this._highResolution=k&&U,this._startTime=this._now(),this._stopTime=-1}static create(U=!0){return new A(U)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?S.globals.performance.now():Date.now()}}e.StopWatch=A}),define(Z[3],ee([0,1,11,63,2,64,86]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var O;(function(E){E.None=()=>A.Disposable.None;function p(M){return(j,W=null,$)=>{let H=!1,q;return q=M(D=>{if(!H)return q?q.dispose():H=!0,j.call(W,D)},null,$),H&&q.dispose(),q}}E.once=p;function m(M,j){return o((W,$=null,H)=>M(q=>W.call($,j(q)),null,H))}E.map=m;function c(M,j){return o((W,$=null,H)=>M(q=>{j(q),W.call($,q)},null,H))}E.forEach=c;function s(M,j){return o((W,$=null,H)=>M(q=>j(q)&&W.call($,q),null,H))}E.filter=s;function t(M){return M}E.signal=t;function i(...M){return(j,W=null,$)=>(0,A.combinedDisposable)(...M.map(H=>H(q=>j.call(W,q),null,$)))}E.any=i;function n(M,j,W){let $=W;return m(M,H=>($=j($,H),$))}E.reduce=n;function o(M){let j;const W=new y({onFirstListenerAdd(){j=M(W.fire,W)},onLastListenerRemove(){j.dispose()}});return W.event}E.snapshot=o;function r(M,j,W=100,$=!1,H){let q,D,T,F=0;const N=new y({leakWarningThreshold:H,onFirstListenerAdd(){q=M(V=>{F++,D=j(D,V),$&&!T&&(N.fire(D),D=void 0),clearTimeout(T),T=setTimeout(()=>{const G=D;D=void 0,T=void 0,(!$||F>1)&&N.fire(G),F=0},W)})},onLastListenerRemove(){q.dispose()}});return N.event}E.debounce=r;function l(M){const j=new Date().getTime();return m(p(M),W=>new Date().getTime()-j)}E.stopwatch=l;function h(M){let j=!0,W;return s(M,$=>{const H=j||$!==W;return j=!1,W=$,H})}E.latch=h;function d(M,j=!1,W=[]){let $=W.slice(),H=M(T=>{$?$.push(T):D.fire(T)});const q=()=>{$&&$.forEach(T=>D.fire(T)),$=null},D=new y({onFirstListenerAdd(){H||(H=M(T=>D.fire(T)))},onFirstListenerDidAdd(){$&&(j?setTimeout(q):q())},onLastListenerRemove(){H&&H.dispose(),H=null}});return D.event}E.buffer=d;class w{constructor(j){this.event=j}map(j){return new w(m(this.event,j))}forEach(j){return new w(c(this.event,j))}filter(j){return new w(s(this.event,j))}reduce(j,W){return new w(n(this.event,j,W))}latch(){return new w(h(this.event))}debounce(j,W=100,$=!1,H){return new w(r(this.event,j,W,$,H))}on(j,W,$){return this.event(j,W,$)}once(j,W,$){return p(this.event)(j,W,$)}}function u(M){return new w(M)}E.chain=u;function P(M,j,W=$=>$){const $=(...T)=>D.fire(W(...T)),H=()=>M.on(j,$),q=()=>M.removeListener(j,$),D=new y({onFirstListenerAdd:H,onLastListenerRemove:q});return D.event}E.fromNodeEventEmitter=P;function _(M,j,W=$=>$){const $=(...T)=>D.fire(W(...T)),H=()=>M.addEventListener(j,$),q=()=>M.removeEventListener(j,$),D=new y({onFirstListenerAdd:H,onLastListenerRemove:q});return D.event}E.fromDOMEventEmitter=_;function z(M){const j=new y;let W=!1;return M.then(void 0,()=>null).then(()=>{W?j.fire(void 0):setTimeout(()=>j.fire(void 0),0)}),W=!0,j.event}E.fromPromise=z;function B(M){return new Promise(j=>p(M)(j))}E.toPromise=B})(O=e.Event||(e.Event={}));class g{constructor(p){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${p}_${g._idPool++}`}start(p){this._stopWatch=new U.StopWatch(!0),this._listenerCount=p}stop(){if(this._stopWatch){const p=this._stopWatch.elapsed();this._elapsedOverall+=p,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${p.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}g._idPool=0;let v=-1;function R(E){const p=v;return v=E,{dispose(){v=p}}}e.setGlobalLeakWarningThreshold=R;class f{constructor(p,m=Math.random().toString(18).slice(2,5)){this.customThreshold=p,this.name=m,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(p){let m=v;if(typeof this.customThreshold=="number"&&(m=this.customThreshold),!(m<=0||p<m)){this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(c)||0;if(this._stacks.set(c,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=m*.5;let t,i=0;for(const[n,o]of this._stacks)(!t||i<o)&&(t=n,i=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}}class y{constructor(p){var m;this._disposed=!1,this._options=p,this._leakageMon=v>0?new f(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((m=this._options)===null||m===void 0?void 0:m._profName)?new g(this._options._profName):void 0}get event(){return this._event||(this._event=(p,m,c)=>{var s;this._listeners||(this._listeners=new L.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(m?[p,m]:p);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,p,m);const n=(s=this._leakageMon)===null||s===void 0?void 0:s.check(this._listeners.size);let o;return o={dispose:()=>{n&&n(),o.dispose=y._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof A.DisposableStore?c.add(o):Array.isArray(c)&&c.push(o),o}),this._event}fire(p){var m,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new L.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,p]);for((m=this._perfMon)===null||m===void 0||m.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,t]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,t):s[0].call(s[1],t)}catch(i){(0,S.onUnexpectedError)(i)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var p,m,c;(p=this._listeners)===null||p===void 0||p.clear(),(m=this._deliveryQueue)===null||m===void 0||m.clear(),(c=this._leakageMon)===null||c===void 0||c.dispose(),this._disposed=!0}}e.Emitter=y,y._noop=function(){};class I extends y{constructor(p){super(p);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=p==null?void 0:p.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const p=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(p))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(p){this._listeners&&(this._isPaused!==0?this._eventQueue.push(p):super.fire(p))}}e.PauseableEmitter=I;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(p){const m={event:p,listener:null};this.events.push(m),this.hasListeners&&this.hook(m);const c=()=>{this.hasListeners&&this.unhook(m);const s=this.events.indexOf(m);this.events.splice(s,1)};return(0,A.toDisposable)((0,k.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(p=>this.hook(p))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(p=>this.unhook(p))}hook(p){p.listener=p.event(m=>this.emitter.fire(m))}unhook(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class b{constructor(){this.buffers=[]}wrapEvent(p){return(m,c,s)=>p(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>m.call(c,t)):m.call(c,t)},void 0,s)}bufferEvents(p){const m=[];this.buffers.push(m);const c=p();return this.buffers.pop(),m.forEach(s=>s()),c}}e.EventBufferer=b;class C{constructor(){this.listening=!1,this.inputEvent=O.None,this.inputEventListener=A.Disposable.None,this.emitter=new y({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(p){this.inputEvent=p,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=p(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=C}),define(Z[30],ee([0,1,3]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(O,g){const v=setTimeout(O.bind(g),0);return{dispose(){clearTimeout(v)}}});var A;(function(O){function g(v){return v===O.None||v===O.Cancelled||v instanceof L?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}O.isCancellationToken=g,O.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),O.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(A=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class U{constructor(g){this._token=void 0,this._parentListener=void 0,this._parentListener=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=A.Cancelled}dispose(g=!1){g&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=U}),define(Z[47],ee([0,1,11,2]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(E){const p=E;return p&&[p.on,p.pause,p.resume,p.destroy].every(m=>typeof m=="function")}e.isReadableStream=A;function L(E){const p=E;return p&&A(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean"}e.isReadableBufferedStream=L;function U(E,p){return new O(E,p)}e.newWriteableStream=U;class O{constructor(p,m){this.reducer=p,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){var m;if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof((m=this.options)===null||m===void 0?void 0:m.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(m=>m(p))}emitError(p){this.listeners.error.length===0?(0,S.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(m=>m(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,m){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(p,m){if(!this.state.destroyed){let c;switch(p){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const s=c.indexOf(m);s>=0&&c.splice(s,1)}}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(E,p){const m=[];let c;for(;(c=E.read())!==null;)m.push(c);return p(m)}e.consumeReadable=g;function v(E,p,m){const c=[];let s;for(;(s=E.read())!==null&&c.length<m;)c.push(s);return s===null&&c.length>0?p(c):{read:()=>{if(c.length>0)return c.shift();if(typeof s!="undefined"){const t=s;return s=void 0,t}return E.read()}}}e.peekReadable=v;function R(E,p){return new Promise((m,c)=>{const s=[];f(E,{onData:t=>{p&&s.push(t)},onError:t=>{p?c(t):m(void 0)},onEnd:()=>{m(p?p(s):void 0)}})})}e.consumeStream=R;function f(E,p){E.on("error",m=>p.onError(m)),E.on("end",()=>p.onEnd()),E.on("data",m=>p.onData(m))}e.listenStream=f;function y(E,p){return new Promise((m,c)=>{const s=new k.DisposableStore,t=[],i=r=>{if(t.push(r),t.length>p)return s.dispose(),E.pause(),m({stream:E,buffer:t,ended:!1})},n=r=>c(r),o=()=>m({stream:E,buffer:t,ended:!0});s.add((0,k.toDisposable)(()=>E.removeListener("error",n))),E.on("error",n),s.add((0,k.toDisposable)(()=>E.removeListener("end",o))),E.on("end",o),s.add((0,k.toDisposable)(()=>E.removeListener("data",i))),E.on("data",i)})}e.peekStream=y;function I(E,p){const m=U(p);return m.end(E),m}e.toStream=I;function a(){const E=U(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=a;function b(E){let p=!1;return{read:()=>p?null:(p=!0,E)}}e.toReadable=b;function C(E,p,m){const c=U(m);return f(E,{onData:s=>c.write(p.data(s)),onError:s=>c.error(p.error?p.error(s):s),onEnd:()=>c.end()}),c}e.transform=C}),define(Z[21],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function S(x){return!x||typeof x!="string"?!0:x.trim().length===0}e.isFalsyOrWhitespace=S;const k=/{(\d+)}/g;function A(x,...te){return te.length===0?x:x.replace(k,function(oe,ae){const le=parseInt(ae,10);return isNaN(le)||le<0||le>=te.length?oe:te[le]})}e.format=A;function L(x){return x.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=L;function U(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=U;function O(x,te){let oe=0;const ae=te.charCodeAt(0);for(let le=x.length-1;le>=0;le--)x.charCodeAt(le)===ae&&oe++;return oe}e.count=O;function g(x,te,oe="\u2026"){return x.length<=te?x:`${x.substr(0,te)}${oe}`}e.truncate=g;function v(x,te=" "){const oe=R(x,te);return f(oe,te)}e.trim=v;function R(x,te){if(!x||!te)return x;const oe=te.length;if(oe===0||x.length===0)return x;let ae=0;for(;x.indexOf(te,ae)===ae;)ae=ae+oe;return x.substring(ae)}e.ltrim=R;function f(x,te){if(!x||!te)return x;const oe=te.length,ae=x.length;if(oe===0||ae===0)return x;let le=ae,fe=-1;for(;fe=x.lastIndexOf(te,le-1),!(fe===-1||fe+oe!==le);){if(fe===0)return"";le=fe}return x.substring(0,le)}e.rtrim=f;function y(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=y;function I(x){return x.replace(/\*/g,"")}e.stripWildcards=I;function a(x,te,oe={}){if(!x)throw new Error("Cannot create regex from empty string");te||(x=U(x)),oe.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let ae="";return oe.global&&(ae+="g"),oe.matchCase||(ae+="i"),oe.multiline&&(ae+="m"),oe.unicode&&(ae+="u"),new RegExp(x,ae)}e.createRegExp=a;function b(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function C(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=C;function E(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}e.regExpFlags=E;function p(x){return x.split(/\r\n|\r|\n/)}e.splitLines=p;function m(x){for(let te=0,oe=x.length;te<oe;te++){const ae=x.charCodeAt(te);if(ae!==32&&ae!==9)return te}return-1}e.firstNonWhitespaceIndex=m;function c(x,te=0,oe=x.length){for(let ae=te;ae<oe;ae++){const le=x.charCodeAt(ae);if(le!==32&&le!==9)return x.substring(te,ae)}return x.substring(te,oe)}e.getLeadingWhitespace=c;function s(x,te=x.length-1){for(let oe=te;oe>=0;oe--){const ae=x.charCodeAt(oe);if(ae!==32&&ae!==9)return oe}return-1}e.lastNonWhitespaceIndex=s;function t(x,te){return x<te?-1:x>te?1:0}e.compare=t;function i(x,te,oe=0,ae=x.length,le=0,fe=te.length){for(;oe<ae&&le<fe;oe++,le++){let we=x.charCodeAt(oe),be=te.charCodeAt(le);if(we<be)return-1;if(we>be)return 1}const ve=ae-oe,Se=fe-le;return ve<Se?-1:ve>Se?1:0}e.compareSubstring=i;function n(x,te){return o(x,te,0,x.length,0,te.length)}e.compareIgnoreCase=n;function o(x,te,oe=0,ae=x.length,le=0,fe=te.length){for(;oe<ae&&le<fe;oe++,le++){let we=x.charCodeAt(oe),be=te.charCodeAt(le);if(we!==be){const Pe=we-be;if(!(Pe===32&&l(be))&&!(Pe===-32&&l(we)))return r(we)&&r(be)?Pe:i(x.toLowerCase(),te.toLowerCase(),oe,ae,le,fe)}}const ve=ae-oe,Se=fe-le;return ve<Se?-1:ve>Se?1:0}e.compareSubstringIgnoreCase=o;function r(x){return x>=97&&x<=122}e.isLowerAsciiLetter=r;function l(x){return x>=65&&x<=90}e.isUpperAsciiLetter=l;function h(x){return r(x)||l(x)}function d(x,te){return x.length===te.length&&w(x,te)}e.equalsIgnoreCase=d;function w(x,te,oe=x.length){for(let ae=0;ae<oe;ae++){const le=x.charCodeAt(ae),fe=te.charCodeAt(ae);if(le!==fe){if(h(le)&&h(fe)){const ve=Math.abs(le-fe);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(le).toLowerCase()!==String.fromCharCode(fe).toLowerCase())return!1}}return!0}function u(x,te){const oe=te.length;return te.length>x.length?!1:w(x,te,oe)}e.startsWithIgnoreCase=u;function P(x,te){let oe,ae=Math.min(x.length,te.length);for(oe=0;oe<ae;oe++)if(x.charCodeAt(oe)!==te.charCodeAt(oe))return oe;return ae}e.commonPrefixLength=P;function _(x,te){let oe,ae=Math.min(x.length,te.length);const le=x.length-1,fe=te.length-1;for(oe=0;oe<ae;oe++)if(x.charCodeAt(le-oe)!==te.charCodeAt(fe-oe))return oe;return ae}e.commonSuffixLength=_;function z(x){return 55296<=x&&x<=56319}e.isHighSurrogate=z;function B(x){return 56320<=x&&x<=57343}e.isLowSurrogate=B;function M(x,te){return(x-55296<<10)+(te-56320)+65536}e.computeCodePoint=M;function j(x,te,oe){const ae=x.charCodeAt(oe);if(z(ae)&&oe+1<te){const le=x.charCodeAt(oe+1);if(B(le))return M(ae,le)}return ae}e.getNextCodePoint=j;function W(x,te){const oe=x.charCodeAt(te-1);if(B(oe)&&te>1){const ae=x.charCodeAt(te-2);if(z(ae))return M(ae,oe)}return oe}function $(x,te){const oe=se.getInstance(),ae=te,le=x.length,fe=j(x,le,te);te+=fe>=65536?2:1;let ve=oe.getGraphemeBreakType(fe);for(;te<le;){const Se=j(x,le,te),we=oe.getGraphemeBreakType(Se);if(X(ve,we))break;te+=Se>=65536?2:1,ve=we}return te-ae}e.nextCharLength=$;function H(x,te){const oe=se.getInstance(),ae=te,le=W(x,te);te-=le>=65536?2:1;let fe=oe.getGraphemeBreakType(le);for(;te>0;){const ve=W(x,te),Se=oe.getGraphemeBreakType(ve);if(X(Se,fe))break;te-=ve>=65536?2:1,fe=Se}return ae-te}e.prevCharLength=H;function q(x,te){const oe=se.getInstance(),ae=x.length,le=te,fe=j(x,ae,te),ve=oe.getGraphemeBreakType(fe);te+=fe>=65536?2:1;let Se=ve;for(;te<ae;){const be=j(x,ae,te),Pe=oe.getGraphemeBreakType(be);if(X(Se,Pe))break;te+=be>=65536?2:1,Se=Pe}const we=te;for(te=le,Se=ve;te>0;){const be=W(x,te),Pe=oe.getGraphemeBreakType(be);if(X(Pe,Se))break;te-=be>=65536?2:1,Se=Pe}return[te,we]}function D(x,te){return te>0&&B(x.charCodeAt(te))?q(x,te-1):q(x,te)}e.getCharContainingOffset=D;function T(x){const te=x.length;let oe=0,ae=0;for(;ae<te;){const ve=j(x,te,ae);ae+=ve>=65536?2:1,ve<128?oe+=1:ve<2048?oe+=2:ve<65536?oe+=3:oe+=4}const le=new Uint8Array(oe);ae=0;let fe=0;for(;ae<te;){const ve=j(x,te,ae);ae+=ve>=65536?2:1,ve<128?le[fe++]=ve:ve<2048?(le[fe++]=192|(ve&1984)>>>6,le[fe++]=128|(ve&63)>>>0):ve<65536?(le[fe++]=224|(ve&61440)>>>12,le[fe++]=128|(ve&4032)>>>6,le[fe++]=128|(ve&63)>>>0):(le[fe++]=240|(ve&1835008)>>>18,le[fe++]=128|(ve&258048)>>>12,le[fe++]=128|(ve&4032)>>>6,le[fe++]=128|(ve&63)>>>0)}return le}e.encodeUTF8=T;function F(x){const te=x.byteLength,oe=[];let ae=0;for(;ae<te;){const le=x[ae];let fe;if(le>=240&&ae+3<te?fe=(x[ae++]&7)<<18>>>0|(x[ae++]&63)<<12>>>0|(x[ae++]&63)<<6>>>0|(x[ae++]&63)<<0>>>0:le>=224&&ae+2<te?fe=(x[ae++]&15)<<12>>>0|(x[ae++]&63)<<6>>>0|(x[ae++]&63)<<0>>>0:le>=192&&ae+1<te?fe=(x[ae++]&31)<<6>>>0|(x[ae++]&63)<<0>>>0:fe=x[ae++],fe>=0&&fe<=55295||fe>=57344&&fe<=65535)oe.push(String.fromCharCode(fe));else if(fe>=65536&&fe<=1114111){const ve=fe-65536,Se=55296+((ve&1047552)>>>10),we=56320+((ve&1023)>>>0);oe.push(String.fromCharCode(Se)),oe.push(String.fromCharCode(we))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=F;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function V(x){return N.test(x)}e.containsRTL=V;const G=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function J(x){return G.test(x)}e.containsEmoji=J;const Q=/^[\t\n\r\x20-\x7E]*$/;function ne(x){return Q.test(x)}e.isBasicASCII=ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ie(x){return e.UNUSUAL_LINE_TERMINATORS.test(x)}e.containsUnusualLineTerminators=ie;function ce(x){for(let te=0,oe=x.length;te<oe;te++)if(ue(x.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ce;function ue(x){return x=+x,x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}e.isFullWidthCharacter=ue;function ge(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129003||x>=129280&&x<=129535||x>=129648&&x<=129750}e.isEmojiImprecise=ge;function Ee(x,te){if(x.length<te)return x;const oe=/\b/g;let ae=0;for(;oe.test(x)&&!(x.length-oe.lastIndex<te);)ae=oe.lastIndex,oe.lastIndex+=1;return x.substring(ae).replace(/^\s/,"")}e.lcut=Ee;const Ie=/\x1B\x5B[12]?K/g,Oe=/\x1b\[\d+m/g,Ae=/\x1b\[0?m/g;function Ue(x){return x&&(x=x.replace(Ie,""),x=x.replace(Oe,""),x=x.replace(Ae,"")),x}e.removeAnsiEscapeCodes=Ue,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Ne(x){return ke(x)?x.substr(1):x}e.stripUTF8BOM=Ne;function De(x,te){if(!x||!te||x.length<te.length)return!1;const oe=te.length,ae=x.toLowerCase();let le=0,fe=-1;for(;le<oe;){const ve=ae.indexOf(te[le],fe+1);if(ve<0)return!1;fe=ve,le++}return!0}e.fuzzyContains=De;function Te(x,te=!1){return x?(te&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}e.containsUppercaseCharacter=Te;function Ge(x){return x.charAt(0).toUpperCase()+x.slice(1)}e.uppercaseFirstLetter=Ge;function Ke(x,te=1){if(te===0)return"";let oe=-1;do oe=x.indexOf(`
`,oe+1),te--;while(te>0&&oe>=0);return oe===-1?x:(x[oe-1]==="\r"&&oe--,x.substr(0,oe))}e.getNLines=Ke;function ze(x){const te=90-65+1;return x=x%(2*te),x<te?String.fromCharCode(97+x):String.fromCharCode(65+x-te)}e.singleLetterHash=ze;function $e(x){return se.getInstance().getGraphemeBreakType(x)}e.getGraphemeBreakType=$e;function X(x,te){return x===0?te!==5&&te!==7:x===2&&te===3?!1:x===4||x===2||x===3||te===4||te===2||te===3?!0:!(x===8&&(te===8||te===9||te===11||te===12)||(x===11||x===9)&&(te===9||te===10)||(x===12||x===10)&&te===10||te===5||te===13||te===7||x===1||x===13&&te===14||x===6&&te===6)}e.breakBetweenGraphemeBreakType=X;var re;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class se{constructor(){this._data=me()}static getInstance(){return se._INSTANCE||(se._INSTANCE=new se),se._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const oe=this._data,ae=oe.length/3;let le=1;for(;le<=ae;)if(te<oe[3*le])le=2*le;else if(te>oe[3*le+1])le=2*le+1;else return oe[3*le+2];return 0}}se._INSTANCE=null;function me(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(Z[22],ee([0,1,21,47]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",L=typeof TextEncoder!="undefined",U=typeof TextDecoder!="undefined";let O,g;class v{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return A?new v(Buffer.allocUnsafe(r)):new v(new Uint8Array(r))}static wrap(r){return A&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new v(r)}static fromString(r,l){return!((l==null?void 0:l.dontUseNodeBuffer)||!1)&&A?new v(Buffer.from(r)):L?(O||(O=new TextEncoder),new v(O.encode(r))):new v(S.encodeUTF8(r))}static concat(r,l){if(typeof l=="undefined"){l=0;for(let w=0,u=r.length;w<u;w++)l+=r[w].byteLength}const h=v.alloc(l);let d=0;for(let w=0,u=r.length;w<u;w++){const P=r[w];h.set(P,d),d+=P.byteLength}return h}toString(){return A?this.buffer.toString():U?(g||(g=new TextDecoder),g.decode(this.buffer)):S.decodeUTF8(this.buffer)}slice(r,l){return new v(this.buffer.subarray(r,l))}set(r,l){r instanceof v?this.buffer.set(r.buffer,l):this.buffer.set(r,l)}readUInt32BE(r){return y(this.buffer,r)}writeUInt32BE(r,l){I(this.buffer,r,l)}readUInt32LE(r){return a(this.buffer,r)}writeUInt32LE(r,l){b(this.buffer,r,l)}readUInt8(r){return C(this.buffer,r)}writeUInt8(r,l){E(this.buffer,r,l)}}e.VSBuffer=v;function R(o,r){return o[r+0]<<0>>>0|o[r+1]<<8>>>0}e.readUInt16LE=R;function f(o,r,l){o[l+0]=r&255,r=r>>>8,o[l+1]=r&255}e.writeUInt16LE=f;function y(o,r){return o[r]*2**24+o[r+1]*2**16+o[r+2]*2**8+o[r+3]}e.readUInt32BE=y;function I(o,r,l){o[l+3]=r,r=r>>>8,o[l+2]=r,r=r>>>8,o[l+1]=r,r=r>>>8,o[l]=r}e.writeUInt32BE=I;function a(o,r){return o[r+0]<<0>>>0|o[r+1]<<8>>>0|o[r+2]<<16>>>0|o[r+3]<<24>>>0}e.readUInt32LE=a;function b(o,r,l){o[l+0]=r&255,r=r>>>8,o[l+1]=r&255,r=r>>>8,o[l+2]=r&255,r=r>>>8,o[l+3]=r&255}e.writeUInt32LE=b;function C(o,r){return o[r]}e.readUInt8=C;function E(o,r,l){o[l]=r}e.writeUInt8=E;function p(o){return k.consumeReadable(o,r=>v.concat(r))}e.readableToBuffer=p;function m(o){return k.toReadable(o)}e.bufferToReadable=m;function c(o){return k.consumeStream(o,r=>v.concat(r))}e.streamToBuffer=c;async function s(o){return o.ended?v.concat(o.buffer):v.concat([...o.buffer,await c(o.stream)])}e.bufferedStreamToBuffer=s;function t(o){return k.toStream(o,r=>v.concat(r))}e.bufferToStream=t;function i(o){return k.transform(o,{data:r=>typeof r=="string"?v.fromString(r):v.wrap(r)},r=>v.concat(r))}e.streamToBufferReadableStream=i;function n(o){return k.newWriteableStream(r=>v.concat(r),o)}e.newWriteableBufferStream=n}),define(Z[15],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function S(h){return Array.isArray(h)}e.isArray=S;function k(h){return typeof h=="string"}e.isString=k;function A(h){return Array.isArray(h)&&h.every(d=>k(d))}e.isStringArray=A;function L(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=L;function U(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=U;function O(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=O;function g(h){return h===!0||h===!1}e.isBoolean=g;function v(h){return typeof h=="undefined"}e.isUndefined=v;function R(h){return!f(h)}e.isDefined=R;function f(h){return v(h)||h===null}e.isUndefinedOrNull=f;function y(h,d){if(!h)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}e.assertType=y;function I(h){if(f(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=I;function a(...h){const d=[];for(let w=0;w<h.length;w++){const u=h[w];if(f(u))throw new Error(`Assertion Failed: argument at index ${w} is undefined or null`);d.push(u)}return d}e.assertAllDefined=a;const b=Object.prototype.hasOwnProperty;function C(h){if(!L(h))return!1;for(let d in h)if(b.call(h,d))return!1;return!0}e.isEmptyObject=C;function E(h){return typeof h=="function"}e.isFunction=E;function p(...h){return h.length>0&&h.every(E)}e.areFunctions=p;function m(h,d){const w=Math.min(h.length,d.length);for(let u=0;u<w;u++)c(h[u],d[u])}e.validateConstraints=m;function c(h,d){if(k(d)){if(typeof h!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(E(d)){try{if(h instanceof d)return}catch(w){}if(!f(h)&&h.constructor===d||d.length===1&&d.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function s(h){let d=[],w=Object.getPrototypeOf(h);for(;Object.prototype!==w;)d=d.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return d}e.getAllPropertyNames=s;function t(h){const d=[];for(const w of s(h))typeof h[w]=="function"&&d.push(w);return d}e.getAllMethodNames=t;function i(h,d){const w=P=>function(){const _=Array.prototype.slice.call(arguments,0);return d(P,_)};let u={};for(const P of h)u[P]=w(P);return u}e.createProxyObject=i;function n(h){return h===null?void 0:h}e.withNullAsUndefined=n;function o(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=o;function r(h){return class{constructor(){return new Proxy({},{get(d,w){if(d[w])return d[w];throw new Error(`Not Implemented: ${h}->${String(w)}`)}})}}}e.NotImplementedProxy=r;function l(h){throw new Error("Unreachable")}e.assertNever=l}),define(Z[42],ee([0,1,7,21,8,15]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function U(i){return i===47||i===92}e.isPathSeparator=U;function O(i){return i.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=O;function g(i,n=A.posix.sep){if(!i)return"";const o=i.length,r=i.charCodeAt(0);if(U(r)){if(U(i.charCodeAt(1))&&!U(i.charCodeAt(2))){let h=3;const d=h;for(;h<o&&!U(i.charCodeAt(h));h++);if(d!==h&&!U(i.charCodeAt(h+1))){for(h+=1;h<o;h++)if(U(i.charCodeAt(h)))return i.slice(0,h+1).replace(/[\\/]/g,n)}}return n}else if(C(r)&&i.charCodeAt(1)===58)return U(i.charCodeAt(2))?i.slice(0,2)+n:i.slice(0,2);let l=i.indexOf("://");if(l!==-1){for(l+=3;l<o;l++)if(U(i.charCodeAt(l)))return i.slice(0,l+1)}return""}e.getRoot=g;function v(i){if(!S.isWindows||!i||i.length<5)return!1;let n=i.charCodeAt(0);if(n!==92||(n=i.charCodeAt(1),n!==92))return!1;let o=2;const r=o;for(;o<i.length&&(n=i.charCodeAt(o),n!==92);o++);return!(r===o||(n=i.charCodeAt(o+1),isNaN(n)||n===92))}e.isUNC=v;const R=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function I(i,n=S.isWindows){const o=n?R:f;return!(!i||i.length===0||/^\s+$/.test(i)||(o.lastIndex=0,o.test(i))||n&&y.test(i)||i==="."||i===".."||n&&i[i.length-1]==="."||n&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=I;function a(i,n,o){const r=i===n;return!o||r?r:!i||!n?!1:(0,k.equalsIgnoreCase)(i,n)}e.isEqual=a;function b(i,n,o,r=A.sep){if(i===n)return!0;if(!i||!n||n.length>i.length)return!1;if(o){if(!(0,k.startsWithIgnoreCase)(i,n))return!1;if(n.length===i.length)return!0;let h=n.length;return n.charAt(n.length-1)===r&&h--,i.charAt(h)===r}return n.charAt(n.length-1)!==r&&(n+=r),i.indexOf(n)===0}e.isEqualOrParent=b;function C(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=C;function E(i,n){return S.isWindows&&i.endsWith(":")&&(i+=A.sep),(0,A.isAbsolute)(i)||(i=(0,A.join)(n,i)),i=(0,A.normalize)(i),S.isWindows?(i=(0,k.rtrim)(i,A.sep),i.endsWith(":")&&(i+=A.sep)):(i=(0,k.rtrim)(i,A.sep),i||(i=A.sep)),i}e.sanitizeFilePath=E;function p(i){const n=(0,A.normalize)(i);return S.isWindows?i.length>3?!1:m(n)&&(i.length===2||n.charCodeAt(2)===92):n===A.posix.sep}e.isRootOrDriveLetter=p;function m(i){return S.isWindows?C(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function c(i){return m(i)?i[0]:void 0}e.getDriveLetter=c;function s(i,n,o){return n.length>i.length?-1:i===n?0:(o&&(i=i.toLowerCase(),n=n.toLowerCase()),i.indexOf(n))}e.indexOfPath=s;function t(i){const n=i.split(":");let o,r,l;if(n.forEach(h=>{const d=Number(h);(0,L.isNumber)(d)?r===void 0?r=d:l===void 0&&(l=d):o=o?[o,h].join(":"):h}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:r!==void 0?r:void 0,column:l!==void 0?l:r!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(Z[26],ee([0,1,15]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const b=Array.isArray(a)?[]:{};return Object.keys(a).forEach(C=>{a[C]&&typeof a[C]=="object"?b[C]=k(a[C]):b[C]=a[C]}),b}e.deepClone=k;function A(a){if(!a||typeof a!="object")return a;const b=[a];for(;b.length>0;){const C=b.shift();Object.freeze(C);for(const E in C)if(L.call(C,E)){const p=C[E];typeof p=="object"&&!Object.isFrozen(p)&&b.push(p)}}return a}e.deepFreeze=A;const L=Object.prototype.hasOwnProperty;function U(a,b){return O(a,b,new Set)}e.cloneAndChange=U;function O(a,b,C){if((0,S.isUndefinedOrNull)(a))return a;const E=b(a);if(typeof E!="undefined")return E;if((0,S.isArray)(a)){const p=[];for(const m of a)p.push(O(m,b,C));return p}if((0,S.isObject)(a)){if(C.has(a))throw new Error("Cannot clone recursive data-structure");C.add(a);const p={};for(let m in a)L.call(a,m)&&(p[m]=O(a[m],b,C));return C.delete(a),p}return a}function g(a,b,C=!0){return(0,S.isObject)(a)?((0,S.isObject)(b)&&Object.keys(b).forEach(E=>{E in a?C&&((0,S.isObject)(a[E])&&(0,S.isObject)(b[E])?g(a[E],b[E],C):a[E]=b[E]):a[E]=b[E]}),a):b}e.mixin=g;function v(a,b){if(a===b)return!0;if(a==null||b===null||b===void 0||typeof a!=typeof b||typeof a!="object"||Array.isArray(a)!==Array.isArray(b))return!1;let C,E;if(Array.isArray(a)){if(a.length!==b.length)return!1;for(C=0;C<a.length;C++)if(!v(a[C],b[C]))return!1}else{const p=[];for(E in a)p.push(E);p.sort();const m=[];for(E in b)m.push(E);if(m.sort(),!v(p,m))return!1;for(C=0;C<p.length;C++)if(!v(a[p[C]],b[p[C]]))return!1}return!0}e.equals=v;function R(a){const b=new Set;return JSON.stringify(a,(C,E)=>{if((0,S.isObject)(E)||Array.isArray(E)){if(b.has(E))return"[Circular]";b.add(E)}return E})}e.safeStringify=R;function f(a,b,C){const E=b(a);return typeof E=="undefined"?C:E}e.getOrDefault=f;function y(a,b){const C=Object.create(null);return!a||!b||Object.keys(b).forEach(p=>{const m=a[p],c=b[p];v(m,c)||(C[p]=c)}),C}e.distinct=y;function I(a,b){const C=b.toLowerCase(),E=Object.keys(a).find(p=>p.toLowerCase()===C);return E?a[E]:a[b]}e.getCaseInsensitive=I}),define(Z[4],ee([0,1,7,8]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,L=/^\//,U=/^\/\//;function O(n,o){if(!n.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!A.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!L.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(U.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(n,o){return!n&&!o?"file":n}function v(n,o){switch(n){case"https":case"http":case"file":o?o[0]!==f&&(o=f+o):o=f;break}return o}const R="",f="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class I{constructor(o,r,l,h,d,w=!1){typeof o=="object"?(this.scheme=o.scheme||R,this.authority=o.authority||R,this.path=o.path||R,this.query=o.query||R,this.fragment=o.fragment||R):(this.scheme=g(o,w),this.authority=r||R,this.path=v(this.scheme,l||R),this.query=h||R,this.fragment=d||R,O(this,w))}static isUri(o){return o instanceof I?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return m(this,!1)}with(o){if(!o)return this;let{scheme:r,authority:l,path:h,query:d,fragment:w}=o;return r===void 0?r=this.scheme:r===null&&(r=R),l===void 0?l=this.authority:l===null&&(l=R),h===void 0?h=this.path:h===null&&(h=R),d===void 0?d=this.query:d===null&&(d=R),w===void 0?w=this.fragment:w===null&&(w=R),r===this.scheme&&l===this.authority&&h===this.path&&d===this.query&&w===this.fragment?this:new b(r,l,h,d,w)}static parse(o,r=!1){const l=y.exec(o);return l?new b(l[2]||R,i(l[4]||R),i(l[5]||R),i(l[7]||R),i(l[9]||R),r):new b(R,R,R,R,R)}static file(o){let r=R;if(S.isWindows&&(o=o.replace(/\\/g,f)),o[0]===f&&o[1]===f){const l=o.indexOf(f,2);l===-1?(r=o.substring(2),o=f):(r=o.substring(2,l),o=o.substring(l)||f)}return new b("file",r,o,R,R)}static from(o){return new b(o.scheme,o.authority,o.path,o.query,o.fragment)}static joinPath(o,...r){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return S.isWindows&&o.scheme==="file"?l=I.file(k.win32.join(m(o,!0),...r)).path:l=k.posix.join(o.path,...r),o.with({path:l})}toString(o=!1){return c(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof I)return o;{const r=new b(o);return r._formatted=o.external,r._fsPath=o._sep===a?o.fsPath:null,r}}else return o}}e.URI=I;const a=S.isWindows?1:void 0;class b extends I{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(o=!1){return o?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=a),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(n,o){let r,l=-1;for(let h=0;h<n.length;h++){const d=n.charCodeAt(h);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||o&&d===47)l!==-1&&(r+=encodeURIComponent(n.substring(l,h)),l=-1),r!==void 0&&(r+=n.charAt(h));else{r===void 0&&(r=n.substr(0,h));const w=C[d];w!==void 0?(l!==-1&&(r+=encodeURIComponent(n.substring(l,h)),l=-1),r+=w):l===-1&&(l=h)}}return l!==-1&&(r+=encodeURIComponent(n.substring(l))),r!==void 0?r:n}function p(n){let o;for(let r=0;r<n.length;r++){const l=n.charCodeAt(r);l===35||l===63?(o===void 0&&(o=n.substr(0,r)),o+=C[l]):o!==void 0&&(o+=n[r])}return o!==void 0?o:n}function m(n,o){let r;return n.authority&&n.path.length>1&&n.scheme==="file"?r=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?o?r=n.path.substr(1):r=n.path[1].toLowerCase()+n.path.substr(2):r=n.path,S.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=m;function c(n,o){const r=o?p:E;let l="",{scheme:h,authority:d,path:w,query:u,fragment:P}=n;if(h&&(l+=h,l+=":"),(d||h==="file")&&(l+=f,l+=f),d){let _=d.indexOf("@");if(_!==-1){const z=d.substr(0,_);d=d.substr(_+1),_=z.indexOf(":"),_===-1?l+=r(z,!1):(l+=r(z.substr(0,_),!1),l+=":",l+=r(z.substr(_+1),!1)),l+="@"}d=d.toLowerCase(),_=d.indexOf(":"),_===-1?l+=r(d,!1):(l+=r(d.substr(0,_),!1),l+=d.substr(_))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const _=w.charCodeAt(1);_>=65&&_<=90&&(w=`/${String.fromCharCode(_+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const _=w.charCodeAt(0);_>=65&&_<=90&&(w=`${String.fromCharCode(_+32)}:${w.substr(2)}`)}l+=r(w,!0)}return u&&(l+="?",l+=r(u,!1)),P&&(l+="#",l+=o?P:E(P,!1)),l}function s(n){try{return decodeURIComponent(n)}catch(o){return n.length>3?n.substr(0,3)+s(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(n){return n.match(t)?n.replace(t,o=>s(o)):n}}),define(Z[87],ee([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function k(v){const R=v;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=k;function A(v){const R=[];let f;try{const y=JSON.parse(v.arguments),I=y[y.length-1];I&&I.__$stack&&(y.pop(),f=I.__$stack),R.push(...y)}catch(y){R.push("Unable to log remote console arguments",v.arguments)}return{args:R,stack:f}}e.parse=A;function L(v){if(typeof v!="string")return L(A(v).stack);const R=v;if(R){const f=U(R),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(f||"");if(y&&y.length===4)return{uri:S.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=L;function U(v){if(!v)return v;const R=v.indexOf(`
`);return R===-1?v:v.substring(0,R)}function O(v,R){const{args:f,stack:y}=A(v),I=typeof f[0]=="string"&&f.length===1;let a=U(y);a&&(a=`(${a.trim()})`);let b=[];if(typeof f[0]=="string"?a&&I?b=[`%c[${R}] %c${f[0]} %c${a}`,g("blue"),g(""),g("grey")]:b=[`%c[${R}] %c${f[0]}`,g("blue"),g(""),...f.slice(1)]:b=[`%c[${R}]%`,g("blue"),...f],a&&!I&&b.push(a),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,b)}e.log=O;function g(v){return`color: ${v}`}});var lt=this&&this.__classPrivateFieldSet||function(K,e,S,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!A:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(K,S):A?A.value=S:e.set(K,S),S},je=this&&this.__classPrivateFieldGet||function(K,e,S,k){if(S==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!k:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return S==="m"?k:S==="a"?k.call(K):k?k.value:e.get(K)};define(Z[37],ee([0,1,4,21]),function(K,e,S,k){"use strict";var A,L,U;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function O(t,i,n){let o=t.get(i);return o===void 0&&(o=n,t.set(i,o)),o}e.getOrSet=O;function g(t){const i=[];return t.forEach((n,o)=>{i.push(`${o} => ${n}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=g;function v(t){const i=[];return t.forEach(n=>{i.push(n)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=v;class R{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const n=i.charCodeAt(0),o=this._value.charCodeAt(this._pos);return n-o}value(){return this._value[this._pos]}}e.StringIterator=R;class f{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,k.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=f;class y{constructor(i=!0,n=!0){this._splitOnBackslash=i,this._caseSensitive=n}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,k.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var I;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(I||(I={}));class a{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,k.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class b{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class C{constructor(i){this._iter=i}static forUris(i=()=>!1){return new C(new a(i))}static forPaths(){return new C(new y)}static forStrings(){return new C(new R)}static forConfigKeys(){return new C(new f)}clear(){this._root=void 0}set(i,n){const o=this._iter.reset(i);let r;for(this._root||(this._root=new b,this._root.segment=o.value()),r=this._root;;){const h=o.cmp(r.segment);if(h>0)r.left||(r.left=new b,r.left.segment=o.value()),r=r.left;else if(h<0)r.right||(r.right=new b,r.right.segment=o.value()),r=r.right;else if(o.hasNext())o.next(),r.mid||(r.mid=new b,r.mid.segment=o.value()),r=r.mid;else break}const l=r.value;return r.value=n,r.key=i,l}get(i){var n;return(n=this._getNode(i))===null||n===void 0?void 0:n.value}_getNode(i){const n=this._iter.reset(i);let o=this._root;for(;o;){const r=n.cmp(o.segment);if(r>0)o=o.left;else if(r<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else break}return o}has(i){const n=this._getNode(i);return!((n==null?void 0:n.value)===void 0&&(n==null?void 0:n.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,n){const o=this._iter.reset(i),r=[];let l=this._root;for(;l;){const h=o.cmp(l.segment);if(h>0)r.push([1,l]),l=l.left;else if(h<0)r.push([-1,l]),l=l.right;else if(o.hasNext())o.next(),r.push([0,l]),l=l.mid;else{for(n?(l.left=void 0,l.mid=void 0,l.right=void 0):l.value=void 0;r.length>0&&l.isEmpty();){let[d,w]=r.pop();switch(d){case 1:w.left=void 0;break;case 0:w.mid=void 0;break;case-1:w.right=void 0;break}l=w}break}}}findSubstr(i){const n=this._iter.reset(i);let o=this._root,r;for(;o;){const l=n.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(n.hasNext())n.next(),r=o.value||r,o=o.mid;else break}return o&&o.value||r}findSuperstr(i){const n=this._iter.reset(i);let o=this._root;for(;o;){const r=n.cmp(o.segment);if(r>0)o=o.left;else if(r<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(i){for(const[n,o]of this)i(o,n)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){i&&(yield*this._entries(i.left),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid),yield*this._entries(i.right))}}e.TernarySearchTree=C;class E{constructor(i,n){this[A]="ResourceMap",i instanceof E?(this.map=new Map(i.map),this.toKey=n!=null?n:E.defaultToKey):(this.map=new Map,this.toKey=i!=null?i:E.defaultToKey)}set(i,n){return this.map.set(this.toKey(i),n),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,n){typeof n!="undefined"&&(i=i.bind(n));for(let[o,r]of this.map)i(r,S.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield S.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[S.URI.parse(i[0]),i[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[S.URI.parse(i[0]),i[1]]}}e.ResourceMap=E,E.defaultToKey=t=>t.toString();var p;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class m{constructor(){this[L]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,n=0){const o=this._map.get(i);if(!!o)return n!==0&&this.touch(o,n),o.value}set(i,n,o=0){let r=this._map.get(i);if(r)r.value=n,o!==0&&this.touch(r,o);else{switch(r={key:i,value:n,next:void 0,previous:void 0},o){case 0:this.addItemLast(r);break;case 1:this.addItemFirst(r);break;case 2:this.addItemLast(r);break;default:this.addItemLast(r);break}this._map.set(i,r),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this._map.get(i);if(!!n)return this._map.delete(i),this.removeItem(n),this._size--,n.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}}forEach(i,n){const o=this._state;let r=this._head;for(;r;){if(n?i.bind(n)(r.value,r.key,this):i(r.value,r.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");r=r.next}}keys(){const i=this,n=this._state;let o=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(o){const l={value:o.key,done:!1};return o=o.next,l}else return{value:void 0,done:!0}}};return r}values(){const i=this,n=this._state;let o=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(o){const l={value:o.value,done:!1};return o=o.next,l}else return{value:void 0,done:!0}}};return r}entries(){const i=this,n=this._state;let o=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(o){const l={value:[o.key,o.value],done:!1};return o=o.next,l}else return{value:void 0,done:!0}}};return r}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(!(i>=this.size)){if(i===0){this.clear();return}let n=this._head,o=this.size;for(;n&&o>i;)this._map.delete(n.key),n=n.next,o--;this._head=n,this._size=o,n&&(n.previous=void 0),this._state++}}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const n=i.next,o=i.previous;if(!n||!o)throw new Error("Invalid list");n.previous=o,o.next=n}i.next=void 0,i.previous=void 0,this._state++}touch(i,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(i===this._head)return;const o=i.next,r=i.previous;i===this._tail?(r.next=void 0,this._tail=r):(o.previous=r,r.next=o),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(n===2){if(i===this._tail)return;const o=i.next,r=i.previous;i===this._head?(o.previous=void 0,this._head=o):(o.previous=r,r.next=o),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((n,o)=>{i.push([o,n])}),i}fromJSON(i){this.clear();for(const[n,o]of i)this.set(n,o)}}e.LinkedMap=m;class c extends m{constructor(i,n=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,n=2){return super.get(i,n)}peek(i){return super.get(i,0)}set(i,n){return super.set(i,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class s{constructor(i){U.set(this,void 0),lt(this,U,i,"f")}get size(){return je(this,U,"f").size}forEach(i,n){je(this,U,"f").forEach(i,n)}get(i){return je(this,U,"f").get(i)}has(i){return je(this,U,"f").has(i)}entries(){return je(this,U,"f").entries()}keys(){return je(this,U,"f").keys()}values(){return je(this,U,"f").values()}[(U=new WeakMap,Symbol.iterator)](){return je(this,U,"f").entries()}}e.ReadonlyMapView=s}),define(Z[88],ee([0,1,22,21,4]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(v){return JSON.stringify(v,O)}e.stringify=L;function U(v){let R=JSON.parse(v);return R=g(R),R}e.parse=U;function O(v,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,k.regExpFlags)(R)}:R}function g(v,R=0){if(!v||R>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return A.URI.revive(v);case 2:return new RegExp(v.source,v.flags)}if(v instanceof S.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let f=0;f<v.length;++f)v[f]=g(v[f],R+1);else for(const f in v)Object.hasOwnProperty.call(v,f)&&(v[f]=g(v[f],R+1))}return v}e.revive=g}),define(Z[16],ee([0,1,4,7]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(O){O.inMemory="inmemory",O.vscode="vscode",O.internal="private",O.walkThrough="walkThrough",O.walkThroughSnippet="walkThroughSnippet",O.http="http",O.https="https",O.file="file",O.mailto="mailto",O.untitled="untitled",O.data="data",O.command="command",O.vscodeRemote="vscode-remote",O.vscodeRemoteResource="vscode-remote-resource",O.userData="vscode-userdata",O.vscodeCustomEditor="vscode-custom-editor",O.vscodeNotebook="vscode-notebook",O.vscodeNotebookCell="vscode-notebook-cell",O.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",O.vscodeSettings="vscode-settings",O.vscodeWorkspaceTrust="vscode-workspace-trust",O.webviewPanel="webview-panel",O.vscodeWebview="vscode-webview",O.extension="extension",O.vscodeFileResource="vscode-file"})(A=e.Schemas||(e.Schemas={}));class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}set(g,v,R){this._hosts[g]=v,this._ports[g]=R}setConnectionToken(g,v){this._connectionTokens[g]=v}rewrite(g){if(this._delegate)return this._delegate(g);const v=g.authority;let R=this._hosts[v];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const f=this._ports[v],y=this._connectionTokens[v];let I=`path=${encodeURIComponent(g.path)}`;return typeof y=="string"&&(I+=`&tkn=${encodeURIComponent(y)}`),S.URI.from({scheme:k.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${R}:${f}`,path:"/vscode-remote-resource",query:I})}}e.RemoteAuthorities=new L;class U{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(g,v,R){const f=this.toUri(g,v);return f.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(f):k.isNative&&(R||k.isPreferringBrowserCodeLoad)&&f.scheme===A.file?f.with({scheme:A.vscodeFileResource,authority:f.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):f}asFileUri(g,v){const R=this.toUri(g,v);return R.scheme===A.vscodeFileResource?R.with({scheme:A.file,authority:R.authority!==this.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(g,v){return S.URI.isUri(g)?g:S.URI.parse(v.toUrl(g))}}e.FileAccess=new U}),define(Z[65],ee([0,1,37]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const k=new S.LRUCache(1e4);function A(v){return g(v,"NFC",k)}e.normalizeNFC=A;const L=new S.LRUCache(1e4);function U(v){return g(v,"NFD",L)}e.normalizeNFD=U;const O=/[^\u0000-\u0080]/;function g(v,R,f){if(!e.canNormalize||!v)return v;const y=f.get(v);if(y)return y;let I;return O.test(v)?I=v.normalize(R):I=v,f.set(v,I),I}e.removeAccents=function(){if(e.canNormalize){const v=/[\u0300-\u036f]/g;return function(R){return U(R).replace(v,"")}}else return function(v){return v}}()}),define(Z[12],ee([0,1,42,8,4,21,16,7]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(I){return(0,A.uriToFsPath)(I,!0)}e.originalFSPath=g;class v{constructor(a){this._ignorePathCasing=a}compare(a,b,C=!1){return a===b?0:(0,L.compare)(this.getComparisonKey(a,C),this.getComparisonKey(b,C))}isEqual(a,b,C=!1){return a===b?!0:!a||!b?!1:this.getComparisonKey(a,C)===this.getComparisonKey(b,C)}getComparisonKey(a,b=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,b,C=!1){if(a.scheme===b.scheme){if(a.scheme===U.Schemas.file)return S.isEqualOrParent(g(a),g(b),this._ignorePathCasing(a))&&a.query===b.query&&(C||a.fragment===b.fragment);if((0,e.isEqualAuthority)(a.authority,b.authority))return S.isEqualOrParent(a.path,b.path,this._ignorePathCasing(a),"/")&&a.query===b.query&&(C||a.fragment===b.fragment)}return!1}joinPath(a,...b){return A.URI.joinPath(a,...b)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return k.posix.basename(a.path)}extname(a){return k.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let b;return a.scheme===U.Schemas.file?b=A.URI.file(k.dirname(g(a))).path:(b=k.posix.dirname(a.path),a.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),b="/")),a.with({path:b})}normalizePath(a){if(!a.path.length)return a;let b;return a.scheme===U.Schemas.file?b=A.URI.file(k.normalize(g(a))).path:b=k.posix.normalize(a.path),a.with({path:b})}relativePath(a,b){if(!(a.scheme!==b.scheme||!(0,e.isEqualAuthority)(a.authority,b.authority))){if(a.scheme===U.Schemas.file){const p=k.relative(g(a),g(b));return O.isWindows?S.toSlashes(p):p}let C=a.path||"/",E=b.path||"/";if(this._ignorePathCasing(a)){let p=0;for(const m=Math.min(C.length,E.length);p<m&&!(C.charCodeAt(p)!==E.charCodeAt(p)&&C.charAt(p).toLowerCase()!==E.charAt(p).toLowerCase());p++);C=E.substr(0,p)+C.substr(p)}return k.posix.relative(C,E)}}resolvePath(a,b){if(a.scheme===U.Schemas.file){const C=A.URI.file(k.resolve(g(a),b));return a.with({authority:C.authority,path:C.path})}return b.indexOf("/")===-1&&(b=S.toSlashes(b),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b)),a.with({path:k.posix.resolve(a.path,b)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,b){return a===b||(0,L.equalsIgnoreCase)(a,b)}hasTrailingPathSeparator(a,b=k.sep){if(a.scheme===U.Schemas.file){const C=g(a);return C.length>S.getRoot(C).length&&C[C.length-1]===b}else{const C=a.path;return C.length>1&&C.charCodeAt(C.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,b=k.sep){return(0,e.hasTrailingPathSeparator)(a,b)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,b=k.sep){let C=!1;if(a.scheme===U.Schemas.file){const E=g(a);C=E!==void 0&&E.length===S.getRoot(E).length&&E[E.length-1]===b}else{b="/";const E=a.path;C=E.length===1&&E.charCodeAt(E.length-1)===47}return!C&&!(0,e.hasTrailingPathSeparator)(a,b)?a.with({path:a.path+"/"}):a}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(I=>I.scheme===U.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new v(I=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(I,a){const b=[];for(let C=0;C<I.length;C++){const E=a(I[C]);I.some((p,m)=>m===C?!1:(0,e.isEqualOrParent)(E,a(p)))||b.push(I[C])}return b}e.distinctParents=R;var f;(function(I){I.META_DATA_LABEL="label",I.META_DATA_DESCRIPTION="description",I.META_DATA_SIZE="size",I.META_DATA_MIME="mime";function a(b){const C=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(m=>{const[c,s]=m.split(":");c&&s&&C.set(c,s)});const p=b.path.substring(0,b.path.indexOf(";"));return p&&C.set(I.META_DATA_MIME,p),C}I.parseMetaData=a})(f=e.DataUri||(e.DataUri={}));function y(I,a,b){if(a){let C=I.path;return C&&C[0]!==k.posix.sep&&(C=k.posix.sep+C),I.with({scheme:b,authority:a,path:C})}return I.with({scheme:b})}e.toLocalResource=y}),define(Z[6],ee([0,1,30,11,3,2,64,12]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(q){return!!q&&typeof q.then=="function"}e.isThenable=g;function v(q){const D=new S.CancellationTokenSource,T=q(D.token),F=new Promise((N,V)=>{D.token.onCancellationRequested(()=>{V((0,k.canceled)())}),Promise.resolve(T).then(G=>{D.dispose(),N(G)},G=>{D.dispose(),V(G)})});return new class{cancel(){D.cancel()}then(N,V){return F.then(N,V)}catch(N){return this.then(void 0,N)}finally(N){return F.finally(N)}}}e.createCancelablePromise=v;function R(q,D,T){return Promise.race([q,new Promise(F=>D.onCancellationRequested(()=>F(T)))])}e.raceCancellation=R;async function f(q){let D=-1;const T=q.map((N,V)=>N.then(G=>(D=V,G))),F=await Promise.race(T);return q.forEach((N,V)=>{V!==D&&N.cancel()}),F}e.raceCancellablePromises=f;function y(q,D,T){let F;const N=setTimeout(()=>{F==null||F(void 0),T==null||T()},D);return Promise.race([q.finally(()=>clearTimeout(N)),new Promise(V=>F=V)])}e.raceTimeout=y;function I(q){return new Promise((D,T)=>{const F=q();g(F)?F.then(D,T):D(F)})}e.asPromise=I;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(D){if(this.activePromise){if(this.queuedPromiseFactory=D,!this.queuedPromise){const T=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(T,T).then(F)})}return new Promise((T,F)=>{this.queuedPromise.then(T,F)})}return this.activePromise=D(),new Promise((T,F)=>{this.activePromise.then(N=>{this.activePromise=null,T(N)},N=>{this.activePromise=null,F(N)})})}}e.Throttler=a;class b{constructor(){this.current=Promise.resolve(null)}queue(D){return this.current=this.current.then(()=>D(),()=>D())}}e.Sequencer=b;class C{constructor(){this.promiseMap=new Map}queue(D,T){var F;const V=((F=this.promiseMap.get(D))!==null&&F!==void 0?F:Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(D)===V&&this.promiseMap.delete(D)});return this.promiseMap.set(D,V),V}}e.SequencerByKey=C;class E{constructor(D){this.defaultDelay=D,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(D,T=this.defaultDelay){return this.task=D,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,N)=>{this.doResolve=F,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},T),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,k.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=E;class p{constructor(D){this.delayer=new E(D),this.throttler=new a}trigger(D,T){return this.delayer.trigger(()=>this.throttler.queue(D),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=p;class m{constructor(){this._isOpen=!1,this._promise=new Promise((D,T)=>{this._completePromise=D})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=m;class c extends m{constructor(D){super();this._timeout=setTimeout(()=>this.open(),D)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function s(q,D){return D?new Promise((T,F)=>{const N=setTimeout(T,q);D.onCancellationRequested(()=>{clearTimeout(N),F((0,k.canceled)())})}):v(T=>s(q,T))}e.timeout=s;function t(q,D=0){const T=setTimeout(q,D);return(0,L.toDisposable)(()=>clearTimeout(T))}e.disposableTimeout=t;function i(q){return q.then(void 0,D=>{})}e.ignoreErrors=i;function n(q){const D=[];let T=0;const F=q.length;function N(){return T<F?q[T++]():null}function V(G){G!=null&&D.push(G);const J=N();return J?J.then(V):Promise.resolve(D)}return Promise.resolve(null).then(V)}e.sequence=n;function o(q,D=F=>!!F,T=null){let F=0;const N=q.length,V=()=>{if(F>=N)return Promise.resolve(T);const G=q[F++];return Promise.resolve(G()).then(Q=>D(Q)?Promise.resolve(Q):V())};return V()}e.first=o;function r(q,D=F=>!!F,T=null){if(q.length===0)return Promise.resolve(T);let F=q.length;const N=()=>{var V,G;F=-1;for(const J of q)(G=(V=J).cancel)===null||G===void 0||G.call(V)};return new Promise((V,G)=>{for(const J of q)J.then(Q=>{--F>=0&&D(Q)?(N(),V(Q)):F===0&&V(T)}).catch(Q=>{--F>=0&&(N(),G(Q))})})}e.firstParallel=r;class l{constructor(D){this._size=0,this.maxDegreeOfParalellism=D,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(D){return this._size++,new Promise((T,F)=>{this.outstandingPromises.push({factory:D,c:T,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const D=this.outstandingPromises.shift();this.runningPromises++;const T=D.factory();T.then(D.c,D.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=l;class h extends l{constructor(){super(1)}}e.Queue=h;class d{constructor(){this.queues=new Map}queueFor(D,T=O.extUri){const F=T.getComparisonKey(D);let N=this.queues.get(F);return N||(N=new h,A.Event.once(N.onFinished)(()=>{N==null||N.dispose(),this.queues.delete(F)}),this.queues.set(F,N)),N}dispose(){this.queues.forEach(D=>D.dispose()),this.queues.clear()}}e.ResourceQueue=d;class w{constructor(D,T){this._token=-1,typeof D=="function"&&typeof T=="number"&&this.setIfNotSet(D,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(D,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,D()},T)}setIfNotSet(D,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,D()},T))}}e.TimeoutTimer=w;class u{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(D,T){this.cancel(),this._token=setInterval(()=>{D()},T)}}e.IntervalTimer=u;class P{constructor(D,T){this.timeoutToken=-1,this.runner=D,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(D=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,D)}get delay(){return this.timeout}set delay(D){this.timeout=D}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class _ extends P{constructor(D,T){super(D,T);this.units=[]}work(D){this.units.push(D),this.isScheduled()||this.schedule()}doRun(){const D=this.units;this.units=[],this.runner&&this.runner(D)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const q=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=D=>{const T=setTimeout(()=>D(q));let F=!1;return{dispose(){F||(F=!0,clearTimeout(T))}}}}else e.runWhenIdle=(q,D)=>{const T=requestIdleCallback(q,typeof D=="number"?{timeout:D}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(T))}}}}();class z{constructor(D){this._didRun=!1,this._executor=()=>{try{this._value=D()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=z;async function B(q,D,T){let F;for(let N=0;N<T;N++)try{return await q()}catch(V){F=V,await s(D)}throw F}e.retry=B;class M{hasPending(D){return this._pending?typeof D=="number"?this._pending.taskId===D:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var D;(D=this._pending)===null||D===void 0||D.cancel()}setPending(D,T,F){return this._pending={taskId:D,cancel:()=>F==null?void 0:F(),promise:T},T.then(()=>this.donePending(D),()=>this.donePending(D)),T}donePending(D){this._pending&&D===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const D=this._next;this._next=void 0,D.run().then(D.promiseResolve,D.promiseReject)}}setNext(D){if(this._next)this._next.run=D;else{let T,F;const N=new Promise((V,G)=>{T=V,F=G});this._next={run:D,promise:N,promiseResolve:T,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=M;class j{constructor(D){this.interval=D,this.lastIncrementTime=0,this.value=0}increment(){const D=Date.now();return D-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=D,this.value=0),this.value++,this.value}}e.IntervalCounter=j;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((D,T)=>{this.completeCallback=D,this.errorCallback=T})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(D){return new Promise(T=>{this.completeCallback(D),this.resolved=!0,T()})}error(D){return new Promise(T=>{this.errorCallback(D),this.rejected=!0,T()})}cancel(){new Promise(D=>{this.errorCallback((0,k.canceled)()),this.rejected=!0,D()})}}e.DeferredPromise=W;class $ extends A.Emitter{async fireAsync(D,T,F){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new U.LinkedList);for(const N of this._listeners)this._asyncDeliveryQueue.push([N,D]);for(;this._asyncDeliveryQueue.size>0&&!T.isCancellationRequested;){const[N,V]=this._asyncDeliveryQueue.shift(),G=[],J=Object.assign(Object.assign({},V),{waitUntil:Q=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");F&&(Q=F(Q,typeof N=="function"?N:N[0])),G.push(Q)}});try{typeof N=="function"?N.call(void 0,J):N[0].call(N[1],J)}catch(Q){(0,k.onUnexpectedError)(Q);continue}Object.freeze(G),await H.settled(G).catch(Q=>(0,k.onUnexpectedError)(Q))}}}}e.AsyncEmitter=$;var H;(function(q){async function D(V){return typeof Promise.allSettled=="function"?T(V):F(V)}q.allSettled=D;async function T(V){return Promise.allSettled(V)}async function F(V){return Promise.all(V.map(G=>G.then(J=>({status:"fulfilled",value:J}),J=>({status:"rejected",reason:J}))))}async function N(V){let G;const J=await Promise.all(V.map(Q=>Q.then(ne=>ne,ne=>{G||(G=ne)})));if(typeof G!="undefined")throw G;return J}q.settled=N})(H=e.Promises||(e.Promises={}))}),define(Z[89],ee([0,1,21,42,8,37,6]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function O(){return Object.create(null)}e.getEmptyExpression=O;const g="**",v="/",R="[/\\\\]",f="[^/\\\\]",y=/\//g;function I(T){switch(T){case 0:return"";case 1:return`${f}*?`;default:return`(?:${R}|${f}+${R}|${R}${f}+)*?`}}function a(T,F){if(!T)return[];const N=[];let V=!1,G=!1,J="";for(const Q of T){switch(Q){case F:if(!V&&!G){N.push(J),J="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":G=!0;break;case"]":G=!1;break}J+=Q}return J&&N.push(J),N}e.splitGlobAware=a;function b(T){if(!T)return"";let F="";const N=a(T,v);if(N.every(V=>V===g))F=".*";else{let V=!1;N.forEach((G,J)=>{if(G===g){V||(F+=I(2),V=!0);return}let Q=!1,ne="",ie=!1,ce="";for(const ue of G){if(ue!=="}"&&Q){ne+=ue;continue}if(ie&&(ue!=="]"||!ce)){let ge;ue==="-"?ge=ue:(ue==="^"||ue==="!")&&!ce?ge="^":ue===v?ge="":ge=S.escapeRegExpCharacters(ue),ce+=ge;continue}switch(ue){case"{":Q=!0;continue;case"[":ie=!0;continue;case"}":F+=`(?:${a(ne,",").map(Ie=>b(Ie)).join("|")})`,Q=!1,ne="";break;case"]":F+="["+ce+"]",ie=!1,ce="";break;case"?":F+=f;continue;case"*":F+=I(1);continue;default:F+=S.escapeRegExpCharacters(ue)}}J<N.length-1&&(N[J+1]!==g||J+2<N.length)&&(F+=R),V=!1})}return F}const C=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,m=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.LRUCache(1e4),i=function(){return!1},n=function(){return null};function o(T,F){if(!T)return n;let N;typeof T!="string"?N=T.pattern:N=T,N=N.trim();const V=`${N}_${!!F.trimForExclusions}`;let G=t.get(V);if(G)return r(G,T);let J;if(C.test(N)){const Q=N.substr(4);G=function(ne,ie){return typeof ne=="string"&&ne.endsWith(Q)?N:null}}else(J=E.exec(l(N,F)))?G=h(J[1],N):(F.trimForExclusions?m:p).test(N)?G=d(N,F):(J=c.exec(l(N,F)))?G=w(J[1].substr(1),N,!0):(J=s.exec(l(N,F)))?G=w(J[1],N,!1):G=u(N);return t.set(V,G),r(G,T)}function r(T,F){return typeof F=="string"?T:function(N,V){return k.isEqualOrParent(N,F.base)?T(A.relative(F.base,N),V):null}}function l(T,F){return F.trimForExclusions&&T.endsWith("/**")?T.substr(0,T.length-2):T}function h(T,F){const N=`/${T}`,V=`\\${T}`,G=function(Q,ne){return typeof Q!="string"?null:ne?ne===T?F:null:Q===T||Q.endsWith(N)||Q.endsWith(V)?F:null},J=[T];return G.basenames=J,G.patterns=[F],G.allBasenames=J,G}function d(T,F){const N=D(T.slice(1,-1).split(",").map(ne=>o(ne,F)).filter(ne=>ne!==n),T),V=N.length;if(!V)return n;if(V===1)return N[0];const G=function(ne,ie){for(let ce=0,ue=N.length;ce<ue;ce++)if(N[ce](ne,ie))return T;return null},J=N.find(ne=>!!ne.allBasenames);J&&(G.allBasenames=J.allBasenames);const Q=N.reduce((ne,ie)=>ie.allPaths?ne.concat(ie.allPaths):ne,[]);return Q.length&&(G.allPaths=Q),G}function w(T,F,N){const V=A.sep===A.posix.sep,G=V?T:T.replace(y,A.sep),J=A.sep+G,Q=A.posix.sep+T,ne=N?function(ie,ce){return typeof ie=="string"&&(ie===G||ie.endsWith(J)||!V&&(ie===T||ie.endsWith(Q)))?F:null}:function(ie,ce){return typeof ie=="string"&&(ie===G||!V&&ie===T)?F:null};return ne.allPaths=[(N?"*/":"./")+T],ne}function u(T){try{const F=new RegExp(`^${b(T)}$`);return function(N){return F.lastIndex=0,typeof N=="string"&&F.test(N)?T:null}}catch(F){return n}}function P(T,F,N){return!T||typeof F!="string"?!1:_(T)(F,void 0,N)}e.match=P;function _(T,F={}){if(!T)return i;if(typeof T=="string"||j(T)){const N=o(T,F);if(N===n)return i;const V=function(G,J){return!!N(G,J)};return N.allBasenames&&(V.allBasenames=N.allBasenames),N.allPaths&&(V.allPaths=N.allPaths),V}return H(T,F)}e.parse=_;function z(T){if(!!T){let F;return N=>(F||(F=(T()||Promise.resolve([])).then(V=>V?M(V):{})),F.then(V=>!!V[N]))}}e.hasSiblingPromiseFn=z;function B(T){if(!!T){let F;return N=>{if(!F){const V=T();F=V?M(V):{}}return!!F[N]}}}e.hasSiblingFn=B;function M(T){const F={};for(const N of T)F[N]=!0;return F}function j(T){const F=T;return F&&typeof F.base=="string"&&typeof F.pattern=="string"}e.isRelativePattern=j;function W(T){return T.allBasenames||[]}e.getBasenameTerms=W;function $(T){return T.allPaths||[]}e.getPathTerms=$;function H(T,F){const N=D(Object.getOwnPropertyNames(T).map(ne=>q(ne,T[ne],F)).filter(ne=>ne!==n)),V=N.length;if(!V)return n;if(!N.some(ne=>!!ne.requiresSiblings)){if(V===1)return N[0];const ne=function(ue,ge){for(let Ee=0,Ie=N.length;Ee<Ie;Ee++){const Oe=N[Ee](ue,ge);if(Oe)return Oe}return null},ie=N.find(ue=>!!ue.allBasenames);ie&&(ne.allBasenames=ie.allBasenames);const ce=N.reduce((ue,ge)=>ge.allPaths?ue.concat(ge.allPaths):ue,[]);return ce.length&&(ne.allPaths=ce),ne}const G=function(ne,ie,ce){let ue;for(let ge=0,Ee=N.length;ge<Ee;ge++){const Ie=N[ge];Ie.requiresSiblings&&ce&&(ie||(ie=A.basename(ne)),ue||(ue=ie.substr(0,ie.length-A.extname(ne).length)));const Oe=Ie(ne,ie,ue,ce);if(Oe)return Oe}return null},J=N.find(ne=>!!ne.allBasenames);J&&(G.allBasenames=J.allBasenames);const Q=N.reduce((ne,ie)=>ie.allPaths?ne.concat(ie.allPaths):ne,[]);return Q.length&&(G.allPaths=Q),G}function q(T,F,N){if(F===!1)return n;const V=o(T,N);if(V===n)return n;if(typeof F=="boolean")return V;if(F){const G=F.when;if(typeof G=="string"){const J=(Q,ne,ie,ce)=>{if(!ce||!V(Q,ne))return null;const ue=G.replace("$(basename)",ie),ge=ce(ue);return(0,U.isThenable)(ge)?ge.then(Ee=>Ee?T:null):ge?T:null};return J.requiresSiblings=!0,J}}return V}function D(T,F){const N=T.filter(ne=>!!ne.basenames);if(N.length<2)return T;const V=N.reduce((ne,ie)=>{const ce=ie.basenames;return ce?ne.concat(ce):ne},[]);let G;if(F){G=[];for(let ne=0,ie=V.length;ne<ie;ne++)G.push(F)}else G=N.reduce((ne,ie)=>{const ce=ie.patterns;return ce?ne.concat(ce):ne},[]);const J=function(ne,ie){if(typeof ne!="string")return null;if(!ie){let ue;for(ue=ne.length;ue>0;ue--){const ge=ne.charCodeAt(ue-1);if(ge===47||ge===92)break}ie=ne.substr(ue)}const ce=V.indexOf(ie);return ce!==-1?G[ce]:null};J.basenames=V,J.patterns=G,J.allBasenames=V;const Q=T.filter(ne=>!ne.basenames);return Q.push(J),Q}}),define(Z[90],ee([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(R){return R.toJSON()}class A{constructor(f){this._uriTransformer=f}transformIncoming(f){const y=this._uriTransformer.transformIncoming(f);return y===f?f:k(S.URI.from(y))}transformOutgoing(f){const y=this._uriTransformer.transformOutgoing(f);return y===f?f:k(S.URI.from(y))}transformOutgoingURI(f){const y=this._uriTransformer.transformOutgoing(f);return y===f?f:S.URI.from(y)}transformOutgoingScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function L(R,f,y){if(!R||y>200)return null;if(typeof R=="object"){if(R instanceof S.URI)return f.transformOutgoing(R);for(let I in R)if(Object.hasOwnProperty.call(R,I)){const a=L(R[I],f,y+1);a!==null&&(R[I]=a)}}return null}function U(R,f){const y=L(R,f,0);return y===null?R:y}e.transformOutgoingURIs=U;function O(R,f,y,I){if(!R||I>200)return null;if(typeof R=="object"){if(R.$mid===1)return y?S.URI.revive(f.transformIncoming(R)):f.transformIncoming(R);for(let a in R)if(Object.hasOwnProperty.call(R,a)){const b=O(R[a],f,y,I+1);b!==null&&(R[a]=b)}}return null}function g(R,f){const y=O(R,f,!1,0);return y===null?R:y}e.transformIncomingURIs=g;function v(R,f){const y=O(R,f,!0,0);return y===null?R:y}e.transformAndReviveIncomingURIs=v}),define(Z[31],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(g){return S.test(g)}e.isUUID=k;const A=new Uint8Array(16),L=[];for(let g=0;g<256;g++)L.push(g.toString(16).padStart(2,"0"));let U;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?U=crypto.getRandomValues.bind(crypto):U=function(g){for(let v=0;v<g.length;v++)g[v]=Math.floor(Math.random()*256);return g};function O(){U(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let g=0,v="";return v+=L[A[g++]],v+=L[A[g++]],v+=L[A[g++]],v+=L[A[g++]],v+="-",v+=L[A[g++]],v+=L[A[g++]],v+="-",v+=L[A[g++]],v+=L[A[g++]],v+="-",v+=L[A[g++]],v+=L[A[g++]],v+="-",v+=L[A[g++]],v+=L[A[g++]],v+=L[A[g++]],v+=L[A[g++]],v+=L[A[g++]],v+=L[A[g++]],v}e.generateUuid=O}),define(Z[66],ee([0,1,199]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class k{constructor(L="utf8"){this.stringDecoder=new S.StringDecoder(L),this.remaining=null}write(L){const U=[],O=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(O.length<1)return U;let g=0,v,R=g;for(;R<O.length;)if(v=O.charCodeAt(R),v===13||v===10){if(U.push(O.substring(g,R)),R++,R<O.length){const f=v;v=O.charCodeAt(R),(f===13&&v===10||f===10&&v===13)&&R++}g=R}else R++;return this.remaining=g<O.length?O.substr(g):null,U}end(){return this.remaining}}e.LineDecoder=k}),define(Z[91],ee([0,1,38]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const k=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(O){const g=O.replace(/\-/g,":").toLowerCase();return!k.has(g)}function L(){return new Promise(async(O,g)=>{const v=setTimeout(()=>g("Unable to retrieve mac address (timeout after 10s)"),1e4);try{O(await U())}catch(R){g(R)}finally{clearTimeout(v)}})}e.getMac=L;function U(){return new Promise((O,g)=>{try{const v=(0,S.networkInterfaces)();for(let R in v){const f=v[R];if(f){for(const{mac:y}of f)if(A(y))return O(y)}}g("Unable to retrieve mac address (unexpected format)")}catch(v){g(v)}})}}),define(Z[92],ee([0,1,11,31,38,37,91]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(R){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(R)}value(){if(this._value===void 0){let R=0,f=0;const y=(0,A.networkInterfaces)();for(let I in y){const a=y[I];if(a)for(const{mac:b,internal:C}of a)C||(f+=1,this._isVirtualMachineMacAdress(b.toUpperCase())&&(R+=1))}this._value=f>0?R/f:0}return this._value}};let O;async function g(){return O||(O=(async()=>await v()||k.generateUuid())()),O}e.getMachineId=g;async function v(){try{const R=await new Promise((y,I)=>{K(["crypto"],y,I)}),f=await(0,U.getMac)();return R.createHash("sha256").update(f,"utf8").digest("hex")}catch(R){S.onUnexpectedError(R);return}}}),define(Z[23],ee([0,1,27,38,8,6,7,42,31,65,12,4]),function(K,e,S,k,A,L,U,O,g,v,R,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var y;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function I(W,$=y.UNLINK){if((0,O.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return $===y.UNLINK?b(W):a(W)}e.rimraf=I;async function a(W){try{const $=(0,A.join)((0,k.tmpdir)(),(0,g.generateUuid)());try{await S.promises.rename(W,$)}catch(H){return b(W)}b($).catch(H=>{})}catch($){if($.code!=="ENOENT")throw $}}async function b(W){return S.promises.rmdir(W,{recursive:!0,maxRetries:3})}function C(W){if((0,O.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");S.rmdirSync(W,{recursive:!0})}e.rimrafSync=C;async function E(W,$){return c(await($?p(W):S.promises.readdir(W)))}e.readdir=E;async function p(W){try{return await S.promises.readdir(W,{withFileTypes:!0})}catch(q){console.warn("[node.js fs] readdir with filetypes failed with error: ",q)}const $=[],H=await E(W);for(const q of H){let D=!1,T=!1,F=!1;try{const N=await S.promises.lstat((0,A.join)(W,q));D=N.isFile(),T=N.isDirectory(),F=N.isSymbolicLink()}catch(N){console.warn("[node.js fs] unexpected error from lstat after readdir: ",N)}$.push({name:q,isFile:()=>D,isDirectory:()=>T,isSymbolicLink:()=>F})}return $}function m(W){return c(S.readdirSync(W))}e.readdirSync=m;function c(W){return W.map($=>typeof $=="string"?U.isMacintosh?(0,v.normalizeNFC)($):$:($.name=U.isMacintosh?(0,v.normalizeNFC)($.name):$.name,$))}async function s(W){const $=await E(W),H=[];for(const q of $)await i.existsDirectory((0,A.join)(W,q))&&H.push(q);return H}e.readDirsInDir=s;function t(W,$=1e3){return new Promise(H=>{let q=!1;const D=setInterval(()=>{q||(q=!0,S.access(W,T=>{q=!1,T&&(clearInterval(D),H(void 0))}))},$)})}e.whenDeleted=t;var i;(function(W){async function $(D){let T;try{if(T=await S.promises.lstat(D),!T.isSymbolicLink())return{stat:T}}catch(F){}try{return{stat:await S.promises.stat(D),symbolicLink:(T==null?void 0:T.isSymbolicLink())?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};if(U.isWindows&&F.code==="EACCES")try{return{stat:await S.promises.stat(await S.promises.readlink(D)),symbolicLink:{dangling:!1}}}catch(N){if(N.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};throw N}throw F}}W.stat=$;async function H(D){try{const{stat:T,symbolicLink:F}=await W.stat(D);return T.isFile()&&(F==null?void 0:F.dangling)!==!0}catch(T){}return!1}W.existsFile=H;async function q(D){try{const{stat:T,symbolicLink:F}=await W.stat(D);return T.isDirectory()&&(F==null?void 0:F.dangling)!==!0}catch(T){}return!1}W.existsDirectory=q})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new L.ResourceQueue;function o(W,$,H){return n.queueFor(f.URI.file(W),R.extUriBiasedIgnorePathCase).queue(()=>{const q=d(H);return new Promise((D,T)=>l(W,$,q,F=>F?T(F):D()))})}e.writeFile=o;let r=!0;function l(W,$,H,q){if(!r)return S.writeFile(W,$,{mode:H.mode,flag:H.flag},q);S.open(W,H.flag,H.mode,(D,T)=>{if(D)return q(D);S.writeFile(T,$,F=>{if(F)return S.close(T,()=>q(F));S.fdatasync(T,N=>(N&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",N),r=!1),S.close(T,V=>q(V))))})})}function h(W,$,H){const q=d(H);if(!r)return S.writeFileSync(W,$,{mode:q.mode,flag:q.flag});const D=S.openSync(W,q.flag,q.mode);try{S.writeFileSync(D,$);try{S.fdatasyncSync(D)}catch(T){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",T),r=!1}}finally{S.closeSync(D)}}e.writeFileSync=h;function d(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function w(W,$){if(W!==$){async function H(q){try{const D=await S.promises.lstat(q);if(D.isDirectory()||D.isSymbolicLink())return;const T=await S.promises.open(q,"a");try{await T.utimes(D.atime,new Date)}finally{await T.close()}}catch(D){}}try{await S.promises.rename(W,$),await H($)}catch(q){if(W.toLowerCase()!==$.toLowerCase()&&q.code==="EXDEV"||W.endsWith("."))await u(W,$,{preserveSymlinks:!1}),await I(W,y.MOVE),await H($);else throw q}}}e.move=w;async function u(W,$,H){return _(W,$,{root:{source:W,target:$},options:H,handledSourcePaths:new Set})}e.copy=u;const P=511;async function _(W,$,H){if(!H.handledSourcePaths.has(W)){H.handledSourcePaths.add(W);const{stat:q,symbolicLink:D}=await i.stat(W);if(D){if(H.options.preserveSymlinks)try{return await M(W,$,H)}catch(T){console.warn("[node.js fs] copy of symlink failed: ",T)}if(D.dangling)return}return q.isDirectory()?z(W,$,q.mode&P,H):B(W,$,q.mode&P)}}async function z(W,$,H,q){await S.promises.mkdir($,{recursive:!0,mode:H});const D=await E(W);for(const T of D)await _((0,A.join)(W,T),(0,A.join)($,T),q)}async function B(W,$,H){await S.promises.copyFile(W,$),await S.promises.chmod($,H)}async function M(W,$,H){let q=await S.promises.readlink(W);(0,O.isEqualOrParent)(q,H.root.source,!U.isLinux)&&(q=(0,A.join)(H.root.target,q.substr(H.root.source.length+1))),await S.promises.symlink(q,$)}async function j(W){try{return await S.promises.access(W),!0}catch($){return!1}}e.exists=j}),define(Z[93],ee([0,1,27,94,21,8,23]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function O(f){const y=(0,L.dirname)(f);if(f===y)return f;const I=((0,L.basename)(f)||f).toLowerCase();try{const b=(0,U.readdirSync)(y).filter(C=>C.toLowerCase()===I);if(b.length===1){const C=O(y);if(C)return(0,L.join)(C,b[0])}else if(b.length>1){const C=b.indexOf(I);if(C>=0){const E=O(y);if(E)return(0,L.join)(E,b[C])}}}catch(a){}return null}e.realcaseSync=O;async function g(f){try{return await(0,k.promisify)(S.realpath)(f)}catch(y){const I=R(f);return await S.promises.access(I,S.constants.R_OK),I}}e.realpath=g;function v(f){try{return S.realpathSync(f)}catch(y){const I=R(f);return S.accessSync(I,S.constants.R_OK),I}}e.realpathSync=v;function R(f){return(0,A.rtrim)((0,L.normalize)(f),L.sep)}}),define(Z[95],ee([0,1,48,16]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function A(U){return new Promise((O,g)=>{let v;const R=new Map;function f(a,b,C,E,p){const m=R.get(b);if(a===U||m){const c={name:y(C),cmd:C,pid:a,ppid:b,load:E,mem:p};R.set(a,c),a===U&&(v=c),m&&(m.children||(m.children=[]),m.children.push(c),m.children.length>1&&(m.children=m.children.sort((s,t)=>s.pid-t.pid)))}}function y(a){const b=/--disable-blink-features=Auxclick/,C=/\\watcher\\win32\\CodeHelper\.exe/,E=/--crashes-directory/,p=/\\pipe\\winpty-control/,m=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(C.exec(a))return"watcherService ";if(E.exec(a))return"electron-crash-reporter";if(p.exec(a))return"winpty-process";if(m.exec(a))return"console-window-host (Windows internal process)";let s=c.exec(a);if(s&&s.length===2)return s[1]==="renderer"?b.exec(a)?"shared-process":"window":s[1];const t=/[a-zA-Z-]+\.js/g;let i="";do s=t.exec(a),s&&(i+=s+" ");while(s);return i&&a.indexOf("node ")<0&&a.indexOf("node.exe")<0?`electron_node ${i}`:a}if(process.platform==="win32"){const a=b=>b.indexOf("\\\\?\\")===0||b.indexOf("\\??\\")===0?b.substr(4):b.indexOf('"\\\\?\\')===0||b.indexOf('"\\??\\')===0?'"'+b.substr(5):b;new Promise((b,C)=>{K(["windows-process-tree"],b,C)}).then(b=>{b.getProcessList(U,C=>{b.getProcessCpuUsage(C,E=>{const p=new Map;E.forEach(m=>{const c=a(m.commandLine||"");p.set(m.pid,{name:y(c),cmd:c,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),v=p.get(U),v?(p.forEach(m=>{const c=p.get(m.ppid);c&&(c.children||(c.children=[]),c.children.push(m))}),p.forEach(m=>{m.children&&(m.children=m.children.sort((c,s)=>c.pid-s.pid))}),O(v)):g(new Error(`Root process ${U} not found`))})},b.ProcessDataFlag.CommandLine|b.ProcessDataFlag.Memory)})}else{function I(){let a=[v];const b=[];for(;a.length;){const E=a.shift();E&&(b.push(E.pid),E.children&&(a=a.concat(E.children)))}let C=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);C+=" "+b.join(" "),(0,S.exec)(C,{},(E,p,m)=>{if(E||m)g(E||new Error(m.toString()));else{const c=p.toString().split(`
`);for(let s=0;s<b.length;s++){const t=R.get(b[s]);t.load=parseFloat(c[s])}if(!v){g(new Error(`Root process ${U} not found`));return}O(v)}})}(0,S.exec)("which ps",{},(a,b,C)=>{if(a||C)if(process.platform!=="linux")g(a||new Error(C.toString()));else{const E=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,S.exec)(E,{},(p,m,c)=>{p||c?g(p||new Error(c.toString())):(L(m,f),I())})}else{const E=b.toString().trim(),p="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${E} ${p}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,c,s)=>{m||s&&!s.includes("screen size is bogus")?g(m||new Error(s.toString())):(L(c,f),process.platform==="linux"?I():v?O(v):g(new Error(`Root process ${U} not found`)))})}})}})}e.listProcesses=A;function L(U,O){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,v=U.toString().split(`
`);for(const R of v){const f=g.exec(R.trim());f&&f.length===6&&O(parseInt(f[1]),parseInt(f[2]),f[5],parseFloat(f[3]),parseFloat(f[4]))}}}),define(Z[96],ee([0,1,8,27,7,65,2,23]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function g(f,y,I){return R({path:f,isDirectory:!1},y,I)}e.watchFile=g;function v(f,y,I){return R({path:f,isDirectory:!0},y,I)}e.watchFolder=v,e.CHANGE_BUFFER_DELAY=100;function R(f,y,I){const a=(0,S.basename)(f.path),b=new Map;let C=!1,E=[(0,U.toDisposable)(()=>{b.forEach(p=>(0,U.dispose)(p)),b.clear()})];try{const p=(0,k.watch)(f.path);E.push((0,U.toDisposable)(()=>{p.removeAllListeners(),p.close()}));const m=new Set;f.isDirectory&&(0,O.readdir)(f.path).then(c=>c.forEach(s=>m.add(s))),p.on("error",(c,s)=>{C||I(`Failed to watch ${f.path} for changes using fs.watch() (${c}, ${s})`)}),p.on("change",(c,s)=>{if(!C){let t="";if(s&&(t=s.toString(),A.isMacintosh&&(t=(0,L.normalizeNFC)(t))),!(!t||c!=="change"&&c!=="rename")){const i=f.isDirectory?(0,S.join)(f.path,t):f.path;if(f.isDirectory)if(c==="rename"){const n=b.get(i);n&&(0,U.dispose)(n);const o=setTimeout(async()=>{b.delete(i);const r=await(0,O.exists)(i);if(!C){let l;r?m.has(t)?l="changed":(l="added",m.add(t)):(m.delete(t),l="deleted"),y(l,i)}},e.CHANGE_BUFFER_DELAY);b.set(i,(0,U.toDisposable)(()=>clearTimeout(o)))}else{let n;m.has(t)?n="changed":(n="added",m.add(t)),y(n,i)}else if(c==="rename"||t!==a){const n=setTimeout(async()=>{const o=await(0,O.exists)(i);C||(o?(y("changed",i),E=[R(f,y,I)]):y("deleted",i))},e.CHANGE_BUFFER_DELAY);(0,U.dispose)(E),E=[(0,U.toDisposable)(()=>clearTimeout(n))]}else y("changed",i)}}})}catch(p){(0,O.exists)(f.path).then(m=>{m&&!C&&I(`Failed to watch ${f.path} for changes using fs.watch() (${p.toString()})`)})}return(0,U.toDisposable)(()=>{C=!0,E=(0,U.dispose)(E)})}}),define(Z[34],ee([0,1,3,2,6,30,11,22,18,15,88,21]),function(K,e,S,k,A,L,U,O,g,v,R,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function I(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(a=e.ResponseType||(e.ResponseType={}));function b(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var C;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(C||(C={}));class E{constructor(D){this.buffer=D,this.pos=0}read(D){const T=this.buffer.slice(this.pos,this.pos+D);return this.pos+=T.byteLength,T}}class p{constructor(){this.buffers=[]}get buffer(){return O.VSBuffer.concat(this.buffers)}write(D){this.buffers.push(D)}}var m;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(m||(m={}));function c(q){const D=O.VSBuffer.alloc(4);return D.writeUInt32BE(q,0),D}function s(q){return q.read(4).readUInt32BE(0)}function t(q){const D=O.VSBuffer.alloc(1);return D.writeUInt8(q,0),D}const i={Undefined:t(m.Undefined),String:t(m.String),Buffer:t(m.Buffer),VSBuffer:t(m.VSBuffer),Array:t(m.Array),Object:t(m.Object)},n=typeof Buffer!="undefined";function o(q,D){if(typeof D=="undefined")q.write(i.Undefined);else if(typeof D=="string"){const T=O.VSBuffer.fromString(D);q.write(i.String),q.write(c(T.byteLength)),q.write(T)}else if(n&&Buffer.isBuffer(D)){const T=O.VSBuffer.wrap(D);q.write(i.Buffer),q.write(c(T.byteLength)),q.write(T)}else if(D instanceof O.VSBuffer)q.write(i.VSBuffer),q.write(c(D.byteLength)),q.write(D);else if(Array.isArray(D)){q.write(i.Array),q.write(c(D.length));for(const T of D)o(q,T)}else{const T=O.VSBuffer.fromString(JSON.stringify(D));q.write(i.Object),q.write(c(T.byteLength)),q.write(T)}}function r(q){switch(q.read(1).readUInt8(0)){case m.Undefined:return;case m.String:return q.read(s(q)).toString();case m.Buffer:return q.read(s(q)).buffer;case m.VSBuffer:return q.read(s(q));case m.Array:{const T=s(q),F=[];for(let N=0;N<T;N++)F.push(r(q));return F}case m.Object:return JSON.parse(q.read(s(q)).toString())}}class l{constructor(D,T,F=null,N=1e3){this.protocol=D,this.ctx=T,this.logger=F,this.timeoutDelay=N,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel(D,T){this.channels.set(D,T),setTimeout(()=>this.flushPendingRequests(D),0)}sendResponse(D){switch(D.type){case 200:{const T=this.send([D.type]);this.logger&&this.logger.logOutgoing(T,0,1,b(D.type));return}case 201:case 202:case 204:case 203:{const T=this.send([D.type,D.id],D.data);this.logger&&this.logger.logOutgoing(T,D.id,1,b(D.type),D.data);return}}}send(D,T=void 0){const F=new p;return o(F,D),o(F,T),this.sendBuffer(F.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(T){return 0}}onRawMessage(D){const T=new E(D),F=r(T),N=r(T),V=F[0];switch(V){case 100:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${I(V)}: ${F[2]}.${F[3]}`,N),this.onPromise({type:V,id:F[1],channelName:F[2],name:F[3],arg:N});case 102:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${I(V)}: ${F[2]}.${F[3]}`,N),this.onEventListen({type:V,id:F[1],channelName:F[2],name:F[3],arg:N});case 101:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${I(V)}`),this.disposeActiveRequest({type:V,id:F[1]});case 103:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${I(V)}`),this.disposeActiveRequest({type:V,id:F[1]})}}onPromise(D){const T=this.channels.get(D.channelName);if(!T){this.collectPendingRequest(D);return}const F=new L.CancellationTokenSource;let N;try{N=T.call(this.ctx,D.name,D.arg,F.token)}catch(J){N=Promise.reject(J)}const V=D.id;N.then(J=>{this.sendResponse({id:V,data:J,type:201}),this.activeRequests.delete(D.id)},J=>{J instanceof Error?this.sendResponse({id:V,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.sendResponse({id:V,data:J,type:203}),this.activeRequests.delete(D.id)});const G=(0,k.toDisposable)(()=>F.cancel());this.activeRequests.set(D.id,G)}onEventListen(D){const T=this.channels.get(D.channelName);if(!T){this.collectPendingRequest(D);return}const F=D.id,V=T.listen(this.ctx,D.name,D.arg)(G=>this.sendResponse({id:F,data:G,type:204}));this.activeRequests.set(D.id,V)}disposeActiveRequest(D){const T=this.activeRequests.get(D.id);T&&(T.dispose(),this.activeRequests.delete(D.id))}collectPendingRequest(D){let T=this.pendingRequests.get(D.channelName);T||(T=[],this.pendingRequests.set(D.channelName,T));const F=setTimeout(()=>{console.error(`Unknown channel: ${D.channelName}`),D.type===100&&this.sendResponse({id:D.id,data:{name:"Unknown channel",message:`Channel name '${D.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);T.push({request:D,timeoutTimer:F})}flushPendingRequests(D){const T=this.pendingRequests.get(D);if(T){for(const F of T)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete(D)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var h;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class d{constructor(D,T=null){this.protocol=D,this.isDisposed=!1,this.state=C.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=T}getChannel(D){const T=this;return{call(F,N,V){return T.isDisposed?Promise.reject(U.canceled()):T.requestPromise(D,F,N,V)},listen(F,N){return T.isDisposed?Promise.reject(U.canceled()):T.requestEvent(D,F,N)}}}requestPromise(D,T,F,N=L.CancellationToken.None){const V=this.lastRequestId++,J={id:V,type:100,channelName:D,name:T,arg:F};if(N.isCancellationRequested)return Promise.reject(U.canceled());let Q;return new Promise((ie,ce)=>{if(N.isCancellationRequested)return ce(U.canceled());const ue=()=>{const Oe=Ae=>{switch(Ae.type){case 201:this.handlers.delete(V),ie(Ae.data);break;case 202:this.handlers.delete(V);const Ue=new Error(Ae.data.message);Ue.stack=Ae.data.stack,Ue.name=Ae.data.name,ce(Ue);break;case 203:this.handlers.delete(V),ce(Ae.data);break}};this.handlers.set(V,Oe),this.sendRequest(J)};let ge=null;this.state===C.Idle?ue():(ge=(0,A.createCancelablePromise)(Oe=>this.whenInitialized()),ge.then(()=>{ge=null,ue()}));const Ee=()=>{ge?(ge.cancel(),ge=null):this.sendRequest({id:V,type:101}),ce(U.canceled())},Ie=N.onCancellationRequested(Ee);Q=(0,k.combinedDisposable)((0,k.toDisposable)(Ee),Ie),this.activeRequests.add(Q)}).finally(()=>{this.activeRequests.delete(Q)})}requestEvent(D,T,F){const N=this.lastRequestId++,G={id:N,type:102,channelName:D,name:T,arg:F};let J=null;const Q=new S.Emitter({onFirstListenerAdd:()=>{J=(0,A.createCancelablePromise)(ie=>this.whenInitialized()),J.then(()=>{J=null,this.activeRequests.add(Q),this.sendRequest(G)})},onLastListenerRemove:()=>{J?(J.cancel(),J=null):(this.activeRequests.delete(Q),this.sendRequest({id:N,type:103}))}}),ne=ie=>Q.fire(ie.data);return this.handlers.set(N,ne),Q.event}sendRequest(D){switch(D.type){case 100:case 102:{const T=this.send([D.type,D.id,D.channelName,D.name],D.arg);this.logger&&this.logger.logOutgoing(T,D.id,0,`${I(D.type)}: ${D.channelName}.${D.name}`,D.arg);return}case 101:case 103:{const T=this.send([D.type,D.id]);this.logger&&this.logger.logOutgoing(T,D.id,0,I(D.type));return}}}send(D,T=void 0){const F=new p;return o(F,D),o(F,T),this.sendBuffer(F.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(T){return 0}}onBuffer(D){const T=new E(D),F=r(T),N=r(T),V=F[0];switch(V){case 200:return this.logger&&this.logger.logIncoming(D.byteLength,0,0,b(V)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],0,b(V),N),this.onResponse({type:F[0],id:F[1],data:N})}}onResponse(D){if(D.type===200){this.state=C.Idle,this._onDidInitialize.fire();return}const T=this.handlers.get(D.id);T&&T(D)}whenInitialized(){return this.state===C.Idle?Promise.resolve():S.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}e.ChannelClient=d;class w{constructor(D){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,D(({protocol:T,onDidClientDisconnect:F})=>{S.Event.once(T.onMessage)(V=>{const G=new E(V),J=r(G),Q=new l(T,J),ne=new d(T);this.channels.forEach((ce,ue)=>Q.registerChannel(ue,ce));const ie={channelServer:Q,channelClient:ne,ctx:J};this._connections.add(ie),this._onDidAddConnection.fire(ie),F(()=>{Q.dispose(),ne.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)})})})}get connections(){const D=[];return this._connections.forEach(T=>D.push(T)),D}getChannel(D,T){const F=this;return{call(N,V,G){let J;if((0,v.isFunction)(T)){let ne=(0,g.getRandomElement)(F.connections.filter(T));J=ne?Promise.resolve(ne):S.Event.toPromise(S.Event.filter(F.onDidAddConnection,T))}else J=T.routeCall(F,N,V);const Q=J.then(ne=>ne.channelClient.getChannel(D));return P(Q).call(N,V,G)},listen(N,V){if((0,v.isFunction)(T))return F.getMulticastEvent(D,T,N,V);const G=T.routeEvent(F,N,V).then(J=>J.channelClient.getChannel(D));return P(G).listen(N,V)}}}getMulticastEvent(D,T,F,N){const V=this;let G=new k.DisposableStore;const J=new S.Emitter({onFirstListenerAdd:()=>{G=new k.DisposableStore;const Q=new S.EventMultiplexer,ne=new Map,ie=ue=>{const Ee=ue.channelClient.getChannel(D).listen(F,N),Ie=Q.add(Ee);ne.set(ue,Ie)},ce=ue=>{const ge=ne.get(ue);!ge||(ge.dispose(),ne.delete(ue))};V.connections.filter(T).forEach(ie),S.Event.filter(V.onDidAddConnection,T)(ie,void 0,G),V.onDidRemoveConnection(ce,void 0,G),Q.event(J.fire,J,G),G.add(Q)},onLastListenerRemove:()=>{G.dispose()}});return J.event}registerChannel(D,T){this.channels.set(D,T),this._connections.forEach(F=>{F.channelServer.registerChannel(D,T)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=w;class u{constructor(D,T,F=null){const N=new p;o(N,T),D.send(N.buffer),this.channelClient=new d(D,F),this.channelServer=new l(D,T,F)}getChannel(D){return this.channelClient.getChannel(D)}registerChannel(D,T){this.channelServer.registerChannel(D,T)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=u;function P(q){return{call(D,T,F){return q.then(N=>N.call(D,T,F))},listen(D,T){const F=new S.Relay;return q.then(N=>F.input=N.listen(D,T)),F.event}}}e.getDelayedChannel=P;function _(q){let D=!1;return{call(T,F,N){return D?q.call(T,F,N):(0,A.timeout)(0).then(()=>D=!0).then(()=>q.call(T,F,N))},listen(T,F){if(D)return q.listen(T,F);const N=new S.Relay;return(0,A.timeout)(0).then(()=>D=!0).then(()=>N.input=q.listen(T,F)),N.event}}}e.getNextTickChannel=_;class z{constructor(D){this.fn=D}routeCall(D){return this.route(D)}routeEvent(D){return this.route(D)}async route(D){for(const T of D.connections)if(await Promise.resolve(this.fn(T.ctx)))return Promise.resolve(T);return await S.Event.toPromise(D.onDidAddConnection),await this.route(D)}}e.StaticRouter=z;var B;(function(q){function D(N,V){const G=N,J=V&&V.disableMarshalling,Q=new Map;for(const ne in G)F(ne)&&Q.set(ne,S.Event.buffer(G[ne],!0));return new class{listen(ne,ie){const ce=Q.get(ie);if(ce)return ce;throw new Error(`Event not found: ${ie}`)}call(ne,ie,ce){const ue=G[ie];if(typeof ue=="function"){if(!J&&Array.isArray(ce))for(let ge=0;ge<ce.length;ge++)ce[ge]=(0,R.revive)(ce[ge]);return ue.apply(G,ce)}throw new Error(`Method not found: ${ie}`)}}}q.fromService=D;function T(N,V){const G=V&&V.disableMarshalling;return new Proxy({},{get(J,Q){var ne;if(typeof Q=="string")return((ne=V==null?void 0:V.properties)===null||ne===void 0?void 0:ne.has(Q))?V.properties.get(Q):F(Q)?N.listen(Q):async function(...ie){let ce;V&&!(0,v.isUndefinedOrNull)(V.context)?ce=[V.context,...ie]:ce=ie;const ue=await N.call(Q,ce);return G?ue:(0,R.revive)(ue)};throw new Error(`Property not found: ${String(Q)}`)}})}q.toService=T;function F(N){return N[0]==="o"&&N[1]==="n"&&f.isUpperAsciiLetter(N.charCodeAt(2))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let D=q.toString();if(D!=="[object Object]")return D}return q}function W(q){return Array.isArray(q)?q.map(j):j(q)}function $(q,D,T,F,N,V,G){G=W(G);const J=M[N],Q=J[F%J.length];let ne=[`%c[${q}]%c[${String(D).padStart(7," ")}]%c[len: ${String(T).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${Q}`];/\($/.test(V)?(ne=ne.concat(G),ne.push(")")):ne.push(G),console.log.apply(console,ne)}e.logWithColors=$;class H{constructor(D,T){this._outgoingPrefix=D,this._incomingPrefix=T,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(D,T,F,N,V){this._totalOutgoing+=D,$(this._outgoingPrefix,this._totalOutgoing,D,T,F,N,V)}logIncoming(D,T,F,N,V){this._totalIncoming+=D,$(this._incomingPrefix,this._totalIncoming,D,T,F,N,V)}}e.IPCLogger=H}),define(Z[97],ee([0,1,3,34,22]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(g){this.port=g,this.onMessage=S.Event.fromDOMEventEmitter(this.port,"message",v=>A.VSBuffer.wrap(v.data)),g.start()}send(g){this.port.postMessage(g.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class U extends k.IPCClient{constructor(g,v){const R=new L(g);super(R,v);this.protocol=R}dispose(){this.protocol.disconnect()}}e.Client=U}),define(Z[98],ee([0,1,99,3,34,97]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class U extends A.IPCServer{static getOnDidClientConnect(){const g=k.Event.fromNodeEventEmitter(S.ipcRenderer,"vscode:createMessageChannel",(v,R)=>R);return k.Event.map(g,v=>{const{port1:R,port2:f}=new MessageChannel,I={protocol:new L.Protocol(R),onDidClientDisconnect:k.Event.fromDOMEventEmitter(R,"close")};return S.ipcRenderer.postMessage("vscode:createMessageChannelResult",v,[f]),I})}constructor(){super(U.getOnDidClientConnect())}}e.Server=U}),define(Z[100],ee([0,1,11,22]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function A(O,g){O.proxyAuthorization&&(O.headers=Object.assign(Object.assign({},O.headers||{}),{"Proxy-Authorization":O.proxyAuthorization}));const v=new XMLHttpRequest;return new Promise((R,f)=>{v.open(O.type||"GET",O.url||"",!0,O.user,O.password),L(v,O),v.responseType="arraybuffer",v.onerror=y=>f(new Error(v.statusText&&"XHR failed: "+v.statusText||"XHR failed")),v.onload=y=>{R({res:{statusCode:v.status,headers:U(v)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(v.response)))})},v.ontimeout=y=>f(new Error(`XHR timeout: ${O.timeout}ms`)),O.timeout&&(v.timeout=O.timeout),v.send(O.data),g.onCancellationRequested(()=>{v.abort(),f((0,S.canceled)())})})}e.request=A;function L(O,g){if(g.headers){e:for(let v in g.headers){switch(v){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}O.setRequestHeader(v,g.headers[v])}}}function U(O){const g=Object.create(null);for(const v of O.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(v){const R=v.indexOf(":");g[v.substr(0,R).trim().toLowerCase()]=v.substr(R+1).trim()}return g}}),define(Z[67],ee([0,1,2,3,6,15]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var U;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(U=e.StorageHint||(e.StorageHint={}));var O;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(O||(O={}));class g extends S.Disposable{constructor(f,y=Object.create(null)){super();this.database=f,this.options=y,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=O.None,this.cache=new Map,this.flushDelayer=new A.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){var y,I;(y=f.changed)===null||y===void 0||y.forEach((a,b)=>this.accept(b,a)),(I=f.deleted)===null||I===void 0||I.forEach(a=>this.accept(a,void 0))}accept(f,y){if(this.state!==O.Closed){let I=!1;(0,L.isUndefinedOrNull)(y)?I=this.cache.delete(f):this.cache.get(f)!==y&&(this.cache.set(f,y),I=!0),I&&this._onDidChangeStorage.fire(f)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===O.None&&(this.state=O.Initialized,this.options.hint!==U.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,y){const I=this.cache.get(f);return(0,L.isUndefinedOrNull)(I)?y:I}getBoolean(f,y){const I=this.get(f);return(0,L.isUndefinedOrNull)(I)?y:I==="true"}getNumber(f,y){const I=this.get(f);return(0,L.isUndefinedOrNull)(I)?y:parseInt(I,10)}async set(f,y){if(this.state!==O.Closed){if((0,L.isUndefinedOrNull)(y))return this.delete(f);const I=String(y);if(this.cache.get(f)!==I)return this.cache.set(f,I),this.pendingInserts.set(f,I),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(f){if(this.state!==O.Closed&&!!this.cache.delete(f))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=O.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(f){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{var y;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(y=this.whenFlushedCallbacks.pop())===null||y===void 0||y()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class v{constructor(){this.onDidChangeItemsExternal=k.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((y,I)=>this.items.set(I,y)),f.delete&&f.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=v}),define(Z[101],ee([13,14]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[54],ee([0,1,101]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,A=k*60,L=A*24,U=L*7,O=L*30,g=L*365;function v(f,y){typeof f!="number"&&(f=f.getTime());const I=Math.round((new Date().getTime()-f)/1e3);if(I<-30)return(0,S.localize)(0,null,v(new Date().getTime()+I*1e3,!1));if(I<30)return(0,S.localize)(1,null);let a;return I<k?(a=I,y?a===1?(0,S.localize)(2,null,a):(0,S.localize)(3,null,a):a===1?(0,S.localize)(4,null,a):(0,S.localize)(5,null,a)):I<A?(a=Math.floor(I/k),y?a===1?(0,S.localize)(6,null,a):(0,S.localize)(7,null,a):a===1?(0,S.localize)(8,null,a):(0,S.localize)(9,null,a)):I<L?(a=Math.floor(I/A),y?a===1?(0,S.localize)(10,null,a):(0,S.localize)(11,null,a):a===1?(0,S.localize)(12,null,a):(0,S.localize)(13,null,a)):I<U?(a=Math.floor(I/L),y?a===1?(0,S.localize)(14,null,a):(0,S.localize)(15,null,a):a===1?(0,S.localize)(16,null,a):(0,S.localize)(17,null,a)):I<O?(a=Math.floor(I/U),y?a===1?(0,S.localize)(18,null,a):(0,S.localize)(19,null,a):a===1?(0,S.localize)(20,null,a):(0,S.localize)(21,null,a)):I<g?(a=Math.floor(I/O),y?a===1?(0,S.localize)(22,null,a):(0,S.localize)(23,null,a):a===1?(0,S.localize)(24,null,a):(0,S.localize)(25,null,a)):(a=Math.floor(I/g),y?a===1?(0,S.localize)(26,null,a):(0,S.localize)(27,null,a):a===1?(0,S.localize)(28,null,a):(0,S.localize)(29,null,a))}e.fromNow=v;function R(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Z[102],ee([13,14]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[43],ee([0,1,102,15,18]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function L(v,R){return R&&(v.stack||v.stacktrace)?S.localize(0,null,O(v),U(v.stack)||U(v.stacktrace)):O(v)}function U(v){return Array.isArray(v)?v.join(`
`):v}function O(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?S.localize(1,null,v.message):v.message||S.localize(2,null)}function g(v=null,R=!1){if(!v)return S.localize(3,null);if(Array.isArray(v)){const f=A.coalesce(v),y=g(f[0],R);return f.length>1?S.localize(4,null,y,f.length):y}if(k.isString(v))return v;if(v.detail){const f=v.detail;if(f.error)return L(f.error,R);if(f.exception)return L(f.exception,R)}return v.stack?L(v,R):v.message?v.message:S.localize(5,null)}e.toErrorMessage=g}),define(Z[103],ee([13,14]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[104],ee([0,1,8,27,23,48,103,36,15,26,42,7,66,16]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function a(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function b(s,t){if(f.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};t&&(i.cwd=t);const n=L.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],i);return new Promise(o=>{n.once("error",r=>{o({success:!1,error:r})}),n.once("exit",(r,l)=>{o(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?a(i.status):1})}else if(f.isLinux||f.isMacintosh)try{const i=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(n=>{L.execFile(i,[s.pid.toString()],{encoding:"utf8",shell:!0},(o,r,l)=>{n(o?{success:!1,error:o}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function C(s=O.env){return s.comspec||"cmd.exe"}e.getWindowsShell=C;class E{constructor(t,i,n,o){if(i!==void 0&&n!==void 0&&o!==void 0)this.cmd=t,this.args=i,this.shell=n,this.options=o;else{const r=t;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(O.env).forEach(l=>{r[l]=O.env[l]}),Object.keys(this.options.env).forEach(l=>{r[l]=this.options.env[l]}),this.options.env=r}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const i=t.lastIndexOf(S.sep);return i!==-1&&(t=t.substring(i+1)),E.WellKnowCommands[t]?t:"other"}start(t){return f.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(O.cwd()))?Promise.reject(new Error(U.localize(0,null))):this.useExec().then(i=>{let n,o;const r=new Promise((l,h)=>{n=l,o=h});if(i){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=L.exec(l,this.options,(h,d,w)=>{this.childProcess=null;const u=h;u&&u.killed?o({killed:this.terminateRequested,stdout:d.toString(),stderr:w.toString()}):this.handleExec(n,t,h,d,w)})}else{let l=null;const h=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,n,t,o);const w={terminated:this.terminateRequested};g.isNumber(d)&&(w.cmdCode=d),n(w)};if(this.shell&&f.isWindows){const d=v.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let w=!1,u=!1;const P=[];let _=this.ensureQuotes(this.cmd);P.push(_.value),w=_.quoted,this.args&&this.args.forEach(B=>{_=this.ensureQuotes(B),P.push(_.value),u=u&&_.quoted});const z=["/s","/c"];w?u?z.push('"'+P.join(" ")+'"'):P.length>1?z.push('"'+P[0]+'" '+P.slice(1).join(" ")):z.push('"'+P[0]+'"'):z.push(P.join(" ")),l=L.spawn(C(),z,d)}else this.cmd&&(l=L.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(g.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",d=>{this.childProcess=null,o({terminated:this.terminateRequested,error:d})}),l.pid&&(this.childProcess.on("close",h),this.handleSpawn(l,n,t,o,!0)))}return r})}handleClose(t,i,n,o){}ensureQuotes(t){return E.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,b(t,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!f.isWindows)return t(!1);const i=L.spawn(C(),["/s","/c"]);i.on("error",n=>t(!0)),i.on("exit",n=>t(!1))})}}e.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class p extends E{constructor(t,i,n,o){super(t,i,n,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,i,n,o,r){[o,r].forEach((l,h)=>{const d=new y.LineDecoder;d.write(l).forEach(P=>{i({line:P,source:h===0?0:1})});const u=d.end();u&&i({line:u,source:h===0?0:1})}),t({terminated:this.terminateRequested,error:n})}handleSpawn(t,i,n,o,r){const l=new y.LineDecoder,h=new y.LineDecoder;t.stdout.on("data",d=>{l.write(d).forEach(u=>n({line:u,source:0}))}),t.stderr.on("data",d=>{h.write(d).forEach(u=>n({line:u,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=h}handleClose(t,i,n,o){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&n({line:r,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&n({line:l,source:1})}}e.LineProcess=p;function m(s){let t=[],i=!1;const n=function(o){if(i){t.push(o);return}(!s.send(o,l=>{if(l&&console.error(l),i=!1,t.length>0){const h=t.slice(0);t=[],h.forEach(d=>n(d))}})||f.isWindows)&&(i=!0)};return{send:n}}e.createQueuedSender=m;var c;(function(s){async function t(i,n,o){if(S.isAbsolute(i))return i;if(n===void 0&&(n=O.cwd()),S.dirname(i)!=="."||(o===void 0&&g.isString(O.env.PATH)&&(o=O.env.PATH.split(S.delimiter)),o===void 0||o.length===0))return S.join(n,i);async function l(h){return await A.exists(h)?!(await k.promises.stat(h)).isDirectory():!1}for(let h of o){let d;if(S.isAbsolute(h)?d=S.join(h,i):d=S.join(n,h,i),await l(d))return d;let w=d+".com";if(await l(w)||(w=d+".exe",await l(w)))return w}return S.join(n,i)}s.findExecutable=t})(c=e.win32||(e.win32={}))}),define(Z[49],ee([0,1,48,2,6,26,3,104,34,87,30,11,22,7]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class a extends g.ChannelServer{constructor(E){super({send:p=>{try{process.send&&process.send(p.buffer.toString("base64"))}catch(m){}},onMessage:U.Event.fromNodeEventEmitter(process,"message",p=>y.VSBuffer.wrap(Buffer.from(p,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=a;class b{constructor(E,p){this.modulePath=E,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new U.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new A.Delayer(m),this.child=null,this._client=null}getChannel(E){const p=this;return{call(m,c,s){return p.requestPromise(E,m,c,s)},listen(m,c){return p.requestEvent(E,m,c)}}}requestPromise(E,p,m,c=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(f.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(E),t=(0,A.createCancelablePromise)(o=>s.call(p,m,o)),i=c.onCancellationRequested(()=>t.cancel()),n=(0,k.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(E,p,m){if(!this.disposeDelayer)return U.Event.None;this.disposeDelayer.cancel();let c;const s=new U.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(E).listen(p,m)(s.fire,s),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env=Object.assign(Object.assign({},(0,L.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(p.env=Object.assign(Object.assign({},p.env),this.options.env)),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),I.isMacintosh&&p.env&&delete p.env.DYLD_LIBRARY_PATH,this.child=(0,S.fork)(this.modulePath,E,p);const m=new U.Emitter;U.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,v.isRemoteConsoleLog)(r)){(0,v.log)(r,`IPC Library: ${this.options.serverName}`);return}m.fire(y.VSBuffer.wrap(Buffer.from(r,"base64")))});const s=this.options.useQueue?(0,O.createQueuedSender)(this.child):this.child,t=r=>this.child&&this.child.connected&&s.send(r.buffer.toString("base64")),i=m.event,n={send:t,onMessage:i};this._client=new g.ChannelClient(n);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,l)=>{process.removeListener("exit",o),this.activeRequests.forEach(h=>(0,k.dispose)(h)),this.activeRequests.clear(),r!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:l})})}return this._client}getCachedChannel(E){let p=this.channels.get(E);return p||(p=this.client.getChannel(E),this.channels.set(E,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=b}),define(Z[105],ee([13,14]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[106],ee([13,14]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[107],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[108],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[109],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[110],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[111],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[112],ee([13,14]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[113],ee([13,14]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[114],ee([13,14]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[115],ee([13,14]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[116],ee([13,14]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[117],ee([13,14]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[118],ee([13,14]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[119],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[120],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[121],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[122],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[123],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[124],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)});var he=this&&this.__decorate||function(K,e,S,k){var A=arguments.length,L=A<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,S):k,U;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(K,e,S,k);else for(var O=K.length-1;O>=0;O--)(U=K[O])&&(L=(A<3?U(L):A>3?U(e,S,L):U(e,S))||L);return A>3&&L&&Object.defineProperty(e,S,L),L};define(Z[125],ee([0,1,8,12,85,54,16,4,36]),function(K,e,S,k,A,L,U,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class v{constructor(a,b,C){this._args=a,this.paths=b,this.productService=C}get appRoot(){return(0,S.dirname)(U.FileAccess.asFileUri("",K).fsPath)}get userHome(){return O.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return O.URI.file((0,S.join)(this.userDataPath,"User"))}get tmpDir(){return O.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,k.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const a=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,S.join)(this.userDataPath,"logs",a)}return this.args.logsPath}get userDataSyncLogResource(){return O.URI.file((0,S.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(O.URI.file((0,S.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return O.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return O.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const a=g.env.VSCODE_PORTABLE;return a?O.URI.file((0,S.join)(a,"argv.json")):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,k.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return O.URI.file((0,S.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,S.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const a=this.args["builtin-extensions-dir"];return a?(0,S.resolve)(a):(0,S.normalize)((0,S.join)(U.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const a=this.args["extensions-download-dir"];return a?(0,S.resolve)(a):(0,S.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const a=this.args["extensions-dir"];if(a)return(0,S.resolve)(a);const b=g.env.VSCODE_EXTENSIONS;if(b)return b;const C=g.env.VSCODE_PORTABLE;return C?(0,S.join)(C,"extensions"):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const a=this.args.extensionDevelopmentPath;if(Array.isArray(a))return a.map(b=>/^[^:/?#]+?:\/\//.test(b)?O.URI.parse(b):O.URI.file((0,S.normalize)(b)))}get extensionDevelopmentKind(){var a;return(a=this.args.extensionDevelopmentKind)===null||a===void 0?void 0:a.map(b=>b==="ui"||b==="workspace"||b==="web"?b:"workspace")}get extensionTestsLocationURI(){const a=this.args.extensionTestsPath;if(a)return/^[^:/?#]+?:\/\//.test(a)?O.URI.parse(a):O.URI.file((0,S.normalize)(a))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const a=this.args["disable-extension"];if(a){if(typeof a=="string")return[a];if(Array.isArray(a)&&a.length>0)return a}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!g.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,k.joinPath)(O.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return O.URI.file((0,S.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}he([A.memoize],v.prototype,"appRoot",null),he([A.memoize],v.prototype,"userHome",null),he([A.memoize],v.prototype,"userDataPath",null),he([A.memoize],v.prototype,"appSettingsHome",null),he([A.memoize],v.prototype,"tmpDir",null),he([A.memoize],v.prototype,"userRoamingDataHome",null),he([A.memoize],v.prototype,"settingsResource",null),he([A.memoize],v.prototype,"userDataSyncHome",null),he([A.memoize],v.prototype,"userDataSyncLogResource",null),he([A.memoize],v.prototype,"sync",null),he([A.memoize],v.prototype,"machineSettingsResource",null),he([A.memoize],v.prototype,"globalStorageHome",null),he([A.memoize],v.prototype,"workspaceStorageHome",null),he([A.memoize],v.prototype,"keybindingsResource",null),he([A.memoize],v.prototype,"keyboardLayoutResource",null),he([A.memoize],v.prototype,"argvResource",null),he([A.memoize],v.prototype,"snippetsHome",null),he([A.memoize],v.prototype,"isExtensionDevelopment",null),he([A.memoize],v.prototype,"untitledWorkspacesHome",null),he([A.memoize],v.prototype,"installSourcePath",null),he([A.memoize],v.prototype,"builtinExtensionsPath",null),he([A.memoize],v.prototype,"extensionsPath",null),he([A.memoize],v.prototype,"extensionDevelopmentLocationURI",null),he([A.memoize],v.prototype,"extensionDevelopmentKind",null),he([A.memoize],v.prototype,"extensionTestsLocationURI",null),he([A.memoize],v.prototype,"debugExtensionHost",null),he([A.memoize],v.prototype,"serviceMachineIdResource",null),he([A.memoize],v.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=v;function R(I,a){return y(I["inspect-extensions"],I["inspect-brk-extensions"],5870,a,I.debugId)}e.parseExtensionHostPort=R;function f(I,a){return y(I["inspect-search"],I["inspect-brk-search"],5876,a)}e.parseSearchPort=f;function y(I,a,b,C,E){const m=Number(a||I)||(C?null:b),c=m?Boolean(!!a):!1;return{port:m,break:c,debugId:E}}}),function(){"use strict";function K(e,S,k,A){function L(O){const g=U(O),v=[g];return e.isAbsolute(g)||v.unshift(A),e.resolve(...v)}function U(O){const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");const v=O["user-data-dir"];if(v)return v;let R=process.env.VSCODE_APPDATA;if(!R)switch(process.platform){case"win32":if(R=process.env.APPDATA,!R){const f=process.env.USERPROFILE;if(typeof f!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");R=e.join(f,"AppData","Roaming")}break;case"darwin":R=e.join(S.homedir(),"Library","Application Support");break;case"linux":R=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(R,k)}return{getUserDataPath:L}}if(typeof define=="function")define(Z[126],ee([0,200,38,16,12,36]),function(e,S,k,A,L,U){const O=L.dirname(A.FileAccess.asFileUri("",e)),g=e.__$__nodeRequire(L.joinPath(O,"package.json").fsPath);return K(S,k,g.name,U.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),S=require("path"),k=require("os");module.exports=K(S,k,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[127],ee([0,1,38,126,125]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends A.AbstractNativeEnvironmentService{constructor(O,g){super(O,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,k.getUserDataPath)(O)},g)}}e.NativeEnvironmentService=L}),define(Z[128],ee([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const k=/^([^@:]+@)?([^:]+):/,A=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,U=/([^@:.]+\.[^@:.]+)(:\d+)?$/,O=/^\s*url\s*=\s*(.+\S)\s*$/mg,g=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function v(C){const E=C.match(U);return E?E[1]:null}function R(C){if(C.indexOf("://")===-1){const E=C.match(k);return E?v(E[2]):null}try{const E=S.URI.parse(C);if(E.authority)return v(E.authority)}catch(E){}return null}function f(C,E){const p=new Set;let m;for(;m=O.exec(C);){const s=R(m[1]);s&&p.add(s)}const c=new Set(E);return Array.from(p).map(s=>c.has(s)?s:s.replace(g,"a"))}e.getDomainsOfRemotes=f;function y(C){const E=C.match(L);return E?E[2]:null}function I(C,E,p){return C&&E?(p&&E.endsWith(".git")&&(E=E.substr(0,E.length-4)),E.indexOf("/")===0?`${C}${E}`:`${C}/${E}`):null}function a(C,E){if(C.indexOf("://")===-1){const p=C.match(A);if(p)return I(p[2],p[3],E)}try{const p=S.URI.parse(C);if(p.authority)return I(y(p.authority),p.path,E)}catch(p){}return null}function b(C,E=!1){const p=[];let m;for(;m=O.exec(C);){const c=a(m[1],E);c&&p.push(c)}return p}e.getRemotes=b}),define(Z[129],ee([0,1,3,4,90,26,2]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function O(a,b){return k.URI.revive(b?b.transformIncoming(a):a)}function g(a,b){return b?b.transformOutgoingURI(a):a}function v(a,b){b=b||A.DefaultURITransformer;const C=a.manifest,E=(0,A.transformAndReviveIncomingURIs)(Object.assign(Object.assign({},a),{manifest:void 0}),b);return Object.assign(Object.assign({},E),{manifest:C})}function R(a,b){return b?(0,L.cloneAndChange)(a,C=>C instanceof k.URI?b.transformOutgoingURI(C):void 0):a}class f{constructor(b,C){this.service=b,this.getUriTransformer=C,this.onInstallExtension=S.Event.buffer(b.onInstallExtension,!0),this.onDidInstallExtension=S.Event.buffer(b.onDidInstallExtension,!0),this.onUninstallExtension=S.Event.buffer(b.onUninstallExtension,!0),this.onDidUninstallExtension=S.Event.buffer(b.onDidUninstallExtension,!0)}listen(b,C){const E=this.getUriTransformer(b);switch(C){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return S.Event.map(this.onDidInstallExtension,p=>Object.assign(Object.assign({},p),{local:p.local?R(p.local,E):p.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(b,C,E){const p=this.getUriTransformer(b);switch(C){case"zip":return this.service.zip(v(E[0],p)).then(m=>g(m,p));case"unzip":return this.service.unzip(O(E[0],p));case"install":return this.service.install(O(E[0],p));case"getManifest":return this.service.getManifest(O(E[0],p));case"canInstall":return this.service.canInstall(E[0]);case"installFromGallery":return this.service.installFromGallery(E[0],E[1]);case"uninstall":return this.service.uninstall(v(E[0],p),E[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(v(E[0],p));case"getInstalled":return this.service.getInstalled(E[0]).then(m=>m.map(c=>R(c,p)));case"updateMetadata":return this.service.updateMetadata(v(E[0],p),E[1]).then(m=>R(m,p));case"updateExtensionScope":return this.service.updateExtensionScope(v(E[0],p),E[1]).then(m=>R(m,p));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class y extends U.Disposable{constructor(b){super();this.channel=b,this._onInstallExtension=this._register(new S.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new S.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new S.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new S.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(C=>this._onInstallExtension.fire(C))),this._register(this.channel.listen("onDidInstallExtension")(C=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},C),{local:C.local?v(C.local,null):C.local})))),this._register(this.channel.listen("onUninstallExtension")(C=>this._onUninstallExtension.fire(C))),this._register(this.channel.listen("onDidUninstallExtension")(C=>this._onDidUninstallExtension.fire(C)))}zip(b){return Promise.resolve(this.channel.call("zip",[b]).then(C=>k.URI.revive(C)))}unzip(b){return Promise.resolve(this.channel.call("unzip",[b]))}install(b){return Promise.resolve(this.channel.call("install",[b])).then(C=>v(C,null))}getManifest(b){return Promise.resolve(this.channel.call("getManifest",[b]))}async canInstall(b){return!0}installFromGallery(b,C){return Promise.resolve(this.channel.call("installFromGallery",[b,C])).then(E=>v(E,null))}uninstall(b,C){return Promise.resolve(this.channel.call("uninstall",[b,C]))}reinstallFromGallery(b){return Promise.resolve(this.channel.call("reinstallFromGallery",[b]))}getInstalled(b=null){return Promise.resolve(this.channel.call("getInstalled",[b])).then(C=>C.map(E=>v(E,null)))}updateMetadata(b,C){return Promise.resolve(this.channel.call("updateMetadata",[b,C])).then(E=>v(E,null))}updateExtensionScope(b,C){return Promise.resolve(this.channel.call("updateExtensionScope",[b,C])).then(E=>v(E,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=y;class I{constructor(b){this.service=b}listen(b,C){throw new Error("Invalid listen")}call(b,C,E){switch(C){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(E[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=I}),define(Z[130],ee([0,1,26]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const k=/^%([\w\d.-]+)%$/i;function A(L,U){const O=g=>{if(typeof g=="string"){const v=k.exec(g);if(!!v)return U[v[1]]||g}};return(0,S.cloneAndChange)(L,O)}e.localizeManifest=A}),define(Z[131],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class S{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,U,O,g){return this.channel.call("promptImportantExtensionsInstallNotification",[L,U,O,g])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=S;class k{constructor(L){this.service=L}listen(L,U){throw new Error(`Event not found: ${U}`)}call(L,U,O){switch(U){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(O[0],O[1],O[2],O[3])}throw new Error(`Call not found: ${U}`)}}e.ExtensionRecommendationNotificationServiceChannel=k}),define(Z[68],ee([0,1,112]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(f){return f=f.trim(),f==="*"||k.test(f)}e.isValidVersionStr=A;function L(f){if(!A(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=f.match(k);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=L;function U(f){if(!f)return null;let y=f.majorBase,I=f.majorMustEqual,a=f.minorBase,b=f.minorMustEqual,C=f.patchBase,E=f.patchMustEqual;return f.hasCaret&&(y===0||(b=!1),E=!1),{majorBase:y,majorMustEqual:I,minorBase:a,minorMustEqual:b,patchBase:C,patchMustEqual:E,isMinimum:f.hasGreaterEquals}}e.normalizeVersion=U;function O(f,y){let I;typeof f=="string"?I=U(L(f)):I=f;let a;if(typeof y=="string"?a=U(L(y)):a=y,!I||!a)return!1;let b=I.majorBase,C=I.minorBase,E=I.patchBase,p=a.majorBase,m=a.minorBase,c=a.patchBase,s=a.majorMustEqual,t=a.minorMustEqual,i=a.patchMustEqual;return a.isMinimum?b>p?!0:b<p?!1:C>m?!0:C<m?!1:E>=c:(b===1&&p===0&&(!s||!t||!i)&&(p=1,m=0,c=0,s=!0,t=!1,i=!1),b<p?!1:b>p?!s:C<m?!1:C>m?!t:E<c?!1:E>c?!i:!0)}e.isValidVersion=O;function g(f,y,I){return y.isBuiltin||typeof y.main=="undefined"?!0:R(f,y.engines.vscode,I)}e.isValidExtensionVersion=g;function v(f,y){return f==="*"||R(y,f)}e.isEngineValid=v;function R(f,y,I=[]){let a=U(L(y));if(!a)return I.push(S.localize(0,null,y)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return I.push(S.localize(1,null,y)),!1}else if(!a.majorMustEqual)return I.push(S.localize(2,null,y)),!1;return O(f,a)?!0:(I.push(S.localize(3,null,f,y)),!1)}e.isVersionValid=R}),define(Z[132],ee([0,1,34,49,2,16]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class U extends A.Disposable{constructor(g,v,R,f){super();this.folders=g,this.onDidFilesChange=v,this.onLogMessage=R,this.verboseLogging=f,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const g=this._register(new k.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(g.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=U.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(g.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(v=>!this.isDisposed&&this.onDidFilesChange(v))),this._register(this.service.onDidLogMessage(v=>this.onLogMessage(v))),this.setFolders(this.folders)}setVerboseLogging(g){this.verboseLogging=g,!this.isDisposed&&this.service&&this.service.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${g}`})}setFolders(g){this.folders=g,this.service&&this.service.setRoots(g)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=U,U.MAX_RESTARTS=5}),define(Z[133],ee([0,1,34,49,2,16]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class U extends A.Disposable{constructor(g,v,R,f,y={}){super();this.folders=g,this.onDidFilesChange=v,this.onLogMessage=R,this.verboseLogging=f,this.watcherOptions=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const g=this._register(new k.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(g.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=U.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(g.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(v=>!this.isDisposed&&this.onDidFilesChange(v))),this._register(this.service.onDidLogMessage(v=>this.onLogMessage(v))),this.service.setRoots(this.folders)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${g}`})}setVerboseLogging(g){this.verboseLogging=g,this.service&&this.service.setVerboseLogging(g)}setFolders(g){this.folders=g,this.service&&this.service.setRoots(g)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=U,U.MAX_RESTARTS=5}),define(Z[134],ee([0,1,48,66,89,16]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class U{constructor(g,v,R,f,y){this.watchedFolder=g,this.eventCallback=R,this.logCallback=f,this.verboseLogging=y,this.restartCounter=0,Array.isArray(v)?this.ignored=v.map(I=>A.parse(I)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${g}`),this.startWatcher()}startWatcher(){const g=[this.watchedFolder];this.verboseLogging&&g.push("-verbose"),this.handle=S.spawn(L.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,g);const v=new k.LineDecoder;this.handle.stdout.on("data",R=>{const f=[];v.write(R).forEach(y=>{const I=y.split("|");if(I.length===2){const a=Number(I[0]),b=I[1];if(a>=0&&a<3){if(this.ignored&&this.ignored.some(C=>C(b))){this.verboseLogging&&this.log(b);return}f.push({type:U.changeTypeMap[a],path:b})}else this.log(I[1])}}),f.length>0&&this.eventCallback(f)}),this.handle.on("error",R=>this.onError(R)),this.handle.stderr.on("data",R=>this.onError(R)),this.handle.on("exit",(R,f)=>this.onExit(R,f))}onError(g){this.error("process error: "+g.toString())}onExit(g,v){this.handle&&(this.error(`terminated unexpectedly (code: ${g}, signal: ${v})`),this.restartCounter<=U.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(g){this.logCallback({type:"error",message:`[File Watcher (C#)] ${g}`})}log(g){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${g}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=U,U.MAX_RESTARTS=5,U.changeTypeMap=[0,1,2]}),define(Z[135],ee([0,1,134,8,21]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class L{constructor(O,g,v,R){this.onDidFilesChange=g,this.onLogMessage=v,this.verboseLogging=R,this.service=void 0,this.folder=O[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(k.posix.sep)&&(this.folder.path=(0,A.rtrim)(this.folder.path,k.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new S.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,O=>this.onFileEvents(O),O=>this.onLogMessage(O),this.verboseLogging)}setVerboseLogging(O){this.verboseLogging=O,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(O){this.isDisposed||O.length>0&&this.onDidFilesChange(O)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=L}),define(Z[50],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class S{constructor(L,U=[],O=!1){this.ctor=L,this.staticArguments=U,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=S;const k=(A,...L)=>new S(A,L);e.createSyncDescriptor=k}),define(Z[136],ee([0,1,50]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function A(U,O,g){O instanceof S.SyncDescriptor||(O=new S.SyncDescriptor(O,[],g)),k.push([U,O])}e.registerSingleton=A;function L(){return k}e.getSingletonServiceDescriptors=L}),define(Z[137],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=S;class k{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let U of this._nodes.values())U.outgoing.size===0&&L.push(U);return L}insertEdge(L,U){const O=this.lookupOrInsertNode(L),g=this.lookupOrInsertNode(U);O.outgoing.set(this._hashFn(U),g),g.incoming.set(this._hashFn(L),O)}removeNode(L){const U=this._hashFn(L);this._nodes.delete(U);for(let O of this._nodes.values())O.outgoing.delete(U),O.incoming.delete(U)}lookupOrInsertNode(L){const U=this._hashFn(L);let O=this._nodes.get(U);return O||(O=new S(L),this._nodes.set(U,O)),O}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[U,O]of this._nodes)L.push(`${U}, (incoming)[${[...O.incoming.keys()].join(", ")}], (outgoing)[${[...O.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,U]of this._nodes){const O=new Set([L]),g=this._findCycle(U,O);if(g)return g}}_findCycle(L,U){for(let[O,g]of L.outgoing){if(U.has(O))return[...U,O].join(" -> ");U.add(O);const v=this._findCycle(g,U);if(v)return v;U.delete(O)}}}e.Graph=k}),define(Z[5],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function g(v){return v[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=g})(S=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function k(O,g,v,R){g[S.DI_TARGET]===g?g[S.DI_DEPENDENCIES].push({id:O,index:v,optional:R}):(g[S.DI_DEPENDENCIES]=[{id:O,index:v,optional:R}],g[S.DI_TARGET]=g)}function A(O){if(S.serviceIds.has(O))return S.serviceIds.get(O);const g=function(v,R,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(g,v,f,!1)};return g.toString=()=>O,S.serviceIds.set(O,g),g}e.createDecorator=A;function L(O){return O}e.refineServiceDecorator=L;function U(O){return function(g,v,R){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(O,g,R,!0)}}e.optional=U}),define(Z[138],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,S.createDecorator)("checksumService")}),define(Z[139],ee([0,1,21,5,7]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let L=A.userAgent||"";const U=new Map;U.set("false",!1),U.set("true",!0),U.set("isMac",A.isMacintosh),U.set("isLinux",A.isLinux),U.set("isWindows",A.isWindows),U.set("isWeb",A.isWeb),U.set("isMacNative",A.isMacintosh&&!A.isWeb),U.set("isEdge",L.indexOf("Edg/")>=0),U.set("isFirefox",L.indexOf("Firefox")>=0),U.set("isChrome",L.indexOf("Chrome")>=0),U.set("isSafari",L.indexOf("Safari")>=0),U.set("isIPad",L.indexOf("iPad")>=0);const O=Object.prototype.hasOwnProperty;var g;(function(w){w[w.False=0]="False",w[w.True=1]="True",w[w.Defined=2]="Defined",w[w.Not=3]="Not",w[w.Equals=4]="Equals",w[w.NotEquals=5]="NotEquals",w[w.And=6]="And",w[w.Regex=7]="Regex",w[w.NotRegex=8]="NotRegex",w[w.Or=9]="Or",w[w.In=10]="In",w[w.NotIn=11]="NotIn",w[w.Greater=12]="Greater",w[w.GreaterEquals=13]="GreaterEquals",w[w.Smaller=14]="Smaller",w[w.SmallerEquals=15]="SmallerEquals"})(g=e.ContextKeyExprType||(e.ContextKeyExprType={}));class v{static false(){return f.INSTANCE}static true(){return y.INSTANCE}static has(u){return I.create(u)}static equals(u,P){return a.create(u,P)}static notEquals(u,P){return E.create(u,P)}static regex(u,P){return i.create(u,P)}static in(u,P){return b.create(u,P)}static not(u){return p.create(u)}static and(...u){return o.create(u)}static or(...u){return r.create(u)}static greater(u,P){return m.create(u,P)}static less(u,P){return s.create(u,P)}static deserialize(u,P=!1){if(!!u)return this._deserializeOrExpression(u,P)}static _deserializeOrExpression(u,P){let _=u.split("||");return r.create(_.map(z=>this._deserializeAndExpression(z,P)))}static _deserializeAndExpression(u,P){let _=u.split("&&");return o.create(_.map(z=>this._deserializeOne(z,P)))}static _deserializeOne(u,P){if(u=u.trim(),u.indexOf("!=")>=0){let _=u.split("!=");return E.create(_[0].trim(),this._deserializeValue(_[1],P))}if(u.indexOf("==")>=0){let _=u.split("==");return a.create(_[0].trim(),this._deserializeValue(_[1],P))}if(u.indexOf("=~")>=0){let _=u.split("=~");return i.create(_[0].trim(),this._deserializeRegexValue(_[1],P))}if(u.indexOf(" in ")>=0){let _=u.split(" in ");return b.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(u)){const _=u.split(">=");return c.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(u)){const _=u.split(">");return m.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(u)){const _=u.split("<=");return t.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(u)){const _=u.split("<");return s.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(u)?p.create(u.substr(1).trim()):I.create(u)}static _deserializeValue(u,P){if(u=u.trim(),u==="true")return!0;if(u==="false")return!1;let _=/^'([^']*)'$/.exec(u);return _?_[1].trim():u}static _deserializeRegexValue(u,P){if((0,S.isFalsyOrWhitespace)(u)){if(P)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=u.indexOf("/"),z=u.lastIndexOf("/");if(_===z||_<0){if(P)throw new Error(`bad regexp-value '${u}', missing /-enclosure`);return console.warn(`bad regexp-value '${u}', missing /-enclosure`),null}let B=u.slice(_+1,z),M=u[z+1]==="i"?"i":"";try{return new RegExp(B,M)}catch(j){if(P)throw new Error(`bad regexp-value '${u}', parse error: ${j}`);return console.warn(`bad regexp-value '${u}', parse error: ${j}`),null}}}e.ContextKeyExpr=v;function R(w,u){return w.cmp(u)}class f{constructor(){this.type=0}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!1}serialize(){return"false"}keys(){return[]}map(u){return this}negate(){return y.INSTANCE}}e.ContextKeyFalseExpr=f,f.INSTANCE=new f;class y{constructor(){this.type=1}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!0}serialize(){return"true"}keys(){return[]}map(u){return this}negate(){return f.INSTANCE}}e.ContextKeyTrueExpr=y,y.INSTANCE=new y;class I{constructor(u){this.key=u,this.type=2}static create(u){const P=U.get(u);return typeof P=="boolean"?P?y.INSTANCE:f.INSTANCE:new I(u)}cmp(u){return u.type!==this.type?this.type-u.type:h(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!!u.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(u){return u.mapDefined(this.key)}negate(){return p.create(this.key)}}e.ContextKeyDefinedExpr=I;class a{constructor(u,P){this.key=u,this.value=P,this.type=4}static create(u,P){if(typeof P=="boolean")return P?I.create(u):p.create(u);const _=U.get(u);return typeof _=="boolean"?P===(_?"true":"false")?y.INSTANCE:f.INSTANCE:new a(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:d(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(u){return u.mapEquals(this.key,this.value)}negate(){return E.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class b{constructor(u,P){this.key=u,this.valueKey=P,this.type=10}static create(u,P){return new b(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:d(this.key,this.valueKey,u.key,u.valueKey)}equals(u){return u.type===this.type?this.key===u.key&&this.valueKey===u.valueKey:!1}evaluate(u){const P=u.getValue(this.valueKey),_=u.getValue(this.key);return Array.isArray(P)?P.indexOf(_)>=0:typeof _=="string"&&typeof P=="object"&&P!==null?O.call(P,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(u){return u.mapIn(this.key,this.valueKey)}negate(){return C.create(this)}}e.ContextKeyInExpr=b;class C{constructor(u){this._actual=u,this.type=11}static create(u){return new C(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new C(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotInExpr=C;class E{constructor(u,P){this.key=u,this.value=P,this.type=5}static create(u,P){if(typeof P=="boolean")return P?p.create(u):I.create(u);const _=U.get(u);return typeof _=="boolean"?P===(_?"true":"false")?f.INSTANCE:y.INSTANCE:new E(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:d(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(u){return u.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=E;class p{constructor(u){this.key=u,this.type=3}static create(u){const P=U.get(u);return typeof P=="boolean"?P?f.INSTANCE:y.INSTANCE:new p(u)}cmp(u){return u.type!==this.type?this.type-u.type:h(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!u.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(u){return u.mapNot(this.key)}negate(){return I.create(this.key)}}e.ContextKeyNotExpr=p;class m{constructor(u,P){this.key=u,this.value=P,this.type=12}static create(u,P){return new m(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:d(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=m;class c{constructor(u,P){this.key=u,this.value=P,this.type=13}static create(u,P){return new c(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:d(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreaterEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class s{constructor(u,P){this.key=u,this.value=P,this.type=14}static create(u,P){return new s(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:d(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=s;class t{constructor(u,P){this.key=u,this.value=P,this.type=15}static create(u,P){return new t(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:d(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmallerEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(u,P){this.key=u,this.regexp=P,this.type=7}static create(u,P){return new i(u,P)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.key<u.key)return-1;if(this.key>u.key)return 1;const P=this.regexp?this.regexp.source:"",_=u.regexp?u.regexp.source:"";return P<_?-1:P>_?1:0}equals(u){if(u.type===this.type){const P=this.regexp?this.regexp.source:"",_=u.regexp?u.regexp.source:"";return this.key===u.key&&P===_}return!1}evaluate(u){let P=u.getValue(this.key);return this.regexp?this.regexp.test(P):!1}serialize(){const u=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${u}`}keys(){return[this.key]}map(u){return u.mapRegex(this.key,this.regexp)}negate(){return n.create(this)}}e.ContextKeyRegexExpr=i;class n{constructor(u){this._actual=u,this.type=8}static create(u){return new n(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new n(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;class o{constructor(u){this.expr=u,this.type=6}static create(u){return o._normalizeArr(u)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let P=0,_=this.expr.length;P<_;P++){const z=R(this.expr[P],u.expr[P]);if(z!==0)return z}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].equals(u.expr[P]))return!1;return!0}return!1}evaluate(u){for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].evaluate(u))return!1;return!0}static _normalizeArr(u){const P=[];let _=!1;for(const z of u)if(!!z){if(z.type===1){_=!0;continue}if(z.type===0)return f.INSTANCE;if(z.type===6){P.push(...z.expr);continue}P.push(z)}if(P.length===0&&_)return y.INSTANCE;if(P.length!==0){if(P.length===1)return P[0];for(P.sort(R);P.length>1;){const z=P[P.length-1];if(z.type!==9)break;P.pop();const B=P.pop(),M=r.create(z.expr.map(j=>o.create([j,B])));M&&(P.push(M),P.sort(R))}return P.length===1?P[0]:new o(P)}}serialize(){return this.expr.map(u=>u.serialize()).join(" && ")}keys(){const u=[];for(let P of this.expr)u.push(...P.keys());return u}map(u){return new o(this.expr.map(P=>P.map(u)))}negate(){let u=[];for(let P of this.expr)u.push(P.negate());return r.create(u)}}e.ContextKeyAndExpr=o;class r{constructor(u){this.expr=u,this.type=9}static create(u){const P=r._normalizeArr(u);if(P.length!==0)return P.length===1?P[0]:new r(P)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let P=0,_=this.expr.length;P<_;P++){const z=R(this.expr[P],u.expr[P]);if(z!==0)return z}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].equals(u.expr[P]))return!1;return!0}return!1}evaluate(u){for(let P=0,_=this.expr.length;P<_;P++)if(this.expr[P].evaluate(u))return!0;return!1}static _normalizeArr(u){let P=[],_=!1;if(u){for(let z=0,B=u.length;z<B;z++){const M=u[z];if(!!M){if(M.type===0){_=!0;continue}if(M.type===1)return[y.INSTANCE];if(M.type===9){P=P.concat(M.expr);continue}P.push(M)}}if(P.length===0&&_)return[f.INSTANCE];P.sort(R)}return P}serialize(){return this.expr.map(u=>u.serialize()).join(" || ")}keys(){const u=[];for(let P of this.expr)u.push(...P.keys());return u}map(u){return new r(this.expr.map(P=>P.map(u)))}negate(){let u=[];for(let _ of this.expr)u.push(_.negate());const P=_=>_.type===9?_.expr:[_];for(;u.length>1;){const _=u.shift(),z=u.shift(),B=[];for(const M of P(_))for(const j of P(z))B.push(v.and(M,j));u.unshift(v.or(...B))}return u[0]}}e.ContextKeyOrExpr=r;class l extends I{constructor(u,P,_){super(u);this._defaultValue=P,typeof _=="object"?l._info.push(Object.assign(Object.assign({},_),{key:u})):_!==!0&&l._info.push({key:u,description:_,type:P!=null?typeof P:void 0})}static all(){return l._info.values()}bindTo(u){return u.createKey(this.key,this._defaultValue)}getValue(u){return u.getContextKeyValue(this.key)}toNegated(){return v.not(this.key)}isEqualTo(u){return v.equals(this.key,u)}notEqualsTo(u){return v.notEquals(this.key,u)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(w,u){return w<u?-1:w>u?1:0}function d(w,u,P,_){return w<P?-1:w>P?1:u<_?-1:u>_?1:0}}),define(Z[69],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function k(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=k}),define(Z[70],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,S.createDecorator)("downloadService")}),define(Z[9],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)});var Y=this&&this.__param||function(K,e){return function(S,k){e(S,k,K)}};define(Z[140],ee([0,1,9,8,23,11,2,6]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let g=class extends U.Disposable{constructor(R){super();this.environmentService=R,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let R=setTimeout(()=>{R=void 0;const f=(0,k.basename)(this.environmentService.logsPath),y=(0,k.dirname)(this.environmentService.logsPath);(0,A.readdir)(y).then(I=>{const b=I.filter(E=>/^\d{8}T\d{6}$/.test(E)).sort().filter((E,p)=>E!==f),C=b.slice(0,Math.max(0,b.length-9));return O.Promises.settled(C.map(E=>(0,A.rimraf)((0,k.join)(y,E))))}).then(null,L.onUnexpectedError)},10*1e3);this._register((0,U.toDisposable)(()=>{R&&(clearTimeout(R),R=void 0)}))}};g=he([Y(0,S.IEnvironmentService)],g),e.LogsDataCleaner=g}),define(Z[141],ee([0,1,27,9,8,23,11,2]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let g=class ct extends O.Disposable{constructor(R,f){super();this.backupWorkspacesPath=R,this.environmentService=f,this.cleanUpStorageSoon()}cleanUpStorageSoon(){let R=setTimeout(()=>{R=void 0,(async()=>{try{const f=await S.promises.readFile(this.backupWorkspacesPath,"utf8"),I=JSON.parse(f).emptyWorkspaceInfos.map(C=>C.backupFolder),a=await(0,L.readdir)(this.environmentService.workspaceStorageHome.fsPath),b=[];a.forEach(C=>{C.length!==ct.NON_EMPTY_WORKSPACE_ID_LENGTH&&I.indexOf(C)===-1&&b.push((0,L.rimraf)((0,A.join)(this.environmentService.workspaceStorageHome.fsPath,C)))}),await Promise.all(b)}catch(f){(0,U.onUnexpectedError)(f)}})()},30*1e3);this._register((0,O.toDisposable)(()=>{R&&(clearTimeout(R),R=void 0)}))}};g.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,g=he([Y(1,k.INativeEnvironmentService)],g),e.StorageDataCleaner=g}),define(Z[29],ee([0,1,107,5,16]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function L(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=L;var U;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=5]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(U=e.SortBy||(e.SortBy={}));var O;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(O=e.SortOrder||(e.SortOrder={}));var g;(function(f){f.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var v;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class R extends Error{constructor(y,I){super(y);this.code=I}}e.ExtensionManagementError=R,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=A.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,S.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,S.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(Z[142],ee([0,1,2,29]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let A=class extends S.Disposable{constructor(U){super();this.extensionManagementService=U,this._register(U),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};A=he([Y(0,k.IExtensionManagementService)],A),e.DeprecatedExtensionsCleaner=A}),define(Z[71],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var k;(function(U){U[U.FILE=1]="FILE",U[U.WORKSPACE=2]="WORKSPACE",U[U.EXE=3]="EXE"})(k=e.RecommendationSource||(e.RecommendationSource={}));function A(U){switch(U){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=A;var L;(function(U){U.Ignored="ignored",U.Cancelled="cancelled",U.TooMany="toomany",U.IncompatibleWindow="incompatibleWindow",U.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,S.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[72],ee([0,1,21,5]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(L=e.ExtensionType||(e.ExtensionType={}));class U{constructor(R){this.value=R,this._lower=R.toLowerCase()}static equals(R,f){if(typeof R=="undefined"||R===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof R=="string"||typeof f=="string"){let y=typeof R=="string"?R:R.value,I=typeof f=="string"?f:f.value;return S.equalsIgnoreCase(y,I)}return R._lower===f._lower}static toKey(R){return typeof R=="string"?R.toLowerCase():R._lower}}e.ExtensionIdentifier=U;function O(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=O;function g(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=g,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[33],ee([0,1,21,72]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(I,a){return I.uuid&&a.uuid?I.uuid===a.uuid:I.id===a.id?!0:(0,S.compareIgnoreCase)(I.id,a.id)===0}e.areSameExtensions=A;class L{constructor(a,b){this.version=b,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof L?A(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=L;function U(I,a){return`${I}.${a}`}e.getExtensionId=U;function O(I){return I.toLocaleLowerCase()}e.adoptToGalleryExtensionId=O;function g(I,a){return O(U(I,a))}e.getGalleryExtensionId=g;function v(I,a){const b=[],C=E=>{for(const p of b)if(p.some(m=>A(a(m),a(E))))return p;return null};for(const E of I){const p=C(E);p?p.push(E):b.push([E])}return b}e.groupByExtension=v;function R(I){return{id:I.identifier.id,name:I.manifest.name,galleryId:null,publisherId:I.publisherId,publisherName:I.manifest.publisher,publisherDisplayName:I.publisherDisplayName,dependencies:I.manifest.extensionDependencies&&I.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function f(I){return Object.assign({id:I.identifier.id,name:I.name,galleryId:I.identifier.uuid,publisherId:I.publisherId,publisherName:I.publisher,publisherDisplayName:I.publisherDisplayName,dependencies:!!(I.properties.dependencies&&I.properties.dependencies.length>0)},I.telemetryData)}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function y(I){const a=new Set;for(const b of I)b.malicious&&a.add(b.id.id);return a}e.getMaliciousExtensionsSet=y}),define(Z[143],ee([0,1,2,8,72,23]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class U extends S.Disposable{constructor(g,v){super();this.environmentService=g,this.extensionsManifestCache=(0,k.join)(this.environmentService.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this._register(v.onDidInstallExtension(R=>this.onDidInstallExtension(R))),this._register(v.onDidUninstallExtension(R=>this.onDidUnInstallExtension(R)))}onDidInstallExtension(g){g.error||this.invalidate()}onDidUnInstallExtension(g){g.error||this.invalidate()}invalidate(){L.rimraf(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=U}),define(Z[10],ee([0,1,114,8,4,5,21,15,37]),function(K,e,S,k,A,L,U,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,L.createDecorator)("fileService");function v(M){return M.create===!0}e.isFileOpenForWriteOptions=v;var R;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var f;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=y;function I(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=I;function a(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function b(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=b;var C;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(j,W){super(j);this.code=W}}e.FileSystemProviderError=E;function p(M,j){const W=new E(M.toString(),j);return c(W,j),W}e.createFileSystemProviderError=p;function m(M){return M||p((0,S.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=m;function c(M,j){return M.name=j?`${j} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=c;function s(M){if(!M)return C.Unknown;if(M instanceof E)return M.code;const j=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!j)return C.Unknown;switch(j[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=s;function t(M){if(M instanceof h)return M.fileOperationResult;switch(s(M)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class n{constructor(j,W,$){this.resource=j,this.operation=W,this.target=$}isOperation(j){return this.operation===j}}e.FileOperationEvent=n;var o;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class r{constructor(j,W){this.ignorePathCasing=W,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=j;for(const $ of j)switch($.type){case 1:this.added||(this.added=g.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=g.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=g.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set($.resource,$);break}}contains(j,...W){return this.doContains(j,{includeChildren:!1},...W)}affects(j,...W){return this.doContains(j,{includeChildren:!0},...W)}doContains(j,W,...$){var H,q,D,T,F,N;if(!j)return!1;const V=$.length>0;return!!((!V||$.includes(1))&&(((H=this.added)===null||H===void 0?void 0:H.get(j))||W.includeChildren&&((q=this.added)===null||q===void 0?void 0:q.findSuperstr(j)))||(!V||$.includes(0))&&(((D=this.updated)===null||D===void 0?void 0:D.get(j))||W.includeChildren&&((T=this.updated)===null||T===void 0?void 0:T.findSuperstr(j)))||(!V||$.includes(2))&&(((F=this.deleted)===null||F===void 0?void 0:F.findSubstr(j))||W.includeChildren&&((N=this.deleted)===null||N===void 0?void 0:N.findSuperstr(j))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(j){const W=[],$=j===1?this.added:j===0?this.updated:this.deleted;if($)for(const[,H]of $)W.push(H);return W}filter(j){return new r(this.changes.filter(W=>j(W)),this.ignorePathCasing)}}e.FileChangesEvent=r;function l(M,j,W){return!M||!j||M===j||j.length>M.length?!1:(j.charAt(j.length-1)!==k.sep&&(j+=k.sep),W?(0,U.startsWithIgnoreCase)(M,j):M.indexOf(j)===0)}e.isParent=l;class h extends Error{constructor(j,W,$){super(j);this.fileOperationResult=W,this.options=$}static isFileOperationError(j){return j instanceof Error&&!(0,O.isUndefinedOrNull)(j.fileOperationResult)}}e.FileOperationError=h;var d;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(d=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var w;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(w=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function u(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=u;async function P(M,j){if(!j.canHandleResource(A.URI.from({scheme:M.scheme})))return new Promise(W=>{const $=j.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===M.scheme&&H.added&&($.dispose(),W())})})}e.whenProviderRegistered=P,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class _{static formatSize(j){return(0,O.isNumber)(j)||(j=0),j<_.KB?(0,S.localize)(1,null,j.toFixed(0)):j<_.MB?(0,S.localize)(2,null,(j/_.KB).toFixed(2)):j<_.GB?(0,S.localize)(3,null,(j/_.MB).toFixed(2)):j<_.TB?(0,S.localize)(4,null,(j/_.GB).toFixed(2)):(0,S.localize)(5,null,(j/_.TB).toFixed(2))}}e.ByteSize=_,_.KB=1024,_.MB=_.KB*_.KB,_.GB=_.MB*_.KB,_.TB=_.GB*_.KB;var z;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function B(M){return{maxFileSize:M===0?300*_.MB:16*_.GB,maxHeapSize:M===0?700*_.MB:2*700*_.MB}}e.getPlatformLimits=B}),define(Z[144],ee([0,1,145,47,10]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(O){this.fileService=O}checksum(O){return new Promise(async(g,v)=>{const R=(0,S.createHash)("md5"),f=(await this.fileService.readFileStream(O)).value;(0,k.listenStream)(f,{onData:y=>R.update(y.buffer),onError:y=>v(y),onEnd:()=>g(R.digest("base64").replace(/=+$/,""))})})}};L=he([Y(0,A.IFileService)],L),e.ChecksumService=L}),define(Z[73],ee([0,1,4,10,7]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function L(g){return g.map(v=>({type:v.type,resource:S.URI.file(v.path)}))}e.toFileChanges=L;function U(g){const v=new O;for(const R of g)v.processEvent(R);return v.normalize()}e.normalizeFileChanges=U;class O{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(v){const R=this.mapPathToChange.get(v.path);if(R){const f=R.type,y=v.type;f===1&&y===2?(this.mapPathToChange.delete(v.path),this.normalized.splice(this.normalized.indexOf(R),1)):f===2&&y===1?R.type=0:f===1&&y===0||(R.type=y)}else this.normalized.push(v),this.mapPathToChange.set(v.path,v)}normalize(){const v=[],R=[];return this.normalized.filter(f=>f.type!==2?(v.push(f),!1):!0).sort((f,y)=>f.path.length-y.path.length).filter(f=>R.some(y=>(0,k.isParent)(f.path,y,!A.isLinux))?!1:(R.push(f.path),!0)).concat(v)}}}),define(Z[146],ee([0,1,73,2,23,93,96,6,8]),function(K,e,S,k,A,L,U,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class v extends k.Disposable{constructor(f,y,I,a){super();this.path=f,this.onDidFilesChange=y,this.onLogMessage=I,this.verboseLogging=a,this.fileChangesDelayer=this._register(new O.ThrottledDelayer(U.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(f){this.verboseLogging=f}async startWatching(){try{const{stat:f,symbolicLink:y}=await A.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let I=this.path;if(y)try{I=await(0,L.realpath)(I)}catch(a){if(this.onError(a),y.dangling)return}f.isDirectory()?this._register((0,U.watchFolder)(I,(a,b)=>{this.onFileChange({type:a==="changed"?0:a==="added"?1:2,path:(0,g.join)(this.path,(0,g.basename)(b))})},a=>this.onError(a))):this._register((0,U.watchFile)(I,a=>{this.onFileChange({type:a==="changed"?0:2,path:this.path})},a=>this.onError(a)))}catch(f){f.code!=="ENOENT"&&this.onError(f)}}onFileChange(f){this.fileChangesBuffer.push(f),this.verboseLogging&&this.onVerbose(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const I=(0,S.normalizeFileChanges)(y);this.verboseLogging&&I.forEach(a=>{this.onVerbose(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`)}),I.length>0&&this.onDidFilesChange(I)})}onError(f){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${f}`})}onVerbose(f){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=v}),define(Z[74],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...A){this._entries=new Map;for(let[L,U]of A)this.set(L,U)}set(A,L){const U=this._entries.get(A);return this._entries.set(A,L),U}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=S}),define(Z[147],ee([0,1,11,137,50,5,74,6]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const g=!1;class v extends Error{constructor(a){var b;super("cyclic dependency between services");this.message=(b=a.findCycleSlow())!==null&&b!==void 0?b:`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class R{constructor(a=new U.ServiceCollection,b=!1,C){this._activeInstantiations=new Set,this._services=a,this._strict=b,this._parent=C,this._services.set(L.IInstantiationService,this)}createChild(a){return new R(a,this._strict,this)}invokeFunction(a,...b){let C=y.traceInvocation(a),E=!1;try{return a({get:(m,c)=>{if(E)throw(0,S.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(m,C);if(!s&&c!==L.optional)throw new Error(`[invokeFunction] unknown service '${m}'`);return s}},...b)}finally{E=!0,C.stop()}}createInstance(a,...b){let C,E;return a instanceof A.SyncDescriptor?(C=y.traceCreation(a.ctor),E=this._createInstance(a.ctor,a.staticArguments.concat(b),C)):(C=y.traceCreation(a),E=this._createInstance(a,b,C)),C.stop(),E}_createInstance(a,b=[],C){let E=L._util.getServiceDependencies(a).sort((c,s)=>c.index-s.index),p=[];for(const c of E){let s=this._getOrCreateServiceInstance(c.id,C);if(!s&&this._strict&&!c.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${c.id}.`);p.push(s)}let m=E.length>0?E[0].index:b.length;if(b.length!==m){console.warn(`[createInstance] First service dependency of ${a.name} at position ${m+1} conflicts with ${b.length} static arguments`);let c=m-b.length;c>0?b=b.concat(new Array(c)):b=b.slice(0,m)}return new a(...[...b,...p])}_setServiceInstance(a,b){if(this._services.get(a)instanceof A.SyncDescriptor)this._services.set(a,b);else if(this._parent)this._parent._setServiceInstance(a,b);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let b=this._services.get(a);return!b&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):b}_getOrCreateServiceInstance(a,b){let C=this._getServiceInstanceOrDescriptor(a);return C instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,C,b.branch(a,!0)):(b.branch(a,!1),C)}_safeCreateAndCacheServiceInstance(a,b,C){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,b,C)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,b,C){const E=new k.Graph(c=>c.id.toString());let p=0;const m=[{id:a,desc:b,_trace:C}];for(;m.length;){const c=m.pop();if(E.lookupOrInsertNode(c),p++>1e3)throw new v(E);for(let s of L._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(!t&&!s.optional&&console.warn(`[createInstance] ${a} depends on ${s.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const i={id:s.id,desc:t,_trace:c._trace.branch(s.id,!0)};E.insertEdge(c,i),m.push(i)}}}for(;;){const c=E.roots();if(c.length===0){if(!E.isEmpty())throw new v(E);break}for(const{data:s}of c){if(this._getServiceInstanceOrDescriptor(s.id)instanceof A.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}E.removeNode(s)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,b,C=[],E,p){if(this._services.get(a)instanceof A.SyncDescriptor)return this._createServiceInstance(b,C,E,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,b,C,E,p);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}_createServiceInstance(a,b=[],C,E){if(C){const p=new O.IdleValue(()=>this._createInstance(a,b,E));return new Proxy(Object.create(null),{get(m,c){if(c in m)return m[c];let s=p.value,t=s[c];return typeof t!="function"||(t=t.bind(s),m[c]=t),t},set(m,c,s){return p.value[c]=s,!0}})}else return this._createInstance(a,b,E)}}e.InstantiationService=R;var f;(function(I){I[I.Creation=0]="Creation",I[I.Invocation=1]="Invocation",I[I.Branch=2]="Branch"})(f||(f={}));class y{constructor(a,b){this.type=a,this.name=b,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return g?new y(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(a){return g?new y(0,a.name):y._None}branch(a,b){let C=new y(2,a.toString());return this._dep.push([a,b,C]),C}stop(){let a=Date.now()-this._start;y._totals+=a;let b=!1;function C(p,m){let c=[],s=new Array(p+1).join("	");for(const[t,i,n]of m._dep)if(i&&n){b=!0,c.push(`${s}CREATES -> ${t}`);let o=C(p+1,n);o&&c.push(o)}else c.push(`${s}uses -> ${t}`);return c.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${C(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(a>2||b)&&console.log(E.join(`
`))}}y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(Z[148],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class S{constructor(A,L){this.server=A,this.router=L}getChannel(A){return this.server.getChannel(A,this.router)}registerChannel(A,L){this.server.registerChannel(A,L)}}e.MessagePortMainProcessService=S}),define(Z[149],ee([0,1,34,50,136,5]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class U{constructor(I,a,b){const C=b.getChannel(I);return O(a)?new a.channelClientCtor(C):S.ProxyChannel.toService(C,a==null?void 0:a.proxyOptions)}}function O(y){const I=y;return!!(I==null?void 0:I.channelClientCtor)}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let g=class extends U{constructor(I,a,b){super(I,a,b)}};g=he([Y(2,e.IMainProcessService)],g);function v(y,I,a){(0,A.registerSingleton)(y,new k.SyncDescriptor(g,[I,a],a==null?void 0:a.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=v,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let R=class extends U{constructor(I,a,b){super(I,a,b)}};R=he([Y(2,e.ISharedProcessService)],R);function f(y,I,a){(0,A.registerSingleton)(y,new k.SyncDescriptor(R,[I,a],a==null?void 0:a.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=f}),define(Z[55],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,S.createDecorator)("localizationsService");function k(A){if(typeof A.languageId!="string"||!Array.isArray(A.translations)||A.translations.length===0)return!1;for(const L of A.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(A.languageName&&typeof A.languageName!="string"||A.localizedLanguageName&&typeof A.localizedLanguageName!="string")}e.isValidLocalization=k}),define(Z[150],ee([0,1,2,55]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let A=class extends S.Disposable{constructor(U){super();this.localizationsService=U,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};A=he([Y(0,k.ILocalizationsService)],A),e.LocalizationsUpdater=A}),define(Z[17],ee([0,1,5,2,7,3,43]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function O(){return new Date().toISOString()}var g;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(g=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=g.Info;class v extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=v;class R extends v{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(g.Trace)&&this.log(g.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(g.Debug)&&this.log(g.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(g.Info)&&this.log(g.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(g.Warning)&&this.log(g.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(g.Error))if(t instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=t.stack,this.log(g.Error,this.format(n))}else this.log(g.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(g.Critical)&&this.log(g.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let n=0;n<t.length;n++){let o=t[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch(r){}i+=(n>0?" ":"")+o}return i}}e.AbstractMessageLogger=R;class f extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...i){this.getLevel()<=g.Trace&&(this.useColors?console.log(`[90m[main ${O()}][0m`,t,...i):console.log(`[main ${O()}]`,t,...i))}debug(t,...i){this.getLevel()<=g.Debug&&(this.useColors?console.log(`[90m[main ${O()}][0m`,t,...i):console.log(`[main ${O()}]`,t,...i))}info(t,...i){this.getLevel()<=g.Info&&(this.useColors?console.log(`[90m[main ${O()}][0m`,t,...i):console.log(`[main ${O()}]`,t,...i))}warn(t,...i){this.getLevel()<=g.Warning&&(this.useColors?console.warn(`[93m[main ${O()}][0m`,t,...i):console.warn(`[main ${O()}]`,t,...i))}error(t,...i){this.getLevel()<=g.Error&&(this.useColors?console.error(`[91m[main ${O()}][0m`,t,...i):console.error(`[main ${O()}]`,t,...i))}critical(t,...i){this.getLevel()<=g.Critical&&(this.useColors?console.error(`[90m[main ${O()}][0m`,t,...i):console.error(`[main ${O()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class y extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=g.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=g.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=g.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=g.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=g.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=g.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=y;class I extends v{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=g.Trace&&this.adapter.log(g.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=g.Debug&&this.adapter.log(g.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=g.Info&&this.adapter.log(g.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=g.Warning&&this.adapter.log(g.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=g.Error&&this.adapter.log(g.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=g.Critical&&this.adapter.log(g.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,U.toErrorMessage)(t,this.getLevel()<=g.Trace)}dispose(){}flush(){}}e.AdapterLogger=I;class a extends v{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const n of this.logServices)n.trace(t,...i)}debug(t,...i){for(const n of this.logServices)n.debug(t,...i)}info(t,...i){for(const n of this.logServices)n.info(t,...i)}warn(t,...i){for(const n of this.logServices)n.warn(t,...i)}error(t,...i){for(const n of this.logServices)n.error(t,...i)}critical(t,...i){for(const n of this.logServices)n.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=a;class b extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=b;class C extends k.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(n))}))}createLogger(t,i){let n=this.loggers.get(t.toString());return n||(n=this.doCreateLogger(t,(i==null?void 0:i.always)?g.Trace:this.logLevel,i),this.loggers.set(t.toString(),n),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=C;class E{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return g.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=E;function p(s){if(s.verbose)return g.Trace;if(typeof s.logLevel=="string"){const t=m(s.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function m(s){switch(s){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Critical;case"off":return g.Off}}e.parseLogLevel=m;function c(s){switch(s){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Critical:return"critical";case g.Off:return"off"}}e.LogLevelToString=c}),define(Z[151],ee([0,1,27,2,10,29,9,4,12,33,17,31,56,7,6,11]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let E=class extends k.Disposable{constructor(m,c,s,t){super();this.fileService=c,this.extensionGalleryService=s,this.logService=t,this.extensionsDownloadDir=O.URI.file(m.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(m,c){await this.cleanUpPromise;const s=this.getName(m),t=(0,g.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(t)){const i=(0,g.joinPath)(this.extensionsDownloadDir,`.${(0,f.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(m,i,c);try{await this.rename(i,t,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(o){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",m.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return t}async delete(m){}async rename(m,c,s){try{await S.promises.rename(m.fsPath,c.fsPath)}catch(t){if(I.isWindows&&t&&t.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${m} to ${c} with 'EPERM' error. Trying again...`),this.rename(m,c,s);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const m=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const c=[],s=[];for(const n of m.children){const o=this.parse(n.name);o&&s.push([o,n])}const t=(0,v.groupByExtension)(s,([n])=>n),i=[];for(const n of t)n.sort((o,r)=>y.rcompare(o[0].version,r[0].version)),c.push(...n.slice(1).map(o=>o[1].resource)),i.push(n[0][1]);i.sort((n,o)=>n.mtime-o.mtime),c.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await a.Promises.settled(c.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(m){this.logService.error(m)}}getName(m){return this.cache?new v.ExtensionIdentifierWithVersion(m.identifier,m.version).key().toLowerCase():(0,f.generateUuid)()}parse(m){const c=C.exec(m);return c&&c[1]&&c[2]?new v.ExtensionIdentifierWithVersion({id:c[1]},c[2]):null}};E=he([Y(0,U.INativeEnvironmentService),Y(1,A.IFileService),Y(2,L.IExtensionGalleryService),Y(3,R.ILogService)],E),e.ExtensionsDownloader=E}),define(Z[152],ee([0,1,2,17,48,43,8,6,3,16,23,9]),function(K,e,S,k,A,L,U,O,g,v,R,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let y=class extends S.Disposable{constructor(a,b){super();this.environmentService=a,this.logService=b,this.processesLimiter=new O.Limiter(5)}async postUninstall(a){const b=this.parseScript(a,"uninstall");return b&&(this.logService.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(b.script,"uninstall",b.args,!0,a).then(()=>this.logService.info(a.identifier.id,a.manifest.version,"Finished running post uninstall script"),C=>this.logService.error(a.identifier.id,a.manifest.version,`Failed to run post uninstall script: ${C}`)))),(0,R.rimraf)(this.getExtensionStoragePath(a)).then(void 0,C=>this.logService.error("Error while removing extension storage path",C))}parseScript(a,b){const C=`vscode:${b}`;if(a.location.scheme===v.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[C]=="string"){const E=a.manifest.scripts[C].split(" ");return E.length<2||E[0]!=="node"||!E[1]?(this.logService.warn(a.identifier.id,a.manifest.version,`${C} should be a node script`),null):{script:(0,U.join)(a.location.fsPath,E[1]),args:E.slice(2)||[]}}return null}runLifecycleHook(a,b,C,E,p){return new Promise((m,c)=>{const s=this.start(a,b,C,p);let t;const i=n=>{t&&(clearTimeout(t),t=null),n?c(n):m(void 0)};s.on("error",n=>{i((0,L.toErrorMessage)(n)||"Unknown")}),s.on("exit",(n,o)=>{i(n?`post-${b} process exited with code ${n}`:void 0)}),E&&(t=setTimeout(()=>{t=null,s.kill(),c("timed out")},5e3))})}start(a,b,C,E){const p={silent:!0,execArgv:void 0},m=(0,A.fork)(a,[`--type=extension-post-${b}`,...C],p);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const c=g.Event.fromNodeEventEmitter(m.stdout,"data"),s=g.Event.fromNodeEventEmitter(m.stderr,"data");c(n=>this.logService.info(E.identifier.id,E.manifest.version,`post-${b}`,n)),s(n=>this.logService.error(E.identifier.id,E.manifest.version,`post-${b}`,n));const t=g.Event.any(g.Event.map(c,n=>({data:`%c${n}`,format:[""]})),g.Event.map(s,n=>({data:`%c${n}`,format:["color: red"]})));return g.Event.debounce(t,(n,o)=>n?{data:n.data+o.data,format:[...n.format,...o.format]}:{data:o.data,format:o.format},100)(n=>{console.group(E.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),m}getExtensionStoragePath(a){return(0,U.join)(this.environmentService.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};y=he([Y(0,f.IEnvironmentService),Y(1,k.ILogService)],y),e.ExtensionsLifecycle=y}),define(Z[153],ee([0,1,2,9,3,10,4,33,12,17]),function(K,e,S,k,A,L,U,O,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let R=class extends S.Disposable{constructor(y,I,a,b){super();this.extensionsManagementService=y,this.logService=b,this._onDidChangeExtensionsByAnotherSource=this._register(new A.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(p=>{this.installedExtensions=p.map(m=>m.identifier),this.startTimestamp=Date.now()}),this._register(y.onInstallExtension(p=>this.onInstallExtension(p))),this._register(y.onDidInstallExtension(p=>this.onDidInstallExtension(p))),this._register(y.onDidUninstallExtension(p=>this.onDidUninstallExtension(p)));const C=U.URI.file(a.extensionsPath),E=new g.ExtUri(p=>!I.hasCapability(p,1024));this._register(I.watch(C)),this._register(A.Event.filter(I.onDidFilesChange,p=>p.changes.some(m=>this.doesChangeAffects(m,C,E)))(()=>this.onDidChange()))}doesChangeAffects(y,I,a){return a.isEqual(a.dirname(y.resource),I)?a.isEqual(y.resource,a.joinPath(I,".obsolete"))?!0:!(y.type!==1&&y.type!==2||a.basename(y.resource).startsWith(".")):!1}onInstallExtension(y){this.addInstallingExtension(y.identifier)}onDidInstallExtension(y){this.removeInstallingExtension(y.identifier),y.error||this.addInstalledExtension(y.identifier)}onDidUninstallExtension(y){y.error||this.removeInstalledExtension(y.identifier)}addInstallingExtension(y){this.removeInstallingExtension(y),this.installingExtensions.push(y)}removeInstallingExtension(y){this.installingExtensions=this.installingExtensions.filter(I=>!(0,O.areSameExtensions)(I,y))}addInstalledExtension(y){this.installedExtensions&&(this.removeInstalledExtension(y),this.installedExtensions.push(y))}removeInstalledExtension(y){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(I=>!(0,O.areSameExtensions)(I,y)))}async onDidChange(){if(this.installedExtensions){const y=await this.extensionsManagementService.getInstalled(1),I=y.filter(b=>[...this.installingExtensions,...this.installedExtensions].some(C=>(0,O.areSameExtensions)(C,b.identifier))?!1:b.installedTimestamp&&b.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",b.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",b.identifier.id),!1)),a=this.installedExtensions.filter(b=>this.installingExtensions.some(C=>(0,O.areSameExtensions)(C,b))?!1:y.every(C=>!(0,O.areSameExtensions)(C.identifier,b))?(this.logService.info("Detected extension removed from another source",b.id),!0):!1);this.installedExtensions=y.map(b=>b.identifier),(I.length||a.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:I,removed:a})}}};R=he([Y(1,L.IFileService),Y(2,k.INativeEnvironmentService),Y(3,v.ILogService)],R),e.ExtensionsWatcher=R}),define(Z[154],ee([0,1,23,27,145,29,2,9,6,33,17,55,18,3,16,8]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let C=class extends U.Disposable{constructor(m,c,s){super();this.extensionManagementService=m,this.logService=s,this._onDidLanguagesChange=this._register(new I.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new E(c,s)),this._register(m.onDidInstallExtension(({local:t})=>this.onDidInstallExtension(t))),this._register(m.onDidUninstallExtension(({identifier:t})=>this.onDidUninstallExtension(t)))}getLanguageIds(){return this.cache.getLanguagePacks().then(m=>{const c=["en",...Object.keys(m)];return(0,y.distinct)(c)})}onDidInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",m.identifier.id),this.update().then(c=>{c&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(m){this.cache.getLanguagePacks().then(c=>{Object.keys(c).some(s=>c[s]&&c[s].extensions.some(t=>(0,v.areSameExtensions)(t.extensionIdentifier,m)))&&(this.logService.debug("Removing language packs from the extension",m.id),this.update().then(s=>{s&&this._onDidLanguagesChange.fire()}))})}async update(){const[m,c]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),s=await this.cache.update(c);return!(0,y.equals)(Object.keys(m),Object.keys(s))}};C=he([Y(0,L.IExtensionManagementService),Y(1,O.INativeEnvironmentService),Y(2,R.ILogService)],C),e.LocalizationsService=C;let E=class extends U.Disposable{constructor(m,c){super();this.logService=c,this.languagePacks={},this.languagePacksFilePath=(0,b.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new g.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(c=>{Object.keys(c).forEach(s=>delete c[s]),this.createLanguagePacksFromExtensions(c,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...c){for(const s of c)s&&s.manifest&&s.manifest.contributes&&s.manifest.contributes.localizations&&s.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,s);Object.keys(m).forEach(s=>this.updateHash(m[s]))}createLanguagePacksFromExtension(m,c){const s=c.identifier,t=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const i of t)if(c.location.scheme===a.Schemas.file&&(0,f.isValidLocalization)(i)){let n=m[i.languageId];n||(n={hash:"",extensions:[],translations:{}},m[i.languageId]=n);let o=n.extensions.filter(r=>(0,v.areSameExtensions)(r.extensionIdentifier,s))[0];o?o.version=c.manifest.version:n.extensions.push({extensionIdentifier:s,version:c.manifest.version});for(const r of i.translations)n.translations[r.id]=(0,b.join)(c.location.fsPath,r.path)}}updateHash(m){if(m){const c=(0,A.createHash)("md5");for(const s of m.extensions)c.update(s.extensionIdentifier.uuid||s.extensionIdentifier.id).update(s.version);m.hash=c.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let c=null;return k.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,s=>s.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(s)).then(s=>{try{return JSON.parse(s)}catch(t){return{}}}).then(s=>(c=m(s),s)).then(s=>{for(const i of Object.keys(s))s[i]||delete s[i];this.languagePacks=s,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),(0,S.writeFile)(this.languagePacksFilePath,t)}).then(()=>c,s=>this.logService.error(s))})}};E=he([Y(0,O.INativeEnvironmentService),Y(1,R.ILogService)],E)}),define(Z[75],ee([0,1,17,3,4]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(y){this.service=y,this.onDidChangeLogLevel=k.Event.buffer(y.onDidChangeLogLevel,!0)}listen(y,I){switch(I){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${I}`)}async call(y,I,a){switch(I){case"setLevel":return this.service.setLevel(a)}throw new Error(`Call not found: ${I}`)}}e.LogLevelChannel=L;class U{constructor(y){this.channel=y}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(y){U.setLevel(this.channel,y)}static setLevel(y,I){return y.call("setLevel",I)}}e.LogLevelChannelClient=U;class O{constructor(y){this.loggerService=y,this.loggers=new Map}listen(y,I){throw new Error(`Event not found: ${I}`)}async call(y,I,a){switch(I){case"createLogger":this.createLogger(A.URI.revive(a[0]),a[1]);return;case"log":return this.log(A.URI.revive(a[0]),a[1]);case"consoleLog":return this.consoleLog(a[0],a[1])}throw new Error(`Call not found: ${I}`)}createLogger(y,I){this.loggers.set(y.toString(),this.loggerService.createLogger(y,I))}consoleLog(y,I){let a=console.log;switch(y){case S.LogLevel.Error:a=console.error;break;case S.LogLevel.Warning:a=console.warn;break;case S.LogLevel.Info:a=console.info;break}a.call(console,...I)}log(y,I){const a=this.loggers.get(y.toString());if(!a)throw new Error("Create the logger before logging");for(const[b,C]of I)switch(b){case S.LogLevel.Trace:a.trace(C);break;case S.LogLevel.Debug:a.debug(C);break;case S.LogLevel.Info:a.info(C);break;case S.LogLevel.Warning:a.warn(C);break;case S.LogLevel.Error:a.error(C);break;case S.LogLevel.Critical:a.critical(C);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=O;class g extends S.AbstractLoggerService{constructor(y,I,a){super(y,I);this.channel=a}createConsoleMainLogger(){return new S.AdapterLogger({log:(y,I)=>{this.channel.call("consoleLog",[y,I])}})}doCreateLogger(y,I,a){return new v(this.channel,y,I,a)}}e.LoggerChannelClient=g;class v extends S.AbstractMessageLogger{constructor(y,I,a,b){super(b==null?void 0:b.always);this.channel=y,this.file=I,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(a),this.channel.call("createLogger",[I,b]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,I){const a=[[y,I]];this.isLoggerCreated?this.doLog(a):this.buffer.push(...a)}doLog(y){this.channel.call("log",[this.file,y])}}class R extends S.LogService{constructor(y,I){super(I);this.parent=y,this._register(y.onDidChangeLogLevel(a=>I.setLevel(a)))}setLevel(y){super.setLevel(y),this.parent.setLevel(y)}}e.FollowerLogService=R}),define(Z[57],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,S.createDecorator)("nativeHostService")}),define(Z[51],ee([0,1,16,7,36,12]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let U;if(typeof k.globals.vscode!="undefined"){const O=k.globals.vscode.context.configuration();if(O)U=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(K==null?void 0:K.__$__nodeRequire)=="function"){const O=(0,L.dirname)(S.FileAccess.asFileUri("",K));U=K.__$__nodeRequire((0,L.joinPath)(O,"product.json").fsPath);const g=K.__$__nodeRequire((0,L.joinPath)(O,"package.json").fsPath);A.env.VSCODE_DEV&&Object.assign(U,{nameShort:`${U.nameShort} Dev`,nameLong:`${U.nameLong} Dev`,dataFolderName:`${U.dataFolderName}-dev`}),Object.assign(U,{version:g.version})}else U={},Object.keys(U).length===0&&Object.assign(U,{version:"1.56.0-dev",nameShort:k.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:k.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=U}),define(Z[76],ee([0,1,115,22,10,11,51]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function O(f,y,I,a,b,C){let E;try{await g(f,y,I,a,b,C)}catch(p){E=p}finally{E&&b.errorTransformer&&(E=b.errorTransformer(E)),typeof E!="undefined"&&I.error(E),I.end()}}e.readFileIntoStream=O;async function g(f,y,I,a,b,C){v(C);const E=await f.open(y,{create:!1});try{v(C);let p=0,m=0,c=b&&typeof b.length=="number"?b.length:void 0,s=k.VSBuffer.alloc(Math.min(b.bufferSize,typeof c=="number"?c:b.bufferSize)),t=b&&typeof b.position=="number"?b.position:0,i=0;do m=await f.read(E,t,s.buffer,i,s.byteLength-i),t+=m,i+=m,p+=m,typeof c=="number"&&(c-=m),i===s.byteLength&&(await I.write(a(s)),s=k.VSBuffer.alloc(Math.min(b.bufferSize,typeof c=="number"?c:b.bufferSize)),i=0);while(m>0&&(typeof c!="number"||c>0)&&v(C)&&R(p,b));if(i>0){let n=i;typeof c=="number"&&(n=Math.min(i,c)),I.write(a(s.slice(0,n)))}}catch(p){throw(0,A.ensureFileSystemProviderError)(p)}finally{await f.close(E)}}function v(f){if(f.isCancellationRequested)throw(0,L.canceled)();return!0}function R(f,y){if(y==null?void 0:y.limits){if(typeof y.limits.memory=="number"&&f>y.limits.memory)throw(0,A.createFileSystemProviderError)((0,S.localize)(0,null,U.default.nameShort),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&f>y.limits.size)throw(0,A.createFileSystemProviderError)((0,S.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[155],ee([0,1,113,156,2,10,3,12,37,18,17,22,47,6,30,16,76,53]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I,a,b,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let p=class extends A.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new U.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new U.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new U.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new U.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new U.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new U.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(c,s){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,k.mark)(`code/registerFilesystem/${c}`),this.provider.set(c,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:s});const t=new A.DisposableStore;return t.add(s.onDidChangeFile(i=>this._onDidFilesChange.fire(new L.FileChangesEvent(i,!this.isPathCaseSensitive(s))))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:c}))),typeof s.onDidErrorOccur=="function"&&t.add(s.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,A.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:s}),this.provider.delete(c),(0,A.dispose)(t)})}async activateProvider(c){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(t){s.push(t)}}),!this.provider.has(c)&&await I.Promises.settled(s)}canHandleResource(c){return this.provider.has(c.scheme)}hasCapability(c,s){const t=this.provider.get(c.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return E.Iterable.map(this.provider,([c,s])=>({scheme:c,capabilities:s.capabilities}))}async withProvider(c){if(!(0,O.isAbsolutePath)(c))throw new L.FileOperationError((0,S.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const s=this.provider.get(c.scheme);if(!s){const t=new Error;throw t.name="ENOPRO",t.message=(0,S.localize)(1,null,c.toString()),t}return s}async withReadProvider(c){const s=await this.withProvider(c);if((0,L.hasOpenReadWriteCloseCapability)(s)||(0,L.hasReadWriteCapability)(s)||(0,L.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const s=await this.withProvider(c);if((0,L.hasOpenReadWriteCloseCapability)(s)||(0,L.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,s){try{return await this.doResolveFile(c,s)}catch(t){throw(0,L.toFileSystemProviderErrorCode)(t)===L.FileSystemProviderErrorCode.FileNotFound?new L.FileOperationError((0,S.localize)(2,null,this.resourceForError(c)),1):(0,L.ensureFileSystemProviderError)(t)}}async doResolveFile(c,s){const t=await this.withProvider(c),i=this.isPathCaseSensitive(t),n=s==null?void 0:s.resolveTo,o=s==null?void 0:s.resolveSingleChildDescendants,r=s==null?void 0:s.resolveMetadata,l=await t.stat(c);let h;return this.toFileStat(t,c,l,void 0,!!r,(d,w)=>(h||(h=g.TernarySearchTree.forUris(()=>!i),h.set(c,!0),(0,v.isNonEmptyArray)(n)&&n.forEach(u=>h.set(u,!0))),Boolean(h.findSuperstr(d.resource)||h.get(d.resource))?!0:d.isDirectory&&o?w===1:!1))}async toFileStat(c,s,t,i,n,o){const{providerExtUri:r}=this.getExtUri(c),l={resource:s,name:r.basename(s),isFile:(t.type&L.FileType.File)!=0,isDirectory:(t.type&L.FileType.Directory)!=0,isSymbolicLink:(t.type&L.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,L.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&o(l,i)){try{const h=await c.readdir(s),d=await I.Promises.settled(h.map(async([w,u])=>{try{const P=r.joinPath(s,w),_=n?await c.stat(P):{type:u};return await this.toFileStat(c,P,_,h.length,n,o)}catch(P){return this.logService.trace(P),null}}));l.children=(0,v.coalesce)(d)}catch(h){this.logService.trace(h),l.children=[]}return l}return l}async resolveAll(c){return I.Promises.settled(c.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(c){const s=await this.withProvider(c);try{return!!await s.stat(c)}catch(t){return!1}}async canCreateFile(c,s){try{await this.doValidateCreateFile(c,s)}catch(t){return t}return!0}async doValidateCreateFile(c,s){if(!(s==null?void 0:s.overwrite)&&await this.exists(c))throw new L.FileOperationError((0,S.localize)(3,null,this.resourceForError(c)),3,s)}async createFile(c,s=f.VSBuffer.fromString(""),t){await this.doValidateCreateFile(c,t);const i=await this.writeFile(c,s);return this._onDidRunOperation.fire(new L.FileOperationEvent(c,0,i)),i}async writeFile(c,s,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,c,t)||await this.mkdirp(i,n.dirname(c));let r;if((0,L.hasReadWriteCapability)(i)&&!(s instanceof f.VSBuffer))if((0,y.isReadableStream)(s)){const l=await(0,y.peekStream)(s,3);l.ended?r=f.VSBuffer.concat(l.buffer):r=l}else r=(0,y.peekReadable)(s,l=>f.VSBuffer.concat(l),3);else r=s;!(0,L.hasOpenReadWriteCloseCapability)(i)||(0,L.hasReadWriteCapability)(i)&&r instanceof f.VSBuffer?await this.doWriteUnbuffered(i,c,t,r):await this.doWriteBuffered(i,c,t,r instanceof f.VSBuffer?(0,f.bufferToReadable)(r):r)}catch(o){throw new L.FileOperationError((0,S.localize)(4,null,this.resourceForError(c),(0,L.ensureFileSystemProviderError)(o).toString()),(0,L.toFileOperationResult)(o),t)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,s,t){if(!!(t==null?void 0:t.unlock)&&!(c.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(s)));let n;try{n=await c.stat(s)}catch(o){return}if((n.type&L.FileType.Directory)!=0)throw new L.FileOperationError((0,S.localize)(6,null,this.resourceForError(s)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==L.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&t.mtime<n.mtime&&t.etag!==(0,L.etag)({mtime:t.mtime,size:n.size}))throw new L.FileOperationError((0,S.localize)(7,null),3,t);return n}async readFile(c,s){const t=await this.withReadProvider(c);return(s==null?void 0:s.atomic)?this.doReadFileAtomic(t,c,s):this.doReadFile(t,c,s)}async doReadFileAtomic(c,s,t){return new Promise((i,n)=>{this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(c,s,t);i(o)}catch(o){n(o)}})})}async doReadFile(c,s,t){const i=await this.doReadFileStream(c,s,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await(0,f.streamToBuffer)(i.value)})}async readFileStream(c,s){const t=await this.withReadProvider(c);return this.doReadFileStream(t,c,s)}async doReadFileStream(c,s,t){const i=new a.CancellationTokenSource,n=this.validateReadFile(s,t).then(r=>r,r=>{throw i.cancel(),r});let o;try{t&&typeof t.etag=="string"&&t.etag!==L.ETAG_DISABLED&&await n,!((0,L.hasOpenReadWriteCloseCapability)(c)||(0,L.hasFileReadStreamCapability)(c))||(0,L.hasReadWriteCapability)(c)&&(t==null?void 0:t.preferUnbuffered)?o=this.readFileUnbuffered(c,s,t):(0,L.hasFileReadStreamCapability)(c)?o=this.readFileStreamed(c,s,i.token,t):o=this.readFileBuffered(c,s,i.token,t);const r=await n;return Object.assign(Object.assign({},r),{value:o})}catch(r){throw o&&await(0,y.consumeStream)(o),new L.FileOperationError((0,S.localize)(8,null,this.resourceForError(s),(0,L.ensureFileSystemProviderError)(r).toString()),(0,L.toFileOperationResult)(r),t)}}readFileStreamed(c,s,t,i=Object.create(null)){const n=c.readFileStream(s,i,t);return(0,y.transform)(n,{data:o=>o instanceof f.VSBuffer?o:f.VSBuffer.wrap(o),error:o=>new L.FileOperationError((0,S.localize)(9,null,this.resourceForError(s),(0,L.ensureFileSystemProviderError)(o).toString()),(0,L.toFileOperationResult)(o),i)},o=>f.VSBuffer.concat(o))}readFileBuffered(c,s,t,i=Object.create(null)){const n=(0,f.newWriteableBufferStream)();return(0,C.readFileIntoStream)(c,s,n,o=>o,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new L.FileOperationError((0,S.localize)(10,null,this.resourceForError(s),(0,L.ensureFileSystemProviderError)(o).toString()),(0,L.toFileOperationResult)(o),i)}),t),n}readFileUnbuffered(c,s,t){const i=(0,y.newWriteableStream)(n=>f.VSBuffer.concat(n));return(async()=>{try{let n=await c.readFile(s);t&&typeof t.position=="number"&&(n=n.slice(t.position)),t&&typeof t.length=="number"&&(n=n.slice(0,t.length)),this.validateReadFileLimits(s,n.byteLength,t),i.end(f.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(c,s){const t=await this.resolve(c,{resolveMetadata:!0});if(t.isDirectory)throw new L.FileOperationError((0,S.localize)(11,null,this.resourceForError(c)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==L.ETAG_DISABLED&&s.etag===t.etag)throw new L.FileOperationError((0,S.localize)(12,null),2,s);return this.validateReadFileLimits(c,t.size,s),t}validateReadFileLimits(c,s,t){if(t==null?void 0:t.limits){let i;if(typeof t.limits.memory=="number"&&s>t.limits.memory&&(i=9),typeof t.limits.size=="number"&&s>t.limits.size&&(i=7),typeof i=="number")throw new L.FileOperationError((0,S.localize)(13,null,this.resourceForError(c)),i)}}async canMove(c,s,t){return this.doCanMoveCopy(c,s,"move",t)}async canCopy(c,s,t){return this.doCanMoveCopy(c,s,"copy",t)}async doCanMoveCopy(c,s,t,i){if(c.toString()!==s.toString())try{const n=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,c,o,s,t,i)}catch(n){return n}return!0}async move(c,s,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,c,n,s,"move",!!t),r=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(c,o==="move"?2:3,r)),r}async copy(c,s,t){const i=await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,c,n,s,"copy",!!t),r=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(c,o==="copy"?3:2,r)),r}async doMoveCopy(c,s,t,i,n,o){if(s.toString()===i.toString())return n;const{exists:r,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(c,s,t,i,n,o);if(r&&!l&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i)),n==="copy"){if(c===t&&(0,L.hasFileFolderCopyCapability)(c))await c.copy(s,i,{overwrite:o});else{const h=await this.resolve(s);h.isDirectory?await this.doCopyFolder(c,h,t,i):await this.doCopyFile(c,s,t,i)}return n}else return c===t?(await c.rename(s,i,{overwrite:o}),n):(await this.doMoveCopy(c,s,t,i,"copy",o),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(c,s,t,i){if((0,L.hasOpenReadWriteCloseCapability)(c)&&(0,L.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(c,s,t,i);if((0,L.hasOpenReadWriteCloseCapability)(c)&&(0,L.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(c,s,t,i);if((0,L.hasReadWriteCapability)(c)&&(0,L.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(c,s,t,i);if((0,L.hasReadWriteCapability)(c)&&(0,L.hasReadWriteCapability)(t))return this.doPipeUnbuffered(c,s,t,i)}async doCopyFolder(c,s,t,i){await t.mkdir(i),Array.isArray(s.children)&&await I.Promises.settled(s.children.map(async n=>{const o=this.getExtUri(t).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(c,await this.resolve(n.resource),t,o):this.doCopyFile(c,n.resource,t,o)}))}async doValidateMoveCopy(c,s,t,i,n,o){let r=!1;if(c===t){const{providerExtUri:h,isPathCaseSensitive:d}=this.getExtUri(c);if(d||(r=h.isEqual(s,i)),r&&n==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!r&&h.isEqualOrParent(i,s))throw new Error((0,S.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const l=await this.exists(i);if(l&&!r){if(!o)throw new L.FileOperationError((0,S.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(c===t){const{providerExtUri:h}=this.getExtUri(c);if(h.isEqualOrParent(s,i))throw new Error((0,S.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:l,isSameResourceWithDifferentPathCase:r}}getExtUri(c){const s=this.isPathCaseSensitive(c);return{providerExtUri:s?O.extUri:O.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(s,c);const t=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(c,0,t)),t}async mkdirp(c,s){const t=[],{providerExtUri:i}=this.getExtUri(c);for(;!i.isEqual(s,i.dirname(s));)try{if(((await c.stat(s)).type&L.FileType.Directory)==0)throw new Error((0,S.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,L.toFileSystemProviderErrorCode)(n)!==L.FileSystemProviderErrorCode.FileNotFound)throw n;t.push(i.basename(s)),s=i.dirname(s)}for(let n=t.length-1;n>=0;n--){s=i.joinPath(s,t[n]);try{await c.mkdir(s)}catch(o){if((0,L.toFileSystemProviderErrorCode)(o)!==L.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(c,s){try{await this.doValidateDelete(c,s)}catch(t){return t}return!0}async doValidateDelete(c,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!(s==null?void 0:s.useTrash)&&!(t.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(c)));const n=await this.exists(c);if(!n)throw new L.FileOperationError((0,S.localize)(20,null,this.resourceForError(c)),1);if(!!!(s==null?void 0:s.recursive)&&n){const r=await this.resolve(c);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(c)))}return t}async del(c,s){const t=await this.doValidateDelete(c,s),i=!!(s==null?void 0:s.useTrash),n=!!(s==null?void 0:s.recursive);await t.delete(c,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new L.FileOperationEvent(c,1))}watch(c,s={recursive:!1,excludes:[]}){let t=!1,i=()=>{t=!0};return this.doWatch(c,s).then(n=>{t?(0,A.dispose)(n):i=()=>(0,A.dispose)(n)},n=>this.logService.error(n)),(0,A.toDisposable)(()=>i())}async doWatch(c,s){const t=await this.withProvider(c),i=this.toWatchKey(t,c,s),n=this.activeWatchers.get(i)||{count:0,disposable:t.watch(c,s)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,A.toDisposable)(()=>{n.count--,n.count===0&&((0,A.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(c,s,t){const{providerExtUri:i}=this.getExtUri(c);return[i.getComparisonKey(s),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(c=>(0,A.dispose)(c.disposable)),this.activeWatchers.clear()}async doWriteBuffered(c,s,t,i){return this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(async()=>{var n;const o=await c.open(s,{create:!0,unlock:(n=t==null?void 0:t.unlock)!==null&&n!==void 0?n:!1});try{(0,y.isReadableStream)(i)||(0,y.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(c,o,i):await this.doWriteReadableBufferedQueued(c,o,i)}catch(r){throw(0,L.ensureFileSystemProviderError)(r)}finally{await c.close(o)}})}async doWriteStreamBufferedQueued(c,s,t){let i=0,n;if((0,y.isReadableBufferedStream)(t)){if(t.buffer.length>0){const o=f.VSBuffer.concat(t.buffer);await this.doWriteBuffer(c,s,o,o.byteLength,i,0),i+=o.byteLength}if(t.ended)return;n=t.stream}else n=t;return new Promise(async(o,r)=>{(0,y.listenStream)(n,{onData:async l=>{n.pause();try{await this.doWriteBuffer(c,s,l,l.byteLength,i,0)}catch(h){return r(h)}i+=l.byteLength,setTimeout(()=>n.resume())},onError:l=>r(l),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(c,s,t){let i=0,n;for(;(n=t.read())!==null;)await this.doWriteBuffer(c,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(c,s,t,i,n,o){let r=0;for(;r<i;)r+=await c.write(s,n+r,t.buffer,o+r,i-r)}async doWriteUnbuffered(c,s,t,i){return this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,s,t,i))}async doWriteUnbufferedQueued(c,s,t,i){var n;let o;i instanceof f.VSBuffer?o=i:(0,y.isReadableStream)(i)?o=await(0,f.streamToBuffer)(i):(0,y.isReadableBufferedStream)(i)?o=await(0,f.bufferedStreamToBuffer)(i):o=(0,f.readableToBuffer)(i),await c.writeFile(s,o.buffer,{create:!0,overwrite:!0,unlock:(n=t==null?void 0:t.unlock)!==null&&n!==void 0?n:!1})}async doPipeBuffered(c,s,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,s,t,i))}async doPipeBufferedQueued(c,s,t,i){let n,o;try{n=await c.open(s,{create:!1}),o=await t.open(i,{create:!0,unlock:!1});const r=f.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,h=0,d=0;do d=await c.read(n,l,r.buffer,h,r.byteLength-h),await this.doWriteBuffer(t,o,r,d,l,h),l+=d,h+=d,h===r.byteLength&&(h=0);while(d>0)}catch(r){throw(0,L.ensureFileSystemProviderError)(r)}finally{await I.Promises.settled([typeof n=="number"?c.close(n):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async doPipeUnbuffered(c,s,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,s,t,i))}async doPipeUnbufferedQueued(c,s,t,i){return t.writeFile(i,await c.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,s,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,s,t,i))}async doPipeUnbufferedToBufferedQueued(c,s,t,i){const n=await t.open(i,{create:!0,unlock:!1});try{const o=await c.readFile(s);await this.doWriteBuffer(t,n,f.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,L.ensureFileSystemProviderError)(o)}finally{await t.close(n)}}async doPipeBufferedToUnbuffered(c,s,t,i){const n=await(0,f.streamToBuffer)(this.readFileBuffered(c,s,a.CancellationToken.None));await this.doWriteUnbuffered(t,i,void 0,n)}throwIfFileSystemIsReadonly(c,s){if(c.capabilities&2048)throw new L.FileOperationError((0,S.localize)(22,null,this.resourceForError(s)),6);return c}resourceForError(c){return c.scheme===b.Schemas.file?c.fsPath:c.toString(!0)}};p=he([Y(0,R.ILogService)],p),e.FileService=p}),define(Z[157],ee([0,1,27,94,2,10,3,7,23,8,12,42,6,17,116,73,133,135,132,146,47,76,18,22]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I,a,b,C,E,p,m,c,s,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class n extends A.Disposable{constructor(r,l){var h;super();this.logService=r,this.options=l,this.BUFFER_SIZE=((h=this.options)===null||h===void 0?void 0:h.bufferSize)||64*1024,this.onDidChangeCapabilities=U.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new U.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new U.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new y.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,O.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:l,symbolicLink:h}=await g.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(l,h),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size}}catch(l){throw this.toFileSystemProviderError(l)}}async readdir(r){try{const l=await(0,g.readdir)(this.toFilePath(r),{withFileTypes:!0}),h=[];return await Promise.all(l.map(async d=>{try{let w;d.isSymbolicLink()?w=(await this.stat((0,R.joinPath)(r,d.name))).type:w=this.toType(d),h.push([d.name,w])}catch(w){this.logService.trace(w)}})),h}catch(l){throw this.toFileSystemProviderError(l)}}toType(r,l){let h;return(l==null?void 0:l.dangling)?h=L.FileType.Unknown:r.isFile()?h=L.FileType.File:r.isDirectory()?h=L.FileType.Directory:h=L.FileType.Unknown,l&&(h|=L.FileType.SymbolicLink),h}async readFile(r){try{const l=this.toFilePath(r);return await S.promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}}readFileStream(r,l,h){const d=(0,c.newWriteableStream)(w=>i.VSBuffer.concat(w.map(u=>i.VSBuffer.wrap(u))).buffer);return(0,s.readFileIntoStream)(this,r,d,w=>w.buffer,Object.assign(Object.assign({},l),{bufferSize:this.BUFFER_SIZE}),h),d}async writeFile(r,l,h){let d;try{const w=this.toFilePath(r);if(!h.create||!h.overwrite){if(await(0,g.exists)(w)){if(!h.overwrite)throw(0,L.createFileSystemProviderError)((0,a.localize)(0,null),L.FileSystemProviderErrorCode.FileExists)}else if(!h.create)throw(0,L.createFileSystemProviderError)((0,a.localize)(1,null),L.FileSystemProviderErrorCode.FileNotFound)}d=await this.open(r,{create:!0,unlock:h.unlock}),await this.write(d,0,l,0,l.byteLength)}catch(w){throw await this.toFileSystemProviderWriteError(r,w)}finally{typeof d=="number"&&await this.close(d)}}async open(r,l){try{const h=this.toFilePath(r);if((0,L.isFileOpenForWriteOptions)(l)&&l.unlock)try{const{stat:u}=await g.SymlinkSupport.stat(h);u.mode&128||await S.promises.chmod(h,u.mode|128)}catch(u){this.logService.trace(u)}let d;if((0,L.isFileOpenForWriteOptions)(l)){if(O.isWindows)try{await S.promises.truncate(h,0),d="r+"}catch(u){u.code!=="ENOENT"&&this.logService.trace(u)}d||(d="w")}else d="r";const w=await(0,k.promisify)(S.open)(h,d);return this.mapHandleToPos.set(w,0),(0,L.isFileOpenForWriteOptions)(l)&&this.writeHandles.set(w,r),w}catch(h){throw(0,L.isFileOpenForWriteOptions)(l)?await this.toFileSystemProviderWriteError(r,h):this.toFileSystemProviderError(h)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await(0,k.promisify)(S.fdatasync)(r)}catch(l){this.canFlush=!1,this.logService.error(l)}return await(0,k.promisify)(S.close)(r)}catch(l){throw this.toFileSystemProviderError(l)}}async read(r,l,h,d,w){const u=this.normalizePos(r,l);let P=null;try{const _=await(0,k.promisify)(S.read)(r,h,d,w,u);return typeof _=="number"?P=_:P=_.bytesRead,P}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(r,u,P)}}normalizePos(r,l){return l===this.mapHandleToPos.get(r)?null:l}updatePos(r,l,h){const d=this.mapHandleToPos.get(r);typeof d=="number"&&(typeof l=="number"||(typeof h=="number"?this.mapHandleToPos.set(r,d+h):this.mapHandleToPos.delete(r)))}async write(r,l,h,d,w){return(0,y.retry)(()=>this.doWrite(r,l,h,d,w),100,3)}async doWrite(r,l,h,d,w){const u=this.normalizePos(r,l);let P=null;try{const _=await(0,k.promisify)(S.write)(r,h,d,w,u);return typeof _=="number"?P=_:P=_.bytesWritten,P}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),_)}finally{this.updatePos(r,u,P)}}async mkdir(r){try{await S.promises.mkdir(this.toFilePath(r))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(r,l){try{const h=this.toFilePath(r);await this.doDelete(h,l)}catch(h){throw this.toFileSystemProviderError(h)}}async doDelete(r,l){l.recursive?await(0,g.rimraf)(r,g.RimRafMode.MOVE):await S.promises.unlink(r)}async rename(r,l,h){const d=this.toFilePath(r),w=this.toFilePath(l);if(d!==w)try{await this.validateTargetDeleted(r,l,"move",h.overwrite),await(0,g.move)(d,w)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,a.localize)(2,null,(0,v.basename)(d),(0,v.basename)((0,v.dirname)(w)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(r,l,h){const d=this.toFilePath(r),w=this.toFilePath(l);if(d!==w)try{await this.validateTargetDeleted(r,l,"copy",h.overwrite),await(0,g.copy)(d,w,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,a.localize)(3,null,(0,v.basename)(d),(0,v.basename)((0,v.dirname)(w)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(r,l,h,d){const w=this.toFilePath(r),u=this.toFilePath(l);let P=!1;if(!!(this.capabilities&1024)||(P=(0,f.isEqual)(w,u,!0)),P&&h==="copy")throw(0,L.createFileSystemProviderError)((0,a.localize)(4,null),L.FileSystemProviderErrorCode.FileExists);if(!P&&await(0,g.exists)(u)){if(!d)throw(0,L.createFileSystemProviderError)((0,a.localize)(5,null),L.FileSystemProviderErrorCode.FileExists);await this.delete(l,{recursive:!0,useTrash:!1})}}watch(r,l){return l.recursive?this.watchRecursive(r,l.excludes):this.watchNonRecursive(r)}watchRecursive(r,l){const h={path:this.toFilePath(r),excludes:l},d=(0,t.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,A.toDisposable)(()=>{d(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var r,l,h;if(this.recursiveWatcher instanceof p.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,A.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let d,w;((l=(r=this.options)===null||r===void 0?void 0:r.watcher)===null||l===void 0?void 0:l.usePolling)?(d=C.FileWatcher,w=(h=this.options)===null||h===void 0?void 0:h.watcher):this.recursiveFoldersToWatch.length===1?O.isWindows?d=E.FileWatcher:d=C.FileWatcher:d=p.FileWatcher,this.recursiveWatcher=new d(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire((0,b.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===I.LogLevel.Trace,w),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))}}watchNonRecursive(r){const l=new m.FileWatcher(this.toFilePath(r),d=>this._onDidChangeFile.fire((0,b.toFileChanges)(d)),d=>{d.type==="error"&&this._onDidWatchErrorOccur.fire(d.message),this.logService[d.type](d.message)},this.logService.getLevel()===I.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)});return(0,A.combinedDisposable)(l,h)}toFilePath(r){return(0,v.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof L.FileSystemProviderError)return r;let l;switch(r.code){case"ENOENT":l=L.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=L.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=L.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=L.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=L.FileSystemProviderErrorCode.NoPermissions;break;default:l=L.FileSystemProviderErrorCode.Unknown}return(0,L.createFileSystemProviderError)(r,l)}async toFileSystemProviderWriteError(r,l){let h=this.toFileSystemProviderError(l);if(r&&h.code===L.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await g.SymlinkSupport.stat(this.toFilePath(r));d.mode&128||(h=(0,L.createFileSystemProviderError)(l,L.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.logService.trace(d)}return h}dispose(){super.dispose(),(0,A.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,A.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=n}),define(Z[28],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService")}),define(Z[158],ee([0,1,27,8,23,28,2,11,17,9]),function(K,e,S,k,A,L,U,O,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let R=class extends U.Disposable{constructor(y,I,a){super();this._environmentService=y,this._logService=I,this._productService=a,this._DataMaxAge=this._productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._environmentService.isBuilt&&this._manageCachedDataSoon()}_manageCachedDataSoon(){let y=setTimeout(async()=>{y=void 0,this._logService.info("Starting to clean up unused language packs.");try{const I=Object.create(null),a=JSON.parse(await S.promises.readFile(k.join(this._environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let p of Object.keys(a)){const m=a[p];I[`${m.hash}.${p}`]=!0}const b=k.join(this._environmentService.userDataPath,"clp");if(!await A.exists(b))return;for(let p of await A.readdir(b)){if(I[p]){this._logService.info(`Skipping directory ${p}. Language pack still in use.`);continue}this._logService.info("Removing unused language pack:",p),await A.rimraf(k.join(b,p))}const E=Date.now();for(let p of Object.keys(I)){const m=k.join(b,p);for(let c of await A.readdir(m))if(c!=="tcf.json"){const s=k.join(m,c),t=await S.promises.stat(s);t.isDirectory()&&E-t.mtime.getTime()>this._DataMaxAge&&(this._logService.info("Removing language pack cache entry: ",k.join(p,c)),await A.rimraf(s))}}}catch(I){(0,O.onUnexpectedError)(I)}},40*1e3);this._register((0,U.toDisposable)(()=>{y!==void 0&&clearTimeout(y)}))}};R=he([Y(0,v.INativeEnvironmentService),Y(1,g.ILogService),Y(2,L.IProductService)],R),e.LanguagePackCachedDataCleaner=R}),define(Z[159],ee([0,1,27,8,11,2,23,28]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeCachedDataCleaner=void 0;let g=class{constructor(R,f){this.nodeCachedDataDir=R,this.productService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._disposables=new L.DisposableStore,this._manageCachedDataSoon()}dispose(){this._disposables.dispose()}_manageCachedDataSoon(){if(!!this.nodeCachedDataDir){const R=(0,k.dirname)(this.nodeCachedDataDir),f=(0,k.basename)(this.nodeCachedDataDir);let y=setTimeout(()=>{y=void 0,(0,U.readdir)(R).then(I=>{const a=Date.now(),b=[];return I.forEach(C=>{if(C!==f){const E=(0,k.join)(R,C);b.push(S.promises.stat(E).then(p=>{if(p.isDirectory()&&a-p.mtime.getTime()>this._DataMaxAge)return(0,U.rimraf)(E)}))}}),Promise.all(b)}).then(void 0,A.onUnexpectedError)},30*1e3);this._disposables.add((0,L.toDisposable)(()=>{y&&(clearTimeout(y),y=void 0)}))}}};g=he([Y(1,O.IProductService)],g),e.NodeCachedDataCleaner=g}),define(Z[35],ee([0,1,15,84]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(U,O){k.ok(S.isString(U)),k.ok(S.isObject(O)),k.ok(!this.data.has(U),"There is already an extension with this id"),this.data.set(U,O)}knows(U){return this.data.has(U)}as(U){return this.data.get(U)||null}}e.Registry=new A}),define(Z[77],ee([0,1,35,3]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class L{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,v){this.schemasById[A(g)]=v,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const U=new L;S.Registry.add(e.Extensions.JSONContribution,U)}),define(Z[39],ee([0,1,106,3,35,15,77]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const g=A.Registry.as(U.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,p=!0){this.registerConfigurations([E],p)}registerConfigurations(E,p=!0){const m=[];E.forEach(c=>{m.push(...this.validateAndRegisterProperties(c,p,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterConfigurations(E){const p=[],m=c=>{if(c.properties)for(const s in c.properties)p.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,c.properties[s]);c.allOf&&c.allOf.forEach(s=>m(s))};for(const c of E){m(c);const s=this.configurationContributors.indexOf(c);s!==-1&&this.configurationContributors.splice(s,1)}g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}registerDefaultConfigurations(E){const p=[],m=[];for(const c of E)for(const s in c)if(p.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]=Object.assign(Object.assign({},this.defaultValues[s]||{}),c[s]);const t={type:"object",default:this.defaultValues[s],description:S.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};m.push(f(s)),this.configurationProperties[s]=t,this.defaultLanguageConfigurationOverridesNode.properties[s]=t}else{this.defaultValues[s]=c[s];const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterDefaultConfigurations(E){const p=[];for(const m of E)for(const c in m)if(p.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const s=this.configurationProperties[c];s&&(this.updatePropertyDefaultValue(c,s),this.updateSchema(c,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const p of E)this.overrideIdentifiers.add(p);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,p=!0,m,c=3){var s;c=L.isUndefinedOrNull(E.scope)?c:E.scope;let t=[],i=E.properties;if(i)for(let o in i){if(p&&a(o)){delete i[o];continue}const r=i[o];if(this.updatePropertyDefaultValue(o,r),e.OVERRIDE_PROPERTY_PATTERN.test(o)?r.scope=void 0:(r.scope=L.isUndefinedOrNull(r.scope)?c:r.scope,r.requireTrust=L.isUndefinedOrNull(r.requireTrust)?!!((s=m==null?void 0:m.requireTrustForConfigurations)===null||s===void 0?void 0:s.includes(o)):r.requireTrust),i[o].hasOwnProperty("included")&&!i[o].included){this.excludedConfigurationProperties[o]=i[o],delete i[o];continue}else this.configurationProperties[o]=i[o];!i[o].deprecationMessage&&i[o].markdownDeprecationMessage&&(i[o].deprecationMessage=i[o].markdownDeprecationMessage),t.push(o)}let n=E.allOf;if(n)for(let o of n)t.push(...this.validateAndRegisterProperties(o,p,m,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const p=m=>{let c=m.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let s=m.allOf;s&&s.forEach(p)};p(E)}updateSchema(E,p){switch(e.allSettings.properties[E]=p,p.scope){case 1:e.applicationSettings.properties[E]=p;break;case 2:e.machineSettings.properties[E]=p;break;case 6:e.machineOverridableSettings.properties[E]=p;break;case 3:e.windowSettings.properties[E]=p;break;case 4:e.resourceSettings.properties[E]=p;break;case 5:e.resourceSettings.properties[E]=p,this.resourceLanguageSettingsSchema.properties[E]=p;break}}removeFromSchema(E,p){switch(delete e.allSettings.properties[E],p.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const p=`[${E}]`,m={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(p,m),e.allSettings.properties[p]=m,e.applicationSettings.properties[p]=m,e.machineSettings.properties[p]=m,e.machineOverridableSettings.properties[p]=m,e.windowSettings.properties[p]=m,e.resourceSettings.properties[p]=m}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,p){let m=this.defaultValues[E];L.isUndefined(m)&&(m=p.default),L.isUndefined(m)&&(m=y(p.type)),p.default=m}}const R="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(R);function f(C){return C.substring(1,C.length-1)}e.overrideIdentifierFromKey=f;function y(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=y;const I=new v;A.Registry.add(e.Extensions.Configuration,I);function a(C){return C.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(C)?S.localize(5,null,C):I.getConfigurationProperties()[C]!==void 0?S.localize(6,null,C):null:S.localize(4,null)}e.validateProperty=a;function b(){const C=[],E=I.getConfigurationProperties();for(const p of Object.keys(E))C.push([p,E[p].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.getScopes=b}),define(Z[24],ee([0,1,26,15,4,35,5,39]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,U.createDecorator)("configurationService");function g(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof A.URI)}e.isConfigurationOverrides=g;var v;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(v=e.ConfigurationTarget||(e.ConfigurationTarget={}));function R(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=R;function f(i,n){const o=n?i?n.keys.filter(P=>i.keys.indexOf(P)===-1):[...n.keys]:[],r=i?n?i.keys.filter(P=>n.keys.indexOf(P)===-1):[...i.keys]:[],l=[];if(n&&i){for(const P of i.keys)if(n.keys.indexOf(P)!==-1){const _=E(i.contents,P),z=E(n.contents,P);S.equals(_,z)||l.push(P)}}const h=[],d=P=>{const _={};for(const z of P)for(const B of z.identifiers)_[s(B)]=z;return _},w=n?d(n.overrides):{},u=i?d(i.overrides):{};if(Object.keys(w).length)for(const P of o){const _=w[P];_&&h.push([(0,O.overrideIdentifierFromKey)(P),_.keys])}if(Object.keys(u).length)for(const P of r){const _=u[P];_&&h.push([(0,O.overrideIdentifierFromKey)(P),_.keys])}if(Object.keys(w).length&&Object.keys(u).length)for(const P of l){const _=u[P],z=w[P];if(_&&z){const B=f({contents:_.contents,keys:_.keys,overrides:[]},{contents:z.contents,keys:z.keys,overrides:[]});h.push([(0,O.overrideIdentifierFromKey)(P),[...B.added,...B.removed,...B.updated]])}}return{added:o,removed:r,updated:l,overrides:h}}e.compare=f;function y(i,n){const o=[];for(const r of Object.keys(i))if(O.OVERRIDE_PROPERTY_PATTERN.test(r)){const l={};for(const h in i[r])l[h]=i[r][h];o.push({identifiers:[(0,O.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(l),contents:I(l,n)})}return o}e.toOverrides=y;function I(i,n){const o=Object.create(null);for(let r in i)a(o,r,i[r],n);return o}e.toValuesTree=I;function a(i,n,o,r){const l=n.split("."),h=l.pop();let d=i;for(let w=0;w<l.length;w++){let u=l[w],P=d[u];switch(typeof P){case"undefined":P=d[u]=Object.create(null);break;case"object":break;default:r(`Ignoring ${n} as ${l.slice(0,w+1).join(".")} is ${JSON.stringify(P)}`);return}d=P}if(typeof d=="object"&&d!==null)try{d[h]=o}catch(w){r(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}else r(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=a;function b(i,n){const o=n.split(".");C(i,o)}e.removeFromValueTree=b;function C(i,n){const o=n.shift();if(n.length===0){delete i[o];return}if(Object.keys(i).indexOf(o)!==-1){const r=i[o];typeof r=="object"&&!Array.isArray(r)&&(C(r,n),Object.keys(r).length===0&&delete i[o])}}function E(i,n,o){function r(d,w){let u=d;for(const P of w){if(typeof u!="object"||u===null)return;u=u[P]}return u}const l=n.split("."),h=r(i,l);return typeof h=="undefined"?o:h}e.getConfigurationValue=E;function p(i,n,o){Object.keys(n).forEach(r=>{r!=="__proto__"&&(r in i?k.isObject(i[r])&&k.isObject(n[r])?p(i[r],n[r],o):o&&(i[r]=n[r]):i[r]=n[r])})}e.merge=p;function m(){const i=L.Registry.as(O.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=m;function c(){const i=Object.create(null),n=L.Registry.as(O.Extensions.Configuration).getConfigurationProperties();for(let o in n){let r=n[o].default;a(i,o,r,l=>console.error(`Conflict in default settings: ${l}`))}return i}e.getDefaultValues=c;function s(i){return`[${i}]`}e.keyFromOverrideIdentifier=s;function t(i,n,o){const r=i.inspect(n),l=i.inspect(o);return typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:r.defaultValue}e.getMigratedSettingValue=t}),define(Z[160],ee([0,1,32,37,18,15,26,4,39,24,35,2,3]),function(K,e,S,k,A,L,U,O,g,v,R,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class I{constructor(t={},i=[],n=[]){this._contents=t,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,v.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const n=this.getContentsForOverrideIdentifer(i);return n?t?(0,v.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const o of A.distinct([...Object.keys(this.contents),...Object.keys(i)])){let r=this.contents[o],l=i[o];l&&(typeof r=="object"&&typeof l=="object"?(r=U.deepClone(r),this.mergeContents(r,l)):r=l),n[o]=r}return new I(n,this.keys,this.overrides)}merge(...t){const i=U.deepClone(this.contents),n=U.deepClone(this.overrides),o=[...this.keys];for(const r of t){this.mergeContents(i,r.contents);for(const l of r.overrides){const[h]=n.filter(d=>A.equals(d.identifiers,l.identifiers));h?this.mergeContents(h.contents,l.contents):n.push(U.deepClone(l))}for(const l of r.keys)o.indexOf(l)===-1&&o.push(l)}return new I(i,o,n)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const n of Object.keys(i)){if(n in t&&L.isObject(t[n])&&L.isObject(i[n])){this.mergeContents(t[n],i[n]);continue}t[n]=U.deepClone(i[n])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?U.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,v.addToValueTree)(this.contents,t,i,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&(0,v.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let n=0;n<i;n++)t.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=I;class a extends I{constructor(){const t=(0,v.getDefaultValues)(),i=(0,v.getConfigurationKeys)(),n=[];for(const o of Object.keys(t))g.OVERRIDE_PROPERTY_PATTERN.test(o)&&n.push({identifiers:[(0,g.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(t[o]),contents:(0,v.toValuesTree)(t[o],r=>console.error(`Conflict in default settings file: ${r}`))});super(t,i,n)}}e.DefaultConfigurationModel=a;class b{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!L.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:n,keys:o,overrides:r,untrusted:l}=this.doParseRaw(t,i);this._configurationModel=new I(n,o,r),this._untrustedConfigurations=l||[]}doParseContent(t){let i={},n=null,o=[],r=[],l=[];function h(w){Array.isArray(o)?o.push(w):n&&(o[n]=w)}let d={onObjectBegin:()=>{let w={};h(w),r.push(o),o=w,n=null},onObjectProperty:w=>{n=w},onObjectEnd:()=>{o=r.pop()},onArrayBegin:()=>{let w=[];h(w),r.push(o),o=w,n=null},onArrayEnd:()=>{o=r.pop()},onLiteralValue:h,onError:(w,u,P)=>{l.push({error:w,offset:u,length:P})}};if(t)try{S.visit(t,d),i=o[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return i}doParseRaw(t,i){const n=R.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,n,!0,i);t=o.raw;const r=(0,v.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),l=Object.keys(t),h=(0,v.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:r,keys:l,overrides:h,untrusted:o.untrusted}}filter(t,i,n,o){if(!(o==null?void 0:o.scopes)&&!(o==null?void 0:o.isUntrusted))return{raw:t,untrusted:[]};const r={},l=[];for(let h in t)if(g.OVERRIDE_PROPERTY_PATTERN.test(h)&&n){const d=this.filter(t[h],i,!1,o);r[h]=d.raw,l.push(...d.untrusted)}else{const d=i[h],w=d?typeof d.scope!="undefined"?d.scope:3:void 0;(w===void 0||o.scopes===void 0||o.scopes.includes(w))&&(o.isUntrusted&&(d==null?void 0:d.requireTrust)?l.push(h):r[h]=t[h])}return{raw:r,untrusted:l}}}e.ConfigurationModelParser=b;class C extends f.Disposable{constructor(t,i,n,o){super();this.userSettingsResource=t,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new b(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(y.Event.filter(this.fileService.onDidFilesChange,r=>r.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new I}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=C;class E{constructor(t,i,n=new I,o=new I,r=new k.ResourceMap,l=new I,h=new k.ResourceMap,d=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=o,this._folderConfigurations=r,this._memoryConfiguration=l,this._memoryConfigurationByResource=h,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(t)}updateValue(t,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new I,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(t):o.setValue(t,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,n){const o=this.getConsolidateConfigurationModel(i,n),r=this.getFolderConfigurationModelForResource(i.resource,n),l=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,h=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),d=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),w=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),u=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),P=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,_=r?i.overrideIdentifier?r.freeze().override(i.overrideIdentifier).getValue(t):r.freeze().getValue(t):void 0,z=i.overrideIdentifier?l.override(i.overrideIdentifier).getValue(t):l.getValue(t),B=o.getValue(t),M=A.distinct(A.flatten(o.overrides.map(j=>j.identifiers))).filter(j=>o.getOverrideValue(t,j)!==void 0);return{defaultValue:h,userValue:d,userLocalValue:w,userRemoteValue:u,workspaceValue:P,workspaceFolderValue:_,memoryValue:z,value:B,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:w!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:u!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:P!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:r==null?void 0:r.freeze().getValue(t),override:i.overrideIdentifier?r==null?void 0:r.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:l.getValue(t),override:i.overrideIdentifier?l.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:M.length?M:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=i.filter(o=>g.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const r=(0,g.overrideIdentifierFromKey)(o),l=this._defaultConfiguration.getKeysForOverrideIdentifier(r),h=t.getKeysForOverrideIdentifier(r),d=[...h.filter(w=>l.indexOf(w)===-1),...l.filter(w=>h.indexOf(w)===-1),...l.filter(w=>!U.equals(this._defaultConfiguration.override(r).getValue(w),t.override(r).getValue(w)))];return[r,d]});return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:o,overrides:r}=(0,v.compare)(this.localUserConfiguration,t),l=[...i,...n,...o];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:r}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:o,overrides:r}=(0,v.compare)(this.remoteUserConfiguration,t);let l=[...i,...n,...o];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:r}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:o,overrides:r}=(0,v.compare)(this.workspaceConfiguration,t);let l=[...i,...n,...o];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:r}}compareAndUpdateFolderConfiguration(t,i){const n=this.folderConfigurations.get(t),{added:o,updated:r,removed:l,overrides:h}=(0,v.compare)(n,i);let d=[...o,...r,...l];return(d.length||!n)&&this.updateFolderConfiguration(t,i),{keys:d,overrides:h}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:o,removed:r,overrides:l}=(0,v.compare)(i,void 0);return{keys:[...n,...o,...r],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let n=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?n.override(t.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:t},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const o=i.getFolder(t);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const r=this._memoryConfigurationByResource.get(t);r&&(n=n.merge(r))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(i=n.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=n}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:n,overrides:o,keys:r}=this._folderConfigurations.get(i);return t.push([i,{contents:n,overrides:o,keys:r}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),r=t.folders.reduce((l,h)=>(l.set(O.URI.revive(h[0]),this.parseConfigurationModel(h[1])),l),new k.ResourceMap);return new E(i,n,new I,o,r,new I,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new I(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=E;function p(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,i=new Map;for(const o of s)o.keys.forEach(r=>t.add(r)),o.overrides.forEach(([r,l])=>{const h=(0,k.getOrSet)(i,r,new Set);l.forEach(d=>h.add(d))});const n=[];return i.forEach((o,r)=>n.push([r,[...o.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=p;class m{constructor(t,i,n,o){this.change=t,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._previousConfiguration=void 0;const r=new Set;t.keys.forEach(h=>r.add(h)),t.overrides.forEach(([,h])=>h.forEach(d=>r.add(d))),this.affectedKeys=[...r.values()];const l=new I;this.affectedKeys.forEach(h=>l.setValue(h,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(n=this.previous)===null||n===void 0?void 0:n.workspace):void 0,r=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!U.equals(o,r)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let n=(0,v.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof n=="object"&&(o=Object.keys(n)[0]);){if(t=t[o],!t)return!1;n=n[o]}return!0}}e.ConfigurationChangeEvent=m;class c extends m{constructor(t,i,n,o){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=n,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=c}),define(Z[161],ee([0,1,35,39,2,24,160,3,6,12]),function(K,e,S,k,A,L,U,O,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class R extends A.Disposable{constructor(y,I){super();this.settingsResource=y,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new U.UserSettings(this.settingsResource,void 0,v.extUriBiasedIgnorePathCase,I)),this.configuration=new U.Configuration(new U.DefaultConfigurationModel,new U.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new g.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(S.Registry.as(k.Extensions.Configuration).onDidUpdateConfiguration(a=>this.onDidDefaultConfigurationChange(a))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const y=await this.userConfiguration.loadConfiguration();this.configuration=new U.Configuration(new U.DefaultConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(y,I){const a=typeof y=="string"?y:void 0,b=(0,L.isConfigurationOverrides)(y)?y:(0,L.isConfigurationOverrides)(I)?I:{};return this.configuration.getValue(a,b,void 0)}updateValue(y,I,a,b){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const I=this.configuration.toData(),a=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(a,I,1)}onDidDefaultConfigurationChange(y){const I=this.configuration.toData(),a=this.configuration.compareAndUpdateDefaultConfiguration(new U.DefaultConfigurationModel,y);this.trigger(a,I,6)}trigger(y,I,a){const b=new U.ConfigurationChangeEvent(y,{data:I},this.configuration);b.source=a,b.sourceConfig=this.getTargetConfiguration(a),this._onDidChangeConfiguration.fire(b)}getTargetConfiguration(y){switch(y){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=R}),define(Z[162],ee([0,1,24,17,100]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(O,g){this.configurationService=O,this.logService=g}request(O,g){return this.logService.trace("RequestService#request",O.url),O.proxyAuthorization||(O.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,A.request)(O,g)}async resolveProxy(O){}};L=he([Y(0,S.IConfigurationService),Y(1,k.ILogService)],L),e.RequestService=L}),define(Z[40],ee([0,1,117,5,39,35,22]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function O(a){return a.res.statusCode&&a.res.statusCode>=200&&a.res.statusCode<300||a.res.statusCode===1223}e.isSuccess=O;function g(a){return a.res.statusCode===204}async function v(a){if(!O(a))throw new Error("Server returned "+a.res.statusCode);return g(a)?null:(await(0,U.streamToBuffer)(a.stream)).toString()}e.asText=v;async function R(a){if(!O(a))throw new Error("Server returned "+a.res.statusCode);if(g(a))return null;const C=(await(0,U.streamToBuffer)(a.stream)).toString();try{return JSON.parse(C)}catch(E){throw E.message+=`:
`+C,E}}e.asJson=R;function f(a){I(a)}e.updateProxyConfigurationsScope=f;let y;function I(a){const b=L.Registry.as(A.Extensions.Configuration);y&&b.deregisterConfigurations([y]),y={id:"http",order:15,title:(0,S.localize)(0,null),type:"object",scope:a,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,S.localize)(1,null),requireTrust:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,S.localize)(2,null),requireTrust:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,S.localize)(3,null),requireTrust:!0},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[(0,S.localize)(4,null),(0,S.localize)(5,null),(0,S.localize)(6,null)],default:"override",description:(0,S.localize)(7,null),requireTrust:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,S.localize)(8,null),requireTrust:!0}}},b.registerConfiguration(y)}I(2)}),define(Z[163],ee([0,1,40,30,10,16]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let U=class{constructor(g,v){this.requestService=g,this.fileService=v}async download(g,v,R=k.CancellationToken.None){if(g.scheme===L.Schemas.file||g.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(g,v);return}const f={type:"GET",url:g.toString()},y=await this.requestService.request(f,R);if(y.res.statusCode===200)await this.fileService.writeFile(v,y.stream);else{const I=await(0,S.asText)(y);throw new Error(`Expected 200, got back ${y.res.statusCode} instead.

${I}`)}}};U=he([Y(0,S.IRequestService),Y(1,A.IFileService)],U),e.DownloadService=U}),define(Z[164],ee([0,1,28,10,18,62,40,30,17,12,128,2]),function(K,e,S,k,A,L,U,O,g,v,R,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let y=class extends f.Disposable{constructor(a,b,C,E){super();this.fileService=a,this.productService=b,this.requestService=C,this.logService=E,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,L.forEach)(this.productService.configBasedExtensionTips,({value:p})=>this.allConfigBasedTips.set(p.configPath,p))}getConfigBasedTips(a){return this.getValidConfigBasedTips(a)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(a){const b=[];for(const[C,E]of this.allConfigBasedTips)try{const p=await this.fileService.readFile((0,v.joinPath)(a,C)),m=new Map;(0,L.forEach)(E.recommendations,({key:s,value:t})=>{if((0,A.isNonEmptyArray)(t.remotes))for(const i of t.remotes)m.set(i,{extensionId:s,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else b.push({extensionId:s,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const c=(0,R.getDomainsOfRemotes)(p.value.toString(),[...m.keys()]);for(const s of c){const t=m.get(s);t&&b.push(t)}}catch(p){}return b}async fetchWorkspacesTips(){var a,b;if(!((a=this.productService.extensionsGallery)===null||a===void 0?void 0:a.recommendationsUrl))return[];try{const C=await this.requestService.request({type:"GET",url:(b=this.productService.extensionsGallery)===null||b===void 0?void 0:b.recommendationsUrl},O.CancellationToken.None);if(C.res.statusCode!==200)return[];const E=await(0,U.asJson)(C);return E?E.workspaceRecommendations||[]:[]}catch(C){return this.logService.error(C),[]}}};y=he([Y(0,k.IFileService),Y(1,S.IProductService),Y(2,U.IRequestService),Y(3,g.ILogService)],y),e.ExtensionTipsService=y}),define(Z[44],ee([0,1,31,22]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function A(L,U,O){let g=O&&O.get("storage.serviceMachineId",0)||null;if(g)return g;try{const R=(await U.readFile(L.serviceMachineIdResource)).value.toString();g=(0,S.isUUID)(R)?R:null}catch(v){g=null}if(!g){g=(0,S.generateUuid)();try{await U.writeFile(L.serviceMachineIdResource,k.VSBuffer.fromString(g))}catch(v){}}return O&&O.store("storage.serviceMachineId",g,0,1),g}e.getServiceMachineId=A}),define(Z[19],ee([0,1,5,3,2,15,67,6]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const g="__$__targetStorageMarker";e.IStorageService=(0,S.createDecorator)("storageService");var v;(function(b){b[b.NONE=0]="NONE",b[b.SHUTDOWN=1]="SHUTDOWN"})(v=e.WillSaveStateReason||(e.WillSaveStateReason={}));var R;(function(b){b[b.GLOBAL=0]="GLOBAL",b[b.WORKSPACE=1]="WORKSPACE"})(R=e.StorageScope||(e.StorageScope={}));var f;(function(b){b[b.USER=0]="USER",b[b.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class y extends A.Disposable{constructor(C={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=C,this._onDidChangeValue=this._register(new k.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new k.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new k.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new O.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new A.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,O.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,A.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(C,E){E===g?(C===0?this._globalKeyTargets=void 0:C===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:C})):this._onDidChangeValue.fire({scope:C,key:E,target:this.getKeyTargets(C)[E]})}emitWillSaveState(C){this._onWillSaveState.fire({reason:C})}get(C,E,p){var m;return(m=this.getStorage(E))===null||m===void 0?void 0:m.get(C,p)}getBoolean(C,E,p){var m;return(m=this.getStorage(E))===null||m===void 0?void 0:m.getBoolean(C,p)}getNumber(C,E,p){var m;return(m=this.getStorage(E))===null||m===void 0?void 0:m.getNumber(C,p)}store(C,E,p,m){if((0,L.isUndefinedOrNull)(E)){this.remove(C,p);return}this.withPausedEmitters(()=>{var c;this.updateKeyTarget(C,p,m),(c=this.getStorage(p))===null||c===void 0||c.set(C,E)})}remove(C,E){this.withPausedEmitters(()=>{var p;this.updateKeyTarget(C,E,void 0),(p=this.getStorage(E))===null||p===void 0||p.delete(C)})}withPausedEmitters(C){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{C()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(C,E){const p=[],m=this.getKeyTargets(C);for(const c of Object.keys(m))m[c]===E&&p.push(c);return p}updateKeyTarget(C,E,p){var m,c;const s=this.getKeyTargets(E);typeof p=="number"?s[C]!==p&&(s[C]=p,(m=this.getStorage(E))===null||m===void 0||m.set(g,JSON.stringify(s))):typeof s[C]=="number"&&(delete s[C],(c=this.getStorage(E))===null||c===void 0||c.set(g,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(C){return C===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(C){const E=this.get(g,C);if(E)try{return JSON.parse(E)}catch(p){}return Object.create(null)}isNew(C){return this.getBoolean(e.IS_NEW_KEY,C)===!0}async flush(){var C,E,p,m;this._onWillSaveState.fire({reason:v.NONE}),await O.Promises.settled([(E=(C=this.getStorage(0))===null||C===void 0?void 0:C.whenFlushed())!==null&&E!==void 0?E:Promise.resolve(),(m=(p=this.getStorage(1))===null||p===void 0?void 0:p.whenFlushed())!==null&&m!==void 0?m:Promise.resolve()])}async logStorage(){var C,E,p,m,c,s;const t=(E=(C=this.getStorage(0))===null||C===void 0?void 0:C.items)!==null&&E!==void 0?E:new Map,i=(m=(p=this.getStorage(1))===null||p===void 0?void 0:p.items)!==null&&m!==void 0?m:new Map;return a(t,i,(c=this.getLogDetails(0))!==null&&c!==void 0?c:"",(s=this.getLogDetails(1))!==null&&s!==void 0?s:"")}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class I extends y{constructor(){super();this.globalStorage=new U.Storage(new U.InMemoryStorageDatabase),this.workspaceStorage=new U.Storage(new U.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(C=>this.emitDidChangeValue(1,C))),this._register(this.globalStorage.onDidChangeStorage(C=>this.emitDidChangeValue(0,C)))}getStorage(C){return C===0?this.globalStorage:this.workspaceStorage}getLogDetails(C){return C===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(C){}}e.InMemoryStorageService=I;async function a(b,C,E,p){const m=r=>{try{return JSON.parse(r)}catch(l){return r}},c=new Map,s=new Map;b.forEach((r,l)=>{c.set(l,r),s.set(l,m(r))});const t=new Map,i=new Map;C.forEach((r,l)=>{t.set(l,r),i.set(l,m(r))}),console.group(`Storage: Global (path: ${E})`);let n=[];c.forEach((r,l)=>{n.push({key:l,value:r})}),console.table(n),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${p})`);let o=[];t.forEach((r,l)=>{o.push({key:l,value:r})}),console.table(o),console.groupEnd(),console.log(i)}e.logStorage=a}),define(Z[165],ee([0,1,3,2,29,33,19,15]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let g=class extends k.Disposable{constructor(f){super();this._onDidChangeEnablement=new S.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new v(f)),this._register(this.storageManger.onDidChange(y=>this._onDidChangeEnablement.fire({extensions:y,source:"storage"})))}async enableExtension(f,y){return this._removeFromDisabledExtensions(f)?(this._onDidChangeEnablement.fire({extensions:[f],source:y}),!0):!1}async disableExtension(f,y){return this._addToDisabledExtensions(f)?(this._onDidChangeEnablement.fire({extensions:[f],source:y}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(f){let y=this.getDisabledExtensions();return y.every(I=>!(0,L.areSameExtensions)(I,f))?(y.push(f),this._setDisabledExtensions(y),!0):!1}_removeFromDisabledExtensions(f){let y=this.getDisabledExtensions();for(let I=0;I<y.length;I++){const a=y[I];if((0,L.areSameExtensions)(a,f))return y.splice(I,1),this._setDisabledExtensions(y),!0}return!1}_setDisabledExtensions(f){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,f)}_getExtensions(f){return this.storageManger.get(f,0)}_setExtensions(f,y){this.storageManger.set(f,y,0)}};g=he([Y(0,U.IStorageService)],g),e.GlobalExtensionEnablementService=g;class v extends k.Disposable{constructor(f){super();this.storageService=f,this.storage=Object.create(null),this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event,this._register(f.onDidChangeValue(y=>this.onDidStorageChange(y)))}get(f,y){let I;return y===0?((0,O.isUndefinedOrNull)(this.storage[f])&&(this.storage[f]=this._get(f,y)),I=this.storage[f]):I=this._get(f,y),JSON.parse(I)}set(f,y,I){let a=JSON.stringify(y.map(({id:C,uuid:E})=>({id:C,uuid:E})));this._get(f,I)!==a&&(I===0&&(y.length?this.storage[f]=a:delete this.storage[f]),this._set(f,y.length?a:void 0,I))}onDidStorageChange(f){if(f.scope===0&&!(0,O.isUndefinedOrNull)(this.storage[f.key])&&this._get(f.key,f.scope)!==this.storage[f.key]){const I=this.get(f.key,f.scope);delete this.storage[f.key];const a=this.get(f.key,f.scope),b=I.filter(E=>!a.some(p=>(0,L.areSameExtensions)(E,p))),C=a.filter(E=>!I.some(p=>(0,L.areSameExtensions)(p,E)));(b.length||C.length)&&this._onDidChange.fire([...b,...C])}}_get(f,y){return this.storageService.get(f,y,"[]")}_set(f,y,I){y?this.storageService.store(f,y,I,1):this.storageService.remove(f,I)}}e.StorageManager=v}),define(Z[166],ee([0,1,3,2]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class A extends k.Disposable{constructor(v,R){super();this.channel=v,this.workspace=R}async getItems(){const v={workspace:this.workspace},R=await this.channel.call("getItems",v);return new Map(R)}updateItems(v){const R={workspace:this.workspace};return v.insert&&(R.insert=Array.from(v.insert.entries())),v.delete&&(R.delete=Array.from(v.delete.values())),this.channel.call("updateItems",R)}}class L extends A{constructor(v){super(v,void 0);this._onDidChangeItemsExternal=this._register(new S.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(v=>this.onDidChangeGlobalStorage(v)))}onDidChangeGlobalStorage(v){(Array.isArray(v.changed)||Array.isArray(v.deleted))&&this._onDidChangeItemsExternal.fire({changed:v.changed?new Map(v.changed):void 0,deleted:v.deleted?new Set(v.deleted):void 0})}async close(){this.dispose()}}class U extends A{constructor(v,R){super(v,R);this.onDidChangeItemsExternal=S.Event.None}async close(){const v={workspace:this.workspace};return this.channel.call("close",v)}}class O extends k.Disposable{constructor(v,R){super();this.channel=v,this.workspace=R,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new L(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new U(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=O}),define(Z[167],ee([0,1,2,19,67,6,156,166,12]),function(K,e,S,k,A,L,U,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class v extends k.AbstractStorageService{constructor(f,y,I){super();this.mainProcessService=y,this.environmentService=I,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new S.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(f)}createGlobalStorage(){const f=new O.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),y=new A.Storage(f.globalStorage);return this._register(y.onDidChangeStorage(I=>this.emitDidChangeValue(0,I))),y}createWorkspaceStorage(f){const y=new O.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),f);if(y.workspaceStorage){const I=new A.Storage(y.workspaceStorage);return this.workspaceStorageDisposable.value=I.onDidChangeStorage(a=>this.emitDidChangeValue(1,a)),this.workspaceStorageId=f==null?void 0:f.id,I}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){var f,y;(0,U.mark)("code/willInitStorage");try{await L.Promises.settled([this.globalStorage.init(),(y=(f=this.workspaceStorage)===null||f===void 0?void 0:f.init())!==null&&y!==void 0?y:Promise.resolve()])}finally{(0,U.mark)("code/didInitStorage")}}getStorage(f){return f===0?this.globalStorage:this.workspaceStorage}getLogDetails(f){return f===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,g.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){var f,y;this.stopFlushWhenIdle(),this.emitWillSaveState(k.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.globalStorage.close(),(y=(f=this.workspaceStorage)===null||f===void 0?void 0:f.close())!==null&&y!==void 0?y:Promise.resolve()])}async migrate(f){var y;const I=this.workspaceStorage,a=(y=I==null?void 0:I.items)!==null&&y!==void 0?y:new Map;I&&(await I.close(),I.dispose()),this.workspaceStorage=this.createWorkspaceStorage(f),await this.workspaceStorage.init();for(const[b,C]of a)this.workspaceStorage.set(b,C)}}e.NativeStorageService=v}),define(Z[168],ee([0,1,7,36,31,4]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;async function U(g,v,R,f,y,I,a,b,C){const E=Object.create(null);E["common.machineId"]=I,E.sessionID=(0,A.generateUuid)()+Date.now(),E.commitHash=f,E.version=y,E["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,S.PlatformToString)(S.platform),E["common.nodePlatform"]=k.platform,E["common.nodeArch"]=R,E["common.product"]=C||"desktop";const p=O(a||[]);p&&(E["common.msftInternal"]=p);let m=0;const c=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>m++,enumerable:!0}}),S.isLinuxSnap&&(E["common.snap"]="true");try{const s=await g.readFile(L.URI.file(b));E["common.source"]=s.value.toString().slice(0,30)}catch(s){}return E}e.resolveCommonProperties=U;function O(g){const v=k.env.USERDNSDOMAIN;if(!v)return!1;const R=v.toLowerCase();return g.some(f=>R===f)}}),define(Z[25],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[169],ee([0,1,38,92,69,27,8,32,95,28,7,4,25,53,16,10,23]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I,a,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function E(t,i){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],o=new Map,r=new Map,l=2e4;function h(u,P,_,z){const B=P.substring(u.length+1);return new Promise(async M=>{var j,W,$;let H;try{H=await(0,C.readdir)(P,{withFileTypes:!0})}catch(T){M();return}if(z.count>=l){z.count+=H.length,z.maxReached=!0,M();return}let q=H.length;if(q===0){M();return}let D=H;z.count+H.length>l&&(z.maxReached=!0,q=l-z.count,D=H.slice(0,q)),z.count+=H.length;for(const T of D)if(T.isDirectory()){if(_.includes(T.name)||await h(u,(0,U.join)(P,T.name),_,z),--q==0){M();return}}else{const F=T.name.lastIndexOf(".");if(F>=0){const N=T.name.substring(F+1);N&&o.set(N,((j=o.get(N))!==null&&j!==void 0?j:0)+1)}for(const N of n)((W=N.relativePathPattern)===null||W===void 0?void 0:W.test(B))!==!1&&N.filePattern.test(T.name)&&r.set(N.tag,(($=r.get(N.tag))!==null&&$!==void 0?$:0)+1);if(--q==0){M();return}}})}const d={count:0,maxReached:!1};await h(t,t,i,d);const w=await c(t);return{configFiles:p(r),fileTypes:p(o),fileCount:d.count,maxFilesReached:d.maxReached,launchConfigFiles:w}}e.collectWorkspaceStats=E;function p(t){return[...I.Iterable.map(t.entries(),([i,n])=>({name:i,count:n}))].sort((i,n)=>n.count-i.count)}function m(){const t={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/b.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/b.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(k.virtualMachineHint.value()*100)}%`},i=S.cpus();return i&&i.length>0&&(t.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),t}e.getMachineInfo=m;function c(t){let i=new Map,n=(0,U.join)(t,".vscode","launch.json");return new Promise((o,r)=>{(0,L.exists)(n,l=>{if(l)(0,L.readFile)(n,(h,d)=>{if(h)return o([]);const w=[],u=(0,O.parse)(d.toString(),w);if(w.length)return console.log(`Unable to parse ${n}`),o([]);if((0,O.getNodeType)(u)==="object"&&u.configurations)for(const P of u.configurations){const _=P.type;_&&(i.has(_)?i.set(_,i.get(_)+1):i.set(_,1))}return o(p(i))});else return o([])})})}e.collectLaunchConfigs=c;let s=class{constructor(i,n){this.telemetryService=i,this.productService=n}formatMachineInfo(i){const n=[];return n.push(`OS Version:       ${i.os}`),n.push(`CPUs:             ${i.cpus}`),n.push(`Memory (System):  ${i.memory}`),n.push(`VM:               ${i.vmHint}`),n.join(`
`)}formatEnvironment(i){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const o=S.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(S.totalmem()/b.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/b.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||n.push(`Load (avg):       ${S.loadavg().map(r=>Math.round(r)).join(", ")}`),n.push(`VM:               ${Math.round(k.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${i.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(i,n){return Promise.all([(0,g.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async o=>{let[r,l]=o,h=this.formatProcessList(i,r);return n.forEach(d=>{if((0,A.isRemoteDiagnosticError)(d))h+=`
${d.errorMessage}`,l+=`
${d.errorMessage}`;else if(h+=`

Remote: ${d.hostName}`,d.processes&&(h+=`
${this.formatProcessList(i,d.processes)}`),d.workspaceMetadata){l+=`
|  Remote: ${d.hostName}`;for(const w of Object.keys(d.workspaceMetadata)){const u=d.workspaceMetadata[w];let P=`${u.fileCount} files`;u.maxFilesReached&&(P=`more than ${P}`),l+=`|    Folder (${w}): ${P}`,l+=this.formatWorkspaceStats(u)}}}),{processInfo:h,workspaceInfo:l}})}async getSystemInfo(i,n){const{memory:o,vmHint:r,os:l,cpus:h}=m(),d={os:l,memory:o,cpus:h,vmHint:r,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:n};return R.isWindows||(d.load=`${S.loadavg().map(w=>Math.round(w)).join(", ")}`),R.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(i,n){const o=[];return(0,g.listProcesses)(i.mainPID).then(async r=>(o.push(""),o.push(this.formatEnvironment(i)),o.push(""),o.push(this.formatProcessList(i,r)),i.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(i))),n.forEach(l=>{if((0,A.isRemoteDiagnosticError)(l))o.push(`
${l.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${l.hostName}`),o.push(this.formatMachineInfo(l.machineInfo)),l.processes&&o.push(this.formatProcessList(i,l.processes)),l.workspaceMetadata)for(const h of Object.keys(l.workspaceMetadata)){const d=l.workspaceMetadata[h];let w=`${d.fileCount} files`;d.maxFilesReached&&(w=`more than ${w}`),o.push(`Folder (${h}): ${w}`),o.push(this.formatWorkspaceStats(d))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(i){const n=[],o=60;let r=0;const l=(u,P)=>{const _=` ${u}(${P})`;r+_.length>o?(n.push(h),h="|                 ",r=h.length):r+=_.length,h+=_};let h="|      File types:";const d=10;let w=i.fileTypes.length>d?d:i.fileTypes.length;for(let u=0;u<w;u++){const P=i.fileTypes[u];l(P.name,P.count)}if(n.push(h),i.configFiles.length>=0&&(h="|      Conf files:",r=0,i.configFiles.forEach(u=>{l(u.name,u.count)}),n.push(h)),i.launchConfigFiles.length>0){let u="|      Launch Configs:";i.launchConfigFiles.forEach(P=>{u+=P.count>1?` ${P.name}(${P.count})`:` ${P.name}`}),n.push(u)}return n.join(`
`)}expandGPUFeatures(i){const n=Math.max(...Object.keys(i).map(o=>o.length));return Object.keys(i).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${i[o]}`).join(`
                  `)}formatWorkspaceMetadata(i){const n=[],o=[];return i.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(n.push(`|  Window (${r.title})`),r.folderURIs.forEach(l=>{const h=f.URI.revive(l);if(h.scheme===a.Schemas.file){const d=h.fsPath;o.push(E(d,["node_modules",".git"]).then(w=>{let u=`${w.fileCount} files`;w.maxFilesReached&&(u=`more than ${u}`),n.push(`|    Folder (${(0,U.basename)(d)}): ${u}`),n.push(this.formatWorkspaceStats(w))}).catch(w=>{n.push(`|      Error: Unable to collect workspace stats for folder ${d} (${w.toString()})`)}))}else n.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(r=>n.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(i,n){const o=new Map;i.windows.forEach(l=>o.set(l.pid,l.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(i.mainPID,o,r,n,0),r.join(`
`)}formatProcessItem(i,n,o,r,l){const h=l===0;let d;h?d=r.pid===i?`${this.productService.applicationName} main`:"remote agent":(d=`${"  ".repeat(l)} ${r.name}`,r.name==="window"&&(d=`${d} (${n.get(r.pid)})`));const w=process.platform==="win32"?r.mem:S.totalmem()*(r.mem/100);o.push(`${r.load.toFixed(0).padStart(5," ")}	${(w/b.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(r.children)&&r.children.forEach(u=>this.formatProcessItem(i,n,o,u,l+1))}async reportWorkspaceStats(i){for(const{uri:n}of i.folders){const o=f.URI.revive(n);if(o.scheme===a.Schemas.file){const r=o.fsPath;try{const l=await E(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),l.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:h.name,count:h.count})}),l.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:h.name,count:h.count})}),l.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:h.name,count:h.count})})}catch(l){}}}}};s=he([Y(0,y.ITelemetryService),Y(1,v.IProductService)],s),e.DiagnosticsService=s}),define(Z[170],ee([0,1,11,29,33,26,25,40,68,9,30,17,10,4,28,19,44,5,12]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I,a,b,C,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var m;(function(D){D[D.None=0]="None",D[D.IncludeVersions=1]="IncludeVersions",D[D.IncludeFiles=2]="IncludeFiles",D[D.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",D[D.IncludeSharedAccounts=8]="IncludeSharedAccounts",D[D.IncludeVersionProperties=16]="IncludeVersionProperties",D[D.ExcludeNonValidated=32]="ExcludeNonValidated",D[D.IncludeInstallationTargets=64]="IncludeInstallationTargets",D[D.IncludeAssetUri=128]="IncludeAssetUri",D[D.IncludeStatistics=256]="IncludeStatistics",D[D.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",D[D.Unpublished=4096]="Unpublished"})(m||(m={}));function c(...D){return String(D.reduce((T,F)=>T|F,0))}var s;(function(D){D[D.Tag=1]="Tag",D[D.ExtensionId=4]="ExtensionId",D[D.Category=5]="Category",D[D.ExtensionName=7]="ExtensionName",D[D.Target=8]="Target",D[D.Featured=9]="Featured",D[D.SearchText=10]="SearchText",D[D.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:m.None,criteria:[],assetTypes:[]};class r{constructor(T=o){this.state=T}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(T,F=this.state.pageSize){return new r(Object.assign(Object.assign({},this.state),{pageNumber:T,pageSize:F}))}withFilter(T,...F){const N=[...this.state.criteria,...F.length?F.map(V=>({filterType:T,value:V})):[{filterType:T}]];return new r(Object.assign(Object.assign({},this.state),{criteria:N}))}withSortBy(T){return new r(Object.assign(Object.assign({},this.state),{sortBy:T}))}withSortOrder(T){return new r(Object.assign(Object.assign({},this.state),{sortOrder:T}))}withFlags(...T){return new r(Object.assign(Object.assign({},this.state),{flags:T.reduce((F,N)=>F|N,0)}))}withAssetTypes(...T){return new r(Object.assign(Object.assign({},this.state),{assetTypes:T}))}get raw(){const{criteria:T,pageNumber:F,pageSize:N,sortBy:V,sortOrder:G,flags:J,assetTypes:Q}=this.state;return{filters:[{criteria:T,pageNumber:F,pageSize:N,sortBy:V,sortOrder:G}],assetTypes:Q,flags:J}}get searchText(){const T=this.state.criteria.filter(F=>F.filterType===s.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(T=>String(T.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function l(D,T){const F=(D||[]).filter(N=>N.statisticName===T)[0];return F?F.value:0}function h(D){const T="Microsoft.VisualStudio.Code.Translation.";return D.files.filter(N=>N.assetType.indexOf(T)===0).reduce((N,V)=>{const G=P(D,V.assetType);return G&&N.push([V.assetType.substring(T.length),G]),N},[])}function d(D){if(D.properties){const T=D.properties.filter(V=>V.key===t.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),N=T.filter(V=>F.test(V.value))[0];return N?{uri:N.value,fallbackUri:N.value}:null}return P(D,t.Repository)}function w(D){return{uri:`${D.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${D.fallbackAssetUri}/${t.VSIX}`}}function u(D){const T=P(D,t.Icon);if(T)return T;const F=k.DefaultIconPath;return{uri:F,fallbackUri:F}}function P(D,T){return D.files.filter(N=>N.assetType===T)[0]?{uri:`${D.assetUri}/${T}`,fallbackUri:`${D.fallbackAssetUri}/${T}`}:null}function _(D,T){const F=D.properties?D.properties.filter(V=>V.key===T):[],N=F.length>0&&F[0].value;return N?N.split(",").map(V=>(0,A.adoptToGalleryExtensionId)(V)):[]}function z(D){const T=D.properties?D.properties.filter(F=>F.key===i.Engine):[];return T.length>0&&T[0].value||""}function B(D){const T=D.properties?D.properties.filter(N=>N.key===i.LocalizedLanguages):[],F=T.length>0&&T[0].value||"";return F?F.split(","):[]}function M(D){return D.indexOf("preview")!==-1}function j(D){const T=D.properties?D.properties.find(F=>F.key===i.WebExtension):void 0;return!!T&&T.value==="true"}function W(D){return D.files.some(T=>T.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,p.joinPath)(I.URI.parse(D.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function $(D,T,F,N,V){const G={manifest:P(T,t.Manifest),readme:P(T,t.Details),changelog:P(T,t.Changelog),license:P(T,t.License),repository:d(T),download:w(T),icon:u(T),coreTranslations:h(T)};return{identifier:{id:(0,A.getGalleryExtensionId)(D.publisher.publisherName,D.extensionName),uuid:D.extensionId},name:D.extensionName,version:T.version,date:T.lastUpdated,displayName:D.displayName,publisherId:D.publisher.publisherId,publisher:D.publisher.publisherName,publisherDisplayName:D.publisher.displayName,description:D.shortDescription||"",installCount:l(D.statistics,"install"),rating:l(D.statistics,"averagerating"),ratingCount:l(D.statistics,"ratingcount"),assetUri:I.URI.parse(T.assetUri),webResource:W(T),assetTypes:T.files.map(({assetType:J})=>J),assets:G,properties:{dependencies:_(T,i.Dependency),extensionPack:_(T,i.ExtensionPack),engine:z(T),localizedLanguages:B(T),webExtension:j(T)},telemetryData:{index:(N.pageNumber-1)*N.pageSize+F,searchText:N.searchText,querySource:V},preview:M(D.flags)}}let H=class{constructor(T,F,N,V,G,J,Q){this.requestService=T,this.logService=F,this.environmentService=N,this.telemetryService=V,this.fileService=G,this.productService=J;const ne=J.extensionsGallery;this.extensionsGalleryUrl=ne&&ne.serviceUrl,this.extensionsControlUrl=ne&&ne.controlUrl,this.commonHeadersPromise=q(J.version,this.environmentService,this.fileService,Q)}api(T=""){return`${this.extensionsGalleryUrl}${T}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(T,F){const N=[];let{total:V,firstPage:G,getPage:J}=await this.query({names:T,pageSize:T.length},F);N.push(...G);for(let Q=1;N.length<V&&(G=await J(Q,F),G.length);Q++)N.push(...G);return N}async getCompatibleExtension(T,F){const N=await this.getCompatibleExtensionByEngine(T,F);return(N==null?void 0:N.properties.webExtension)?N.webResource?N:null:N}async getCompatibleExtensionByEngine(T,F){const N=(0,k.isIExtensionIdentifier)(T)?null:T;if(N&&N.properties.engine&&(0,g.isEngineValid)(N.properties.engine,this.productService.version))return N;const{id:V,uuid:G}=N?N.identifier:T;let J=new r().withFlags(m.IncludeAssetUri,m.IncludeStatistics,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");G?J=J.withFilter(s.ExtensionId,G):J=J.withFilter(s.ExtensionName,V);const{galleryExtensions:Q}=await this.queryGallery(J,R.CancellationToken.None),[ne]=Q;if(!ne||!ne.versions.length)return null;if(F){const ce=ne.versions.filter(ue=>ue.version===F)[0];if(ce){const ue=$(ne,ce,0,J);if(ue.properties.engine&&(0,g.isEngineValid)(ue.properties.engine,this.productService.version))return ue}return null}const ie=await this.getLastValidExtensionVersion(ne,ne.versions);return ie?$(ne,ie,0,J):null}async query(T,F){const N=R.CancellationToken.isCancellationToken(T)?{}:T,V=R.CancellationToken.isCancellationToken(T)?T:F;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let G=N.text||"";const J=(0,L.getOrDefault)(N,ge=>ge.pageSize,50);let Q=new r().withFlags(m.IncludeLatestVersionOnly,m.IncludeAssetUri,m.IncludeStatistics,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,J).withFilter(s.Target,"Microsoft.VisualStudio.Code");G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,Ee,Ie)=>(Q=Q.withFilter(s.Category,Ie||Ee),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,Ee,Ie)=>(Q=Q.withFilter(s.Tag,Ie||Ee),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(Q=Q.withFilter(s.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),Q=Q.withFilter(s.SearchText,G)),Q=Q.withSortBy(0)):N.ids?Q=Q.withFilter(s.ExtensionId,...N.ids):N.names?Q=Q.withFilter(s.ExtensionName,...N.names):Q=Q.withSortBy(4),typeof N.sortBy=="number"&&(Q=Q.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(Q=Q.withSortOrder(N.sortOrder));const{galleryExtensions:ne,total:ie}=await this.queryGallery(Q,V),ce=ne.map((ge,Ee)=>$(ge,ge.versions[0],Ee,Q,N.source)),ue=async(ge,Ee)=>{if(Ee.isCancellationRequested)throw(0,S.canceled)();const Ie=Q.withPage(ge+1),{galleryExtensions:Oe}=await this.queryGallery(Ie,Ee);return Oe.map((Ae,Ue)=>$(Ae,Ae.versions[0],Ue,Ie,N.source))};return{firstPage:ce,total:ie,pageSize:Q.pageSize,getPage:ue}}async queryGallery(T,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,m.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,c(m.Unpublished));const N=await this.commonHeadersPromise,V=JSON.stringify(T.raw),G=Object.assign(Object.assign({},N),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(V.length)}),J=new Date().getTime();let Q,ne,ie=0;try{if(Q=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:V,headers:G},F),Q.res.statusCode&&Q.res.statusCode>=400&&Q.res.statusCode<500)return{galleryExtensions:[],total:ie};const ce=await(0,O.asJson)(Q);if(ce){const ue=ce.results[0],ge=ue.extensions,Ee=ue.resultMetadata&&ue.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return ie=Ee&&Ee.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:ie}}return{galleryExtensions:[],total:ie}}catch(ce){throw ne=ce,ce}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},T.telemetryData),{requestBodySize:String(V.length),duration:new Date().getTime()-J,success:!!Q&&(0,O.isSuccess)(Q),responseBodySize:Q==null?void 0:Q.res.headers["Content-Length"],statusCode:Q?String(Q.res.statusCode):void 0,errorCode:ne?(0,S.isPromiseCanceledError)(ne)?"canceled":(0,S.getErrorMessage)(ne).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ie)}))}}async reportStatistic(T,F,N,V){if(!!this.isEnabled()){const G=await this.commonHeadersPromise,J=Object.assign(Object.assign({},G),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${T}/extensions/${F}/${N}/stats?statType=${V}`),headers:J},R.CancellationToken.None)}catch(Q){}}}async download(T,F,N){this.logService.trace("ExtensionGalleryService#download",T.identifier.id);const V=(0,A.getGalleryExtensionTelemetryData)(T),G=new Date().getTime(),J=ce=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},V),{duration:ce})),Q=N===1?"install":N===2?"update":"",ne=Q?{uri:`${T.assets.download.uri}&${Q}=true`,fallbackUri:`${T.assets.download.fallbackUri}?${Q}=true`}:T.assets.download,ie=await this.getAsset(ne);await this.fileService.writeFile(F,ie.stream),J(new Date().getTime()-G)}async getReadme(T,F){if(T.assets.readme){const N=await this.getAsset(T.assets.readme,{},F);return await(0,O.asText)(N)||""}return""}async getManifest(T,F){if(T.assets.manifest){const N=await this.getAsset(T.assets.manifest,{},F),V=await(0,O.asText)(N);return V?JSON.parse(V):null}return null}async getCoreTranslation(T,F){const N=T.assets.coreTranslations.filter(V=>V[0]===F.toUpperCase())[0];if(N){const V=await this.getAsset(N[1]),G=await(0,O.asText)(V);return G?JSON.parse(G):null}return null}async getChangelog(T,F){if(T.assets.changelog){const N=await this.getAsset(T.assets.changelog,{},F);return await(0,O.asText)(N)||""}return""}async getAllVersions(T,F){let N=new r().withFlags(m.IncludeVersions,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");T.identifier.uuid?N=N.withFilter(s.ExtensionId,T.identifier.uuid):N=N.withFilter(s.ExtensionName,T.identifier.id);const V=[],{galleryExtensions:G}=await this.queryGallery(N,R.CancellationToken.None);return G.length&&(F?await Promise.all(G[0].versions.map(async J=>{let Q;try{Q=await this.getEngine(J)}catch(ne){}Q&&(0,g.isEngineValid)(Q,this.productService.version)&&V.push({version:J.version,date:J.lastUpdated})})):V.push(...G[0].versions.map(J=>({version:J.version,date:J.lastUpdated})))),V}async getAsset(T,F={},N=R.CancellationToken.None){const V=await this.commonHeadersPromise,G={type:"GET"},J=Object.assign(Object.assign({},V),F.headers||{});F=Object.assign(Object.assign(Object.assign({},F),G),{headers:J});const Q=T.uri,ne=T.fallbackUri,ie=Object.assign(Object.assign({},F),{url:Q});try{const ce=await this.requestService.request(ie,N);if(ce.res.statusCode===200)return ce;const ue=await(0,O.asText)(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${ue}`)}catch(ce){if((0,S.isPromiseCanceledError)(ce))throw ce;const ue=(0,S.getErrorMessage)(ce);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Q,message:ue});const ge=Object.assign(Object.assign({},F),{url:ne});return this.requestService.request(ge,N)}}async getLastValidExtensionVersion(T,F){const N=this.getLastValidExtensionVersionFromProperties(T,F);return N||this.getLastValidExtensionVersionRecursively(T,F)}getLastValidExtensionVersionFromProperties(T,F){for(const N of F){const V=z(N);if(!V)return null;if((0,g.isEngineValid)(V,this.productService.version))return N}return null}async getEngine(T){const F=z(T);if(F)return F;const N=P(T,t.Manifest);if(!N)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},G=await this.getAsset(N,{headers:V}),J=await(0,O.asJson)(G);if(J)return J.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(T,F){if(!F.length)return null;const N=F[0],V=await this.getEngine(N);return(0,g.isEngineValid)(V,this.productService.version)?(N.properties=N.properties||[],N.properties.push({key:i.Engine,value:V}),N):this.getLastValidExtensionVersionRecursively(T,F.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const T=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,O.asJson)(T),N=new Map;if(F)for(const V of F.malicious){const G=N.get(V)||{id:{id:V},malicious:!0,slow:!1};G.malicious=!0,N.set(V,G)}return[...N.values()]}};H=he([Y(0,O.IRequestService),Y(1,f.ILogService),Y(2,v.IEnvironmentService),Y(3,U.ITelemetryService),Y(4,y.IFileService),Y(5,a.IProductService),Y(6,(0,E.optional)(b.IStorageService))],H),e.ExtensionGalleryService=H;async function q(D,T,F,N){const V={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D}`},G=await(0,C.getServiceMachineId)(T,F,N);return V["X-Market-User-Id"]=G,V}e.resolveMarketplaceHeaders=q}),define(Z[171],ee([0,1,4,8,28,9,36,10,7,18,29,62,40,17,164,6,25,71,108,19,3,57]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I,a,b,C,E,p,m,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",i="extensionTips/lastPromptedMediumImpExeTime";let n=class extends a.ExtensionTipsService{constructor(r,l,h,d,w,u,P,_,z,B){super(P,_,z,B);this.environmentService=r,this.telemetryService=l,this.extensionManagementService=h,this.storageService=d,this.nativeHostService=w,this.extensionRecommendationNotificationService=u,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,_.exeBasedExtensionTips&&(0,f.forEach)(_.exeBasedExtensionTips,({key:M,value:j})=>{const W=[],$=[],H=[];(0,f.forEach)(j.recommendations,({key:q,value:D})=>{D.important?j.important?W.push({extensionId:q,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):$.push({extensionId:q,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):H.push({extensionId:q,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),W.length&&this.highImportanceExecutableTips.set(M,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:W}),$.length&&this.mediumImportanceExecutableTips.set(M,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:$}),H.length&&this.allOtherExecutableTips.set(M,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:H})}),(0,b.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const r=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...r,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const r=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),h=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(r,h),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,h)}groupImportantTipsByExe(r,l){const h=new Map;r.forEach(_=>h.set(_.extensionId.toLowerCase(),_));const{installed:d,uninstalled:w}=this.groupByInstalled([...h.keys()],l);for(const _ of d){const z=h.get(_);z&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:_,exeName:(0,k.basename)(z.windowsPath)})}for(const _ of w){const z=h.get(_);z&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:_,exeName:(0,k.basename)(z.windowsPath)})}const u=this.getPromptedExecutableTips(),P=new Map;for(const _ of w){const z=h.get(_);if(z&&(!u[z.exeName]||!u[z.exeName].includes(z.extensionId))){let B=P.get(z.exeName);B||(B=[],P.set(z.exeName,B)),B.push(z)}}return P}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size!==0){const[r,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(h=>{switch(h){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(r);break;case"incompatibleWindow":const d=c.Event.once(c.Event.latch(c.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const w=this._register((0,b.disposableTimeout)(()=>{w.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size!==0){const r=this.getLastPromptedMediumExeTime(),l=Date.now()-r,h=7*24*60*60*1e3;if(l<h){const u=this._register((0,b.disposableTimeout)(()=>{u.dispose(),this.promptMediumImportanceExeBasedTip()},h-l));return}const[d,w]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(w).then(u=>{switch(u){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(w[0].exeName,w);const P=this._register((0,b.disposableTimeout)(()=>{P.dispose(),this.promptMediumImportanceExeBasedTip()},h));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const _=c.Event.once(c.Event.latch(c.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const z=this._register((0,b.disposableTimeout)(()=>{z.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}}promptExeRecommendations(r){const l=r.map(({extensionId:d})=>d.toLowerCase()),h=(0,p.localize)(0,null,r[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,h,`@exe:"${r[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let r=this.storageService.getNumber(i,0);return r||(r=Date.now(),this.updateLastPromptedMediumExeTime(r)),r}updateLastPromptedMediumExeTime(r){this.storageService.store(i,r,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(r,l){const h=this.getPromptedExecutableTips();h[r]=l.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(t,JSON.stringify(h),0,0)}groupByInstalled(r,l){const h=[],d=[],w=l.reduce((u,P)=>(u.add(P.identifier.id.toLowerCase()),u),new Set);return r.forEach(u=>{w.has(u.toLowerCase())?h.push(u):d.push(u)}),{installed:h,uninstalled:d}}async getValidExecutableBasedExtensionTips(r){const l=[],h=new Map;for(const d of r.keys()){const w=r.get(d);if(!(!w||!(0,v.isNonEmptyArray)(w.recommendations))){const u=[];g.isWindows?w.windowsPath&&u.push(w.windowsPath.replace("%USERPROFILE%",U.env.USERPROFILE).replace("%ProgramFiles(x86)%",U.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",U.env.ProgramFiles).replace("%APPDATA%",U.env.APPDATA).replace("%WINDIR%",U.env.WINDIR)):(u.push((0,k.join)("/usr/local/bin",d)),u.push((0,k.join)("/usr/bin",d)),u.push((0,k.join)(this.environmentService.userHome.fsPath,d)));for(const P of u){let _=h.get(P);if(_===void 0&&(_=await this.fileService.exists(S.URI.file(P)),h.set(P,_)),_)for(const{extensionId:z,extensionName:B,isExtensionPack:M}of w.recommendations)l.push({extensionId:z,extensionName:B,isExtensionPack:M,exeName:d,exeFriendlyName:w.exeFriendlyName,windowsPath:w.windowsPath})}}}return l}};n=he([Y(0,L.INativeEnvironmentService),Y(1,C.ITelemetryService),Y(2,R.IExtensionManagementService),Y(3,m.IStorageService),Y(4,s.INativeHostService),Y(5,E.IExtensionRecommendationNotificationService),Y(6,O.IFileService),Y(7,A.IProductService),Y(8,y.IRequestService),Y(9,I.ILogService)],n),e.ExtensionTipsService=n}),define(Z[78],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class S{constructor(L){this.appender=L}listen(L,U){throw new Error(`Event not found: ${U}`)}call(L,U,{eventName:O,data:g}){return this.appender.log(O,g),Promise.resolve(null)}}e.TelemetryAppenderChannel=S;class k{constructor(L){this.channel=L}log(L,U){return this.channel.call("log",{eventName:L,data:U}).then(void 0,O=>`Failed to log telemetry: ${console.warn(O)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=k}),define(Z[79],ee([0,1,51,118,21,5,24,39,2,26,35]),function(K,e,S,k,A,L,U,O,g,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{constructor(a,b){this._configurationService=b,this._experimentProperties={},this._disposables=new g.DisposableStore,this._cleanupPatterns=[],this._appender=a.appender,this._commonProperties=a.commonProperties||Promise.resolve({}),this._piiPaths=a.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!a.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let C of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(C),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(C=>{const E=/^[a-f0-9]+$/i.test(C["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!E})}))}setExperimentProperty(a,b){this._experimentProperties[a]=b}setEnabled(a){this._enabled=a}_updateUserOptIn(){var a;const b=(a=this._configurationService)===null||a===void 0?void 0:a.getValue(y);this._userOptIn=b?b.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const a=await this._commonProperties;let b=a.sessionID,C=a["common.instanceId"],E=a["common.machineId"],p=a["common.firstSessionDate"],m=a["common.msftInternal"];return{sessionId:b,instanceId:C,machineId:E,firstSessionDate:p,msftInternal:m}}dispose(){this._disposables.dispose()}publicLog(a,b,C){return this.isOptedIn?this._commonProperties.then(E=>{b=(0,v.mixin)(b,E),b=(0,v.mixin)(b,this._experimentProperties),b=(0,v.cloneAndChange)(b,p=>{if(typeof p=="string")return this._cleanupInfo(p,C)}),this._appender.log(a,b)},E=>{console.error(E)}):Promise.resolve(void 0)}publicLog2(a,b,C){return this.publicLog(a,b,C)}publicLogError(a,b){return this.sendErrorTelemetry?this.publicLog(a,b,!0):Promise.resolve(void 0)}publicLogError2(a,b){return this.publicLogError(a,b)}_cleanupInfo(a,b){let C=a;if(b){const E=[];for(let s of this._cleanupPatterns)for(;;){const t=s.exec(a);if(!t)break;E.push([t.index,s.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(C="";;){const s=m.exec(a);if(!s)break;!p.test(s[0])&&E.every(([t,i])=>s.index<t||s.index>=i)&&(C+=a.substring(c,s.index)+"<REDACTED: user-file-path>",c=m.lastIndex)}c<a.length&&(C+=a.substr(c))}for(let E of this._cleanupPatterns)C=C.replace(E,"");return C}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=he([Y(1,(0,L.optional)(U.IConfigurationService))],f),e.TelemetryService=f;const y="telemetry";R.Registry.as(O.Extensions.Configuration).registerConfiguration({id:y,order:110,type:"object",title:(0,k.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,k.localize)(2,null,S.default.privacyStatementUrl):(0,k.localize)(1,null),default:!0,requireTrust:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Z[58],ee([0,1,24,26,15,6]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(a,b){return Promise.resolve(void 0)}publicLog2(a,b){return this.publicLog(a,b)}publicLogError(a,b){return Promise.resolve(void 0)}publicLogError2(a,b){return this.publicLogError(a,b)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class U{async publicLog(b,C,E){}async publicLogError(b,C,E){}}e.NullEndpointTelemetryService=U;function O(...a){return{log:(b,C)=>a.forEach(E=>E.log(b,C)),flush:()=>L.Promises.settled(a.map(b=>b.flush()))}}e.combinedAppender=O,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(a,b){return b.onDidChangeConfiguration(C=>{C.source!==6&&a.publicLog2("updateConfiguration",{configurationSource:(0,S.ConfigurationTargetToString)(C.source),configurationKeys:y(C.sourceConfig)})})}e.configurationTelemetry=g;function v(a){const b=Object.create(null),C=Object.create(null),E=Object.create(null);f(a,E);for(let p in E){p=p.length>150?p.substr(p.length-149):p;const m=E[p];typeof m=="number"?C[p]=m:typeof m=="boolean"?C[p]=m?1:0:typeof m=="string"?b[p]=m.substring(0,1023):typeof m!="undefined"&&m!==null&&(b[p]=m)}return{properties:b,measurements:C}}e.validateTelemetryData=v;function R(a){if(!a)return"none";let b="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{a.indexOf(`${E}+`)===0&&(b=E)}),b}e.cleanRemoteAuthority=R;function f(a,b,C=0,E){if(!!a)for(let p of Object.getOwnPropertyNames(a)){const m=a[p],c=E?E+p:p;Array.isArray(m)?b[c]=(0,k.safeStringify)(m):m instanceof Date?b[c]=m.toISOString():(0,A.isObject)(m)?C<2?f(m,b,C+1,c+"."):b[c]=(0,k.safeStringify)(m):b[c]=m}}function y(a){if(!a)return[];const b=[];return I(b,"",a),b}function I(a,b,C){C&&typeof C=="object"&&!Array.isArray(C)?Object.keys(C).forEach(E=>I(a,b?`${b}.${E}`:E,C[E])):a.push(b)}}),define(Z[172],ee([0,1,2,9,17,58]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let U=class extends S.Disposable{constructor(g,v){super();this.logger=this._register(g.createLogger(v.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(g,v){this.logger.trace(`telemetry/${g}`,(0,L.validateTelemetryData)(v))}};U=he([Y(0,A.ILoggerService),Y(1,k.IEnvironmentService)],U),e.TelemetryLogAppender=U}),define(Z[173],ee([0,1,11,26,58]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function L(O){const g=await new Promise((R,f)=>{K(["applicationinsights"],R,f)});let v;return g.defaultClient?(v=new g.TelemetryClient(O),v.channel.setUseDiskRetryCaching(!0)):(g.setup(O).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),v=g.defaultClient),O.indexOf("AIF-")===0&&(v.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),v}class U{constructor(g,v,R){this._eventPrefix=g,this._defaultData=v,this._defaultData||(this._defaultData=Object.create(null)),typeof R=="function"?this._aiClient=R():this._aiClient=R,this._asyncAIClient=null}_withAIClient(g){if(!!this._aiClient){if(typeof this._aiClient!="string"){g(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(v=>{g(v)},v=>{(0,S.onUnexpectedError)(v),console.error(v)})}}log(g,v){!this._aiClient||(v=(0,k.mixin)(v,this._defaultData),v=(0,A.validateTelemetryData)(v),this._withAIClient(R=>R.trackEvent({name:this._eventPrefix+"/"+g,properties:v.properties,measurements:v.measurements})))}flush(){return this._aiClient?new Promise(g=>{this._withAIClient(v=>{v.flush({callback:()=>{this._aiClient=void 0,g(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=U}),define(Z[174],ee([0,1,49,78,16,79,24,25]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let g=class{constructor(R,f){this.configurationService=R,this.telemetryService=f,this.customTelemetryServices=new Map}async getCustomTelemetryService(R){if(!this.customTelemetryServices.has(R.id)){const{machineId:f,sessionId:y}=await this.telemetryService.getTelemetryInfo(),I=Object.create(null);I["common.vscodemachineid"]=f,I["common.vscodesessionid"]=y;const a=[R.id,JSON.stringify(I),R.aiKey],C=new S.Client(A.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:a,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),E=new k.TelemetryAppenderClient(C);this.customTelemetryServices.set(R.id,new L.TelemetryService({appender:E,sendErrorTelemetry:R.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(R.id)}async publicLog(R,f,y){await(await this.getCustomTelemetryService(R)).publicLog(f,y)}async publicLogError(R,f,y){await(await this.getCustomTelemetryService(R)).publicLogError(f,y)}};g=he([Y(0,U.IConfigurationService),Y(1,O.ITelemetryService)],g),e.CustomEndpointTelemetryService=g}),define(Z[80],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FlowControlConstants=e.LocalReconnectConstants=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.WindowsShellType=void 0;var k;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Log="log",g.Heartbeat="heartbeat"})(A=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=(0,S.createDecorator)("localTerminalService"),e.IPtyService=(0,S.createDecorator)("ptyService");var L;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(L=e.HeartbeatConstants||(e.HeartbeatConstants={}));var U;(function(g){g[g.ReconnectionGraceTime=6e4]="ReconnectionGraceTime",g[g.ReconnectionShortGraceTime=6e3]="ReconnectionShortGraceTime"})(U=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var O;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(O=e.FlowControlConstants||(e.FlowControlConstants={}))}),define(Z[175],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,S.createDecorator)("localPtyService")}),define(Z[176],ee([0,1,2,17,80,49,16,34,3,75]),function(K,e,S,k,A,L,U,O,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var R;(function(I){I[I.MaxRestarts=5]="MaxRestarts"})(R||(R={}));let f=0,y=class extends S.Disposable{constructor(a){super();this._logService=a,this._restartCount=0,this._isDisposed=!1,this._onPtyHostExit=this._register(new g.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new g.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new g.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new g.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onProcessData=this._register(new g.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessBinary=this._register(new g.Emitter),this.onProcessBinary=this._onProcessBinary.event,this._onProcessExit=this._register(new g.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new g.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new g.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new g.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new g.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new g.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new g.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new g.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._register((0,S.toDisposable)(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const a=new L.Client(U.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:f,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}});this._onPtyHostStart.fire(),O.ProxyChannel.toService(a.getChannel(A.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(a.onDidProcessExit(p=>{this._onPtyHostExit.fire(p.code),this._isDisposed||(this._restartCount<=R.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${p.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${p.code}, giving up`))}));const C=a.getChannel(A.TerminalIpcChannels.Log);this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(C,this._logService.getLevel())}));const E=O.ProxyChannel.toService(a.getChannel(A.TerminalIpcChannels.PtyHost));return this._register(E.onProcessData(p=>this._onProcessData.fire(p))),this._register(E.onProcessBinary(p=>this._onProcessBinary.fire(p))),this._register(E.onProcessExit(p=>this._onProcessExit.fire(p))),this._register(E.onProcessReady(p=>this._onProcessReady.fire(p))),this._register(E.onProcessTitleChanged(p=>this._onProcessTitleChanged.fire(p))),this._register(E.onProcessShellTypeChanged(p=>this._onProcessShellTypeChanged.fire(p))),this._register(E.onProcessOverrideDimensions(p=>this._onProcessOverrideDimensions.fire(p))),this._register(E.onProcessResolvedShellLaunchConfig(p=>this._onProcessResolvedShellLaunchConfig.fire(p))),this._register(E.onProcessReplay(p=>this._onProcessReplay.fire(p))),this._register(E.onProcessOrphanQuestion(p=>this._onProcessOrphanQuestion.fire(p))),[a,E]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,b,C,E,p,m,c,s,t,i){const n=setTimeout(()=>this._handleUnresponsiveCreateProcess(),A.HeartbeatConstants.CreateProcessTimeout),o=await this._proxy.createProcess(a,b,C,E,p,m,c,s,t,i);return clearTimeout(n),f=Math.max(f,o),o}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,b){return this._proxy.shutdown(a,b)}input(a,b){return this._proxy.input(a,b)}processBinary(a,b){return this._proxy.processBinary(a,b)}resize(a,b,C){return this._proxy.resize(a,b,C)}acknowledgeDataEvent(a,b){return this._proxy.acknowledgeDataEvent(a,b)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}getShellEnvironment(){return this._proxy.getShellEnvironment()}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async restartPtyHost(){this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier+A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${A.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}};y=he([Y(0,k.ILogService)],y),e.PtyHostService=y}),define(Z[52],ee([0,1,41]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function k(U,O,g,v){const R=(0,S.setProperty)(U,O,g,v)[0];return R&&(U=U.substring(0,R.offset)+R.content+U.substring(R.offset+R.length)),U}e.edit=k;function A(U,O,g){let v=g;for(;v>=0;){if(U.charAt(v)===O.charAt(O.length-1)&&O.length===1)return v+1;if(v--,O.length===2&&v>=0&&U.charAt(v)===O.charAt(0))return v+2}return 0}e.getLineStartOffset=A;function L(U,O,g){let v=g;for(;v>=0;)if(U.charAt(v)===O.charAt(O.length-1)&&O.length===1||(v++,O.length===2&&v>=0&&U.charAt(v)===O.charAt(1)))return v;return U.length-1}e.getLineEndOffset=L}),define(Z[177],ee([0,1,26,56]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(f,y,I,a,b){var C,E;const p=[],m=[],c=[];if(!y){const z=f.filter(({identifier:B})=>b.every(M=>M.toLowerCase()!==B.id.toLowerCase()));return{added:p,removed:m,updated:c,remote:z.length>0?z:null}}f=f.map(v),y=y.map(v),I=I?I.map(v):null;const s=new Map,t=z=>{z.uuid&&s.set(z.id.toLowerCase(),z.uuid)};f.forEach(({identifier:z})=>t(z)),y.forEach(({identifier:z})=>t(z)),I&&I.forEach(({identifier:z})=>t(z));const i=z=>{const B=z.identifier.uuid||s.get(z.identifier.id.toLowerCase());return B?`uuid:${B}`:`id:${z.identifier.id.toLowerCase()}`},n=(z,B)=>(z.set(i(B),B),z),o=f.reduce(n,new Map),r=y.reduce(n,new Map),l=y.reduce((z,B)=>{const M=i(B);B=(0,S.deepClone)(B);const j=o.get(M);return j&&(j.installed&&(B.installed=!0),B.version||(B.version=j.version)),n(z,B)},new Map),h=I?I.reduce(n,new Map):null,d=a.reduce(n,new Map),w=b.reduce((z,B)=>{const M=s.get(B.toLowerCase());return z.add(M?`uuid:${M}`:`id:${B.toLowerCase()}`)},new Set),u=L(o,r,w);if(u.added.size>0||u.removed.size>0||u.updated.size>0){const z=L(h,o,w),B=L(h,r,w),M=(j,W)=>{const $=o.get(j);if($){const H=r.get(j);return Object.assign(Object.assign({},W?H:$),{version:(H.version&&k.gt(H.version,$.version),$.version),state:U($,H,h==null?void 0:h.get(j))})}};for(const j of B.removed.values()){const W=o.get(j);W&&m.push(W.identifier)}for(const j of B.added.values())if(z.added.has(j)){if(u.updated.has(j)){const W=M(j,!0);W&&(c.push(R(W,j)),l.set(j,W))}}else{const W=r.get(j);W.installed&&p.push(R(W,j))}for(const j of B.updated.values()){const W=M(j,!0);W&&(c.push(R(W,j)),l.set(j,W))}for(const j of z.added.values())B.added.has(j)||l.set(j,o.get(j));for(const j of z.updated.values())if(!B.removed.has(j)&&!B.updated.has(j)){const W=M(j,!1);W&&(((C=l.get(j))===null||C===void 0?void 0:C.installed)&&(W.installed=!0),l.set(j,W))}for(const j of z.removed.values())!d.has(j)&&!B.updated.has(j)&&((E=h==null?void 0:h.get(j))===null||E===void 0?void 0:E.installed)&&l.delete(j)}const P=[],_=L(r,l,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&l.forEach((z,B)=>P.push(R(z,B))),{added:p,removed:m,updated:c,remote:P.length?P:null}}e.merge=A;function L(f,y,I,{checkInstalledProperty:a,checkVersionProperty:b}={checkInstalledProperty:!1,checkVersionProperty:!1}){const C=f?[...f.keys()].filter(s=>!I.has(s)):[],E=[...y.keys()].filter(s=>!I.has(s)),p=E.filter(s=>C.indexOf(s)===-1).reduce((s,t)=>(s.add(t),s),new Set),m=C.filter(s=>E.indexOf(s)===-1).reduce((s,t)=>(s.add(t),s),new Set),c=new Set;for(const s of C)if(!m.has(s)){const t=f.get(s),i=y.get(s);(!i||t.disabled!==i.disabled||!g(t.state,i.state)||b&&t.version!==i.version||a&&t.installed!==i.installed)&&c.add(s)}return{added:p,removed:m,updated:c}}function U(f,y,I){const a=f.state,b=y.state,C=I==null?void 0:I.state;if(!y.version||a&&k.gt(f.version,y.version))return a;if(b&&k.gt(y.version,f.version)||!a)return b;if(!b)return a;const E=(0,S.deepClone)(a),p=C?O(C,b):{added:Object.keys(b).reduce((c,s)=>(c.add(s),c),new Set),removed:new Set,updated:new Set},m=C?O(C,a):{added:Object.keys(a).reduce((c,s)=>(c.add(s),c),new Set),removed:new Set,updated:new Set};for(const c of[...p.added.values(),...p.updated.values()])E[c]=b[c];for(const c of p.removed.values())m.updated.has(c)||delete E[c];return E}function O(f,y){const I=Object.keys(f),a=Object.keys(y),b=a.filter(p=>I.indexOf(p)===-1).reduce((p,m)=>(p.add(m),p),new Set),C=I.filter(p=>a.indexOf(p)===-1).reduce((p,m)=>(p.add(m),p),new Set),E=new Set;for(const p of I)if(!C.has(p)){const m=f[p],c=y[p];(0,S.equals)(m,c)||E.add(p)}return{added:b,removed:C,updated:E}}function g(f={},y={}){const{added:I,removed:a,updated:b}=O(f,y);return I.size===0&&a.size===0&&b.size===0}function v(f){return Object.assign(Object.assign({},f),{disabled:!!f.disabled,installed:!!f.installed})}function R(f,y){const I={identifier:{id:f.identifier.id,uuid:y.startsWith("uuid:")?y.substring("uuid:".length):void 0}};return f.version&&(I.version=f.version),f.disabled&&(I.disabled=!0),f.installed&&(I.installed=!0),f.state&&(I.state=f.state),I}}),define(Z[81],ee([0,1,18,3,2,33,5,28,19]),function(K,e,S,k,A,L,U,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,U.createDecorator)("IExtensionsStorageSyncService");const v=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let R=class Xe extends A.Disposable{constructor(y,I){super();this.storageService=y,this.productService=I,this._onDidChangeExtensionsStorage=this._register(new k.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(a=>this.onDidChangeStorageValue(a)))}static toKey(y){return`extensionKeys/${(0,L.adoptToGalleryExtensionId)(y.id)}@${y.version}`}static fromKey(y){const I=v.exec(y);if(I&&I[1])return{id:I[1],version:I[2]}}initialize(){const y=this.storageService.keys(0,1);for(const I of y){const a=Xe.fromKey(I);a&&this.extensionsWithKeysForSync.add(a.id.toLowerCase())}}onDidChangeStorageValue(y){if(y.scope===0){if(this.extensionsWithKeysForSync.has(y.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const I=Xe.fromKey(y.key);if(I){this.extensionsWithKeysForSync.add(I.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}}setKeysForSync(y,I){this.storageService.store(Xe.toKey(y),JSON.stringify(I),0,1)}getKeysForSync(y){var I;const a=(I=this.productService.extensionSyncedKeys)===null||I===void 0?void 0:I[y.id.toLowerCase()],b=this.storageService.get(Xe.toKey(y),0),C=b?JSON.parse(b):void 0;return C&&a?(0,S.distinct)([...C,...a]):C||a}};R=he([Y(0,g.IStorageService),Y(1,O.IProductService)],R),e.ExtensionsStorageSyncService=R}),define(Z[82],ee([0,1,18,24,5]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,A.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(O){this.configurationService=O}hasToNeverSyncExtension(O){return this.getConfiguredIgnoredExtensions().includes(O.toLowerCase())}hasToAlwaysSyncExtension(O){return this.getConfiguredIgnoredExtensions().includes(`-${O.toLowerCase()}`)}updateIgnoredExtensions(O,g){let v=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return v=v.filter(R=>R!==O&&R!==`-${O}`),g&&v.push(O.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,1)}updateSynchronizedExtensions(O,g){let v=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return v=v.filter(R=>R!==O&&R!==`-${O}`),g&&v.push(`-${O.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,1)}getIgnoredExtensions(O){const g=O.filter(y=>y.isMachineScoped).map(y=>y.identifier.id.toLowerCase()),v=this.getConfiguredIgnoredExtensions().map(y=>y.toLowerCase()),R=[],f=[];if(Array.isArray(v))for(const y of v)y.startsWith("-")?f.push(y.substring(1)):R.push(y);return(0,S.distinct)([...g,...R].filter(y=>f.indexOf(y)===-1))}getConfiguredIgnoredExtensions(){let O=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return O!==void 0||(O=this.configurationService.inspect("sync.ignoredExtensions").userValue,O!==void 0)?O:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(g=>g.toLowerCase())}};L=he([Y(0,k.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(Z[178],ee([0,1,26,32,18,139,52]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function O(c){return(0,k.parse)(c)||[]}e.parseKeybindings=O;async function g(c,s,t,i,n){const o=O(c),r=O(s),l=t?O(t):null,h=[...o,...r,...l||[]].map($=>$.key),d=await n.resolveUserBindings(h);let w=R(o,r,l,d);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const u=y(o),P=y(r),_=l?y(l):null,z=a(u,P,d),B=_?a(_,u,d):{added:[...u.keys()].reduce(($,H)=>($.add(H),$),new Set),removed:new Set,updated:new Set},M=_?a(_,P,d):{added:[...P.keys()].reduce(($,H)=>($.add(H),$),new Set),removed:new Set,updated:new Set},j=v(z,B,M);let W=c;for(const $ of j.removed.values())j.conflicts.has($)||(W=p(W,$,i));for(const $ of j.added.values())if(!j.conflicts.has($)){const H=P.get($);if(H.some(q=>q.command!==`-${$}`&&w.conflicts.has(d[q.key]))){j.conflicts.add($);continue}W=E(W,H,i)}for(const $ of j.updated.values())if(!j.conflicts.has($)){const H=P.get($);if(H.some(q=>q.command!==`-${$}`&&w.conflicts.has(d[q.key]))){j.conflicts.add($);continue}W=m(W,$,H,i)}return{mergeContent:W,hasChanges:!0,hasConflicts:j.conflicts.size>0}}e.merge=g;function v(c,s,t){const i=new Set,n=new Set,o=new Set,r=new Set;for(const l of s.removed.values())t.updated.has(l)&&r.add(l);for(const l of t.removed.values())r.has(l)||(s.updated.has(l)?r.add(l):n.add(l));for(const l of s.added.values())r.has(l)||t.added.has(l)&&c.updated.has(l)&&r.add(l);for(const l of t.added.values())r.has(l)||(s.added.has(l)?c.updated.has(l)&&r.add(l):i.add(l));for(const l of s.updated.values())r.has(l)||t.updated.has(l)&&c.updated.has(l)&&r.add(l);for(const l of t.updated.values())r.has(l)||(s.updated.has(l)?c.updated.has(l)&&r.add(l):o.add(l));return{added:i,removed:n,updated:o,conflicts:r}}function R(c,s,t,i){const n=new Set,o=f(c,i),r=f(s,i),l=t?f(t,i):null,h=I(o,r);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const d=l?I(l,o):{added:[...o.keys()].reduce((B,M)=>(B.add(M),B),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const w=l?I(l,r):{added:[...r.keys()].reduce((B,M)=>(B.add(M),B),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:u,removed:P,updated:_,conflicts:z}=v(h,d,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:u,removed:P,updated:_,conflicts:z}}function f(c,s){const t=new Map;for(const i of c){const n=s[i.key];let o=t.get(n);o||(o=[],t.set(n,o)),o.push(i)}return t}function y(c){const s=new Map;for(const t of c){const i=t.command[0]==="-"?t.command.substring(1):t.command;let n=s.get(i);n||(n=[],s.set(i,n)),n.push(t)}return s}function I(c,s){const t=[...c.keys()],i=[...s.keys()],n=i.filter(l=>t.indexOf(l)===-1).reduce((l,h)=>(l.add(h),l),new Set),o=t.filter(l=>i.indexOf(l)===-1).reduce((l,h)=>(l.add(h),l),new Set),r=new Set;for(const l of t)if(!o.has(l)){const h=c.get(l).map(w=>Object.assign(Object.assign({},w),{key:l})),d=s.get(l).map(w=>Object.assign(Object.assign({},w),{key:l}));(0,A.equals)(h,d,(w,u)=>C(w,u))||r.add(l)}return{added:n,removed:o,updated:r}}function a(c,s,t){const i=[...c.keys()],n=[...s.keys()],o=n.filter(h=>i.indexOf(h)===-1).reduce((h,d)=>(h.add(d),h),new Set),r=i.filter(h=>n.indexOf(h)===-1).reduce((h,d)=>(h.add(d),h),new Set),l=new Set;for(const h of i)if(!r.has(h)){const d=c.get(h).map(u=>Object.assign(Object.assign({},u),{key:t[u.key]})),w=s.get(h).map(u=>Object.assign(Object.assign({},u),{key:t[u.key]}));b(d,w)||l.add(h)}return{added:o,removed:r,updated:l}}function b(c,s){return!(!(0,A.equals)(c.filter(({command:t})=>t[0]!=="-"),s.filter(({command:t})=>t[0]!=="-"),(t,i)=>C(t,i))||!(0,A.equals)(c.filter(({command:t})=>t[0]==="-"),s.filter(({command:t})=>t[0]==="-"),(t,i)=>C(t,i)))}function C(c,s){if(c.command!==s.command||c.key!==s.key)return!1;const t=L.ContextKeyExpr.deserialize(c.when),i=L.ContextKeyExpr.deserialize(s.when);return!(t&&!i||!t&&i||t&&i&&!t.equals(i)||!S.equals(c.args,s.args))}function E(c,s,t){for(const i of s)c=U.edit(c,[-1],i,t);return c}function p(c,s,t){const i=O(c);for(let n=i.length-1;n>=0;n--)(i[n].command===s||i[n].command===`-${s}`)&&(c=U.edit(c,[n],void 0,t));return c}function m(c,s,t,i){const n=O(c),o=n.findIndex(r=>r.command===s||r.command===`-${s}`);for(let r=n.length-1;r>=0;r--)(n[r].command===s||n[r].command===`-${s}`)&&(c=U.edit(c,[r],void 0,i));for(let r=t.length-1;r>=0;r--)c=U.edit(c,[o],t[r],i);return c}}),define(Z[179],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function S(L,U,O){const g={},v={},R=new Set;if(!U)return{local:{added:g,updated:v,removed:[...R.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const f=k(L,U);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{local:{added:g,updated:v,removed:[...R.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const y=k(O,L),I=k(O,U),a={},b={},C=new Set,E=new Set;for(const p of y.removed.values())I.updated.has(p)?g[p]=U[p]:C.add(p);for(const p of I.removed.values())E.has(p)||(y.updated.has(p)?E.add(p):R.add(p));for(const p of y.updated.values())E.has(p)||(I.updated.has(p)?f.updated.has(p)&&E.add(p):b[p]=L[p]);for(const p of I.updated.values())E.has(p)||(y.updated.has(p)?f.updated.has(p)&&E.add(p):L[p]!==void 0&&(v[p]=U[p]));for(const p of y.added.values())E.has(p)||(I.added.has(p)?f.updated.has(p)&&E.add(p):a[p]=L[p]);for(const p of I.added.values())E.has(p)||(y.added.has(p)?f.updated.has(p)&&E.add(p):g[p]=U[p]);return{local:{added:g,removed:[...R.values()],updated:v},remote:{added:a,removed:[...C.values()],updated:b},conflicts:[...E.values()]}}e.merge=S;function k(L,U){const O=L?Object.keys(L):[],g=U?Object.keys(U):[],v=g.filter(y=>O.indexOf(y)===-1).reduce((y,I)=>(y.add(I),y),new Set),R=O.filter(y=>g.indexOf(y)===-1).reduce((y,I)=>(y.add(I),y),new Set),f=new Set;for(const y of O)if(!R.has(y)){const I=L[y],a=U[y];I!==a&&f.add(y)}return{added:v,removed:R,updated:f}}function A(L,U){const{added:O,removed:g,updated:v}=k(L,U);return O.size===0&&g.size===0&&v.size===0}e.areSame=A}),define(Z[20],ee([0,1,5,29,35,39,123,77,12,18,15]),function(K,e,S,k,A,L,U,O,g,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function f(){const r=A.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(r).filter(l=>!!r[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=f;function y(){const r=A.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(r).filter(w=>!!r[w].ignoreSync),h=Object.keys(r).filter(w=>r[w].scope===2||r[w].scope===6),d=f();return(0,v.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...h,...d])}e.getDefaultIgnoredSettings=y;function I(){const r="vscode://schemas/ignoredSettings",l=A.Registry.as(L.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,U.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,U.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,U.localize)(2,null),items:[{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,U.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,U.localize)(4,null),default:[],scope:1,$ref:r,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const h=A.Registry.as(O.Extensions.JSONContribution),d=()=>{const w=f(),u=y().filter(B=>B!==e.CONFIGURATION_SYNC_STORE_KEY),P=Object.keys(L.allSettings.properties).filter(B=>u.indexOf(B)===-1),_=u.filter(B=>w.indexOf(B)===-1),z={items:{type:"string",enum:[...P,..._.map(B=>`-${B}`)]}};h.registerSchema(r,z)};return l.onDidUpdateConfiguration(()=>d())}e.registerConfiguration=I;function a(r){return r&&(0,R.isObject)(r)&&(0,R.isString)(r.id)&&(0,R.isArray)(r.scopes)}e.isAuthenticationProvider=a;var b;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Extensions="extensions",r.GlobalState="globalState"})(b=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"],e.IUserDataSyncStoreManagementService=(0,S.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,S.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,S.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function C(r){const l={};return l[e.HEADER_EXECUTION_ID]=r,l}e.createSyncHeaders=C;var E;(function(r){r.Unauthorized="Unauthorized",r.Conflict="Conflict",r.Gone="Gone",r.PreconditionFailed="PreconditionFailed",r.TooLarge="TooLarge",r.UpgradeRequired="UpgradeRequired",r.PreconditionRequired="PreconditionRequired",r.TooManyRequests="RemoteTooManyRequests",r.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",r.RequestFailed="RequestFailed",r.RequestCanceled="RequestCanceled",r.RequestTimeout="RequestTimeout",r.NoRef="NoRef",r.TurnedOff="TurnedOff",r.SessionExpired="SessionExpired",r.ServiceChanged="ServiceChanged",r.DefaultServiceChanged="DefaultServiceChanged",r.LocalTooManyRequests="LocalTooManyRequests",r.LocalPreconditionFailed="LocalPreconditionFailed",r.LocalInvalidContent="LocalInvalidContent",r.LocalError="LocalError",r.IncompatibleLocalContent="IncompatibleLocalContent",r.IncompatibleRemoteContent="IncompatibleRemoteContent",r.UnresolvedConflicts="UnresolvedConflicts",r.Unknown="Unknown"})(E=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class p extends Error{constructor(l,h,d,w){super(l);this.code=h,this.resource=d,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=p;class m extends p{constructor(l,h,d,w){super(l,d,void 0,w);this.url=h}}e.UserDataSyncStoreError=m;class c extends p{constructor(l,h){super(l,h)}}e.UserDataAutoSyncError=c,function(r){function l(h){if(h instanceof r)return h;const d=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(h.name);if(d&&d[1]){const w=d[2]==="unknown"?void 0:d[2],u=d[3]==="unknown"?void 0:d[3];return new r(h.message,d[1],w,u)}return new r(h.message,E.Unknown)}r.toUserDataSyncError=l}(p=e.UserDataSyncError||(e.UserDataSyncError={}));var s;(function(r){r.Uninitialized="uninitialized",r.Idle="idle",r.Syncing="syncing",r.HasConflicts="hasConflicts"})(s=e.SyncStatus||(e.SyncStatus={}));var t;(function(r){r[r.None=0]="None",r[r.Added=1]="Added",r[r.Modified=2]="Modified",r[r.Deleted=3]="Deleted"})(t=e.Change||(e.Change={}));var i;(function(r){r.Preview="preview",r.Conflict="conflict",r.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(r){return`sync.enable.${r}`}e.getEnablementKey=n,e.IUserDataSyncResourceEnablementService=(0,S.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,S.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,S.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,S.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,S.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,S.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(r,l){if(r.scheme!==e.USER_DATA_SYNC_SCHEME)return r=r.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(h=>(0,g.isEqualOrParent)(r,(0,g.joinPath)(l.userDataSyncHome,h,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(Z[45],ee([0,1,2,10,22,4,20,9,12,6,3,25,32,119,24,15,21,18,44,19,30]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I,a,b,C,E,p,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function s(l){return!!(l&&l.version!==void 0&&typeof l.version=="number"&&l.content!==void 0&&typeof l.content=="string"&&(Object.keys(l).length===2||Object.keys(l).length===3&&l.machineId!==void 0&&typeof l.machineId=="string"))}e.isSyncData=s;function t(l,h,d){return d.joinPath(h.userDataSyncHome,l,`lastSync${l}.json`)}let i=class extends S.Disposable{constructor(h,d,w,u,P,_,z,B,M,j){super();this.resource=h,this.fileService=d,this.environmentService=w,this.userDataSyncStoreService=P,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=z,this.telemetryService=B,this.logService=M,this.configurationService=j,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new v.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new R.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,C.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(w.userDataSyncHome,1024)?g.extUri:g.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(w.userDataSyncHome,h),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,U.PREVIEW_DIR_NAME),this.lastSyncResource=t(h,w,this.extUri),this.currentMachineIdPromise=(0,p.getServiceMachineId)(w,d,u)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const h=await this.syncPreviewPromise;this.syncPreviewPromise=null;const d=await this.performSync(h.remoteUserData,h.lastSyncUserData,!0);this.setStatus(d)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const h=await this.getLastSyncUserData();(h?(await this.doGenerateSyncResourcePreview(h,h,!0,c.CancellationToken.None)).resourcePreviews.some(({remoteChange:w})=>w!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(h){if(this._status!==h){const d=this._status;h==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),d==="hasConflicts"&&h==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=h,this._onDidChangStatus.fire(h)}}async sync(h,d={}){await this._sync(h,!0,d)}async preview(h,d={}){return this._sync(h,!1,d)}async apply(h,d={}){try{this.syncHeaders=Object.assign({},d);const w=await this.doApply(h);return this.setStatus(w),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(h,d,w){try{if(this.syncHeaders=Object.assign({},w),!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let u="idle";try{const P=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(h,P);return u=await this.performSync(_,P,d),u==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):u==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(u)}}finally{this.syncHeaders={}}}async replace(h){const d=await this.resolveContent(h);if(!d)return!1;const w=this.parseSyncData(d);if(!w)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const u=await this.getLastSyncUserData(),P=await this.getLatestRemoteUserData(null,u),_=await this.generateSyncPreview({ref:P.ref,syncData:w},u,c.CancellationToken.None),z=[];for(const B of _){const M=await this.getAcceptResult(B,B.remoteResource,void 0,c.CancellationToken.None),{remoteChange:j}=await this.getAcceptResult(B,B.previewResource,B.remoteContent,c.CancellationToken.None);z.push([B,Object.assign(Object.assign({},M),{remoteChange:j!==0?j:2})])}await this.applyResult(P,u,z,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async getLatestRemoteUserData(h,d){if(d){const w=h&&h.latest?h.latest[this.resource]:void 0;if(d.ref===w||w===void 0&&d.syncData===null)return d}return this.getRemoteUserData(d)}async performSync(h,d,w){if(h.syncData&&h.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new U.UserDataSyncError((0,I.localize)(0,null,this.resource,this.version,h.syncData.version),U.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(h,d,w)}catch(u){if(u instanceof U.UserDataSyncError)switch(u.code){case U.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(h,d,w);case U.UserDataSyncErrorCode.Conflict:case U.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),h=await this.getRemoteUserData(null),d=await this.getLastSyncUserData(),this.performSync(h,d,w)}throw u}}async doSync(h,d,w){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,v.createCancelablePromise)(P=>this.doGenerateSyncResourcePreview(h,d,w,P)));const u=await this.syncPreviewPromise;return this.updateConflicts(u.resourcePreviews),u.resourcePreviews.some(({mergeState:P})=>P==="conflict")?"hasConflicts":w?await this.doApply(!1):"syncing"}catch(u){throw this.syncPreviewPromise=null,u}}async merge(h){return await this.updateSyncResourcePreview(h,async d=>{const w=await this.getMergeResult(d,c.CancellationToken.None);await this.fileService.writeFile(d.previewResource,A.VSBuffer.fromString((w==null?void 0:w.content)||""));const u=w&&!w.hasConflicts?await this.getAcceptResult(d,d.previewResource,void 0,c.CancellationToken.None):void 0;return d.acceptResult=u,d.mergeState=w.hasConflicts?"conflict":u?"accepted":"preview",d.localChange=u?u.localChange:w.localChange,d.remoteChange=u?u.remoteChange:w.remoteChange,d}),this.syncPreviewPromise}async accept(h,d){return await this.updateSyncResourcePreview(h,async w=>{const u=await this.getAcceptResult(w,h,d,c.CancellationToken.None);return w.acceptResult=u,w.mergeState="accepted",w.localChange=u.localChange,w.remoteChange=u.remoteChange,w}),this.syncPreviewPromise}async discard(h){return await this.updateSyncResourcePreview(h,async d=>{const w=await this.getMergeResult(d,c.CancellationToken.None);return await this.fileService.writeFile(d.previewResource,A.VSBuffer.fromString(w.content||"")),d.acceptResult=void 0,d.mergeState="preview",d.localChange=w.localChange,d.remoteChange=w.remoteChange,d}),this.syncPreviewPromise}async updateSyncResourcePreview(h,d){if(!!this.syncPreviewPromise){let w=await this.syncPreviewPromise;const u=w.resourcePreviews.findIndex(({localResource:P,remoteResource:_,previewResource:z})=>this.extUri.isEqual(P,h)||this.extUri.isEqual(_,h)||this.extUri.isEqual(z,h));u!==-1&&(this.syncPreviewPromise=(0,v.createCancelablePromise)(async P=>{const _=[...w.resourcePreviews];return _[u]=await d(_[u]),Object.assign(Object.assign({},w),{resourcePreviews:_})}),w=await this.syncPreviewPromise,this.updateConflicts(w.resourcePreviews),w.resourcePreviews.some(({mergeState:P})=>P==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}}async doApply(h){if(!this.syncPreviewPromise)return"idle";const d=await this.syncPreviewPromise;return d.resourcePreviews.some(({mergeState:w})=>w==="conflict")?"hasConflicts":d.resourcePreviews.some(({mergeState:w})=>w!=="accepted")?"syncing":(await this.applyResult(d.remoteUserData,d.lastSyncUserData,d.resourcePreviews.map(w=>[w,w.acceptResult]),h),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(h){}}updateConflicts(h){const d=h.filter(({mergeState:w})=>w==="conflict");(0,E.equals)(this._conflicts,d,(w,u)=>this.extUri.isEqual(w.previewResource,u.previewResource))||(this._conflicts=d,this._onDidChangeConflicts.fire(d))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:d,ref:w})=>({created:d,uri:this.toRemoteBackupResource(w)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:d,ref:w})=>({created:d,uri:this.toLocalBackupResource(w)}))}toRemoteBackupResource(h){return L.URI.from({scheme:U.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${h}`})}toLocalBackupResource(h){return L.URI.from({scheme:U.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${h}`})}async getMachineId({uri:h}){const d=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(d))){const{content:w}=await this.getUserData(d);if(w){const u=this.parseSyncData(w);return u==null?void 0:u.machineId}}}async resolveContent(h){const d=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(d))){const{content:w}=await this.getUserData(d);return w}return this.extUri.isEqual(h,this.toLocalBackupResource(d))?this.userDataSyncBackupStoreService.resolveContent(this.resource,d):null}async resolvePreviewContent(h){const d=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(d)for(const w of d.resourcePreviews){if(this.extUri.isEqual(w.acceptedResource,h))return w.acceptResult?w.acceptResult.content:null;if(this.extUri.isEqual(w.remoteResource,h))return w.remoteContent;if(this.extUri.isEqual(w.localResource,h))return w.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(h){}}async doGenerateSyncResourcePreview(h,d,w,u){var P;const _=await this.currentMachineIdPromise,z=!!((P=h.syncData)===null||P===void 0?void 0:P.machineId)&&h.syncData.machineId===_,B=d===null&&z&&!this.hasSyncResourceStateVersionChanged?h:d,M=await this.generateSyncPreview(h,B,u),j=[];for(const W of M){const $=W.previewResource.with({scheme:U.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(W.localChange===0&&W.remoteChange===0)j.push(Object.assign(Object.assign({},W),{acceptedResource:$,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"}));else{const H=w?await this.getMergeResult(W,u):void 0;if(u.isCancellationRequested)break;await this.fileService.writeFile(W.previewResource,A.VSBuffer.fromString((H==null?void 0:H.content)||""));const q=H&&!H.hasConflicts?await this.getAcceptResult(W,W.previewResource,void 0,u):void 0;j.push(Object.assign(Object.assign({},W),{acceptResult:q,mergeState:(H==null?void 0:H.hasConflicts)?"conflict":q?"accepted":"preview",localChange:q?q.localChange:H?H.localChange:W.localChange,remoteChange:q?q.remoteChange:H?H.remoteChange:W.remoteChange}))}}return{remoteUserData:h,lastSyncUserData:d,resourcePreviews:j,isLastSyncFromCurrentMachine:z}}async getLastSyncUserData(){try{const h=await this.fileService.readFile(this.lastSyncResource),d=JSON.parse(h.value.toString()),w=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=d.version&&w&&d.version!==w,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${d.version} is not compatible with current sync state version ${w}.`),await this.resetLocal(),null;const u=d;if(u.content===null)return{ref:d.ref,syncData:null};const P=JSON.parse(u.content);if(s(P))return Object.assign(Object.assign({},d),{syncData:P,content:void 0})}catch(h){h instanceof k.FileOperationError&&h.fileOperationResult===1||this.logService.error(h)}return null}async updateLastSyncUserData(h,d={}){if(d.ref||d.content||d.version)throw new Error("Cannot have core properties as additional");const w=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),u=Object.assign({ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null,version:w},d);await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(u)))}async getRemoteUserData(h){const{ref:d,content:w}=await this.getUserData(h);let u=null;return w!==null&&(u=this.parseSyncData(w)),{ref:d,syncData:u}}parseSyncData(h){try{const d=JSON.parse(h);if(s(d))return d}catch(d){this.logService.error(d)}throw new U.UserDataSyncError((0,I.localize)(1,null),U.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(h){if((0,b.isString)(h)){const d=await this.userDataSyncStoreService.resolveContent(this.resource,h);return{ref:h,content:d}}else{const d=h?{ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,d,this.syncHeaders)}}async updateRemoteUserData(h,d){const w=await this.currentMachineIdPromise,u={version:this.version,machineId:w,content:h};return d=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(u),d,this.syncHeaders),{ref:d,syncData:u}}async backupLocal(h){const d={version:this.version,content:h};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(d))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};i=he([Y(1,k.IFileService),Y(2,O.IEnvironmentService),Y(3,m.IStorageService),Y(4,U.IUserDataSyncStoreService),Y(5,U.IUserDataSyncBackupStoreService),Y(6,U.IUserDataSyncResourceEnablementService),Y(7,f.ITelemetryService),Y(8,U.IUserDataSyncLogService),Y(9,a.IConfigurationService)],i),e.AbstractSynchroniser=i;let n=class extends i{constructor(h,d,w,u,P,_,z,B,M,j,W){super(d,w,u,P,_,z,B,M,j,W);this.file=h,this._register(this.fileService.watch(this.extUri.dirname(h))),this._register(this.fileService.onDidFilesChange($=>this.onFileChanges($)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(h){return null}}async updateLocalFileContent(h,d,w){try{d?await this.fileService.writeFile(this.file,A.VSBuffer.fromString(h),w?void 0:d):await this.fileService.createFile(this.file,A.VSBuffer.fromString(h),{overwrite:w})}catch(u){throw u instanceof k.FileOperationError&&u.fileOperationResult===1||u instanceof k.FileOperationError&&u.fileOperationResult===3?new U.UserDataSyncError(u.message,U.UserDataSyncErrorCode.LocalPreconditionFailed):u}}onFileChanges(h){!h.contains(this.file)||this.triggerLocalChange()}};n=he([Y(2,k.IFileService),Y(3,O.IEnvironmentService),Y(4,m.IStorageService),Y(5,U.IUserDataSyncStoreService),Y(6,U.IUserDataSyncBackupStoreService),Y(7,U.IUserDataSyncResourceEnablementService),Y(8,f.ITelemetryService),Y(9,U.IUserDataSyncLogService),Y(10,a.IConfigurationService)],n),e.AbstractFileSynchroniser=n;let o=class extends n{constructor(h,d,w,u,P,_,z,B,M,j,W,$){super(h,d,w,u,P,_,z,B,M,j,$);this.userDataSyncUtilService=W,this._formattingOptions=void 0}hasErrors(h){const d=[];return(0,y.parse)(h,d,{allowEmptyContent:!0,allowTrailingComma:!0}),d.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};o=he([Y(2,k.IFileService),Y(3,O.IEnvironmentService),Y(4,m.IStorageService),Y(5,U.IUserDataSyncStoreService),Y(6,U.IUserDataSyncBackupStoreService),Y(7,U.IUserDataSyncResourceEnablementService),Y(8,f.ITelemetryService),Y(9,U.IUserDataSyncLogService),Y(10,U.IUserDataSyncUtilService),Y(11,a.IConfigurationService)],o),e.AbstractJsonFileSynchroniser=o;let r=class{constructor(h,d,w,u){this.resource=h,this.environmentService=d,this.logService=w,this.fileService=u,this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?g.extUri:g.extUriIgnorePathCase,this.lastSyncResource=t(this.resource,d,g.extUri)}async initialize({ref:h,content:d}){if(!d){this.logService.info("Remote content does not exist.",this.resource);return}const w=this.parseSyncData(d);if(!!w){if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:h,syncData:w})}catch(P){this.logService.error(P)}}}parseSyncData(h){try{const d=JSON.parse(h);if(s(d))return d}catch(d){this.logService.error(d)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(h,d={}){const w=Object.assign({ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null},d);await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(w)))}};r=he([Y(1,O.IEnvironmentService),Y(2,U.IUserDataSyncLogService),Y(3,k.IFileService)],r),e.AbstractInitializer=r}),define(Z[180],ee([0,1,20,3,9,29,33,10,24,177,45,25,4,46,41,21,19,30,82,11,81,6]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I,a,b,C,E,p,m,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function t(l,h){const d=JSON.parse(l.content);if(l.version===1||l.version===2){const w=(await h.getInstalled(0)).filter(u=>u.isBuiltin);for(const u of d)l.version===1&&(u.enabled===!1&&(u.disabled=!0),delete u.enabled),l.version===2&&w.every(P=>!(0,U.areSameExtensions)(P.identifier,u.identifier))&&(u.installed=!0)}return d}function i(l,h,d){const w=d.get((0,U.getExtensionId)(l,h),0)||"{}";return JSON.parse(w)}function n(l,h,d,w){w.store((0,U.getExtensionId)(l,h),JSON.stringify(d),0,1)}let o=class st extends R.AbstractSynchroniser{constructor(h,d,w,u,P,_,z,B,M,j,W,$,H,q){super("extensions",d,h,w,u,P,$,H,M,W);this.storageService=w,this.extensionManagementService=_,this.extensionEnablementService=z,this.ignoredExtensionsManagementService=B,this.extensionGalleryService=j,this.extensionsStorageSyncService=q,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.debounce(k.Event.any(k.Event.filter(this.extensionManagementService.onDidInstallExtension,D=>!!D.gallery),k.Event.filter(this.extensionManagementService.onDidUninstallExtension,D=>!D.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(h,d){const w=h.syncData?await t(h.syncData,this.extensionManagementService):null,u=(d==null?void 0:d.skippedExtensions)||[],P=(d==null?void 0:d.syncData)?await t(d.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(),z=this.getLocalExtensions(_),B=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);w?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{added:M,removed:j,updated:W,remote:$}=(0,v.merge)(z,w,P,u,B),H={added:M,removed:j,updated:W,remote:$,content:this.getPreviewContent(z,M,W,j),localChange:M.length>0||j.length>0||W.length>0?2:0,remoteChange:$!==null?2:0};return[{skippedExtensions:u,localResource:this.localResource,localContent:this.format(z),localExtensions:z,remoteResource:this.remoteResource,remoteContent:w?this.format(w):null,previewResource:this.previewResource,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(h,d,w,u){const P=[...d,...w],_=new Set,z=B=>{_.add(B.id.toLowerCase()),B.uuid&&_.add(B.uuid)};P.forEach(({identifier:B})=>z(B)),u.forEach(z);for(const B of h)_.has(B.identifier.id.toLowerCase())||B.identifier.uuid&&_.has(B.identifier.uuid)||P.push(B);return this.format(P)}async getMergeResult(h,d){return Object.assign(Object.assign({},h.previewResult),{hasConflicts:!1})}async getAcceptResult(h,d,w,u){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(d,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(h){const d=await this.extensionManagementService.getInstalled(),w=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),u=(0,v.merge)(h.localExtensions,null,null,h.skippedExtensions,w),{added:P,removed:_,updated:z,remote:B}=u;return{content:h.localContent,added:P,removed:_,updated:z,remote:B,localChange:P.length>0||_.length>0||z.length>0?2:0,remoteChange:B!==null?2:0}}async acceptRemote(h){const d=await this.extensionManagementService.getInstalled(),w=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),u=h.remoteContent?JSON.parse(h.remoteContent):null;if(u!==null){const P=(0,v.merge)(h.localExtensions,u,h.localExtensions,[],w),{added:_,removed:z,updated:B,remote:M}=P;return{content:h.remoteContent,added:_,removed:z,updated:B,remote:M,localChange:_.length>0||z.length>0||B.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:h.remoteContent,added:[],removed:[],updated:[],remote:null,localChange:0,remoteChange:0}}async applyResult(h,d,w,u){let{skippedExtensions:P,localExtensions:_}=w[0][0],{added:z,removed:B,updated:M,remote:j,localChange:W,remoteChange:$}=w[0][1];if(W===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),W!==0&&(await this.backupLocal(JSON.stringify(_)),P=await this.updateLocalExtensions(z,B,M,P)),j){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const H=JSON.stringify(j);h=await this.updateRemoteUserData(H,u?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions`)}(d==null?void 0:d.ref)!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(h,{skippedExtensions:P}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions`))}async getAssociatedResources({uri:h}){return[{resource:this.extUri.joinPath(h,"extensions.json"),comparableResource:st.EXTENSIONS_DATA_URI}]}async resolveContent(h){if(this.extUri.isEqual(h,st.EXTENSIONS_DATA_URI)){const w=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(w),P=this.getLocalExtensions(w).filter(_=>!u.some(z=>(0,U.areSameExtensions)({id:z},_.identifier)));return this.format(P)}if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h))return this.resolvePreviewContent(h);let d=await super.resolveContent(h);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(h)),d){const w=this.parseSyncData(d);if(w)switch(this.extUri.basename(h)){case"extensions.json":return this.format(this.parseExtensions(w))}}return null}format(h){h.sort((u,P)=>!u.identifier.uuid&&P.identifier.uuid?-1:u.identifier.uuid&&!P.identifier.uuid?1:(0,b.compare)(u.identifier.id,P.identifier.id));const d=JSON.stringify(h),w=(0,I.format)(d,void 0,{});return(0,a.applyEdits)(d,w)}async hasLocalData(){try{const h=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(h).some(w=>w.installed||w.disabled))return!0}catch(h){}return!1}async updateLocalExtensions(h,d,w,u){const P=[],_=[],z=await this.extensionManagementService.getInstalled();if(d.length){const M=z.filter(({identifier:j,isBuiltin:W})=>!W&&d.some($=>(0,U.areSameExtensions)(j,$)));await s.Promises.settled(M.map(async j=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,j.identifier.id),await this.extensionManagementService.uninstall(j,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,j.identifier.id),P.push(j.identifier)}))}(h.length||w.length)&&await s.Promises.settled([...h,...w].map(async M=>{const j=z.find($=>(0,U.areSameExtensions)($.identifier,M.identifier));if(j&&j.isBuiltin){M.state&&j.manifest.version===M.version&&this.updateExtensionState(M.state,j.manifest.publisher,j.manifest.name,j.manifest.version),M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id)),P.push(M.identifier);return}const W=await this.extensionGalleryService.getCompatibleExtension(M.identifier);if(M.state&&(j?j.manifest.version===M.version:!!W)){const $=j?j.manifest.publisher:W.publisher,H=j?j.manifest.name:W.name;this.updateExtensionState(M.state,$,H,j==null?void 0:j.manifest.version)}if(W)try{M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id,W.version),await this.extensionEnablementService.disableExtension(W.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id,W.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id,W.version),await this.extensionEnablementService.enableExtension(W.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id,W.version)),j||(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,M.identifier.id,W.version),await this.extensionManagementService.installFromGallery(W,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,M.identifier.id,W.version),P.push(W.identifier))}catch($){_.push(M),this.logService.error($),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,W.displayName||W.identifier.id)}else _.push(M)}));const B=[];for(const M of u)P.some(j=>(0,U.areSameExtensions)(j,M.identifier))||B.push(M);for(const M of _)B.some(j=>(0,U.areSameExtensions)(j.identifier,M.identifier))||B.push(M);return B}updateExtensionState(h,d,w,u){const P=i(d,w,this.storageService),_=u?this.extensionsStorageSyncService.getKeysForSync({id:(0,U.getGalleryExtensionId)(d,w),version:u}):void 0;_?_.forEach(z=>{P[z]=h[z]}):Object.keys(h).forEach(z=>P[z]=h[z]),n(d,w,P,this.storageService)}parseExtensions(h){return JSON.parse(h.content)}getLocalExtensions(h){const d=this.extensionEnablementService.getDisabledExtensions();return h.map(({identifier:w,isBuiltin:u,manifest:P})=>{const _={identifier:w,version:P.version};d.some(z=>(0,U.areSameExtensions)(z,w))&&(_.disabled=!0),u||(_.installed=!0);try{const z=this.extensionsStorageSyncService.getKeysForSync({id:w.id,version:P.version});if(z){const B=i(P.publisher,P.name,this.storageService);_.state=Object.keys(B).reduce((M,j)=>(z.includes(j)&&(M[j]=B[j]),M),{})}}catch(z){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,m.getErrorMessage)(z))}return _})}};o.EXTENSIONS_DATA_URI=y.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),o=he([Y(0,A.IEnvironmentService),Y(1,O.IFileService),Y(2,C.IStorageService),Y(3,S.IUserDataSyncStoreService),Y(4,S.IUserDataSyncBackupStoreService),Y(5,L.IExtensionManagementService),Y(6,L.IGlobalExtensionEnablementService),Y(7,p.IIgnoredExtensionsManagementService),Y(8,S.IUserDataSyncLogService),Y(9,L.IExtensionGalleryService),Y(10,g.IConfigurationService),Y(11,S.IUserDataSyncResourceEnablementService),Y(12,f.ITelemetryService),Y(13,c.IExtensionsStorageSyncService)],o),e.ExtensionsSynchroniser=o;let r=class extends R.AbstractInitializer{constructor(h,d,w,u,P,_,z,B){super("extensions",z,B,_);this.extensionManagementService=h,this.galleryService=d,this.extensionEnablementService=w,this.storageService=u,this.ignoredExtensionsManagementService=P}async doInitialize(h){const d=h.syncData?await t(h.syncData,this.extensionManagementService):null;if(!d){this.logService.info("Skipping initializing extensions because remote extensions does not exist.");return}await this.initializeRemoteExtensions(d)}async initializeRemoteExtensions(h){const d=[],w=await this.extensionManagementService.getInstalled(),u=new Map,P=[],_={names:[],uuids:[]},z=[];for(const B of h)if(!this.ignoredExtensionsManagementService.hasToNeverSyncExtension(B.identifier.id)){const M=w.find(j=>(0,U.areSameExtensions)(j.identifier,B.identifier));M?(P.push({syncExtension:B,installedExtension:M}),B.disabled&&z.push(B.identifier)):B.installed&&(u.set(B.identifier.id.toLowerCase(),B),B.identifier.uuid?_.uuids.push(B.identifier.uuid):_.names.push(B.identifier.id),B.disabled&&z.push(B.identifier))}for(const{syncExtension:B,installedExtension:M}of P)if(B.state){const j=i(M.manifest.publisher,M.manifest.name,this.storageService);Object.keys(B.state).forEach(W=>j[W]=B.state[W]),n(M.manifest.publisher,M.manifest.name,j,this.storageService)}if(z.length)for(const B of z)this.logService.trace("Disabling extension...",B.id),await this.extensionEnablementService.disableExtension(B),this.logService.info("Disabling extension",B.id);if(_.names.length||_.uuids.length){const B=(await this.galleryService.query({ids:_.uuids,names:_.names,pageSize:_.uuids.length+_.names.length},E.CancellationToken.None)).firstPage;for(const M of B)try{const j=u.get(M.identifier.id.toLowerCase());j.state&&n(M.publisher,M.name,j.state,this.storageService),this.logService.trace("Installing extension...",M.identifier.id);const W=await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1});z.some($=>(0,U.areSameExtensions)($,M.identifier))||d.push(W),this.logService.info("Installed extension.",M.identifier.id)}catch(j){this.logService.error(j)}}return d}};r=he([Y(0,L.IExtensionManagementService),Y(1,L.IExtensionGalleryService),Y(2,L.IGlobalExtensionEnablementService),Y(3,C.IStorageService),Y(4,p.IIgnoredExtensionsManagementService),Y(5,O.IFileService),Y(6,A.IEnvironmentService),Y(7,S.IUserDataSyncLogService)],r),e.ExtensionsInitializer=r}),define(Z[181],ee([0,1,26,20]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(O,g,v,R,f){if(!g)return{remote:Object.keys(O).length>0?O:null,local:{added:{},removed:[],updated:{}}};const y=L(O,g);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const I=v?L(v,g):{added:Object.keys(g).reduce((p,m)=>(p.add(m),p),new Set),removed:new Set,updated:new Set},a=v?L(v,O):{added:Object.keys(O).reduce((p,m)=>(p.add(m),p),new Set),removed:new Set,updated:new Set},b={added:{},removed:[],updated:{}},C=S.deepClone(g),E=!v;for(const p of a.added.values())p!==k.SYNC_SERVICE_URL_TYPE&&E&&I.added.has(p)||(C[p]=O[p]);for(const p of a.updated.values())C[p]=O[p];for(const p of a.removed.values())R.unregistered.includes(p)||delete C[p];for(const p of I.added.values()){const m=g[p];if(R.machine.includes(p)){f.info(`GlobalState: Skipped adding ${p} in local storage because it is declared as machine scoped.`);continue}if(!(v&&a.added.has(p))){const c=O[p];c&&c.value===m.value||p===k.SYNC_SERVICE_URL_TYPE&&E&&a.added.has(p)||(c?b.updated[p]=m:b.added[p]=m)}}for(const p of I.updated.values()){const m=g[p];if(R.machine.includes(p)){f.info(`GlobalState: Skipped updating ${p} in local storage because it is declared as machine scoped.`);continue}if(!(a.updated.has(p)||a.removed.has(p))){const c=O[p];c&&c.value===m.value||(b.updated[p]=m)}}for(const p of I.removed.values()){if(R.machine.includes(p)){f.trace(`GlobalState: Skipped removing ${p} in local storage because it is declared as machine scoped.`);continue}a.updated.has(p)||a.removed.has(p)||b.removed.push(p)}return{local:b,remote:U(C,g)?null:C}}e.merge=A;function L(O,g){const v=Object.keys(O),R=Object.keys(g),f=R.filter(a=>v.indexOf(a)===-1).reduce((a,b)=>(a.add(b),a),new Set),y=v.filter(a=>R.indexOf(a)===-1).reduce((a,b)=>(a.add(b),a),new Set),I=new Set;for(const a of v)if(!y.has(a)){const b=O[a],C=g[a];S.equals(b,C)||I.add(a)}return{added:f,removed:y,updated:I}}function U(O,g){const{added:v,removed:R,updated:f}=L(O,g);return v.size===0&&R.size===0&&f.size===0}}),define(Z[182],ee([0,1,20,22,3,9,10,52,181,32,45,25,24,4,46,41,19,7,44,31,17]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I,a,b,C,E,p,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const s="globalState.argv.",t=["locale"];function i(h){const d=h.storage?Object.keys(h.storage).sort():[],w={};d.forEach(_=>w[_]=h.storage[_]),h.storage=w;const u=JSON.stringify(h),P=(0,a.format)(u,void 0,{});return(0,b.applyEdits)(u,P)}const n=1;let o=class ot extends R.AbstractSynchroniser{constructor(d,w,u,P,_,z,B,M,j){super("globalState",d,_,j,w,u,z,B,P,M);this.storageService=j,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(d.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(A.Event.any(A.Event.filter(d.onDidFilesChange,W=>W.contains(this.environmentService.argvResource)),A.Event.filter(j.onDidChangeValue,W=>W.scope===0&&W.target!==void 0?W.target===0:j.keys(0,0).includes(W.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(d,w,u){const P=d.syncData?JSON.parse(d.syncData.content):null,_=w&&w.syncData?JSON.parse(w.syncData.content):null,z=await this.getLocalGlobalState();P?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const B=this.getStorageKeys(_),{local:M,remote:j}=(0,g.merge)(z.storage,P?P.storage:null,_?_.storage:null,B,this.logService),W={content:null,local:M,remote:j,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:j!==null?2:0};return[{localResource:this.localResource,localContent:i(z),localUserData:z,remoteResource:this.remoteResource,remoteContent:P?i(P):null,previewResource:this.previewResource,previewResult:W,localChange:W.localChange,remoteChange:W.remoteChange,acceptedResource:this.acceptedResource,storageKeys:B}]}async getMergeResult(d,w){return Object.assign(Object.assign({},d.previewResult),{hasConflicts:!1})}async getAcceptResult(d,w,u,P){if(this.extUri.isEqual(w,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(w,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(w,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async acceptLocal(d){return{content:d.localContent,local:{added:{},removed:[],updated:{}},remote:d.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(d){if(d.remoteContent!==null){const w=JSON.parse(d.remoteContent),{local:u,remote:P}=(0,g.merge)(d.localUserData.storage,w.storage,null,d.storageKeys,this.logService);return{content:d.remoteContent,local:u,remote:P,localChange:Object.keys(u.added).length>0||Object.keys(u.updated).length>0||u.removed.length>0?2:0,remoteChange:P!==null?2:0}}else return{content:d.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(d,w,u,P){let{localUserData:_}=u[0][0],{local:z,remote:B,localChange:M,remoteChange:j}=u[0][1];if(M===0&&j===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),M!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(_)),await this.writeLocalGlobalState(z),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),j!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const W=JSON.stringify({storage:B});d=await this.updateRemoteUserData(W,P?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}(w==null?void 0:w.ref)!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,ot.GLOBAL_STATE_DATA_URI)){const u=await this.getLocalGlobalState();return i(u)}if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let w=await super.resolveContent(d);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(d)),w){const u=this.parseSyncData(w);if(u)switch(this.extUri.basename(d)){case"globalState.json":return i(JSON.parse(u.content))}}return null}async hasLocalData(){var d;try{const{storage:w}=await this.getLocalGlobalState();if(Object.keys(w).length>1||((d=w[`${s}.locale`])===null||d===void 0?void 0:d.value)!=="en")return!0}catch(w){}return!1}async getLocalGlobalState(){const d={},w=await this.getLocalArgvContent(),u=(0,v.parse)(w);for(const P of t)u[P]!==void 0&&(d[`${s}${P}`]={version:1,value:u[P]});for(const P of this.storageService.keys(0,0)){const _=this.storageService.get(P,0);_&&(d[P]={version:1,value:_})}return{storage:d}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(d){}return"{}"}async writeLocalGlobalState({added:d,removed:w,updated:u}){const P={},_={},z=(M,j)=>{for(const W of M){if(W.startsWith(s)){P[W.substring(s.length)]=j?j[W].value:void 0;continue}if(j){const $=j[W];$.value!==String(this.storageService.get(W,0))&&(_[W]=$.value)}else this.storageService.get(W,0)!==void 0&&(_[W]=void 0)}};if(z(Object.keys(d),d),z(Object.keys(u),u),z(w),Object.keys(P).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(P),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(_).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const M of Object.keys(_))this.storageService.store(M,_[M],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(_))}}async updateArgv(d){const w=await this.getLocalArgvContent();let u=w;for(const P of Object.keys(d))u=(0,O.edit)(u,[P],d[P],{});w!==u&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(u)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(d){const w=this.storageService.keys(0,0),u=this.storageService.keys(0,1),P=[...w,...u],_=(d==null?void 0:d.storage)?Object.keys(d.storage).filter(z=>!z.startsWith(s)&&!P.includes(z)&&this.storageService.get(z,0)!==void 0):[];if(!E.isWeb){const z=[...S.ALL_SYNC_RESOURCES.map(B=>(0,S.getEnablementKey)(B)),S.SYNC_SERVICE_URL_TYPE];_.push(...z),u.push(...z)}return{user:w,machine:u,unregistered:_}}};o.GLOBAL_STATE_DATA_URI=I.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=he([Y(0,U.IFileService),Y(1,S.IUserDataSyncStoreService),Y(2,S.IUserDataSyncBackupStoreService),Y(3,S.IUserDataSyncLogService),Y(4,L.IEnvironmentService),Y(5,S.IUserDataSyncResourceEnablementService),Y(6,f.ITelemetryService),Y(7,y.IConfigurationService),Y(8,C.IStorageService)],o),e.GlobalStateSynchroniser=o;let r=class extends R.AbstractInitializer{constructor(d,w,u,P){super("globalState",u,P,w);this.storageService=d}async doInitialize(d){const w=d.syncData?JSON.parse(d.syncData.content):null;if(!w){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const u={},P={};for(const _ of Object.keys(w.storage))_.startsWith(s)?u[_.substring(s.length)]=w.storage[_].value:this.storageService.get(_,0)===void 0&&(P[_]=w.storage[_].value);if(Object.keys(u).length){let _="{}";try{_=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(z){}for(const z of Object.keys(u))_=(0,O.edit)(_,[z],u[z],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(_))}if(Object.keys(P).length)for(const _ of Object.keys(P))this.storageService.store(_,P[_],0,0)}};r=he([Y(0,C.IStorageService),Y(1,U.IFileService),Y(2,L.IEnvironmentService),Y(3,S.IUserDataSyncLogService)],r),e.GlobalStateInitializer=r;let l=class{constructor(d,w,u,P,_){this.userDataSyncStoreClient=d,this.storageService=w,this.environmentService=u,this.fileService=P,this.logService=_}getSyncStoreType(d){var w;const u=this.parseGlobalState(d);return(w=u==null?void 0:u.storage[S.SYNC_SERVICE_URL_TYPE])===null||w===void 0?void 0:w.value}async sync(d){const w=(0,S.createSyncHeaders)((0,m.generateUuid)());try{return await this.doSync(d,w)}catch(u){if(u instanceof S.UserDataSyncError)switch(u.code){case S.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(d,w)}throw u}}async doSync(d,w){const u=await this.userDataSyncStoreClient.read("globalState",null,w),P=this.parseGlobalState(u)||{storage:{}};P.storage[S.SYNC_SERVICE_URL_TYPE]={value:d,version:n};const _=await(0,p.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),z={version:n,machineId:_,content:i(P)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(z),u.ref,w)}parseGlobalState({content:d}){if(!d)return null;const w=JSON.parse(d);if((0,R.isSyncData)(w))return w?JSON.parse(w.content):null;throw new Error("Invalid remote data")}};l=he([Y(1,C.IStorageService),Y(2,L.IEnvironmentService),Y(3,U.IFileService),Y(4,c.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(Z[183],ee([0,1,10,20,178,32,120,9,24,7,15,18,45,25,19,22,3]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I,a,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function E(c,s){const t=JSON.parse(c);if(!s)return(0,R.isUndefined)(t.all)?null:t.all;switch(v.OS){case 2:return(0,R.isUndefined)(t.mac)?null:t.mac;case 3:return(0,R.isUndefined)(t.linux)?null:t.linux;case 1:return(0,R.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=E;let p=class extends y.AbstractJsonFileSynchroniser{constructor(s,t,i,n,o,r,l,h,d,w){super(l.keybindingsResource,"keybindings",r,l,h,s,t,o,w,i,d,n);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(C.Event.filter(n.onDidChangeConfiguration,u=>u.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(s,t,i){const n=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null,o=t?this.getKeybindingsContentFromLastSyncUserData(t):null,r=await this.getLocalFileContent(),l=await this.getFormattingOptions();let h=null,d=!1,w=!1,u=!1;if(n){let _=r?r.value.toString():"[]";if(_=_||"[]",this.hasErrors(_))throw new k.UserDataSyncError((0,U.localize)(0,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!o||o!==_||o!==n){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const z=await(0,A.merge)(_,n,o,l,this.userDataSyncUtilService);z.hasChanges&&(h=z.mergeContent,u=z.hasConflicts,d=u||z.mergeContent!==_,w=u||z.mergeContent!==n)}}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),h=r.value.toString(),w=!0);const P={content:h,localChange:d?r?2:1:0,remoteChange:w?2:0,hasConflicts:u};return[{fileContent:r,localResource:this.localResource,localContent:r?r.value.toString():null,localChange:P.localChange,remoteResource:this.remoteResource,remoteContent:n,remoteChange:P.remoteChange,previewResource:this.previewResource,previewResult:P,acceptedResource:this.acceptedResource}]}async getMergeResult(s,t){return s.previewResult}async getAcceptResult(s,t,i,n){if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,i,n){var o;const{fileContent:r}=i[0][0];let{content:l,localChange:h,remoteChange:d}=i[0][1];if(h===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.hasErrors(l)))throw new k.UserDataSyncError((0,U.localize)(1,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(l||"[]",r,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),d!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const w=this.toSyncContent(l||"[]",(o=s.syncData)===null||o===void 0?void 0:o.content);s=await this.updateRemoteUserData(w,n?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(w){}(t==null?void 0:t.ref)!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(s,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=(0,L.parse)(s.value.toString());if((0,f.isNonEmptyArray)(t))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"keybindings.json"),comparableResource:t}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let t=await super.resolveContent(s);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(s)),t){const i=this.parseSyncData(t);if(i)switch(this.extUri.basename(s)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(i.content)}}return null}getKeybindingsContentFromLastSyncUserData(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(s.syncData.content)}getKeybindingsContentFromSyncContent(s){try{return E(s,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(s,t){let i={};try{i=JSON.parse(t||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=s,v.OS){case 2:i.mac=s;break;case 3:i.linux=s;break;case 1:i.windows=s;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){let s=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return s!==void 0||(s=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,s!==void 0)?s:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};p=he([Y(0,k.IUserDataSyncStoreService),Y(1,k.IUserDataSyncBackupStoreService),Y(2,k.IUserDataSyncLogService),Y(3,g.IConfigurationService),Y(4,k.IUserDataSyncResourceEnablementService),Y(5,S.IFileService),Y(6,O.IEnvironmentService),Y(7,a.IStorageService),Y(8,k.IUserDataSyncUtilService),Y(9,I.ITelemetryService)],p),e.KeybindingsSynchroniser=p;let m=class extends y.AbstractInitializer{constructor(s,t,i){super("keybindings",t,i,s)}async doInitialize(s){const t=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,b.VSBuffer.fromString(t)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,L.parse)(s.value.toString());return!(0,f.isNonEmptyArray)(t)}catch(s){return s.fileOperationResult===1}}getKeybindingsContentFromSyncContent(s){try{return E(s,!0)}catch(t){return this.logService.error(t),null}}};m=he([Y(0,S.IFileService),Y(1,O.IEnvironmentService),Y(2,k.IUserDataSyncLogService)],m),e.KeybindingsInitializer=m}),define(Z[184],ee([0,1,26,32,41,46,52,20,18]),function(K,e,S,k,A,L,U,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function v(l,h,d){let w=[];d?w=f(d):w=R(h);const u=[],P=[...(0,O.getDisallowedIgnoredSettings)()];if(Array.isArray(w))for(const _ of w)_.startsWith("-")?P.push(_.substring(1)):u.push(_);return(0,g.distinct)([...l,...u].filter(_=>P.indexOf(_)===-1))}e.getIgnoredSettings=v;function R(l){let h=l.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=l.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:l.getValue("settingsSync.ignoredSettings")||[]}function f(l){const h=(0,k.parse)(l);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function y(l,h,d,w){if(d.length){const u=r(h),P=(0,k.parse)(h),_=(0,k.parse)(l),z=[];for(const B of d){const M=P[B],j=_[B];M===void 0?l=U.edit(l,[B],void 0,w):j!==void 0?l=U.edit(l,[B],M,w):z.push(s(B,u))}z.sort((B,M)=>B.startOffset-M.startOffset),z.forEach(B=>l=E(B.setting.key,h,l,w))}return l}e.updateIgnoredSettings=y;function I(l,h,d,w,u,P){const _=y(l,h,w,P),z=d!==_,B=d!==h;if(!z&&!B)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(z&&!B)return{conflictsSettings:[],localContent:null,remoteContent:_,hasConflicts:!1};if(B&&!z)return{conflictsSettings:[],localContent:y(h,l,w,P),remoteContent:null,hasConflicts:!1};if(d===null&&b(l)){const ie=a(l,h,w)?null:y(h,l,w,P);return{conflictsSettings:[],localContent:ie,remoteContent:null,hasConflicts:!1}}let M=l,j=h;const W=(0,k.parse)(l),$=(0,k.parse)(h),H=d?(0,k.parse)(d):null,q=w.reduce((ie,ce)=>(ie.add(ce),ie),new Set),D=C(W,$,q),T=C(H,W,q),F=C(H,$,q),N=new Map,V=new Set,G=ie=>{V.add(ie);const ce=u.filter(({key:ue})=>ue===ie)[0];ce?(M=U.edit(M,[ie],ce.value,P),j=U.edit(j,[ie],ce.value,P)):N.set(ie,{key:ie,localValue:W[ie],remoteValue:$[ie]})};for(const ie of T.removed.values())F.updated.has(ie)?G(ie):j=U.edit(j,[ie],void 0,P);for(const ie of F.removed.values())V.has(ie)||(T.updated.has(ie)?G(ie):M=U.edit(M,[ie],void 0,P));for(const ie of T.updated.values())V.has(ie)||(F.updated.has(ie)?D.updated.has(ie)&&G(ie):j=U.edit(j,[ie],W[ie],P));for(const ie of F.updated.values())V.has(ie)||(T.updated.has(ie)?D.updated.has(ie)&&G(ie):M=U.edit(M,[ie],$[ie],P));for(const ie of T.added.values())V.has(ie)||(F.added.has(ie)?D.updated.has(ie)&&G(ie):j=E(ie,M,j,P));for(const ie of F.added.values())V.has(ie)||(T.added.has(ie)?D.updated.has(ie)&&G(ie):M=E(ie,j,M,P));const J=N.size>0||!a(M,j,w),Q=J||!a(M,l,[]),ne=J||!a(j,h,[]);return{localContent:Q?M:null,remoteContent:ne?j:null,conflictsSettings:[...N.values()],hasConflicts:J}}e.merge=I;function a(l,h,d){if(l===h)return!0;const w=(0,k.parse)(l),u=(0,k.parse)(h),P=d.reduce((B,M)=>(B.add(M),B),new Set),_=r(l).filter(B=>!(B.setting&&P.has(B.setting.key))),z=r(h).filter(B=>!(B.setting&&P.has(B.setting.key)));if(_.length!==z.length)return!1;for(let B=0;B<_.length;B++){const M=_[B],j=z[B];if(M.setting&&j.setting){if(M.setting.key!==j.setting.key||!S.equals(w[M.setting.key],u[M.setting.key]))return!1}else if(!M.setting&&!j.setting){if(M.value!==j.value)return!1}else return!1}return!0}e.areSame=a;function b(l){return l?r(l).length===0:!0}e.isEmpty=b;function C(l,h,d){const w=l?Object.keys(l).filter(B=>!d.has(B)):[],u=Object.keys(h).filter(B=>!d.has(B)),P=u.filter(B=>w.indexOf(B)===-1).reduce((B,M)=>(B.add(M),B),new Set),_=w.filter(B=>u.indexOf(B)===-1).reduce((B,M)=>(B.add(M),B),new Set),z=new Set;if(l){for(const B of w)if(!_.has(B)){const M=l[B],j=h[B];S.equals(M,j)||z.add(B)}}return{added:P,removed:_,updated:z}}function E(l,h,d,w){const u=(0,k.parse)(h),P=r(h),_=r(d),z=p(l,P,_);return m(d,l,u[l],z,_,w)}e.addSetting=E;function p(l,h,d){const w=h.findIndex(P=>{var _;return((_=P.setting)===null||_===void 0?void 0:_.key)===l}),u=h[w-1];if(u){if(u.setting){const _=s(u.setting.key,d);if(_)return{index:d.indexOf(_),insertAfter:!0}}else{const _=t(w,h);if(_){const z=s(_.setting.key,d);if(z){const B=i(d.indexOf(z),d),M=n(h,_,h[w]);if(B){const j=n(d,z,B),W=o(M,j);return W?{index:d.indexOf(W),insertAfter:!0}:{index:d.indexOf(B),insertAfter:!1}}else{const j=n(d,z,d[d.length-1]),W=o(M,j);return W?{index:d.indexOf(W),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const P=h[w+1];if(P)if(P.setting){const _=s(P.setting.key,d);if(_)return{index:d.indexOf(_),insertAfter:!1}}else{const _=i(w,h);if(_){const z=s(_.setting.key,d);if(z){const B=t(d.indexOf(z),d),M=n(h,h[w],_);if(B){const j=n(d,B,z),W=o(M.reverse(),j.reverse());return W?{index:d.indexOf(W),insertAfter:!1}:{index:d.indexOf(B),insertAfter:!0}}else{const j=n(d,d[0],z),W=o(M.reverse(),j.reverse());return W?{index:d.indexOf(W),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function m(l,h,d,w,u,P){let _;return w.index===-1?_=(0,A.setProperty)(l,[h],d,P):_=c(l,h,d,w,u,P).map(z=>(0,A.withFormatting)(l,z,P)[0]),(0,A.applyEdits)(l,_)}function c(l,h,d,w,u,P){var _;const z=`${JSON.stringify(h)}: ${JSON.stringify(d)}`,B=(0,L.getEOL)(P,l),M=u[w.index];if(w.insertAfter){const j=[];if(M.setting)j.push({offset:M.endOffset,length:0,content:","+z});else{const W=i(w.index,u),$=t(w.index,u),H=(_=$==null?void 0:$.setting)===null||_===void 0?void 0:_.commaOffset;$&&H===void 0&&j.push({offset:$.endOffset,length:0,content:","});const q=H!==void 0&&H>M.endOffset;j.push({offset:q?H+1:M.endOffset,length:0,content:W?B+z+",":B+z})}return j}else{if(M.setting)return[{offset:M.startOffset,length:0,content:z+","}];const j=(u[w.index-1]&&!u[w.index-1].setting?B:"")+z+(i(w.index,u)?",":"")+B;return[{offset:M.startOffset,length:0,content:j}]}}function s(l,h){return h.filter(d=>{var w;return((w=d.setting)===null||w===void 0?void 0:w.key)===l})[0]}function t(l,h){for(let d=l-1;d>=0;d--)if(h[d].setting)return h[d]}function i(l,h){for(let d=l+1;d<h.length;d++)if(h[d].setting)return h[d]}function n(l,h,d){const w=l.indexOf(h),u=l.indexOf(d);return l.filter((P,_)=>w<_&&_<u)}function o(l,h){if(l.length&&h.length){let d=0;for(;d<h.length&&d<l.length;d++)if(l[d].value!==h[d].value)return h[d-1];return h[d-1]}}function r(l){const h=[];let d=-1,w,u;const P={onObjectBegin:_=>{d++},onObjectProperty:(_,z,B)=>{d===0&&(w=z,u=_)},onObjectEnd:(_,z)=>{d--,d===0&&h.push({startOffset:w,endOffset:_+z,value:l.substring(w,_+z),setting:{key:u,commaOffset:void 0}})},onArrayBegin:(_,z)=>{d++},onArrayEnd:(_,z)=>{d--,d===0&&h.push({startOffset:w,endOffset:_+z,value:l.substring(w,_+z),setting:{key:u,commaOffset:void 0}})},onLiteralValue:(_,z,B)=>{d===0&&h.push({startOffset:w,endOffset:z+B,value:l.substring(w,z+B),setting:{key:u,commaOffset:void 0}})},onSeparator:(_,z,B)=>{if(d===0&&_===","){let M=h.length-1;for(;M>=0&&!h[M].setting;M--);const j=h[M];j&&h.splice(M,1,{startOffset:j.startOffset,endOffset:j.endOffset,value:j.value,setting:{key:j.setting.key,commaOffset:z}})}},onComment:(_,z)=>{d===0&&h.push({startOffset:_,endOffset:_+z,value:l.substring(_,_+z)})}};return(0,k.visit)(l,P),h}}),define(Z[185],ee([0,1,10,20,22,121,3,9,24,184,52,45,25,29,19,41]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function C(s){return s&&s.settings&&typeof s.settings=="string"&&Object.keys(s).length===1}function E(s){const t=JSON.parse(s);return C(t)?t:{settings:s}}e.parseSettingsSyncContent=E;let p=class extends f.AbstractJsonFileSynchroniser{constructor(t,i,n,o,r,l,h,d,w,u,P){super(i.settingsResource,"settings",t,i,n,o,r,w,u,l,h,d);this.extensionManagementService=P,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,i,n){const o=await this.getLocalFileContent(),r=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t),h=i?this.getSettingsSyncContent(i):null,d=await this.getIgnoredSettings();let w=null,u=!1,P=!1,_=!1;if(l){let B=o?o.value.toString().trim():"{}";B=B||"{}",this.validateContent(B),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const M=(0,v.merge)(B,l.settings,h?h.settings:null,d,[],r);w=M.localContent||M.remoteContent,u=M.localContent!==null,P=M.remoteContent!==null,_=M.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),w=o.value.toString(),P=!0);const z={content:w,localChange:u?2:0,remoteChange:P?2:0,hasConflicts:_};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async getMergeResult(t,i){const n=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return Object.assign(Object.assign({},t.previewResult),{content:t.previewResult.content?(0,v.updateIgnoredSettings)(t.previewResult.content,"{}",o,n):null})}async getAcceptResult(t,i,n,o){const r=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(i,this.localResource))return{content:t.fileContent?(0,v.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",l,r):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:t.remoteContent!==null?(0,v.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",l,r):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,v.updateIgnoredSettings)(n,t.fileContent?t.fileContent.value.toString():"{}",l,r):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(t,i,n,o){const{fileContent:r}=n[0][0];let{content:l,localChange:h,remoteChange:d}=n[0][1];if(h===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),r&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(r.value.toString()))),await this.updateLocalFileContent(l,r,o),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),d!==0){const w=await this.getFormattingOptions(),u=this.getSettingsSyncContent(t),P=await this.getIgnoredSettings(l);l=(0,v.updateIgnoredSettings)(l,u?u.settings:"{}",P,w),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),o?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(w){}(i==null?void 0:i.ref)!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const i=await this.getFormattingOptions(),n=(0,R.edit)(t.value.toString(),[k.CONFIGURATION_SYNC_STORE_KEY],void 0,i);return!(0,v.isEmpty)(n)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const i=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:i}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let i=await super.resolveContent(t);if(i)return i;if(i=await super.resolveContent(this.extUri.dirname(t)),i){const n=this.parseSyncData(i);if(n){const o=this.parseSettingsSyncContent(n.content);if(o)switch(this.extUri.basename(t)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(t){let i=await super.resolvePreviewContent(t);if(i){const n=await this.getFormattingOptions(),o=await this.getIgnoredSettings();i=(0,v.updateIgnoredSettings)(i,"{}",o,n)}return i}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return E(t)}catch(i){this.logService.error(i)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=U.Event.any(U.Event.filter(this.extensionManagementService.onDidInstallExtension,o=>!!o.gallery),U.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const i=await this._defaultIgnoredSettings;return(0,v.getIgnoredSettings)(i,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new k.UserDataSyncError((0,L.localize)(0,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const i=JSON.parse(t.value.toString());if(!c(i))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const n=this.parseSettingsSyncContent(i.content);if(!n||!n.settings)return;let o=n.settings;const r=await this.getFormattingOptions();for(const l in i)if(["version","content","machineId"].indexOf(l)===-1&&i[l]!==void 0){const h=(0,b.setProperty)(o,[l],i[l],r);h.length&&(o=(0,b.applyEdits)(o,h))}await this.fileService.writeFile(this.file,A.VSBuffer.fromString(o))}catch(t){}}};p=he([Y(0,S.IFileService),Y(1,O.IEnvironmentService),Y(2,a.IStorageService),Y(3,k.IUserDataSyncStoreService),Y(4,k.IUserDataSyncBackupStoreService),Y(5,k.IUserDataSyncLogService),Y(6,k.IUserDataSyncUtilService),Y(7,g.IConfigurationService),Y(8,k.IUserDataSyncResourceEnablementService),Y(9,y.ITelemetryService),Y(10,I.IExtensionManagementService)],p),e.SettingsSynchroniser=p;let m=class extends f.AbstractInitializer{constructor(t,i,n){super("settings",i,n,t)}async doInitialize(t){const i=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!i){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,A.VSBuffer.fromString(i.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,v.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return E(t)}catch(i){this.logService.error(i)}return null}};m=he([Y(0,S.IFileService),Y(1,O.IEnvironmentService),Y(2,k.IUserDataSyncLogService)],m),e.SettingsInitializer=m;function c(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&s.machineId!==void 0&&typeof s.machineId=="string")}}),define(Z[186],ee([0,1,20,9,10,24,45,25,22,179,19,26,3]),function(K,e,S,k,A,L,U,O,g,v,R,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let I=class extends U.AbstractSynchroniser{constructor(C,E,p,m,c,s,t,i,n){super("snippets",E,C,p,m,c,i,n,s,t);this.version=1,this.snippetsFolder=C.snippetsHome,this._register(this.fileService.watch(C.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(y.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(C,E,p){const m=await this.getSnippetsFileContents(),c=this.toSnippetsContents(m),s=C.syncData?this.parseSnippets(C.syncData):null,t=E&&E.syncData?this.parseSnippets(E.syncData):null;s?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,v.merge)(c,s,t);return this.getResourcePreviews(i,m,s||{})}async getMergeResult(C,E){return C.previewResult}async getAcceptResult(C,E,p,m){if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:C.fileContent?C.fileContent.value.toString():null,localChange:0,remoteChange:C.fileContent?C.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:C.remoteContent,localChange:C.remoteContent!==null?C.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder))return p===void 0?{content:C.previewResult.content,localChange:C.previewResult.localChange,remoteChange:C.previewResult.remoteChange}:{content:p,localChange:p===null?C.fileContent!==null?3:0:2,remoteChange:p===null?C.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${E.toString()}`)}async applyResult(C,E,p,m){const c=p.map(([s,t])=>Object.assign(Object.assign({},s),{acceptResult:t}));c.every(({localChange:s,remoteChange:t})=>s===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),c.some(({localChange:s})=>s!==0)&&(await this.updateLocalBackup(c),await this.updateLocalSnippets(c,m)),c.some(({remoteChange:s})=>s!==0)&&(C=await this.updateRemoteSnippets(c,C,m)),(E==null?void 0:E.ref)!==C.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(C),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:s}of c)try{await this.fileService.del(s)}catch(t){}}getResourcePreviews(C,E,p){const m=new Map;for(const c of Object.keys(C.local.added)){const s={content:C.local.added[c],hasConflicts:!1,localChange:1,remoteChange:0};m.set(c,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:p[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(C.local.updated)){const s={content:C.local.updated[c],hasConflicts:!1,localChange:2,remoteChange:0};m.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[c],localContent:E[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:p[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of C.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0};m.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[c],localContent:E[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(C.remote.added)){const s={content:C.remote.added[c],hasConflicts:!1,localChange:0,remoteChange:1};m.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[c],localContent:E[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(C.remote.updated)){const s={content:C.remote.updated[c],hasConflicts:!1,localChange:0,remoteChange:2};m.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[c],localContent:E[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:p[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of C.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};m.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:p[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of C.conflicts){const s={content:E[c]?E[c].value.toString():null,hasConflicts:!0,localChange:E[c]?2:1,remoteChange:p[c]?2:1};m.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[c]||null,localContent:E[c]?E[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:p[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(E))if(!m.has(c)){const s={content:E[c]?E[c].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};m.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[c]||null,localContent:E[c]?E[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:p[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...m.values()]}async getAssociatedResources({uri:C}){let E=await super.resolveContent(C);if(E){const p=this.parseSyncData(E);if(p){const m=this.parseSnippets(p),c=[];for(const s of Object.keys(m)){const t=this.extUri.joinPath(C,s),i=this.extUri.joinPath(this.snippetsFolder,s),n=await this.fileService.exists(i);c.push({resource:t,comparableResource:n?i:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})})}return c}}return[]}async resolveContent(C){if(this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(C);let E=await super.resolveContent(C);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(C)),E){const p=this.parseSyncData(E);if(p)return this.parseSnippets(p)[this.extUri.basename(C)]||null}return null}async hasLocalData(){try{const C=await this.getSnippetsFileContents();if(Object.keys(C).length)return!0}catch(C){}return!1}async updateLocalBackup(C){const E={};for(const p of C)p.fileContent&&(E[this.extUri.basename(p.localResource)]=p.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(E)))}async updateLocalSnippets(C,E){for(const{fileContent:p,acceptResult:m,localResource:c,remoteResource:s,localChange:t}of C)if(t!==0){const i=s?this.extUri.basename(s):this.extUri.basename(c),n=this.extUri.joinPath(this.snippetsFolder,i);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,g.VSBuffer.fromString(m.content),{overwrite:E}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,g.VSBuffer.fromString(m.content),E?void 0:p),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(C,E,p){const m=E.syncData?this.parseSnippets(E.syncData):{},c=(0,f.deepClone)(m);for(const{acceptResult:s,localResource:t,remoteResource:i,remoteChange:n}of C)if(n!==0){const o=t?this.extUri.basename(t):this.extUri.basename(i);n===3?delete c[o]:c[o]=s.content}return(0,v.areSame)(m,c)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),E=await this.updateRemoteUserData(JSON.stringify(c),p?null:E.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),E}parseSnippets(C){return JSON.parse(C.content)}toSnippetsContents(C){const E={};for(const p of Object.keys(C))E[p]=C[p].value.toString();return E}async getSnippetsFileContents(){const C={};let E;try{E=await this.fileService.resolve(this.snippetsFolder)}catch(p){if(p instanceof A.FileOperationError&&p.fileOperationResult===1)return C;throw p}for(const p of E.children||[]){const m=p.resource,c=this.extUri.extname(m);if(c===".json"||c===".code-snippets"){const s=this.extUri.relativePath(this.snippetsFolder,m),t=await this.fileService.readFile(m);C[s]=t}}return C}};I=he([Y(0,k.IEnvironmentService),Y(1,A.IFileService),Y(2,R.IStorageService),Y(3,S.IUserDataSyncStoreService),Y(4,S.IUserDataSyncBackupStoreService),Y(5,S.IUserDataSyncLogService),Y(6,L.IConfigurationService),Y(7,S.IUserDataSyncResourceEnablementService),Y(8,O.ITelemetryService)],I),e.SnippetsSynchroniser=I;let a=class extends U.AbstractInitializer{constructor(C,E,p){super("snippets",E,p,C)}async doInitialize(C){const E=C.syncData?JSON.parse(C.syncData.content):null;if(!E){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const m of Object.keys(E)){const c=E[m];if(c){const s=this.extUri.joinPath(this.environmentService.snippetsHome,m);await this.fileService.createFile(s,g.VSBuffer.fromString(c)),this.logService.info("Created snippet",this.extUri.basename(s))}}await this.updateLastSyncUserData(C)}async isEmpty(){var C;try{return!((C=(await this.fileService.resolve(this.environmentService.snippetsHome)).children)===null||C===void 0?void 0:C.length)}catch(E){return E.fileOperationResult===1}}};a=he([Y(0,A.IFileService),Y(1,k.IEnvironmentService),Y(2,S.IUserDataSyncLogService)],a),e.SnippetsInitializer=a}),define(Z[59],ee([0,1,5,3,2,20]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,S.createDecorator)("IUserDataSyncAccountService");let U=class extends A.Disposable{constructor(g){super();this.userDataSyncStoreService=g,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(g.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(g.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(g){(g&&this._account?g.token!==this._account.token||g.authenticationProviderId!==this._account.authenticationProviderId:g!==this._account)&&(this._account=g,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(g))}};U=he([Y(0,L.IUserDataSyncStoreService)],U),e.UserDataSyncAccountService=U}),define(Z[187],ee([0,1,2,20,12,24,10,9,54,22,6]),function(K,e,S,k,A,L,U,O,g,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let f=class extends S.Disposable{constructor(I,a,b,C){super();this.environmentService=I,this.fileService=a,this.configurationService=b,this.logService=C,k.ALL_SYNC_RESOURCES.forEach(E=>this.cleanUpBackup(E))}async getAllRefs(I){const a=(0,A.joinPath)(this.environmentService.userDataSyncHome,I),b=await this.fileService.resolve(a);return b.children?b.children.filter(E=>E.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(E.name)).sort().reverse().map(E=>({ref:E.name,created:this.getCreationTime(E)})):[]}async resolveContent(I,a){if(!a){const b=await this.getAllRefs(I);b.length&&(a=b[b.length-1].ref)}if(a){const b=(0,A.joinPath)(this.environmentService.userDataSyncHome,I,a);return(await this.fileService.readFile(b)).value.toString()}return null}async backup(I,a){const b=(0,A.joinPath)(this.environmentService.userDataSyncHome,I),C=(0,A.joinPath)(b,`${(0,g.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(C,v.VSBuffer.fromString(a))}catch(E){this.logService.error(E)}try{this.cleanUpBackup(I)}catch(E){}}async cleanUpBackup(I){const a=(0,A.joinPath)(this.environmentService.userDataSyncHome,I);try{try{if(!await this.fileService.exists(a))return}catch(C){return}const b=await this.fileService.resolve(a);if(b.children){const C=b.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),E=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let p=C.filter(c=>Date.now()-this.getCreationTime(c)>E);const m=C.length-p.length;m<10&&(p=p.slice(10-m)),await R.Promises.settled(p.map(async c=>{this.logService.info("Deleting from backup",c.resource.path),await this.fileService.del(c.resource)}))}}catch(b){this.logService.error(b)}}getCreationTime(I){return I.ctime||new Date(parseInt(I.name.substring(0,4)),parseInt(I.name.substring(4,6))-1,parseInt(I.name.substring(6,8)),parseInt(I.name.substring(9,11)),parseInt(I.name.substring(11,13)),parseInt(I.name.substring(13,15))).getTime()}};f=he([Y(0,O.IEnvironmentService),Y(1,U.IFileService),Y(2,L.IConfigurationService),Y(3,k.IUserDataSyncLogService)],f),e.UserDataSyncBackupStoreService=f}),define(Z[188],ee([0,1,4,2]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class A{constructor(y){this.service=y}listen(y,I){switch(I){case"onError":return this.service.onError}throw new Error(`Event not found: ${I}`)}call(y,I,a){switch(I){case"triggerSync":return this.service.triggerSync(a[0],a[1],a[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(a[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=A;class L{constructor(y){this.service=y}listen(y,I){throw new Error(`Event not found: ${I}`)}call(y,I,a){switch(I){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(a[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(S.URI.revive(a[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class U{constructor(y){this.channel=y}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(y){return this.channel.call("resolveUserKeybindings",[y])}async resolveFormattingOptions(y){return this.channel.call("resolveFormattingOptions",[y])}}e.UserDataSyncUtilServiceClient=U;class O{constructor(y){this.service=y}listen(y,I){switch(I){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${I}`)}async call(y,I,a){switch(I){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(a[0],a[1]);case"setEnablement":return this.service.setEnablement(a[0],a[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=O;class g{constructor(y){this.service=y}listen(y,I){switch(I){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${I}`)}call(y,I,a){switch(I){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(a)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=g;class v{constructor(y){this.service=y}listen(y,I){switch(I){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${I}`)}call(y,I,a){switch(I){case"switch":return this.service.switch(a[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=v;class R extends k.Disposable{constructor(y){super();this.channel=y,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(y){return this.channel.call("switch",[y])}async getPreviousUserDataSyncStore(){const y=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(y)}revive(y){return{url:S.URI.revive(y.url),type:y.type,defaultUrl:S.URI.revive(y.defaultUrl),insidersUrl:S.URI.revive(y.insidersUrl),stableUrl:S.URI.revive(y.stableUrl),canSwitch:y.canSwitch,authenticationProviders:y.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=R}),define(Z[189],ee([0,1,17,9]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let A=class extends S.AbstractLogger{constructor(U,O){super();this.logger=this._register(U.createLogger(O.userDataSyncLogResource,{name:"settingssync"}))}trace(U,...O){this.logger.trace(U,...O)}debug(U,...O){this.logger.debug(U,...O)}info(U,...O){this.logger.info(U,...O)}warn(U,...O){this.logger.warn(U,...O)}error(U,...O){this.logger.error(U,...O)}critical(U,...O){this.logger.critical(U,...O)}flush(){this.logger.flush()}};A=he([Y(0,S.ILoggerService),Y(1,k.IEnvironmentService)],A),e.UserDataSyncLogService=A}),define(Z[60],ee([0,1,5,2,44,9,10,19,20,124,28,7,21,3]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const a="sync.currentMachineName";let b=class He extends k.Disposable{constructor(E,p,m,c,s,t){super();this.storageService=m,this.userDataSyncStoreService=c,this.logService=s,this.productService=t,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,A.getServiceMachineId)(E,p,m)}async getMachines(E){const p=await this.currentMachineIdPromise;return(await this.readMachinesData(E)).machines.map(c=>Object.assign(Object.assign({},c),{isCurrent:c.id===p}))}async addCurrentMachine(E){const p=await this.currentMachineIdPromise,m=await this.readMachinesData(E);m.machines.some(({id:c})=>c===p)||(m.machines.push({id:p,name:this.computeCurrentMachineName(m.machines)}),await this.writeMachinesData(m))}async removeCurrentMachine(E){const p=await this.currentMachineIdPromise,m=await this.readMachinesData(E),c=m.machines.filter(({id:s})=>s!==p);c.length!==m.machines.length&&(m.machines=c,await this.writeMachinesData(m))}async renameMachine(E,p,m){const c=await this.currentMachineIdPromise,s=await this.readMachinesData(m),t=s.machines.find(({id:i})=>i===E);t&&(t.name=p,await this.writeMachinesData(s),s.machines.some(({id:i})=>i===c)&&this.storageService.store(a,p,0,1))}async setEnablement(E,p){const m=await this.readMachinesData(),c=m.machines.find(({id:s})=>s===E);c&&(c.disabled=p?void 0:!0,await this.writeMachinesData(m))}computeCurrentMachineName(E){const p=this.storageService.get(a,0);if(p)return p;const m=`${this.productService.nameLong} (${(0,f.PlatformToString)(f.isWeb?0:f.platform)})`,c=new RegExp(`${(0,y.escapeRegExpCharacters)(m)}\\s#(\\d+)`);let s=0;for(const t of E){const i=c.exec(t.name),n=i?parseInt(i[1]):0;s=n>s?n:s}return`${m} #${s+1}`}async readMachinesData(E){this.userData=await this.readUserData(E);const p=this.parse(this.userData);if(p.version!==He.VERSION)throw new Error((0,v.localize)(0,null,this.productService.nameLong));return p}async writeMachinesData(E){var p;const m=JSON.stringify(E),c=await this.userDataSyncStoreService.write(He.RESOURCE,m,((p=this.userData)===null||p===void 0?void 0:p.ref)||null);this.userData={ref:c,content:m},this._onDidChange.fire()}async readUserData(E){if(this.userData){const p=E&&E.latest?E.latest[He.RESOURCE]:void 0;if(this.userData.ref===p)return this.userData;if(p===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(He.RESOURCE,this.userData)}parse(E){if(E.content!==null)try{return JSON.parse(E.content)}catch(p){this.logService.error(p)}return{version:He.VERSION,machines:[]}}};b.VERSION=1,b.RESOURCE="machines",b=he([Y(0,L.IEnvironmentService),Y(1,U.IFileService),Y(2,O.IStorageService),Y(3,g.IUserDataSyncStoreService),Y(4,g.IUserDataSyncLogService),Y(5,R.IProductService)],b),e.UserDataSyncMachinesService=b}),define(Z[83],ee([0,1,6,3,2,20,59,25,11,19,9,60,122,54,4,12,7,28]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I,a,b,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const p="sync.enable",m="sync.disableMachineEventually",c="sync.sessionId",s="sync.storeUrl",t="sync.productQuality";let i=class extends A.Disposable{constructor(l,h,d){super();this.storageService=l,this.environmentService=h,this.userDataSyncStoreManagementService=d,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(l.onDidChangeValue(w=>this.onDidStorageChange(w)))}isEnabled(l){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(p,0,!!l)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(l){l&&!this.canToggleEnablement()||this.storageService.store(p,l,0,1)}onDidStorageChange(l){if(l.scope===0&&p===l.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};i=he([Y(0,v.IStorageService),Y(1,R.IEnvironmentService),Y(2,L.IUserDataSyncStoreManagementService)],i),e.UserDataAutoSyncEnablementService=i;let n=class extends A.Disposable{constructor(l,h,d,w,u,P,_,z,B,M,j){var W;super();this.userDataSyncStoreManagementService=h,this.userDataSyncStoreService=d,this.userDataSyncResourceEnablementService=w,this.userDataSyncService=u,this.logService=P,this.userDataSyncAccountService=_,this.telemetryService=z,this.userDataSyncMachinesService=B,this.storageService=M,this.autoSync=this._register(new A.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=j,this.syncTriggerDelayer=this._register(new S.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=(W=h.userDataSyncStore)===null||W===void 0?void 0:W.url,this.previousProductQuality=this.productQuality,this.productQuality=l.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(h.onDidChangeUserDataSyncStore(()=>{var $,H;(0,b.isEqual)(this.syncUrl,($=h.userDataSyncStore)===null||$===void 0?void 0:$.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=(H=h.userDataSyncStore)===null||H===void 0?void 0:H.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(_.onDidChangeAccount(()=>this.updateAutoSync())),this._register(d.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(u.onDidChangeLocal,($,H)=>$?[...$,H]:[H],1e3)($=>this.triggerSync($,!1,!1))),this._register(k.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const l=this.storageService.get(s,0);return l?a.URI.parse(l):void 0}set syncUrl(l){l?this.storageService.store(s,l.toString(),0,1):this.storageService.remove(s,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(l){l?this.storageService.store(t,l,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:l,message:h}=this.isAutoSyncEnabled();l?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(d=>this.onDidFinishSync(d))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(h&&this.logService.info(h),this.autoSync.clear()):h&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(h))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,I.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(l,h,d){try{this.userDataSyncAccountService.account&&!d&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(c,0),l?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(w){if(h)this.logService.error(w),this.updateEnablement(!1);else throw w}}updateEnablement(l){this.userDataAutoSyncEnablementService.isEnabled()!==l&&(this.telemetryService.publicLog2(p,{enabled:l}),this.userDataAutoSyncEnablementService.setEnablement(l),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(l){if(!l){this.successiveFailures=0;return}const h=L.UserDataSyncError.toUserDataSyncError(l);h instanceof L.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:h.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),h.code===L.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):h.code===L.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):h.code===L.UserDataSyncErrorCode.LocalTooManyRequests||h.code===L.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):h.code===L.UserDataSyncErrorCode.UpgradeRequired||h.code===L.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):h.code===L.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${h.resource} content with newer version than of client. Requires client upgrade.`)):h.code===L.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${h.resource} content with older version than of client. Requires server reset.`)):h.code===L.UserDataSyncErrorCode.ServiceChanged||h.code===L.UserDataSyncErrorCode.DefaultServiceChanged?C.isWeb&&h.code===L.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(h),this.successiveFailures++),this._onError.fire(h)}async disableMachineEventually(){this.storageService.store(m,!0,0,1),await(0,S.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(m,0,!1)}stopDisableMachineEventually(){this.storageService.remove(m,0)}async triggerSync(l,h,d){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(h&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...l),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",d)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};n=he([Y(0,E.IProductService),Y(1,L.IUserDataSyncStoreManagementService),Y(2,L.IUserDataSyncStoreService),Y(3,L.IUserDataSyncResourceEnablementService),Y(4,L.IUserDataSyncService),Y(5,L.IUserDataSyncLogService),Y(6,U.IUserDataSyncAccountService),Y(7,O.ITelemetryService),Y(8,f.IUserDataSyncMachinesService),Y(9,v.IStorageService),Y(10,L.IUserDataAutoSyncEnablementService)],n),e.UserDataAutoSyncService=n;class o extends A.Disposable{constructor(l,h,d,w,u,P,_,z){super();this.lastSyncUrl=l,this.interval=h,this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=w,this.userDataSyncService=u,this.userDataSyncMachinesService=P,this.logService=_,this.storageService=z,this.intervalHandler=this._register(new A.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,A.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,S.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(l,h){const d=(0,S.createCancelablePromise)(async w=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(u){if((0,g.isPromiseCanceledError)(u))return}return this.doSync(l,h,w)});return this.syncPromise=d,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){var l;return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,(l=this.userDataSyncStoreManagementService.userDataSyncStore)===null||l===void 0?void 0:l.url)}async hasDefaultServiceChanged(){const l=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),h=this.userDataSyncStoreManagementService.userDataSyncStore;return!!h&&!!l&&(!(0,b.isEqual)(h.defaultUrl,l.defaultUrl)||!(0,b.isEqual)(h.insidersUrl,l.insidersUrl)||!(0,b.isEqual)(h.stableUrl,l.stableUrl))}async doSync(l,h,d){this.logService.info(`Auto Sync: Triggered by ${l}`),this._onDidStartSync.fire();let w;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(h),d.isCancellationRequested)return;let u=this.syncTask.manifest;if(u===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new L.UserDataAutoSyncError((0,y.localize)(0,null),L.UserDataSyncErrorCode.DefaultServiceChanged):new L.UserDataAutoSyncError((0,y.localize)(1,null),L.UserDataSyncErrorCode.ServiceChanged):new L.UserDataAutoSyncError((0,y.localize)(2,null),L.UserDataSyncErrorCode.TurnedOff);const P=this.storageService.get(c,0);if(P&&u&&P!==u.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new L.UserDataAutoSyncError((0,y.localize)(3,null),L.UserDataSyncErrorCode.DefaultServiceChanged):new L.UserDataAutoSyncError((0,y.localize)(4,null),L.UserDataSyncErrorCode.ServiceChanged):new L.UserDataAutoSyncError((0,y.localize)(5,null),L.UserDataSyncErrorCode.SessionExpired);const _=await this.userDataSyncMachinesService.getMachines(u||void 0);if(d.isCancellationRequested)return;const z=_.find(B=>B.isCurrent);if(z==null?void 0:z.disabled)throw new L.UserDataAutoSyncError((0,y.localize)(6,null),L.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),u===null&&(u=await this.userDataSyncStoreService.manifest()),u&&u.session!==P&&this.storageService.store(c,u.session,0,1),d.isCancellationRequested)return;z||await this.userDataSyncMachinesService.addCurrentMachine(u||void 0)}catch(u){this.logService.error(u),w=u}this._onDidFinishSync.fire(w)}register(l){return super._register(l)}}o.INTERVAL_SYNCING="Interval"}),define(Z[190],ee([0,1,20,2,3,19,25,7]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let g=class extends k.Disposable{constructor(R,f){super();this.storageService=R,this.telemetryService=f,this._onDidChangeResourceEnablement=new A.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(R.onDidChangeValue(y=>this.onDidStorageChange(y)))}isResourceEnabled(R){return this.storageService.getBoolean((0,S.getEnablementKey)(R),0,!0)}setResourceEnablement(R,f){if(this.isResourceEnabled(R)!==f){const y=(0,S.getEnablementKey)(R);this.telemetryService.publicLog2(y,{enabled:f}),this.storeResourceEnablement(y,f)}}getResourceSyncStateVersion(R){}storeResourceEnablement(R,f){this.storageService.store(R,f,0,O.isWeb?0:1)}onDidStorageChange(R){if(R.scope===0){const f=S.ALL_SYNC_RESOURCES.filter(y=>(0,S.getEnablementKey)(y)===R.key)[0];if(f){this._onDidChangeResourceEnablement.fire([f,this.isResourceEnabled(f)]);return}}}};g=he([Y(0,L.IStorageService),Y(1,U.ITelemetryService)],g),e.UserDataSyncResourceEnablementService=g}),define(Z[191],ee([0,1,20,2,5,3,180,183,182,43,25,18,19,185,12,186,31,6,11]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I,a,b,C,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const m="sync.lastSyncTime";let c=class extends k.Disposable{constructor(n,o,r,l,h,d){super();this.userDataSyncStoreService=n,this.userDataSyncStoreManagementService=o,this.instantiationService=r,this.logService=l,this.telemetryService=h,this.storageService=d,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(I.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(O.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(b.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(g.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(U.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(L.Event.any(...this.synchronisers.map(w=>L.Event.map(w.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(L.Event.any(...this.synchronisers.map(w=>L.Event.map(w.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(m,0,void 0),this.onDidChangeLocal=L.Event.any(...this.synchronisers.map(w=>L.Event.map(w.onDidChangeLocal,()=>w.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(n){await this.checkEnablement();const o=(0,C.generateUuid)();let r;try{const w=(0,S.createSyncHeaders)(o);n&&(w["Cache-Control"]="no-cache"),r=await this.userDataSyncStoreService.manifest(w)}catch(w){const u=S.UserDataSyncError.toUserDataSyncError(w);throw this.reportUserDataSyncError(u,o),u}let l=!1;const h=this;let d;return{manifest:r,run(){if(l)throw new Error("Can run a task only once");return d=(0,E.createCancelablePromise)(w=>h.sync(r,o,w)),d.finally(()=>d=void 0)},async stop(){if(d&&d.cancel(),h.status!=="idle")return h.stop()}}}async createManualSyncTask(){await this.checkEnablement();const n=(0,C.generateUuid)(),o=(0,S.createSyncHeaders)(n);let r;try{r=await this.userDataSyncStoreService.manifest(o)}catch(l){const h=S.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(h,n),h}return new s(n,r,o,this.synchronisers,this.logService)}async sync(n,o,r){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),!r.isCancellationRequested){const l=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const h=(0,S.createSyncHeaders)(o);for(const d of this.synchronisers){if(r.isCancellationRequested)return;try{await d.sync(n,h)}catch(w){if(w instanceof S.UserDataSyncError)switch(w.code){case S.UserDataSyncErrorCode.TooLarge:throw new S.UserDataSyncError(w.message,w.code,d.resource);case S.UserDataSyncErrorCode.TooManyRequests:case S.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case S.UserDataSyncErrorCode.LocalTooManyRequests:case S.UserDataSyncErrorCode.Gone:case S.UserDataSyncErrorCode.UpgradeRequired:case S.UserDataSyncErrorCode.IncompatibleRemoteContent:case S.UserDataSyncErrorCode.IncompatibleLocalContent:throw w}const u=S.UserDataSyncError.toUserDataSyncError(w);this.reportUserDataSyncError(u,o),this.logService.error(w),this.logService.error(`${d.resource}: ${(0,v.toErrorMessage)(w)}`),this._syncErrors.push([d.resource,u])}}this.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),this.updateLastSyncTime()}catch(h){const d=S.UserDataSyncError.toUserDataSyncError(h);throw this.reportUserDataSyncError(d,o),d}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}}async stop(){if(this.status!=="idle")for(const n of this.synchronisers)try{n.status!=="idle"&&await n.stop()}catch(o){this.logService.error(o)}}async replace(n){await this.checkEnablement();for(const o of this.synchronisers)if(await o.replace(n))return}async accept(n,o,r,l){await this.checkEnablement();const h=this.getSynchroniser(n);await h.accept(o,r),l&&await h.apply(!1,(0,S.createSyncHeaders)((0,C.generateUuid)()))}async resolveContent(n){for(const o of this.synchronisers){const r=await o.resolveContent(n);if(r)return r}return null}getRemoteSyncResourceHandles(n){return this.getSynchroniser(n).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(n){return this.getSynchroniser(n).getLocalSyncResourceHandles()}getAssociatedResources(n,o){return this.getSynchroniser(n).getAssociatedResources(o)}getMachineId(n,o){return this.getSynchroniser(n).getMachineId(o)}async hasLocalData(){const n=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const o of n)if(await o.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(n){this.logService.error(n)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(m,0);for(const n of this.synchronisers)try{await n.resetLocal()}catch(o){this.logService.error(`${n.resource}: ${(0,v.toErrorMessage)(o)}`),this.logService.error(o)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const n of this.synchronisers)if(await n.hasPreviouslySynced())return!0;return!1}setStatus(n){const o=this._status;this._status!==n&&(this._status=n,this._onDidChangeStatus.fire(n),o==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const n=this.computeStatus();this.setStatus(n)}updateConflicts(){const n=this.computeConflicts();(0,f.equals)(this._conflicts,n,([o,r],[l,h])=>o===o&&(0,f.equals)(r,h,(d,w)=>(0,a.isEqual)(d.previewResource,w.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(n))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(m,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(n,o){this.telemetryService.publicLog2("sync/error",{code:n.code,url:n instanceof S.UserDataSyncStoreError?n.url:void 0,resource:n.resource,executionId:o,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(n=>n.status==="hasConflicts").map(n=>[n.resource,n.conflicts.map(t)])}getSynchroniser(n){return this.synchronisers.find(o=>o.resource===n)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};c=he([Y(0,S.IUserDataSyncStoreService),Y(1,S.IUserDataSyncStoreManagementService),Y(2,A.IInstantiationService),Y(3,S.IUserDataSyncLogService),Y(4,R.ITelemetryService),Y(5,y.IStorageService)],c),e.UserDataSyncService=c;class s extends k.Disposable{constructor(n,o,r,l,h){super();this.id=n,this.manifest=o,this.syncHeaders=r,this.synchronisers=l,this.logService=h,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new L.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,E.createCancelablePromise)(n=>this.getPreviews(n))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(n){throw this.logService.error(n),n}}async accept(n,o){try{return await this.performAction(n,r=>r.accept(n,o))}catch(r){throw this.logService.error(r),r}}async merge(n){try{return n?await this.performAction(n,o=>o.merge(n)):await this.mergeAll()}catch(o){throw this.logService.error(o),o}}async discard(n){try{return await this.performAction(n,o=>o.discard(n))}catch(o){throw this.logService.error(o),o}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const n=[];for(const[,o]of this.previews)for(const r of o.resourcePreviews)r.mergeState==="conflict"&&n.push(r.previewResource);for(const o of n)await this.discard(o);return this.previews}catch(n){throw this.logService.error(n),n}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const n=[];for(const[o,r]of this.previews){this.synchronizingResources.push([o,r.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===o);for(const d of r.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&await l.merge(d.previewResource);const h=await l.apply(!1,this.syncHeaders);h&&n.push(this.toSyncResourcePreview(l.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}catch(n){throw this.logService.error(n),n}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,o]of this.previews){this.synchronizingResources.push([n,o.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const r=this.synchronisers.find(l=>l.resource===n);for(const l of o.resourcePreviews)await r.accept(l.remoteResource);await r.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,o]of this.previews){this.synchronizingResources.push([n,o.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const r=this.synchronisers.find(l=>l.resource===n);for(const l of o.resourcePreviews)await r.accept(l.localResource);await r.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async stop(){for(const n of this.synchronisers)try{await n.stop()}catch(o){(0,p.isPromiseCanceledError)(o)||this.logService.error(o)}this.reset()}async performAction(n,o){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const r=this.previews.findIndex(([,z])=>z.resourcePreviews.some(({localResource:B,previewResource:M,remoteResource:j})=>(0,a.isEqual)(n,B)||(0,a.isEqual)(n,M)||(0,a.isEqual)(n,j)));if(r===-1)return this.previews;const[l,h]=this.previews[r],d=h.resourcePreviews.find(({localResource:z,remoteResource:B,previewResource:M})=>(0,a.isEqual)(z,n)||(0,a.isEqual)(B,n)||(0,a.isEqual)(M,n));if(!d)return this.previews;let w=this.synchronizingResources.find(z=>z[0]===l);w||(w=[l,[]],this.synchronizingResources.push(w)),w[1].some(z=>(0,a.isEqual)(z,d.localResource))||(w[1].push(d.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const u=this.synchronisers.find(z=>z.resource===this.previews[r][0]),P=await o(u);P?this.previews.splice(r,1,this.toSyncResourcePreview(u.resource,P)):this.previews.splice(r,1);const _=this.synchronizingResources.findIndex(z=>z[0]===l);return this.synchronizingResources[_][1].splice(w[1].findIndex(z=>(0,a.isEqual)(z,d.localResource)),1),w[1].length||(this.synchronizingResources.splice(_,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const n=[];for(const[o,r]of this.previews){this.synchronizingResources.push([o,r.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===o);let h=r;for(const d of r.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&(h=await l.merge(d.previewResource));h&&n.push(this.toSyncResourcePreview(l.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}async getPreviews(n){const o=[];for(const r of this.synchronisers){if(n.isCancellationRequested)return[];const l=await r.preview(this.manifest,this.syncHeaders);l&&o.push(this.toSyncResourcePreview(r.resource,l))}return o}toSyncResourcePreview(n,o){return[n,{isLastSyncFromCurrentMachine:o.isLastSyncFromCurrentMachine,resourcePreviews:o.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(i){return{localResource:i.localResource,previewResource:i.previewResource,remoteResource:i.remoteResource,acceptedResource:i.acceptedResource,localChange:i.localChange,remoteChange:i.remoteChange,mergeState:i.mergeState}}}),define(Z[192],ee([0,1,3,20,4,2,15]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class O{constructor(f,y){this.service=f,this.logService=y,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new S.Emitter}listen(f,y){switch(y){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${y}`)}async call(f,y,I){try{return await this._call(f,y,I)}catch(a){throw this.logService.error(a),a}}async _call(f,y,I){switch(y){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(A.URI.revive(I[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(I[0],A.URI.revive(I[1]),I[2],I[3]);case"resolveContent":return this.service.resolveContent(A.URI.revive(I[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(I[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(I[0]);case"getAssociatedResources":return this.service.getAssociatedResources(I[0],{created:I[1].created,uri:A.URI.revive(I[1].uri)});case"getMachineId":return this.service.getMachineId(I[0],{created:I[1].created,uri:A.URI.revive(I[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(y.startsWith("manualSync/")){const a=y.substring("manualSync/".length),b=I[0],C=this.getManualSyncTask(b);switch(I=I.slice(1),a){case"preview":return C.preview();case"accept":return C.accept(A.URI.revive(I[0]),I[1]);case"merge":return C.merge(A.URI.revive(I[0]));case"discard":return C.discard(A.URI.revive(I[0]));case"discardConflicts":return C.discardConflicts();case"apply":return C.apply();case"pull":return C.pull();case"push":return C.push();case"stop":return C.stop();case"_getStatus":return C.status;case"dispose":return this.disposeManualSyncTask(C)}}throw new Error("Invalid call")}getManualSyncTask(f){const y=this.manualSyncTasks.get(this.createKey(f));if(!y)throw new Error(`Manual sync taks not found: ${f}`);return y.manualSyncTask}async createManualSyncTask(){const f=new L.DisposableStore,y=f.add(await this.service.createManualSyncTask());return f.add(y.onSynchronizeResources(I=>this.onManualSynchronizeResources.fire({manualSyncTaskId:y.id,data:I}))),this.manualSyncTasks.set(this.createKey(y.id),{manualSyncTask:y,disposables:f}),{id:y.id,manifest:y.manifest,status:y.status}}disposeManualSyncTask(f){var y;f.dispose();const I=this.createKey(f.id);(y=this.manualSyncTasks.get(I))===null||y===void 0||y.disposables.dispose(),this.manualSyncTasks.delete(I)}createKey(f){return`manualSyncTask-${f}`}}e.UserDataSyncChannel=O;class g extends L.Disposable{constructor(f){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new S.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new S.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new S.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new S.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(y,I,a){return f.call(y,I,a).then(null,b=>{throw k.UserDataSyncError.toUserDataSyncError(b)})},listen(y,I){return f.listen(y,I)}},this.channel.call("_getInitialData").then(([y,I,a])=>{this.updateStatus(y),this.updateConflicts(I),a&&this.updateLastSyncTime(a),this._register(this.channel.listen("onDidChangeStatus")(b=>this.updateStatus(b))),this._register(this.channel.listen("onDidChangeLastSyncTime")(b=>this.updateLastSyncTime(b)))}),this._register(this.channel.listen("onDidChangeConflicts")(y=>this.updateConflicts(y))),this._register(this.channel.listen("onSyncErrors")(y=>this._onSyncErrors.fire(y.map(([I,a])=>[I,k.UserDataSyncError.toUserDataSyncError(a)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:f,manifest:y,status:I}=await this.channel.call("createManualSyncTask"),a=this,b=new v(f,y,I,{async call(C,E,p){return a.channel.call(`manualSync/${C}`,[f,...(0,U.isArray)(E)?E:[E]],p)},listen(C,E){return S.Event.map(S.Event.filter(a.channel.listen(`manualSync/${C}`,E),p=>!b.isDiposed()&&p.manualSyncTaskId===f),p=>p.data)}});return b}replace(f){return this.channel.call("replace",[f])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(f,y,I,a){return this.channel.call("accept",[f,y,I,a])}resolveContent(f){return this.channel.call("resolveContent",[f])}async getLocalSyncResourceHandles(f){return(await this.channel.call("getLocalSyncResourceHandles",[f])).map(({created:I,uri:a})=>({created:I,uri:A.URI.revive(a)}))}async getRemoteSyncResourceHandles(f){return(await this.channel.call("getRemoteSyncResourceHandles",[f])).map(({created:I,uri:a})=>({created:I,uri:A.URI.revive(a)}))}async getAssociatedResources(f,y){return(await this.channel.call("getAssociatedResources",[f,y])).map(({resource:a,comparableResource:b})=>({resource:A.URI.revive(a),comparableResource:A.URI.revive(b)}))}async getMachineId(f,y){return this.channel.call("getMachineId",[f,y])}async updateStatus(f){this._status=f,this._onDidChangeStatus.fire(f)}async updateConflicts(f){this._conflicts=f.map(([y,I])=>[y,I.map(a=>Object.assign(Object.assign({},a),{localResource:A.URI.revive(a.localResource),remoteResource:A.URI.revive(a.remoteResource),previewResource:A.URI.revive(a.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(f){this._lastSyncTime!==f&&(this._lastSyncTime=f,this._onDidChangeLastSyncTime.fire(f))}}e.UserDataSyncChannelClient=g;class v extends L.Disposable{constructor(f,y,I,a){super();this.id=f,this.manifest=y,this._disposed=!1,this._status=I;const b=this;this.channel={async call(C,E,p){try{const m=await a.call(C,E,p);return b.isDiposed()||(b._status=await a.call("_getStatus")),m}catch(m){throw k.UserDataSyncError.toUserDataSyncError(m)}},listen(C,E){return a.listen(C,E)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const f=await this.channel.call("preview");return this.deserializePreviews(f)}async accept(f,y){const I=await this.channel.call("accept",[f,y]);return this.deserializePreviews(I)}async merge(f){const y=await this.channel.call("merge",[f]);return this.deserializePreviews(y)}async discard(f){const y=await this.channel.call("discard",[f]);return this.deserializePreviews(y)}async discardConflicts(){const f=await this.channel.call("discardConflicts");return this.deserializePreviews(f)}async apply(){const f=await this.channel.call("apply");return this.deserializePreviews(f)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(f){return f.map(([y,I])=>[y,{isLastSyncFromCurrentMachine:I.isLastSyncFromCurrentMachine,resourcePreviews:I.resourcePreviews.map(a=>Object.assign(Object.assign({},a),{localResource:A.URI.revive(a.localResource),remoteResource:A.URI.revive(a.remoteResource),previewResource:A.URI.revive(a.previewResource),acceptedResource:A.URI.revive(a.acceptedResource)}))}])}}}),define(Z[193],ee([0,1,2,20,40,12,30,24,28,44,9,10,19,31,7,3,6,15,4,11]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I,a,b,C,E,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const c="sync.previous.store",s="sync.donot-make-requests-until",t="sync.user-session-id",i="sync.machine-session-id",n=100,o=1e3*60*5;let r=class extends S.Disposable{constructor(P,_,z){super();this.productService=P,this.configurationService=_,this.storageService=z,this._onDidChangeUserDataSyncStore=this._register(new b.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(b.Event.filter(z.onDidChangeValue,B=>{var M;return B.key===k.SYNC_SERVICE_URL_TYPE&&B.scope===0&&this.userDataSyncStoreType!==((M=this.userDataSyncStore)===null||M===void 0?void 0:M.type)})(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(k.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(P){this.storageService.store(k.SYNC_SERVICE_URL_TYPE,P,0,a.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[k.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(k.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(P,_){P=a.isWeb&&(P==null?void 0:P.web)?Object.assign(Object.assign({},P),P.web):P;const z=Object.assign(Object.assign({},P||{}),_||{});if(z&&(0,E.isString)(z.url)&&(0,E.isObject)(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(B=>(0,E.isArray)(z.authenticationProviders[B].scopes))){const B=z,M=!!B.canSwitch&&!(_==null?void 0:_.url),j=B.url===B.insidersUrl?"insiders":"stable",W=(M?this.userDataSyncStoreType:void 0)||j,$=(_==null?void 0:_.url)||(W==="insiders"?B.insidersUrl:W==="stable"?B.stableUrl:B.url);return{url:p.URI.parse($),type:W,defaultType:j,defaultUrl:p.URI.parse(B.url),stableUrl:p.URI.parse(B.stableUrl),insidersUrl:p.URI.parse(B.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(B.authenticationProviders).reduce((H,q)=>(H.push({id:q,scopes:B.authenticationProviders[q].scopes}),H),[])}}}};r=he([Y(0,g.IProductService),Y(1,O.IConfigurationService),Y(2,y.IStorageService)],r),e.AbstractUserDataSyncStoreManagementService=r;let l=class extends r{constructor(P,_,z){super(P,_,z);const B=this.storageService.get(c,0);B&&(this.previousConfigurationSyncStore=JSON.parse(B));const M=this.productService[k.CONFIGURATION_SYNC_STORE_KEY];M?this.storageService.store(c,JSON.stringify(M),0,1):this.storageService.remove(c,0)}async switch(P){P!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=P,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=he([Y(0,g.IProductService),Y(1,O.IConfigurationService),Y(2,y.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let h=class extends S.Disposable{constructor(P,_,z,B,M,j,W){super();this.requestService=z,this.logService=B,this.storageService=W,this._onTokenFailed=this._register(new b.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new b.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new b.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(P),this.commonHeadersPromise=(0,v.getServiceMachineId)(M,j,W).then($=>{const H={"X-Client-Name":`${_.applicationName}${a.isWeb?"-web":""}`,"X-Client-Version":_.version,"X-Machine-Id":$};return _.commit&&(H["X-Client-Commit"]=_.commit),H}),this.session=new w(n,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,S.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(P,_){this.authToken={token:P,type:_}}updateUserDataSyncStoreUrl(P){this.userDataSyncStoreUrl=P?(0,L.joinPath)(P,"v1"):void 0}initDonotMakeRequestsUntil(){const P=this.storageService.getNumber(s,0);P&&Date.now()<P&&this.setDonotMakeRequestsUntil(new Date(P))}setDonotMakeRequestsUntil(P){var _;((_=this._donotMakeRequestsUntil)===null||_===void 0?void 0:_.getTime())!==(P==null?void 0:P.getTime())&&(this._donotMakeRequestsUntil=P,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(s,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,C.createCancelablePromise)(z=>(0,C.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),z).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,z=>null)):this.storageService.remove(s,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(P){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P),z={},B=await this.request(_.toString(),{type:"GET",headers:z},[],U.CancellationToken.None);return(await(0,A.asJson)(B)||[]).map(({url:j,created:W})=>({ref:(0,L.relativePath)(_,_.with({path:j})),created:W*1e3}))}async resolveContent(P,_){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P,_).toString(),B={};B["Cache-Control"]="no-cache";const M=await this.request(z,{type:"GET",headers:B},[],U.CancellationToken.None);return await(0,A.asText)(M)}async delete(P){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P).toString(),z={};await this.request(_,{type:"DELETE",headers:z},[],U.CancellationToken.None)}async read(P,_,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const B=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P,"latest").toString();z=Object.assign({},z),z["Cache-Control"]="no-cache",_&&(z["If-None-Match"]=_.ref);const M=await this.request(B,{type:"GET",headers:z},[304],U.CancellationToken.None);if(M.res.statusCode===304)return _;const j=M.res.headers.etag;if(!j)throw new k.UserDataSyncStoreError("Server did not return the ref",B,k.UserDataSyncErrorCode.NoRef,M.res.headers[k.HEADER_OPERATION_ID]);const W=await(0,A.asText)(M);return{ref:j,content:W}}async write(P,_,z,B={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P).toString();B=Object.assign({},B),B["Content-Type"]="text/plain",z&&(B["If-Match"]=z);const j=await this.request(M,{type:"POST",data:_,headers:B},[],U.CancellationToken.None),W=j.res.headers.etag;if(!W)throw new k.UserDataSyncStoreError("Server did not return the ref",M,k.UserDataSyncErrorCode.NoRef,j.res.headers[k.HEADER_OPERATION_ID]);return W}async manifest(P={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,L.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();P=Object.assign({},P),P["Content-Type"]="application/json";const z=await this.request(_,{type:"GET",headers:P},[],U.CancellationToken.None),B=await(0,A.asJson)(z),M=this.storageService.get(t,0);return M&&B&&M!==B.session&&this.clearSession(),B===null&&M&&this.clearSession(),B&&this.storageService.store(t,B.session,0,1),B}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const P=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),_={"Content-Type":"text/plain"};await this.request(P,{type:"DELETE",headers:_},[],U.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(t,0),this.storageService.remove(i,0)}async request(P,_,z,B){if(!this.authToken)throw new k.UserDataSyncStoreError("No Auth Token Available",P,k.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,k.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const M=await this.commonHeadersPromise;_.headers=Object.assign(Object.assign(Object.assign({},_.headers||{}),M),{"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`}),this.addSessionHeaders(_.headers),this.logService.trace("Sending request to server",{url:P,type:_.type,headers:Object.assign(Object.assign({},_.headers),{authorization:void 0})});let j;try{j=await this.session.request(P,_,B)}catch(q){if(!(q instanceof k.UserDataSyncStoreError)){const D=(0,m.isPromiseCanceledError)(q)?k.UserDataSyncErrorCode.RequestCanceled:(0,m.getErrorMessage)(q).startsWith("XHR timeout")?k.UserDataSyncErrorCode.RequestTimeout:k.UserDataSyncErrorCode.RequestFailed;q=new k.UserDataSyncStoreError(`Connection refused for the request '${P}'.`,P,D,void 0)}throw this.logService.info("Request failed",P),q}const W=j.res.headers[k.HEADER_OPERATION_ID],$={url:P,status:j.res.statusCode,"execution-id":_.headers[k.HEADER_EXECUTION_ID],"operation-id":W},H=(0,A.isSuccess)(j)||j.res.statusCode&&z.indexOf(j.res.statusCode)!==-1;if(H?this.logService.trace("Request succeeded",$):this.logService.info("Request failed",$),j.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new k.UserDataSyncStoreError(`Request '${P}' failed because of Unauthorized (401).`,P,k.UserDataSyncErrorCode.Unauthorized,W);if(this._onTokenSucceed.fire(),j.res.statusCode===409)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,P,k.UserDataSyncErrorCode.Conflict,W);if(j.res.statusCode===410)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because the requested resource is not longer available (410).`,P,k.UserDataSyncErrorCode.Gone,W);if(j.res.statusCode===412)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,P,k.UserDataSyncErrorCode.PreconditionFailed,W);if(j.res.statusCode===413)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too large payload (413).`,P,k.UserDataSyncErrorCode.TooLarge,W);if(j.res.statusCode===426)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,P,k.UserDataSyncErrorCode.UpgradeRequired,W);if(j.res.statusCode===429){const q=j.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,k.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,W)):new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,k.UserDataSyncErrorCode.TooManyRequests,W)}if(!H)throw new k.UserDataSyncStoreError("Server returned "+j.res.statusCode,P,k.UserDataSyncErrorCode.Unknown,W);return j}addSessionHeaders(P){let _=this.storageService.get(i,0);_===void 0&&(_=(0,I.generateUuid)(),this.storageService.store(i,_,0,1)),P["X-Machine-Session-Id"]=_;const z=this.storageService.get(t,0);z!==void 0&&(P["X-User-Session-Id"]=z)}};h=he([Y(1,g.IProductService),Y(2,A.IRequestService),Y(3,k.IUserDataSyncLogService),Y(4,R.IEnvironmentService),Y(5,f.IFileService),Y(6,y.IStorageService)],h),e.UserDataSyncStoreClient=h;let d=class extends h{constructor(P,_,z,B,M,j,W){var $;super(($=P.userDataSyncStore)===null||$===void 0?void 0:$.url,_,z,B,M,j,W);this._register(P.onDidChangeUserDataSyncStore(()=>{var H;return this.updateUserDataSyncStoreUrl((H=P.userDataSyncStore)===null||H===void 0?void 0:H.url)}))}};d=he([Y(0,k.IUserDataSyncStoreManagementService),Y(1,g.IProductService),Y(2,A.IRequestService),Y(3,k.IUserDataSyncLogService),Y(4,R.IEnvironmentService),Y(5,f.IFileService),Y(6,y.IStorageService)],d),e.UserDataSyncStoreService=d;class w{constructor(P,_,z,B){this.limit=P,this.interval=_,this.requestService=z,this.logService=B,this.requests=[],this.startTime=void 0}request(P,_,z){if(this.isExpired()&&this.reset(),_.url=P,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new k.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,P,k.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(P),this.requestService.request(_,z)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=w}),define(Z[194],ee([0,1,20,3,57,83,59,25,19,60,28]),function(K,e,S,k,A,L,U,O,g,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let f=class extends L.UserDataAutoSyncService{constructor(I,a,b,C,E,p,m,c,s,t,i,n){super(I,a,b,C,E,m,c,s,t,i,n);this._register(k.Event.debounce(k.Event.any(k.Event.map(p.onDidFocusWindow,()=>"windowFocus"),k.Event.map(p.onDidOpenWindow,()=>"windowOpen")),(o,r)=>o?[...o,r]:[r],1e3)(o=>this.triggerSync(o,!0,!1)))}};f=he([Y(0,R.IProductService),Y(1,S.IUserDataSyncStoreManagementService),Y(2,S.IUserDataSyncStoreService),Y(3,S.IUserDataSyncResourceEnablementService),Y(4,S.IUserDataSyncService),Y(5,A.INativeHostService),Y(6,S.IUserDataSyncLogService),Y(7,U.IUserDataSyncAccountService),Y(8,O.ITelemetryService),Y(9,v.IUserDataSyncMachinesService),Y(10,g.IStorageService),Y(11,S.IUserDataAutoSyncEnablementService)],f),e.UserDataAutoSyncService=f}),define(Z[195],ee([0,1,3,2,6]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends k.Disposable{constructor({onDidOpenWindow:O,onDidFocusWindow:g,getActiveWindowId:v}){super();this.disposables=this._register(new k.DisposableStore),S.Event.latch(S.Event.any(O,g))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,A.createCancelablePromise)(()=>v()),(async()=>{try{const f=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:f}catch(f){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(O){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=O}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(Z[61],ee([0,1,105,8,27,6,23,201,202,15]),function(K,e,S,k,A,L,U,O,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class R extends Error{constructor(t,i){let n=i.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=t,this.cause=i}}e.ExtractError=R;function f(s){const t=s.externalFileAttributes>>16||33188;return[448,56,7].map(i=>t&i).reduce((i,n)=>i+n,t&61440)}function y(s){if(s instanceof R)return s;let t;return/end of central directory record signature not found/.test(s.message)&&(t="CorruptZip"),new R(t,s)}function I(s,t,i,n,o,r){const l=k.dirname(t),h=k.join(n,l);if(!h.startsWith(n))return Promise.reject(new Error(S.localize(0,null,t)));const d=k.join(n,t);let w;return r.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(A.promises.mkdir(h,{recursive:!0})).then(()=>new Promise((u,P)=>{if(!r.isCancellationRequested)try{w=(0,A.createWriteStream)(d,{mode:i}),w.once("close",()=>u()),w.once("error",P),s.once("error",P),s.pipe(w)}catch(_){P(_)}}))}function a(s,t,i,n){let o=(0,L.createCancelablePromise)(()=>Promise.resolve()),r=0;return n.onCancellationRequested(()=>{o.cancel(),s.close()}),new Promise((l,h)=>{const d=new L.Sequencer,w=u=>{u.isCancellationRequested||(r++,s.readEntry())};s.once("error",h),s.once("close",()=>o.then(()=>{n.isCancellationRequested||s.entryCount===r?l():h(new R("Incomplete",new Error(S.localize(1,null,r,s.entryCount))))},h)),s.readEntry(),s.on("entry",u=>{if(!n.isCancellationRequested){if(!i.sourcePathRegex.test(u.fileName)){w(n);return}const P=u.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(P)){const B=k.join(t,P);o=(0,L.createCancelablePromise)(M=>A.promises.mkdir(B,{recursive:!0}).then(()=>w(M)).then(void 0,h));return}const _=C(s,u),z=f(u);o=(0,L.createCancelablePromise)(B=>d.queue(()=>_.then(M=>I(M,P,z,t,i,B).then(()=>w(B)))).then(null,h))}})})}function b(s,t=!1){return new Promise((i,n)=>{(0,O.open)(s,t?{lazyEntries:!0}:void 0,(o,r)=>{o?n(y(o)):i((0,v.assertIsDefined)(r))})})}function C(s,t){return new Promise((i,n)=>{s.openReadStream(t,(o,r)=>{o?n(y(o)):i((0,v.assertIsDefined)(r))})})}function E(s,t){return new Promise((i,n)=>{const o=new g.ZipFile;t.forEach(l=>{l.contents?o.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&o.addFile(l.localPath,l.path)}),o.end();const r=(0,A.createWriteStream)(s);o.outputStream.pipe(r),o.outputStream.once("error",n),r.once("error",n),r.once("finish",()=>i(s))})}e.zip=E;function p(s,t,i={},n){const o=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let r=b(s,!0);return i.overwrite&&(r=r.then(l=>(0,U.rimraf)(t).then(()=>l))),r.then(l=>a(l,t,{sourcePathRegex:o},n))}e.extract=p;function m(s,t){return b(s).then(i=>new Promise((n,o)=>{i.on("entry",r=>{r.fileName===t&&C(i,r).then(l=>n(l),l=>o(l))}),i.once("close",()=>o(new Error(S.localize(2,null,t))))}))}function c(s,t){return m(s,t).then(i=>new Promise((n,o)=>{const r=[];i.once("error",o),i.on("data",l=>r.push(l)),i.on("end",()=>n(Buffer.concat(r)))}))}e.buffer=c}),define(Z[196],ee([0,1,61,110]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function A(L){return(0,S.buffer)(L,"extension/package.json").then(U=>{try{return JSON.parse(U.toString("utf8"))}catch(O){throw new Error((0,k.localize)(0,null))}})}e.getManifest=A}),define(Z[197],ee([0,1,27,56,2,23,8,17,29,33,6,4,9,130,111,28,61,7,18,16,10,12,31,11]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I,a,b,C,E,p,m,c,s,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const n="scanningSystem",o="scanningUser",r="extracting",l="deleting",h="renaming";let d=class extends A.Disposable{constructor(u,P,_,z,B){super();this.beforeRemovingExtension=u,this.fileService=P,this.logService=_,this.environmentService=z,this.productService=B,this._devSystemExtensionsPath=null,this.systemExtensionsPath=z.builtinExtensionsPath,this.extensionsPath=z.extensionsPath,this.uninstalledPath=U.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(u){const P=[];(u===null||u===0)&&P.push(this.scanSystemExtensions().then(null,_=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(_).message,n)))),(u===null||u===1)&&P.push(this.scanUserExtensions(!0).then(null,_=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(_).message,o))));try{const _=await Promise.all(P);return(0,p.flatten)(_)}catch(_){throw this.joinErrors(_)}}async scanUserExtensions(u){this.logService.trace("Started scanning user extensions");let[P,_]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return _=_.filter(z=>!P[new v.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]),u&&(_=(0,v.groupByExtension)(_,B=>B.identifier).map(B=>B.sort((M,j)=>k.rcompare(M.manifest.version,j.manifest.version))[0])),this.logService.trace("Scanned user extensions:",_.length),_}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(u,P,_){const z=u.key(),B=U.join(this.extensionsPath,`.${(0,t.generateUuid)()}`),M=U.join(this.extensionsPath,z);try{await L.rimraf(M)}catch(W){try{await L.rimraf(M)}catch($){}throw new g.ExtensionManagementError((0,a.localize)(0,null,M,u.id),l)}await this.extractAtLocation(u,P,B,_);let j=await this.scanExtension(f.URI.file(B),1);if(!j)throw new Error((0,a.localize)(1,null,B));await this.storeMetadata(j,{installedTimestamp:Date.now()});try{await this.rename(u,B,M,Date.now()+2*60*1e3),this.logService.info("Renamed to",M)}catch(W){try{await L.rimraf(B)}catch($){}if(W.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",u.id);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(W)}. Deleted from extracted location`,B),W}try{j=await this.scanExtension(f.URI.file(M),1)}catch(W){}if(j)return j;throw new Error((0,a.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(u,P){return this.setMetadata(u,P),await this.storeMetadata(u,Object.assign(Object.assign({},P),{installedTimestamp:u.installedTimestamp})),u}async storeMetadata(u,P){P.isMachineScoped=P.isMachineScoped||void 0,P.isBuiltin=P.isBuiltin||void 0,P.installedTimestamp=P.installedTimestamp||void 0;const _=U.join(u.location.fsPath,"package.json"),z=await S.promises.readFile(_,"utf8"),{manifest:B}=await this.parseManifest(z);return B.__metadata=P,await L.writeFile(_,JSON.stringify(B,null,"	")),u}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...u){const P=u.map(_=>new v.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version));await this.withUninstalledExtensions(_=>{P.forEach(z=>_[z.key()]=!0)})}async setInstalled(u){await this.withUninstalledExtensions(z=>delete z[u.key()]);const _=(await this.scanExtensions(1)).find(z=>new v.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).equals(u))||null;return _?(await this.storeMetadata(_,{installedTimestamp:Date.now()}),this.scanExtension(_.location,1)):null}async withUninstalledExtensions(u){return this.uninstalledFileLimiter.queue(async()=>{let P;try{P=await S.promises.readFile(this.uninstalledPath,"utf8")}catch(z){if(z.code!=="ENOENT")throw z}let _={};if(P)try{_=JSON.parse(P)}catch(z){}return u&&(u(_),Object.keys(_).length?await L.writeFile(this.uninstalledPath,JSON.stringify(_)):await L.rimraf(this.uninstalledPath)),_})}async removeExtension(u,P){this.logService.trace(`Deleting ${P} extension from disk`,u.identifier.id,u.location.fsPath),await L.rimraf(u.location.fsPath),this.logService.info("Deleted from disk",u.identifier.id,u.location.fsPath)}async removeUninstalledExtension(u){await this.removeExtension(u,"uninstalled"),await this.withUninstalledExtensions(P=>delete P[new v.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()])}async extractAtLocation(u,P,_,z){this.logService.trace(`Started extracting the extension from ${P} to ${_}`);try{await L.rimraf(_)}catch(B){throw new g.ExtensionManagementError(this.joinErrors(B).message,l)}try{await(0,C.extract)(P,_,{sourcePath:"extension",overwrite:!0},z),this.logService.info(`Extracted extension to ${_}:`,u.id)}catch(B){try{await L.rimraf(_)}catch(M){}throw new g.ExtensionManagementError(B.message,B instanceof C.ExtractError&&B.type?B.type:r)}}async rename(u,P,_,z){try{await S.promises.rename(P,_)}catch(B){if(E.isWindows&&B&&B.code==="EPERM"&&Date.now()<z)return this.logService.info(`Failed renaming ${P} to ${_} with 'EPERM' error. Trying again...`,u.id),this.rename(u,P,_,z);throw new g.ExtensionManagementError(B.message||(0,a.localize)(3,null,P,_),B.code||h)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const u=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return u;const P=this.scanDevSystemExtensions(),[_,z]=await Promise.all([u,P]);return[..._,...z]}async scanExtensionsInDir(u,P){const _=new R.Limiter(10),z=await this.fileService.resolve(f.URI.file(u));return z.children?(await Promise.all(z.children.filter(M=>M.isDirectory).map(M=>_.queue(async()=>P===1&&(0,s.basename)(M.resource).indexOf(".")===0?null:this.scanExtension(M.resource,P))))).filter(M=>M&&M.identifier):[]}async scanExtension(u,P){var _,z;try{const B=await this.fileService.resolve(u);if(B.children){const{manifest:M,metadata:j}=await this.readManifest(u.fsPath),W=(_=B.children.find(({name:D})=>/^readme(\.txt|\.md|)$/i.test(D)))===null||_===void 0?void 0:_.resource,$=(z=B.children.find(({name:D})=>/^changelog(\.txt|\.md|)$/i.test(D)))===null||z===void 0?void 0:z.resource,H={id:(0,v.getGalleryExtensionId)(M.publisher,M.name)},q={type:P,identifier:H,manifest:M,location:u,readmeUrl:W,changelogUrl:$,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:P===0};return j&&(this.setMetadata(q,j),q.installedTimestamp=j.installedTimestamp),q}}catch(B){P!==0&&this.logService.trace(B)}return null}async scanDefaultSystemExtensions(){const u=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",u.length),u}async scanDevSystemExtensions(){const u=this.getDevSystemExtensionsList();if(u.length){const P=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",P.length),P.filter(_=>u.some(z=>(0,v.areSameExtensions)(_.identifier,{id:z})))}else return[]}setMetadata(u,P){u.publisherDisplayName=P.publisherDisplayName||null,u.publisherId=P.publisherId||null,u.identifier.uuid=P.id,u.isMachineScoped=!!P.isMachineScoped,u.isBuiltin=u.type===0||!!P.isBuiltin}async removeUninstalledExtensions(){const u=await this.getUninstalledExtensions(),P=await this.scanAllUserExtensions(),_=new Set;for(const M of P)u[new v.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).key()]||_.add(M.identifier.id.toLowerCase());const z=(0,v.groupByExtension)(P,M=>M.identifier);await R.Promises.settled(z.map(async M=>{const j=M.sort((W,$)=>k.rcompare(W.manifest.version,$.manifest.version))[0];_.has(j.identifier.id.toLowerCase())||await this.beforeRemovingExtension(j)}));const B=P.filter(M=>u[new v.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).key()]);await R.Promises.settled(B.map(M=>this.removeUninstalledExtension(M)))}async removeOutdatedExtensions(){const u=await this.scanAllUserExtensions(),P=[],_=(0,v.groupByExtension)(u,z=>z.identifier);P.push(...(0,p.flatten)(_.map(z=>z.sort((B,M)=>k.rcompare(B.manifest.version,M.manifest.version)).slice(1)))),await R.Promises.settled(P.map(z=>this.removeExtension(z,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(u=>u.name)}joinErrors(u){const P=Array.isArray(u)?u:[u];return P.length===1?P[0]instanceof Error?P[0]:new Error(P[0]):P.reduce((_,z)=>new Error(`${_.message}${_.message?",":""}${z instanceof Error?z.message:z}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=U.normalize(U.join(m.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(u){const P=[S.promises.readFile(U.join(u,"package.json"),"utf8").then(M=>this.parseManifest(M)),S.promises.readFile(U.join(u,"package.nls.json"),"utf8").then(void 0,M=>M.code!=="ENOENT"?Promise.reject(M):"{}").then(M=>JSON.parse(M))],[{manifest:_,metadata:z},B]=await Promise.all(P);return{manifest:(0,I.localizeManifest)(_,B),metadata:z}}parseManifest(u){return new Promise((P,_)=>{try{const z=JSON.parse(u),B=z.__metadata||null;P({manifest:z,metadata:B})}catch(z){_(new Error((0,a.localize)(4,null)))}})}};d=he([Y(1,c.IFileService),Y(2,O.ILogService),Y(3,y.INativeEnvironmentService),Y(4,b.IProductService)],d),e.ExtensionsScanner=d}),define(Z[198],ee([0,1,27,109,8,23,2,18,61,29,33,9,6,3,56,4,51,7,17,143,43,25,68,12,31,70,5,16,30,196,151,197,152,153,10]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I,a,b,C,E,p,m,c,s,t,i,n,o,r,l,h,d,w,u,P,_,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const B="unsetUninstalled",M="downloading",j="validating",W="local",$="unknown";let H=class extends U.Disposable{constructor(D,T,F,N,V,G,J){super();this.environmentService=D,this.galleryService=T,this.logService=F,this.downloadService=N,this.telemetryService=V,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new I.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new I.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new I.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new I.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const Q=this._register(G.createInstance(P.ExtensionsLifecycle));this.extensionsScanner=this._register(G.createInstance(u.ExtensionsScanner,ie=>Q.postUninstall(ie))),this.manifestCache=this._register(new m.ExtensionsManifestCache(D,this)),this.extensionsDownloader=this._register(G.createInstance(w.ExtensionsDownloader));const ne=this._register(new _.ExtensionsWatcher(this,J,D,F));this._register(ne.onDidChangeExtensionsByAnotherSource(({added:ie,removed:ce})=>{ie.forEach(ue=>this._onDidInstallExtension.fire({identifier:ue.identifier,operation:0,local:ue})),ce.forEach(ue=>this._onDidUninstallExtension.fire({identifier:ue}))})),this._register((0,U.toDisposable)(()=>{this.installingExtensions.forEach(ie=>ie.cancel()),this.uninstallingExtensions.forEach(ie=>ie.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(D){this.logService.trace("ExtensionManagementService#zip",D.identifier.id);const T=await this.collectFiles(D),F=await(0,g.zip)((0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)()).fsPath,T);return b.URI.file(F)}async unzip(D){return this.logService.trace("ExtensionManagementService#unzip",D.toString()),(await this.install(D)).identifier}async getManifest(D){const T=await this.downloadVsix(D),F=A.resolve(T.fsPath);return(0,d.getManifest)(F)}async collectFiles(D){const T=async N=>{let V=await L.readdir(N);V=V.map(Q=>A.join(N,Q));const G=await Promise.all(V.map(Q=>S.promises.stat(Q)));let J=Promise.resolve([]);return G.forEach((Q,ne)=>{const ie=V[ne];Q.isFile()&&(J=J.then(ce=>[...ce,ie])),Q.isDirectory()&&(J=J.then(ce=>T(ie).then(ue=>[...ce,...ue])))}),J};return(await T(D.location.fsPath)).map(N=>({path:`extension/${A.relative(D.location.fsPath,N)}`,localPath:N}))}async install(D,T={}){return this.logService.trace("ExtensionManagementService#install",D.toString()),(0,y.createCancelablePromise)(async F=>{const N=await this.downloadVsix(D),V=A.resolve(N.fsPath),G=await(0,d.getManifest)(V),J={id:(0,R.getGalleryExtensionId)(G.publisher,G.name)};let Q=1;if(G.engines&&G.engines.vscode&&!(0,t.isEngineValid)(G.engines.vscode,C.default.version))throw new Error(k.localize(0,null,J.id,C.default.version));const ne=new R.ExtensionIdentifierWithVersion(J,G.version),ce=(await this.getInstalled(1)).find(ge=>(0,R.areSameExtensions)(J,ge.identifier));if(ce)if(T.isMachineScoped=T.isMachineScoped||ce.isMachineScoped,T.isBuiltin=T.isBuiltin||ce.isBuiltin,Q=2,ne.equals(new R.ExtensionIdentifierWithVersion(ce.identifier,ce.manifest.version)))try{await this.extensionsScanner.removeExtension(ce,"existing")}catch(ge){throw new Error(k.localize(1,null,G.displayName||G.name))}else a.gt(ce.manifest.version,G.version)&&await this.uninstallExtension(ce);else{const ge=await this.unsetUninstalledAndGetLocal(ne);if(ge)try{await this.extensionsScanner.removeExtension(ge,"existing")}catch(Ee){throw new Error(k.localize(2,null,G.displayName||G.name))}}this.logService.info("Installing the extension:",J.id),this._onInstallExtension.fire({identifier:J,zipPath:V});let ue;try{ue=await this.getGalleryMetadata((0,R.getGalleryExtensionId)(G.publisher,G.name))}catch(ge){}try{const ge=await this.installFromZipPath(ne,V,Object.assign(Object.assign({},ue||{}),T),T,Q,F);return this.logService.info("Successfully installed the extension:",J.id),ge}catch(ge){throw this.logService.error("Failed to install the extension:",J.id,ge.message),ge}})}async downloadVsix(D){if(D.scheme===l.Schemas.file)return D;if(!this.downloadService)throw new Error("Download service is not available");const T=(0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)());return await this.downloadService.download(D,T),T}async installFromZipPath(D,T,F,N,V,G){try{const J=await this.installExtension({zipPath:T,identifierWithVersion:D,metadata:F},G);try{await this.installDependenciesAndPackExtensions(J,void 0,N)}catch(Q){(0,O.isNonEmptyArray)(J.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",J.identifier.id,Q.message),(0,O.isNonEmptyArray)(J.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",J.identifier.id,Q.message)}return this._onDidInstallExtension.fire({identifier:D,zipPath:T,local:J,operation:V}),J}catch(J){throw this._onDidInstallExtension.fire({identifier:D,zipPath:T,operation:V,error:J}),J}}async canInstall(D){return!0}async installFromGallery(D,T={}){if(!this.galleryService.isEnabled())throw new Error(k.localize(3,null));try{D=await this.checkAndGetCompatibleVersion(D)}catch(V){const G=V&&V.code?V.code:$;throw this.logService.error("Failed to install extension:",D.identifier.id,V?V.message:G),this.reportTelemetry(this.getTelemetryEvent(1),(0,R.getGalleryExtensionTelemetryData)(D),void 0,V),V instanceof Error&&(V.name=G),V}const F=new R.ExtensionIdentifierWithVersion(D.identifier,D.version).key();let N=this.installingExtensions.get(F);return N||(N=(0,y.createCancelablePromise)(V=>this.doInstallFromGallery(D,T,V)),this.installingExtensions.set(F,N),N.finally(()=>this.installingExtensions.delete(F))),N}async doInstallFromGallery(D,T,F){const N=new Date().getTime();let V=1;this.logService.info("Installing extension:",D.identifier.id),this._onInstallExtension.fire({identifier:D.identifier,gallery:D});try{const J=(await this.getInstalled(1)).find(ie=>(0,R.areSameExtensions)(ie.identifier,D.identifier));J&&(V=2);const Q=await this.downloadInstallableExtension(D,V);Q.metadata.isMachineScoped=T.isMachineScoped||(J==null?void 0:J.isMachineScoped),Q.metadata.isBuiltin=T.isBuiltin||(J==null?void 0:J.isBuiltin);const ne=await this.installExtension(Q,F);try{await this.extensionsDownloader.delete(b.URI.file(Q.zipPath))}catch(ie){}if(!T.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(ne,J,T)}catch(ie){try{await this.uninstall(ne)}catch(ce){}throw ie}return J&&a.neq(J.manifest.version,D.version)&&await this.extensionsScanner.setUninstalled(J),this.logService.info("Extensions installed successfully:",D.identifier.id),this._onDidInstallExtension.fire({identifier:D.identifier,gallery:D,local:ne,operation:V}),this.reportTelemetry(this.getTelemetryEvent(V),(0,R.getGalleryExtensionTelemetryData)(D),new Date().getTime()-N,void 0),ne}catch(G){const J=G&&G.code?G.code:$;throw this.logService.error("Failed to install extension:",D.identifier.id,G?G.message:J),this._onDidInstallExtension.fire({identifier:D.identifier,gallery:D,operation:V,error:J}),this.reportTelemetry(this.getTelemetryEvent(V),(0,R.getGalleryExtensionTelemetryData)(D),new Date().getTime()-N,G),G instanceof Error&&(G.name=J),G}}async checkAndGetCompatibleVersion(D){if(await this.isMalicious(D))throw new v.ExtensionManagementError(k.localize(4,null),v.INSTALL_ERROR_MALICIOUS);const T=await this.galleryService.getCompatibleExtension(D);if(!T)throw new v.ExtensionManagementError(k.localize(5,null,D.identifier.id,C.default.version),v.INSTALL_ERROR_INCOMPATIBLE);return T}async reinstallFromGallery(D){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",D.identifier.id),!this.galleryService.isEnabled())throw new Error(k.localize(6,null));const T=await this.findGalleryExtension(D);if(!T)throw new Error(k.localize(7,null));await this.extensionsScanner.setUninstalled(D);try{await this.extensionsScanner.removeUninstalledExtension(D)}catch(F){throw new Error(k.localize(8,null,(0,c.toErrorMessage)(F)))}await this.installFromGallery(T)}getTelemetryEvent(D){return D===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(D){const T=await this.getExtensionsReport();return(0,R.getMaliciousExtensionsSet)(T).has(D.identifier.id)}async downloadInstallableExtension(D,T){const F={id:D.identifier.uuid,publisherId:D.publisherId,publisherDisplayName:D.publisherDisplayName};let N;try{this.logService.trace("Started downloading extension:",D.identifier.id),N=(await this.extensionsDownloader.downloadExtension(D,T)).fsPath,this.logService.info("Downloaded extension:",D.identifier.id,N)}catch(V){throw new v.ExtensionManagementError(this.joinErrors(V).message,M)}try{const V=await(0,d.getManifest)(N);return{zipPath:N,identifierWithVersion:new R.ExtensionIdentifierWithVersion(D.identifier,V.version),metadata:F}}catch(V){throw new v.ExtensionManagementError(this.joinErrors(V).message,j)}}async installExtension(D,T){try{const F=await this.unsetUninstalledAndGetLocal(D.identifierWithVersion);if(F)return D.metadata?this.extensionsScanner.saveMetadataForLocalExtension(F,D.metadata):F}catch(F){throw E.isMacintosh?new v.ExtensionManagementError(k.localize(9,null),B):new v.ExtensionManagementError(k.localize(10,null),B)}return this.extractAndInstall(D,T)}async unsetUninstalledAndGetLocal(D){if(!await this.isUninstalled(D))return null;this.logService.trace("Removing the extension from uninstalled list:",D.id);const F=await this.extensionsScanner.setInstalled(D);return this.logService.info("Removed the extension from uninstalled list:",D.id),F}async extractAndInstall({zipPath:D,identifierWithVersion:T,metadata:F},N){let V=await this.extensionsScanner.extractUserExtension(T,D,N);return this.logService.info("Installation completed.",T.id),F&&(V=await this.extensionsScanner.saveMetadataForLocalExtension(V,F)),V}async installDependenciesAndPackExtensions(D,T,F){if(!!this.galleryService.isEnabled()){const N=D.manifest.extensionDependencies||[];if(D.manifest.extensionPack)for(const V of D.manifest.extensionPack)T&&T.manifest.extensionPack&&T.manifest.extensionPack.some(G=>(0,R.areSameExtensions)({id:G},{id:V}))||N.every(G=>!(0,R.areSameExtensions)({id:G},{id:V}))&&N.push(V);if(N.length){const V=await this.getInstalled(),G=N.filter(J=>V.every(({identifier:Q})=>!(0,R.areSameExtensions)(Q,{id:J})));if(G.length){const Q=(await this.galleryService.query({names:G,pageSize:N.length},h.CancellationToken.None)).firstPage;try{await y.Promises.settled(Q.map(ne=>this.installFromGallery(ne,F)))}catch(ne){try{await this.rollback(Q)}catch(ie){}throw ne}}}}}async rollback(D){const F=(await this.getInstalled(1)).filter(N=>D.some(V=>new R.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version).equals(new R.ExtensionIdentifierWithVersion(V.identifier,V.version))));await y.Promises.settled(F.map(N=>this.uninstall(N)))}async uninstall(D,T={}){this.logService.trace("ExtensionManagementService#uninstall",D.identifier.id);const F=await this.getInstalled(1),N=F.find(V=>(0,R.areSameExtensions)(V.identifier,D.identifier));if(!N)throw new Error(k.localize(11,null,D.manifest.displayName||D.manifest.name));try{await this.checkForDependenciesAndUninstall(N,F,T)}catch(V){throw this.joinErrors(V)}}async updateMetadata(D,T){return this.logService.trace("ExtensionManagementService#updateMetadata",D.identifier.id),D=await this.extensionsScanner.saveMetadataForLocalExtension(D,Object.assign(Object.assign({},D.manifest.__metadata||{}),T)),this.manifestCache.invalidate(),D}async updateExtensionScope(D,T){return this.logService.trace("ExtensionManagementService#updateExtensionScope",D.identifier.id),D=await this.extensionsScanner.saveMetadataForLocalExtension(D,Object.assign(Object.assign({},D.manifest.__metadata||{}),{isMachineScoped:T})),this.manifestCache.invalidate(),D}async getGalleryMetadata(D){const T=await this.findGalleryExtensionByName(D);return T?{id:T.identifier.uuid,publisherDisplayName:T.publisherDisplayName,publisherId:T.publisherId}:void 0}async findGalleryExtension(D){if(D.identifier.uuid){const T=await this.findGalleryExtensionById(D.identifier.uuid);return T||this.findGalleryExtensionByName(D.identifier.id)}return this.findGalleryExtensionByName(D.identifier.id)}async findGalleryExtensionById(D){return(await this.galleryService.query({ids:[D],pageSize:1},h.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(D){return(await this.galleryService.query({names:[D],pageSize:1},h.CancellationToken.None)).firstPage[0]}joinErrors(D){const T=Array.isArray(D)?D:[D];return T.length===1?T[0]instanceof Error?T[0]:new Error(T[0]):T.reduce((F,N)=>new Error(`${F.message}${F.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}async checkForDependenciesAndUninstall(D,T,F){try{await this.preUninstallExtension(D);const N=F.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(D,T);await this.uninstallExtensions(D,N,T,F)}catch(N){throw await this.postUninstallExtension(D,new v.ExtensionManagementError(N instanceof Error?N.message:N,W)),N}await this.postUninstallExtension(D)}async uninstallExtensions(D,T,F,N){const V=[D,...T];if(!N.donotCheckDependents)for(const G of V)this.checkForDependents(G,V,F,D);await y.Promises.settled([this.uninstallExtension(D),...T.map(G=>this.doUninstall(G))])}checkForDependents(D,T,F,N){const V=this.getDependents(D,F);if(V.length){const G=V.filter(J=>T.indexOf(J)===-1);if(G.length)throw new Error(this.getDependentsErrorMessage(D,G,N))}}getDependentsErrorMessage(D,T,F){return F===D?T.length===1?k.localize(12,null,F.manifest.displayName||F.manifest.name,T[0].manifest.displayName||T[0].manifest.name):T.length===2?k.localize(13,null,F.manifest.displayName||F.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name):k.localize(14,null,F.manifest.displayName||F.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name):T.length===1?k.localize(15,null,F.manifest.displayName||F.manifest.name,D.manifest.displayName||D.manifest.name,T[0].manifest.displayName||T[0].manifest.name):T.length===2?k.localize(16,null,F.manifest.displayName||F.manifest.name,D.manifest.displayName||D.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name):k.localize(17,null,F.manifest.displayName||F.manifest.name,D.manifest.displayName||D.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name)}getAllPackExtensionsToUninstall(D,T,F=[]){if(F.indexOf(D)!==-1)return[];F.push(D);const N=D.manifest.extensionPack?D.manifest.extensionPack:[];if(N.length){const V=T.filter(J=>!J.isBuiltin&&N.some(Q=>(0,R.areSameExtensions)({id:Q},J.identifier))),G=[];for(const J of V)G.push(...this.getAllPackExtensionsToUninstall(J,T,F));return[...V,...G]}return[]}getDependents(D,T){return T.filter(F=>F.manifest.extensionDependencies&&F.manifest.extensionDependencies.some(N=>(0,R.areSameExtensions)({id:N},D.identifier)))}async doUninstall(D){try{await this.preUninstallExtension(D),await this.uninstallExtension(D)}catch(T){throw await this.postUninstallExtension(D,new v.ExtensionManagementError(T instanceof Error?T.message:T,W)),T}await this.postUninstallExtension(D)}async preUninstallExtension(D){if(!await L.exists(D.location.fsPath))throw new Error(k.localize(18,null));this.logService.info("Uninstalling extension:",D.identifier.id),this._onUninstallExtension.fire(D.identifier)}async uninstallExtension(D){let T=this.uninstallingExtensions.get(D.identifier.id);return T||(T=(0,y.createCancelablePromise)(async()=>{const F=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...F.filter(N=>(0,R.areSameExtensions)(N.identifier,D.identifier)))}),this.uninstallingExtensions.set(D.identifier.id,T),T.finally(()=>this.uninstallingExtensions.delete(D.identifier.id))),T}async postUninstallExtension(D,T){if(T)this.logService.error("Failed to uninstall extension:",D.identifier.id,T.message);else if(this.logService.info("Successfully uninstalled extension:",D.identifier.id),D.identifier.uuid)try{await this.galleryService.reportStatistic(D.manifest.publisher,D.manifest.name,D.manifest.version,"uninstall")}catch(N){}this.reportTelemetry("extensionGallery:uninstall",(0,R.getLocalExtensionTelemetryData)(D),void 0,T);const F=T?T instanceof v.ExtensionManagementError?T.code:$:void 0;this._onDidUninstallExtension.fire({identifier:D.identifier,error:F})}getInstalled(D=null){return this.extensionsScanner.scanExtensions(D)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(D){return(await this.filterUninstalled(D)).length===1}async filterUninstalled(...D){const T=[],F=await this.extensionsScanner.getUninstalledExtensions();for(const N of D)F[N.key()]&&T.push(N.key());return T}getExtensionsReport(){const D=new Date().getTime();return(!this.reportedExtensions||D-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=D),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const D=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${D.length} reported extensions from service`),D}catch(D){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(D,T,F,N){const V=N?N instanceof v.ExtensionManagementError?N.code:$:void 0;this.telemetryService.publicLogError(D,Object.assign(Object.assign({},T),{success:!N,duration:F,errorcode:V}))}};H=he([Y(0,f.INativeEnvironmentService),Y(1,v.IExtensionGalleryService),Y(2,p.ILogService),Y(3,(0,r.optional)(o.IDownloadService)),Y(4,s.ITelemetryService),Y(5,r.IInstantiationService),Y(6,z.IFileService)],H),e.ExtensionManagementService=H}),define(Z[203],ee([0,1,27,38,204,99,51,98,34,74,50,147,9,127,129,29,198,170,24,161,40,162,25,58,168,78,79,173,17,75,154,55,2,163,70,159,158,141,140,149,148,169,69,155,10,157,16,28,20,191,193,188,57,189,194,167,19,165,190,59,187,171,60,71,131,195,172,83,82,81,5,150,142,11,43,80,176,175,192,138,144,174,4,12]),function(K,e,S,k,A,L,U,O,g,v,R,f,y,I,a,b,C,E,p,m,c,s,t,i,n,o,r,l,h,d,w,u,P,_,z,B,M,j,W,$,H,q,D,T,F,N,V,G,J,Q,ne,ie,ce,ue,ge,Ee,Ie,Oe,Ae,Ue,ke,Ne,De,Te,Ge,Ke,ze,$e,X,re,se,me,x,te,oe,ae,le,fe,ve,Se,we,be,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class pe extends P.Disposable{constructor(de){super();this.configuration=de,this.server=this._register(new O.Server),(0,A.gracefulify)(S),this.registerListeners()}registerListeners(){const de=()=>this.dispose();process.once("exit",de),L.ipcRenderer.once("vscode:electron-main->shared-process=exit",de)}async open(){const de=await this.initServices();(0,J.registerConfiguration)(),de.invokeFunction(Le=>{const _e=Le.get(h.ILogService);_e.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Le),this.registerErrorHandler(_e)}),this._register((0,P.combinedDisposable)(de.createInstance(B.NodeCachedDataCleaner,this.configuration.nodeCachedDataDir),de.createInstance(M.LanguagePackCachedDataCleaner),de.createInstance(j.StorageDataCleaner,this.configuration.backupWorkspacesPath),de.createInstance(W.LogsDataCleaner),de.createInstance(me.LocalizationsUpdater),de.createInstance(x.DeprecatedExtensionsCleaner)))}async initServices(){const de=new v.ServiceCollection,Le=Object.assign({_serviceBrand:void 0},U.default);de.set(G.IProductService,Le);const _e=new g.StaticRouter(qe=>qe==="main"),Fe=new H.MessagePortMainProcessService(this.server,_e);de.set($.IMainProcessService,Fe);const Me=new I.NativeEnvironmentService(this.configuration.args,Le);de.set(y.INativeEnvironmentService,Me);const Qe=new d.LogLevelChannelClient(this.server.getChannel("logLevel",_e)),Ye=new d.LoggerChannelClient(this.configuration.logLevel,Qe.onDidChangeLogLevel,Fe.getChannel("logger"));de.set(h.ILoggerService,Ye);const tt=this._register(new h.MultiplexLogService([this._register(new h.ConsoleLogger(this.configuration.logLevel)),this._register(Ye.createLogger((0,ye.joinPath)(Pe.URI.file(Me.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Be=this._register(new d.FollowerLogService(Qe,tt));de.set(h.ILogService,Be);const We=this._register(new T.FileService(Be));de.set(F.IFileService,We);const it=this._register(new N.DiskFileSystemProvider(Be));We.registerProvider(V.Schemas.file,it);const xe=this._register(new m.ConfigurationService(Me.settingsResource,We));de.set(p.IConfigurationService,xe),await xe.initialize();const Je=new Ee.NativeStorageService(void 0,Fe,Me);de.set(Ie.IStorageService,Je),await Je.initialize(),this._register((0,P.toDisposable)(()=>Je.flush())),de.set(c.IRequestService,new R.SyncDescriptor(s.RequestService)),de.set(Se.IChecksumService,new R.SyncDescriptor(we.ChecksumService));const Ze=g.ProxyChannel.toService(Fe.getChannel("nativeHost"),{context:this.configuration.windowId});de.set(ce.INativeHostService,Ze),de.set(z.IDownloadService,new R.SyncDescriptor(_.DownloadService));const nt=this._register(new Ke.ActiveWindowManager(Ze)),ut=new g.StaticRouter(qe=>nt.getActiveClientId().then(rt=>qe===rt));de.set(Te.IExtensionRecommendationNotificationService,new Ge.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));let et,Ve;if(!Me.isExtensionDevelopment&&!Me.disableTelemetry&&Le.enableTelemetry){Ve=new ze.TelemetryLogAppender(Ye,Me);const{appRoot:qe,extensionsPath:rt,isBuilt:dt,installSourcePath:ft}=Me;if(Le.aiConfig&&Le.aiConfig.asimovKey&&dt){const at=new l.AppInsightsAppender("monacoworkbench",null,Le.aiConfig.asimovKey);this._register((0,P.toDisposable)(()=>at.flush())),Ve=(0,i.combinedAppender)(at,Ve)}et=new r.TelemetryService({appender:Ve,commonProperties:(0,n.resolveCommonProperties)(We,(0,k.release)(),process.arch,Le.commit,Le.version,this.configuration.machineId,Le.msftInternalDomains,ft),sendErrorTelemetry:!0,piiPaths:[qe,rt]},xe)}else et=i.NullTelemetryService,Ve=i.NullAppender;this.server.registerChannel("telemetryAppender",new o.TelemetryAppenderChannel(Ve)),de.set(t.ITelemetryService,et);const ht=new be.CustomEndpointTelemetryService(xe,et);return de.set(t.ICustomEndpointTelemetryService,ht),de.set(b.IExtensionManagementService,new R.SyncDescriptor(C.ExtensionManagementService)),de.set(b.IExtensionGalleryService,new R.SyncDescriptor(E.ExtensionGalleryService)),de.set(b.IExtensionTipsService,new R.SyncDescriptor(Ne.ExtensionTipsService)),de.set(u.ILocalizationsService,new R.SyncDescriptor(w.LocalizationsService)),de.set(D.IDiagnosticsService,new R.SyncDescriptor(q.DiagnosticsService)),de.set(Ue.IUserDataSyncAccountService,new R.SyncDescriptor(Ue.UserDataSyncAccountService)),de.set(J.IUserDataSyncLogService,new R.SyncDescriptor(ue.UserDataSyncLogService)),de.set(J.IUserDataSyncUtilService,new ie.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",qe=>qe.ctx!=="main"))),de.set(b.IGlobalExtensionEnablementService,new R.SyncDescriptor(Oe.GlobalExtensionEnablementService)),de.set(X.IIgnoredExtensionsManagementService,new R.SyncDescriptor(X.IgnoredExtensionsManagementService)),de.set(re.IExtensionsStorageSyncService,new R.SyncDescriptor(re.ExtensionsStorageSyncService)),de.set(J.IUserDataSyncStoreManagementService,new R.SyncDescriptor(ne.UserDataSyncStoreManagementService)),de.set(J.IUserDataSyncStoreService,new R.SyncDescriptor(ne.UserDataSyncStoreService)),de.set(De.IUserDataSyncMachinesService,new R.SyncDescriptor(De.UserDataSyncMachinesService)),de.set(J.IUserDataSyncBackupStoreService,new R.SyncDescriptor(ke.UserDataSyncBackupStoreService)),de.set(J.IUserDataAutoSyncEnablementService,new R.SyncDescriptor($e.UserDataAutoSyncEnablementService)),de.set(J.IUserDataSyncResourceEnablementService,new R.SyncDescriptor(Ae.UserDataSyncResourceEnablementService)),de.set(J.IUserDataSyncService,new R.SyncDescriptor(Q.UserDataSyncService)),de.set(fe.ILocalPtyService,this._register(new le.PtyHostService(Be))),new f.InstantiationService(de)}initChannels(de){const Le=new a.ExtensionManagementChannel(de.get(b.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Le);const _e=g.ProxyChannel.fromService(de.get(u.ILocalizationsService));this.server.registerChannel("localizations",_e);const Fe=g.ProxyChannel.fromService(de.get(D.IDiagnosticsService));this.server.registerChannel("diagnostics",Fe);const Me=new a.ExtensionTipsChannel(de.get(b.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Me);const Qe=g.ProxyChannel.fromService(de.get(Se.IChecksumService));this.server.registerChannel("checksum",Qe);const Ye=new ie.UserDataSyncMachinesServiceChannel(de.get(De.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ye);const tt=g.ProxyChannel.fromService(de.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",tt);const Be=new ie.UserDataSyncAccountServiceChannel(de.get(Ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Be);const We=new ie.UserDataSyncStoreManagementServiceChannel(de.get(J.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",We);const it=new ve.UserDataSyncChannel(de.get(J.IUserDataSyncService),de.get(h.ILogService));this.server.registerChannel("userDataSync",it);const xe=this._register(de.get(se.IInstantiationService).createInstance(ge.UserDataAutoSyncService)),Je=new ie.UserDataAutoSyncChannel(xe);this.server.registerChannel("userDataAutoSync",Je);const Ze=de.get(fe.ILocalPtyService),nt=g.ProxyChannel.fromService(Ze);this.server.registerChannel(ae.TerminalIpcChannels.LocalPty,nt)}registerErrorHandler(de){window.addEventListener("unhandledrejection",Le=>{(0,te.onUnexpectedError)(Le.reason),Le.preventDefault()}),(0,te.setUnexpectedErrorHandler)(Le=>{const _e=(0,oe.toErrorMessage)(Le,!0);!_e||de.error(`[uncaught exception in sharedProcess]: ${_e}`)})}}async function Ce(Re){const de=new pe(Re);L.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await de.open(),L.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Ce})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8aff878db2542eea2dfb571c8bb485118bbb3113/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
