/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var X=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/base/common/types","electron","vs/nls","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/errors","fs","vs/base/node/pfs","vs/platform/product/common/productService","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","os","vs/base/common/uuid","vs/platform/workspaces/common/workspaces","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/node/state","vs/base/common/labels","vs/platform/update/common/update","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","child_process","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/environment/node/shellEnv","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/tunnel","vs/platform/sign/common/sign","vs/platform/theme/electron-main/themeMainService","vs/platform/webview/common/webviewManagerService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","vs/base/node/extpath","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],J=function(j){for(var e=[],m=0,D=j.length;m<D;m++)e[m]=X[j[m]];return e};define(X[100],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(D,k){if(!D)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=m}),define(X[53],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function m(p){return(i,L,g)=>{let b=null,v=null;if(typeof g.value=="function"?(b="value",v=g.value):typeof g.get=="function"&&(b="get",v=g.get),!v)throw new Error("not supported");g[b]=p(v,L)}}e.createDecorator=m;let D=0;function k(){const p=`$memoize${D++}`;let i;const L=function(b,v,d){let w=null,I=null;if(typeof d.value=="function"?(w="value",I=d.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(w="get",I=d.get),!I)throw new Error("not supported");const E=`${p}:${v}`;d[w]=function(...o){return i=this,this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!0,enumerable:!1,writable:!0,value:I.apply(this,o)}),this[E]}};return L.clear=()=>{typeof i!="undefined"&&Object.getOwnPropertyNames(i).forEach(g=>{g.indexOf(p)===0&&delete i[g]})},L}e.createMemoizer=k;function y(p,i,L){return k()(p,i,L)}e.memoize=y;function P(p,i,L){return m((g,b)=>{const v=`$debounce$${b}`,d=`$debounce$result$${b}`;return function(...w){this[d]||(this[d]=L?L():void 0),clearTimeout(this[v]),i&&(this[d]=i(this[d],...w),w=[this[d]]),this[v]=setTimeout(()=>{g.apply(this,w),this[d]=L?L():void 0},p)}})}e.debounce=P;function r(p,i,L){return m((g,b)=>{const v=`$throttle$timer$${b}`,d=`$throttle$result$${b}`,w=`$throttle$lastRun$${b}`,I=`$throttle$pending$${b}`;return function(...E){if(this[d]||(this[d]=L?L():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),i&&(this[d]=i(this[d],...E)),!this[I]){const o=this[w]+p;o<=Date.now()?(this[w]=Date.now(),g.apply(this,[this[d]]),this[d]=L?L():void 0):(this[I]=!0,this[v]=setTimeout(()=>{this[I]=!1,this[w]=Date.now(),g.apply(this,[this[d]]),this[d]=L?L():void 0},o-Date.now()))}}})}e.throttle=r}),define(X[17],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function D(h){e.errorHandler.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=D;function k(h){p(h)||e.errorHandler.onUnexpectedError(h)}e.onUnexpectedError=k;function y(h){p(h)||e.errorHandler.onUnexpectedExternalError(h)}e.onUnexpectedExternalError=y;function P(h){if(h instanceof Error){let{name:t,message:n}=h;const s=h.stacktrace||h.stack;return{$isError:!0,name:t,message:n,stack:s}}return h}e.transformErrorForSerialization=P;const r="Canceled";function p(h){return h instanceof Error&&h.name===r&&h.message===r}e.isPromiseCanceledError=p;class i extends Error{constructor(){super(r);this.name=this.message}}e.CancellationError=i;function L(){const h=new Error(r);return h.name=h.message,h}e.canceled=L;function g(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.illegalArgument=g;function b(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.illegalState=b;function v(h){return h?new Error(`readonly property '${h} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function d(h){const t=new Error(`${h} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function w(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.getErrorMessage=w;class I extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=I;class E extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=E;class o extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=o;function c(h){const t=h;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function a(h,t=Object.create(null)){const n=new Error(h);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=a}),define(X[35],J([0,1,17]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function D(C,q=0){return C[C.length-(1+q)]}e.tail=D;function k(C){if(C.length===0)throw new Error("Invalid tail call");return[C.slice(0,C.length-1),C[C.length-1]]}e.tail2=k;function y(C,q,N=(_,R)=>_===R){if(C===q)return!0;if(!C||!q||C.length!==q.length)return!1;for(let _=0,R=C.length;_<R;_++)if(!N(C[_],q[_]))return!1;return!0}e.equals=y;function P(C,q,N){let _=0,R=C.length-1;for(;_<=R;){const W=(_+R)/2|0,M=N(C[W],q);if(M<0)_=W+1;else if(M>0)R=W-1;else return W}return-(_+1)}e.binarySearch=P;function r(C,q){let N=0,_=C.length;if(_===0)return 0;for(;N<_;){const R=Math.floor((N+_)/2);q(C[R])?_=R:N=R+1}return N}e.findFirstInSorted=r;function p(C,q,N){if(C=C|0,C>=q.length)throw new TypeError("invalid index");let _=q[Math.floor(q.length*Math.random())],R=[],W=[],M=[];for(let F of q){const B=N(F,_);B<0?R.push(F):B>0?W.push(F):M.push(F)}return C<R.length?p(C,R,N):C<R.length+M.length?M[0]:p(C-(R.length+M.length),W,N)}e.quickSelect=p;function i(C,q){const N=[];let _;for(const R of C.slice(0).sort(q))!_||q(_[0],R)!==0?(_=[R],N.push(_)):_.push(R);return N}e.groupBy=i;function L(C,q,N){const _=[];function R(F,B,V){if(!(B===0&&V.length===0)){const G=_[_.length-1];G&&G.start+G.deleteCount===F?(G.deleteCount+=B,G.toInsert.push(...V)):_.push({start:F,deleteCount:B,toInsert:V})}}let W=0,M=0;for(;;){if(W===C.length){R(W,0,q.slice(M));break}if(M===q.length){R(W,C.length-W,[]);break}const F=C[W],B=q[M],V=N(F,B);V===0?(W+=1,M+=1):V<0?(R(W,1,[]),W+=1):V>0&&(R(W,0,[B]),M+=1)}return _}e.sortedDiff=L;function g(C,q,N){const _=L(C,q,N),R=[],W=[];for(const M of _)R.push(...C.slice(M.start,M.start+M.deleteCount)),W.push(...M.toInsert);return{removed:R,added:W}}e.delta=g;function b(C,q,N){if(N===0)return[];const _=C.slice(0,N).sort(q);return d(C,q,_,N,C.length),_}e.top=b;function v(C,q,N,_,R){return N===0?Promise.resolve([]):new Promise((W,M)=>{(async()=>{const F=C.length,B=C.slice(0,N).sort(q);for(let V=N,G=Math.min(N+_,F);V<F;V=G,G=Math.min(G+_,F)){if(V>N&&await new Promise(Y=>setTimeout(Y)),R&&R.isCancellationRequested)throw(0,m.canceled)();d(C,q,B,V,G)}return B})().then(W,M)})}e.topAsync=v;function d(C,q,N,_,R){for(const W=N.length;_<R;_++){const M=C[_];if(q(M,N[W-1])<0){N.pop();const F=r(N,B=>q(M,B)<0);N.splice(F,0,M)}}}function w(C){return C.filter(q=>!!q)}e.coalesce=w;function I(C){let q=0;for(let N=0;N<C.length;N++)C[N]&&(C[q]=C[N],q+=1);C.length=q}e.coalesceInPlace=I;function E(C,q,N){C.splice(N,0,C.splice(q,1)[0])}e.move=E;function o(C){return!Array.isArray(C)||C.length===0}e.isFalsyOrEmpty=o;function c(C){return Array.isArray(C)&&C.length>0}e.isNonEmptyArray=c;function a(C,q){if(!q)return C.filter((_,R)=>C.indexOf(_)===R);const N=Object.create(null);return C.filter(_=>{const R=q(_);return N[R]?!1:(N[R]=!0,!0)})}e.distinct=a;function h(C){const q=new Set;return C.filter(N=>q.has(N)?!1:(q.add(N),!0))}e.distinctES6=h;function t(C){const q=Object.create(null);return N=>{const _=C(N);return q[_]?!1:(q[_]=!0,!0)}}e.uniqueFilter=t;function n(C,q){for(let N=C.length-1;N>=0;N--){const _=C[N];if(q(_))return N}return-1}e.lastIndex=n;function s(C,q){return C.length>0?C[0]:q}e.firstOrDefault=s;function l(C,q,N=(_,R)=>_===R){let _=0;for(let R=0,W=Math.min(C.length,q.length);R<W&&N(C[R],q[R]);R++)_++;return _}e.commonPrefixLength=l;function u(C){return[].concat(...C)}e.flatten=u;function f(C,q){let N=typeof q=="number"?C:0;typeof q=="number"?N=C:(N=0,q=C);const _=[];if(N<=q)for(let R=N;R<q;R++)_.push(R);else for(let R=N;R>q;R--)_.push(R);return _}e.range=f;function S(C,q,N){return C.reduce((_,R)=>(_[q(R)]=N?N(R):R,_),Object.create(null))}e.index=S;function A(C,q){return C.push(q),()=>T(C,q)}e.insert=A;function T(C,q){const N=C.indexOf(q);if(N>-1)return C.splice(N,1),q}e.remove=T;function U(C,q,N){const _=C.slice(0,q),R=C.slice(q);return _.concat(N,R)}e.arrayInsert=U;function H(C,q){let N;if(typeof q=="number"){let _=q;N=()=>{const R=Math.sin(_++)*179426549;return R-Math.floor(R)}}else N=Math.random;for(let _=C.length-1;_>0;_-=1){const R=Math.floor(N()*(_+1)),W=C[_];C[_]=C[R],C[R]=W}}e.shuffle=H;function Q(C,q){const N=C.indexOf(q);N>-1&&(C.splice(N,1),C.unshift(q))}e.pushToStart=Q;function ne(C,q){const N=C.indexOf(q);N>-1&&(C.splice(N,1),C.push(q))}e.pushToEnd=ne;function ae(C,q){return Array.isArray(C)?C.map(q):q(C)}e.mapArrayOrNot=ae;function O(C){return Array.isArray(C)?C:[C]}e.asArray=O;function $(C){return C[Math.floor(Math.random()*C.length)]}e.getRandomElement=$;function z(C,q){for(const N of C){const _=q(N);if(_!==void 0)return _}}e.mapFind=z}),define(X[42],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(D){const k=this;let y=!1,P;return function(){return y||(y=!0,P=D.apply(k,arguments)),P}}e.once=m}),define(X[62],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(D){function k(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}D.is=k;const y=Object.freeze([]);function P(){return y}D.empty=P;function*r(h){yield h}D.single=r;function p(h){return h||y}D.from=p;function i(h){return!h||h[Symbol.iterator]().next().done===!0}D.isEmpty=i;function L(h){return h[Symbol.iterator]().next().value}D.first=L;function g(h,t){for(const n of h)if(t(n))return!0;return!1}D.some=g;function b(h,t){for(const n of h)if(t(n))return n}D.find=b;function*v(h,t){for(const n of h)t(n)&&(yield n)}D.filter=v;function*d(h,t){for(const n of h)yield t(n)}D.map=d;function*w(...h){for(const t of h)for(const n of t)yield n}D.concat=w;function*I(h){for(const t of h)for(const n of t)yield n}D.concatNested=I;function E(h,t,n){let s=n;for(const l of h)s=t(s,l);return s}D.reduce=E;function*o(h,t,n=h.length){for(t<0&&(t+=h.length),n<0?n+=h.length:n>h.length&&(n=h.length);t<n;t++)yield h[t]}D.slice=o;function c(h,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,h];const s=h[Symbol.iterator]();for(let l=0;l<t;l++){const u=s.next();if(u.done)return[n,D.empty()];n.push(u.value)}return[n,{[Symbol.iterator](){return s}}]}D.consume=c;function a(h,t,n=(s,l)=>s===l){const s=h[Symbol.iterator](),l=t[Symbol.iterator]();for(;;){const u=s.next(),f=l.next();if(u.done!==f.done)return!1;if(u.done)return!0;if(!n(u.value,f.value))return!1}}D.equals=a})(m=e.Iterable||(e.Iterable={}))}),define(X[43],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function P(t,n=!1){let s=0,l=t.length,u="",f=0,S=16,A=0;function T($){let z=0,C=0;for(;z<$;){const q=t.charCodeAt(s);if(q>=48&&q<=57)C=C*16+q-48;else if(q>=65&&q<=70)C=C*16+q-65+10;else if(q>=97&&q<=102)C=C*16+q-97+10;else break;s++,z++}return z<$&&(C=-1),C}function U($){s=$,u="",f=0,S=16,A=0}function H(){const $=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&i(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&i(t.charCodeAt(s)))for(s++;s<t.length&&i(t.charCodeAt(s));)s++;else return A=3,t.substring($,s);let z=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&i(t.charCodeAt(s))){for(s++;s<t.length&&i(t.charCodeAt(s));)s++;z=s}else A=3;return t.substring($,z)}function Q(){let $="",z=s;for(;;){if(s>=l){$+=t.substring(z,s),A=2;break}const C=t.charCodeAt(s);if(C===34){$+=t.substring(z,s),s++;break}if(C===92){if($+=t.substring(z,s),s++,s>=l){A=2;break}switch(t.charCodeAt(s++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const N=T(4);N>=0?$+=String.fromCharCode(N):A=4;break;default:A=5}z=s;continue}if(C>=0&&C<=31)if(p(C)){$+=t.substring(z,s),A=2;break}else A=6;s++}return $}function ne(){if(u="",A=0,f=s,s>=l)return f=l,S=17;let $=t.charCodeAt(s);if(r($)){do s++,u+=String.fromCharCode($),$=t.charCodeAt(s);while(r($));return S=15}if(p($))return s++,u+=String.fromCharCode($),$===13&&t.charCodeAt(s)===10&&(s++,u+=`
`),S=14;switch($){case 123:return s++,S=1;case 125:return s++,S=2;case 91:return s++,S=3;case 93:return s++,S=4;case 58:return s++,S=6;case 44:return s++,S=5;case 34:return s++,u=Q(),S=10;case 47:const z=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<l&&!p(t.charCodeAt(s));)s++;return u=t.substring(z,s),S=12}if(t.charCodeAt(s+1)===42){s+=2;const C=l-1;let q=!1;for(;s<C;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,q=!0;break}s++}return q||(s++,A=1),u=t.substring(z,s),S=13}return u+=String.fromCharCode($),s++,S=16;case 45:if(u+=String.fromCharCode($),s++,s===l||!i(t.charCodeAt(s)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=H(),S=11;default:for(;s<l&&ae($);)s++,$=t.charCodeAt(s);if(f!==s){switch(u=t.substring(f,s),u){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return u+=String.fromCharCode($),s++,S=16}}function ae($){if(r($)||p($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function O(){let $;do $=ne();while($>=12&&$<=15);return $}return{setPosition:U,getPosition:()=>s,scan:n?O:ne,getToken:()=>S,getTokenValue:()=>u,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>A}}e.createScanner=P;function r(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function i(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function g(t,n){const s=[],l=new Object;let u;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function A(T,U,H,Q){f.value=T,f.offset=U,f.length=H,f.type=Q,f.colonOffset=void 0,u=f}try{c(t,{onObjectBegin:(T,U)=>{if(n<=T)throw l;u=void 0,S=n>T,s.push("")},onObjectProperty:(T,U,H)=>{if(n<U||(A(T,U,H,"property"),s[s.length-1]=T,n<=U+H))throw l},onObjectEnd:(T,U)=>{if(n<=T)throw l;u=void 0,s.pop()},onArrayBegin:(T,U)=>{if(n<=T)throw l;u=void 0,s.push(0)},onArrayEnd:(T,U)=>{if(n<=T)throw l;u=void 0,s.pop()},onLiteralValue:(T,U,H)=>{if(n<U||(A(T,U,H,h(T)),n<=U+H))throw l},onSeparator:(T,U,H)=>{if(n<=U)throw l;if(T===":"&&u&&u.type==="property")u.colonOffset=U,S=!1,u=void 0;else if(T===","){const Q=s[s.length-1];typeof Q=="number"?s[s.length-1]=Q+1:(S=!0,s[s.length-1]=""),u=void 0}}})}catch(T){if(T!==l)throw T}return{path:s,previousNode:u,isAtPropertyKey:S,matches:T=>{let U=0;for(let H=0;U<T.length&&H<s.length;H++)if(T[U]===s[H]||T[U]==="*")U++;else if(T[U]!=="**")return!1;return U===T.length}}}e.getLocation=g;function b(t,n=[],s=y.DEFAULT){let l=null,u=[];const f=[];function S(T){Array.isArray(u)?u.push(T):l!==null&&(u[l]=T)}return c(t,{onObjectBegin:()=>{const T={};S(T),f.push(u),u=T,l=null},onObjectProperty:T=>{l=T},onObjectEnd:()=>{u=f.pop()},onArrayBegin:()=>{const T=[];S(T),f.push(u),u=T,l=null},onArrayEnd:()=>{u=f.pop()},onLiteralValue:S,onError:(T,U,H)=>{n.push({error:T,offset:U,length:H})}},s),u[0]}e.parse=b;function v(t,n=[],s=y.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(T){l.type==="property"&&(l.length=T-l.offset,l=l.parent)}function f(T){return l.children.push(T),T}c(t,{onObjectBegin:T=>{l=f({type:"object",offset:T,length:-1,parent:l,children:[]})},onObjectProperty:(T,U,H)=>{l=f({type:"property",offset:U,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:T,offset:U,length:H,parent:l})},onObjectEnd:(T,U)=>{l.length=T+U-l.offset,l=l.parent,u(T+U)},onArrayBegin:(T,U)=>{l=f({type:"array",offset:T,length:-1,parent:l,children:[]})},onArrayEnd:(T,U)=>{l.length=T+U-l.offset,l=l.parent,u(T+U)},onLiteralValue:(T,U,H)=>{f({type:h(T),offset:U,length:H,parent:l,value:T}),u(U+H)},onSeparator:(T,U,H)=>{l.type==="property"&&(T===":"?l.colonOffset=U:T===","&&u(U))},onError:(T,U,H)=>{n.push({error:T,offset:U,length:H})}},s);const A=l.children[0];return A&&delete A.parent,A}e.parseTree=v;function d(t,n){if(!!t){let s=t;for(let l of n)if(typeof l=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let u=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===l){s=f.children[1],u=!0;break}if(!u)return}else{const u=l;if(s.type!=="array"||u<0||!Array.isArray(s.children)||u>=s.children.length)return;s=s.children[u]}return s}}e.findNodeAtLocation=d;function w(t){if(!t.parent||!t.parent.children)return[];const n=w(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;n.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&n.push(s)}return n}e.getNodePath=w;function I(t){switch(t.type){case"array":return t.children.map(I);case"object":const n=Object.create(null);for(let s of t.children){const l=s.children[1];l&&(n[s.children[0].value]=I(l))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=I;function E(t,n,s=!1){return n>=t.offset&&n<t.offset+t.length||s&&n===t.offset+t.length}e.contains=E;function o(t,n,s=!1){if(E(t,n,s)){const l=t.children;if(Array.isArray(l))for(let u=0;u<l.length&&l[u].offset<=n;u++){const f=o(l[u],n,s);if(f)return f}return t}}e.findNodeAtOffset=o;function c(t,n,s=y.DEFAULT){const l=P(t,!1);function u(B){return B?()=>B(l.getTokenOffset(),l.getTokenLength()):()=>!0}function f(B){return B?V=>B(V,l.getTokenOffset(),l.getTokenLength()):()=>!0}const S=u(n.onObjectBegin),A=f(n.onObjectProperty),T=u(n.onObjectEnd),U=u(n.onArrayBegin),H=u(n.onArrayEnd),Q=f(n.onLiteralValue),ne=f(n.onSeparator),ae=u(n.onComment),O=f(n.onError),$=s&&s.disallowComments,z=s&&s.allowTrailingComma;function C(){for(;;){const B=l.scan();switch(l.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:$||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(B){case 12:case 13:$?q(10):ae();break;case 16:q(1);break;case 15:case 14:break;default:return B}}}function q(B,V=[],G=[]){if(O(B),V.length+G.length>0){let Y=l.getToken();for(;Y!==17;){if(V.indexOf(Y)!==-1){C();break}else if(G.indexOf(Y)!==-1)break;Y=C()}}}function N(B){const V=l.getTokenValue();return B?Q(V):A(V),C(),!0}function _(){switch(l.getToken()){case 11:let B=0;try{B=JSON.parse(l.getTokenValue()),typeof B!="number"&&(q(2),B=0)}catch(V){q(2)}Q(B);break;case 7:Q(null);break;case 8:Q(!0);break;case 9:Q(!1);break;default:return!1}return C(),!0}function R(){return l.getToken()!==10?(q(3,[],[2,5]),!1):(N(!1),l.getToken()===6?(ne(":"),C(),F()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function W(){S(),C();let B=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(B||q(4,[],[]),ne(","),C(),l.getToken()===2&&z)break}else B&&q(6,[],[]);R()||q(4,[],[2,5]),B=!0}return T(),l.getToken()!==2?q(7,[2],[]):C(),!0}function M(){U(),C();let B=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(B||q(4,[],[]),ne(","),C(),l.getToken()===4&&z)break}else B&&q(6,[],[]);F()||q(4,[],[4,5]),B=!0}return H(),l.getToken()!==4?q(8,[4],[]):C(),!0}function F(){switch(l.getToken()){case 3:return M();case 1:return W();case 10:return N(!0);default:return _()}}return C(),l.getToken()===17?s.allowEmptyContent?!0:(q(4,[],[]),!1):F()?(l.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=c;function a(t,n){let s=P(t),l=[],u,f=0,S;do switch(S=s.getPosition(),u=s.scan(),u){case 12:case 13:case 17:f!==S&&l.push(t.substring(f,S)),n!==void 0&&l.push(s.getTokenValue().replace(/[^\r\n]/g,n)),f=s.getPosition();break}while(u!==17);return l.join("")}e.stripComments=a;function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=h}),define(X[101],J([0,1,43]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function D(p,i,L){let g,b,v,d,w;if(i){for(d=i.offset,w=d+i.length,v=d;v>0&&!r(p,v-1);)v--;let f=w;for(;f<p.length&&!r(p,f);)f++;b=p.substring(v,f),g=y(b,L)}else b=p,g=0,v=0,d=0,w=p.length;const I=P(L,p);let E=!1,o=0,c;L.insertSpaces?c=k(" ",L.tabSize||4):c="	";const a=(0,m.createScanner)(b,!1);let h=!1;function t(){return I+k(c,g+o)}function n(){let f=a.scan();for(E=!1;f===15||f===14;)E=E||f===14,f=a.scan();return h=f===16||a.getTokenError()!==0,f}const s=[];function l(f,S,A){!h&&S<w&&A>d&&p.substring(S,A)!==f&&s.push({offset:S,length:A-S,content:f})}let u=n();if(u!==17){const f=a.getTokenOffset()+v,S=k(c,g);l(S,v,f)}for(;u!==17;){let f=a.getTokenOffset()+a.getTokenLength()+v,S=n(),A="";for(;!E&&(S===12||S===13);){const U=a.getTokenOffset()+v;l(" ",f,U),f=a.getTokenOffset()+a.getTokenLength()+v,A=S===12?t():"",S=n()}if(S===2)u!==1&&(o--,A=t());else if(S===4)u!==3&&(o--,A=t());else{switch(u){case 3:case 1:o++,A=t();break;case 5:case 12:A=t();break;case 13:E?A=t():A=" ";break;case 6:A=" ";break;case 10:if(S===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?A=" ":S!==5&&S!==17&&(h=!0);break;case 16:h=!0;break}E&&(S===12||S===13)&&(A=t())}const T=a.getTokenOffset()+v;l(A,f,T),u=S}return s}e.format=D;function k(p,i){let L="";for(let g=0;g<i;g++)L+=p;return L}function y(p,i){let L=0,g=0;const b=i.tabSize||4;for(;L<p.length;){const v=p.charAt(L);if(v===" ")g++;else if(v==="	")g+=b;else break;L++}return Math.floor(g/b)}function P(p,i){for(let L=0;L<i.length;L++){const g=i.charAt(L);if(g==="\r")return L+1<i.length&&i.charAt(L+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return p&&p.eol||`
`}e.getEOL=P;function r(p,i){return`\r
`.indexOf(p.charAt(i))!==-1}e.isEOL=r}),define(X[102],J([0,1,43,101]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(i,L,g){return y(i,L,void 0,g)}e.removeProperty=k;function y(i,L,g,b,v){const d=L.slice(),w=[],I=(0,m.parseTree)(i,w);let E,o;for(;d.length>0&&(o=d.pop(),E=(0,m.findNodeAtLocation)(I,d),E===void 0&&g!==void 0);)typeof o=="string"?g={[o]:g}:g=[g];if(E)if(E.type==="object"&&typeof o=="string"&&Array.isArray(E.children)){const c=(0,m.findNodeAtLocation)(E,[o]);if(c!==void 0)if(g===void 0){if(!c.parent)throw new Error("Malformed AST");const a=E.children.indexOf(c.parent);let h,t=c.parent.offset+c.parent.length;if(a>0){const n=E.children[a-1];h=n.offset+n.length}else h=E.offset+1,E.children.length>1&&(t=E.children[1].offset);return P(i,{offset:h,length:t-h,content:""},b)}else return P(i,{offset:c.offset,length:c.length,content:JSON.stringify(g)},b);else{if(g===void 0)return[];const a=`${JSON.stringify(o)}: ${JSON.stringify(g)}`,h=v?v(E.children.map(n=>n.children[0].value)):E.children.length;let t;if(h>0){const n=E.children[h-1];t={offset:n.offset+n.length,length:0,content:","+a}}else E.children.length===0?t={offset:E.offset+1,length:0,content:a}:t={offset:E.offset+1,length:0,content:a+","};return P(i,t,b)}}else if(E.type==="array"&&typeof o=="number"&&Array.isArray(E.children))if(g!==void 0){const c=`${JSON.stringify(g)}`;let a;if(E.children.length===0||o===0)a={offset:E.offset+1,length:0,content:E.children.length===0?c:c+","};else{const h=o===-1||o>E.children.length?E.children.length:o,t=E.children[h-1];a={offset:t.offset+t.length,length:0,content:","+c}}return P(i,a,b)}else{const c=o,a=E.children[c];let h;if(E.children.length===1)h={offset:E.offset+1,length:E.length-2,content:""};else if(E.children.length-1===c){const t=E.children[c-1],n=t.offset+t.length,s=E.offset+E.length;h={offset:n,length:s-2-n,content:""}}else h={offset:a.offset,length:E.children[c+1].offset-a.offset,content:""};return P(i,h,b)}else throw new Error(`Can not add ${typeof o!="number"?"index":"property"} to parent of type ${E.type}`);else{if(g===void 0)throw new Error("Can not delete in empty document");return P(i,{offset:I?I.offset:0,length:I?I.length:0,content:JSON.stringify(g)},b)}}e.setProperty=y;function P(i,L,g){let b=r(i,L),v=L.offset,d=L.offset+L.content.length;if(L.length===0||L.content.length===0){for(;v>0&&!(0,D.isEOL)(b,v-1);)v--;for(;d<b.length&&!(0,D.isEOL)(b,d);)d++}const w=(0,D.format)(b,{offset:v,length:d-v},g);for(let E=w.length-1;E>=0;E--){const o=w[E];b=r(b,o),v=Math.min(v,o.offset),d=Math.max(d,o.offset+o.length),d+=o.content.length-o.length}const I=i.length-(b.length-d)-v;return[{offset:v,length:I,content:b.substring(v,d)}]}e.withFormatting=P;function r(i,L){return i.substring(0,L.offset)+L.content+i.substring(L.offset+L.length)}e.applyEdit=r;function p(i,L){let g=L.slice(0).sort((v,d)=>{const w=v.offset-d.offset;return w===0?v.length-d.length:w}),b=i.length;for(let v=g.length-1;v>=0;v--){let d=g[v];if(d.offset+d.length<=b)i=r(i,d);else throw new Error("Overlapping edit");b=d.offset}return i}e.applyEdits=p}),define(X[57],J([0,1,17]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var D;(function(o){o[o.DependsOnKbLayout=-1]="DependsOnKbLayout",o[o.Unknown=0]="Unknown",o[o.Backspace=1]="Backspace",o[o.Tab=2]="Tab",o[o.Enter=3]="Enter",o[o.Shift=4]="Shift",o[o.Ctrl=5]="Ctrl",o[o.Alt=6]="Alt",o[o.PauseBreak=7]="PauseBreak",o[o.CapsLock=8]="CapsLock",o[o.Escape=9]="Escape",o[o.Space=10]="Space",o[o.PageUp=11]="PageUp",o[o.PageDown=12]="PageDown",o[o.End=13]="End",o[o.Home=14]="Home",o[o.LeftArrow=15]="LeftArrow",o[o.UpArrow=16]="UpArrow",o[o.RightArrow=17]="RightArrow",o[o.DownArrow=18]="DownArrow",o[o.Insert=19]="Insert",o[o.Delete=20]="Delete",o[o.KEY_0=21]="KEY_0",o[o.KEY_1=22]="KEY_1",o[o.KEY_2=23]="KEY_2",o[o.KEY_3=24]="KEY_3",o[o.KEY_4=25]="KEY_4",o[o.KEY_5=26]="KEY_5",o[o.KEY_6=27]="KEY_6",o[o.KEY_7=28]="KEY_7",o[o.KEY_8=29]="KEY_8",o[o.KEY_9=30]="KEY_9",o[o.KEY_A=31]="KEY_A",o[o.KEY_B=32]="KEY_B",o[o.KEY_C=33]="KEY_C",o[o.KEY_D=34]="KEY_D",o[o.KEY_E=35]="KEY_E",o[o.KEY_F=36]="KEY_F",o[o.KEY_G=37]="KEY_G",o[o.KEY_H=38]="KEY_H",o[o.KEY_I=39]="KEY_I",o[o.KEY_J=40]="KEY_J",o[o.KEY_K=41]="KEY_K",o[o.KEY_L=42]="KEY_L",o[o.KEY_M=43]="KEY_M",o[o.KEY_N=44]="KEY_N",o[o.KEY_O=45]="KEY_O",o[o.KEY_P=46]="KEY_P",o[o.KEY_Q=47]="KEY_Q",o[o.KEY_R=48]="KEY_R",o[o.KEY_S=49]="KEY_S",o[o.KEY_T=50]="KEY_T",o[o.KEY_U=51]="KEY_U",o[o.KEY_V=52]="KEY_V",o[o.KEY_W=53]="KEY_W",o[o.KEY_X=54]="KEY_X",o[o.KEY_Y=55]="KEY_Y",o[o.KEY_Z=56]="KEY_Z",o[o.Meta=57]="Meta",o[o.ContextMenu=58]="ContextMenu",o[o.F1=59]="F1",o[o.F2=60]="F2",o[o.F3=61]="F3",o[o.F4=62]="F4",o[o.F5=63]="F5",o[o.F6=64]="F6",o[o.F7=65]="F7",o[o.F8=66]="F8",o[o.F9=67]="F9",o[o.F10=68]="F10",o[o.F11=69]="F11",o[o.F12=70]="F12",o[o.F13=71]="F13",o[o.F14=72]="F14",o[o.F15=73]="F15",o[o.F16=74]="F16",o[o.F17=75]="F17",o[o.F18=76]="F18",o[o.F19=77]="F19",o[o.NumLock=78]="NumLock",o[o.ScrollLock=79]="ScrollLock",o[o.US_SEMICOLON=80]="US_SEMICOLON",o[o.US_EQUAL=81]="US_EQUAL",o[o.US_COMMA=82]="US_COMMA",o[o.US_MINUS=83]="US_MINUS",o[o.US_DOT=84]="US_DOT",o[o.US_SLASH=85]="US_SLASH",o[o.US_BACKTICK=86]="US_BACKTICK",o[o.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",o[o.US_BACKSLASH=88]="US_BACKSLASH",o[o.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",o[o.US_QUOTE=90]="US_QUOTE",o[o.OEM_8=91]="OEM_8",o[o.OEM_102=92]="OEM_102",o[o.NUMPAD_0=93]="NUMPAD_0",o[o.NUMPAD_1=94]="NUMPAD_1",o[o.NUMPAD_2=95]="NUMPAD_2",o[o.NUMPAD_3=96]="NUMPAD_3",o[o.NUMPAD_4=97]="NUMPAD_4",o[o.NUMPAD_5=98]="NUMPAD_5",o[o.NUMPAD_6=99]="NUMPAD_6",o[o.NUMPAD_7=100]="NUMPAD_7",o[o.NUMPAD_8=101]="NUMPAD_8",o[o.NUMPAD_9=102]="NUMPAD_9",o[o.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",o[o.NUMPAD_ADD=104]="NUMPAD_ADD",o[o.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",o[o.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",o[o.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",o[o.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",o[o.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",o[o.ABNT_C1=110]="ABNT_C1",o[o.ABNT_C2=111]="ABNT_C2",o[o.MAX_VALUE=112]="MAX_VALUE"})(D=e.KeyCode||(e.KeyCode={}));class k{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(c,a){this._keyCodeToStr[c]=a,this._strToKeyCode[a.toLowerCase()]=c}keyCodeToStr(c){return this._keyCodeToStr[c]}strToKeyCode(c){return this._strToKeyCode[c.toLowerCase()]||0}}const y=new k,P=new k,r=new k;(function(){function o(c,a,h=a,t=h){y.define(c,a),P.define(c,h),r.define(c,t)}o(0,"unknown"),o(1,"Backspace"),o(2,"Tab"),o(3,"Enter"),o(4,"Shift"),o(5,"Ctrl"),o(6,"Alt"),o(7,"PauseBreak"),o(8,"CapsLock"),o(9,"Escape"),o(10,"Space"),o(11,"PageUp"),o(12,"PageDown"),o(13,"End"),o(14,"Home"),o(15,"LeftArrow","Left"),o(16,"UpArrow","Up"),o(17,"RightArrow","Right"),o(18,"DownArrow","Down"),o(19,"Insert"),o(20,"Delete"),o(21,"0"),o(22,"1"),o(23,"2"),o(24,"3"),o(25,"4"),o(26,"5"),o(27,"6"),o(28,"7"),o(29,"8"),o(30,"9"),o(31,"A"),o(32,"B"),o(33,"C"),o(34,"D"),o(35,"E"),o(36,"F"),o(37,"G"),o(38,"H"),o(39,"I"),o(40,"J"),o(41,"K"),o(42,"L"),o(43,"M"),o(44,"N"),o(45,"O"),o(46,"P"),o(47,"Q"),o(48,"R"),o(49,"S"),o(50,"T"),o(51,"U"),o(52,"V"),o(53,"W"),o(54,"X"),o(55,"Y"),o(56,"Z"),o(57,"Meta"),o(58,"ContextMenu"),o(59,"F1"),o(60,"F2"),o(61,"F3"),o(62,"F4"),o(63,"F5"),o(64,"F6"),o(65,"F7"),o(66,"F8"),o(67,"F9"),o(68,"F10"),o(69,"F11"),o(70,"F12"),o(71,"F13"),o(72,"F14"),o(73,"F15"),o(74,"F16"),o(75,"F17"),o(76,"F18"),o(77,"F19"),o(78,"NumLock"),o(79,"ScrollLock"),o(80,";",";","OEM_1"),o(81,"=","=","OEM_PLUS"),o(82,",",",","OEM_COMMA"),o(83,"-","-","OEM_MINUS"),o(84,".",".","OEM_PERIOD"),o(85,"/","/","OEM_2"),o(86,"`","`","OEM_3"),o(110,"ABNT_C1"),o(111,"ABNT_C2"),o(87,"[","[","OEM_4"),o(88,"\\","\\","OEM_5"),o(89,"]","]","OEM_6"),o(90,"'","'","OEM_7"),o(91,"OEM_8"),o(92,"OEM_102"),o(93,"NumPad0"),o(94,"NumPad1"),o(95,"NumPad2"),o(96,"NumPad3"),o(97,"NumPad4"),o(98,"NumPad5"),o(99,"NumPad6"),o(100,"NumPad7"),o(101,"NumPad8"),o(102,"NumPad9"),o(103,"NumPad_Multiply"),o(104,"NumPad_Add"),o(105,"NumPad_Separator"),o(106,"NumPad_Subtract"),o(107,"NumPad_Decimal"),o(108,"NumPad_Divide")})();var p;(function(o){function c(s){return y.keyCodeToStr(s)}o.toString=c;function a(s){return y.strToKeyCode(s)}o.fromString=a;function h(s){return P.keyCodeToStr(s)}o.toUserSettingsUS=h;function t(s){return r.keyCodeToStr(s)}o.toUserSettingsGeneral=t;function n(s){return P.strToKeyCode(s)||r.strToKeyCode(s)}o.fromUserSettings=n})(p=e.KeyCodeUtils||(e.KeyCodeUtils={}));var i;(function(o){o[o.CtrlCmd=2048]="CtrlCmd",o[o.Shift=1024]="Shift",o[o.Alt=512]="Alt",o[o.WinCtrl=256]="WinCtrl",o[o.KeyCode=255]="KeyCode"})(i||(i={}));var L;(function(o){o[o.CtrlCmd=2048]="CtrlCmd",o[o.Shift=1024]="Shift",o[o.Alt=512]="Alt",o[o.WinCtrl=256]="WinCtrl"})(L=e.KeyMod||(e.KeyMod={}));function g(o,c){const a=(c&65535)<<16>>>0;return(o|a)>>>0}e.KeyChord=g;function b(o,c){if(o===0)return null;const a=(o&65535)>>>0,h=(o&4294901760)>>>16;return h!==0?new w([v(a,c),v(h,c)]):new w([v(a,c)])}e.createKeybinding=b;function v(o,c){const a=!!(o&2048),h=!!(o&256),t=c===2?h:a,n=!!(o&1024),s=!!(o&512),l=c===2?a:h,u=o&255;return new d(t,n,s,l,u)}e.createSimpleKeybinding=v;class d{constructor(c,a,h,t,n){this.ctrlKey=c,this.shiftKey=a,this.altKey=h,this.metaKey=t,this.keyCode=n}equals(c){return this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.keyCode===c.keyCode}getHashCode(){const c=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",h=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${c}${a}${h}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new w([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class w{constructor(c){if(c.length===0)throw(0,m.illegalArgument)("parts");this.parts=c}getHashCode(){let c="";for(let a=0,h=this.parts.length;a<h;a++)a!==0&&(c+=";"),c+=this.parts[a].getHashCode();return c}equals(c){if(c===null||this.parts.length!==c.parts.length)return!1;for(let a=0;a<this.parts.length;a++)if(!this.parts[a].equals(c.parts[a]))return!1;return!0}}e.ChordKeybinding=w;class I{constructor(c,a,h,t,n,s){this.ctrlKey=c,this.shiftKey=a,this.altKey=h,this.metaKey=t,this.keyLabel=n,this.keyAriaLabel=s}}e.ResolvedKeybindingPart=I;class E{}e.ResolvedKeybinding=E}),define(X[2],J([0,1,42,62]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const k=!1;let y=null;function P(c){y=c}if(e.setDisposableTracker=P,k){const c="__is_disposable_tracked__";y=new class{trackDisposable(a){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[c]||console.log(h)},3e3)}markTracked(a){if(a&&a!==w.None)try{a[c]=!0}catch(h){}}}}function r(c){!y||y.markTracked(c)}function p(c){return y&&y.trackDisposable(c),c}e.trackDisposable=p;class i extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=i;function L(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=L;function g(c){if(D.Iterable.is(c)){let a=[];for(const h of c)if(h){r(h);try{h.dispose()}catch(t){a.push(t)}}if(a.length===1)throw a[0];if(a.length>1)throw new i(a);return Array.isArray(c)?[]:c}else if(c)return r(c),c.dispose(),c}e.dispose=g;function b(...c){return c.forEach(r),v(()=>g(c))}e.combinedDisposable=b;function v(c){const a=p({dispose:()=>{r(a),c()}});return a}e.toDisposable=v;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(r(this),this._isDisposed=!0,this.clear())}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return r(a),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new d,p(this)}dispose(){r(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class I{constructor(){this._isDisposed=!1,p(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){var h;this._isDisposed||a===this._value||((h=this._value)===null||h===void 0||h.dispose(),a&&r(a),this._value=a)}clear(){this.value=void 0}dispose(){var a;this._isDisposed=!0,r(this),(a=this._value)===null||a===void 0||a.dispose(),this._value=void 0}}e.MutableDisposable=I;class E{constructor(){this.references=new Map}acquire(a,...h){let t=this.references.get(a);t||(t={counter:0,object:this.createReferencedObject(a,...h)},this.references.set(a,t));const{object:n}=t,s=(0,m.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(a,t.object),this.references.delete(a))});return t.counter++,{object:n,dispose:s}}}e.ReferenceCollection=E;class o{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=o}),define(X[78],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(y){this.element=y,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class D{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,P){const r=new m(y);if(this._first===m.Undefined)this._first=r,this._last=r;else if(P){const i=this._last;this._last=r,r.prev=i,i.next=r}else{const i=this._first;this._first=r,r.next=i,i.prev=r}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(r))}}shift(){if(this._first!==m.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==m.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==m.Undefined&&y.next!==m.Undefined){const P=y.prev;P.next=y.next,y.next.prev=P}else y.prev===m.Undefined&&y.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):y.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):y.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==m.Undefined;)yield y.element,y=y.next}}e.LinkedList=D});"use strict";(function(){function j(k){const y=[];typeof k=="number"&&y.push("code/timeOrigin",k);function P(p){y.push(p,Date.now())}function r(){const p=[];for(let i=0;i<y.length;i+=2)p.push({name:y[i],startTime:y[i+1]});return p}return{mark:P,getMarks:r}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const P of performance.getEntriesByType("mark"))y.push({name:P.name,startTime:Math.round(k+P.startTime)});return y}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function m(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=m(D))})(),define(X[3],J([0,1]),function(j,e){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const D="en";let k=!1,y=!1,P=!1,r=!1,p=!1,i=!1,L=!1,g,b=D,v,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof e.globals.vscode!="undefined"?w=e.globals.vscode.process:typeof process!="undefined"&&(w=process);const I=typeof((m=w==null?void 0:w.versions)===null||m===void 0?void 0:m.electron)=="string"&&w.type==="renderer";if(e.isElectronSandboxed=I&&(w==null?void 0:w.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const l=w==null?void 0:w.env.VSCODE_BROWSER_CODE_LOADING;if(typeof l=="string")return l==="none"||l==="code"||l==="bypassHeatCheck"||l==="bypassHeatCheckAndEagerCompile"?l:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!I)d=navigator.userAgent,k=d.indexOf("Windows")>=0,y=d.indexOf("Macintosh")>=0,L=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=d.indexOf("Linux")>=0,i=!0,g=navigator.language,b=g;else if(typeof w=="object"){k=w.platform==="win32",y=w.platform==="darwin",P=w.platform==="linux",r=P&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,g=D,b=D;const l=w.env.VSCODE_NLS_CONFIG;if(l)try{const u=JSON.parse(l),f=u.availableLanguages["*"];g=u.locale,b=f||D,v=u._translationsConfigFile}catch(u){}p=!0}else console.error("Unable to resolve platform.");var E;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function o(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=o;let c=0;y?c=1:k?c=3:P&&(c=2),e.isWindows=k,e.isMacintosh=y,e.isLinux=P,e.isLinuxSnap=r,e.isNative=p,e.isWeb=i,e.isIOS=L,e.platform=c,e.userAgent=d,e.language=b;var a;(function(l){function u(){return e.language}l.value=u;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}l.isDefaultVariant=f;function S(){return e.language==="en"}l.isDefault=S})(a=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=v,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",A=>{if(A.data&&A.data.vscodeSetImmediateId)for(let T=0,U=f.length;T<U;T++){const H=f[T];if(H.id===A.data.vscodeSetImmediateId){f.splice(T,1),H.callback();return}}});let S=0;return A=>{const T=++S;f.push({id:T,callback:A}),e.globals.postMessage({vscodeSetImmediateId:T},"*")}}if(typeof(w==null?void 0:w.nextTick)=="function")return w.nextTick.bind(w);const u=Promise.resolve();return f=>u.then(f)}();var h;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(h=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||L?2:k?1:3;let t=!0,n=!1;function s(){if(!n){n=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,t=new Uint16Array(l.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(X[32],J([0,1,3]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let D;if(typeof m.globals.vscode!="undefined"){const k=m.globals.vscode.process;D={get platform(){return k.platform},get env(){return k.env},cwd(){return k.cwd()},nextTick(y){return(0,m.setImmediate)(y)}}}else typeof process!="undefined"?D={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:D={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},nextTick(k){return(0,m.setImmediate)(k)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=D.cwd,e.env=D.env,e.platform=D.platform,e.nextTick=D.nextTick}),define(X[8],J([0,1,32]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const D=65,k=97,y=90,P=122,r=46,p=47,i=92,L=58,g=63;class b extends Error{constructor(a,h,t){let n;typeof h=="string"&&h.indexOf("not ")===0?(n="must not be",h=h.replace(/^not /,"")):n="must be";const s=a.indexOf(".")!==-1?"property":"argument";let l=`The "${a}" ${s} ${n} of type ${h}`;l+=`. Received type ${typeof t}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function v(c,a){if(typeof c!="string")throw new b(a,"string",c)}function d(c){return c===p||c===i}function w(c){return c===p}function I(c){return c>=D&&c<=y||c>=k&&c<=P}function E(c,a,h,t){let n="",s=0,l=-1,u=0,f=0;for(let S=0;S<=c.length;++S){if(S<c.length)f=c.charCodeAt(S);else{if(t(f))break;f=p}if(t(f)){if(!(l===S-1||u===1))if(u===2){if(n.length<2||s!==2||n.charCodeAt(n.length-1)!==r||n.charCodeAt(n.length-2)!==r){if(n.length>2){const A=n.lastIndexOf(h);A===-1?(n="",s=0):(n=n.slice(0,A),s=n.length-1-n.lastIndexOf(h)),l=S,u=0;continue}else if(n.length!==0){n="",s=0,l=S,u=0;continue}}a&&(n+=n.length>0?`${h}..`:"..",s=2)}else n.length>0?n+=`${h}${c.slice(l+1,S)}`:n=c.slice(l+1,S),s=S-l-1;l=S,u=0}else f===r&&u!==-1?++u:u=-1}return n}function o(c,a){if(a===null||typeof a!="object")throw new b("pathObject","Object",a);const h=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return h?h===a.root?`${h}${t}`:`${h}${c}${t}`:t}e.win32={resolve(...c){let a="",h="",t=!1;for(let n=c.length-1;n>=-1;n--){let s;if(n>=0){if(s=c[n],v(s,"path"),s.length===0)continue}else a.length===0?s=m.cwd():(s=m.env[`=${a}`]||m.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==a.toLowerCase()&&s.charCodeAt(2)===i)&&(s=`${a}\\`));const l=s.length;let u=0,f="",S=!1;const A=s.charCodeAt(0);if(l===1)d(A)&&(u=1,S=!0);else if(d(A))if(S=!0,d(s.charCodeAt(1))){let T=2,U=T;for(;T<l&&!d(s.charCodeAt(T));)T++;if(T<l&&T!==U){const H=s.slice(U,T);for(U=T;T<l&&d(s.charCodeAt(T));)T++;if(T<l&&T!==U){for(U=T;T<l&&!d(s.charCodeAt(T));)T++;(T===l||T!==U)&&(f=`\\\\${H}\\${s.slice(U,T)}`,u=T)}}}else u=1;else I(A)&&s.charCodeAt(1)===L&&(f=s.slice(0,2),u=2,l>2&&d(s.charCodeAt(2))&&(S=!0,u=3));if(f.length>0)if(a.length>0){if(f.toLowerCase()!==a.toLowerCase())continue}else a=f;if(t){if(a.length>0)break}else if(h=`${s.slice(u)}\\${h}`,t=S,S&&a.length>0)break}return h=E(h,!t,"\\",d),t?`${a}\\${h}`:`${a}${h}`||"."},normalize(c){v(c,"path");const a=c.length;if(a===0)return".";let h=0,t,n=!1;const s=c.charCodeAt(0);if(a===1)return w(s)?"\\":c;if(d(s))if(n=!0,d(c.charCodeAt(1))){let u=2,f=u;for(;u<a&&!d(c.charCodeAt(u));)u++;if(u<a&&u!==f){const S=c.slice(f,u);for(f=u;u<a&&d(c.charCodeAt(u));)u++;if(u<a&&u!==f){for(f=u;u<a&&!d(c.charCodeAt(u));)u++;if(u===a)return`\\\\${S}\\${c.slice(f)}\\`;u!==f&&(t=`\\\\${S}\\${c.slice(f,u)}`,h=u)}}}else h=1;else I(s)&&c.charCodeAt(1)===L&&(t=c.slice(0,2),h=2,a>2&&d(c.charCodeAt(2))&&(n=!0,h=3));let l=h<a?E(c.slice(h),!n,"\\",d):"";return l.length===0&&!n&&(l="."),l.length>0&&d(c.charCodeAt(a-1))&&(l+="\\"),t===void 0?n?`\\${l}`:l:n?`${t}\\${l}`:`${t}${l}`},isAbsolute(c){v(c,"path");const a=c.length;if(a===0)return!1;const h=c.charCodeAt(0);return d(h)||a>2&&I(h)&&c.charCodeAt(1)===L&&d(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let a,h;for(let s=0;s<c.length;++s){const l=c[s];v(l,"path"),l.length>0&&(a===void 0?a=h=l:a+=`\\${l}`)}if(a===void 0)return".";let t=!0,n=0;if(typeof h=="string"&&d(h.charCodeAt(0))){++n;const s=h.length;s>1&&d(h.charCodeAt(1))&&(++n,s>2&&(d(h.charCodeAt(2))?++n:t=!1))}if(t){for(;n<a.length&&d(a.charCodeAt(n));)n++;n>=2&&(a=`\\${a.slice(n)}`)}return e.win32.normalize(a)},relative(c,a){if(v(c,"from"),v(a,"to"),c===a)return"";const h=e.win32.resolve(c),t=e.win32.resolve(a);if(h===t||(c=h.toLowerCase(),a=t.toLowerCase(),c===a))return"";let n=0;for(;n<c.length&&c.charCodeAt(n)===i;)n++;let s=c.length;for(;s-1>n&&c.charCodeAt(s-1)===i;)s--;const l=s-n;let u=0;for(;u<a.length&&a.charCodeAt(u)===i;)u++;let f=a.length;for(;f-1>u&&a.charCodeAt(f-1)===i;)f--;const S=f-u,A=l<S?l:S;let T=-1,U=0;for(;U<A;U++){const Q=c.charCodeAt(n+U);if(Q!==a.charCodeAt(u+U))break;Q===i&&(T=U)}if(U!==A){if(T===-1)return t}else{if(S>A){if(a.charCodeAt(u+U)===i)return t.slice(u+U+1);if(U===2)return t.slice(u+U)}l>A&&(c.charCodeAt(n+U)===i?T=U:U===2&&(T=3)),T===-1&&(T=0)}let H="";for(U=n+T+1;U<=s;++U)(U===s||c.charCodeAt(U)===i)&&(H+=H.length===0?"..":"\\..");return u+=T,H.length>0?`${H}${t.slice(u,f)}`:(t.charCodeAt(u)===i&&++u,t.slice(u,f))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const a=e.win32.resolve(c);if(a.length<=2)return c;if(a.charCodeAt(0)===i){if(a.charCodeAt(1)===i){const h=a.charCodeAt(2);if(h!==g&&h!==r)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(I(a.charCodeAt(0))&&a.charCodeAt(1)===L&&a.charCodeAt(2)===i)return`\\\\?\\${a}`;return c},dirname(c){v(c,"path");const a=c.length;if(a===0)return".";let h=-1,t=0;const n=c.charCodeAt(0);if(a===1)return d(n)?c:".";if(d(n)){if(h=t=1,d(c.charCodeAt(1))){let u=2,f=u;for(;u<a&&!d(c.charCodeAt(u));)u++;if(u<a&&u!==f){for(f=u;u<a&&d(c.charCodeAt(u));)u++;if(u<a&&u!==f){for(f=u;u<a&&!d(c.charCodeAt(u));)u++;if(u===a)return c;u!==f&&(h=t=u+1)}}}}else I(n)&&c.charCodeAt(1)===L&&(h=a>2&&d(c.charCodeAt(2))?3:2,t=h);let s=-1,l=!0;for(let u=a-1;u>=t;--u)if(d(c.charCodeAt(u))){if(!l){s=u;break}}else l=!1;if(s===-1){if(h===-1)return".";s=h}return c.slice(0,s)},basename(c,a){a!==void 0&&v(a,"ext"),v(c,"path");let h=0,t=-1,n=!0,s;if(c.length>=2&&I(c.charCodeAt(0))&&c.charCodeAt(1)===L&&(h=2),a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let l=a.length-1,u=-1;for(s=c.length-1;s>=h;--s){const f=c.charCodeAt(s);if(d(f)){if(!n){h=s+1;break}}else u===-1&&(n=!1,u=s+1),l>=0&&(f===a.charCodeAt(l)?--l==-1&&(t=s):(l=-1,t=u))}return h===t?t=u:t===-1&&(t=c.length),c.slice(h,t)}for(s=c.length-1;s>=h;--s)if(d(c.charCodeAt(s))){if(!n){h=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":c.slice(h,t)},extname(c){v(c,"path");let a=0,h=-1,t=0,n=-1,s=!0,l=0;c.length>=2&&c.charCodeAt(1)===L&&I(c.charCodeAt(0))&&(a=t=2);for(let u=c.length-1;u>=a;--u){const f=c.charCodeAt(u);if(d(f)){if(!s){t=u+1;break}continue}n===-1&&(s=!1,n=u+1),f===r?h===-1?h=u:l!==1&&(l=1):h!==-1&&(l=-1)}return h===-1||n===-1||l===0||l===1&&h===n-1&&h===t+1?"":c.slice(h,n)},format:o.bind(null,"\\"),parse(c){v(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const h=c.length;let t=0,n=c.charCodeAt(0);if(h===1)return d(n)?(a.root=a.dir=c,a):(a.base=a.name=c,a);if(d(n)){if(t=1,d(c.charCodeAt(1))){let T=2,U=T;for(;T<h&&!d(c.charCodeAt(T));)T++;if(T<h&&T!==U){for(U=T;T<h&&d(c.charCodeAt(T));)T++;if(T<h&&T!==U){for(U=T;T<h&&!d(c.charCodeAt(T));)T++;T===h?t=T:T!==U&&(t=T+1)}}}}else if(I(n)&&c.charCodeAt(1)===L){if(h<=2)return a.root=a.dir=c,a;if(t=2,d(c.charCodeAt(2))){if(h===3)return a.root=a.dir=c,a;t=3}}t>0&&(a.root=c.slice(0,t));let s=-1,l=t,u=-1,f=!0,S=c.length-1,A=0;for(;S>=t;--S){if(n=c.charCodeAt(S),d(n)){if(!f){l=S+1;break}continue}u===-1&&(f=!1,u=S+1),n===r?s===-1?s=S:A!==1&&(A=1):s!==-1&&(A=-1)}return u!==-1&&(s===-1||A===0||A===1&&s===u-1&&s===l+1?a.base=a.name=c.slice(l,u):(a.name=c.slice(l,s),a.base=c.slice(l,u),a.ext=c.slice(s,u))),l>0&&l!==t?a.dir=c.slice(0,l-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let a="",h=!1;for(let t=c.length-1;t>=-1&&!h;t--){const n=t>=0?c[t]:m.cwd();v(n,"path"),n.length!==0&&(a=`${n}/${a}`,h=n.charCodeAt(0)===p)}return a=E(a,!h,"/",w),h?`/${a}`:a.length>0?a:"."},normalize(c){if(v(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===p,h=c.charCodeAt(c.length-1)===p;return c=E(c,!a,"/",w),c.length===0?a?"/":h?"./":".":(h&&(c+="/"),a?`/${c}`:c)},isAbsolute(c){return v(c,"path"),c.length>0&&c.charCodeAt(0)===p},join(...c){if(c.length===0)return".";let a;for(let h=0;h<c.length;++h){const t=c[h];v(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(c,a){if(v(c,"from"),v(a,"to"),c===a||(c=e.posix.resolve(c),a=e.posix.resolve(a),c===a))return"";const h=1,t=c.length,n=t-h,s=1,l=a.length-s,u=n<l?n:l;let f=-1,S=0;for(;S<u;S++){const T=c.charCodeAt(h+S);if(T!==a.charCodeAt(s+S))break;T===p&&(f=S)}if(S===u)if(l>u){if(a.charCodeAt(s+S)===p)return a.slice(s+S+1);if(S===0)return a.slice(s+S)}else n>u&&(c.charCodeAt(h+S)===p?f=S:S===0&&(f=0));let A="";for(S=h+f+1;S<=t;++S)(S===t||c.charCodeAt(S)===p)&&(A+=A.length===0?"..":"/..");return`${A}${a.slice(s+f)}`},toNamespacedPath(c){return c},dirname(c){if(v(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===p;let h=-1,t=!0;for(let n=c.length-1;n>=1;--n)if(c.charCodeAt(n)===p){if(!t){h=n;break}}else t=!1;return h===-1?a?"/":".":a&&h===1?"//":c.slice(0,h)},basename(c,a){a!==void 0&&v(a,"ext"),v(c,"path");let h=0,t=-1,n=!0,s;if(a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let l=a.length-1,u=-1;for(s=c.length-1;s>=0;--s){const f=c.charCodeAt(s);if(f===p){if(!n){h=s+1;break}}else u===-1&&(n=!1,u=s+1),l>=0&&(f===a.charCodeAt(l)?--l==-1&&(t=s):(l=-1,t=u))}return h===t?t=u:t===-1&&(t=c.length),c.slice(h,t)}for(s=c.length-1;s>=0;--s)if(c.charCodeAt(s)===p){if(!n){h=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":c.slice(h,t)},extname(c){v(c,"path");let a=-1,h=0,t=-1,n=!0,s=0;for(let l=c.length-1;l>=0;--l){const u=c.charCodeAt(l);if(u===p){if(!n){h=l+1;break}continue}t===-1&&(n=!1,t=l+1),u===r?a===-1?a=l:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||t===-1||s===0||s===1&&a===t-1&&a===h+1?"":c.slice(a,t)},format:o.bind(null,"/"),parse(c){v(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const h=c.charCodeAt(0)===p;let t;h?(a.root="/",t=1):t=0;let n=-1,s=0,l=-1,u=!0,f=c.length-1,S=0;for(;f>=t;--f){const A=c.charCodeAt(f);if(A===p){if(!u){s=f+1;break}continue}l===-1&&(u=!1,l=f+1),A===r?n===-1?n=f:S!==1&&(S=1):n!==-1&&(S=-1)}if(l!==-1){const A=s===0&&h?1:s;n===-1||S===0||S===1&&n===l-1&&n===s+1?a.base=a.name=c.slice(A,l):(a.name=c.slice(A,n),a.base=c.slice(A,l),a.ext=c.slice(n,l))}return s>0?a.dir=c.slice(0,s-1):h&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(X[79],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var m;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.None=0]="None",r[r.Hyper=1]="Hyper",r[r.Super=2]="Super",r[r.Fn=3]="Fn",r[r.FnLock=4]="FnLock",r[r.Suspend=5]="Suspend",r[r.Resume=6]="Resume",r[r.Turbo=7]="Turbo",r[r.Sleep=8]="Sleep",r[r.WakeUp=9]="WakeUp",r[r.KeyA=10]="KeyA",r[r.KeyB=11]="KeyB",r[r.KeyC=12]="KeyC",r[r.KeyD=13]="KeyD",r[r.KeyE=14]="KeyE",r[r.KeyF=15]="KeyF",r[r.KeyG=16]="KeyG",r[r.KeyH=17]="KeyH",r[r.KeyI=18]="KeyI",r[r.KeyJ=19]="KeyJ",r[r.KeyK=20]="KeyK",r[r.KeyL=21]="KeyL",r[r.KeyM=22]="KeyM",r[r.KeyN=23]="KeyN",r[r.KeyO=24]="KeyO",r[r.KeyP=25]="KeyP",r[r.KeyQ=26]="KeyQ",r[r.KeyR=27]="KeyR",r[r.KeyS=28]="KeyS",r[r.KeyT=29]="KeyT",r[r.KeyU=30]="KeyU",r[r.KeyV=31]="KeyV",r[r.KeyW=32]="KeyW",r[r.KeyX=33]="KeyX",r[r.KeyY=34]="KeyY",r[r.KeyZ=35]="KeyZ",r[r.Digit1=36]="Digit1",r[r.Digit2=37]="Digit2",r[r.Digit3=38]="Digit3",r[r.Digit4=39]="Digit4",r[r.Digit5=40]="Digit5",r[r.Digit6=41]="Digit6",r[r.Digit7=42]="Digit7",r[r.Digit8=43]="Digit8",r[r.Digit9=44]="Digit9",r[r.Digit0=45]="Digit0",r[r.Enter=46]="Enter",r[r.Escape=47]="Escape",r[r.Backspace=48]="Backspace",r[r.Tab=49]="Tab",r[r.Space=50]="Space",r[r.Minus=51]="Minus",r[r.Equal=52]="Equal",r[r.BracketLeft=53]="BracketLeft",r[r.BracketRight=54]="BracketRight",r[r.Backslash=55]="Backslash",r[r.IntlHash=56]="IntlHash",r[r.Semicolon=57]="Semicolon",r[r.Quote=58]="Quote",r[r.Backquote=59]="Backquote",r[r.Comma=60]="Comma",r[r.Period=61]="Period",r[r.Slash=62]="Slash",r[r.CapsLock=63]="CapsLock",r[r.F1=64]="F1",r[r.F2=65]="F2",r[r.F3=66]="F3",r[r.F4=67]="F4",r[r.F5=68]="F5",r[r.F6=69]="F6",r[r.F7=70]="F7",r[r.F8=71]="F8",r[r.F9=72]="F9",r[r.F10=73]="F10",r[r.F11=74]="F11",r[r.F12=75]="F12",r[r.PrintScreen=76]="PrintScreen",r[r.ScrollLock=77]="ScrollLock",r[r.Pause=78]="Pause",r[r.Insert=79]="Insert",r[r.Home=80]="Home",r[r.PageUp=81]="PageUp",r[r.Delete=82]="Delete",r[r.End=83]="End",r[r.PageDown=84]="PageDown",r[r.ArrowRight=85]="ArrowRight",r[r.ArrowLeft=86]="ArrowLeft",r[r.ArrowDown=87]="ArrowDown",r[r.ArrowUp=88]="ArrowUp",r[r.NumLock=89]="NumLock",r[r.NumpadDivide=90]="NumpadDivide",r[r.NumpadMultiply=91]="NumpadMultiply",r[r.NumpadSubtract=92]="NumpadSubtract",r[r.NumpadAdd=93]="NumpadAdd",r[r.NumpadEnter=94]="NumpadEnter",r[r.Numpad1=95]="Numpad1",r[r.Numpad2=96]="Numpad2",r[r.Numpad3=97]="Numpad3",r[r.Numpad4=98]="Numpad4",r[r.Numpad5=99]="Numpad5",r[r.Numpad6=100]="Numpad6",r[r.Numpad7=101]="Numpad7",r[r.Numpad8=102]="Numpad8",r[r.Numpad9=103]="Numpad9",r[r.Numpad0=104]="Numpad0",r[r.NumpadDecimal=105]="NumpadDecimal",r[r.IntlBackslash=106]="IntlBackslash",r[r.ContextMenu=107]="ContextMenu",r[r.Power=108]="Power",r[r.NumpadEqual=109]="NumpadEqual",r[r.F13=110]="F13",r[r.F14=111]="F14",r[r.F15=112]="F15",r[r.F16=113]="F16",r[r.F17=114]="F17",r[r.F18=115]="F18",r[r.F19=116]="F19",r[r.F20=117]="F20",r[r.F21=118]="F21",r[r.F22=119]="F22",r[r.F23=120]="F23",r[r.F24=121]="F24",r[r.Open=122]="Open",r[r.Help=123]="Help",r[r.Select=124]="Select",r[r.Again=125]="Again",r[r.Undo=126]="Undo",r[r.Cut=127]="Cut",r[r.Copy=128]="Copy",r[r.Paste=129]="Paste",r[r.Find=130]="Find",r[r.AudioVolumeMute=131]="AudioVolumeMute",r[r.AudioVolumeUp=132]="AudioVolumeUp",r[r.AudioVolumeDown=133]="AudioVolumeDown",r[r.NumpadComma=134]="NumpadComma",r[r.IntlRo=135]="IntlRo",r[r.KanaMode=136]="KanaMode",r[r.IntlYen=137]="IntlYen",r[r.Convert=138]="Convert",r[r.NonConvert=139]="NonConvert",r[r.Lang1=140]="Lang1",r[r.Lang2=141]="Lang2",r[r.Lang3=142]="Lang3",r[r.Lang4=143]="Lang4",r[r.Lang5=144]="Lang5",r[r.Abort=145]="Abort",r[r.Props=146]="Props",r[r.NumpadParenLeft=147]="NumpadParenLeft",r[r.NumpadParenRight=148]="NumpadParenRight",r[r.NumpadBackspace=149]="NumpadBackspace",r[r.NumpadMemoryStore=150]="NumpadMemoryStore",r[r.NumpadMemoryRecall=151]="NumpadMemoryRecall",r[r.NumpadMemoryClear=152]="NumpadMemoryClear",r[r.NumpadMemoryAdd=153]="NumpadMemoryAdd",r[r.NumpadMemorySubtract=154]="NumpadMemorySubtract",r[r.NumpadClear=155]="NumpadClear",r[r.NumpadClearEntry=156]="NumpadClearEntry",r[r.ControlLeft=157]="ControlLeft",r[r.ShiftLeft=158]="ShiftLeft",r[r.AltLeft=159]="AltLeft",r[r.MetaLeft=160]="MetaLeft",r[r.ControlRight=161]="ControlRight",r[r.ShiftRight=162]="ShiftRight",r[r.AltRight=163]="AltRight",r[r.MetaRight=164]="MetaRight",r[r.BrightnessUp=165]="BrightnessUp",r[r.BrightnessDown=166]="BrightnessDown",r[r.MediaPlay=167]="MediaPlay",r[r.MediaRecord=168]="MediaRecord",r[r.MediaFastForward=169]="MediaFastForward",r[r.MediaRewind=170]="MediaRewind",r[r.MediaTrackNext=171]="MediaTrackNext",r[r.MediaTrackPrevious=172]="MediaTrackPrevious",r[r.MediaStop=173]="MediaStop",r[r.Eject=174]="Eject",r[r.MediaPlayPause=175]="MediaPlayPause",r[r.MediaSelect=176]="MediaSelect",r[r.LaunchMail=177]="LaunchMail",r[r.LaunchApp2=178]="LaunchApp2",r[r.LaunchApp1=179]="LaunchApp1",r[r.SelectTask=180]="SelectTask",r[r.LaunchScreenSaver=181]="LaunchScreenSaver",r[r.BrowserSearch=182]="BrowserSearch",r[r.BrowserHome=183]="BrowserHome",r[r.BrowserBack=184]="BrowserBack",r[r.BrowserForward=185]="BrowserForward",r[r.BrowserStop=186]="BrowserStop",r[r.BrowserRefresh=187]="BrowserRefresh",r[r.BrowserFavorites=188]="BrowserFavorites",r[r.ZoomToggle=189]="ZoomToggle",r[r.MailReply=190]="MailReply",r[r.MailForward=191]="MailForward",r[r.MailSend=192]="MailSend",r[r.MAX_VALUE=193]="MAX_VALUE"})(m=e.ScanCode||(e.ScanCode={}));const D=[],k=Object.create(null),y=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:r=>y[r]||0,toEnum:r=>k[r]||0,toString:r=>D[r]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class P{constructor(p,i,L,g,b){this.ctrlKey=p,this.shiftKey=i,this.altKey=L,this.metaKey=g,this.scanCode=b}equals(p){return this.ctrlKey===p.ctrlKey&&this.shiftKey===p.shiftKey&&this.altKey===p.altKey&&this.metaKey===p.metaKey&&this.scanCode===p.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=P,function(){function r(p,i){D[p]=i,k[i]=p,y[i.toLowerCase()]=p}r(0,"None"),r(1,"Hyper"),r(2,"Super"),r(3,"Fn"),r(4,"FnLock"),r(5,"Suspend"),r(6,"Resume"),r(7,"Turbo"),r(8,"Sleep"),r(9,"WakeUp"),r(10,"KeyA"),r(11,"KeyB"),r(12,"KeyC"),r(13,"KeyD"),r(14,"KeyE"),r(15,"KeyF"),r(16,"KeyG"),r(17,"KeyH"),r(18,"KeyI"),r(19,"KeyJ"),r(20,"KeyK"),r(21,"KeyL"),r(22,"KeyM"),r(23,"KeyN"),r(24,"KeyO"),r(25,"KeyP"),r(26,"KeyQ"),r(27,"KeyR"),r(28,"KeyS"),r(29,"KeyT"),r(30,"KeyU"),r(31,"KeyV"),r(32,"KeyW"),r(33,"KeyX"),r(34,"KeyY"),r(35,"KeyZ"),r(36,"Digit1"),r(37,"Digit2"),r(38,"Digit3"),r(39,"Digit4"),r(40,"Digit5"),r(41,"Digit6"),r(42,"Digit7"),r(43,"Digit8"),r(44,"Digit9"),r(45,"Digit0"),r(46,"Enter"),r(47,"Escape"),r(48,"Backspace"),r(49,"Tab"),r(50,"Space"),r(51,"Minus"),r(52,"Equal"),r(53,"BracketLeft"),r(54,"BracketRight"),r(55,"Backslash"),r(56,"IntlHash"),r(57,"Semicolon"),r(58,"Quote"),r(59,"Backquote"),r(60,"Comma"),r(61,"Period"),r(62,"Slash"),r(63,"CapsLock"),r(64,"F1"),r(65,"F2"),r(66,"F3"),r(67,"F4"),r(68,"F5"),r(69,"F6"),r(70,"F7"),r(71,"F8"),r(72,"F9"),r(73,"F10"),r(74,"F11"),r(75,"F12"),r(76,"PrintScreen"),r(77,"ScrollLock"),r(78,"Pause"),r(79,"Insert"),r(80,"Home"),r(81,"PageUp"),r(82,"Delete"),r(83,"End"),r(84,"PageDown"),r(85,"ArrowRight"),r(86,"ArrowLeft"),r(87,"ArrowDown"),r(88,"ArrowUp"),r(89,"NumLock"),r(90,"NumpadDivide"),r(91,"NumpadMultiply"),r(92,"NumpadSubtract"),r(93,"NumpadAdd"),r(94,"NumpadEnter"),r(95,"Numpad1"),r(96,"Numpad2"),r(97,"Numpad3"),r(98,"Numpad4"),r(99,"Numpad5"),r(100,"Numpad6"),r(101,"Numpad7"),r(102,"Numpad8"),r(103,"Numpad9"),r(104,"Numpad0"),r(105,"NumpadDecimal"),r(106,"IntlBackslash"),r(107,"ContextMenu"),r(108,"Power"),r(109,"NumpadEqual"),r(110,"F13"),r(111,"F14"),r(112,"F15"),r(113,"F16"),r(114,"F17"),r(115,"F18"),r(116,"F19"),r(117,"F20"),r(118,"F21"),r(119,"F22"),r(120,"F23"),r(121,"F24"),r(122,"Open"),r(123,"Help"),r(124,"Select"),r(125,"Again"),r(126,"Undo"),r(127,"Cut"),r(128,"Copy"),r(129,"Paste"),r(130,"Find"),r(131,"AudioVolumeMute"),r(132,"AudioVolumeUp"),r(133,"AudioVolumeDown"),r(134,"NumpadComma"),r(135,"IntlRo"),r(136,"KanaMode"),r(137,"IntlYen"),r(138,"Convert"),r(139,"NonConvert"),r(140,"Lang1"),r(141,"Lang2"),r(142,"Lang3"),r(143,"Lang4"),r(144,"Lang5"),r(145,"Abort"),r(146,"Props"),r(147,"NumpadParenLeft"),r(148,"NumpadParenRight"),r(149,"NumpadBackspace"),r(150,"NumpadMemoryStore"),r(151,"NumpadMemoryRecall"),r(152,"NumpadMemoryClear"),r(153,"NumpadMemoryAdd"),r(154,"NumpadMemorySubtract"),r(155,"NumpadClear"),r(156,"NumpadClearEntry"),r(157,"ControlLeft"),r(158,"ShiftLeft"),r(159,"AltLeft"),r(160,"MetaLeft"),r(161,"ControlRight"),r(162,"ShiftRight"),r(163,"AltRight"),r(164,"MetaRight"),r(165,"BrightnessUp"),r(166,"BrightnessDown"),r(167,"MediaPlay"),r(168,"MediaRecord"),r(169,"MediaFastForward"),r(170,"MediaRewind"),r(171,"MediaTrackNext"),r(172,"MediaTrackPrevious"),r(173,"MediaStop"),r(174,"Eject"),r(175,"MediaPlayPause"),r(176,"MediaSelect"),r(177,"LaunchMail"),r(178,"LaunchApp2"),r(179,"LaunchApp1"),r(180,"SelectTask"),r(181,"LaunchScreenSaver"),r(182,"BrowserSearch"),r(183,"BrowserHome"),r(184,"BrowserBack"),r(185,"BrowserForward"),r(186,"BrowserStop"),r(187,"BrowserRefresh"),r(188,"BrowserFavorites"),r(189,"ZoomToggle"),r(190,"MailReply"),r(191,"MailForward"),r(192,"MailSend")}(),function(){for(let p=0;p<=193;p++)e.IMMUTABLE_CODE_TO_KEY_CODE[p]=-1;for(let p=0;p<=112;p++)e.IMMUTABLE_KEY_CODE_TO_CODE[p]=-1;function r(p,i){e.IMMUTABLE_CODE_TO_KEY_CODE[p]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[i]=p)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,r(0,0),r(1,0),r(2,0),r(3,0),r(4,0),r(5,0),r(6,0),r(7,0),r(8,0),r(9,0),r(46,3),r(47,9),r(48,1),r(49,2),r(50,10),r(63,8),r(64,59),r(65,60),r(66,61),r(67,62),r(68,63),r(69,64),r(70,65),r(71,66),r(72,67),r(73,68),r(74,69),r(75,70),r(76,0),r(77,79),r(78,7),r(79,19),r(80,14),r(81,11),r(82,20),r(83,13),r(84,12),r(85,17),r(86,15),r(87,18),r(88,16),r(89,78),r(90,108),r(91,103),r(92,106),r(93,104),r(94,3),r(95,94),r(96,95),r(97,96),r(98,97),r(99,98),r(100,99),r(101,100),r(102,101),r(103,102),r(104,93),r(105,107),r(107,58),r(108,0),r(109,0),r(110,71),r(111,72),r(112,73),r(113,74),r(114,75),r(115,76),r(116,77),r(117,0),r(118,0),r(119,0),r(120,0),r(121,0),r(122,0),r(123,0),r(124,0),r(125,0),r(126,0),r(127,0),r(128,0),r(129,0),r(130,0),r(131,0),r(132,0),r(133,0),r(134,105),r(136,0),r(138,0),r(139,0),r(140,0),r(141,0),r(142,0),r(143,0),r(144,0),r(145,0),r(146,0),r(147,0),r(148,0),r(149,0),r(150,0),r(151,0),r(152,0),r(153,0),r(154,0),r(155,0),r(156,0),r(157,5),r(158,4),r(159,6),r(160,57),r(161,5),r(162,4),r(163,6),r(164,57),r(165,0),r(166,0),r(167,0),r(168,0),r(169,0),r(170,0),r(171,0),r(172,0),r(173,0),r(174,0),r(175,0),r(176,0),r(177,0),r(178,0),r(179,0),r(180,0),r(181,0),r(182,0),r(183,0),r(184,0),r(185,0),r(186,0),r(187,0),r(188,0),r(189,0),r(190,0),r(191,0),r(192,0)}()}),define(X[103],J([0,1,57,79]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class k{static _readModifiers(P){P=P.toLowerCase().trim();let r=!1,p=!1,i=!1,L=!1,g;do g=!1,/^ctrl(\+|\-)/.test(P)&&(r=!0,P=P.substr("ctrl-".length),g=!0),/^shift(\+|\-)/.test(P)&&(p=!0,P=P.substr("shift-".length),g=!0),/^alt(\+|\-)/.test(P)&&(i=!0,P=P.substr("alt-".length),g=!0),/^meta(\+|\-)/.test(P)&&(L=!0,P=P.substr("meta-".length),g=!0),/^win(\+|\-)/.test(P)&&(L=!0,P=P.substr("win-".length),g=!0),/^cmd(\+|\-)/.test(P)&&(L=!0,P=P.substr("cmd-".length),g=!0);while(g);let b;const v=P.indexOf(" ");return v>0?(b=P.substring(0,v),P=P.substring(v)):(b=P,P=""),{remains:P,ctrl:r,shift:p,alt:i,meta:L,key:b}}static parseSimpleKeybinding(P){const r=this._readModifiers(P),p=m.KeyCodeUtils.fromUserSettings(r.key);return[new m.SimpleKeybinding(r.ctrl,r.shift,r.alt,r.meta,p),r.remains]}static parseKeybinding(P,r){if(!P)return null;const p=[];let i;do[i,P]=this.parseSimpleKeybinding(P),p.push(i);while(P.length>0);return new m.ChordKeybinding(p)}static parseSimpleUserBinding(P){const r=this._readModifiers(P),p=r.key.match(/^\[([^\]]+)\]$/);if(p){const L=p[1],g=D.ScanCodeUtils.lowerCaseToEnum(L);return[new D.ScanCodeBinding(r.ctrl,r.shift,r.alt,r.meta,g),r.remains]}const i=m.KeyCodeUtils.fromUserSettings(r.key);return[new m.SimpleKeybinding(r.ctrl,r.shift,r.alt,r.meta,i),r.remains]}static parseUserBinding(P){if(!P)return[];const r=[];let p;for(;P.length>0;)[p,P]=this.parseSimpleUserBinding(P),r.push(p);return r}}e.KeybindingParser=k}),define(X[104],J([0,1,3]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const D=m.globals.performance&&typeof m.globals.performance.now=="function";class k{constructor(P){this._highResolution=D&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new k(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=k}),define(X[5],J([0,1,17,42,2,78,104]),function(j,e,m,D,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var r;(function(E){E.None=()=>k.Disposable.None;function o(O){return($,z=null,C)=>{let q=!1,N;return N=O(_=>{if(!q)return N?N.dispose():q=!0,$.call(z,_)},null,C),q&&N.dispose(),N}}E.once=o;function c(O,$){return l((z,C=null,q)=>O(N=>z.call(C,$(N)),null,q))}E.map=c;function a(O,$){return l((z,C=null,q)=>O(N=>{$(N),z.call(C,N)},null,q))}E.forEach=a;function h(O,$){return l((z,C=null,q)=>O(N=>$(N)&&z.call(C,N),null,q))}E.filter=h;function t(O){return O}E.signal=t;function n(...O){return($,z=null,C)=>(0,k.combinedDisposable)(...O.map(q=>q(N=>$.call(z,N),null,C)))}E.any=n;function s(O,$,z){let C=z;return c(O,q=>(C=$(C,q),C))}E.reduce=s;function l(O){let $;const z=new b({onFirstListenerAdd(){$=O(z.fire,z)},onLastListenerRemove(){$.dispose()}});return z.event}E.snapshot=l;function u(O,$,z=100,C=!1,q){let N,_,R,W=0;const M=new b({leakWarningThreshold:q,onFirstListenerAdd(){N=O(F=>{W++,_=$(_,F),C&&!R&&(M.fire(_),_=void 0),clearTimeout(R),R=setTimeout(()=>{const B=_;_=void 0,R=void 0,(!C||W>1)&&M.fire(B),W=0},z)})},onLastListenerRemove(){N.dispose()}});return M.event}E.debounce=u;function f(O){const $=new Date().getTime();return c(o(O),z=>new Date().getTime()-$)}E.stopwatch=f;function S(O){let $=!0,z;return h(O,C=>{const q=$||C!==z;return $=!1,z=C,q})}E.latch=S;function A(O,$=!1,z=[]){let C=z.slice(),q=O(R=>{C?C.push(R):_.fire(R)});const N=()=>{C&&C.forEach(R=>_.fire(R)),C=null},_=new b({onFirstListenerAdd(){q||(q=O(R=>_.fire(R)))},onFirstListenerDidAdd(){C&&($?setTimeout(N):N())},onLastListenerRemove(){q&&q.dispose(),q=null}});return _.event}E.buffer=A;class T{constructor($){this.event=$}map($){return new T(c(this.event,$))}forEach($){return new T(a(this.event,$))}filter($){return new T(h(this.event,$))}reduce($,z){return new T(s(this.event,$,z))}latch(){return new T(S(this.event))}debounce($,z=100,C=!1,q){return new T(u(this.event,$,z,C,q))}on($,z,C){return this.event($,z,C)}once($,z,C){return o(this.event)($,z,C)}}function U(O){return new T(O)}E.chain=U;function H(O,$,z=C=>C){const C=(...R)=>_.fire(z(...R)),q=()=>O.on($,C),N=()=>O.removeListener($,C),_=new b({onFirstListenerAdd:q,onLastListenerRemove:N});return _.event}E.fromNodeEventEmitter=H;function Q(O,$,z=C=>C){const C=(...R)=>_.fire(z(...R)),q=()=>O.addEventListener($,C),N=()=>O.removeEventListener($,C),_=new b({onFirstListenerAdd:q,onLastListenerRemove:N});return _.event}E.fromDOMEventEmitter=Q;function ne(O){const $=new b;let z=!1;return O.then(void 0,()=>null).then(()=>{z?$.fire(void 0):setTimeout(()=>$.fire(void 0),0)}),z=!0,$.event}E.fromPromise=ne;function ae(O){return new Promise($=>o(O)($))}E.toPromise=ae})(r=e.Event||(e.Event={}));class p{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${p._idPool++}`}start(o){this._stopWatch=new P.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}p._idPool=0;let i=-1;function L(E){const o=i;return i=E,{dispose(){i=o}}}e.setGlobalLeakWarningThreshold=L;class g{constructor(o,c=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let c=i;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),!(c<=0||o<c)){this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),h=this._stacks.get(a)||0;if(this._stacks.set(a,h+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let t,n=0;for(const[s,l]of this._stacks)(!t||n<l)&&(t=s,n=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}}class b{constructor(o){var c;this._disposed=!1,this._options=o,this._leakageMon=i>0?new g(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((c=this._options)===null||c===void 0?void 0:c._profName)?new p(this._options._profName):void 0}get event(){return this._event||(this._event=(o,c,a)=>{var h;this._listeners||(this._listeners=new y.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(c?[o,c]:o);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,c);const s=(h=this._leakageMon)===null||h===void 0?void 0:h.check(this._listeners.size);let l;return l={dispose:()=>{s&&s(),l.dispose=b._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},a instanceof k.DisposableStore?a.add(l):Array.isArray(a)&&a.push(l),l}),this._event}fire(o){var c,a;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let h of this._listeners)this._deliveryQueue.push([h,o]);for((c=this._perfMon)===null||c===void 0||c.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[h,t]=this._deliveryQueue.shift();try{typeof h=="function"?h.call(void 0,t):h[0].call(h[1],t)}catch(n){(0,m.onUnexpectedError)(n)}}(a=this._perfMon)===null||a===void 0||a.stop()}}dispose(){var o,c,a;(o=this._listeners)===null||o===void 0||o.clear(),(c=this._deliveryQueue)===null||c===void 0||c.clear(),(a=this._leakageMon)===null||a===void 0||a.dispose(),this._disposed=!0}}e.Emitter=b,b._noop=function(){};class v extends b{constructor(o){super(o);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=o==null?void 0:o.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=v;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const c={event:o,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const a=()=>{this.hasListeners&&this.unhook(c);const h=this.events.indexOf(c);this.events.splice(h,1)};return(0,k.toDisposable)((0,D.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(c=>this.emitter.fire(c))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class w{constructor(){this.buffers=[]}wrapEvent(o){return(c,a,h)=>o(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>c.call(a,t)):c.call(a,t)},void 0,h)}bufferEvents(o){const c=[];this.buffers.push(c);const a=o();return this.buffers.pop(),c.forEach(h=>h()),a}}e.EventBufferer=w;class I{constructor(){this.listening=!1,this.inputEvent=r.None,this.inputEventListener=k.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=I}),define(X[25],J([0,1,5]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const D=Object.freeze(function(r,p){const i=setTimeout(r.bind(p),0);return{dispose(){clearTimeout(i)}}});var k;(function(r){function p(i){return i===r.None||i===r.Cancelled||i instanceof y?!0:!i||typeof i!="object"?!1:typeof i.isCancellationRequested=="boolean"&&typeof i.onCancellationRequested=="function"}r.isCancellationToken=p,r.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),r.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(k=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=k.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=P}),define(X[105],J([0,1,5]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class D{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(L){const g=this._icons.get(L.id);g?L.description?g.description=L.description:console.error(`Duplicate registration of codicon ${L.id}`):(this._icons.set(L.id,L),this._onDidRegister.fire(L))}get(L){return this._icons.get(L)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new D;e.iconRegistry=k;function y(i,L){return new P(i,L)}e.registerCodicon=y;class P{constructor(L,g,b){this.id=L,this.definition=g,this.description=b,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function r(i,L){const g=["codicon","codicon-"+i];return L&&g.push("codicon-modifier-"+L),g}e.getClassNamesArray=r;var p;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const L=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function g(d){if(d instanceof P)return["codicon","codicon-"+d.id];const w=L.exec(d.id);if(!w)return g(P.error);let[,I,E]=w;const o=["codicon","codicon-"+I];return E&&o.push("codicon-modifier-"+E.substr(1)),o}i.asClassNameArray=g;function b(d){return g(d).join(" ")}i.asClassName=b;function v(d){return"."+g(d).join(".")}i.asCSSSelector=v})(p=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personAdd=new i("person-add",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(X[63],J([0,1,17,2]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(E){const o=E;return o&&[o.on,o.pause,o.resume,o.destroy].every(c=>typeof c=="function")}e.isReadableStream=k;function y(E){const o=E;return o&&k(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean"}e.isReadableBufferedStream=y;function P(E,o){return new r(E,o)}e.newWriteableStream=P;class r{constructor(o,c){this.reducer=o,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){var c;if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof((c=this.options)===null||c===void 0?void 0:c.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(c=>c(o))}emitError(o){this.listeners.error.length===0?(0,m.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(c=>c(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,c){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(o,c){if(!this.state.destroyed){let a;switch(o){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const h=a.indexOf(c);h>=0&&a.splice(h,1)}}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(E,o){const c=[];let a;for(;(a=E.read())!==null;)c.push(a);return o(c)}e.consumeReadable=p;function i(E,o,c){const a=[];let h;for(;(h=E.read())!==null&&a.length<c;)a.push(h);return h===null&&a.length>0?o(a):{read:()=>{if(a.length>0)return a.shift();if(typeof h!="undefined"){const t=h;return h=void 0,t}return E.read()}}}e.peekReadable=i;function L(E,o){return new Promise((c,a)=>{const h=[];g(E,{onData:t=>{o&&h.push(t)},onError:t=>{o?a(t):c(void 0)},onEnd:()=>{c(o?o(h):void 0)}})})}e.consumeStream=L;function g(E,o){E.on("error",c=>o.onError(c)),E.on("end",()=>o.onEnd()),E.on("data",c=>o.onData(c))}e.listenStream=g;function b(E,o){return new Promise((c,a)=>{const h=new D.DisposableStore,t=[],n=u=>{if(t.push(u),t.length>o)return h.dispose(),E.pause(),c({stream:E,buffer:t,ended:!1})},s=u=>a(u),l=()=>c({stream:E,buffer:t,ended:!0});h.add((0,D.toDisposable)(()=>E.removeListener("error",s))),E.on("error",s),h.add((0,D.toDisposable)(()=>E.removeListener("end",l))),E.on("end",l),h.add((0,D.toDisposable)(()=>E.removeListener("data",n))),E.on("data",n)})}e.peekStream=b;function v(E,o){const c=P(o);return c.end(E),c}e.toStream=v;function d(){const E=P(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=d;function w(E){let o=!1;return{read:()=>o?null:(o=!0,E)}}e.toReadable=w;function I(E,o,c){const a=P(c);return g(E,{onData:h=>a.write(o.data(h)),onError:h=>a.error(o.error?o.error(h):h),onEnd:()=>a.end()}),a}e.transform=I}),define(X[22],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function m(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=m;const D=/{(\d+)}/g;function k(K,...te){return te.length===0?K:K.replace(D,function(oe,le){const de=parseInt(le,10);return isNaN(de)||de<0||de>=te.length?oe:te[de]})}e.format=k;function y(K){return K.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=y;function P(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function r(K,te){let oe=0;const le=te.charCodeAt(0);for(let de=K.length-1;de>=0;de--)K.charCodeAt(de)===le&&oe++;return oe}e.count=r;function p(K,te,oe="\u2026"){return K.length<=te?K:`${K.substr(0,te)}${oe}`}e.truncate=p;function i(K,te=" "){const oe=L(K,te);return g(oe,te)}e.trim=i;function L(K,te){if(!K||!te)return K;const oe=te.length;if(oe===0||K.length===0)return K;let le=0;for(;K.indexOf(te,le)===le;)le=le+oe;return K.substring(le)}e.ltrim=L;function g(K,te){if(!K||!te)return K;const oe=te.length,le=K.length;if(oe===0||le===0)return K;let de=le,pe=-1;for(;pe=K.lastIndexOf(te,de-1),!(pe===-1||pe+oe!==de);){if(pe===0)return"";de=pe}return K.substring(0,de)}e.rtrim=g;function b(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=b;function v(K){return K.replace(/\*/g,"")}e.stripWildcards=v;function d(K,te,oe={}){if(!K)throw new Error("Cannot create regex from empty string");te||(K=P(K)),oe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let le="";return oe.global&&(le+="g"),oe.matchCase||(le+="i"),oe.multiline&&(le+="m"),oe.unicode&&(le+="u"),new RegExp(K,le)}e.createRegExp=d;function w(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function I(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=I;function E(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=E;function o(K){return K.split(/\r\n|\r|\n/)}e.splitLines=o;function c(K){for(let te=0,oe=K.length;te<oe;te++){const le=K.charCodeAt(te);if(le!==32&&le!==9)return te}return-1}e.firstNonWhitespaceIndex=c;function a(K,te=0,oe=K.length){for(let le=te;le<oe;le++){const de=K.charCodeAt(le);if(de!==32&&de!==9)return K.substring(te,le)}return K.substring(te,oe)}e.getLeadingWhitespace=a;function h(K,te=K.length-1){for(let oe=te;oe>=0;oe--){const le=K.charCodeAt(oe);if(le!==32&&le!==9)return oe}return-1}e.lastNonWhitespaceIndex=h;function t(K,te){return K<te?-1:K>te?1:0}e.compare=t;function n(K,te,oe=0,le=K.length,de=0,pe=te.length){for(;oe<le&&de<pe;oe++,de++){let Ce=K.charCodeAt(oe),Ne=te.charCodeAt(de);if(Ce<Ne)return-1;if(Ce>Ne)return 1}const Ie=le-oe,Oe=pe-de;return Ie<Oe?-1:Ie>Oe?1:0}e.compareSubstring=n;function s(K,te){return l(K,te,0,K.length,0,te.length)}e.compareIgnoreCase=s;function l(K,te,oe=0,le=K.length,de=0,pe=te.length){for(;oe<le&&de<pe;oe++,de++){let Ce=K.charCodeAt(oe),Ne=te.charCodeAt(de);if(Ce!==Ne){const qe=Ce-Ne;if(!(qe===32&&f(Ne))&&!(qe===-32&&f(Ce)))return u(Ce)&&u(Ne)?qe:n(K.toLowerCase(),te.toLowerCase(),oe,le,de,pe)}}const Ie=le-oe,Oe=pe-de;return Ie<Oe?-1:Ie>Oe?1:0}e.compareSubstringIgnoreCase=l;function u(K){return K>=97&&K<=122}e.isLowerAsciiLetter=u;function f(K){return K>=65&&K<=90}e.isUpperAsciiLetter=f;function S(K){return u(K)||f(K)}function A(K,te){return K.length===te.length&&T(K,te)}e.equalsIgnoreCase=A;function T(K,te,oe=K.length){for(let le=0;le<oe;le++){const de=K.charCodeAt(le),pe=te.charCodeAt(le);if(de!==pe){if(S(de)&&S(pe)){const Ie=Math.abs(de-pe);if(Ie!==0&&Ie!==32)return!1}else if(String.fromCharCode(de).toLowerCase()!==String.fromCharCode(pe).toLowerCase())return!1}}return!0}function U(K,te){const oe=te.length;return te.length>K.length?!1:T(K,te,oe)}e.startsWithIgnoreCase=U;function H(K,te){let oe,le=Math.min(K.length,te.length);for(oe=0;oe<le;oe++)if(K.charCodeAt(oe)!==te.charCodeAt(oe))return oe;return le}e.commonPrefixLength=H;function Q(K,te){let oe,le=Math.min(K.length,te.length);const de=K.length-1,pe=te.length-1;for(oe=0;oe<le;oe++)if(K.charCodeAt(de-oe)!==te.charCodeAt(pe-oe))return oe;return le}e.commonSuffixLength=Q;function ne(K){return 55296<=K&&K<=56319}e.isHighSurrogate=ne;function ae(K){return 56320<=K&&K<=57343}e.isLowSurrogate=ae;function O(K,te){return(K-55296<<10)+(te-56320)+65536}e.computeCodePoint=O;function $(K,te,oe){const le=K.charCodeAt(oe);if(ne(le)&&oe+1<te){const de=K.charCodeAt(oe+1);if(ae(de))return O(le,de)}return le}e.getNextCodePoint=$;function z(K,te){const oe=K.charCodeAt(te-1);if(ae(oe)&&te>1){const le=K.charCodeAt(te-2);if(ne(le))return O(le,oe)}return oe}function C(K,te){const oe=ze.getInstance(),le=te,de=K.length,pe=$(K,de,te);te+=pe>=65536?2:1;let Ie=oe.getGraphemeBreakType(pe);for(;te<de;){const Oe=$(K,de,te),Ce=oe.getGraphemeBreakType(Oe);if(Ke(Ie,Ce))break;te+=Oe>=65536?2:1,Ie=Ce}return te-le}e.nextCharLength=C;function q(K,te){const oe=ze.getInstance(),le=te,de=z(K,te);te-=de>=65536?2:1;let pe=oe.getGraphemeBreakType(de);for(;te>0;){const Ie=z(K,te),Oe=oe.getGraphemeBreakType(Ie);if(Ke(Oe,pe))break;te-=Ie>=65536?2:1,pe=Oe}return le-te}e.prevCharLength=q;function N(K,te){const oe=ze.getInstance(),le=K.length,de=te,pe=$(K,le,te),Ie=oe.getGraphemeBreakType(pe);te+=pe>=65536?2:1;let Oe=Ie;for(;te<le;){const Ne=$(K,le,te),qe=oe.getGraphemeBreakType(Ne);if(Ke(Oe,qe))break;te+=Ne>=65536?2:1,Oe=qe}const Ce=te;for(te=de,Oe=Ie;te>0;){const Ne=z(K,te),qe=oe.getGraphemeBreakType(Ne);if(Ke(qe,Oe))break;te-=Ne>=65536?2:1,Oe=qe}return[te,Ce]}function _(K,te){return te>0&&ae(K.charCodeAt(te))?N(K,te-1):N(K,te)}e.getCharContainingOffset=_;function R(K){const te=K.length;let oe=0,le=0;for(;le<te;){const Ie=$(K,te,le);le+=Ie>=65536?2:1,Ie<128?oe+=1:Ie<2048?oe+=2:Ie<65536?oe+=3:oe+=4}const de=new Uint8Array(oe);le=0;let pe=0;for(;le<te;){const Ie=$(K,te,le);le+=Ie>=65536?2:1,Ie<128?de[pe++]=Ie:Ie<2048?(de[pe++]=192|(Ie&1984)>>>6,de[pe++]=128|(Ie&63)>>>0):Ie<65536?(de[pe++]=224|(Ie&61440)>>>12,de[pe++]=128|(Ie&4032)>>>6,de[pe++]=128|(Ie&63)>>>0):(de[pe++]=240|(Ie&1835008)>>>18,de[pe++]=128|(Ie&258048)>>>12,de[pe++]=128|(Ie&4032)>>>6,de[pe++]=128|(Ie&63)>>>0)}return de}e.encodeUTF8=R;function W(K){const te=K.byteLength,oe=[];let le=0;for(;le<te;){const de=K[le];let pe;if(de>=240&&le+3<te?pe=(K[le++]&7)<<18>>>0|(K[le++]&63)<<12>>>0|(K[le++]&63)<<6>>>0|(K[le++]&63)<<0>>>0:de>=224&&le+2<te?pe=(K[le++]&15)<<12>>>0|(K[le++]&63)<<6>>>0|(K[le++]&63)<<0>>>0:de>=192&&le+1<te?pe=(K[le++]&31)<<6>>>0|(K[le++]&63)<<0>>>0:pe=K[le++],pe>=0&&pe<=55295||pe>=57344&&pe<=65535)oe.push(String.fromCharCode(pe));else if(pe>=65536&&pe<=1114111){const Ie=pe-65536,Oe=55296+((Ie&1047552)>>>10),Ce=56320+((Ie&1023)>>>0);oe.push(String.fromCharCode(Oe)),oe.push(String.fromCharCode(Ce))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=W;const M=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function F(K){return M.test(K)}e.containsRTL=F;const B=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function V(K){return B.test(K)}e.containsEmoji=V;const G=/^[\t\n\r\x20-\x7E]*$/;function Y(K){return G.test(K)}e.isBasicASCII=Y,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Z;function re(K){for(let te=0,oe=K.length;te<oe;te++)if(se(K.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=re;function se(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=se;function x(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=x;function ie(K,te){if(K.length<te)return K;const oe=/\b/g;let le=0;for(;oe.test(K)&&!(K.length-oe.lastIndex<te);)le=oe.lastIndex,oe.lastIndex+=1;return K.substring(le).replace(/^\s/,"")}e.lcut=ie;const ue=/\x1B\x5B[12]?K/g,ye=/\x1b\[\d+m/g,ge=/\x1b\[0?m/g;function Ee(K){return K&&(K=K.replace(ue,""),K=K.replace(ye,""),K=K.replace(ge,"")),K}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ae(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ae;function ve(K){return Ae(K)?K.substr(1):K}e.stripUTF8BOM=ve;function me(K,te){if(!K||!te||K.length<te.length)return!1;const oe=te.length,le=K.toLowerCase();let de=0,pe=-1;for(;de<oe;){const Ie=le.indexOf(te[de],pe+1);if(Ie<0)return!1;pe=Ie,de++}return!0}e.fuzzyContains=me;function be(K,te=!1){return K?(te&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=be;function _e(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=_e;function Te(K,te=1){if(te===0)return"";let oe=-1;do oe=K.indexOf(`
`,oe+1),te--;while(te>0&&oe>=0);return oe===-1?K:(K[oe-1]==="\r"&&oe--,K.substr(0,oe))}e.getNLines=Te;function Ye(K){const te=90-65+1;return K=K%(2*te),K<te?String.fromCharCode(97+K):String.fromCharCode(65+K-te)}e.singleLetterHash=Ye;function xe(K){return ze.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=xe;function Ke(K,te){return K===0?te!==5&&te!==7:K===2&&te===3?!1:K===4||K===2||K===3||te===4||te===2||te===3?!0:!(K===8&&(te===8||te===9||te===11||te===12)||(K===11||K===9)&&(te===9||te===10)||(K===12||K===10)&&te===10||te===5||te===13||te===7||K===1||K===13&&te===14||K===6&&te===6)}e.breakBetweenGraphemeBreakType=Ke;var ot;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(ot=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=nt()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const oe=this._data,le=oe.length/3;let de=1;for(;de<=le;)if(te<oe[3*de])de=2*de;else if(te>oe[3*de+1])de=2*de+1;else return oe[3*de+2];return 0}}ze._INSTANCE=null;function nt(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(X[23],J([0,1,22,63]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",P=typeof TextDecoder!="undefined";let r,p;class i{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return k?new i(Buffer.allocUnsafe(u)):new i(new Uint8Array(u))}static wrap(u){return k&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new i(u)}static fromString(u,f){return!((f==null?void 0:f.dontUseNodeBuffer)||!1)&&k?new i(Buffer.from(u)):y?(r||(r=new TextEncoder),new i(r.encode(u))):new i(m.encodeUTF8(u))}static concat(u,f){if(typeof f=="undefined"){f=0;for(let T=0,U=u.length;T<U;T++)f+=u[T].byteLength}const S=i.alloc(f);let A=0;for(let T=0,U=u.length;T<U;T++){const H=u[T];S.set(H,A),A+=H.byteLength}return S}toString(){return k?this.buffer.toString():P?(p||(p=new TextDecoder),p.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(u,f){return new i(this.buffer.subarray(u,f))}set(u,f){u instanceof i?this.buffer.set(u.buffer,f):this.buffer.set(u,f)}readUInt32BE(u){return b(this.buffer,u)}writeUInt32BE(u,f){v(this.buffer,u,f)}readUInt32LE(u){return d(this.buffer,u)}writeUInt32LE(u,f){w(this.buffer,u,f)}readUInt8(u){return I(this.buffer,u)}writeUInt8(u,f){E(this.buffer,u,f)}}e.VSBuffer=i;function L(l,u){return l[u+0]<<0>>>0|l[u+1]<<8>>>0}e.readUInt16LE=L;function g(l,u,f){l[f+0]=u&255,u=u>>>8,l[f+1]=u&255}e.writeUInt16LE=g;function b(l,u){return l[u]*2**24+l[u+1]*2**16+l[u+2]*2**8+l[u+3]}e.readUInt32BE=b;function v(l,u,f){l[f+3]=u,u=u>>>8,l[f+2]=u,u=u>>>8,l[f+1]=u,u=u>>>8,l[f]=u}e.writeUInt32BE=v;function d(l,u){return l[u+0]<<0>>>0|l[u+1]<<8>>>0|l[u+2]<<16>>>0|l[u+3]<<24>>>0}e.readUInt32LE=d;function w(l,u,f){l[f+0]=u&255,u=u>>>8,l[f+1]=u&255,u=u>>>8,l[f+2]=u&255,u=u>>>8,l[f+3]=u&255}e.writeUInt32LE=w;function I(l,u){return l[u]}e.readUInt8=I;function E(l,u,f){l[f]=u}e.writeUInt8=E;function o(l){return D.consumeReadable(l,u=>i.concat(u))}e.readableToBuffer=o;function c(l){return D.toReadable(l)}e.bufferToReadable=c;function a(l){return D.consumeStream(l,u=>i.concat(u))}e.streamToBuffer=a;async function h(l){return l.ended?i.concat(l.buffer):i.concat([...l.buffer,await a(l.stream)])}e.bufferedStreamToBuffer=h;function t(l){return D.toStream(l,u=>i.concat(u))}e.bufferToStream=t;function n(l){return D.transform(l,{data:u=>typeof u=="string"?i.fromString(u):i.wrap(u)},u=>i.concat(u))}e.streamToBufferReadableStream=n;function s(l){return D.newWriteableStream(u=>i.concat(u),l)}e.newWriteableBufferStream=s}),define(X[80],J([0,1,22]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function D(E){return k(E,0)}e.hash=D;function k(E,o){switch(typeof E){case"object":return E===null?y(349,o):Array.isArray(E)?p(E,o):i(E,o);case"string":return r(E,o);case"boolean":return P(E,o);case"number":return y(E,o);case"undefined":return y(937,o);default:return y(617,o)}}e.doHash=k;function y(E,o){return(o<<5)-o+E|0}function P(E,o){return y(E?433:863,o)}function r(E,o){o=y(149417,o);for(let c=0,a=E.length;c<a;c++)o=y(E.charCodeAt(c),o);return o}e.stringHash=r;function p(E,o){return o=y(104579,o),E.reduce((c,a)=>k(a,c),o)}function i(E,o){return o=y(181387,o),Object.keys(E).sort().reduce((c,a)=>(c=r(a,c),k(E[a],c)),o)}class L{constructor(){this._value=0}get value(){return this._value}hash(o){return this._value=k(o,this._value),this._value}}e.Hasher=L;var g;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(g||(g={}));function b(E,o,c=32){const a=c-o,h=~((1<<a)-1);return(E<<o|(h&E)>>>a)>>>0}function v(E,o=0,c=E.byteLength,a=0){for(let h=0;h<c;h++)E[o+h]=a}function d(E,o,c="0"){for(;E.length<o;)E=c+E;return E}function w(E,o=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(c=>c.toString(16).padStart(2,"0")).join(""):d((E>>>0).toString(16),o/4)}e.toHexString=w;class I{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(o){const c=o.length;if(c!==0){const a=this._buff;let h=this._buffLen,t=this._leftoverHighSurrogate,n,s;for(t!==0?(n=t,s=-1,t=0):(n=o.charCodeAt(0),s=0);;){let l=n;if(m.isHighSurrogate(n))if(s+1<c){const u=o.charCodeAt(s+1);m.isLowSurrogate(u)?(s++,l=m.computeCodePoint(n,u)):l=65533}else{t=n;break}else m.isLowSurrogate(n)&&(l=65533);if(h=this._push(a,h,l),s++,s<c)n=o.charCodeAt(s);else break}this._buffLen=h,this._leftoverHighSurrogate=t}}_push(o,c,a){return a<128?o[c++]=a:a<2048?(o[c++]=192|(a&1984)>>>6,o[c++]=128|(a&63)>>>0):a<65536?(o[c++]=224|(a&61440)>>>12,o[c++]=128|(a&4032)>>>6,o[c++]=128|(a&63)>>>0):(o[c++]=240|(a&1835008)>>>18,o[c++]=128|(a&258048)>>>12,o[c++]=128|(a&4032)>>>6,o[c++]=128|(a&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,o[0]=o[64+0],o[1]=o[64+1],o[2]=o[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const o=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(o/4294967296),!1),this._buffDV.setUint32(60,o%4294967296,!1),this._step()}_step(){const o=I._bigBlock32,c=this._buffDV;for(let S=0;S<64;S+=4)o.setUint32(S,c.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)o.setUint32(S,b(o.getUint32(S-12,!1)^o.getUint32(S-32,!1)^o.getUint32(S-56,!1)^o.getUint32(S-64,!1),1),!1);let a=this._h0,h=this._h1,t=this._h2,n=this._h3,s=this._h4,l,u,f;for(let S=0;S<80;S++)S<20?(l=h&t|~h&n,u=1518500249):S<40?(l=h^t^n,u=1859775393):S<60?(l=h&t|h&n|t&n,u=2400959708):(l=h^t^n,u=3395469782),f=b(a,5)+l+s+u+o.getUint32(S*4,!1)&4294967295,s=n,n=t,t=b(h,30),h=a,a=f;this._h0=this._h0+a&4294967295,this._h1=this._h1+h&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=I,I._bigBlock32=new DataView(new ArrayBuffer(320))}),define(X[12],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(S){return Array.isArray(S)}e.isArray=m;function D(S){return typeof S=="string"}e.isString=D;function k(S){return Array.isArray(S)&&S.every(A=>D(A))}e.isStringArray=k;function y(S){return typeof S=="object"&&S!==null&&!Array.isArray(S)&&!(S instanceof RegExp)&&!(S instanceof Date)}e.isObject=y;function P(S){return typeof S=="number"&&!isNaN(S)}e.isNumber=P;function r(S){return!!S&&typeof S[Symbol.iterator]=="function"}e.isIterable=r;function p(S){return S===!0||S===!1}e.isBoolean=p;function i(S){return typeof S=="undefined"}e.isUndefined=i;function L(S){return!g(S)}e.isDefined=L;function g(S){return i(S)||S===null}e.isUndefinedOrNull=g;function b(S,A){if(!S)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}e.assertType=b;function v(S){if(g(S))throw new Error("Assertion Failed: argument is undefined or null");return S}e.assertIsDefined=v;function d(...S){const A=[];for(let T=0;T<S.length;T++){const U=S[T];if(g(U))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);A.push(U)}return A}e.assertAllDefined=d;const w=Object.prototype.hasOwnProperty;function I(S){if(!y(S))return!1;for(let A in S)if(w.call(S,A))return!1;return!0}e.isEmptyObject=I;function E(S){return typeof S=="function"}e.isFunction=E;function o(...S){return S.length>0&&S.every(E)}e.areFunctions=o;function c(S,A){const T=Math.min(S.length,A.length);for(let U=0;U<T;U++)a(S[U],A[U])}e.validateConstraints=c;function a(S,A){if(D(A)){if(typeof S!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(E(A)){try{if(S instanceof A)return}catch(T){}if(!g(S)&&S.constructor===A||A.length===1&&A.call(void 0,S)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function h(S){let A=[],T=Object.getPrototypeOf(S);for(;Object.prototype!==T;)A=A.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return A}e.getAllPropertyNames=h;function t(S){const A=[];for(const T of h(S))typeof S[T]=="function"&&A.push(T);return A}e.getAllMethodNames=t;function n(S,A){const T=H=>function(){const Q=Array.prototype.slice.call(arguments,0);return A(H,Q)};let U={};for(const H of S)U[H]=T(H);return U}e.createProxyObject=n;function s(S){return S===null?void 0:S}e.withNullAsUndefined=s;function l(S){return typeof S=="undefined"?null:S}e.withUndefinedAsNull=l;function u(S){return class{constructor(){return new Proxy({},{get(A,T){if(A[T])return A[T];throw new Error(`Not Implemented: ${S}->${String(T)}`)}})}}}e.NotImplementedProxy=u;function f(S){throw new Error("Unreachable")}e.assertNever=f}),define(X[30],J([0,1,3,22,8,12]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function P(n){return n===47||n===92}e.isPathSeparator=P;function r(n){return n.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=r;function p(n,s=k.posix.sep){if(!n)return"";const l=n.length,u=n.charCodeAt(0);if(P(u)){if(P(n.charCodeAt(1))&&!P(n.charCodeAt(2))){let S=3;const A=S;for(;S<l&&!P(n.charCodeAt(S));S++);if(A!==S&&!P(n.charCodeAt(S+1))){for(S+=1;S<l;S++)if(P(n.charCodeAt(S)))return n.slice(0,S+1).replace(/[\\/]/g,s)}}return s}else if(I(u)&&n.charCodeAt(1)===58)return P(n.charCodeAt(2))?n.slice(0,2)+s:n.slice(0,2);let f=n.indexOf("://");if(f!==-1){for(f+=3;f<l;f++)if(P(n.charCodeAt(f)))return n.slice(0,f+1)}return""}e.getRoot=p;function i(n){if(!m.isWindows||!n||n.length<5)return!1;let s=n.charCodeAt(0);if(s!==92||(s=n.charCodeAt(1),s!==92))return!1;let l=2;const u=l;for(;l<n.length&&(s=n.charCodeAt(l),s!==92);l++);return!(u===l||(s=n.charCodeAt(l+1),isNaN(s)||s===92))}e.isUNC=i;const L=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(n,s=m.isWindows){const l=s?L:g;return!(!n||n.length===0||/^\s+$/.test(n)||(l.lastIndex=0,l.test(n))||s&&b.test(n)||n==="."||n===".."||s&&n[n.length-1]==="."||s&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=v;function d(n,s,l){const u=n===s;return!l||u?u:!n||!s?!1:(0,D.equalsIgnoreCase)(n,s)}e.isEqual=d;function w(n,s,l,u=k.sep){if(n===s)return!0;if(!n||!s||s.length>n.length)return!1;if(l){if(!(0,D.startsWithIgnoreCase)(n,s))return!1;if(s.length===n.length)return!0;let S=s.length;return s.charAt(s.length-1)===u&&S--,n.charAt(S)===u}return s.charAt(s.length-1)!==u&&(s+=u),n.indexOf(s)===0}e.isEqualOrParent=w;function I(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=I;function E(n,s){return m.isWindows&&n.endsWith(":")&&(n+=k.sep),(0,k.isAbsolute)(n)||(n=(0,k.join)(s,n)),n=(0,k.normalize)(n),m.isWindows?(n=(0,D.rtrim)(n,k.sep),n.endsWith(":")&&(n+=k.sep)):(n=(0,D.rtrim)(n,k.sep),n||(n=k.sep)),n}e.sanitizeFilePath=E;function o(n){const s=(0,k.normalize)(n);return m.isWindows?n.length>3?!1:c(s)&&(n.length===2||s.charCodeAt(2)===92):s===k.posix.sep}e.isRootOrDriveLetter=o;function c(n){return m.isWindows?I(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function a(n){return c(n)?n[0]:void 0}e.getDriveLetter=a;function h(n,s,l){return s.length>n.length?-1:n===s?0:(l&&(n=n.toLowerCase(),s=s.toLowerCase()),n.indexOf(s))}e.indexOfPath=h;function t(n){const s=n.split(":");let l,u,f;if(s.forEach(S=>{const A=Number(S);(0,y.isNumber)(A)?u===void 0?u=A:f===void 0&&(f=A):l=l?[l,S].join(":"):S}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:u!==void 0?u:void 0,column:f!==void 0?f:u!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(X[44],J([0,1,12]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const w=Array.isArray(d)?[]:{};return Object.keys(d).forEach(I=>{d[I]&&typeof d[I]=="object"?w[I]=D(d[I]):w[I]=d[I]}),w}e.deepClone=D;function k(d){if(!d||typeof d!="object")return d;const w=[d];for(;w.length>0;){const I=w.shift();Object.freeze(I);for(const E in I)if(y.call(I,E)){const o=I[E];typeof o=="object"&&!Object.isFrozen(o)&&w.push(o)}}return d}e.deepFreeze=k;const y=Object.prototype.hasOwnProperty;function P(d,w){return r(d,w,new Set)}e.cloneAndChange=P;function r(d,w,I){if((0,m.isUndefinedOrNull)(d))return d;const E=w(d);if(typeof E!="undefined")return E;if((0,m.isArray)(d)){const o=[];for(const c of d)o.push(r(c,w,I));return o}if((0,m.isObject)(d)){if(I.has(d))throw new Error("Cannot clone recursive data-structure");I.add(d);const o={};for(let c in d)y.call(d,c)&&(o[c]=r(d[c],w,I));return I.delete(d),o}return d}function p(d,w,I=!0){return(0,m.isObject)(d)?((0,m.isObject)(w)&&Object.keys(w).forEach(E=>{E in d?I&&((0,m.isObject)(d[E])&&(0,m.isObject)(w[E])?p(d[E],w[E],I):d[E]=w[E]):d[E]=w[E]}),d):w}e.mixin=p;function i(d,w){if(d===w)return!0;if(d==null||w===null||w===void 0||typeof d!=typeof w||typeof d!="object"||Array.isArray(d)!==Array.isArray(w))return!1;let I,E;if(Array.isArray(d)){if(d.length!==w.length)return!1;for(I=0;I<d.length;I++)if(!i(d[I],w[I]))return!1}else{const o=[];for(E in d)o.push(E);o.sort();const c=[];for(E in w)c.push(E);if(c.sort(),!i(o,c))return!1;for(I=0;I<o.length;I++)if(!i(d[o[I]],w[o[I]]))return!1}return!0}e.equals=i;function L(d){const w=new Set;return JSON.stringify(d,(I,E)=>{if((0,m.isObject)(E)||Array.isArray(E)){if(w.has(E))return"[Circular]";w.add(E)}return E})}e.safeStringify=L;function g(d,w,I){const E=w(d);return typeof E=="undefined"?I:E}e.getOrDefault=g;function b(d,w){const I=Object.create(null);return!d||!w||Object.keys(w).forEach(o=>{const c=d[o],a=w[o];i(c,a)||(I[o]=a)}),I}e.distinct=b;function v(d,w){const I=w.toLowerCase(),E=Object.keys(d).find(o=>o.toLowerCase()===I);return E?d[E]:d[w]}e.getCaseInsensitive=v}),define(X[7],J([0,1,3,8]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,y=/^\//,P=/^\/\//;function r(s,l){if(!s.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!k.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!y.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(s,l){return!s&&!l?"file":s}function i(s,l){switch(s){case"https":case"http":case"file":l?l[0]!==g&&(l=g+l):l=g;break}return l}const L="",g="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(l,u,f,S,A,T=!1){typeof l=="object"?(this.scheme=l.scheme||L,this.authority=l.authority||L,this.path=l.path||L,this.query=l.query||L,this.fragment=l.fragment||L):(this.scheme=p(l,T),this.authority=u||L,this.path=i(this.scheme,f||L),this.query=S||L,this.fragment=A||L,r(this,T))}static isUri(l){return l instanceof v?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}get fsPath(){return c(this,!1)}with(l){if(!l)return this;let{scheme:u,authority:f,path:S,query:A,fragment:T}=l;return u===void 0?u=this.scheme:u===null&&(u=L),f===void 0?f=this.authority:f===null&&(f=L),S===void 0?S=this.path:S===null&&(S=L),A===void 0?A=this.query:A===null&&(A=L),T===void 0?T=this.fragment:T===null&&(T=L),u===this.scheme&&f===this.authority&&S===this.path&&A===this.query&&T===this.fragment?this:new w(u,f,S,A,T)}static parse(l,u=!1){const f=b.exec(l);return f?new w(f[2]||L,n(f[4]||L),n(f[5]||L),n(f[7]||L),n(f[9]||L),u):new w(L,L,L,L,L)}static file(l){let u=L;if(m.isWindows&&(l=l.replace(/\\/g,g)),l[0]===g&&l[1]===g){const f=l.indexOf(g,2);f===-1?(u=l.substring(2),l=g):(u=l.substring(2,f),l=l.substring(f)||g)}return new w("file",u,l,L,L)}static from(l){return new w(l.scheme,l.authority,l.path,l.query,l.fragment)}static joinPath(l,...u){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return m.isWindows&&l.scheme==="file"?f=v.file(D.win32.join(c(l,!0),...u)).path:f=D.posix.join(l.path,...u),l.with({path:f})}toString(l=!1){return a(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof v)return l;{const u=new w(l);return u._formatted=l.external,u._fsPath=l._sep===d?l.fsPath:null,u}}else return l}}e.URI=v;const d=m.isWindows?1:void 0;class w extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(l=!1){return l?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=d),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const I={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(s,l){let u,f=-1;for(let S=0;S<s.length;S++){const A=s.charCodeAt(S);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||l&&A===47)f!==-1&&(u+=encodeURIComponent(s.substring(f,S)),f=-1),u!==void 0&&(u+=s.charAt(S));else{u===void 0&&(u=s.substr(0,S));const T=I[A];T!==void 0?(f!==-1&&(u+=encodeURIComponent(s.substring(f,S)),f=-1),u+=T):f===-1&&(f=S)}}return f!==-1&&(u+=encodeURIComponent(s.substring(f))),u!==void 0?u:s}function o(s){let l;for(let u=0;u<s.length;u++){const f=s.charCodeAt(u);f===35||f===63?(l===void 0&&(l=s.substr(0,u)),l+=I[f]):l!==void 0&&(l+=s[u])}return l!==void 0?l:s}function c(s,l){let u;return s.authority&&s.path.length>1&&s.scheme==="file"?u=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?l?u=s.path.substr(1):u=s.path[1].toLowerCase()+s.path.substr(2):u=s.path,m.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=c;function a(s,l){const u=l?o:E;let f="",{scheme:S,authority:A,path:T,query:U,fragment:H}=s;if(S&&(f+=S,f+=":"),(A||S==="file")&&(f+=g,f+=g),A){let Q=A.indexOf("@");if(Q!==-1){const ne=A.substr(0,Q);A=A.substr(Q+1),Q=ne.indexOf(":"),Q===-1?f+=u(ne,!1):(f+=u(ne.substr(0,Q),!1),f+=":",f+=u(ne.substr(Q+1),!1)),f+="@"}A=A.toLowerCase(),Q=A.indexOf(":"),Q===-1?f+=u(A,!1):(f+=u(A.substr(0,Q),!1),f+=A.substr(Q))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const Q=T.charCodeAt(1);Q>=65&&Q<=90&&(T=`/${String.fromCharCode(Q+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const Q=T.charCodeAt(0);Q>=65&&Q<=90&&(T=`${String.fromCharCode(Q+32)}:${T.substr(2)}`)}f+=u(T,!0)}return U&&(f+="?",f+=u(U,!1)),H&&(f+="#",f+=l?H:E(H,!1)),f}function h(s){try{return decodeURIComponent(s)}catch(l){return s.length>3?s.substr(0,3)+h(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(t)?s.replace(t,l=>h(l)):s}}),define(X[106],J([0,1,7]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function D(i){const L=i;return L&&typeof L.type=="string"&&typeof L.severity=="string"}e.isRemoteConsoleLog=D;function k(i){const L=[];let g;try{const b=JSON.parse(i.arguments),v=b[b.length-1];v&&v.__$stack&&(b.pop(),g=v.__$stack),L.push(...b)}catch(b){L.push("Unable to log remote console arguments",i.arguments)}return{args:L,stack:g}}e.parse=k;function y(i){if(typeof i!="string")return y(k(i).stack);const L=i;if(L){const g=P(L),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(g||"");if(b&&b.length===4)return{uri:m.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=y;function P(i){if(!i)return i;const L=i.indexOf(`
`);return L===-1?i:i.substring(0,L)}function r(i,L){const{args:g,stack:b}=k(i),v=typeof g[0]=="string"&&g.length===1;let d=P(b);d&&(d=`(${d.trim()})`);let w=[];if(typeof g[0]=="string"?d&&v?w=[`%c[${L}] %c${g[0]} %c${d}`,p("blue"),p(""),p("grey")]:w=[`%c[${L}] %c${g[0]}`,p("blue"),p(""),...g.slice(1)]:w=[`%c[${L}]%`,p("blue"),...g],d&&!v&&w.push(d),typeof console[i.severity]!="function")throw new Error("Unknown console method");console[i.severity].apply(console,w)}e.log=r;function p(i){return`color: ${i}`}});var yt=this&&this.__classPrivateFieldSet||function(j,e,m,D,k){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?j!==e||!k:!e.has(j))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?k.call(j,m):k?k.value=m:e.set(j,m),m},Ge=this&&this.__classPrivateFieldGet||function(j,e,m,D){if(m==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?j!==e||!D:!e.has(j))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?D:m==="a"?D.call(j):D?D.value:e.get(j)};define(X[36],J([0,1,7,22]),function(j,e,m,D){"use strict";var k,y,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function r(t,n,s){let l=t.get(n);return l===void 0&&(l=s,t.set(n,l)),l}e.getOrSet=r;function p(t){const n=[];return t.forEach((s,l)=>{n.push(`${l} => ${s}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=p;function i(t){const n=[];return t.forEach(s=>{n.push(s)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=i;class L{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),l=this._value.charCodeAt(this._pos);return s-l}value(){return this._value[this._pos]}}e.StringIterator=L;class g{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,D.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=g;class b{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,D.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=b;var v;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(v||(v={}));class d{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new b(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,D.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class w{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class I{constructor(n){this._iter=n}static forUris(n=()=>!1){return new I(new d(n))}static forPaths(){return new I(new b)}static forStrings(){return new I(new L)}static forConfigKeys(){return new I(new g)}clear(){this._root=void 0}set(n,s){const l=this._iter.reset(n);let u;for(this._root||(this._root=new w,this._root.segment=l.value()),u=this._root;;){const S=l.cmp(u.segment);if(S>0)u.left||(u.left=new w,u.left.segment=l.value()),u=u.left;else if(S<0)u.right||(u.right=new w,u.right.segment=l.value()),u=u.right;else if(l.hasNext())l.next(),u.mid||(u.mid=new w,u.mid.segment=l.value()),u=u.mid;else break}const f=u.value;return u.value=s,u.key=n,f}get(n){var s;return(s=this._getNode(n))===null||s===void 0?void 0:s.value}_getNode(n){const s=this._iter.reset(n);let l=this._root;for(;l;){const u=s.cmp(l.segment);if(u>0)l=l.left;else if(u<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else break}return l}has(n){const s=this._getNode(n);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const l=this._iter.reset(n),u=[];let f=this._root;for(;f;){const S=l.cmp(f.segment);if(S>0)u.push([1,f]),f=f.left;else if(S<0)u.push([-1,f]),f=f.right;else if(l.hasNext())l.next(),u.push([0,f]),f=f.mid;else{for(s?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;u.length>0&&f.isEmpty();){let[A,T]=u.pop();switch(A){case 1:T.left=void 0;break;case 0:T.mid=void 0;break;case-1:T.right=void 0;break}f=T}break}}}findSubstr(n){const s=this._iter.reset(n);let l=this._root,u;for(;l;){const f=s.cmp(l.segment);if(f>0)l=l.left;else if(f<0)l=l.right;else if(s.hasNext())s.next(),u=l.value||u,l=l.mid;else break}return l&&l.value||u}findSuperstr(n){const s=this._iter.reset(n);let l=this._root;for(;l;){const u=s.cmp(l.segment);if(u>0)l=l.left;else if(u<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(n){for(const[s,l]of this)n(l,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=I;class E{constructor(n,s){this[k]="ResourceMap",n instanceof E?(this.map=new Map(n.map),this.toKey=s!=null?s:E.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:E.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),s),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[l,u]of this.map)n(u,m.URI.parse(l),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield m.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[m.URI.parse(n[0]),n[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[m.URI.parse(n[0]),n[1]]}}e.ResourceMap=E,E.defaultToKey=t=>t.toString();var o;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class c{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,s=0){const l=this._map.get(n);if(!!l)return s!==0&&this.touch(l,s),l.value}set(n,s,l=0){let u=this._map.get(n);if(u)u.value=s,l!==0&&this.touch(u,l);else{switch(u={key:n,value:s,next:void 0,previous:void 0},l){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(n,u),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,s){const l=this._state;let u=this._head;for(;u;){if(s?n.bind(s)(u.value,u.key,this):n(u.value,u.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,s=this._state;let l=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const f={value:l.key,done:!1};return l=l.next,f}else return{value:void 0,done:!0}}};return u}values(){const n=this,s=this._state;let l=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const f={value:l.value,done:!1};return l=l.next,f}else return{value:void 0,done:!0}}};return u}entries(){const n=this,s=this._state;let l=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const f={value:[l.key,l.value],done:!1};return l=l.next,f}else return{value:void 0,done:!0}}};return u}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let s=this._head,l=this.size;for(;s&&l>n;)this._map.delete(s.key),s=s.next,l--;this._head=s,this._size=l,s&&(s.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,l=n.previous;if(!s||!l)throw new Error("Invalid list");s.previous=l,l.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const l=n.next,u=n.previous;n===this._tail?(u.next=void 0,this._tail=u):(l.previous=u,u.next=l),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const l=n.next,u=n.previous;n===this._head?(l.previous=void 0,this._head=l):(l.previous=u,u.next=l),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,l)=>{n.push([l,s])}),n}fromJSON(n){this.clear();for(const[s,l]of n)this.set(s,l)}}e.LinkedMap=c;class a extends c{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class h{constructor(n){P.set(this,void 0),yt(this,P,n,"f")}get size(){return Ge(this,P,"f").size}forEach(n,s){Ge(this,P,"f").forEach(n,s)}get(n){return Ge(this,P,"f").get(n)}has(n){return Ge(this,P,"f").has(n)}entries(){return Ge(this,P,"f").entries()}keys(){return Ge(this,P,"f").keys()}values(){return Ge(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Ge(this,P,"f").entries()}}e.ReadonlyMapView=h}),define(X[107],J([0,1,23,22,7]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function y(i){return JSON.stringify(i,r)}e.stringify=y;function P(i){let L=JSON.parse(i);return L=p(L),L}e.parse=P;function r(i,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,D.regExpFlags)(L)}:L}function p(i,L=0){if(!i||L>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return k.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof m.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let g=0;g<i.length;++g)i[g]=p(i[g],L+1);else for(const g in i)Object.hasOwnProperty.call(i,g)&&(i[g]=p(i[g],L+1))}return i}e.revive=p}),define(X[10],J([0,1,7,3]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.userData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebook="vscode-notebook",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file"})(k=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}set(p,i,L){this._hosts[p]=i,this._ports[p]=L}setConnectionToken(p,i){this._connectionTokens[p]=i}rewrite(p){if(this._delegate)return this._delegate(p);const i=p.authority;let L=this._hosts[i];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const g=this._ports[i],b=this._connectionTokens[i];let v=`path=${encodeURIComponent(p.path)}`;return typeof b=="string"&&(v+=`&tkn=${encodeURIComponent(b)}`),m.URI.from({scheme:D.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${L}:${g}`,path:"/vscode-remote-resource",query:v})}}e.RemoteAuthorities=new y;class P{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(p,i,L){const g=this.toUri(p,i);return g.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(g):D.isNative&&(L||D.isPreferringBrowserCodeLoad)&&g.scheme===k.file?g.with({scheme:k.vscodeFileResource,authority:g.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):g}asFileUri(p,i){const L=this.toUri(p,i);return L.scheme===k.vscodeFileResource?L.with({scheme:k.file,authority:L.authority!==this.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(p,i){return m.URI.isUri(p)?p:m.URI.parse(i.toUrl(p))}}e.FileAccess=new P}),define(X[64],J([0,1,36]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const D=new m.LRUCache(1e4);function k(i){return p(i,"NFC",D)}e.normalizeNFC=k;const y=new m.LRUCache(1e4);function P(i){return p(i,"NFD",y)}e.normalizeNFD=P;const r=/[^\u0000-\u0080]/;function p(i,L,g){if(!e.canNormalize||!i)return i;const b=g.get(i);if(b)return b;let v;return r.test(i)?v=i.normalize(L):v=i,g.set(i,v),v}e.removeAccents=function(){if(e.canNormalize){const i=/[\u0300-\u036f]/g;return function(L){return P(L).replace(i,"")}}else return function(i){return i}}()}),define(X[15],J([0,1,30,8,7,22,10,3]),function(j,e,m,D,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(v){return(0,k.uriToFsPath)(v,!0)}e.originalFSPath=p;class i{constructor(d){this._ignorePathCasing=d}compare(d,w,I=!1){return d===w?0:(0,y.compare)(this.getComparisonKey(d,I),this.getComparisonKey(w,I))}isEqual(d,w,I=!1){return d===w?!0:!d||!w?!1:this.getComparisonKey(d,I)===this.getComparisonKey(w,I)}getComparisonKey(d,w=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,w,I=!1){if(d.scheme===w.scheme){if(d.scheme===P.Schemas.file)return m.isEqualOrParent(p(d),p(w),this._ignorePathCasing(d))&&d.query===w.query&&(I||d.fragment===w.fragment);if((0,e.isEqualAuthority)(d.authority,w.authority))return m.isEqualOrParent(d.path,w.path,this._ignorePathCasing(d),"/")&&d.query===w.query&&(I||d.fragment===w.fragment)}return!1}joinPath(d,...w){return k.URI.joinPath(d,...w)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return D.posix.basename(d.path)}extname(d){return D.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let w;return d.scheme===P.Schemas.file?w=k.URI.file(D.dirname(p(d))).path:(w=D.posix.dirname(d.path),d.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),w="/")),d.with({path:w})}normalizePath(d){if(!d.path.length)return d;let w;return d.scheme===P.Schemas.file?w=k.URI.file(D.normalize(p(d))).path:w=D.posix.normalize(d.path),d.with({path:w})}relativePath(d,w){if(!(d.scheme!==w.scheme||!(0,e.isEqualAuthority)(d.authority,w.authority))){if(d.scheme===P.Schemas.file){const o=D.relative(p(d),p(w));return r.isWindows?m.toSlashes(o):o}let I=d.path||"/",E=w.path||"/";if(this._ignorePathCasing(d)){let o=0;for(const c=Math.min(I.length,E.length);o<c&&!(I.charCodeAt(o)!==E.charCodeAt(o)&&I.charAt(o).toLowerCase()!==E.charAt(o).toLowerCase());o++);I=E.substr(0,o)+I.substr(o)}return D.posix.relative(I,E)}}resolvePath(d,w){if(d.scheme===P.Schemas.file){const I=k.URI.file(D.resolve(p(d),w));return d.with({authority:I.authority,path:I.path})}return w.indexOf("/")===-1&&(w=m.toSlashes(w),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w)),d.with({path:D.posix.resolve(d.path,w)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,w){return d===w||(0,y.equalsIgnoreCase)(d,w)}hasTrailingPathSeparator(d,w=D.sep){if(d.scheme===P.Schemas.file){const I=p(d);return I.length>m.getRoot(I).length&&I[I.length-1]===w}else{const I=d.path;return I.length>1&&I.charCodeAt(I.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,w=D.sep){return(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,w=D.sep){let I=!1;if(d.scheme===P.Schemas.file){const E=p(d);I=E!==void 0&&E.length===m.getRoot(E).length&&E[E.length-1]===w}else{w="/";const E=d.path;I=E.length===1&&E.charCodeAt(E.length-1)===47}return!I&&!(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path+"/"}):d}}e.ExtUri=i,e.extUri=new i(()=>!1),e.extUriBiasedIgnorePathCase=new i(v=>v.scheme===P.Schemas.file?!r.isLinux:!0),e.extUriIgnorePathCase=new i(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(v,d){const w=[];for(let I=0;I<v.length;I++){const E=d(v[I]);v.some((o,c)=>c===I?!1:(0,e.isEqualOrParent)(E,d(o)))||w.push(v[I])}return w}e.distinctParents=L;var g;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function d(w){const I=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(c=>{const[a,h]=c.split(":");a&&h&&I.set(a,h)});const o=w.path.substring(0,w.path.indexOf(";"));return o&&I.set(v.META_DATA_MIME,o),I}v.parseMetaData=d})(g=e.DataUri||(e.DataUri={}));function b(v,d,w){if(d){let I=v.path;return I&&I[0]!==D.posix.sep&&(I=D.posix.sep+I),v.with({scheme:w,authority:d,path:I})}return v.with({scheme:w})}e.toLocalResource=b}),define(X[9],J([0,1,25,17,5,2,78,15]),function(j,e,m,D,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function p(N){return!!N&&typeof N.then=="function"}e.isThenable=p;function i(N){const _=new m.CancellationTokenSource,R=N(_.token),W=new Promise((M,F)=>{_.token.onCancellationRequested(()=>{F((0,D.canceled)())}),Promise.resolve(R).then(B=>{_.dispose(),M(B)},B=>{_.dispose(),F(B)})});return new class{cancel(){_.cancel()}then(M,F){return W.then(M,F)}catch(M){return this.then(void 0,M)}finally(M){return W.finally(M)}}}e.createCancelablePromise=i;function L(N,_,R){return Promise.race([N,new Promise(W=>_.onCancellationRequested(()=>W(R)))])}e.raceCancellation=L;async function g(N){let _=-1;const R=N.map((M,F)=>M.then(B=>(_=F,B))),W=await Promise.race(R);return N.forEach((M,F)=>{F!==_&&M.cancel()}),W}e.raceCancellablePromises=g;function b(N,_,R){let W;const M=setTimeout(()=>{W==null||W(void 0),R==null||R()},_);return Promise.race([N.finally(()=>clearTimeout(M)),new Promise(F=>W=F)])}e.raceTimeout=b;function v(N){return new Promise((_,R)=>{const W=N();p(W)?W.then(_,R):_(W)})}e.asPromise=v;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(_){if(this.activePromise){if(this.queuedPromiseFactory=_,!this.queuedPromise){const R=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(R,R).then(W)})}return new Promise((R,W)=>{this.queuedPromise.then(R,W)})}return this.activePromise=_(),new Promise((R,W)=>{this.activePromise.then(M=>{this.activePromise=null,R(M)},M=>{this.activePromise=null,W(M)})})}}e.Throttler=d;class w{constructor(){this.current=Promise.resolve(null)}queue(_){return this.current=this.current.then(()=>_(),()=>_())}}e.Sequencer=w;class I{constructor(){this.promiseMap=new Map}queue(_,R){var W;const F=((W=this.promiseMap.get(_))!==null&&W!==void 0?W:Promise.resolve()).catch(()=>{}).then(R).finally(()=>{this.promiseMap.get(_)===F&&this.promiseMap.delete(_)});return this.promiseMap.set(_,F),F}}e.SequencerByKey=I;class E{constructor(_){this.defaultDelay=_,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(_,R=this.defaultDelay){return this.task=_,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((W,M)=>{this.doResolve=W,this.doReject=M}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const W=this.task;return this.task=null,W()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},R),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,D.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=E;class o{constructor(_){this.delayer=new E(_),this.throttler=new d}trigger(_,R){return this.delayer.trigger(()=>this.throttler.queue(_),R)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=o;class c{constructor(){this._isOpen=!1,this._promise=new Promise((_,R)=>{this._completePromise=_})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class a extends c{constructor(_){super();this._timeout=setTimeout(()=>this.open(),_)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function h(N,_){return _?new Promise((R,W)=>{const M=setTimeout(R,N);_.onCancellationRequested(()=>{clearTimeout(M),W((0,D.canceled)())})}):i(R=>h(N,R))}e.timeout=h;function t(N,_=0){const R=setTimeout(N,_);return(0,y.toDisposable)(()=>clearTimeout(R))}e.disposableTimeout=t;function n(N){return N.then(void 0,_=>{})}e.ignoreErrors=n;function s(N){const _=[];let R=0;const W=N.length;function M(){return R<W?N[R++]():null}function F(B){B!=null&&_.push(B);const V=M();return V?V.then(F):Promise.resolve(_)}return Promise.resolve(null).then(F)}e.sequence=s;function l(N,_=W=>!!W,R=null){let W=0;const M=N.length,F=()=>{if(W>=M)return Promise.resolve(R);const B=N[W++];return Promise.resolve(B()).then(G=>_(G)?Promise.resolve(G):F())};return F()}e.first=l;function u(N,_=W=>!!W,R=null){if(N.length===0)return Promise.resolve(R);let W=N.length;const M=()=>{var F,B;W=-1;for(const V of N)(B=(F=V).cancel)===null||B===void 0||B.call(F)};return new Promise((F,B)=>{for(const V of N)V.then(G=>{--W>=0&&_(G)?(M(),F(G)):W===0&&F(R)}).catch(G=>{--W>=0&&(M(),B(G))})})}e.firstParallel=u;class f{constructor(_){this._size=0,this.maxDegreeOfParalellism=_,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(_){return this._size++,new Promise((R,W)=>{this.outstandingPromises.push({factory:_,c:R,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const _=this.outstandingPromises.shift();this.runningPromises++;const R=_.factory();R.then(_.c,_.e),R.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class S extends f{constructor(){super(1)}}e.Queue=S;class A{constructor(){this.queues=new Map}queueFor(_,R=r.extUri){const W=R.getComparisonKey(_);let M=this.queues.get(W);return M||(M=new S,k.Event.once(M.onFinished)(()=>{M==null||M.dispose(),this.queues.delete(W)}),this.queues.set(W,M)),M}dispose(){this.queues.forEach(_=>_.dispose()),this.queues.clear()}}e.ResourceQueue=A;class T{constructor(_,R){this._token=-1,typeof _=="function"&&typeof R=="number"&&this.setIfNotSet(_,R)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(_,R){this.cancel(),this._token=setTimeout(()=>{this._token=-1,_()},R)}setIfNotSet(_,R){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,_()},R))}}e.TimeoutTimer=T;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(_,R){this.cancel(),this._token=setInterval(()=>{_()},R)}}e.IntervalTimer=U;class H{constructor(_,R){this.timeoutToken=-1,this.runner=_,this.timeout=R,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(_=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,_)}get delay(){return this.timeout}set delay(_){this.timeout=_}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=H;class Q extends H{constructor(_,R){super(_,R);this.units=[]}work(_){this.units.push(_),this.isScheduled()||this.schedule()}doRun(){const _=this.units;this.units=[],this.runner&&this.runner(_)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Q,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=_=>{const R=setTimeout(()=>_(N));let W=!1;return{dispose(){W||(W=!0,clearTimeout(R))}}}}else e.runWhenIdle=(N,_)=>{const R=requestIdleCallback(N,typeof _=="number"?{timeout:_}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(R))}}}}();class ne{constructor(_){this._didRun=!1,this._executor=()=>{try{this._value=_()}catch(R){this._error=R}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=ne;async function ae(N,_,R){let W;for(let M=0;M<R;M++)try{return await N()}catch(F){W=F,await h(_)}throw W}e.retry=ae;class O{hasPending(_){return this._pending?typeof _=="number"?this._pending.taskId===_:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var _;(_=this._pending)===null||_===void 0||_.cancel()}setPending(_,R,W){return this._pending={taskId:_,cancel:()=>W==null?void 0:W(),promise:R},R.then(()=>this.donePending(_),()=>this.donePending(_)),R}donePending(_){this._pending&&_===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const _=this._next;this._next=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this._next)this._next.run=_;else{let R,W;const M=new Promise((F,B)=>{R=F,W=B});this._next={run:_,promise:M,promiseResolve:R,promiseReject:W}}return this._next.promise}}e.TaskSequentializer=O;class ${constructor(_){this.interval=_,this.lastIncrementTime=0,this.value=0}increment(){const _=Date.now();return _-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=_,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((_,R)=>{this.completeCallback=_,this.errorCallback=R})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(_){return new Promise(R=>{this.completeCallback(_),this.resolved=!0,R()})}error(_){return new Promise(R=>{this.errorCallback(_),this.rejected=!0,R()})}cancel(){new Promise(_=>{this.errorCallback((0,D.canceled)()),this.rejected=!0,_()})}}e.DeferredPromise=z;class C extends k.Emitter{async fireAsync(_,R,W){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const M of this._listeners)this._asyncDeliveryQueue.push([M,_]);for(;this._asyncDeliveryQueue.size>0&&!R.isCancellationRequested;){const[M,F]=this._asyncDeliveryQueue.shift(),B=[],V=Object.assign(Object.assign({},F),{waitUntil:G=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");W&&(G=W(G,typeof M=="function"?M:M[0])),B.push(G)}});try{typeof M=="function"?M.call(void 0,V):M[0].call(M[1],V)}catch(G){(0,D.onUnexpectedError)(G);continue}Object.freeze(B),await q.settled(B).catch(G=>(0,D.onUnexpectedError)(G))}}}}e.AsyncEmitter=C;var q;(function(N){async function _(F){return typeof Promise.allSettled=="function"?R(F):W(F)}N.allSettled=_;async function R(F){return Promise.allSettled(F)}async function W(F){return Promise.all(F.map(B=>B.then(V=>({status:"fulfilled",value:V}),V=>({status:"rejected",reason:V}))))}async function M(F){let B;const V=await Promise.all(F.map(G=>G.then(Y=>Y,Y=>{B||(B=Y)})));if(typeof B!="undefined")throw B;return V}N.settled=M})(q=e.Promises||(e.Promises={}))}),define(X[108],J([0,1,22,30,8,36,9]),function(j,e,m,D,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function r(){return Object.create(null)}e.getEmptyExpression=r;const p="**",i="/",L="[/\\\\]",g="[^/\\\\]",b=/\//g;function v(R){switch(R){case 0:return"";case 1:return`${g}*?`;default:return`(?:${L}|${g}+${L}|${L}${g}+)*?`}}function d(R,W){if(!R)return[];const M=[];let F=!1,B=!1,V="";for(const G of R){switch(G){case W:if(!F&&!B){M.push(V),V="";continue}break;case"{":F=!0;break;case"}":F=!1;break;case"[":B=!0;break;case"]":B=!1;break}V+=G}return V&&M.push(V),M}e.splitGlobAware=d;function w(R){if(!R)return"";let W="";const M=d(R,i);if(M.every(F=>F===p))W=".*";else{let F=!1;M.forEach((B,V)=>{if(B===p){F||(W+=v(2),F=!0);return}let G=!1,Y="",Z=!1,re="";for(const se of B){if(se!=="}"&&G){Y+=se;continue}if(Z&&(se!=="]"||!re)){let x;se==="-"?x=se:(se==="^"||se==="!")&&!re?x="^":se===i?x="":x=m.escapeRegExpCharacters(se),re+=x;continue}switch(se){case"{":G=!0;continue;case"[":Z=!0;continue;case"}":W+=`(?:${d(Y,",").map(ue=>w(ue)).join("|")})`,G=!1,Y="";break;case"]":W+="["+re+"]",Z=!1,re="";break;case"?":W+=g;continue;case"*":W+=v(1);continue;default:W+=m.escapeRegExpCharacters(se)}}V<M.length-1&&(M[V+1]!==p||V+2<M.length)&&(W+=L),F=!1})}return W}const I=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,o=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),n=function(){return!1},s=function(){return null};function l(R,W){if(!R)return s;let M;typeof R!="string"?M=R.pattern:M=R,M=M.trim();const F=`${M}_${!!W.trimForExclusions}`;let B=t.get(F);if(B)return u(B,R);let V;if(I.test(M)){const G=M.substr(4);B=function(Y,Z){return typeof Y=="string"&&Y.endsWith(G)?M:null}}else(V=E.exec(f(M,W)))?B=S(V[1],M):(W.trimForExclusions?c:o).test(M)?B=A(M,W):(V=a.exec(f(M,W)))?B=T(V[1].substr(1),M,!0):(V=h.exec(f(M,W)))?B=T(V[1],M,!1):B=U(M);return t.set(F,B),u(B,R)}function u(R,W){return typeof W=="string"?R:function(M,F){return D.isEqualOrParent(M,W.base)?R(k.relative(W.base,M),F):null}}function f(R,W){return W.trimForExclusions&&R.endsWith("/**")?R.substr(0,R.length-2):R}function S(R,W){const M=`/${R}`,F=`\\${R}`,B=function(G,Y){return typeof G!="string"?null:Y?Y===R?W:null:G===R||G.endsWith(M)||G.endsWith(F)?W:null},V=[R];return B.basenames=V,B.patterns=[W],B.allBasenames=V,B}function A(R,W){const M=_(R.slice(1,-1).split(",").map(Y=>l(Y,W)).filter(Y=>Y!==s),R),F=M.length;if(!F)return s;if(F===1)return M[0];const B=function(Y,Z){for(let re=0,se=M.length;re<se;re++)if(M[re](Y,Z))return R;return null},V=M.find(Y=>!!Y.allBasenames);V&&(B.allBasenames=V.allBasenames);const G=M.reduce((Y,Z)=>Z.allPaths?Y.concat(Z.allPaths):Y,[]);return G.length&&(B.allPaths=G),B}function T(R,W,M){const F=k.sep===k.posix.sep,B=F?R:R.replace(b,k.sep),V=k.sep+B,G=k.posix.sep+R,Y=M?function(Z,re){return typeof Z=="string"&&(Z===B||Z.endsWith(V)||!F&&(Z===R||Z.endsWith(G)))?W:null}:function(Z,re){return typeof Z=="string"&&(Z===B||!F&&Z===R)?W:null};return Y.allPaths=[(M?"*/":"./")+R],Y}function U(R){try{const W=new RegExp(`^${w(R)}$`);return function(M){return W.lastIndex=0,typeof M=="string"&&W.test(M)?R:null}}catch(W){return s}}function H(R,W,M){return!R||typeof W!="string"?!1:Q(R)(W,void 0,M)}e.match=H;function Q(R,W={}){if(!R)return n;if(typeof R=="string"||$(R)){const M=l(R,W);if(M===s)return n;const F=function(B,V){return!!M(B,V)};return M.allBasenames&&(F.allBasenames=M.allBasenames),M.allPaths&&(F.allPaths=M.allPaths),F}return q(R,W)}e.parse=Q;function ne(R){if(!!R){let W;return M=>(W||(W=(R()||Promise.resolve([])).then(F=>F?O(F):{})),W.then(F=>!!F[M]))}}e.hasSiblingPromiseFn=ne;function ae(R){if(!!R){let W;return M=>{if(!W){const F=R();W=F?O(F):{}}return!!W[M]}}}e.hasSiblingFn=ae;function O(R){const W={};for(const M of R)W[M]=!0;return W}function $(R){const W=R;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=$;function z(R){return R.allBasenames||[]}e.getBasenameTerms=z;function C(R){return R.allPaths||[]}e.getPathTerms=C;function q(R,W){const M=_(Object.getOwnPropertyNames(R).map(Y=>N(Y,R[Y],W)).filter(Y=>Y!==s)),F=M.length;if(!F)return s;if(!M.some(Y=>!!Y.requiresSiblings)){if(F===1)return M[0];const Y=function(se,x){for(let ie=0,ue=M.length;ie<ue;ie++){const ye=M[ie](se,x);if(ye)return ye}return null},Z=M.find(se=>!!se.allBasenames);Z&&(Y.allBasenames=Z.allBasenames);const re=M.reduce((se,x)=>x.allPaths?se.concat(x.allPaths):se,[]);return re.length&&(Y.allPaths=re),Y}const B=function(Y,Z,re){let se;for(let x=0,ie=M.length;x<ie;x++){const ue=M[x];ue.requiresSiblings&&re&&(Z||(Z=k.basename(Y)),se||(se=Z.substr(0,Z.length-k.extname(Y).length)));const ye=ue(Y,Z,se,re);if(ye)return ye}return null},V=M.find(Y=>!!Y.allBasenames);V&&(B.allBasenames=V.allBasenames);const G=M.reduce((Y,Z)=>Z.allPaths?Y.concat(Z.allPaths):Y,[]);return G.length&&(B.allPaths=G),B}function N(R,W,M){if(W===!1)return s;const F=l(R,M);if(F===s)return s;if(typeof W=="boolean")return F;if(W){const B=W.when;if(typeof B=="string"){const V=(G,Y,Z,re)=>{if(!re||!F(G,Y))return null;const se=B.replace("$(basename)",Z),x=re(se);return(0,P.isThenable)(x)?x.then(ie=>ie?R:null):x?R:null};return V.requiresSiblings=!0,V}}return F}function _(R,W){const M=R.filter(Y=>!!Y.basenames);if(M.length<2)return R;const F=M.reduce((Y,Z)=>{const re=Z.basenames;return re?Y.concat(re):Y},[]);let B;if(W){B=[];for(let Y=0,Z=F.length;Y<Z;Y++)B.push(W)}else B=M.reduce((Y,Z)=>{const re=Z.patterns;return re?Y.concat(re):Y},[]);const V=function(Y,Z){if(typeof Y!="string")return null;if(!Z){let se;for(se=Y.length;se>0;se--){const x=Y.charCodeAt(se-1);if(x===47||x===92)break}Z=Y.substr(se)}const re=F.indexOf(Z);return re!==-1?B[re]:null};V.basenames=F,V.patterns=B,V.allBasenames=F;const G=R.filter(Y=>!Y.basenames);return G.push(V),G}}),define(X[39],J([0,1,7,8,22,10,3,15,30]),function(j,e,m,D,k,y,P,r,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function i(l,u,f){if(typeof l=="string"&&(l=m.URI.file(l)),f){const A=f.getWorkspaceFolder(l);if(A){const T=f.getWorkspace().folders.length>1;let U;if((0,r.isEqual)(A.uri,l)?U="":U=(0,r.relativePath)(A.uri,l),T){const H=A.name?A.name:(0,r.basename)(A.uri);U=U?H+" \u2022 "+U:H}return U}}if(l.scheme!==y.Schemas.file&&l.scheme!==y.Schemas.untitled)return l.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(l.fsPath))return(0,D.normalize)(g(l.fsPath));let S=(0,D.normalize)(l.fsPath);return!P.isWindows&&(u==null?void 0:u.userHome)&&(S=v(S,u.userHome.fsPath)),S}e.getPathLabel=i;function L(l){if(!!l){typeof l=="string"&&(l=m.URI.file(l));const u=(0,r.basename)(l)||(l.scheme===y.Schemas.file?l.fsPath:l.path);return P.isWindows&&(0,p.isRootOrDriveLetter)(u)?g(u):u}}e.getBaseLabel=L;function g(l){return(0,p.hasDriveLetter)(l)?l.charAt(0).toUpperCase()+l.slice(1):l}e.normalizeDriveLetter=g;let b=Object.create(null);function v(l,u){if(P.isWindows||!l||!u)return l;let f=b.original===u?b.normalized:void 0;return f||(f=`${(0,k.rtrim)(u,D.posix.sep)}${D.posix.sep}`,b={original:u,normalized:f}),(P.isLinux?l.startsWith(f):(0,k.startsWithIgnoreCase)(l,f))&&(l=`~/${l.substr(f.length)}`),l}e.tildify=v;function d(l,u){return l.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=d;const w="\u2026",I="\\\\",E="~";function o(l,u=D.sep){const f=new Array(l.length);let S=!1;for(let A=0;A<l.length;A++){let T=l[A];if(T===""){f[A]=`.${u}`;continue}if(!T){f[A]=T;continue}S=!0;let U="";T.indexOf(I)===0?(U=T.substr(0,T.indexOf(I)+I.length),T=T.substr(T.indexOf(I)+I.length)):T.indexOf(u)===0?(U=T.substr(0,T.indexOf(u)+u.length),T=T.substr(T.indexOf(u)+u.length)):T.indexOf(E)===0&&(U=T.substr(0,T.indexOf(E)+E.length),T=T.substr(T.indexOf(E)+E.length));const H=T.split(u);for(let Q=1;S&&Q<=H.length;Q++)for(let ne=H.length-Q;S&&ne>=0;ne--){S=!1;let ae=H.slice(ne,ne+Q).join(u);for(let O=0;!S&&O<l.length;O++)if(O!==A&&l[O]&&l[O].indexOf(ae)>-1){const $=ne+Q===H.length,z=ne>0&&l[O].indexOf(u)>-1?u+ae:ae,C=l[O].endsWith(z);S=!$||C}if(!S){let O="";(H[0].endsWith(":")||U!=="")&&(ne===1&&(ne=0,Q++,ae=H[0]+u+ae),ne>0&&(O=H[0]+u),O=U+O),ne>0&&(O=O+w+u),O=O+ae,ne+Q<H.length&&(O=O+u+w),f[A]=O}}S&&(f[A]=T)}return f}e.shorten=o;var c;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function a(l,u=Object.create(null)){const f=[];let S=!1,A="";for(const T of l)if(T==="$"||S&&T==="{")A&&f.push({value:A,type:c.TEXT}),A="",S=!0;else if(T==="}"&&S){const U=u[A];if(typeof U=="string")U.length&&f.push({value:U,type:c.VARIABLE});else if(U){const H=f[f.length-1];(!H||H.type!==c.SEPARATOR)&&f.push({value:U.label,type:c.SEPARATOR})}A="",S=!1}else A+=T;return A&&!S&&f.push({value:A,type:c.TEXT}),f.filter((T,U)=>{if(T.type===c.SEPARATOR){const H=f[U-1],Q=f[U+1];return[H,Q].every(ne=>ne&&(ne.type===c.VARIABLE||ne.type===c.TEXT)&&ne.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=a;function h(l,u){return P.isMacintosh||u?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):l.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function t(l,u){return P.isMacintosh||u?l.replace(/\(&&\w\)|&&/g,""):P.isWindows?l.replace(/&&|&/g,f=>f==="&"?"&&":"&"):l.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(l){return l.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(l){const u=l.indexOf("/")!==-1?D.posix:D.win32,f=u.basename(l),S=u.dirname(l);return f.length?{name:f,parentPath:S}:{name:S,parentPath:""}}e.splitName=s}),define(X[28],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(p){return m.test(p)}e.isUUID=D;const k=new Uint8Array(16),y=[];for(let p=0;p<256;p++)y.push(p.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(p){for(let i=0;i<p.length;i++)p[i]=Math.floor(Math.random()*256);return p};function r(){P(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let p=0,i="";return i+=y[k[p++]],i+=y[k[p++]],i+=y[k[p++]],i+=y[k[p++]],i+="-",i+=y[k[p++]],i+=y[k[p++]],i+="-",i+=y[k[p++]],i+=y[k[p++]],i+="-",i+=y[k[p++]],i+=y[k[p++]],i+="-",i+=y[k[p++]],i+=y[k[p++]],i+=y[k[p++]],i+=y[k[p++]],i+=y[k[p++]],i+=y[k[p++]],i}e.generateUuid=r}),define(X[109],J([0,1,18,58,42]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function y(P,r){if(await new Promise((L,g)=>{const b=m.createReadStream(P),v=D.createHash("sha1");b.pipe(v);const d=(0,k.once)((w,I)=>{b.removeAllListeners(),v.removeAllListeners(),w?g(w):L(I)});b.once("error",d),b.once("end",d),v.once("error",d),v.once("data",w=>d(void 0,w.toString("hex")))})!==r)throw new Error("Hash mismatch")}e.checksum=y}),define(X[81],J([0,1,231]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class D{constructor(y="utf8"){this.stringDecoder=new m.StringDecoder(y),this.remaining=null}write(y){const P=[],r=this.remaining?this.remaining+this.stringDecoder.write(y):this.stringDecoder.write(y);if(r.length<1)return P;let p=0,i,L=p;for(;L<r.length;)if(i=r.charCodeAt(L),i===13||i===10){if(P.push(r.substring(p,L)),L++,L<r.length){const g=i;i=r.charCodeAt(L),(g===13&&i===10||g===10&&i===13)&&L++}p=L}else L++;return this.remaining=p<r.length?r.substr(p):null,P}end(){return this.remaining}}e.LineDecoder=D}),define(X[110],J([0,1,27]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(r){const p=r.replace(/\-/g,":").toLowerCase();return!D.has(p)}function y(){return new Promise(async(r,p)=>{const i=setTimeout(()=>p("Unable to retrieve mac address (timeout after 10s)"),1e4);try{r(await P())}catch(L){p(L)}finally{clearTimeout(i)}})}e.getMac=y;function P(){return new Promise((r,p)=>{try{const i=(0,m.networkInterfaces)();for(let L in i){const g=i[L];if(g){for(const{mac:b}of g)if(k(b))return r(b)}}p("Unable to retrieve mac address (unexpected format)")}catch(i){p(i)}})}}),define(X[65],J([0,1,17,28,27,36,110]),function(j,e,m,D,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(L){return this._virtualMachineOUIs||(this._virtualMachineOUIs=y.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(L)}value(){if(this._value===void 0){let L=0,g=0;const b=(0,k.networkInterfaces)();for(let v in b){const d=b[v];if(d)for(const{mac:w,internal:I}of d)I||(g+=1,this._isVirtualMachineMacAdress(w.toUpperCase())&&(L+=1))}this._value=g>0?L/g:0}return this._value}};let r;async function p(){return r||(r=(async()=>await i()||D.generateUuid())()),r}e.getMachineId=p;async function i(){try{const L=await new Promise((b,v)=>{j(["crypto"],b,v)}),g=await(0,P.getMac)();return L.createHash("sha256").update(g,"utf8").digest("hex")}catch(L){m.onUnexpectedError(L);return}}}),define(X[19],J([0,1,18,27,8,9,3,30,28,64,15,7]),function(j,e,m,D,k,y,P,r,p,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var b;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function v(z,C=b.UNLINK){if((0,r.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return C===b.UNLINK?w(z):d(z)}e.rimraf=v;async function d(z){try{const C=(0,k.join)((0,D.tmpdir)(),(0,p.generateUuid)());try{await m.promises.rename(z,C)}catch(q){return w(z)}w(C).catch(q=>{})}catch(C){if(C.code!=="ENOENT")throw C}}async function w(z){return m.promises.rmdir(z,{recursive:!0,maxRetries:3})}function I(z){if((0,r.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(z,{recursive:!0})}e.rimrafSync=I;async function E(z,C){return a(await(C?o(z):m.promises.readdir(z)))}e.readdir=E;async function o(z){try{return await m.promises.readdir(z,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const C=[],q=await E(z);for(const N of q){let _=!1,R=!1,W=!1;try{const M=await m.promises.lstat((0,k.join)(z,N));_=M.isFile(),R=M.isDirectory(),W=M.isSymbolicLink()}catch(M){console.warn("[node.js fs] unexpected error from lstat after readdir: ",M)}C.push({name:N,isFile:()=>_,isDirectory:()=>R,isSymbolicLink:()=>W})}return C}function c(z){return a(m.readdirSync(z))}e.readdirSync=c;function a(z){return z.map(C=>typeof C=="string"?P.isMacintosh?(0,i.normalizeNFC)(C):C:(C.name=P.isMacintosh?(0,i.normalizeNFC)(C.name):C.name,C))}async function h(z){const C=await E(z),q=[];for(const N of C)await n.existsDirectory((0,k.join)(z,N))&&q.push(N);return q}e.readDirsInDir=h;function t(z,C=1e3){return new Promise(q=>{let N=!1;const _=setInterval(()=>{N||(N=!0,m.access(z,R=>{N=!1,R&&(clearInterval(_),q(void 0))}))},C)})}e.whenDeleted=t;var n;(function(z){async function C(_){let R;try{if(R=await m.promises.lstat(_),!R.isSymbolicLink())return{stat:R}}catch(W){}try{return{stat:await m.promises.stat(_),symbolicLink:(R==null?void 0:R.isSymbolicLink())?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};if(P.isWindows&&W.code==="EACCES")try{return{stat:await m.promises.stat(await m.promises.readlink(_)),symbolicLink:{dangling:!1}}}catch(M){if(M.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};throw M}throw W}}z.stat=C;async function q(_){try{const{stat:R,symbolicLink:W}=await z.stat(_);return R.isFile()&&(W==null?void 0:W.dangling)!==!0}catch(R){}return!1}z.existsFile=q;async function N(_){try{const{stat:R,symbolicLink:W}=await z.stat(_);return R.isDirectory()&&(W==null?void 0:W.dangling)!==!0}catch(R){}return!1}z.existsDirectory=N})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new y.ResourceQueue;function l(z,C,q){return s.queueFor(g.URI.file(z),L.extUriBiasedIgnorePathCase).queue(()=>{const N=A(q);return new Promise((_,R)=>f(z,C,N,W=>W?R(W):_()))})}e.writeFile=l;let u=!0;function f(z,C,q,N){if(!u)return m.writeFile(z,C,{mode:q.mode,flag:q.flag},N);m.open(z,q.flag,q.mode,(_,R)=>{if(_)return N(_);m.writeFile(R,C,W=>{if(W)return m.close(R,()=>N(W));m.fdatasync(R,M=>(M&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",M),u=!1),m.close(R,F=>N(F))))})})}function S(z,C,q){const N=A(q);if(!u)return m.writeFileSync(z,C,{mode:N.mode,flag:N.flag});const _=m.openSync(z,N.flag,N.mode);try{m.writeFileSync(_,C);try{m.fdatasyncSync(_)}catch(R){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",R),u=!1}}finally{m.closeSync(_)}}e.writeFileSync=S;function A(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function T(z,C){if(z!==C){async function q(N){try{const _=await m.promises.lstat(N);if(_.isDirectory()||_.isSymbolicLink())return;const R=await m.promises.open(N,"a");try{await R.utimes(_.atime,new Date)}finally{await R.close()}}catch(_){}}try{await m.promises.rename(z,C),await q(C)}catch(N){if(z.toLowerCase()!==C.toLowerCase()&&N.code==="EXDEV"||z.endsWith("."))await U(z,C,{preserveSymlinks:!1}),await v(z,b.MOVE),await q(C);else throw N}}}e.move=T;async function U(z,C,q){return Q(z,C,{root:{source:z,target:C},options:q,handledSourcePaths:new Set})}e.copy=U;const H=511;async function Q(z,C,q){if(!q.handledSourcePaths.has(z)){q.handledSourcePaths.add(z);const{stat:N,symbolicLink:_}=await n.stat(z);if(_){if(q.options.preserveSymlinks)try{return await O(z,C,q)}catch(R){console.warn("[node.js fs] copy of symlink failed: ",R)}if(_.dangling)return}return N.isDirectory()?ne(z,C,N.mode&H,q):ae(z,C,N.mode&H)}}async function ne(z,C,q,N){await m.promises.mkdir(C,{recursive:!0,mode:q});const _=await E(z);for(const R of _)await Q((0,k.join)(z,R),(0,k.join)(C,R),N)}async function ae(z,C,q){await m.promises.copyFile(z,C),await m.promises.chmod(C,q)}async function O(z,C,q){let N=await m.promises.readlink(z);(0,r.isEqualOrParent)(N,q.root.source,!P.isLinux)&&(N=(0,k.join)(q.root.target,N.substr(q.root.source.length+1))),await m.promises.symlink(N,C)}async function $(z){try{return await m.promises.access(z),!0}catch(C){return!1}}e.exists=$}),define(X[111],J([0,1,18,112,22,8,19]),function(j,e,m,D,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function r(g){const b=(0,y.dirname)(g);if(g===b)return g;const v=((0,y.basename)(g)||g).toLowerCase();try{const w=(0,P.readdirSync)(b).filter(I=>I.toLowerCase()===v);if(w.length===1){const I=r(b);if(I)return(0,y.join)(I,w[0])}else if(w.length>1){const I=w.indexOf(v);if(I>=0){const E=r(b);if(E)return(0,y.join)(E,w[I])}}}catch(d){}return null}e.realcaseSync=r;async function p(g){try{return await(0,D.promisify)(m.realpath)(g)}catch(b){const v=L(g);return await m.promises.access(v,m.constants.R_OK),v}}e.realpath=p;function i(g){try{return m.realpathSync(g)}catch(b){const v=L(g);return m.accessSync(v,m.constants.R_OK),v}}e.realpathSync=i;function L(g){return(0,k.rtrim)((0,y.normalize)(g),y.sep)}}),define(X[113],J([0,1,59]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=e.randomPort=void 0;function D(){const p=1025;return p+Math.floor((65535-p)*Math.random())}e.randomPort=D;function k(p,i,L){let g=!1;return new Promise(b=>{const v=setTimeout(()=>{if(!g)return g=!0,b(0)},L);y(p,i,d=>{if(!g)return g=!0,clearTimeout(v),b(d)})})}e.findFreePort=k;function y(p,i,L){if(i===0)return L(0);const g=new m.Socket;g.once("connect",()=>(r(g),y(p+1,i-1,L))),g.once("data",()=>{}),g.once("error",b=>(r(g),b.code!=="ECONNREFUSED"?y(p+1,i-1,L):L(p))),g.connect(p,"127.0.0.1")}function P(p,i,L){let g=!1,b,v=1;const d=m.createServer({pauseOnConnect:!0});function w(I,E){g||(g=!0,d.removeAllListeners(),d.close(),b&&clearTimeout(b),E(I))}return new Promise(I=>{b=setTimeout(()=>{w(0,I)},L),d.on("listening",()=>{w(p,I)}),d.on("error",E=>{E&&(E.code==="EADDRINUSE"||E.code==="EACCES")&&v<i?(p++,v++,d.listen(p,"127.0.0.1")):w(0,I)}),d.on("close",()=>{w(0,I)}),d.listen(p,"127.0.0.1")})}e.findFreePortFaster=P;function r(p){try{p.removeAllListeners("connect"),p.removeAllListeners("error"),p.end(),p.destroy(),p.unref()}catch(i){console.error(i)}}});var Fe=this&&this.__await||function(j){return this instanceof Fe?(this.v=j,this):new Fe(j)},ft=this&&this.__asyncGenerator||function(j,e,m){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var D=m.apply(j,e||[]),k,y=[];return k={},P("next"),P("throw"),P("return"),k[Symbol.asyncIterator]=function(){return this},k;function P(b){D[b]&&(k[b]=function(v){return new Promise(function(d,w){y.push([b,v,d,w])>1||r(b,v)})})}function r(b,v){try{p(D[b](v))}catch(d){g(y[0][3],d)}}function p(b){b.value instanceof Fe?Promise.resolve(b.value.v).then(i,L):g(y[0][2],b)}function i(b){r("next",b)}function L(b){r("throw",b)}function g(b,v){b(v),y.shift(),y.length&&r(y[0][0],y[0][1])}},gt=this&&this.__asyncValues||function(j){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=j[Symbol.asyncIterator],m;return e?e.call(j):(j=typeof __values=="function"?__values(j):j[Symbol.iterator](),m={},D("next"),D("throw"),D("return"),m[Symbol.asyncIterator]=function(){return this},m);function D(y){m[y]=j[y]&&function(P){return new Promise(function(r,p){P=j[y](P),k(r,p,P.done,P.value)})}}function k(y,P,r,p){Promise.resolve(p).then(function(i){y({value:i,done:r})},P)}};define(X[114],J([0,1,19,27,8]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const y=/^\d+$/,P=/^Microsoft.PowerShell_.*/,r=/^Microsoft.PowerShellPreview_.*/;var p;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(p||(p={}));let i;switch(process.arch){case"ia32":case"x32":i=1;break;case"arm":case"arm64":i=2;break;default:i=0;break}let L;process.env.PROCESSOR_ARCHITEW6432?L=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?L=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?L=1:L=0;class g{constructor(h,t,n){this.exePath=h,this.displayName=t,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await m.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:a=!1}={}){return a?i===0?process.env["ProgramFiles(x86)"]||null:L===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:a=!1,findPreview:h=!1}={}){const t=b({useAlternateBitness:a});if(!t)return null;const n=k.join(t,"PowerShell");if(!await m.SymlinkSupport.existsDirectory(n))return null;let s=-1,l=null;for(const S of await m.readdir(n)){let A=-1;if(h){const U=S.indexOf("-");if(U<0)continue;const H=S.substring(0,U);if(!y.test(H)||S.substring(U+1)!=="preview")continue;A=parseInt(H,10)}else{if(!y.test(S))continue;A=parseInt(S,10)}if(!(A<=s)){const T=k.join(n,S,"pwsh.exe");!await m.SymlinkSupport.existsFile(T)||(l=T,s=A)}}if(!l)return null;const u=t.includes("x86")?" (x86)":"",f=h?" Preview":"";return new g(l,`PowerShell${f}${u}`,!0)}async function d({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const h=k.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await m.SymlinkSupport.existsDirectory(h))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=a?{pwshMsixDirRegex:r,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const s of await m.readdir(h))if(t.test(s)){const l=k.join(h,s,"pwsh.exe");return new g(l,n)}return null}function w(){const a=k.join(D.homedir(),".dotnet","tools","pwsh.exe");return new g(a,".NET Core PowerShell Global Tool")}function I(){const a=k.join(process.env.windir,i===1&&L!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new g(a,"Windows PowerShell",!0)}function E(){return ft(this,arguments,function*(){let h=yield Fe(v());h&&(yield yield Fe(h)),h=yield Fe(v({useAlternateBitness:!0})),h&&(yield yield Fe(h)),h=yield Fe(d()),h&&(yield yield Fe(h)),h=w(),h&&(yield yield Fe(h)),h=yield Fe(v({findPreview:!0})),h&&(yield yield Fe(h)),h=yield Fe(d({findPreview:!0})),h&&(yield yield Fe(h)),h=yield Fe(v({useAlternateBitness:!0,findPreview:!0})),h&&(yield yield Fe(h)),h=I(),h&&(yield yield Fe(h))})}function o(){return ft(this,arguments,function*(){var h,t;try{for(var n=gt(E()),s;s=yield Fe(n.next()),!s.done;){const l=s.value;(yield Fe(l.exists()))&&(yield yield Fe(l))}}catch(l){h={error:l}}finally{try{s&&!s.done&&(t=n.return)&&(yield Fe(t.call(n)))}finally{if(h)throw h.error}}})}e.enumeratePowerShellInstallations=o;async function c(){var a,h;try{for(var t=gt(o()),n;n=await t.next(),!n.done;)return n.value}catch(s){a={error:s}}finally{try{n&&!n.done&&(h=t.return)&&await h.call(t)}finally{if(a)throw a.error}}return null}e.getFirstAvailablePowerShellInstallation=c}),define(X[82],J([0,1,45,10]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(P){return new Promise((r,p)=>{let i;const L=new Map;function g(d,w,I,E,o){const c=L.get(w);if(d===P||c){const a={name:b(I),cmd:I,pid:d,ppid:w,load:E,mem:o};L.set(d,a),d===P&&(i=a),c&&(c.children||(c.children=[]),c.children.push(a),c.children.length>1&&(c.children=c.children.sort((h,t)=>h.pid-t.pid)))}}function b(d){const w=/--disable-blink-features=Auxclick/,I=/\\watcher\\win32\\CodeHelper\.exe/,E=/--crashes-directory/,o=/\\pipe\\winpty-control/,c=/conhost\.exe/,a=/--type=([a-zA-Z-]+)/;if(I.exec(d))return"watcherService ";if(E.exec(d))return"electron-crash-reporter";if(o.exec(d))return"winpty-process";if(c.exec(d))return"console-window-host (Windows internal process)";let h=a.exec(d);if(h&&h.length===2)return h[1]==="renderer"?w.exec(d)?"shared-process":"window":h[1];const t=/[a-zA-Z-]+\.js/g;let n="";do h=t.exec(d),h&&(n+=h+" ");while(h);return n&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron_node ${n}`:d}if(process.platform==="win32"){const d=w=>w.indexOf("\\\\?\\")===0||w.indexOf("\\??\\")===0?w.substr(4):w.indexOf('"\\\\?\\')===0||w.indexOf('"\\??\\')===0?'"'+w.substr(5):w;new Promise((w,I)=>{j(["windows-process-tree"],w,I)}).then(w=>{w.getProcessList(P,I=>{w.getProcessCpuUsage(I,E=>{const o=new Map;E.forEach(c=>{const a=d(c.commandLine||"");o.set(c.pid,{name:b(a),cmd:a,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),i=o.get(P),i?(o.forEach(c=>{const a=o.get(c.ppid);a&&(a.children||(a.children=[]),a.children.push(c))}),o.forEach(c=>{c.children&&(c.children=c.children.sort((a,h)=>a.pid-h.pid))}),r(i)):p(new Error(`Root process ${P} not found`))})},w.ProcessDataFlag.CommandLine|w.ProcessDataFlag.Memory)})}else{function v(){let d=[i];const w=[];for(;d.length;){const E=d.shift();E&&(w.push(E.pid),E.children&&(d=d.concat(E.children)))}let I=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);I+=" "+w.join(" "),(0,m.exec)(I,{},(E,o,c)=>{if(E||c)p(E||new Error(c.toString()));else{const a=o.toString().split(`
`);for(let h=0;h<w.length;h++){const t=L.get(w[h]);t.load=parseFloat(a[h])}if(!i){p(new Error(`Root process ${P} not found`));return}r(i)}})}(0,m.exec)("which ps",{},(d,w,I)=>{if(d||I)if(process.platform!=="linux")p(d||new Error(I.toString()));else{const E=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,m.exec)(E,{},(o,c,a)=>{o||a?p(o||new Error(a.toString())):(y(c,g),v())})}else{const E=w.toString().trim(),o="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,m.exec)(`${E} ${o}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,a,h)=>{c||h&&!h.includes("screen size is bogus")?p(c||new Error(h.toString())):(y(a,g),process.platform==="linux"?v():i?r(i):p(new Error(`Root process ${P} not found`)))})}})}})}e.listProcesses=k;function y(P,r){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,i=P.toString().split(`
`);for(const L of i){const g=p.exec(L.trim());g&&g.length===6&&r(parseInt(g[1]),parseInt(g[2]),g[5],parseFloat(g[3]),parseFloat(g[4]))}}}),define(X[115],J([0,1,8,18,3,64,2,19]),function(j,e,m,D,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function p(g,b,v){return L({path:g,isDirectory:!1},b,v)}e.watchFile=p;function i(g,b,v){return L({path:g,isDirectory:!0},b,v)}e.watchFolder=i,e.CHANGE_BUFFER_DELAY=100;function L(g,b,v){const d=(0,m.basename)(g.path),w=new Map;let I=!1,E=[(0,P.toDisposable)(()=>{w.forEach(o=>(0,P.dispose)(o)),w.clear()})];try{const o=(0,D.watch)(g.path);E.push((0,P.toDisposable)(()=>{o.removeAllListeners(),o.close()}));const c=new Set;g.isDirectory&&(0,r.readdir)(g.path).then(a=>a.forEach(h=>c.add(h))),o.on("error",(a,h)=>{I||v(`Failed to watch ${g.path} for changes using fs.watch() (${a}, ${h})`)}),o.on("change",(a,h)=>{if(!I){let t="";if(h&&(t=h.toString(),k.isMacintosh&&(t=(0,y.normalizeNFC)(t))),!(!t||a!=="change"&&a!=="rename")){const n=g.isDirectory?(0,m.join)(g.path,t):g.path;if(g.isDirectory)if(a==="rename"){const s=w.get(n);s&&(0,P.dispose)(s);const l=setTimeout(async()=>{w.delete(n);const u=await(0,r.exists)(n);if(!I){let f;u?c.has(t)?f="changed":(f="added",c.add(t)):(c.delete(t),f="deleted"),b(f,n)}},e.CHANGE_BUFFER_DELAY);w.set(n,(0,P.toDisposable)(()=>clearTimeout(l)))}else{let s;c.has(t)?s="changed":(s="added",c.add(t)),b(s,n)}else if(a==="rename"||t!==d){const s=setTimeout(async()=>{const l=await(0,r.exists)(n);I||(l?(b("changed",n),E=[L(g,b,v)]):b("deleted",n))},e.CHANGE_BUFFER_DELAY);(0,P.dispose)(E),E=[(0,P.toDisposable)(()=>clearTimeout(s))]}else b("changed",n)}}})}catch(o){(0,r.exists)(g.path).then(c=>{c&&!I&&v(`Failed to watch ${g.path} for changes using fs.watch() (${o.toString()})`)})}return(0,P.toDisposable)(()=>{I=!0,E=(0,P.dispose)(E)})}}),define(X[116],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(X[117],J([0,1,13,116,12]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function y(){m.ipcMain.on(D.CONTEXT_MENU_CHANNEL,(r,p,i,L,g)=>{const b=P(r,L,i);b.popup({window:(0,k.withNullAsUndefined)(m.BrowserWindow.fromWebContents(r.sender)),x:g?g.x:void 0,y:g?g.y:void 0,positioningItem:g?g.positioningItem:void 0,callback:()=>{b&&r.sender.send(D.CONTEXT_MENU_CLOSE_CHANNEL,p)}})})}e.registerContextMenuListener=y;function P(r,p,i){const L=new m.Menu;return i.forEach(g=>{let b;g.type==="separator"?b=new m.MenuItem({type:g.type}):Array.isArray(g.submenu)?b=new m.MenuItem({submenu:P(r,p,g.submenu),label:g.label}):b=new m.MenuItem({label:g.label,type:g.type,accelerator:g.accelerator,checked:g.checked,enabled:g.enabled,visible:g.visible,click:(v,d,w)=>r.sender.send(p,g.id,w)}),L.append(b)}),L}}),define(X[33],J([0,1,5,2,9,25,17,23,35,12,107,22]),function(j,e,m,D,k,y,P,r,p,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function v(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function w(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var I;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(I||(I={}));class E{constructor(_){this.buffer=_,this.pos=0}read(_){const R=this.buffer.slice(this.pos,this.pos+_);return this.pos+=R.byteLength,R}}class o{constructor(){this.buffers=[]}get buffer(){return r.VSBuffer.concat(this.buffers)}write(_){this.buffers.push(_)}}var c;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(c||(c={}));function a(N){const _=r.VSBuffer.alloc(4);return _.writeUInt32BE(N,0),_}function h(N){return N.read(4).readUInt32BE(0)}function t(N){const _=r.VSBuffer.alloc(1);return _.writeUInt8(N,0),_}const n={Undefined:t(c.Undefined),String:t(c.String),Buffer:t(c.Buffer),VSBuffer:t(c.VSBuffer),Array:t(c.Array),Object:t(c.Object)},s=typeof Buffer!="undefined";function l(N,_){if(typeof _=="undefined")N.write(n.Undefined);else if(typeof _=="string"){const R=r.VSBuffer.fromString(_);N.write(n.String),N.write(a(R.byteLength)),N.write(R)}else if(s&&Buffer.isBuffer(_)){const R=r.VSBuffer.wrap(_);N.write(n.Buffer),N.write(a(R.byteLength)),N.write(R)}else if(_ instanceof r.VSBuffer)N.write(n.VSBuffer),N.write(a(_.byteLength)),N.write(_);else if(Array.isArray(_)){N.write(n.Array),N.write(a(_.length));for(const R of _)l(N,R)}else{const R=r.VSBuffer.fromString(JSON.stringify(_));N.write(n.Object),N.write(a(R.byteLength)),N.write(R)}}function u(N){switch(N.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return N.read(h(N)).toString();case c.Buffer:return N.read(h(N)).buffer;case c.VSBuffer:return N.read(h(N));case c.Array:{const R=h(N),W=[];for(let M=0;M<R;M++)W.push(u(N));return W}case c.Object:return JSON.parse(N.read(h(N)).toString())}}class f{constructor(_,R,W=null,M=1e3){this.protocol=_,this.ctx=R,this.logger=W,this.timeoutDelay=M,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(F=>this.onRawMessage(F)),this.sendResponse({type:200})}registerChannel(_,R){this.channels.set(_,R),setTimeout(()=>this.flushPendingRequests(_),0)}sendResponse(_){switch(_.type){case 200:{const R=this.send([_.type]);this.logger&&this.logger.logOutgoing(R,0,1,w(_.type));return}case 201:case 202:case 204:case 203:{const R=this.send([_.type,_.id],_.data);this.logger&&this.logger.logOutgoing(R,_.id,1,w(_.type),_.data);return}}}send(_,R=void 0){const W=new o;return l(W,_),l(W,R),this.sendBuffer(W.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(R){return 0}}onRawMessage(_){const R=new E(_),W=u(R),M=u(R),F=W[0];switch(F){case 100:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],1,`${v(F)}: ${W[2]}.${W[3]}`,M),this.onPromise({type:F,id:W[1],channelName:W[2],name:W[3],arg:M});case 102:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],1,`${v(F)}: ${W[2]}.${W[3]}`,M),this.onEventListen({type:F,id:W[1],channelName:W[2],name:W[3],arg:M});case 101:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],1,`${v(F)}`),this.disposeActiveRequest({type:F,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],1,`${v(F)}`),this.disposeActiveRequest({type:F,id:W[1]})}}onPromise(_){const R=this.channels.get(_.channelName);if(!R){this.collectPendingRequest(_);return}const W=new y.CancellationTokenSource;let M;try{M=R.call(this.ctx,_.name,_.arg,W.token)}catch(V){M=Promise.reject(V)}const F=_.id;M.then(V=>{this.sendResponse({id:F,data:V,type:201}),this.activeRequests.delete(_.id)},V=>{V instanceof Error?this.sendResponse({id:F,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split?V.stack.split(`
`):V.stack:void 0},type:202}):this.sendResponse({id:F,data:V,type:203}),this.activeRequests.delete(_.id)});const B=(0,D.toDisposable)(()=>W.cancel());this.activeRequests.set(_.id,B)}onEventListen(_){const R=this.channels.get(_.channelName);if(!R){this.collectPendingRequest(_);return}const W=_.id,F=R.listen(this.ctx,_.name,_.arg)(B=>this.sendResponse({id:W,data:B,type:204}));this.activeRequests.set(_.id,F)}disposeActiveRequest(_){const R=this.activeRequests.get(_.id);R&&(R.dispose(),this.activeRequests.delete(_.id))}collectPendingRequest(_){let R=this.pendingRequests.get(_.channelName);R||(R=[],this.pendingRequests.set(_.channelName,R));const W=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.sendResponse({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);R.push({request:_,timeoutTimer:W})}flushPendingRequests(_){const R=this.pendingRequests.get(_);if(R){for(const W of R)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(_)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var S;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(_,R=null){this.protocol=_,this.isDisposed=!1,this.state=I.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=R}getChannel(_){const R=this;return{call(W,M,F){return R.isDisposed?Promise.reject(P.canceled()):R.requestPromise(_,W,M,F)},listen(W,M){return R.isDisposed?Promise.reject(P.canceled()):R.requestEvent(_,W,M)}}}requestPromise(_,R,W,M=y.CancellationToken.None){const F=this.lastRequestId++,V={id:F,type:100,channelName:_,name:R,arg:W};if(M.isCancellationRequested)return Promise.reject(P.canceled());let G;return new Promise((Z,re)=>{if(M.isCancellationRequested)return re(P.canceled());const se=()=>{const ye=ge=>{switch(ge.type){case 201:this.handlers.delete(F),Z(ge.data);break;case 202:this.handlers.delete(F);const Ee=new Error(ge.data.message);Ee.stack=ge.data.stack,Ee.name=ge.data.name,re(Ee);break;case 203:this.handlers.delete(F),re(ge.data);break}};this.handlers.set(F,ye),this.sendRequest(V)};let x=null;this.state===I.Idle?se():(x=(0,k.createCancelablePromise)(ye=>this.whenInitialized()),x.then(()=>{x=null,se()}));const ie=()=>{x?(x.cancel(),x=null):this.sendRequest({id:F,type:101}),re(P.canceled())},ue=M.onCancellationRequested(ie);G=(0,D.combinedDisposable)((0,D.toDisposable)(ie),ue),this.activeRequests.add(G)}).finally(()=>{this.activeRequests.delete(G)})}requestEvent(_,R,W){const M=this.lastRequestId++,B={id:M,type:102,channelName:_,name:R,arg:W};let V=null;const G=new m.Emitter({onFirstListenerAdd:()=>{V=(0,k.createCancelablePromise)(Z=>this.whenInitialized()),V.then(()=>{V=null,this.activeRequests.add(G),this.sendRequest(B)})},onLastListenerRemove:()=>{V?(V.cancel(),V=null):(this.activeRequests.delete(G),this.sendRequest({id:M,type:103}))}}),Y=Z=>G.fire(Z.data);return this.handlers.set(M,Y),G.event}sendRequest(_){switch(_.type){case 100:case 102:{const R=this.send([_.type,_.id,_.channelName,_.name],_.arg);this.logger&&this.logger.logOutgoing(R,_.id,0,`${v(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const R=this.send([_.type,_.id]);this.logger&&this.logger.logOutgoing(R,_.id,0,v(_.type));return}}}send(_,R=void 0){const W=new o;return l(W,_),l(W,R),this.sendBuffer(W.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(R){return 0}}onBuffer(_){const R=new E(_),W=u(R),M=u(R),F=W[0];switch(F){case 200:return this.logger&&this.logger.logIncoming(_.byteLength,0,0,w(F)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],0,w(F),M),this.onResponse({type:W[0],id:W[1],data:M})}}onResponse(_){if(_.type===200){this.state=I.Idle,this._onDidInitialize.fire();return}const R=this.handlers.get(_.id);R&&R(_)}whenInitialized(){return this.state===I.Idle?Promise.resolve():m.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}e.ChannelClient=A;class T{constructor(_){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,_(({protocol:R,onDidClientDisconnect:W})=>{m.Event.once(R.onMessage)(F=>{const B=new E(F),V=u(B),G=new f(R,V),Y=new A(R);this.channels.forEach((re,se)=>G.registerChannel(se,re));const Z={channelServer:G,channelClient:Y,ctx:V};this._connections.add(Z),this._onDidAddConnection.fire(Z),W(()=>{G.dispose(),Y.dispose(),this._connections.delete(Z),this._onDidRemoveConnection.fire(Z)})})})}get connections(){const _=[];return this._connections.forEach(R=>_.push(R)),_}getChannel(_,R){const W=this;return{call(M,F,B){let V;if((0,i.isFunction)(R)){let Y=(0,p.getRandomElement)(W.connections.filter(R));V=Y?Promise.resolve(Y):m.Event.toPromise(m.Event.filter(W.onDidAddConnection,R))}else V=R.routeCall(W,M,F);const G=V.then(Y=>Y.channelClient.getChannel(_));return H(G).call(M,F,B)},listen(M,F){if((0,i.isFunction)(R))return W.getMulticastEvent(_,R,M,F);const B=R.routeEvent(W,M,F).then(V=>V.channelClient.getChannel(_));return H(B).listen(M,F)}}}getMulticastEvent(_,R,W,M){const F=this;let B=new D.DisposableStore;const V=new m.Emitter({onFirstListenerAdd:()=>{B=new D.DisposableStore;const G=new m.EventMultiplexer,Y=new Map,Z=se=>{const ie=se.channelClient.getChannel(_).listen(W,M),ue=G.add(ie);Y.set(se,ue)},re=se=>{const x=Y.get(se);!x||(x.dispose(),Y.delete(se))};F.connections.filter(R).forEach(Z),m.Event.filter(F.onDidAddConnection,R)(Z,void 0,B),F.onDidRemoveConnection(re,void 0,B),G.event(V.fire,V,B),B.add(G)},onLastListenerRemove:()=>{B.dispose()}});return V.event}registerChannel(_,R){this.channels.set(_,R),this._connections.forEach(W=>{W.channelServer.registerChannel(_,R)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class U{constructor(_,R,W=null){const M=new o;l(M,R),_.send(M.buffer),this.channelClient=new A(_,W),this.channelServer=new f(_,R,W)}getChannel(_){return this.channelClient.getChannel(_)}registerChannel(_,R){this.channelServer.registerChannel(_,R)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function H(N){return{call(_,R,W){return N.then(M=>M.call(_,R,W))},listen(_,R){const W=new m.Relay;return N.then(M=>W.input=M.listen(_,R)),W.event}}}e.getDelayedChannel=H;function Q(N){let _=!1;return{call(R,W,M){return _?N.call(R,W,M):(0,k.timeout)(0).then(()=>_=!0).then(()=>N.call(R,W,M))},listen(R,W){if(_)return N.listen(R,W);const M=new m.Relay;return(0,k.timeout)(0).then(()=>_=!0).then(()=>M.input=N.listen(R,W)),M.event}}}e.getNextTickChannel=Q;class ne{constructor(_){this.fn=_}routeCall(_){return this.route(_)}routeEvent(_){return this.route(_)}async route(_){for(const R of _.connections)if(await Promise.resolve(this.fn(R.ctx)))return Promise.resolve(R);return await m.Event.toPromise(_.onDidAddConnection),await this.route(_)}}e.StaticRouter=ne;var ae;(function(N){function _(M,F){const B=M,V=F&&F.disableMarshalling,G=new Map;for(const Y in B)W(Y)&&G.set(Y,m.Event.buffer(B[Y],!0));return new class{listen(Y,Z){const re=G.get(Z);if(re)return re;throw new Error(`Event not found: ${Z}`)}call(Y,Z,re){const se=B[Z];if(typeof se=="function"){if(!V&&Array.isArray(re))for(let x=0;x<re.length;x++)re[x]=(0,L.revive)(re[x]);return se.apply(B,re)}throw new Error(`Method not found: ${Z}`)}}}N.fromService=_;function R(M,F){const B=F&&F.disableMarshalling;return new Proxy({},{get(V,G){var Y;if(typeof G=="string")return((Y=F==null?void 0:F.properties)===null||Y===void 0?void 0:Y.has(G))?F.properties.get(G):W(G)?M.listen(G):async function(...Z){let re;F&&!(0,i.isUndefinedOrNull)(F.context)?re=[F.context,...Z]:re=Z;const se=await M.call(G,re);return B?se:(0,L.revive)(se)};throw new Error(`Property not found: ${String(G)}`)}})}N.toService=R;function W(M){return M[0]==="o"&&M[1]==="n"&&g.isUpperAsciiLetter(M.charCodeAt(2))}})(ae=e.ProxyChannel||(e.ProxyChannel={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){let _=N.toString();if(_!=="[object Object]")return _}return N}function z(N){return Array.isArray(N)?N.map($):$(N)}function C(N,_,R,W,M,F,B){B=z(B);const V=O[M],G=V[W%V.length];let Y=[`%c[${N}]%c[${String(_).padStart(7," ")}]%c[len: ${String(R).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${F}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(F)?(Y=Y.concat(B),Y.push(")")):Y.push(B),console.log.apply(console,Y)}e.logWithColors=C;class q{constructor(_,R){this._outgoingPrefix=_,this._incomingPrefix=R,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(_,R,W,M,F){this._totalOutgoing+=_,C(this._outgoingPrefix,this._totalOutgoing,_,R,W,M,F)}logIncoming(_,R,W,M,F){this._totalIncoming+=_,C(this._incomingPrefix,this._totalIncoming,_,R,W,M,F)}}e.IPCLogger=q}),define(X[118],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class m{constructor(k,y){this.sender=k,this.onMessage=y}send(k){try{this.sender.send("vscode:message",k.buffer)}catch(y){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=m}),define(X[119],J([0,1,5,33,23]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class y{constructor(p){this.port=p,this.onMessage=m.Event.fromDOMEventEmitter(this.port,"message",i=>k.VSBuffer.wrap(i.data)),p.start()}send(p){this.port.postMessage(p.buffer)}disconnect(){this.port.close()}}e.Protocol=y;class P extends D.IPCClient{constructor(p,i){const L=new y(p);super(L,i);this.protocol=L}dispose(){this.protocol.disconnect()}}e.Client=P}),define(X[83],J([0,1,5,33,2,23,3,32]),function(j,e,m,D,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let p=null;function i(){return p||(p=y.VSBuffer.alloc(0)),p}class L{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,l){if(s===0)return i();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const A=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=s),A}if(this._chunks[0].byteLength>s){const A=this._chunks[0].slice(0,s);return l&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),A}let u=y.VSBuffer.alloc(s),f=0,S=0;for(;s>0;){const A=this._chunks[S];if(A.byteLength>s){const T=A.slice(0,s);u.set(T,f),f+=s,l&&(this._chunks[S]=A.slice(s),this._totalLength-=s),s-=s}else u.set(A,f),f+=A.byteLength,l?(this._chunks.shift(),this._totalLength-=A.byteLength):S++,s-=A.byteLength}return u}}e.ChunkStream=L;var g;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(g||(g={}));var b;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(b=e.ProtocolConstants||(e.ProtocolConstants={}));class v{constructor(s,l,u,f){this.type=s,this.id=l,this.ack=u,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends k.Disposable{constructor(s){super();this._onMessage=this._register(new m.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new L,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const u=this._state.messageType,f=this._state.id,S=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new v(u,f,S,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class w{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(!this._isDisposed){s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=y.VSBuffer.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this._writeSoon(l,s.data)}}_bufferAdd(s,l){const u=this._totalLength===0;return this._data.push(s,l),this._totalLength+=s.byteLength+l.byteLength,u}_bufferTake(){const s=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,l){this._bufferAdd(s,l)&&P.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class I extends k.Disposable{constructor(s){super();this._onMessage=new m.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new m.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new w(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new v(1,0,0,s))}}e.Protocol=I;class E extends D.IPCClient{constructor(s,l,u=null){super(s,l,u);this.protocol=s}static fromSocket(s,l){return new E(new I(s),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=E;class o{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new m.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,r.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=o;class c{constructor(s){this.data=s,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],l=0,u=this._first;for(;u;)s[l++]=u.data,u=u.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const l=new c(s);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class h{constructor(){this.lastRuns=[];const s=Date.now();for(let l=0;l<h._HISTORY_LENGTH;l++)this.lastRuns[l]=s-1e3*l;setInterval(()=>{for(let l=h._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return h._INSTANCE||(h._INSTANCE=new h),h._INSTANCE}load(){const s=Date.now(),l=(1+h._HISTORY_LENGTH)*1e3;let u=0;for(let f=0;f<h._HISTORY_LENGTH;f++)s-this.lastRuns[f]<=l&&u++;return 1-u/h._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}h._HISTORY_LENGTH=10,h._INSTANCE=null;class t{constructor(s,l=null){this._loadEstimator=h.getInstance(),this._onControlMessage=new o,this.onControlMessage=this._onControlMessage.event,this._onMessage=new o,this.onMessage=this._onMessage.event,this._onDidDispose=new o,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new o,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new o,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new v(5,0,0,i());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const l=new v(4,0,0,i());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,l){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let l=0,u=s.length;l<u;l++)this._socketWriter.write(s[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new v(6,0,0,i())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const l=this._outgoingUnackMsg.toArray();for(let u=0,f=l.length;u<f;u++)this._socketWriter.write(l[u]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new v(1,l,this._incomingAckId,s);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(s){const l=new v(2,0,0,s);this._socketWriter.write(l)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const s=this._outgoingUnackMsg.peek(),l=Date.now()-s.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const s=new v(3,0,this._incomingAckId,i());this._socketWriter.write(s)}}}e.PersistentProtocol=t}),define(X[120],J([0,1,13,5,33,118,2,23]),function(j,e,m,D,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function p(L,g){const b=D.Event.fromNodeEventEmitter(m.ipcMain,g,(d,w)=>({event:d,message:w})),v=D.Event.filter(b,({event:d})=>d.sender.id===L);return D.Event.map(v,({message:d})=>d&&r.VSBuffer.wrap(d))}class i extends k.IPCServer{constructor(){super(i.getOnDidClientConnect())}static getOnDidClientConnect(){const g=D.Event.fromNodeEventEmitter(m.ipcMain,"vscode:hello",({sender:b})=>b);return D.Event.map(g,b=>{const v=b.id,d=i.Clients.get(v);d&&d.dispose();const w=new D.Emitter;i.Clients.set(v,(0,P.toDisposable)(()=>w.fire()));const I=p(v,"vscode:message"),E=D.Event.any(D.Event.signal(p(v,"vscode:disconnect")),w.event);return{protocol:new y.Protocol(b,I),onDidClientDisconnect:E}})}}e.Server=i,i.Clients=new Map}),define(X[84],J([0,1,13,5,28,119]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class P extends y.Client{constructor(i,L){super({addEventListener:(g,b)=>i.addListener(g,b),removeEventListener:(g,b)=>i.removeListener(g,b),postMessage:g=>i.postMessage(g),start:()=>i.start(),close:()=>i.close()},L)}}e.Client=P;async function r(p){if(p.isDestroyed()||p.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const i=(0,k.generateUuid)();p.webContents.send("vscode:createMessageChannel",i);const L=D.Event.fromNodeEventEmitter(m.ipcMain,"vscode:createMessageChannelResult",(b,v)=>({nonce:v,port:b.ports[0]})),{port:g}=await D.Event.toPromise(D.Event.once(D.Event.filter(L,b=>b.nonce===i)));return g}e.connect=r}),define(X[85],J([0,1,2,5,9,12]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var P;(function(L){L[L.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(P=e.StorageHint||(e.StorageHint={}));var r;(function(L){L[L.None=0]="None",L[L.Initialized=1]="Initialized",L[L.Closed=2]="Closed"})(r||(r={}));class p extends m.Disposable{constructor(g,b=Object.create(null)){super();this.database=g,this.options=b,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=r.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){var b,v;(b=g.changed)===null||b===void 0||b.forEach((d,w)=>this.accept(w,d)),(v=g.deleted)===null||v===void 0||v.forEach(d=>this.accept(d,void 0))}accept(g,b){if(this.state!==r.Closed){let v=!1;(0,y.isUndefinedOrNull)(b)?v=this.cache.delete(g):this.cache.get(g)!==b&&(this.cache.set(g,b),v=!0),v&&this._onDidChangeStorage.fire(g)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===r.None&&(this.state=r.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,b){const v=this.cache.get(g);return(0,y.isUndefinedOrNull)(v)?b:v}getBoolean(g,b){const v=this.get(g);return(0,y.isUndefinedOrNull)(v)?b:v==="true"}getNumber(g,b){const v=this.get(g);return(0,y.isUndefinedOrNull)(v)?b:parseInt(v,10)}async set(g,b){if(this.state!==r.Closed){if((0,y.isUndefinedOrNull)(b))return this.delete(g);const v=String(b);if(this.cache.get(g)!==v)return this.cache.set(g,v),this.pendingInserts.set(g,v),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(g){if(this.state!==r.Closed&&!!this.cache.delete(g))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=r.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{var b;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(b=this.whenFlushedCallbacks.pop())===null||b===void 0||b()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((b,v)=>this.items.set(v,b)),g.delete&&g.delete.forEach(b=>this.items.delete(b))}async close(){}}e.InMemoryStorageDatabase=i}),define(X[121],J([0,1,18,5,9,36,8,19]),function(j,e,m,D,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class p{constructor(g,b=Object.create(null)){this.path=g,this.options=b,this.name=(0,P.basename)(this.path),this.logger=new i(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return D.Event.None}async getItems(){const g=await this.whenConnected,b=new Map;return(await this.all(g,"SELECT * FROM ItemTable")).forEach(d=>b.set(d.key,d.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${b.size} rows`),b}async updateItems(g){const b=await this.whenConnected;return this.doUpdateItems(b,g)}doUpdateItems(g,b){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${b.insert?(0,y.mapToString)(b.insert):"0"}), delete(${b.delete?(0,y.setToString)(b.delete):"0"})`),this.transaction(g,()=>{const v=b.insert,d=b.delete;if(v&&v.size>0){const w=[];w.push([]);let I=0;v.forEach((E,o)=>{let c=w[I];c.length>p.MAX_HOST_PARAMETERS&&(I++,c=[],w.push(c)),c.push(o,E)}),w.forEach(E=>{this.prepare(g,`INSERT INTO ItemTable VALUES ${new Array(E.length/2).fill("(?,?)").join(",")}`,o=>o.run(E),()=>{const o=[];let c=0;return v.forEach((a,h)=>{o.push(h),c+=a.length}),`Keys: ${o.join(", ")} Length: ${c}`})})}if(d&&d.size){const w=[];w.push([]);let I=0;d.forEach(E=>{let o=w[I];o.length>p.MAX_HOST_PARAMETERS&&(I++,o=[],w.push(o)),o.push(E)}),w.forEach(E=>{this.prepare(g,`DELETE FROM ItemTable WHERE key IN (${new Array(E.length).fill("?").join(",")})`,o=>o.run(E),()=>{const o=[];return d.forEach(c=>{o.push(c)}),`Keys: ${o.join(", ")}`})})}})}async close(g){this.logger.trace(`[storage ${this.name}] close()`);const b=await this.whenConnected;return this.doClose(b,g)}doClose(g,b){return new Promise((v,d)=>{g.db.close(w=>(w&&this.handleSQLiteError(g,`[storage ${this.name}] close(): ${w}`),this.path===p.IN_MEMORY_PATH?v():!g.isErroneous&&!g.isInMemory?this.backup().then(v,I=>(this.logger.error(`[storage ${this.name}] backup(): ${I}`),v())):typeof b=="function"?m.promises.unlink(this.path).then(()=>this.doConnect(this.path).then(I=>{const E=()=>this.doClose(I,void 0);return this.doUpdateItems(I,{insert:b()}).then(()=>E(),o=>(E(),Promise.reject(o)))})).then(v,d):d(w||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const g=this.toBackupPath(this.path);return(0,r.copy)(this.path,g,{preserveSymlinks:!1})}toBackupPath(g){return`${g}.backup`}async checkIntegrity(g){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${g})`);const b=await this.whenConnected,v=await this.get(b,g?"PRAGMA integrity_check":"PRAGMA quick_check"),d=g?v.integrity_check:v.quick_check;return b.isErroneous?`${d} (last error: ${b.lastError})`:b.isInMemory?`${d} (in-memory!)`:d}async connect(g,b=!0){this.logger.trace(`[storage ${this.name}] open(${g}, retryOnBusy: ${b})`);try{return await this.doConnect(g)}catch(v){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&b)return await(0,k.timeout)(p.BUSY_OPEN_TIMEOUT),this.connect(g,!1);try{await m.promises.unlink(g);try{await m.promises.rename(this.toBackupPath(g),g)}catch(d){}return await this.doConnect(g)}catch(d){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${d}`),this.doConnect(p.IN_MEMORY_PATH)}}}handleSQLiteError(g,b){g.isErroneous=!0,g.lastError=b,this.logger.error(b)}doConnect(g){return new Promise((b,v)=>{new Promise((d,w)=>{j(["vscode-sqlite3"],d,w)}).then(d=>{const w={db:new(this.logger.isTracing?d.verbose().Database:d.Database)(g,I=>I?w.db?w.db.close(()=>v(I)):v(I):this.exec(w,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(w),E=>w.db.close(()=>v(E)))),isInMemory:g===p.IN_MEMORY_PATH};w.db.on("error",I=>this.handleSQLiteError(w,`[storage ${this.name}] Error (event): ${I}`)),this.logger.isTracing&&w.db.on("trace",I=>this.logger.trace(`[storage ${this.name}] Trace (event): ${I}`))},v)})}exec(g,b){return new Promise((v,d)=>{g.db.exec(b,w=>w?(this.handleSQLiteError(g,`[storage ${this.name}] exec(): ${w}`),d(w)):v())})}get(g,b){return new Promise((v,d)=>{g.db.get(b,(w,I)=>w?(this.handleSQLiteError(g,`[storage ${this.name}] get(): ${w}`),d(w)):v(I))})}all(g,b){return new Promise((v,d)=>{g.db.all(b,(w,I)=>w?(this.handleSQLiteError(g,`[storage ${this.name}] all(): ${w}`),d(w)):v(I))})}transaction(g,b){return new Promise((v,d)=>{g.db.serialize(()=>{g.db.run("BEGIN TRANSACTION"),b(),g.db.run("END TRANSACTION",w=>w?(this.handleSQLiteError(g,`[storage ${this.name}] transaction(): ${w}`),d(w)):v())})})}prepare(g,b,v,d){const w=g.db.prepare(b),I=E=>{this.handleSQLiteError(g,`[storage ${this.name}] prepare(): ${E} (${b}). Details: ${d()}`)};w.on("error",I),v(w),w.finalize(E=>{E&&I(E),w.removeListener("error",I)})}}e.SQLiteStorageDatabase=p,p.IN_MEMORY_PATH=":memory:",p.BUSY_OPEN_TIMEOUT=2e3,p.MAX_HOST_PARAMETERS=256;class i{constructor(g){g&&typeof g.logTrace=="function"&&process.env[i.VSCODE_TRACE_STORAGE]&&(this.logTrace=g.logTrace),g&&typeof g.logError=="function"&&(this.logError=g.logError)}get isTracing(){return!!this.logTrace}trace(g){this.logTrace&&this.logTrace(g)}error(g){this.logError&&this.logError(g)}}i.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(X[122],J([14,11]),function(j,e){return j.create("vs/base/common/date",e)}),define(X[123],J([0,1,122]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,k=D*60,y=k*24,P=y*7,r=y*30,p=y*365;function i(g,b){typeof g!="number"&&(g=g.getTime());const v=Math.round((new Date().getTime()-g)/1e3);if(v<-30)return(0,m.localize)(0,null,i(new Date().getTime()+v*1e3,!1));if(v<30)return(0,m.localize)(1,null);let d;return v<D?(d=v,b?d===1?(0,m.localize)(2,null,d):(0,m.localize)(3,null,d):d===1?(0,m.localize)(4,null,d):(0,m.localize)(5,null,d)):v<k?(d=Math.floor(v/D),b?d===1?(0,m.localize)(6,null,d):(0,m.localize)(7,null,d):d===1?(0,m.localize)(8,null,d):(0,m.localize)(9,null,d)):v<y?(d=Math.floor(v/k),b?d===1?(0,m.localize)(10,null,d):(0,m.localize)(11,null,d):d===1?(0,m.localize)(12,null,d):(0,m.localize)(13,null,d)):v<P?(d=Math.floor(v/y),b?d===1?(0,m.localize)(14,null,d):(0,m.localize)(15,null,d):d===1?(0,m.localize)(16,null,d):(0,m.localize)(17,null,d)):v<r?(d=Math.floor(v/P),b?d===1?(0,m.localize)(18,null,d):(0,m.localize)(19,null,d):d===1?(0,m.localize)(20,null,d):(0,m.localize)(21,null,d)):v<p?(d=Math.floor(v/r),b?d===1?(0,m.localize)(22,null,d):(0,m.localize)(23,null,d):d===1?(0,m.localize)(24,null,d):(0,m.localize)(25,null,d)):(d=Math.floor(v/p),b?d===1?(0,m.localize)(26,null,d):(0,m.localize)(27,null,d):d===1?(0,m.localize)(28,null,d):(0,m.localize)(29,null,d))}e.fromNow=i;function L(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(X[124],J([14,11]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(X[66],J([0,1,124,12,35]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(i,L){return L&&(i.stack||i.stacktrace)?m.localize(0,null,r(i),P(i.stack)||P(i.stacktrace)):r(i)}function P(i){return Array.isArray(i)?i.join(`
`):i}function r(i){return typeof i.code=="string"&&typeof i.errno=="number"&&typeof i.syscall=="string"?m.localize(1,null,i.message):i.message||m.localize(2,null)}function p(i=null,L=!1){if(!i)return m.localize(3,null);if(Array.isArray(i)){const g=k.coalesce(i),b=p(g[0],L);return g.length>1?m.localize(4,null,b,g.length):b}if(D.isString(i))return i;if(i.detail){const g=i.detail;if(g.error)return y(g.error,L);if(g.exception)return y(g.exception,L)}return i.stack?y(i,L):i.message?i.message:m.localize(5,null)}e.toErrorMessage=p}),define(X[125],J([14,11]),function(j,e){return j.create("vs/base/common/keybindingLabels",e)}),define(X[126],J([0,1,125]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class D{constructor(P,r,p=r){this.modifierLabels=[null],this.modifierLabels[2]=P,this.modifierLabels[1]=r,this.modifierLabels[3]=p}toLabel(P,r,p){if(r.length===0)return null;const i=[];for(let L=0,g=r.length;L<g;L++){const b=r[L],v=p(b);if(v===null)return null;i[L]=k(b,v,this.modifierLabels[P])}return i.join(" ")}}e.ModifierLabelProvider=D,e.UILabelProvider=new D({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:m.localize(0,null),shiftKey:m.localize(1,null),altKey:m.localize(2,null),metaKey:m.localize(3,null),separator:"+"},{ctrlKey:m.localize(4,null),shiftKey:m.localize(5,null),altKey:m.localize(6,null),metaKey:m.localize(7,null),separator:"+"}),e.AriaLabelProvider=new D({ctrlKey:m.localize(8,null),shiftKey:m.localize(9,null),altKey:m.localize(10,null),metaKey:m.localize(11,null),separator:"+"},{ctrlKey:m.localize(12,null),shiftKey:m.localize(13,null),altKey:m.localize(14,null),metaKey:m.localize(15,null),separator:"+"},{ctrlKey:m.localize(16,null),shiftKey:m.localize(17,null),altKey:m.localize(18,null),metaKey:m.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new D({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new D({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function k(y,P,r){if(P===null)return"";const p=[];return y.ctrlKey&&p.push(r.ctrlKey),y.shiftKey&&p.push(r.shiftKey),y.altKey&&p.push(r.altKey),y.metaKey&&p.push(r.metaKey),P!==""&&p.push(P),p.join(r.separator)}}),define(X[127],J([14,11]),function(j,e){return j.create("vs/base/node/processes",e)}),define(X[86],J([0,1,8,18,19,45,127,32,12,44,30,3,81,10]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function d(h){switch(h){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(h,t){if(g.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const s=y.execFile("taskkill",["/T","/F","/PID",h.pid.toString()],n);return new Promise(l=>{s.once("error",u=>{l({success:!1,error:u})}),s.once("exit",(u,f)=>{l(u===0?{success:!0}:{success:!1,code:u!==null?u:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?d(n.status):1})}else if(g.isLinux||g.isMacintosh)try{const n=v.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(s=>{y.execFile(n,[h.pid.toString()],{encoding:"utf8",shell:!0},(l,u,f)=>{s(l?{success:!1,error:l}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else h.kill("SIGKILL");return Promise.resolve({success:!0})}function I(h=r.env){return h.comspec||"cmd.exe"}e.getWindowsShell=I;class E{constructor(t,n,s,l){if(n!==void 0&&s!==void 0&&l!==void 0)this.cmd=t,this.args=n,this.shell=s,this.options=l;else{const u=t;this.cmd=u.command,this.shell=u.isShellCommand,this.args=u.args.slice(0),this.options=u.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const u=Object.create(null);Object.keys(r.env).forEach(f=>{u[f]=r.env[f]}),Object.keys(this.options.env).forEach(f=>{u[f]=this.options.env[f]}),this.options.env=u}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(m.sep);return n!==-1&&(t=t.substring(n+1)),E.WellKnowCommands[t]?t:"other"}start(t){return g.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(r.cwd()))?Promise.reject(new Error(P.localize(0,null))):this.useExec().then(n=>{let s,l;const u=new Promise((f,S)=>{s=f,l=S});if(n){let f=this.cmd;this.args&&(f=f+" "+this.args.join(" ")),this.childProcess=y.exec(f,this.options,(S,A,T)=>{this.childProcess=null;const U=S;U&&U.killed?l({killed:this.terminateRequested,stdout:A.toString(),stderr:T.toString()}):this.handleExec(s,t,S,A,T)})}else{let f=null;const S=A=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(A,s,t,l);const T={terminated:this.terminateRequested};p.isNumber(A)&&(T.cmdCode=A),s(T)};if(this.shell&&g.isWindows){const A=i.deepClone(this.options);A.windowsVerbatimArguments=!0,A.detached=!1;let T=!1,U=!1;const H=[];let Q=this.ensureQuotes(this.cmd);H.push(Q.value),T=Q.quoted,this.args&&this.args.forEach(ae=>{Q=this.ensureQuotes(ae),H.push(Q.value),U=U&&Q.quoted});const ne=["/s","/c"];T?U?ne.push('"'+H.join(" ")+'"'):H.length>1?ne.push('"'+H[0]+'" '+H.slice(1).join(" ")):ne.push('"'+H[0]+'"'):ne.push(H.join(" ")),f=y.spawn(I(),ne,A)}else this.cmd&&(f=y.spawn(this.cmd,this.args,this.options));f&&(this.childProcess=f,this.childProcessPromise=Promise.resolve(f),this.pidResolve&&(this.pidResolve(p.isNumber(f.pid)?f.pid:-1),this.pidResolve=void 0),f.on("error",A=>{this.childProcess=null,l({terminated:this.terminateRequested,error:A})}),f.pid&&(this.childProcess.on("close",S),this.handleSpawn(f,s,t,l,!0)))}return u})}handleClose(t,n,s,l){}ensureQuotes(t){return E.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,w(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!g.isWindows)return t(!1);const n=y.spawn(I(),["/s","/c"]);n.on("error",s=>t(!0)),n.on("exit",s=>t(!1))})}}e.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class o extends E{constructor(t,n,s,l){super(t,n,s,l);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,s,l,u){[l,u].forEach((f,S)=>{const A=new b.LineDecoder;A.write(f).forEach(H=>{n({line:H,source:S===0?0:1})});const U=A.end();U&&n({line:U,source:S===0?0:1})}),t({terminated:this.terminateRequested,error:s})}handleSpawn(t,n,s,l,u){const f=new b.LineDecoder,S=new b.LineDecoder;t.stdout.on("data",A=>{f.write(A).forEach(U=>s({line:U,source:0}))}),t.stderr.on("data",A=>{S.write(A).forEach(U=>s({line:U,source:1}))}),this.stdoutLineDecoder=f,this.stderrLineDecoder=S}handleClose(t,n,s,l){const u=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;u&&s({line:u,source:0});const f=this.stderrLineDecoder?this.stderrLineDecoder.end():null;f&&s({line:f,source:1})}}e.LineProcess=o;function c(h){let t=[],n=!1;const s=function(l){if(n){t.push(l);return}(!h.send(l,f=>{if(f&&console.error(f),n=!1,t.length>0){const S=t.slice(0);t=[],S.forEach(A=>s(A))}})||g.isWindows)&&(n=!0)};return{send:s}}e.createQueuedSender=c;var a;(function(h){async function t(n,s,l){if(m.isAbsolute(n))return n;if(s===void 0&&(s=r.cwd()),m.dirname(n)!=="."||(l===void 0&&p.isString(r.env.PATH)&&(l=r.env.PATH.split(m.delimiter)),l===void 0||l.length===0))return m.join(s,n);async function f(S){return await k.exists(S)?!(await D.promises.stat(S)).isDirectory():!1}for(let S of l){let A;if(m.isAbsolute(S)?A=m.join(S,n):A=m.join(s,S,n),await f(A))return A;let T=A+".com";if(await f(T)||(T=A+".exe",await f(T)))return T}return m.join(s,n)}h.findExecutable=t})(a=e.win32||(e.win32={}))}),define(X[128],J([0,1,27,3,114,86]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function P(v,d){return v===1?D.isWindows?g():y.getWindowsShell(d):i(v,d)}e.getSystemShell=P;function r(v,d){return v===1?D.isWindows?b(d):y.getWindowsShell(d):i(v,d)}e.getSystemShellSync=r;let p=null;function i(v,d){if(D.isLinux&&v===2||D.isMacintosh&&v===3)return"/bin/bash";if(!p){let w;if(D.isWindows)w="/bin/bash";else{if(w=d.SHELL,!w)try{w=(0,m.userInfo)().shell}catch(I){}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}p=w}return p}let L=null;async function g(){return L||(L=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),L}function b(v){if(L)return L;const d=D.isWindows&&parseFloat((0,m.release)())>=10,w=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),I=`${v.windir}\\${w?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?I:y.getWindowsShell(v)}}),define(X[87],J([0,1,45,2,9,44,5,86,33,106,25,17,23,3]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends p.ChannelServer{constructor(E){super({send:o=>{try{process.send&&process.send(o.buffer.toString("base64"))}catch(c){}},onMessage:P.Event.fromNodeEventEmitter(process,"message",o=>b.VSBuffer.wrap(Buffer.from(o,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=d;class w{constructor(E,o){this.modulePath=E,this.options=o,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new P.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=o&&o.timeout?o.timeout:6e4;this.disposeDelayer=new k.Delayer(c),this.child=null,this._client=null}getChannel(E){const o=this;return{call(c,a,h){return o.requestPromise(E,c,a,h)},listen(c,a){return o.requestEvent(E,c,a)}}}requestPromise(E,o,c,a=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(g.canceled());this.disposeDelayer.cancel();const h=this.getCachedChannel(E),t=(0,k.createCancelablePromise)(l=>h.call(o,c,l)),n=a.onCancellationRequested(()=>t.cancel()),s=(0,D.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{n.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(E,o,c){if(!this.disposeDelayer)return P.Event.None;this.disposeDelayer.cancel();let a;const h=new P.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(E).listen(o,c)(h.fire,h),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return h.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],o=Object.create(null);o.env=Object.assign(Object.assign({},(0,y.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(o.env=Object.assign(Object.assign({},o.env),this.options.env)),this.options&&this.options.freshExecArgv&&(o.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(o.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(o.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),o.execArgv===void 0&&(o.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),v.isMacintosh&&o.env&&delete o.env.DYLD_LIBRARY_PATH,this.child=(0,m.fork)(this.modulePath,E,o);const c=new P.Emitter;P.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if((0,i.isRemoteConsoleLog)(u)){(0,i.log)(u,`IPC Library: ${this.options.serverName}`);return}c.fire(b.VSBuffer.wrap(Buffer.from(u,"base64")))});const h=this.options.useQueue?(0,r.createQueuedSender)(this.child):this.child,t=u=>this.child&&this.child.connected&&h.send(u.buffer.toString("base64")),n=c.event,s={send:t,onMessage:n};this._client=new p.ChannelClient(s);const l=()=>this.disposeClient();process.once("exit",l),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,f)=>{process.removeListener("exit",l),this.activeRequests.forEach(S=>(0,D.dispose)(S)),this.activeRequests.clear(),u!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+f),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:f})})}return this._client}getCachedChannel(E){let o=this.channels.get(E);return o||(o=this.client.getChannel(E),this.channels.set(E,o)),o}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=w}),define(X[129],J([14,11]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(X[130],J([14,11]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(X[131],J([14,11]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(X[132],J([14,11]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(X[133],J([14,11]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(X[134],J([14,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(X[135],J([14,11]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(X[136],J([14,11]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(X[137],J([14,11]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(X[138],J([14,11]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(X[139],J([14,11]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(X[140],J([14,11]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(X[141],J([14,11]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(X[142],J([14,11]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(X[143],J([14,11]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(X[144],J([14,11]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(X[145],J([14,11]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(X[146],J([14,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(X[147],J([14,11]),function(j,e){return j.create("vs/platform/workspaces/common/workspaces",e)}),define(X[148],J([14,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(X[149],J([14,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(X[150],J([0,1,5,2]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new m.Emitter,this._onReloadEmitter=new m.Emitter,this._onTerminateEmitter=new m.Emitter,this._onAttachEmitter=new m.Emitter}call(r,p,i){switch(p){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:i[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:i[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:i[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:i[0],port:i[1],subId:i[2]}))}throw new Error("Method not implemented.")}listen(r,p,i){switch(p){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class y extends D.Disposable{constructor(r){super();this.channel=r}reload(r){this.channel.call("reload",[r])}get onReload(){return this.channel.listen("reload")}close(r){this.channel.call("close",[r])}get onClose(){return this.channel.listen("close")}attachSession(r,p,i){this.channel.call("attach",[r,p,i])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(r,p){this.channel.call("terminate",[r,p])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(r,p,i){return this.channel.call("openExtensionDevelopmentHostWindow",[r,p||{},i])}}e.ExtensionHostDebugChannelClient=y});var ce=this&&this.__decorate||function(j,e,m,D){var k=arguments.length,y=k<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,m):D,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(j,e,m,D);else for(var r=j.length-1;r>=0;r--)(P=j[r])&&(y=(k<3?P(y):k>3?P(e,m,y):P(e,m))||y);return k>3&&y&&Object.defineProperty(e,m,y),y};define(X[151],J([0,1,8,15,53,123,10,7,32]),function(j,e,m,D,k,y,P,r,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class i{constructor(d,w,I){this._args=d,this.paths=w,this.productService=I}get appRoot(){return(0,m.dirname)(P.FileAccess.asFileUri("",j).fsPath)}get userHome(){return r.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return r.URI.file((0,m.join)(this.userDataPath,"User"))}get tmpDir(){return r.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,D.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,D.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,m.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return r.URI.file((0,m.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,D.joinPath)(r.URI.file((0,m.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return r.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return r.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=p.env.VSCODE_PORTABLE;return d?r.URI.file((0,m.join)(d,"argv.json")):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,D.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return r.URI.file((0,m.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,m.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,m.resolve)(d):(0,m.normalize)((0,m.join)(P.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,m.resolve)(d):(0,m.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,m.resolve)(d);const w=p.env.VSCODE_EXTENSIONS;if(w)return w;const I=p.env.VSCODE_PORTABLE;return I?(0,m.join)(I,"extensions"):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(w=>/^[^:/?#]+?:\/\//.test(w)?r.URI.parse(w):r.URI.file((0,m.normalize)(w)))}get extensionDevelopmentKind(){var d;return(d=this.args.extensionDevelopmentKind)===null||d===void 0?void 0:d.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?r.URI.parse(d):r.URI.file((0,m.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return L(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!p.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,D.joinPath)(r.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return r.URI.file((0,m.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ce([k.memoize],i.prototype,"appRoot",null),ce([k.memoize],i.prototype,"userHome",null),ce([k.memoize],i.prototype,"userDataPath",null),ce([k.memoize],i.prototype,"appSettingsHome",null),ce([k.memoize],i.prototype,"tmpDir",null),ce([k.memoize],i.prototype,"userRoamingDataHome",null),ce([k.memoize],i.prototype,"settingsResource",null),ce([k.memoize],i.prototype,"userDataSyncHome",null),ce([k.memoize],i.prototype,"userDataSyncLogResource",null),ce([k.memoize],i.prototype,"sync",null),ce([k.memoize],i.prototype,"machineSettingsResource",null),ce([k.memoize],i.prototype,"globalStorageHome",null),ce([k.memoize],i.prototype,"workspaceStorageHome",null),ce([k.memoize],i.prototype,"keybindingsResource",null),ce([k.memoize],i.prototype,"keyboardLayoutResource",null),ce([k.memoize],i.prototype,"argvResource",null),ce([k.memoize],i.prototype,"snippetsHome",null),ce([k.memoize],i.prototype,"isExtensionDevelopment",null),ce([k.memoize],i.prototype,"untitledWorkspacesHome",null),ce([k.memoize],i.prototype,"installSourcePath",null),ce([k.memoize],i.prototype,"builtinExtensionsPath",null),ce([k.memoize],i.prototype,"extensionsPath",null),ce([k.memoize],i.prototype,"extensionDevelopmentLocationURI",null),ce([k.memoize],i.prototype,"extensionDevelopmentKind",null),ce([k.memoize],i.prototype,"extensionTestsLocationURI",null),ce([k.memoize],i.prototype,"debugExtensionHost",null),ce([k.memoize],i.prototype,"serviceMachineIdResource",null),ce([k.memoize],i.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=i;function L(v,d){return b(v["inspect-extensions"],v["inspect-brk-extensions"],5870,d,v.debugId)}e.parseExtensionHostPort=L;function g(v,d){return b(v["inspect-search"],v["inspect-brk-search"],5876,d)}e.parseSearchPort=g;function b(v,d,w,I,E){const c=Number(d||v)||(I?null:w),a=c?Boolean(!!d):!1;return{port:c,break:a,debugId:E}}}),define(X[88],J([0,1,232,132,3]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const y={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(30,null)},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const P={onUnknownOption:()=>{},onMultipleValues:()=>{}};function r(d,w,I=P){const E={},o=[],c=[];for(let n in w){const s=w[n];s.alias&&(E[n]=s.alias),s.type==="string"||s.type==="string[]"?(o.push(n),s.deprecates&&o.push(s.deprecates)):s.type==="boolean"&&(c.push(n),s.deprecates&&c.push(s.deprecates))}const a=m(d,{string:o,boolean:c,alias:E}),h={},t=a;h._=a._.map(n=>String(n)).filter(n=>n.length>0),delete t._;for(let n in w){const s=w[n];s.alias&&delete t[s.alias];let l=t[n];s.deprecates&&t.hasOwnProperty(s.deprecates)&&(l||(l=t[s.deprecates]),delete t[s.deprecates]),typeof l!="undefined"&&(s.type==="string[]"?l&&!Array.isArray(l)&&(l=[l]):s.type==="string"&&Array.isArray(l)&&(l=l.pop(),I.onMultipleValues(n,l)),h[n]=l),delete t[n]}for(let n in t)I.onUnknownOption(n);return h}e.parseArgs=r;function p(d,w){let I="";return w.args&&(Array.isArray(w.args)?I=` <${w.args.join("> <")}>`:I=` <${w.args}>`),w.alias?`-${w.alias} --${d}${I}`:`--${d}${I}`}function i(d,w){let I=0,E=[];for(const h in d){const t=d[h],n=p(h,t);I=Math.max(I,n.length),E.push([n,t.description])}let o=I+2+1;if(w-o<25)return E.reduce((h,t)=>h.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let c=w-o-1,a=[];for(const h of E){let t=h[0],n=g(h[1],c),s=L(o-t.length-2);a.push("  "+t+s+n[0]);for(let l=1;l<n.length;l++)a.push(L(o)+n[l])}return a}e.formatOptions=i;function L(d){return" ".repeat(d)}function g(d,w){let I=[];for(;d.length;){let E=d.length<w?d.length:d.lastIndexOf(" ",w),o=d.slice(0,E).trim();d=d.slice(E),I.push(o)}return I}function b(d,w,I,E,o=!0){const c=process.stdout.isTTY&&process.stdout.columns||80;let a=[`${d} ${I}`];a.push(""),a.push(`${(0,D.localize)(32,null)}: ${w} [${(0,D.localize)(33,null)}][${(0,D.localize)(34,null)}...]`),a.push(""),o&&(k.isWindows?a.push((0,D.localize)(35,null,w)):a.push((0,D.localize)(36,null,w)),a.push(""));const h={};for(const t in E){const n=E[t];if(n.description&&n.cat){let s=h[n.cat];s||(h[n.cat]=s={}),s[t]=n}}for(let t in h){const n=t;let s=h[n];s&&(a.push(y[n]),a.push(...i(s,c)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=b;function v(d,w){return`${d||(0,D.localize)(37,null)}
${w||(0,D.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=v}),define(X[152],J([0,1,88,59,150]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class y extends k.ExtensionHostDebugBroadcastChannel{constructor(r){super();this.windowsMainService=r}call(r,p,i){return p==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(i[0],i[1],i[2]):super.call(r,p,i)}async openExtensionDevelopmentHostWindow(r,p,i){const L=(0,m.parseArgs)(r,m.OPTIONS);L.debugRenderer=i;const g=L.extensionDevelopmentPath;if(!g)return{};let b;const v=Object.keys(p);for(let c of v){let a=p[c];a===null||(b||(b=Object.create(null)),b[c]=a)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(g,{context:5,cli:L,userEnv:b});if(!i)return{};const w=d.win;if(!w)return{};const I=w.webContents.debugger;let E=I.isAttached()?Infinity:0;const o=(0,D.createServer)(c=>{E++==0&&I.attach();let a=!1;const h=s=>{a||c.write(JSON.stringify(s)+"\0")},t=(s,l,u,f)=>h({method:l,params:u,sessionId:f});w.on("close",()=>{I.removeListener("message",t),c.end(),a=!0}),I.addListener("message",t);let n=Buffer.alloc(0);c.on("data",s=>{n=Buffer.concat([n,s]);for(let l=n.indexOf(0);l!==-1;l=n.indexOf(0)){let u;try{const f=n.slice(0,l).toString("utf8");n=n.slice(l+1),u=JSON.parse(f)}catch(f){console.error("error reading cdp line",f)}I.sendCommand(u.method,u.params,u.sessionId).then(f=>h({id:u.id,sessionId:u.sessionId,result:f})).catch(f=>h({id:u.id,sessionId:u.sessionId,error:{code:0,message:f.message}}))}}),c.on("error",s=>{console.error("error on cdp pipe:",s)}),c.on("close",()=>{a=!0,--E==0&&I.detach()})});return await new Promise(c=>o.listen(0,c)),w.on("close",()=>o.close()),{rendererDebugPort:o.address().port}}}e.ElectronExtensionHostDebugBroadcastChannel=y}),function(){"use strict";function j(e,m,D,k){function y(r){const p=P(r),i=[p];return e.isAbsolute(p)||i.unshift(k),e.resolve(...i)}function P(r){const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");const i=r["user-data-dir"];if(i)return i;let L=process.env.VSCODE_APPDATA;if(!L)switch(process.platform){case"win32":if(L=process.env.APPDATA,!L){const g=process.env.USERPROFILE;if(typeof g!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");L=e.join(g,"AppData","Roaming")}break;case"darwin":L=e.join(m.homedir(),"Library","Application Support");break;case"linux":L=process.env.XDG_CONFIG_HOME||e.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(L,D)}return{getUserDataPath:y}}if(typeof define=="function")define(X[153],J([0,154,27,10,15,32]),function(e,m,D,k,y,P){const r=y.dirname(k.FileAccess.asFileUri("",e)),p=e.__$__nodeRequire(y.joinPath(r,"package.json").fsPath);return j(m,D,p.name,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),m=require("path"),D=require("os");module.exports=j(m,D,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(X[155],J([0,1,27,153,151]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class y extends k.AbstractNativeEnvironmentService{constructor(r,p){super(r,{homeDir:(0,m.homedir)(),tmpDir:(0,m.tmpdir)(),userDataDir:(0,D.getUserDataPath)(r)},p)}}e.NativeEnvironmentService=y}),define(X[156],J([0,1,18,27,8]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function y(P){const r=(0,k.join)((0,D.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return m.writeFileSync(r,""),P&&console.log(`Marker file for --wait created: ${r}`),r}catch(p){P&&console.error(`Failed to create marker file for --wait: ${p}`);return}}e.createWaitMarkerFile=y}),define(X[157],J([0,1,135]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function k(g){return g=g.trim(),g==="*"||D.test(g)}e.isValidVersionStr=k;function y(g){if(!k(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=g.match(D);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=y;function P(g){if(!g)return null;let b=g.majorBase,v=g.majorMustEqual,d=g.minorBase,w=g.minorMustEqual,I=g.patchBase,E=g.patchMustEqual;return g.hasCaret&&(b===0||(w=!1),E=!1),{majorBase:b,majorMustEqual:v,minorBase:d,minorMustEqual:w,patchBase:I,patchMustEqual:E,isMinimum:g.hasGreaterEquals}}e.normalizeVersion=P;function r(g,b){let v;typeof g=="string"?v=P(y(g)):v=g;let d;if(typeof b=="string"?d=P(y(b)):d=b,!v||!d)return!1;let w=v.majorBase,I=v.minorBase,E=v.patchBase,o=d.majorBase,c=d.minorBase,a=d.patchBase,h=d.majorMustEqual,t=d.minorMustEqual,n=d.patchMustEqual;return d.isMinimum?w>o?!0:w<o?!1:I>c?!0:I<c?!1:E>=a:(w===1&&o===0&&(!h||!t||!n)&&(o=1,c=0,a=0,h=!0,t=!1,n=!1),w<o?!1:w>o?!h:I<c?!1:I>c?!t:E<a?!1:E>a?!n:!0)}e.isValidVersion=r;function p(g,b,v){return b.isBuiltin||typeof b.main=="undefined"?!0:L(g,b.engines.vscode,v)}e.isValidExtensionVersion=p;function i(g,b){return g==="*"||L(b,g)}e.isEngineValid=i;function L(g,b,v=[]){let d=P(y(b));if(!d)return v.push(m.localize(0,null,b)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return v.push(m.localize(1,null,b)),!1}else if(!d.majorMustEqual)return v.push(m.localize(2,null,b)),!1;return r(g,d)?!0:(v.push(m.localize(3,null,g,b)),!1)}e.isVersionValid=L}),define(X[158],J([0,1,33,87,2,10]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends k.Disposable{constructor(p,i,L,g){super();this.folders=p,this.onDidFilesChange=i,this.onLogMessage=L,this.verboseLogging=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new D.Client(y.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(p.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(i=>!this.isDisposed&&this.onDidFilesChange(i))),this._register(this.service.onDidLogMessage(i=>this.onLogMessage(i))),this.setFolders(this.folders)}setVerboseLogging(p){this.verboseLogging=p,!this.isDisposed&&this.service&&this.service.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${p}`})}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(X[159],J([0,1,33,87,2,10]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends k.Disposable{constructor(p,i,L,g,b={}){super();this.folders=p,this.onDidFilesChange=i,this.onLogMessage=L,this.verboseLogging=g,this.watcherOptions=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new D.Client(y.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(p.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(i=>!this.isDisposed&&this.onDidFilesChange(i))),this._register(this.service.onDidLogMessage(i=>this.onLogMessage(i))),this.service.setRoots(this.folders)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${p}`})}setVerboseLogging(p){this.verboseLogging=p,this.service&&this.service.setVerboseLogging(p)}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(X[160],J([0,1,45,81,108,10]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class P{constructor(p,i,L,g,b){this.watchedFolder=p,this.eventCallback=L,this.logCallback=g,this.verboseLogging=b,this.restartCounter=0,Array.isArray(i)?this.ignored=i.map(v=>k.parse(v)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${p}`),this.startWatcher()}startWatcher(){const p=[this.watchedFolder];this.verboseLogging&&p.push("-verbose"),this.handle=m.spawn(y.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",j).fsPath,p);const i=new D.LineDecoder;this.handle.stdout.on("data",L=>{const g=[];i.write(L).forEach(b=>{const v=b.split("|");if(v.length===2){const d=Number(v[0]),w=v[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(I=>I(w))){this.verboseLogging&&this.log(w);return}g.push({type:P.changeTypeMap[d],path:w})}else this.log(v[1])}}),g.length>0&&this.eventCallback(g)}),this.handle.on("error",L=>this.onError(L)),this.handle.stderr.on("data",L=>this.onError(L)),this.handle.on("exit",(L,g)=>this.onExit(L,g))}onError(p){this.error("process error: "+p.toString())}onExit(p,i){this.handle&&(this.error(`terminated unexpectedly (code: ${p}, signal: ${i})`),this.restartCounter<=P.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(p){this.logCallback({type:"error",message:`[File Watcher (C#)] ${p}`})}log(p){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${p}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=P,P.MAX_RESTARTS=5,P.changeTypeMap=[0,1,2]}),define(X[161],J([0,1,160,8,22]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class y{constructor(r,p,i,L){this.onDidFilesChange=p,this.onLogMessage=i,this.verboseLogging=L,this.service=void 0,this.folder=r[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(D.posix.sep)&&(this.folder.path=(0,k.rtrim)(this.folder.path,D.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,r=>this.onFileEvents(r),r=>this.onLogMessage(r),this.verboseLogging)}setVerboseLogging(r){this.verboseLogging=r,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(r){this.isDisposed||r.length>0&&this.onDidFilesChange(r)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=y}),define(X[67],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class m{constructor(y,P=[],r=!1){this.ctor=y,this.staticArguments=P,this.supportsDelayedInstantiation=r}}e.SyncDescriptor=m;const D=(k,...y)=>new m(k,y);e.createSyncDescriptor=D}),define(X[162],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=m;class D{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let P of this._nodes.values())P.outgoing.size===0&&y.push(P);return y}insertEdge(y,P){const r=this.lookupOrInsertNode(y),p=this.lookupOrInsertNode(P);r.outgoing.set(this._hashFn(P),p),p.incoming.set(this._hashFn(y),r)}removeNode(y){const P=this._hashFn(y);this._nodes.delete(P);for(let r of this._nodes.values())r.outgoing.delete(P),r.incoming.delete(P)}lookupOrInsertNode(y){const P=this._hashFn(y);let r=this._nodes.get(P);return r||(r=new m(y),this._nodes.set(P,r)),r}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[P,r]of this._nodes)y.push(`${P}, (incoming)[${[...r.incoming.keys()].join(", ")}], (outgoing)[${[...r.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,P]of this._nodes){const r=new Set([y]),p=this._findCycle(P,r);if(p)return p}}_findCycle(y,P){for(let[r,p]of y.outgoing){if(P.has(r))return[...P,r].join(" -> ");P.add(r);const i=this._findCycle(p,P);if(i)return i;P.delete(r)}}}e.Graph=D}),define(X[4],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(r){r.serviceIds=new Map,r.DI_TARGET="$di$target",r.DI_DEPENDENCIES="$di$dependencies";function p(i){return i[r.DI_DEPENDENCIES]||[]}r.getServiceDependencies=p})(m=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function D(r,p,i,L){p[m.DI_TARGET]===p?p[m.DI_DEPENDENCIES].push({id:r,index:i,optional:L}):(p[m.DI_DEPENDENCIES]=[{id:r,index:i,optional:L}],p[m.DI_TARGET]=p)}function k(r){if(m.serviceIds.has(r))return m.serviceIds.get(r);const p=function(i,L,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(p,i,g,!1)};return p.toString=()=>r,m.serviceIds.set(r,p),p}e.createDecorator=k;function y(r){return r}e.refineServiceDecorator=y;function P(r){return function(p,i,L){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");D(r,p,L,!0)}}e.optional=P}),define(X[68],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,m.createDecorator)(e.ID);function D(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=D}),define(X[89],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,m.createDecorator)("encryptionMainService");class D{constructor(y){this.machineId=y}encryption(){return new Promise((y,P)=>j(["vscode-encrypt"],y,P))}async encrypt(y){try{return(await this.encryption()).encrypt(this.machineId,y)}catch(P){return y}}async decrypt(y){try{return(await this.encryption()).decrypt(this.machineId,y)}catch(P){return y}}}e.EncryptionMainService=D}),define(X[46],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(X[163],J([0,1,134,4,10]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function y(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=y;var P;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=5]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var r;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(r=e.SortOrder||(e.SortOrder={}));var p;(function(g){g.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var i;(function(g){g[g.None=0]="None",g[g.Install=1]="Install",g[g.Update=2]="Update"})(i=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class L extends Error{constructor(b,v){super(b);this.code=v}}e.ExtensionManagementError=L,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),e.ExtensionsLabel=(0,m.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,m.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(X[164],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,m.createDecorator)("extensionUrlTrustService")}),define(X[165],J([0,1,22,4]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function k(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));class P{constructor(L){this.value=L,this._lower=L.toLowerCase()}static equals(L,g){if(typeof L=="undefined"||L===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof L=="string"||typeof g=="string"){let b=typeof L=="string"?L:L.value,v=typeof g=="string"?g:g.value;return m.equalsIgnoreCase(b,v)}return L._lower===g._lower}static toKey(L){return typeof L=="string"?L.toLowerCase():L._lower}}e.ExtensionIdentifier=P;function r(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=r;function p(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=p,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(X[166],J([0,1,22,165]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(v,d){return v.uuid&&d.uuid?v.uuid===d.uuid:v.id===d.id?!0:(0,m.compareIgnoreCase)(v.id,d.id)===0}e.areSameExtensions=k;class y{constructor(d,w){this.version=w,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof y?k(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=y;function P(v,d){return`${v}.${d}`}e.getExtensionId=P;function r(v){return v.toLocaleLowerCase()}e.adoptToGalleryExtensionId=r;function p(v,d){return r(P(v,d))}e.getGalleryExtensionId=p;function i(v,d){const w=[],I=E=>{for(const o of w)if(o.some(c=>k(d(c),d(E))))return o;return null};for(const E of v){const o=I(E);o?o.push(E):w.push([E])}return w}e.groupByExtension=i;function L(v){return{id:v.identifier.id,name:v.manifest.name,galleryId:null,publisherId:v.publisherId,publisherName:v.manifest.publisher,publisherDisplayName:v.publisherDisplayName,dependencies:v.manifest.extensionDependencies&&v.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=L;function g(v){return Object.assign({id:v.identifier.id,name:v.name,galleryId:v.identifier.uuid,publisherId:v.publisherId,publisherName:v.publisher,publisherDisplayName:v.publisherDisplayName,dependencies:!!(v.properties.dependencies&&v.properties.dependencies.length>0)},v.telemetryData)}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function b(v){const d=new Set;for(const w of v)w.malicious&&d.add(w.id.id);return d}e.getMaliciousExtensionsSet=b}),define(X[24],J([0,1,137,8,7,4,22,12,36]),function(j,e,m,D,k,y,P,r,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function i(O){return O.create===!0}e.isFileOpenForWriteOptions=i;var L;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var g;(function(O){O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=b;function v(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=v;function d(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function w(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=w;var I;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor($,z){super($);this.code=z}}e.FileSystemProviderError=E;function o(O,$){const z=new E(O.toString(),$);return a(z,$),z}e.createFileSystemProviderError=o;function c(O){return O||o((0,m.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=c;function a(O,$){return O.name=$?`${$} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=a;function h(O){if(!O)return I.Unknown;if(O instanceof E)return O.code;const $=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!$)return I.Unknown;switch($[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=h;function t(O){if(O instanceof S)return O.fileOperationResult;switch(h(O)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class s{constructor($,z,C){this.resource=$,this.operation=z,this.target=C}isOperation($){return this.operation===$}}e.FileOperationEvent=s;var l;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class u{constructor($,z){this.ignorePathCasing=z,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=$;for(const C of $)switch(C.type){case 1:this.added||(this.added=p.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(C.resource,C);break;case 0:this.updated||(this.updated=p.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(C.resource,C);break;case 2:this.deleted||(this.deleted=p.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(C.resource,C);break}}contains($,...z){return this.doContains($,{includeChildren:!1},...z)}affects($,...z){return this.doContains($,{includeChildren:!0},...z)}doContains($,z,...C){var q,N,_,R,W,M;if(!$)return!1;const F=C.length>0;return!!((!F||C.includes(1))&&(((q=this.added)===null||q===void 0?void 0:q.get($))||z.includeChildren&&((N=this.added)===null||N===void 0?void 0:N.findSuperstr($)))||(!F||C.includes(0))&&(((_=this.updated)===null||_===void 0?void 0:_.get($))||z.includeChildren&&((R=this.updated)===null||R===void 0?void 0:R.findSuperstr($)))||(!F||C.includes(2))&&(((W=this.deleted)===null||W===void 0?void 0:W.findSubstr($))||z.includeChildren&&((M=this.deleted)===null||M===void 0?void 0:M.findSuperstr($))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType($){const z=[],C=$===1?this.added:$===0?this.updated:this.deleted;if(C)for(const[,q]of C)z.push(q);return z}filter($){return new u(this.changes.filter(z=>$(z)),this.ignorePathCasing)}}e.FileChangesEvent=u;function f(O,$,z){return!O||!$||O===$||$.length>O.length?!1:($.charAt($.length-1)!==D.sep&&($+=D.sep),z?(0,P.startsWithIgnoreCase)(O,$):O.indexOf($)===0)}e.isParent=f;class S extends Error{constructor($,z,C){super($);this.fileOperationResult=z,this.options=C}static isFileOperationError($){return $ instanceof Error&&!(0,r.isUndefinedOrNull)($.fileOperationResult)}}e.FileOperationError=S;var A;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=U;async function H(O,$){if(!$.canHandleResource(k.URI.from({scheme:O.scheme})))return new Promise(z=>{const C=$.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===O.scheme&&q.added&&(C.dispose(),z())})})}e.whenProviderRegistered=H,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Q{static formatSize($){return(0,r.isNumber)($)||($=0),$<Q.KB?(0,m.localize)(1,null,$.toFixed(0)):$<Q.MB?(0,m.localize)(2,null,($/Q.KB).toFixed(2)):$<Q.GB?(0,m.localize)(3,null,($/Q.MB).toFixed(2)):$<Q.TB?(0,m.localize)(4,null,($/Q.GB).toFixed(2)):(0,m.localize)(5,null,($/Q.TB).toFixed(2))}}e.ByteSize=Q,Q.KB=1024,Q.MB=Q.KB*Q.KB,Q.GB=Q.MB*Q.KB,Q.TB=Q.GB*Q.KB;var ne;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(ne=e.Arch||(e.Arch={}));function ae(O){return{maxFileSize:O===0?300*Q.MB:16*Q.GB,maxHeapSize:O===0?700*Q.MB:2*700*Q.MB}}e.getPlatformLimits=ae}),define(X[54],J([0,1,233,133,24,88]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function P(b,v){const d={onUnknownOption:I=>{console.warn((0,D.localize)(0,null,I))},onMultipleValues:(I,E)=>{console.warn((0,D.localize)(1,null,I,E))}},w=(0,y.parseArgs)(b,y.OPTIONS,v?d:void 0);return w.goto&&w._.forEach(I=>m(/^(\w:)?[^:]+(:\d*){0,2}$/.test(I),(0,D.localize)(2,null))),w["max-memory"]&&m(parseInt(w["max-memory"])>=k.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${k.MIN_MAX_MEMORY_SIZE_MB} MB.`),w}function r(b){const v=b.findIndex(d=>!/^-/.test(d));if(v>-1)return[...b.slice(0,v),...b.slice(v+1)]}function p(b){let[,...v]=b;process.env.VSCODE_DEV&&(v=r(v)||[]);const d=!g(process.env);return P(v,d)}e.parseMainProcessArgv=p;function i(b){const[,,...v]=b;return P(v,!0)}e.parseCLIProcessArgv=i;function L(b,...v){const d=b.indexOf("--");return d===-1?b.push(...v):b.splice(d,0,...v),b}e.addArg=L;function g(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=g}),define(X[69],J([0,1,154,45,28,3,54,66,128]),function(j,e,m,D,k,y,P,r,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function i(b,v,d){return v["force-disable-user-env"]?(b.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):y.isWindows?(b.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(d)&&!v["force-user-env"]?(b.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(d)?b.trace("resolveShellEnv(): running (--force-user-env)"):b.trace("resolveShellEnv(): running (macOS/Linux)"),L||(L=g(b)),L)}e.resolveShellEnv=i;let L;async function g(b){const v=new Promise(async(d,w)=>{const I=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",I);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",E);const o=(0,k.generateUuid)().replace(/-/g,"").substr(0,12),c=new RegExp(o+"(.*)"+o),a=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});b.trace("getUnixShellEnvironment#env",a);const h=await(0,p.getSystemShell)(y.OS,a);b.trace("getUnixShellEnvironment#shell",h);let t=`'${process.execPath}' -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,n=["-ilc"];const s=m.basename(h);/^pwsh(-preview)?$/.test(s)&&(t=`& ${t}`,n=["-Login","-Command"]),b.trace("getUnixShellEnvironment#spawn",JSON.stringify(n),t);const l=(0,D.spawn)(h,[...n,t],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});l.on("error",S=>{b.error("getUnixShellEnvironment#errorChildProcess",(0,r.toErrorMessage)(S)),d({})});const u=[];l.stdout.on("data",S=>u.push(S));const f=[];l.stderr.on("data",S=>f.push(S)),l.on("close",(S,A)=>{const T=Buffer.concat(u).toString("utf8");b.trace("getUnixShellEnvironment#raw",T);const U=Buffer.concat(f).toString("utf8");if(U.trim()&&b.trace("getUnixShellEnvironment#stderr",U),S||A)return w(new Error(`Failed to get environment (code ${S}, signal ${A})`));const H=c.exec(T),Q=H?H[1]:"{}";try{const ne=JSON.parse(Q);I?ne.ELECTRON_RUN_AS_NODE=I:delete ne.ELECTRON_RUN_AS_NODE,E?ne.ELECTRON_NO_ATTACH_CONSOLE=E:delete ne.ELECTRON_NO_ATTACH_CONSOLE,delete ne.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",ne),d(ne)}catch(ne){b.error("getUnixShellEnvironment#errorCaught",(0,r.toErrorMessage)(ne)),w(ne)}})});try{return await v}catch(d){return b.error("getUnixShellEnvironment#error",(0,r.toErrorMessage)(d)),{}}}}),define(X[90],J([0,1,7,24,3]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function y(p){return p.map(i=>({type:i.type,resource:m.URI.file(i.path)}))}e.toFileChanges=y;function P(p){const i=new r;for(const L of p)i.processEvent(L);return i.normalize()}e.normalizeFileChanges=P;class r{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(i){const L=this.mapPathToChange.get(i.path);if(L){const g=L.type,b=i.type;g===1&&b===2?(this.mapPathToChange.delete(i.path),this.normalized.splice(this.normalized.indexOf(L),1)):g===2&&b===1?L.type=0:g===1&&b===0||(L.type=b)}else this.normalized.push(i),this.mapPathToChange.set(i.path,i)}normalize(){const i=[],L=[];return this.normalized.filter(g=>g.type!==2?(i.push(g),!1):!0).sort((g,b)=>g.path.length-b.path.length).filter(g=>L.some(b=>(0,D.isParent)(g.path,b,!k.isLinux))?!1:(L.push(g.path),!0)).concat(i)}}}),define(X[167],J([0,1,90,2,19,111,115,9,8]),function(j,e,m,D,k,y,P,r,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends D.Disposable{constructor(g,b,v,d){super();this.path=g,this.onDidFilesChange=b,this.onLogMessage=v,this.verboseLogging=d,this.fileChangesDelayer=this._register(new r.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(g){this.verboseLogging=g}async startWatching(){try{const{stat:g,symbolicLink:b}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let v=this.path;if(b)try{v=await(0,y.realpath)(v)}catch(d){if(this.onError(d),b.dangling)return}g.isDirectory()?this._register((0,P.watchFolder)(v,(d,w)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,p.join)(this.path,(0,p.basename)(w))})},d=>this.onError(d))):this._register((0,P.watchFile)(v,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(g){g.code!=="ENOENT"&&this.onError(g)}}onFileChange(g){this.fileChangesBuffer.push(g),this.verboseLogging&&this.onVerbose(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),this.fileChangesDelayer.trigger(async()=>{const b=this.fileChangesBuffer;this.fileChangesBuffer=[];const v=(0,m.normalizeFileChanges)(b);this.verboseLogging&&v.forEach(d=>{this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`)}),v.length>0&&this.onDidFilesChange(v)})}onError(g){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${g}`})}onVerbose(g){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=i}),define(X[70],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...k){this._entries=new Map;for(let[y,P]of k)this.set(y,P)}set(k,y){const P=this._entries.get(k);return this._entries.set(k,y),P}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=m}),define(X[168],J([0,1,17,162,67,4,70,9]),function(j,e,m,D,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const p=!1;class i extends Error{constructor(d){var w;super("cyclic dependency between services");this.message=(w=d.findCycleSlow())!==null&&w!==void 0?w:`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class L{constructor(d=new P.ServiceCollection,w=!1,I){this._activeInstantiations=new Set,this._services=d,this._strict=w,this._parent=I,this._services.set(y.IInstantiationService,this)}createChild(d){return new L(d,this._strict,this)}invokeFunction(d,...w){let I=b.traceInvocation(d),E=!1;try{return d({get:(c,a)=>{if(E)throw(0,m.illegalState)("service accessor is only valid during the invocation of its target method");const h=this._getOrCreateServiceInstance(c,I);if(!h&&a!==y.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return h}},...w)}finally{E=!0,I.stop()}}createInstance(d,...w){let I,E;return d instanceof k.SyncDescriptor?(I=b.traceCreation(d.ctor),E=this._createInstance(d.ctor,d.staticArguments.concat(w),I)):(I=b.traceCreation(d),E=this._createInstance(d,w,I)),I.stop(),E}_createInstance(d,w=[],I){let E=y._util.getServiceDependencies(d).sort((a,h)=>a.index-h.index),o=[];for(const a of E){let h=this._getOrCreateServiceInstance(a.id,I);if(!h&&this._strict&&!a.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${a.id}.`);o.push(h)}let c=E.length>0?E[0].index:w.length;if(w.length!==c){console.warn(`[createInstance] First service dependency of ${d.name} at position ${c+1} conflicts with ${w.length} static arguments`);let a=c-w.length;a>0?w=w.concat(new Array(a)):w=w.slice(0,c)}return new d(...[...w,...o])}_setServiceInstance(d,w){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,w);else if(this._parent)this._parent._setServiceInstance(d,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let w=this._services.get(d);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):w}_getOrCreateServiceInstance(d,w){let I=this._getServiceInstanceOrDescriptor(d);return I instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,I,w.branch(d,!0)):(w.branch(d,!1),I)}_safeCreateAndCacheServiceInstance(d,w,I){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,w,I)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,w,I){const E=new D.Graph(a=>a.id.toString());let o=0;const c=[{id:d,desc:w,_trace:I}];for(;c.length;){const a=c.pop();if(E.lookupOrInsertNode(a),o++>1e3)throw new i(E);for(let h of y._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(h.id);if(!t&&!h.optional&&console.warn(`[createInstance] ${d} depends on ${h.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const n={id:h.id,desc:t,_trace:a._trace.branch(h.id,!0)};E.insertEdge(a,n),c.push(n)}}}for(;;){const a=E.roots();if(a.length===0){if(!E.isEmpty())throw new i(E);break}for(const{data:h}of a){if(this._getServiceInstanceOrDescriptor(h.id)instanceof k.SyncDescriptor){const n=this._createServiceInstanceWithOwner(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this._setServiceInstance(h.id,n)}E.removeNode(h)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,w,I=[],E,o){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(w,I,E,o);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,w,I,E,o);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(d,w=[],I,E){if(I){const o=new r.IdleValue(()=>this._createInstance(d,w,E));return new Proxy(Object.create(null),{get(c,a){if(a in c)return c[a];let h=o.value,t=h[a];return typeof t!="function"||(t=t.bind(h),c[a]=t),t},set(c,a,h){return o.value[a]=h,!0}})}else return this._createInstance(d,w,E)}}e.InstantiationService=L;var g;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(g||(g={}));class b{constructor(d,w){this.type=d,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return p?new b(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(d){return p?new b(0,d.name):b._None}branch(d,w){let I=new b(2,d.toString());return this._dep.push([d,w,I]),I}stop(){let d=Date.now()-this._start;b._totals+=d;let w=!1;function I(o,c){let a=[],h=new Array(o+1).join("	");for(const[t,n,s]of c._dep)if(n&&s){w=!0,a.push(`${h}CREATES -> ${t}`);let l=I(o+1,s);l&&a.push(l)}else a.push(`${h}uses -> ${t}`);return a.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${I(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(d>2||w)&&console.log(E.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(X[169],J([0,1,17,126,57]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class y extends k.ResolvedKeybinding{constructor(r,p){super();if(p.length===0)throw(0,m.illegalArgument)("parts");this._os=r,this._parts=p}getLabel(){return D.UILabelProvider.toLabel(this._os,this._parts,r=>this._getLabel(r))}getAriaLabel(){return D.AriaLabelProvider.toLabel(this._os,this._parts,r=>this._getAriaLabel(r))}getElectronAccelerator(){return this._parts.length>1?null:D.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,r=>this._getElectronAccelerator(r))}getUserSettingsLabel(){return D.UserSettingsLabelProvider.toLabel(this._os,this._parts,r=>this._getUserSettingsLabel(r))}isWYSIWYG(){return this._parts.every(r=>this._isWYSIWYG(r))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(r=>this._getPart(r))}_getPart(r){return new k.ResolvedKeybindingPart(r.ctrlKey,r.shiftKey,r.altKey,r.metaKey,this._getLabel(r),this._getAriaLabel(r))}getDispatchParts(){return this._parts.map(r=>this._getDispatchPart(r))}getSingleModifierDispatchParts(){return this._parts.map(r=>this._getSingleModifierDispatchPart(r))}}e.BaseResolvedKeybinding=y}),define(X[170],J([0,1,57,169]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends D.BaseResolvedKeybinding{constructor(P,r){super(r,P.parts)}_keyCodeToUILabel(P){if(this._os===2)switch(P){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return m.KeyCodeUtils.toString(P)}_getLabel(P){return P.isDuplicateModifierCase()?"":this._keyCodeToUILabel(P.keyCode)}_getAriaLabel(P){return P.isDuplicateModifierCase()?"":m.KeyCodeUtils.toString(P.keyCode)}_keyCodeToElectronAccelerator(P){if(P>=93&&P<=108)return null;switch(P){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return m.KeyCodeUtils.toString(P)}_getElectronAccelerator(P){return P.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(P.keyCode)}_getUserSettingsLabel(P){if(P.isDuplicateModifierCase())return"";const r=m.KeyCodeUtils.toUserSettingsUS(P.keyCode);return r&&r.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(P){return k.getDispatchStr(P)}static getDispatchStr(P){if(P.isModifierKey())return null;let r="";return P.ctrlKey&&(r+="ctrl+"),P.shiftKey&&(r+="shift+"),P.altKey&&(r+="alt+"),P.metaKey&&(r+="meta+"),r+=m.KeyCodeUtils.toString(P.keyCode),r}_getSingleModifierDispatchPart(P){return P.keyCode===5&&!P.shiftKey&&!P.altKey&&!P.metaKey?"ctrl":P.keyCode===4&&!P.ctrlKey&&!P.altKey&&!P.metaKey?"shift":P.keyCode===6&&!P.ctrlKey&&!P.shiftKey&&!P.metaKey?"alt":P.keyCode===57&&!P.ctrlKey&&!P.shiftKey&&!P.altKey?"meta":null}}e.USLayoutResolvedKeybinding=k}),define(X[171],J([0,1,9]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function D(k,y){if(k.length===0)return Promise.resolve(!1);const P=[];let r=!1;for(let p of k){if(p===!0)return Promise.resolve(!0);(0,m.isThenable)(p)&&P.push(p.then(i=>{i&&(r=!0)},i=>{y(i),r=!0}))}return m.Promises.settled(P).then(()=>r)}e.handleVetos=D}),define(X[6],J([0,1,4,2,3,5,66]),function(j,e,m,D,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function r(){return new Date().toISOString()}var p;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;class i extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=i;class L extends i{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(p.Trace)&&this.log(p.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(p.Debug)&&this.log(p.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(p.Info)&&this.log(p.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(p.Warning)&&this.log(p.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(p.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(p.Error,this.format(s))}else this.log(p.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(p.Critical)&&this.log(p.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let s=0;s<t.length;s++){let l=t[s];if(typeof l=="object")try{l=JSON.stringify(l)}catch(u){}n+=(s>0?" ":"")+l}return n}}e.AbstractMessageLogger=L;class g extends i{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...n){this.getLevel()<=p.Trace&&(this.useColors?console.log(`[90m[main ${r()}][0m`,t,...n):console.log(`[main ${r()}]`,t,...n))}debug(t,...n){this.getLevel()<=p.Debug&&(this.useColors?console.log(`[90m[main ${r()}][0m`,t,...n):console.log(`[main ${r()}]`,t,...n))}info(t,...n){this.getLevel()<=p.Info&&(this.useColors?console.log(`[90m[main ${r()}][0m`,t,...n):console.log(`[main ${r()}]`,t,...n))}warn(t,...n){this.getLevel()<=p.Warning&&(this.useColors?console.warn(`[93m[main ${r()}][0m`,t,...n):console.warn(`[main ${r()}]`,t,...n))}error(t,...n){this.getLevel()<=p.Error&&(this.useColors?console.error(`[91m[main ${r()}][0m`,t,...n):console.error(`[main ${r()}]`,t,...n))}critical(t,...n){this.getLevel()<=p.Critical&&(this.useColors?console.error(`[90m[main ${r()}][0m`,t,...n):console.error(`[main ${r()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class b extends i{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=p.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=p.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=p.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=p.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=p.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=p.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=b;class v extends i{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=p.Trace&&this.adapter.log(p.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=p.Debug&&this.adapter.log(p.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=p.Info&&this.adapter.log(p.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=p.Warning&&this.adapter.log(p.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=p.Error&&this.adapter.log(p.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=p.Critical&&this.adapter.log(p.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,P.toErrorMessage)(t,this.getLevel()<=p.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class d extends i{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const s of this.logServices)s.trace(t,...n)}debug(t,...n){for(const s of this.logServices)s.debug(t,...n)}info(t,...n){for(const s of this.logServices)s.info(t,...n)}warn(t,...n){for(const s of this.logServices)s.warn(t,...n)}error(t,...n){for(const s of this.logServices)s.error(t,...n)}critical(t,...n){for(const s of this.logServices)s.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class w extends D.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=w;class I extends D.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(l=>l.setLevel(s))}))}createLogger(t,n){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(n==null?void 0:n.always)?p.Trace:this.logLevel,n),this.loggers.set(t.toString(),s),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=I;class E{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(t){}getLevel(){return p.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=E;function o(h){if(h.verbose)return p.Trace;if(typeof h.logLevel=="string"){const t=c(h.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function c(h){switch(h){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Critical;case"off":return p.Off}}e.parseLogLevel=c;function a(h){switch(h){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Critical:return"critical";case p.Off:return"off"}}e.LogLevelToString=a}),define(X[91],J([0,1,6]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function D(y,P){switch(P){case m.LogLevel.Trace:return y.trace;case m.LogLevel.Debug:return y.debug;case m.LogLevel.Info:return y.info;case m.LogLevel.Warning:return y.warn;case m.LogLevel.Error:return y.error;case m.LogLevel.Critical:return y.critical;default:throw new Error("Invalid log level")}}class k extends m.AbstractLogger{constructor(P=m.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(P),this._register(this.onDidChangeLogLevel(r=>{this._logger&&this._logger.setLevel(r)}))}set logger(P){this._logger=P;for(const{level:r,args:p}of this.buffer)D(P,r).apply(P,p);this.buffer=[]}_log(P,...r){this._logger?D(this._logger,P).apply(this._logger,r):this.getLevel()<=P&&this.buffer.push({level:P,args:r})}trace(P,...r){this._log(m.LogLevel.Trace,P,...r)}debug(P,...r){this._log(m.LogLevel.Debug,P,...r)}info(P,...r){this._log(m.LogLevel.Info,P,...r)}warn(P,...r){this._log(m.LogLevel.Warning,P,...r)}error(P,...r){this._log(m.LogLevel.Error,P,...r)}critical(P,...r){this._log(m.LogLevel.Critical,P,...r)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=k});var ee=this&&this.__param||function(j,e){return function(m,D){e(m,D,j)}};define(X[172],J([0,1,6,24,9,23,15,4,91]),function(j,e,m,D,k,y,P,r,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const i=5*D.ByteSize.MB;let L=class extends m.AbstractLogger{constructor(v,d,w,I){super();this.name=v,this.resource=d,this.fileService=I,this.backupIndex=1,this.setLevel(w),this.queue=this._register(new k.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=m.LogLevel.Trace&&this._log(m.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=m.LogLevel.Debug&&this._log(m.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=m.LogLevel.Info&&this._log(m.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=m.LogLevel.Warning&&this._log(m.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=m.LogLevel.Error){const v=arguments[0];if(v instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=v.stack,this._log(m.LogLevel.Error,this.format(d))}else this._log(m.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=m.LogLevel.Critical&&this._log(m.LogLevel.Critical,this.format(arguments))}flush(){}log(v,d){this._log(v,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(v){if(v.fileOperationResult!==3)throw v}}_log(v,d){this.queue.queue(async()=>{await this.initializePromise;let w=await this.loadContent();w.length>i&&(await this.fileService.writeFile(this.getBackupResource(),y.VSBuffer.fromString(w)),w=""),w+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(v)}] ${d}
`,await this.fileService.writeFile(this.resource,y.VSBuffer.fromString(w))})}getCurrentTimestamp(){const v=I=>I<10?`0${I}`:I,d=I=>I<10?`00${I}`:I<100?`0${I}`:I,w=new Date;return`${w.getFullYear()}-${v(w.getMonth()+1)}-${v(w.getDate())} ${v(w.getHours())}:${v(w.getMinutes())}:${v(w.getSeconds())}.${d(w.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,P.joinPath)((0,P.dirname)(this.resource),`${(0,P.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(v){return""}}stringifyLogLevel(v){switch(v){case m.LogLevel.Critical:return"critical";case m.LogLevel.Debug:return"debug";case m.LogLevel.Error:return"error";case m.LogLevel.Info:return"info";case m.LogLevel.Trace:return"trace";case m.LogLevel.Warning:return"warning"}return""}format(v){let d="";for(let w=0;w<v.length;w++){let I=v[w];if(typeof I=="object")try{I=JSON.stringify(I)}catch(E){}d+=(w>0?" ":"")+I}return d}};L=ce([ee(3,D.IFileService)],L),e.FileLogger=L;let g=class extends m.AbstractLoggerService{constructor(v,d,w){super(v.getLevel(),v.onDidChangeLogLevel);this.instantiationService=d,this.fileService=w}doCreateLogger(v,d){const w=new p.BufferLogService(d);return(0,D.whenProviderRegistered)(v,this.fileService).then(()=>w.logger=this.instantiationService.createInstance(L,(0,P.basename)(v),v,w.getLevel())),w}};g=ce([ee(0,m.ILogService),ee(1,r.IInstantiationService),ee(2,D.IFileService)],g),e.FileLoggerService=g}),define(X[173],J([0,1,6,5,7]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class y{constructor(b){this.service=b,this.onDidChangeLogLevel=D.Event.buffer(b.onDidChangeLogLevel,!0)}listen(b,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(b,v,d){switch(v){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=y;class P{constructor(b){this.channel=b}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(b){P.setLevel(this.channel,b)}static setLevel(b,v){return b.call("setLevel",v)}}e.LogLevelChannelClient=P;class r{constructor(b){this.loggerService=b,this.loggers=new Map}listen(b,v){throw new Error(`Event not found: ${v}`)}async call(b,v,d){switch(v){case"createLogger":this.createLogger(k.URI.revive(d[0]),d[1]);return;case"log":return this.log(k.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${v}`)}createLogger(b,v){this.loggers.set(b.toString(),this.loggerService.createLogger(b,v))}consoleLog(b,v){let d=console.log;switch(b){case m.LogLevel.Error:d=console.error;break;case m.LogLevel.Warning:d=console.warn;break;case m.LogLevel.Info:d=console.info;break}d.call(console,...v)}log(b,v){const d=this.loggers.get(b.toString());if(!d)throw new Error("Create the logger before logging");for(const[w,I]of v)switch(w){case m.LogLevel.Trace:d.trace(I);break;case m.LogLevel.Debug:d.debug(I);break;case m.LogLevel.Info:d.info(I);break;case m.LogLevel.Warning:d.warn(I);break;case m.LogLevel.Error:d.error(I);break;case m.LogLevel.Critical:d.critical(I);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=r;class p extends m.AbstractLoggerService{constructor(b,v,d){super(b,v);this.channel=d}createConsoleMainLogger(){return new m.AdapterLogger({log:(b,v)=>{this.channel.call("consoleLog",[b,v])}})}doCreateLogger(b,v,d){return new i(this.channel,b,v,d)}}e.LoggerChannelClient=p;class i extends m.AbstractMessageLogger{constructor(b,v,d,w){super(w==null?void 0:w.always);this.channel=b,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[v,w]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,v){const d=[[b,v]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(b){this.channel.call("log",[this.file,b])}}class L extends m.LogService{constructor(b,v){super(v);this.parent=b,this._register(b.onDidChangeLogLevel(d=>v.setLevel(d)))}setLevel(b){super.setLevel(b),this.parent.setLevel(b)}}e.FollowerLogService=L}),define(X[92],J([0,1,6,24]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(p,i,L,g){try{const b=await new Promise((v,d)=>{j(["spdlog"],v,d)});return b.setAsyncMode(8192,500),b.createRotatingLoggerAsync(p,i,L,g)}catch(b){console.error(b)}return null}function y(p,i,L,g){return j.__$__nodeRequire("spdlog").createRotatingLogger(p,i,L,g)}e.createRotatingLogger=y;function P(p,i,L){switch(i){case m.LogLevel.Trace:p.trace(L);break;case m.LogLevel.Debug:p.debug(L);break;case m.LogLevel.Info:p.info(L);break;case m.LogLevel.Warning:p.warn(L);break;case m.LogLevel.Error:p.error(L);break;case m.LogLevel.Critical:p.critical(L);break;default:throw new Error("Invalid log level")}}class r extends m.AbstractMessageLogger{constructor(i,L,g,b){super();this.name=i,this.filepath=L,this.rotating=g,this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(v=>{this._logger&&this._logger.setLevel(v)}))}_createSpdLogLogger(){const i=this.rotating?6:1,L=30/i*D.ByteSize.MB;return k(this.name,this.filepath,L,i).then(g=>{if(g){this._logger=g,this._logger.setLevel(this.getLevel());for(const{level:b,message:v}of this.buffer)P(this._logger,b,v);this.buffer=[]}})}log(i,L){this._logger?P(this._logger,i,L):this.getLevel()<=i&&this.buffer.push({level:i,message:L})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=r}),define(X[174],J([0,1,6,15,10,172,92,24,28]),function(j,e,m,D,k,y,P,r,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let i=class extends m.AbstractLoggerService{constructor(g,b){super(g.getLevel(),g.onDidChangeLogLevel);this.fileService=b}doCreateLogger(g,b,v){var d;if(g.scheme===k.Schemas.file){const w=new P.SpdLogLogger((v==null?void 0:v.name)||(0,p.generateUuid)(),g.fsPath,!(v==null?void 0:v.donotRotate),b);return(v==null?void 0:v.donotUseFormatters)&&w.clearFormatters(),w}else return new y.FileLogger((d=v==null?void 0:v.name)!==null&&d!==void 0?d:(0,D.basename)(g),g,b,this.fileService)}};i=ce([ee(0,m.ILogService),ee(1,r.IFileService)],i),e.LoggerService=i}),define(X[175],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function m(P){return P.submenu!==void 0}e.isMenubarMenuItemSubmenu=m;function D(P){return P.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=D;function k(P){return P.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function y(P){return!m(P)&&!D(P)&&!k(P)}e.isMenubarMenuItemAction=y}),define(X[47],J([0,1,10,3,32,15]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof D.globals.vscode!="undefined"){const r=D.globals.vscode.context.configuration();if(r)P=r.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(j==null?void 0:j.__$__nodeRequire)=="function"){const r=(0,y.dirname)(m.FileAccess.asFileUri("",j));P=j.__$__nodeRequire((0,y.joinPath)(r,"product.json").fsPath);const p=j.__$__nodeRequire((0,y.joinPath)(r,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:p.version})}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.56.0-dev",nameShort:D.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:D.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=P}),define(X[93],J([0,1,138,23,24,17,47]),function(j,e,m,D,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function r(g,b,v,d,w,I){let E;try{await p(g,b,v,d,w,I)}catch(o){E=o}finally{E&&w.errorTransformer&&(E=w.errorTransformer(E)),typeof E!="undefined"&&v.error(E),v.end()}}e.readFileIntoStream=r;async function p(g,b,v,d,w,I){i(I);const E=await g.open(b,{create:!1});try{i(I);let o=0,c=0,a=w&&typeof w.length=="number"?w.length:void 0,h=D.VSBuffer.alloc(Math.min(w.bufferSize,typeof a=="number"?a:w.bufferSize)),t=w&&typeof w.position=="number"?w.position:0,n=0;do c=await g.read(E,t,h.buffer,n,h.byteLength-n),t+=c,n+=c,o+=c,typeof a=="number"&&(a-=c),n===h.byteLength&&(await v.write(d(h)),h=D.VSBuffer.alloc(Math.min(w.bufferSize,typeof a=="number"?a:w.bufferSize)),n=0);while(c>0&&(typeof a!="number"||a>0)&&i(I)&&L(o,w));if(n>0){let s=n;typeof a=="number"&&(s=Math.min(n,a)),v.write(d(h.slice(0,s)))}}catch(o){throw(0,k.ensureFileSystemProviderError)(o)}finally{await g.close(E)}}function i(g){if(g.isCancellationRequested)throw(0,y.canceled)();return!0}function L(g,b){if(b==null?void 0:b.limits){if(typeof b.limits.memory=="number"&&g>b.limits.memory)throw(0,k.createFileSystemProviderError)((0,m.localize)(0,null,P.default.nameShort),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&g>b.limits.size)throw(0,k.createFileSystemProviderError)((0,m.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(X[176],J([0,1,136,71,2,24,5,15,36,35,6,23,63,9,25,10,93,62]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let o=class extends k.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new P.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new P.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new P.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new P.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new P.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new v.ResourceQueue)}registerProvider(a,h){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,D.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,h),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:h});const t=new k.DisposableStore;return t.add(h.onDidChangeFile(n=>this._onDidFilesChange.fire(new y.FileChangesEvent(n,!this.isPathCaseSensitive(h))))),t.add(h.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:h,scheme:a}))),typeof h.onDidErrorOccur=="function"&&t.add(h.onDidErrorOccur(n=>this._onError.fire(new Error(n)))),(0,k.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:h}),this.provider.delete(a),(0,k.dispose)(t)})}async activateProvider(a){const h=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(t){h.push(t)}}),!this.provider.has(a)&&await v.Promises.settled(h)}canHandleResource(a){return this.provider.has(a.scheme)}hasCapability(a,h){const t=this.provider.get(a.scheme);return!!(t&&t.capabilities&h)}listCapabilities(){return E.Iterable.map(this.provider,([a,h])=>({scheme:a,capabilities:h.capabilities}))}async withProvider(a){if(!(0,r.isAbsolutePath)(a))throw new y.FileOperationError((0,m.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const h=this.provider.get(a.scheme);if(!h){const t=new Error;throw t.name="ENOPRO",t.message=(0,m.localize)(1,null,a.toString()),t}return h}async withReadProvider(a){const h=await this.withProvider(a);if((0,y.hasOpenReadWriteCloseCapability)(h)||(0,y.hasReadWriteCapability)(h)||(0,y.hasFileReadStreamCapability)(h))return h;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const h=await this.withProvider(a);if((0,y.hasOpenReadWriteCloseCapability)(h)||(0,y.hasReadWriteCapability)(h))return h;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,h){try{return await this.doResolveFile(a,h)}catch(t){throw(0,y.toFileSystemProviderErrorCode)(t)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,m.localize)(2,null,this.resourceForError(a)),1):(0,y.ensureFileSystemProviderError)(t)}}async doResolveFile(a,h){const t=await this.withProvider(a),n=this.isPathCaseSensitive(t),s=h==null?void 0:h.resolveTo,l=h==null?void 0:h.resolveSingleChildDescendants,u=h==null?void 0:h.resolveMetadata,f=await t.stat(a);let S;return this.toFileStat(t,a,f,void 0,!!u,(A,T)=>(S||(S=p.TernarySearchTree.forUris(()=>!n),S.set(a,!0),(0,i.isNonEmptyArray)(s)&&s.forEach(U=>S.set(U,!0))),Boolean(S.findSuperstr(A.resource)||S.get(A.resource))?!0:A.isDirectory&&l?T===1:!1))}async toFileStat(a,h,t,n,s,l){const{providerExtUri:u}=this.getExtUri(a),f={resource:h,name:u.basename(h),isFile:(t.type&y.FileType.File)!=0,isDirectory:(t.type&y.FileType.Directory)!=0,isSymbolicLink:(t.type&y.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,y.etag)({mtime:t.mtime,size:t.size})};if(f.isDirectory&&l(f,n)){try{const S=await a.readdir(h),A=await v.Promises.settled(S.map(async([T,U])=>{try{const H=u.joinPath(h,T),Q=s?await a.stat(H):{type:U};return await this.toFileStat(a,H,Q,S.length,s,l)}catch(H){return this.logService.trace(H),null}}));f.children=(0,i.coalesce)(A)}catch(S){this.logService.trace(S),f.children=[]}return f}return f}async resolveAll(a){return v.Promises.settled(a.map(async h=>{try{return{stat:await this.doResolveFile(h.resource,h.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(a){const h=await this.withProvider(a);try{return!!await h.stat(a)}catch(t){return!1}}async canCreateFile(a,h){try{await this.doValidateCreateFile(a,h)}catch(t){return t}return!0}async doValidateCreateFile(a,h){if(!(h==null?void 0:h.overwrite)&&await this.exists(a))throw new y.FileOperationError((0,m.localize)(3,null,this.resourceForError(a)),3,h)}async createFile(a,h=g.VSBuffer.fromString(""),t){await this.doValidateCreateFile(a,t);const n=await this.writeFile(a,h);return this._onDidRunOperation.fire(new y.FileOperationEvent(a,0,n)),n}async writeFile(a,h,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:s}=this.getExtUri(n);try{await this.validateWriteFile(n,a,t)||await this.mkdirp(n,s.dirname(a));let u;if((0,y.hasReadWriteCapability)(n)&&!(h instanceof g.VSBuffer))if((0,b.isReadableStream)(h)){const f=await(0,b.peekStream)(h,3);f.ended?u=g.VSBuffer.concat(f.buffer):u=f}else u=(0,b.peekReadable)(h,f=>g.VSBuffer.concat(f),3);else u=h;!(0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n)&&u instanceof g.VSBuffer?await this.doWriteUnbuffered(n,a,t,u):await this.doWriteBuffered(n,a,t,u instanceof g.VSBuffer?(0,g.bufferToReadable)(u):u)}catch(l){throw new y.FileOperationError((0,m.localize)(4,null,this.resourceForError(a),(0,y.ensureFileSystemProviderError)(l).toString()),(0,y.toFileOperationResult)(l),t)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,h,t){if(!!(t==null?void 0:t.unlock)&&!(a.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(h)));let s;try{s=await a.stat(h)}catch(l){return}if((s.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,m.localize)(6,null,this.resourceForError(h)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==y.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==(0,y.etag)({mtime:t.mtime,size:s.size}))throw new y.FileOperationError((0,m.localize)(7,null),3,t);return s}async readFile(a,h){const t=await this.withReadProvider(a);return(h==null?void 0:h.atomic)?this.doReadFileAtomic(t,a,h):this.doReadFile(t,a,h)}async doReadFileAtomic(a,h,t){return new Promise((n,s)=>{this.writeQueue.queueFor(h,this.getExtUri(a).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(a,h,t);n(l)}catch(l){s(l)}})})}async doReadFile(a,h,t){const n=await this.doReadFileStream(a,h,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},n),{value:await(0,g.streamToBuffer)(n.value)})}async readFileStream(a,h){const t=await this.withReadProvider(a);return this.doReadFileStream(t,a,h)}async doReadFileStream(a,h,t){const n=new d.CancellationTokenSource,s=this.validateReadFile(h,t).then(u=>u,u=>{throw n.cancel(),u});let l;try{t&&typeof t.etag=="string"&&t.etag!==y.ETAG_DISABLED&&await s,!((0,y.hasOpenReadWriteCloseCapability)(a)||(0,y.hasFileReadStreamCapability)(a))||(0,y.hasReadWriteCapability)(a)&&(t==null?void 0:t.preferUnbuffered)?l=this.readFileUnbuffered(a,h,t):(0,y.hasFileReadStreamCapability)(a)?l=this.readFileStreamed(a,h,n.token,t):l=this.readFileBuffered(a,h,n.token,t);const u=await s;return Object.assign(Object.assign({},u),{value:l})}catch(u){throw l&&await(0,b.consumeStream)(l),new y.FileOperationError((0,m.localize)(8,null,this.resourceForError(h),(0,y.ensureFileSystemProviderError)(u).toString()),(0,y.toFileOperationResult)(u),t)}}readFileStreamed(a,h,t,n=Object.create(null)){const s=a.readFileStream(h,n,t);return(0,b.transform)(s,{data:l=>l instanceof g.VSBuffer?l:g.VSBuffer.wrap(l),error:l=>new y.FileOperationError((0,m.localize)(9,null,this.resourceForError(h),(0,y.ensureFileSystemProviderError)(l).toString()),(0,y.toFileOperationResult)(l),n)},l=>g.VSBuffer.concat(l))}readFileBuffered(a,h,t,n=Object.create(null)){const s=(0,g.newWriteableBufferStream)();return(0,I.readFileIntoStream)(a,h,s,l=>l,Object.assign(Object.assign({},n),{bufferSize:this.BUFFER_SIZE,errorTransformer:l=>new y.FileOperationError((0,m.localize)(10,null,this.resourceForError(h),(0,y.ensureFileSystemProviderError)(l).toString()),(0,y.toFileOperationResult)(l),n)}),t),s}readFileUnbuffered(a,h,t){const n=(0,b.newWriteableStream)(s=>g.VSBuffer.concat(s));return(async()=>{try{let s=await a.readFile(h);t&&typeof t.position=="number"&&(s=s.slice(t.position)),t&&typeof t.length=="number"&&(s=s.slice(0,t.length)),this.validateReadFileLimits(h,s.byteLength,t),n.end(g.VSBuffer.wrap(s))}catch(s){n.error(s),n.end()}})(),n}async validateReadFile(a,h){const t=await this.resolve(a,{resolveMetadata:!0});if(t.isDirectory)throw new y.FileOperationError((0,m.localize)(11,null,this.resourceForError(a)),0,h);if(h&&typeof h.etag=="string"&&h.etag!==y.ETAG_DISABLED&&h.etag===t.etag)throw new y.FileOperationError((0,m.localize)(12,null),2,h);return this.validateReadFileLimits(a,t.size,h),t}validateReadFileLimits(a,h,t){if(t==null?void 0:t.limits){let n;if(typeof t.limits.memory=="number"&&h>t.limits.memory&&(n=9),typeof t.limits.size=="number"&&h>t.limits.size&&(n=7),typeof n=="number")throw new y.FileOperationError((0,m.localize)(13,null,this.resourceForError(a)),n)}}async canMove(a,h,t){return this.doCanMoveCopy(a,h,"move",t)}async canCopy(a,h,t){return this.doCanMoveCopy(a,h,"copy",t)}async doCanMoveCopy(a,h,t,n){if(a.toString()!==h.toString())try{const s=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h);await this.doValidateMoveCopy(s,a,l,h,t,n)}catch(s){return s}return!0}async move(a,h,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h),l=await this.doMoveCopy(n,a,s,h,"move",!!t),u=await this.resolve(h,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(a,l==="move"?2:3,u)),u}async copy(a,h,t){const n=await this.withReadProvider(a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h),l=await this.doMoveCopy(n,a,s,h,"copy",!!t),u=await this.resolve(h,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(a,l==="copy"?3:2,u)),u}async doMoveCopy(a,h,t,n,s,l){if(h.toString()===n.toString())return s;const{exists:u,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(a,h,t,n,s,l);if(u&&!f&&l&&await this.del(n,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n)),s==="copy"){if(a===t&&(0,y.hasFileFolderCopyCapability)(a))await a.copy(h,n,{overwrite:l});else{const S=await this.resolve(h);S.isDirectory?await this.doCopyFolder(a,S,t,n):await this.doCopyFile(a,h,t,n)}return s}else return a===t?(await a.rename(h,n,{overwrite:l}),s):(await this.doMoveCopy(a,h,t,n,"copy",l),await this.del(h,{recursive:!0}),"copy")}async doCopyFile(a,h,t,n){if((0,y.hasOpenReadWriteCloseCapability)(a)&&(0,y.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(a,h,t,n);if((0,y.hasOpenReadWriteCloseCapability)(a)&&(0,y.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(a,h,t,n);if((0,y.hasReadWriteCapability)(a)&&(0,y.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(a,h,t,n);if((0,y.hasReadWriteCapability)(a)&&(0,y.hasReadWriteCapability)(t))return this.doPipeUnbuffered(a,h,t,n)}async doCopyFolder(a,h,t,n){await t.mkdir(n),Array.isArray(h.children)&&await v.Promises.settled(h.children.map(async s=>{const l=this.getExtUri(t).providerExtUri.joinPath(n,s.name);return s.isDirectory?this.doCopyFolder(a,await this.resolve(s.resource),t,l):this.doCopyFile(a,s.resource,t,l)}))}async doValidateMoveCopy(a,h,t,n,s,l){let u=!1;if(a===t){const{providerExtUri:S,isPathCaseSensitive:A}=this.getExtUri(a);if(A||(u=S.isEqual(h,n)),u&&s==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(h),this.resourceForError(n)));if(!u&&S.isEqualOrParent(n,h))throw new Error((0,m.localize)(15,null,this.resourceForError(h),this.resourceForError(n)))}const f=await this.exists(n);if(f&&!u){if(!l)throw new y.FileOperationError((0,m.localize)(16,null,this.resourceForError(h),this.resourceForError(n)),4);if(a===t){const{providerExtUri:S}=this.getExtUri(a);if(S.isEqualOrParent(h,n))throw new Error((0,m.localize)(17,null,this.resourceForError(h),this.resourceForError(n)))}}return{exists:f,isSameResourceWithDifferentPathCase:u}}getExtUri(a){const h=this.isPathCaseSensitive(a);return{providerExtUri:h?r.extUri:r.extUriIgnorePathCase,isPathCaseSensitive:h}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const h=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(h,a);const t=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(a,0,t)),t}async mkdirp(a,h){const t=[],{providerExtUri:n}=this.getExtUri(a);for(;!n.isEqual(h,n.dirname(h));)try{if(((await a.stat(h)).type&y.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(h)));break}catch(s){if((0,y.toFileSystemProviderErrorCode)(s)!==y.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(n.basename(h)),h=n.dirname(h)}for(let s=t.length-1;s>=0;s--){h=n.joinPath(h,t[s]);try{await a.mkdir(h)}catch(l){if((0,y.toFileSystemProviderErrorCode)(l)!==y.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(a,h){try{await this.doValidateDelete(a,h)}catch(t){return t}return!0}async doValidateDelete(a,h){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!(h==null?void 0:h.useTrash)&&!(t.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(a)));const s=await this.exists(a);if(!s)throw new y.FileOperationError((0,m.localize)(20,null,this.resourceForError(a)),1);if(!!!(h==null?void 0:h.recursive)&&s){const u=await this.resolve(a);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(a)))}return t}async del(a,h){const t=await this.doValidateDelete(a,h),n=!!(h==null?void 0:h.useTrash),s=!!(h==null?void 0:h.recursive);await t.delete(a,{recursive:s,useTrash:n}),this._onDidRunOperation.fire(new y.FileOperationEvent(a,1))}watch(a,h={recursive:!1,excludes:[]}){let t=!1,n=()=>{t=!0};return this.doWatch(a,h).then(s=>{t?(0,k.dispose)(s):n=()=>(0,k.dispose)(s)},s=>this.logService.error(s)),(0,k.toDisposable)(()=>n())}async doWatch(a,h){const t=await this.withProvider(a),n=this.toWatchKey(t,a,h),s=this.activeWatchers.get(n)||{count:0,disposable:t.watch(a,h)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,s),s.count+=1,(0,k.toDisposable)(()=>{s.count--,s.count===0&&((0,k.dispose)(s.disposable),this.activeWatchers.delete(n))})}toWatchKey(a,h,t){const{providerExtUri:n}=this.getExtUri(a);return[n.getComparisonKey(h),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(a=>(0,k.dispose)(a.disposable)),this.activeWatchers.clear()}async doWriteBuffered(a,h,t,n){return this.writeQueue.queueFor(h,this.getExtUri(a).providerExtUri).queue(async()=>{var s;const l=await a.open(h,{create:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1});try{(0,b.isReadableStream)(n)||(0,b.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(a,l,n):await this.doWriteReadableBufferedQueued(a,l,n)}catch(u){throw(0,y.ensureFileSystemProviderError)(u)}finally{await a.close(l)}})}async doWriteStreamBufferedQueued(a,h,t){let n=0,s;if((0,b.isReadableBufferedStream)(t)){if(t.buffer.length>0){const l=g.VSBuffer.concat(t.buffer);await this.doWriteBuffer(a,h,l,l.byteLength,n,0),n+=l.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise(async(l,u)=>{(0,b.listenStream)(s,{onData:async f=>{s.pause();try{await this.doWriteBuffer(a,h,f,f.byteLength,n,0)}catch(S){return u(S)}n+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>u(f),onEnd:()=>l()})})}async doWriteReadableBufferedQueued(a,h,t){let n=0,s;for(;(s=t.read())!==null;)await this.doWriteBuffer(a,h,s,s.byteLength,n,0),n+=s.byteLength}async doWriteBuffer(a,h,t,n,s,l){let u=0;for(;u<n;)u+=await a.write(h,s+u,t.buffer,l+u,n-u)}async doWriteUnbuffered(a,h,t,n){return this.writeQueue.queueFor(h,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,h,t,n))}async doWriteUnbufferedQueued(a,h,t,n){var s;let l;n instanceof g.VSBuffer?l=n:(0,b.isReadableStream)(n)?l=await(0,g.streamToBuffer)(n):(0,b.isReadableBufferedStream)(n)?l=await(0,g.bufferedStreamToBuffer)(n):l=(0,g.readableToBuffer)(n),await a.writeFile(h,l.buffer,{create:!0,overwrite:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1})}async doPipeBuffered(a,h,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,h,t,n))}async doPipeBufferedQueued(a,h,t,n){let s,l;try{s=await a.open(h,{create:!1}),l=await t.open(n,{create:!0,unlock:!1});const u=g.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,S=0,A=0;do A=await a.read(s,f,u.buffer,S,u.byteLength-S),await this.doWriteBuffer(t,l,u,A,f,S),f+=A,S+=A,S===u.byteLength&&(S=0);while(A>0)}catch(u){throw(0,y.ensureFileSystemProviderError)(u)}finally{await v.Promises.settled([typeof s=="number"?a.close(s):Promise.resolve(),typeof l=="number"?t.close(l):Promise.resolve()])}}async doPipeUnbuffered(a,h,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,h,t,n))}async doPipeUnbufferedQueued(a,h,t,n){return t.writeFile(n,await a.readFile(h),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,h,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,h,t,n))}async doPipeUnbufferedToBufferedQueued(a,h,t,n){const s=await t.open(n,{create:!0,unlock:!1});try{const l=await a.readFile(h);await this.doWriteBuffer(t,s,g.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw(0,y.ensureFileSystemProviderError)(l)}finally{await t.close(s)}}async doPipeBufferedToUnbuffered(a,h,t,n){const s=await(0,g.streamToBuffer)(this.readFileBuffered(a,h,d.CancellationToken.None));await this.doWriteUnbuffered(t,n,void 0,s)}throwIfFileSystemIsReadonly(a,h){if(a.capabilities&2048)throw new y.FileOperationError((0,m.localize)(22,null,this.resourceForError(h)),6);return a}resourceForError(a){return a.scheme===w.Schemas.file?a.fsPath:a.toString(!0)}};o=ce([ee(0,L.ILogService)],o),e.FileService=o}),define(X[177],J([0,1,18,112,2,24,5,3,19,8,15,30,9,6,139,90,159,161,158,167,63,93,35,23]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w,I,E,o,c,a,h,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class s extends k.Disposable{constructor(u,f){var S;super();this.logService=u,this.options=f,this.BUFFER_SIZE=((S=this.options)===null||S===void 0?void 0:S.bufferSize)||64*1024,this.onDidChangeCapabilities=P.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new P.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new b.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,r.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(u){try{const{stat:f,symbolicLink:S}=await p.SymlinkSupport.stat(this.toFilePath(u));return{type:this.toType(f,S),ctime:f.birthtime.getTime(),mtime:f.mtime.getTime(),size:f.size}}catch(f){throw this.toFileSystemProviderError(f)}}async readdir(u){try{const f=await(0,p.readdir)(this.toFilePath(u),{withFileTypes:!0}),S=[];return await Promise.all(f.map(async A=>{try{let T;A.isSymbolicLink()?T=(await this.stat((0,L.joinPath)(u,A.name))).type:T=this.toType(A),S.push([A.name,T])}catch(T){this.logService.trace(T)}})),S}catch(f){throw this.toFileSystemProviderError(f)}}toType(u,f){let S;return(f==null?void 0:f.dangling)?S=y.FileType.Unknown:u.isFile()?S=y.FileType.File:u.isDirectory()?S=y.FileType.Directory:S=y.FileType.Unknown,f&&(S|=y.FileType.SymbolicLink),S}async readFile(u){try{const f=this.toFilePath(u);return await m.promises.readFile(f)}catch(f){throw this.toFileSystemProviderError(f)}}readFileStream(u,f,S){const A=(0,a.newWriteableStream)(T=>n.VSBuffer.concat(T.map(U=>n.VSBuffer.wrap(U))).buffer);return(0,h.readFileIntoStream)(this,u,A,T=>T.buffer,Object.assign(Object.assign({},f),{bufferSize:this.BUFFER_SIZE}),S),A}async writeFile(u,f,S){let A;try{const T=this.toFilePath(u);if(!S.create||!S.overwrite){if(await(0,p.exists)(T)){if(!S.overwrite)throw(0,y.createFileSystemProviderError)((0,d.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!S.create)throw(0,y.createFileSystemProviderError)((0,d.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}A=await this.open(u,{create:!0,unlock:S.unlock}),await this.write(A,0,f,0,f.byteLength)}catch(T){throw await this.toFileSystemProviderWriteError(u,T)}finally{typeof A=="number"&&await this.close(A)}}async open(u,f){try{const S=this.toFilePath(u);if((0,y.isFileOpenForWriteOptions)(f)&&f.unlock)try{const{stat:U}=await p.SymlinkSupport.stat(S);U.mode&128||await m.promises.chmod(S,U.mode|128)}catch(U){this.logService.trace(U)}let A;if((0,y.isFileOpenForWriteOptions)(f)){if(r.isWindows)try{await m.promises.truncate(S,0),A="r+"}catch(U){U.code!=="ENOENT"&&this.logService.trace(U)}A||(A="w")}else A="r";const T=await(0,D.promisify)(m.open)(S,A);return this.mapHandleToPos.set(T,0),(0,y.isFileOpenForWriteOptions)(f)&&this.writeHandles.set(T,u),T}catch(S){throw(0,y.isFileOpenForWriteOptions)(f)?await this.toFileSystemProviderWriteError(u,S):this.toFileSystemProviderError(S)}}async close(u){try{if(this.mapHandleToPos.delete(u),this.writeHandles.delete(u)&&this.canFlush)try{await(0,D.promisify)(m.fdatasync)(u)}catch(f){this.canFlush=!1,this.logService.error(f)}return await(0,D.promisify)(m.close)(u)}catch(f){throw this.toFileSystemProviderError(f)}}async read(u,f,S,A,T){const U=this.normalizePos(u,f);let H=null;try{const Q=await(0,D.promisify)(m.read)(u,S,A,T,U);return typeof Q=="number"?H=Q:H=Q.bytesRead,H}catch(Q){throw this.toFileSystemProviderError(Q)}finally{this.updatePos(u,U,H)}}normalizePos(u,f){return f===this.mapHandleToPos.get(u)?null:f}updatePos(u,f,S){const A=this.mapHandleToPos.get(u);typeof A=="number"&&(typeof f=="number"||(typeof S=="number"?this.mapHandleToPos.set(u,A+S):this.mapHandleToPos.delete(u)))}async write(u,f,S,A,T){return(0,b.retry)(()=>this.doWrite(u,f,S,A,T),100,3)}async doWrite(u,f,S,A,T){const U=this.normalizePos(u,f);let H=null;try{const Q=await(0,D.promisify)(m.write)(u,S,A,T,U);return typeof Q=="number"?H=Q:H=Q.bytesWritten,H}catch(Q){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(u),Q)}finally{this.updatePos(u,U,H)}}async mkdir(u){try{await m.promises.mkdir(this.toFilePath(u))}catch(f){throw this.toFileSystemProviderError(f)}}async delete(u,f){try{const S=this.toFilePath(u);await this.doDelete(S,f)}catch(S){throw this.toFileSystemProviderError(S)}}async doDelete(u,f){f.recursive?await(0,p.rimraf)(u,p.RimRafMode.MOVE):await m.promises.unlink(u)}async rename(u,f,S){const A=this.toFilePath(u),T=this.toFilePath(f);if(A!==T)try{await this.validateTargetDeleted(u,f,"move",S.overwrite),await(0,p.move)(A,T)}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,d.localize)(2,null,(0,i.basename)(A),(0,i.basename)((0,i.dirname)(T)),U.toString()))),this.toFileSystemProviderError(U)}}async copy(u,f,S){const A=this.toFilePath(u),T=this.toFilePath(f);if(A!==T)try{await this.validateTargetDeleted(u,f,"copy",S.overwrite),await(0,p.copy)(A,T,{preserveSymlinks:!0})}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,d.localize)(3,null,(0,i.basename)(A),(0,i.basename)((0,i.dirname)(T)),U.toString()))),this.toFileSystemProviderError(U)}}async validateTargetDeleted(u,f,S,A){const T=this.toFilePath(u),U=this.toFilePath(f);let H=!1;if(!!(this.capabilities&1024)||(H=(0,g.isEqual)(T,U,!0)),H&&S==="copy")throw(0,y.createFileSystemProviderError)((0,d.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!H&&await(0,p.exists)(U)){if(!A)throw(0,y.createFileSystemProviderError)((0,d.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(f,{recursive:!0,useTrash:!1})}}watch(u,f){return f.recursive?this.watchRecursive(u,f.excludes):this.watchNonRecursive(u)}watchRecursive(u,f){const S={path:this.toFilePath(u),excludes:f},A=(0,t.insert)(this.recursiveFoldersToWatch,S);return this.refreshRecursiveWatchers(),(0,k.toDisposable)(()=>{A(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var u,f,S;if(this.recursiveWatcher instanceof o.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,k.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let A,T;((f=(u=this.options)===null||u===void 0?void 0:u.watcher)===null||f===void 0?void 0:f.usePolling)?(A=I.FileWatcher,T=(S=this.options)===null||S===void 0?void 0:S.watcher):this.recursiveFoldersToWatch.length===1?r.isWindows?A=E.FileWatcher:A=I.FileWatcher:A=o.FileWatcher,this.recursiveWatcher=new A(this.recursiveFoldersToWatch,U=>this._onDidChangeFile.fire((0,w.toFileChanges)(U)),U=>{U.type==="error"&&this._onDidWatchErrorOccur.fire(U.message),this.logService[U.type](U.message)},this.logService.getLevel()===v.LogLevel.Trace,T),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))}}watchNonRecursive(u){const f=new c.FileWatcher(this.toFilePath(u),A=>this._onDidChangeFile.fire((0,w.toFileChanges)(A)),A=>{A.type==="error"&&this._onDidWatchErrorOccur.fire(A.message),this.logService[A.type](A.message)},this.logService.getLevel()===v.LogLevel.Trace),S=this.logService.onDidChangeLogLevel(()=>{f.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)});return(0,k.combinedDisposable)(f,S)}toFilePath(u){return(0,i.normalize)(u.fsPath)}toFileSystemProviderError(u){if(u instanceof y.FileSystemProviderError)return u;let f;switch(u.code){case"ENOENT":f=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":f=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":f=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":f=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":f=y.FileSystemProviderErrorCode.NoPermissions;break;default:f=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(u,f)}async toFileSystemProviderWriteError(u,f){let S=this.toFileSystemProviderError(f);if(u&&S.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:A}=await p.SymlinkSupport.stat(this.toFilePath(u));A.mode&128||(S=(0,y.createFileSystemProviderError)(f,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(A){this.logService.trace(A)}return S}dispose(){super.dispose(),(0,k.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,k.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=s}),define(X[20],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,m.createDecorator)("productService")}),define(X[178],J([0,1,58,6,20]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let y=class{constructor(r,p){this.productService=r,this.logService=p,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(r,p){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const i=/^(.*)#([^#]+)$/.exec(p);if(!i)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",p),!1;const[,L,g]=i;let b=this.trustedExtensionUrlPublicKeys.get(r);if(!b){if(b=this.productService.trustedExtensionUrlPublicKeys[r],!b||b.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",r),!1;this.trustedExtensionUrlPublicKeys.set(r,[...b])}const v=Buffer.from(decodeURIComponent(g),"base64");if(v.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",p),!1;const d=v.slice(0,6),w=v.readUIntBE(0,6),I=Date.now()-w;if(I<0||I>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",p),!1;const E=v.slice(6),o=m.createVerify("SHA256");o.write(d),o.write(Buffer.from(L)),o.end();for(let c=0;c<b.length;c++){let a=b[c];if(a!==null){if(typeof a=="string")try{a=m.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),b[c]=a}catch(h){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${r}:`,h),b[c]=null;continue}if(o.verify(a,E))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",p),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",p),!1}};y=ce([ee(0,k.IProductService),ee(1,D.ILogService)],y),e.ExtensionUrlTrustService=y}),define(X[55],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,m.createDecorator)("protocolMainService")}),define(X[179],J([0,1,2,10,7,46,13,6,36,3,15,28]),function(j,e,m,D,k,y,P,r,p,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let b=class extends m.Disposable{constructor(d,w){super();this.logService=w,this.validRoots=p.TernarySearchTree.forUris(()=>!i.isLinux),this.validExtensions=new Set([".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(k.URI.file(d.appRoot)),this.addValidFileRoot(k.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=P.session;d.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(w,I)=>this.handleResourceRequest(w,I)),d.protocol.interceptFileProtocol(D.Schemas.file,(w,I)=>this.handleFileRequest(w,I)),this._register((0,m.toDisposable)(()=>{d.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?m.Disposable.None:(this.validRoots.set(d,!0),(0,m.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,w){const I=k.URI.parse(d.url);return i.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${I.fsPath} from ${D.Schemas.file}: protocol (original URL: ${d.url})`),w({error:-3})):this.validRoots.findSubstr(I)?w({path:I.fsPath}):this.validExtensions.has((0,L.extname)(I))?w({path:I.fsPath}):(this.logService.error(`${D.Schemas.file}: Refused to load resource ${I.fsPath} from ${D.Schemas.file}: protocol (original URL: ${d.url})`),w({error:-3}))}handleResourceRequest(d,w){const I=k.URI.parse(d.url),E=D.FileAccess.asFileUri(I);return this.validRoots.findSubstr(E)?w({path:E.fsPath}):this.validExtensions.has((0,L.extname)(E))?w({path:E.fsPath}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${E.fsPath} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),w({error:-3}))}createIPCObjectUrl(d){const w=k.URI.from({scheme:"vscode",path:(0,g.generateUuid)()}),I=w.toString(),E=async()=>d;return P.ipcMain.handle(I,E),this.logService.trace(`IPC Object URL: Registered new channel ${I}.`),{resource:w,update:o=>d=o,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${I}.`),P.ipcMain.removeHandler(I)}}}};b=ce([ee(0,y.INativeEnvironmentService),ee(1,r.ILogService)],b),e.ProtocolMainService=b}),define(X[37],J([0,1,12,100]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(P,r){D.ok(m.isString(P)),D.ok(m.isObject(r)),D.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,r)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new k}),define(X[180],J([0,1,37,5]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(r){return r.length>0&&r.charAt(r.length-1)==="#"?r.substring(0,r.length-1):r}class y{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,i){this.schemasById[k(p)]=i,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new y;m.Registry.add(e.Extensions.JSONContribution,P)}),define(X[48],J([0,1,130,5,37,12,180]),function(j,e,m,D,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var r;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(r=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const p=k.Registry.as(P.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,o=!0){this.registerConfigurations([E],o)}registerConfigurations(E,o=!0){const c=[];E.forEach(a=>{c.push(...this.validateAndRegisterProperties(a,o,a.extensionInfo)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(E){const o=[],c=a=>{if(a.properties)for(const h in a.properties)o.push(h),delete this.configurationProperties[h],this.removeFromSchema(h,a.properties[h]);a.allOf&&a.allOf.forEach(h=>c(h))};for(const a of E){c(a);const h=this.configurationContributors.indexOf(a);h!==-1&&this.configurationContributors.splice(h,1)}p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}registerDefaultConfigurations(E){const o=[],c=[];for(const a of E)for(const h in a)if(o.push(h),e.OVERRIDE_PROPERTY_PATTERN.test(h)){this.defaultValues[h]=Object.assign(Object.assign({},this.defaultValues[h]||{}),a[h]);const t={type:"object",default:this.defaultValues[h],description:m.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId};c.push(g(h)),this.configurationProperties[h]=t,this.defaultLanguageConfigurationOverridesNode.properties[h]=t}else{this.defaultValues[h]=a[h];const t=this.configurationProperties[h];t&&(this.updatePropertyDefaultValue(h,t),this.updateSchema(h,t))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(E){const o=[];for(const c of E)for(const a in c)if(o.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const h=this.configurationProperties[a];h&&(this.updatePropertyDefaultValue(a,h),this.updateSchema(a,h))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const o of E)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,o=!0,c,a=3){var h;a=y.isUndefinedOrNull(E.scope)?a:E.scope;let t=[],n=E.properties;if(n)for(let l in n){if(o&&d(l)){delete n[l];continue}const u=n[l];if(this.updatePropertyDefaultValue(l,u),e.OVERRIDE_PROPERTY_PATTERN.test(l)?u.scope=void 0:(u.scope=y.isUndefinedOrNull(u.scope)?a:u.scope,u.requireTrust=y.isUndefinedOrNull(u.requireTrust)?!!((h=c==null?void 0:c.requireTrustForConfigurations)===null||h===void 0?void 0:h.includes(l)):u.requireTrust),n[l].hasOwnProperty("included")&&!n[l].included){this.excludedConfigurationProperties[l]=n[l],delete n[l];continue}else this.configurationProperties[l]=n[l];!n[l].deprecationMessage&&n[l].markdownDeprecationMessage&&(n[l].deprecationMessage=n[l].markdownDeprecationMessage),t.push(l)}let s=E.allOf;if(s)for(let l of s)t.push(...this.validateAndRegisterProperties(l,o,c,a));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const o=c=>{let a=c.properties;if(a)for(const t in a)this.updateSchema(t,a[t]);let h=c.allOf;h&&h.forEach(o)};o(E)}updateSchema(E,o){switch(e.allSettings.properties[E]=o,o.scope){case 1:e.applicationSettings.properties[E]=o;break;case 2:e.machineSettings.properties[E]=o;break;case 6:e.machineOverridableSettings.properties[E]=o;break;case 3:e.windowSettings.properties[E]=o;break;case 4:e.resourceSettings.properties[E]=o;break;case 5:e.resourceSettings.properties[E]=o,this.resourceLanguageSettingsSchema.properties[E]=o;break}}removeFromSchema(E,o){switch(delete e.allSettings.properties[E],o.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const o=`[${E}]`,c={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,c),e.allSettings.properties[o]=c,e.applicationSettings.properties[o]=c,e.machineSettings.properties[o]=c,e.machineOverridableSettings.properties[o]=c,e.windowSettings.properties[o]=c,e.resourceSettings.properties[o]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,o){let c=this.defaultValues[E];y.isUndefined(c)&&(c=o.default),y.isUndefined(c)&&(c=b(o.type)),o.default=c}}const L="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(L);function g(I){return I.substring(1,I.length-1)}e.overrideIdentifierFromKey=g;function b(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=b;const v=new i;k.Registry.add(e.Extensions.Configuration,v);function d(I){return I.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(I)?m.localize(5,null,I):v.getConfigurationProperties()[I]!==void 0?m.localize(6,null,I):null:m.localize(4,null)}e.validateProperty=d;function w(){const I=[],E=v.getConfigurationProperties();for(const o of Object.keys(E))I.push([o,E[o].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=w}),define(X[21],J([0,1,44,12,7,37,4,48]),function(j,e,m,D,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function p(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof k.URI)}e.isConfigurationOverrides=p;var i;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(i=e.ConfigurationTarget||(e.ConfigurationTarget={}));function L(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=L;function g(n,s){const l=s?n?s.keys.filter(H=>n.keys.indexOf(H)===-1):[...s.keys]:[],u=n?s?n.keys.filter(H=>s.keys.indexOf(H)===-1):[...n.keys]:[],f=[];if(s&&n){for(const H of n.keys)if(s.keys.indexOf(H)!==-1){const Q=E(n.contents,H),ne=E(s.contents,H);m.equals(Q,ne)||f.push(H)}}const S=[],A=H=>{const Q={};for(const ne of H)for(const ae of ne.identifiers)Q[h(ae)]=ne;return Q},T=s?A(s.overrides):{},U=n?A(n.overrides):{};if(Object.keys(T).length)for(const H of l){const Q=T[H];Q&&S.push([(0,r.overrideIdentifierFromKey)(H),Q.keys])}if(Object.keys(U).length)for(const H of u){const Q=U[H];Q&&S.push([(0,r.overrideIdentifierFromKey)(H),Q.keys])}if(Object.keys(T).length&&Object.keys(U).length)for(const H of f){const Q=U[H],ne=T[H];if(Q&&ne){const ae=g({contents:Q.contents,keys:Q.keys,overrides:[]},{contents:ne.contents,keys:ne.keys,overrides:[]});S.push([(0,r.overrideIdentifierFromKey)(H),[...ae.added,...ae.removed,...ae.updated]])}}return{added:l,removed:u,updated:f,overrides:S}}e.compare=g;function b(n,s){const l=[];for(const u of Object.keys(n))if(r.OVERRIDE_PROPERTY_PATTERN.test(u)){const f={};for(const S in n[u])f[S]=n[u][S];l.push({identifiers:[(0,r.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(f),contents:v(f,s)})}return l}e.toOverrides=b;function v(n,s){const l=Object.create(null);for(let u in n)d(l,u,n[u],s);return l}e.toValuesTree=v;function d(n,s,l,u){const f=s.split("."),S=f.pop();let A=n;for(let T=0;T<f.length;T++){let U=f[T],H=A[U];switch(typeof H){case"undefined":H=A[U]=Object.create(null);break;case"object":break;default:u(`Ignoring ${s} as ${f.slice(0,T+1).join(".")} is ${JSON.stringify(H)}`);return}A=H}if(typeof A=="object"&&A!==null)try{A[S]=l}catch(T){u(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(A)}`)}else u(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(A)}`)}e.addToValueTree=d;function w(n,s){const l=s.split(".");I(n,l)}e.removeFromValueTree=w;function I(n,s){const l=s.shift();if(s.length===0){delete n[l];return}if(Object.keys(n).indexOf(l)!==-1){const u=n[l];typeof u=="object"&&!Array.isArray(u)&&(I(u,s),Object.keys(u).length===0&&delete n[l])}}function E(n,s,l){function u(A,T){let U=A;for(const H of T){if(typeof U!="object"||U===null)return;U=U[H]}return U}const f=s.split("."),S=u(n,f);return typeof S=="undefined"?l:S}e.getConfigurationValue=E;function o(n,s,l){Object.keys(s).forEach(u=>{u!=="__proto__"&&(u in n?D.isObject(n[u])&&D.isObject(s[u])?o(n[u],s[u],l):l&&(n[u]=s[u]):n[u]=s[u])})}e.merge=o;function c(){const n=y.Registry.as(r.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=c;function a(){const n=Object.create(null),s=y.Registry.as(r.Extensions.Configuration).getConfigurationProperties();for(let l in s){let u=s[l].default;d(n,l,u,f=>console.error(`Conflict in default settings: ${f}`))}return n}e.getDefaultValues=a;function h(n){return`[${n}]`}e.keyFromOverrideIdentifier=h;function t(n,s,l){const u=n.inspect(s),f=n.inspect(l);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:u.defaultValue}e.getMigratedSettingValue=t}),define(X[181],J([0,1,43,36,35,12,44,7,48,21,37,2,5]),function(j,e,m,D,k,y,P,r,p,i,L,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(t={},n=[],s=[]){this._contents=t,this._keys=n,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const s=this.getContentsForOverrideIdentifer(n);return s?t?(0,i.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const l of k.distinct([...Object.keys(this.contents),...Object.keys(n)])){let u=this.contents[l],f=n[l];f&&(typeof u=="object"&&typeof f=="object"?(u=P.deepClone(u),this.mergeContents(u,f)):u=f),s[l]=u}return new v(s,this.keys,this.overrides)}merge(...t){const n=P.deepClone(this.contents),s=P.deepClone(this.overrides),l=[...this.keys];for(const u of t){this.mergeContents(n,u.contents);for(const f of u.overrides){const[S]=s.filter(A=>k.equals(A.identifiers,f.identifiers));S?this.mergeContents(S.contents,f.contents):s.push(P.deepClone(f))}for(const f of u.keys)l.indexOf(f)===-1&&l.push(f)}return new v(n,l,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const s of Object.keys(n)){if(s in t&&y.isObject(t[s])&&y.isObject(n[s])){this.mergeContents(t[s],n[s]);continue}t[s]=P.deepClone(n[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,i.addToValueTree)(this.contents,t,n,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let s=0;s<n;s++)t.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=v;class d extends v{constructor(){const t=(0,i.getDefaultValues)(),n=(0,i.getConfigurationKeys)(),s=[];for(const l of Object.keys(t))p.OVERRIDE_PROPERTY_PATTERN.test(l)&&s.push({identifiers:[(0,p.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(t[l]),contents:(0,i.toValuesTree)(t[l],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,n,s)}}e.DefaultConfigurationModel=d;class w{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!y.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:s,keys:l,overrides:u,untrusted:f}=this.doParseRaw(t,n);this._configurationModel=new v(s,l,u),this._untrustedConfigurations=f||[]}doParseContent(t){let n={},s=null,l=[],u=[],f=[];function S(T){Array.isArray(l)?l.push(T):s&&(l[s]=T)}let A={onObjectBegin:()=>{let T={};S(T),u.push(l),l=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{l=u.pop()},onArrayBegin:()=>{let T=[];S(T),u.push(l),l=T,s=null},onArrayEnd:()=>{l=u.pop()},onLiteralValue:S,onError:(T,U,H)=>{f.push({error:T,offset:U,length:H})}};if(t)try{m.visit(t,A),n=l[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return n}doParseRaw(t,n){const s=L.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),l=this.filter(t,s,!0,n);t=l.raw;const u=(0,i.toValuesTree)(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),f=Object.keys(t),S=(0,i.toOverrides)(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:u,keys:f,overrides:S,untrusted:l.untrusted}}filter(t,n,s,l){if(!(l==null?void 0:l.scopes)&&!(l==null?void 0:l.isUntrusted))return{raw:t,untrusted:[]};const u={},f=[];for(let S in t)if(p.OVERRIDE_PROPERTY_PATTERN.test(S)&&s){const A=this.filter(t[S],n,!1,l);u[S]=A.raw,f.push(...A.untrusted)}else{const A=n[S],T=A?typeof A.scope!="undefined"?A.scope:3:void 0;(T===void 0||l.scopes===void 0||l.scopes.includes(T))&&(l.isUntrusted&&(A==null?void 0:A.requireTrust)?f.push(S):u[S]=t[S])}return{raw:u,untrusted:f}}}e.ConfigurationModelParser=w;class I extends g.Disposable{constructor(t,n,s,l){super();this.userSettingsResource=t,this.scopes=n,this.fileService=l,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(b.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=I;class E{constructor(t,n,s=new v,l=new v,u=new D.ResourceMap,f=new v,S=new D.ResourceMap,A=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=l,this._folderConfigurations=u,this._memoryConfiguration=f,this._memoryConfigurationByResource=S,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(t,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(t)}updateValue(t,n,s={}){let l;s.resource?(l=this._memoryConfigurationByResource.get(s.resource),l||(l=new v,this._memoryConfigurationByResource.set(s.resource,l))):l=this._memoryConfiguration,n===void 0?l.removeValue(t):l.setValue(t,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,s){const l=this.getConsolidateConfigurationModel(n,s),u=this.getFolderConfigurationModelForResource(n.resource,s),f=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,S=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),A=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),T=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),U=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),H=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,Q=u?n.overrideIdentifier?u.freeze().override(n.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,ne=n.overrideIdentifier?f.override(n.overrideIdentifier).getValue(t):f.getValue(t),ae=l.getValue(t),O=k.distinct(k.flatten(l.overrides.map($=>$.identifiers))).filter($=>l.getOverrideValue(t,$)!==void 0);return{defaultValue:S,userValue:A,userLocalValue:T,userRemoteValue:U,workspaceValue:H,workspaceFolderValue:Q,memoryValue:ne,value:ae,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:H!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:Q!==void 0?{value:u==null?void 0:u.freeze().getValue(t),override:n.overrideIdentifier?u==null?void 0:u.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:ne!==void 0?{value:f.getValue(t),override:n.overrideIdentifier?f.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:O.length?O:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=n.filter(l=>p.OVERRIDE_PROPERTY_PATTERN.test(l)).map(l=>{const u=(0,p.overrideIdentifierFromKey)(l),f=this._defaultConfiguration.getKeysForOverrideIdentifier(u),S=t.getKeysForOverrideIdentifier(u),A=[...S.filter(T=>f.indexOf(T)===-1),...f.filter(T=>S.indexOf(T)===-1),...f.filter(T=>!P.equals(this._defaultConfiguration.override(u).getValue(T),t.override(u).getValue(T)))];return[u,A]});return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:l,overrides:u}=(0,i.compare)(this.localUserConfiguration,t),f=[...n,...s,...l];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:l,overrides:u}=(0,i.compare)(this.remoteUserConfiguration,t);let f=[...n,...s,...l];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:l,overrides:u}=(0,i.compare)(this.workspaceConfiguration,t);let f=[...n,...s,...l];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:u}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:l,updated:u,removed:f,overrides:S}=(0,i.compare)(s,n);let A=[...l,...u,...f];return(A.length||!s)&&this.updateFolderConfiguration(t,n),{keys:A,overrides:S}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:l,removed:u,overrides:f}=(0,i.compare)(n,void 0);return{keys:[...s,...l,...u],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let s=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const l=n.getFolder(t);l&&(s=this.getFolderConsolidatedConfiguration(l.uri)||s);const u=this._memoryConfigurationByResource.get(t);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(t);l?(n=s.merge(l),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=s}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:s,overrides:l,keys:u}=this._folderConfigurations.get(n);return t.push([n,{contents:s,overrides:l,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(l=>n.add(l))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),l=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((f,S)=>(f.set(r.URI.revive(S[0]),this.parseConfigurationModel(S[1])),f),new D.ResourceMap);return new E(n,s,new v,l,u,new v,new D.ResourceMap,!1)}static parseConfigurationModel(t){return new v(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=E;function o(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const t=new Set,n=new Map;for(const l of h)l.keys.forEach(u=>t.add(u)),l.overrides.forEach(([u,f])=>{const S=(0,D.getOrSet)(n,u,new Set);f.forEach(A=>S.add(A))});const s=[];return n.forEach((l,u)=>s.push([u,[...l.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=o;class c{constructor(t,n,s,l){this.change=t,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=l,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(S=>u.add(S)),t.overrides.forEach(([,S])=>S.forEach(A=>u.add(A))),this.affectedKeys=[...u.values()];const f=new v;this.affectedKeys.forEach(S=>f.setValue(S,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const l=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,u=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!P.equals(l,u)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let s=(0,i.toValuesTree)({[n]:!0},()=>{}),l;for(;typeof s=="object"&&(l=Object.keys(s)[0]);){if(t=t[l],!t)return!1;s=s[l]}return!0}}e.ConfigurationChangeEvent=c;class a extends c{constructor(t,n,s,l){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=s,this.sourceConfig=l}}e.AllKeysConfigurationChangeEvent=a}),define(X[182],J([0,1,37,48,2,21,181,5,9,15]),function(j,e,m,D,k,y,P,r,p,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class L extends k.Disposable{constructor(b,v){super();this.settingsResource=b,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,i.extUriBiasedIgnorePathCase,v)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(D.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const b=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,b)}getConfigurationData(){return this.configuration.toData()}getValue(b,v){const d=typeof b=="string"?b:void 0,w=(0,y.isConfigurationOverrides)(b)?b:(0,y.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(d,w,void 0)}updateValue(b,v,d,w){return Promise.reject(new Error("not supported"))}inspect(b){return this.configuration.inspect(b,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const b=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(b)}onDidChangeUserConfiguration(b){const v=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(b);this.trigger(d,v,1)}onDidDefaultConfigurationChange(b){const v=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,b);this.trigger(d,v,6)}trigger(b,v,d){const w=new P.ConfigurationChangeEvent(b,{data:v},this.configuration);w.source=d,w.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(b){switch(b){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=L}),define(X[183],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var D;(function(P){P[P.Unknown=0]="Unknown",P[P.DisableTrust=1]="DisableTrust",P[P.MachineTrusted=2]="MachineTrusted"})(D=e.RemoteTrustOption||(e.RemoteTrustOption={}));var k;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class y extends Error{constructor(r,p=k.Unknown,i){super(r);this._message=r,this._code=p,this._detail=i,this.isHandled=p===k.NotAvailable&&i===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype)}static isTemporarilyNotAvailable(r){return r instanceof y&&r._code===k.TemporarilyNotAvailable}static isNoResolverFound(r){return r instanceof y&&r._code===k.NoResolverFound}static isHandled(r){return r instanceof y&&r.isHandled}}e.RemoteAuthorityResolverError=y}),define(X[184],J([0,1,83,28,2,23,5,183,17,9,25]),function(j,e,m,D,k,y,P,r,p,i,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const g=30*1e3;var b;(function(M){M[M.Management=1]="Management",M[M.ExtensionHost=2]="ExtensionHost",M[M.Tunnel=3]="Tunnel"})(b=e.ConnectionType||(e.ConnectionType={}));function v(M){switch(M){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(M){const F=new L.CancellationTokenSource;return setTimeout(()=>F.cancel(),M),F.token}function w(M,F){if(M.isCancellationRequested||F.isCancellationRequested)return L.CancellationToken.Cancelled;const B=new L.CancellationTokenSource;return M.onCancellationRequested(()=>B.cancel()),F.onCancellationRequested(()=>B.cancel()),B.token}class I{constructor(F){this._state="pending",this._disposables=new k.DisposableStore,this.promise=new Promise((B,V)=>{this._resolvePromise=B,this._rejectPromise=V}),F.isCancellationRequested?this._timeout():this._disposables.add(F.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(F){this._state==="pending"?this._disposables.add(F):F.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(F))}reject(F){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(F))}}function E(M,F){const B=new I(F);return B.registerDisposable(M.onControlMessage(V=>{const G=JSON.parse(V.toString()),Y=q(G);Y?B.reject(Y):B.resolve(G)})),B.promise}function o(M,F,B,V,G,Y){const Z=new I(Y);return F.connect(B,V,G,(re,se)=>{Z.didTimeout?(re&&M.error(re),se==null||se.dispose()):re||!se?Z.reject(re):Z.resolve(se)}),Z.promise}function c(M,F){const B=new I(F);return M.then(V=>{B.didTimeout||B.resolve(V)},V=>{B.didTimeout||B.reject(V)}),B.promise}async function a(M,F,B,V){const G=R(M,F);M.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await o(M.logService,M.socketFactory,M.host,M.port,`reconnectionToken=${M.reconnectionToken}&reconnection=${M.reconnectionProtocol?"true":"false"}`,V)}catch(x){throw M.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),M.logService.error(x),x}M.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let Z,re;M.reconnectionProtocol?(M.reconnectionProtocol.beginAcceptReconnection(Y,null),Z=M.reconnectionProtocol,re=!1):(Z=new m.PersistentProtocol(Y,null),re=!0),M.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const se={type:"auth",auth:M.connectionToken||"00000000000000000000"};Z.sendControl(y.VSBuffer.fromString(JSON.stringify(se)));try{const x=await E(Z,w(V,d(1e4)));if(x.type!=="sign"||typeof x.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}M.logService.trace(`${G} 4/6. received SignRequest control message.`);const ie=await c(M.signService.sign(x.data),V),ue={type:"connectionType",commit:M.commit,signedData:ie,desiredConnectionType:F};return B&&(ue.args=B),M.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(y.VSBuffer.fromString(JSON.stringify(ue))),{protocol:Z,ownsProtocol:re}}catch(x){throw x&&x.code==="ETIMEDOUT"&&(M.logService.error(`${G} the handshake timed out. Error:`),M.logService.error(x)),x&&x.code==="VSCODE_CONNECTION_ERROR"&&(M.logService.error(`${G} received error control message when negotiating connection. Error:`),M.logService.error(x)),re&&C(Z),x}}async function h(M,F,B,V){const G=Date.now(),Y=R(M,F),{protocol:Z,ownsProtocol:re}=await a(M,F,B,V),se=new I(V);return se.registerDisposable(Z.onControlMessage(x=>{const ie=JSON.parse(x.toString()),ue=q(ie);ue?(M.logService.error(`${Y} received error control message when negotiating connection. Error:`),M.logService.error(ue),re&&C(Z),se.reject(ue)):(M.reconnectionProtocol&&M.reconnectionProtocol.endAcceptReconnection(),M.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${W(G)}!`),se.resolve({protocol:Z,firstMessage:ie}))})),se.promise}async function t(M,F){const{protocol:B}=await h(M,1,void 0,F);return{protocol:B}}async function n(M,F,B){const{protocol:V,firstMessage:G}=await h(M,2,F,B),Y=G&&G.debugPort;return{protocol:V,debugPort:Y}}async function s(M,F,B){const V=Date.now(),G=R(M,3),{protocol:Y}=await a(M,3,F,B);return M.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${W(V)}!`),Y}async function l(M,F,B){const{host:V,port:G,connectionToken:Y}=await M.addressProvider.getAddress();return{commit:M.commit,host:V,port:G,connectionToken:Y,reconnectionToken:F,reconnectionProtocol:B,socketFactory:M.socketFactory,signService:M.signService,logService:M.logService}}async function u(M,F,B){try{const V=(0,D.generateUuid)(),G=await l(M,V,null),{protocol:Y}=await t(G,L.CancellationToken.None);return new $(M,F,B,V,Y)}catch(V){throw M.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),M.logService.error(V),O.triggerPermanentFailure(0,0,r.RemoteAuthorityResolverError.isHandled(V)),V}}e.connectRemoteAgentManagement=u;async function f(M,F){try{const B=(0,D.generateUuid)(),V=await l(M,B,null),{protocol:G,debugPort:Y}=await n(V,F,L.CancellationToken.None);return new z(M,F,B,G,Y)}catch(B){throw M.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),M.logService.error(B),O.triggerPermanentFailure(0,0,r.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentExtensionHost=f;async function S(M,F){const B=await l(M,(0,D.generateUuid)(),null);return await s(B,{port:F},L.CancellationToken.None)}e.connectRemoteAgentTunnel=S;function A(M){return(0,i.createCancelablePromise)(F=>new Promise((B,V)=>{const G=setTimeout(B,M*1e3);F.onCancellationRequested(()=>{clearTimeout(G),B()})}))}var T;(function(M){M[M.ConnectionLost=0]="ConnectionLost",M[M.ReconnectionWait=1]="ReconnectionWait",M[M.ReconnectionRunning=2]="ReconnectionRunning",M[M.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",M[M.ConnectionGain=4]="ConnectionGain"})(T=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(F,B){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=U;class H{constructor(F,B,V,G){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.durationSeconds=V,this.cancellableTimer=G,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=H;class Q{constructor(F,B,V){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.attempt=V,this.type=2}}e.ReconnectionRunningEvent=Q;class ne{constructor(F,B,V){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.attempt=V,this.type=4}}e.ConnectionGainEvent=ne;class ae{constructor(F,B,V,G){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.attempt=V,this.handled=G,this.type=3}}e.ReconnectionPermanentFailureEvent=ae;class O extends k.Disposable{constructor(F,B,V,G){super();this._connectionType=F,this._onDidStateChange=this._register(new P.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=B,this.reconnectionToken=V,this.protocol=G,this._isReconnecting=!1,this._onDidStateChange.fire(new ne(this.reconnectionToken,0,0)),this._register(G.onSocketClose(()=>this._beginReconnecting())),this._register(G.onSocketTimeout(()=>this._beginReconnecting())),O._instances.push(this),O._permanentFailure&&this._gotoPermanentFailure(O._permanentFailureMillisSinceLastIncomingData,O._permanentFailureAttempt,O._permanentFailureHandled)}static triggerPermanentFailure(F,B,V){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=F,this._permanentFailureAttempt=B,this._permanentFailureHandled=V,this._instances.forEach(G=>G._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(!O._permanentFailure){const F=_(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30],V=Date.now();let G=-1;do{G++;const Y=G<B.length?B[G]:B[B.length-1];try{if(Y>0){const re=A(Y);this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,re)),this._options.logService.info(`${F} waiting for ${Y} seconds before reconnecting...`);try{await re}catch(se){}}if(O._permanentFailure){this._options.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this._options.logService.info(`${F} resolving connection...`);const Z=await l(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${F} connecting to ${Z.host}:${Z.port}...`),await this._reconnect(Z,d(g)),this._options.logService.info(`${F} reconnected!`),this._onDidStateChange.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(Date.now()-V>108e5){this._options.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(r.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Z)){this._options.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this._options.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((0,p.isPromiseCanceledError)(Z)){this._options.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if(Z instanceof r.RemoteAuthorityResolverError){this._options.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,r.RemoteAuthorityResolverError.isHandled(Z));break}this._options.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!O._permanentFailure)}}_gotoPermanentFailure(F,B,V){this._onDidStateChange.fire(new ae(this.reconnectionToken,F,B,V)),C(this.protocol)}}O._permanentFailure=!1,O._permanentFailureMillisSinceLastIncomingData=0,O._permanentFailureAttempt=0,O._permanentFailureHandled=!1,O._instances=[];class $ extends O{constructor(F,B,V,G,Y){super(1,F,G,Y);this.client=this._register(new m.Client(Y,{remoteAuthority:B,clientId:V},F.ipcLogger))}async _reconnect(F,B){await t(F,B)}}e.ManagementPersistentConnection=$;class z extends O{constructor(F,B,V,G,Y){super(2,F,V,G);this._startArguments=B,this.debugPort=Y}async _reconnect(F,B){await n(F,this._startArguments,B)}}e.ExtensionHostPersistentConnection=z;function C(M){try{M.acceptDisconnect();const F=M.getSocket();M.dispose(),F.dispose()}catch(F){(0,p.onUnexpectedError)(F)}}function q(M){if(M&&M.type==="error"){const F=new Error(`Connection error: ${M.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function N(M,F){for(;M.length<F;)M+=" ";return M}function _(M,F,B){return`[remote-connection][${N(v(M),13)}][${F.substr(0,5)}\u2026][${B?"reconnect":"initial"}]`}function R(M,F){return`${_(F,M.reconnectionToken,!!M.reconnectionProtocol)}[${M.host}:${M.port}]`}function W(M){return`${Date.now()-M} ms`}}),define(X[72],J([0,1,10]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function D(p){return p.scheme===m.Schemas.vscodeRemote?p.authority:void 0}e.getRemoteAuthority=D;function k(p){if(!!p){const i=p.indexOf("+");return i<0?p:p.substr(0,i)}}e.getRemoteName=k;function y(p){return p.scheme!==m.Schemas.file&&p.scheme!==m.Schemas.vscodeRemote}function P(p){if(p.folders.length)return p.folders.every(i=>y(i.uri))?p.folders[0].uri:void 0;if(p.configuration&&y(p.configuration))return p.configuration}e.getVirtualWorkspaceLocation=P;function r(p){var i;return(i=P(p))===null||i===void 0?void 0:i.scheme}e.getVirtualWorkspaceScheme=r}),define(X[73],J([0,1,5,3,4,6]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var P;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore"})(P=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function r(b){if(!(b.scheme!=="http"&&b.scheme!=="https")){const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(!!v)return{address:v[1],port:+v[2]}}}e.extractLocalHostUriMetaDataForPortMapping=r,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(b){return e.LOCALHOST_ADDRESSES.indexOf(b)>=0}e.isLocalhost=p,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(b){return e.ALL_INTERFACES_ADDRESSES.indexOf(b)>=0}e.isAllInterfaces=i;function L(b,v){return v?v!==1&&b<1024:!D.isWindows&&b<1024}e.isPortPrivileged=L;let g=class{constructor(v){this.logService=v,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}setTunnelProvider(v,d){return this._tunnelProvider=v,v?(this._canElevate=d.elevation,this._canMakePublic=d.public,{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async v=>{const d=[],w=Array.from(this._tunnels.values());for(let I of w){const E=Array.from(I.values());for(let o of E){const c=await o.value;c&&d.push(c)}}v(d)})}async dispose(){for(const v of this._tunnels.values()){for(const{value:d}of v.values())await d.then(w=>w==null?void 0:w.dispose());v.clear()}this._tunnels.clear()}openTunnel(v,d,w,I,E=!1,o=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${w} on local port ${I}.`),!!v){d||(d="localhost");const c=this.retainOrCreateTunnel(v,d,w,I,E,o);return c?c.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,w);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const h=this.makeTunnel(a);return(a.tunnelRemoteHost!==d||a.tunnelRemotePort!==w)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(h),h}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,public:v.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemotePort} `);const d=this._tunnels.get(v.tunnelRemoteHost);if(d){const w=d.get(v.tunnelRemotePort);w&&(w.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,w))}}}}async tryDisposeTunnel(v,d,w){if(w.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${d}.`);const I=w.value.then(async E=>{E&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(d),I}}async closeTunnel(v,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d} `);const w=this._tunnels.get(v);if(w&&w.has(d)){const I=w.get(d);I.refcount=0,await this.tryDisposeTunnel(v,d,I)}}addTunnelToMap(v,d,w){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(d,{refcount:1,value:w})}async removeEmptyTunnelFromMap(v,d){const w=this._tunnels.get(v);w&&(await w.get(d)||w.delete(d),w.size===0&&this._tunnels.delete(v))}getTunnelFromMap(v,d){let w=[v];p(v)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):i(v)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const I=w.map(E=>this._tunnels.get(E));for(const E of I){const o=E==null?void 0:E.get(d);if(o)return o}}canTunnel(v){return!!r(v)}createWithProvider(v,d,w,I,E,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${w} on local port ${I}.`);const a={elevationRequired:E?L(I===void 0?w:I):!1},h={remoteAddress:{host:d,port:w},localAddressPort:I,public:o},t=v.forwardPort(h,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(d,w,t),t}};g=ce([ee(0,y.ILogService)],g),e.AbstractTunnelService=g}),define(X[49],J([0,1,142,4,48,37,23]),function(j,e,m,D,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");function r(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=r;function p(d){return d.res.statusCode===204}async function i(d){if(!r(d))throw new Error("Server returned "+d.res.statusCode);return p(d)?null:(await(0,P.streamToBuffer)(d.stream)).toString()}e.asText=i;async function L(d){if(!r(d))throw new Error("Server returned "+d.res.statusCode);if(p(d))return null;const I=(await(0,P.streamToBuffer)(d.stream)).toString();try{return JSON.parse(I)}catch(E){throw E.message+=`:
`+I,E}}e.asJson=L;function g(d){v(d)}e.updateProxyConfigurationsScope=g;let b;function v(d){const w=y.Registry.as(k.Extensions.Configuration);b&&w.deregisterConfigurations([b]),b={id:"http",order:15,title:(0,m.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,m.localize)(1,null),requireTrust:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,m.localize)(2,null),requireTrust:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,m.localize)(3,null),requireTrust:!0},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[(0,m.localize)(4,null),(0,m.localize)(5,null),(0,m.localize)(6,null)],default:"override",description:(0,m.localize)(7,null),requireTrust:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,m.localize)(8,null),requireTrust:!0}}},w.registerConfiguration(b)}v(2)}),define(X[185],J([0,1,186,12]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(P,r){return P.protocol==="http:"?r.HTTP_PROXY||r.http_proxy||null:P.protocol==="https:"&&(r.HTTPS_PROXY||r.https_proxy||r.HTTP_PROXY||r.http_proxy)||null}async function y(P,r,p={}){const i=(0,m.parse)(P),L=p.proxyUrl||k(i,r);if(!L)return null;const g=(0,m.parse)(L);if(!/^https?:$/.test(g.protocol||""))return null;const b={host:g.hostname||"",port:g.port||(g.protocol==="https"?"443":"80"),auth:g.auth,rejectUnauthorized:(0,D.isBoolean)(p.strictSSL)?p.strictSSL:!0};return i.protocol==="http:"?new(await new Promise((v,d)=>{j(["http-proxy-agent"],v,d)}))(b):new(await new Promise((v,d)=>{j(["https-proxy-agent"],v,d)}))(b)}e.getProxyAgent=y}),define(X[187],J([0,1,28,23]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(y,P,r){let p=r&&r.get("storage.serviceMachineId",0)||null;if(p)return p;try{const L=(await P.readFile(y.serviceMachineIdResource)).value.toString();p=(0,m.isUUID)(L)?L:null}catch(i){p=null}if(!p){p=(0,m.generateUuid)();try{await P.writeFile(y.serviceMachineIdResource,D.VSBuffer.fromString(p))}catch(i){}}return r&&r.store("storage.serviceMachineId",p,0,1),p}e.getServiceMachineId=k}),define(X[74],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,m.createDecorator)(e.SIGN_SERVICE_ID)}),define(X[188],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{vsda(){return new Promise((k,y)=>j(["vsda"],k,y))}async sign(k){try{const y=await this.vsda(),P=new y.signer;if(P)return P.sign(k)}catch(y){}return k}}e.SignService=m}),define(X[38],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,m.createDecorator)("stateService")}),define(X[16],J([0,1,13,6,38,5,4,171,3,2,9,12,32]),function(j,e,m,D,k,y,P,r,p,i,L,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,P.createDecorator)("lifecycleMainService");var v;(function(I){I[I.CLOSE=1]="CLOSE",I[I.QUIT=2]="QUIT",I[I.RELOAD=3]="RELOAD",I[I.LOAD=4]="LOAD"})(v=e.UnloadReason||(e.UnloadReason={}));var d;(function(I){I[I.Starting=1]="Starting",I[I.Ready=2]="Ready",I[I.AfterWindowOpen=3]="AfterWindowOpen"})(d=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let w=class it extends i.Disposable{constructor(E,o){super();this.logService=E,this.stateService=o,this._onBeforeShutdown=this._register(new y.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new y.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new y.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new y.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new y.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=null,this.pendingQuitPromiseResolve=null,this.pendingWillShutdownPromise=null,this.phaseWhen=new Map,this.handleRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}handleRestarted(){this._wasRestarted=!!this.stateService.getItem(it.QUIT_FROM_RESTART_MARKER),this._wasRestarted&&this.stateService.removeItem(it.QUIT_FROM_RESTART_MARKER)}registerListeners(){const E=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),p.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};m.app.addListener("before-quit",E);const o=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!p.isMacintosh)&&m.app.quit()};m.app.addListener("window-all-closed",o),m.app.once("will-quit",c=>{this.logService.trace("Lifecycle#app.on(will-quit)"),c.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),m.app.removeListener("before-quit",E),m.app.removeListener("window-all-closed",o),m.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const E=[];return this._onWillShutdown.fire({join(o){E.push(o)}}),this.pendingWillShutdownPromise=L.Promises.settled(E).then(()=>{},o=>this.logService.error(o)),this.pendingWillShutdownPromise}set phase(E){if(E<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase!==E){this.logService.trace(`lifecycle (main): phase changed (value: ${E})`),this._phase=E;const o=this.phaseWhen.get(this._phase);o&&(o.open(),this.phaseWhen.delete(this._phase))}}async when(E){if(!(E<=this._phase)){let o=this.phaseWhen.get(E);o||(o=new L.Barrier,this.phaseWhen.set(E,o)),await o.wait()}}registerWindow(E){const o=new i.DisposableStore;this.windowCounter++,o.add(E.onWillLoad(a=>this._onWillLoadWindow.fire({window:E,workspace:a.workspace})));const c=(0,g.assertIsDefined)(E.win);c.on("close",a=>{const h=E.id;if(this.windowToCloseRequest.has(h)){this.windowToCloseRequest.delete(h);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${E.id}`),a.preventDefault(),this.unload(E,1).then(t=>{if(t){this.windowToCloseRequest.delete(h);return}this.windowToCloseRequest.add(h),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${h}`),this._onBeforeCloseWindow.fire(E),E.close()})}),c.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${E.id}`),this.windowCounter--,o.dispose(),this.windowCounter===0&&(!p.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(E,o){await this.unload(E,3)||E.reload(o)}async unload(E,o){if(!E.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${E.id}`);const c=this._quitRequested?2:o;let a=await this.onBeforeUnloadWindowInRenderer(E,c);return a?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${E.id})`),this.handleWindowUnloadVeto(a)):(a=await this.onBeforeUnloadWindowInMain(E,c),a?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${E.id})`),this.handleWindowUnloadVeto(a)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${E.id})`),await this.onWillUnloadWindowInRenderer(E,c),!1))}handleWindowUnloadVeto(E){return E?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(E){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(E),this.pendingQuitPromiseResolve=null,this.pendingQuitPromise=null)}onBeforeUnloadWindowInRenderer(E,o){return new Promise(c=>{const a=this.oneTimeListenerTokenGenerator++,h=`vscode:ok${a}`,t=`vscode:cancel${a}`;m.ipcMain.once(h,()=>{c(!1)}),m.ipcMain.once(t,()=>{c(!0)}),E.send("vscode:onBeforeUnload",{okChannel:h,cancelChannel:t,reason:o})})}onBeforeUnloadWindowInMain(E,o){const c=[];return this._onBeforeUnloadWindow.fire({reason:o,window:E,veto(a){c.push(a)}}),(0,r.handleVetos)(c,a=>this.logService.error(a))}onWillUnloadWindowInRenderer(E,o){return new Promise(c=>{const h=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;m.ipcMain.once(h,()=>c()),E.send("vscode:onWillUnload",{replyChannel:h,reason:o})})}quit(E){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - from update: ${E}`),E&&this.stateService.setItem(it.QUIT_FROM_RESTART_MARKER,!0),this.pendingQuitPromise=new Promise(o=>{this.pendingQuitPromiseResolve=o,this.logService.trace("Lifecycle#quit() - calling app.quit()"),m.app.quit()}),this.pendingQuitPromise)}relaunch(E){this.logService.trace("Lifecycle#relaunch()");const o=process.argv.slice(1);if((E==null?void 0:E.addArgs)&&o.push(...E.addArgs),E==null?void 0:E.removeArgs)for(const a of E.removeArgs){const h=o.indexOf(a);h>=0&&o.splice(h,1)}let c=!1;m.app.once("quit",()=>{if(!c){this.stateService.setItem(it.QUIT_FROM_RESTART_MARKER,!0);try{if(p.isWindows){const a=(0,b.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),m.app.relaunch({args:o})}}),this.quit().then(a=>c=a)}async kill(E){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const o of m.BrowserWindow.getAllWindows())if(o&&!o.isDestroyed()){let c;o.webContents&&!o.webContents.isDestroyed()?c=new Promise(a=>o.once("closed",a)):c=Promise.resolve(),o.destroy(),await c}})()]),m.app.exit(E)}};w.QUIT_FROM_RESTART_MARKER="quit.from.restart",w=ce([ee(0,D.ILogService),ee(1,k.IStateService)],w),e.LifecycleMainService=w}),define(X[189],J([0,1,4,5,2,16]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,m.createDecorator)("keyboardLayoutMainService");let P=class extends k.Disposable{constructor(i){super();this._onDidChangeKeyboardLayout=this._register(new D.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,i.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const i=await new Promise((L,g)=>{j(["native-keymap"],L,g)});this._keyboardLayoutData=r(i),i.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=r(i),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};P=ce([ee(0,y.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function r(p){const i=p.getKeyMap(),L=p.getCurrentKeyboardLayout();return{keyboardMapping:i,keyboardLayoutInfo:L}}}),define(X[190],J([0,1,8,18,46,19,12,6]),function(j,e,m,D,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class p{constructor(g,b){this.dbPath=g,this.onError=b,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const g=await this.loadAsync();this._database||(this._database=g)}}loadSync(){try{return this.lastFlushedSerializedDatabase=D.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(g){return g.code!=="ENOENT"&&this.onError(g),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await D.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(g){return g.code!=="ENOENT"&&this.onError(g),{}}}getItem(g,b){const v=this.database[g];return(0,P.isUndefinedOrNull)(v)?b:v}setItem(g,b){if((0,P.isUndefinedOrNull)(b))return this.removeItem(g);(typeof b=="string"||typeof b=="number"||typeof b=="boolean")&&this.database[g]===b||(this.database[g]=b,this.saveSync())}removeItem(g){(0,P.isUndefined)(this.database[g])||(this.database[g]=void 0,this.saveSync())}saveSync(){const g=JSON.stringify(this.database,null,4);if(g!==this.lastFlushedSerializedDatabase)try{(0,y.writeFileSync)(this.dbPath,g),this.lastFlushedSerializedDatabase=g}catch(b){this.onError(b)}}}e.FileStorage=p;let i=class wt{constructor(g,b){this.fileStorage=new p(m.join(g.userDataPath,wt.STATE_FILE),v=>b.error(v))}init(){return this.fileStorage.init()}getItem(g,b){return this.fileStorage.getItem(g,b)}setItem(g,b){this.fileStorage.setItem(g,b)}removeItem(g){this.fileStorage.removeItem(g)}};i.STATE_FILE="storage.json",i=ce([ee(0,k.INativeEnvironmentService),ee(1,r.ILogService)],i),e.StateService=i}),define(X[94],J([0,1,4,5,2,12,85,9]),function(j,e,m,D,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const p="__$__targetStorageMarker";e.IStorageService=(0,m.createDecorator)("storageService");var i;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(i=e.WillSaveStateReason||(e.WillSaveStateReason={}));var L;(function(w){w[w.GLOBAL=0]="GLOBAL",w[w.WORKSPACE=1]="WORKSPACE"})(L=e.StorageScope||(e.StorageScope={}));var g;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class b extends k.Disposable{constructor(I={flushInterval:b.DEFAULT_FLUSH_INTERVAL}){super();this.options=I,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new r.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,r.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(I,E){E===p?(I===0?this._globalKeyTargets=void 0:I===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:I})):this._onDidChangeValue.fire({scope:I,key:E,target:this.getKeyTargets(I)[E]})}emitWillSaveState(I){this._onWillSaveState.fire({reason:I})}get(I,E,o){var c;return(c=this.getStorage(E))===null||c===void 0?void 0:c.get(I,o)}getBoolean(I,E,o){var c;return(c=this.getStorage(E))===null||c===void 0?void 0:c.getBoolean(I,o)}getNumber(I,E,o){var c;return(c=this.getStorage(E))===null||c===void 0?void 0:c.getNumber(I,o)}store(I,E,o,c){if((0,y.isUndefinedOrNull)(E)){this.remove(I,o);return}this.withPausedEmitters(()=>{var a;this.updateKeyTarget(I,o,c),(a=this.getStorage(o))===null||a===void 0||a.set(I,E)})}remove(I,E){this.withPausedEmitters(()=>{var o;this.updateKeyTarget(I,E,void 0),(o=this.getStorage(E))===null||o===void 0||o.delete(I)})}withPausedEmitters(I){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{I()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(I,E){const o=[],c=this.getKeyTargets(I);for(const a of Object.keys(c))c[a]===E&&o.push(a);return o}updateKeyTarget(I,E,o){var c,a;const h=this.getKeyTargets(E);typeof o=="number"?h[I]!==o&&(h[I]=o,(c=this.getStorage(E))===null||c===void 0||c.set(p,JSON.stringify(h))):typeof h[I]=="number"&&(delete h[I],(a=this.getStorage(E))===null||a===void 0||a.set(p,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(I){return I===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(I){const E=this.get(p,I);if(E)try{return JSON.parse(E)}catch(o){}return Object.create(null)}isNew(I){return this.getBoolean(e.IS_NEW_KEY,I)===!0}async flush(){var I,E,o,c;this._onWillSaveState.fire({reason:i.NONE}),await r.Promises.settled([(E=(I=this.getStorage(0))===null||I===void 0?void 0:I.whenFlushed())!==null&&E!==void 0?E:Promise.resolve(),(c=(o=this.getStorage(1))===null||o===void 0?void 0:o.whenFlushed())!==null&&c!==void 0?c:Promise.resolve()])}async logStorage(){var I,E,o,c,a,h;const t=(E=(I=this.getStorage(0))===null||I===void 0?void 0:I.items)!==null&&E!==void 0?E:new Map,n=(c=(o=this.getStorage(1))===null||o===void 0?void 0:o.items)!==null&&c!==void 0?c:new Map;return d(t,n,(a=this.getLogDetails(0))!==null&&a!==void 0?a:"",(h=this.getLogDetails(1))!==null&&h!==void 0?h:"")}}e.AbstractStorageService=b,b.DEFAULT_FLUSH_INTERVAL=60*1e3;class v extends b{constructor(){super();this.globalStorage=new P.Storage(new P.InMemoryStorageDatabase),this.workspaceStorage=new P.Storage(new P.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(I=>this.emitDidChangeValue(1,I))),this._register(this.globalStorage.onDidChangeStorage(I=>this.emitDidChangeValue(0,I)))}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(I){}}e.InMemoryStorageService=v;async function d(w,I,E,o){const c=u=>{try{return JSON.parse(u)}catch(f){return u}},a=new Map,h=new Map;w.forEach((u,f)=>{a.set(f,u),h.set(f,c(u))});const t=new Map,n=new Map;I.forEach((u,f)=>{t.set(f,u),n.set(f,c(u))}),console.group(`Storage: Global (path: ${E})`);let s=[];a.forEach((u,f)=>{s.push({key:f,value:u})}),console.table(s),console.groupEnd(),console.log(h),console.group(`Storage: Workspace (path: ${o})`);let l=[];t.forEach((u,f)=>{l.push({key:f,value:u})}),console.table(l),console.groupEnd(),console.log(n)}e.logStorage=d}),define(X[191],J([0,1,3,32,28,7]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;async function P(p,i,L,g,b,v,d,w,I){const E=Object.create(null);E["common.machineId"]=v,E.sessionID=(0,k.generateUuid)()+Date.now(),E.commitHash=g,E.version=b,E["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,m.PlatformToString)(m.platform),E["common.nodePlatform"]=D.platform,E["common.nodeArch"]=L,E["common.product"]=I||"desktop";const o=r(d||[]);o&&(E["common.msftInternal"]=o);let c=0;const a=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),m.isLinuxSnap&&(E["common.snap"]="true");try{const h=await p.readFile(y.URI.file(w));E["common.source"]=h.value.toString().slice(0,30)}catch(h){}return E}e.resolveCommonProperties=P;function r(p){const i=D.env.USERDNSDOMAIN;if(!i)return!1;const L=i.toLowerCase();return p.some(g=>L===g)}}),define(X[31],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,m.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,m.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(X[192],J([0,1,27,65,68,18,8,43,82,20,3,7,31,62,10,24,19]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function E(t,n){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],l=new Map,u=new Map,f=2e4;function S(U,H,Q,ne){const ae=H.substring(U.length+1);return new Promise(async O=>{var $,z,C;let q;try{q=await(0,I.readdir)(H,{withFileTypes:!0})}catch(R){O();return}if(ne.count>=f){ne.count+=q.length,ne.maxReached=!0,O();return}let N=q.length;if(N===0){O();return}let _=q;ne.count+q.length>f&&(ne.maxReached=!0,N=f-ne.count,_=q.slice(0,N)),ne.count+=q.length;for(const R of _)if(R.isDirectory()){if(Q.includes(R.name)||await S(U,(0,P.join)(H,R.name),Q,ne),--N==0){O();return}}else{const W=R.name.lastIndexOf(".");if(W>=0){const M=R.name.substring(W+1);M&&l.set(M,(($=l.get(M))!==null&&$!==void 0?$:0)+1)}for(const M of s)((z=M.relativePathPattern)===null||z===void 0?void 0:z.test(ae))!==!1&&M.filePattern.test(R.name)&&u.set(M.tag,((C=u.get(M.tag))!==null&&C!==void 0?C:0)+1);if(--N==0){O();return}}})}const A={count:0,maxReached:!1};await S(t,t,n,A);const T=await a(t);return{configFiles:o(u),fileTypes:o(l),fileCount:A.count,maxFilesReached:A.maxReached,launchConfigFiles:T}}e.collectWorkspaceStats=E;function o(t){return[...v.Iterable.map(t.entries(),([n,s])=>({name:n,count:s}))].sort((n,s)=>s.count-n.count)}function c(){const t={os:`${m.type()} ${m.arch()} ${m.release()}`,memory:`${(m.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(D.virtualMachineHint.value()*100)}%`},n=m.cpus();return n&&n.length>0&&(t.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),t}e.getMachineInfo=c;function a(t){let n=new Map,s=(0,P.join)(t,".vscode","launch.json");return new Promise((l,u)=>{(0,y.exists)(s,f=>{if(f)(0,y.readFile)(s,(S,A)=>{if(S)return l([]);const T=[],U=(0,r.parse)(A.toString(),T);if(T.length)return console.log(`Unable to parse ${s}`),l([]);if((0,r.getNodeType)(U)==="object"&&U.configurations)for(const H of U.configurations){const Q=H.type;Q&&(n.has(Q)?n.set(Q,n.get(Q)+1):n.set(Q,1))}return l(o(n))});else return l([])})})}e.collectLaunchConfigs=a;let h=class{constructor(n,s){this.telemetryService=n,this.productService=s}formatMachineInfo(n){const s=[];return s.push(`OS Version:       ${n.os}`),s.push(`CPUs:             ${n.cpus}`),s.push(`Memory (System):  ${n.memory}`),s.push(`VM:               ${n.vmHint}`),s.join(`
`)}formatEnvironment(n){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${m.type()} ${m.arch()} ${m.release()}`);const l=m.cpus();return l&&l.length>0&&s.push(`CPUs:             ${l[0].model} (${l.length} x ${l[0].speed})`),s.push(`Memory (System):  ${(m.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`),L.isWindows||s.push(`Load (avg):       ${m.loadavg().map(u=>Math.round(u)).join(", ")}`),s.push(`VM:               ${Math.round(D.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${n.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(n,s){return Promise.all([(0,p.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async l=>{let[u,f]=l,S=this.formatProcessList(n,u);return s.forEach(A=>{if((0,k.isRemoteDiagnosticError)(A))S+=`
${A.errorMessage}`,f+=`
${A.errorMessage}`;else if(S+=`

Remote: ${A.hostName}`,A.processes&&(S+=`
${this.formatProcessList(n,A.processes)}`),A.workspaceMetadata){f+=`
|  Remote: ${A.hostName}`;for(const T of Object.keys(A.workspaceMetadata)){const U=A.workspaceMetadata[T];let H=`${U.fileCount} files`;U.maxFilesReached&&(H=`more than ${H}`),f+=`|    Folder (${T}): ${H}`,f+=this.formatWorkspaceStats(U)}}}),{processInfo:S,workspaceInfo:f}})}async getSystemInfo(n,s){const{memory:l,vmHint:u,os:f,cpus:S}=c(),A={os:f,memory:l,cpus:S,vmHint:u,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:s};return L.isWindows||(A.load=`${m.loadavg().map(T=>Math.round(T)).join(", ")}`),L.isLinux&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(n,s){const l=[];return(0,p.listProcesses)(n.mainPID).then(async u=>(l.push(""),l.push(this.formatEnvironment(n)),l.push(""),l.push(this.formatProcessList(n,u)),n.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(l.push(""),l.push("Workspace Stats: "),l.push(await this.formatWorkspaceMetadata(n))),s.forEach(f=>{if((0,k.isRemoteDiagnosticError)(f))l.push(`
${f.errorMessage}`);else if(l.push(`

`),l.push(`Remote:           ${f.hostName}`),l.push(this.formatMachineInfo(f.machineInfo)),f.processes&&l.push(this.formatProcessList(n,f.processes)),f.workspaceMetadata)for(const S of Object.keys(f.workspaceMetadata)){const A=f.workspaceMetadata[S];let T=`${A.fileCount} files`;A.maxFilesReached&&(T=`more than ${T}`),l.push(`Folder (${S}): ${T}`),l.push(this.formatWorkspaceStats(A))}}),l.push(""),l.push(""),l.join(`
`)))}formatWorkspaceStats(n){const s=[],l=60;let u=0;const f=(U,H)=>{const Q=` ${U}(${H})`;u+Q.length>l?(s.push(S),S="|                 ",u=S.length):u+=Q.length,S+=Q};let S="|      File types:";const A=10;let T=n.fileTypes.length>A?A:n.fileTypes.length;for(let U=0;U<T;U++){const H=n.fileTypes[U];f(H.name,H.count)}if(s.push(S),n.configFiles.length>=0&&(S="|      Conf files:",u=0,n.configFiles.forEach(U=>{f(U.name,U.count)}),s.push(S)),n.launchConfigFiles.length>0){let U="|      Launch Configs:";n.launchConfigFiles.forEach(H=>{U+=H.count>1?` ${H.name}(${H.count})`:` ${H.name}`}),s.push(U)}return s.join(`
`)}expandGPUFeatures(n){const s=Math.max(...Object.keys(n).map(l=>l.length));return Object.keys(n).map(l=>`${l}:  ${" ".repeat(s-l.length)}  ${n[l]}`).join(`
                  `)}formatWorkspaceMetadata(n){const s=[],l=[];return n.windows.forEach(u=>{u.folderURIs.length===0||!!u.remoteAuthority||(s.push(`|  Window (${u.title})`),u.folderURIs.forEach(f=>{const S=g.URI.revive(f);if(S.scheme===d.Schemas.file){const A=S.fsPath;l.push(E(A,["node_modules",".git"]).then(T=>{let U=`${T.fileCount} files`;T.maxFilesReached&&(U=`more than ${U}`),s.push(`|    Folder (${(0,P.basename)(A)}): ${U}`),s.push(this.formatWorkspaceStats(T))}).catch(T=>{s.push(`|      Error: Unable to collect workspace stats for folder ${A} (${T.toString()})`)}))}else s.push(`|    Folder (${S.toString()}): Workspace stats not available.`)}))}),Promise.all(l).then(u=>s.join(`
`)).catch(u=>`Unable to collect workspace stats: ${u}`)}formatProcessList(n,s){const l=new Map;n.windows.forEach(f=>l.set(f.pid,f.title));const u=[];return u.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(n.mainPID,l,u,s,0),u.join(`
`)}formatProcessItem(n,s,l,u,f){const S=f===0;let A;S?A=u.pid===n?`${this.productService.applicationName} main`:"remote agent":(A=`${"  ".repeat(f)} ${u.name}`,u.name==="window"&&(A=`${A} (${s.get(u.pid)})`));const T=process.platform==="win32"?u.mem:m.totalmem()*(u.mem/100);l.push(`${u.load.toFixed(0).padStart(5," ")}	${(T/w.ByteSize.MB).toFixed(0).padStart(6," ")}	${u.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(u.children)&&u.children.forEach(U=>this.formatProcessItem(n,s,l,U,f+1))}async reportWorkspaceStats(n){for(const{uri:s}of n.folders){const l=g.URI.revive(s);if(l.scheme===d.Schemas.file){const u=l.fsPath;try{const f=await E(u,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),f.fileTypes.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:S.name,count:S.count})}),f.launchConfigFiles.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:S.name,count:S.count})}),f.configFiles.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:S.name,count:S.count})})}catch(f){}}}}};h=ce([ee(0,b.ITelemetryService),ee(1,i.IProductService)],h),e.DiagnosticsService=h}),define(X[193],J([0,1,17,163,166,44,31,49,157,46,25,6,24,7,20,94,187,4,15]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w,I,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var c;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished"})(c||(c={}));function a(..._){return String(_.reduce((R,W)=>R|W,0))}var h;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(h||(h={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},n={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:c.None,criteria:[],assetTypes:[]};class u{constructor(R=l){this.state=R}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(R,W=this.state.pageSize){return new u(Object.assign(Object.assign({},this.state),{pageNumber:R,pageSize:W}))}withFilter(R,...W){const M=[...this.state.criteria,...W.length?W.map(F=>({filterType:R,value:F})):[{filterType:R}]];return new u(Object.assign(Object.assign({},this.state),{criteria:M}))}withSortBy(R){return new u(Object.assign(Object.assign({},this.state),{sortBy:R}))}withSortOrder(R){return new u(Object.assign(Object.assign({},this.state),{sortOrder:R}))}withFlags(...R){return new u(Object.assign(Object.assign({},this.state),{flags:R.reduce((W,M)=>W|M,0)}))}withAssetTypes(...R){return new u(Object.assign(Object.assign({},this.state),{assetTypes:R}))}get raw(){const{criteria:R,pageNumber:W,pageSize:M,sortBy:F,sortOrder:B,flags:V,assetTypes:G}=this.state;return{filters:[{criteria:R,pageNumber:W,pageSize:M,sortBy:F,sortOrder:B}],assetTypes:G,flags:V}}get searchText(){const R=this.state.criteria.filter(W=>W.filterType===h.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(R=>String(R.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function f(_,R){const W=(_||[]).filter(M=>M.statisticName===R)[0];return W?W.value:0}function S(_){const R="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(M=>M.assetType.indexOf(R)===0).reduce((M,F)=>{const B=H(_,F.assetType);return B&&M.push([F.assetType.substring(R.length),B]),M},[])}function A(_){if(_.properties){const R=_.properties.filter(F=>F.key===t.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),M=R.filter(F=>W.test(F.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return H(_,t.Repository)}function T(_){return{uri:`${_.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${_.fallbackAssetUri}/${t.VSIX}`}}function U(_){const R=H(_,t.Icon);if(R)return R;const W=D.DefaultIconPath;return{uri:W,fallbackUri:W}}function H(_,R){return _.files.filter(M=>M.assetType===R)[0]?{uri:`${_.assetUri}/${R}`,fallbackUri:`${_.fallbackAssetUri}/${R}`}:null}function Q(_,R){const W=_.properties?_.properties.filter(F=>F.key===R):[],M=W.length>0&&W[0].value;return M?M.split(",").map(F=>(0,k.adoptToGalleryExtensionId)(F)):[]}function ne(_){const R=_.properties?_.properties.filter(W=>W.key===n.Engine):[];return R.length>0&&R[0].value||""}function ae(_){const R=_.properties?_.properties.filter(M=>M.key===n.LocalizedLanguages):[],W=R.length>0&&R[0].value||"";return W?W.split(","):[]}function O(_){return _.indexOf("preview")!==-1}function $(_){const R=_.properties?_.properties.find(W=>W.key===n.WebExtension):void 0;return!!R&&R.value==="true"}function z(_){return _.files.some(R=>R.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,o.joinPath)(v.URI.parse(_.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function C(_,R,W,M,F){const B={manifest:H(R,t.Manifest),readme:H(R,t.Details),changelog:H(R,t.Changelog),license:H(R,t.License),repository:A(R),download:T(R),icon:U(R),coreTranslations:S(R)};return{identifier:{id:(0,k.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:R.version,date:R.lastUpdated,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,description:_.shortDescription||"",installCount:f(_.statistics,"install"),rating:f(_.statistics,"averagerating"),ratingCount:f(_.statistics,"ratingcount"),assetUri:v.URI.parse(R.assetUri),webResource:z(R),assetTypes:R.files.map(({assetType:V})=>V),assets:B,properties:{dependencies:Q(R,n.Dependency),extensionPack:Q(R,n.ExtensionPack),engine:ne(R),localizedLanguages:ae(R),webExtension:$(R)},telemetryData:{index:(M.pageNumber-1)*M.pageSize+W,searchText:M.searchText,querySource:F},preview:O(_.flags)}}let q=class{constructor(R,W,M,F,B,V,G){this.requestService=R,this.logService=W,this.environmentService=M,this.telemetryService=F,this.fileService=B,this.productService=V;const Y=V.extensionsGallery;this.extensionsGalleryUrl=Y&&Y.serviceUrl,this.extensionsControlUrl=Y&&Y.controlUrl,this.commonHeadersPromise=N(V.version,this.environmentService,this.fileService,G)}api(R=""){return`${this.extensionsGalleryUrl}${R}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(R,W){const M=[];let{total:F,firstPage:B,getPage:V}=await this.query({names:R,pageSize:R.length},W);M.push(...B);for(let G=1;M.length<F&&(B=await V(G,W),B.length);G++)M.push(...B);return M}async getCompatibleExtension(R,W){const M=await this.getCompatibleExtensionByEngine(R,W);return(M==null?void 0:M.properties.webExtension)?M.webResource?M:null:M}async getCompatibleExtensionByEngine(R,W){const M=(0,D.isIExtensionIdentifier)(R)?null:R;if(M&&M.properties.engine&&(0,p.isEngineValid)(M.properties.engine,this.productService.version))return M;const{id:F,uuid:B}=M?M.identifier:R;let V=new u().withFlags(c.IncludeAssetUri,c.IncludeStatistics,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1).withFilter(h.Target,"Microsoft.VisualStudio.Code");B?V=V.withFilter(h.ExtensionId,B):V=V.withFilter(h.ExtensionName,F);const{galleryExtensions:G}=await this.queryGallery(V,L.CancellationToken.None),[Y]=G;if(!Y||!Y.versions.length)return null;if(W){const re=Y.versions.filter(se=>se.version===W)[0];if(re){const se=C(Y,re,0,V);if(se.properties.engine&&(0,p.isEngineValid)(se.properties.engine,this.productService.version))return se}return null}const Z=await this.getLastValidExtensionVersion(Y,Y.versions);return Z?C(Y,Z,0,V):null}async query(R,W){const M=L.CancellationToken.isCancellationToken(R)?{}:R,F=L.CancellationToken.isCancellationToken(R)?R:W;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=M.text||"";const V=(0,y.getOrDefault)(M,x=>x.pageSize,50);let G=new u().withFlags(c.IncludeLatestVersionOnly,c.IncludeAssetUri,c.IncludeStatistics,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,V).withFilter(h.Target,"Microsoft.VisualStudio.Code");B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(x,ie,ue)=>(G=G.withFilter(h.Category,ue||ie),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(x,ie,ue)=>(G=G.withFilter(h.Tag,ue||ie),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(h.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),G=G.withFilter(h.SearchText,B)),G=G.withSortBy(0)):M.ids?G=G.withFilter(h.ExtensionId,...M.ids):M.names?G=G.withFilter(h.ExtensionName,...M.names):G=G.withSortBy(4),typeof M.sortBy=="number"&&(G=G.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(G=G.withSortOrder(M.sortOrder));const{galleryExtensions:Y,total:Z}=await this.queryGallery(G,F),re=Y.map((x,ie)=>C(x,x.versions[0],ie,G,M.source)),se=async(x,ie)=>{if(ie.isCancellationRequested)throw(0,m.canceled)();const ue=G.withPage(x+1),{galleryExtensions:ye}=await this.queryGallery(ue,ie);return ye.map((ge,Ee)=>C(ge,ge.versions[0],Ee,ue,M.source))};return{firstPage:re,total:Z,pageSize:G.pageSize,getPage:se}}async queryGallery(R,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,c.ExcludeNonValidated).withFilter(h.ExcludeWithFlags,a(c.Unpublished));const M=await this.commonHeadersPromise,F=JSON.stringify(R.raw),B=Object.assign(Object.assign({},M),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(F.length)}),V=new Date().getTime();let G,Y,Z=0;try{if(G=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:F,headers:B},W),G.res.statusCode&&G.res.statusCode>=400&&G.res.statusCode<500)return{galleryExtensions:[],total:Z};const re=await(0,r.asJson)(G);if(re){const se=re.results[0],x=se.extensions,ie=se.resultMetadata&&se.resultMetadata.filter(ue=>ue.metadataType==="ResultCount")[0];return Z=ie&&ie.metadataItems.filter(ue=>ue.name==="TotalCount")[0].count||0,{galleryExtensions:x,total:Z}}return{galleryExtensions:[],total:Z}}catch(re){throw Y=re,re}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},R.telemetryData),{requestBodySize:String(F.length),duration:new Date().getTime()-V,success:!!G&&(0,r.isSuccess)(G),responseBodySize:G==null?void 0:G.res.headers["Content-Length"],statusCode:G?String(G.res.statusCode):void 0,errorCode:Y?(0,m.isPromiseCanceledError)(Y)?"canceled":(0,m.getErrorMessage)(Y).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Z)}))}}async reportStatistic(R,W,M,F){if(!!this.isEnabled()){const B=await this.commonHeadersPromise,V=Object.assign(Object.assign({},B),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${R}/extensions/${W}/${M}/stats?statType=${F}`),headers:V},L.CancellationToken.None)}catch(G){}}}async download(R,W,M){this.logService.trace("ExtensionGalleryService#download",R.identifier.id);const F=(0,k.getGalleryExtensionTelemetryData)(R),B=new Date().getTime(),V=re=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},F),{duration:re})),G=M===1?"install":M===2?"update":"",Y=G?{uri:`${R.assets.download.uri}&${G}=true`,fallbackUri:`${R.assets.download.fallbackUri}?${G}=true`}:R.assets.download,Z=await this.getAsset(Y);await this.fileService.writeFile(W,Z.stream),V(new Date().getTime()-B)}async getReadme(R,W){if(R.assets.readme){const M=await this.getAsset(R.assets.readme,{},W);return await(0,r.asText)(M)||""}return""}async getManifest(R,W){if(R.assets.manifest){const M=await this.getAsset(R.assets.manifest,{},W),F=await(0,r.asText)(M);return F?JSON.parse(F):null}return null}async getCoreTranslation(R,W){const M=R.assets.coreTranslations.filter(F=>F[0]===W.toUpperCase())[0];if(M){const F=await this.getAsset(M[1]),B=await(0,r.asText)(F);return B?JSON.parse(B):null}return null}async getChangelog(R,W){if(R.assets.changelog){const M=await this.getAsset(R.assets.changelog,{},W);return await(0,r.asText)(M)||""}return""}async getAllVersions(R,W){let M=new u().withFlags(c.IncludeVersions,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1).withFilter(h.Target,"Microsoft.VisualStudio.Code");R.identifier.uuid?M=M.withFilter(h.ExtensionId,R.identifier.uuid):M=M.withFilter(h.ExtensionName,R.identifier.id);const F=[],{galleryExtensions:B}=await this.queryGallery(M,L.CancellationToken.None);return B.length&&(W?await Promise.all(B[0].versions.map(async V=>{let G;try{G=await this.getEngine(V)}catch(Y){}G&&(0,p.isEngineValid)(G,this.productService.version)&&F.push({version:V.version,date:V.lastUpdated})})):F.push(...B[0].versions.map(V=>({version:V.version,date:V.lastUpdated})))),F}async getAsset(R,W={},M=L.CancellationToken.None){const F=await this.commonHeadersPromise,B={type:"GET"},V=Object.assign(Object.assign({},F),W.headers||{});W=Object.assign(Object.assign(Object.assign({},W),B),{headers:V});const G=R.uri,Y=R.fallbackUri,Z=Object.assign(Object.assign({},W),{url:G});try{const re=await this.requestService.request(Z,M);if(re.res.statusCode===200)return re;const se=await(0,r.asText)(re);throw new Error(`Expected 200, got back ${re.res.statusCode} instead.

${se}`)}catch(re){if((0,m.isPromiseCanceledError)(re))throw re;const se=(0,m.getErrorMessage)(re);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:G,message:se});const x=Object.assign(Object.assign({},W),{url:Y});return this.requestService.request(x,M)}}async getLastValidExtensionVersion(R,W){const M=this.getLastValidExtensionVersionFromProperties(R,W);return M||this.getLastValidExtensionVersionRecursively(R,W)}getLastValidExtensionVersionFromProperties(R,W){for(const M of W){const F=ne(M);if(!F)return null;if((0,p.isEngineValid)(F,this.productService.version))return M}return null}async getEngine(R){const W=ne(R);if(W)return W;const M=H(R,t.Manifest);if(!M)throw new Error("Manifest was not found");const F={"Accept-Encoding":"gzip"},B=await this.getAsset(M,{headers:F}),V=await(0,r.asJson)(B);if(V)return V.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(R,W){if(!W.length)return null;const M=W[0],F=await this.getEngine(M);return(0,p.isEngineValid)(F,this.productService.version)?(M.properties=M.properties||[],M.properties.push({key:n.Engine,value:F}),M):this.getLastValidExtensionVersionRecursively(R,W.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const R=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,r.asJson)(R),M=new Map;if(W)for(const F of W.malicious){const B=M.get(F)||{id:{id:F},malicious:!0,slow:!1};B.malicious=!0,M.set(F,B)}return[...M.values()]}};q=ce([ee(0,r.IRequestService),ee(1,g.ILogService),ee(2,i.IEnvironmentService),ee(3,P.ITelemetryService),ee(4,b.IFileService),ee(5,d.IProductService),ee(6,(0,E.optional)(w.IStorageService))],q),e.ExtensionGalleryService=q;async function N(_,R,W,M){const F={"X-Market-Client-Id":`VSCode ${_}`,"User-Agent":`VSCode ${_}`},B=await(0,I.getServiceMachineId)(R,W,M);return F["X-Market-User-Id"]=B,F}e.resolveMarketplaceHeaders=N}),define(X[194],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class m{constructor(y){this.appender=y}listen(y,P){throw new Error(`Event not found: ${P}`)}call(y,P,{eventName:r,data:p}){return this.appender.log(r,p),Promise.resolve(null)}}e.TelemetryAppenderChannel=m;class D{constructor(y){this.channel=y}log(y,P){return this.channel.call("log",{eventName:y,data:P}).then(void 0,r=>`Failed to log telemetry: ${console.warn(r)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=D}),define(X[195],J([0,1,47,143,22,4,21,48,2,44,37]),function(j,e,m,D,k,y,P,r,p,i,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{constructor(d,w){this._configurationService=w,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appender=d.appender,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let I of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(I),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(I=>{const E=/^[a-f0-9]+$/i.test(I["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!E})}))}setExperimentProperty(d,w){this._experimentProperties[d]=w}setEnabled(d){this._enabled=d}_updateUserOptIn(){var d;const w=(d=this._configurationService)===null||d===void 0?void 0:d.getValue(b);this._userOptIn=w?w.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const d=await this._commonProperties;let w=d.sessionID,I=d["common.instanceId"],E=d["common.machineId"],o=d["common.firstSessionDate"],c=d["common.msftInternal"];return{sessionId:w,instanceId:I,machineId:E,firstSessionDate:o,msftInternal:c}}dispose(){this._disposables.dispose()}publicLog(d,w,I){return this.isOptedIn?this._commonProperties.then(E=>{w=(0,i.mixin)(w,E),w=(0,i.mixin)(w,this._experimentProperties),w=(0,i.cloneAndChange)(w,o=>{if(typeof o=="string")return this._cleanupInfo(o,I)}),this._appender.log(d,w)},E=>{console.error(E)}):Promise.resolve(void 0)}publicLog2(d,w,I){return this.publicLog(d,w,I)}publicLogError(d,w){return this.sendErrorTelemetry?this.publicLog(d,w,!0):Promise.resolve(void 0)}publicLogError2(d,w){return this.publicLogError(d,w)}_cleanupInfo(d,w){let I=d;if(w){const E=[];for(let h of this._cleanupPatterns)for(;;){const t=h.exec(d);if(!t)break;E.push([t.index,h.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(I="";;){const h=c.exec(d);if(!h)break;!o.test(h[0])&&E.every(([t,n])=>h.index<t||h.index>=n)&&(I+=d.substring(a,h.index)+"<REDACTED: user-file-path>",a=c.lastIndex)}a<d.length&&(I+=d.substr(a))}for(let E of this._cleanupPatterns)I=I.replace(E,"");return I}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=ce([ee(1,(0,y.optional)(P.IConfigurationService))],g),e.TelemetryService=g;const b="telemetry";L.Registry.as(r.Extensions.Configuration).registerConfiguration({id:b,order:110,type:"object",title:(0,D.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,D.localize)(2,null,m.default.privacyStatementUrl):(0,D.localize)(1,null),default:!0,requireTrust:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(X[95],J([0,1,21,44,12,9]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(d,w){return Promise.resolve(void 0)}publicLog2(d,w){return this.publicLog(d,w)}publicLogError(d,w){return Promise.resolve(void 0)}publicLogError2(d,w){return this.publicLogError(d,w)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class P{async publicLog(w,I,E){}async publicLogError(w,I,E){}}e.NullEndpointTelemetryService=P;function r(...d){return{log:(w,I)=>d.forEach(E=>E.log(w,I)),flush:()=>y.Promises.settled(d.map(w=>w.flush()))}}e.combinedAppender=r,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(d,w){return w.onDidChangeConfiguration(I=>{I.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,m.ConfigurationTargetToString)(I.source),configurationKeys:b(I.sourceConfig)})})}e.configurationTelemetry=p;function i(d){const w=Object.create(null),I=Object.create(null),E=Object.create(null);g(d,E);for(let o in E){o=o.length>150?o.substr(o.length-149):o;const c=E[o];typeof c=="number"?I[o]=c:typeof c=="boolean"?I[o]=c?1:0:typeof c=="string"?w[o]=c.substring(0,1023):typeof c!="undefined"&&c!==null&&(w[o]=c)}return{properties:w,measurements:I}}e.validateTelemetryData=i;function L(d){if(!d)return"none";let w="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{d.indexOf(`${E}+`)===0&&(w=E)}),w}e.cleanRemoteAuthority=L;function g(d,w,I=0,E){if(!!d)for(let o of Object.getOwnPropertyNames(d)){const c=d[o],a=E?E+o:o;Array.isArray(c)?w[a]=(0,D.safeStringify)(c):c instanceof Date?w[a]=c.toISOString():(0,k.isObject)(c)?I<2?g(c,w,I+1,a+"."):w[a]=(0,D.safeStringify)(c):w[a]=c}}function b(d){if(!d)return[];const w=[];return v(w,"",d),w}function v(d,w,I){I&&typeof I=="object"&&!Array.isArray(I)?Object.keys(I).forEach(E=>v(d,w?`${w}.${E}`:E,I[E])):d.push(w)}}),define(X[196],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(D){D.DARK="dark",D.LIGHT="light",D.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(X[197],J([0,1,4,2,37,5,196,105]),function(j,e,m,D,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,m.createDecorator)("themeService");var p;(function(I){function E(o){return o&&typeof o=="object"&&typeof o.id=="string"}I.isThemeColor=E})(p=e.ThemeColor||(e.ThemeColor={}));function i(I){return{id:I}}e.themeColorFromId=i;var L;(function(I){function E(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||p.isThemeColor(t.color))}I.isThemeIcon=E;const o=new RegExp(`^\\$\\((${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?)\\)$`);function c(t){const n=o.exec(t);if(!!n){let[,s]=n;return{id:s}}}I.fromString=c;function a(t,n){let s=t.id;const l=s.lastIndexOf("~");return l!==-1&&(s=s.substring(0,l)),n&&(s=`${s}~${n}`),{id:s}}I.modify=a;function h(t,n){var s,l;return t.id===n.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((l=n.color)===null||l===void 0?void 0:l.id)}I.isEqual=h,I.asClassNameArray=r.CSSIcon.asClassNameArray,I.asClassName=r.CSSIcon.asClassName,I.asCSSSelector=r.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=r.Codicon.file,e.FolderThemeIcon=r.Codicon.folder;function g(I){switch(I){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=g,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new y.Emitter}onColorThemeChange(E){return this.themingParticipants.push(E),this.onThemingParticipantAddedEmitter.fire(E),(0,D.toDisposable)(()=>{const o=this.themingParticipants.indexOf(E);this.themingParticipants.splice(o,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let v=new b;k.Registry.add(e.Extensions.ThemingContribution,v);function d(I){return v.onColorThemeChange(I)}e.registerThemingParticipant=d;class w extends D.Disposable{constructor(E){super();this.themeService=E,this.theme=E.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(o=>this.onThemeChange(o)))}onThemeChange(E){this.theme=E,this.updateStyles()}updateStyles(){}getColor(E,o){let c=this.theme.getColor(E);return c&&o&&(c=o(c,this.theme)),c?c.toString():null}}e.Themable=w}),define(X[75],J([0,1,3,13,38,4]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const P="#FFFFFF",r="#1E1E1E",p="#000000",i="theme",L="themeBackground";e.IThemeMainService=(0,y.createDecorator)("themeMainService");let g=class{constructor(v){this.stateService=v,D.ipcMain.on("vscode:changeColorTheme",(d,w,I)=>{typeof I=="string"&&this.storeBackgroundColor(JSON.parse(I))})}storeBackgroundColor(v){this.stateService.setItem(i,v.baseTheme),this.stateService.setItem(L,v.background)}getBackgroundColor(){if((m.isWindows||m.isMacintosh)&&D.nativeTheme.shouldUseInvertedColorScheme)return p;let v=this.stateService.getItem(L,null);if(!v){let d;(m.isWindows||m.isMacintosh)&&D.nativeTheme.shouldUseInvertedColorScheme?d="hc-black":d=this.stateService.getItem(i,"vs-dark").split(" ")[0],v=d==="hc-black"?p:d==="vs"?P:r}return m.isMacintosh&&v.toUpperCase()===r&&(v="#171717"),v}};g=ce([ee(0,k.IStateService)],g),e.ThemeMainService=g}),define(X[40],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var D;(function(y){y.Uninitialized="uninitialized",y.Idle="idle",y.CheckingForUpdates="checking for updates",y.AvailableForDownload="available for download",y.Downloading="downloading",y.Downloaded="downloaded",y.Updating="updating",y.Ready="ready"})(D=e.StateType||(e.StateType={}));var k;(function(y){y[y.Setup=0]="Setup",y[y.Archive=1]="Archive",y[y.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(y,P)=>({type:"idle",updateType:y,error:P}),CheckingForUpdates:y=>({type:"checking for updates",context:y}),AvailableForDownload:y=>({type:"available for download",update:y}),Downloading:y=>({type:"downloading",update:y}),Downloaded:y=>({type:"downloaded",update:y}),Updating:y=>({type:"updating",update:y}),Ready:y=>({type:"ready",update:y})},e.IUpdateService=(0,m.createDecorator)("updateService")}),define(X[198],J([0,1,37,48,144,3]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),m.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,k.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,k.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,k.localize)(2,null),(0,k.localize)(3,null),(0,k.localize)(4,null),(0,k.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,k.localize)(6,null),deprecationMessage:(0,k.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,k.localize)(8,null),description:(0,k.localize)(9,null),included:y.isWindows&&!y.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,k.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(X[199],J([0,1,5,40]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(r){this.service=r}listen(r,p){switch(p){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${p}`)}call(r,p,i){switch(p){case"checkForUpdates":return this.service.checkForUpdates(i);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${p}`)}}e.UpdateChannel=k;class y{constructor(r){this.channel=r,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,this._state=D.State.Uninitialized,this.channel.listen("onStateChange")(p=>this.state=p),this.channel.call("_getInitialState").then(p=>this.state=p)}get state(){return this._state}set state(r){this._state=r,this._onStateChange.fire(r)}checkForUpdates(r){return this.channel.call("checkForUpdates",r)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=y}),define(X[96],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,m.createDecorator)("urlService")}),define(X[200],J([0,1,7]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class D{constructor(r){this.handler=r}listen(r,p){throw new Error(`Event not found: ${p}`)}call(r,p,i){switch(p){case"handleURL":return this.handler.handleURL(m.URI.revive(i[0]),i[1])}throw new Error(`Call not found: ${p}`)}}e.URLHandlerChannel=D;class k{constructor(r){this.channel=r}handleURL(r,p){return this.channel.call("handleURL",[r.toJSON(),p])}}e.URLHandlerChannelClient=k;class y{constructor(r){this.next=r}async routeCall(r,p,i,L){if(p!=="handleURL")throw new Error(`Call not found: ${p}`);if(i){const g=m.URI.revive(i);if(g&&g.query){const b=/\bwindowId=(\d+)/.exec(g.query);if(b){const v=b[1],d=new RegExp(`window:${v}`),w=r.connections.find(I=>d.test(I.ctx));if(w)return w}}}return this.next.routeCall(r,p,i,L)}routeEvent(r,p){throw new Error(`Event not found: ${p}`)}}e.URLHandlerRouter=y}),define(X[201],J([0,1,7,9,2,20]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class P extends k.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(i,L){const g=[...this.handlers.values()];return(0,D.first)(g.map(b=>()=>b.handleURL(i,L)),void 0,!1).then(b=>b||!1)}registerHandler(i){return this.handlers.add(i),(0,k.toDisposable)(()=>this.handlers.delete(i))}}e.AbstractURLService=P;let r=class extends P{constructor(i){super();this.productService=i}create(i){let{authority:L,path:g,query:b,fragment:v}=i||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return L&&g&&g.indexOf("/")!==0&&(g=`/${g}`),m.URI.from({scheme:this.productService.urlProtocol,authority:L,path:g,query:b,fragment:v})}};r=ce([ee(0,y.IProductService)],r),e.NativeURLService=r}),define(X[202],J([0,1,5,13,7,2,3,9]),function(j,e,m,D,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function p(L){try{return k.URI.parse(L)}catch(g){return null}}class i{constructor(g,b,v,d,w){if(this.urlService=b,this.uris=[],this.retryCount=0,this.flushDisposable=y.Disposable.None,this.disposables=new y.DisposableStore,this.uris=g,P.isWindows){const o=d.isBuilt?[]:[`"${d.appRoot}"`];o.push("--open-url","--"),D.app.setAsDefaultProtocolClient(w.urlProtocol,process.execPath,o)}const I=m.Event.map(m.Event.fromNodeEventEmitter(D.app,"open-url",(o,c)=>({event:o,url:c})),({event:o,url:c})=>(o.preventDefault(),c));this.disposables.add(I(o=>{const c=p(o);!c||this.urlService.open(c,{originalUrl:o})})),v.getWindows().filter(o=>o.isReady).length>0?this.flush():m.Event.once(v.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(!(this.retryCount++>10)){const g=[];for(const b of this.uris)await this.urlService.open(b.uri,{originalUrl:b.url})||g.push(b);g.length!==0&&(this.uris=g,this.flushDisposable=(0,r.disposableTimeout)(()=>this.flush(),500))}}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=i}),define(X[76],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewPartitionId=e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,m.createDecorator)("webviewManagerService"),e.webviewPartitionId="webview"}),define(X[203],J([0,1,13,2,10,7,76]),function(j,e,m,D,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class r extends D.Disposable{constructor(){super();const i=m.session.fromPartition(P.webviewPartitionId),L=this.handleWebviewRequest.bind(this);m.protocol.registerFileProtocol(k.Schemas.vscodeWebview,L),i.protocol.registerFileProtocol(k.Schemas.vscodeWebview,L)}async handleWebviewRequest(i,L){try{const g=y.URI.parse(i.url),b=r.validWebviewFilePaths.get(g.path);if(typeof b=="string"){const v=g.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${b}`:`vs/workbench/contrib/webview/browser/pre/${b}`,d=k.FileAccess.asFileUri(v,j);return L(decodeURIComponent(d.fsPath))}}catch(g){}L({error:-10})}}e.WebviewProtocolProvider=r,r.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/electron-browser-index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"],["/service-worker.js","service-worker.js"]])}),define(X[60],J([0,1,3]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function D(i){return!!i.workspaceUri}e.isWorkspaceToOpen=D;function k(i){return!!i.folderUri}e.isFolderToOpen=k;function y(i){return!!i.fileUri}e.isFileToOpen=y;function P(i){const L=r(i),g=i.getValue("window.menuBarVisibility");return g==="default"||L==="native"&&g==="compact"||m.isMacintosh&&m.isNative?"classic":g}e.getMenuBarVisibility=P;function r(i){if(m.isWeb)return"custom";const L=i.getValue("window");if(L){if(m.isMacintosh&&L.nativeTabs===!0||m.isMacintosh&&L.nativeFullScreen===!1)return"native";const v=L.titleBarStyle;if(v==="native"||v==="custom")return v}return m.isLinux?"native":"custom"}e.getTitleBarStyle=r;function p(i=0){return Math.pow(1.2,i)}e.zoomLevelToZoomFactor=p}),define(X[34],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var D;(function(r){r[r.CLI=0]="CLI",r[r.DOCK=1]="DOCK",r[r.MENU=2]="MENU",r[r.DIALOG=3]="DIALOG",r[r.DESKTOP=4]="DESKTOP",r[r.API=5]="API"})(D=e.OpenContext||(e.OpenContext={}));const k=function(r=1){return{width:1024,height:768,mode:r}};e.defaultWindowState=k;var y;(function(r){r[r.Maximized=0]="Maximized",r[r.Normal=1]="Normal",r[r.Minimized=2]="Minimized",r[r.Fullscreen=3]="Fullscreen"})(y=e.WindowMode||(e.WindowMode={}));var P;(function(r){r[r.UNRESPONSIVE=1]="UNRESPONSIVE",r[r.CRASHED=2]="CRASHED",r[r.LOAD=3]="LOAD"})(P=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,m.createDecorator)("windowsMainService")}),define(X[204],J([0,1,13,2,73,76,203,34]),function(j,e,m,D,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let p=class extends D.Disposable{constructor(L,g){super();this.windowsMainService=g,this._register(new P.WebviewProtocolProvider);const b=m.session.fromPartition(y.webviewPartitionId);b.setPermissionRequestHandler((v,d,w)=>w(d==="clipboard-read")),b.setPermissionCheckHandler((v,d)=>d==="clipboard-read")}async setIgnoreMenuShortcuts(L,g){let b;if(typeof L.windowId=="number"){const{windowId:v}=L,d=this.windowsMainService.getWindowById(v);if(!(d==null?void 0:d.win))throw new Error(`Invalid windowId: ${v}`);b=d.win.webContents}else{const{webContentsId:v}=L;if(b=m.webContents.fromId(v),!b)throw new Error(`Invalid webContentsId: ${v}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(g)}};p=ce([ee(0,k.ITunnelService),ee(1,r.IWindowsMainService)],p),e.WebviewMainService=p}),define(X[205],J([0,1,5,2,9]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class y extends D.Disposable{constructor({onDidOpenWindow:r,onDidFocusWindow:p,getActiveWindowId:i}){super();this.disposables=this._register(new D.DisposableStore),m.Event.latch(m.Event.any(r,p))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>i()),(async()=>{try{const g=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:g}catch(g){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(r){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=r}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=y}),define(X[206],J([0,1,7,15,4,36]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");var P;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function r(b){const v=b;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.isWorkspace=r;function p(b){const v=b;return!!(v&&typeof v=="object"&&m.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.isWorkspaceFolder=p;class i{constructor(v,d,w,I){this._id=v,this._configuration=w,this._ignorePathCasing=I,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(v){this._id=v.id,this._configuration=v.configuration,this._ignorePathCasing=v._ignorePathCasing,this.folders=v.folders}get folders(){return this._folders}set folders(v){this._folders=v,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(v){this._configuration=v}getFolder(v){return v&&this._foldersMap.findSubstr(v.with({scheme:v.scheme,authority:v.authority,path:v.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const v of this.folders)this._foldersMap.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=i;class L{constructor(v,d){this.raw=d,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,D.joinPath)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=L;function g(b){return new L({uri:b,index:0,name:(0,D.basenameOrAuthority)(b)},{uri:b.toString()})}e.toWorkspaceFolder=g}),define(X[29],J([0,1,4,147,206,7,3,8,15,102,43,10,39,30,72]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(z){return(typeof z=="string"?(0,r.extname)(z):(0,p.extname)(z))===w}e.hasWorkspaceFileExtension=I,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function E(z){return z.hasOwnProperty("workspace")}e.isRecentWorkspace=E;function o(z){return z.hasOwnProperty("folderUri")}e.isRecentFolder=o;function c(z){return z.hasOwnProperty("fileUri")}e.isRecentFile=c;function a(z){const C=z;return typeof(C==null?void 0:C.id)=="string"&&y.URI.isUri(C.uri)}e.isSingleFolderWorkspaceIdentifier=a;function h(z){if(z.configuration)return{id:z.id,configPath:z.configuration};if(z.folders.length===1)return{id:z.id,uri:z.folders[0].uri}}e.toWorkspaceIdentifier=h;function t(z){const C=z;return typeof(C==null?void 0:C.id)=="string"&&y.URI.isUri(C.configPath)}e.isWorkspaceIdentifier=t;function n(z){const C=z;if(C==null?void 0:C.uri)return{id:C.id,uri:y.URI.revive(C.uri)};const q=z;if(q==null?void 0:q.configPath)return{id:q.id,configPath:y.URI.revive(q.configPath)};if(z==null?void 0:z.id)return{id:z.id}}e.reviveIdentifier=n;function s(z,C){return p.extUriBiasedIgnorePathCase.isEqualOrParent(z,C.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function l(z){return u(z)||f(z)}e.isStoredWorkspaceFolder=l;function u(z){const C=z;return typeof(C==null?void 0:C.path)=="string"&&(!C.name||typeof C.name=="string")}e.isRawFileWorkspaceFolder=u;function f(z){const C=z;return typeof(C==null?void 0:C.uri)=="string"&&(!C.name||typeof C.name=="string")}e.isRawUriWorkspaceFolder=f;function S(z,C,q,N,_=!P.isWindows,R){if(z.scheme!==N.scheme)return{name:q,uri:z.toString(!0)};let W=C?void 0:R.relativePath(N,z);if(W!==void 0)W.length===0?W=".":P.isWindows&&z.scheme===g.Schemas.file&&!_&&(W=W.replace(/\//g,"\\"));else if(z.scheme===g.Schemas.file)W=z.fsPath,P.isWindows&&(W=(0,b.normalizeDriveLetter)(W),_&&(W=(0,v.toSlashes)(W)));else{if(!R.isEqualAuthority(z.authority,N.authority))return{name:q,uri:z.toString(!0)};W=z.path}return{name:q,path:W}}e.getStoredWorkspaceFolder=S;function A(z,C,q){let N=[],_=new Set;const R=q.dirname(C);for(let W of z){let M=null;if(u(W))W.path&&(M=q.resolvePath(R,W.path));else if(f(W))try{M=y.URI.parse(W.uri),M.path[0]!=="/"&&(M=M.with({path:"/"+M.path}))}catch(F){console.warn(F)}if(M){let F=q.getComparisonKey(M);if(!_.has(F)){_.add(F);const B=W.name||q.basenameOrAuthority(M);N.push(new k.WorkspaceFolder({uri:M,name:B,index:N.length},W))}}}return N}e.toWorkspaceFolders=A;function T(z,C,q,N,_){let R=U(C,z);const W=_.dirname(C),M=_.dirname(N),F=[],B=H(R.folders);for(const Z of R.folders){const re=u(Z)?_.resolvePath(W,Z.path):y.URI.parse(Z.uri);let se;q?se=!1:se=!u(Z)||(0,r.isAbsolute)(Z.path),F.push(S(re,se,Z.name,M,B,_))}const V={insertSpaces:!1,tabSize:4,eol:P.isLinux||P.isMacintosh?`
`:`\r
`},G=i.setProperty(z,["folders"],F,V);let Y=i.applyEdits(z,G);return R.remoteAuthority===(0,d.getRemoteAuthority)(N)&&(Y=i.applyEdits(Y,i.removeProperty(Y,["remoteAuthority"],V))),Y}e.rewriteWorkspaceFileForNewLocation=T;function U(z,C){let q=L.parse(C);if(q&&Array.isArray(q.folders))q.folders=q.folders.filter(N=>l(N));else throw new Error(`${z} looks like an invalid workspace file.`);return q}function H(z){return P.isWindows?z.some(C=>u(C)&&C.path.indexOf("/")>=0):!0}e.useSlashForPath=H;function Q(z){return z.workspace&&typeof z.workspace=="object"&&typeof z.workspace.id=="string"&&typeof z.workspace.configPath=="string"}function ne(z){return typeof z.folderUri=="string"}function ae(z){return typeof z.fileUri=="string"}function O(z,C){const q={workspaces:[],files:[]};if(z){const N=function(R,W){for(let M=0;M<R.length;M++)try{W(R[M],M)}catch(F){C.warn(`Error restoring recent entry ${JSON.stringify(R[M])}: ${F.toString()}. Skip entry.`)}},_=z;if(Array.isArray(_.entries))N(_.entries,R=>{const W=R.label,M=R.remoteAuthority;Q(R)?q.workspaces.push({label:W,remoteAuthority:M,workspace:{id:R.workspace.id,configPath:y.URI.parse(R.workspace.configPath)}}):ne(R)?q.workspaces.push({label:W,remoteAuthority:M,folderUri:y.URI.parse(R.folderUri)}):ae(R)&&q.files.push({label:W,remoteAuthority:M,fileUri:y.URI.parse(R.fileUri)})});else{const R=z;Array.isArray(R.workspaces3)&&N(R.workspaces3,(W,M)=>{const F=Array.isArray(R.workspaceLabels)&&R.workspaceLabels[M]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?q.workspaces.push({label:F,workspace:{id:W.id,configPath:y.URI.parse(W.configURIPath)}}):typeof W=="string"&&q.workspaces.push({label:F,folderUri:y.URI.parse(W)})}),Array.isArray(R.files2)&&N(R.files2,(W,M)=>{const F=Array.isArray(R.fileLabels)&&R.fileLabels[M]||void 0;typeof W=="string"&&q.files.push({label:F,fileUri:y.URI.parse(W)})})}}return q}e.restoreRecentlyOpened=O;function $(z){const C={entries:[]};for(const q of z.workspaces)o(q)?C.entries.push({folderUri:q.folderUri.toString(),label:q.label,remoteAuthority:q.remoteAuthority}):C.entries.push({workspace:{id:q.workspace.id,configPath:q.workspace.configPath.toString()},label:q.label,remoteAuthority:q.remoteAuthority});for(const q of z.files)C.entries.push({fileUri:q.fileUri.toString(),label:q.label,remoteAuthority:q.remoteAuthority});return C}e.toStoreData=$}),define(X[50],J([0,1,4,29]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,m.createDecorator)("backupMainService");function k(y){const P=y;return P&&(0,D.isWorkspaceIdentifier)(P.workspace)}e.isWorkspaceBackupInfo=k}),define(X[51],J([0,1,4,13,9,38,3,8,64,19,12,131,29,39,2,80]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,m.createDecorator)("dialogMainService");let I=class ut{constructor(o){this.stateService=o,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new k.Queue}pickFileFolder(o,c){return this.doPick(Object.assign(Object.assign({},o),{pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)}),c)}pickFolder(o,c){return this.doPick(Object.assign(Object.assign({},o),{pickFolders:!0,title:(0,g.localize)(1,null)}),c)}pickFile(o,c){return this.doPick(Object.assign(Object.assign({},o),{pickFiles:!0,title:(0,g.localize)(2,null)}),c)}pickWorkspace(o,c){const a=(0,g.localize)(3,null),h=(0,v.mnemonicButtonLabel)((0,g.localize)(4,null)),t=b.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},o),{pickFiles:!0,title:a,filters:t,buttonLabel:h}),c)}async doPick(o,c){const a={title:o.title,buttonLabel:o.buttonLabel,filters:o.filters};a.defaultPath=o.defaultPath||this.stateService.getItem(ut.workingDirPickerStorageKey),(typeof o.pickFiles=="boolean"||typeof o.pickFolders=="boolean")&&(a.properties=void 0,o.pickFiles&&o.pickFolders&&(a.properties=["multiSelections","openDirectory","openFile","createDirectory"])),a.properties||(a.properties=["multiSelections",o.pickFolders?"openDirectory":"openFile","createDirectory"]),P.isMacintosh&&a.properties.push("treatPackageAsDirectory");const h=c||D.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(a,(0,L.withNullAsUndefined)(h));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateService.setItem(ut.workingDirPickerStorageKey,(0,r.dirname)(t.filePaths[0])),t.filePaths}getWindowDialogQueue(o){if(o){let c=this.windowDialogQueues.get(o.id);return c||(c=new k.Queue,this.windowDialogQueues.set(o.id,c)),c}else return this.noWindowDialogueQueue}showMessageBox(o,c){return this.getWindowDialogQueue(c).queue(async()=>c?D.dialog.showMessageBox(c,o):D.dialog.showMessageBox(o))}async showSaveDialog(o,c){const a=this.acquireFileDialogLock(o,c);if(!a)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(c).queue(async()=>{let h;return c?h=await D.dialog.showSaveDialog(c,o):h=await D.dialog.showSaveDialog(o),h.filePath=this.normalizePath(h.filePath),h})}finally{(0,d.dispose)(a)}}normalizePath(o){return o&&P.isMacintosh&&(o=(0,p.normalizeNFC)(o)),o}normalizePaths(o){return o.map(c=>this.normalizePath(c))}async showOpenDialog(o,c){o.defaultPath&&(await(0,i.exists)(o.defaultPath)||(o.defaultPath=void 0));const a=this.acquireFileDialogLock(o,c);if(!a)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(c).queue(async()=>{let h;return c?h=await D.dialog.showOpenDialog(c,o):h=await D.dialog.showOpenDialog(o),h.filePaths=this.normalizePaths(h.filePaths),h})}finally{(0,d.dispose)(a)}}acquireFileDialogLock(o,c){if(!c)return d.Disposable.None;let a=this.windowFileDialogLocks.get(c.id);a||(a=new Set,this.windowFileDialogLocks.set(c.id,a));const h=(0,w.hash)(o);if(!a.has(h))return a.add(h),(0,d.toDisposable)(()=>{a==null||a.delete(h),(a==null?void 0:a.size)===0&&this.windowFileDialogLocks.delete(c.id)})}};I.workingDirPickerStorageKey="pickerWorkingDir",I=ce([ee(0,y.IStateService)],I),e.DialogMainService=I}),define(X[207],J([0,1,5,2,29]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class y extends D.Disposable{constructor(r,p){super();this.logService=r,this.storageMainService=p,this._onDidChangeGlobalStorage=this._register(new m.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(m.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(r,p)=>(r?r.push(p):r=[p],r),y.STORAGE_CHANGE_DEBOUNCE_TIME)(r=>{r.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(r))}))}serializeGlobalStorageEvents(r){const p=new Map,i=new Set;return r.forEach(L=>{const g=this.storageMainService.globalStorage.get(L.key);typeof g=="string"?p.set(L.key,g):i.add(L.key)}),{changed:Array.from(p.entries()),deleted:Array.from(i.values())}}listen(r,p){switch(p){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${p}`)}async call(r,p,i){const L=(0,k.reviveIdentifier)(i.workspace),g=await this.withStorageInitialized(L);switch(p){case"getItems":return Array.from(g.items.entries());case"updateItems":{const b=i;if(b.insert)for(const[v,d]of b.insert)g.set(v,d);b.delete&&b.delete.forEach(v=>g.delete(v));break}case"close":{if(L)return g.close();break}default:throw new Error(`Call not found: ${p}`)}}async withStorageInitialized(r){const p=r?this.storageMainService.workspaceStorage(r):this.storageMainService.globalStorage;try{await p.init()}catch(i){this.logService.error(`StorageIPC#init: Unable to init ${r?"workspace":"global"} storage due to ${i}`)}return p}}e.StorageDatabaseChannel=y,y.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(X[208],J([0,1,18,19,5,2,6,121,85,8,94,31,28,29]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class d extends y.Disposable{constructor(o){super();this.logService=o,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new p.Storage(new p.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const o=await this.doCreate();this.storage.dispose(),this.storage=o,this._register(o.onDidChangeStorage(a=>this._onDidChangeStorage.fire({key:a}))),await this.doInit(o);const c=o.getBoolean(L.IS_NEW_KEY);c===void 0?o.set(L.IS_NEW_KEY,!0):c&&o.set(L.IS_NEW_KEY,!1)}catch(o){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${o}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===P.LogLevel.Trace?o=>this.logService.trace(o):void 0,logError:o=>this.logService.error(o)}}doInit(o){return o.init()}get items(){return this.storage.items}get(o,c){return this.storage.get(o,c)}set(o,c){return this.storage.set(o,c)}delete(o){return this.storage.delete(o)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class w extends d{constructor(o,c,a){super(c);this.options=o,this.environmentService=a}async doCreate(){let o;return this.options.useInMemoryStorage?o=r.SQLiteStorageDatabase.IN_MEMORY_PATH:o=(0,i.join)(this.environmentService.globalStorageHome.fsPath,w.STORAGE_NAME),new p.Storage(new r.SQLiteStorageDatabase(o,{logging:this.createLogginOptions()}))}async doInit(o){await super.doInit(o),this.updateTelemetryState(o)}updateTelemetryState(o){o.get(g.instanceStorageKey,void 0)===void 0&&o.set(g.instanceStorageKey,(0,b.generateUuid)()),o.get(g.firstSessionDateStorageKey,void 0)===void 0&&o.set(g.firstSessionDateStorageKey,new Date().toUTCString());const h=o.get(g.currentSessionDateStorageKey,void 0),t=new Date().toUTCString();o.set(g.lastSessionDateStorageKey,typeof h=="undefined"?null:h),o.set(g.currentSessionDateStorageKey,t)}}e.GlobalStorageMain=w,w.STORAGE_NAME="state.vscdb";class I extends d{constructor(o,c,a,h){super(a);this.workspace=o,this.options=c,this.environmentService=h}async doCreate(){const{storageFilePath:o,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new p.Storage(new r.SQLiteStorageDatabase(o,{logging:this.createLogginOptions()}),{hint:c?p.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:r.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const o=(0,i.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=(0,i.join)(o,I.WORKSPACE_STORAGE_NAME);return await(0,D.exists)(o)?{storageFilePath:c,wasCreated:!1}:(await m.promises.mkdir(o,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(o),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(o){let c;if((0,v.isSingleFolderWorkspaceIdentifier)(this.workspace)?c={folder:this.workspace.uri.toString()}:(0,v.isWorkspaceIdentifier)(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const a=(0,i.join)(o,I.WORKSPACE_META_NAME);await(0,D.exists)(a)||await(0,D.writeFile)(a,JSON.stringify(c,void 0,2))}catch(a){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${a}`)}}}e.WorkspaceStorageMain=I,I.WORKSPACE_STORAGE_NAME="state.vscdb",I.WORKSPACE_META_NAME="workspace.json"}),define(X[97],J([0,1,42,2,46,4,16,6,208]),function(j,e,m,D,k,y,P,r,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,y.createDecorator)("storageMainService");let i=class extends D.Disposable{constructor(g,b,v){super();this.logService=g,this.environmentService=b,this.lifecycleMainService=v,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async g=>{g.workspace&&this.workspaceStorage(g.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(g=>{g.join(this.globalStorage.close());for(const[,b]of this.mapWorkspaceToStorage)g.join(b.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const g=new p.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,m.once)(g.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),g}createWorkspaceStorage(g){return new p.WorkspaceStorageMain(g,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(g){let b=this.mapWorkspaceToStorage.get(g.id);return b||(this.logService.trace(`StorageMainService: creating workspace storage (${g.id})`),b=this.createWorkspaceStorage(g),this.mapWorkspaceToStorage.set(g.id,b),(0,m.once)(b.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${g.id})`),this.mapWorkspaceToStorage.delete(g.id)})),b}};i=ce([ee(0,r.ILogService),ee(1,k.IEnvironmentService),ee(2,P.ILifecycleMainService)],i),e.StorageMainService=i}),define(X[98],J([0,1,7,29,15]),function(j,e,m,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function y(p,i,L){for(const b of p){const v=b.openedWorkspace;if((0,D.isWorkspaceIdentifier)(v)){const d=L(v);if(d){if(d.folders.some(w=>k.extUriBiasedIgnorePathCase.isEqualOrParent(i,w.uri)))return b}else if(k.extUriBiasedIgnorePathCase.isEqualOrParent(i,v.configPath))return b}}const g=p.filter(b=>(0,D.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&k.extUriBiasedIgnorePathCase.isEqualOrParent(i,b.openedWorkspace.uri));if(g.length)return g.sort((b,v)=>-(b.openedWorkspace.uri.path.length-v.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=y;function P(p,i){for(const L of p)if((0,D.isWorkspaceIdentifier)(L.openedWorkspace)&&k.extUriBiasedIgnorePathCase.isEqual(L.openedWorkspace.configPath,i)||(0,D.isSingleFolderWorkspaceIdentifier)(L.openedWorkspace)&&k.extUriBiasedIgnorePathCase.isEqual(L.openedWorkspace.uri,i))return L}e.findWindowOnWorkspaceOrFolder=P;function r(p,i){var L,g;const b=v=>i.some(d=>k.extUriBiasedIgnorePathCase.isEqual(m.URI.file(d),m.URI.file(v)));for(const v of p)if((g=(L=v.config)===null||L===void 0?void 0:L.extensionDevelopmentPath)===null||g===void 0?void 0:g.some(d=>b(d)))return v}e.findWindowOnExtensionDevelopmentPath=r}),define(X[209],J([0,1,13,2,3,15,7,21,16,6,38,34,29]),function(j,e,m,D,k,y,P,r,p,i,L,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let v=class ht extends D.Disposable{constructor(c,a,h,t,n){super();this.windowsMainService=c,this.stateService=a,this.lifecycleMainService=h,this.logService=t,this.configurationService=n,this._state=d(this.stateService.getItem(ht.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){m.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),t&&(c.lastActiveWindow=this.toWindowState(t))}const a=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);a&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const h=I(c);this.stateService.setItem(ht.windowsStateStorageKey,h),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",h)}onBeforeCloseWindow(c){if(!this.lifecycleMainService.quitRequested){const a=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(h=>{var t;const n=(0,b.isWorkspaceIdentifier)(c.openedWorkspace)&&((t=h.workspace)===null||t===void 0?void 0:t.id)===c.openedWorkspace.id,s=(0,b.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&h.folderUri&&y.extUriBiasedIgnorePathCase.isEqual(h.folderUri,c.openedWorkspace.uri);(n||s)&&(h.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}}toWindowState(c){return{workspace:(0,b.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,b.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const a=this.doGetNewWindowState(c),h=this.configurationService.getValue("window");let t;return a.hasDefaultState?t=!!((h==null?void 0:h.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(h.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||(h==null?void 0:h.restoreFullscreen)),t&&k.isMacintosh&&this.windowsMainService.getWindows().some(n=>n.isFullScreen)&&(t=!1)),a.mode===3&&!t&&(a.mode=1),a}doGetNewWindowState(c){const a=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(!!c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const u=c.workspace;if((0,b.isWorkspaceIdentifier)(u)){const S=this.state.openedWindows.filter(A=>A.workspace&&A.workspace.id===u.id).map(A=>A.uiState);if(S.length)return S[0]}if((0,b.isSingleFolderWorkspaceIdentifier)(u)){const S=this.state.openedWindows.filter(A=>A.folderUri&&y.extUriBiasedIgnorePathCase.isEqual(A.folderUri,u.uri)).map(A=>A.uiState);if(S.length)return S[0]}else if(c.backupPath){const S=this.state.openedWindows.filter(A=>A.backupPath===c.backupPath).map(A=>A.uiState);if(S.length)return S[0]}const f=this.lastClosedState||this.state.lastActiveWindow;if(!a&&f)return f.uiState}let h;const t=m.screen.getAllDisplays();if(t.length===1)h=t[0];else{if(k.isMacintosh){const u=m.screen.getCursorScreenPoint();h=m.screen.getDisplayNearestPoint(u)}!h&&a&&(h=m.screen.getDisplayMatching(a.getBounds())),h||(h=m.screen.getPrimaryDisplay()||t[0])}let n=(0,g.defaultWindowState)();n.x=Math.round(h.bounds.x+h.bounds.width/2-n.width/2),n.y=Math.round(h.bounds.y+h.bounds.height/2-n.height/2);const s=this.configurationService.getValue("window");let l=!0;if(s==null?void 0:s.newWindowDimensions){if(s.newWindowDimensions==="maximized")n.mode=0,l=!1;else if(s.newWindowDimensions==="fullscreen")n.mode=3,l=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&a){const u=a.serializeWindowState();u.mode===3?n.mode=3:n=u,l=n.mode!==3&&s.newWindowDimensions==="offset"}}return l&&(n=this.ensureNoOverlap(n)),n.hasDefaultState=!0,n}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const a=this.windowsMainService.getWindows().map(h=>h.getBounds());for(;a.some(h=>h.x===c.x||h.y===c.y);)c.x+=30,c.y+=30;return c}};v.windowsStateStorageKey="windowsState",v=ce([ee(0,g.IWindowsMainService),ee(1,L.IStateService),ee(2,p.ILifecycleMainService),ee(3,i.ILogService),ee(4,r.IConfigurationService)],v),e.WindowsStateHandler=v;function d(o){const c={openedWindows:[]},a=o||{openedWindows:[]};return a.lastActiveWindow&&(c.lastActiveWindow=w(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=w(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(c.openedWindows=a.openedWindows.map(h=>w(h))),c}e.restoreWindowsState=d;function w(o){const c={uiState:o.uiState};return o.backupPath&&(c.backupPath=o.backupPath),o.remoteAuthority&&(c.remoteAuthority=o.remoteAuthority),o.folder&&(c.folderUri=P.URI.parse(o.folder)),o.workspaceIdentifier&&(c.workspace={id:o.workspaceIdentifier.id,configPath:P.URI.parse(o.workspaceIdentifier.configURIPath)}),c}function I(o){return{lastActiveWindow:o.lastActiveWindow&&E(o.lastActiveWindow),lastPluginDevelopmentHostWindow:o.lastPluginDevelopmentHostWindow&&E(o.lastPluginDevelopmentHostWindow),openedWindows:o.openedWindows.map(c=>E(c))}}e.getWindowsStateStoreData=I;function E(o){return{workspaceIdentifier:o.workspace&&{id:o.workspace.id,configURIPath:o.workspace.configPath.toString()},folder:o.folderUri&&o.folderUri.toString(),backupPath:o.backupPath,remoteAuthority:o.remoteAuthority,uiState:o.uiState}}}),define(X[56],J([0,1,58,59,210,5,33,8,27,28,2,23,83,17,3]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(S){this.socket=S,this._errorListener=A=>{if(A){if(A.code==="EPIPE")return;(0,v.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(S){const A=T=>S(g.VSBuffer.wrap(T));return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(S){return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(S){return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(S){if(!this.socket.destroyed)try{this.socket.write(S.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,v.onUnexpectedError)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,v.onUnexpectedError)(A)}}end(){this.socket.end()}drain(){return new Promise((S,A)=>{if(this.socket.bufferSize===0){S();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),S()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=w;var I;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(I||(I={}));var E;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(E||(E={}));class o extends L.Disposable{constructor(S,A,T,U){super();this._onDidZlibFlush=this._register(new y.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=S,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=A,this._recordInflateBytes=U,A?(this._zlibInflate=k.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",H=>{console.error(H),(0,v.onUnexpectedError)(H),this._onClose.fire()}),this._zlibInflate.on("data",H=>{this._pendingInflateData.push(H)}),T&&(this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=k.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",H=>{console.error(H),(0,v.onUnexpectedError)(H),this._onClose.fire()}),this._zlibDeflate.on("data",H=>{this._pendingDeflateData.push(H)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new b.ChunkStream,this._register(this.socket.onData(H=>this._acceptChunk(H))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?g.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):g.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this._onData.event(S)}onClose(S){return this._onClose.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){this._totalOutgoingDataBytes+=S.byteLength,this._zlibDeflate?(this._zlibDeflate.write(S.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let A=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,A=A.slice(0,A.length-4),this._isEnded||this._write(g.VSBuffer.wrap(A),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(S,!1)}_write(S,A){let T=2;S.byteLength<126?T+=0:S.byteLength<2**16?T+=2:T+=8;const U=g.VSBuffer.alloc(T);if(A?U.writeUInt8(194,0):U.writeUInt8(130,0),S.byteLength<126)U.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){U.writeUInt8(126,1);let H=1;U.writeUInt8(S.byteLength>>>8&255,++H),U.writeUInt8(S.byteLength>>>0&255,++H)}else{U.writeUInt8(127,1);let H=1;U.writeUInt8(0,++H),U.writeUInt8(0,++H),U.writeUInt8(0,++H),U.writeUInt8(0,++H),U.writeUInt8(S.byteLength>>>24&255,++H),U.writeUInt8(S.byteLength>>>16&255,++H),U.writeUInt8(S.byteLength>>>8&255,++H),U.writeUInt8(S.byteLength>>>0&255,++H)}this._totalOutgoingWireBytes+=U.byteLength+S.byteLength,this.socket.write(g.VSBuffer.concat([U,S]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(S){if(S.byteLength!==0){for(this._totalIncomingWireBytes+=S.byteLength,this._incomingData.acceptChunk(S);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const A=this._incomingData.peek(this._state.readLen),U=(A.readUInt8(0)&128)>>>7,H=A.readUInt8(1),Q=(H&128)>>>7,ne=H&127;this._state.state=2,this._state.readLen=2+(Q?4:0)+(ne===126?2:0)+(ne===127?8:0),this._state.fin=U,this._state.mask=0}else if(this._state.state===2){const A=this._incomingData.read(this._state.readLen),T=A.readUInt8(1),U=(T&128)>>>7;let H=T&127,Q=1;H===126?H=A.readUInt8(++Q)*2**8+A.readUInt8(++Q):H===127&&(H=A.readUInt8(++Q)*0+A.readUInt8(++Q)*0+A.readUInt8(++Q)*0+A.readUInt8(++Q)*0+A.readUInt8(++Q)*2**24+A.readUInt8(++Q)*2**16+A.readUInt8(++Q)*2**8+A.readUInt8(++Q));let ne=0;U&&(ne=A.readUInt8(++Q)*2**24+A.readUInt8(++Q)*2**16+A.readUInt8(++Q)*2**8+A.readUInt8(++Q)),this._state.state=3,this._state.readLen=H,this._state.mask=ne}else if(this._state.state===3){const A=this._incomingData.read(this._state.readLen);c(A,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(A.buffer)),this._zlibInflate.write(A.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const T=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=T.length,this._onData.fire(g.VSBuffer.wrap(T))})):(this._totalIncomingDataBytes+=A.byteLength,this._onData.fire(A))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await y.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=o;function c(f,S){if(S!==0){let A=f.byteLength>>>2;for(let ae=0;ae<A;ae++){const O=f.readUInt32BE(ae*4);f.writeUInt32BE(O^S,ae*4)}let T=A*4,U=f.byteLength-T;const H=S>>>24&255,Q=S>>>16&255,ne=S>>>8&255;U>=1&&f.writeUInt8(f.readUInt8(T)^H,T),U>=2&&f.writeUInt8(f.readUInt8(T+1)^Q,T+1),U>=3&&f.writeUInt8(f.readUInt8(T+2)^ne,T+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function h(){const f=(0,i.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let S;return e.XDG_RUNTIME_DIR?S=(0,r.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):S=(0,r.join)((0,p.tmpdir)(),`vscode-ipc-${f}.sock`),n(S),S}e.createRandomIPCHandle=h;function t(f,S,A){const T=(0,m.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${A}-${S}-sock`;let U;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=(0,r.join)(e.XDG_RUNTIME_DIR,`vscode-${T.substr(0,8)}-${A}-${S}.sock`):U=(0,r.join)(f,`${A}-${S}.sock`),n(U),U}e.createStaticIPCHandle=t;function n(f){const S=a[d.platform];typeof S=="number"&&f.length>=S&&console.warn(`WARNING: IPC handle "${f}" is longer than ${S} chars, try a shorter --user-data-dir`)}class s extends P.IPCServer{constructor(S){super(s.toClientConnectionEvent(S));this.server=S}static toClientConnectionEvent(S){const A=y.Event.fromNodeEventEmitter(S,"connection");return y.Event.map(A,T=>({protocol:new b.Protocol(new w(T)),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(T,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function l(f){return new Promise((S,A)=>{const T=(0,D.createServer)();T.on("error",A),T.listen(f,()=>{T.removeListener("error",A),S(new s(T))})})}e.serve=l;function u(f,S){return new Promise((A,T)=>{const U=(0,D.createConnection)(f,()=>{U.removeListener("error",T),A(b.Client.fromSocket(new w(U),S))});U.once("error",T)})}e.connect=u}),define(X[211],J([0,1,56]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverChannelClient=e.WindowDriverChannel=e.WindowDriverRegistryChannelClient=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class D{constructor(g){this.driver=g}listen(g,b){throw new Error("No event found")}call(g,b,v){switch(b){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(v);case"reloadWindow":return this.driver.reloadWindow(v);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(v[0],v[1]);case"click":return this.driver.click(v[0],v[1],v[2],v[3]);case"doubleClick":return this.driver.doubleClick(v[0],v[1]);case"setValue":return this.driver.setValue(v[0],v[1],v[2]);case"getTitle":return this.driver.getTitle(v[0]);case"isActiveElement":return this.driver.isActiveElement(v[0],v[1]);case"getElements":return this.driver.getElements(v[0],v[1],v[2]);case"getElementXY":return this.driver.getElementXY(v[0],v[1],v[2]);case"typeInEditor":return this.driver.typeInEditor(v[0],v[1],v[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(v[0],v[1]);case"writeInTerminal":return this.driver.writeInTerminal(v[0],v[1],v[2])}throw new Error(`Call not found: ${b}`)}}e.DriverChannel=D;class k{constructor(g){this.channel=g}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(g){return this.channel.call("capturePage",g)}reloadWindow(g){return this.channel.call("reloadWindow",g)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(g,b){return this.channel.call("dispatchKeybinding",[g,b])}click(g,b,v,d){return this.channel.call("click",[g,b,v,d])}doubleClick(g,b){return this.channel.call("doubleClick",[g,b])}setValue(g,b,v){return this.channel.call("setValue",[g,b,v])}getTitle(g){return this.channel.call("getTitle",[g])}isActiveElement(g,b){return this.channel.call("isActiveElement",[g,b])}getElements(g,b,v){return this.channel.call("getElements",[g,b,v])}getElementXY(g,b,v,d){return this.channel.call("getElementXY",[g,b,v,d])}typeInEditor(g,b,v){return this.channel.call("typeInEditor",[g,b,v])}getTerminalBuffer(g,b){return this.channel.call("getTerminalBuffer",[g,b])}writeInTerminal(g,b,v){return this.channel.call("writeInTerminal",[g,b,v])}}e.DriverChannelClient=k;class y{constructor(g){this.registry=g}listen(g,b){throw new Error(`Event not found: ${b}`)}call(g,b,v){switch(b){case"registerWindowDriver":return this.registry.registerWindowDriver(v);case"reloadWindowDriver":return this.registry.reloadWindowDriver(v)}throw new Error(`Call not found: ${b}`)}}e.WindowDriverRegistryChannel=y;class P{constructor(g){this.channel=g}registerWindowDriver(g){return this.channel.call("registerWindowDriver",g)}reloadWindowDriver(g){return this.channel.call("reloadWindowDriver",g)}}e.WindowDriverRegistryChannelClient=P;class r{constructor(g){this.driver=g}listen(g,b){throw new Error(`No event found: ${b}`)}call(g,b,v){switch(b){case"click":return this.driver.click(v[0],v[1],v[2]);case"doubleClick":return this.driver.doubleClick(v);case"setValue":return this.driver.setValue(v[0],v[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(v);case"getElements":return this.driver.getElements(v[0],v[1]);case"getElementXY":return this.driver.getElementXY(v[0],v[1],v[2]);case"typeInEditor":return this.driver.typeInEditor(v[0],v[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(v);case"writeInTerminal":return this.driver.writeInTerminal(v[0],v[1])}throw new Error(`Call not found: ${b}`)}}e.WindowDriverChannel=r;class p{constructor(g){this.channel=g}click(g,b,v){return this.channel.call("click",[g,b,v])}doubleClick(g){return this.channel.call("doubleClick",g)}setValue(g,b){return this.channel.call("setValue",[g,b])}getTitle(){return this.channel.call("getTitle")}isActiveElement(g){return this.channel.call("isActiveElement",g)}getElements(g,b){return this.channel.call("getElements",[g,b])}getElementXY(g,b,v){return this.channel.call("getElementXY",[g,b,v])}typeInEditor(g,b){return this.channel.call("typeInEditor",[g,b])}getTerminalBuffer(g){return this.channel.call("getTerminalBuffer",g)}writeInTerminal(g,b){return this.channel.call("writeInTerminal",[g,b])}}e.WindowDriverChannelClient=p;async function i(L){const g=await(0,m.connect)(L,"driverClient"),b=g.getChannel("driver"),v=new k(b);return{client:g,driver:v}}e.connect=i}),define(X[26],J([0,1,8,53,4,46,155,56]),function(j,e,m,D,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,k.refineServiceDecorator)(y.IEnvironmentService);class p extends P.NativeEnvironmentService{get cachedLanguagesPath(){return(0,m.join)(this.userDataPath,"clp")}get backupHome(){return(0,m.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,m.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,r.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get nodeCachedDataDir(){return process.env.VSCODE_NODE_CACHED_DATA_DIR||void 0}get chromeCachedDataDir(){return(0,m.join)(this.userDataPath,"Code Cache")}}ce([D.memoize],p.prototype,"cachedLanguagesPath",null),ce([D.memoize],p.prototype,"backupHome",null),ce([D.memoize],p.prototype,"backupWorkspacesPath",null),ce([D.memoize],p.prototype,"mainIPCHandle",null),ce([D.memoize],p.prototype,"sandbox",null),ce([D.memoize],p.prototype,"driverVerbose",null),ce([D.memoize],p.prototype,"disableUpdates",null),ce([D.memoize],p.prototype,"disableKeytar",null),ce([D.memoize],p.prototype,"nodeCachedDataDir",null),ce([D.memoize],p.prototype,"chromeCachedDataDir",null),e.EnvironmentMainService=p}),define(X[212],J([0,1,18,58,8,3,19,50,26,21,24,6,29,7,30,10,15]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let E=class{constructor(c,a,h){this.configurationService=a,this.logService=h,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=I.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,n)=>(0,d.isEqual)(t,n,!y.isLinux)},this.backupHome=c.backupHome,this.workspacesJsonPath=c.backupWorkspacesPath}async initialize(){let c;try{c=JSON.parse(await m.promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){c=Object.create(null)}c.emptyWorkspaceInfos&&(this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos));let a=[];try{Array.isArray(c.rootURIWorkspaces)&&(a=c.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:v.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(a);let h=[];try{Array.isArray(c.folderURIWorkspaces)&&(h=c.folderURIWorkspaces.map(t=>v.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(h),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==L.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===L.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var c;const a=this.configurationService.getValue();return((c=a==null?void 0:a.files)===null||c===void 0?void 0:c.hotExit)||L.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(c,a){this.workspaces.some(t=>c.workspace.id===t.workspace.id)||(this.workspaces.push(c),this.saveSync());const h=this.getBackupPath(c.workspace.id);return a&&this.moveBackupFolderSync(h,a),h}moveBackupFolderSync(c,a){if(m.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),m.existsSync(a))try{m.renameSync(a,c)}catch(h){this.logService.error(`Backup: Could not move backup folder to new location: ${h.toString()}`)}}unregisterWorkspaceBackupSync(c){const a=c.id,h=this.workspaces.findIndex(t=>t.workspace.id===a);h!==-1&&(this.workspaces.splice(h,1),this.saveSync())}registerFolderBackupSync(c){return this.folders.some(a=>this.backupUriComparer.isEqual(c,a))||(this.folders.push(c),this.saveSync()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackupSync(c){const a=this.folders.findIndex(h=>this.backupUriComparer.isEqual(c,h));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(c,a){const h=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,h))||(this.emptyWindows.push({backupFolder:h,remoteAuthority:a}),this.saveSync()),this.getBackupPath(h)}unregisterEmptyWindowBackupSync(c){const a=this.emptyWindows.findIndex(h=>!!h.backupFolder&&this.backupPathComparer.isEqual(h.backupFolder,c));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(c){return(0,k.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const a=new Set,h=[];for(let t of c){const n=t.workspace;if(!(0,b.isWorkspaceIdentifier)(n))return[];if(!a.has(n.id)){a.add(n.id);const s=this.getBackupPath(n.id);await this.doHasBackups(s)?n.configPath.scheme!==w.Schemas.file||await(0,P.exists)(n.configPath.fsPath)?h.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return h}async validateFolders(c){if(!Array.isArray(c))return[];const a=[],h=new Set;for(let t of c){const n=this.backupUriComparer.getComparisonKey(t);if(!h.has(n)){h.add(n);const s=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(s)?t.scheme!==w.Schemas.file||await(0,P.exists)(t.fsPath)?a.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return a}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const a=[],h=new Set;for(let t of c){const n=t.backupFolder;if(typeof n!="string")return[];if(!h.has(n)){h.add(n);const s=this.getBackupPath(n);await this.doHasBackups(s)?a.push(t):await this.deleteStaleBackup(s)}}return a}async deleteStaleBackup(c){try{await(0,P.exists)(c)&&await(0,P.rimraf)(c,P.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a));)a=this.getRandomEmptyWindowId();const h=this.getBackupPath(a);try{await m.promises.rename(c,h)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a));)a=this.getRandomEmptyWindowId();const h=this.getBackupPath(a);try{m.renameSync(c,h)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const c=[];for(const a of this.workspaces)await this.hasBackups(a)&&c.push(a.workspace);for(const a of this.folders)await this.hasBackups(a)&&c.push(a);return c}hasBackups(c){let a;return v.URI.isUri(c)?a=this.getBackupPath(this.getFolderHash(c)):(0,r.isWorkspaceBackupInfo)(c)?a=this.getBackupPath(c.workspace.id):a=c.backupFolder,this.doHasBackups(a)}async doHasBackups(c){try{const a=await(0,P.readdir)(c);for(const h of a)try{if((await(0,P.readdir)((0,k.join)(c,h))).length>0)return!0}catch(t){}}catch(a){}return!1}saveSync(){try{(0,P.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}async save(){try{await(0,P.writeFile)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderURIWorkspaces:this.folders.map(c=>c.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){let a;return c.scheme===w.Schemas.file?a=y.isLinux?c.fsPath:c.fsPath.toLowerCase():a=c.toString().toLowerCase(),(0,D.createHash)("md5").update(a).digest("hex")}};E=ce([ee(0,p.IEnvironmentMainService),ee(1,i.IConfigurationService),ee(2,g.ILogService)],E),e.BackupMainService=E}),define(X[41],J([0,1,5,34,13,16,3,26,51,19,7,31,4,27,65,6,8,20,53,2]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w,I,E,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,b.createDecorator)("nativeHostMainService");let a=class st extends c.Disposable{constructor(t,n,s,l,u,f,S,A){super();this.sharedProcess=t,this.windowsMainService=n,this.dialogMainService=s,this.lifecycleMainService=l,this.environmentMainService=u,this.telemetryService=f,this.logService=S,this.productService=A,this.onDidOpenWindow=m.Event.map(this.windowsMainService.onDidOpenWindow,T=>T.id),this.onDidMaximizeWindow=m.Event.filter(m.Event.fromNodeEventEmitter(k.app,"browser-window-maximize",(T,U)=>U.id),T=>!!this.windowsMainService.getWindowById(T)),this.onDidUnmaximizeWindow=m.Event.filter(m.Event.fromNodeEventEmitter(k.app,"browser-window-unmaximize",(T,U)=>U.id),T=>!!this.windowsMainService.getWindowById(T)),this.onDidBlurWindow=m.Event.filter(m.Event.fromNodeEventEmitter(k.app,"browser-window-blur",(T,U)=>U.id),T=>!!this.windowsMainService.getWindowById(T)),this.onDidFocusWindow=m.Event.any(m.Event.map(m.Event.filter(m.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),T=>!!T),T=>T.id),m.Event.filter(m.Event.fromNodeEventEmitter(k.app,"browser-window-focus",(T,U)=>U.id),T=>!!this.windowsMainService.getWindowById(T))),this.onDidResumeOS=m.Event.fromNodeEventEmitter(k.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new m.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new m.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=m.Event.debounce(m.Event.any(m.Event.filter(m.Event.fromNodeEventEmitter(k.screen,"display-metrics-changed",(T,U,H)=>H),T=>!(Array.isArray(T)&&T.length===1&&T[0]==="workArea")),m.Event.fromNodeEventEmitter(k.screen,"display-added"),m.Event.fromNodeEventEmitter(k.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){k.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:k.nativeTheme.shouldUseInvertedColorScheme||k.nativeTheme.shouldUseHighContrastColors,dark:k.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(n=>{var s,l;return{id:n.id,workspace:n.openedWorkspace,title:(l=(s=n.win)===null||s===void 0?void 0:s.getTitle())!==null&&l!==void 0?l:"",filename:n.getRepresentedFilename(),dirty:n.isDocumentEdited()}})}async getWindowCount(t){return this.windowsMainService.getWindowCount()}async getActiveWindowId(t){const n=k.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(n)return n.id}openWindow(t,n,s){return Array.isArray(n)?this.doOpenWindow(t,n,s):this.doOpenEmptyWindow(t,n)}async doOpenWindow(t,n,s=Object.create(null)){n.length>0&&this.windowsMainService.open({context:5,contextWindowId:t,urisToOpen:n,cli:this.environmentMainService.args,forceNewWindow:s.forceNewWindow,forceReuseWindow:s.forceReuseWindow,preferNewWindow:s.preferNewWindow,diffMode:s.diffMode,addMode:s.addMode,gotoLineMode:s.gotoLineMode,noRecentEntry:s.noRecentEntry,waitMarkerFileURI:s.waitMarkerFileURI,remoteAuthority:s.remoteAuthority||void 0})}async doOpenEmptyWindow(t,n){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:t},n)}async toggleFullScreen(t){const n=this.windowById(t);n&&n.toggleFullScreen()}async handleTitleDoubleClick(t){const n=this.windowById(t);n&&n.handleTitleDoubleClick()}async isMaximized(t){const n=this.windowById(t);return(n==null?void 0:n.win)?n.win.isMaximized():!1}async maximizeWindow(t){const n=this.windowById(t);(n==null?void 0:n.win)&&n.win.maximize()}async unmaximizeWindow(t){const n=this.windowById(t);(n==null?void 0:n.win)&&n.win.unmaximize()}async minimizeWindow(t){const n=this.windowById(t);(n==null?void 0:n.win)&&n.win.minimize()}async focusWindow(t,n){var s;n&&typeof n.windowId=="number"&&(t=n.windowId);const l=this.windowById(t);l&&l.focus({force:(s=n==null?void 0:n.force)!==null&&s!==void 0?s:!1})}async setMinimumSize(t,n,s){const l=this.windowById(t);if(l==null?void 0:l.win){const[u,f]=l.win.getSize(),[S,A]=l.win.getMinimumSize(),[T,U]=[n!=null?n:S,s!=null?s:A],[H,Q]=[Math.max(u,T),Math.max(f,U)];(S!==T||A!==U)&&l.win.setMinimumSize(T,U),(u!==H||f!==Q)&&l.win.setSize(H,Q)}}async showMessageBox(t,n){return this.dialogMainService.showMessageBox(n,this.toBrowserWindow(t))}async showSaveDialog(t,n){return this.dialogMainService.showSaveDialog(n,this.toBrowserWindow(t))}async showOpenDialog(t,n){return this.dialogMainService.showOpenDialog(n,this.toBrowserWindow(t))}toBrowserWindow(t){const n=this.windowById(t);if(n==null?void 0:n.win)return n.win}async pickFileFolderAndOpen(t,n){const s=await this.dialogMainService.pickFileFolder(n);s&&(this.sendPickerTelemetry(s,n.telemetryEventName||"openFileFolder",n.telemetryExtraData),this.doOpenPicked(await Promise.all(s.map(async l=>await i.SymlinkSupport.existsDirectory(l)?{folderUri:L.URI.file(l)}:{fileUri:L.URI.file(l)})),n,t))}async pickFolderAndOpen(t,n){const s=await this.dialogMainService.pickFolder(n);s&&(this.sendPickerTelemetry(s,n.telemetryEventName||"openFolder",n.telemetryExtraData),this.doOpenPicked(s.map(l=>({folderUri:L.URI.file(l)})),n,t))}async pickFileAndOpen(t,n){const s=await this.dialogMainService.pickFile(n);s&&(this.sendPickerTelemetry(s,n.telemetryEventName||"openFile",n.telemetryExtraData),this.doOpenPicked(s.map(l=>({fileUri:L.URI.file(l)})),n,t))}async pickWorkspaceAndOpen(t,n){const s=await this.dialogMainService.pickWorkspace(n);s&&(this.sendPickerTelemetry(s,n.telemetryEventName||"openWorkspace",n.telemetryExtraData),this.doOpenPicked(s.map(l=>({workspaceUri:L.URI.file(l)})),n,t))}doOpenPicked(t,n,s){this.windowsMainService.open({context:3,contextWindowId:s,cli:this.environmentMainService.args,urisToOpen:t,forceNewWindow:n.forceNewWindow})}sendPickerTelemetry(t,n,s){const l=t?t.length:0;this.telemetryService.publicLog(n,Object.assign(Object.assign({},s),{outcome:l?"success":"canceled",numberOfPaths:l}))}async showItemInFolder(t,n){k.shell.showItemInFolder(n)}async setRepresentedFilename(t,n){const s=this.windowById(t);s&&s.setRepresentedFilename(n)}async setDocumentEdited(t,n){const s=this.windowById(t);s&&s.setDocumentEdited(n)}async openExternal(t,n){return P.isLinuxSnap?this.safeSnapOpenExternal(n):k.shell.openExternal(n),!0}safeSnapOpenExternal(t){const n=process.env.GDK_PIXBUF_MODULE_FILE,s=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,k.shell.openExternal(t),process.env.GDK_PIXBUF_MODULE_FILE=n,process.env.GDK_PIXBUF_MODULEDIR=s}async moveItemToTrash(t,n){return k.shell.moveItemToTrash(n)}async isAdmin(){let t;return P.isWindows?t=(await new Promise((n,s)=>{j(["native-is-elevated"],n,s)}))():t=process.getuid()===0,t}async writeElevated(t,n,s,l){const u=await new Promise((f,S)=>{j(["sudo-prompt"],f,S)});return new Promise((f,S)=>{const A=[`"${this.cliPath}"`];(l==null?void 0:l.unlock)&&A.push("--file-chmod"),A.push("--file-write",`"${n.fsPath}"`,`"${s.fsPath}"`);const T={name:this.productService.nameLong.replace("-",""),icns:P.isMacintosh&&this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};u.exec(A.join(" "),T,(U,H,Q)=>{H&&this.logService.trace(`[sudo-prompt] received stdout: ${H}`),Q&&this.logService.trace(`[sudo-prompt] received stderr: ${Q}`),U?S(U):f(void 0)})})}get cliPath(){return P.isWindows?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):P.isLinux?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,I.join)(this.environmentMainService.appRoot,"bin","code"):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,v.totalmem)(),freemem:(0,v.freemem)(),loadavg:(0,v.loadavg)()}}async getOSProperties(){return{arch:(0,v.arch)(),platform:(0,v.platform)(),release:(0,v.release)(),type:(0,v.type)(),cpus:(0,v.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}async killProcess(t,n,s){process.kill(n,s)}async readClipboardText(t,n){return k.clipboard.readText(n)}async writeClipboardText(t,n,s){return k.clipboard.writeText(n,s)}async readClipboardFindText(t){return k.clipboard.readFindText()}async writeClipboardFindText(t,n){return k.clipboard.writeFindText(n)}async writeClipboardBuffer(t,n,s,l){return k.clipboard.writeBuffer(n,Buffer.from(s),l)}async readClipboardBuffer(t,n){return k.clipboard.readBuffer(n)}async hasClipboard(t,n,s){return k.clipboard.has(n,s)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){k.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){k.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){k.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){k.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){k.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(t,n){const s=this.windowById(t);s&&s.updateTouchBar(n)}async notifyReady(t){const n=this.windowById(t);n&&n.setReady()}async relaunch(t,n){return this.lifecycleMainService.relaunch(n)}async reload(t,n){const s=this.windowById(t);if(s)return this.lifecycleMainService.reload(s,(n==null?void 0:n.disableExtensions)!==void 0?{_:[],"disable-extensions":n==null?void 0:n.disableExtensions}:void 0)}async closeWindow(t){this.closeWindowById(t,t)}async closeWindowById(t,n){const s=this.windowById(n);if(s==null?void 0:s.win)return s.win.close()}async quit(t){const n=this.windowsMainService.getLastActiveWindow();(n==null?void 0:n.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&n.win?n.win.close():setTimeout(()=>{this.lifecycleMainService.quit()},10)}async exit(t,n){await this.lifecycleMainService.kill(n)}async resolveProxy(t,n){var s,l;const u=this.windowById(t),f=(l=(s=u==null?void 0:u.win)===null||s===void 0?void 0:s.webContents)===null||l===void 0?void 0:l.session;if(f)return f.resolveProxy(n)}async openDevTools(t,n){const s=this.windowById(t);(s==null?void 0:s.win)&&s.win.webContents.openDevTools(n)}async toggleDevTools(t){const n=this.windowById(t);(n==null?void 0:n.win)&&n.win.webContents.toggleDevTools()}async sendInputEvent(t,n){const s=this.windowById(t);(s==null?void 0:s.win)&&(n.type==="mouseDown"||n.type==="mouseUp")&&s.win.webContents.sendInputEvent(n)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(t,n,s,l){if(!!P.isWindows){const u=await new Promise((f,S)=>{j(["vscode-windows-registry"],f,S)});try{return u.GetStringRegKey(n,s,l)}catch(f){return}}}async getPassword(t,n,s){const l=await this.withKeytar(),u=await l.getPassword(n,s);if(u)try{let{content:f,hasNextChunk:S}=JSON.parse(u);if(!f||!S)return u;let A=1;for(;S;){const T=await l.getPassword(n,`${s}-${A}`),U=JSON.parse(T);f+=U.content,S=U.hasNextChunk}return f}catch(f){return u}return u}async setPassword(t,n,s,l){const u=await this.withKeytar();if(P.isWindows&&l.length>st.MAX_PASSWORD_LENGTH){let f=0,S=0,A=!0;for(;A;){const T=l.substring(f,f+st.PASSWORD_CHUNK_SIZE);f+=st.PASSWORD_CHUNK_SIZE,A=l.length-f>0;const U={content:T,hasNextChunk:A};await u.setPassword(n,S?`${s}-${S}`:s,JSON.stringify(U)),S++}}else await u.setPassword(n,s,l);this._onDidChangePassword.fire({service:n,account:s})}async deletePassword(t,n,s){const u=await(await this.withKeytar()).deletePassword(n,s);return u&&this._onDidChangePassword.fire({service:n,account:s}),u}async findPassword(t,n){return(await this.withKeytar()).findPassword(n)}async findCredentials(t,n){return(await this.withKeytar()).findCredentials(n)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((t,n)=>{j(["keytar"],t,n)})}windowById(t){if(typeof t=="number")return this.windowsMainService.getWindowById(t)}};a.MAX_PASSWORD_LENGTH=2500,a.PASSWORD_CHUNK_SIZE=a.MAX_PASSWORD_LENGTH-100,ce([o.memoize],a.prototype,"cliPath",null),a=ce([ee(1,D.IWindowsMainService),ee(2,p.IDialogMainService),ee(3,y.ILifecycleMainService),ee(4,r.IEnvironmentMainService),ee(5,g.ITelemetryService),ee(6,w.ILogService),ee(7,E.IProductService)],a),e.NativeHostMainService=a}),define(X[213],J([0,1,2,5,80,13,6,34,41,89,28,20,25]),function(j,e,m,D,k,y,P,r,p,i,L,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var v;(function(w){w[w.Initial=1]="Initial",w[w.StoredCredentialsUsed=2]="StoredCredentialsUsed",w[w.LoginDialogShown=3]="LoginDialogShown"})(v||(v={}));let d=class extends m.Disposable{constructor(I,E,o,c,a){super();this.logService=I,this.windowsMainService=E,this.nativeHostMainService=o,this.encryptionMainService=c,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=v.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const I=D.Event.fromNodeEventEmitter(y.app,"login",(E,o,c,a,h)=>({event:E,webContents:o,req:c,authInfo:a,callback:h}));this._register(I(this.onLogin,this))}async onLogin({event:I,authInfo:E,req:o,callback:c}){if(!!E.isProxy){if(!this.pendingProxyResolve&&this.state===v.LoginDialogShown&&o.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}I.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(E);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(a==null?void 0:a.username,a==null?void 0:a.password)}}async resolveProxyCredentials(I){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const E=await this.doResolveProxyCredentials(I);if(E)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),E;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(I){var E,o,c,a;this.logService.trace("auth#doResolveProxyCredentials - enter",I);const h=String((0,k.hash)({scheme:I.scheme,host:I.host,port:I.port}));let t,n;try{const f=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,h);if(f){const S=JSON.parse(await this.encryptionMainService.decrypt(f));t=S.username,n=S.password}}catch(f){this.logService.error(f)}if(this.state!==v.StoredCredentialsUsed&&typeof t=="string"&&typeof n=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=v.StoredCredentialsUsed,{username:t,password:n};const s=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!s){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${s.id} to handle proxy login`);const l={authInfo:I,username:(o=(E=this.sessionCredentials)===null||E===void 0?void 0:E.username)!==null&&o!==void 0?o:t,password:(a=(c=this.sessionCredentials)===null||c===void 0?void 0:c.password)!==null&&a!==void 0?a:n,replyChannel:`vscode:proxyAuthResponse:${(0,L.generateUuid)()}`};s.sendWhenReady("vscode:openProxyAuthenticationDialog",b.CancellationToken.None,l),this.state=v.LoginDialogShown;const u=await new Promise(f=>{var S;const A=async(T,U,H)=>{var Q;if(U===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${s.id}`),(Q=s.win)===null||Q===void 0||Q.webContents.off("ipc-message",A),H){const ne={username:H.username,password:H.password};try{if(H.remember){const ae=await this.encryptionMainService.encrypt(JSON.stringify(ne));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,h,ae)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,h)}catch(ae){this.logService.error(ae)}f({username:ne.username,password:ne.password})}else f(void 0)};(S=s.win)===null||S===void 0||S.webContents.on("ipc-message",A)});return this.sessionCredentials=u,u}};d=ce([ee(0,P.ILogService),ee(1,r.IWindowsMainService),ee(2,p.INativeHostMainService),ee(3,i.IEncryptionMainService),ee(4,g.IProductService)],d),e.ProxyAuthHandler=d}),define(X[214],J([0,1,211,34,56,2,33,57,170,3,5,79,103,9,16,41]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function I(c){return c<21}let E=class{constructor(a,h,t,n,s){this.windowServer=a,this.options=h,this.windowsMainService=t,this.lifecycleMainService=n,this.nativeHostMainService=s,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(a){return this.registeredWindowIds.add(a),this.reloadingWindowIds.delete(a),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(a){this.reloadingWindowIds.add(a)}async getWindowIds(){return this.windowsMainService.getWindows().map(a=>a.id).filter(a=>this.registeredWindowIds.has(a)&&!this.reloadingWindowIds.has(a))}async capturePage(a){await this.whenUnfrozen(a);const h=this.windowsMainService.getWindowById(a);if(!(h==null?void 0:h.win))throw new Error("Invalid window");return(await h.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(a){await this.whenUnfrozen(a);const h=this.windowsMainService.getWindowById(a);if(!h)throw new Error("Invalid window");this.reloadingWindowIds.add(a),this.lifecycleMainService.reload(h)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(a,h){await this.whenUnfrozen(a);const t=b.KeybindingParser.parseUserBinding(h);for(let n of t)await this._dispatchKeybinding(a,n)}async _dispatchKeybinding(a,h){if(h instanceof g.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const t=this.windowsMainService.getWindowById(a);if(!(t==null?void 0:t.win))throw new Error("Invalid window");const n=t.win.webContents,s=new r.SimpleKeybinding(!1,!1,!1,!1,h.keyCode),u=new p.USLayoutResolvedKeybinding(s.toChord(),i.OS).getElectronAccelerator(),f=[];h.ctrlKey&&f.push("ctrl"),h.metaKey&&f.push("meta"),h.shiftKey&&f.push("shift"),h.altKey&&f.push("alt"),n.sendInputEvent({type:"keyDown",keyCode:u,modifiers:f}),I(h.keyCode)||n.sendInputEvent({type:"char",keyCode:u,modifiers:f}),n.sendInputEvent({type:"keyUp",keyCode:u,modifiers:f}),await(0,v.timeout)(100)}async click(a,h,t,n){await(await this.getWindowDriver(a)).click(h,t,n)}async doubleClick(a,h){await(await this.getWindowDriver(a)).doubleClick(h)}async setValue(a,h,t){await(await this.getWindowDriver(a)).setValue(h,t)}async getTitle(a){return await(await this.getWindowDriver(a)).getTitle()}async isActiveElement(a,h){return await(await this.getWindowDriver(a)).isActiveElement(h)}async getElements(a,h,t){return await(await this.getWindowDriver(a)).getElements(h,t)}async getElementXY(a,h,t,n){return await(await this.getWindowDriver(a)).getElementXY(h,t,n)}async typeInEditor(a,h,t){await(await this.getWindowDriver(a)).typeInEditor(h,t)}async getTerminalBuffer(a,h){return await(await this.getWindowDriver(a)).getTerminalBuffer(h)}async writeInTerminal(a,h,t){await(await this.getWindowDriver(a)).writeInTerminal(h,t)}async getWindowDriver(a){await this.whenUnfrozen(a);const h=`window:${a}`,t=new P.StaticRouter(s=>s===h),n=this.windowServer.getChannel("windowDriver",t);return new m.WindowDriverChannelClient(n)}async whenUnfrozen(a){for(;this.reloadingWindowIds.has(a);)await L.Event.toPromise(this.onDidReloadingChange.event)}};E=ce([ee(2,D.IWindowsMainService),ee(3,d.ILifecycleMainService),ee(4,w.INativeHostMainService)],E),e.Driver=E;async function o(c,a,h,t){const n=h.driverVerbose,s=t.createInstance(E,c,{verbose:n}),l=new m.WindowDriverRegistryChannel(s);c.registerChannel("windowDriverRegistry",l);const u=await(0,k.serve)(a),f=new m.DriverChannel(s);return u.registerChannel("driver",f),(0,y.combinedDisposable)(u,c)}e.serve=o}),define(X[215],J([0,1,59,56]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,y,P,r){const p=L=>r(L,void 0),i=m.createConnection({host:k,port:y},()=>{i.removeListener("error",p);const L=Buffer.alloc(16);for(let d=0;d<16;d++)L[d]=Math.round(Math.random()*256);const g=L.toString("base64");let b=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${y}/?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];i.write(b.join(`\r
`)+`\r
\r
`);const v=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(i.off("data",v),r(void 0,new D.NodeSocket(i)))};i.on("data",v)});i.once("error",p)}}}),define(X[216],J([0,1,59,9,2,113,6,20,184,73,215,74]),function(j,e,m,D,k,y,P,r,p,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function b(I,E,o,c){return new v(I,E,o,c).waitForReady()}class v extends k.Disposable{constructor(E,o,c,a){super();this.suggestedLocalPort=a,this.public=!1,this._socketsDispose=new Map,this._options=E,this._server=m.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=h=>this._onConnection(h),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(o=>{o()})}async waitForReady(){var E;let o=await(0,y.findFreePortFaster)((E=this.suggestedLocalPort)!==null&&E!==void 0?E:this.tunnelRemotePort,2,1e3),c=null;return c=this._server.listen(o).address(),c||(o=0,c=this._server.listen(o).address()),this.tunnelLocalPort=c.port,await this._barrier.wait(),this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(E){E.pause();const o=await(0,p.connectRemoteAgentTunnel)(this._options,this.tunnelRemotePort),c=o.getSocket().socket,a=o.readEntireBuffer();o.dispose(),a.byteLength>0&&E.write(a.buffer),E.on("end",()=>{this._socketsDispose.delete(E.localAddress),c.end()}),E.on("close",()=>c.end()),E.on("error",()=>{this._socketsDispose.delete(E.localAddress),c.destroy()}),c.on("end",()=>E.end()),c.on("close",()=>E.end()),c.on("error",()=>{E.destroy()}),E.pipe(c),c.pipe(E),this._socketsDispose.set(E.localAddress,()=>{E.end(),c.end()})}}let d=class extends i.AbstractTunnelService{constructor(E,o,c,a){super(o);this.socketFactory=E,this.signService=c,this.productService=a}retainOrCreateTunnel(E,o,c,a,h,t){const n=this.getTunnelFromMap(o,c);if(n)return++n.refcount,n.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,o,c,a,h,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${c} on local port ${a}.`);const s={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:E,signService:this.signService,logService:this.logService,ipcLogger:null},l=b(s,o,c,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(o,c,l),l}}};d=ce([ee(1,P.ILogService),ee(2,g.ISignService),ee(3,r.IProductService)],d),e.BaseTunnelService=d;let w=class extends d{constructor(E,o,c){super(L.nodeSocketFactory,E,o,c)}};w=ce([ee(0,P.ILogService),ee(1,g.ISignService),ee(2,r.IProductService)],w),e.TunnelService=w}),define(X[217],J([0,1,210,186,2,12,17,185,21,6,23,46,69]),function(j,e,m,D,k,y,P,r,p,i,L,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let v=class extends k.Disposable{constructor(w,I,E){super();this.environmentService=I,this.logService=E,this.configure(w.getValue()),this._register(w.onDidChangeConfiguration(()=>this.configure(w.getValue()),this))}configure(w){this.proxyUrl=w.http&&w.http.proxy,this.strictSSL=!!(w.http&&w.http.proxyStrictSSL),this.authorization=w.http&&w.http.proxyAuthorization}async request(w,I){this.logService.trace("RequestService#request",w.url);const{proxyUrl:E,strictSSL:o}=this,c=Object.assign(Object.assign({},process.env),await(0,b.resolveShellEnv)(this.logService,this.environmentService.args,process.env)),a=w.agent?w.agent:await(0,r.getProxyAgent)(w.url||"",c,{proxyUrl:E,strictSSL:o});return w.agent=a,w.strictSSL=o,this.authorization&&(w.headers=Object.assign(Object.assign({},w.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(w,I)}async getNodeRequest(w){return((0,D.parse)(w.url).protocol==="https:"?await new Promise((o,c)=>{j(["https"],o,c)}):await new Promise((o,c)=>{j(["http"],o,c)})).request}_request(w,I){return new Promise(async(E,o)=>{let c;const a=(0,D.parse)(w.url),h=w.getRawRequest?w.getRawRequest(w):await this.getNodeRequest(w),t={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:w.type||"GET",headers:w.headers,agent:w.agent,rejectUnauthorized:(0,y.isBoolean)(w.strictSSL)?w.strictSSL:!0};w.user&&w.password&&(t.auth=w.user+":"+w.password),c=h(t,n=>{const s=(0,y.isNumber)(w.followRedirects)?w.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)this._request(Object.assign(Object.assign({},w),{url:n.headers.location,followRedirects:s-1}),I).then(E,o);else{let l=n;n.headers["content-encoding"]==="gzip"&&(l=n.pipe((0,m.createGunzip)())),E({res:n,stream:(0,L.streamToBufferReadableStream)(l)})}}),c.on("error",o),w.timeout&&c.setTimeout(w.timeout),w.data&&typeof w.data=="string"&&c.write(w.data),c.end(),I.onCancellationRequested(()=>{c.abort(),o((0,P.canceled)())})})}async resolveProxy(w){}};v=ce([ee(0,p.IConfigurationService),ee(1,g.INativeEnvironmentService),ee(2,i.ILogService)],v),e.RequestService=v}),define(X[218],J([0,1,217,13]),function(j,e,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(P){return D.net.request}class y extends m.RequestService{request(r,p){return super.request(Object.assign(Object.assign({},r||{}),{getRawRequest:k}),p)}}e.RequestMainService=y}),define(X[219],J([0,1,47,13,26,9,6,16,75,10,3,2,84,12,5,69,55]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let E=class extends g.Disposable{constructor(c,a,h,t,n,s,l){super();this.machineId=c,this.userEnv=a,this.environmentMainService=h,this.lifecycleMainService=t,this.logService=n,this.themeMainService=s,this.protocolMainService=l,this.firstWindowConnectionBarrier=new y.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new d.Emitter),this.onDidError=d.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),D.ipcMain.on("vscode:createSharedProcessMessageChannel",async(c,a)=>this.onWindowConnection(c,a))}async onWindowConnection(c,a){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const h=await this.connect();if(c.sender.isDestroyed())return h.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",a,[h])}onWillShutdown(){const c=this.window;!c||(!c.isDestroyed()&&!c.webContents.isDestroyed()&&c.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch(a){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>D.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.userEnv=Object.assign(Object.assign({},this.userEnv),await(0,w.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env)),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>D.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new D.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:i.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`],v8CacheOptions:L.browserCodeLoadingCacheStrategy,nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default}),this.window.loadURL(i.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{var a;this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),((a=this.window)===null||a===void 0?void 0:a.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,a)=>this._onDidError.fire({type:2,details:a})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1,details:"SharedProcess: detected unresponsive window"})),this.window.webContents.on("did-fail-load",(c,a,h)=>this._onDidError.fire({type:3,details:`SharedProcess: failed to load: ${h}`})))}async connect(){await this.whenIpcReady;const c=(0,v.assertIsDefined)(this.window);return(0,b.connect)(c)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){var c,a;return(a=(c=this.window)===null||c===void 0?void 0:c.isVisible())!==null&&a!==void 0?a:!1}};E=ce([ee(2,k.IEnvironmentMainService),ee(3,r.ILifecycleMainService),ee(4,P.ILogService),ee(5,p.IThemeMainService),ee(6,I.IProtocolMainService)],E),e.SharedProcess=E}),define(X[77],J([0,1,5,9,21,16,20,40,26,6,49,25]),function(j,e,m,D,k,y,P,r,p,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(d,w,I){return`${I.updateUrl}/api/update/${d}/${w}/${I.commit}`}e.createUpdateURL=b;let v=class{constructor(w,I,E,o,c,a){this.lifecycleMainService=w,this.configurationService=I,this.environmentMainService=E,this.requestService=o,this.logService=c,this.productService=a,this._state=r.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}initialize(){if(!!this.environmentMainService.isBuilt){if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const w=(0,k.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),I=this.getProductQuality(w);if(!I){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(I),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(r.State.Idle(this.getUpdateType())),w==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(null),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,E=>this.logService.error(E))}}getProductQuality(w){return w==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(w=60*60*1e3){return(0,D.timeout)(w).then(()=>this.checkForUpdates(null)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(w){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},g.CancellationToken.None).then(w=>w.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};v=ce([ee(0,y.ILifecycleMainService),ee(1,k.IConfigurationService),ee(2,p.IEnvironmentMainService),ee(3,L.IRequestService),ee(4,i.ILogService),ee(5,P.IProductService)],v),e.AbstractUpdateService=v}),define(X[220],J([0,1,13,2,5,53,21,16,40,31,26,6,77,49,20]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=class extends b.AbstractUpdateService{constructor(E,o,c,a,h,t,n){super(E,o,a,h,t,n);this.telemetryService=c,this.disposables=new D.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(m.autoUpdater,"error",(E,o)=>o)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(m.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(m.autoUpdater,"update-available",(E,o,c)=>({url:o,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(m.autoUpdater,"update-downloaded",(E,o,c,a)=>({releaseNotes:o,version:c,productVersion:c,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(E){this.logService.error("UpdateService error:",E);const c=(this.state.type==="checking for updates"?!!this.state.context:!0)?E:void 0;this.setState(p.State.Idle(1,c))}buildUpdateFeedUrl(E){let o;this.productService.darwinUniversalAssetId?o=this.productService.darwinUniversalAssetId:o=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,b.createUpdateURL)(o,E,this.productService);try{m.autoUpdater.setFeedURL({url:c})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return c}doCheckForUpdates(E){this.setState(p.State.CheckingForUpdates(E)),m.autoUpdater.checkForUpdates()}onUpdateAvailable(E){this.state.type==="checking for updates"&&this.setState(p.State.Downloading(E))}onUpdateDownloaded(E){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:E.version}),this.setState(p.State.Ready(E)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!this.state.context}),this.setState(p.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),m.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ce([y.memoize],w.prototype,"onRawError",null),ce([y.memoize],w.prototype,"onRawUpdateNotAvailable",null),ce([y.memoize],w.prototype,"onRawUpdateAvailable",null),ce([y.memoize],w.prototype,"onRawUpdateDownloaded",null),w=ce([ee(0,r.ILifecycleMainService),ee(1,P.IConfigurationService),ee(2,i.ITelemetryService),ee(3,L.IEnvironmentMainService),ee(4,v.IRequestService),ee(5,g.ILogService),ee(6,d.IProductService)],w),e.DarwinUpdateService=w}),define(X[221],J([0,1,20,21,16,40,31,26,6,77,49,25,41]),function(j,e,m,D,k,y,P,r,p,i,L,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let v=class extends i.AbstractUpdateService{constructor(w,I,E,o,c,a,h,t){super(w,I,o,c,a,t);this.telemetryService=E,this.nativeHostMainService=h}buildUpdateFeedUrl(w){return(0,i.createUpdateURL)(`linux-${process.arch}`,w,this.productService)}doCheckForUpdates(w){!this.url||(this.setState(y.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},g.CancellationToken.None).then(L.asJson).then(I=>{!I||!I.url||!I.version||!I.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(y.State.Idle(1))):this.setState(y.State.AvailableForDownload(I))}).then(void 0,I=>{this.logService.error(I),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w});const E=w?I.message||I:void 0;this.setState(y.State.Idle(1,E))}))}async doDownloadUpdate(w){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(y.State.Idle(1))}};v=ce([ee(0,k.ILifecycleMainService),ee(1,D.IConfigurationService),ee(2,P.ITelemetryService),ee(3,r.IEnvironmentMainService),ee(4,L.IRequestService),ee(5,p.ILogService),ee(6,b.INativeHostMainService),ee(7,m.IProductService)],v),e.LinuxUpdateService=v}),define(X[222],J([0,1,5,9,16,40,26,6,8,18,45,31]),function(j,e,m,D,k,y,P,r,p,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{constructor(w,I,E){if(this.lifecycleMainService=w,this.logService=E,this._state=y.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,I.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(y.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,o=>this.logService.error(o))}get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}scheduleCheckForUpdates(w=60*60*1e3){return(0,D.timeout)(w).then(()=>this.checkForUpdates(null)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(w){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};b=ce([ee(0,k.ILifecycleMainService),ee(1,P.IEnvironmentMainService),ee(2,r.ILogService)],b);let v=class extends b{constructor(w,I,E,o,c,a){super(E,o,c);this.snap=w,this.snapRevision=I,this.telemetryService=a;const h=(0,i.watch)(p.dirname(this.snap)),t=m.Event.fromNodeEventEmitter(h,"change",(u,f)=>f),n=m.Event.filter(t,u=>u==="current"),l=m.Event.debounce(n,(u,f)=>f,2e3)(this.checkForUpdates,this);E.onWillShutdown(()=>{l.dispose(),h.close()})}doCheckForUpdates(w){this.setState(y.State.CheckingForUpdates(w)),this.isUpdateAvailable().then(I=>{I?this.setState(y.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(y.State.Idle(2)))},I=>{this.logService.error(I),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(y.State.Idle(2,I.message||I))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,L.spawn)("sleep 3 && "+p.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const w=await new Promise((E,o)=>(0,i.realpath)(`${p.dirname(this.snap)}/current`,(c,a)=>c?o(c):E(a))),I=p.basename(w);return this.snapRevision!==I}isLatestVersion(){return this.isUpdateAvailable().then(void 0,w=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};v=ce([ee(2,k.ILifecycleMainService),ee(3,P.IEnvironmentMainService),ee(4,r.ILogService),ee(5,g.ITelemetryService)],v),e.SnapUpdateService=v}),define(X[223],J([0,1,18,8,19,53,21,16,20,40,31,26,6,77,49,109,27,45,25,9,24,7,41]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w,I,E,o,c,a,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function n(f,S=1e3){for(;!f();)await(0,c.timeout)(S)}let s;function l(){return typeof s=="undefined"&&(s=m.existsSync(D.join(D.dirname(process.execPath),"unins000.exe"))?0:1),s}let u=class extends v.AbstractUpdateService{constructor(S,A,T,U,H,Q,ne,ae,O){super(S,A,U,H,Q,O);this.telemetryService=T,this.fileService=ne,this.nativeHostMainService=ae}get cachePath(){const S=D.join((0,I.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return m.promises.mkdir(S,{recursive:!0}).then(()=>S)}initialize(){super.initialize(),l()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(S){let A="win32";return process.arch!=="ia32"&&(A+=`-${process.arch}`),l()===1?A+="-archive":this.productService.target==="user"&&(A+="-user"),(0,v.createUpdateURL)(A,S,this.productService)}doCheckForUpdates(S){!this.url||(this.setState(i.State.CheckingForUpdates(S)),this.requestService.request({url:this.url},o.CancellationToken.None).then(d.asJson).then(A=>{const T=l();return!A||!A.url||!A.version||!A.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S}),this.setState(i.State.Idle(T)),Promise.resolve(null)):T===1?(this.setState(i.State.AvailableForDownload(A)),Promise.resolve(null)):(this.setState(i.State.Downloading(A)),this.cleanup(A.version).then(()=>this.getUpdatePackagePath(A.version).then(U=>k.exists(U).then(H=>{if(H)return Promise.resolve(U);const Q=A.url,ne=A.hash,ae=`${U}.tmp`;return this.requestService.request({url:Q},o.CancellationToken.None).then(O=>this.fileService.writeFile(h.URI.file(ae),O.stream)).then(ne?()=>(0,w.checksum)(ae,A.hash):()=>{}).then(()=>m.promises.rename(ae,U)).then(()=>U)})).then(U=>{const H=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:U},H&&A.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(i.State.Downloaded(A)):this.setState(i.State.Ready(A))})))}).then(void 0,A=>{this.logService.error(A),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S});const T=S?A.message||A:void 0;this.setState(i.State.Idle(l(),T))}))}async doDownloadUpdate(S){S.update.url&&this.nativeHostMainService.openExternal(void 0,S.update.url),this.setState(i.State.Idle(l()))}async getUpdatePackagePath(S){const A=await this.cachePath;return D.join(A,`CodeSetup-${this.productService.quality}-${S}.exe`)}async cleanup(S=null){const A=S?Q=>!new RegExp(`${this.productService.quality}-${S}\\.exe$`).test(Q):()=>!0,T=await this.cachePath,H=(await k.readdir(T)).filter(A).map(async Q=>{try{await m.promises.unlink(D.join(T,Q))}catch(ne){}});await Promise.all(H)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const S=this.state.update;this.setState(i.State.Updating(S));const A=await this.cachePath;this.availableUpdate.updateFilePath=D.join(A,`CodeSetup-${this.productService.quality}-${S.version}.flag`),await k.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,E.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(i.State.Idle(l()))});const U=`${this.productService.win32MutexName}-ready`,H=await new Promise((Q,ne)=>{j(["windows-mutex"],Q,ne)});n(()=>H.isActive(U)).then(()=>this.setState(i.State.Ready(S)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?m.unlinkSync(this.availableUpdate.updateFilePath):(0,E.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return l()}};ce([y.memoize],u.prototype,"cachePath",null),u=ce([ee(0,r.ILifecycleMainService),ee(1,P.IConfigurationService),ee(2,L.ITelemetryService),ee(3,g.IEnvironmentMainService),ee(4,d.IRequestService),ee(5,b.ILogService),ee(6,a.IFileService),ee(7,t.INativeHostMainService),ee(8,p.IProductService)],u),e.Win32UpdateService=u}),define(X[52],J([0,1,29,26,8,19,18,3,5,6,58,43,10,2,15,4,149,20,13,12,50,51,98]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w,I,E,o,c,a,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,w.createDecorator)("workspacesManagementMainService");let n=class extends v.Disposable{constructor(f,S,A,T,U){super();this.environmentMainService=f,this.logService=S,this.backupMainService=A,this.dialogMainService=T,this.productService=U,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new p.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new p.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(f){if(!this.isWorkspacePath(f)||f.scheme!==b.Schemas.file)return null;let S;try{S=(0,P.readFileSync)(f.fsPath,"utf8")}catch(A){return null}return this.doResolveWorkspace(f,S)}isWorkspacePath(f){return(0,m.isUntitledWorkspace)(f,this.environmentMainService)||(0,m.hasWorkspaceFileExtension)(f)}doResolveWorkspace(f,S){try{const A=this.doParseStoredWorkspace(f,S),T=s(f);return{id:T.id,configPath:T.configPath,folders:(0,m.toWorkspaceFolders)(A.folders,T.configPath,d.extUriBiasedIgnorePathCase),remoteAuthority:A.remoteAuthority}}catch(A){this.logService.warn(A.toString())}return null}doParseStoredWorkspace(f,S){const A=(0,g.parse)(S);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(T=>(0,m.isStoredWorkspaceFolder)(T));else throw new Error(`${f.toString(!0)} looks like an invalid workspace file.`);return A}async createUntitledWorkspace(f,S){const{workspace:A,storedWorkspace:T}=this.newUntitledWorkspace(f,S),U=A.configPath.fsPath;return await P.promises.mkdir((0,k.dirname)(U),{recursive:!0}),await(0,y.writeFile)(U,JSON.stringify(T,null,"	")),A}createUntitledWorkspaceSync(f,S){const{workspace:A,storedWorkspace:T}=this.newUntitledWorkspace(f,S),U=A.configPath.fsPath;return(0,P.mkdirSync)((0,k.dirname)(U),{recursive:!0}),(0,y.writeFileSync)(U,JSON.stringify(T,null,"	")),A}newUntitledWorkspace(f=[],S){const A=(Date.now()+Math.round(Math.random()*1e3)).toString(),T=(0,d.joinPath)(this.untitledWorkspacesHome,A),U=(0,d.joinPath)(T,m.UNTITLED_WORKSPACE_NAME),H=[];for(const Q of f)H.push((0,m.getStoredWorkspaceFolder)(Q.uri,!0,Q.name,T,!r.isWindows,d.extUriBiasedIgnorePathCase));return{workspace:s(U),storedWorkspace:{folders:H,remoteAuthority:S}}}async getWorkspaceIdentifier(f){return s(f)}isUntitledWorkspace(f){return(0,m.isUntitledWorkspace)(f.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(f){!this.isUntitledWorkspace(f)||(this.doDeleteUntitledWorkspaceSync(f),this._onDidDeleteUntitledWorkspace.fire(f))}async deleteUntitledWorkspace(f){this.deleteUntitledWorkspaceSync(f)}doDeleteUntitledWorkspaceSync(f){const S=(0,d.originalFSPath)(f.configPath);try{(0,y.rimrafSync)((0,k.dirname)(S));const A=(0,k.join)(this.environmentMainService.workspaceStorageHome.fsPath,f.id);(0,P.existsSync)(A)&&(0,y.writeFileSync)((0,k.join)(A,"obsolete"),"")}catch(A){this.logService.warn(`Unable to delete untitled workspace ${S} (${A}).`)}}getUntitledWorkspacesSync(){const f=[];try{const S=(0,y.readdirSync)(this.untitledWorkspacesHome.fsPath).map(A=>(0,d.joinPath)(this.untitledWorkspacesHome,A,m.UNTITLED_WORKSPACE_NAME));for(const A of S){const T=s(A),U=this.resolveLocalWorkspaceSync(A);U?f.push({workspace:T,remoteAuthority:U.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(T)}}catch(S){S.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${S}).`)}return f}async enterWorkspace(f,S,A){if(!f||!f.win||!f.isReady||!await this.isValidTargetWorkspacePath(f,S,A))return null;const U=this.doEnterWorkspace(f,s(A));return U?(this._onDidEnterWorkspace.fire({window:f,workspace:U.workspace}),U):null}async isValidTargetWorkspacePath(f,S,A){if(!A)return!0;if((0,m.isWorkspaceIdentifier)(f.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(f.openedWorkspace.configPath,A))return!1;if((0,t.findWindowOnWorkspaceOrFolder)(S,A)){const T={title:this.productService.nameLong,type:"info",buttons:[(0,I.localize)(0,null)],message:(0,I.localize)(1,null,(0,d.basename)(A)),detail:(0,I.localize)(2,null),noLink:!0};return await this.dialogMainService.showMessageBox(T,(0,c.withNullAsUndefined)(o.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(f,S){if(!f.config)return null;f.focus();let A;return f.config.extensionDevelopmentPath||(A=this.backupMainService.registerWorkspaceBackupSync({workspace:S,remoteAuthority:f.remoteAuthority},f.config.backupPath)),(0,m.isWorkspaceIdentifier)(f.openedWorkspace)&&this.isUntitledWorkspace(f.openedWorkspace)&&this.deleteUntitledWorkspaceSync(f.openedWorkspace),f.config.workspace=S,f.config.backupPath=A,{workspace:S,backupPath:A}}};n=ce([ee(0,D.IEnvironmentMainService),ee(1,i.ILogService),ee(2,a.IBackupMainService),ee(3,h.IDialogMainService),ee(4,E.IProductService)],n),e.WorkspacesManagementMainService=n;function s(u){function f(){let S=u.scheme===b.Schemas.file?(0,d.originalFSPath)(u):u.toString();return r.isLinux||(S=S.toLowerCase()),(0,L.createHash)("md5").update(S).digest("hex")}return{id:f(),configPath:u}}e.getWorkspaceIdentifier=s;function l(u,f){function S(){if(u.scheme!==b.Schemas.file)return(0,L.createHash)("md5").update(u.toString()).digest("hex");if(!f)try{f=(0,P.statSync)(u.fsPath)}catch(U){return}let T;return r.isLinux?T=f.ino:r.isMacintosh?T=f.birthtime.getTime():r.isWindows&&(typeof f.birthtimeMs=="number"?T=Math.floor(f.birthtimeMs):T=f.birthtime.getTime()),(0,L.createHash)("md5").update(u.fsPath).update(T?String(T):"").digest("hex")}const A=S();if(typeof A=="string")return{id:A,uri:u}}e.getSingleFolderWorkspaceIdentifier=l}),define(X[99],J([0,1,6,96,3,4,34,19,52,21,7,13,35,54,25,29,12]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,y.createDecorator)(e.ID);let E=class{constructor(c,a,h,t,n){this.logService=c,this.windowsMainService=a,this.urlService=h,this.workspacesManagementMainService=t,this.configurationService=n}async start(c,a){this.logService.trace("Received data from other instance: ",c,a),k.isMacintosh&&g.app.focus({steal:!0});const h=this.parseOpenUrl(c);if(h.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:n,url:s}of h)this.urlService.open(n,{originalUrl:s})})}else return this.startOpenWindow(c,a)}parseOpenUrl(c){return c["open-url"]&&c._urls&&c._urls.length>0?(0,b.coalesce)(c._urls.map(a=>{try{return{uri:L.URI.parse(a),url:a}}catch(h){return null}})):[]}async startOpenWindow(c,a){const h=(0,v.isLaunchedFromCli)(a)?0:4;let t=[];const n=c.wait&&c.waitMarkerFilePath?L.URI.file(c.waitMarkerFilePath):void 0,s=c.remote||void 0;if(c.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(c.extensionDevelopmentPath,{context:h,cli:c,userEnv:a,waitMarkerFileURI:n,remoteAuthority:s});else if(!c._.length&&!c["folder-uri"]&&!c["file-uri"]){let l=!1;if(c["new-window"]||c["unity-launch"])l=!0;else if(c["reuse-window"])l=!1;else{const u=this.configurationService.getValue("window");switch((u==null?void 0:u.openWithoutArgumentsInNewWindow)||"default"){case"on":l=!0;break;case"off":l=!1;break;default:l=!k.isMacintosh}}if(l)t=this.windowsMainService.open({context:h,cli:c,userEnv:a,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:n,remoteAuthority:s});else{const u=this.windowsMainService.getLastActiveWindow();u?(u.focus(),t=[u]):t=this.windowsMainService.open({context:h,cli:c,forceEmpty:!0,remoteAuthority:s})}}else t=this.windowsMainService.open({context:h,cli:c,userEnv:a,forceNewWindow:c["new-window"],preferNewWindow:!c["reuse-window"]&&!c.wait,forceReuseWindow:c["reuse-window"],diffMode:c.diff,addMode:c.add,noRecentEntry:!!c["skip-add-to-recently-opened"],waitMarkerFileURI:n,gotoLineMode:c.goto,remoteAuthority:s});if(n&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,(0,r.whenDeleted)(n.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const c=[];return g.BrowserWindow.getAllWindows().forEach(a=>{const h=this.windowsMainService.getWindowById(a.id);h?c.push(this.codeWindowToInfo(h)):c.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:c,screenReader:!!g.app.accessibilitySupportEnabled,gpuFeatureStatus:g.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(c){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(t=>new Promise(n=>{const s=t.remoteAuthority;if(s){const l=`vscode:getDiagnosticInfoResponse${t.id}`,u={includeProcesses:c.includeProcesses,folders:c.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",d.CancellationToken.None,{replyChannel:l,args:u}),g.ipcMain.once(l,(f,S)=>{S||n({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),n(S)}),setTimeout(()=>{n({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else n(void 0)})))).filter(t=>!!t)}getFolderURIs(c){const a=[],h=c.openedWorkspace;if((0,w.isSingleFolderWorkspaceIdentifier)(h))a.push(h.uri);else if((0,w.isWorkspaceIdentifier)(h)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.configPath);t&&t.folders.forEach(s=>{a.push(s.uri)})}return a}codeWindowToInfo(c){const a=this.getFolderURIs(c),h=(0,I.assertIsDefined)(c.win);return this.browserWindowToInfo(h,a,c.remoteAuthority)}browserWindowToInfo(c,a=[],h){return{pid:c.webContents.getOSProcessId(),title:c.getTitle(),folderURIs:a,remoteAuthority:h}}};E=ce([ee(0,m.ILogService),ee(1,P.IWindowsMainService),ee(2,D.IURLService),ee(3,p.IWorkspacesManagementMainService),ee(4,i.IConfigurationService)],E),e.LaunchMainService=E}),define(X[224],J([0,1,140,27,47,13,99,68,26,3,6,82,51,4,60,10,41,55,2]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w,I,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,v.createDecorator)("issueMainService");let c=class pt{constructor(h,t,n,s,l,u,f,S){this.userEnv=h,this.environmentMainService=t,this.launchMainService=n,this.logService=s,this.diagnosticsService=l,this.dialogMainService=u,this.nativeHostMainService=f,this.protocolMainService=S,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){y.ipcMain.on("vscode:issueSystemInfoRequest",async h=>{const[t,n]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),s=await this.diagnosticsService.getSystemInfo(t,n);this.safeSend(h,"vscode:issueSystemInfoResponse",s)}),y.ipcMain.on("vscode:listProcesses",async h=>{const t=[];try{const n=await this.launchMainService.getMainProcessId();t.push({name:(0,m.localize)(0,null),rootProcess:await(0,g.listProcesses)(n)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(l=>{(0,r.isRemoteDiagnosticError)(l)?t.push({name:l.hostName,rootProcess:l}):l.processes&&t.push({name:l.hostName,rootProcess:l.processes})})}catch(n){this.logService.error(`Listing processes failed: ${n}`)}this.safeSend(h,"vscode:listProcessesResponse",t)}),y.ipcMain.on("vscode:issueReporterClipboard",async h=>{const t={message:(0,m.localize)(1,null),type:"warning",buttons:[(0,m.localize)(2,null),(0,m.localize)(3,null)]};if(this.issueReporterWindow){const n=await this.dialogMainService.showMessageBox(t,this.issueReporterWindow);this.safeSend(h,"vscode:issueReporterClipboardResponse",n.response===0)}}),y.ipcMain.on("vscode:issuePerformanceInfoRequest",async h=>{const t=await this.getPerformanceInfo();this.safeSend(h,"vscode:issuePerformanceInfoResponse",t)}),y.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const h={message:(0,m.localize)(4,null),type:"warning",buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null)]};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(h,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),y.ipcMain.on("vscode:workbenchCommand",(h,t)=>{const{id:n,from:s,args:l}=t;let u;switch(s){case"issueReporter":u=this.issueReporterParentWindow;break;case"processExplorer":u=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${s}`)}u&&u.webContents.send("vscode:runAction",{id:n,from:s,args:l})}),y.ipcMain.on("vscode:openExternal",(h,t)=>{this.nativeHostMainService.openExternal(void 0,t)}),y.ipcMain.on("vscode:closeIssueReporter",h=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),y.ipcMain.on("vscode:closeProcessExplorer",h=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),y.ipcMain.on("vscode:windowsInfoRequest",async h=>{const t=await this.launchMainService.getMainProcessInfo();this.safeSend(h,"vscode:windowsInfoResponse",t.windows)})}safeSend(h,t,...n){h.sender.isDestroyed()||h.sender.send(t,...n)}async openReporter(h){var t;if(!this.issueReporterWindow&&(this.issueReporterParentWindow=y.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const n=new o.DisposableStore,s=n.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,s,h.styles.backgroundColor,(0,m.localize)(7,null),h.zoomLevel),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:h,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,D.type)(),arch:(0,D.arch)(),release:(0,D.release)()},product:k.default}),this.issueReporterWindow.loadURL(w.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,n.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,n.dispose())})}(t=this.issueReporterWindow)===null||t===void 0||t.focus()}async openProcessExplorer(h){var t;if(!this.processExplorerWindow&&(this.processExplorerParentWindow=y.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const n=new o.DisposableStore,s=n.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,s,h.styles.backgroundColor,(0,m.localize)(8,null),h.zoomLevel),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:h,product:k.default}),this.processExplorerWindow.loadURL(w.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,n.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,n.dispose())})}(t=this.processExplorerWindow)===null||t===void 0||t.focus()}createBrowserWindow(h,t,n,s,l){const u=new y.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:h.width,height:h.height,minWidth:300,minHeight:200,x:h.x,y:h.y,title:s,backgroundColor:n||pt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:w.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`,"--context-isolation"],v8CacheOptions:i.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,d.zoomLevelToZoomFactor)(l),sandbox:!0,contextIsolation:!0}});return u.setMenuBarVisibility(!1),u}async getSystemStatus(){const[h,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(h,t)}getWindowPosition(h,t,n){let s;const l=y.screen.getAllDisplays();if(l.length===1)s=l[0];else{if(i.isMacintosh){const S=y.screen.getCursorScreenPoint();s=y.screen.getDisplayNearestPoint(S)}!s&&h&&(s=y.screen.getDisplayMatching(h.getBounds())),s||(s=y.screen.getPrimaryDisplay()||l[0])}const u={width:t,height:n},f=s.bounds;return u.x=f.x+f.width/2-u.width/2,u.y=f.y+f.height/2-u.height/2,f.width>0&&f.height>0&&(u.x<f.x&&(u.x=f.x),u.y<f.y&&(u.y=f.y),u.x>f.x+f.width&&(u.x=f.x),u.y>f.y+f.height&&(u.y=f.y),u.width>f.width&&(u.width=f.width),u.height>f.height&&(u.height=f.height)),u}async getPerformanceInfo(){try{const[h,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(h,t)}catch(h){throw this.logService.warn("issueService#getPerformanceInfo ",h.message),h}}};c.DEFAULT_BACKGROUND_COLOR="#1E1E1E",c=ce([ee(1,p.IEnvironmentMainService),ee(2,P.ILaunchMainService),ee(3,L.ILogService),ee(4,r.IDiagnosticsService),ee(5,b.IDialogMainService),ee(6,I.INativeHostMainService),ee(7,E.IProtocolMainService)],c),e.IssueMainService=c}),define(X[225],J([0,1,8,145,71,5,7,13,26,6,21,20,60,2,3,34,29,52,50,193,75,31,51,39,197,16,97,24,10,54,25,41,55]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w,I,E,o,c,a,h,t,n,s,l,u,f,S,A,T,U,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(ae){ae[ae.NONE=0]="NONE",ae[ae.LOADING=1]="LOADING",ae[ae.NAVIGATING=2]="NAVIGATING",ae[ae.READY=3]="READY"})(Q||(Q={}));let ne=class extends v.Disposable{constructor(O,$,z,C,q,N,_,R,W,M,F,B,V,G,Y){super();this.logService=$,this.environmentMainService=z,this.fileService=C,this.configurationService=N,this.themeMainService=_,this.workspacesManagementMainService=R,this.backupMainService=W,this.telemetryService=M,this.dialogMainService=F,this.lifecycleMainService=B,this.nativeHostMainService=V,this.productService=G,this.protocolMainService=Y,this._onWillLoad=this._register(new y.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new y.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new y.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new y.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.readyState=0;{const[Z,re]=this.restoreWindowState(O.state);this.windowState=Z,this.logService.trace("window#ctor: using window state",Z);const se=this.windowState.mode===0||this.windowState.mode===3,x=this.configurationService.getValue("window"),ie={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:b.WindowMinimumSize.WIDTH,minHeight:b.WindowMinimumSize.HEIGHT,show:!se,title:this.productService.nameLong,webPreferences:Object.assign({preload:S.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:d.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:(0,b.zoomLevelToZoomFactor)(x==null?void 0:x.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1})};d.browserCodeLoadingCacheStrategy?this.logService.info(`window#ctor: using vscode-file:// protocol and V8 cache options: ${d.browserCodeLoadingCacheStrategy}`):this.logService.trace("window#ctor: vscode-file:// protocol is explicitly disabled"),d.isLinux?ie.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):d.isWindows&&!this.environmentMainService.isBuilt&&(ie.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),d.isMacintosh&&!this.useNativeFullScreen()&&(ie.fullscreenable=!1),d.isMacintosh&&(ie.acceptFirstMouse=!0,(x==null?void 0:x.clickThroughInactive)===!1&&(ie.acceptFirstMouse=!1));const ue=d.isMacintosh&&(x==null?void 0:x.nativeTabs)===!0;ue&&(ie.tabbingIdentifier=this.productService.nameShort);const ye=(0,b.getTitleBarStyle)(this.configurationService)==="custom";if(ye&&(ie.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,d.isMacintosh||(ie.frame=!1)),(0,k.mark)("code/willCreateCodeBrowserWindow"),this._win=new r.BrowserWindow(ie),(0,k.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),d.isMacintosh&&ye&&this._win.setSheetOffset(22),d.isMacintosh&&re&&(!ue||r.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ge=>typeof ge=="number")){const ge=this.windowState;this._win.setBounds({width:ge.width,height:ge.height,x:ge.x,y:ge.y})}se&&((0,k.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,k.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,c.resolveMarketplaceHeaders)(this.productService.version,this.environmentMainService,this.fileService,{get:Z=>q.globalStorage.get(Z),store:(Z,re)=>q.globalStorage.set(Z,re)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var O;return(O=this.currentConfig)===null||O===void 0?void 0:O.backupPath}get openedWorkspace(){var O;return(O=this.currentConfig)===null||O===void 0?void 0:O.workspace}get remoteAuthority(){var O;return(O=this.currentConfig)===null||O===void 0?void 0:O.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var O;return!!((O=this.currentConfig)===null||O===void 0?void 0:O.extensionDevelopmentPath)}get isExtensionTestHost(){var O;return!!((O=this.currentConfig)===null||O===void 0?void 0:O.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var O;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((O=this.currentConfig)===null||O===void 0?void 0:O.debugId)}setRepresentedFilename(O){d.isMacintosh?this._win.setRepresentedFilename(O):this.representedFilename=O}getRepresentedFilename(){return d.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(O){d.isMacintosh&&this._win.setDocumentEdited(O),this.documentEdited=O}isDocumentEdited(){return d.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(O){d.isMacintosh&&(O==null?void 0:O.force)&&r.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(O=>{if(this.isReady)return O(this);this.whenReadyCallbacks.push(O)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(O=>{function $(){z.dispose(),C.dispose(),O()}const z=this.onDidClose(()=>$()),C=this.onWillLoad(()=>$())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(C,q)=>this.onWindowError(2,q)),this._win.webContents.on("did-fail-load",(C,q,N)=>this.onWindowError(3,N)),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const O=new Set([S.Schemas.file,S.Schemas.vscodeFileResource,S.Schemas.vscodeRemoteResource,"devtools"]),$=C=>C==null?void 0:C.startsWith(`${S.Schemas.vscodeWebview}://`);this._win.webContents.session.webRequest.onBeforeRequest((C,q)=>{var N;const _=P.URI.parse(C.url);if(_.path.endsWith(".svg")&&!(O.has(_.scheme)||_.path.includes(S.Schemas.vscodeRemoteResource))){const W=$((N=C.frame)===null||N===void 0?void 0:N.url);return q({cancel:!W})}return q({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((C,q)=>{var N;const _=C.responseHeaders,R=_["content-type"]||_["Content-Type"];if(R&&Array.isArray(R)){const W=P.URI.parse(C.url);if(W.path.endsWith(".svg")&&O.has(W.scheme))return _["Content-Type"]=["image/svg+xml"],q({cancel:!1,responseHeaders:_});if(!W.path.includes(S.Schemas.vscodeRemoteResource)&&R.some(M=>M.toLowerCase().includes("image/svg"))){const M=$((N=C.frame)===null||N===void 0?void 0:N.url);return q({cancel:!M})}}return q({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),d.isMacintosh&&this._register(this.nativeHostMainService.onDidChangeDisplay(()=>{!this._win||!this.useNativeFullScreen()&&this.isFullScreen&&(this.setFullScreen(!1),this.setFullScreen(!0))})),this._win.on("maximize",C=>{this.currentConfig&&(this.currentConfig.maximized=!0),r.app.emit("browser-window-maximize",C,this._win)}),this._win.on("unmaximize",C=>{this.currentConfig&&(this.currentConfig.maximized=!1),r.app.emit("browser-window-unmaximize",C,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",T.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",T.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(C=>this.onDidDeleteUntitledWorkspace(C)));const z=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:z},async(C,q)=>{const N=await this.marketplaceHeadersPromise;q({cancel:!1,requestHeaders:Object.assign(C.requestHeaders,N)})})}async onWindowError(O,$){switch(O){case 2:this.logService.error(`CodeWindow: renderer process crashed (detail: ${typeof $=="string"?$:$==null?void 0:$.reason})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load workbench window: ${typeof $=="string"?$:$==null?void 0:$.reason}`);break}if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:O,reason:typeof $!="string"?$==null?void 0:$.reason:void 0}),O===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,n.mnemonicButtonLabel)((0,D.localize)(0,null)),(0,n.mnemonicButtonLabel)((0,D.localize)(1,null)),(0,n.mnemonicButtonLabel)((0,D.localize)(2,null))],message:(0,D.localize)(3,null),detail:(0,D.localize)(4,null),noLink:!0},this._win);if(!this._win)return;z.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):z.response===2&&this.destroyWindow()}else if(O===2){let z;typeof $=="string"||!$?z=(0,D.localize)(5,null):z=(0,D.localize)(6,null,$.reason);const C=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,n.mnemonicButtonLabel)((0,D.localize)(7,null)),(0,n.mnemonicButtonLabel)((0,D.localize)(8,null))],message:z,detail:(0,D.localize)(9,null),noLink:!0},this._win);if(!this._win)return;C.response===0?this.reload():C.response===1&&this.destroyWindow()}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(O){var $;(($=this.openedWorkspace)===null||$===void 0?void 0:$.id)===O.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const O=this.getMenuBarVisibility();O!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=O,this.setMenuBarVisibility(O));let $=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;($==null?void 0:$.endsWith("/"))&&($=$.substr(0,$.length-1));const z=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if(($||"").indexOf("@")===-1&&($!==this.currentHttpProxy||z!==this.currentNoProxy)){this.currentHttpProxy=$,this.currentNoProxy=z;const C=$||"",q=z?`${z},<local>`:"<local>";this.logService.trace(`Setting proxy to '${C}', bypassing '${q}'`),this._win.webContents.session.setProxy({proxyRules:C,proxyBypassRules:q,pacScript:""})}}addTabbedWindow(O){d.isMacintosh&&O.win&&this._win.addTabbedWindow(O.win)}load(O,$=Object.create(null)){this.isDocumentEdited()&&(!$.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),$.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(O,$),this.readyState===0?this.currentConfig=O:(this.pendingLoadConfig=O,this.readyState=2),this._win.loadURL(S.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:O.workspace})}updateConfiguration(O,$){var z,C;const q=(C=(z=this.currentConfig)!==null&&z!==void 0?z:this.pendingLoadConfig)===null||C===void 0?void 0:C.userEnv;q&&(0,A.isLaunchedFromCli)(q)&&!(0,A.isLaunchedFromCli)(O.userEnv)&&(O.userEnv=Object.assign(Object.assign({},q),O.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(O.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),$.disableExtensions!==void 0&&(O["disable-extensions"]=$.disableExtensions),O.fullscreen=this.isFullScreen,O.maximized=this._win.isMaximized(),(0,k.mark)("code/willOpenNewWindow"),O.perfMarks=(0,k.getMarks)(),this.configObjectUrl.update(O)}async reload(O){const $=Object.assign({},this.currentConfig);$.workspace=await this.validateWorkspace($),delete $.filesToOpenOrCreate,delete $.filesToDiff,delete $.filesToWait,this.isExtensionDevelopmentHost&&O&&($.verbose=O.verbose,$.debugId=O.debugId,$["inspect-extensions"]=O["inspect-extensions"],$["inspect-brk-extensions"]=O["inspect-brk-extensions"],$["extensions-dir"]=O["extensions-dir"]),$.isInitialStartup=!1,this.load($,{isReload:!0,disableExtensions:O==null?void 0:O["disable-extensions"]})}async validateWorkspace(O){if((0,I.isWorkspaceIdentifier)(O.workspace)){const $=O.workspace.configPath;if($.scheme===S.Schemas.file&&!await this.fileService.exists($))return}else if((0,I.isSingleFolderWorkspaceIdentifier)(O.workspace)){const $=O.workspace.uri;if($.scheme===S.Schemas.file&&!await this.fileService.exists($))return}return O.workspace}serializeWindowState(){if(!this._win)return(0,w.defaultWindowState)();if(this.isFullScreen){let z;try{z=r.screen.getDisplayMatching(this.getBounds())}catch(N){}const C=(0,w.defaultWindowState)();return{mode:3,display:z?z.id:void 0,width:this.windowState.width||C.width,height:this.windowState.height||C.height,x:this.windowState.x||0,y:this.windowState.y||0}}const O=Object.create(null);let $;if(!d.isMacintosh&&this._win.isMaximized()?$=0:$=1,$===0?O.mode=0:O.mode=1,$===1||$===0){let z;$===1?z=this.getBounds():z=this._win.getNormalBounds(),O.x=z.x,O.y=z.y,O.width=z.width,O.height=z.height}return O}restoreWindowState(O){(0,k.mark)("code/willRestoreCodeWindowState");let $=!1;if(O)try{const z=r.screen.getAllDisplays();$=z.length>1,O=this.validateWindowState(O,z)}catch(z){this.logService.warn(`Unexpected error validating window state: ${z}
${z.stack}`)}return(0,k.mark)("code/didRestoreCodeWindowState"),[O||(0,w.defaultWindowState)(),$]}validateWindowState(O,$){var z,C;if(this.logService.trace(`window#validateWindowState: validating window state on ${$.length} display(s)`,O),typeof O.x!="number"||typeof O.y!="number"||typeof O.width!="number"||typeof O.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(O.width<=0||O.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if($.length===1){const R=this.getWorkingArea($[0]);if(R){this.logService.trace("window#validateWindowState: 1 monitor working area",R);function q(){!O||typeof O.x!="number"||typeof O.y!="number"||!R||(O.x<R.x&&(O.x=R.x),O.y<R.y&&(O.y=R.y))}q(),O.width>R.width&&(O.width=R.width),O.height>R.height&&(O.height=R.height),O.x>R.x+R.width-128&&(O.x=R.x+R.width-O.width),O.y>R.y+R.height-128&&(O.y=R.y+R.height-O.height),q()}return O}if(O.display&&O.mode===3){const R=$.find(W=>W.id===O.display);if(R&&typeof((z=R.bounds)===null||z===void 0?void 0:z.x)=="number"&&typeof((C=R.bounds)===null||C===void 0?void 0:C.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const W=(0,w.defaultWindowState)(3);return W.x=R.bounds.x,W.y=R.bounds.y,W}}let N,_;try{N=r.screen.getDisplayMatching({x:O.x,y:O.y,width:O.width,height:O.height}),_=this.getWorkingArea(N)}catch(R){}if(N&&_&&O.x+O.width>_.x&&O.y+O.height>_.y&&O.x<_.x+_.width&&O.y<_.y+_.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",_),O}getWorkingArea(O){if(O.workArea.width>0&&O.workArea.height>0)return O.workArea;if(O.bounds.width>0&&O.bounds.height>0)return O.bounds}getBounds(){const[O,$]=this._win.getPosition(),[z,C]=this._win.getSize();return{x:O,y:$,width:z,height:C}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(O){this.useNativeFullScreen()?this.setNativeFullScreen(O):this.setSimpleFullScreen(O),this.sendWhenReady(O?"vscode:enterFullScreen":"vscode:leaveFullScreen",T.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(O){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(O)}setSimpleFullScreen(O){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(O),this._win.webContents.focus()}useNativeFullScreen(){const O=this.configurationService.getValue("window");return!O||typeof O.nativeFullScreen!="boolean"||O.nativeTabs?!0:O.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let O=(0,b.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(O)<0&&(O="classic"),O}setMenuBarVisibility(O,$=!0){d.isMacintosh||(O==="toggle"&&$&&this.send("vscode:showInfoMessage",(0,D.localize)(10,null)),O==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(O)}):this.doSetMenuBarVisibility(O))}doSetMenuBarVisibility(O){const $=this.isFullScreen;switch(O){case"classic":this._win.setMenuBarVisibility(!$),this._win.autoHideMenuBar=$;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(d.isMacintosh)switch(r.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(O,$,...z){this.isReady?this.send(O,...z):this.ready().then(()=>{$.isCancellationRequested||this.send(O,...z)})}send(O,...$){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${O} for window that is destroyed`);return}this._win.webContents.send(O,...$)}}updateTouchBar(O){!d.isMacintosh||this.touchBarGroups.forEach(($,z)=>{const C=O[z];$.segments=this.createTouchBarGroupSegments(C)})}createTouchBar(){if(!!d.isMacintosh){for(let O=0;O<10;O++){const $=this.createTouchBarGroup();this.touchBarGroups.push($)}this._win.setTouchBar(new r.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(O=[]){const $=this.createTouchBarGroupSegments(O),z=new r.TouchBar.TouchBarSegmentedControl({segments:$,mode:"buttons",segmentStyle:"automatic",change:C=>{this.sendWhenReady("vscode:runAction",T.CancellationToken.None,{id:z.segments[C].id,from:"touchbar"})}});return z}createTouchBarGroupSegments(O=[]){return O.map(z=>{var C,q;let N;z.icon&&!s.ThemeIcon.isThemeIcon(z.icon)&&((q=(C=z.icon)===null||C===void 0?void 0:C.dark)===null||q===void 0?void 0:q.scheme)===S.Schemas.file&&(N=r.nativeImage.createFromPath(P.URI.revive(z.icon.dark).fsPath),N.isEmpty()&&(N=void 0));let _;return typeof z.title=="string"?_=z.title:_=z.title.value,{id:z.id,label:N?void 0:_,icon:N}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};ne=ce([ee(1,i.ILogService),ee(2,p.IEnvironmentMainService),ee(3,f.IFileService),ee(4,u.IStorageMainService),ee(5,L.IConfigurationService),ee(6,a.IThemeMainService),ee(7,E.IWorkspacesManagementMainService),ee(8,o.IBackupMainService),ee(9,h.ITelemetryService),ee(10,t.IDialogMainService),ee(11,l.ILifecycleMainService),ee(12,U.INativeHostMainService),ee(13,g.IProductService),ee(14,H.IProtocolMainService)],ne),e.CodeWindow=ne}),define(X[61],J([0,1,148,35,38,13,6,39,5,3,29,52,9,15,7,10,19,16,4,2]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w,I,E,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,o.createDecorator)("workspacesHistoryMainService");let a=class Ve extends c.Disposable{constructor(f,S,A,T){super();this.stateService=f,this.logService=S,this.workspacesManagementMainService=A,this.lifecycleMainService=T,this._onDidChangeRecentlyOpened=this._register(new p.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new b.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace}])))}handleWindowsJumpList(){!i.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(f){const S=[],A=[];for(let T of f)if((0,L.isRecentWorkspace)(T))!this.workspacesManagementMainService.isUntitledWorkspace(T.workspace)&&n(S,T.workspace)===-1&&S.push(T);else if((0,L.isRecentFolder)(T))s(S,T.folderUri)===-1&&S.push(T);else{const U=l(A,T.fileUri)>=0,H=T.fileUri.scheme===w.Schemas.file&&Ve.COMMON_FILES_FILTER.indexOf((0,v.basename)(T.fileUri))>=0;!U&&!H&&(A.push(T),i.isWindows&&T.fileUri.scheme===w.Schemas.file&&y.app.addRecentDocument(T.fileUri.fsPath))}this.addEntriesFromStorage(S,A),S.length>Ve.MAX_TOTAL_RECENT_ENTRIES&&(S.length=Ve.MAX_TOTAL_RECENT_ENTRIES),A.length>Ve.MAX_TOTAL_RECENT_ENTRIES&&(A.length=Ve.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:S,files:A}),this._onDidChangeRecentlyOpened.fire(),i.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(f){const S=H=>{const Q=t(H);for(const ne of f)if(v.extUriBiasedIgnorePathCase.isEqual(ne,Q))return!1;return!0},A=this.getRecentlyOpened(),T=A.workspaces.filter(S),U=A.files.filter(S);(T.length!==A.workspaces.length||U.length!==A.files.length)&&(this.saveRecentlyOpened({files:U,workspaces:T}),this._onDidChangeRecentlyOpened.fire(),i.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!!i.isMacintosh){y.app.clearRecentDocuments();const f=this.getRecentlyOpened(),S=[];let A=0;for(let U=0;U<f.workspaces.length&&A<Ve.MAX_MACOS_DOCK_RECENT_WORKSPACES;U++){const H=t(f.workspaces[U]);if(H.scheme===w.Schemas.file){const Q=(0,v.originalFSPath)(H);await(0,I.exists)(Q)&&(S.push(Q),A++)}}const T=[];for(let U=0;U<f.files.length&&A<Ve.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;U++){const H=t(f.files[U]);if(H.scheme===w.Schemas.file){const Q=(0,v.originalFSPath)(H);if(Ve.COMMON_FILES_FILTER.includes((0,v.basename)(H))||S.includes(Q))continue;await(0,I.exists)(Q)&&(T.push(Q),A++)}}T.reverse().forEach(U=>y.app.addRecentDocument(U)),S.reverse().forEach(U=>y.app.addRecentDocument(U))}}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),y.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(f){var S,A;const T=[],U=[],H=(S=f==null?void 0:f.config)===null||S===void 0?void 0:S.workspace;(0,L.isWorkspaceIdentifier)(H)&&!this.workspacesManagementMainService.isUntitledWorkspace(H)?T.push({workspace:H}):(0,L.isSingleFolderWorkspaceIdentifier)(H)&&T.push({folderUri:H.uri});const Q=(A=f==null?void 0:f.config)===null||A===void 0?void 0:A.filesToOpenOrCreate;if(Q)for(let ne of Q){const ae=ne.fileUri;ae&&l(U,ae)===-1&&U.push({fileUri:ae})}return this.addEntriesFromStorage(T,U),{workspaces:T,files:U}}addEntriesFromStorage(f,S){let A=this.getRecentlyOpenedFromStorage();for(let T of A.workspaces){let U=(0,L.isRecentFolder)(T)?s(f,T.folderUri):n(f,T.workspace);U>=0?f[U].label=f[U].label||T.label:f.push(T)}for(let T of A.files){let U=l(S,T.fileUri);U>=0?S[U].label=S[U].label||T.label:S.push(T)}}getRecentlyOpenedFromStorage(){const f=this.stateService.getItem(Ve.recentlyOpenedStorageKey);return(0,L.restoreRecentlyOpened)(f,this.logService)}saveRecentlyOpened(f){const S=(0,L.toStoreData)(f);this.stateService.setItem(Ve.recentlyOpenedStorageKey,S)}updateWindowsJumpList(){if(!!i.isWindows){const f=[];if(f.push({type:"tasks",items:[{type:"task",title:(0,m.localize)(0,null),description:(0,m.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let S=[];for(let U of y.app.getJumpListSettings().removedItems){const H=U.args;if(H){const Q=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(H);Q&&S.push(d.URI.parse(Q[2]))}}this.removeRecentlyOpened(S);let A=!1;const T=(0,D.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(U=>{const H=(0,L.isRecentWorkspace)(U)?U.workspace:U.folderUri,{title:Q,description:ne}=this.getWindowsJumpListLabel(H,U.label);let ae;return d.URI.isUri(H)?ae=`--folder-uri "${H.toString()}"`:(A=!0,ae=`--file-uri "${H.configPath.toString()}"`),{type:"task",title:Q.substr(0,255),description:ne.substr(0,255),program:process.execPath,args:ae,iconPath:"explorer.exe",iconIndex:0}}));T.length>0&&f.push({type:"custom",name:A?(0,m.localize)(2,null):(0,m.localize)(3,null),items:T})}f.push({type:"recent"});try{y.app.setJumpList(f)}catch(S){this.logService.warn("updateWindowsJumpList#setJumpList",S)}}}getWindowsJumpListLabel(f,S){if(S)return{title:(0,r.splitName)(S).name,description:S};if(d.URI.isUri(f))return{title:(0,v.basename)(f),description:h(f)};if(this.workspacesManagementMainService.isUntitledWorkspace(f))return{title:(0,m.localize)(4,null),description:""};let A=(0,v.basename)(f.configPath);return A.endsWith(L.WORKSPACE_EXTENSION)&&(A=A.substr(0,A.length-L.WORKSPACE_EXTENSION.length-1)),{title:(0,m.localize)(5,null,A),description:h(f.configPath)}}};a.MAX_TOTAL_RECENT_ENTRIES=100,a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a.recentlyOpenedStorageKey="openedPathsList",a=ce([ee(0,k.IStateService),ee(1,P.ILogService),ee(2,g.IWorkspacesManagementMainService),ee(3,E.ILifecycleMainService)],a),e.WorkspacesHistoryMainService=a;function h(u){return u.scheme==="file"?(0,r.normalizeDriveLetter)(u.fsPath):u.toString()}function t(u){return(0,L.isRecentFolder)(u)?u.folderUri:(0,L.isRecentFile)(u)?u.fileUri:u.workspace.configPath}function n(u,f){return u.findIndex(S=>(0,L.isRecentWorkspace)(S)&&S.workspace.id===f.id)}function s(u,f){return u.findIndex(S=>(0,L.isRecentFolder)(S)&&v.extUriBiasedIgnorePathCase.isEqual(S.folderUri,f))}function l(u,f){return u.findIndex(S=>v.extUriBiasedIgnorePathCase.isEqual(S.fileUri,f))}}),define(X[226],J([0,1,141,3,26,13,60,21,31,40,20,9,6,39,34,61,175,7,38,16,41,25]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w,I,E,o,c,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let n=class dt{constructor(u,f,S,A,T,U,H,Q,ne,ae,O){this.updateService=u,this.configurationService=f,this.windowsMainService=S,this.environmentMainService=A,this.telemetryService=T,this.workspacesHistoryMainService=U,this.stateService=H,this.lifecycleMainService=Q,this.logService=ne,this.nativeHostMainService=ae,this.productService=O,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new g.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new g.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,P.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const u=this.stateService.getItem(dt.lastKnownMenubarStorageKey);u&&(u.menus&&(this.menubarMenus=u.menus),u.keybindings&&(this.keybindings=u.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(U,H,Q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:H==null?void 0:H.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(U,H,Q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:H==null?void 0:H.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(U,H,Q)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(Q),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(U,H,Q)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(Q),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const u=this.productService.twitterUrl;u&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(u,"openTwitterUrl"));const f=this.productService.requestFeatureUrl;f&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(f,"openUserVoiceUrl"));const S=this.productService.reportIssueUrl;S&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(S,"openReportIssues"));const A=this.productService.licenseUrl;A&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const U=A.indexOf("?")>0?"&":"?";this.openUrl(`${A}${U}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(A,"openLicenseUrl")});const T=this.productService.privacyStatementUrl;T&&A&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(D.language){const U=A.indexOf("?")>0?"&":"?";this.openUrl(`${T}${U}lang=${D.language}`,"openPrivacyStatement")}else this.openUrl(T,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(u=>this.onDidChangeWindowsCount(u)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let u=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof u!="boolean"&&(u=!0),u}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;let u=this.configurationService.getValue("window.nativeTabs");return typeof u!="boolean"&&(u=!1),u}updateMenu(u,f){this.menubarMenus=u.menus,this.keybindings=u.keybindings,this.stateService.setItem(dt.lastKnownMenubarStorageKey,u),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(u){!D.isMacintosh||(u.oldCount===0&&u.newCount>0||u.oldCount>0&&u.newCount===0)&&(this.closedLastWindow=u.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!D.isMacintosh||(this.noActiveWindow=!y.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const u=y.Menu.getApplicationMenu();if(u&&this.oldMenus.push(u),Object.keys(this.menubarMenus).length===0){y.Menu.setApplicationMenu(D.isMacintosh?new y.Menu:null);return}const f=new y.Menu;let S;if(D.isMacintosh){const F=new y.Menu;S=new y.MenuItem({label:this.productService.nameShort,submenu:F}),this.setMacApplicationMenu(F),f.append(S)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const F=new y.Menu;F.append(new y.MenuItem({label:this.mnemonicLabel(m.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),y.app.dock.setMenu(F)}const A=new y.Menu,T=new y.MenuItem({label:this.mnemonicLabel(m.localize(1,null)),submenu:A});this.setMenuById(A,"File"),f.append(T);const U=new y.Menu,H=new y.MenuItem({label:this.mnemonicLabel(m.localize(2,null)),submenu:U});this.setMenuById(U,"Edit"),f.append(H);const Q=new y.Menu,ne=new y.MenuItem({label:this.mnemonicLabel(m.localize(3,null)),submenu:Q});this.setMenuById(Q,"Selection"),f.append(ne);const ae=new y.Menu,O=new y.MenuItem({label:this.mnemonicLabel(m.localize(4,null)),submenu:ae});this.setMenuById(ae,"View"),f.append(O);const $=new y.Menu,z=new y.MenuItem({label:this.mnemonicLabel(m.localize(5,null)),submenu:$});this.setMenuById($,"Go"),f.append(z);const C=new y.Menu,q=new y.MenuItem({label:this.mnemonicLabel(m.localize(6,null)),submenu:C});this.setMenuById(C,"Run"),f.append(q);const N=new y.Menu,_=new y.MenuItem({label:this.mnemonicLabel(m.localize(7,null)),submenu:N});this.setMenuById(N,"Terminal"),f.append(_);let R;if(this.shouldDrawMenu("Window")){const F=new y.Menu;R=new y.MenuItem({label:this.mnemonicLabel(m.localize(8,null)),submenu:F,role:"window"}),this.setMacWindowMenu(F)}R&&f.append(R);const W=new y.Menu,M=new y.MenuItem({label:this.mnemonicLabel(m.localize(9,null)),submenu:W,role:"help"});this.setMenuById(W,"Help"),f.append(M),f.items&&f.items.length>0?y.Menu.setApplicationMenu(f):y.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(u){const f=this.createMenuItem(m.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),S=this.getUpdateMenuItems();let A;if(this.shouldDrawMenu("Preferences")){const $=new y.Menu;this.setMenuById($,"Preferences"),A=new y.MenuItem({label:this.mnemonicLabel(m.localize(11,null)),submenu:$})}const T=new y.Menu,U=new y.MenuItem({label:m.localize(12,null),role:"services",submenu:T}),H=new y.MenuItem({label:m.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),Q=new y.MenuItem({label:m.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ne=new y.MenuItem({label:m.localize(15,null),role:"unhide"}),ae=new y.MenuItem(this.likeAction("workbench.action.quit",{label:m.localize(16,null,this.productService.nameLong),click:()=>{const $=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!y.BrowserWindow.getFocusedWindow()||($==null?void 0:$.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),O=[f];O.push(...S),A&&O.push(s(),A),O.push(s(),U,s(),H,Q,ne,s(),ae),O.forEach($=>u.append($))}shouldDrawMenu(u){if(!D.isMacintosh&&(0,P.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(u){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[u];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[u]}}setMenu(u,f){f.forEach(S=>{if((0,I.isMenubarMenuItemSeparator)(S))u.append(s());else if((0,I.isMenubarMenuItemSubmenu)(S)){const A=new y.Menu,T=new y.MenuItem({label:this.mnemonicLabel(S.label),submenu:A});this.setMenu(A,S.submenu.items),u.append(T)}else(0,I.isMenubarMenuItemRecentAction)(S)?u.append(this.createOpenRecentMenuItem(S)):(0,I.isMenubarMenuItemAction)(S)&&(S.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(u),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[S.id]?u.append(new y.MenuItem(this.likeAction(S.id,{label:this.mnemonicLabel(S.label),click:this.fallbackMenuHandlers[S.id]}))):u.append(this.createMenuItem(S.label,S.id,!1,S.checked)):u.append(this.createMenuItem(S.label,S.id,S.enabled!==!1,!!S.checked)):u.append(this.createMenuItem(S.label,S.id,S.enabled!==!1,!!S.checked)))})}setMenuById(u,f){this.menubarMenus&&this.menubarMenus[f]&&this.setMenu(u,this.menubarMenus[f].items)}insertCheckForUpdatesItems(u){const f=this.getUpdateMenuItems();f.length&&(f.forEach(S=>u.append(S)),u.append(s()))}createOpenRecentMenuItem(u){const f=E.URI.revive(u.uri),S=u.id,A=S==="openRecentFile"?{fileUri:f}:S==="openRecentWorkspace"?{workspaceUri:f}:{folderUri:f};return new y.MenuItem(this.likeAction(S,{label:u.label,click:(T,U,H)=>{const Q=this.isOptionClick(H);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[A],forceNewWindow:Q,gotoLineMode:!1,remoteAuthority:u.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([f])}},!1))}isOptionClick(u){return!!(u&&(!D.isMacintosh&&(u.ctrlKey||u.shiftKey)||D.isMacintosh&&(u.metaKey||u.altKey)))}createRoleMenuItem(u,f,S){const A={label:this.mnemonicLabel(u),role:S,enabled:!0};return new y.MenuItem(this.withKeybinding(f,A))}setMacWindowMenu(u){const f=new y.MenuItem({label:m.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),S=new y.MenuItem({label:m.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),A=new y.MenuItem({label:m.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),T=this.createMenuItem(m.localize(20,null),"workbench.action.switchWindow"),U=[];this.currentEnableNativeTabs&&(U.push(s()),U.push(this.createMenuItem(m.localize(21,null),"workbench.action.newWindowTab")),U.push(this.createRoleMenuItem(m.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),U.push(this.createRoleMenuItem(m.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),U.push(this.createRoleMenuItem(m.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),U.push(this.createRoleMenuItem(m.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[f,S,s(),T,...U,s(),A].forEach(H=>u.append(H))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new y.MenuItem({label:this.mnemonicLabel(m.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate");const f=this.windowsMainService.getLastActiveWindow(),S=f&&`window:${f.id}`;this.updateService.checkForUpdates(S)},0)})];case"checking for updates":return[new y.MenuItem({label:m.localize(27,null),enabled:!1})];case"available for download":return[new y.MenuItem({label:this.mnemonicLabel(m.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new y.MenuItem({label:m.localize(29,null),enabled:!1})];case"downloaded":return[new y.MenuItem({label:this.mnemonicLabel(m.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new y.MenuItem({label:m.localize(31,null),enabled:!1})];case"ready":return[new y.MenuItem({label:this.mnemonicLabel(m.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(u,f,S,A){const T=this.mnemonicLabel(u),U=typeof f=="function"?f:(O,$,z)=>{const C=O?O.userSettingsLabel:null;let q=f;Array.isArray(f)&&(q=this.isOptionClick(z)?f[1]:f[0]),C&&z.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:C}):this.runActionInRenderer({type:"commandId",commandId:q})},H=typeof S=="boolean"?S:this.windowsMainService.getWindowCount()>0,Q=typeof A=="boolean"?A:!1,ne={label:T,click:U,enabled:H};Q&&(ne.type="checkbox",ne.checked=Q);let ae;return typeof f=="string"?ae=f:Array.isArray(f)&&(ae=f[0]),D.isMacintosh&&(ae==="editor.action.clipboardCutAction"?ne.role="cut":ae==="editor.action.clipboardCopyAction"?ne.role="copy":ae==="editor.action.clipboardPasteAction"&&(ne.role="paste"),ae==="undo"?ne.click=this.makeContextAwareClickHandler(U,{inDevTools:O=>O.undo(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("undo:")}):ae==="redo"?ne.click=this.makeContextAwareClickHandler(U,{inDevTools:O=>O.redo(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("redo:")}):ae==="editor.action.selectAll"&&(ne.click=this.makeContextAwareClickHandler(U,{inDevTools:O=>O.selectAll(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("selectAll:")}))),new y.MenuItem(this.withKeybinding(ae,ne))}makeContextAwareClickHandler(u,f){return(S,A,T)=>{const U=y.BrowserWindow.getFocusedWindow();if(!U)return f.inNoWindow();if(U.webContents.isDevToolsFocused()&&U.webContents.devToolsWebContents)return f.inDevTools(U.webContents.devToolsWebContents);u(S,A||U,T)}}runActionInRenderer(u){let f=y.BrowserWindow.getFocusedWindow();if(!f){const A=this.windowsMainService.getLastActiveWindow();(A==null?void 0:A.isMinimized())&&(f=A.win)}const S=f?this.windowsMainService.getWindowById(f.id):void 0;if(S){if(this.logService.trace("menubar#runActionInRenderer",u),D.isMacintosh&&!this.environmentMainService.isBuilt&&!S.isReady&&(u.type==="commandId"&&u.commandId==="workbench.action.toggleDevTools"||u.type!=="commandId"&&u.userSettingsLabel==="alt+cmd+i"))return;if(u.type==="commandId"){const A={id:u.commandId,from:"menu"};S.sendWhenReady("vscode:runAction",h.CancellationToken.None,A)}else{const A={userSettingsLabel:u.userSettingsLabel};S.sendWhenReady("vscode:runKeybinding",h.CancellationToken.None,A)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",u)}withKeybinding(u,f){const S=typeof u=="string"?this.keybindings[u]:void 0;if(S==null?void 0:S.label){if(S.isNative!==!1)f.accelerator=S.label,f.userSettingsLabel=S.userSettingsLabel;else if(typeof f.label=="string"){const A=f.label.indexOf("[");A>=0?f.label=`${f.label.substr(0,A)} [${S.label}]`:f.label=`${f.label} [${S.label}]`}}else f.accelerator=void 0;return f}likeAction(u,f,S=!f.accelerator){S&&(f=this.withKeybinding(u,f));const A=f.click;return f.click=(T,U,H)=>{this.reportMenuActionTelemetry(u),A&&A(T,U,H)},f}openUrl(u,f){this.nativeHostMainService.openExternal(void 0,u),this.reportMenuActionTelemetry(f)}reportMenuActionTelemetry(u){this.telemetryService.publicLog2("workbenchActionExecuted",{id:u,from:t})}mnemonicLabel(u){return(0,v.mnemonicMenuLabel)(u,!this.currentEnableMenuBarMnemonics)}};n.lastKnownMenubarStorageKey="lastKnownMenubarData",n=ce([ee(0,i.IUpdateService),ee(1,r.IConfigurationService),ee(2,d.IWindowsMainService),ee(3,k.IEnvironmentMainService),ee(4,p.ITelemetryService),ee(5,w.IWorkspacesHistoryMainService),ee(6,o.IStateService),ee(7,c.ILifecycleMainService),ee(8,b.ILogService),ee(9,a.INativeHostMainService),ee(10,L.IProductService)],n),e.Menubar=n;function s(){return new y.MenuItem({type:"separator"})}}),define(X[227],J([0,1,226,6,4,16]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,k.createDecorator)("menubarMainService");let P=class{constructor(p,i,L){this.instantiationService=p,this.lifecycleMainService=i,this.logService=L,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(m.Menubar)}async updateMenubar(p,i){this.logService.trace("menubarService#updateMenubar",p),(await this.menubar).updateMenu(i,p)}};P=ce([ee(0,k.IInstantiationService),ee(1,y.ILifecycleMainService),ee(2,D.ILogService)],P),e.MenubarMainService=P}),define(X[228],J([0,1,18,27,47,71,8,146,35,50,26,38,225,13,16,21,6,60,98,5,20,61,3,29,4,10,7,15,72,209,52,42,2,51,12,30,39,25,24,32,55]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w,I,E,o,c,a,h,t,n,s,l,u,f,S,A,T,U,H,Q,ne,ae,O,$,z,C,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function N(W){return(0,n.isWorkspaceIdentifier)(W==null?void 0:W.workspace)}function _(W){return(0,n.isSingleFolderWorkspaceIdentifier)(W==null?void 0:W.workspace)}let R=class et extends H.Disposable{constructor(M,F,B,V,G,Y,Z,re,se,x,ie,ue,ye,ge,Ee){super();this.machineId=M,this.initialUserEnv=F,this.logService=B,this.stateService=V,this.environmentMainService=G,this.lifecycleMainService=Y,this.backupMainService=Z,this.configurationService=re,this.workspacesHistoryMainService=se,this.workspacesManagementMainService=x,this.instantiationService=ie,this.dialogMainService=ue,this.fileService=ye,this.productService=ge,this.protocolMainService=Ee,this._onDidOpenWindow=this._register(new c.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new c.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new c.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new c.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new A.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(M=>this._onDidSignalReadyWindow.fire(M.window))),this._register(this.onDidSignalReadyWindow(M=>{var F,B;if(((F=M.config)===null||F===void 0?void 0:F.extensionDevelopmentPath)||((B=M.config)===null||B===void 0?void 0:B.extensionTestsPath)){const V=new H.DisposableStore;if(V.add(c.Event.any(M.onDidClose,M.onDidDestroy)(()=>V.dispose())),M.config.extensionDevelopmentPath)for(const G of M.config.extensionDevelopmentPath)V.add(this.protocolMainService.addValidFileRoot(u.URI.file(G)));M.config.extensionTestsPath&&V.add(this.protocolMainService.addValidFileRoot(u.URI.file(M.config.extensionTestsPath)))}}))}openEmptyWindow(M,F){let B=this.environmentMainService.args;const V=(F==null?void 0:F.remoteAuthority)||void 0,G=!0,Y=F==null?void 0:F.forceReuseWindow,Z=!Y;return this.open(Object.assign(Object.assign({},M),{cli:B,forceEmpty:G,forceNewWindow:Z,forceReuseWindow:Y,remoteAuthority:V}))}open(M){this.logService.trace("windowsManager#open"),M.addMode&&(M.initialStartup||!this.getLastActiveWindow())&&(M.addMode=!1);const F=[],B=[],V=[],G=[],Y=[];let Z,re=0;const se=this.getPathsToOpen(M);this.logService.trace("windowsManager#open pathsToOpen",se);for(const ge of se)_(ge)?M.addMode?F.push(ge):B.push(ge):N(ge)?V.push(ge):ge.fileUri?(Z||(Z={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ge.remoteAuthority}),Z.filesToOpenOrCreate.push(ge)):ge.backupPath?Y.push({backupFolder:(0,P.basename)(ge.backupPath),remoteAuthority:ge.remoteAuthority}):re++;M.diffMode&&(Z==null?void 0:Z.filesToOpenOrCreate.length)===2&&(Z.filesToDiff=Z.filesToOpenOrCreate,Z.filesToOpenOrCreate=[]),Z&&M.waitMarkerFileURI&&(Z.filesToWait={paths:[...Z.filesToDiff,...Z.filesToOpenOrCreate],waitMarkerFileUri:M.waitMarkerFileURI}),M.initialStartup?(G.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),V.push(...G),Y.push(...this.backupMainService.getEmptyWindowBackupPaths())):Y.length=0;const{windows:x,filesOpenedInWindow:ie}=this.doOpen(M,V,B,Y,re,Z,F);if(this.logService.trace(`windowsManager#open used window count ${x.length} (workspacesToOpen: ${V.length}, foldersToOpen: ${B.length}, emptyToRestore: ${Y.length}, emptyToOpen: ${re})`),x.length>1)if(ie)ie.focus();else{const ge=this.windowsStateHandler.state.lastActiveWindow&&!M.forceEmpty&&!M.cli._.length&&!M.cli["file-uri"]&&!M.cli["folder-uri"]&&!(M.urisToOpen&&M.urisToOpen.length);let Ee=!0,Ae=!0;if(ge){const ve=x.filter(me=>this.windowsStateHandler.state.lastActiveWindow&&me.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ve.length&&(ve[0].focus(),Ee=!1,Ae=!1)}if(Ee)for(let ve=x.length-1;ve>=0;ve--){const me=x[ve];if(!(me.openedWorkspace&&G.some(be=>me.openedWorkspace&&be.workspace.id===me.openedWorkspace.id)||me.backupPath&&Y.some(be=>me.backupPath&&be.backupFolder===(0,P.basename)(me.backupPath)))){me.focus(),Ae=!1;break}}Ae&&x[x.length-1].focus()}const ue=Z&&Z.filesToDiff.length>0;if(!x.some(ge=>ge.isExtensionDevelopmentHost)&&!ue&&!M.noRecentEntry){const ge=[];for(const Ee of se)N(Ee)?ge.push({label:Ee.label,workspace:Ee.workspace,remoteAuthority:Ee.remoteAuthority}):_(Ee)?ge.push({label:Ee.label,folderUri:Ee.workspace.uri,remoteAuthority:Ee.remoteAuthority}):Ee.fileUri&&ge.push({label:Ee.label,fileUri:Ee.fileUri,remoteAuthority:Ee.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ge)}const ye=M.waitMarkerFileURI;return M.context===0&&ye&&x.length===1&&x[0]&&x[0].whenClosedOrLoaded.then(()=>this.fileService.del(ye),()=>{}),x}doOpen(M,F,B,V,G,Y,Z){const re=[];let se;function x(ve,me){re.push(ve),me&&(se=ve,Y=void 0)}let{openFolderInNewWindow:ie,openFilesInNewWindow:ue}=this.shouldOpenNewWindow(M);if(!M.initialStartup&&Z.length>0){const ve=Z[0].remoteAuthority,me=this.getLastActiveWindowForAuthority(ve);me&&x(this.doAddFoldersToExistingWindow(me,Z.map(be=>be.workspace.uri)))}const ye=B.length+F.length+V.length;if(Y&&ye===0){const ve=Y.filesToOpenOrCreate[0]||Y.filesToDiff[0],me=this.getWindows().filter(_e=>Y&&_e.remoteAuthority===Y.remoteAuthority);let be;(ve==null?void 0:ve.fileUri)&&!ue&&((M.context===4||M.context===0||M.context===1)&&(be=(0,o.findWindowOnFile)(me,ve.fileUri,_e=>_e.configPath.scheme===l.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(_e.configPath):null)),be||(be=this.doGetLastActiveWindow(me))),be?(0,n.isWorkspaceIdentifier)(be.openedWorkspace)?F.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,n.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?B.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):x(this.doOpenFilesInExistingWindow(M,be,Y),!0):x(this.openInBrowserWindow({userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,filesToOpen:Y,forceNewWindow:!0,remoteAuthority:Y.remoteAuthority,forceNewTabbedWindow:M.forceNewTabbedWindow}),!0)}const ge=(0,p.distinct)(F,ve=>ve.workspace.id);if(ge.length>0){const ve=(0,p.coalesce)(ge.map(me=>(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.configPath)));if(ve.length>0){const me=ve[0],be=(Y==null?void 0:Y.remoteAuthority)===me.remoteAuthority?Y:void 0;x(this.doOpenFilesInExistingWindow(M,me,be),!!be),ie=!0}ge.forEach(me=>{if(!ve.some(Te=>Te.openedWorkspace&&Te.openedWorkspace.id===me.workspace.id)){const be=me.remoteAuthority,_e=(Y==null?void 0:Y.remoteAuthority)===be?Y:void 0;x(this.doOpenFolderOrWorkspace(M,me,ie,_e),!!_e),ie=!0}})}const Ee=(0,p.distinct)(B,ve=>f.extUriBiasedIgnorePathCase.getComparisonKey(ve.workspace.uri));if(Ee.length>0){const ve=(0,p.coalesce)(Ee.map(me=>(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.uri)));if(ve.length>0){const me=ve[0],be=(Y==null?void 0:Y.remoteAuthority)===me.remoteAuthority?Y:void 0;x(this.doOpenFilesInExistingWindow(M,me,be),!!be),ie=!0}Ee.forEach(me=>{if(!ve.some(Te=>(0,n.isSingleFolderWorkspaceIdentifier)(Te.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(Te.openedWorkspace.uri,me.workspace.uri))){const be=me.remoteAuthority,_e=(Y==null?void 0:Y.remoteAuthority)===be?Y:void 0;x(this.doOpenFolderOrWorkspace(M,me,ie,_e),!!_e),ie=!0}})}const Ae=(0,p.distinct)(V,ve=>ve.backupFolder);if(Ae.length>0&&Ae.forEach(ve=>{const me=ve.remoteAuthority,be=(Y==null?void 0:Y.remoteAuthority)===me?Y:void 0;x(this.openInBrowserWindow({userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,filesToOpen:be,remoteAuthority:me,forceNewWindow:!0,forceNewTabbedWindow:M.forceNewTabbedWindow,emptyWindowBackupInfo:ve}),!!be),ie=!0}),re.length===0||Y){Y&&!G&&G++;const ve=Y?Y.remoteAuthority:M.remoteAuthority;for(let me=0;me<G;me++)x(this.doOpenEmpty(M,ie,ve,Y),!!Y),ie=!0}return{windows:(0,p.distinct)(re),filesOpenedInWindow:se}}doOpenFilesInExistingWindow(M,F,B){var V;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),F.focus();const G={filesToOpenOrCreate:B==null?void 0:B.filesToOpenOrCreate,filesToDiff:B==null?void 0:B.filesToDiff,filesToWait:B==null?void 0:B.filesToWait,termProgram:(V=M==null?void 0:M.userEnv)===null||V===void 0?void 0:V.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",$.CancellationToken.None,G),F}doAddFoldersToExistingWindow(M,F){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),M.focus();const B={foldersToAdd:F};return M.sendWhenReady("vscode:addFolders",$.CancellationToken.None,B),M}doOpenEmpty(M,F,B,V,G){return!F&&!G&&typeof M.contextWindowId=="number"&&(G=this.getWindowById(M.contextWindowId)),this.openInBrowserWindow({userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,remoteAuthority:B,forceNewWindow:F,forceNewTabbedWindow:M.forceNewTabbedWindow,filesToOpen:V,windowToUse:G})}doOpenFolderOrWorkspace(M,F,B,V,G){return!B&&!G&&typeof M.contextWindowId=="number"&&(G=this.getWindowById(M.contextWindowId)),this.openInBrowserWindow({workspace:F.workspace,userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:B,forceNewTabbedWindow:M.forceNewTabbedWindow,filesToOpen:V,windowToUse:G})}getPathsToOpen(M){var F;let B,V=!1,G=!1;if(M.urisToOpen&&M.urisToOpen.length>0?(B=this.doExtractPathsFromAPI(M),V=!0):M.forceEmpty?B=[Object.create(null)]:M.cli._.length||M.cli["folder-uri"]||M.cli["file-uri"]?(B=this.doExtractPathsFromCLI(M.cli),B.length===0&&B.push(Object.create(null)),V=!0):(B=this.doGetPathsFromLastSession(),B.length===0&&B.push(Object.create(null)),G=!0),!M.addMode&&V){const Y=B.filter(Z=>_(Z));if(Y.length>1){const Z=Y[0].remoteAuthority;if(Y.every(re=>re.remoteAuthority===Z)){const re=this.workspacesManagementMainService.createUntitledWorkspaceSync(Y.map(se=>({uri:se.workspace.uri})));B.push({workspace:re,remoteAuthority:Z}),B=B.filter(se=>!_(se))}}}return M.initialStartup&&!G&&((F=this.configurationService.getValue("window"))===null||F===void 0?void 0:F.restoreWindows)==="preserve"&&B.unshift(...this.doGetPathsFromLastSession().filter(Y=>N(Y)||_(Y)||Y.backupPath)),B}doExtractPathsFromAPI(M){const F=[],B={gotoLineMode:M.gotoLineMode,remoteAuthority:M.remoteAuthority};for(const V of(0,p.coalesce)(M.urisToOpen||[])){const G=this.resolveOpenable(V,B);if(G)G.label=V.label,F.push(G);else{const Y=this.resourceFromOpenable(V),Z={title:this.productService.nameLong,type:"info",buttons:[(0,r.localize)(0,null)],message:Y.scheme===l.Schemas.file?(0,r.localize)(1,null):(0,r.localize)(2,null),detail:Y.scheme===l.Schemas.file?(0,r.localize)(3,null,(0,O.getPathLabel)(Y.fsPath,this.environmentMainService)):(0,r.localize)(4,null,Y.toString()),noLink:!0};this.dialogMainService.showMessageBox(Z,(0,ne.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return F}doExtractPathsFromCLI(M){const F=[],B={ignoreFileNotFound:!0,gotoLineMode:M.goto,remoteAuthority:M.remote||void 0,forceOpenWorkspaceAsFile:!1},V=M["folder-uri"];if(V)for(const Z of V){const re=this.cliArgToUri(Z);if(re){const se=this.resolveOpenable({folderUri:re},B);se&&F.push(se)}}const G=M["file-uri"];if(G)for(const Z of G){const re=this.cliArgToUri(Z);if(re){const se=this.resolveOpenable((0,n.hasWorkspaceFileExtension)(Z)?{workspaceUri:re}:{fileUri:re},B);se&&F.push(se)}}const Y=M._;for(const Z of Y){const re=B.remoteAuthority?this.doResolvePathRemote(Z,B):this.doResolveFilePath(Z,B);re&&F.push(re)}return F}cliArgToUri(M){try{const F=u.URI.parse(M);if(!F.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${M}`);return}return F}catch(F){this.logService.error(`Invalid URI input string: ${M}, ${F.message}`)}}doGetPathsFromLastSession(){const M=this.getRestoreWindowsSetting();switch(M){case"none":return[];case"one":case"all":case"preserve":case"folders":const F=[];M!=="one"&&F.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&F.push(this.windowsStateHandler.state.lastActiveWindow);const B=[];for(const V of F)if(V.workspace){const G=this.resolveOpenable({workspaceUri:V.workspace.configPath},{remoteAuthority:V.remoteAuthority});N(G)&&B.push(G)}else if(V.folderUri){const G=this.resolveOpenable({folderUri:V.folderUri},{remoteAuthority:V.remoteAuthority});_(G)&&B.push(G)}else M!=="folders"&&V.backupPath&&B.push({backupPath:V.backupPath,remoteAuthority:V.remoteAuthority});return B}}getRestoreWindowsSetting(){let M;if(this.lifecycleMainService.wasRestarted)M="all";else{const F=this.configurationService.getValue("window");M=(F==null?void 0:F.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(M)||(M="all")}return M}resolveOpenable(M,F={}){let B=this.resourceFromOpenable(M);return B.scheme===l.Schemas.file?((0,E.isFileToOpen)(M)&&(F=Object.assign(Object.assign({},F),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(B.fsPath,F)):this.doResolveRemoteOpenable(M,F)}doResolveRemoteOpenable(M,F){let B=this.resourceFromOpenable(M);const V=(0,S.getRemoteAuthority)(B)||F.remoteAuthority;if(B=(0,f.removeTrailingPathSeparator)((0,f.normalizePath)(B)),(0,E.isFileToOpen)(M)){if(F.gotoLineMode){const{path:G,line:Y,column:Z}=(0,ae.parseLineAndColumnAware)(B.path);return{fileUri:B.with({path:G}),lineNumber:Y,columnNumber:Z,remoteAuthority:V}}return{fileUri:B,remoteAuthority:V}}else if((0,E.isWorkspaceToOpen)(M))return{workspace:(0,T.getWorkspaceIdentifier)(B),remoteAuthority:V};return{workspace:(0,T.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:V}}resourceFromOpenable(M){return(0,E.isWorkspaceToOpen)(M)?M.workspaceUri:(0,E.isFolderToOpen)(M)?M.folderUri:M.fileUri}doResolveFilePath(M,F){let B,V;F.gotoLineMode&&({path:M,line:B,column:V}=(0,ae.parseLineAndColumnAware)(M)),M=(0,ae.sanitizeFilePath)((0,P.normalize)(M),(0,C.cwd)());try{const G=(0,m.statSync)(M);if(G.isFile()){if(!F.forceOpenWorkspaceAsFile){const Y=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.URI.file(M));if(Y)return{workspace:{id:Y.id,configPath:Y.configPath},remoteAuthority:Y.remoteAuthority,exists:!0}}return{fileUri:u.URI.file(M),lineNumber:B,columnNumber:V,exists:!0}}else if(G.isDirectory())return{workspace:(0,T.getSingleFolderWorkspaceIdentifier)(u.URI.file(M),G),exists:!0}}catch(G){const Y=u.URI.file(M);if(this.workspacesHistoryMainService.removeRecentlyOpened([Y]),F.ignoreFileNotFound)return{fileUri:Y,exists:!1}}}doResolvePathRemote(M,F){const B=M.charCodeAt(0),V=F.remoteAuthority;let G,Y;F.gotoLineMode&&({path:M,line:G,column:Y}=(0,ae.parseLineAndColumnAware)(M)),B!==47&&((0,ae.isWindowsDriveLetter)(B)&&M.charCodeAt(M.charCodeAt(1))===58&&(M=(0,ae.toSlashes)(M)),M=`/${M}`);const Z=u.URI.from({scheme:l.Schemas.vscodeRemote,authority:V,path:M});if(M.charCodeAt(M.length-1)!==47){if((0,n.hasWorkspaceFileExtension)(M))return F.forceOpenWorkspaceAsFile?{fileUri:Z,lineNumber:G,columnNumber:Y,remoteAuthority:F.remoteAuthority}:{workspace:(0,T.getWorkspaceIdentifier)(Z),remoteAuthority:V};if(F.gotoLineMode||P.posix.basename(M).indexOf(".")!==-1)return{fileUri:Z,lineNumber:G,columnNumber:Y,remoteAuthority:V}}return{workspace:(0,T.getSingleFolderWorkspaceIdentifier)(Z),remoteAuthority:V}}shouldOpenNewWindow(M){const F=this.configurationService.getValue("window"),B=(F==null?void 0:F.openFoldersInNewWindow)||"default",V=(F==null?void 0:F.openFilesInNewWindow)||"off";let G=(M.preferNewWindow||M.forceNewWindow)&&!M.forceReuseWindow;!M.forceNewWindow&&!M.forceReuseWindow&&(B==="on"||B==="off")&&(G=B==="on");let Y=!1;return M.forceNewWindow||M.forceReuseWindow?Y=!!M.forceNewWindow&&!M.forceReuseWindow:(t.isMacintosh?M.context===1&&(Y=!0):M.context!==3&&M.context!==2&&!(M.userEnv&&M.userEnv.TERM_PROGRAM==="vscode")&&(Y=!0),!M.cli.extensionDevelopmentPath&&(V==="on"||V==="off")&&(Y=V==="on")),{openFolderInNewWindow:!!G,openFilesInNewWindow:Y}}openExtensionDevelopmentHostWindow(M,F){const B=(0,o.findWindowOnExtensionDevelopmentPath)(this.getWindows(),M);if(B)return this.lifecycleMainService.reload(B,F.cli),B.focus(),[B];let V=F.cli["folder-uri"]||[],G=F.cli["file-uri"]||[],Y=F.cli._;if(!Y.length&&!V.length&&!G.length&&!F.cli.extensionTestsPath){const x=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ie=x&&(x.workspace||x.folderUri);ie&&(u.URI.isUri(ie)?ie.scheme===l.Schemas.file?Y=[ie.fsPath]:V=[ie.toString()]:ie.configPath.scheme===l.Schemas.file?Y=[(0,f.originalFSPath)(ie.configPath)]:G=[ie.configPath.toString()])}let Z=F.remoteAuthority;for(const x of M)if(x.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ie=u.URI.parse(x),ue=(0,S.getRemoteAuthority)(ie);ue&&(Z?ue!==Z&&this.logService.error("more than one extension development path authority"):Z=ue)}Y=Y.filter(x=>{const ie=u.URI.file(x);return(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:(0,S.getRemoteAuthority)(ie)===Z}),V=V.filter(x=>{const ie=this.cliArgToUri(x);return ie&&!!(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:ie?(0,S.getRemoteAuthority)(ie)===Z:!1}),G=G.filter(x=>{const ie=this.cliArgToUri(x);return ie&&!!(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:ie?(0,S.getRemoteAuthority)(ie)===Z:!1}),F.cli._=Y,F.cli["folder-uri"]=V,F.cli["file-uri"]=G;const re=!Y.length&&!V.length&&!G.length,se={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:re,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:Z};return this.open(se)}openInBrowserWindow(M){var F,B,V,G,Y;const Z=this.configurationService.getValue("window"),re=Object.assign(Object.assign(Object.assign({},this.environmentMainService.args),M.cli),{machineId:this.machineId,sessionId:"",windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,partsSplashPath:(0,P.join)(this.environmentMainService.userDataPath,"rapid_render.json"),backupPath:M.emptyWindowBackupInfo?(0,P.join)(this.environmentMainService.backupHome,M.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:M.remoteAuthority,workspace:M.workspace,userEnv:Object.assign(Object.assign({},this.initialUserEnv),M.userEnv),filesToOpenOrCreate:(F=M.filesToOpen)===null||F===void 0?void 0:F.filesToOpenOrCreate,filesToDiff:(B=M.filesToOpen)===null||B===void 0?void 0:B.filesToDiff,filesToWait:(V=M.filesToOpen)===null||V===void 0?void 0:V.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:k.default,isInitialStartup:M.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,D.release)()},zoomLevel:typeof(Z==null?void 0:Z.zoomLevel)=="number"?Z.zoomLevel:void 0,autoDetectHighContrast:(G=Z==null?void 0:Z.autoDetectHighContrast)!==null&&G!==void 0?G:!0,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:{dark:v.nativeTheme.shouldUseDarkColors,highContrast:v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors}});let se;if(!M.forceNewWindow&&!M.forceNewTabbedWindow&&(se=M.windowToUse||this.getLastActiveWindow(),se&&se.focus()),se){const x=se.config;!re.extensionDevelopmentPath&&x&&!!x.extensionDevelopmentPath&&(re.extensionDevelopmentPath=x.extensionDevelopmentPath,re.verbose=x.verbose,re["inspect-brk-extensions"]=x["inspect-brk-extensions"],re.debugId=x.debugId,re["inspect-extensions"]=x["inspect-extensions"],re["extensions-dir"]=x["extensions-dir"])}else{const x=this.windowsStateHandler.getNewWindowState(re);(0,y.mark)("code/willCreateCodeWindow");const ie=se=this.instantiationService.createInstance(b.CodeWindow,{state:x,extensionDevelopmentPath:re.extensionDevelopmentPath,isExtensionTestHost:!!re.extensionTestsPath});if((0,y.mark)("code/didCreateCodeWindow"),M.forceNewTabbedWindow){const ye=this.getLastActiveWindow();ye&&ye.addTabbedWindow(ie)}et.WINDOWS.push(ie),this._onDidOpenWindow.fire(ie),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,U.once)(ie.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(ie)),(0,U.once)(ie.onDidClose)(()=>this.onWindowClosed(ie)),(0,U.once)(ie.onDidDestroy)(()=>this._onDidDestroyWindow.fire(ie));const ue=(0,ne.assertIsDefined)((Y=ie.win)===null||Y===void 0?void 0:Y.webContents);ue.removeAllListeners("devtools-reload-page"),ue.on("devtools-reload-page",()=>this.lifecycleMainService.reload(ie)),this.lifecycleMainService.registerWindow(ie)}return re.windowId=se.id,re.sessionId=`window:${se.id}`,se.isReady?this.lifecycleMainService.unload(se,4).then(x=>{x||this.doOpenInBrowserWindow(se,re,M)}):this.doOpenInBrowserWindow(se,re,M),se}doOpenInBrowserWindow(M,F,B){if(!F.extensionDevelopmentPath)if((0,n.isWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:F.workspace,remoteAuthority:F.remoteAuthority});else if((0,n.isSingleFolderWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerFolderBackupSync(F.workspace.uri);else{const V=B.emptyWindowBackupInfo&&B.emptyWindowBackupInfo.backupFolder;F.backupPath=this.backupMainService.registerEmptyWindowBackupSync(V,F.remoteAuthority)}M.load(F)}onWindowClosed(M){const F=et.WINDOWS.indexOf(M);et.WINDOWS.splice(F,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const M=v.BrowserWindow.getFocusedWindow();if(M)return this.getWindowById(M.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(M){return this.doGetLastActiveWindow(this.getWindows().filter(F=>F.remoteAuthority===M))}doGetLastActiveWindow(M){const F=Math.max.apply(Math,M.map(B=>B.lastFocusTime));return M.find(B=>B.lastFocusTime===F)}sendToFocused(M,...F){const B=this.getFocusedWindow()||this.getLastActiveWindow();B&&B.sendWhenReady(M,$.CancellationToken.None,...F)}sendToAll(M,F,B){for(const V of this.getWindows())B&&B.indexOf(V.id)>=0||V.sendWhenReady(M,$.CancellationToken.None,F)}getWindows(){return et.WINDOWS}getWindowCount(){return et.WINDOWS.length}getWindowById(M){const F=this.getWindows().filter(B=>B.id===M);return(0,p.firstOrDefault)(F)}getWindowByWebContents(M){const F=v.BrowserWindow.fromWebContents(M);if(!!F)return this.getWindowById(F.id)}};R.WINDOWS=[],R=ce([ee(2,I.ILogService),ee(3,g.IStateService),ee(4,L.IEnvironmentMainService),ee(5,d.ILifecycleMainService),ee(6,i.IBackupMainService),ee(7,w.IConfigurationService),ee(8,h.IWorkspacesHistoryMainService),ee(9,T.IWorkspacesManagementMainService),ee(10,s.IInstantiationService),ee(11,Q.IDialogMainService),ee(12,z.IFileService),ee(13,a.IProductService),ee(14,q.IProtocolMainService)],R),e.WindowsMainService=R}),define(X[229],J([0,1,52,34,61,50]),function(j,e,m,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let P=class{constructor(p,i,L,g){this.workspacesManagementMainService=p,this.windowsMainService=i,this.workspacesHistoryMainService=L,this.backupMainService=g,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(p,i){const L=this.windowsMainService.getWindowById(p);return L?this.workspacesManagementMainService.enterWorkspace(L,this.windowsMainService.getWindows(),i):null}createUntitledWorkspace(p,i,L){return this.workspacesManagementMainService.createUntitledWorkspace(i,L)}deleteUntitledWorkspace(p,i){return this.workspacesManagementMainService.deleteUntitledWorkspace(i)}getWorkspaceIdentifier(p,i){return this.workspacesManagementMainService.getWorkspaceIdentifier(i)}async getRecentlyOpened(p){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(p))}async addRecentlyOpened(p,i){return this.workspacesHistoryMainService.addRecentlyOpened(i)}async removeRecentlyOpened(p,i){return this.workspacesHistoryMainService.removeRecentlyOpened(i)}async clearRecentlyOpened(p){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};P=ce([ee(0,m.IWorkspacesManagementMainService),ee(1,D.IWindowsMainService),ee(2,k.IWorkspacesHistoryMainService),ee(3,y.IBackupMainService)],P),e.WorkspacesMainService=P}),define(X[230],J([0,1,27,18,13,3,228,16,69,40,199,33,120,84,219,99,4,70,67,6,38,26,21,96,200,31,95,194,195,191,20,213,2,34,7,29,229,65,223,221,220,224,173,17,202,214,227,117,8,15,129,10,222,97,207,212,50,61,201,52,68,152,41,51,12,39,204,76,24,43,28,23,89,205,189,54,30,25,164,178,42,72,74]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w,I,E,o,c,a,h,t,n,s,l,u,f,S,A,T,U,H,Q,ne,ae,O,$,z,C,q,N,_,R,W,M,F,B,V,G,Y,Z,re,se,x,ie,ue,ye,ge,Ee,Ae,ve,me,be,_e,Te,Ye,xe,Ke,ot,ze,nt,K,te,oe,le,de,pe,Ie,Oe,Ce,Ne,qe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let at=class extends H.Disposable{constructor(fe,we,Le,he,ke,Se,Pe,De,Me,We){super();this.mainProcessNodeIpcServer=fe,this.userEnv=we,this.mainInstantiationService=Le,this.logService=he,this.environmentMainService=ke,this.lifecycleMainService=Se,this.configurationService=Pe,this.stateService=De,this.fileService=Me,this.productService=We,this.registerListeners()}registerListeners(){(0,R.setUnexpectedErrorHandler)(he=>this.onUnexpectedError(he)),process.on("uncaughtException",he=>this.onUnexpectedError(he)),process.on("unhandledRejection",he=>(0,R.onUnexpectedError)(he)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,B.registerContextMenuListener)(),k.app.on("accessibility-support-changed",(he,ke)=>{var Se;(Se=this.windowsMainService)===null||Se===void 0||Se.sendToAll("vscode:accessibilitySupportChanged",ke)}),k.app.on("activate",(he,ke)=>{var Se;this.logService.trace("app#activate"),ke||(Se=this.windowsMainService)===null||Se===void 0||Se.openEmptyWindow({context:1})}),k.app.on("remote-require",(he,ke,Se)=>{this.logService.trace("app#on(remote-require): prevented"),he.preventDefault()}),k.app.on("remote-get-global",(he,ke,Se)=>{this.logService.trace(`app#on(remote-get-global): prevented on ${Se}`),he.preventDefault()}),k.app.on("remote-get-builtin",(he,ke,Se)=>{this.logService.trace(`app#on(remote-get-builtin): prevented on ${Se}`),Se!=="clipboard"&&he.preventDefault()}),k.app.on("remote-get-current-window",he=>{this.logService.trace("app#on(remote-get-current-window): prevented"),he.preventDefault()}),k.app.on("remote-get-current-web-contents",he=>{this.environmentMainService.args.driver||(this.logService.trace("app#on(remote-get-current-web-contents): prevented"),he.preventDefault())}),k.app.on("web-contents-created",(he,ke)=>{ke.on("will-attach-webview",(Pe,De,Me)=>{const We=$e=>{if(!$e)return!1;const Ue=ne.URI.parse($e);if(Ue.scheme===Z.Schemas.vscodeWebview)return Ue.path==="/index.html"||Ue.path==="/electron-browser-index.html";const Je=Ue.fsPath.toLowerCase(),Re=ne.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return Je.startsWith(Re+V.sep)};delete De.preload,De.nodeIntegration=!1,!(We(Me.src)&&We(De.preloadURL))&&(delete De.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),Pe.preventDefault())}),ke.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),ke.on("new-window",(Pe,De)=>{var Me;Pe.preventDefault(),(Me=this.nativeHostMainService)===null||Me===void 0||Me.openExternal(void 0,De)});const Se=Pe=>Pe.startsWith(`${Z.Schemas.vscodeWebview}://`);k.session.defaultSession.setPermissionRequestHandler((Pe,De,Me,We)=>Se(We.requestingUrl)?Me(De==="clipboard-read"):Me(!1)),k.session.defaultSession.setPermissionCheckHandler((Pe,De,Me,We)=>Se(We.requestingUrl)?De==="clipboard-read":!1)});let fe=[],we=null;k.app.on("open-file",(he,ke)=>{this.logService.trace("app#open-file: ",ke),he.preventDefault(),fe.push(this.getWindowOpenableFromPathSync(ke)),we!==null&&(clearTimeout(we),we=null),we=setTimeout(()=>{var Se;(Se=this.windowsMainService)===null||Se===void 0||Se.open({context:1,cli:this.environmentMainService.args,urisToOpen:fe,gotoLineMode:!1,preferNewWindow:!0}),fe=[],we=null},100)}),k.app.on("new-window-for-tab",()=>{var he;(he=this.windowsMainService)===null||he===void 0||he.openEmptyWindow({context:4})});let Le=!1;k.ipcMain.handle("vscode:fetchShellEnv",he=>new Promise(async ke=>{var Se;const Pe=he.sender;let De=!1;function Me(je){clearTimeout($e),clearTimeout(Je),De||(De=!0,Pe.isDestroyed()||ke(je))}const We=new pe.CancellationTokenSource,$e=setTimeout(()=>{var je;Le||((je=this.windowsMainService)===null||je===void 0||je.sendToFocused("vscode:showShellEnvSlowWarning",We.token),Le=!0)},3e3),Ue=(Se=this.windowsMainService)===null||Se===void 0?void 0:Se.getWindowByWebContents(he.sender),Je=setTimeout(()=>{We.dispose(!0),Ue==null||Ue.sendWhenReady("vscode:showShellEnvTimeoutError",pe.CancellationToken.None),Me({})},1e4);let Re,Qe;(Ue==null?void 0:Ue.config)?(Re=Ue.config,Qe=Object.assign(Object.assign({},process.env),Ue.config.userEnv)):(Re=this.environmentMainService.args,Qe=process.env);const Xe=await(0,p.resolveShellEnv)(this.logService,Re,Qe);Me(Xe)})),k.ipcMain.handle("vscode:writeNlsFile",(he,ke,Se)=>{const Pe=this.validateNlsPath([ke]);if(!Pe||typeof Se!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Pe,nt.VSBuffer.fromString(Se))}),k.ipcMain.handle("vscode:readNlsFile",async(he,...ke)=>{const Se=this.validateNlsPath(ke);if(!Se)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Se)).value.toString()}),k.ipcMain.on("vscode:toggleDevTools",he=>he.sender.toggleDevTools()),k.ipcMain.on("vscode:openDevTools",he=>he.sender.openDevTools()),k.ipcMain.on("vscode:reloadWindow",he=>he.sender.reload())}validateNlsPath(fe){let we;for(const Le of fe)typeof Le=="string"&&(typeof we!="string"?we=Le:we=(0,V.join)(we,Le));if(!(typeof we!="string"||!(0,V.isAbsolute)(we)||!(0,de.isEqualOrParent)(we,this.environmentMainService.cachedLanguagesPath,!y.isLinux)))return ne.URI.file(we)}onUnexpectedError(fe){var we;if(fe){const Le={message:`[uncaught exception in main]: ${fe.message}`,stack:fe.stack};(we=this.windowsMainService)===null||we===void 0||we.sendToFocused("vscode:reportError",JSON.stringify(Le))}this.logService.error(`[uncaught exception in main]: ${fe}`),fe.stack&&this.logService.error(fe.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);try{const Me=ne.URI.file(this.environmentMainService.chromeCachedDataDir);this.logService.trace(`Deleting Chrome cached data path: ${Me.fsPath}`),await this.fileService.del(Me,{recursive:!0})}catch(Me){Me.fileOperationResult!==1&&this.logService.error(Me)}const fe=this.productService.win32AppUserModelId;y.isWindows&&fe&&k.app.setAppUserModelId(fe);try{y.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!k.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&k.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Me){this.logService.error(Me)}const we=new b.Server;this.logService.trace("Resolving machine identifier...");const Le=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Le}`);const{sharedProcess:he,sharedProcessReady:ke,sharedProcessClient:Se}=this.setupSharedProcess(Le),Pe=await this.initServices(Le,he,ke);if(this.environmentMainService.driverHandle){const Me=await(0,M.serve)(we,this.environmentMainService.driverHandle,this.environmentMainService,Pe);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Me)}this._register(Pe.createInstance(U.ProxyAuthHandler)),Pe.invokeFunction(Me=>this.initChannels(Me,we,Se));const De=Pe.invokeFunction(Me=>this.openFirstWindow(Me,we));Pe.invokeFunction(Me=>this.afterWindowOpen(Me,he)),this.environmentMainService.args.trace&&Pe.invokeFunction(Me=>this.stopTracingEventually(Me,De))}async resolveMachineId(){let fe=this.stateService.getItem(l.machineIdKey);return(!fe||y.isMacintosh&&fe==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(fe=await(0,$.getMachineId)(),this.stateService.setItem(l.machineIdKey,fe)),fe}setupSharedProcess(fe){const we=this._register(this.mainInstantiationService.createInstance(d.SharedProcess,fe,this.userEnv)),Le=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ke=await we.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new v.Client(ke,"main")})(),he=(async()=>(await we.whenReady(),Le))();return{sharedProcess:we,sharedProcessReady:he,sharedProcessClient:Le}}async initServices(fe,we,Le){const he=new E.ServiceCollection;switch(process.platform){case"win32":he.set(i.IUpdateService,new o.SyncDescriptor(z.Win32UpdateService));break;case"linux":y.isLinuxSnap?he.set(i.IUpdateService,new o.SyncDescriptor(re.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):he.set(i.IUpdateService,new o.SyncDescriptor(C.LinuxUpdateService));break;case"darwin":he.set(i.IUpdateService,new o.SyncDescriptor(q.DarwinUpdateService));break}he.set(Q.IWindowsMainService,new o.SyncDescriptor(P.WindowsMainService,[fe,this.userEnv])),he.set(be.IDialogMainService,new o.SyncDescriptor(be.DialogMainService)),he.set(w.ILaunchMainService,new o.SyncDescriptor(w.LaunchMainService)),he.set(Ae.IDiagnosticsService,g.ProxyChannel.toService((0,g.getDelayedChannel)(Le.then(Se=>Se.getChannel("diagnostics"))))),he.set(N.IIssueMainService,new o.SyncDescriptor(N.IssueMainService,[this.userEnv])),he.set(K.IEncryptionMainService,new o.SyncDescriptor(K.EncryptionMainService,[fe])),he.set(oe.IKeyboardLayoutMainService,new o.SyncDescriptor(oe.KeyboardLayoutMainService)),he.set(me.INativeHostMainService,new o.SyncDescriptor(me.NativeHostMainService,[we])),he.set(xe.IWebviewManagerService,new o.SyncDescriptor(Ye.WebviewMainService)),he.set(ae.IWorkspacesService,new o.SyncDescriptor(O.WorkspacesMainService)),he.set(Ee.IWorkspacesManagementMainService,new o.SyncDescriptor(Ee.WorkspacesManagementMainService)),he.set(ye.IWorkspacesHistoryMainService,new o.SyncDescriptor(ye.WorkspacesHistoryMainService)),he.set(F.IMenubarMainService,new o.SyncDescriptor(F.MenubarMainService)),he.set(Ie.IExtensionUrlTrustService,new o.SyncDescriptor(Oe.ExtensionUrlTrustService)),he.set(se.IStorageMainService,new o.SyncDescriptor(se.StorageMainService));const ke=new ie.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(he.set(ue.IBackupMainService,ke),he.set(n.IURLService,new o.SyncDescriptor(ge.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const Se=(0,g.getDelayedChannel)(Le.then($e=>$e.getChannel("telemetryAppender"))),Pe=new f.TelemetryAppenderClient(Se),De=(0,A.resolveCommonProperties)(this.fileService,(0,m.release)(),process.arch,this.productService.commit,this.productService.version,fe,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Me=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],We={appender:Pe,commonProperties:De,piiPaths:Me,sendErrorTelemetry:!0};he.set(l.ITelemetryService,new o.SyncDescriptor(S.TelemetryService,[We]))}else he.set(l.ITelemetryService,u.NullTelemetryService);return await ke.initialize(),this.mainInstantiationService.createChild(he)}initChannels(fe,we,Le){const he=g.ProxyChannel.fromService(fe.get(w.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",he);const ke=new L.UpdateChannel(fe.get(i.IUpdateService));we.registerChannel("update",ke);const Se=g.ProxyChannel.fromService(fe.get(N.IIssueMainService));we.registerChannel("issue",Se);const Pe=g.ProxyChannel.fromService(fe.get(K.IEncryptionMainService));we.registerChannel("encryption",Pe);const De=g.ProxyChannel.fromService(fe.get(qe.ISignService));we.registerChannel("sign",De);const Me=g.ProxyChannel.fromService(fe.get(oe.IKeyboardLayoutMainService));we.registerChannel("keyboardLayout",Me),this.nativeHostMainService=fe.get(me.INativeHostMainService);const We=g.ProxyChannel.fromService(this.nativeHostMainService);we.registerChannel("nativeHost",We),Le.then(He=>He.registerChannel("nativeHost",We));const $e=g.ProxyChannel.fromService(fe.get(ae.IWorkspacesService));we.registerChannel("workspaces",$e);const Ue=g.ProxyChannel.fromService(fe.get(F.IMenubarMainService));we.registerChannel("menubar",Ue);const Je=g.ProxyChannel.fromService(fe.get(n.IURLService));we.registerChannel("url",Je);const Re=g.ProxyChannel.fromService(fe.get(Ie.IExtensionUrlTrustService));we.registerChannel("extensionUrlTrust",Re);const Qe=g.ProxyChannel.fromService(fe.get(xe.IWebviewManagerService));we.registerChannel("webview",Qe);const Xe=this._register(new x.StorageDatabaseChannel(this.logService,fe.get(se.IStorageMainService)));we.registerChannel("storage",Xe),Le.then(He=>He.registerChannel("storage",Xe));const je=new _.LogLevelChannel(fe.get(c.ILogService));we.registerChannel("logLevel",je),Le.then(He=>He.registerChannel("logLevel",je));const tt=new _.LoggerChannel(fe.get(c.ILoggerService));we.registerChannel("logger",tt),Le.then(He=>He.registerChannel("logger",tt));const rt=new ve.ElectronExtensionHostDebugBroadcastChannel(fe.get(Q.IWindowsMainService));we.registerChannel("extensionhostdebugservice",rt)}openFirstWindow(fe,we){const Le=this.windowsMainService=fe.get(Q.IWindowsMainService),he=fe.get(n.IURLService),ke=fe.get(me.INativeHostMainService);this.lifecycleMainService.phase=2;const Se=[],Pe=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Be=>{try{return{uri:ne.URI.parse(Be),url:Be}}catch(Ze){return null}}).filter(Be=>{if(!Be||this.shouldBlockURI(Be.uri))return!1;const Ze=this.getWindowOpenableFromProtocolLink(Be.uri);return Ze?(Se.push(Ze),!1):!0}),De=this,Me=this.environmentMainService;he.registerHandler({async handleURL(Be,Ze){if(De.shouldBlockURI(Be))return!0;const vt=De.getWindowOpenableFromProtocolLink(Be);if(vt){const[ct]=Le.open({context:5,cli:Object.assign({},Me.args),urisToOpen:[vt],gotoLineMode:!0});return ct.focus(),!0}if(y.isMacintosh&&Le.getWindowCount()===0){const[ct]=Le.open({context:5,cli:Object.assign({},Me.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ne.getRemoteAuthority)(Be)});return await ct.ready(),he.open(Be,Ze)}return!1}});const We=this._register(new te.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),$e=new g.StaticRouter(Be=>We.getActiveClientId().then(Ze=>Be===Ze)),Ue=new s.URLHandlerRouter($e),Je=we.getChannel("urlHandler",Ue);he.registerHandler(new s.URLHandlerChannelClient(Je)),this._register(new W.ElectronURLListener(Pe,he,Le,this.environmentMainService,this.productService));const Re=this.environmentMainService.args,Qe=global.macOpenFiles,Xe=(0,le.isLaunchedFromCli)(process.env)?0:4,je=Re._.length,tt=!!Re["folder-uri"],rt=!!Re["file-uri"],He=Re["skip-add-to-recently-opened"]===!0,lt=Re.wait&&Re.waitMarkerFilePath?ne.URI.file(Re.waitMarkerFilePath):void 0,mt=Re.remote||void 0;return Se.length>0?Le.open({context:Xe,cli:Re,urisToOpen:Se,gotoLineMode:!0,initialStartup:!0}):Re["new-window"]&&!je&&!tt&&!rt?Le.open({context:Xe,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:He,waitMarkerFileURI:lt,initialStartup:!0,remoteAuthority:mt}):Qe.length&&!je&&!tt&&!rt?Le.open({context:1,cli:Re,urisToOpen:Qe.map(Be=>this.getWindowOpenableFromPathSync(Be)),noRecentEntry:He,waitMarkerFileURI:lt,initialStartup:!0}):Le.open({context:Xe,cli:Re,forceNewWindow:Re["new-window"]||!je&&Re["unity-launch"],diffMode:Re.diff,noRecentEntry:He,waitMarkerFileURI:lt,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:mt})}shouldBlockURI(fe){return!!(fe.authority===Z.Schemas.file&&y.isWindows&&k.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,Te.mnemonicButtonLabel)((0,Y.localize)(0,null)),(0,Te.mnemonicButtonLabel)((0,Y.localize)(1,null))],cancelId:1,message:(0,Y.localize)(2,null,(0,Te.getPathLabel)(fe.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,Y.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(fe){if(!!fe.path){if(fe.authority===Z.Schemas.file)return{fileUri:ne.URI.file(fe.fsPath)};if(fe.authority===Z.Schemas.vscodeRemote){const we=fe.path.indexOf(V.posix.sep,1);if(we!==-1){const Le=fe.path.substring(1,we),he=fe.path.substring(we),ke=ne.URI.from({scheme:Z.Schemas.vscodeRemote,authority:Le,path:he,query:fe.query,fragment:fe.fragment});return(0,ae.hasWorkspaceFileExtension)(he)?{workspaceUri:ke}:{folderUri:ke}}}}}getWindowOpenableFromPathSync(fe){try{if((0,D.statSync)(fe).isDirectory())return{folderUri:ne.URI.file(fe)};if((0,ae.hasWorkspaceFileExtension)(fe))return{workspaceUri:ne.URI.file(fe)}}catch(we){}return{fileUri:ne.URI.file(fe)}}async afterWindowOpen(fe,we){var Le;this.lifecycleMainService.phase=3;const he=fe.get(l.ITelemetryService);this._register(we.onDidError(({type:Pe,details:De})=>{let Me;typeof De=="string"?Me=De:Me=`SharedProcess: crashed (detail: ${De.reason})`,(0,R.onUnexpectedError)(new Error(Me)),he.publicLog2("sharedprocesserror",{type:Pe,reason:typeof De!="string"?De==null?void 0:De.reason:void 0,visible:we.isVisible()})}));const ke=this.productService.win32MutexName;if(y.isWindows&&ke)try{const Pe=j.__$__nodeRequire("windows-mutex").Mutex,De=new Pe(ke);(0,Ce.once)(this.lifecycleMainService.onWillShutdown)(()=>De.release())}catch(Pe){this.logService.error(Pe)}k.protocol.registerHttpProtocol(Z.Schemas.vscodeRemoteResource,(Pe,De)=>{De({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})});const Se=fe.get(i.IUpdateService);(Se instanceof z.Win32UpdateService||Se instanceof C.LinuxUpdateService||Se instanceof q.DarwinUpdateService)&&Se.initialize(),(0,p.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const De=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,ot.stripComments)(De))["enable-crash-reporter"]===void 0){const We=(Le=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&Le!==void 0?Le:!0,$e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${We},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,ze.generateUuid)()}"`,"}"],Ue=De.substring(0,De.length-2).concat(`,
`,$e.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,nt.VSBuffer.fromString(Ue))}}catch(Pe){this.logService.error(Pe)}}stopTracingEventually(fe,we){this.logService.info("Tracing: waiting for windows to get ready...");const Le=fe.get(be.IDialogMainService);let he=!1;const ke=async Pe=>{if(!he){he=!0;const De=await k.contentTracing.stopRecording((0,G.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Pe?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${De}`):Le.showMessageBox({type:"info",message:(0,Y.localize)(4,null),detail:(0,Y.localize)(5,null,De),buttons:[(0,Y.localize)(6,null)]},(0,_e.withNullAsUndefined)(k.BrowserWindow.getFocusedWindow()))}},Se=setTimeout(()=>ke(!0),3e4);Promise.all(we.map(Pe=>Pe.ready())).then(()=>{clearTimeout(Se),ke(!1)})}};at=ce([ee(2,I.IInstantiationService),ee(3,c.ILogService),ee(4,h.IEnvironmentMainService),ee(5,r.ILifecycleMainService),ee(6,t.IConfigurationService),ee(7,a.IStateService),ee(8,Ke.IFileService),ee(9,T.IProductService)],at),e.CodeApplication=at}),define(X[234],J([0,1,13,18,11,3,71,47,54,156,16,33,56,168,70,67,6,190,38,21,182,49,218,230,39,92,91,17,75,42,74,188,192,176,177,10,24,73,216,20,30,22,8,35,26,66,95,174,32,55,179,198]),function(j,e,m,D,k,y,P,r,p,i,L,g,b,v,d,w,I,E,o,c,a,h,t,n,s,l,u,f,S,A,T,U,H,Q,ne,ae,O,$,z,C,q,N,_,R,W,M,F,B,V,G,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Z{main(){try{this.startup()}catch(x){console.error(x.message),m.app.exit(1)}}async startup(){(0,f.setUnexpectedErrorHandler)(ve=>console.error(ve));const[x,ie,ue,ye,ge,Ee,Ae]=this.createServices();try{try{await this.initServices(ue,ye,ge)}catch(ve){throw this.handleStartupDataDirError(ue,Ae.nameLong,ve),ve}await x.invokeFunction(async ve=>{const me=ve.get(I.ILogService),be=ve.get(L.ILifecycleMainService),_e=ve.get(O.IFileService),Te=await this.claimInstance(me,ue,be,x,Ae,!0);return Ee.logger=new l.SpdLogLogger("main",(0,_.join)(ue.logsPath,"main.log"),!0,Ee.getLevel()),(0,A.once)(be.onWillShutdown)(()=>{_e.dispose(),ye.dispose()}),x.createInstance(n.CodeApplication,Te,ie).startup()})}catch(ve){x.invokeFunction(this.quit,ve)}}createServices(){const x=new d.ServiceCollection,ie=Object.assign({_serviceBrand:void 0},r.default);x.set(C.IProductService,ie);const ue=new W.EnvironmentMainService(this.resolveArgs(),ie),ye=this.patchEnvironment(ue);x.set(W.IEnvironmentMainService,ue);const ge=new u.BufferLogService,Ee=new I.MultiplexLogService([new I.ConsoleMainLogger((0,I.getLogLevel)(ue)),ge]);process.once("exit",()=>Ee.dispose()),x.set(I.ILogService,Ee);const Ae=new Q.FileService(Ee);x.set(O.IFileService,Ae);const ve=new ne.DiskFileSystemProvider(Ee);Ae.registerProvider(ae.Schemas.file,ve),x.set(I.ILoggerService,new B.LoggerService(Ee,Ae));const me=new a.ConfigurationService(ue.settingsResource,Ae);x.set(c.IConfigurationService,me),x.set(L.ILifecycleMainService,new w.SyncDescriptor(L.LifecycleMainService));const be=new E.StateService(ue,Ee);return x.set(o.IStateService,be),x.set(h.IRequestService,new w.SyncDescriptor(t.RequestMainService)),x.set(S.IThemeMainService,new w.SyncDescriptor(S.ThemeMainService)),x.set(T.ISignService,new w.SyncDescriptor(U.SignService)),x.set($.ITunnelService,new w.SyncDescriptor(z.TunnelService)),x.set(G.IProtocolMainService,new w.SyncDescriptor(Y.ProtocolMainService)),[new v.InstantiationService(x,!0),ye,ue,me,be,ge,ie]}patchEnvironment(x){const ie={VSCODE_IPC_HOOK:x.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const ye=process.env[ue];typeof ye=="string"&&(ie[ue]=ye)}),Object.assign(process.env,ie),ie}initServices(x,ie,ue){const ye=Promise.all([x.extensionsPath,x.nodeCachedDataDir,x.logsPath,x.globalStorageHome.fsPath,x.workspaceStorageHome.fsPath,x.backupHome].map(Ae=>Ae?D.promises.mkdir(Ae,{recursive:!0}):void 0)),ge=ie.initialize(),Ee=ue.init();return Promise.all([ye,ge,Ee])}async claimInstance(x,ie,ue,ye,ge,Ee){let Ae;try{(0,P.mark)("code/willStartMainServer"),Ae=await(0,b.serve)(ie.mainIPCHandle),(0,P.mark)("code/didStartMainServer"),(0,A.once)(ue.onWillShutdown)(()=>Ae.dispose())}catch(ve){if(ve.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ie,ge.nameLong,ve),ve;let me;try{me=await(0,b.connect)(ie.mainIPCHandle,"main")}catch(Te){if(!Ee||y.isWindows||Te.code!=="ECONNREFUSED")throw Te.code==="EPERM"&&this.showStartupWarningDialog((0,k.localize)(0,null,ge.nameShort),(0,k.localize)(1,null),ge.nameLong),Te;try{(0,D.unlinkSync)(ie.mainIPCHandle)}catch(Ye){throw x.warn("Could not delete obsolete instance handle",Ye),Ye}return this.claimInstance(x,ie,ue,ye,ge,!1)}if(ie.extensionTestsLocationURI&&!ie.debugExtensionHost.break){const Te="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw x.error(Te),me.dispose(),new Error(Te)}let be;!ie.args.wait&&!ie.args.status&&(be=setTimeout(()=>{this.showStartupWarningDialog((0,k.localize)(2,null,ge.nameShort),(0,k.localize)(3,null),ge.nameLong)},1e4));const _e=g.ProxyChannel.toService(me.getChannel("launch"),{disableMarshalling:!0});if(ie.args.status)return ye.invokeFunction(async()=>{const Te=new H.DiagnosticsService(F.NullTelemetryService,ge),Ye=await _e.getMainProcessInfo(),xe=await _e.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ke=await Te.getDiagnostics(Ye,xe);throw console.log(Ke),new f.ExpectedError});throw y.isWindows&&await this.windowsAllowSetForegroundWindow(_e,x),x.trace("Sending env to running instance..."),await _e.start(ie.args,process.env),me.dispose(),be&&clearTimeout(be),new f.ExpectedError("Sent env to running instance. Terminating...")}if(ie.args.status)throw x.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ae}handleStartupDataDirError(x,ie,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const ye=(0,R.coalesce)([x.userDataPath,x.extensionsPath,b.XDG_RUNTIME_DIR]).map(ge=>(0,s.getPathLabel)(ge,x));this.showStartupWarningDialog((0,k.localize)(4,null),(0,k.localize)(5,null,(0,M.toErrorMessage)(ue),ye.join(`
`)),ie)}}showStartupWarningDialog(x,ie,ue){m.dialog.showMessageBoxSync({title:ue,type:"warning",buttons:[(0,s.mnemonicButtonLabel)((0,k.localize)(6,null))],message:x,detail:ie,noLink:!0})}async windowsAllowSetForegroundWindow(x,ie){if(y.isWindows){const ue=await x.getMainProcessId();ie.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((ye,ge)=>{j(["windows-foreground-love"],ye,ge)})).allowSetForegroundWindow(ue)}catch(ye){ie.error(ye)}}}quit(x,ie){const ue=x.get(I.ILogService),ye=x.get(L.ILifecycleMainService);let ge=0;ie&&(ie.isExpected?ie.message&&ue.trace(ie.message):(ge=1,ie.stack?ue.error(ie.stack):ue.error(`Startup error: ${ie.toString()}`))),ye.kill(ge)}resolveArgs(){const x=this.validatePaths((0,p.parseMainProcessArgv)(process.argv));if(x.wait&&!x.waitMarkerFilePath){const ie=(0,i.createWaitMarkerFile)(x.verbose);ie&&((0,p.addArg)(process.argv,"--waitMarkerFilePath",ie),x.waitMarkerFilePath=ie)}return x}validatePaths(x){if(x["open-url"]&&(x._urls=x._,x._=[]),!x.remote){const ie=this.doValidatePaths(x._,x.goto);x._=ie}return x}doValidatePaths(x,ie){const ue=(0,V.cwd)(),ye=x.map(Ae=>{let ve=String(Ae),me;ie&&(me=(0,q.parseLineAndColumnAware)(ve),ve=me.path),ve&&(ve=this.preparePath(ue,ve));const be=(0,q.sanitizeFilePath)(ve,ue),_e=(0,_.basename)(be);return _e&&!(0,q.isValidBasename)(_e)?null:ie&&me?(me.path=be,this.toPath(me)):be}),ge=y.isWindows||y.isMacintosh,Ee=(0,R.distinct)(ye,Ae=>Ae&&ge?Ae.toLowerCase():Ae||"");return(0,R.coalesce)(Ee)}preparePath(x,ie){return y.isWindows&&(ie=(0,N.rtrim)(ie,'"')),ie=(0,N.trim)((0,N.trim)(ie," "),"	"),y.isWindows&&(ie=(0,_.resolve)(x,ie),ie=(0,N.rtrim)(ie,".")),ie}toPath(x){const ie=[x.path];return typeof x.line=="number"&&ie.push(String(x.line)),typeof x.column=="number"&&ie.push(String(x.column)),ie.join(":")}}new Z().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8aff878db2542eea2dfb571c8bb485118bbb3113/core/vs/code/electron-main/main.js.map
