/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/platform","vs/base/common/strings","vs/base/common/network","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/errors","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/base/common/resources","vs/base/node/pfs","vs/workbench/api/common/extHostInitDataService","vs/base/common/uuid","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","fs","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","os","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/externalTerminal/node/externalTerminal","vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProfiles","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(G){for(var e=[],_=0,k=G.length;_<k;_++)e[_]=me[G[_]];return e};define(me[52],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function _(k,A){if(!k)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=_}),define(me[53],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const _=Object.prototype.hasOwnProperty;function k(T){const C=[];for(let m in T)_.call(T,m)&&C.push(T[m]);return C}e.values=k;function A(T,C){for(let m in T)if(_.call(T,m)&&C({key:m,value:T[m]},function(){delete T[m]})===!1)return}e.forEach=A;function I(T,C){const m=Object.create(null);for(const f of T){const a=C(f);let d=m[a];d||(d=m[a]=[]),d.push(f)}return m}e.groupBy=I;function y(T){const C=Object.create(null);return T&&T.forEach((m,f)=>{C[f]=m}),C}e.fromMap=y;function P(T,C){const m=[],f=[];for(let a of T)C.has(a)||m.push(a);for(let a of C)T.has(a)||f.push(a);return{removed:m,added:f}}e.diffSets=P;function D(T,C){const m=[],f=[];for(let[a,d]of T)C.has(a)||m.push(d);for(let[a,d]of C)T.has(a)||f.push(d);return{removed:m,added:f}}e.diffMaps=D;class i{constructor(){this.map=new Map}add(C,m){let f=this.map.get(C);f||(f=new Set,this.map.set(C,f)),f.add(m)}delete(C,m){const f=this.map.get(C);!f||(f.delete(m),f.size===0&&this.map.delete(C))}forEach(C,m){const f=this.map.get(C);!f||f.forEach(m)}}e.SetMap=i}),define(me[70],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function _(D){return(i,T,C)=>{let m=null,f=null;if(typeof C.value=="function"?(m="value",f=C.value):typeof C.get=="function"&&(m="get",f=C.get),!f)throw new Error("not supported");C[m]=D(f,T)}}e.createDecorator=_;let k=0;function A(){const D=`$memoize${k++}`;let i;const T=function(m,f,a){let d=null,E=null;if(typeof a.value=="function"?(d="value",E=a.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(d="get",E=a.get),!E)throw new Error("not supported");const w=`${D}:${f}`;a[d]=function(...b){return i=this,this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!0,enumerable:!1,writable:!0,value:E.apply(this,b)}),this[w]}};return T.clear=()=>{typeof i!="undefined"&&Object.getOwnPropertyNames(i).forEach(C=>{C.indexOf(D)===0&&delete i[C]})},T}e.createMemoizer=A;function I(D,i,T){return A()(D,i,T)}e.memoize=I;function y(D,i,T){return _((C,m)=>{const f=`$debounce$${m}`,a=`$debounce$result$${m}`;return function(...d){this[a]||(this[a]=T?T():void 0),clearTimeout(this[f]),i&&(this[a]=i(this[a],...d),d=[this[a]]),this[f]=setTimeout(()=>{C.apply(this,d),this[a]=T?T():void 0},D)}})}e.debounce=y;function P(D,i,T){return _((C,m)=>{const f=`$throttle$timer$${m}`,a=`$throttle$result$${m}`,d=`$throttle$lastRun$${m}`,E=`$throttle$pending$${m}`;return function(...w){if(this[a]||(this[a]=T?T():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),i&&(this[a]=i(this[a],...w)),!this[E]){const b=this[d]+D;b<=Date.now()?(this[d]=Date.now(),C.apply(this,[this[a]]),this[a]=T?T():void 0):(this[E]=!0,this[f]=setTimeout(()=>{this[E]=!1,this[d]=Date.now(),C.apply(this,[this[a]]),this[a]=T?T():void 0},b-Date.now()))}}})}e.throttle=P}),define(me[18],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=_,e.errorHandler=new _;function k(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=k;function A(g){D(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=A;function I(g){D(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=I;function y(g){if(g instanceof Error){let{name:t,message:n}=g;const s=g.stacktrace||g.stack;return{$isError:!0,name:t,message:n,stack:s}}return g}e.transformErrorForSerialization=y;const P="Canceled";function D(g){return g instanceof Error&&g.name===P&&g.message===P}e.isPromiseCanceledError=D;class i extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=i;function T(){const g=new Error(P);return g.name=g.message,g}e.canceled=T;function C(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=C;function m(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=m;function f(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function a(g){const t=new Error(`${g} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function d(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=d;class E extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=E;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function p(g){const t=g;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=p;function c(g,t=Object.create(null)){const n=new Error(g);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=c}),define(me[15],ge([0,1,18]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k(N,M=0){return N[N.length-(1+M)]}e.tail=k;function A(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=A;function I(N,M,F=(U,O)=>U===O){if(N===M)return!0;if(!N||!M||N.length!==M.length)return!1;for(let U=0,O=N.length;U<O;U++)if(!F(N[U],M[U]))return!1;return!0}e.equals=I;function y(N,M,F){let U=0,O=N.length-1;for(;U<=O;){const W=(U+O)/2|0,q=F(N[W],M);if(q<0)U=W+1;else if(q>0)O=W-1;else return W}return-(U+1)}e.binarySearch=y;function P(N,M){let F=0,U=N.length;if(U===0)return 0;for(;F<U;){const O=Math.floor((F+U)/2);M(N[O])?U=O:F=O+1}return F}e.findFirstInSorted=P;function D(N,M,F){if(N=N|0,N>=M.length)throw new TypeError("invalid index");let U=M[Math.floor(M.length*Math.random())],O=[],W=[],q=[];for(let Q of M){const he=F(Q,U);he<0?O.push(Q):he>0?W.push(Q):q.push(Q)}return N<O.length?D(N,O,F):N<O.length+q.length?q[0]:D(N-(O.length+q.length),W,F)}e.quickSelect=D;function i(N,M){const F=[];let U;for(const O of N.slice(0).sort(M))!U||M(U[0],O)!==0?(U=[O],F.push(U)):U.push(O);return F}e.groupBy=i;function T(N,M,F){const U=[];function O(Q,he,ve){if(!(he===0&&ve.length===0)){const Ie=U[U.length-1];Ie&&Ie.start+Ie.deleteCount===Q?(Ie.deleteCount+=he,Ie.toInsert.push(...ve)):U.push({start:Q,deleteCount:he,toInsert:ve})}}let W=0,q=0;for(;;){if(W===N.length){O(W,0,M.slice(q));break}if(q===M.length){O(W,N.length-W,[]);break}const Q=N[W],he=M[q],ve=F(Q,he);ve===0?(W+=1,q+=1):ve<0?(O(W,1,[]),W+=1):ve>0&&(O(W,0,[he]),q+=1)}return U}e.sortedDiff=T;function C(N,M,F){const U=T(N,M,F),O=[],W=[];for(const q of U)O.push(...N.slice(q.start,q.start+q.deleteCount)),W.push(...q.toInsert);return{removed:O,added:W}}e.delta=C;function m(N,M,F){if(F===0)return[];const U=N.slice(0,F).sort(M);return a(N,M,U,F,N.length),U}e.top=m;function f(N,M,F,U,O){return F===0?Promise.resolve([]):new Promise((W,q)=>{(async()=>{const Q=N.length,he=N.slice(0,F).sort(M);for(let ve=F,Ie=Math.min(F+U,Q);ve<Q;ve=Ie,Ie=Math.min(Ie+U,Q)){if(ve>F&&await new Promise(ke=>setTimeout(ke)),O&&O.isCancellationRequested)throw(0,_.canceled)();a(N,M,he,ve,Ie)}return he})().then(W,q)})}e.topAsync=f;function a(N,M,F,U,O){for(const W=F.length;U<O;U++){const q=N[U];if(M(q,F[W-1])<0){F.pop();const Q=P(F,he=>M(q,he)<0);F.splice(Q,0,q)}}}function d(N){return N.filter(M=>!!M)}e.coalesce=d;function E(N){let M=0;for(let F=0;F<N.length;F++)N[F]&&(N[M]=N[F],M+=1);N.length=M}e.coalesceInPlace=E;function w(N,M,F){N.splice(F,0,N.splice(M,1)[0])}e.move=w;function b(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=b;function p(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=p;function c(N,M){if(!M)return N.filter((U,O)=>N.indexOf(U)===O);const F=Object.create(null);return N.filter(U=>{const O=M(U);return F[O]?!1:(F[O]=!0,!0)})}e.distinct=c;function g(N){const M=new Set;return N.filter(F=>M.has(F)?!1:(M.add(F),!0))}e.distinctES6=g;function t(N){const M=Object.create(null);return F=>{const U=N(F);return M[U]?!1:(M[U]=!0,!0)}}e.uniqueFilter=t;function n(N,M){for(let F=N.length-1;F>=0;F--){const U=N[F];if(M(U))return F}return-1}e.lastIndex=n;function s(N,M){return N.length>0?N[0]:M}e.firstOrDefault=s;function r(N,M,F=(U,O)=>U===O){let U=0;for(let O=0,W=Math.min(N.length,M.length);O<W&&F(N[O],M[O]);O++)U++;return U}e.commonPrefixLength=r;function o(N){return[].concat(...N)}e.flatten=o;function l(N,M){let F=typeof M=="number"?N:0;typeof M=="number"?F=N:(F=0,M=N);const U=[];if(F<=M)for(let O=F;O<M;O++)U.push(O);else for(let O=F;O>M;O--)U.push(O);return U}e.range=l;function h(N,M,F){return N.reduce((U,O)=>(U[M(O)]=F?F(O):O,U),Object.create(null))}e.index=h;function S(N,M){return N.push(M),()=>u(N,M)}e.insert=S;function u(N,M){const F=N.indexOf(M);if(F>-1)return N.splice(F,1),M}e.remove=u;function v(N,M,F){const U=N.slice(0,M),O=N.slice(M);return U.concat(F,O)}e.arrayInsert=v;function R(N,M){let F;if(typeof M=="number"){let U=M;F=()=>{const O=Math.sin(U++)*179426549;return O-Math.floor(O)}}else F=Math.random;for(let U=N.length-1;U>0;U-=1){const O=Math.floor(F()*(U+1)),W=N[U];N[U]=N[O],N[O]=W}}e.shuffle=R;function L(N,M){const F=N.indexOf(M);F>-1&&(N.splice(F,1),N.unshift(M))}e.pushToStart=L;function H(N,M){const F=N.indexOf(M);F>-1&&(N.splice(F,1),N.push(M))}e.pushToEnd=H;function ie(N,M){return Array.isArray(N)?N.map(M):M(N)}e.mapArrayOrNot=ie;function j(N){return Array.isArray(N)?N:[N]}e.asArray=j;function B(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=B;function $(N,M){for(const F of N){const U=M(F);if(U!==void 0)return U}}e.mapFind=$}),define(me[71],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function _(k){const A=this;let I=!1,y;return function(){return I||(I=!0,y=k.apply(A,arguments)),y}}e.once=_}),define(me[72],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class _{constructor(A){this._prefix=A,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=_,e.defaultGenerator=new _("id#")}),define(me[54],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(k){function A(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}k.is=A;const I=Object.freeze([]);function y(){return I}k.empty=y;function*P(g){yield g}k.single=P;function D(g){return g||I}k.from=D;function i(g){return!g||g[Symbol.iterator]().next().done===!0}k.isEmpty=i;function T(g){return g[Symbol.iterator]().next().value}k.first=T;function C(g,t){for(const n of g)if(t(n))return!0;return!1}k.some=C;function m(g,t){for(const n of g)if(t(n))return n}k.find=m;function*f(g,t){for(const n of g)t(n)&&(yield n)}k.filter=f;function*a(g,t){for(const n of g)yield t(n)}k.map=a;function*d(...g){for(const t of g)for(const n of t)yield n}k.concat=d;function*E(g){for(const t of g)for(const n of t)yield n}k.concatNested=E;function w(g,t,n){let s=n;for(const r of g)s=t(s,r);return s}k.reduce=w;function*b(g,t,n=g.length){for(t<0&&(t+=g.length),n<0?n+=g.length:n>g.length&&(n=g.length);t<n;t++)yield g[t]}k.slice=b;function p(g,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,g];const s=g[Symbol.iterator]();for(let r=0;r<t;r++){const o=s.next();if(o.done)return[n,k.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return s}}]}k.consume=p;function c(g,t,n=(s,r)=>s===r){const s=g[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const o=s.next(),l=r.next();if(o.done!==l.done)return!1;if(o.done)return!0;if(!n(o.value,l.value))return!1}}k.equals=c})(_=e.Iterable||(e.Iterable={}))}),define(me[55],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var _;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(_=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let s=0,r=t.length,o="",l=0,h=16,S=0;function u(B){let $=0,N=0;for(;$<B;){const M=t.charCodeAt(s);if(M>=48&&M<=57)N=N*16+M-48;else if(M>=65&&M<=70)N=N*16+M-65+10;else if(M>=97&&M<=102)N=N*16+M-97+10;else break;s++,$++}return $<B&&(N=-1),N}function v(B){s=B,o="",l=0,h=16,S=0}function R(){const B=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&i(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&i(t.charCodeAt(s)))for(s++;s<t.length&&i(t.charCodeAt(s));)s++;else return S=3,t.substring(B,s);let $=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&i(t.charCodeAt(s))){for(s++;s<t.length&&i(t.charCodeAt(s));)s++;$=s}else S=3;return t.substring(B,$)}function L(){let B="",$=s;for(;;){if(s>=r){B+=t.substring($,s),S=2;break}const N=t.charCodeAt(s);if(N===34){B+=t.substring($,s),s++;break}if(N===92){if(B+=t.substring($,s),s++,s>=r){S=2;break}switch(t.charCodeAt(s++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const F=u(4);F>=0?B+=String.fromCharCode(F):S=4;break;default:S=5}$=s;continue}if(N>=0&&N<=31)if(D(N)){B+=t.substring($,s),S=2;break}else S=6;s++}return B}function H(){if(o="",S=0,l=s,s>=r)return l=r,h=17;let B=t.charCodeAt(s);if(P(B)){do s++,o+=String.fromCharCode(B),B=t.charCodeAt(s);while(P(B));return h=15}if(D(B))return s++,o+=String.fromCharCode(B),B===13&&t.charCodeAt(s)===10&&(s++,o+=`
`),h=14;switch(B){case 123:return s++,h=1;case 125:return s++,h=2;case 91:return s++,h=3;case 93:return s++,h=4;case 58:return s++,h=6;case 44:return s++,h=5;case 34:return s++,o=L(),h=10;case 47:const $=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<r&&!D(t.charCodeAt(s));)s++;return o=t.substring($,s),h=12}if(t.charCodeAt(s+1)===42){s+=2;const N=r-1;let M=!1;for(;s<N;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,M=!0;break}s++}return M||(s++,S=1),o=t.substring($,s),h=13}return o+=String.fromCharCode(B),s++,h=16;case 45:if(o+=String.fromCharCode(B),s++,s===r||!i(t.charCodeAt(s)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=R(),h=11;default:for(;s<r&&ie(B);)s++,B=t.charCodeAt(s);if(l!==s){switch(o=t.substring(l,s),o){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return o+=String.fromCharCode(B),s++,h=16}}function ie(B){if(P(B)||D(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let B;do B=H();while(B>=12&&B<=15);return B}return{setPosition:v,getPosition:()=>s,scan:n?j:H,getToken:()=>h,getTokenValue:()=>o,getTokenOffset:()=>l,getTokenLength:()=>s-l,getTokenError:()=>S}}e.createScanner=y;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function i(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function C(t,n){const s=[],r=new Object;let o;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function S(u,v,R,L){l.value=u,l.offset=v,l.length=R,l.type=L,l.colonOffset=void 0,o=l}try{p(t,{onObjectBegin:(u,v)=>{if(n<=u)throw r;o=void 0,h=n>u,s.push("")},onObjectProperty:(u,v,R)=>{if(n<v||(S(u,v,R,"property"),s[s.length-1]=u,n<=v+R))throw r},onObjectEnd:(u,v)=>{if(n<=u)throw r;o=void 0,s.pop()},onArrayBegin:(u,v)=>{if(n<=u)throw r;o=void 0,s.push(0)},onArrayEnd:(u,v)=>{if(n<=u)throw r;o=void 0,s.pop()},onLiteralValue:(u,v,R)=>{if(n<v||(S(u,v,R,g(u)),n<=v+R))throw r},onSeparator:(u,v,R)=>{if(n<=v)throw r;if(u===":"&&o&&o.type==="property")o.colonOffset=v,h=!1,o=void 0;else if(u===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(h=!0,s[s.length-1]=""),o=void 0}}})}catch(u){if(u!==r)throw u}return{path:s,previousNode:o,isAtPropertyKey:h,matches:u=>{let v=0;for(let R=0;v<u.length&&R<s.length;R++)if(u[v]===s[R]||u[v]==="*")v++;else if(u[v]!=="**")return!1;return v===u.length}}}e.getLocation=C;function m(t,n=[],s=I.DEFAULT){let r=null,o=[];const l=[];function h(u){Array.isArray(o)?o.push(u):r!==null&&(o[r]=u)}return p(t,{onObjectBegin:()=>{const u={};h(u),l.push(o),o=u,r=null},onObjectProperty:u=>{r=u},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const u=[];h(u),l.push(o),o=u,r=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:h,onError:(u,v,R)=>{n.push({error:u,offset:v,length:R})}},s),o[0]}e.parse=m;function f(t,n=[],s=I.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(u){r.type==="property"&&(r.length=u-r.offset,r=r.parent)}function l(u){return r.children.push(u),u}p(t,{onObjectBegin:u=>{r=l({type:"object",offset:u,length:-1,parent:r,children:[]})},onObjectProperty:(u,v,R)=>{r=l({type:"property",offset:v,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:u,offset:v,length:R,parent:r})},onObjectEnd:(u,v)=>{r.length=u+v-r.offset,r=r.parent,o(u+v)},onArrayBegin:(u,v)=>{r=l({type:"array",offset:u,length:-1,parent:r,children:[]})},onArrayEnd:(u,v)=>{r.length=u+v-r.offset,r=r.parent,o(u+v)},onLiteralValue:(u,v,R)=>{l({type:g(u),offset:v,length:R,parent:r,value:u}),o(v+R)},onSeparator:(u,v,R)=>{r.type==="property"&&(u===":"?r.colonOffset=v:u===","&&o(v))},onError:(u,v,R)=>{n.push({error:u,offset:v,length:R})}},s);const S=r.children[0];return S&&delete S.parent,S}e.parseTree=f;function a(t,n){if(!!t){let s=t;for(let r of n)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const l of s.children)if(Array.isArray(l.children)&&l.children[0].value===r){s=l.children[1],o=!0;break}if(!o)return}else{const o=r;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}}e.findNodeAtLocation=a;function d(t){if(!t.parent||!t.parent.children)return[];const n=d(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;n.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&n.push(s)}return n}e.getNodePath=d;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":const n=Object.create(null);for(let s of t.children){const r=s.children[1];r&&(n[s.children[0].value]=E(r))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function w(t,n,s=!1){return n>=t.offset&&n<t.offset+t.length||s&&n===t.offset+t.length}e.contains=w;function b(t,n,s=!1){if(w(t,n,s)){const r=t.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const l=b(r[o],n,s);if(l)return l}return t}}e.findNodeAtOffset=b;function p(t,n,s=I.DEFAULT){const r=y(t,!1);function o(he){return he?()=>he(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(he){return he?ve=>he(ve,r.getTokenOffset(),r.getTokenLength()):()=>!0}const h=o(n.onObjectBegin),S=l(n.onObjectProperty),u=o(n.onObjectEnd),v=o(n.onArrayBegin),R=o(n.onArrayEnd),L=l(n.onLiteralValue),H=l(n.onSeparator),ie=o(n.onComment),j=l(n.onError),B=s&&s.disallowComments,$=s&&s.allowTrailingComma;function N(){for(;;){const he=r.scan();switch(r.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:B||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(he){case 12:case 13:B?M(10):ie();break;case 16:M(1);break;case 15:case 14:break;default:return he}}}function M(he,ve=[],Ie=[]){if(j(he),ve.length+Ie.length>0){let ke=r.getToken();for(;ke!==17;){if(ve.indexOf(ke)!==-1){N();break}else if(Ie.indexOf(ke)!==-1)break;ke=N()}}}function F(he){const ve=r.getTokenValue();return he?L(ve):S(ve),N(),!0}function U(){switch(r.getToken()){case 11:let he=0;try{he=JSON.parse(r.getTokenValue()),typeof he!="number"&&(M(2),he=0)}catch(ve){M(2)}L(he);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return N(),!0}function O(){return r.getToken()!==10?(M(3,[],[2,5]),!1):(F(!1),r.getToken()===6?(H(":"),N(),Q()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function W(){h(),N();let he=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(he||M(4,[],[]),H(","),N(),r.getToken()===2&&$)break}else he&&M(6,[],[]);O()||M(4,[],[2,5]),he=!0}return u(),r.getToken()!==2?M(7,[2],[]):N(),!0}function q(){v(),N();let he=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(he||M(4,[],[]),H(","),N(),r.getToken()===4&&$)break}else he&&M(6,[],[]);Q()||M(4,[],[4,5]),he=!0}return R(),r.getToken()!==4?M(8,[4],[]):N(),!0}function Q(){switch(r.getToken()){case 3:return q();case 1:return W();case 10:return F(!0);default:return U()}}return N(),r.getToken()===17?s.allowEmptyContent?!0:(M(4,[],[]),!1):Q()?(r.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=p;function c(t,n){let s=y(t),r=[],o,l=0,h;do switch(h=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:l!==h&&r.push(t.substring(l,h)),n!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,n)),l=s.getPosition();break}while(o!==17);return r.join("")}e.stripComments=c;function g(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(me[132],ge([0,1,55]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(D,i,T){let C,m,f,a,d;if(i){for(a=i.offset,d=a+i.length,f=a;f>0&&!P(D,f-1);)f--;let l=d;for(;l<D.length&&!P(D,l);)l++;m=D.substring(f,l),C=I(m,T)}else m=D,C=0,f=0,a=0,d=D.length;const E=y(T,D);let w=!1,b=0,p;T.insertSpaces?p=A(" ",T.tabSize||4):p="	";const c=(0,_.createScanner)(m,!1);let g=!1;function t(){return E+A(p,C+b)}function n(){let l=c.scan();for(w=!1;l===15||l===14;)w=w||l===14,l=c.scan();return g=l===16||c.getTokenError()!==0,l}const s=[];function r(l,h,S){!g&&h<d&&S>a&&D.substring(h,S)!==l&&s.push({offset:h,length:S-h,content:l})}let o=n();if(o!==17){const l=c.getTokenOffset()+f,h=A(p,C);r(h,f,l)}for(;o!==17;){let l=c.getTokenOffset()+c.getTokenLength()+f,h=n(),S="";for(;!w&&(h===12||h===13);){const v=c.getTokenOffset()+f;r(" ",l,v),l=c.getTokenOffset()+c.getTokenLength()+f,S=h===12?t():"",h=n()}if(h===2)o!==1&&(b--,S=t());else if(h===4)o!==3&&(b--,S=t());else{switch(o){case 3:case 1:b++,S=t();break;case 5:case 12:S=t();break;case 13:w?S=t():S=" ";break;case 6:S=" ";break;case 10:if(h===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?S=" ":h!==5&&h!==17&&(g=!0);break;case 16:g=!0;break}w&&(h===12||h===13)&&(S=t())}const u=c.getTokenOffset()+f;r(S,l,u),o=h}return s}e.format=k;function A(D,i){let T="";for(let C=0;C<i;C++)T+=D;return T}function I(D,i){let T=0,C=0;const m=i.tabSize||4;for(;T<D.length;){const f=D.charAt(T);if(f===" ")C++;else if(f==="	")C+=m;else break;T++}return Math.floor(C/m)}function y(D,i){for(let T=0;T<i.length;T++){const C=i.charAt(T);if(C==="\r")return T+1<i.length&&i.charAt(T+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=y;function P(D,i){return`\r
`.indexOf(D.charAt(i))!==-1}e.isEOL=P}),define(me[133],ge([0,1,55,132]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(i,T,C){return I(i,T,void 0,C)}e.removeProperty=A;function I(i,T,C,m,f){const a=T.slice(),d=[],E=(0,_.parseTree)(i,d);let w,b;for(;a.length>0&&(b=a.pop(),w=(0,_.findNodeAtLocation)(E,a),w===void 0&&C!==void 0);)typeof b=="string"?C={[b]:C}:C=[C];if(w)if(w.type==="object"&&typeof b=="string"&&Array.isArray(w.children)){const p=(0,_.findNodeAtLocation)(w,[b]);if(p!==void 0)if(C===void 0){if(!p.parent)throw new Error("Malformed AST");const c=w.children.indexOf(p.parent);let g,t=p.parent.offset+p.parent.length;if(c>0){const n=w.children[c-1];g=n.offset+n.length}else g=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return y(i,{offset:g,length:t-g,content:""},m)}else return y(i,{offset:p.offset,length:p.length,content:JSON.stringify(C)},m);else{if(C===void 0)return[];const c=`${JSON.stringify(b)}: ${JSON.stringify(C)}`,g=f?f(w.children.map(n=>n.children[0].value)):w.children.length;let t;if(g>0){const n=w.children[g-1];t={offset:n.offset+n.length,length:0,content:","+c}}else w.children.length===0?t={offset:w.offset+1,length:0,content:c}:t={offset:w.offset+1,length:0,content:c+","};return y(i,t,m)}}else if(w.type==="array"&&typeof b=="number"&&Array.isArray(w.children))if(C!==void 0){const p=`${JSON.stringify(C)}`;let c;if(w.children.length===0||b===0)c={offset:w.offset+1,length:0,content:w.children.length===0?p:p+","};else{const g=b===-1||b>w.children.length?w.children.length:b,t=w.children[g-1];c={offset:t.offset+t.length,length:0,content:","+p}}return y(i,c,m)}else{const p=b,c=w.children[p];let g;if(w.children.length===1)g={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===p){const t=w.children[p-1],n=t.offset+t.length,s=w.offset+w.length;g={offset:n,length:s-2-n,content:""}}else g={offset:c.offset,length:w.children[p+1].offset-c.offset,content:""};return y(i,g,m)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${w.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return y(i,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(C)},m)}}e.setProperty=I;function y(i,T,C){let m=P(i,T),f=T.offset,a=T.offset+T.content.length;if(T.length===0||T.content.length===0){for(;f>0&&!(0,k.isEOL)(m,f-1);)f--;for(;a<m.length&&!(0,k.isEOL)(m,a);)a++}const d=(0,k.format)(m,{offset:f,length:a-f},C);for(let w=d.length-1;w>=0;w--){const b=d[w];m=P(m,b),f=Math.min(f,b.offset),a=Math.max(a,b.offset+b.length),a+=b.content.length-b.length}const E=i.length-(m.length-a)-f;return[{offset:f,length:E,content:m.substring(f,a)}]}e.withFormatting=y;function P(i,T){return i.substring(0,T.offset)+T.content+i.substring(T.offset+T.length)}e.applyEdit=P;function D(i,T){let C=T.slice(0).sort((f,a)=>{const d=f.offset-a.offset;return d===0?f.length-a.length:d}),m=i.length;for(let f=C.length-1;f>=0;f--){let a=C[f];if(a.offset+a.length<=m)i=P(i,a);else throw new Error("Overlapping edit");m=a.offset}return i}e.applyEdits=D}),define(me[134],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class _{constructor(A){this.executor=A,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(A){return new _(()=>A(this.getValue()))}}e.Lazy=_}),define(me[6],ge([0,1,71,54]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let I=null;function y(p){I=p}if(e.setDisposableTracker=y,A){const p="__is_disposable_tracked__";I=new class{trackDisposable(c){const g=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[p]||console.log(g)},3e3)}markTracked(c){if(c&&c!==d.None)try{c[p]=!0}catch(g){}}}}function P(p){!I||I.markTracked(p)}function D(p){return I&&I.trackDisposable(p),p}e.trackDisposable=D;class i extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=i;function T(p){return typeof p.dispose=="function"&&p.dispose.length===0}e.isDisposable=T;function C(p){if(k.Iterable.is(p)){let c=[];for(const g of p)if(g){P(g);try{g.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new i(c);return Array.isArray(p)?[]:p}else if(p)return P(p),p.dispose(),p}e.dispose=C;function m(...p){return p.forEach(P),f(()=>C(p))}e.combinedDisposable=m;function f(p){const c=D({dispose:()=>{P(c),p()}});return c}e.toDisposable=f;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return P(c),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this._store=new a,D(this)}dispose(){P(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var g;this._isDisposed||c===this._value||((g=this._value)===null||g===void 0||g.dispose(),c&&P(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,P(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=E;class w{constructor(){this.references=new Map}acquire(c,...g){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...g)},this.references.set(c,t));const{object:n}=t,s=(0,_.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:n,dispose:s}}}e.ReferenceCollection=w;class b{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=b}),define(me[56],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{constructor(I){this.element=I,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class k{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(I){return this._insert(I,!1)}push(I){return this._insert(I,!0)}_insert(I,y){const P=new _(I);if(this._first===_.Undefined)this._first=P,this._last=P;else if(y){const i=this._last;this._last=P,P.prev=i,i.next=P}else{const i=this._first;this._first=P,P.next=i,i.prev=P}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(P))}}shift(){if(this._first!==_.Undefined){const I=this._first.element;return this._remove(this._first),I}}pop(){if(this._last!==_.Undefined){const I=this._last.element;return this._remove(this._last),I}}_remove(I){if(I.prev!==_.Undefined&&I.next!==_.Undefined){const y=I.prev;y.next=I.next,I.next.prev=y}else I.prev===_.Undefined&&I.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):I.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):I.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let I=this._first;for(;I!==_.Undefined;)yield I.element,I=I.next}}e.LinkedList=k}),function(G,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(G=typeof globalThis!="undefined"?globalThis:G||self,G.marked=e())}(this,function(){"use strict";function G(K,oe){for(var fe=0;fe<oe.length;fe++){var Z=oe[fe];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(K,Z.key,Z)}}function e(K,oe,fe){return oe&&G(K.prototype,oe),fe&&G(K,fe),K}function _(K,oe){if(!!K){if(typeof K=="string")return k(K,oe);var fe=Object.prototype.toString.call(K).slice(8,-1);if(fe==="Object"&&K.constructor&&(fe=K.constructor.name),fe==="Map"||fe==="Set")return Array.from(K);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return k(K,oe)}}function k(K,oe){(oe==null||oe>K.length)&&(oe=K.length);for(var fe=0,Z=new Array(oe);fe<oe;fe++)Z[fe]=K[fe];return Z}function A(K,oe){var fe;if(typeof Symbol=="undefined"||K[Symbol.iterator]==null){if(Array.isArray(K)||(fe=_(K))||oe&&K&&typeof K.length=="number"){fe&&(K=fe);var Z=0;return function(){return Z>=K.length?{done:!0}:{done:!1,value:K[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return fe=K[Symbol.iterator](),fe.next.bind(fe)}function I(K){var oe={exports:{}};return K(oe,oe.exports),oe.exports}var y=I(function(K){function oe(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function fe(Z){K.exports.defaults=Z}K.exports={defaults:oe(),getDefaults:oe,changeDefaults:fe}}),P=/[&<>"']/,D=/[&<>"']/g,i=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(oe){return C[oe]};function f(K,oe){if(oe){if(P.test(K))return K.replace(D,m)}else if(i.test(K))return K.replace(T,m);return K}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(K){return K.replace(a,function(oe,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var E=/(^|[^\[])\^/g;function w(K,oe){K=K.source||K,oe=oe||"";var fe={replace:function(ne,ce){return ce=ce.source||ce,ce=ce.replace(E,"$1"),K=K.replace(ne,ce),fe},getRegex:function(){return new RegExp(K,oe)}};return fe}var b=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(K,oe,fe){if(K){var Z;try{Z=decodeURIComponent(d(fe)).replace(b,"").toLowerCase()}catch(ne){return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}oe&&!p.test(fe)&&(fe=r(oe,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch(ne){return null}return fe}var g={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(K,oe){g[" "+K]||(t.test(K)?g[" "+K]=K+"/":g[" "+K]=S(K,"/",!0)),K=g[" "+K];var fe=K.indexOf(":")===-1;return oe.substring(0,2)==="//"?fe?oe:K.replace(n,"$1")+oe:oe.charAt(0)==="/"?fe?oe:K.replace(s,"$1")+oe:K+oe}var o={exec:function(){}};function l(K){for(var oe=1,fe,Z;oe<arguments.length;oe++){fe=arguments[oe];for(Z in fe)Object.prototype.hasOwnProperty.call(fe,Z)&&(K[Z]=fe[Z])}return K}function h(K,oe){var fe=K.replace(/\|/g,function(ce,pe,Se){for(var qe=!1,Me=pe;--Me>=0&&Se[Me]==="\\";)qe=!qe;return qe?"|":" |"}),Z=fe.split(/ \|/),ne=0;if(Z.length>oe)Z.splice(oe);else for(;Z.length<oe;)Z.push("");for(;ne<Z.length;ne++)Z[ne]=Z[ne].trim().replace(/\\\|/g,"|");return Z}function S(K,oe,fe){var Z=K.length;if(Z===0)return"";for(var ne=0;ne<Z;){var ce=K.charAt(Z-ne-1);if(ce===oe&&!fe)ne++;else if(ce!==oe&&fe)ne++;else break}return K.substr(0,Z-ne)}function u(K,oe){if(K.indexOf(oe[1])===-1)return-1;for(var fe=K.length,Z=0,ne=0;ne<fe;ne++)if(K[ne]==="\\")ne++;else if(K[ne]===oe[0])Z++;else if(K[ne]===oe[1]&&(Z--,Z<0))return ne;return-1}function v(K){K&&K.sanitize&&!K.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(K,oe){if(oe<1)return"";for(var fe="";oe>1;)oe&1&&(fe+=K),oe>>=1,K+=K;return fe+K}var L={escape:f,unescape:d,edit:w,cleanUrl:c,resolveUrl:r,noopTest:o,merge:l,splitCells:h,rtrim:S,findClosingBracket:u,checkSanitizeDeprecation:v,repeatString:R},H=y.defaults,ie=L.rtrim,j=L.splitCells,B=L.escape,$=L.findClosingBracket;function N(K,oe,fe){var Z=oe.href,ne=oe.title?B(oe.title):null,ce=K[1].replace(/\\([\[\]])/g,"$1");return K[0].charAt(0)!=="!"?{type:"link",raw:fe,href:Z,title:ne,text:ce}:{type:"image",raw:fe,href:Z,title:ne,text:B(ce)}}function M(K,oe){var fe=K.match(/^(\s+)(?:```)/);if(fe===null)return oe;var Z=fe[1];return oe.split(`
`).map(function(ne){var ce=ne.match(/^\s+/);if(ce===null)return ne;var pe=ce[0];return pe.length>=Z.length?ne.slice(Z.length):ne}).join(`
`)}var F=function(){function K(fe){this.options=fe||H}var oe=K.prototype;return oe.space=function(Z){var ne=this.rules.block.newline.exec(Z);if(ne)return ne[0].length>1?{type:"space",raw:ne[0]}:{raw:`
`}},oe.code=function(Z){var ne=this.rules.block.code.exec(Z);if(ne){var ce=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?ce:ie(ce,`
`)}}},oe.fences=function(Z){var ne=this.rules.block.fences.exec(Z);if(ne){var ce=ne[0],pe=M(ce,ne[3]||"");return{type:"code",raw:ce,lang:ne[2]?ne[2].trim():ne[2],text:pe}}},oe.heading=function(Z){var ne=this.rules.block.heading.exec(Z);if(ne){var ce=ne[2].trim();if(/#$/.test(ce)){var pe=ie(ce,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(ce=pe.trim())}return{type:"heading",raw:ne[0],depth:ne[1].length,text:ce}}},oe.nptable=function(Z){var ne=this.rules.block.nptable.exec(Z);if(ne){var ce={type:"table",header:j(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[],raw:ne[0]};if(ce.header.length===ce.align.length){var pe=ce.align.length,Se;for(Se=0;Se<pe;Se++)/^ *-+: *$/.test(ce.align[Se])?ce.align[Se]="right":/^ *:-+: *$/.test(ce.align[Se])?ce.align[Se]="center":/^ *:-+ *$/.test(ce.align[Se])?ce.align[Se]="left":ce.align[Se]=null;for(pe=ce.cells.length,Se=0;Se<pe;Se++)ce.cells[Se]=j(ce.cells[Se],ce.header.length);return ce}}},oe.hr=function(Z){var ne=this.rules.block.hr.exec(Z);if(ne)return{type:"hr",raw:ne[0]}},oe.blockquote=function(Z){var ne=this.rules.block.blockquote.exec(Z);if(ne){var ce=ne[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ne[0],text:ce}}},oe.list=function(Z){var ne=this.rules.block.list.exec(Z);if(ne){var ce=ne[0],pe=ne[2],Se=pe.length>1,qe={type:"list",raw:ce,ordered:Se,start:Se?+pe.slice(0,-1):"",loose:!1,items:[]},Me=ne[0].match(this.rules.block.item),He=!1,Qe,it,at,Ze,nt,dt,_t,ue,De=Me.length;at=this.rules.block.listItemStart.exec(Me[0]);for(var le=0;le<De;le++){if(Qe=Me[le],ce=Qe,le!==De-1){if(Ze=this.rules.block.listItemStart.exec(Me[le+1]),this.options.pedantic?Ze[1].length>at[1].length:Ze[1].length>at[0].length||Ze[1].length>3){Me.splice(le,2,Me[le]+`
`+Me[le+1]),le--,De--;continue}else(!this.options.pedantic||this.options.smartLists?Ze[2][Ze[2].length-1]!==pe[pe.length-1]:Se===(Ze[2].length===1))&&(nt=Me.slice(le+1).join(`
`),qe.raw=qe.raw.substring(0,qe.raw.length-nt.length),le=De-1);at=Ze}it=Qe.length,Qe=Qe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Qe.indexOf(`
 `)&&(it-=Qe.length,Qe=this.options.pedantic?Qe.replace(/^ {1,4}/gm,""):Qe.replace(new RegExp("^ {1,"+it+"}","gm"),"")),dt=He||/\n\n(?!\s*$)/.test(Qe),le!==De-1&&(He=Qe.charAt(Qe.length-1)===`
`,dt||(dt=He)),dt&&(qe.loose=!0),this.options.gfm&&(_t=/^\[[ xX]\] /.test(Qe),ue=void 0,_t&&(ue=Qe[1]!==" ",Qe=Qe.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:ce,task:_t,checked:ue,loose:dt,text:Qe})}return qe}},oe.html=function(Z){var ne=this.rules.block.html.exec(Z);if(ne)return{type:this.options.sanitize?"paragraph":"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):B(ne[0]):ne[0]}},oe.def=function(Z){var ne=this.rules.block.def.exec(Z);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var ce=ne[1].toLowerCase().replace(/\s+/g," ");return{tag:ce,raw:ne[0],href:ne[2],title:ne[3]}}},oe.table=function(Z){var ne=this.rules.block.table.exec(Z);if(ne){var ce={type:"table",header:j(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[]};if(ce.header.length===ce.align.length){ce.raw=ne[0];var pe=ce.align.length,Se;for(Se=0;Se<pe;Se++)/^ *-+: *$/.test(ce.align[Se])?ce.align[Se]="right":/^ *:-+: *$/.test(ce.align[Se])?ce.align[Se]="center":/^ *:-+ *$/.test(ce.align[Se])?ce.align[Se]="left":ce.align[Se]=null;for(pe=ce.cells.length,Se=0;Se<pe;Se++)ce.cells[Se]=j(ce.cells[Se].replace(/^ *\| *| *\| *$/g,""),ce.header.length);return ce}}},oe.lheading=function(Z){var ne=this.rules.block.lheading.exec(Z);if(ne)return{type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1]}},oe.paragraph=function(Z){var ne=this.rules.block.paragraph.exec(Z);if(ne)return{type:"paragraph",raw:ne[0],text:ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1]}},oe.text=function(Z){var ne=this.rules.block.text.exec(Z);if(ne)return{type:"text",raw:ne[0],text:ne[0]}},oe.escape=function(Z){var ne=this.rules.inline.escape.exec(Z);if(ne)return{type:"escape",raw:ne[0],text:B(ne[1])}},oe.tag=function(Z,ne,ce){var pe=this.rules.inline.tag.exec(Z);if(pe)return!ne&&/^<a /i.test(pe[0])?ne=!0:ne&&/^<\/a>/i.test(pe[0])&&(ne=!1),!ce&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?ce=!0:ce&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(ce=!1),{type:this.options.sanitize?"text":"html",raw:pe[0],inLink:ne,inRawBlock:ce,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):B(pe[0]):pe[0]}},oe.link=function(Z){var ne=this.rules.inline.link.exec(Z);if(ne){var ce=ne[2].trim();if(!this.options.pedantic&&/^</.test(ce)){if(!/>$/.test(ce))return;var pe=ie(ce.slice(0,-1),"\\");if((ce.length-pe.length)%2==0)return}else{var Se=$(ne[2],"()");if(Se>-1){var qe=ne[0].indexOf("!")===0?5:4,Me=qe+ne[1].length+Se;ne[2]=ne[2].substring(0,Se),ne[0]=ne[0].substring(0,Me).trim(),ne[3]=""}}var He=ne[2],Qe="";if(this.options.pedantic){var it=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(He);it&&(He=it[1],Qe=it[3])}else Qe=ne[3]?ne[3].slice(1,-1):"";return He=He.trim(),/^</.test(He)&&(this.options.pedantic&&!/>$/.test(ce)?He=He.slice(1):He=He.slice(1,-1)),N(ne,{href:He&&He.replace(this.rules.inline._escapes,"$1"),title:Qe&&Qe.replace(this.rules.inline._escapes,"$1")},ne[0])}},oe.reflink=function(Z,ne){var ce;if((ce=this.rules.inline.reflink.exec(Z))||(ce=this.rules.inline.nolink.exec(Z))){var pe=(ce[2]||ce[1]).replace(/\s+/g," ");if(pe=ne[pe.toLowerCase()],!pe||!pe.href){var Se=ce[0].charAt(0);return{type:"text",raw:Se,text:Se}}return N(ce,pe,ce[0])}},oe.emStrong=function(Z,ne,ce){ce===void 0&&(ce="");var pe=this.rules.inline.emStrong.lDelim.exec(Z);if(!!pe&&!(pe[3]&&ce.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Se=pe[1]||pe[2]||"";if(!Se||Se&&(ce===""||this.rules.inline.punctuation.exec(ce))){var qe=pe[0].length-1,Me,He,Qe=qe,it=0,at=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(at.lastIndex=0,ne=ne.slice(-1*Z.length+qe);(pe=at.exec(ne))!=null;)if(Me=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!Me){if(He=Me.length,pe[3]||pe[4]){Qe+=He;continue}else if((pe[5]||pe[6])&&qe%3&&!((qe+He)%3)){it+=He;continue}if(Qe-=He,!(Qe>0)){if(Qe+it-He<=0&&!ne.slice(at.lastIndex).match(at)&&(He=Math.min(He,He+Qe+it)),Math.min(qe,He)%2)return{type:"em",raw:Z.slice(0,qe+pe.index+He+1),text:Z.slice(1,qe+pe.index+He)};if(Math.min(qe,He)%2==0)return{type:"strong",raw:Z.slice(0,qe+pe.index+He+1),text:Z.slice(2,qe+pe.index+He-1)}}}}}},oe.codespan=function(Z){var ne=this.rules.inline.code.exec(Z);if(ne){var ce=ne[2].replace(/\n/g," "),pe=/[^ ]/.test(ce),Se=/^ /.test(ce)&&/ $/.test(ce);return pe&&Se&&(ce=ce.substring(1,ce.length-1)),ce=B(ce,!0),{type:"codespan",raw:ne[0],text:ce}}},oe.br=function(Z){var ne=this.rules.inline.br.exec(Z);if(ne)return{type:"br",raw:ne[0]}},oe.del=function(Z){var ne=this.rules.inline.del.exec(Z);if(ne)return{type:"del",raw:ne[0],text:ne[2]}},oe.autolink=function(Z,ne){var ce=this.rules.inline.autolink.exec(Z);if(ce){var pe,Se;return ce[2]==="@"?(pe=B(this.options.mangle?ne(ce[1]):ce[1]),Se="mailto:"+pe):(pe=B(ce[1]),Se=pe),{type:"link",raw:ce[0],text:pe,href:Se,tokens:[{type:"text",raw:pe,text:pe}]}}},oe.url=function(Z,ne){var ce;if(ce=this.rules.inline.url.exec(Z)){var pe,Se;if(ce[2]==="@")pe=B(this.options.mangle?ne(ce[0]):ce[0]),Se="mailto:"+pe;else{var qe;do qe=ce[0],ce[0]=this.rules.inline._backpedal.exec(ce[0])[0];while(qe!==ce[0]);pe=B(ce[0]),ce[1]==="www."?Se="http://"+pe:Se=pe}return{type:"link",raw:ce[0],text:pe,href:Se,tokens:[{type:"text",raw:pe,text:pe}]}}},oe.inlineText=function(Z,ne,ce){var pe=this.rules.inline.text.exec(Z);if(pe){var Se;return ne?Se=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):B(pe[0]):pe[0]:Se=B(this.options.smartypants?ce(pe[0]):pe[0]),{type:"text",raw:pe[0],text:Se}}},K}(),U=L.noopTest,O=L.edit,W=L.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:U,table:U,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=O(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=O(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=O(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=O(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=O(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=O(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=O(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=W({},q),q.gfm=W({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=O(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=O(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=W({},q.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:U,paragraph:O(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:U,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:U,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=O(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=O(q._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=O(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=O(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=O(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=O(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=O(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=O(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=O(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=O(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=W({},Q),Q.pedantic=W({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=W({},Q.normal,{escape:O(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Q.gfm.url=O(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=W({},Q.gfm,{br:O(Q.br).replace("{2,}","*").getRegex(),text:O(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var he={block:q,inline:Q},ve=y.defaults,Ie=he.block,ke=he.inline,Le=L.repeatString;function V(K){return K.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function J(K){var oe="",fe,Z,ne=K.length;for(fe=0;fe<ne;fe++)Z=K.charCodeAt(fe),Math.random()>.5&&(Z="x"+Z.toString(16)),oe+="&#"+Z+";";return oe}var ee=function(){function K(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||ve,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var Z={block:Ie.normal,inline:ke.normal};this.options.pedantic?(Z.block=Ie.pedantic,Z.inline=ke.pedantic):this.options.gfm&&(Z.block=Ie.gfm,this.options.breaks?Z.inline=ke.breaks:Z.inline=ke.gfm),this.tokenizer.rules=Z}K.lex=function(Z,ne){var ce=new K(ne);return ce.lex(Z)},K.lexInline=function(Z,ne){var ce=new K(ne);return ce.inlineTokens(Z)};var oe=K.prototype;return oe.lex=function(Z){return Z=Z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Z,this.tokens,!0),this.inline(this.tokens),this.tokens},oe.blockTokens=function(Z,ne,ce){ne===void 0&&(ne=[]),ce===void 0&&(ce=!0),this.options.pedantic&&(Z=Z.replace(/^ +$/gm,""));for(var pe,Se,qe,Me;Z;){if(pe=this.tokenizer.space(Z)){Z=Z.substring(pe.raw.length),pe.type&&ne.push(pe);continue}if(pe=this.tokenizer.code(Z)){Z=Z.substring(pe.raw.length),Me=ne[ne.length-1],Me&&Me.type==="paragraph"?(Me.raw+=`
`+pe.raw,Me.text+=`
`+pe.text):ne.push(pe);continue}if(pe=this.tokenizer.fences(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.heading(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.nptable(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.hr(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.blockquote(Z)){Z=Z.substring(pe.raw.length),pe.tokens=this.blockTokens(pe.text,[],ce),ne.push(pe);continue}if(pe=this.tokenizer.list(Z)){for(Z=Z.substring(pe.raw.length),qe=pe.items.length,Se=0;Se<qe;Se++)pe.items[Se].tokens=this.blockTokens(pe.items[Se].text,[],!1);ne.push(pe);continue}if(pe=this.tokenizer.html(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(ce&&(pe=this.tokenizer.def(Z))){Z=Z.substring(pe.raw.length),this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.lheading(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(ce&&(pe=this.tokenizer.paragraph(Z))){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.text(Z)){Z=Z.substring(pe.raw.length),Me=ne[ne.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+pe.raw,Me.text+=`
`+pe.text):ne.push(pe);continue}if(Z){var He="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(He);break}else throw new Error(He)}}return ne},oe.inline=function(Z){var ne,ce,pe,Se,qe,Me,He=Z.length;for(ne=0;ne<He;ne++)switch(Me=Z[ne],Me.type){case"paragraph":case"text":case"heading":{Me.tokens=[],this.inlineTokens(Me.text,Me.tokens);break}case"table":{for(Me.tokens={header:[],cells:[]},Se=Me.header.length,ce=0;ce<Se;ce++)Me.tokens.header[ce]=[],this.inlineTokens(Me.header[ce],Me.tokens.header[ce]);for(Se=Me.cells.length,ce=0;ce<Se;ce++)for(qe=Me.cells[ce],Me.tokens.cells[ce]=[],pe=0;pe<qe.length;pe++)Me.tokens.cells[ce][pe]=[],this.inlineTokens(qe[pe],Me.tokens.cells[ce][pe]);break}case"blockquote":{this.inline(Me.tokens);break}case"list":{for(Se=Me.items.length,ce=0;ce<Se;ce++)this.inline(Me.items[ce].tokens);break}}return Z},oe.inlineTokens=function(Z,ne,ce,pe){ne===void 0&&(ne=[]),ce===void 0&&(ce=!1),pe===void 0&&(pe=!1);var Se,qe,Me=Z,He,Qe,it;if(this.tokens.links){var at=Object.keys(this.tokens.links);if(at.length>0)for(;(He=this.tokenizer.rules.inline.reflinkSearch.exec(Me))!=null;)at.includes(He[0].slice(He[0].lastIndexOf("[")+1,-1))&&(Me=Me.slice(0,He.index)+"["+Le("a",He[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(He=this.tokenizer.rules.inline.blockSkip.exec(Me))!=null;)Me=Me.slice(0,He.index)+"["+Le("a",He[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(He=this.tokenizer.rules.inline.escapedEmSt.exec(Me))!=null;)Me=Me.slice(0,He.index)+"++"+Me.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;){if(Qe||(it=""),Qe=!1,Se=this.tokenizer.escape(Z)){Z=Z.substring(Se.raw.length),ne.push(Se);continue}if(Se=this.tokenizer.tag(Z,ce,pe)){Z=Z.substring(Se.raw.length),ce=Se.inLink,pe=Se.inRawBlock;var Ze=ne[ne.length-1];Ze&&Se.type==="text"&&Ze.type==="text"?(Ze.raw+=Se.raw,Ze.text+=Se.text):ne.push(Se);continue}if(Se=this.tokenizer.link(Z)){Z=Z.substring(Se.raw.length),Se.type==="link"&&(Se.tokens=this.inlineTokens(Se.text,[],!0,pe)),ne.push(Se);continue}if(Se=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(Se.raw.length);var nt=ne[ne.length-1];Se.type==="link"?(Se.tokens=this.inlineTokens(Se.text,[],!0,pe),ne.push(Se)):nt&&Se.type==="text"&&nt.type==="text"?(nt.raw+=Se.raw,nt.text+=Se.text):ne.push(Se);continue}if(Se=this.tokenizer.emStrong(Z,Me,it)){Z=Z.substring(Se.raw.length),Se.tokens=this.inlineTokens(Se.text,[],ce,pe),ne.push(Se);continue}if(Se=this.tokenizer.codespan(Z)){Z=Z.substring(Se.raw.length),ne.push(Se);continue}if(Se=this.tokenizer.br(Z)){Z=Z.substring(Se.raw.length),ne.push(Se);continue}if(Se=this.tokenizer.del(Z)){Z=Z.substring(Se.raw.length),Se.tokens=this.inlineTokens(Se.text,[],ce,pe),ne.push(Se);continue}if(Se=this.tokenizer.autolink(Z,J)){Z=Z.substring(Se.raw.length),ne.push(Se);continue}if(!ce&&(Se=this.tokenizer.url(Z,J))){Z=Z.substring(Se.raw.length),ne.push(Se);continue}if(Se=this.tokenizer.inlineText(Z,pe,V)){Z=Z.substring(Se.raw.length),Se.raw.slice(-1)!=="_"&&(it=Se.raw.slice(-1)),Qe=!0,qe=ne[ne.length-1],qe&&qe.type==="text"?(qe.raw+=Se.raw,qe.text+=Se.text):ne.push(Se);continue}if(Z){var dt="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(dt);break}else throw new Error(dt)}}return ne},e(K,null,[{key:"rules",get:function(){return{block:Ie,inline:ke}}}]),K}(),ae=y.defaults,we=L.cleanUrl,Ce=L.escape,Oe=function(){function K(fe){this.options=fe||ae}var oe=K.prototype;return oe.code=function(Z,ne,ce){var pe=(ne||"").match(/\S*/)[0];if(this.options.highlight){var Se=this.options.highlight(Z,pe);Se!=null&&Se!==Z&&(ce=!0,Z=Se)}return Z=Z.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+Ce(pe,!0)+'">'+(ce?Z:Ce(Z,!0))+`</code></pre>
`:"<pre><code>"+(ce?Z:Ce(Z,!0))+`</code></pre>
`},oe.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},oe.html=function(Z){return Z},oe.heading=function(Z,ne,ce,pe){return this.options.headerIds?"<h"+ne+' id="'+this.options.headerPrefix+pe.slug(ce)+'">'+Z+"</h"+ne+`>
`:"<h"+ne+">"+Z+"</h"+ne+`>
`},oe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},oe.list=function(Z,ne,ce){var pe=ne?"ol":"ul",Se=ne&&ce!==1?' start="'+ce+'"':"";return"<"+pe+Se+`>
`+Z+"</"+pe+`>
`},oe.listitem=function(Z){return"<li>"+Z+`</li>
`},oe.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},oe.paragraph=function(Z){return"<p>"+Z+`</p>
`},oe.table=function(Z,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ne+`</table>
`},oe.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},oe.tablecell=function(Z,ne){var ce=ne.header?"th":"td",pe=ne.align?"<"+ce+' align="'+ne.align+'">':"<"+ce+">";return pe+Z+"</"+ce+`>
`},oe.strong=function(Z){return"<strong>"+Z+"</strong>"},oe.em=function(Z){return"<em>"+Z+"</em>"},oe.codespan=function(Z){return"<code>"+Z+"</code>"},oe.br=function(){return this.options.xhtml?"<br/>":"<br>"},oe.del=function(Z){return"<del>"+Z+"</del>"},oe.link=function(Z,ne,ce){if(Z=we(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ce;var pe='<a href="'+Ce(Z)+'"';return ne&&(pe+=' title="'+ne+'"'),pe+=">"+ce+"</a>",pe},oe.image=function(Z,ne,ce){if(Z=we(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ce;var pe='<img src="'+Z+'" alt="'+ce+'"';return ne&&(pe+=' title="'+ne+'"'),pe+=this.options.xhtml?"/>":">",pe},oe.text=function(Z){return Z},K}(),be=function(){function K(){}var oe=K.prototype;return oe.strong=function(Z){return Z},oe.em=function(Z){return Z},oe.codespan=function(Z){return Z},oe.del=function(Z){return Z},oe.html=function(Z){return Z},oe.text=function(Z){return Z},oe.link=function(Z,ne,ce){return""+ce},oe.image=function(Z,ne,ce){return""+ce},oe.br=function(){return""},K}(),Pe=function(){function K(){this.seen={}}var oe=K.prototype;return oe.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},oe.getNextSafeSlug=function(Z,ne){var ce=Z,pe=0;if(this.seen.hasOwnProperty(ce)){pe=this.seen[Z];do pe++,ce=Z+"-"+pe;while(this.seen.hasOwnProperty(ce))}return ne||(this.seen[Z]=pe,this.seen[ce]=0),ce},oe.slug=function(Z,ne){ne===void 0&&(ne={});var ce=this.serialize(Z);return this.getNextSafeSlug(ce,ne.dryrun)},K}(),Re=y.defaults,We=L.unescape,Ee=function(){function K(fe){this.options=fe||Re,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new be,this.slugger=new Pe}K.parse=function(Z,ne){var ce=new K(ne);return ce.parse(Z)},K.parseInline=function(Z,ne){var ce=new K(ne);return ce.parseInline(Z)};var oe=K.prototype;return oe.parse=function(Z,ne){ne===void 0&&(ne=!0);var ce="",pe,Se,qe,Me,He,Qe,it,at,Ze,nt,dt,_t,ue,De,le,Y,Ne,Te,Je=Z.length;for(pe=0;pe<Je;pe++)switch(nt=Z[pe],nt.type){case"space":continue;case"hr":{ce+=this.renderer.hr();continue}case"heading":{ce+=this.renderer.heading(this.parseInline(nt.tokens),nt.depth,We(this.parseInline(nt.tokens,this.textRenderer)),this.slugger);continue}case"code":{ce+=this.renderer.code(nt.text,nt.lang,nt.escaped);continue}case"table":{for(at="",it="",Me=nt.header.length,Se=0;Se<Me;Se++)it+=this.renderer.tablecell(this.parseInline(nt.tokens.header[Se]),{header:!0,align:nt.align[Se]});for(at+=this.renderer.tablerow(it),Ze="",Me=nt.cells.length,Se=0;Se<Me;Se++){for(Qe=nt.tokens.cells[Se],it="",He=Qe.length,qe=0;qe<He;qe++)it+=this.renderer.tablecell(this.parseInline(Qe[qe]),{header:!1,align:nt.align[qe]});Ze+=this.renderer.tablerow(it)}ce+=this.renderer.table(at,Ze);continue}case"blockquote":{Ze=this.parse(nt.tokens),ce+=this.renderer.blockquote(Ze);continue}case"list":{for(dt=nt.ordered,_t=nt.start,ue=nt.loose,Me=nt.items.length,Ze="",Se=0;Se<Me;Se++)le=nt.items[Se],Y=le.checked,Ne=le.task,De="",le.task&&(Te=this.renderer.checkbox(Y),ue?le.tokens.length>0&&le.tokens[0].type==="text"?(le.tokens[0].text=Te+" "+le.tokens[0].text,le.tokens[0].tokens&&le.tokens[0].tokens.length>0&&le.tokens[0].tokens[0].type==="text"&&(le.tokens[0].tokens[0].text=Te+" "+le.tokens[0].tokens[0].text)):le.tokens.unshift({type:"text",text:Te}):De+=Te),De+=this.parse(le.tokens,ue),Ze+=this.renderer.listitem(De,Ne,Y);ce+=this.renderer.list(Ze,dt,_t);continue}case"html":{ce+=this.renderer.html(nt.text);continue}case"paragraph":{ce+=this.renderer.paragraph(this.parseInline(nt.tokens));continue}case"text":{for(Ze=nt.tokens?this.parseInline(nt.tokens):nt.text;pe+1<Je&&Z[pe+1].type==="text";)nt=Z[++pe],Ze+=`
`+(nt.tokens?this.parseInline(nt.tokens):nt.text);ce+=ne?this.renderer.paragraph(Ze):Ze;continue}default:{var et='Token with "'+nt.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}return ce},oe.parseInline=function(Z,ne){ne=ne||this.renderer;var ce="",pe,Se,qe=Z.length;for(pe=0;pe<qe;pe++)switch(Se=Z[pe],Se.type){case"escape":{ce+=ne.text(Se.text);break}case"html":{ce+=ne.html(Se.text);break}case"link":{ce+=ne.link(Se.href,Se.title,this.parseInline(Se.tokens,ne));break}case"image":{ce+=ne.image(Se.href,Se.title,Se.text);break}case"strong":{ce+=ne.strong(this.parseInline(Se.tokens,ne));break}case"em":{ce+=ne.em(this.parseInline(Se.tokens,ne));break}case"codespan":{ce+=ne.codespan(Se.text);break}case"br":{ce+=ne.br();break}case"del":{ce+=ne.del(this.parseInline(Se.tokens,ne));break}case"text":{ce+=ne.text(Se.text);break}default:{var Me='Token with "'+Se.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}return ce},K}(),Ke=L.merge,X=L.checkSanitizeDeprecation,re=L.escape,_e=y.getDefaults,xe=y.changeDefaults,ze=y.defaults;function $e(K,oe,fe){if(typeof K=="undefined"||K===null)throw new Error("marked(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");if(typeof oe=="function"&&(fe=oe,oe=null),oe=Ke({},$e.defaults,oe||{}),X(oe),fe){var Z=oe.highlight,ne;try{ne=ee.lex(K,oe)}catch(qe){return fe(qe)}var ce=function(Me){var He;if(!Me)try{He=Ee.parse(ne,oe)}catch(Qe){Me=Qe}return oe.highlight=Z,Me?fe(Me):fe(null,He)};if(!Z||Z.length<3||(delete oe.highlight,!ne.length))return ce();var pe=0;$e.walkTokens(ne,function(qe){qe.type==="code"&&(pe++,setTimeout(function(){Z(qe.text,qe.lang,function(Me,He){if(Me)return ce(Me);He!=null&&He!==qe.text&&(qe.text=He,qe.escaped=!0),pe--,pe===0&&ce()})},0))}),pe===0&&ce();return}try{var Se=ee.lex(K,oe);return oe.walkTokens&&$e.walkTokens(Se,oe.walkTokens),Ee.parse(Se,oe)}catch(qe){if(qe.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+re(qe.message+"",!0)+"</pre>";throw qe}}$e.options=$e.setOptions=function(K){return Ke($e.defaults,K),xe($e.defaults),$e},$e.getDefaults=_e,$e.defaults=ze,$e.use=function(K){var oe=Ke({},K);if(K.renderer&&function(){var Z=$e.defaults.renderer||new Oe,ne=function(Se){var qe=Z[Se];Z[Se]=function(){for(var Me=arguments.length,He=new Array(Me),Qe=0;Qe<Me;Qe++)He[Qe]=arguments[Qe];var it=K.renderer[Se].apply(Z,He);return it===!1&&(it=qe.apply(Z,He)),it}};for(var ce in K.renderer)ne(ce);oe.renderer=Z}(),K.tokenizer&&function(){var Z=$e.defaults.tokenizer||new F,ne=function(Se){var qe=Z[Se];Z[Se]=function(){for(var Me=arguments.length,He=new Array(Me),Qe=0;Qe<Me;Qe++)He[Qe]=arguments[Qe];var it=K.tokenizer[Se].apply(Z,He);return it===!1&&(it=qe.apply(Z,He)),it}};for(var ce in K.tokenizer)ne(ce);oe.tokenizer=Z}(),K.walkTokens){var fe=$e.defaults.walkTokens;oe.walkTokens=function(Z){K.walkTokens(Z),fe&&fe(Z)}}$e.setOptions(oe)},$e.walkTokens=function(K,oe){for(var fe=A(K),Z;!(Z=fe()).done;){var ne=Z.value;switch(oe(ne),ne.type){case"table":{for(var ce=A(ne.tokens.header),pe;!(pe=ce()).done;){var Se=pe.value;$e.walkTokens(Se,oe)}for(var qe=A(ne.tokens.cells),Me;!(Me=qe()).done;)for(var He=Me.value,Qe=A(He),it;!(it=Qe()).done;){var at=it.value;$e.walkTokens(at,oe)}break}case"list":{$e.walkTokens(ne.items,oe);break}default:ne.tokens&&$e.walkTokens(ne.tokens,oe)}}},$e.parseInline=function(K,oe){if(typeof K=="undefined"||K===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");oe=Ke({},$e.defaults,oe||{}),X(oe);try{var fe=ee.lexInline(K,oe);return oe.walkTokens&&$e.walkTokens(fe,oe.walkTokens),Ee.parseInline(fe,oe)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+re(Z.message+"",!0)+"</pre>";throw Z}},$e.Parser=Ee,$e.parser=Ee.parse,$e.Renderer=Oe,$e.TextRenderer=be,$e.Lexer=ee,$e.lexer=ee.lex,$e.Tokenizer=F,$e.Slugger=Pe,$e.parse=$e;var Ye=$e;return Ye}),define(me[73],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function _(y,P,D){return Math.min(Math.max(y,P),D)}e.clamp=_;function k(y,P){return(P+y%P)%P}e.rot=k;class A{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=A;class I{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=I});"use strict";(function(){function G(A){const I=[];typeof A=="number"&&I.push("code/timeOrigin",A);function y(D){I.push(D,Date.now())}function P(){const D=[];for(let i=0;i<I.length;i+=2)D.push({name:I[i],startTime:I[i+1]});return D}return{mark:y,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const y of performance.getEntriesByType("mark"))I.push({name:y.name,startTime:Math.round(A+y.startTime)});return I}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function _(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return _(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=_(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=_(k))})(),define(me[9],ge([0,1]),function(G,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const k="en";let A=!1,I=!1,y=!1,P=!1,D=!1,i=!1,T=!1,C,m=k,f,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const E=typeof((_=d==null?void 0:d.versions)===null||_===void 0?void 0:_.electron)=="string"&&d.type==="renderer";if(e.isElectronSandboxed=E&&(d==null?void 0:d.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=d==null?void 0:d.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!E)a=navigator.userAgent,A=a.indexOf("Windows")>=0,I=a.indexOf("Macintosh")>=0,T=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=a.indexOf("Linux")>=0,i=!0,C=navigator.language,m=C;else if(typeof d=="object"){A=d.platform==="win32",I=d.platform==="darwin",y=d.platform==="linux",P=y&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,C=k,m=k;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const o=JSON.parse(r),l=o.availableLanguages["*"];C=o.locale,m=l||k,f=o._translationsConfigFile}catch(o){}D=!0}else console.error("Unable to resolve platform.");var w;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function b(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let p=0;I?p=1:A?p=3:y&&(p=2),e.isWindows=A,e.isMacintosh=I,e.isLinux=y,e.isLinuxSnap=P,e.isNative=D,e.isWeb=i,e.isIOS=T,e.platform=p,e.userAgent=a,e.language=m;var c;(function(r){function o(){return e.language}r.value=o;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=l;function h(){return e.language==="en"}r.isDefault=h})(c=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let u=0,v=l.length;u<v;u++){const R=l[u];if(R.id===S.data.vscodeSetImmediateId){l.splice(u,1),R.callback();return}}});let h=0;return S=>{const u=++h;l.push({id:u,callback:S}),e.globals.postMessage({vscodeSetImmediateId:u},"*")}}if(typeof(d==null?void 0:d.nextTick)=="function")return d.nextTick.bind(d);const o=Promise.resolve();return l=>o.then(l)}();var g;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(g=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||T?2:A?1:3;let t=!0,n=!1;function s(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(me[36],ge([0,1,9]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let k;if(typeof _.globals.vscode!="undefined"){const A=_.globals.vscode.process;k={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(I){return(0,_.setImmediate)(I)}}}else typeof process!="undefined"?k={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:k={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},nextTick(A){return(0,_.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick}),define(me[8],ge([0,1,36]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,A=97,I=90,y=122,P=46,D=47,i=92,T=58,C=63;class m extends Error{constructor(c,g,t){let n;typeof g=="string"&&g.indexOf("not ")===0?(n="must not be",g=g.replace(/^not /,"")):n="must be";const s=c.indexOf(".")!==-1?"property":"argument";let r=`The "${c}" ${s} ${n} of type ${g}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function f(p,c){if(typeof p!="string")throw new m(c,"string",p)}function a(p){return p===D||p===i}function d(p){return p===D}function E(p){return p>=k&&p<=I||p>=A&&p<=y}function w(p,c,g,t){let n="",s=0,r=-1,o=0,l=0;for(let h=0;h<=p.length;++h){if(h<p.length)l=p.charCodeAt(h);else{if(t(l))break;l=D}if(t(l)){if(!(r===h-1||o===1))if(o===2){if(n.length<2||s!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const S=n.lastIndexOf(g);S===-1?(n="",s=0):(n=n.slice(0,S),s=n.length-1-n.lastIndexOf(g)),r=h,o=0;continue}else if(n.length!==0){n="",s=0,r=h,o=0;continue}}c&&(n+=n.length>0?`${g}..`:"..",s=2)}else n.length>0?n+=`${g}${p.slice(r+1,h)}`:n=p.slice(r+1,h),s=h-r-1;r=h,o=0}else l===P&&o!==-1?++o:o=-1}return n}function b(p,c){if(c===null||typeof c!="object")throw new m("pathObject","Object",c);const g=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return g?g===c.root?`${g}${t}`:`${g}${p}${t}`:t}e.win32={resolve(...p){let c="",g="",t=!1;for(let n=p.length-1;n>=-1;n--){let s;if(n>=0){if(s=p[n],f(s,"path"),s.length===0)continue}else c.length===0?s=_.cwd():(s=_.env[`=${c}`]||_.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==c.toLowerCase()&&s.charCodeAt(2)===i)&&(s=`${c}\\`));const r=s.length;let o=0,l="",h=!1;const S=s.charCodeAt(0);if(r===1)a(S)&&(o=1,h=!0);else if(a(S))if(h=!0,a(s.charCodeAt(1))){let u=2,v=u;for(;u<r&&!a(s.charCodeAt(u));)u++;if(u<r&&u!==v){const R=s.slice(v,u);for(v=u;u<r&&a(s.charCodeAt(u));)u++;if(u<r&&u!==v){for(v=u;u<r&&!a(s.charCodeAt(u));)u++;(u===r||u!==v)&&(l=`\\\\${R}\\${s.slice(v,u)}`,o=u)}}}else o=1;else E(S)&&s.charCodeAt(1)===T&&(l=s.slice(0,2),o=2,r>2&&a(s.charCodeAt(2))&&(h=!0,o=3));if(l.length>0)if(c.length>0){if(l.toLowerCase()!==c.toLowerCase())continue}else c=l;if(t){if(c.length>0)break}else if(g=`${s.slice(o)}\\${g}`,t=h,h&&c.length>0)break}return g=w(g,!t,"\\",a),t?`${c}\\${g}`:`${c}${g}`||"."},normalize(p){f(p,"path");const c=p.length;if(c===0)return".";let g=0,t,n=!1;const s=p.charCodeAt(0);if(c===1)return d(s)?"\\":p;if(a(s))if(n=!0,a(p.charCodeAt(1))){let o=2,l=o;for(;o<c&&!a(p.charCodeAt(o));)o++;if(o<c&&o!==l){const h=p.slice(l,o);for(l=o;o<c&&a(p.charCodeAt(o));)o++;if(o<c&&o!==l){for(l=o;o<c&&!a(p.charCodeAt(o));)o++;if(o===c)return`\\\\${h}\\${p.slice(l)}\\`;o!==l&&(t=`\\\\${h}\\${p.slice(l,o)}`,g=o)}}}else g=1;else E(s)&&p.charCodeAt(1)===T&&(t=p.slice(0,2),g=2,c>2&&a(p.charCodeAt(2))&&(n=!0,g=3));let r=g<c?w(p.slice(g),!n,"\\",a):"";return r.length===0&&!n&&(r="."),r.length>0&&a(p.charCodeAt(c-1))&&(r+="\\"),t===void 0?n?`\\${r}`:r:n?`${t}\\${r}`:`${t}${r}`},isAbsolute(p){f(p,"path");const c=p.length;if(c===0)return!1;const g=p.charCodeAt(0);return a(g)||c>2&&E(g)&&p.charCodeAt(1)===T&&a(p.charCodeAt(2))},join(...p){if(p.length===0)return".";let c,g;for(let s=0;s<p.length;++s){const r=p[s];f(r,"path"),r.length>0&&(c===void 0?c=g=r:c+=`\\${r}`)}if(c===void 0)return".";let t=!0,n=0;if(typeof g=="string"&&a(g.charCodeAt(0))){++n;const s=g.length;s>1&&a(g.charCodeAt(1))&&(++n,s>2&&(a(g.charCodeAt(2))?++n:t=!1))}if(t){for(;n<c.length&&a(c.charCodeAt(n));)n++;n>=2&&(c=`\\${c.slice(n)}`)}return e.win32.normalize(c)},relative(p,c){if(f(p,"from"),f(c,"to"),p===c)return"";const g=e.win32.resolve(p),t=e.win32.resolve(c);if(g===t||(p=g.toLowerCase(),c=t.toLowerCase(),p===c))return"";let n=0;for(;n<p.length&&p.charCodeAt(n)===i;)n++;let s=p.length;for(;s-1>n&&p.charCodeAt(s-1)===i;)s--;const r=s-n;let o=0;for(;o<c.length&&c.charCodeAt(o)===i;)o++;let l=c.length;for(;l-1>o&&c.charCodeAt(l-1)===i;)l--;const h=l-o,S=r<h?r:h;let u=-1,v=0;for(;v<S;v++){const L=p.charCodeAt(n+v);if(L!==c.charCodeAt(o+v))break;L===i&&(u=v)}if(v!==S){if(u===-1)return t}else{if(h>S){if(c.charCodeAt(o+v)===i)return t.slice(o+v+1);if(v===2)return t.slice(o+v)}r>S&&(p.charCodeAt(n+v)===i?u=v:v===2&&(u=3)),u===-1&&(u=0)}let R="";for(v=n+u+1;v<=s;++v)(v===s||p.charCodeAt(v)===i)&&(R+=R.length===0?"..":"\\..");return o+=u,R.length>0?`${R}${t.slice(o,l)}`:(t.charCodeAt(o)===i&&++o,t.slice(o,l))},toNamespacedPath(p){if(typeof p!="string")return p;if(p.length===0)return"";const c=e.win32.resolve(p);if(c.length<=2)return p;if(c.charCodeAt(0)===i){if(c.charCodeAt(1)===i){const g=c.charCodeAt(2);if(g!==C&&g!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(E(c.charCodeAt(0))&&c.charCodeAt(1)===T&&c.charCodeAt(2)===i)return`\\\\?\\${c}`;return p},dirname(p){f(p,"path");const c=p.length;if(c===0)return".";let g=-1,t=0;const n=p.charCodeAt(0);if(c===1)return a(n)?p:".";if(a(n)){if(g=t=1,a(p.charCodeAt(1))){let o=2,l=o;for(;o<c&&!a(p.charCodeAt(o));)o++;if(o<c&&o!==l){for(l=o;o<c&&a(p.charCodeAt(o));)o++;if(o<c&&o!==l){for(l=o;o<c&&!a(p.charCodeAt(o));)o++;if(o===c)return p;o!==l&&(g=t=o+1)}}}}else E(n)&&p.charCodeAt(1)===T&&(g=c>2&&a(p.charCodeAt(2))?3:2,t=g);let s=-1,r=!0;for(let o=c-1;o>=t;--o)if(a(p.charCodeAt(o))){if(!r){s=o;break}}else r=!1;if(s===-1){if(g===-1)return".";s=g}return p.slice(0,s)},basename(p,c){c!==void 0&&f(c,"ext"),f(p,"path");let g=0,t=-1,n=!0,s;if(p.length>=2&&E(p.charCodeAt(0))&&p.charCodeAt(1)===T&&(g=2),c!==void 0&&c.length>0&&c.length<=p.length){if(c===p)return"";let r=c.length-1,o=-1;for(s=p.length-1;s>=g;--s){const l=p.charCodeAt(s);if(a(l)){if(!n){g=s+1;break}}else o===-1&&(n=!1,o=s+1),r>=0&&(l===c.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=o))}return g===t?t=o:t===-1&&(t=p.length),p.slice(g,t)}for(s=p.length-1;s>=g;--s)if(a(p.charCodeAt(s))){if(!n){g=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":p.slice(g,t)},extname(p){f(p,"path");let c=0,g=-1,t=0,n=-1,s=!0,r=0;p.length>=2&&p.charCodeAt(1)===T&&E(p.charCodeAt(0))&&(c=t=2);for(let o=p.length-1;o>=c;--o){const l=p.charCodeAt(o);if(a(l)){if(!s){t=o+1;break}continue}n===-1&&(s=!1,n=o+1),l===P?g===-1?g=o:r!==1&&(r=1):g!==-1&&(r=-1)}return g===-1||n===-1||r===0||r===1&&g===n-1&&g===t+1?"":p.slice(g,n)},format:b.bind(null,"\\"),parse(p){f(p,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return c;const g=p.length;let t=0,n=p.charCodeAt(0);if(g===1)return a(n)?(c.root=c.dir=p,c):(c.base=c.name=p,c);if(a(n)){if(t=1,a(p.charCodeAt(1))){let u=2,v=u;for(;u<g&&!a(p.charCodeAt(u));)u++;if(u<g&&u!==v){for(v=u;u<g&&a(p.charCodeAt(u));)u++;if(u<g&&u!==v){for(v=u;u<g&&!a(p.charCodeAt(u));)u++;u===g?t=u:u!==v&&(t=u+1)}}}}else if(E(n)&&p.charCodeAt(1)===T){if(g<=2)return c.root=c.dir=p,c;if(t=2,a(p.charCodeAt(2))){if(g===3)return c.root=c.dir=p,c;t=3}}t>0&&(c.root=p.slice(0,t));let s=-1,r=t,o=-1,l=!0,h=p.length-1,S=0;for(;h>=t;--h){if(n=p.charCodeAt(h),a(n)){if(!l){r=h+1;break}continue}o===-1&&(l=!1,o=h+1),n===P?s===-1?s=h:S!==1&&(S=1):s!==-1&&(S=-1)}return o!==-1&&(s===-1||S===0||S===1&&s===o-1&&s===r+1?c.base=c.name=p.slice(r,o):(c.name=p.slice(r,s),c.base=p.slice(r,o),c.ext=p.slice(s,o))),r>0&&r!==t?c.dir=p.slice(0,r-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...p){let c="",g=!1;for(let t=p.length-1;t>=-1&&!g;t--){const n=t>=0?p[t]:_.cwd();f(n,"path"),n.length!==0&&(c=`${n}/${c}`,g=n.charCodeAt(0)===D)}return c=w(c,!g,"/",d),g?`/${c}`:c.length>0?c:"."},normalize(p){if(f(p,"path"),p.length===0)return".";const c=p.charCodeAt(0)===D,g=p.charCodeAt(p.length-1)===D;return p=w(p,!c,"/",d),p.length===0?c?"/":g?"./":".":(g&&(p+="/"),c?`/${p}`:p)},isAbsolute(p){return f(p,"path"),p.length>0&&p.charCodeAt(0)===D},join(...p){if(p.length===0)return".";let c;for(let g=0;g<p.length;++g){const t=p[g];f(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(p,c){if(f(p,"from"),f(c,"to"),p===c||(p=e.posix.resolve(p),c=e.posix.resolve(c),p===c))return"";const g=1,t=p.length,n=t-g,s=1,r=c.length-s,o=n<r?n:r;let l=-1,h=0;for(;h<o;h++){const u=p.charCodeAt(g+h);if(u!==c.charCodeAt(s+h))break;u===D&&(l=h)}if(h===o)if(r>o){if(c.charCodeAt(s+h)===D)return c.slice(s+h+1);if(h===0)return c.slice(s+h)}else n>o&&(p.charCodeAt(g+h)===D?l=h:h===0&&(l=0));let S="";for(h=g+l+1;h<=t;++h)(h===t||p.charCodeAt(h)===D)&&(S+=S.length===0?"..":"/..");return`${S}${c.slice(s+l)}`},toNamespacedPath(p){return p},dirname(p){if(f(p,"path"),p.length===0)return".";const c=p.charCodeAt(0)===D;let g=-1,t=!0;for(let n=p.length-1;n>=1;--n)if(p.charCodeAt(n)===D){if(!t){g=n;break}}else t=!1;return g===-1?c?"/":".":c&&g===1?"//":p.slice(0,g)},basename(p,c){c!==void 0&&f(c,"ext"),f(p,"path");let g=0,t=-1,n=!0,s;if(c!==void 0&&c.length>0&&c.length<=p.length){if(c===p)return"";let r=c.length-1,o=-1;for(s=p.length-1;s>=0;--s){const l=p.charCodeAt(s);if(l===D){if(!n){g=s+1;break}}else o===-1&&(n=!1,o=s+1),r>=0&&(l===c.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=o))}return g===t?t=o:t===-1&&(t=p.length),p.slice(g,t)}for(s=p.length-1;s>=0;--s)if(p.charCodeAt(s)===D){if(!n){g=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":p.slice(g,t)},extname(p){f(p,"path");let c=-1,g=0,t=-1,n=!0,s=0;for(let r=p.length-1;r>=0;--r){const o=p.charCodeAt(r);if(o===D){if(!n){g=r+1;break}continue}t===-1&&(n=!1,t=r+1),o===P?c===-1?c=r:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||t===-1||s===0||s===1&&c===t-1&&c===g+1?"":p.slice(c,t)},format:b.bind(null,"/"),parse(p){f(p,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return c;const g=p.charCodeAt(0)===D;let t;g?(c.root="/",t=1):t=0;let n=-1,s=0,r=-1,o=!0,l=p.length-1,h=0;for(;l>=t;--l){const S=p.charCodeAt(l);if(S===D){if(!o){s=l+1;break}continue}r===-1&&(o=!1,r=l+1),S===P?n===-1?n=l:h!==1&&(h=1):n!==-1&&(h=-1)}if(r!==-1){const S=s===0&&g?1:s;n===-1||h===0||h===1&&n===r-1&&n===s+1?c.base=c.name=p.slice(S,r):(c.name=p.slice(S,n),c.base=p.slice(S,r),c.ext=p.slice(n,r))}return s>0?c.dir=p.slice(0,s-1):g&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=_.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=_.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=_.platform==="win32"?e.win32.join:e.posix.join,e.resolve=_.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=_.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=_.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=_.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=_.platform==="win32"?e.win32.extname:e.posix.extname,e.format=_.platform==="win32"?e.win32.format:e.posix.format,e.parse=_.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=_.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=_.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=_.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[135],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var _;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(_=e.Source||(e.Source={}));var k;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(I,...y){const P=y.reduce((T,C)=>(T[C]=!0,T),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(T=>!P[T]).forEach(T=>{for(let C=0;C<D.length;C++)if(T.search(D[C])!==-1){delete I[T];break}})}e.sanitizeProcessEnvironment=A}),define(me[47],ge([0,1,9]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=_.globals.performance&&typeof _.globals.performance.now=="function";class A{constructor(y){this._highResolution=k&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new A(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?_.globals.performance.now():Date.now()}}e.StopWatch=A}),define(me[3],ge([0,1,18,71,6,56,47]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(w){w.None=()=>A.Disposable.None;function b(j){return(B,$=null,N)=>{let M=!1,F;return F=j(U=>{if(!M)return F?F.dispose():M=!0,B.call($,U)},null,N),M&&F.dispose(),F}}w.once=b;function p(j,B){return r(($,N=null,M)=>j(F=>$.call(N,B(F)),null,M))}w.map=p;function c(j,B){return r(($,N=null,M)=>j(F=>{B(F),$.call(N,F)},null,M))}w.forEach=c;function g(j,B){return r(($,N=null,M)=>j(F=>B(F)&&$.call(N,F),null,M))}w.filter=g;function t(j){return j}w.signal=t;function n(...j){return(B,$=null,N)=>(0,A.combinedDisposable)(...j.map(M=>M(F=>B.call($,F),null,N)))}w.any=n;function s(j,B,$){let N=$;return p(j,M=>(N=B(N,M),N))}w.reduce=s;function r(j){let B;const $=new m({onFirstListenerAdd(){B=j($.fire,$)},onLastListenerRemove(){B.dispose()}});return $.event}w.snapshot=r;function o(j,B,$=100,N=!1,M){let F,U,O,W=0;const q=new m({leakWarningThreshold:M,onFirstListenerAdd(){F=j(Q=>{W++,U=B(U,Q),N&&!O&&(q.fire(U),U=void 0),clearTimeout(O),O=setTimeout(()=>{const he=U;U=void 0,O=void 0,(!N||W>1)&&q.fire(he),W=0},$)})},onLastListenerRemove(){F.dispose()}});return q.event}w.debounce=o;function l(j){const B=new Date().getTime();return p(b(j),$=>new Date().getTime()-B)}w.stopwatch=l;function h(j){let B=!0,$;return g(j,N=>{const M=B||N!==$;return B=!1,$=N,M})}w.latch=h;function S(j,B=!1,$=[]){let N=$.slice(),M=j(O=>{N?N.push(O):U.fire(O)});const F=()=>{N&&N.forEach(O=>U.fire(O)),N=null},U=new m({onFirstListenerAdd(){M||(M=j(O=>U.fire(O)))},onFirstListenerDidAdd(){N&&(B?setTimeout(F):F())},onLastListenerRemove(){M&&M.dispose(),M=null}});return U.event}w.buffer=S;class u{constructor(B){this.event=B}map(B){return new u(p(this.event,B))}forEach(B){return new u(c(this.event,B))}filter(B){return new u(g(this.event,B))}reduce(B,$){return new u(s(this.event,B,$))}latch(){return new u(h(this.event))}debounce(B,$=100,N=!1,M){return new u(o(this.event,B,$,N,M))}on(B,$,N){return this.event(B,$,N)}once(B,$,N){return b(this.event)(B,$,N)}}function v(j){return new u(j)}w.chain=v;function R(j,B,$=N=>N){const N=(...O)=>U.fire($(...O)),M=()=>j.on(B,N),F=()=>j.removeListener(B,N),U=new m({onFirstListenerAdd:M,onLastListenerRemove:F});return U.event}w.fromNodeEventEmitter=R;function L(j,B,$=N=>N){const N=(...O)=>U.fire($(...O)),M=()=>j.addEventListener(B,N),F=()=>j.removeEventListener(B,N),U=new m({onFirstListenerAdd:M,onLastListenerRemove:F});return U.event}w.fromDOMEventEmitter=L;function H(j){const B=new m;let $=!1;return j.then(void 0,()=>null).then(()=>{$?B.fire(void 0):setTimeout(()=>B.fire(void 0),0)}),$=!0,B.event}w.fromPromise=H;function ie(j){return new Promise(B=>b(j)(B))}w.toPromise=ie})(P=e.Event||(e.Event={}));class D{constructor(b){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${b}_${D._idPool++}`}start(b){this._stopWatch=new y.StopWatch(!0),this._listenerCount=b}stop(){if(this._stopWatch){const b=this._stopWatch.elapsed();this._elapsedOverall+=b,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${b.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let i=-1;function T(w){const b=i;return i=w,{dispose(){i=b}}}e.setGlobalLeakWarningThreshold=T;class C{constructor(b,p=Math.random().toString(18).slice(2,5)){this.customThreshold=b,this.name=p,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(b){let p=i;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),!(p<=0||b<p)){this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),g=this._stacks.get(c)||0;if(this._stacks.set(c,g+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let t,n=0;for(const[s,r]of this._stacks)(!t||n<r)&&(t=s,n=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}}class m{constructor(b){var p;this._disposed=!1,this._options=b,this._leakageMon=i>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((p=this._options)===null||p===void 0?void 0:p._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(b,p,c)=>{var g;this._listeners||(this._listeners=new I.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(p?[b,p]:b);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,b,p);const s=(g=this._leakageMon)===null||g===void 0?void 0:g.check(this._listeners.size);let r;return r={dispose:()=>{s&&s(),r.dispose=m._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof A.DisposableStore?c.add(r):Array.isArray(c)&&c.push(r),r}),this._event}fire(b){var p,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new I.LinkedList);for(let g of this._listeners)this._deliveryQueue.push([g,b]);for((p=this._perfMon)===null||p===void 0||p.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[g,t]=this._deliveryQueue.shift();try{typeof g=="function"?g.call(void 0,t):g[0].call(g[1],t)}catch(n){(0,_.onUnexpectedError)(n)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var b,p,c;(b=this._listeners)===null||b===void 0||b.clear(),(p=this._deliveryQueue)===null||p===void 0||p.clear(),(c=this._leakageMon)===null||c===void 0||c.dispose(),this._disposed=!0}}e.Emitter=m,m._noop=function(){};class f extends m{constructor(b){super(b);this._isPaused=0,this._eventQueue=new I.LinkedList,this._mergeFn=b==null?void 0:b.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const b=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(b))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(b){this._listeners&&(this._isPaused!==0?this._eventQueue.push(b):super.fire(b))}}e.PauseableEmitter=f;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(b){const p={event:b,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const c=()=>{this.hasListeners&&this.unhook(p);const g=this.events.indexOf(p);this.events.splice(g,1)};return(0,A.toDisposable)((0,k.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(b=>this.hook(b))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(b=>this.unhook(b))}hook(b){b.listener=b.event(p=>this.emitter.fire(p))}unhook(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class d{constructor(){this.buffers=[]}wrapEvent(b){return(p,c,g)=>b(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>p.call(c,t)):p.call(c,t)},void 0,g)}bufferEvents(b){const p=[];this.buffers.push(p);const c=b();return this.buffers.pop(),p.forEach(g=>g()),c}}e.EventBufferer=d;class E{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=A.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(b){this.inputEvent=b,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=b(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(me[21],ge([0,1,3]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(P,D){const i=setTimeout(P.bind(D),0);return{dispose(){clearTimeout(i)}}});var A;(function(P){function D(i){return i===P.None||i===P.Cancelled||i instanceof I?!0:!i||typeof i!="object"?!1:typeof i.isCancellationRequested=="boolean"&&typeof i.onCancellationRequested=="function"}P.isCancellationToken=D,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(A=e.CancellationToken||(e.CancellationToken={}));class I{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new I),this._token}cancel(){this._token?this._token instanceof I&&this._token.cancel():this._token=A.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof I&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=y}),define(me[43],ge([0,1,3]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class k{constructor(){this._icons=new Map,this._onDidRegister=new _.Emitter}add(T){const C=this._icons.get(T.id);C?T.description?C.description=T.description:console.error(`Duplicate registration of codicon ${T.id}`):(this._icons.set(T.id,T),this._onDidRegister.fire(T))}get(T){return this._icons.get(T)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const A=new k;e.iconRegistry=A;function I(i,T){return new y(i,T)}e.registerCodicon=I;class y{constructor(T,C,m){this.id=T,this.definition=C,this.description=m,A.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=y;function P(i,T){const C=["codicon","codicon-"+i];return T&&C.push("codicon-modifier-"+T),C}e.getClassNamesArray=P;var D;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const T=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function C(a){if(a instanceof y)return["codicon","codicon-"+a.id];const d=T.exec(a.id);if(!d)return C(y.error);let[,E,w]=d;const b=["codicon","codicon-"+E];return w&&b.push("codicon-modifier-"+w.substr(1)),b}i.asClassNameArray=C;function m(a){return C(a).join(" ")}i.asClassName=m;function f(a){return"."+C(a).join(".")}i.asCSSSelector=f})(D=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personAdd=new i("person-add",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(y=e.Codicon||(e.Codicon={}))}),define(me[94],ge([0,1,18,6]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(w){const b=w;return b&&[b.on,b.pause,b.resume,b.destroy].every(p=>typeof p=="function")}e.isReadableStream=A;function I(w){const b=w;return b&&A(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean"}e.isReadableBufferedStream=I;function y(w,b){return new P(w,b)}e.newWriteableStream=y;class P{constructor(b,p){this.reducer=b,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(b){var p;if(!this.state.destroyed){if(this.state.flowing)this.emitData(b);else if(this.buffer.data.push(b),typeof((p=this.options)===null||p===void 0?void 0:p.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(b){this.state.destroyed||(this.state.flowing?this.emitError(b):this.buffer.error.push(b))}end(b){this.state.destroyed||(typeof b!="undefined"&&this.write(b),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(b){this.listeners.data.slice(0).forEach(p=>p(b))}emitError(b){this.listeners.error.length===0?(0,_.onUnexpectedError)(b):this.listeners.error.slice(0).forEach(p=>p(b))}emitEnd(){this.listeners.end.slice(0).forEach(b=>b())}on(b,p){if(!this.state.destroyed)switch(b){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(b,p){if(!this.state.destroyed){let c;switch(b){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const g=c.indexOf(p);g>=0&&c.splice(g,1)}}}flowData(){if(this.buffer.data.length>0){const b=this.reducer(this.buffer.data);this.emitData(b),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const b of this.buffer.error)this.emitError(b);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(w,b){const p=[];let c;for(;(c=w.read())!==null;)p.push(c);return b(p)}e.consumeReadable=D;function i(w,b,p){const c=[];let g;for(;(g=w.read())!==null&&c.length<p;)c.push(g);return g===null&&c.length>0?b(c):{read:()=>{if(c.length>0)return c.shift();if(typeof g!="undefined"){const t=g;return g=void 0,t}return w.read()}}}e.peekReadable=i;function T(w,b){return new Promise((p,c)=>{const g=[];C(w,{onData:t=>{b&&g.push(t)},onError:t=>{b?c(t):p(void 0)},onEnd:()=>{p(b?b(g):void 0)}})})}e.consumeStream=T;function C(w,b){w.on("error",p=>b.onError(p)),w.on("end",()=>b.onEnd()),w.on("data",p=>b.onData(p))}e.listenStream=C;function m(w,b){return new Promise((p,c)=>{const g=new k.DisposableStore,t=[],n=o=>{if(t.push(o),t.length>b)return g.dispose(),w.pause(),p({stream:w,buffer:t,ended:!1})},s=o=>c(o),r=()=>p({stream:w,buffer:t,ended:!0});g.add((0,k.toDisposable)(()=>w.removeListener("error",s))),w.on("error",s),g.add((0,k.toDisposable)(()=>w.removeListener("end",r))),w.on("end",r),g.add((0,k.toDisposable)(()=>w.removeListener("data",n))),w.on("data",n)})}e.peekStream=m;function f(w,b){const p=y(b);return p.end(w),p}e.toStream=f;function a(){const w=y(()=>{throw new Error("not supported")});return w.end(),w}e.emptyStream=a;function d(w){let b=!1;return{read:()=>b?null:(b=!0,w)}}e.toReadable=d;function E(w,b,p){const c=y(p);return C(w,{onData:g=>c.write(b.data(g)),onError:g=>c.error(b.error?b.error(g):g),onEnd:()=>c.end()}),c}e.transform=E}),define(me[10],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function _(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=_;const k=/{(\d+)}/g;function A(K,...oe){return oe.length===0?K:K.replace(k,function(fe,Z){const ne=parseInt(Z,10);return isNaN(ne)||ne<0||ne>=oe.length?fe:oe[ne]})}e.format=A;function I(K){return K.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=I;function y(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function P(K,oe){let fe=0;const Z=oe.charCodeAt(0);for(let ne=K.length-1;ne>=0;ne--)K.charCodeAt(ne)===Z&&fe++;return fe}e.count=P;function D(K,oe,fe="\u2026"){return K.length<=oe?K:`${K.substr(0,oe)}${fe}`}e.truncate=D;function i(K,oe=" "){const fe=T(K,oe);return C(fe,oe)}e.trim=i;function T(K,oe){if(!K||!oe)return K;const fe=oe.length;if(fe===0||K.length===0)return K;let Z=0;for(;K.indexOf(oe,Z)===Z;)Z=Z+fe;return K.substring(Z)}e.ltrim=T;function C(K,oe){if(!K||!oe)return K;const fe=oe.length,Z=K.length;if(fe===0||Z===0)return K;let ne=Z,ce=-1;for(;ce=K.lastIndexOf(oe,ne-1),!(ce===-1||ce+fe!==ne);){if(ce===0)return"";ne=ce}return K.substring(0,ne)}e.rtrim=C;function m(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function f(K){return K.replace(/\*/g,"")}e.stripWildcards=f;function a(K,oe,fe={}){if(!K)throw new Error("Cannot create regex from empty string");oe||(K=y(K)),fe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Z="";return fe.global&&(Z+="g"),fe.matchCase||(Z+="i"),fe.multiline&&(Z+="m"),fe.unicode&&(Z+="u"),new RegExp(K,Z)}e.createRegExp=a;function d(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function E(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function w(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=w;function b(K){return K.split(/\r\n|\r|\n/)}e.splitLines=b;function p(K){for(let oe=0,fe=K.length;oe<fe;oe++){const Z=K.charCodeAt(oe);if(Z!==32&&Z!==9)return oe}return-1}e.firstNonWhitespaceIndex=p;function c(K,oe=0,fe=K.length){for(let Z=oe;Z<fe;Z++){const ne=K.charCodeAt(Z);if(ne!==32&&ne!==9)return K.substring(oe,Z)}return K.substring(oe,fe)}e.getLeadingWhitespace=c;function g(K,oe=K.length-1){for(let fe=oe;fe>=0;fe--){const Z=K.charCodeAt(fe);if(Z!==32&&Z!==9)return fe}return-1}e.lastNonWhitespaceIndex=g;function t(K,oe){return K<oe?-1:K>oe?1:0}e.compare=t;function n(K,oe,fe=0,Z=K.length,ne=0,ce=oe.length){for(;fe<Z&&ne<ce;fe++,ne++){let qe=K.charCodeAt(fe),Me=oe.charCodeAt(ne);if(qe<Me)return-1;if(qe>Me)return 1}const pe=Z-fe,Se=ce-ne;return pe<Se?-1:pe>Se?1:0}e.compareSubstring=n;function s(K,oe){return r(K,oe,0,K.length,0,oe.length)}e.compareIgnoreCase=s;function r(K,oe,fe=0,Z=K.length,ne=0,ce=oe.length){for(;fe<Z&&ne<ce;fe++,ne++){let qe=K.charCodeAt(fe),Me=oe.charCodeAt(ne);if(qe!==Me){const He=qe-Me;if(!(He===32&&l(Me))&&!(He===-32&&l(qe)))return o(qe)&&o(Me)?He:n(K.toLowerCase(),oe.toLowerCase(),fe,Z,ne,ce)}}const pe=Z-fe,Se=ce-ne;return pe<Se?-1:pe>Se?1:0}e.compareSubstringIgnoreCase=r;function o(K){return K>=97&&K<=122}e.isLowerAsciiLetter=o;function l(K){return K>=65&&K<=90}e.isUpperAsciiLetter=l;function h(K){return o(K)||l(K)}function S(K,oe){return K.length===oe.length&&u(K,oe)}e.equalsIgnoreCase=S;function u(K,oe,fe=K.length){for(let Z=0;Z<fe;Z++){const ne=K.charCodeAt(Z),ce=oe.charCodeAt(Z);if(ne!==ce){if(h(ne)&&h(ce)){const pe=Math.abs(ne-ce);if(pe!==0&&pe!==32)return!1}else if(String.fromCharCode(ne).toLowerCase()!==String.fromCharCode(ce).toLowerCase())return!1}}return!0}function v(K,oe){const fe=oe.length;return oe.length>K.length?!1:u(K,oe,fe)}e.startsWithIgnoreCase=v;function R(K,oe){let fe,Z=Math.min(K.length,oe.length);for(fe=0;fe<Z;fe++)if(K.charCodeAt(fe)!==oe.charCodeAt(fe))return fe;return Z}e.commonPrefixLength=R;function L(K,oe){let fe,Z=Math.min(K.length,oe.length);const ne=K.length-1,ce=oe.length-1;for(fe=0;fe<Z;fe++)if(K.charCodeAt(ne-fe)!==oe.charCodeAt(ce-fe))return fe;return Z}e.commonSuffixLength=L;function H(K){return 55296<=K&&K<=56319}e.isHighSurrogate=H;function ie(K){return 56320<=K&&K<=57343}e.isLowSurrogate=ie;function j(K,oe){return(K-55296<<10)+(oe-56320)+65536}e.computeCodePoint=j;function B(K,oe,fe){const Z=K.charCodeAt(fe);if(H(Z)&&fe+1<oe){const ne=K.charCodeAt(fe+1);if(ie(ne))return j(Z,ne)}return Z}e.getNextCodePoint=B;function $(K,oe){const fe=K.charCodeAt(oe-1);if(ie(fe)&&oe>1){const Z=K.charCodeAt(oe-2);if(H(Z))return j(Z,fe)}return fe}function N(K,oe){const fe=$e.getInstance(),Z=oe,ne=K.length,ce=B(K,ne,oe);oe+=ce>=65536?2:1;let pe=fe.getGraphemeBreakType(ce);for(;oe<ne;){const Se=B(K,ne,oe),qe=fe.getGraphemeBreakType(Se);if(xe(pe,qe))break;oe+=Se>=65536?2:1,pe=qe}return oe-Z}e.nextCharLength=N;function M(K,oe){const fe=$e.getInstance(),Z=oe,ne=$(K,oe);oe-=ne>=65536?2:1;let ce=fe.getGraphemeBreakType(ne);for(;oe>0;){const pe=$(K,oe),Se=fe.getGraphemeBreakType(pe);if(xe(Se,ce))break;oe-=pe>=65536?2:1,ce=Se}return Z-oe}e.prevCharLength=M;function F(K,oe){const fe=$e.getInstance(),Z=K.length,ne=oe,ce=B(K,Z,oe),pe=fe.getGraphemeBreakType(ce);oe+=ce>=65536?2:1;let Se=pe;for(;oe<Z;){const Me=B(K,Z,oe),He=fe.getGraphemeBreakType(Me);if(xe(Se,He))break;oe+=Me>=65536?2:1,Se=He}const qe=oe;for(oe=ne,Se=pe;oe>0;){const Me=$(K,oe),He=fe.getGraphemeBreakType(Me);if(xe(He,Se))break;oe-=Me>=65536?2:1,Se=He}return[oe,qe]}function U(K,oe){return oe>0&&ie(K.charCodeAt(oe))?F(K,oe-1):F(K,oe)}e.getCharContainingOffset=U;function O(K){const oe=K.length;let fe=0,Z=0;for(;Z<oe;){const pe=B(K,oe,Z);Z+=pe>=65536?2:1,pe<128?fe+=1:pe<2048?fe+=2:pe<65536?fe+=3:fe+=4}const ne=new Uint8Array(fe);Z=0;let ce=0;for(;Z<oe;){const pe=B(K,oe,Z);Z+=pe>=65536?2:1,pe<128?ne[ce++]=pe:pe<2048?(ne[ce++]=192|(pe&1984)>>>6,ne[ce++]=128|(pe&63)>>>0):pe<65536?(ne[ce++]=224|(pe&61440)>>>12,ne[ce++]=128|(pe&4032)>>>6,ne[ce++]=128|(pe&63)>>>0):(ne[ce++]=240|(pe&1835008)>>>18,ne[ce++]=128|(pe&258048)>>>12,ne[ce++]=128|(pe&4032)>>>6,ne[ce++]=128|(pe&63)>>>0)}return ne}e.encodeUTF8=O;function W(K){const oe=K.byteLength,fe=[];let Z=0;for(;Z<oe;){const ne=K[Z];let ce;if(ne>=240&&Z+3<oe?ce=(K[Z++]&7)<<18>>>0|(K[Z++]&63)<<12>>>0|(K[Z++]&63)<<6>>>0|(K[Z++]&63)<<0>>>0:ne>=224&&Z+2<oe?ce=(K[Z++]&15)<<12>>>0|(K[Z++]&63)<<6>>>0|(K[Z++]&63)<<0>>>0:ne>=192&&Z+1<oe?ce=(K[Z++]&31)<<6>>>0|(K[Z++]&63)<<0>>>0:ce=K[Z++],ce>=0&&ce<=55295||ce>=57344&&ce<=65535)fe.push(String.fromCharCode(ce));else if(ce>=65536&&ce<=1114111){const pe=ce-65536,Se=55296+((pe&1047552)>>>10),qe=56320+((pe&1023)>>>0);fe.push(String.fromCharCode(Se)),fe.push(String.fromCharCode(qe))}else fe.push(String.fromCharCode(65533))}return fe.join("")}e.decodeUTF8=W;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(K){return q.test(K)}e.containsRTL=Q;const he=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ve(K){return he.test(K)}e.containsEmoji=ve;const Ie=/^[\t\n\r\x20-\x7E]*$/;function ke(K){return Ie.test(K)}e.isBasicASCII=ke,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Le(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Le;function V(K){for(let oe=0,fe=K.length;oe<fe;oe++)if(J(K.charCodeAt(oe)))return!0;return!1}e.containsFullWidthCharacter=V;function J(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=J;function ee(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=ee;function ae(K,oe){if(K.length<oe)return K;const fe=/\b/g;let Z=0;for(;fe.test(K)&&!(K.length-fe.lastIndex<oe);)Z=fe.lastIndex,fe.lastIndex+=1;return K.substring(Z).replace(/^\s/,"")}e.lcut=ae;const we=/\x1B\x5B[12]?K/g,Ce=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function be(K){return K&&(K=K.replace(we,""),K=K.replace(Ce,""),K=K.replace(Oe,"")),K}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Pe(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Pe;function Re(K){return Pe(K)?K.substr(1):K}e.stripUTF8BOM=Re;function We(K,oe){if(!K||!oe||K.length<oe.length)return!1;const fe=oe.length,Z=K.toLowerCase();let ne=0,ce=-1;for(;ne<fe;){const pe=Z.indexOf(oe[ne],ce+1);if(pe<0)return!1;ce=pe,ne++}return!0}e.fuzzyContains=We;function Ee(K,oe=!1){return K?(oe&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Ee;function Ke(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Ke;function X(K,oe=1){if(oe===0)return"";let fe=-1;do fe=K.indexOf(`
`,fe+1),oe--;while(oe>0&&fe>=0);return fe===-1?K:(K[fe-1]==="\r"&&fe--,K.substr(0,fe))}e.getNLines=X;function re(K){const oe=90-65+1;return K=K%(2*oe),K<oe?String.fromCharCode(97+K):String.fromCharCode(65+K-oe)}e.singleLetterHash=re;function _e(K){return $e.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=_e;function xe(K,oe){return K===0?oe!==5&&oe!==7:K===2&&oe===3?!1:K===4||K===2||K===3||oe===4||oe===2||oe===3?!0:!(K===8&&(oe===8||oe===9||oe===11||oe===12)||(K===11||K===9)&&(oe===9||oe===10)||(K===12||K===10)&&oe===10||oe===5||oe===13||oe===7||K===1||K===13&&oe===14||K===6&&oe===6)}e.breakBetweenGraphemeBreakType=xe;var ze;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(ze=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Ye()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const fe=this._data,Z=fe.length/3;let ne=1;for(;ne<=Z;)if(oe<fe[3*ne])ne=2*ne;else if(oe>fe[3*ne+1])ne=2*ne+1;else return fe[3*ne+2];return 0}}$e._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(me[22],ge([0,1,10,94]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",I=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let P,D;class i{constructor(o){this.buffer=o,this.byteLength=this.buffer.byteLength}static alloc(o){return A?new i(Buffer.allocUnsafe(o)):new i(new Uint8Array(o))}static wrap(o){return A&&!Buffer.isBuffer(o)&&(o=Buffer.from(o.buffer,o.byteOffset,o.byteLength)),new i(o)}static fromString(o,l){return!((l==null?void 0:l.dontUseNodeBuffer)||!1)&&A?new i(Buffer.from(o)):I?(P||(P=new TextEncoder),new i(P.encode(o))):new i(_.encodeUTF8(o))}static concat(o,l){if(typeof l=="undefined"){l=0;for(let u=0,v=o.length;u<v;u++)l+=o[u].byteLength}const h=i.alloc(l);let S=0;for(let u=0,v=o.length;u<v;u++){const R=o[u];h.set(R,S),S+=R.byteLength}return h}toString(){return A?this.buffer.toString():y?(D||(D=new TextDecoder),D.decode(this.buffer)):_.decodeUTF8(this.buffer)}slice(o,l){return new i(this.buffer.subarray(o,l))}set(o,l){o instanceof i?this.buffer.set(o.buffer,l):this.buffer.set(o,l)}readUInt32BE(o){return m(this.buffer,o)}writeUInt32BE(o,l){f(this.buffer,o,l)}readUInt32LE(o){return a(this.buffer,o)}writeUInt32LE(o,l){d(this.buffer,o,l)}readUInt8(o){return E(this.buffer,o)}writeUInt8(o,l){w(this.buffer,o,l)}}e.VSBuffer=i;function T(r,o){return r[o+0]<<0>>>0|r[o+1]<<8>>>0}e.readUInt16LE=T;function C(r,o,l){r[l+0]=o&255,o=o>>>8,r[l+1]=o&255}e.writeUInt16LE=C;function m(r,o){return r[o]*2**24+r[o+1]*2**16+r[o+2]*2**8+r[o+3]}e.readUInt32BE=m;function f(r,o,l){r[l+3]=o,o=o>>>8,r[l+2]=o,o=o>>>8,r[l+1]=o,o=o>>>8,r[l]=o}e.writeUInt32BE=f;function a(r,o){return r[o+0]<<0>>>0|r[o+1]<<8>>>0|r[o+2]<<16>>>0|r[o+3]<<24>>>0}e.readUInt32LE=a;function d(r,o,l){r[l+0]=o&255,o=o>>>8,r[l+1]=o&255,o=o>>>8,r[l+2]=o&255,o=o>>>8,r[l+3]=o&255}e.writeUInt32LE=d;function E(r,o){return r[o]}e.readUInt8=E;function w(r,o,l){r[l]=o}e.writeUInt8=w;function b(r){return k.consumeReadable(r,o=>i.concat(o))}e.readableToBuffer=b;function p(r){return k.toReadable(r)}e.bufferToReadable=p;function c(r){return k.consumeStream(r,o=>i.concat(o))}e.streamToBuffer=c;async function g(r){return r.ended?i.concat(r.buffer):i.concat([...r.buffer,await c(r.stream)])}e.bufferedStreamToBuffer=g;function t(r){return k.toStream(r,o=>i.concat(o))}e.bufferToStream=t;function n(r){return k.transform(r,{data:o=>typeof o=="string"?i.fromString(o):i.wrap(o)},o=>i.concat(o))}e.streamToBufferReadableStream=n;function s(r){return k.newWriteableStream(o=>i.concat(o),r)}e.newWriteableBufferStream=s}),define(me[74],ge([0,1,10]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function k(w){return A(w,0)}e.hash=k;function A(w,b){switch(typeof w){case"object":return w===null?I(349,b):Array.isArray(w)?D(w,b):i(w,b);case"string":return P(w,b);case"boolean":return y(w,b);case"number":return I(w,b);case"undefined":return I(937,b);default:return I(617,b)}}e.doHash=A;function I(w,b){return(b<<5)-b+w|0}function y(w,b){return I(w?433:863,b)}function P(w,b){b=I(149417,b);for(let p=0,c=w.length;p<c;p++)b=I(w.charCodeAt(p),b);return b}e.stringHash=P;function D(w,b){return b=I(104579,b),w.reduce((p,c)=>A(c,p),b)}function i(w,b){return b=I(181387,b),Object.keys(w).sort().reduce((p,c)=>(p=P(c,p),A(w[c],p)),b)}class T{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=A(b,this._value),this._value}}e.Hasher=T;var C;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function m(w,b,p=32){const c=p-b,g=~((1<<c)-1);return(w<<b|(g&w)>>>c)>>>0}function f(w,b=0,p=w.byteLength,c=0){for(let g=0;g<p;g++)w[b+g]=c}function a(w,b,p="0"){for(;w.length<b;)w=p+w;return w}function d(w,b=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(p=>p.toString(16).padStart(2,"0")).join(""):a((w>>>0).toString(16),b/4)}e.toHexString=d;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const p=b.length;if(p!==0){const c=this._buff;let g=this._buffLen,t=this._leftoverHighSurrogate,n,s;for(t!==0?(n=t,s=-1,t=0):(n=b.charCodeAt(0),s=0);;){let r=n;if(_.isHighSurrogate(n))if(s+1<p){const o=b.charCodeAt(s+1);_.isLowSurrogate(o)?(s++,r=_.computeCodePoint(n,o)):r=65533}else{t=n;break}else _.isLowSurrogate(n)&&(r=65533);if(g=this._push(c,g,r),s++,s<p)n=b.charCodeAt(s);else break}this._buffLen=g,this._leftoverHighSurrogate=t}}_push(b,p,c){return c<128?b[p++]=c:c<2048?(b[p++]=192|(c&1984)>>>6,b[p++]=128|(c&63)>>>0):c<65536?(b[p++]=224|(c&61440)>>>12,b[p++]=128|(c&4032)>>>6,b[p++]=128|(c&63)>>>0):(b[p++]=240|(c&1835008)>>>18,b[p++]=128|(c&258048)>>>12,b[p++]=128|(c&4032)>>>6,b[p++]=128|(c&63)>>>0),p>=64&&(this._step(),p-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),p}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=E._bigBlock32,p=this._buffDV;for(let h=0;h<64;h+=4)b.setUint32(h,p.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)b.setUint32(h,m(b.getUint32(h-12,!1)^b.getUint32(h-32,!1)^b.getUint32(h-56,!1)^b.getUint32(h-64,!1),1),!1);let c=this._h0,g=this._h1,t=this._h2,n=this._h3,s=this._h4,r,o,l;for(let h=0;h<80;h++)h<20?(r=g&t|~g&n,o=1518500249):h<40?(r=g^t^n,o=1859775393):h<60?(r=g&t|g&n|t&n,o=2400959708):(r=g^t^n,o=3395469782),l=m(c,5)+r+s+o+b.getUint32(h*4,!1)&4294967295,s=n,n=t,t=m(g,30),g=c,c=l;this._h0=this._h0+c&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[57],ge([0,1,10]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(k||(k={})),function(A){const I="error",y="warning",P="warn",D="info";function i(T){return T?_.equalsIgnoreCase(I,T)?A.Error:_.equalsIgnoreCase(y,T)||_.equalsIgnoreCase(P,T)?A.Warning:_.equalsIgnoreCase(D,T)?A.Info:A.Ignore:A.Ignore}A.fromValue=i}(k||(k={})),e.default=k}),define(me[12],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function _(h){return Array.isArray(h)}e.isArray=_;function k(h){return typeof h=="string"}e.isString=k;function A(h){return Array.isArray(h)&&h.every(S=>k(S))}e.isStringArray=A;function I(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=I;function y(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=y;function P(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=P;function D(h){return h===!0||h===!1}e.isBoolean=D;function i(h){return typeof h=="undefined"}e.isUndefined=i;function T(h){return!C(h)}e.isDefined=T;function C(h){return i(h)||h===null}e.isUndefinedOrNull=C;function m(h,S){if(!h)throw new Error(S?`Unexpected type, expected '${S}'`:"Unexpected type")}e.assertType=m;function f(h){if(C(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=f;function a(...h){const S=[];for(let u=0;u<h.length;u++){const v=h[u];if(C(v))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);S.push(v)}return S}e.assertAllDefined=a;const d=Object.prototype.hasOwnProperty;function E(h){if(!I(h))return!1;for(let S in h)if(d.call(h,S))return!1;return!0}e.isEmptyObject=E;function w(h){return typeof h=="function"}e.isFunction=w;function b(...h){return h.length>0&&h.every(w)}e.areFunctions=b;function p(h,S){const u=Math.min(h.length,S.length);for(let v=0;v<u;v++)c(h[v],S[v])}e.validateConstraints=p;function c(h,S){if(k(S)){if(typeof h!==S)throw new Error(`argument does not match constraint: typeof ${S}`)}else if(w(S)){try{if(h instanceof S)return}catch(u){}if(!C(h)&&h.constructor===S||S.length===1&&S.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function g(h){let S=[],u=Object.getPrototypeOf(h);for(;Object.prototype!==u;)S=S.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return S}e.getAllPropertyNames=g;function t(h){const S=[];for(const u of g(h))typeof h[u]=="function"&&S.push(u);return S}e.getAllMethodNames=t;function n(h,S){const u=R=>function(){const L=Array.prototype.slice.call(arguments,0);return S(R,L)};let v={};for(const R of h)v[R]=u(R);return v}e.createProxyObject=n;function s(h){return h===null?void 0:h}e.withNullAsUndefined=s;function r(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=r;function o(h){return class{constructor(){return new Proxy({},{get(S,u){if(S[u])return S[u];throw new Error(`Not Implemented: ${h}->${String(u)}`)}})}}}e.NotImplementedProxy=o;function l(h){throw new Error("Unreachable")}e.assertNever=l}),define(me[30],ge([0,1,9,10,8,12]),function(G,e,_,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function y(n){return n===47||n===92}e.isPathSeparator=y;function P(n){return n.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=P;function D(n,s=A.posix.sep){if(!n)return"";const r=n.length,o=n.charCodeAt(0);if(y(o)){if(y(n.charCodeAt(1))&&!y(n.charCodeAt(2))){let h=3;const S=h;for(;h<r&&!y(n.charCodeAt(h));h++);if(S!==h&&!y(n.charCodeAt(h+1))){for(h+=1;h<r;h++)if(y(n.charCodeAt(h)))return n.slice(0,h+1).replace(/[\\/]/g,s)}}return s}else if(E(o)&&n.charCodeAt(1)===58)return y(n.charCodeAt(2))?n.slice(0,2)+s:n.slice(0,2);let l=n.indexOf("://");if(l!==-1){for(l+=3;l<r;l++)if(y(n.charCodeAt(l)))return n.slice(0,l+1)}return""}e.getRoot=D;function i(n){if(!_.isWindows||!n||n.length<5)return!1;let s=n.charCodeAt(0);if(s!==92||(s=n.charCodeAt(1),s!==92))return!1;let r=2;const o=r;for(;r<n.length&&(s=n.charCodeAt(r),s!==92);r++);return!(o===r||(s=n.charCodeAt(r+1),isNaN(s)||s===92))}e.isUNC=i;const T=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(n,s=_.isWindows){const r=s?T:C;return!(!n||n.length===0||/^\s+$/.test(n)||(r.lastIndex=0,r.test(n))||s&&m.test(n)||n==="."||n===".."||s&&n[n.length-1]==="."||s&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=f;function a(n,s,r){const o=n===s;return!r||o?o:!n||!s?!1:(0,k.equalsIgnoreCase)(n,s)}e.isEqual=a;function d(n,s,r,o=A.sep){if(n===s)return!0;if(!n||!s||s.length>n.length)return!1;if(r){if(!(0,k.startsWithIgnoreCase)(n,s))return!1;if(s.length===n.length)return!0;let h=s.length;return s.charAt(s.length-1)===o&&h--,n.charAt(h)===o}return s.charAt(s.length-1)!==o&&(s+=o),n.indexOf(s)===0}e.isEqualOrParent=d;function E(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=E;function w(n,s){return _.isWindows&&n.endsWith(":")&&(n+=A.sep),(0,A.isAbsolute)(n)||(n=(0,A.join)(s,n)),n=(0,A.normalize)(n),_.isWindows?(n=(0,k.rtrim)(n,A.sep),n.endsWith(":")&&(n+=A.sep)):(n=(0,k.rtrim)(n,A.sep),n||(n=A.sep)),n}e.sanitizeFilePath=w;function b(n){const s=(0,A.normalize)(n);return _.isWindows?n.length>3?!1:p(s)&&(n.length===2||s.charCodeAt(2)===92):s===A.posix.sep}e.isRootOrDriveLetter=b;function p(n){return _.isWindows?E(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function c(n){return p(n)?n[0]:void 0}e.getDriveLetter=c;function g(n,s,r){return s.length>n.length?-1:n===s?0:(r&&(n=n.toLowerCase(),s=s.toLowerCase()),n.indexOf(s))}e.indexOfPath=g;function t(n){const s=n.split(":");let r,o,l;if(s.forEach(h=>{const S=Number(h);(0,I.isNumber)(S)?o===void 0?o=S:l===void 0&&(l=S):r=r?[r,h].join(":"):h}),!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:o!==void 0?o:void 0,column:l!==void 0?l:o!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(me[23],ge([0,1,12]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const d=Array.isArray(a)?[]:{};return Object.keys(a).forEach(E=>{a[E]&&typeof a[E]=="object"?d[E]=k(a[E]):d[E]=a[E]}),d}e.deepClone=k;function A(a){if(!a||typeof a!="object")return a;const d=[a];for(;d.length>0;){const E=d.shift();Object.freeze(E);for(const w in E)if(I.call(E,w)){const b=E[w];typeof b=="object"&&!Object.isFrozen(b)&&d.push(b)}}return a}e.deepFreeze=A;const I=Object.prototype.hasOwnProperty;function y(a,d){return P(a,d,new Set)}e.cloneAndChange=y;function P(a,d,E){if((0,_.isUndefinedOrNull)(a))return a;const w=d(a);if(typeof w!="undefined")return w;if((0,_.isArray)(a)){const b=[];for(const p of a)b.push(P(p,d,E));return b}if((0,_.isObject)(a)){if(E.has(a))throw new Error("Cannot clone recursive data-structure");E.add(a);const b={};for(let p in a)I.call(a,p)&&(b[p]=P(a[p],d,E));return E.delete(a),b}return a}function D(a,d,E=!0){return(0,_.isObject)(a)?((0,_.isObject)(d)&&Object.keys(d).forEach(w=>{w in a?E&&((0,_.isObject)(a[w])&&(0,_.isObject)(d[w])?D(a[w],d[w],E):a[w]=d[w]):a[w]=d[w]}),a):d}e.mixin=D;function i(a,d){if(a===d)return!0;if(a==null||d===null||d===void 0||typeof a!=typeof d||typeof a!="object"||Array.isArray(a)!==Array.isArray(d))return!1;let E,w;if(Array.isArray(a)){if(a.length!==d.length)return!1;for(E=0;E<a.length;E++)if(!i(a[E],d[E]))return!1}else{const b=[];for(w in a)b.push(w);b.sort();const p=[];for(w in d)p.push(w);if(p.sort(),!i(b,p))return!1;for(E=0;E<b.length;E++)if(!i(a[b[E]],d[b[E]]))return!1}return!0}e.equals=i;function T(a){const d=new Set;return JSON.stringify(a,(E,w)=>{if((0,_.isObject)(w)||Array.isArray(w)){if(d.has(w))return"[Circular]";d.add(w)}return w})}e.safeStringify=T;function C(a,d,E){const w=d(a);return typeof w=="undefined"?E:w}e.getOrDefault=C;function m(a,d){const E=Object.create(null);return!a||!d||Object.keys(d).forEach(b=>{const p=a[b],c=d[b];i(p,c)||(E[b]=c)}),E}e.distinct=m;function f(a,d){const E=d.toLowerCase(),w=Object.keys(a).find(b=>b.toLowerCase()===E);return w?a[w]:a[d]}e.getCaseInsensitive=f}),define(me[95],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var _;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_=e.Constants||(e.Constants={}));function k(I){return I<0?0:I>255?255:I|0}e.toUint8=k;function A(I){return I<0?0:I>4294967295?4294967295:I|0}e.toUint32=A}),define(me[2],ge([0,1,9,8]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,I=/^\//,y=/^\/\//;function P(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!A.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!I.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(s,r){return!s&&!r?"file":s}function i(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==C&&(r=C+r):r=C;break}return r}const T="",C="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(r,o,l,h,S,u=!1){typeof r=="object"?(this.scheme=r.scheme||T,this.authority=r.authority||T,this.path=r.path||T,this.query=r.query||T,this.fragment=r.fragment||T):(this.scheme=D(r,u),this.authority=o||T,this.path=i(this.scheme,l||T),this.query=h||T,this.fragment=S||T,P(this,u))}static isUri(r){return r instanceof f?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return p(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:l,path:h,query:S,fragment:u}=r;return o===void 0?o=this.scheme:o===null&&(o=T),l===void 0?l=this.authority:l===null&&(l=T),h===void 0?h=this.path:h===null&&(h=T),S===void 0?S=this.query:S===null&&(S=T),u===void 0?u=this.fragment:u===null&&(u=T),o===this.scheme&&l===this.authority&&h===this.path&&S===this.query&&u===this.fragment?this:new d(o,l,h,S,u)}static parse(r,o=!1){const l=m.exec(r);return l?new d(l[2]||T,n(l[4]||T),n(l[5]||T),n(l[7]||T),n(l[9]||T),o):new d(T,T,T,T,T)}static file(r){let o=T;if(_.isWindows&&(r=r.replace(/\\/g,C)),r[0]===C&&r[1]===C){const l=r.indexOf(C,2);l===-1?(o=r.substring(2),r=C):(o=r.substring(2,l),r=r.substring(l)||C)}return new d("file",o,r,T,T)}static from(r){return new d(r.scheme,r.authority,r.path,r.query,r.fragment)}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return _.isWindows&&r.scheme==="file"?l=f.file(k.win32.join(p(r,!0),...o)).path:l=k.posix.join(r.path,...o),r.with({path:l})}toString(r=!1){return c(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof f)return r;{const o=new d(r);return o._formatted=r.external,o._fsPath=r._sep===a?r.fsPath:null,o}}else return r}}e.URI=f;const a=_.isWindows?1:void 0;class d extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(r=!1){return r?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=a),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(s,r){let o,l=-1;for(let h=0;h<s.length;h++){const S=s.charCodeAt(h);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||r&&S===47)l!==-1&&(o+=encodeURIComponent(s.substring(l,h)),l=-1),o!==void 0&&(o+=s.charAt(h));else{o===void 0&&(o=s.substr(0,h));const u=E[S];u!==void 0?(l!==-1&&(o+=encodeURIComponent(s.substring(l,h)),l=-1),o+=u):l===-1&&(l=h)}}return l!==-1&&(o+=encodeURIComponent(s.substring(l))),o!==void 0?o:s}function b(s){let r;for(let o=0;o<s.length;o++){const l=s.charCodeAt(o);l===35||l===63?(r===void 0&&(r=s.substr(0,o)),r+=E[l]):r!==void 0&&(r+=s[o])}return r!==void 0?r:s}function p(s,r){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,_.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=p;function c(s,r){const o=r?b:w;let l="",{scheme:h,authority:S,path:u,query:v,fragment:R}=s;if(h&&(l+=h,l+=":"),(S||h==="file")&&(l+=C,l+=C),S){let L=S.indexOf("@");if(L!==-1){const H=S.substr(0,L);S=S.substr(L+1),L=H.indexOf(":"),L===-1?l+=o(H,!1):(l+=o(H.substr(0,L),!1),l+=":",l+=o(H.substr(L+1),!1)),l+="@"}S=S.toLowerCase(),L=S.indexOf(":"),L===-1?l+=o(S,!1):(l+=o(S.substr(0,L),!1),l+=S.substr(L))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const L=u.charCodeAt(1);L>=65&&L<=90&&(u=`/${String.fromCharCode(L+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const L=u.charCodeAt(0);L>=65&&L<=90&&(u=`${String.fromCharCode(L+32)}:${u.substr(2)}`)}l+=o(u,!0)}return v&&(l+="?",l+=o(v,!1)),R&&(l+="#",l+=r?R:w(R,!1)),l}function g(s){try{return decodeURIComponent(s)}catch(r){return s.length>3?s.substr(0,3)+g(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(t)?s.replace(t,r=>g(r)):s}});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!k:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(G):k?k.value:e.get(G)};define(me[24],ge([0,1,2,10]),function(G,e,_,k){"use strict";var A,I,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,n,s){let r=t.get(n);return r===void 0&&(r=s,t.set(n,r)),r}e.getOrSet=P;function D(t){const n=[];return t.forEach((s,r)=>{n.push(`${r} => ${s}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=D;function i(t){const n=[];return t.forEach(s=>{n.push(s)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=i;class T{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),r=this._value.charCodeAt(this._pos);return s-r}value(){return this._value[this._pos]}}e.StringIterator=T;class C{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,k.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class m{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,k.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var f;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(f||(f={}));class a{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,k.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class d{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class E{constructor(n){this._iter=n}static forUris(n=()=>!1){return new E(new a(n))}static forPaths(){return new E(new m)}static forStrings(){return new E(new T)}static forConfigKeys(){return new E(new C)}clear(){this._root=void 0}set(n,s){const r=this._iter.reset(n);let o;for(this._root||(this._root=new d,this._root.segment=r.value()),o=this._root;;){const h=r.cmp(o.segment);if(h>0)o.left||(o.left=new d,o.left.segment=r.value()),o=o.left;else if(h<0)o.right||(o.right=new d,o.right.segment=r.value()),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new d,o.mid.segment=r.value()),o=o.mid;else break}const l=o.value;return o.value=s,o.key=n,l}get(n){var s;return(s=this._getNode(n))===null||s===void 0?void 0:s.value}_getNode(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const o=s.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(n){const s=this._getNode(n);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const r=this._iter.reset(n),o=[];let l=this._root;for(;l;){const h=r.cmp(l.segment);if(h>0)o.push([1,l]),l=l.left;else if(h<0)o.push([-1,l]),l=l.right;else if(r.hasNext())r.next(),o.push([0,l]),l=l.mid;else{for(s?(l.left=void 0,l.mid=void 0,l.right=void 0):l.value=void 0;o.length>0&&l.isEmpty();){let[S,u]=o.pop();switch(S){case 1:u.left=void 0;break;case 0:u.mid=void 0;break;case-1:u.right=void 0;break}l=u}break}}}findSubstr(n){const s=this._iter.reset(n);let r=this._root,o;for(;r;){const l=s.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(s.hasNext())s.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const o=s.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(n){for(const[s,r]of this)n(r,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=E;class w{constructor(n,s){this[A]="ResourceMap",n instanceof w?(this.map=new Map(n.map),this.toKey=s!=null?s:w.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:w.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),s),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[r,o]of this.map)n(o,_.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield _.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[_.URI.parse(n[0]),n[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[_.URI.parse(n[0]),n[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var b;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class p{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,s=0){const r=this._map.get(n);if(!!r)return s!==0&&this.touch(r,s),r.value}set(n,s,r=0){let o=this._map.get(n);if(o)o.value=s,r!==0&&this.touch(o,r);else{switch(o={key:n,value:s,next:void 0,previous:void 0},r){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(n,o),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,s){const r=this._state;let o=this._head;for(;o;){if(s?n.bind(s)(o.value,o.key,this):n(o.value,o.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,s=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const l={value:r.key,done:!1};return r=r.next,l}else return{value:void 0,done:!0}}};return o}values(){const n=this,s=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const l={value:r.value,done:!1};return r=r.next,l}else return{value:void 0,done:!0}}};return o}entries(){const n=this,s=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const l={value:[r.key,r.value],done:!1};return r=r.next,l}else return{value:void 0,done:!0}}};return o}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let s=this._head,r=this.size;for(;s&&r>n;)this._map.delete(s.key),s=s.next,r--;this._head=s,this._size=r,s&&(s.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,r=n.previous;if(!s||!r)throw new Error("Invalid list");s.previous=r,r.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const r=n.next,o=n.previous;n===this._tail?(o.next=void 0,this._tail=o):(r.previous=o,o.next=r),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const r=n.next,o=n.previous;n===this._head?(r.previous=void 0,this._head=r):(r.previous=o,o.next=r),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,r)=>{n.push([r,s])}),n}fromJSON(n){this.clear();for(const[s,r]of n)this.set(s,r)}}e.LinkedMap=p;class c extends p{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class g{constructor(n){y.set(this,void 0),tt(this,y,n,"f")}get size(){return Ue(this,y,"f").size}forEach(n,s){Ue(this,y,"f").forEach(n,s)}get(n){return Ue(this,y,"f").get(n)}has(n){return Ue(this,y,"f").has(n)}entries(){return Ue(this,y,"f").entries()}keys(){return Ue(this,y,"f").keys()}values(){return Ue(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Ue(this,y,"f").entries()}}e.ReadonlyMapView=g}),define(me[96],ge([0,1,24,10]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function A(...be){return function(Pe,Re){for(let We=0,Ee=be.length;We<Ee;We++){const Ke=be[We](Pe,Re);if(Ke)return Ke}return null}}e.or=A,e.matchesStrictPrefix=I.bind(void 0,!1),e.matchesPrefix=I.bind(void 0,!0);function I(be,Pe,Re){if(!Re||Re.length<Pe.length)return null;let We;return be?We=k.startsWithIgnoreCase(Re,Pe):We=Re.indexOf(Pe)===0,We?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function y(be,Pe){const Re=Pe.toLowerCase().indexOf(be.toLowerCase());return Re===-1?null:[{start:Re,end:Re+be.length}]}e.matchesContiguousSubString=y;function P(be,Pe){return D(be.toLowerCase(),Pe.toLowerCase(),0,0)}e.matchesSubString=P;function D(be,Pe,Re,We){if(Re===be.length)return[];if(We===Pe.length)return null;if(be[Re]===Pe[We]){let Ee=null;return(Ee=D(be,Pe,Re+1,We+1))?w({start:We,end:We+1},Ee):null}return D(be,Pe,Re,We+1)}function i(be){return 97<=be&&be<=122}function T(be){return 65<=be&&be<=90}e.isUpper=T;function C(be){return 48<=be&&be<=57}function m(be){return be===32||be===9||be===10||be===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(be=>f.add(be.charCodeAt(0)));function a(be){return m(be)||f.has(be)}function d(be,Pe){return be===Pe||a(be)&&a(Pe)}function E(be){return i(be)||T(be)||C(be)}function w(be,Pe){return Pe.length===0?Pe=[be]:be.end===Pe[0].start?Pe[0].start=be.start:Pe.unshift(be),Pe}function b(be,Pe){for(let Re=Pe;Re<be.length;Re++){const We=be.charCodeAt(Re);if(T(We)||C(We)||Re>0&&!E(be.charCodeAt(Re-1)))return Re}return be.length}function p(be,Pe,Re,We){if(Re===be.length)return[];if(We===Pe.length)return null;if(be[Re]!==Pe[We].toLowerCase())return null;{let Ee=null,Ke=We+1;for(Ee=p(be,Pe,Re+1,We+1);!Ee&&(Ke=b(Pe,Ke))<Pe.length;)Ee=p(be,Pe,Re+1,Ke),Ke++;return Ee===null?null:w({start:We,end:We+1},Ee)}}function c(be){let Pe=0,Re=0,We=0,Ee=0,Ke=0;for(let ze=0;ze<be.length;ze++)Ke=be.charCodeAt(ze),T(Ke)&&Pe++,i(Ke)&&Re++,E(Ke)&&We++,C(Ke)&&Ee++;const X=Pe/be.length,re=Re/be.length,_e=We/be.length,xe=Ee/be.length;return{upperPercent:X,lowerPercent:re,alphaPercent:_e,numericPercent:xe}}function g(be){const{upperPercent:Pe,lowerPercent:Re}=be;return Re===0&&Pe>.6}function t(be){const{upperPercent:Pe,lowerPercent:Re,alphaPercent:We,numericPercent:Ee}=be;return Re>.2&&Pe<.8&&We>.6&&Ee<.2}function n(be){let Pe=0,Re=0,We=0,Ee=0;for(let Ke=0;Ke<be.length;Ke++)We=be.charCodeAt(Ke),T(We)&&Pe++,i(We)&&Re++,m(We)&&Ee++;return(Pe===0||Re===0)&&Ee===0?be.length<=30:Pe<=5}function s(be,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!n(be)||Pe.length>60)return null;const Re=c(Pe);if(!t(Re)){if(!g(Re))return null;Pe=Pe.toLowerCase()}let We=null,Ee=0;for(be=be.toLowerCase();Ee<Pe.length&&(We=p(be,Pe,0,Ee))===null;)Ee=b(Pe,Ee+1);return We}e.matchesCamelCase=s;function r(be,Pe,Re=!1){if(!Pe||Pe.length===0)return null;let We=null,Ee=0;for(be=be.toLowerCase(),Pe=Pe.toLowerCase();Ee<Pe.length&&(We=o(be,Pe,0,Ee,Re))===null;)Ee=l(Pe,Ee+1);return We}e.matchesWords=r;function o(be,Pe,Re,We,Ee){if(Re===be.length)return[];if(We===Pe.length)return null;if(d(be.charCodeAt(Re),Pe.charCodeAt(We))){let Ke=null,X=We+1;if(Ke=o(be,Pe,Re+1,We+1,Ee),!Ee)for(;!Ke&&(X=l(Pe,X))<Pe.length;)Ke=o(be,Pe,Re+1,X,Ee),X++;return Ke===null?null:w({start:We,end:We+1},Ke)}else return null}function l(be,Pe){for(let Re=Pe;Re<be.length;Re++)if(a(be.charCodeAt(Re))||Re>0&&a(be.charCodeAt(Re-1)))return Re;return be.length}const h=A(e.matchesPrefix,s,y),S=A(e.matchesPrefix,s,P),u=new _.LRUCache(1e4);function v(be,Pe,Re=!1){if(typeof be!="string"||typeof Pe!="string")return null;let We=u.get(be);We||(We=new RegExp(k.convertSimple2RegExpPattern(be),"i"),u.set(be,We));const Ee=We.exec(Pe);return Ee?[{start:Ee.index,end:Ee.index+Ee[0].length}]:Re?S(be,Pe):h(be,Pe)}e.matchesFuzzy=v;function R(be,Pe){const Re=V(be,be.toLowerCase(),0,Pe,Pe.toLowerCase(),0,!0);return Re?H(Re):null}e.matchesFuzzy2=R;function L(be,Pe,Re,We,Ee,Ke){const X=Math.min(13,be.length);for(;Re<X;Re++){const re=V(be,Pe,Re,We,Ee,Ke,!1);if(re)return re}return[0,Ke]}e.anyScore=L;function H(be){if(typeof be=="undefined")return[];const Pe=[],Re=be[1];for(let We=be.length-1;We>1;We--){const Ee=be[We]+Re,Ke=Pe[Pe.length-1];Ke&&Ke.end===Ee?Ke.end=Ee+1:Pe.push({start:Ee,end:Ee+1})}return Pe}e.createMatches=H;const ie=128;function j(){const be=[],Pe=[];for(let Re=0;Re<=ie;Re++)Pe[Re]=0;for(let Re=0;Re<=ie;Re++)be.push(Pe.slice(0));return be}function B(be){const Pe=[];for(let Re=0;Re<=be;Re++)Pe[Re]=0;return Pe}const $=B(2*ie),N=B(2*ie),M=j(),F=j(),U=j(),O=!1;function W(be,Pe,Re,We,Ee){function Ke(re,_e,xe=" "){for(;re.length<_e;)re=xe+re;return re}let X=` |   |${We.split("").map(re=>Ke(re,3)).join("|")}
`;for(let re=0;re<=Re;re++)re===0?X+=" |":X+=`${Pe[re-1]}|`,X+=be[re].slice(0,Ee+1).map(_e=>Ke(_e.toString(),3)).join("|")+`
`;return X}function q(be,Pe,Re,We){be=be.substr(Pe),Re=Re.substr(We),console.log(W(F,be,be.length,Re,Re.length)),console.log(W(U,be,be.length,Re,Re.length)),console.log(W(M,be,be.length,Re,Re.length))}function Q(be,Pe){if(Pe<0||Pe>=be.length)return!1;const Re=be.codePointAt(Pe);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(Re)}}function he(be,Pe){if(Pe<0||Pe>=be.length)return!1;switch(be.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function ve(be,Pe,Re){return Pe[be]!==Re[be]}function Ie(be,Pe,Re,We,Ee,Ke,X=!1){for(;Pe<Re&&Ee<Ke;)be[Pe]===We[Ee]&&(X&&($[Pe]=Ee),Pe+=1),Ee+=1;return Pe===Re}e.isPatternInWord=Ie;var ke;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(ke||(ke={}));var Le;(function(be){be.Default=[-100,0];function Pe(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}be.isDefault=Pe})(Le=e.FuzzyScore||(e.FuzzyScore={}));function V(be,Pe,Re,We,Ee,Ke,X){const re=be.length>ie?ie:be.length,_e=We.length>ie?ie:We.length;if(!(Re>=re||Ke>=_e||re-Re>_e-Ke)&&!!Ie(Pe,Re,re,Ee,Ke,_e,!0)){J(re,_e,Re,Ke,Pe,Ee);let xe=1,ze=1,$e=Re,Ye=Ke;const K=[!1];for(xe=1,$e=Re;$e<re;xe++,$e++){const ce=$[$e],pe=N[$e],Se=$e+1<re?N[$e+1]:_e;for(ze=ce-Ke+1,Ye=ce;Ye<Se;ze++,Ye++){let qe=Number.MIN_SAFE_INTEGER,Me=!1;Ye<=pe&&(qe=ee(be,Pe,$e,Re,We,Ee,Ye,_e,Ke,M[xe-1][ze-1]===0,K));let He=0;qe!==Number.MAX_SAFE_INTEGER&&(Me=!0,He=qe+F[xe-1][ze-1]);const Qe=Ye>ce,it=Qe?F[xe][ze-1]+(M[xe][ze-1]>0?-5:0):0,at=Ye>ce+1&&M[xe][ze-1]>0,Ze=at?F[xe][ze-2]+(M[xe][ze-2]>0?-5:0):0;if(at&&(!Qe||Ze>=it)&&(!Me||Ze>=He))F[xe][ze]=Ze,U[xe][ze]=3,M[xe][ze]=0;else if(Qe&&(!Me||it>=He))F[xe][ze]=it,U[xe][ze]=2,M[xe][ze]=0;else if(Me)F[xe][ze]=He,U[xe][ze]=1,M[xe][ze]=M[xe-1][ze-1]+1;else throw new Error("not possible")}}if(O&&q(be,Re,We,Ke),!(!K[0]&&!X)){xe--,ze--;const oe=[F[xe][ze],Ke];let fe=0,Z=0;for(;xe>=1;){let ce=ze;do{const pe=U[xe][ce];if(pe===3)ce=ce-2;else if(pe===2)ce=ce-1;else break}while(ce>=1);fe>1&&Pe[Re+xe-1]===Ee[Ke+ze-1]&&!ve(ce+Ke-1,We,Ee)&&fe+1>M[xe][ce]&&(ce=ze),ce===ze?fe++:fe=1,Z||(Z=ce),xe--,ze=ce-1,oe.push(ze)}_e===re&&(oe[0]+=2);const ne=Z-re;return oe[0]-=ne,oe}}}e.fuzzyScore=V;function J(be,Pe,Re,We,Ee,Ke){let X=be-1,re=Pe-1;for(;X>=Re&&re>=We;)Ee[X]===Ke[re]&&(N[X]=re,X--),re--}function ee(be,Pe,Re,We,Ee,Ke,X,re,_e,xe,ze){if(Pe[Re]!==Ke[X])return Number.MIN_SAFE_INTEGER;let $e=1,Ye=!1;return X===Re-We?$e=be[Re]===Ee[X]?7:5:ve(X,Ee,Ke)&&(X===0||!ve(X-1,Ee,Ke))?($e=be[Re]===Ee[X]?7:5,Ye=!0):Q(Ke,X)&&(X===0||!Q(Ke,X-1))?$e=5:(Q(Ke,X-1)||he(Ke,X-1))&&($e=5,Ye=!0),$e>1&&Re===We&&(ze[0]=!0),Ye||(Ye=ve(X,Ee,Ke)||Q(Ke,X-1)||he(Ke,X-1)),Re===We?X>_e&&($e-=Ye?3:5):xe?$e+=Ye?2:0:$e+=Ye?0:1,X+1===re&&($e-=Ye?3:5),$e}function ae(be,Pe,Re,We,Ee,Ke,X){return Ce(be,Pe,Re,We,Ee,Ke,!0,X)}e.fuzzyScoreGracefulAggressive=ae;function we(be,Pe,Re,We,Ee,Ke,X){return Ce(be,Pe,Re,We,Ee,Ke,!1,X)}e.fuzzyScoreGraceful=we;function Ce(be,Pe,Re,We,Ee,Ke,X,re){let _e=V(be,Pe,Re,We,Ee,Ke,re);if(_e&&!X)return _e;if(be.length>=3){const xe=Math.min(7,be.length-1);for(let ze=Re+1;ze<xe;ze++){const $e=Oe(be,ze);if($e){const Ye=V($e,$e.toLowerCase(),Re,We,Ee,Ke,re);Ye&&(Ye[0]-=3,(!_e||Ye[0]>_e[0])&&(_e=Ye))}}}return _e}function Oe(be,Pe){if(!(Pe+1>=be.length)){const Re=be[Pe],We=be[Pe+1];if(Re!==We)return be.slice(0,Pe)+We+Re+be.slice(Pe+2)}}}),define(me[136],ge([0,1,43,96,10]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const I=new RegExp(`\\$\\(${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${I.source}`,"g");function P(d){return d.replace(y,(E,w)=>w?E:`\\${E}`)}e.escapeIcons=P;const D=new RegExp(`\\\\${I.source}`,"g");function i(d){return d.replace(D,E=>`\\${E}`)}e.markdownEscapeEscapedIcons=i;const T=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function C(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(T,(E,w,b,p)=>b?E:w||p||"")}e.stripIcons=C;function m(d){const E=d.indexOf(e.iconStartMarker);return E===-1?{text:d}:f(d,E)}e.parseLabelWithIcons=m;function f(d,E){const w=[];let b="";function p(l){if(l){b+=l;for(const h of l)w.push(t)}}let c=-1,g="",t=0,n,s,r=E;const o=d.length;for(p(d.substr(0,E));r<o;)n=d[r],s=d[r+1],n===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(c=r,p(g),g=e.iconStartMarker,r++):n===")"&&c!==-1?(t+=r-c+1,c=-1,g=""):c!==-1?/^[a-z0-9\-]$/i.test(n)?g+=n:(p(g),c=-1,g=""):p(n),r++;return p(g),{text:b,iconOffsets:w}}function a(d,E,w=!1){const{text:b,iconOffsets:p}=E;if(!p||p.length===0)return(0,k.matchesFuzzy)(d,b,w);const c=(0,A.ltrim)(b," "),g=b.length-c.length,t=(0,k.matchesFuzzy)(d,c,w);if(t)for(const n of t){const s=p[n.start+g]+g;n.start+=s,n.end+=s}return t}e.matchesFuzzyIconAware=a}),define(me[97],ge([0,1,15,136,18]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(d="",E=!1){var w,b;if(this.value=d,typeof this.value!="string")throw(0,A.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1):(this.isTrusted=(w=E.isTrusted)!==null&&w!==void 0?w:void 0,this.supportThemeIcons=(b=E.supportThemeIcons)!==null&&b!==void 0?b:!1)}appendText(d,E=0){return this.value+=C(this.supportThemeIcons?(0,k.escapeIcons)(d):d).replace(/([ \t]+)/g,(w,b)=>"&nbsp;".repeat(b.length)).replace(/^>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,E){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}}e.MarkdownString=y;function P(a){return D(a)?!a.value:Array.isArray(a)?a.every(P):!0}e.isEmptyMarkdownString=P;function D(a){return a instanceof y?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function i(a,d){return!a&&!d?!0:!a||!d?!1:Array.isArray(a)&&Array.isArray(d)?(0,_.equals)(a,d,T):D(a)&&D(d)?T(a,d):!1}e.markedStringsEquals=i;function T(a,d){return a===d?!0:!a||!d?!1:a.value===d.value&&a.isTrusted===d.isTrusted&&a.supportThemeIcons===d.supportThemeIcons}function C(a){return a.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function m(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=m;function f(a){const d=[],E=a.split("|").map(b=>b.trim());a=E[0];const w=E[1];if(w){const b=/height=(\d+)/.exec(w),p=/width=(\d+)/.exec(w),c=b?b[1]:"",g=p?p[1]:"",t=isFinite(parseInt(g)),n=isFinite(parseInt(c));t&&d.push(`width="${g}"`),n&&d.push(`height="${c}"`)}return{href:a,dimensions:d}}e.parseHrefAndDimensions=f}),define(me[58],ge([0,1,22,10,2]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function I(i){return JSON.stringify(i,P)}e.stringify=I;function y(i){let T=JSON.parse(i);return T=D(T),T}e.parse=y;function P(i,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,k.regExpFlags)(T)}:T}function D(i,T=0){if(!i||T>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return A.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof _.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let C=0;C<i.length;++C)i[C]=D(i[C],T+1);else for(const C in i)Object.hasOwnProperty.call(i,C)&&(i[C]=D(i[C],T+1))}return i}e.revive=D}),define(me[11],ge([0,1,2,9]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file"})(A=e.Schemas||(e.Schemas={}));class I{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,i,T){this._hosts[D]=i,this._ports[D]=T}setConnectionToken(D,i){this._connectionTokens[D]=i}rewrite(D){if(this._delegate)return this._delegate(D);const i=D.authority;let T=this._hosts[i];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const C=this._ports[i],m=this._connectionTokens[i];let f=`path=${encodeURIComponent(D.path)}`;return typeof m=="string"&&(f+=`&tkn=${encodeURIComponent(m)}`),_.URI.from({scheme:k.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${T}:${C}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new I;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,i,T){const C=this.toUri(D,i);return C.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(C):k.isNative&&(T||k.isPreferringBrowserCodeLoad)&&C.scheme===A.file?C.with({scheme:A.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(D,i){const T=this.toUri(D,i);return T.scheme===A.vscodeFileResource?T.with({scheme:A.file,authority:T.authority!==this.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(D,i){return _.URI.isUri(D)?D:_.URI.parse(i.toUrl(D))}}e.FileAccess=new y}),define(me[75],ge([0,1,24]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const k=new _.LRUCache(1e4);function A(i){return D(i,"NFC",k)}e.normalizeNFC=A;const I=new _.LRUCache(1e4);function y(i){return D(i,"NFD",I)}e.normalizeNFD=y;const P=/[^\u0000-\u0080]/;function D(i,T,C){if(!e.canNormalize||!i)return i;const m=C.get(i);if(m)return m;let f;return P.test(i)?f=i.normalize(T):f=i,C.set(i,f),f}e.removeAccents=function(){if(e.canNormalize){const i=/[\u0300-\u036f]/g;return function(T){return y(T).replace(i,"")}}else return function(i){return i}}()}),define(me[25],ge([0,1,30,8,2,10,11,9]),function(G,e,_,k,A,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(f){return(0,A.uriToFsPath)(f,!0)}e.originalFSPath=D;class i{constructor(a){this._ignorePathCasing=a}compare(a,d,E=!1){return a===d?0:(0,I.compare)(this.getComparisonKey(a,E),this.getComparisonKey(d,E))}isEqual(a,d,E=!1){return a===d?!0:!a||!d?!1:this.getComparisonKey(a,E)===this.getComparisonKey(d,E)}getComparisonKey(a,d=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,d,E=!1){if(a.scheme===d.scheme){if(a.scheme===y.Schemas.file)return _.isEqualOrParent(D(a),D(d),this._ignorePathCasing(a))&&a.query===d.query&&(E||a.fragment===d.fragment);if((0,e.isEqualAuthority)(a.authority,d.authority))return _.isEqualOrParent(a.path,d.path,this._ignorePathCasing(a),"/")&&a.query===d.query&&(E||a.fragment===d.fragment)}return!1}joinPath(a,...d){return A.URI.joinPath(a,...d)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return k.posix.basename(a.path)}extname(a){return k.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let d;return a.scheme===y.Schemas.file?d=A.URI.file(k.dirname(D(a))).path:(d=k.posix.dirname(a.path),a.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),d="/")),a.with({path:d})}normalizePath(a){if(!a.path.length)return a;let d;return a.scheme===y.Schemas.file?d=A.URI.file(k.normalize(D(a))).path:d=k.posix.normalize(a.path),a.with({path:d})}relativePath(a,d){if(!(a.scheme!==d.scheme||!(0,e.isEqualAuthority)(a.authority,d.authority))){if(a.scheme===y.Schemas.file){const b=k.relative(D(a),D(d));return P.isWindows?_.toSlashes(b):b}let E=a.path||"/",w=d.path||"/";if(this._ignorePathCasing(a)){let b=0;for(const p=Math.min(E.length,w.length);b<p&&!(E.charCodeAt(b)!==w.charCodeAt(b)&&E.charAt(b).toLowerCase()!==w.charAt(b).toLowerCase());b++);E=w.substr(0,b)+E.substr(b)}return k.posix.relative(E,w)}}resolvePath(a,d){if(a.scheme===y.Schemas.file){const E=A.URI.file(k.resolve(D(a),d));return a.with({authority:E.authority,path:E.path})}return d.indexOf("/")===-1&&(d=_.toSlashes(d),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d)),a.with({path:k.posix.resolve(a.path,d)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,d){return a===d||(0,I.equalsIgnoreCase)(a,d)}hasTrailingPathSeparator(a,d=k.sep){if(a.scheme===y.Schemas.file){const E=D(a);return E.length>_.getRoot(E).length&&E[E.length-1]===d}else{const E=a.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,d=k.sep){return(0,e.hasTrailingPathSeparator)(a,d)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,d=k.sep){let E=!1;if(a.scheme===y.Schemas.file){const w=D(a);E=w!==void 0&&w.length===_.getRoot(w).length&&w[w.length-1]===d}else{d="/";const w=a.path;E=w.length===1&&w.charCodeAt(w.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(a,d)?a.with({path:a.path+"/"}):a}}e.ExtUri=i,e.extUri=new i(()=>!1),e.extUriBiasedIgnorePathCase=new i(f=>f.scheme===y.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new i(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(f,a){const d=[];for(let E=0;E<f.length;E++){const w=a(f[E]);f.some((b,p)=>p===E?!1:(0,e.isEqualOrParent)(w,a(b)))||d.push(f[E])}return d}e.distinctParents=T;var C;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function a(d){const E=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(p=>{const[c,g]=p.split(":");c&&g&&E.set(c,g)});const b=d.path.substring(0,d.path.indexOf(";"));return b&&E.set(f.META_DATA_MIME,b),E}f.parseMetaData=a})(C=e.DataUri||(e.DataUri={}));function m(f,a,d){if(a){let E=f.path;return E&&E[0]!==k.posix.sep&&(E=k.posix.sep+E),f.with({scheme:d,authority:a,path:E})}return f.with({scheme:d})}e.toLocalResource=m}),define(me[19],ge([0,1,21,18,3,6,56,25]),function(G,e,_,k,A,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(F){return!!F&&typeof F.then=="function"}e.isThenable=D;function i(F){const U=new _.CancellationTokenSource,O=F(U.token),W=new Promise((q,Q)=>{U.token.onCancellationRequested(()=>{Q((0,k.canceled)())}),Promise.resolve(O).then(he=>{U.dispose(),q(he)},he=>{U.dispose(),Q(he)})});return new class{cancel(){U.cancel()}then(q,Q){return W.then(q,Q)}catch(q){return this.then(void 0,q)}finally(q){return W.finally(q)}}}e.createCancelablePromise=i;function T(F,U,O){return Promise.race([F,new Promise(W=>U.onCancellationRequested(()=>W(O)))])}e.raceCancellation=T;async function C(F){let U=-1;const O=F.map((q,Q)=>q.then(he=>(U=Q,he))),W=await Promise.race(O);return F.forEach((q,Q)=>{Q!==U&&q.cancel()}),W}e.raceCancellablePromises=C;function m(F,U,O){let W;const q=setTimeout(()=>{W==null||W(void 0),O==null||O()},U);return Promise.race([F.finally(()=>clearTimeout(q)),new Promise(Q=>W=Q)])}e.raceTimeout=m;function f(F){return new Promise((U,O)=>{const W=F();D(W)?W.then(U,O):U(W)})}e.asPromise=f;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(O,O).then(W)})}return new Promise((O,W)=>{this.queuedPromise.then(O,W)})}return this.activePromise=U(),new Promise((O,W)=>{this.activePromise.then(q=>{this.activePromise=null,O(q)},q=>{this.activePromise=null,W(q)})})}}e.Throttler=a;class d{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=d;class E{constructor(){this.promiseMap=new Map}queue(U,O){var W;const Q=((W=this.promiseMap.get(U))!==null&&W!==void 0?W:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(U)===Q&&this.promiseMap.delete(U)});return this.promiseMap.set(U,Q),Q}}e.SequencerByKey=E;class w{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,O=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((W,q)=>{this.doResolve=W,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const W=this.task;return this.task=null,W()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,k.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=w;class b{constructor(U){this.delayer=new w(U),this.throttler=new a}trigger(U,O){return this.delayer.trigger(()=>this.throttler.queue(U),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class p{constructor(){this._isOpen=!1,this._promise=new Promise((U,O)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=p;class c extends p{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function g(F,U){return U?new Promise((O,W)=>{const q=setTimeout(O,F);U.onCancellationRequested(()=>{clearTimeout(q),W((0,k.canceled)())})}):i(O=>g(F,O))}e.timeout=g;function t(F,U=0){const O=setTimeout(F,U);return(0,I.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function n(F){return F.then(void 0,U=>{})}e.ignoreErrors=n;function s(F){const U=[];let O=0;const W=F.length;function q(){return O<W?F[O++]():null}function Q(he){he!=null&&U.push(he);const ve=q();return ve?ve.then(Q):Promise.resolve(U)}return Promise.resolve(null).then(Q)}e.sequence=s;function r(F,U=W=>!!W,O=null){let W=0;const q=F.length,Q=()=>{if(W>=q)return Promise.resolve(O);const he=F[W++];return Promise.resolve(he()).then(Ie=>U(Ie)?Promise.resolve(Ie):Q())};return Q()}e.first=r;function o(F,U=W=>!!W,O=null){if(F.length===0)return Promise.resolve(O);let W=F.length;const q=()=>{var Q,he;W=-1;for(const ve of F)(he=(Q=ve).cancel)===null||he===void 0||he.call(Q)};return new Promise((Q,he)=>{for(const ve of F)ve.then(Ie=>{--W>=0&&U(Ie)?(q(),Q(Ie)):W===0&&Q(O)}).catch(Ie=>{--W>=0&&(q(),he(Ie))})})}e.firstParallel=o;class l{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((O,W)=>{this.outstandingPromises.push({factory:U,c:O,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const O=U.factory();O.then(U.c,U.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=l;class h extends l{constructor(){super(1)}}e.Queue=h;class S{constructor(){this.queues=new Map}queueFor(U,O=P.extUri){const W=O.getComparisonKey(U);let q=this.queues.get(W);return q||(q=new h,A.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete(W)}),this.queues.set(W,q)),q}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=S;class u{constructor(U,O){this._token=-1,typeof U=="function"&&typeof O=="number"&&this.setIfNotSet(U,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},O)}setIfNotSet(U,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},O))}}e.TimeoutTimer=u;class v{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,O){this.cancel(),this._token=setInterval(()=>{U()},O)}}e.IntervalTimer=v;class R{constructor(U,O){this.timeoutToken=-1,this.runner=U,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class L extends R{constructor(U,O){super(U,O);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const F=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=U=>{const O=setTimeout(()=>U(F));let W=!1;return{dispose(){W||(W=!0,clearTimeout(O))}}}}else e.runWhenIdle=(F,U)=>{const O=requestIdleCallback(F,typeof U=="number"?{timeout:U}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(O))}}}}();class H{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=H;async function ie(F,U,O){let W;for(let q=0;q<O;q++)try{return await F()}catch(Q){W=Q,await g(U)}throw W}e.retry=ie;class j{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var U;(U=this._pending)===null||U===void 0||U.cancel()}setPending(U,O,W){return this._pending={taskId:U,cancel:()=>W==null?void 0:W(),promise:O},O.then(()=>this.donePending(U),()=>this.donePending(U)),O}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let O,W;const q=new Promise((Q,he)=>{O=Q,W=he});this._next={run:U,promise:q,promiseResolve:O,promiseReject:W}}return this._next.promise}}e.TaskSequentializer=j;class B{constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,O)=>{this.completeCallback=U,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(O=>{this.completeCallback(U),this.resolved=!0,O()})}error(U){return new Promise(O=>{this.errorCallback(U),this.rejected=!0,O()})}cancel(){new Promise(U=>{this.errorCallback((0,k.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=$;class N extends A.Emitter{async fireAsync(U,O,W){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,U]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[q,Q]=this._asyncDeliveryQueue.shift(),he=[],ve=Object.assign(Object.assign({},Q),{waitUntil:Ie=>{if(Object.isFrozen(he))throw new Error("waitUntil can NOT be called asynchronous");W&&(Ie=W(Ie,typeof q=="function"?q:q[0])),he.push(Ie)}});try{typeof q=="function"?q.call(void 0,ve):q[0].call(q[1],ve)}catch(Ie){(0,k.onUnexpectedError)(Ie);continue}Object.freeze(he),await M.settled(he).catch(Ie=>(0,k.onUnexpectedError)(Ie))}}}}e.AsyncEmitter=N;var M;(function(F){async function U(Q){return typeof Promise.allSettled=="function"?O(Q):W(Q)}F.allSettled=U;async function O(Q){return Promise.allSettled(Q)}async function W(Q){return Promise.all(Q.map(he=>he.then(ve=>({status:"fulfilled",value:ve}),ve=>({status:"rejected",reason:ve}))))}async function q(Q){let he;const ve=await Promise.all(Q.map(Ie=>Ie.then(ke=>ke,ke=>{he||(he=ke)})));if(typeof he!="undefined")throw he;return ve}F.settled=q})(M=e.Promises||(e.Promises={}))}),define(me[98],ge([0,1,8,19]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const A=new k.IdleValue(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),I=new k.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new k.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(c,g,t=!1){const n=c||"",s=g||"",r=A.value.collator.compare(n,s);return A.value.collatorIsNumeric&&r===0&&n!==s?n<s?-1:1:r}e.compareFileNames=P;function D(c,g){const t=I.value.collator;return c=c||"",g=g||"",d(t,c,g)}e.compareFileNamesDefault=D;function i(c,g,t=!1){t||(c=c&&c.toLowerCase(),g=g&&g.toLowerCase());const[n,s]=f(c),[r,o]=f(g);return n!==r?n<r?-1:1:s===o?0:s<o?-1:1}e.noIntlCompareFileNames=i;function T(c,g){const[t,n]=f(c),[s,r]=f(g);let o=A.value.collator.compare(n,r);if(o===0){if(A.value.collatorIsNumeric&&n!==r)return n<r?-1:1;if(o=A.value.collator.compare(t,s),A.value.collatorIsNumeric&&o===0&&t!==s)return t<s?-1:1}return o}e.compareFileExtensions=T;function C(c,g){c=c||"",g=g||"";const t=a(c),n=a(g),s=I.value.collator,r=y.value.collator;let o;return o=d(r,t,n),o!==0?o:d(s,c,g)}e.compareFileExtensionsDefault=C;const m=/^(.*?)(\.([^.]*))?$/;function f(c,g=!1){const t=c?m.exec(c):[];let n=[t&&t[1]||"",t&&t[3]||""];return g&&(!n[0]&&n[1]||n[0]&&n[0].charAt(0)===".")&&(n=[n[0]+"."+n[1],""]),n}function a(c){const g=c?m.exec(c):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function d(c,g,t){let n=c.compare(g,t);return n!==0?n:g.length!==t.length?g.length<t.length?-1:1:0}function E(c,g,t=!1){return t||(c=c&&c.toLowerCase(),g=g&&g.toLowerCase()),c===g?0:c<g?-1:1}function w(c,g,t=!1){const n=c.split(_.sep),s=g.split(_.sep),r=n.length-1,o=s.length-1;let l,h;for(let S=0;;S++){if(l=r===S,h=o===S,l&&h)return P(n[S],s[S],t);if(l)return-1;if(h)return 1;const u=E(n[S],s[S],t);if(u!==0)return u}}e.comparePaths=w;function b(c,g,t){const n=c.toLowerCase(),s=g.toLowerCase(),r=p(c,g,t);if(r)return r;const o=n.endsWith(t),l=s.endsWith(t);if(o!==l)return o?-1:1;const h=P(n,s);return h!==0?h:n.localeCompare(s)}e.compareAnything=b;function p(c,g,t){const n=c.toLowerCase(),s=g.toLowerCase(),r=n.startsWith(t),o=s.startsWith(t);if(r!==o)return r?-1:1;if(r&&o){if(n.length<s.length)return-1;if(n.length>s.length)return 1}return 0}e.compareByPrefix=p}),define(me[99],ge([0,1,98,96,8,9,10]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const P=0,D=[P,[]];function i(B,$,N,M){if(!B||!$)return D;const F=B.length,U=$.length;if(F<U)return D;const O=B.toLowerCase();return!M&&!O.includes(N)?D:T($,N,U,B,O,F)}e.scoreFuzzy=i;function T(B,$,N,M,F,U){const O=[],W=[];for(let ve=0;ve<N;ve++){const Ie=ve*U,ke=Ie-U,Le=ve>0,V=B[ve],J=$[ve];for(let ee=0;ee<U;ee++){const ae=ee>0,we=Ie+ee,Ce=we-1,Oe=ke+ee-1,be=ae?O[Ce]:0,Pe=Le&&ae?O[Oe]:0,Re=Le&&ae?W[Oe]:0;let We;!Pe&&Le?We=0:We=C(V,J,M,F,ee,Re),We&&Pe+We>=be?(W[we]=Re+1,O[we]=Pe+We):(W[we]=P,O[we]=be)}}const q=[];let Q=N-1,he=U-1;for(;Q>=0&&he>=0;){const ve=Q*U+he;W[ve]===P||(q.push(he),Q--),he--}return[O[N*U-1],q.reverse()]}function C(B,$,N,M,F,U){let O=0;if(!m($,M[F]))return O;if(O+=1,U>0&&(O+=U*5),B===N[F]&&(O+=1),F===0)O+=8;else{const W=f(N.charCodeAt(F-1));W?O+=W:(0,k.isUpper)(N.charCodeAt(F))&&(O+=2)}return O}function m(B,$){return B===$?!0:B==="/"||B==="\\"?$==="/"||$==="\\":!1}function f(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function d(B,$,N=0,M=0){const F=$;return F.values&&F.values.length>1?E(B,F.values,N,M):w(B,$,N,M)}e.scoreFuzzy2=d;function E(B,$,N,M){let F=0;const U=[];for(const O of $){const[W,q]=w(B,O,N,M);if(typeof W!="number")return a;F+=W,U.push(...q)}return[F,l(U)]}function w(B,$,N,M){const F=(0,k.fuzzyScore)($.original,$.originalLowercase,N,B,B.toLowerCase(),M,!0);return F?[F[0],(0,k.createMatches)(F)]:a}const b=Object.freeze({score:0}),p=1<<18,c=1<<17,g=1<<16;function t(B,$,N,M,F){if(!B||!$.normalized)return b;const U=M.getItemLabel(B);if(!U)return b;const O=M.getItemDescription(B);let W;O?W=`${U}${O}${$.normalized}${Array.isArray($.values)?$.values.length:""}${N}`:W=`${U}${$.normalized}${Array.isArray($.values)?$.values.length:""}${N}`;const q=F[W];if(q)return q;const Q=n(U,O,M.getItemPath(B),$,N);return F[W]=Q,Q}e.scoreItemFuzzy=t;function n(B,$,N,M,F){const U=!N||!M.containsPathSeparator;return N&&(I.isLinux?M.pathNormalized===N:(0,y.equalsIgnoreCase)(M.pathNormalized,N))?{score:p,labelMatch:[{start:0,end:B.length}],descriptionMatch:$?[{start:0,end:$.length}]:void 0}:M.values&&M.values.length>1?s(B,$,N,M.values,U,F):r(B,$,N,M,U,F)}function s(B,$,N,M,F,U){let O=0;const W=[],q=[];for(const Q of M){const{score:he,labelMatch:ve,descriptionMatch:Ie}=r(B,$,N,Q,F,U);if(he===P)return b;O+=he,ve&&W.push(...ve),Ie&&q.push(...Ie)}return{score:O,labelMatch:l(W),descriptionMatch:l(q)}}function r(B,$,N,M,F,U){if(F||!$){const[O,W]=i(B,M.normalized,M.normalizedLowercase,U);if(O){const q=(0,k.matchesPrefix)(M.normalized,B);let Q;return q?(Q=c,Q+=Math.round(M.normalized.length/B.length*100)):Q=g,{score:Q+O,labelMatch:q||o(W)}}}if($){let O=$;N&&(O=`${$}${A.sep}`);const W=O.length,q=`${O}${B}`,[Q,he]=i(q,M.normalized,M.normalizedLowercase,U);if(Q){const ve=o(he),Ie=[],ke=[];return ve.forEach(Le=>{Le.start<W&&Le.end>W?(Ie.push({start:0,end:Le.end-W}),ke.push({start:Le.start,end:W})):Le.start>=W?Ie.push({start:Le.start-W,end:Le.end-W}):ke.push(Le)}),{score:Q,labelMatch:Ie,descriptionMatch:ke}}}return b}function o(B){const $=[];if(!B)return $;let N;for(const M of B)N&&N.end===M?N.end+=1:(N={start:M,end:M+1},$.push(N));return $}function l(B){const $=B.sort((F,U)=>F.start-U.start),N=[];let M;for(const F of $)!M||!h(M,F)?(M=F,N.push(F)):(M.start=Math.min(M.start,F.start),M.end=Math.max(M.end,F.end));return N}function h(B,$){return!(B.end<$.start||$.end<B.start)}function S(B,$,N,M,F,U){const O=t(B,N,M,F,U),W=t($,N,M,F,U),q=O.score,Q=W.score;if((q===p||Q===p)&&q!==Q)return q===p?-1:1;if(q>g||Q>g){if(q!==Q)return q>Q?-1:1;if(q<c&&Q<c){const J=v(O.labelMatch,W.labelMatch);if(J!==0)return J}const Le=F.getItemLabel(B)||"",V=F.getItemLabel($)||"";if(Le.length!==V.length)return Le.length-V.length}if(q!==Q)return q>Q?-1:1;const he=Array.isArray(O.labelMatch)&&O.labelMatch.length>0,ve=Array.isArray(W.labelMatch)&&W.labelMatch.length>0;if(he&&!ve)return-1;if(ve&&!he)return 1;const Ie=u(B,O,F),ke=u($,W,F);return Ie&&ke&&Ie!==ke?ke>Ie?-1:1:R(B,$,N,F)}e.compareItemsByFuzzyScore=S;function u(B,$,N){let M=-1,F=-1;if($.descriptionMatch&&$.descriptionMatch.length?M=$.descriptionMatch[0].start:$.labelMatch&&$.labelMatch.length&&(M=$.labelMatch[0].start),$.labelMatch&&$.labelMatch.length){if(F=$.labelMatch[$.labelMatch.length-1].end,$.descriptionMatch&&$.descriptionMatch.length){const U=N.getItemDescription(B);U&&(F+=U.length)}}else $.descriptionMatch&&$.descriptionMatch.length&&(F=$.descriptionMatch[$.descriptionMatch.length-1].end);return F-M}function v(B,$){if(!B&&!$||(!B||!B.length)&&(!$||!$.length))return 0;if(!$||!$.length)return-1;if(!B||!B.length)return 1;const N=B[0].start,F=B[B.length-1].end-N,U=$[0].start,W=$[$.length-1].end-U;return F===W?0:W<F?1:-1}function R(B,$,N,M){const F=M.getItemLabel(B)||"",U=M.getItemLabel($)||"",O=M.getItemDescription(B),W=M.getItemDescription($),q=F.length+(O?O.length:0),Q=U.length+(W?W.length:0);if(q!==Q)return q-Q;const he=M.getItemPath(B),ve=M.getItemPath($);return he&&ve&&he.length!==ve.length?he.length-ve.length:F!==U?(0,_.compareAnything)(F,U,N.normalized):O&&W&&O!==W?(0,_.compareAnything)(O,W,N.normalized):he&&ve&&he!==ve?(0,_.compareAnything)(he,ve,N.normalized):0}const L=" ";function H(B){typeof B!="string"&&(B="");const $=B.toLowerCase(),{pathNormalized:N,normalized:M,normalizedLowercase:F}=ie(B),U=N.indexOf(A.sep)>=0;let O;const W=B.split(L);if(W.length>1)for(const q of W){const{pathNormalized:Q,normalized:he,normalizedLowercase:ve}=ie(q);he&&(O||(O=[]),O.push({original:q,originalLowercase:q.toLowerCase(),pathNormalized:Q,normalized:he,normalizedLowercase:ve}))}return{original:B,originalLowercase:$,pathNormalized:N,normalized:M,normalizedLowercase:F,values:O,containsPathSeparator:U}}e.prepareQuery=H;function ie(B){let $;I.isWindows?$=B.replace(/\//g,A.sep):$=B.replace(/\\/g,A.sep);const N=(0,y.stripWildcards)($).replace(/\s/g,"");return{pathNormalized:$,normalized:N,normalizedLowercase:N.toLowerCase()}}function j(B){return Array.isArray(B)?H(B.map($=>$.original).join(L)):H(B.original)}e.pieceToQuery=j}),define(me[33],ge([0,1,10,30,8,24,19]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const D="**",i="/",T="[/\\\\]",C="[^/\\\\]",m=/\//g;function f(O){switch(O){case 0:return"";case 1:return`${C}*?`;default:return`(?:${T}|${C}+${T}|${T}${C}+)*?`}}function a(O,W){if(!O)return[];const q=[];let Q=!1,he=!1,ve="";for(const Ie of O){switch(Ie){case W:if(!Q&&!he){q.push(ve),ve="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":he=!0;break;case"]":he=!1;break}ve+=Ie}return ve&&q.push(ve),q}e.splitGlobAware=a;function d(O){if(!O)return"";let W="";const q=a(O,i);if(q.every(Q=>Q===D))W=".*";else{let Q=!1;q.forEach((he,ve)=>{if(he===D){Q||(W+=f(2),Q=!0);return}let Ie=!1,ke="",Le=!1,V="";for(const J of he){if(J!=="}"&&Ie){ke+=J;continue}if(Le&&(J!=="]"||!V)){let ee;J==="-"?ee=J:(J==="^"||J==="!")&&!V?ee="^":J===i?ee="":ee=_.escapeRegExpCharacters(J),V+=ee;continue}switch(J){case"{":Ie=!0;continue;case"[":Le=!0;continue;case"}":W+=`(?:${a(ke,",").map(we=>d(we)).join("|")})`,Ie=!1,ke="";break;case"]":W+="["+V+"]",Le=!1,V="";break;case"?":W+=C;continue;case"*":W+=f(1);continue;default:W+=_.escapeRegExpCharacters(J)}}ve<q.length-1&&(q[ve+1]!==D||ve+2<q.length)&&(W+=T),Q=!1})}return W}const E=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,p=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.LRUCache(1e4),n=function(){return!1},s=function(){return null};function r(O,W){if(!O)return s;let q;typeof O!="string"?q=O.pattern:q=O,q=q.trim();const Q=`${q}_${!!W.trimForExclusions}`;let he=t.get(Q);if(he)return o(he,O);let ve;if(E.test(q)){const Ie=q.substr(4);he=function(ke,Le){return typeof ke=="string"&&ke.endsWith(Ie)?q:null}}else(ve=w.exec(l(q,W)))?he=h(ve[1],q):(W.trimForExclusions?p:b).test(q)?he=S(q,W):(ve=c.exec(l(q,W)))?he=u(ve[1].substr(1),q,!0):(ve=g.exec(l(q,W)))?he=u(ve[1],q,!1):he=v(q);return t.set(Q,he),o(he,O)}function o(O,W){return typeof W=="string"?O:function(q,Q){return k.isEqualOrParent(q,W.base)?O(A.relative(W.base,q),Q):null}}function l(O,W){return W.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function h(O,W){const q=`/${O}`,Q=`\\${O}`,he=function(Ie,ke){return typeof Ie!="string"?null:ke?ke===O?W:null:Ie===O||Ie.endsWith(q)||Ie.endsWith(Q)?W:null},ve=[O];return he.basenames=ve,he.patterns=[W],he.allBasenames=ve,he}function S(O,W){const q=U(O.slice(1,-1).split(",").map(ke=>r(ke,W)).filter(ke=>ke!==s),O),Q=q.length;if(!Q)return s;if(Q===1)return q[0];const he=function(ke,Le){for(let V=0,J=q.length;V<J;V++)if(q[V](ke,Le))return O;return null},ve=q.find(ke=>!!ke.allBasenames);ve&&(he.allBasenames=ve.allBasenames);const Ie=q.reduce((ke,Le)=>Le.allPaths?ke.concat(Le.allPaths):ke,[]);return Ie.length&&(he.allPaths=Ie),he}function u(O,W,q){const Q=A.sep===A.posix.sep,he=Q?O:O.replace(m,A.sep),ve=A.sep+he,Ie=A.posix.sep+O,ke=q?function(Le,V){return typeof Le=="string"&&(Le===he||Le.endsWith(ve)||!Q&&(Le===O||Le.endsWith(Ie)))?W:null}:function(Le,V){return typeof Le=="string"&&(Le===he||!Q&&Le===O)?W:null};return ke.allPaths=[(q?"*/":"./")+O],ke}function v(O){try{const W=new RegExp(`^${d(O)}$`);return function(q){return W.lastIndex=0,typeof q=="string"&&W.test(q)?O:null}}catch(W){return s}}function R(O,W,q){return!O||typeof W!="string"?!1:L(O)(W,void 0,q)}e.match=R;function L(O,W={}){if(!O)return n;if(typeof O=="string"||B(O)){const q=r(O,W);if(q===s)return n;const Q=function(he,ve){return!!q(he,ve)};return q.allBasenames&&(Q.allBasenames=q.allBasenames),q.allPaths&&(Q.allPaths=q.allPaths),Q}return M(O,W)}e.parse=L;function H(O){if(!!O){let W;return q=>(W||(W=(O()||Promise.resolve([])).then(Q=>Q?j(Q):{})),W.then(Q=>!!Q[q]))}}e.hasSiblingPromiseFn=H;function ie(O){if(!!O){let W;return q=>{if(!W){const Q=O();W=Q?j(Q):{}}return!!W[q]}}}e.hasSiblingFn=ie;function j(O){const W={};for(const q of O)W[q]=!0;return W}function B(O){const W=O;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=B;function $(O){return O.allBasenames||[]}e.getBasenameTerms=$;function N(O){return O.allPaths||[]}e.getPathTerms=N;function M(O,W){const q=U(Object.getOwnPropertyNames(O).map(ke=>F(ke,O[ke],W)).filter(ke=>ke!==s)),Q=q.length;if(!Q)return s;if(!q.some(ke=>!!ke.requiresSiblings)){if(Q===1)return q[0];const ke=function(J,ee){for(let ae=0,we=q.length;ae<we;ae++){const Ce=q[ae](J,ee);if(Ce)return Ce}return null},Le=q.find(J=>!!J.allBasenames);Le&&(ke.allBasenames=Le.allBasenames);const V=q.reduce((J,ee)=>ee.allPaths?J.concat(ee.allPaths):J,[]);return V.length&&(ke.allPaths=V),ke}const he=function(ke,Le,V){let J;for(let ee=0,ae=q.length;ee<ae;ee++){const we=q[ee];we.requiresSiblings&&V&&(Le||(Le=A.basename(ke)),J||(J=Le.substr(0,Le.length-A.extname(ke).length)));const Ce=we(ke,Le,J,V);if(Ce)return Ce}return null},ve=q.find(ke=>!!ke.allBasenames);ve&&(he.allBasenames=ve.allBasenames);const Ie=q.reduce((ke,Le)=>Le.allPaths?ke.concat(Le.allPaths):ke,[]);return Ie.length&&(he.allPaths=Ie),he}function F(O,W,q){if(W===!1)return s;const Q=r(O,q);if(Q===s)return s;if(typeof W=="boolean")return Q;if(W){const he=W.when;if(typeof he=="string"){const ve=(Ie,ke,Le,V)=>{if(!V||!Q(Ie,ke))return null;const J=he.replace("$(basename)",Le),ee=V(J);return(0,y.isThenable)(ee)?ee.then(ae=>ae?O:null):ee?O:null};return ve.requiresSiblings=!0,ve}}return Q}function U(O,W){const q=O.filter(ke=>!!ke.basenames);if(q.length<2)return O;const Q=q.reduce((ke,Le)=>{const V=Le.basenames;return V?ke.concat(V):ke},[]);let he;if(W){he=[];for(let ke=0,Le=Q.length;ke<Le;ke++)he.push(W)}else he=q.reduce((ke,Le)=>{const V=Le.patterns;return V?ke.concat(V):ke},[]);const ve=function(ke,Le){if(typeof ke!="string")return null;if(!Le){let J;for(J=ke.length;J>0;J--){const ee=ke.charCodeAt(J-1);if(ee===47||ee===92)break}Le=ke.substr(J)}const V=Q.indexOf(Le);return V!==-1?he[V]:null};ve.basenames=Q,ve.patterns=he,ve.allBasenames=Q;const Ie=O.filter(ke=>!ke.basenames);return Ie.push(ve),Ie}}),define(me[76],ge([0,1,2,8,10,11,9,25,30]),function(G,e,_,k,A,I,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function i(r,o,l){if(typeof r=="string"&&(r=_.URI.file(r)),l){const S=l.getWorkspaceFolder(r);if(S){const u=l.getWorkspace().folders.length>1;let v;if((0,P.isEqual)(S.uri,r)?v="":v=(0,P.relativePath)(S.uri,r),u){const R=S.name?S.name:(0,P.basename)(S.uri);v=v?R+" \u2022 "+v:R}return v}}if(r.scheme!==I.Schemas.file&&r.scheme!==I.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(r.fsPath))return(0,k.normalize)(C(r.fsPath));let h=(0,k.normalize)(r.fsPath);return!y.isWindows&&(o==null?void 0:o.userHome)&&(h=f(h,o.userHome.fsPath)),h}e.getPathLabel=i;function T(r){if(!!r){typeof r=="string"&&(r=_.URI.file(r));const o=(0,P.basename)(r)||(r.scheme===I.Schemas.file?r.fsPath:r.path);return y.isWindows&&(0,D.isRootOrDriveLetter)(o)?C(o):o}}e.getBaseLabel=T;function C(r){return(0,D.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=C;let m=Object.create(null);function f(r,o){if(y.isWindows||!r||!o)return r;let l=m.original===o?m.normalized:void 0;return l||(l=`${(0,A.rtrim)(o,k.posix.sep)}${k.posix.sep}`,m={original:o,normalized:l}),(y.isLinux?r.startsWith(l):(0,A.startsWithIgnoreCase)(r,l))&&(r=`~/${r.substr(l.length)}`),r}e.tildify=f;function a(r,o){return r.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=a;const d="\u2026",E="\\\\",w="~";function b(r,o=k.sep){const l=new Array(r.length);let h=!1;for(let S=0;S<r.length;S++){let u=r[S];if(u===""){l[S]=`.${o}`;continue}if(!u){l[S]=u;continue}h=!0;let v="";u.indexOf(E)===0?(v=u.substr(0,u.indexOf(E)+E.length),u=u.substr(u.indexOf(E)+E.length)):u.indexOf(o)===0?(v=u.substr(0,u.indexOf(o)+o.length),u=u.substr(u.indexOf(o)+o.length)):u.indexOf(w)===0&&(v=u.substr(0,u.indexOf(w)+w.length),u=u.substr(u.indexOf(w)+w.length));const R=u.split(o);for(let L=1;h&&L<=R.length;L++)for(let H=R.length-L;h&&H>=0;H--){h=!1;let ie=R.slice(H,H+L).join(o);for(let j=0;!h&&j<r.length;j++)if(j!==S&&r[j]&&r[j].indexOf(ie)>-1){const B=H+L===R.length,$=H>0&&r[j].indexOf(o)>-1?o+ie:ie,N=r[j].endsWith($);h=!B||N}if(!h){let j="";(R[0].endsWith(":")||v!=="")&&(H===1&&(H=0,L++,ie=R[0]+o+ie),H>0&&(j=R[0]+o),j=v+j),H>0&&(j=j+d+o),j=j+ie,H+L<R.length&&(j=j+o+d),l[S]=j}}h&&(l[S]=u)}return l}e.shorten=b;var p;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function c(r,o=Object.create(null)){const l=[];let h=!1,S="";for(const u of r)if(u==="$"||h&&u==="{")S&&l.push({value:S,type:p.TEXT}),S="",h=!0;else if(u==="}"&&h){const v=o[S];if(typeof v=="string")v.length&&l.push({value:v,type:p.VARIABLE});else if(v){const R=l[l.length-1];(!R||R.type!==p.SEPARATOR)&&l.push({value:v.label,type:p.SEPARATOR})}S="",h=!1}else S+=u;return S&&!h&&l.push({value:S,type:p.TEXT}),l.filter((u,v)=>{if(u.type===p.SEPARATOR){const R=l[v-1],L=l[v+1];return[R,L].every(H=>H&&(H.type===p.VARIABLE||H.type===p.TEXT)&&H.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=c;function g(r,o){return y.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):r.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function t(r,o){return y.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,""):y.isWindows?r.replace(/&&|&/g,l=>l==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(r){const o=r.indexOf("/")!==-1?k.posix:k.win32,l=o.basename(r),h=o.dirname(r);return l.length?{name:l,parentPath:h}:{name:h,parentPath:""}}e.splitName=s}),define(me[100],ge([0,1,2]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(T){return T.toJSON()}class A{constructor(C){this._uriTransformer=C}transformIncoming(C){const m=this._uriTransformer.transformIncoming(C);return m===C?C:k(_.URI.from(m))}transformOutgoing(C){const m=this._uriTransformer.transformOutgoing(C);return m===C?C:k(_.URI.from(m))}transformOutgoingURI(C){const m=this._uriTransformer.transformOutgoing(C);return m===C?C:_.URI.from(m)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function I(T,C,m){if(!T||m>200)return null;if(typeof T=="object"){if(T instanceof _.URI)return C.transformOutgoing(T);for(let f in T)if(Object.hasOwnProperty.call(T,f)){const a=I(T[f],C,m+1);a!==null&&(T[f]=a)}}return null}function y(T,C){const m=I(T,C,0);return m===null?T:m}e.transformOutgoingURIs=y;function P(T,C,m,f){if(!T||f>200)return null;if(typeof T=="object"){if(T.$mid===1)return m?_.URI.revive(C.transformIncoming(T)):C.transformIncoming(T);for(let a in T)if(Object.hasOwnProperty.call(T,a)){const d=P(T[a],C,m,f+1);d!==null&&(T[a]=d)}}return null}function D(T,C){const m=P(T,C,!1,0);return m===null?T:m}e.transformIncomingURIs=D;function i(T,C){const m=P(T,C,!0,0);return m===null?T:m}e.transformAndReviveIncomingURIs=i}),define(me[28],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(D){return _.test(D)}e.isUUID=k;const A=new Uint8Array(16),I=[];for(let D=0;D<256;D++)I.push(D.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let i=0;i<D.length;i++)D[i]=Math.floor(Math.random()*256);return D};function P(){y(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let D=0,i="";return i+=I[A[D++]],i+=I[A[D++]],i+=I[A[D++]],i+=I[A[D++]],i+="-",i+=I[A[D++]],i+=I[A[D++]],i+="-",i+=I[A[D++]],i+=I[A[D++]],i+="-",i+=I[A[D++]],i+=I[A[D++]],i+="-",i+=I[A[D++]],i+=I[A[D++]],i+=I[A[D++]],i+=I[A[D++]],i+=I[A[D++]],i+=I[A[D++]],i}e.generateUuid=P}),define(me[137],ge([0,1,101]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class k{constructor(I="utf8"){this.stringDecoder=new _.StringDecoder(I),this.remaining=null}write(I){const y=[],P=this.remaining?this.remaining+this.stringDecoder.write(I):this.stringDecoder.write(I);if(P.length<1)return y;let D=0,i,T=D;for(;T<P.length;)if(i=P.charCodeAt(T),i===13||i===10){if(y.push(P.substring(D,T)),T++,T<P.length){const C=i;i=P.charCodeAt(T),(C===13&&i===10||C===10&&i===13)&&T++}D=T}else T++;return this.remaining=D<P.length?P.substr(D):null,y}end(){return this.remaining}}e.LineDecoder=k}),define(me[26],ge([0,1,37,48,8,19,9,30,28,75,25,2]),function(G,e,_,k,A,I,y,P,D,i,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var m;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function f($,N=m.UNLINK){if((0,P.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return N===m.UNLINK?d($):a($)}e.rimraf=f;async function a($){try{const N=(0,A.join)((0,k.tmpdir)(),(0,D.generateUuid)());try{await _.promises.rename($,N)}catch(M){return d($)}d(N).catch(M=>{})}catch(N){if(N.code!=="ENOENT")throw N}}async function d($){return _.promises.rmdir($,{recursive:!0,maxRetries:3})}function E($){if((0,P.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");_.rmdirSync($,{recursive:!0})}e.rimrafSync=E;async function w($,N){return c(await(N?b($):_.promises.readdir($)))}e.readdir=w;async function b($){try{return await _.promises.readdir($,{withFileTypes:!0})}catch(F){console.warn("[node.js fs] readdir with filetypes failed with error: ",F)}const N=[],M=await w($);for(const F of M){let U=!1,O=!1,W=!1;try{const q=await _.promises.lstat((0,A.join)($,F));U=q.isFile(),O=q.isDirectory(),W=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}N.push({name:F,isFile:()=>U,isDirectory:()=>O,isSymbolicLink:()=>W})}return N}function p($){return c(_.readdirSync($))}e.readdirSync=p;function c($){return $.map(N=>typeof N=="string"?y.isMacintosh?(0,i.normalizeNFC)(N):N:(N.name=y.isMacintosh?(0,i.normalizeNFC)(N.name):N.name,N))}async function g($){const N=await w($),M=[];for(const F of N)await n.existsDirectory((0,A.join)($,F))&&M.push(F);return M}e.readDirsInDir=g;function t($,N=1e3){return new Promise(M=>{let F=!1;const U=setInterval(()=>{F||(F=!0,_.access($,O=>{F=!1,O&&(clearInterval(U),M(void 0))}))},N)})}e.whenDeleted=t;var n;(function($){async function N(U){let O;try{if(O=await _.promises.lstat(U),!O.isSymbolicLink())return{stat:O}}catch(W){}try{return{stat:await _.promises.stat(U),symbolicLink:(O==null?void 0:O.isSymbolicLink())?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(y.isWindows&&W.code==="EACCES")try{return{stat:await _.promises.stat(await _.promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw q}throw W}}$.stat=N;async function M(U){try{const{stat:O,symbolicLink:W}=await $.stat(U);return O.isFile()&&(W==null?void 0:W.dangling)!==!0}catch(O){}return!1}$.existsFile=M;async function F(U){try{const{stat:O,symbolicLink:W}=await $.stat(U);return O.isDirectory()&&(W==null?void 0:W.dangling)!==!0}catch(O){}return!1}$.existsDirectory=F})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new I.ResourceQueue;function r($,N,M){return s.queueFor(C.URI.file($),T.extUriBiasedIgnorePathCase).queue(()=>{const F=S(M);return new Promise((U,O)=>l($,N,F,W=>W?O(W):U()))})}e.writeFile=r;let o=!0;function l($,N,M,F){if(!o)return _.writeFile($,N,{mode:M.mode,flag:M.flag},F);_.open($,M.flag,M.mode,(U,O)=>{if(U)return F(U);_.writeFile(O,N,W=>{if(W)return _.close(O,()=>F(W));_.fdatasync(O,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),o=!1),_.close(O,Q=>F(Q))))})})}function h($,N,M){const F=S(M);if(!o)return _.writeFileSync($,N,{mode:F.mode,flag:F.flag});const U=_.openSync($,F.flag,F.mode);try{_.writeFileSync(U,N);try{_.fdatasyncSync(U)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),o=!1}}finally{_.closeSync(U)}}e.writeFileSync=h;function S($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function u($,N){if($!==N){async function M(F){try{const U=await _.promises.lstat(F);if(U.isDirectory()||U.isSymbolicLink())return;const O=await _.promises.open(F,"a");try{await O.utimes(U.atime,new Date)}finally{await O.close()}}catch(U){}}try{await _.promises.rename($,N),await M(N)}catch(F){if($.toLowerCase()!==N.toLowerCase()&&F.code==="EXDEV"||$.endsWith("."))await v($,N,{preserveSymlinks:!1}),await f($,m.MOVE),await M(N);else throw F}}}e.move=u;async function v($,N,M){return L($,N,{root:{source:$,target:N},options:M,handledSourcePaths:new Set})}e.copy=v;const R=511;async function L($,N,M){if(!M.handledSourcePaths.has($)){M.handledSourcePaths.add($);const{stat:F,symbolicLink:U}=await n.stat($);if(U){if(M.options.preserveSymlinks)try{return await j($,N,M)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(U.dangling)return}return F.isDirectory()?H($,N,F.mode&R,M):ie($,N,F.mode&R)}}async function H($,N,M,F){await _.promises.mkdir(N,{recursive:!0,mode:M});const U=await w($);for(const O of U)await L((0,A.join)($,O),(0,A.join)(N,O),F)}async function ie($,N,M){await _.promises.copyFile($,N),await _.promises.chmod(N,M)}async function j($,N,M){let F=await _.promises.readlink($);(0,P.isEqualOrParent)(F,M.root.source,!y.isLinux)&&(F=(0,A.join)(M.root.target,F.substr(M.root.source.length+1))),await _.promises.symlink(F,N)}async function B($){try{return await _.promises.access($),!0}catch(N){return!1}}e.exists=B}),define(me[102],ge([0,1,37,285,10,8,26]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(C){const m=(0,I.dirname)(C);if(C===m)return C;const f=((0,I.basename)(C)||C).toLowerCase();try{const d=(0,y.readdirSync)(m).filter(E=>E.toLowerCase()===f);if(d.length===1){const E=P(m);if(E)return(0,I.join)(E,d[0])}else if(d.length>1){const E=d.indexOf(f);if(E>=0){const w=P(m);if(w)return(0,I.join)(w,d[E])}}}catch(a){}return null}e.realcaseSync=P;async function D(C){try{return await(0,k.promisify)(_.realpath)(C)}catch(m){const f=T(C);return await _.promises.access(f,_.constants.R_OK),f}}e.realpath=D;function i(C){try{return _.realpathSync(C)}catch(m){const f=T(C);return _.accessSync(f,_.constants.R_OK),f}}e.realpathSync=i;function T(C){return(0,A.rtrim)((0,I.normalize)(C),I.sep)}});var wt=this&&this.__await||function(G){return this instanceof wt?(this.v=G,this):new wt(G)},Rn=this&&this.__asyncGenerator||function(G,e,_){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var k=_.apply(G,e||[]),A,I=[];return A={},y("next"),y("throw"),y("return"),A[Symbol.asyncIterator]=function(){return this},A;function y(m){k[m]&&(A[m]=function(f){return new Promise(function(a,d){I.push([m,f,a,d])>1||P(m,f)})})}function P(m,f){try{D(k[m](f))}catch(a){C(I[0][3],a)}}function D(m){m.value instanceof wt?Promise.resolve(m.value.v).then(i,T):C(I[0][2],m)}function i(m){P("next",m)}function T(m){P("throw",m)}function C(m,f){m(f),I.shift(),I.length&&P(I[0][0],I[0][1])}},hn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],_;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),_={},k("next"),k("throw"),k("return"),_[Symbol.asyncIterator]=function(){return this},_);function k(I){_[I]=G[I]&&function(y){return new Promise(function(P,D){y=G[I](y),A(P,D,y.done,y.value)})}}function A(I,y,P,D){Promise.resolve(D).then(function(i){I({value:i,done:P})},y)}};define(me[103],ge([0,1,26,48,8]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,y=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var D;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(D||(D={}));let i;switch(process.arch){case"ia32":case"x32":i=1;break;case"arm":case"arm64":i=2;break;default:i=0;break}let T;process.env.PROCESSOR_ARCHITEW6432?T=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?T=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?T=1:T=0;class C{constructor(g,t,n){this.exePath=g,this.displayName=t,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await _.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:c=!1}={}){return c?i===0?process.env["ProgramFiles(x86)"]||null:T===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:c=!1,findPreview:g=!1}={}){const t=m({useAlternateBitness:c});if(!t)return null;const n=A.join(t,"PowerShell");if(!await _.SymlinkSupport.existsDirectory(n))return null;let s=-1,r=null;for(const h of await _.readdir(n)){let S=-1;if(g){const v=h.indexOf("-");if(v<0)continue;const R=h.substring(0,v);if(!I.test(R)||h.substring(v+1)!=="preview")continue;S=parseInt(R,10)}else{if(!I.test(h))continue;S=parseInt(h,10)}if(!(S<=s)){const u=A.join(n,h,"pwsh.exe");!await _.SymlinkSupport.existsFile(u)||(r=u,s=S)}}if(!r)return null;const o=t.includes("x86")?" (x86)":"",l=g?" Preview":"";return new C(r,`PowerShell${l}${o}`,!0)}async function a({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const g=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await _.SymlinkSupport.existsDirectory(g))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=c?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:y,pwshMsixName:"PowerShell (Store)"};for(const s of await _.readdir(g))if(t.test(s)){const r=A.join(g,s,"pwsh.exe");return new C(r,n)}return null}function d(){const c=A.join(k.homedir(),".dotnet","tools","pwsh.exe");return new C(c,".NET Core PowerShell Global Tool")}function E(){const c=A.join(process.env.windir,i===1&&T!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(c,"Windows PowerShell",!0)}function w(){return Rn(this,arguments,function*(){let g=yield wt(f());g&&(yield yield wt(g)),g=yield wt(f({useAlternateBitness:!0})),g&&(yield yield wt(g)),g=yield wt(a()),g&&(yield yield wt(g)),g=d(),g&&(yield yield wt(g)),g=yield wt(f({findPreview:!0})),g&&(yield yield wt(g)),g=yield wt(a({findPreview:!0})),g&&(yield yield wt(g)),g=yield wt(f({useAlternateBitness:!0,findPreview:!0})),g&&(yield yield wt(g)),g=E(),g&&(yield yield wt(g))})}function b(){return Rn(this,arguments,function*(){var g,t;try{for(var n=hn(w()),s;s=yield wt(n.next()),!s.done;){const r=s.value;(yield wt(r.exists()))&&(yield yield wt(r))}}catch(r){g={error:r}}finally{try{s&&!s.done&&(t=n.return)&&(yield wt(t.call(n)))}finally{if(g)throw g.error}}})}e.enumeratePowerShellInstallations=b;async function p(){var c,g;try{for(var t=hn(b()),n;n=await t.next(),!n.done;)return n.value}catch(s){c={error:s}}finally{try{n&&!n.done&&(g=t.return)&&await g.call(t)}finally{if(c)throw c.error}}return null}e.getFirstAvailablePowerShellInstallation=p}),define(me[104],ge([0,1,3,6,19,21,18,22,15,12,58,10]),function(G,e,_,k,A,I,y,P,D,i,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function f(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(a=e.ResponseType||(e.ResponseType={}));function d(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(E||(E={}));class w{constructor(U){this.buffer=U,this.pos=0}read(U){const O=this.buffer.slice(this.pos,this.pos+U);return this.pos+=O.byteLength,O}}class b{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var p;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(p||(p={}));function c(F){const U=P.VSBuffer.alloc(4);return U.writeUInt32BE(F,0),U}function g(F){return F.read(4).readUInt32BE(0)}function t(F){const U=P.VSBuffer.alloc(1);return U.writeUInt8(F,0),U}const n={Undefined:t(p.Undefined),String:t(p.String),Buffer:t(p.Buffer),VSBuffer:t(p.VSBuffer),Array:t(p.Array),Object:t(p.Object)},s=typeof Buffer!="undefined";function r(F,U){if(typeof U=="undefined")F.write(n.Undefined);else if(typeof U=="string"){const O=P.VSBuffer.fromString(U);F.write(n.String),F.write(c(O.byteLength)),F.write(O)}else if(s&&Buffer.isBuffer(U)){const O=P.VSBuffer.wrap(U);F.write(n.Buffer),F.write(c(O.byteLength)),F.write(O)}else if(U instanceof P.VSBuffer)F.write(n.VSBuffer),F.write(c(U.byteLength)),F.write(U);else if(Array.isArray(U)){F.write(n.Array),F.write(c(U.length));for(const O of U)r(F,O)}else{const O=P.VSBuffer.fromString(JSON.stringify(U));F.write(n.Object),F.write(c(O.byteLength)),F.write(O)}}function o(F){switch(F.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return F.read(g(F)).toString();case p.Buffer:return F.read(g(F)).buffer;case p.VSBuffer:return F.read(g(F));case p.Array:{const O=g(F),W=[];for(let q=0;q<O;q++)W.push(o(F));return W}case p.Object:return JSON.parse(F.read(g(F)).toString())}}class l{constructor(U,O,W=null,q=1e3){this.protocol=U,this.ctx=O,this.logger=W,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(U,O){this.channels.set(U,O),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const O=this.send([U.type]);this.logger&&this.logger.logOutgoing(O,0,1,d(U.type));return}case 201:case 202:case 204:case 203:{const O=this.send([U.type,U.id],U.data);this.logger&&this.logger.logOutgoing(O,U.id,1,d(U.type),U.data);return}}}send(U,O=void 0){const W=new b;return r(W,U),r(W,O),this.sendBuffer(W.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(O){return 0}}onRawMessage(U){const O=new w(U),W=o(O),q=o(O),Q=W[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${f(Q)}: ${W[2]}.${W[3]}`,q),this.onPromise({type:Q,id:W[1],channelName:W[2],name:W[3],arg:q});case 102:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${f(Q)}: ${W[2]}.${W[3]}`,q),this.onEventListen({type:Q,id:W[1],channelName:W[2],name:W[3],arg:q});case 101:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${f(Q)}`),this.disposeActiveRequest({type:Q,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${f(Q)}`),this.disposeActiveRequest({type:Q,id:W[1]})}}onPromise(U){const O=this.channels.get(U.channelName);if(!O){this.collectPendingRequest(U);return}const W=new I.CancellationTokenSource;let q;try{q=O.call(this.ctx,U.name,U.arg,W.token)}catch(ve){q=Promise.reject(ve)}const Q=U.id;q.then(ve=>{this.sendResponse({id:Q,data:ve,type:201}),this.activeRequests.delete(U.id)},ve=>{ve instanceof Error?this.sendResponse({id:Q,data:{message:ve.message,name:ve.name,stack:ve.stack?ve.stack.split?ve.stack.split(`
`):ve.stack:void 0},type:202}):this.sendResponse({id:Q,data:ve,type:203}),this.activeRequests.delete(U.id)});const he=(0,k.toDisposable)(()=>W.cancel());this.activeRequests.set(U.id,he)}onEventListen(U){const O=this.channels.get(U.channelName);if(!O){this.collectPendingRequest(U);return}const W=U.id,Q=O.listen(this.ctx,U.name,U.arg)(he=>this.sendResponse({id:W,data:he,type:204}));this.activeRequests.set(U.id,Q)}disposeActiveRequest(U){const O=this.activeRequests.get(U.id);O&&(O.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let O=this.pendingRequests.get(U.channelName);O||(O=[],this.pendingRequests.set(U.channelName,O));const W=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:U,timeoutTimer:W})}flushPendingRequests(U){const O=this.pendingRequests.get(U);if(O){for(const W of O)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var h;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(U,O=null){this.protocol=U,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=O}getChannel(U){const O=this;return{call(W,q,Q){return O.isDisposed?Promise.reject(y.canceled()):O.requestPromise(U,W,q,Q)},listen(W,q){return O.isDisposed?Promise.reject(y.canceled()):O.requestEvent(U,W,q)}}}requestPromise(U,O,W,q=I.CancellationToken.None){const Q=this.lastRequestId++,ve={id:Q,type:100,channelName:U,name:O,arg:W};if(q.isCancellationRequested)return Promise.reject(y.canceled());let Ie;return new Promise((Le,V)=>{if(q.isCancellationRequested)return V(y.canceled());const J=()=>{const Ce=Oe=>{switch(Oe.type){case 201:this.handlers.delete(Q),Le(Oe.data);break;case 202:this.handlers.delete(Q);const be=new Error(Oe.data.message);be.stack=Oe.data.stack,be.name=Oe.data.name,V(be);break;case 203:this.handlers.delete(Q),V(Oe.data);break}};this.handlers.set(Q,Ce),this.sendRequest(ve)};let ee=null;this.state===E.Idle?J():(ee=(0,A.createCancelablePromise)(Ce=>this.whenInitialized()),ee.then(()=>{ee=null,J()}));const ae=()=>{ee?(ee.cancel(),ee=null):this.sendRequest({id:Q,type:101}),V(y.canceled())},we=q.onCancellationRequested(ae);Ie=(0,k.combinedDisposable)((0,k.toDisposable)(ae),we),this.activeRequests.add(Ie)}).finally(()=>{this.activeRequests.delete(Ie)})}requestEvent(U,O,W){const q=this.lastRequestId++,he={id:q,type:102,channelName:U,name:O,arg:W};let ve=null;const Ie=new _.Emitter({onFirstListenerAdd:()=>{ve=(0,A.createCancelablePromise)(Le=>this.whenInitialized()),ve.then(()=>{ve=null,this.activeRequests.add(Ie),this.sendRequest(he)})},onLastListenerRemove:()=>{ve?(ve.cancel(),ve=null):(this.activeRequests.delete(Ie),this.sendRequest({id:q,type:103}))}}),ke=Le=>Ie.fire(Le.data);return this.handlers.set(q,ke),Ie.event}sendRequest(U){switch(U.type){case 100:case 102:{const O=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger&&this.logger.logOutgoing(O,U.id,0,`${f(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const O=this.send([U.type,U.id]);this.logger&&this.logger.logOutgoing(O,U.id,0,f(U.type));return}}}send(U,O=void 0){const W=new b;return r(W,U),r(W,O),this.sendBuffer(W.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(O){return 0}}onBuffer(U){const O=new w(U),W=o(O),q=o(O),Q=W[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(U.byteLength,0,0,d(Q)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],0,d(Q),q),this.onResponse({type:W[0],id:W[1],data:q})}}onResponse(U){if(U.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(U.id);O&&O(U)}whenInitialized(){return this.state===E.Idle?Promise.resolve():_.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelClient=S;class u{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:O,onDidClientDisconnect:W})=>{_.Event.once(O.onMessage)(Q=>{const he=new w(Q),ve=o(he),Ie=new l(O,ve),ke=new S(O);this.channels.forEach((V,J)=>Ie.registerChannel(J,V));const Le={channelServer:Ie,channelClient:ke,ctx:ve};this._connections.add(Le),this._onDidAddConnection.fire(Le),W(()=>{Ie.dispose(),ke.dispose(),this._connections.delete(Le),this._onDidRemoveConnection.fire(Le)})})})}get connections(){const U=[];return this._connections.forEach(O=>U.push(O)),U}getChannel(U,O){const W=this;return{call(q,Q,he){let ve;if((0,i.isFunction)(O)){let ke=(0,D.getRandomElement)(W.connections.filter(O));ve=ke?Promise.resolve(ke):_.Event.toPromise(_.Event.filter(W.onDidAddConnection,O))}else ve=O.routeCall(W,q,Q);const Ie=ve.then(ke=>ke.channelClient.getChannel(U));return R(Ie).call(q,Q,he)},listen(q,Q){if((0,i.isFunction)(O))return W.getMulticastEvent(U,O,q,Q);const he=O.routeEvent(W,q,Q).then(ve=>ve.channelClient.getChannel(U));return R(he).listen(q,Q)}}}getMulticastEvent(U,O,W,q){const Q=this;let he=new k.DisposableStore;const ve=new _.Emitter({onFirstListenerAdd:()=>{he=new k.DisposableStore;const Ie=new _.EventMultiplexer,ke=new Map,Le=J=>{const ae=J.channelClient.getChannel(U).listen(W,q),we=Ie.add(ae);ke.set(J,we)},V=J=>{const ee=ke.get(J);!ee||(ee.dispose(),ke.delete(J))};Q.connections.filter(O).forEach(Le),_.Event.filter(Q.onDidAddConnection,O)(Le,void 0,he),Q.onDidRemoveConnection(V,void 0,he),Ie.event(ve.fire,ve,he),he.add(Ie)},onLastListenerRemove:()=>{he.dispose()}});return ve.event}registerChannel(U,O){this.channels.set(U,O),this._connections.forEach(W=>{W.channelServer.registerChannel(U,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=u;class v{constructor(U,O,W=null){const q=new b;r(q,O),U.send(q.buffer),this.channelClient=new S(U,W),this.channelServer=new l(U,O,W)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,O){this.channelServer.registerChannel(U,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=v;function R(F){return{call(U,O,W){return F.then(q=>q.call(U,O,W))},listen(U,O){const W=new _.Relay;return F.then(q=>W.input=q.listen(U,O)),W.event}}}e.getDelayedChannel=R;function L(F){let U=!1;return{call(O,W,q){return U?F.call(O,W,q):(0,A.timeout)(0).then(()=>U=!0).then(()=>F.call(O,W,q))},listen(O,W){if(U)return F.listen(O,W);const q=new _.Relay;return(0,A.timeout)(0).then(()=>U=!0).then(()=>q.input=F.listen(O,W)),q.event}}}e.getNextTickChannel=L;class H{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const O of U.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await _.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=H;var ie;(function(F){function U(q,Q){const he=q,ve=Q&&Q.disableMarshalling,Ie=new Map;for(const ke in he)W(ke)&&Ie.set(ke,_.Event.buffer(he[ke],!0));return new class{listen(ke,Le){const V=Ie.get(Le);if(V)return V;throw new Error(`Event not found: ${Le}`)}call(ke,Le,V){const J=he[Le];if(typeof J=="function"){if(!ve&&Array.isArray(V))for(let ee=0;ee<V.length;ee++)V[ee]=(0,T.revive)(V[ee]);return J.apply(he,V)}throw new Error(`Method not found: ${Le}`)}}}F.fromService=U;function O(q,Q){const he=Q&&Q.disableMarshalling;return new Proxy({},{get(ve,Ie){var ke;if(typeof Ie=="string")return((ke=Q==null?void 0:Q.properties)===null||ke===void 0?void 0:ke.has(Ie))?Q.properties.get(Ie):W(Ie)?q.listen(Ie):async function(...Le){let V;Q&&!(0,i.isUndefinedOrNull)(Q.context)?V=[Q.context,...Le]:V=Le;const J=await q.call(Ie,V);return he?J:(0,T.revive)(J)};throw new Error(`Property not found: ${String(Ie)}`)}})}F.toService=O;function W(q){return q[0]==="o"&&q[1]==="n"&&C.isUpperAsciiLetter(q.charCodeAt(2))}})(ie=e.ProxyChannel||(e.ProxyChannel={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let U=F.toString();if(U!=="[object Object]")return U}return F}function $(F){return Array.isArray(F)?F.map(B):B(F)}function N(F,U,O,W,q,Q,he){he=$(he);const ve=j[q],Ie=ve[W%ve.length];let ke=[`%c[${F}]%c[${String(U).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${Ie}`];/\($/.test(Q)?(ke=ke.concat(he),ke.push(")")):ke.push(he),console.log.apply(console,ke)}e.logWithColors=N;class M{constructor(U,O){this._outgoingPrefix=U,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,O,W,q,Q){this._totalOutgoing+=U,N(this._outgoingPrefix,this._totalOutgoing,U,O,W,q,Q)}logIncoming(U,O,W,q,Q){this._totalIncoming+=U,N(this._incomingPrefix,this._totalIncoming,U,O,W,q,Q)}}e.IPCLogger=M}),define(me[105],ge([0,1,3,104,6,22,9,36]),function(G,e,_,k,A,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function i(){return D||(D=I.VSBuffer.alloc(0)),D}class T{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,r){if(s===0)return i();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const S=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=s),S}if(this._chunks[0].byteLength>s){const S=this._chunks[0].slice(0,s);return r&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),S}let o=I.VSBuffer.alloc(s),l=0,h=0;for(;s>0;){const S=this._chunks[h];if(S.byteLength>s){const u=S.slice(0,s);o.set(u,l),l+=s,r&&(this._chunks[h]=S.slice(s),this._totalLength-=s),s-=s}else o.set(S,l),l+=S.byteLength,r?(this._chunks.shift(),this._totalLength-=S.byteLength):h++,s-=S.byteLength}return o}}e.ChunkStream=T;var C;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(C||(C={}));var m;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(s,r,o,l){this.type=s,this.id=r,this.ack=o,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class a extends A.Disposable{constructor(s){super();this._onMessage=this._register(new _.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new T,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const o=this._state.messageType,l=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new f(o,l,h,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(!this._isDisposed){s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.VSBuffer.alloc(13);r.writeUInt8(s.type,0),r.writeUInt32BE(s.id,1),r.writeUInt32BE(s.ack,5),r.writeUInt32BE(s.data.byteLength,9),this._writeSoon(r,s.data)}}_bufferAdd(s,r){const o=this._totalLength===0;return this._data.push(s,r),this._totalLength+=s.byteLength+r.byteLength,o}_bufferTake(){const s=I.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,r){this._bufferAdd(s,r)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends A.Disposable{constructor(s){super();this._onMessage=new _.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new a(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new f(1,0,0,s))}}e.Protocol=E;class w extends k.IPCClient{constructor(s,r,o=null){super(s,r,o);this.protocol=s}static fromSocket(s,r){return new w(new E(s),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=w;class b{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new _.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=b;class p{constructor(s){this.data=s,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],r=0,o=this._first;for(;o;)s[r++]=o.data,o=o.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const r=new p(s);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class g{constructor(){this.lastRuns=[];const s=Date.now();for(let r=0;r<g._HISTORY_LENGTH;r++)this.lastRuns[r]=s-1e3*r;setInterval(()=>{for(let r=g._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return g._INSTANCE||(g._INSTANCE=new g),g._INSTANCE}load(){const s=Date.now(),r=(1+g._HISTORY_LENGTH)*1e3;let o=0;for(let l=0;l<g._HISTORY_LENGTH;l++)s-this.lastRuns[l]<=r&&o++;return 1-o/g._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}g._HISTORY_LENGTH=10,g._INSTANCE=null;class t{constructor(s,r=null){this._loadEstimator=g.getInstance(),this._onControlMessage=new b,this.onControlMessage=this._onControlMessage.event,this._onMessage=new b,this.onMessage=this._onMessage.event,this._onDidDispose=new b,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new b,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new b,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,A.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new f(5,0,0,i());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const r=new f(4,0,0,i());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,r){this._isReconnecting=!0,this._socketDisposables=(0,A.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let r=0,o=s.length;r<o;r++)this._socketWriter.write(s[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new f(6,0,0,i())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const r=this._outgoingUnackMsg.toArray();for(let o=0,l=r.length;o<l;o++)this._socketWriter.write(r[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new f(1,r,this._incomingAckId,s);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(s){const r=new f(2,0,0,s);this._socketWriter.write(r)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const s=this._outgoingUnackMsg.peek(),r=Date.now()-s.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const s=new f(3,0,this._incomingAckId,i());this._socketWriter.write(s)}}}e.PersistentProtocol=t}),define(me[106],ge([0,1,95]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class k{constructor(P){let D=(0,_.toUint8)(P);this._defaultValue=D,this._asciiMap=k._createAsciiMap(D),this._map=new Map}static _createAsciiMap(P){let D=new Uint8Array(256);for(let i=0;i<256;i++)D[i]=P;return D}set(P,D){let i=(0,_.toUint8)(D);P>=0&&P<256?this._asciiMap[P]=i:this._map.set(P,i)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}}e.CharacterClassifier=k;var A;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(A||(A={}));class I{constructor(){this._actual=new k(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}}e.CharacterSet=I}),define(me[138],ge([0,1,106]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var k;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(k=e.WordCharacterClass||(e.WordCharacterClass={}));class A extends _.CharacterClassifier{constructor(P){super(0);for(let D=0,i=P.length;D<i;D++)this.set(P.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=A;function I(y){let P={};return D=>(P.hasOwnProperty(D)||(P[D]=y(D)),P[D])}e.getMapForWordSeparators=I(y=>new A(y))}),define(me[49],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class _{constructor(A,I){this.lineNumber=A,this.column=I}with(A=this.lineNumber,I=this.column){return A===this.lineNumber&&I===this.column?this:new _(A,I)}delta(A=0,I=0){return this.with(this.lineNumber+A,this.column+I)}equals(A){return _.equals(this,A)}static equals(A,I){return!A&&!I?!0:!!A&&!!I&&A.lineNumber===I.lineNumber&&A.column===I.column}isBefore(A){return _.isBefore(this,A)}static isBefore(A,I){return A.lineNumber<I.lineNumber?!0:I.lineNumber<A.lineNumber?!1:A.column<I.column}isBeforeOrEqual(A){return _.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,I){return A.lineNumber<I.lineNumber?!0:I.lineNumber<A.lineNumber?!1:A.column<=I.column}static compare(A,I){let y=A.lineNumber|0,P=I.lineNumber|0;if(y===P){let D=A.column|0,i=I.column|0;return D-i}return y-P}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new _(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}}e.Position=_}),define(me[44],ge([0,1,49]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class k{constructor(I,y,P,D){I>P||I===P&&y>D?(this.startLineNumber=P,this.startColumn=D,this.endLineNumber=I,this.endColumn=y):(this.startLineNumber=I,this.startColumn=y,this.endLineNumber=P,this.endColumn=D)}isEmpty(){return k.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return k.containsPosition(this,I)}static containsPosition(I,y){return!(y.lineNumber<I.startLineNumber||y.lineNumber>I.endLineNumber||y.lineNumber===I.startLineNumber&&y.column<I.startColumn||y.lineNumber===I.endLineNumber&&y.column>I.endColumn)}containsRange(I){return k.containsRange(this,I)}static containsRange(I,y){return!(y.startLineNumber<I.startLineNumber||y.endLineNumber<I.startLineNumber||y.startLineNumber>I.endLineNumber||y.endLineNumber>I.endLineNumber||y.startLineNumber===I.startLineNumber&&y.startColumn<I.startColumn||y.endLineNumber===I.endLineNumber&&y.endColumn>I.endColumn)}strictContainsRange(I){return k.strictContainsRange(this,I)}static strictContainsRange(I,y){return!(y.startLineNumber<I.startLineNumber||y.endLineNumber<I.startLineNumber||y.startLineNumber>I.endLineNumber||y.endLineNumber>I.endLineNumber||y.startLineNumber===I.startLineNumber&&y.startColumn<=I.startColumn||y.endLineNumber===I.endLineNumber&&y.endColumn>=I.endColumn)}plusRange(I){return k.plusRange(this,I)}static plusRange(I,y){let P,D,i,T;return y.startLineNumber<I.startLineNumber?(P=y.startLineNumber,D=y.startColumn):y.startLineNumber===I.startLineNumber?(P=y.startLineNumber,D=Math.min(y.startColumn,I.startColumn)):(P=I.startLineNumber,D=I.startColumn),y.endLineNumber>I.endLineNumber?(i=y.endLineNumber,T=y.endColumn):y.endLineNumber===I.endLineNumber?(i=y.endLineNumber,T=Math.max(y.endColumn,I.endColumn)):(i=I.endLineNumber,T=I.endColumn),new k(P,D,i,T)}intersectRanges(I){return k.intersectRanges(this,I)}static intersectRanges(I,y){let P=I.startLineNumber,D=I.startColumn,i=I.endLineNumber,T=I.endColumn,C=y.startLineNumber,m=y.startColumn,f=y.endLineNumber,a=y.endColumn;return P<C?(P=C,D=m):P===C&&(D=Math.max(D,m)),i>f?(i=f,T=a):i===f&&(T=Math.min(T,a)),P>i||P===i&&D>T?null:new k(P,D,i,T)}equalsRange(I){return k.equalsRange(this,I)}static equalsRange(I,y){return!!I&&!!y&&I.startLineNumber===y.startLineNumber&&I.startColumn===y.startColumn&&I.endLineNumber===y.endLineNumber&&I.endColumn===y.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(I){return new _.Position(I.endLineNumber,I.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(I){return new _.Position(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,y){return new k(this.startLineNumber,this.startColumn,I,y)}setStartPosition(I,y){return new k(I,y,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(I){return new k(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}static fromPositions(I,y=I){return new k(I.lineNumber,I.column,y.lineNumber,y.column)}static lift(I){return I?new k(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,y){return!(I.endLineNumber<y.startLineNumber||I.endLineNumber===y.startLineNumber&&I.endColumn<y.startColumn||y.endLineNumber<I.startLineNumber||y.endLineNumber===I.startLineNumber&&y.endColumn<I.startColumn)}static areIntersecting(I,y){return!(I.endLineNumber<y.startLineNumber||I.endLineNumber===y.startLineNumber&&I.endColumn<=y.startColumn||y.endLineNumber<I.startLineNumber||y.endLineNumber===I.startLineNumber&&y.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,y){if(I&&y){const i=I.startLineNumber|0,T=y.startLineNumber|0;if(i===T){const C=I.startColumn|0,m=y.startColumn|0;if(C===m){const f=I.endLineNumber|0,a=y.endLineNumber|0;if(f===a){const d=I.endColumn|0,E=y.endColumn|0;return d-E}return f-a}return C-m}return i-T}return(I?1:0)-(y?1:0)}static compareRangesUsingEnds(I,y){return I.endLineNumber===y.endLineNumber?I.endColumn===y.endColumn?I.startLineNumber===y.startLineNumber?I.startColumn-y.startColumn:I.startLineNumber-y.startLineNumber:I.endColumn-y.endColumn:I.endLineNumber-y.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}}e.Range=k}),define(me[139],ge([0,1,49,44]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var A;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(A=e.SelectionDirection||(e.SelectionDirection={}));class I extends k.Range{constructor(P,D,i,T){super(P,D,i,T);this.selectionStartLineNumber=P,this.selectionStartColumn=D,this.positionLineNumber=i,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return I.selectionsEqual(this,P)}static selectionsEqual(P,D){return P.selectionStartLineNumber===D.selectionStartLineNumber&&P.selectionStartColumn===D.selectionStartColumn&&P.positionLineNumber===D.positionLineNumber&&P.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,D){return this.getDirection()===0?new I(this.startLineNumber,this.startColumn,P,D):new I(P,D,this.startLineNumber,this.startColumn)}getPosition(){return new _.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(P,D){return this.getDirection()===0?new I(P,D,this.endLineNumber,this.endColumn):new I(this.endLineNumber,this.endColumn,P,D)}static fromPositions(P,D=P){return new I(P.lineNumber,P.column,D.lineNumber,D.column)}static liftSelection(P){return new I(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,D){if(P&&!D||!P&&D)return!1;if(!P&&!D)return!0;if(P.length!==D.length)return!1;for(let i=0,T=P.length;i<T;i++)if(!this.selectionsEqual(P[i],D[i]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,D,i,T,C){return C===0?new I(P,D,i,T):new I(i,T,P,D)}}e.Selection=I}),define(me[107],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var _;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(_=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var I;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(I=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(a){this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace)}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class D{constructor(a,d){this.range=a,this.matches=d}}e.FindMatch=D;var i;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(i=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var T;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(T=e.ModelConstants||(e.ModelConstants={}));class C{constructor(a,d,E,w,b,p){this.identifier=a,this.range=d,this.text=E,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=b,this._isTracked=p}}e.ValidAnnotatedEditOperation=C;class m{constructor(a,d,E){this.reverseEdits=a,this.changes=d,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=m}),define(me[140],ge([0,1,10,138,49,44,107]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class D{constructor(p,c,g,t){this.searchString=p,this.isRegex=c,this.matchCase=g,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=i(this.searchString):p=this.searchString.indexOf(`
`)>=0;let c=null;try{c=_.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch(t){return null}if(!c)return null;let g=!this.isRegex&&!p;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new T(c,this.wordSeparators?(0,k.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=D;function i(b){if(!b||b.length===0)return!1;for(let p=0,c=b.length;p<c;p++)if(b.charCodeAt(p)===92){if(p++,p>=c)break;const t=b.charCodeAt(p);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=i;class T{constructor(p,c,g){this.regex=p,this.wordSeparators=c,this.simpleSearch=g}}e.SearchData=T;function C(b,p,c){if(!c)return new y.FindMatch(b,null);let g=[];for(let t=0,n=p.length;t<n;t++)g[t]=p[t];return new y.FindMatch(b,g)}e.createFindMatch=C;class m{constructor(p){let c=[],g=0;for(let t=0,n=p.length;t<n;t++)p.charCodeAt(t)===10&&(c[g++]=t);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(p){const c=this._lineFeedsOffsets;let g=0,t=c.length-1;if(t===-1||p<=c[0])return 0;for(;g<t;){const n=g+((t-g)/2>>0);c[n]>=p?t=n-1:c[n+1]>=p?(g=n,t=n):g=n+1}return g+1}}class f{static findMatches(p,c,g,t,n){const s=c.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(p,g,new w(s.wordSeparators,s.regex),t,n):this._doFindMatchesLineByLine(p,g,s,t,n):[]}static _getMultilineMatchRange(p,c,g,t,n,s){let r,o=0;t?(o=t.findLineFeedCountBeforeOffset(n),r=c+n+o):r=c+n;let l;if(t){let v=t.findLineFeedCountBeforeOffset(n+s.length)-o;l=r+s.length+v}else l=r+s.length;const h=p.getPositionAt(r),S=p.getPositionAt(l);return new I.Range(h.lineNumber,h.column,S.lineNumber,S.column)}static _doFindMatchesMultiline(p,c,g,t,n){const s=p.getOffsetAt(c.getStartPosition()),r=p.getValueInRange(c,1),o=p.getEOL()===`\r
`?new m(r):null,l=[];let h=0,S;for(g.reset(0);S=g.next(r);)if(l[h++]=C(this._getMultilineMatchRange(p,s,r,o,S.index,S[0]),S,t),h>=n)return l;return l}static _doFindMatchesLineByLine(p,c,g,t,n){const s=[];let r=0;if(c.startLineNumber===c.endLineNumber){const l=p.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return r=this._findMatchesInLine(g,l,c.startLineNumber,c.startColumn-1,r,s,t,n),s}const o=p.getLineContent(c.startLineNumber).substring(c.startColumn-1);r=this._findMatchesInLine(g,o,c.startLineNumber,c.startColumn-1,r,s,t,n);for(let l=c.startLineNumber+1;l<c.endLineNumber&&r<n;l++)r=this._findMatchesInLine(g,p.getLineContent(l),l,0,r,s,t,n);if(r<n){const l=p.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);r=this._findMatchesInLine(g,l,c.endLineNumber,0,r,s,t,n)}return s}static _findMatchesInLine(p,c,g,t,n,s,r,o){const l=p.wordSeparators;if(!r&&p.simpleSearch){const u=p.simpleSearch,v=u.length,R=c.length;let L=-v;for(;(L=c.indexOf(u,L+v))!==-1;)if((!l||E(l,c,R,L,v))&&(s[n++]=new y.FindMatch(new I.Range(g,L+1+t,g,L+1+v+t),null),n>=o))return n;return n}const h=new w(p.wordSeparators,p.regex);let S;h.reset(0);do if(S=h.next(c),S&&(s[n++]=C(new I.Range(g,S.index+1+t,g,S.index+1+S[0].length+t),S,r),n>=o))return n;while(S);return n}static findNextMatch(p,c,g,t){const n=c.parseSearchRequest();if(!n)return null;const s=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(p,g,s,t):this._doFindNextMatchLineByLine(p,g,s,t)}static _doFindNextMatchMultiline(p,c,g,t){const n=new A.Position(c.lineNumber,1),s=p.getOffsetAt(n),r=p.getLineCount(),o=p.getValueInRange(new I.Range(n.lineNumber,n.column,r,p.getLineMaxColumn(r)),1),l=p.getEOL()===`\r
`?new m(o):null;g.reset(c.column-1);let h=g.next(o);return h?C(this._getMultilineMatchRange(p,s,o,l,h.index,h[0]),h,t):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(p,new A.Position(1,1),g,t):null}static _doFindNextMatchLineByLine(p,c,g,t){const n=p.getLineCount(),s=c.lineNumber,r=p.getLineContent(s),o=this._findFirstMatchInLine(g,r,s,c.column,t);if(o)return o;for(let l=1;l<=n;l++){const h=(s+l-1)%n,S=p.getLineContent(h+1),u=this._findFirstMatchInLine(g,S,h+1,1,t);if(u)return u}return null}static _findFirstMatchInLine(p,c,g,t,n){p.reset(t-1);const s=p.next(c);return s?C(new I.Range(g,s.index+1,g,s.index+1+s[0].length),s,n):null}static findPreviousMatch(p,c,g,t){const n=c.parseSearchRequest();if(!n)return null;const s=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(p,g,s,t):this._doFindPreviousMatchLineByLine(p,g,s,t)}static _doFindPreviousMatchMultiline(p,c,g,t){const n=this._doFindMatchesMultiline(p,new I.Range(1,1,c.lineNumber,c.column),g,t,10*P);if(n.length>0)return n[n.length-1];const s=p.getLineCount();return c.lineNumber!==s||c.column!==p.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(p,new A.Position(s,p.getLineMaxColumn(s)),g,t):null}static _doFindPreviousMatchLineByLine(p,c,g,t){const n=p.getLineCount(),s=c.lineNumber,r=p.getLineContent(s).substring(0,c.column-1),o=this._findLastMatchInLine(g,r,s,t);if(o)return o;for(let l=1;l<=n;l++){const h=(n+s-l-1)%n,S=p.getLineContent(h+1),u=this._findLastMatchInLine(g,S,h+1,t);if(u)return u}return null}static _findLastMatchInLine(p,c,g,t){let n=null,s;for(p.reset(0);s=p.next(c);)n=C(new I.Range(g,s.index+1,g,s.index+1+s[0].length),s,t);return n}}e.TextModelSearch=f;function a(b,p,c,g,t){if(g===0)return!0;const n=p.charCodeAt(g-1);if(b.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=p.charCodeAt(g);if(b.get(s)!==0)return!0}return!1}function d(b,p,c,g,t){if(g+t===c)return!0;const n=p.charCodeAt(g+t);if(b.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=p.charCodeAt(g+t-1);if(b.get(s)!==0)return!0}return!1}function E(b,p,c,g,t){return a(b,p,c,g,t)&&d(b,p,c,g,t)}e.isValidMatch=E;class w{constructor(p,c){this._wordSeparators=p,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(p){this._searchRegex.lastIndex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(p){const c=p.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(g=this._searchRegex.exec(p),!g))return null;const t=g.index,n=g[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){_.getNextCodePoint(p,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||E(this._wordSeparators,p,c,t,n))return g}while(g);return null}}e.Searcher=w}),define(me[108],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function _(P=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const i of e.USUAL_WORD_SEPARATORS)P.indexOf(i)>=0||(D+="\\"+i);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=_();function k(P){let D=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)D=P;else{let i="g";P.ignoreCase&&(i+="i"),P.multiline&&(i+="m"),P.unicode&&(i+="u"),D=new RegExp(P.source,i)}return D.lastIndex=0,D}e.ensureValidWordDefinition=k;const A={maxLen:1e3,windowSize:15,timeBudget:150};function I(P,D,i,T,C=A){if(i.length>C.maxLen){let E=P-C.maxLen/2;return E<0?E=0:T+=E,i=i.substring(E,P+C.maxLen/2),I(P,D,i,T,C)}const m=Date.now(),f=P-1-T;let a=-1,d=null;for(let E=1;!(Date.now()-m>=C.timeBudget);E++){const w=f-C.windowSize*E;D.lastIndex=Math.max(0,w);const b=y(D,i,f,a);if(!b&&d||(d=b,w<=0))break;a=w}if(d){let E={word:d[0],startColumn:T+1+d.index,endColumn:T+1+d.index+d[0].length};return D.lastIndex=0,E}return null}e.getWordAtText=I;function y(P,D,i,T){let C;for(;C=P.exec(D);){const m=C.index||0;if(m<=i&&P.lastIndex>=i)return C;if(T>0&&m>T)return null}return null}}),define(me[141],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var _;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(_=e.IndentAction||(e.IndentAction={}));class k{constructor(P){if(this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let D=0,i=P.notIn.length;D<i;D++)switch(P.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}}e.StandardAutoClosingPairConditional=k;class A{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of P)I(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),I(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),I(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),I(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&I(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=A;function I(y,P,D){y.has(P)?y.get(P).push(D):y.set(P,[D])}}),define(me[77],ge([0,1,33,8]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function A(I,y,P,D){if(Array.isArray(I)){let i=0;for(const T of I){const C=A(T,y,P,D);if(C===10)return C;C>i&&(i=C)}return i}else{if(typeof I=="string")return D?I==="*"?5:I===P?10:0:0;if(I){const{language:i,pattern:T,scheme:C,hasAccessToAllModels:m}=I;if(!D&&!m)return 0;let f=0;if(C)if(C===y.scheme)f=10;else if(C==="*")f=5;else return 0;if(i)if(i===P)f=10;else if(i==="*")f=Math.max(f,5);else return 0;if(T){let a;if(typeof T=="string"?a=T:a=Object.assign(Object.assign({},T),{base:(0,k.normalize)(T.base)}),a===y.fsPath||(0,_.match)(a,y.fsPath))f=10;else return 0}return f}else return 0}}e.score=A}),define(me[142],ge([0,1,106]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var k;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(k=e.State||(e.State={}));class A{constructor(a,d,E){const w=new Uint8Array(a*d);for(let b=0,p=a*d;b<p;b++)w[b]=E;this._data=w,this.rows=a,this.cols=d}get(a,d){return this._data[a*this.cols+d]}set(a,d,E){this._data[a*this.cols+d]=E}}e.Uint8Matrix=A;class I{constructor(a){let d=0,E=0;for(let b=0,p=a.length;b<p;b++){let[c,g,t]=a[b];g>d&&(d=g),c>E&&(E=c),t>E&&(E=t)}d++,E++;let w=new A(E,d,0);for(let b=0,p=a.length;b<p;b++){let[c,g,t]=a[b];w.set(c,g,t)}this._states=w,this._maxCharCode=d}nextState(a,d){return d<0||d>=this._maxCharCode?0:this._states.get(a,d)}}e.StateMachine=I;let y=null;function P(){return y===null&&(y=new I([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var D;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let i=null;function T(){if(i===null){i=new _.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<f.length;d++)i.set(f.charCodeAt(d),1);const a=".,;";for(let d=0;d<a.length;d++)i.set(a.charCodeAt(d),2)}return i}class C{static _createLink(a,d,E,w,b){let p=b-1;do{const c=d.charCodeAt(p);if(a.get(c)!==2)break;p--}while(p>w);if(w>0){const c=d.charCodeAt(w-1),g=d.charCodeAt(p);(c===40&&g===41||c===91&&g===93||c===123&&g===125)&&p--}return{range:{startLineNumber:E,startColumn:w+1,endLineNumber:E,endColumn:p+2},url:d.substring(w,p+1)}}static computeLinks(a,d=P()){const E=T();let w=[];for(let b=1,p=a.getLineCount();b<=p;b++){const c=a.getLineContent(b),g=c.length;let t=0,n=0,s=0,r=1,o=!1,l=!1,h=!1,S=!1;for(;t<g;){let u=!1;const v=c.charCodeAt(t);if(r===13){let R;switch(v){case 40:o=!0,R=0;break;case 41:R=o?0:1;break;case 91:h=!0,l=!0,R=0;break;case 93:h=!1,R=l?0:1;break;case 123:S=!0,R=0;break;case 125:R=S?0:1;break;case 39:R=s===34||s===96?0:1;break;case 34:R=s===39||s===96?0:1;break;case 96:R=s===39||s===34?0:1;break;case 42:R=s===42?1:0;break;case 124:R=s===124?1:0;break;case 32:R=h?0:1;break;default:R=E.get(v)}R===1&&(w.push(C._createLink(E,c,b,n,t)),u=!0)}else if(r===12){let R;v===91?(l=!0,R=0):R=E.get(v),R===1?u=!0:r=13}else r=d.nextState(r,v),r===0&&(u=!0);u&&(r=1,o=!1,l=!1,S=!1,n=t+1,s=v),t++}r===13&&w.push(C._createLink(E,c,b,n,g))}return w}}e.LinkComputer=C;function m(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:C.computeLinks(f)}e.computeLinks=m}),define(me[143],ge([0,1,3,6]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class A{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,P){return this._map.set(y,P),this.fire([y]),(0,k.toDisposable)(()=>{this._map.get(y)===P&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,P){let D=null,i=!1;return this._promises.set(y,P.then(T=>{this._promises.delete(y),!(i||!T)&&(D=this.register(y,T))})),(0,k.toDisposable)(()=>{i=!0,D&&D.dispose()})}getPromise(y){const P=this.get(y);if(P)return Promise.resolve(P);const D=this._promises.get(y);return D?D.then(i=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=A}),define(me[109],ge([0,1,22,9]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var A;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(A||(A={}));function I(C){for(let m=0,f=C.length;m<f;m+=4){const a=C[m+0],d=C[m+1],E=C[m+2],w=C[m+3];C[m+0]=w,C[m+1]=E,C[m+2]=d,C[m+3]=a}}function y(C){const m=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return k.isLittleEndian()||I(m),_.VSBuffer.wrap(m)}function P(C){const m=C.buffer;if(k.isLittleEndian()||I(m),m.byteOffset%4==0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const f=new Uint8Array(m.byteLength);return f.set(m),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function D(C){const m=new Uint32Array(i(C));let f=0;if(m[f++]=C.id,C.type==="full")m[f++]=1,m[f++]=C.data.length,m.set(C.data,f),f+=C.data.length;else{m[f++]=2,m[f++]=C.deltas.length;for(const a of C.deltas)m[f++]=a.start,m[f++]=a.deleteCount,a.data?(m[f++]=a.data.length,m.set(a.data,f),f+=a.data.length):m[f++]=0}return y(m)}e.encodeSemanticTokensDto=D;function i(C){let m=0;if(m+=1+1,C.type==="full")m+=1+C.data.length;else{m+=1,m+=(1+1+1)*C.deltas.length;for(const f of C.deltas)f.data&&(m+=f.data.length)}return m}function T(C){const m=P(C);let f=0;const a=m[f++];if(m[f++]===1){const b=m[f++],p=m.subarray(f,f+b);return f+=b,{id:a,type:"full",data:p}}const E=m[f++];let w=[];for(let b=0;b<E;b++){const p=m[f++],c=m[f++],g=m[f++];let t;g>0&&(t=m.subarray(f,f+g),f+=g),w[b]={start:p,deleteCount:c,data:t}}return{id:a,type:"delta",deltas:w}}e.decodeSemanticTokensDto=T}),define(me[110],ge([0,1,95]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class k{constructor(y,P){this.index=y,this.remainder=P}}e.PrefixSumIndexOfResult=k;class A{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,P){y=(0,_.toUint32)(y);const D=this.values,i=this.prefixSum,T=P.length;return T===0?!1:(this.values=new Uint32Array(D.length+T),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y),y+T),this.values.set(P,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(i.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,P){return y=(0,_.toUint32)(y),P=(0,_.toUint32)(P),this.values[y]===P?!1:(this.values[y]=P,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,P){y=(0,_.toUint32)(y),P=(0,_.toUint32)(P);const D=this.values,i=this.prefixSum;if(y>=D.length)return!1;let T=D.length-y;return P>=T&&(P=T),P===0?!1:(this.values=new Uint32Array(D.length-P),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y+P),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(i.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,_.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),y>=this.values.length&&(y=this.values.length-1);for(let D=P;D<=y;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let P=0,D=this.values.length-1,i=0,T=0,C=0;for(;P<=D;)if(i=P+(D-P)/2|0,T=this.prefixSum[i],C=T-this.values[i],y<C)D=i-1;else if(y>=T)P=i+1;else break;return new k(i,y-C)}}e.PrefixSumComputer=A}),define(me[144],ge([0,1,10,49,110]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class I{constructor(P,D,i,T){this._uri=P,this._lines=D,this._eol=i,this._versionId=T,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const D=P.changes;for(const i of D)this._acceptDeleteRange(i.range),this._acceptInsertText(new k.Position(i.range.startLineNumber,i.range.startColumn),i.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,D=this._lines.length,i=new Uint32Array(D);for(let T=0;T<D;T++)i[T]=this._lines[T].length+P;this._lineStarts=new A.PrefixSumComputer(i)}}_setLineText(P,D){this._lines[P]=D,this._lineStarts&&this._lineStarts.changeValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,D){if(D.length!==0){let i=(0,_.splitLines)(D);if(i.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+i[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}i[i.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+i[0]);let T=new Uint32Array(i.length-1);for(let C=1;C<i.length;C++)this._lines.splice(P.lineNumber+C-1,0,i[C]),T[C-1]=i[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,T)}}}e.MirrorTextModel=I}),define(me[145],ge([16,17]),function(G,e){return G.create("vs/base/common/date",e)}),define(me[146],ge([0,1,145]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,A=k*60,I=A*24,y=I*7,P=I*30,D=I*365;function i(C,m){typeof C!="number"&&(C=C.getTime());const f=Math.round((new Date().getTime()-C)/1e3);if(f<-30)return(0,_.localize)(0,null,i(new Date().getTime()+f*1e3,!1));if(f<30)return(0,_.localize)(1,null);let a;return f<k?(a=f,m?a===1?(0,_.localize)(2,null,a):(0,_.localize)(3,null,a):a===1?(0,_.localize)(4,null,a):(0,_.localize)(5,null,a)):f<A?(a=Math.floor(f/k),m?a===1?(0,_.localize)(6,null,a):(0,_.localize)(7,null,a):a===1?(0,_.localize)(8,null,a):(0,_.localize)(9,null,a)):f<I?(a=Math.floor(f/A),m?a===1?(0,_.localize)(10,null,a):(0,_.localize)(11,null,a):a===1?(0,_.localize)(12,null,a):(0,_.localize)(13,null,a)):f<y?(a=Math.floor(f/I),m?a===1?(0,_.localize)(14,null,a):(0,_.localize)(15,null,a):a===1?(0,_.localize)(16,null,a):(0,_.localize)(17,null,a)):f<P?(a=Math.floor(f/y),m?a===1?(0,_.localize)(18,null,a):(0,_.localize)(19,null,a):a===1?(0,_.localize)(20,null,a):(0,_.localize)(21,null,a)):f<D?(a=Math.floor(f/P),m?a===1?(0,_.localize)(22,null,a):(0,_.localize)(23,null,a):a===1?(0,_.localize)(24,null,a):(0,_.localize)(25,null,a)):(a=Math.floor(f/D),m?a===1?(0,_.localize)(26,null,a):(0,_.localize)(27,null,a):a===1?(0,_.localize)(28,null,a):(0,_.localize)(29,null,a))}e.fromNow=i;function T(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(me[147],ge([16,17]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(me[59],ge([0,1,147,12,15]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function I(i,T){return T&&(i.stack||i.stacktrace)?_.localize(0,null,P(i),y(i.stack)||y(i.stacktrace)):P(i)}function y(i){return Array.isArray(i)?i.join(`
`):i}function P(i){return typeof i.code=="string"&&typeof i.errno=="number"&&typeof i.syscall=="string"?_.localize(1,null,i.message):i.message||_.localize(2,null)}function D(i=null,T=!1){if(!i)return _.localize(3,null);if(Array.isArray(i)){const C=A.coalesce(i),m=D(C[0],T);return C.length>1?_.localize(4,null,m,C.length):m}if(k.isString(i))return i;if(i.detail){const C=i.detail;if(C.error)return I(C.error,T);if(C.exception)return I(C.exception,T)}return i.stack?I(i,T):i.message?i.message:_.localize(5,null)}e.toErrorMessage=D}),define(me[148],ge([16,17]),function(G,e){return G.create("vs/base/node/processes",e)}),define(me[78],ge([0,1,8,37,26,38,148,36,12,23,30,9,137,11]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function a(g){switch(g){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(g,t){if(C.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const s=I.execFile("taskkill",["/T","/F","/PID",g.pid.toString()],n);return new Promise(r=>{s.once("error",o=>{r({success:!1,error:o})}),s.once("exit",(o,l)=>{r(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?a(n.status):1})}else if(C.isLinux||C.isMacintosh)try{const n=f.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(s=>{I.execFile(n,[g.pid.toString()],{encoding:"utf8",shell:!0},(r,o,l)=>{s(r?{success:!1,error:r}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else g.kill("SIGKILL");return Promise.resolve({success:!0})}function E(g=P.env){return g.comspec||"cmd.exe"}e.getWindowsShell=E;class w{constructor(t,n,s,r){if(n!==void 0&&s!==void 0&&r!==void 0)this.cmd=t,this.args=n,this.shell=s,this.options=r;else{const o=t;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(P.env).forEach(l=>{o[l]=P.env[l]}),Object.keys(this.options.env).forEach(l=>{o[l]=this.options.env[l]}),this.options.env=o}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(_.sep);return n!==-1&&(t=t.substring(n+1)),w.WellKnowCommands[t]?t:"other"}start(t){return C.isWindows&&(this.options&&this.options.cwd&&T.isUNC(this.options.cwd)||!this.options&&T.isUNC(P.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(n=>{let s,r;const o=new Promise((l,h)=>{s=l,r=h});if(n){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=I.exec(l,this.options,(h,S,u)=>{this.childProcess=null;const v=h;v&&v.killed?r({killed:this.terminateRequested,stdout:S.toString(),stderr:u.toString()}):this.handleExec(s,t,h,S,u)})}else{let l=null;const h=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,s,t,r);const u={terminated:this.terminateRequested};D.isNumber(S)&&(u.cmdCode=S),s(u)};if(this.shell&&C.isWindows){const S=i.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let u=!1,v=!1;const R=[];let L=this.ensureQuotes(this.cmd);R.push(L.value),u=L.quoted,this.args&&this.args.forEach(ie=>{L=this.ensureQuotes(ie),R.push(L.value),v=v&&L.quoted});const H=["/s","/c"];u?v?H.push('"'+R.join(" ")+'"'):R.length>1?H.push('"'+R[0]+'" '+R.slice(1).join(" ")):H.push('"'+R[0]+'"'):H.push(R.join(" ")),l=I.spawn(E(),H,S)}else this.cmd&&(l=I.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(D.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",S=>{this.childProcess=null,r({terminated:this.terminateRequested,error:S})}),l.pid&&(this.childProcess.on("close",h),this.handleSpawn(l,s,t,r,!0)))}return o})}handleClose(t,n,s,r){}ensureQuotes(t){return w.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,d(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!C.isWindows)return t(!1);const n=I.spawn(E(),["/s","/c"]);n.on("error",s=>t(!0)),n.on("exit",s=>t(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class b extends w{constructor(t,n,s,r){super(t,n,s,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,s,r,o){[r,o].forEach((l,h)=>{const S=new m.LineDecoder;S.write(l).forEach(R=>{n({line:R,source:h===0?0:1})});const v=S.end();v&&n({line:v,source:h===0?0:1})}),t({terminated:this.terminateRequested,error:s})}handleSpawn(t,n,s,r,o){const l=new m.LineDecoder,h=new m.LineDecoder;t.stdout.on("data",S=>{l.write(S).forEach(v=>s({line:v,source:0}))}),t.stderr.on("data",S=>{h.write(S).forEach(v=>s({line:v,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=h}handleClose(t,n,s,r){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&s({line:o,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&s({line:l,source:1})}}e.LineProcess=b;function p(g){let t=[],n=!1;const s=function(r){if(n){t.push(r);return}(!g.send(r,l=>{if(l&&console.error(l),n=!1,t.length>0){const h=t.slice(0);t=[],h.forEach(S=>s(S))}})||C.isWindows)&&(n=!0)};return{send:s}}e.createQueuedSender=p;var c;(function(g){async function t(n,s,r){if(_.isAbsolute(n))return n;if(s===void 0&&(s=P.cwd()),_.dirname(n)!=="."||(r===void 0&&D.isString(P.env.PATH)&&(r=P.env.PATH.split(_.delimiter)),r===void 0||r.length===0))return _.join(s,n);async function l(h){return await A.exists(h)?!(await k.promises.stat(h)).isDirectory():!1}for(let h of r){let S;if(_.isAbsolute(h)?S=_.join(h,n):S=_.join(s,h,n),await l(S))return S;let u=S+".com";if(await l(u)||(u=S+".exe",await l(u)))return u}return _.join(s,n)}g.findExecutable=t})(c=e.win32||(e.win32={}))}),define(me[149],ge([0,1,48,9,103,78]),function(G,e,_,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function y(f,a){return f===1?k.isWindows?C():I.getWindowsShell(a):i(f,a)}e.getSystemShell=y;function P(f,a){return f===1?k.isWindows?m(a):I.getWindowsShell(a):i(f,a)}e.getSystemShellSync=P;let D=null;function i(f,a){if(k.isLinux&&f===2||k.isMacintosh&&f===3)return"/bin/bash";if(!D){let d;if(k.isWindows)d="/bin/bash";else{if(d=a.SHELL,!d)try{d=(0,_.userInfo)().shell}catch(E){}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}D=d}return D}let T=null;async function C(){return T||(T=(await(0,A.getFirstAvailablePowerShellInstallation)()).exePath),T}function m(f){if(T)return T;const a=k.isWindows&&parseFloat((0,_.release)())>=10,d=f.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${f.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?E:I.getWindowsShell(f)}}),define(me[150],ge([16,17]),function(G,e){return G.create("vs/editor/common/config/editorOptions",e)}),define(me[151],ge([0,1,150,9,108]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(re){this._values=re}hasChanged(re){return this._values[re]}}e.ConfigurationChangedEvent=y;class P{constructor(){this._values=[]}_read(re){return this._values[re]}get(re){return this._values[re]}_write(re,_e){this._values[re]=_e}}e.ValidatedEditorOptions=P;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class i{constructor(re,_e,xe,ze){this.id=re,this.name=_e,this.defaultValue=xe,this.schema=ze}compute(re,_e,xe){return xe}}class T{constructor(re,_e=null){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0,this.deps=_e}validate(re){return this.defaultValue}}class C{constructor(re,_e,xe,ze){this.id=re,this.name=_e,this.defaultValue=xe,this.schema=ze}validate(re){return typeof re=="undefined"?this.defaultValue:re}compute(re,_e,xe){return xe}}function m(X,re){return typeof X=="undefined"?re:X==="false"?!1:Boolean(X)}e.boolean=m;class f extends C{constructor(re,_e,xe,ze=void 0){typeof ze!="undefined"&&(ze.type="boolean",ze.default=xe),super(re,_e,xe,ze)}validate(re){return m(re,this.defaultValue)}}class a extends C{constructor(re,_e,xe,ze,$e,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="integer",Ye.default=xe,Ye.minimum=ze,Ye.maximum=$e),super(re,_e,xe,Ye),this.minimum=ze,this.maximum=$e}static clampedInt(re,_e,xe,ze){if(typeof re=="undefined")return _e;let $e=parseInt(re,10);return isNaN($e)?_e:($e=Math.max(xe,$e),$e=Math.min(ze,$e),$e|0)}validate(re){return a.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}class d extends C{constructor(re,_e,xe,ze,$e){typeof $e!="undefined"&&($e.type="number",$e.default=xe),super(re,_e,xe,$e),this.validationFn=ze}static clamp(re,_e,xe){return re<_e?_e:re>xe?xe:re}static float(re,_e){if(typeof re=="number")return re;if(typeof re=="undefined")return _e;const xe=parseFloat(re);return isNaN(xe)?_e:xe}validate(re){return this.validationFn(d.float(re,this.defaultValue))}}class E extends C{static string(re,_e){return typeof re!="string"?_e:re}constructor(re,_e,xe,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.default=xe),super(re,_e,xe,ze)}validate(re){return E.string(re,this.defaultValue)}}function w(X,re,_e){return typeof X!="string"||_e.indexOf(X)===-1?re:X}e.stringSet=w;class b extends C{constructor(re,_e,xe,ze,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=ze,$e.default=xe),super(re,_e,xe,$e),this._allowedValues=ze}validate(re){return w(re,this.defaultValue,this._allowedValues)}}class p extends i{constructor(re,_e,xe,ze,$e,Ye,K=void 0){typeof K!="undefined"&&(K.type="string",K.enum=$e,K.default=ze),super(re,_e,xe,K),this._allowedValues=$e,this._convert=Ye}validate(re){return typeof re!="string"?this.defaultValue:this._allowedValues.indexOf(re)===-1?this.defaultValue:this._convert(re)}}function c(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends i{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[_.localize(0,null),_.localize(1,null),_.localize(2,null)],default:"auto",description:_.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,_e,xe){return xe===0?re.accessibilitySupport:xe}}class t extends i{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:_.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:_.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{insertSpace:m(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(X){switch(X){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function l(X){switch(X){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class h extends T{constructor(){super(123,[62,31])}compute(re,_e,xe){const ze=["monaco-editor"];return _e.get(31)&&ze.push(_e.get(31)),re.extraEditorClassName&&ze.push(re.extraEditorClassName),_e.get(62)==="default"?ze.push("mouse-default"):_e.get(62)==="copy"&&ze.push("mouse-copy"),_e.get(97)&&ze.push("showUnused"),_e.get(121)&&ze.push("showDeprecated"),ze.join(" ")}}class S extends f{constructor(){super(30,"emptySelectionClipboard",!0,{description:_.localize(6,null)})}compute(re,_e,xe){return xe&&re.emptySelectionClipboard}}class u extends i{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:_.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:re.seedSearchStringFromSelection,description:_.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[_.localize(9,null),_.localize(10,null),_.localize(11,null)],description:_.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:_.localize(13,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:_.localize(14,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:_.localize(15,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{cursorMoveOnType:m(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:m(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":w(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(_e.loop,this.defaultValue.loop)}}}class v extends i{constructor(){super(41,"fontLigatures",v.OFF,{anyOf:[{type:"boolean",description:_.localize(16,null)},{type:"string",description:_.localize(17,null)}],description:_.localize(18,null),default:!1})}validate(re){return typeof re=="undefined"?this.defaultValue:typeof re=="string"?re==="false"?v.OFF:re==="true"?v.ON:re:Boolean(re)?v.ON:v.OFF}}e.EditorFontLigatures=v,v.OFF='"liga" off, "calt" off',v.ON='"liga" on, "calt" on';class R extends T{constructor(){super(40)}compute(re,_e,xe){return re.fontInfo}}class L extends C{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:_.localize(19,null)})}validate(re){let _e=d.float(re,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(_e,6,100)}compute(re,_e,xe){return re.fontInfo.fontSize}}class H extends i{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.MINIMUM_VALUE,maximum:H.MAXIMUM_VALUE,errorMessage:_.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:_.localize(21,null)})}validate(re){return re==="normal"||re==="bold"?re:String(a.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,H.MINIMUM_VALUE,H.MAXIMUM_VALUE))}}H.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],H.MINIMUM_VALUE=1,H.MAXIMUM_VALUE=1e3;class ie extends i{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[_.localize(22,null),_.localize(23,null),_.localize(24,null)]};super(47,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:_.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:_.localize(26,null)},_e),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:_.localize(27,null)},_e),"editor.gotoLocation.multipleDeclarations":Object.assign({description:_.localize(28,null)},_e),"editor.gotoLocation.multipleImplementations":Object.assign({description:_.localize(29,null)},_e),"editor.gotoLocation.multipleReferences":Object.assign({description:_.localize(30,null)},_e),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,description:_.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,description:_.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,description:_.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,description:_.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,description:_.localize(35,null)}})}validate(re){var _e,xe,ze,$e,Ye;if(!re||typeof re!="object")return this.defaultValue;const K=re;return{multiple:w(K.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(_e=K.multipleDefinitions)!==null&&_e!==void 0?_e:w(K.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(xe=K.multipleTypeDefinitions)!==null&&xe!==void 0?xe:w(K.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(ze=K.multipleDeclarations)!==null&&ze!==void 0?ze:w(K.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:($e=K.multipleImplementations)!==null&&$e!==void 0?$e:w(K.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ye=K.multipleReferences)!==null&&Ye!==void 0?Ye:w(K.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(K.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(K.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(K.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(K.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(K.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class j extends i{constructor(){const re={enabled:!0,delay:300,sticky:!0};super(50,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:_.localize(36,null)},"editor.hover.delay":{type:"number",default:re.delay,description:_.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:_.localize(38,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{enabled:m(_e.enabled,this.defaultValue.enabled),delay:a.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:m(_e.sticky,this.defaultValue.sticky)}}}var B;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class $ extends T{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(re,_e,xe){return $.computeLayout(_e,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio})}static computeContainedMinimapLineCount(re){const _e=re.height/re.lineHeight,xe=re.scrollBeyondLastLine?_e-1:0,ze=(re.viewLineCount+xe)/(re.pixelRatio*re.height),$e=Math.floor(re.viewLineCount/ze);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:xe,desiredRatio:ze,minimapLineCount:$e}}static _computeMinimapLayout(re,_e){const xe=re.outerWidth,ze=re.outerHeight,$e=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Ye=_e.stableMinimapLayoutInput,K=Ye&&re.outerHeight===Ye.outerHeight&&re.lineHeight===Ye.lineHeight&&re.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&re.pixelRatio===Ye.pixelRatio&&re.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&re.minimap.enabled===Ye.minimap.enabled&&re.minimap.side===Ye.minimap.side&&re.minimap.size===Ye.minimap.size&&re.minimap.showSlider===Ye.minimap.showSlider&&re.minimap.renderCharacters===Ye.minimap.renderCharacters&&re.minimap.maxColumn===Ye.minimap.maxColumn&&re.minimap.scale===Ye.minimap.scale&&re.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&re.isViewportWrapping===Ye.isViewportWrapping,oe=re.lineHeight,fe=re.typicalHalfwidthCharacterWidth,Z=re.scrollBeyondLastLine,ne=re.minimap.renderCharacters;let ce=$e>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const pe=re.minimap.maxColumn,Se=re.minimap.size,qe=re.minimap.side,Me=re.verticalScrollbarWidth,He=re.viewLineCount,Qe=re.remainingWidth,it=re.isViewportWrapping,at=ne?2:3;let Ze=Math.floor($e*ze);const nt=Ze/$e;let dt=!1,_t=!1,ue=at*ce,De=ce/$e,le=1;if(Se==="fill"||Se==="fit"){const{typicalViewportLineCount:rt,extraLinesBeyondLastLine:Ge,desiredRatio:ht,minimapLineCount:ot}=$.computeContainedMinimapLineCount({viewLineCount:He,scrollBeyondLastLine:Z,height:ze,lineHeight:oe,pixelRatio:$e});if(He/ot>1)dt=!0,_t=!0,ce=1,ue=1,De=ce/$e;else{let pt=!1,Et=ce+1;if(Se==="fit"){const yt=Math.ceil((He+Ge)*ue);it&&K&&Qe<=_e.stableFitRemainingWidth?(pt=!0,Et=_e.stableFitMaxMinimapScale):(pt=yt>Ze,it&&pt?(_e.stableMinimapLayoutInput=re,_e.stableFitRemainingWidth=Qe):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0))}if(Se==="fill"||pt){dt=!0;const yt=ce;ue=Math.min(oe*$e,Math.max(1,Math.floor(1/ht))),ce=Math.min(Et,Math.max(1,Math.floor(ue/at))),ce>yt&&(le=Math.min(2,ce/yt)),De=ce/$e/le,Ze=Math.ceil(Math.max(rt,He+Ge)*ue),it&&pt&&(_e.stableFitMaxMinimapScale=ce)}}}const Y=Math.floor(pe*De),Ne=Math.min(Y,Math.max(0,Math.floor((Qe-Me-2)*De/(fe+De)))+e.MINIMAP_GUTTER_WIDTH);let Te=Math.floor($e*Ne);const Je=Te/$e;Te=Math.floor(Te*le);const et=ne?1:2,ut=qe==="left"?0:xe-Ne-Me;return{renderMinimap:et,minimapLeft:ut,minimapWidth:Ne,minimapHeightIsEditorHeight:dt,minimapIsSampling:_t,minimapScale:ce,minimapLineHeight:ue,minimapCanvasInnerWidth:Te,minimapCanvasInnerHeight:Ze,minimapCanvasOuterWidth:Je,minimapCanvasOuterHeight:nt}}static computeLayout(re,_e){const xe=_e.outerWidth|0,ze=_e.outerHeight|0,$e=_e.lineHeight|0,Ye=_e.lineNumbersDigitCount|0,K=_e.typicalHalfwidthCharacterWidth,oe=_e.maxDigitWidth,fe=_e.pixelRatio,Z=_e.viewLineCount,ne=re.get(118),ce=ne==="inherit"?re.get(117):ne,pe=ce==="inherit"?re.get(113):ce,Se=re.get(116),qe=re.get(2),Me=_e.isDominatedByLongLines,He=re.get(46),Qe=re.get(56).renderType!==0,it=re.get(57),at=re.get(91),Ze=re.get(61),nt=re.get(89),dt=nt.verticalScrollbarSize,_t=nt.verticalHasArrows,ue=nt.arrowSize,De=nt.horizontalScrollbarSize,le=re.get(54),Y=re.get(35);let Ne;if(typeof le=="string"&&/^\d+(\.\d+)?ch$/.test(le)){const At=parseFloat(le.substr(0,le.length-2));Ne=a.clampedInt(At*K,0,0,1e3)}else Ne=a.clampedInt(le,0,0,1e3);Y&&(Ne+=16);let Te=0;if(Qe){const At=Math.max(Ye,it);Te=Math.round(At*oe)}let Je=0;He&&(Je=$e);let et=0,ut=et+Je,rt=ut+Te,Ge=rt+Ne;const ht=xe-Je-Te-Ne;let ot=!1,vt=!1,pt=-1;qe!==2&&(ce==="inherit"&&Me?(ot=!0,vt=!0):pe==="on"||pe==="bounded"?vt=!0:pe==="wordWrapColumn"&&(pt=Se));const Et=$._computeMinimapLayout({outerWidth:xe,outerHeight:ze,lineHeight:$e,typicalHalfwidthCharacterWidth:K,pixelRatio:fe,scrollBeyondLastLine:at,minimap:Ze,verticalScrollbarWidth:dt,viewLineCount:Z,remainingWidth:ht,isViewportWrapping:vt},_e.memory||new D);Et.renderMinimap!==0&&Et.minimapLeft===0&&(et+=Et.minimapWidth,ut+=Et.minimapWidth,rt+=Et.minimapWidth,Ge+=Et.minimapWidth);const yt=ht-Et.minimapWidth,It=Math.max(1,Math.floor((yt-dt-2)/K)),bt=_t?ue:0;return vt&&(pt=Math.max(1,It),pe==="bounded"&&(pt=Math.min(pt,Se))),{width:xe,height:ze,glyphMarginLeft:et,glyphMarginWidth:Je,lineNumbersLeft:ut,lineNumbersWidth:Te,decorationsLeft:rt,decorationsWidth:Ne,contentLeft:Ge,contentWidth:yt,minimap:Et,viewportColumn:It,isWordWrapMinified:ot,isViewportWrapping:vt,wrappingColumn:pt,verticalScrollbarWidth:dt,horizontalScrollbarHeight:De,overviewRuler:{top:bt,width:dt,height:ze-2*bt,right:0}}}}e.EditorLayoutInfoComputer=$;class N extends i{constructor(){const re={enabled:!0};super(53,"lightbulb",re,{"editor.lightbulb.enabled":{type:"boolean",default:re.enabled,description:_.localize(39,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:m(re.enabled,this.defaultValue.enabled)}}}class M extends i{constructor(){const re={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",re,{"editor.inlineHints.enabled":{type:"boolean",default:re.enabled,description:_.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:re.fontSize,description:_.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:re.fontFamily,description:_.localize(42,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{enabled:m(_e.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(_e.fontFamily,this.defaultValue.fontFamily)}}}class F extends a{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:_.localize(43,null)})}compute(re,_e,xe){return re.fontInfo.lineHeight}}class U extends i{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:_.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[_.localize(45,null),_.localize(46,null),_.localize(47,null)],default:re.size,description:_.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:_.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:_.localize(50,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:_.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:_.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:_.localize(53,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{enabled:m(_e.enabled,this.defaultValue.enabled),size:w(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(_e.side,this.defaultValue.side,["right","left"]),showSlider:w(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(_e.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(_e.scale,1,1,3),maxColumn:a.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(X){return X==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class W extends i{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(55,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{top:a.clampedInt(_e.top,0,0,1e3),bottom:a.clampedInt(_e.bottom,0,0,1e3)}}}class q extends i{constructor(){const re={enabled:!0,cycle:!1};super(72,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:_.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:_.localize(57,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{enabled:m(_e.enabled,this.defaultValue.enabled),cycle:m(_e.cycle,this.defaultValue.cycle)}}}class Q extends T{constructor(){super(124)}compute(re,_e,xe){return re.pixelRatio}}class he extends i{constructor(){const re={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",re,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:re.strings,description:_.localize(58,null)},comments:{type:"boolean",default:re.comments,description:_.localize(59,null)},other:{type:"boolean",default:re.other,description:_.localize(60,null)}}}],default:re,description:_.localize(61,null)});this.defaultValue=re}validate(re){if(typeof re=="boolean")return re;if(re&&typeof re=="object"){const _e=re,xe={other:m(_e.other,this.defaultValue.other),comments:m(_e.comments,this.defaultValue.comments),strings:m(_e.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var ve;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(ve=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ie extends i{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[_.localize(62,null),_.localize(63,null),_.localize(64,null),_.localize(65,null)],default:"on",description:_.localize(66,null)})}validate(re){let _e=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof re!="undefined"&&(typeof re=="function"?(_e=4,xe=re):re==="interval"?_e=3:re==="relative"?_e=2:re==="on"?_e=1:_e=0),{renderType:_e,renderFn:xe}}}function ke(X){const re=X.get(84);return re==="editable"?X.get(77):re!=="on"}e.filterValidationDecorations=ke;class Le extends i{constructor(){const re=[],_e={type:"number",description:_.localize(67,null)};super(88,"rulers",re,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:_.localize(68,null),format:"color-hex"}}}]},default:re,description:_.localize(69,null)})}validate(re){if(Array.isArray(re)){let _e=[];for(let xe of re)if(typeof xe=="number")_e.push({column:a.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const ze=xe;_e.push({column:a.clampedInt(ze.column,0,0,1e4),color:ze.color})}return _e.sort((xe,ze)=>xe.column-ze.column),_e}return this.defaultValue}}function V(X,re){if(typeof X!="string")return re;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class J extends i{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re,xe=a.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=a.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:V(_e.vertical,this.defaultValue.vertical),horizontal:V(_e.horizontal,this.defaultValue.horizontal),useShadows:m(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:a.clampedInt(_e.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:a.clampedInt(_e.verticalSliderSize,ze,0,1e3),scrollByPage:m(_e.scrollByPage,this.defaultValue.scrollByPage)}}}class ee extends i{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[_.localize(70,null),_.localize(71,null)],default:re.insertMode,description:_.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:_.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:_.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:_.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:_.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:_.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:_.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:_.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:_.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:_.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:_.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:_.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:_.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:_.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:_.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:_.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:_.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:_.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:_.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:_.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:_.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:_.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:_.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:_.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:_.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:_.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:_.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:_.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:_.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:_.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:_.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:_.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:_.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:_.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:_.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:_.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:_.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:_.localize(109,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{insertMode:w(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:m(_e.showIcons,this.defaultValue.showIcons),showStatusBar:m(_e.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:m(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(_e.showMethods,this.defaultValue.showMethods),showFunctions:m(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:m(_e.showConstructors,this.defaultValue.showConstructors),showFields:m(_e.showFields,this.defaultValue.showFields),showVariables:m(_e.showVariables,this.defaultValue.showVariables),showClasses:m(_e.showClasses,this.defaultValue.showClasses),showStructs:m(_e.showStructs,this.defaultValue.showStructs),showInterfaces:m(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:m(_e.showModules,this.defaultValue.showModules),showProperties:m(_e.showProperties,this.defaultValue.showProperties),showEvents:m(_e.showEvents,this.defaultValue.showEvents),showOperators:m(_e.showOperators,this.defaultValue.showOperators),showUnits:m(_e.showUnits,this.defaultValue.showUnits),showValues:m(_e.showValues,this.defaultValue.showValues),showConstants:m(_e.showConstants,this.defaultValue.showConstants),showEnums:m(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:m(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(_e.showKeywords,this.defaultValue.showKeywords),showWords:m(_e.showWords,this.defaultValue.showWords),showColors:m(_e.showColors,this.defaultValue.showColors),showFiles:m(_e.showFiles,this.defaultValue.showFiles),showReferences:m(_e.showReferences,this.defaultValue.showReferences),showFolders:m(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:m(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(_e.showSnippets,this.defaultValue.showSnippets),showUsers:m(_e.showUsers,this.defaultValue.showUsers),showIssues:m(_e.showIssues,this.defaultValue.showIssues)}}}class ae extends i{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:_.localize(110,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class we extends T{constructor(){super(125,[77])}compute(re,_e,xe){return _e.get(77)?!0:re.tabFocusMode}}var Ce;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Ce=e.WrappingIndent||(e.WrappingIndent={}));function Oe(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class be extends T{constructor(){super(127,[126])}compute(re,_e,xe){const ze=_e.get(126);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}const Pe="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?Re:k.isLinux?We:Pe,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Ee(X){return e.editorOptionsRegistry[X.id]=X,X}var Ke;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.codeLens=12]="codeLens",X[X.codeLensFontFamily=13]="codeLensFontFamily",X[X.codeLensFontSize=14]="codeLensFontSize",X[X.colorDecorators=15]="colorDecorators",X[X.columnSelection=16]="columnSelection",X[X.comments=17]="comments",X[X.contextmenu=18]="contextmenu",X[X.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",X[X.cursorBlinking=20]="cursorBlinking",X[X.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",X[X.cursorStyle=22]="cursorStyle",X[X.cursorSurroundingLines=23]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",X[X.cursorWidth=25]="cursorWidth",X[X.disableLayerHinting=26]="disableLayerHinting",X[X.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",X[X.domReadOnly=28]="domReadOnly",X[X.dragAndDrop=29]="dragAndDrop",X[X.emptySelectionClipboard=30]="emptySelectionClipboard",X[X.extraEditorClassName=31]="extraEditorClassName",X[X.fastScrollSensitivity=32]="fastScrollSensitivity",X[X.find=33]="find",X[X.fixedOverflowWidgets=34]="fixedOverflowWidgets",X[X.folding=35]="folding",X[X.foldingStrategy=36]="foldingStrategy",X[X.foldingHighlight=37]="foldingHighlight",X[X.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=39]="fontFamily",X[X.fontInfo=40]="fontInfo",X[X.fontLigatures=41]="fontLigatures",X[X.fontSize=42]="fontSize",X[X.fontWeight=43]="fontWeight",X[X.formatOnPaste=44]="formatOnPaste",X[X.formatOnType=45]="formatOnType",X[X.glyphMargin=46]="glyphMargin",X[X.gotoLocation=47]="gotoLocation",X[X.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",X[X.hover=50]="hover",X[X.inDiffEditor=51]="inDiffEditor",X[X.letterSpacing=52]="letterSpacing",X[X.lightbulb=53]="lightbulb",X[X.lineDecorationsWidth=54]="lineDecorationsWidth",X[X.lineHeight=55]="lineHeight",X[X.lineNumbers=56]="lineNumbers",X[X.lineNumbersMinChars=57]="lineNumbersMinChars",X[X.linkedEditing=58]="linkedEditing",X[X.links=59]="links",X[X.matchBrackets=60]="matchBrackets",X[X.minimap=61]="minimap",X[X.mouseStyle=62]="mouseStyle",X[X.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=64]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",X[X.multiCursorModifier=66]="multiCursorModifier",X[X.multiCursorPaste=67]="multiCursorPaste",X[X.occurrencesHighlight=68]="occurrencesHighlight",X[X.overviewRulerBorder=69]="overviewRulerBorder",X[X.overviewRulerLanes=70]="overviewRulerLanes",X[X.padding=71]="padding",X[X.parameterHints=72]="parameterHints",X[X.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",X[X.quickSuggestions=75]="quickSuggestions",X[X.quickSuggestionsDelay=76]="quickSuggestionsDelay",X[X.readOnly=77]="readOnly",X[X.renameOnType=78]="renameOnType",X[X.renderControlCharacters=79]="renderControlCharacters",X[X.renderIndentGuides=80]="renderIndentGuides",X[X.renderFinalNewline=81]="renderFinalNewline",X[X.renderLineHighlight=82]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=84]="renderValidationDecorations",X[X.renderWhitespace=85]="renderWhitespace",X[X.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",X[X.roundedSelection=87]="roundedSelection",X[X.rulers=88]="rulers",X[X.scrollbar=89]="scrollbar",X[X.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=91]="scrollBeyondLastLine",X[X.scrollPredominantAxis=92]="scrollPredominantAxis",X[X.selectionClipboard=93]="selectionClipboard",X[X.selectionHighlight=94]="selectionHighlight",X[X.selectOnLineNumbers=95]="selectOnLineNumbers",X[X.showFoldingControls=96]="showFoldingControls",X[X.showUnused=97]="showUnused",X[X.snippetSuggestions=98]="snippetSuggestions",X[X.smartSelect=99]="smartSelect",X[X.smoothScrolling=100]="smoothScrolling",X[X.stickyTabStops=101]="stickyTabStops",X[X.stopRenderingLineAfter=102]="stopRenderingLineAfter",X[X.suggest=103]="suggest",X[X.suggestFontSize=104]="suggestFontSize",X[X.suggestLineHeight=105]="suggestLineHeight",X[X.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",X[X.suggestSelection=107]="suggestSelection",X[X.tabCompletion=108]="tabCompletion",X[X.tabIndex=109]="tabIndex",X[X.unusualLineTerminators=110]="unusualLineTerminators",X[X.useTabStops=111]="useTabStops",X[X.wordSeparators=112]="wordSeparators",X[X.wordWrap=113]="wordWrap",X[X.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=116]="wordWrapColumn",X[X.wordWrapOverride1=117]="wordWrapOverride1",X[X.wordWrapOverride2=118]="wordWrapOverride2",X[X.wrappingIndent=119]="wrappingIndent",X[X.wrappingStrategy=120]="wrappingStrategy",X[X.showDeprecated=121]="showDeprecated",X[X.inlineHints=122]="inlineHints",X[X.editorClassName=123]="editorClassName",X[X.pixelRatio=124]="pixelRatio",X[X.tabFocusMode=125]="tabFocusMode",X[X.layoutInfo=126]="layoutInfo",X[X.wrappingInfo=127]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ee(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:_.localize(111,null)})),acceptSuggestionOnEnter:Ee(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",_.localize(112,null),""],markdownDescription:_.localize(113,null)})),accessibilitySupport:Ee(new g),accessibilityPageSize:Ee(new a(3,"accessibilityPageSize",10,1,1073741824,{description:_.localize(114,null)})),ariaLabel:Ee(new E(4,"ariaLabel",_.localize(115,null))),autoClosingBrackets:Ee(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(116,null),_.localize(117,null),""],description:_.localize(118,null)})),autoClosingDelete:Ee(new b(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",_.localize(119,null),""],description:_.localize(120,null)})),autoClosingOvertype:Ee(new b(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",_.localize(121,null),""],description:_.localize(122,null)})),autoClosingQuotes:Ee(new b(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(123,null),_.localize(124,null),""],description:_.localize(125,null)})),autoIndent:Ee(new p(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[_.localize(126,null),_.localize(127,null),_.localize(128,null),_.localize(129,null),_.localize(130,null)],description:_.localize(131,null)})),automaticLayout:Ee(new f(10,"automaticLayout",!1)),autoSurround:Ee(new b(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[_.localize(132,null),_.localize(133,null),_.localize(134,null),""],description:_.localize(135,null)})),stickyTabStops:Ee(new f(101,"stickyTabStops",!1,{description:_.localize(136,null)})),codeLens:Ee(new f(12,"codeLens",!0,{description:_.localize(137,null)})),codeLensFontFamily:Ee(new E(13,"codeLensFontFamily","",{description:_.localize(138,null)})),codeLensFontSize:Ee(new a(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:_.localize(139,null)})),colorDecorators:Ee(new f(15,"colorDecorators",!0,{description:_.localize(140,null)})),columnSelection:Ee(new f(16,"columnSelection",!1,{description:_.localize(141,null)})),comments:Ee(new t),contextmenu:Ee(new f(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Ee(new f(19,"copyWithSyntaxHighlighting",!0,{description:_.localize(142,null)})),cursorBlinking:Ee(new p(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:_.localize(143,null)})),cursorSmoothCaretAnimation:Ee(new f(21,"cursorSmoothCaretAnimation",!1,{description:_.localize(144,null)})),cursorStyle:Ee(new p(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],l,{description:_.localize(145,null)})),cursorSurroundingLines:Ee(new a(23,"cursorSurroundingLines",0,0,1073741824,{description:_.localize(146,null)})),cursorSurroundingLinesStyle:Ee(new b(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[_.localize(147,null),_.localize(148,null)],description:_.localize(149,null)})),cursorWidth:Ee(new a(25,"cursorWidth",0,0,1073741824,{markdownDescription:_.localize(150,null)})),disableLayerHinting:Ee(new f(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ee(new f(27,"disableMonospaceOptimizations",!1)),domReadOnly:Ee(new f(28,"domReadOnly",!1)),dragAndDrop:Ee(new f(29,"dragAndDrop",!0,{description:_.localize(151,null)})),emptySelectionClipboard:Ee(new S),extraEditorClassName:Ee(new E(31,"extraEditorClassName","")),fastScrollSensitivity:Ee(new d(32,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:_.localize(152,null)})),find:Ee(new u),fixedOverflowWidgets:Ee(new f(34,"fixedOverflowWidgets",!1)),folding:Ee(new f(35,"folding",!0,{description:_.localize(153,null)})),foldingStrategy:Ee(new b(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[_.localize(154,null),_.localize(155,null)],description:_.localize(156,null)})),foldingHighlight:Ee(new f(37,"foldingHighlight",!0,{description:_.localize(157,null)})),unfoldOnClickAfterEndOfLine:Ee(new f(38,"unfoldOnClickAfterEndOfLine",!1,{description:_.localize(158,null)})),fontFamily:Ee(new E(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:_.localize(159,null)})),fontInfo:Ee(new R),fontLigatures2:Ee(new v),fontSize:Ee(new L),fontWeight:Ee(new H),formatOnPaste:Ee(new f(44,"formatOnPaste",!1,{description:_.localize(160,null)})),formatOnType:Ee(new f(45,"formatOnType",!1,{description:_.localize(161,null)})),glyphMargin:Ee(new f(46,"glyphMargin",!0,{description:_.localize(162,null)})),gotoLocation:Ee(new ie),hideCursorInOverviewRuler:Ee(new f(48,"hideCursorInOverviewRuler",!1,{description:_.localize(163,null)})),highlightActiveIndentGuide:Ee(new f(49,"highlightActiveIndentGuide",!0,{description:_.localize(164,null)})),hover:Ee(new j),inDiffEditor:Ee(new f(51,"inDiffEditor",!1)),letterSpacing:Ee(new d(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>d.clamp(X,-5,20),{description:_.localize(165,null)})),lightbulb:Ee(new N),lineDecorationsWidth:Ee(new C(54,"lineDecorationsWidth",10)),lineHeight:Ee(new F),lineNumbers:Ee(new Ie),lineNumbersMinChars:Ee(new a(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Ee(new f(58,"linkedEditing",!1,{description:_.localize(166,null)})),links:Ee(new f(59,"links",!0,{description:_.localize(167,null)})),matchBrackets:Ee(new b(60,"matchBrackets","always",["always","near","never"],{description:_.localize(168,null)})),minimap:Ee(new U),mouseStyle:Ee(new b(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ee(new d(63,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:_.localize(169,null)})),mouseWheelZoom:Ee(new f(64,"mouseWheelZoom",!1,{markdownDescription:_.localize(170,null)})),multiCursorMergeOverlapping:Ee(new f(65,"multiCursorMergeOverlapping",!0,{description:_.localize(171,null)})),multiCursorModifier:Ee(new p(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[_.localize(172,null),_.localize(173,null)],markdownDescription:_.localize(174,null)})),multiCursorPaste:Ee(new b(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[_.localize(175,null),_.localize(176,null)],markdownDescription:_.localize(177,null)})),occurrencesHighlight:Ee(new f(68,"occurrencesHighlight",!0,{description:_.localize(178,null)})),overviewRulerBorder:Ee(new f(69,"overviewRulerBorder",!0,{description:_.localize(179,null)})),overviewRulerLanes:Ee(new a(70,"overviewRulerLanes",3,0,3)),padding:Ee(new W),parameterHints:Ee(new q),peekWidgetDefaultFocus:Ee(new b(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[_.localize(180,null),_.localize(181,null)],description:_.localize(182,null)})),definitionLinkOpensInPeek:Ee(new f(74,"definitionLinkOpensInPeek",!1,{description:_.localize(183,null)})),quickSuggestions:Ee(new he),quickSuggestionsDelay:Ee(new a(76,"quickSuggestionsDelay",10,0,1073741824,{description:_.localize(184,null)})),readOnly:Ee(new f(77,"readOnly",!1)),renameOnType:Ee(new f(78,"renameOnType",!1,{description:_.localize(185,null),markdownDeprecationMessage:_.localize(186,null)})),renderControlCharacters:Ee(new f(79,"renderControlCharacters",!1,{description:_.localize(187,null)})),renderIndentGuides:Ee(new f(80,"renderIndentGuides",!0,{description:_.localize(188,null)})),renderFinalNewline:Ee(new f(81,"renderFinalNewline",!0,{description:_.localize(189,null)})),renderLineHighlight:Ee(new b(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",_.localize(190,null)],description:_.localize(191,null)})),renderLineHighlightOnlyWhenFocus:Ee(new f(83,"renderLineHighlightOnlyWhenFocus",!1,{description:_.localize(192,null)})),renderValidationDecorations:Ee(new b(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ee(new b(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",_.localize(193,null),_.localize(194,null),_.localize(195,null),""],description:_.localize(196,null)})),revealHorizontalRightPadding:Ee(new a(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ee(new f(87,"roundedSelection",!0,{description:_.localize(197,null)})),rulers:Ee(new Le),scrollbar:Ee(new J),scrollBeyondLastColumn:Ee(new a(90,"scrollBeyondLastColumn",5,0,1073741824,{description:_.localize(198,null)})),scrollBeyondLastLine:Ee(new f(91,"scrollBeyondLastLine",!0,{description:_.localize(199,null)})),scrollPredominantAxis:Ee(new f(92,"scrollPredominantAxis",!0,{description:_.localize(200,null)})),selectionClipboard:Ee(new f(93,"selectionClipboard",!0,{description:_.localize(201,null),included:k.isLinux})),selectionHighlight:Ee(new f(94,"selectionHighlight",!0,{description:_.localize(202,null)})),selectOnLineNumbers:Ee(new f(95,"selectOnLineNumbers",!0)),showFoldingControls:Ee(new b(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[_.localize(203,null),_.localize(204,null)],description:_.localize(205,null)})),showUnused:Ee(new f(97,"showUnused",!0,{description:_.localize(206,null)})),showDeprecated:Ee(new f(121,"showDeprecated",!0,{description:_.localize(207,null)})),inlineHints:Ee(new M),snippetSuggestions:Ee(new b(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[_.localize(208,null),_.localize(209,null),_.localize(210,null),_.localize(211,null)],description:_.localize(212,null)})),smartSelect:Ee(new ae),smoothScrolling:Ee(new f(100,"smoothScrolling",!1,{description:_.localize(213,null)})),stopRenderingLineAfter:Ee(new a(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ee(new ee),suggestFontSize:Ee(new a(104,"suggestFontSize",0,0,1e3,{markdownDescription:_.localize(214,null)})),suggestLineHeight:Ee(new a(105,"suggestLineHeight",0,0,1e3,{markdownDescription:_.localize(215,null)})),suggestOnTriggerCharacters:Ee(new f(106,"suggestOnTriggerCharacters",!0,{description:_.localize(216,null)})),suggestSelection:Ee(new b(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[_.localize(217,null),_.localize(218,null),_.localize(219,null)],description:_.localize(220,null)})),tabCompletion:Ee(new b(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[_.localize(221,null),_.localize(222,null),_.localize(223,null)],description:_.localize(224,null)})),tabIndex:Ee(new a(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ee(new b(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[_.localize(225,null),_.localize(226,null),_.localize(227,null)],description:_.localize(228,null)})),useTabStops:Ee(new f(111,"useTabStops",!0,{description:_.localize(229,null)})),wordSeparators:Ee(new E(112,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:_.localize(230,null)})),wordWrap:Ee(new b(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[_.localize(231,null),_.localize(232,null),_.localize(233,null),_.localize(234,null)],description:_.localize(235,null)})),wordWrapBreakAfterCharacters:Ee(new E(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ee(new E(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ee(new a(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:_.localize(236,null)})),wordWrapOverride1:Ee(new b(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ee(new b(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ee(new p(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[_.localize(237,null),_.localize(238,null),_.localize(239,null),_.localize(240,null)],description:_.localize(241,null)})),wrappingStrategy:Ee(new b(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[_.localize(242,null),_.localize(243,null)],description:_.localize(244,null)})),editorClassName:Ee(new h),pixelRatio:Ee(new Q),tabFocusMode:Ee(new we),layoutInfo:Ee(new $),wrappingInfo:Ee(new be)}}),define(me[152],ge([16,17]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[153],ge([16,17]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[154],ge([16,17]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[155],ge([16,17]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(me[156],ge([16,17]),function(G,e){return G.create("vs/platform/markers/common/markers",e)}),define(me[157],ge([16,17]),function(G,e){return G.create("vs/platform/theme/common/iconRegistry",e)}),define(me[158],ge([16,17]),function(G,e){return G.create("vs/platform/workspaces/common/workspaces",e)}),define(me[159],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHost.api.impl",e)}),define(me[160],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[161],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(me[162],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[163],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostProgress",e)}),define(me[164],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[165],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[166],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[167],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[168],ge([16,17]),function(G,e){return G.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[169],ge([16,17]),function(G,e){return G.create("vs/workbench/common/views",e)}),define(me[170],ge([16,17]),function(G,e){return G.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[171],ge([16,17]),function(G,e){return G.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[172],ge([16,17]),function(G,e){return G.create("vs/workbench/contrib/externalTerminal/node/externalTerminalService",e)}),define(me[173],ge([16,17]),function(G,e){return G.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[174],ge([16,17]),function(G,e){return G.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[175],ge([16,17]),function(G,e){return G.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[176],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var _;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(_=e.EditorActivation||(e.EditorActivation={}));var k;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(k=e.EditorOverride||(e.EditorOverride={}));var A;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(A=e.EditorOpenContext||(e.EditorOpenContext={}));var I;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(I=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[177],ge([0,1,154]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(C){return C=C.trim(),C==="*"||k.test(C)}e.isValidVersionStr=A;function I(C){if(!A(C))return null;if(C=C.trim(),C==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=C.match(k);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=I;function y(C){if(!C)return null;let m=C.majorBase,f=C.majorMustEqual,a=C.minorBase,d=C.minorMustEqual,E=C.patchBase,w=C.patchMustEqual;return C.hasCaret&&(m===0||(d=!1),w=!1),{majorBase:m,majorMustEqual:f,minorBase:a,minorMustEqual:d,patchBase:E,patchMustEqual:w,isMinimum:C.hasGreaterEquals}}e.normalizeVersion=y;function P(C,m){let f;typeof C=="string"?f=y(I(C)):f=C;let a;if(typeof m=="string"?a=y(I(m)):a=m,!f||!a)return!1;let d=f.majorBase,E=f.minorBase,w=f.patchBase,b=a.majorBase,p=a.minorBase,c=a.patchBase,g=a.majorMustEqual,t=a.minorMustEqual,n=a.patchMustEqual;return a.isMinimum?d>b?!0:d<b?!1:E>p?!0:E<p?!1:w>=c:(d===1&&b===0&&(!g||!t||!n)&&(b=1,p=0,c=0,g=!0,t=!1,n=!1),d<b?!1:d>b?!g:E<p?!1:E>p?!t:w<c?!1:w>c?!n:!0)}e.isValidVersion=P;function D(C,m,f){return m.isBuiltin||typeof m.main=="undefined"?!0:T(C,m.engines.vscode,f)}e.isValidExtensionVersion=D;function i(C,m){return C==="*"||T(m,C)}e.isEngineValid=i;function T(C,m,f=[]){let a=y(I(m));if(!a)return f.push(_.localize(0,null,m)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return f.push(_.localize(1,null,m)),!1}else if(!a.majorMustEqual)return f.push(_.localize(2,null,m)),!1;return P(C,a)?!0:(f.push(_.localize(3,null,C,m)),!1)}e.isVersionValid=T}),define(me[111],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class _{constructor(I,y=[],P=!1){this.ctor=I,this.staticArguments=y,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=_;const k=(A,...I)=>new _(A,I);e.createSyncDescriptor=k}),define(me[79],ge([0,1,111]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function A(y,P,D){P instanceof _.SyncDescriptor||(P=new _.SyncDescriptor(P,[],D)),k.push([y,P])}e.registerSingleton=A;function I(){return k}e.getSingletonServiceDescriptors=I}),define(me[178],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}e.Node=_;class k{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let y of this._nodes.values())y.outgoing.size===0&&I.push(y);return I}insertEdge(I,y){const P=this.lookupOrInsertNode(I),D=this.lookupOrInsertNode(y);P.outgoing.set(this._hashFn(y),D),D.incoming.set(this._hashFn(I),P)}removeNode(I){const y=this._hashFn(I);this._nodes.delete(y);for(let P of this._nodes.values())P.outgoing.delete(y),P.incoming.delete(y)}lookupOrInsertNode(I){const y=this._hashFn(I);let P=this._nodes.get(y);return P||(P=new _(I),this._nodes.set(y,P)),P}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[y,P]of this._nodes)I.push(`${y}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return I.join(`
`)}findCycleSlow(){for(let[I,y]of this._nodes){const P=new Set([I]),D=this._findCycle(y,P);if(D)return D}}_findCycle(I,y){for(let[P,D]of I.outgoing){if(y.has(P))return[...y,P].join(" -> ");y.add(P);const i=this._findCycle(D,y);if(i)return i;y.delete(P)}}}e.Graph=k}),define(me[4],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var _;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function D(i){return i[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=D})(_=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function k(P,D,i,T){D[_.DI_TARGET]===D?D[_.DI_DEPENDENCIES].push({id:P,index:i,optional:T}):(D[_.DI_DEPENDENCIES]=[{id:P,index:i,optional:T}],D[_.DI_TARGET]=D)}function A(P){if(_.serviceIds.has(P))return _.serviceIds.get(P);const D=function(i,T,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(D,i,C,!1)};return D.toString=()=>P,_.serviceIds.set(P,D),D}e.createDecorator=A;function I(P){return P}e.refineServiceDecorator=I;function y(P){return function(D,i,T){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(P,D,T,!0)}}e.optional=y}),define(me[179],ge([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,_.createDecorator)("modelService");function k(A){return!A.isTooLargeForSyncing()&&!A.isForSimpleWidget}e.shouldSynchronizeModel=k}),define(me[180],ge([0,1,3,74,6,24,73,77,179]),function(G,e,_,k,A,I,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function i(m){return typeof m=="string"?!1:Array.isArray(m)?m.every(i):!!m.exclusive}class T{constructor(){this._clock=0,this._entries=[],this._onDidChange=new _.Emitter}get onDidChange(){return this._onDidChange.event}register(f,a){let d={selector:f,provider:a,_score:-1,_time:this._clock++};return this._entries.push(d),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,A.toDisposable)(()=>{if(d){let E=this._entries.indexOf(d);E>=0&&(this._entries.splice(E,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),d=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const a=[];for(let d of this._entries)d._score>0&&a.push(d.provider);return a}ordered(f){const a=[];return this._orderedForEach(f,d=>a.push(d.provider)),a}orderedGroups(f){const a=[];let d,E;return this._orderedForEach(f,w=>{d&&E===w._score?d.push(w.provider):(E=w._score,d=[w.provider],a.push(d))}),a}_orderedForEach(f,a){if(!!f){this._updateScores(f);for(const d of this._entries)d._score>0&&a(d)}}_updateScores(f){let a={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let d of this._entries)if(d._score=(0,P.score)(d.selector,f.uri,f.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(f)),i(d.selector)&&d._score>0){for(let E of this._entries)E._score=0;d._score=1e3;break}this._entries.sort(T._compareByScoreAndTime)}}static _compareByScoreAndTime(f,a){return f._score<a._score?1:f._score>a._score?-1:f._time<a._time?1:f._time>a._time?-1:0}}e.LanguageFeatureRegistry=T;class C{constructor(f,a,d=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=a,this.max=d,this._cache=new I.LRUCache(50,.7)}_key(f){return f.id+(0,k.hash)(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const a=this._key(f),d=this._cache.get(a);return this._clamp(d==null?void 0:d.value)}update(f,a){const d=this._key(f);let E=this._cache.get(d);return E||(E=new y.MovingAverage,this._cache.set(d,E)),E.update(a),this.get(f)}}e.LanguageFeatureRequestDelays=C}),define(me[80],ge([0,1,2,44,180,143,43]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var P;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));class D{constructor(v,R){this.language=v,this.id=R}}e.LanguageIdentifier=D;var i;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline"})(i=e.FontStyle||(e.FontStyle={}));var T;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var C;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var m;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=2048]="ITALIC_MASK",u[u.BOLD_MASK=4096]="BOLD_MASK",u[u.UNDERLINE_MASK=8192]="UNDERLINE_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(m=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(v){return(v&255)>>>0}static getTokenType(v){return(v&1792)>>>8}static getFontStyle(v){return(v&14336)>>>11}static getForeground(v){return(v&8372224)>>>14}static getBackground(v){return(v&4286578688)>>>23}static getClassNameFromMetadata(v){let R=this.getForeground(v),L="mtk"+R,H=this.getFontStyle(v);return H&1&&(L+=" mtki"),H&2&&(L+=" mtkb"),H&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(v,R){const L=this.getForeground(v),H=this.getFontStyle(v);let ie=`color: ${R[L]};`;return H&1&&(ie+="font-style: italic;"),H&2&&(ie+="font-weight: bold;"),H&4&&(ie+="text-decoration: underline;"),ie}}e.TokenMetadata=f;var a;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let u=Object.create(null);return u[0]="symbol-method",u[1]="symbol-function",u[2]="symbol-constructor",u[3]="symbol-field",u[4]="symbol-variable",u[5]="symbol-class",u[6]="symbol-struct",u[7]="symbol-interface",u[8]="symbol-module",u[9]="symbol-property",u[10]="symbol-event",u[11]="symbol-operator",u[12]="symbol-unit",u[13]="symbol-value",u[14]="symbol-constant",u[15]="symbol-enum",u[16]="symbol-enum-member",u[17]="symbol-keyword",u[27]="symbol-snippet",u[18]="symbol-text",u[19]="symbol-color",u[20]="symbol-file",u[21]="symbol-reference",u[22]="symbol-customcolor",u[23]="symbol-folder",u[24]="symbol-type-parameter",u[25]="account",u[26]="issues",function(v){const R=u[v];let L=R&&y.iconRegistry.get(R);return L||(console.info("No codicon found for CompletionItemKind "+v),L=y.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let u=Object.create(null);return u.method=0,u.function=1,u.constructor=2,u.field=3,u.variable=4,u.class=5,u.struct=6,u.interface=7,u.module=8,u.property=9,u.event=10,u.operator=11,u.unit=12,u.value=13,u.constant=14,u.enum=15,u["enum-member"]=16,u.enumMember=16,u.keyword=17,u.snippet=27,u.text=18,u.color=19,u.file=20,u.reference=21,u.customcolor=22,u.folder=23,u["type-parameter"]=24,u.typeParameter=24,u.account=25,u.issue=26,function(v,R){let L=u[v];return typeof L=="undefined"&&!R&&(L=9),L}}();var d;(function(u){u[u.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var c;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(c=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function g(u){return u&&_.URI.isUri(u.uri)&&k.Range.isIRange(u.range)&&(k.Range.isIRange(u.originSelectionRange)||k.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=g;var t;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(u){u[u.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var s;(function(u){const v=new Map;v.set("file",0),v.set("module",1),v.set("namespace",2),v.set("package",3),v.set("class",4),v.set("method",5),v.set("property",6),v.set("field",7),v.set("constructor",8),v.set("enum",9),v.set("interface",10),v.set("function",11),v.set("variable",12),v.set("constant",13),v.set("string",14),v.set("number",15),v.set("boolean",16),v.set("array",17),v.set("object",18),v.set("key",19),v.set("null",20),v.set("enum-member",21),v.set("struct",22),v.set("event",23),v.set("operator",24),v.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function L(j){return v.get(j)}u.fromString=L;function H(j){return R.get(j)}u.toString=H;function ie(j,B){const $=R.get(j);let N=$&&y.iconRegistry.get("symbol-"+$);return N||(console.info("No codicon found for SymbolKind "+j),N=y.Codicon.symbolProperty),`${B?"inline":"block"} ${N.classNames}`}u.toCssClassName=ie})(s=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(v){this.value=v}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var o;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(o=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var h;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(h=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new A.LanguageFeatureRegistry,e.RenameProviderRegistry=new A.LanguageFeatureRegistry,e.CompletionProviderRegistry=new A.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new A.LanguageFeatureRegistry,e.HoverProviderRegistry=new A.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new A.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new A.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new A.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new A.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new A.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new A.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.LinkProviderRegistry=new A.LanguageFeatureRegistry,e.ColorProviderRegistry=new A.LanguageFeatureRegistry,e.SelectionRangeRegistry=new A.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.TokenizationRegistry=new I.TokenizationRegistryImpl;var S;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(S=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[181],ge([0,1,6,12,4,3,56,54]),function(G,e,_,k,A,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,A.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new I.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,i){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!i)throw new Error("invalid command");return this.registerCommand({id:D,handler:i})}if(D.description){const a=[];for(let E of D.description.args)a.push(E.constraint);const d=D.handler;D.handler=function(E,...w){return(0,k.validateConstraints)(w,a),d(E,...w)}}const{id:T}=D;let C=this._commands.get(T);C||(C=new y.LinkedList,this._commands.set(T,C));let m=C.unshift(D),f=(0,_.toDisposable)(()=>{m();const a=this._commands.get(T);(a==null?void 0:a.isEmpty())&&this._commands.delete(T)});return this._onDidRegisterCommand.fire(T),f}registerCommandAlias(D,i){return e.CommandsRegistry.registerCommand(D,(T,...C)=>T.get(e.ICommandService).executeCommand(i,...C))}getCommand(D){const i=this._commands.get(D);if(!(!i||i.isEmpty()))return P.Iterable.first(i)}getCommands(){const D=new Map;for(const i of this._commands.keys()){const T=this.getCommand(i);T&&D.set(i,T)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>_.Disposable.None,onDidExecuteCommand:()=>_.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(me[81],ge([0,1,10,4,9]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let I=A.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",A.isMacintosh),y.set("isLinux",A.isLinux),y.set("isWindows",A.isWindows),y.set("isWeb",A.isWeb),y.set("isMacNative",A.isMacintosh&&!A.isWeb),y.set("isEdge",I.indexOf("Edg/")>=0),y.set("isFirefox",I.indexOf("Firefox")>=0),y.set("isChrome",I.indexOf("Chrome")>=0),y.set("isSafari",I.indexOf("Safari")>=0),y.set("isIPad",I.indexOf("iPad")>=0);const P=Object.prototype.hasOwnProperty;var D;(function(u){u[u.False=0]="False",u[u.True=1]="True",u[u.Defined=2]="Defined",u[u.Not=3]="Not",u[u.Equals=4]="Equals",u[u.NotEquals=5]="NotEquals",u[u.And=6]="And",u[u.Regex=7]="Regex",u[u.NotRegex=8]="NotRegex",u[u.Or=9]="Or",u[u.In=10]="In",u[u.NotIn=11]="NotIn",u[u.Greater=12]="Greater",u[u.GreaterEquals=13]="GreaterEquals",u[u.Smaller=14]="Smaller",u[u.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class i{static false(){return C.INSTANCE}static true(){return m.INSTANCE}static has(v){return f.create(v)}static equals(v,R){return a.create(v,R)}static notEquals(v,R){return w.create(v,R)}static regex(v,R){return n.create(v,R)}static in(v,R){return d.create(v,R)}static not(v){return b.create(v)}static and(...v){return r.create(v)}static or(...v){return o.create(v)}static greater(v,R){return p.create(v,R)}static less(v,R){return g.create(v,R)}static deserialize(v,R=!1){if(!!v)return this._deserializeOrExpression(v,R)}static _deserializeOrExpression(v,R){let L=v.split("||");return o.create(L.map(H=>this._deserializeAndExpression(H,R)))}static _deserializeAndExpression(v,R){let L=v.split("&&");return r.create(L.map(H=>this._deserializeOne(H,R)))}static _deserializeOne(v,R){if(v=v.trim(),v.indexOf("!=")>=0){let L=v.split("!=");return w.create(L[0].trim(),this._deserializeValue(L[1],R))}if(v.indexOf("==")>=0){let L=v.split("==");return a.create(L[0].trim(),this._deserializeValue(L[1],R))}if(v.indexOf("=~")>=0){let L=v.split("=~");return n.create(L[0].trim(),this._deserializeRegexValue(L[1],R))}if(v.indexOf(" in ")>=0){let L=v.split(" in ");return d.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(v)){const L=v.split(">=");return c.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(v)){const L=v.split(">");return p.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(v)){const L=v.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(v)){const L=v.split("<");return g.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(v)?b.create(v.substr(1).trim()):f.create(v)}static _deserializeValue(v,R){if(v=v.trim(),v==="true")return!0;if(v==="false")return!1;let L=/^'([^']*)'$/.exec(v);return L?L[1].trim():v}static _deserializeRegexValue(v,R){if((0,_.isFalsyOrWhitespace)(v)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=v.indexOf("/"),H=v.lastIndexOf("/");if(L===H||L<0){if(R)throw new Error(`bad regexp-value '${v}', missing /-enclosure`);return console.warn(`bad regexp-value '${v}', missing /-enclosure`),null}let ie=v.slice(L+1,H),j=v[H+1]==="i"?"i":"";try{return new RegExp(ie,j)}catch(B){if(R)throw new Error(`bad regexp-value '${v}', parse error: ${B}`);return console.warn(`bad regexp-value '${v}', parse error: ${B}`),null}}}e.ContextKeyExpr=i;function T(u,v){return u.cmp(v)}class C{constructor(){this.type=0}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}evaluate(v){return!1}serialize(){return"false"}keys(){return[]}map(v){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class m{constructor(){this.type=1}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}evaluate(v){return!0}serialize(){return"true"}keys(){return[]}map(v){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class f{constructor(v){this.key=v,this.type=2}static create(v){const R=y.get(v);return typeof R=="boolean"?R?m.INSTANCE:C.INSTANCE:new f(v)}cmp(v){return v.type!==this.type?this.type-v.type:h(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}evaluate(v){return!!v.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(v){return v.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=f;class a{constructor(v,R){this.key=v,this.value=R,this.type=4}static create(v,R){if(typeof R=="boolean")return R?f.create(v):b.create(v);const L=y.get(v);return typeof L=="boolean"?R===(L?"true":"false")?m.INSTANCE:C.INSTANCE:new a(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return v.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(v){return v.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class d{constructor(v,R){this.key=v,this.valueKey=R,this.type=10}static create(v,R){return new d(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.valueKey,v.key,v.valueKey)}equals(v){return v.type===this.type?this.key===v.key&&this.valueKey===v.valueKey:!1}evaluate(v){const R=v.getValue(this.valueKey),L=v.getValue(this.key);return Array.isArray(R)?R.indexOf(L)>=0:typeof L=="string"&&typeof R=="object"&&R!==null?P.call(R,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(v){return v.mapIn(this.key,this.valueKey)}negate(){return E.create(this)}}e.ContextKeyInExpr=d;class E{constructor(v){this._actual=v,this.type=11}static create(v){return new E(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new E(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class w{constructor(v,R){this.key=v,this.value=R,this.type=5}static create(v,R){if(typeof R=="boolean")return R?b.create(v):f.create(v);const L=y.get(v);return typeof L=="boolean"?R===(L?"true":"false")?C.INSTANCE:m.INSTANCE:new w(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return v.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(v){return v.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class b{constructor(v){this.key=v,this.type=3}static create(v){const R=y.get(v);return typeof R=="boolean"?R?C.INSTANCE:m.INSTANCE:new b(v)}cmp(v){return v.type!==this.type?this.type-v.type:h(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}evaluate(v){return!v.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(v){return v.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=b;class p{constructor(v,R){this.key=v,this.value=R,this.type=12}static create(v,R){return new p(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=p;class c{constructor(v,R){this.key=v,this.value=R,this.type=13}static create(v,R){return new c(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreaterEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class g{constructor(v,R){this.key=v,this.value=R,this.type=14}static create(v,R){return new g(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=g;class t{constructor(v,R){this.key=v,this.value=R,this.type=15}static create(v,R){return new t(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmallerEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(v,R){this.key=v,this.regexp=R,this.type=7}static create(v,R){return new n(v,R)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.key<v.key)return-1;if(this.key>v.key)return 1;const R=this.regexp?this.regexp.source:"",L=v.regexp?v.regexp.source:"";return R<L?-1:R>L?1:0}equals(v){if(v.type===this.type){const R=this.regexp?this.regexp.source:"",L=v.regexp?v.regexp.source:"";return this.key===v.key&&R===L}return!1}evaluate(v){let R=v.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const v=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${v}`}keys(){return[this.key]}map(v){return v.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=n;class s{constructor(v){this._actual=v,this.type=8}static create(v){return new s(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new s(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class r{constructor(v){this.expr=v,this.type=6}static create(v){return r._normalizeArr(v)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let R=0,L=this.expr.length;R<L;R++){const H=T(this.expr[R],v.expr[R]);if(H!==0)return H}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let R=0,L=this.expr.length;R<L;R++)if(!this.expr[R].equals(v.expr[R]))return!1;return!0}return!1}evaluate(v){for(let R=0,L=this.expr.length;R<L;R++)if(!this.expr[R].evaluate(v))return!1;return!0}static _normalizeArr(v){const R=[];let L=!1;for(const H of v)if(!!H){if(H.type===1){L=!0;continue}if(H.type===0)return C.INSTANCE;if(H.type===6){R.push(...H.expr);continue}R.push(H)}if(R.length===0&&L)return m.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(T);R.length>1;){const H=R[R.length-1];if(H.type!==9)break;R.pop();const ie=R.pop(),j=o.create(H.expr.map(B=>r.create([B,ie])));j&&(R.push(j),R.sort(T))}return R.length===1?R[0]:new r(R)}}serialize(){return this.expr.map(v=>v.serialize()).join(" && ")}keys(){const v=[];for(let R of this.expr)v.push(...R.keys());return v}map(v){return new r(this.expr.map(R=>R.map(v)))}negate(){let v=[];for(let R of this.expr)v.push(R.negate());return o.create(v)}}e.ContextKeyAndExpr=r;class o{constructor(v){this.expr=v,this.type=9}static create(v){const R=o._normalizeArr(v);if(R.length!==0)return R.length===1?R[0]:new o(R)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let R=0,L=this.expr.length;R<L;R++){const H=T(this.expr[R],v.expr[R]);if(H!==0)return H}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let R=0,L=this.expr.length;R<L;R++)if(!this.expr[R].equals(v.expr[R]))return!1;return!0}return!1}evaluate(v){for(let R=0,L=this.expr.length;R<L;R++)if(this.expr[R].evaluate(v))return!0;return!1}static _normalizeArr(v){let R=[],L=!1;if(v){for(let H=0,ie=v.length;H<ie;H++){const j=v[H];if(!!j){if(j.type===0){L=!0;continue}if(j.type===1)return[m.INSTANCE];if(j.type===9){R=R.concat(j.expr);continue}R.push(j)}}if(R.length===0&&L)return[C.INSTANCE];R.sort(T)}return R}serialize(){return this.expr.map(v=>v.serialize()).join(" || ")}keys(){const v=[];for(let R of this.expr)v.push(...R.keys());return v}map(v){return new o(this.expr.map(R=>R.map(v)))}negate(){let v=[];for(let L of this.expr)v.push(L.negate());const R=L=>L.type===9?L.expr:[L];for(;v.length>1;){const L=v.shift(),H=v.shift(),ie=[];for(const j of R(L))for(const B of R(H))ie.push(i.and(j,B));v.unshift(i.or(...ie))}return v[0]}}e.ContextKeyOrExpr=o;class l extends f{constructor(v,R,L){super(v);this._defaultValue=R,typeof L=="object"?l._info.push(Object.assign(Object.assign({},L),{key:v})):L!==!0&&l._info.push({key:v,description:L,type:R!=null?typeof R:void 0})}static all(){return l._info.values()}bindTo(v){return v.createKey(this.key,this._defaultValue)}getValue(v){return v.getContextKeyValue(this.key)}toNegated(){return i.not(this.key)}isEqualTo(v){return i.equals(this.key,v)}notEqualsTo(v){return i.notEquals(this.key,v)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(u,v){return u<v?-1:u>v?1:0}function S(u,v,R,L){return u<R?-1:u>R?1:v<L?-1:v>L?1:0}}),define(me[182],ge([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,_.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,_.refineServiceDecorator)(e.IEnvironmentService)}),define(me[183],ge([0,1,153,4,11]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function I(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=I;var y;(function(C){C[C.NoneOrRelevance=0]="NoneOrRelevance",C[C.LastUpdatedDate=1]="LastUpdatedDate",C[C.Title=2]="Title",C[C.PublisherName=3]="PublisherName",C[C.InstallCount=4]="InstallCount",C[C.PublishedDate=5]="PublishedDate",C[C.AverageRating=6]="AverageRating",C[C.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var P;(function(C){C[C.Default=0]="Default",C[C.Ascending=1]="Ascending",C[C.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var D;(function(C){C.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var i;(function(C){C[C.None=0]="None",C[C.Install=1]="Install",C[C.Update=2]="Update"})(i=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class T extends Error{constructor(m,f){super(m);this.code=f}}e.ExtensionManagementError=T,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=A.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,_.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,_.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(me[29],ge([0,1,10,4]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class y{constructor(T){this.value=T,this._lower=T.toLowerCase()}static equals(T,C){if(typeof T=="undefined"||T===null)return typeof C=="undefined"||C===null;if(typeof C=="undefined"||C===null)return!1;if(typeof T=="string"||typeof C=="string"){let m=typeof T=="string"?T:T.value,f=typeof C=="string"?C:C.value;return _.equalsIgnoreCase(m,f)}return T._lower===C._lower}static toKey(T){return typeof T=="string"?T.toLowerCase():T._lower}}e.ExtensionIdentifier=y;function P(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function D(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=D,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[184],ge([0,1,10,29]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(f,a){return f.uuid&&a.uuid?f.uuid===a.uuid:f.id===a.id?!0:(0,_.compareIgnoreCase)(f.id,a.id)===0}e.areSameExtensions=A;class I{constructor(a,d){this.version=d,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof I?A(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=I;function y(f,a){return`${f}.${a}`}e.getExtensionId=y;function P(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function D(f,a){return P(y(f,a))}e.getGalleryExtensionId=D;function i(f,a){const d=[],E=w=>{for(const b of d)if(b.some(p=>A(a(p),a(w))))return b;return null};for(const w of f){const b=E(w);b?b.push(w):d.push([w])}return d}e.groupByExtension=i;function T(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=T;function C(f){return Object.assign({id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0)},f.telemetryData)}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function m(f){const a=new Set;for(const d of f)d.malicious&&a.add(d.id.id);return a}e.getMaliciousExtensionsSet=m}),define(me[45],ge([0,1,155,8,2,4,10,12,24]),function(G,e,_,k,A,I,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function i(j){return j.create===!0}e.isFileOpenForWriteOptions=i;var T;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var C;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=m;function f(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=f;function a(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function d(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=d;var E;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(B,$){super(B);this.code=$}}e.FileSystemProviderError=w;function b(j,B){const $=new w(j.toString(),B);return c($,B),$}e.createFileSystemProviderError=b;function p(j){return j||b((0,_.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=p;function c(j,B){return j.name=B?`${B} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=c;function g(j){if(!j)return E.Unknown;if(j instanceof w)return j.code;const B=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!B)return E.Unknown;switch(B[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=g;function t(j){if(j instanceof h)return j.fileOperationResult;switch(g(j)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class s{constructor(B,$,N){this.resource=B,this.operation=$,this.target=N}isOperation(B){return this.operation===B}}e.FileOperationEvent=s;var r;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class o{constructor(B,$){this.ignorePathCasing=$,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=B;for(const N of B)switch(N.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(N.resource,N);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(N.resource,N);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(N.resource,N);break}}contains(B,...$){return this.doContains(B,{includeChildren:!1},...$)}affects(B,...$){return this.doContains(B,{includeChildren:!0},...$)}doContains(B,$,...N){var M,F,U,O,W,q;if(!B)return!1;const Q=N.length>0;return!!((!Q||N.includes(1))&&(((M=this.added)===null||M===void 0?void 0:M.get(B))||$.includeChildren&&((F=this.added)===null||F===void 0?void 0:F.findSuperstr(B)))||(!Q||N.includes(0))&&(((U=this.updated)===null||U===void 0?void 0:U.get(B))||$.includeChildren&&((O=this.updated)===null||O===void 0?void 0:O.findSuperstr(B)))||(!Q||N.includes(2))&&(((W=this.deleted)===null||W===void 0?void 0:W.findSubstr(B))||$.includeChildren&&((q=this.deleted)===null||q===void 0?void 0:q.findSuperstr(B))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(B){const $=[],N=B===1?this.added:B===0?this.updated:this.deleted;if(N)for(const[,M]of N)$.push(M);return $}filter(B){return new o(this.changes.filter($=>B($)),this.ignorePathCasing)}}e.FileChangesEvent=o;function l(j,B,$){return!j||!B||j===B||B.length>j.length?!1:(B.charAt(B.length-1)!==k.sep&&(B+=k.sep),$?(0,y.startsWithIgnoreCase)(j,B):j.indexOf(B)===0)}e.isParent=l;class h extends Error{constructor(B,$,N){super(B);this.fileOperationResult=$,this.options=N}static isFileOperationError(B){return B instanceof Error&&!(0,P.isUndefinedOrNull)(B.fileOperationResult)}}e.FileOperationError=h;var S;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(S=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var u;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(u=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function v(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=v;async function R(j,B){if(!B.canHandleResource(A.URI.from({scheme:j.scheme})))return new Promise($=>{const N=B.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===j.scheme&&M.added&&(N.dispose(),$())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(B){return(0,P.isNumber)(B)||(B=0),B<L.KB?(0,_.localize)(1,null,B.toFixed(0)):B<L.MB?(0,_.localize)(2,null,(B/L.KB).toFixed(2)):B<L.GB?(0,_.localize)(3,null,(B/L.MB).toFixed(2)):B<L.TB?(0,_.localize)(4,null,(B/L.GB).toFixed(2)):(0,_.localize)(5,null,(B/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var H;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function ie(j){return{maxFileSize:j===0?300*L.MB:16*L.GB,maxHeapSize:j===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=ie}),define(me[82],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...A){this._entries=new Map;for(let[I,y]of A)this.set(I,y)}set(A,I){const y=this._entries.get(A);return this._entries.set(A,I),y}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=_}),define(me[185],ge([0,1,18,178,111,4,82,19]),function(G,e,_,k,A,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class i extends Error{constructor(a){var d;super("cyclic dependency between services");this.message=(d=a.findCycleSlow())!==null&&d!==void 0?d:`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class T{constructor(a=new y.ServiceCollection,d=!1,E){this._activeInstantiations=new Set,this._services=a,this._strict=d,this._parent=E,this._services.set(I.IInstantiationService,this)}createChild(a){return new T(a,this._strict,this)}invokeFunction(a,...d){let E=m.traceInvocation(a),w=!1;try{return a({get:(p,c)=>{if(w)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(p,E);if(!g&&c!==I.optional)throw new Error(`[invokeFunction] unknown service '${p}'`);return g}},...d)}finally{w=!0,E.stop()}}createInstance(a,...d){let E,w;return a instanceof A.SyncDescriptor?(E=m.traceCreation(a.ctor),w=this._createInstance(a.ctor,a.staticArguments.concat(d),E)):(E=m.traceCreation(a),w=this._createInstance(a,d,E)),E.stop(),w}_createInstance(a,d=[],E){let w=I._util.getServiceDependencies(a).sort((c,g)=>c.index-g.index),b=[];for(const c of w){let g=this._getOrCreateServiceInstance(c.id,E);if(!g&&this._strict&&!c.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${c.id}.`);b.push(g)}let p=w.length>0?w[0].index:d.length;if(d.length!==p){console.warn(`[createInstance] First service dependency of ${a.name} at position ${p+1} conflicts with ${d.length} static arguments`);let c=p-d.length;c>0?d=d.concat(new Array(c)):d=d.slice(0,p)}return new a(...[...d,...b])}_setServiceInstance(a,d){if(this._services.get(a)instanceof A.SyncDescriptor)this._services.set(a,d);else if(this._parent)this._parent._setServiceInstance(a,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let d=this._services.get(a);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):d}_getOrCreateServiceInstance(a,d){let E=this._getServiceInstanceOrDescriptor(a);return E instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,E,d.branch(a,!0)):(d.branch(a,!1),E)}_safeCreateAndCacheServiceInstance(a,d,E){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,d,E)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,d,E){const w=new k.Graph(c=>c.id.toString());let b=0;const p=[{id:a,desc:d,_trace:E}];for(;p.length;){const c=p.pop();if(w.lookupOrInsertNode(c),b++>1e3)throw new i(w);for(let g of I._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(g.id);if(!t&&!g.optional&&console.warn(`[createInstance] ${a} depends on ${g.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const n={id:g.id,desc:t,_trace:c._trace.branch(g.id,!0)};w.insertEdge(c,n),p.push(n)}}}for(;;){const c=w.roots();if(c.length===0){if(!w.isEmpty())throw new i(w);break}for(const{data:g}of c){if(this._getServiceInstanceOrDescriptor(g.id)instanceof A.SyncDescriptor){const n=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,n)}w.removeNode(g)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,d,E=[],w,b){if(this._services.get(a)instanceof A.SyncDescriptor)return this._createServiceInstance(d,E,w,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,d,E,w,b);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(a,d=[],E,w){if(E){const b=new P.IdleValue(()=>this._createInstance(a,d,w));return new Proxy(Object.create(null),{get(p,c){if(c in p)return p[c];let g=b.value,t=g[c];return typeof t!="function"||(t=t.bind(g),p[c]=t),t},set(p,c,g){return b.value[c]=g,!0}})}else return this._createInstance(a,d,w)}}e.InstantiationService=T;var C;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(C||(C={}));class m{constructor(a,d){this.type=a,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return D?new m(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(a){return D?new m(0,a.name):m._None}branch(a,d){let E=new m(2,a.toString());return this._dep.push([a,d,E]),E}stop(){let a=Date.now()-this._start;m._totals+=a;let d=!1;function E(b,p){let c=[],g=new Array(b+1).join("	");for(const[t,n,s]of p._dep)if(n&&s){d=!0,c.push(`${g}CREATES -> ${t}`);let r=E(b+1,s);r&&c.push(r)}else c.push(`${g}uses -> ${t}`);return c.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(a>2||d)&&console.log(w.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(me[13],ge([0,1,4,6,9,3,59]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function P(){return new Date().toISOString()}var D;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class i extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=i;class T extends i{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(D.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(D.Error,this.format(s))}else this.log(D.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let s=0;s<t.length;s++){let r=t[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(o){}n+=(s>0?" ":"")+r}return n}}e.AbstractMessageLogger=T;class C extends i{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}debug(t,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}info(t,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}warn(t,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...n):console.warn(`[main ${P()}]`,t,...n))}error(t,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}critical(t,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class m extends i{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=m;class f extends i{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class a extends i{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const s of this.logServices)s.trace(t,...n)}debug(t,...n){for(const s of this.logServices)s.debug(t,...n)}info(t,...n){for(const s of this.logServices)s.info(t,...n)}warn(t,...n){for(const s of this.logServices)s.warn(t,...n)}error(t,...n){for(const s of this.logServices)s.error(t,...n)}critical(t,...n){for(const s of this.logServices)s.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=a;class d extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=d;class E extends k.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}createLogger(t,n){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(n==null?void 0:n.always)?D.Trace:this.logLevel,n),this.loggers.set(t.toString(),s),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class w{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=w;function b(g){if(g.verbose)return D.Trace;if(typeof g.logLevel=="string"){const t=p(g.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function p(g){switch(g){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=p;function c(g){switch(g){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=c}),define(me[112],ge([0,1,13,45]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function A(D,i,T,C){try{const m=await new Promise((f,a)=>{G(["spdlog"],f,a)});return m.setAsyncMode(8192,500),m.createRotatingLoggerAsync(D,i,T,C)}catch(m){console.error(m)}return null}function I(D,i,T,C){return G.__$__nodeRequire("spdlog").createRotatingLogger(D,i,T,C)}e.createRotatingLogger=I;function y(D,i,T){switch(i){case _.LogLevel.Trace:D.trace(T);break;case _.LogLevel.Debug:D.debug(T);break;case _.LogLevel.Info:D.info(T);break;case _.LogLevel.Warning:D.warn(T);break;case _.LogLevel.Error:D.error(T);break;case _.LogLevel.Critical:D.critical(T);break;default:throw new Error("Invalid log level")}}class P extends _.AbstractMessageLogger{constructor(i,T,C,m){super();this.name=i,this.filepath=T,this.rotating=C,this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(f=>{this._logger&&this._logger.setLevel(f)}))}_createSpdLogLogger(){const i=this.rotating?6:1,T=30/i*k.ByteSize.MB;return A(this.name,this.filepath,T,i).then(C=>{if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:m,message:f}of this.buffer)y(this._logger,m,f);this.buffer=[]}})}log(i,T){this._logger?y(this._logger,i,T):this.getLevel()<=i&&this.buffer.push({level:i,message:T})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(me[113],ge([0,1,4,156,57]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(I=e.MarkerTag||(e.MarkerTag={}));var y;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function i(a,d){return d-a}D.compare=i;const T=Object.create(null);T[D.Error]=(0,k.localize)(0,null),T[D.Warning]=(0,k.localize)(1,null),T[D.Info]=(0,k.localize)(2,null);function C(a){return T[a]||""}D.toString=C;function m(a){switch(a){case A.default.Error:return D.Error;case A.default.Warning:return D.Warning;case A.default.Info:return D.Info;case A.default.Ignore:return D.Hint}}D.fromSeverity=m;function f(a){switch(a){case D.Error:return A.default.Error;case D.Warning:return A.default.Warning;case D.Info:return A.default.Info;case D.Hint:return A.default.Ignore}}D.toSeverity=f}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(D){const i="";function T(m){return C(m,!0)}D.makeKey=T;function C(m,f){let a=[i];return m.source?a.push(m.source.replace("\xA6","\\\xA6")):a.push(i),m.code?typeof m.code=="string"?a.push(m.code.replace("\xA6","\\\xA6")):a.push(m.code.value.replace("\xA6","\\\xA6")):a.push(i),m.severity!==void 0&&m.severity!==null?a.push(y.toString(m.severity)):a.push(i),m.message&&f?a.push(m.message.replace("\xA6","\\\xA6")):a.push(i),m.startLineNumber!==void 0&&m.startLineNumber!==null?a.push(m.startLineNumber.toString()):a.push(i),m.startColumn!==void 0&&m.startColumn!==null?a.push(m.startColumn.toString()):a.push(i),m.endLineNumber!==void 0&&m.endLineNumber!==null?a.push(m.endLineNumber.toString()):a.push(i),m.endColumn!==void 0&&m.endColumn!==null?a.push(m.endColumn.toString()):a.push(i),a.push(i),a.join("\xA6")}D.makeKeyOptionalMessage=C})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(me[186],ge([0,1,57,4,3]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=_.default,e.INotificationService=(0,k.createDecorator)("notificationService");var I;(function(i){i[i.WORKSPACE=0]="WORKSPACE",i[i.GLOBAL=1]="GLOBAL"})(I=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(i){i[i.OFF=0]="OFF",i[i.SILENT=1]="SILENT",i[i.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new D,this.onDidClose=A.Event.None,this.onDidChangeVisibility=A.Event.None}updateSeverity(T){}updateMessage(T){}updateActions(T){}close(){}}e.NoOpNotification=P;class D{infinite(){}done(){}total(T){}worked(T){}}e.NoOpProgress=D}),define(me[187],ge([0,1,11,9,36,25]),function(G,e,_,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof k.globals.vscode!="undefined"){const P=k.globals.vscode.context.configuration();if(P)y=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(G==null?void 0:G.__$__nodeRequire)=="function"){const P=(0,I.dirname)(_.FileAccess.asFileUri("",G));y=G.__$__nodeRequire((0,I.joinPath)(P,"product.json").fsPath);const D=G.__$__nodeRequire((0,I.joinPath)(P,"package.json").fsPath);A.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`}),Object.assign(y,{version:D.version})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.56.0-dev",nameShort:k.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:k.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=y});var je=this&&this.__decorate||function(G,e,_,k){var A=arguments.length,I=A<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,_):k,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(G,e,_,k);else for(var P=G.length-1;P>=0;P--)(y=G[P])&&(I=(A<3?y(I):A>3?y(e,_,I):y(e,_))||I);return A>3&&I&&Object.defineProperty(e,_,I),I},Be=this&&this.__param||function(G,e){return function(_,k){e(_,k,G)}};define(me[114],ge([0,1,4,21,6,19]),function(G,e,_,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,_.createDecorator)("progressService");var y;(function(T){T[T.Explorer=1]="Explorer",T[T.Scm=3]="Scm",T[T.Extensions=5]="Extensions",T[T.Window=10]="Window",T[T.Notification=15]="Notification",T[T.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let D=class extends A.Disposable{constructor(C,m){super();this.deferred=new I.DeferredPromise,m.withProgress(C,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,A.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};D=je([Be(1,e.IProgressService)],D),e.UnmanagedProgress=D;class i extends A.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new A.DisposableStore)}start(C){this.stop();const m=++this.currentOperationId,f=new k.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{m===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,A.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,A.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,A.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:m,token:f.token,stop:()=>this.doStop(m),isCurrent:()=>this.currentOperationId===m}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=i,e.IEditorProgressService=(0,_.createDecorator)("editorProgressService")}),define(me[40],ge([0,1,12,52]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(y,P){k.ok(_.isString(y)),k.ok(_.isObject(P)),k.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,P)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new A}),define(me[115],ge([0,1,40,3]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class I{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,i){this.schemasById[A(D)]=i,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new I;_.Registry.add(e.Extensions.JSONContribution,y)}),define(me[83],ge([0,1,152,3,40,12,115]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=A.Registry.as(y.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,b=!0){this.registerConfigurations([w],b)}registerConfigurations(w,b=!0){const p=[];w.forEach(c=>{p.push(...this.validateAndRegisterProperties(c,b,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterConfigurations(w){const b=[],p=c=>{if(c.properties)for(const g in c.properties)b.push(g),delete this.configurationProperties[g],this.removeFromSchema(g,c.properties[g]);c.allOf&&c.allOf.forEach(g=>p(g))};for(const c of w){p(c);const g=this.configurationContributors.indexOf(c);g!==-1&&this.configurationContributors.splice(g,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}registerDefaultConfigurations(w){const b=[],p=[];for(const c of w)for(const g in c)if(b.push(g),e.OVERRIDE_PROPERTY_PATTERN.test(g)){this.defaultValues[g]=Object.assign(Object.assign({},this.defaultValues[g]||{}),c[g]);const t={type:"object",default:this.defaultValues[g],description:_.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId};p.push(C(g)),this.configurationProperties[g]=t,this.defaultLanguageConfigurationOverridesNode.properties[g]=t}else{this.defaultValues[g]=c[g];const t=this.configurationProperties[g];t&&(this.updatePropertyDefaultValue(g,t),this.updateSchema(g,t))}this.registerOverrideIdentifiers(p),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}deregisterDefaultConfigurations(w){const b=[];for(const p of w)for(const c in p)if(b.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const g=this.configurationProperties[c];g&&(this.updatePropertyDefaultValue(c,g),this.updateSchema(c,g))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const b of w)this.overrideIdentifiers.add(b);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,b=!0,p,c=3){var g;c=I.isUndefinedOrNull(w.scope)?c:w.scope;let t=[],n=w.properties;if(n)for(let r in n){if(b&&a(r)){delete n[r];continue}const o=n[r];if(this.updatePropertyDefaultValue(r,o),e.OVERRIDE_PROPERTY_PATTERN.test(r)?o.scope=void 0:(o.scope=I.isUndefinedOrNull(o.scope)?c:o.scope,o.requireTrust=I.isUndefinedOrNull(o.requireTrust)?!!((g=p==null?void 0:p.requireTrustForConfigurations)===null||g===void 0?void 0:g.includes(r)):o.requireTrust),n[r].hasOwnProperty("included")&&!n[r].included){this.excludedConfigurationProperties[r]=n[r],delete n[r];continue}else this.configurationProperties[r]=n[r];!n[r].deprecationMessage&&n[r].markdownDeprecationMessage&&(n[r].deprecationMessage=n[r].markdownDeprecationMessage),t.push(r)}let s=w.allOf;if(s)for(let r of s)t.push(...this.validateAndRegisterProperties(r,b,p,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const b=p=>{let c=p.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let g=p.allOf;g&&g.forEach(b)};b(w)}updateSchema(w,b){switch(e.allSettings.properties[w]=b,b.scope){case 1:e.applicationSettings.properties[w]=b;break;case 2:e.machineSettings.properties[w]=b;break;case 6:e.machineOverridableSettings.properties[w]=b;break;case 3:e.windowSettings.properties[w]=b;break;case 4:e.resourceSettings.properties[w]=b;break;case 5:e.resourceSettings.properties[w]=b,this.resourceLanguageSettingsSchema.properties[w]=b;break}}removeFromSchema(w,b){switch(delete e.allSettings.properties[w],b.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const b=`[${w}]`,p={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(b,p),e.allSettings.properties[b]=p,e.applicationSettings.properties[b]=p,e.machineSettings.properties[b]=p,e.machineOverridableSettings.properties[b]=p,e.windowSettings.properties[b]=p,e.resourceSettings.properties[b]=p}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,b){let p=this.defaultValues[w];I.isUndefined(p)&&(p=b.default),I.isUndefined(p)&&(p=m(b.type)),b.default=p}}const T="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(T);function C(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=C;function m(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const f=new i;A.Registry.add(e.Extensions.Configuration,f);function a(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?_.localize(5,null,E):f.getConfigurationProperties()[E]!==void 0?_.localize(6,null,E):null:_.localize(4,null)}e.validateProperty=a;function d(){const E=[],w=f.getConfigurationProperties();for(const b of Object.keys(w))E.push([b,w[b].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=d}),define(me[84],ge([0,1,23,12,2,40,4,83]),function(G,e,_,k,A,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function D(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof A.URI)}e.isConfigurationOverrides=D;var i;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(i=e.ConfigurationTarget||(e.ConfigurationTarget={}));function T(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=T;function C(n,s){const r=s?n?s.keys.filter(R=>n.keys.indexOf(R)===-1):[...s.keys]:[],o=n?s?n.keys.filter(R=>s.keys.indexOf(R)===-1):[...n.keys]:[],l=[];if(s&&n){for(const R of n.keys)if(s.keys.indexOf(R)!==-1){const L=w(n.contents,R),H=w(s.contents,R);_.equals(L,H)||l.push(R)}}const h=[],S=R=>{const L={};for(const H of R)for(const ie of H.identifiers)L[g(ie)]=H;return L},u=s?S(s.overrides):{},v=n?S(n.overrides):{};if(Object.keys(u).length)for(const R of r){const L=u[R];L&&h.push([(0,P.overrideIdentifierFromKey)(R),L.keys])}if(Object.keys(v).length)for(const R of o){const L=v[R];L&&h.push([(0,P.overrideIdentifierFromKey)(R),L.keys])}if(Object.keys(u).length&&Object.keys(v).length)for(const R of l){const L=v[R],H=u[R];if(L&&H){const ie=C({contents:L.contents,keys:L.keys,overrides:[]},{contents:H.contents,keys:H.keys,overrides:[]});h.push([(0,P.overrideIdentifierFromKey)(R),[...ie.added,...ie.removed,...ie.updated]])}}return{added:r,removed:o,updated:l,overrides:h}}e.compare=C;function m(n,s){const r=[];for(const o of Object.keys(n))if(P.OVERRIDE_PROPERTY_PATTERN.test(o)){const l={};for(const h in n[o])l[h]=n[o][h];r.push({identifiers:[(0,P.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(l),contents:f(l,s)})}return r}e.toOverrides=m;function f(n,s){const r=Object.create(null);for(let o in n)a(r,o,n[o],s);return r}e.toValuesTree=f;function a(n,s,r,o){const l=s.split("."),h=l.pop();let S=n;for(let u=0;u<l.length;u++){let v=l[u],R=S[v];switch(typeof R){case"undefined":R=S[v]=Object.create(null);break;case"object":break;default:o(`Ignoring ${s} as ${l.slice(0,u+1).join(".")} is ${JSON.stringify(R)}`);return}S=R}if(typeof S=="object"&&S!==null)try{S[h]=r}catch(u){o(`Ignoring ${s} as ${l.join(".")} is ${JSON.stringify(S)}`)}else o(`Ignoring ${s} as ${l.join(".")} is ${JSON.stringify(S)}`)}e.addToValueTree=a;function d(n,s){const r=s.split(".");E(n,r)}e.removeFromValueTree=d;function E(n,s){const r=s.shift();if(s.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const o=n[r];typeof o=="object"&&!Array.isArray(o)&&(E(o,s),Object.keys(o).length===0&&delete n[r])}}function w(n,s,r){function o(S,u){let v=S;for(const R of u){if(typeof v!="object"||v===null)return;v=v[R]}return v}const l=s.split("."),h=o(n,l);return typeof h=="undefined"?r:h}e.getConfigurationValue=w;function b(n,s,r){Object.keys(s).forEach(o=>{o!=="__proto__"&&(o in n?k.isObject(n[o])&&k.isObject(s[o])?b(n[o],s[o],r):r&&(n[o]=s[o]):n[o]=s[o])})}e.merge=b;function p(){const n=I.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=p;function c(){const n=Object.create(null),s=I.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let r in s){let o=s[r].default;a(n,r,o,l=>console.error(`Conflict in default settings: ${l}`))}return n}e.getDefaultValues=c;function g(n){return`[${n}]`}e.keyFromOverrideIdentifier=g;function t(n,s,r){const o=n.inspect(s),l=n.inspect(r);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:o.defaultValue}e.getMigratedSettingValue=t}),define(me[188],ge([0,1,55,24,15,12,23,2,83,84,40,6,3]),function(G,e,_,k,A,I,y,P,D,i,T,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},n=[],s=[]){this._contents=t,this._keys=n,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const s=this.getContentsForOverrideIdentifer(n);return s?t?(0,i.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const r of A.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[r],l=n[r];l&&(typeof o=="object"&&typeof l=="object"?(o=y.deepClone(o),this.mergeContents(o,l)):o=l),s[r]=o}return new f(s,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),s=y.deepClone(this.overrides),r=[...this.keys];for(const o of t){this.mergeContents(n,o.contents);for(const l of o.overrides){const[h]=s.filter(S=>A.equals(S.identifiers,l.identifiers));h?this.mergeContents(h.contents,l.contents):s.push(y.deepClone(l))}for(const l of o.keys)r.indexOf(l)===-1&&r.push(l)}return new f(n,r,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const s of Object.keys(n)){if(s in t&&I.isObject(t[s])&&I.isObject(n[s])){this.mergeContents(t[s],n[s]);continue}t[s]=y.deepClone(n[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,i.addToValueTree)(this.contents,t,n,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let s=0;s<n;s++)t.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=f;class a extends f{constructor(){const t=(0,i.getDefaultValues)(),n=(0,i.getConfigurationKeys)(),s=[];for(const r of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[(0,D.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,i.toValuesTree)(t[r],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,n,s)}}e.DefaultConfigurationModel=a;class d{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!I.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:s,keys:r,overrides:o,untrusted:l}=this.doParseRaw(t,n);this._configurationModel=new f(s,r,o),this._untrustedConfigurations=l||[]}doParseContent(t){let n={},s=null,r=[],o=[],l=[];function h(u){Array.isArray(r)?r.push(u):s&&(r[s]=u)}let S={onObjectBegin:()=>{let u={};h(u),o.push(r),r=u,s=null},onObjectProperty:u=>{s=u},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{let u=[];h(u),o.push(r),r=u,s=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:h,onError:(u,v,R)=>{l.push({error:u,offset:v,length:R})}};if(t)try{_.visit(t,S),n=r[0]||{}}catch(u){console.error(`Error while parsing settings file ${this._name}: ${u}`),this._parseErrors=[u]}return n}doParseRaw(t,n){const s=T.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,s,!0,n);t=r.raw;const o=(0,i.toValuesTree)(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),l=Object.keys(t),h=(0,i.toOverrides)(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:o,keys:l,overrides:h,untrusted:r.untrusted}}filter(t,n,s,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.isUntrusted))return{raw:t,untrusted:[]};const o={},l=[];for(let h in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(h)&&s){const S=this.filter(t[h],n,!1,r);o[h]=S.raw,l.push(...S.untrusted)}else{const S=n[h],u=S?typeof S.scope!="undefined"?S.scope:3:void 0;(u===void 0||r.scopes===void 0||r.scopes.includes(u))&&(r.isUntrusted&&(S==null?void 0:S.requireTrust)?l.push(h):o[h]=t[h])}return{raw:o,untrusted:l}}}e.ConfigurationModelParser=d;class E extends C.Disposable{constructor(t,n,s,r){super();this.userSettingsResource=t,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new m.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(m.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=E;class w{constructor(t,n,s=new f,r=new f,o=new k.ResourceMap,l=new f,h=new k.ResourceMap,S=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=o,this._memoryConfiguration=l,this._memoryConfigurationByResource=h,this._freeze=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(t)}updateValue(t,n,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new f,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(t):r.setValue(t,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,s){const r=this.getConsolidateConfigurationModel(n,s),o=this.getFolderConfigurationModelForResource(n.resource,s),l=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,h=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),S=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),u=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),v=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=o?n.overrideIdentifier?o.freeze().override(n.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,H=n.overrideIdentifier?l.override(n.overrideIdentifier).getValue(t):l.getValue(t),ie=r.getValue(t),j=A.distinct(A.flatten(r.overrides.map(B=>B.identifiers))).filter(B=>r.getOverrideValue(t,B)!==void 0);return{defaultValue:h,userValue:S,userLocalValue:u,userRemoteValue:v,workspaceValue:R,workspaceFolderValue:L,memoryValue:H,value:ie,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:S!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:u!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:v!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:o==null?void 0:o.freeze().getValue(t),override:n.overrideIdentifier?o==null?void 0:o.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:H!==void 0?{value:l.getValue(t),override:n.overrideIdentifier?l.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=n.filter(r=>D.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const o=(0,D.overrideIdentifierFromKey)(r),l=this._defaultConfiguration.getKeysForOverrideIdentifier(o),h=t.getKeysForOverrideIdentifier(o),S=[...h.filter(u=>l.indexOf(u)===-1),...l.filter(u=>h.indexOf(u)===-1),...l.filter(u=>!y.equals(this._defaultConfiguration.override(o).getValue(u),t.override(o).getValue(u)))];return[o,S]});return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:o}=(0,i.compare)(this.localUserConfiguration,t),l=[...n,...s,...r];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:o}=(0,i.compare)(this.remoteUserConfiguration,t);let l=[...n,...s,...r];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:r,overrides:o}=(0,i.compare)(this.workspaceConfiguration,t);let l=[...n,...s,...r];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:o}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:r,updated:o,removed:l,overrides:h}=(0,i.compare)(s,n);let S=[...r,...o,...l];return(S.length||!s)&&this.updateFolderConfiguration(t,n),{keys:S,overrides:h}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:r,removed:o,overrides:l}=(0,i.compare)(n,void 0);return{keys:[...s,...r,...o],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let s=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const r=n.getFolder(t);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const o=this._memoryConfigurationByResource.get(t);o&&(s=s.merge(o))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(n=s.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=s}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:s,overrides:r,keys:o}=this._folderConfigurations.get(n);return t.push([n,{contents:s,overrides:r,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((l,h)=>(l.set(P.URI.revive(h[0]),this.parseConfigurationModel(h[1])),l),new k.ResourceMap);return new w(n,s,new f,r,o,new f,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function b(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const t=new Set,n=new Map;for(const r of g)r.keys.forEach(o=>t.add(o)),r.overrides.forEach(([o,l])=>{const h=(0,k.getOrSet)(n,o,new Set);l.forEach(S=>h.add(S))});const s=[];return n.forEach((r,o)=>s.push([o,[...r.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=b;class p{constructor(t,n,s,r){this.change=t,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(h=>o.add(h)),t.overrides.forEach(([,h])=>h.forEach(S=>o.add(S))),this.affectedKeys=[...o.values()];const l=new f;this.affectedKeys.forEach(h=>l.setValue(h,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,o=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let s=(0,i.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(t=t[r],!t)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=p;class c extends p{constructor(t,n,s,r){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=c}),define(me[85],ge([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,_.createDecorator)("remoteAuthorityResolverService");var k;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(k=e.RemoteTrustOption||(e.RemoteTrustOption={}));var A;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(A=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends Error{constructor(P,D=A.Unknown,i){super(P);this._message=P,this._code=D,this._detail=i,this.isHandled=D===A.NotAvailable&&i===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(P){return P instanceof I&&P._code===A.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof I&&P._code===A.NoResolverFound}static isHandled(P){return P instanceof I&&P.isHandled}}e.RemoteAuthorityResolverError=I}),define(me[116],ge([0,1,11]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function k(D){return D.scheme===_.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=k;function A(D){if(!!D){const i=D.indexOf("+");return i<0?D:D.substr(0,i)}}e.getRemoteName=A;function I(D){return D.scheme!==_.Schemas.file&&D.scheme!==_.Schemas.vscodeRemote}function y(D){if(D.folders.length)return D.folders.every(i=>I(i.uri))?D.folders[0].uri:void 0;if(D.configuration&&I(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=y;function P(D){var i;return(i=y(D))===null||i===void 0?void 0:i.scheme}e.getVirtualWorkspaceScheme=P}),define(me[189],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class _{vsda(){return new Promise((A,I)=>G(["vsda"],A,I))}async sign(A){try{const I=await this.vsda(),y=new I.signer;if(y)return y.sign(A)}catch(I){}return A}}e.SignService=_}),define(me[190],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class _{constructor(A){this._callback=A,this._terminalBufferMap=new Map}dispose(){for(const A of this._terminalBufferMap.values())A.dispose()}startBuffering(A,I,y=5){let P;return P=I(D=>{const i=typeof D=="string"?D:D.data;let T=this._terminalBufferMap.get(A);if(T){T.data.push(i);return}const C=setTimeout(()=>this.flushBuffer(A),y);T={data:[i],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(A),P.dispose()}},this._terminalBufferMap.set(A,T)}),P}stopBuffering(A){const I=this._terminalBufferMap.get(A);I&&I.dispose()}flushBuffer(A){const I=this._terminalBufferMap.get(A);I&&(this._terminalBufferMap.delete(A),this._callback(A,I.data.join("")))}}e.TerminalDataBufferer=_}),define(me[191],ge([0,1,48,8,36,26,12,23,9]),function(G,e,_,k,A,I,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function i(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(_.release());let m=0;return C&&C.length===4&&(m=parseInt(C[3])),m}e.getWindowsBuildNumber=i;async function T(C,m,f,a=A.env,d=I.exists){if(k.isAbsolute(C))return await d(C)?C:void 0;if(m===void 0&&(m=A.cwd()),k.dirname(C)!=="."){const p=k.join(m,C);return await d(p)?p:void 0}const w=(0,P.getCaseInsensitive)(a,"PATH");if(f===void 0&&(0,y.isString)(w)&&(f=w.split(k.delimiter)),f===void 0||f.length===0){const p=k.join(m,C);return await d(p)?p:void 0}for(let p of f){let c;if(k.isAbsolute(p)?c=k.join(p,C):c=k.join(m,p,C),await d(c))return c;if(D.isWindows){let g=c+".com";if(await d(g)||(g=c+".exe",await d(g)))return g}}const b=k.join(m,C);return await d(b)?b:void 0}e.findExecutable=T}),define(me[192],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var _;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST="hc"})(_=e.ColorScheme||(e.ColorScheme={}))}),define(me[193],ge([0,1,4,6,40,3,192,43]),function(G,e,_,k,A,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var D;(function(E){function w(b){return b&&typeof b=="object"&&typeof b.id=="string"}E.isThemeColor=w})(D=e.ThemeColor||(e.ThemeColor={}));function i(E){return{id:E}}e.themeColorFromId=i;var T;(function(E){function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||D.isThemeColor(t.color))}E.isThemeIcon=w;const b=new RegExp(`^\\$\\((${P.CSSIcon.iconNameExpression}(?:${P.CSSIcon.iconModifierExpression})?)\\)$`);function p(t){const n=b.exec(t);if(!!n){let[,s]=n;return{id:s}}}E.fromString=p;function c(t,n){let s=t.id;const r=s.lastIndexOf("~");return r!==-1&&(s=s.substring(0,r)),n&&(s=`${s}~${n}`),{id:s}}E.modify=c;function g(t,n){var s,r;return t.id===n.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((r=n.color)===null||r===void 0?void 0:r.id)}E.isEqual=g,E.asClassNameArray=P.CSSIcon.asClassNameArray,E.asClassName=P.CSSIcon.asClassName,E.asCSSSelector=P.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=P.Codicon.file,e.FolderThemeIcon=P.Codicon.folder;function C(E){switch(E){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new I.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,k.toDisposable)(()=>{const b=this.themingParticipants.indexOf(w);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new m;A.Registry.add(e.Extensions.ThemingContribution,f);function a(E){return f.onColorThemeChange(E)}e.registerThemingParticipant=a;class d extends k.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,b){let p=this.theme.getColor(w);return p&&b&&(p=b(p,this.theme)),p?p.toString():null}}e.Themable=d}),define(me[194],ge([0,1,40,193,3,157,115,19,43]),function(G,e,_,k,A,I,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class i{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,I.localize)(0,null)},fontCharacter:{type:"string",description:(0,I.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,b,p,c){const g=this.iconsById[w];if(g){if(p&&!g.description){g.description=p,this.iconSchema.properties[w].markdownDescription=`${p} $(${w})`;const s=this.iconReferenceSchema.enum.indexOf(w);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=p),this._onDidChange.fire()}return g}let t={id:w,description:p,defaults:b,deprecationMessage:c};this.iconsById[w]=t;let n={$ref:"#/definitions/icons"};return c&&(n.deprecationMessage=c),p&&(n.markdownDescription=`${p}: $(${w})`),this.iconSchema.properties[w]=n,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(p||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const b=this.iconReferenceSchema.enum.indexOf(w);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,b){const p=this.iconFontsById[w];if(p)return p;let c={id:w,definition:b};return this.iconFontsById[w]=c,this._onDidChange.fire(),c}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFonts(){return Object.keys(this.iconFontsById).map(w=>this.iconFontsById[w])}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(g,t)=>g.id.localeCompare(t.id),b=g=>{for(;k.ThemeIcon.isThemeIcon(g.defaults);)g=this.iconsById[g.defaults.id];return`codicon codicon-${g?g.id:""}`};let p=[];p.push("| preview     | identifier                        | default codicon ID                | description"),p.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(g=>this.iconsById[g]);for(const g of c.filter(t=>!!t.description).sort(w))p.push(`|<i class="${b(g)}"></i>|${g.id}|${k.ThemeIcon.isThemeIcon(g.defaults)?g.defaults.id:g.id}|${g.description||""}|`);p.push("| preview     | identifier                        "),p.push("| ----------- | --------------------------------- |");for(const g of c.filter(t=>!k.ThemeIcon.isThemeIcon(t.defaults)).sort(w))p.push(`|<i class="${b(g)}"></i>|${g.id}|`);return p.join(`
`)}}const T=new i;_.Registry.add(e.Extensions.IconContribution,T);function C(E,w,b,p){return T.registerIcon(E,w,b,p)}e.registerIcon=C;function m(){return T}e.getIconRegistry=m;function f(){for(const E of D.iconRegistry.all)T.registerIcon(E.id,E.definition,E.description);D.iconRegistry.onDidRegister(E=>T.registerIcon(E.id,E.definition,E.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let a=_.Registry.as(y.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,T.getIconSchema());const d=new P.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);T.onDidChange(()=>{d.isScheduled()||d.schedule()}),e.widgetClose=C("widget-close",D.Codicon.close,(0,I.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",D.Codicon.arrowUp,(0,I.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",D.Codicon.arrowDown,(0,I.localize)(4,null)),e.syncing=k.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(me[60],ge([0,1,2,25,4,24]),function(G,e,_,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var y;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function P(m){const f=m;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=P;function D(m){const f=m;return!!(f&&typeof f=="object"&&_.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=D;class i{constructor(f,a,d,E){this._id=f,this._configuration=d,this._ignorePathCasing=E,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=i;class T{constructor(f,a){this.raw=a,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,k.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=T;function C(m){return new T({uri:m,index:0,name:(0,k.basenameOrAuthority)(m)},{uri:m.toString()})}e.toWorkspaceFolder=C}),define(me[117],ge([0,1,4,158,60,2,9,8,25,133,55,11,76,30,116]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E($){return(typeof $=="string"?(0,P.extname)($):(0,D.extname)($))===d}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,_.createDecorator)("workspacesService");function w($){return $.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function b($){return $.hasOwnProperty("folderUri")}e.isRecentFolder=b;function p($){return $.hasOwnProperty("fileUri")}e.isRecentFile=p;function c($){const N=$;return typeof(N==null?void 0:N.id)=="string"&&I.URI.isUri(N.uri)}e.isSingleFolderWorkspaceIdentifier=c;function g($){if($.configuration)return{id:$.id,configPath:$.configuration};if($.folders.length===1)return{id:$.id,uri:$.folders[0].uri}}e.toWorkspaceIdentifier=g;function t($){const N=$;return typeof(N==null?void 0:N.id)=="string"&&I.URI.isUri(N.configPath)}e.isWorkspaceIdentifier=t;function n($){const N=$;if(N==null?void 0:N.uri)return{id:N.id,uri:I.URI.revive(N.uri)};const M=$;if(M==null?void 0:M.configPath)return{id:M.id,configPath:I.URI.revive(M.configPath)};if($==null?void 0:$.id)return{id:$.id}}e.reviveIdentifier=n;function s($,N){return D.extUriBiasedIgnorePathCase.isEqualOrParent($,N.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function r($){return o($)||l($)}e.isStoredWorkspaceFolder=r;function o($){const N=$;return typeof(N==null?void 0:N.path)=="string"&&(!N.name||typeof N.name=="string")}e.isRawFileWorkspaceFolder=o;function l($){const N=$;return typeof(N==null?void 0:N.uri)=="string"&&(!N.name||typeof N.name=="string")}e.isRawUriWorkspaceFolder=l;function h($,N,M,F,U=!y.isWindows,O){if($.scheme!==F.scheme)return{name:M,uri:$.toString(!0)};let W=N?void 0:O.relativePath(F,$);if(W!==void 0)W.length===0?W=".":y.isWindows&&$.scheme===C.Schemas.file&&!U&&(W=W.replace(/\//g,"\\"));else if($.scheme===C.Schemas.file)W=$.fsPath,y.isWindows&&(W=(0,m.normalizeDriveLetter)(W),U&&(W=(0,f.toSlashes)(W)));else{if(!O.isEqualAuthority($.authority,F.authority))return{name:M,uri:$.toString(!0)};W=$.path}return{name:M,path:W}}e.getStoredWorkspaceFolder=h;function S($,N,M){let F=[],U=new Set;const O=M.dirname(N);for(let W of $){let q=null;if(o(W))W.path&&(q=M.resolvePath(O,W.path));else if(l(W))try{q=I.URI.parse(W.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(Q){console.warn(Q)}if(q){let Q=M.getComparisonKey(q);if(!U.has(Q)){U.add(Q);const he=W.name||M.basenameOrAuthority(q);F.push(new A.WorkspaceFolder({uri:q,name:he,index:F.length},W))}}}return F}e.toWorkspaceFolders=S;function u($,N,M,F,U){let O=v(N,$);const W=U.dirname(N),q=U.dirname(F),Q=[],he=R(O.folders);for(const Le of O.folders){const V=o(Le)?U.resolvePath(W,Le.path):I.URI.parse(Le.uri);let J;M?J=!1:J=!o(Le)||(0,P.isAbsolute)(Le.path),Q.push(h(V,J,Le.name,q,he,U))}const ve={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},Ie=i.setProperty($,["folders"],Q,ve);let ke=i.applyEdits($,Ie);return O.remoteAuthority===(0,a.getRemoteAuthority)(F)&&(ke=i.applyEdits(ke,i.removeProperty(ke,["remoteAuthority"],ve))),ke}e.rewriteWorkspaceFileForNewLocation=u;function v($,N){let M=T.parse(N);if(M&&Array.isArray(M.folders))M.folders=M.folders.filter(F=>r(F));else throw new Error(`${$} looks like an invalid workspace file.`);return M}function R($){return y.isWindows?$.some(N=>o(N)&&N.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function L($){return $.workspace&&typeof $.workspace=="object"&&typeof $.workspace.id=="string"&&typeof $.workspace.configPath=="string"}function H($){return typeof $.folderUri=="string"}function ie($){return typeof $.fileUri=="string"}function j($,N){const M={workspaces:[],files:[]};if($){const F=function(O,W){for(let q=0;q<O.length;q++)try{W(O[q],q)}catch(Q){N.warn(`Error restoring recent entry ${JSON.stringify(O[q])}: ${Q.toString()}. Skip entry.`)}},U=$;if(Array.isArray(U.entries))F(U.entries,O=>{const W=O.label,q=O.remoteAuthority;L(O)?M.workspaces.push({label:W,remoteAuthority:q,workspace:{id:O.workspace.id,configPath:I.URI.parse(O.workspace.configPath)}}):H(O)?M.workspaces.push({label:W,remoteAuthority:q,folderUri:I.URI.parse(O.folderUri)}):ie(O)&&M.files.push({label:W,remoteAuthority:q,fileUri:I.URI.parse(O.fileUri)})});else{const O=$;Array.isArray(O.workspaces3)&&F(O.workspaces3,(W,q)=>{const Q=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[q]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?M.workspaces.push({label:Q,workspace:{id:W.id,configPath:I.URI.parse(W.configURIPath)}}):typeof W=="string"&&M.workspaces.push({label:Q,folderUri:I.URI.parse(W)})}),Array.isArray(O.files2)&&F(O.files2,(W,q)=>{const Q=Array.isArray(O.fileLabels)&&O.fileLabels[q]||void 0;typeof W=="string"&&M.files.push({label:Q,fileUri:I.URI.parse(W)})})}}return M}e.restoreRecentlyOpened=j;function B($){const N={entries:[]};for(const M of $.workspaces)b(M)?N.entries.push({folderUri:M.folderUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority}):N.entries.push({workspace:{id:M.workspace.id,configPath:M.workspace.configPath.toString()},label:M.label,remoteAuthority:M.remoteAuthority});for(const M of $.files)N.entries.push({fileUri:M.fileUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority});return N}e.toStoreData=B}),define(me[86],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class _{constructor(A){this.id=A,this._data=new Map,this._idPool=1}add(A){const I=this._idPool++;return this._data.set(I,A),this.logDebugInfo(),I}get(A,I){return this._data.has(A)?this._data.get(A)[I]:void 0}delete(A){this._data.delete(A),this.logDebugInfo()}logDebugInfo(){!_.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=_,_.enableDebugLogging=!1}),define(me[195],ge([0,1,2,3]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class A{constructor(){this._onDidChangeTabs=new k.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(P=>({name:P.name,group:P.group,resource:_.URI.revive(P.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(me[61],ge([0,1,11,4]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(_.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,P){P===null?this._providerInfo.delete(y):this._providerInfo.set(y,P)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,_.createDecorator)("IExtHostInitDataService")}),define(me[196],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class _{constructor(I,y,P){this._id=I,this._shared=y,this._storage=P,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(D=>(this._value=D,this)),this._storageListener=this._storage.onDidChangeStorage(D=>{D.shared===this._shared&&D.key===this._id&&(this._value=D.value)})}get whenReady(){return this._init}get(I,y){let P=this._value[I];return typeof P=="undefined"&&(P=y),P}update(I,y){return this._value[I]=y,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=_;class k extends _{constructor(I,y){super(I.identifier.value,!0,y);this._extension=I}setKeysForSync(I){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},I)}}e.ExtensionGlobalMemento=k}),define(me[14],ge([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,_.createDecorator)("IExtHostRpcService");class k{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.ExtHostRpcService=k});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!k:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(G):k?k.value:e.get(G)};define(me[197],ge([0,1,29,3]),function(G,e,_,k){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class I{constructor(P,D){A.set(this,void 0),this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._id=_.ExtensionIdentifier.toKey(P.identifier),tt(this,A,D,"f"),Ue(this,A,"f").onDidChangePassword(i=>{i.extensionId===this._id&&this._onDidChange.fire({key:i.key})})}get(P){return Ue(this,A,"f").get(this._id,P)}store(P,D){return Ue(this,A,"f").store(this._id,P,D)}delete(P){return Ue(this,A,"f").delete(this._id,P)}}e.ExtensionSecrets=I,A=new WeakMap}),define(me[118],ge([0,1,4,3]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class A{constructor(){this._onDidChangeTelemetryEnabled=new k.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=A,e.IExtHostTelemetry=(0,_.createDecorator)("IExtHostTelemetry")}),define(me[87],ge([0,1,3]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var k;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(k=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const A=new WeakMap,I=y=>{let P=A.get(y);return P||(P={children:new Map,bus:new _.Emitter},A.set(y,P)),P};e.getPrivateApiFor=I}),define(me[50],ge([0,1,4,3,14]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var I;(function(P){function D(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public}}P.fromApiTunnel=D;function i(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.public}}P.fromServiceTunnel=i})(I=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,_.createDecorator)("IExtHostTunnelService");let y=class{constructor(D){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,i){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,i){return{dispose:()=>{}}}async $providePortAttributes(D,i,T,C,m){return[]}async $forwardPort(D,i){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=je([Be(0,A.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!k:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(G):k?k.value:e.get(G)},Ht=this&&this.__rest||function(G,e){var _={};for(var k in G)Object.prototype.hasOwnProperty.call(G,k)&&e.indexOf(k)<0&&(_[k]=G[k]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,k=Object.getOwnPropertySymbols(G);A<k.length;A++)e.indexOf(k[A])<0&&Object.prototype.propertyIsEnumerable.call(G,k[A])&&(_[k[A]]=G[k[A]]);return _};define(me[7],ge([0,1,15,18,97,24,12,2,28,45,85,87]),function(G,e,_,k,A,I,y,P,D,i,T,C){"use strict";var m,f,a,d,E,w,b,p,c,g,t,n,s,r,o,l;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function h(z){function x(){return Reflect.construct(z,arguments,this.constructor)}return Object.defineProperty(x,"name",Object.getOwnPropertyDescriptor(z,"name")),Object.setPrototypeOf(x,z),Object.setPrototypeOf(x.prototype,z.prototype),x}let S=a=class{constructor(x){m.set(this,void 0),tt(this,m,x,"f")}static from(...x){let se=x;return new a(function(){if(se){for(const ye of se)ye&&typeof ye.dispose=="function"&&ye.dispose();se=void 0}})}dispose(){typeof Ue(this,m,"f")=="function"&&(Ue(this,m,"f").call(this),tt(this,m,void 0,"f"))}};m=new WeakMap,S=a=je([h],S),e.Disposable=S;let u=d=class{constructor(x,se){if(x<0)throw(0,k.illegalArgument)("line must be non-negative");if(se<0)throw(0,k.illegalArgument)("character must be non-negative");this._line=x,this._character=se}static Min(...x){if(x.length===0)throw new TypeError;let se=x[0];for(let ye=1;ye<x.length;ye++){const Ve=x[ye];Ve.isBefore(se)&&(se=Ve)}return se}static Max(...x){if(x.length===0)throw new TypeError;let se=x[0];for(let ye=1;ye<x.length;ye++){const Ve=x[ye];Ve.isAfter(se)&&(se=Ve)}return se}static isPosition(x){if(!x)return!1;if(x instanceof d)return!0;let{line:se,character:ye}=x;return typeof se=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<x._character}isBeforeOrEqual(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<=x._character}isAfter(x){return!this.isBeforeOrEqual(x)}isAfterOrEqual(x){return!this.isBefore(x)}isEqual(x){return this._line===x._line&&this._character===x._character}compareTo(x){return this._line<x._line?-1:this._line>x.line?1:this._character<x._character?-1:this._character>x._character?1:0}translate(x,se=0){if(x===null||se===null)throw(0,k.illegalArgument)();let ye;return typeof x=="undefined"?ye=0:typeof x=="number"?ye=x:(ye=typeof x.lineDelta=="number"?x.lineDelta:0,se=typeof x.characterDelta=="number"?x.characterDelta:0),ye===0&&se===0?this:new d(this.line+ye,this.character+se)}with(x,se=this.character){if(x===null||se===null)throw(0,k.illegalArgument)();let ye;return typeof x=="undefined"?ye=this.line:typeof x=="number"?ye=x:(ye=typeof x.line=="number"?x.line:this.line,se=typeof x.character=="number"?x.character:this.character),ye===this.line&&se===this.character?this:new d(ye,se)}toJSON(){return{line:this.line,character:this.character}}};u=d=je([h],u),e.Position=u;let v=E=class{constructor(x,se,ye,Ve){let Xe,ct;if(typeof x=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof Ve=="number"?(Xe=new u(x,se),ct=new u(ye,Ve)):x instanceof u&&se instanceof u&&(Xe=x,ct=se),!Xe||!ct)throw new Error("Invalid arguments");Xe.isBefore(ct)?(this._start=Xe,this._end=ct):(this._start=ct,this._end=Xe)}static isRange(x){return x instanceof E?!0:x?u.isPosition(x.start)&&u.isPosition(x.end):!1}get start(){return this._start}get end(){return this._end}contains(x){return x instanceof E?this.contains(x._start)&&this.contains(x._end):x instanceof u?!(x.isBefore(this._start)||this._end.isBefore(x)):!1}isEqual(x){return this._start.isEqual(x._start)&&this._end.isEqual(x._end)}intersection(x){const se=u.Max(x.start,this._start),ye=u.Min(x.end,this._end);if(!se.isAfter(ye))return new E(se,ye)}union(x){if(this.contains(x))return this;if(x.contains(this))return x;const se=u.Min(x.start,this._start),ye=u.Max(x.end,this.end);return new E(se,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(x,se=this.end){if(x===null||se===null)throw(0,k.illegalArgument)();let ye;return x?u.isPosition(x)?ye=x:(ye=x.start||this.start,se=x.end||this.end):ye=this.start,ye.isEqual(this._start)&&se.isEqual(this.end)?this:new E(ye,se)}toJSON(){return[this.start,this.end]}};v=E=je([h],v),e.Range=v;let R=w=class extends v{constructor(x,se,ye,Ve){let Xe,ct;if(typeof x=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof Ve=="number"?(Xe=new u(x,se),ct=new u(ye,Ve)):x instanceof u&&se instanceof u&&(Xe=x,ct=se),!Xe||!ct)throw new Error("Invalid arguments");super(Xe,ct);this._anchor=Xe,this._active=ct}static isSelection(x){return x instanceof w?!0:x?v.isRange(x)&&u.isPosition(x.anchor)&&u.isPosition(x.active)&&typeof x.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};R=w=je([h],R),e.Selection=R;class L{constructor(x,se,ye){if(typeof x!="string"||x.length===0)throw(0,k.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,k.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,k.illegalArgument)("connectionToken");this.host=x,this.port=Math.round(se),this.connectionToken=ye}}e.ResolvedAuthority=L;class H extends Error{constructor(x,se=T.RemoteAuthorityResolverErrorCode.Unknown,ye){super(x);this._message=x,this._code=se,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,H.prototype)}static NotAvailable(x,se){return new H(x,T.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(x){return new H(x,T.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=H;var ie;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(ie=e.EndOfLine||(e.EndOfLine={}));var j;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(j=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=b=class{constructor(x,se){this._range=x,this._newText=se}static isTextEdit(x){return x instanceof b?!0:x?v.isRange(x)&&typeof x.newText=="string":!1}static replace(x,se){return new b(x,se)}static insert(x,se){return b.replace(new v(x,x),se)}static delete(x){return b.replace(x,"")}static setEndOfLine(x){const se=new b(new v(new u(0,0),new u(0,0)),"");return se.newEol=x,se}get range(){return this._range}set range(x){if(x&&!v.isRange(x))throw(0,k.illegalArgument)("range");this._range=x}get newText(){return this._newText||""}set newText(x){if(x&&typeof x!="string")throw(0,k.illegalArgument)("newText");this._newText=x}get newEol(){return this._newEol}set newEol(x){if(x&&typeof x!="number")throw(0,k.illegalArgument)("newEol");this._newEol=x}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=b=je([h],B),e.TextEdit=B;var $;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellOutput=4]="CellOutput",z[z.CellReplace=5]="CellReplace",z[z.CellOutputItem=6]="CellOutputItem"})($=e.FileEditType||(e.FileEditType={}));let N=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(x,se,ye,Ve){this._edits.push({_type:1,from:x,to:se,options:ye,metadata:Ve})}createFile(x,se,ye){this._edits.push({_type:1,from:void 0,to:x,options:se,metadata:ye})}deleteFile(x,se,ye){this._edits.push({_type:1,from:x,to:void 0,options:se,metadata:ye})}replaceNotebookMetadata(x,se,ye){this._edits.push({_type:3,metadata:ye,uri:x,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(x,se,ye,Ve,Xe){(se!==ye||Ve.length>0)&&this._edits.push({_type:5,uri:x,index:se,count:ye-se,cells:Ve,metadata:Xe})}replaceNotebookCellOutput(x,se,ye,Ve){this._editNotebookCellOutput(x,se,!1,ye,Ve)}appendNotebookCellOutput(x,se,ye,Ve){this._editNotebookCellOutput(x,se,!0,ye,Ve)}replaceNotebookCellOutputItems(x,se,ye,Ve,Xe){this._editNotebookCellOutputItems(x,se,ye,!1,Ve,Xe)}appendNotebookCellOutputItems(x,se,ye,Ve,Xe){this._editNotebookCellOutputItems(x,se,ye,!0,Ve,Xe)}_editNotebookCellOutputItems(x,se,ye,Ve,Xe,ct){this._edits.push({_type:6,metadata:ct,uri:x,index:se,outputId:ye,append:Ve,newOutputItems:Xe})}_editNotebookCellOutput(x,se,ye,Ve,Xe){this._edits.push({_type:4,metadata:Xe,uri:x,index:se,append:ye,newOutputs:Ve,newMetadata:void 0})}replaceNotebookCellMetadata(x,se,ye,Ve){this._edits.push({_type:3,metadata:Ve,uri:x,edit:{editType:11,index:se,metadata:ye}})}replace(x,se,ye,Ve){this._edits.push({_type:2,uri:x,edit:new B(se,ye),metadata:Ve})}insert(x,se,ye,Ve){this.replace(x,new v(se,se),ye,Ve)}delete(x,se,ye){this.replace(x,se,"",ye)}has(x){return this._edits.some(se=>se._type===2&&se.uri.toString()===x.toString())}set(x,se){if(se)for(const ye of se)ye&&this._edits.push({_type:2,uri:x,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const Ve=this._edits[ye];Ve._type===2&&Ve.uri.toString()===x.toString()&&(this._edits[ye]=void 0)}(0,_.coalesceInPlace)(this._edits)}}get(x){const se=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===x.toString()&&se.push(ye.edit);return se}entries(){const x=new I.ResourceMap;for(let se of this._edits)if(se._type===2){let ye=x.get(se.uri);ye||(ye=[se.uri,[]],x.set(se.uri,ye)),ye[1].push(se.edit)}return[...x.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};N=je([h],N),e.WorkspaceEdit=N;let M=p=class{constructor(x){this._tabstop=1,this.value=x||""}static isSnippetString(x){return x instanceof p?!0:x?typeof x.value=="string":!1}static _escape(x){return x.replace(/\$|}|\\/g,"\\$&")}appendText(x){return this.value+=p._escape(x),this}appendTabstop(x=this._tabstop++){return this.value+="$",this.value+=x,this}appendPlaceholder(x,se=this._tabstop++){if(typeof x=="function"){const ye=new p;ye._tabstop=this._tabstop,x(ye),this._tabstop=ye._tabstop,x=ye.value}else x=p._escape(x);return this.value+="${",this.value+=se,this.value+=":",this.value+=x,this.value+="}",this}appendChoice(x,se=this._tabstop++){const ye=x.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(x,se){if(typeof se=="function"){const ye=new p;ye._tabstop=this._tabstop,se(ye),this._tabstop=ye._tabstop,se=ye.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=x,se&&(this.value+=":",this.value+=se),this.value+="}",this}};M=p=je([h],M),e.SnippetString=M;var F;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(F=e.DiagnosticTag||(e.DiagnosticTag={}));var U;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(U=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let O=c=class{constructor(x,se){if(this.uri=x,se)if(se instanceof v)this.range=se;else if(se instanceof u)this.range=new v(se,se);else throw new Error("Illegal argument")}static isLocation(x){return x instanceof c?!0:x?v.isRange(x.range)&&P.URI.isUri(x.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};O=c=je([h],O),e.Location=O;let W=class{constructor(x,se){this.location=x,this.message=se}static is(x){return x?typeof x.message=="string"&&x.location&&v.isRange(x.location.range)&&P.URI.isUri(x.location.uri):!1}static isEqual(x,se){return x===se?!0:!x||!se?!1:x.message===se.message&&x.location.range.isEqual(se.location.range)&&x.location.uri.toString()===se.location.uri.toString()}};W=je([h],W),e.DiagnosticRelatedInformation=W;let q=class{constructor(x,se,ye=U.Error){if(!v.isRange(x))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=x,this.message=se,this.severity=ye}toJSON(){return{severity:U[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(x,se){return x===se?!0:!x||!se?!1:x.message===se.message&&x.severity===se.severity&&x.code===se.code&&x.severity===se.severity&&x.source===se.source&&x.range.isEqual(se.range)&&(0,_.equals)(x.tags,se.tags)&&(0,_.equals)(x.relatedInformation,se.relatedInformation,W.isEqual)}};q=je([h],q),e.Diagnostic=q;let Q=class{constructor(x,se){if(!x)throw new Error("Illegal argument, contents must be defined");Array.isArray(x)?this.contents=x:(0,A.isMarkdownString)(x)?this.contents=[x]:this.contents=[x],this.range=se}};Q=je([h],Q),e.Hover=Q;var he;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(he=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ve=class{constructor(x,se=he.Text){this.range=x,this.kind=se}toJSON(){return{range:this.range,kind:he[this.kind]}}};ve=je([h],ve),e.DocumentHighlight=ve;var Ie;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Ie=e.SymbolKind||(e.SymbolKind={}));var ke;(function(z){z[z.Deprecated=1]="Deprecated"})(ke=e.SymbolTag||(e.SymbolTag={}));let Le=g=class{constructor(x,se,ye,Ve,Xe){this.name=x,this.kind=se,this.containerName=Xe,typeof ye=="string"&&(this.containerName=ye),Ve instanceof O?this.location=Ve:ye instanceof v&&(this.location=new O(Ve,ye)),g.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ie[this.kind],location:this.location,containerName:this.containerName}}};Le=g=je([h],Le),e.SymbolInformation=Le;let V=t=class{constructor(x,se,ye,Ve,Xe){this.name=x,this.detail=se,this.kind=ye,this.range=Ve,this.selectionRange=Xe,this.children=[],t.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy");if(!x.range.contains(x.selectionRange))throw new Error("selectionRange must be contained in fullRange");x.children&&x.children.forEach(t.validate)}};V=t=je([h],V),e.DocumentSymbol=V;var J;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(J=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ee=class{constructor(x,se){this.title=x,this.kind=se}};ee=je([h],ee),e.CodeAction=ee;let ae=n=class{constructor(x){this.value=x}append(x){return new n(this.value?this.value+n.sep+x:x)}intersects(x){return this.contains(x)||x.contains(this)}contains(x){return this.value===x.value||x.value.startsWith(this.value+n.sep)}};ae.sep=".",ae=n=je([h],ae),e.CodeActionKind=ae,ae.Empty=new ae(""),ae.QuickFix=ae.Empty.append("quickfix"),ae.Refactor=ae.Empty.append("refactor"),ae.RefactorExtract=ae.Refactor.append("extract"),ae.RefactorInline=ae.Refactor.append("inline"),ae.RefactorRewrite=ae.Refactor.append("rewrite"),ae.Source=ae.Empty.append("source"),ae.SourceOrganizeImports=ae.Source.append("organizeImports"),ae.SourceFixAll=ae.Source.append("fixAll");let we=class{constructor(x,se){if(this.range=x,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};we=je([h],we),e.SelectionRange=we;class Ce{constructor(x,se,ye,Ve,Xe,ct){this.kind=x,this.name=se,this.detail=ye,this.uri=Ve,this.range=Xe,this.selectionRange=ct}}e.CallHierarchyItem=Ce;class Oe{constructor(x,se){this.fromRanges=se,this.from=x}}e.CallHierarchyIncomingCall=Oe;class be{constructor(x,se){this.fromRanges=se,this.to=x}}e.CallHierarchyOutgoingCall=be;let Pe=class{constructor(x,se){this.range=x,this.command=se}get isResolved(){return!!this.command}};Pe=je([h],Pe),e.CodeLens=Pe;let Re=s=class{constructor(x,se=!1){f.set(this,void 0),tt(this,f,new A.MarkdownString(x,{supportThemeIcons:se}),"f")}static isMarkdownString(x){return x instanceof s?!0:x&&x.appendCodeblock&&x.appendMarkdown&&x.appendText&&x.value!==void 0}get value(){return Ue(this,f,"f").value}set value(x){Ue(this,f,"f").value=x}get isTrusted(){return Ue(this,f,"f").isTrusted}set isTrusted(x){Ue(this,f,"f").isTrusted=x}get supportThemeIcons(){return Ue(this,f,"f").supportThemeIcons}appendText(x){return Ue(this,f,"f").appendText(x),this}appendMarkdown(x){return Ue(this,f,"f").appendMarkdown(x),this}appendCodeblock(x,se){return Ue(this,f,"f").appendCodeblock(se!=null?se:"",x),this}};f=new WeakMap,Re=s=je([h],Re),e.MarkdownString=Re;let We=class{constructor(x,se){this.label=x,this.documentation=se}};We=je([h],We),e.ParameterInformation=We;let Ee=class{constructor(x,se){this.label=x,this.documentation=se,this.parameters=[]}};Ee=je([h],Ee),e.SignatureInformation=Ee;let Ke=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ke=je([h],Ke),e.SignatureHelp=Ke;var X;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var re;(function(z){z[z.Other=0]="Other",z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(re=e.InlineHintKind||(e.InlineHintKind={}));let _e=class{constructor(x,se,ye){this.text=x,this.range=se,this.kind=ye}};_e=je([h],_e),e.InlineHint=_e;var xe;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(ze=e.CompletionItemKind||(e.CompletionItemKind={}));var $e;(function(z){z[z.Deprecated=1]="Deprecated"})($e=e.CompletionItemTag||(e.CompletionItemTag={}));let Ye=class{constructor(x,se){this.label=x,this.kind=se}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&ze[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ye=je([h],Ye),e.CompletionItem=Ye;let K=class{constructor(x=[],se=!1){this.items=x,this.isIncomplete=se}};K=je([h],K),e.CompletionList=K;var oe;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(oe=e.ViewColumn||(e.ViewColumn={}));var fe;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(fe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Z;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(Z=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ne;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(ne=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ce;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(ce=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pe;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(pe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Se;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Se=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function x(se){switch(se){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=x}(pe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let qe=class{constructor(x,se){if(se&&!P.URI.isUri(se))throw(0,k.illegalArgument)("target");if(!v.isRange(x)||x.isEmpty)throw(0,k.illegalArgument)("range");this.range=x,this.target=se}};qe=je([h],qe),e.DocumentLink=qe;let Me=class{constructor(x,se,ye,Ve){this.red=x,this.green=se,this.blue=ye,this.alpha=Ve}};Me=je([h],Me),e.Color=Me;let He=class{constructor(x,se){if(se&&!(se instanceof Me))throw(0,k.illegalArgument)("color");if(!v.isRange(x)||x.isEmpty)throw(0,k.illegalArgument)("range");this.range=x,this.color=se}};He=je([h],He),e.ColorInformation=He;let Qe=class{constructor(x){if(!x||typeof x!="string")throw(0,k.illegalArgument)("label");this.label=x}};Qe=je([h],Qe),e.ColorPresentation=Qe;var it;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(it=e.ColorFormat||(e.ColorFormat={}));var at;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(at=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ze;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Ze=e.TaskRevealKind||(e.TaskRevealKind={}));var nt;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(nt=e.TaskPanelKind||(e.TaskPanelKind={}));let dt=r=class{constructor(x,se){if(typeof x!="string"||typeof se!="string")throw(0,k.illegalArgument)("name");this._id=x}static from(x){switch(x){case"clean":return r.Clean;case"build":return r.Build;case"rebuild":return r.Rebuild;case"test":return r.Test;default:return}}get id(){return this._id}};dt.Clean=new r("clean","Clean"),dt.Build=new r("build","Build"),dt.Rebuild=new r("rebuild","Rebuild"),dt.Test=new r("test","Test"),dt=r=je([h],dt),e.TaskGroup=dt;function _t(z){let x="";for(let se=0;se<z.length;se++)x+=z[se].replace(/,/g,",,")+",";return x}let ue=class{constructor(x,se,ye){if(typeof x!="string")throw(0,k.illegalArgument)("process");this._args=[],this._process=x,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=ye):this._options=se)}get process(){return this._process}set process(x){if(typeof x!="string")throw(0,k.illegalArgument)("process");this._process=x}get args(){return this._args}set args(x){Array.isArray(x)||(x=[]),this._args=x}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("process"),this._process!==void 0&&x.push(this._process),this._args&&this._args.length>0)for(let se of this._args)x.push(se);return _t(x)}};ue=je([h],ue),e.ProcessExecution=ue;let De=class{constructor(x,se,ye){if(this._args=[],Array.isArray(se)){if(!x)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof x!="string"&&typeof x.value!="string")throw(0,k.illegalArgument)("command");this._command=x,this._args=se,this._options=ye}else{if(typeof x!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=x,this._options=se}}get commandLine(){return this._commandLine}set commandLine(x){if(typeof x!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=x}get command(){return this._command?this._command:""}set command(x){if(typeof x!="string"&&typeof x.value!="string")throw(0,k.illegalArgument)("command");this._command=x}get args(){return this._args}set args(x){this._args=x||[]}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("shell"),this._commandLine!==void 0&&x.push(this._commandLine),this._command!==void 0&&x.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)x.push(typeof se=="string"?se:se.value);return _t(x)}};De=je([h],De),e.ShellExecution=De;var le;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(le=e.ShellQuoting||(e.ShellQuoting={}));var Y;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(Y=e.TaskScope||(e.TaskScope={}));class Ne{constructor(x){this._callback=x}computeId(){return"customExecution"+(0,D.generateUuid)()}set callback(x){this._callback=x}get callback(){return this._callback}}e.CustomExecution=Ne;let Te=o=class{constructor(x,se,ye,Ve,Xe,ct){this.__deprecated=!1,this._definition=this.definition=x;let gt;typeof se=="string"?(this._name=this.name=se,this._source=this.source=ye,this.execution=Ve,gt=Xe,this.__deprecated=!0):se===Y.Global||se===Y.Workspace?(this.target=se,this._name=this.name=ye,this._source=this.source=Ve,this.execution=Xe,gt=ct):(this.target=se,this._name=this.name=ye,this._source=this.source=Ve,this.execution=Xe,gt=ct),typeof gt=="string"?(this._problemMatchers=[gt],this._hasDefinedMatchers=!0):Array.isArray(gt)?(this._problemMatchers=gt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(x){this.__id=x}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ue?this._definition={type:o.ProcessType,id:this._execution.computeId()}:this._execution instanceof De?this._definition={type:o.ShellType,id:this._execution.computeId()}:this._execution instanceof Ne?this._definition={type:o.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:o.EmptyType,id:(0,D.generateUuid)()}}get definition(){return this._definition}set definition(x){if(x==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=x}get scope(){return this._scope}set target(x){this.clear(),this._scope=x}get name(){return this._name}set name(x){if(typeof x!="string")throw(0,k.illegalArgument)("name");this.clear(),this._name=x}get execution(){return this._execution}set execution(x){x===null&&(x=void 0),this.clear(),this._execution=x;const se=this._definition.type;(o.EmptyType===se||o.ProcessType===se||o.ShellType===se||o.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(x){if(Array.isArray(x))this.clear(),this._problemMatchers=x,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(x){x!==!0&&x!==!1&&(x=!1),this.clear(),this._isBackground=x}get source(){return this._source}set source(x){if(typeof x!="string"||x.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=x}get group(){return this._group}set group(x){x===null&&(x=void 0),this.clear(),this._group=x}get detail(){return this._detail}set detail(x){x===null&&(x=void 0),this._detail=x}get presentationOptions(){return this._presentationOptions}set presentationOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._presentationOptions=x}get runOptions(){return this._runOptions}set runOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._runOptions=x}};Te.ExtensionCallbackType="customExecution",Te.ProcessType="process",Te.ShellType="shell",Te.EmptyType="$empty",Te=o=je([h],Te),e.Task=Te;var Je;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(Je=e.ProgressLocation||(e.ProgressLocation={}));let et=class{constructor(x,se=ut.None){this.collapsibleState=se,P.URI.isUri(x)?this.resourceUri=x:this.label=x}};et=je([h],et),e.TreeItem=et;var ut;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let rt=class{constructor(x,se){this.id=x,this.color=se}};rt=je([h],rt),e.ThemeIcon=rt,rt.File=new rt("file"),rt.Folder=new rt("folder");let Ge=class{constructor(x){this.id=x}};Ge=je([h],Ge),e.ThemeColor=Ge;var ht;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(ht=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ot=class{constructor(x,se){if(typeof x!="string"&&(!x||!P.URI.isUri(x)&&!P.URI.isUri(x.uri)))throw(0,k.illegalArgument)("base");if(typeof se!="string")throw(0,k.illegalArgument)("pattern");typeof x=="string"?(this.baseFolder=P.URI.file(x),this.base=x):P.URI.isUri(x)?(this.baseFolder=x,this.base=x.fsPath):(this.baseFolder=x.uri,this.base=x.uri.fsPath),this.pattern=se}};ot=je([h],ot),e.RelativePattern=ot;let vt=class{constructor(x,se,ye,Ve){this.enabled=typeof x=="boolean"?x:!0,typeof se=="string"&&(this.condition=se),typeof ye=="string"&&(this.hitCondition=ye),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=(0,D.generateUuid)()),this._id}};vt=je([h],vt),e.Breakpoint=vt;let pt=class extends vt{constructor(x,se,ye,Ve,Xe){super(se,ye,Ve,Xe);if(x===null)throw(0,k.illegalArgument)("location");this.location=x}};pt=je([h],pt),e.SourceBreakpoint=pt;let Et=class extends vt{constructor(x,se,ye,Ve,Xe){super(se,ye,Ve,Xe);this.functionName=x}};Et=je([h],Et),e.FunctionBreakpoint=Et;let yt=class extends vt{constructor(x,se,ye,Ve,Xe,ct,gt){super(Ve,Xe,ct,gt);if(!se)throw(0,k.illegalArgument)("dataId");this.label=x,this.dataId=se,this.canPersist=ye}};yt=je([h],yt),e.DataBreakpoint=yt;let It=class{constructor(x,se,ye){this.command=x,this.args=se||[],this.options=ye}};It=je([h],It),e.DebugAdapterExecutable=It;let bt=class{constructor(x,se){this.port=x,this.host=se}};bt=je([h],bt),e.DebugAdapterServer=bt;let At=class{constructor(x){this.path=x}};At=je([h],At),e.DebugAdapterNamedPipeServer=At;let Qt=class{constructor(x){this.implementation=x}};Qt=je([h],Qt),e.DebugAdapterInlineImplementation=Qt;let ft=class{constructor(x,se){this.range=x,this.expression=se}};ft=je([h],ft),e.EvaluatableExpression=ft;let Xt=class{constructor(x,se){this.range=x,this.text=se}};Xt=je([h],Xt),e.InlineValueText=Xt;let St=class{constructor(x,se,ye=!0){this.range=x,this.variableName=se,this.caseSensitiveLookup=ye}};St=je([h],St),e.InlineValueVariableLookup=St;let zt=class{constructor(x,se){this.range=x,this.expression=se}};zt=je([h],zt),e.InlineValueEvaluatableExpression=zt;let Yt=class{constructor(x,se){this.frameId=x,this.stoppedLocation=se}};Yt=je([h],Yt),e.InlineValueContext=Yt;var Vt;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let lt=l=class extends Error{constructor(x,se=i.FileSystemProviderErrorCode.Unknown,ye){var Ve;super(P.URI.isUri(x)?x.toString(!0):x);this.code=(Ve=ye==null?void 0:ye.name)!==null&&Ve!==void 0?Ve:"Unknown",(0,i.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,l.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(x){return new l(x,i.FileSystemProviderErrorCode.FileExists,l.FileExists)}static FileNotFound(x){return new l(x,i.FileSystemProviderErrorCode.FileNotFound,l.FileNotFound)}static FileNotADirectory(x){return new l(x,i.FileSystemProviderErrorCode.FileNotADirectory,l.FileNotADirectory)}static FileIsADirectory(x){return new l(x,i.FileSystemProviderErrorCode.FileIsADirectory,l.FileIsADirectory)}static NoPermissions(x){return new l(x,i.FileSystemProviderErrorCode.NoPermissions,l.NoPermissions)}static Unavailable(x){return new l(x,i.FileSystemProviderErrorCode.Unavailable,l.Unavailable)}};lt=l=je([h],lt),e.FileSystemError=lt;let Jt=class{constructor(x,se,ye){this.start=x,this.end=se,this.kind=ye}};Jt=je([h],Jt),e.FoldingRange=Jt;var Tt;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Nt;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Nt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var fn;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(fn=e.CommentMode||(e.CommentMode={}));class _n{constructor(x,se=[]){this.tokenTypes=x,this.tokenModifiers=se}}e.SemanticTokensLegend=_n;function mn(z){return typeof z=="undefined"||(0,y.isStringArray)(z)}class Zt{constructor(x){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,x){this._hasLegend=!0;for(let se=0,ye=x.tokenTypes.length;se<ye;se++)this._tokenTypeStrToInt.set(x.tokenTypes[se],se);for(let se=0,ye=x.tokenModifiers.length;se<ye;se++)this._tokenModifierStrToInt.set(x.tokenModifiers[se],se)}}push(x,se,ye,Ve,Xe){if(typeof x=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof Ve=="number"&&(typeof Xe=="number"||typeof Xe=="undefined"))return typeof Xe=="undefined"&&(Xe=0),this._pushEncoded(x,se,ye,Ve,Xe);if(v.isRange(x)&&typeof se=="string"&&mn(ye))return this._push(x,se,ye);throw(0,k.illegalArgument)()}_push(x,se,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(x.start.line!==x.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Ve=x.start.line,Xe=x.start.character,ct=x.end.character-x.start.character,gt=this._tokenTypeStrToInt.get(se);let Dt=0;if(ye)for(const Ct of ye){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const kt=this._tokenModifierStrToInt.get(Ct);Dt|=1<<kt>>>0}this._pushEncoded(Ve,Xe,ct,gt,Dt)}_pushEncoded(x,se,ye,Ve,Xe){if(this._dataIsSortedAndDeltaEncoded&&(x<this._prevLine||x===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let Ct=0,kt=0;for(let Pt=0;Pt<Dt;Pt++){let Lt=this._data[5*Pt],un=this._data[5*Pt+1];Lt===0?(Lt=Ct,un+=kt):Lt+=Ct,this._data[5*Pt]=Lt,this._data[5*Pt+1]=un,Ct=Lt,kt=un}}let ct=x,gt=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(gt-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=gt,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=Xe,this._prevLine=x,this._prevChar=se}static _sortAndDeltaEncode(x){let se=[];const ye=x.length/5|0;for(let gt=0;gt<ye;gt++)se[gt]=gt;se.sort((gt,Dt)=>{const Ct=x[5*gt],kt=x[5*Dt];if(Ct===kt){const Pt=x[5*gt+1],Lt=x[5*Dt+1];return Pt-Lt}return Ct-kt});const Ve=new Uint32Array(x.length);let Xe=0,ct=0;for(let gt=0;gt<ye;gt++){const Dt=5*se[gt],Ct=x[Dt+0],kt=x[Dt+1],Pt=x[Dt+2],Lt=x[Dt+3],un=x[Dt+4],Ln=Ct-Xe,Un=Ln===0?kt-ct:kt,dn=5*gt;Ve[dn+0]=Ln,Ve[dn+1]=Un,Ve[dn+2]=Pt,Ve[dn+3]=Lt,Ve[dn+4]=un,Xe=Ct,ct=kt}return Ve}build(x){return this._dataIsSortedAndDeltaEncoded?new jt(new Uint32Array(this._data),x):new jt(Zt._sortAndDeltaEncode(this._data),x)}}e.SemanticTokensBuilder=Zt;class jt{constructor(x,se){this.resultId=se,this.data=x}}e.SemanticTokens=jt;class Mt{constructor(x,se,ye){this.start=x,this.deleteCount=se,this.data=ye}}e.SemanticTokensEdit=Mt;class En{constructor(x,se){this.resultId=se,this.edits=x}}e.SemanticTokensEdits=En;var en;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(en=e.DebugConsoleMode||(e.DebugConsoleMode={}));var tn;(function(z){z[z.Initial=1]="Initial",z[z.Dynamic=2]="Dynamic"})(tn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let qt=class{constructor(){}};qt.Back={iconPath:new rt("arrow-left")},qt=je([h],qt),e.QuickInputButtons=qt;var Sn;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(Sn=e.ExtensionKind||(e.ExtensionKind={}));class Rt{constructor(x,se,ye){this.badge=x,this.tooltip=se,this.color=ye}static validate(x){if(x.badge&&x.badge.length!==1&&x.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!x.color&&!x.badge&&!x.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Rt;let nn=class{constructor(x){this.kind=x}};nn=je([h],nn),e.ColorTheme=nn;var yn;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast"})(yn=e.ColorThemeKind||(e.ColorThemeKind={}));class rn{constructor(x,se){if(x<0)throw(0,k.illegalArgument)("start must be positive");if(se<0)throw(0,k.illegalArgument)("end must be positive");x<=se?(this._start=x,this._end=se):(this._start=se,this._end=x)}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(x){let se=this._start,ye=this._end;return x.start!==void 0&&(se=x.start),x.end!==void 0&&(ye=x.end),se===this._start&&ye===this._end?this:new rn(se,ye)}}e.NotebookRange=rn;class sn{constructor(x,se){typeof x=="object"?Object.assign(this,x):(this.inputCollapsed=x,this.outputCollapsed=se)}with(x){let{inputCollapsed:se,outputCollapsed:ye,custom:Ve}=x,Xe=Ht(x,["inputCollapsed","outputCollapsed","custom"]);return se===void 0?se=this.inputCollapsed:se===null&&(se=void 0),ye===void 0?ye=this.outputCollapsed:ye===null&&(ye=void 0),Ve===void 0?Ve=this.custom:Ve===null&&(Ve=void 0),se===this.inputCollapsed&&ye===this.outputCollapsed&&Ve===this.custom&&Object.keys(Xe).length===0?this:new sn(Object.assign({inputCollapsed:se,outputCollapsed:ye,custom:Ve},Xe))}}e.NotebookCellMetadata=sn;class Ot{constructor(x=!0,se={}){var ye,Ve;typeof x=="object"?(Object.assign(this,x),this.trusted=(ye=x.trusted)!==null&&ye!==void 0?ye:!0,this.custom=(Ve=x.custom)!==null&&Ve!==void 0?Ve:{}):(this.trusted=x,this.custom=se)}with(x){let{custom:se,trusted:ye}=x,Ve=Ht(x,["custom","trusted"]);return se===void 0?se=this.custom:se===null&&(se=void 0),ye===void 0?ye=this.trusted:ye===null&&(ye=void 0),se===this.custom&&ye===this.trusted&&Object.keys(Ve).length===0?this:new Ot(Object.assign({trusted:ye,custom:se},Ve))}}e.NotebookDocumentMetadata=Ot;class gn{constructor(x,se,ye,Ve,Xe,ct){this.kind=x,this.source=se,this.language=ye,this.outputs=Ve!=null?Ve:[],this.metadata=Xe,this.latestExecutionSummary=ct}}e.NotebookCellData=gn;class pn{constructor(x,se){this.cells=x,this.metadata=se!=null?se:new Ot}}e.NotebookData=pn;class Ut{constructor(x,se,ye){this.mime=x,this.value=se,this.metadata=ye}static isNotebookCellOutputItem(x){return x instanceof Ut}}e.NotebookCellOutputItem=Ut;class Fe{constructor(x,se,ye){this.outputs=x,typeof se=="string"?(this.id=se,this.metadata=ye):(this.id=(0,D.generateUuid)(),this.metadata=se!=null?se:ye)}}e.NotebookCellOutput=Fe;var on;(function(z){z[z.Markdown=1]="Markdown",z[z.Code=2]="Code"})(on=e.NotebookCellKind||(e.NotebookCellKind={}));var an;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(an=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var mt;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(mt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Dn;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Dn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Cn{constructor(x,se,ye,Ve,Xe,ct){this.text=x,this.alignment=se,this.command=ye,this.tooltip=Ve,this.priority=Xe,this.accessibilityInformation=ct}}e.NotebookCellStatusBarItem=Cn;let Kt=class{constructor(x,se){this.label=x,this.timestamp=se}};Kt=je([h],Kt),e.TimelineItem=Kt;var vn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(vn=e.ExtensionMode||(e.ExtensionMode={}));var kn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(kn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Pn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=4]="RegEx"})(Pn=e.StandardTokenType||(e.StandardTokenType={}));class In{constructor(x,se){this.ranges=x,this.wordPattern=se}}e.LinkedEditingRanges=In;var An;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(An=e.TestResultState||(e.TestResultState={}));var ln;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information",z[z.Hint=3]="Hint"})(ln=e.TestMessageSeverity||(e.TestMessageSeverity={}));var wn;(function(z){z[z.Pending=0]="Pending",z[z.Resolved=1]="Resolved"})(wn=e.TestItemStatus||(e.TestItemStatus={}));const xt=(z,x,se,ye)=>{let Ve=se;return{enumerable:!0,configurable:!1,get(){return Ve},set(Xe){ye(Ve,Xe)||(Ve=Xe,z.bus.fire([3,x,Xe]))}}},Gt=(z,x)=>z===x,Tn=(z,x)=>z===x?!0:!z||!x?!1:z.isEqual(x);class cn{constructor(x,se,ye,Ve){this.label=se,this.data=Ve;const Xe=(0,C.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:x,enumerable:!0,writable:!1},uri:{value:ye,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>Xe.parent},children:{value:new I.ReadonlyMapView(Xe.children),enumerable:!0,writable:!1},range:xt(Xe,"range",void 0,Tn),description:xt(Xe,"description",void 0,Gt),runnable:xt(Xe,"runnable",!0,Gt),debuggable:xt(Xe,"debuggable",!0,Gt),status:xt(Xe,"status",wn.Resolved,Gt)})}invalidate(){(0,C.getPrivateApiFor)(this).bus.fire([2])}dispose(){const x=(0,C.getPrivateApiFor)(this);x.parent&&(0,C.getPrivateApiFor)(x.parent).children.delete(this.id),x.bus.fire([1])}addChild(x){if(!(x instanceof cn))throw new Error("Test child must be created through vscode.test.createTestItem()");const se=(0,C.getPrivateApiFor)(this);if(se.children.has(x.id))throw new Error(`Attempted to insert a duplicate test item ID ${x.id}`);se.children.set(x.id,x),se.bus.fire([0,x])}}e.TestItemImpl=cn;class te{constructor(x){this.message=x,this.severity=ln.Error}static diff(x,se,ye){const Ve=new te(x);return Ve.expectedOutput=se,Ve.actualOutput=ye,Ve}}e.TestMessage=te;var de;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(de=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ae;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(Ae=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var st;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore"})(st=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(me[119],ge([0,1,52,11,10,144,108,7,15]),function(G,e,_,k,A,I,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const i=new Map;function T(a,d){d?i.set(a,d):i.delete(a)}e.setWordDefinitionFor=T;function C(a){return i.get(a)}e.getWordDefinitionFor=C;class m extends I.MirrorTextModel{constructor(d,E,w,b,p,c,g,t){super(E,w,b,p);this._proxy=d,this._languageId=c,this._isDirty=g,this._notebook=t,this._isDisposed=!1}dispose(){(0,_.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,D.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===k.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(E){return E?d._getTextInRange(E):d.getText()},get eol(){return d._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(E){return d._lineAt(E)},offsetAt(E){return d._offsetAt(E)},positionAt(E){return d._positionAt(E)},validateRange(E){return d._validateRange(E)},validatePosition(E){return d._validatePosition(E)},getWordRangeAtPosition(E,w){return d._getWordRangeAtPosition(E,w)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,_.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,_.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const E=this._validateRange(d);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const w=this._eol,b=E.start.line,p=E.end.line,c=[];c.push(this._lines[b].substring(E.start.character));for(let g=b+1;g<p;g++)c.push(this._lines[g]);return c.push(this._lines[p].substring(0,E.end.character)),c.join(w)}_lineAt(d){let E;if(d instanceof P.Position?E=d.line:typeof d=="number"&&(E=d),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new f(E,this._lines[E],E===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(d),w=this._lines[E.index].length;return new P.Position(E.index,Math.min(E.remainder,w))}_validateRange(d){if(!(d instanceof P.Range))throw new Error("Invalid argument");const E=this._validatePosition(d.start),w=this._validatePosition(d.end);return E===d.start&&w===d.end?d:new P.Range(E.line,E.character,w.line,w.character)}_validatePosition(d){if(!(d instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:E,character:w}=d,b=!1;if(E<0)E=0,w=0,b=!0;else if(E>=this._lines.length)E=this._lines.length-1,w=this._lines[E].length,b=!0;else{const p=this._lines[E].length;w<0?(w=0,b=!0):w>p&&(w=p,b=!0)}return b?new P.Position(E,w):d}_getWordRangeAtPosition(d,E){const w=this._validatePosition(d);if(!E)E=C(this._languageId);else if((0,A.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const b=(0,y.getWordAtText)(w.character+1,(0,y.ensureValidWordDefinition)(E),this._lines[w.line],0);if(b)return new P.Range(w.line,b.startColumn-1,w.line,b.endColumn-1)}}e.ExtHostDocumentData=m;class f{constructor(d,E,w){this._line=d,this._text=E,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(me[198],ge([0,1,7,3,110,6,77,24,2,28]),function(G,e,_,k,A,I,y,P,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class T{constructor(m,f,a,d){this._notebook=a,this._selector=d,this._disposables=new I.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,i.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(w=>{const b=this._cellUris.get(w.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(m.onDidChangeNotebookCells(w=>E(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const m=[],f=[];for(const a of this._notebook.getCells())a.kind===_.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),m.push(a.document.getText().length+1),f.push(a.document.lineCount));this._cellLengths=new A.PrefixSumComputer(new Uint32Array(m)),this._cellLines=new A.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(m){var f,a;if(!m){let p="";for(const c of this._cells)p+=c.document.getText()+`
`;return p=p.slice(0,-1),p}if(m.isEmpty)return"";const d=this.locationAt(m.start),E=this.locationAt(m.end),w=this._cells[(f=this._cellUris.get(d.uri))!==null&&f!==void 0?f:-1],b=this._cells[(a=this._cellUris.get(E.uri))!==null&&a!==void 0?a:-1];if(!w||!b)return"";if(w===b)return w.document.getText(new _.Range(d.range.start,E.range.end));{const p=w.document.getText(new _.Range(d.range.start,new _.Position(w.document.lineCount,0))),c=b.document.getText(new _.Range(new _.Position(0,0),E.range.end));return p+`
`+c}}offsetAt(m){const f=this._cellLines.getIndexOf(m.line),a=this._cellLengths.getAccumulatedValue(f.index-1),d=this._cells[f.index].document.offsetAt(m.with(f.remainder));return a+d}positionAt(m){if(typeof m=="number"){const a=this._cellLengths.getIndexOf(m),d=this._cellLines.getAccumulatedValue(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(d)}const f=this._cellUris.get(m.uri);if(f!==void 0){const a=this._cellLines.getAccumulatedValue(f-1);return new _.Position(a+m.range.start.line,m.range.start.character)}return new _.Position(0,0)}locationAt(m){_.Range.isRange(m)||(m=new _.Range(m,m));const f=this._cellLines.getIndexOf(m.start.line);let a=f;m.isEmpty||(a=this._cellLines.getIndexOf(m.end.line));const d=new _.Position(f.remainder,m.start.character),E=new _.Position(a.remainder,m.end.character),w=new _.Range(d,E),b=this._cells[f.index];return new _.Location(b.document.uri,b.document.validateRange(w))}contains(m){return this._cellUris.has(m)}validateRange(m){const f=this.validatePosition(m.start),a=this.validatePosition(m.end);return m.with(f,a)}validatePosition(m){const f=this._cellLines.getIndexOf(m.line),a=new _.Position(f.remainder,m.character),d=this._cells[f.index].document.validatePosition(a),E=this._cellLines.getAccumulatedValue(f.index-1);return new _.Position(E+d.line,d.character)}}e.ExtHostNotebookConcatDocument=T}),define(me[199],ge([0,1,7,14,3]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let I=class{constructor(P){this._actual=new _.ColorTheme(_.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new A.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let D=P==="light"?_.ColorThemeKind.Light:P==="dark"?_.ColorThemeKind.Dark:_.ColorThemeKind.HighContrast;this._actual=new _.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};I=je([Be(0,k.IExtHostRpcService)],I),e.ExtHostTheming=I}),define(me[62],ge([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,_.createDecorator)("IURITransformerService");class k{constructor(I){I?(this.transformIncoming=I.transformIncoming.bind(I),this.transformOutgoing=I.transformOutgoing.bind(I),this.transformOutgoingURI=I.transformOutgoingURI.bind(I),this.transformOutgoingScheme=I.transformOutgoingScheme.bind(I)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=k}),define(me[200],ge([0,1,22]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class k{constructor(){this.buffers=[]}add(D){let i=this.buffers.indexOf(D);return i<0&&(i=this.buffers.length,this.buffers.push(D)),i}}function A(P,D){if(D){const i=new k,T=(f,a)=>{if(a instanceof ArrayBuffer){const d=i.add(a);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(a)){const d=I(a);if(d){const E=i.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:d,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},C=JSON.stringify(P,T),m=i.buffers.map(f=>{const a=new Uint8Array(f);return _.VSBuffer.wrap(a)});return{message:C,buffers:m}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=A;function I(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(P,D){const i=D.map(m=>{const f=new ArrayBuffer(m.byteLength);return new Uint8Array(f).set(m.buffer),f}),T=D.length?(m,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const a=f,{index:d}=a,E=i[d];if(a.view)switch(a.view.type){case 1:return new Int8Array(E,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return f}:void 0;return{message:JSON.parse(P,T),arrayBuffers:i}}e.deserializeWebviewMessage=y}),define(me[63],ge([0,1,2]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function k(I,y,P){const D=I.webviewResourceRoot.replace("{{resource}}",P.scheme+A(P)).replace("{{uuid}}",y);return _.URI.parse(D)}e.asWebviewUri=k;function A(I){return I.toString().replace(/^\S+?:/,"")}}),define(me[201],ge([0,1,3,6,63,28]),function(G,e,_,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(D,i,T){this._proxy=D,this._editors=i,this._initData=T,this._handlePool=0,this._disposables=new k.DisposableStore,this._insets=new Map,this._disposables.add(i.onDidChangeVisibleTextEditors(()=>{const C=i.getVisibleTextEditors();for(const m of this._insets.values())C.indexOf(m.editor)<0&&m.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,i,T,C,m){let f;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===D){f=c;break}if(!f)throw new Error("not a visible editor");const a=this,d=this._handlePool++,E=new _.Emitter,w=new _.Emitter,b=new class{constructor(){this._uuid=(0,I.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,A.asWebviewUri)(a._initData,this._uuid,c)}get cspSource(){return a._initData.webviewCspSource}set options(c){this._options=c,a._proxy.$setOptions(d,c)}get options(){return this._options}set html(c){this._html=c,a._proxy.$setHtml(d,c)}get html(){return this._html}get onDidReceiveMessage(){return E.event}postMessage(c){return a._proxy.$postMessage(d,c)}},p=new class{constructor(){this.editor=D,this.line=i,this.height=T,this.webview=b,this.onDidDispose=w.event}dispose(){a._insets.has(d)&&(a._insets.delete(d),a._proxy.$disposeEditorInset(d),w.fire(),w.dispose(),E.dispose())}};return this._proxy.$createEditorInset(d,f.id,f.value.document.uri,i+1,T,C||{},m.identifier,m.extensionLocation),this._insets.set(d,{editor:D,inset:p,onDidReceiveMessage:E}),p}$onDidDispose(D){const i=this._insets.get(D);i&&i.inset.dispose()}$onDidReceiveMessage(D,i){const T=this._insets.get(D);T&&T.onDidReceiveMessage.fire(i)}}e.ExtHostEditorInsets=y}),define(me[202],ge([0,1,3,81,169,4,6,24,40,15,53,23,43,194]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",m.Codicon.window,(0,A.localize)(0,null));var a;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var d;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel"})(d=e.ViewContainerLocation||(e.ViewContainerLocation={}));function E(o){switch(o){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=E;function w(o){return`viewContainer.${o}.enabled`}e.getEnabledViewContainerContextKey=w;class b extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new _.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new _.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,i.flatten)([...this.viewContainers.values()])}registerViewContainer(l,h,S){var u;const v=this.get(l.id);if(v)return v;const R=l;return R.openCommandActionDescriptor=(S==null?void 0:S.donotRegisterOpenCommand)?void 0:(u=R.openCommandActionDescriptor)!==null&&u!==void 0?u:{id:R.id},(0,P.getOrSet)(this.viewContainers,h,[]).push(R),(S==null?void 0:S.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:h}),R}deregisterViewContainer(l){for(const h of this.viewContainers.keys()){const S=this.viewContainers.get(h),u=S==null?void 0:S.indexOf(l);if(u!==-1){S==null||S.splice(u,1),S.length===0&&this.viewContainers.delete(h),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:h});return}}}get(l){return this.all.filter(h=>h.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(h=>this.getViewContainers(h).filter(S=>(S==null?void 0:S.id)===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(h=>this.getViewContainerLocation(h)===l)}}D.Registry.add(a.ViewContainersRegistry,new b);var p;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(p=e.ViewContentGroups||(e.ViewContentGroups={}));function c(o,l){var h,S,u,v;const R=(h=o.group)!==null&&h!==void 0?h:p.More,L=(S=l.group)!==null&&S!==void 0?S:p.More;return R!==L?R.localeCompare(L):((u=o.order)!==null&&u!==void 0?u:5)-((v=l.order)!==null&&v!==void 0?v:5)}class g extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new _.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new _.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new _.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new _.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new T.SetMap}registerViews(l,h){this.registerViews2([{views:l,viewContainer:h}])}registerViews2(l){l.forEach(({views:h,viewContainer:S})=>this.addViews(h,S)),this._onViewsRegistered.fire(l)}deregisterViews(l,h){const S=this.removeViews(l,h);S.length&&this._onViewsDeregistered.fire({views:S,viewContainer:h})}moveViews(l,h){for(const S of this._views.keys())if(S!==h){const u=this.removeViews(l,S);u.length&&(this.addViews(u,h),this._onDidChangeContainer.fire({views:u,from:S,to:h}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const h of this._viewContainers){const S=(this._views.get(h)||[]).filter(u=>u.id===l)[0];if(S)return S}return null}getViewContainer(l){for(const h of this._viewContainers)if((this._views.get(h)||[]).filter(u=>u.id===l)[0])return h;return null}registerViewWelcomeContent(l,h){return this._viewWelcomeContents.add(l,h),this._onDidChangeViewWelcomeContent.fire(l),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(l,h),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,h){const S=new Map;for(const[u,v]of h)this._viewWelcomeContents.add(l,v),S.set(u,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(l,v),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),S}getViewWelcomeContent(l){const h=[];return this._viewWelcomeContents.forEach(l,S=>h.push(S)),h.sort(c)}addViews(l,h){let S=this._views.get(h);S||(S=[],this._views.set(h,S),this._viewContainers.push(h));for(const u of l){if(this.getView(u.id)!==null)throw new Error((0,A.localize)(1,null,u.id));S.push(u)}}removeViews(l,h){const S=this._views.get(h);if(!S)return[];const u=[],v=[];for(const R of S)l.includes(R)?u.push(R):v.push(R);return u.length&&(v.length?this._views.set(h,v):(this._views.delete(h),this._viewContainers.splice(this._viewContainers.indexOf(h),1))),u}}D.Registry.add(a.ViewsRegistry,new g),e.IViewsService=(0,I.createDecorator)("viewsService"),e.FocusedViewContext=new k.RawContextKey("focusedView","",(0,A.localize)(2,null));function t(o){return`view.${o}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,I.createDecorator)("viewDescriptorService");var n;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(l,h){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,l),this._hasResolve=!!h,this.resolve=async S=>{var u,v;if(h&&!this.resolved){const R=await h(S);R&&(this.tooltip=(u=this.tooltip)!==null&&u!==void 0?u:R.tooltip,this.command=(v=this.command)!==null&&v!==void 0?v:R.command)}S.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r}),define(me[203],ge([0,1,2,181,117,13,182,202]),function(G,e,_,k,A,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(d){return(E,...w)=>d(E.get(k.ICommandService),...w)}class i{static execute(E,w){const b={forceReuseWindow:w&&w.reuseWindow,remoteAuthority:w&&w.remoteAuthority};return E.executeCommand("_files.newWindow",b)}}e.NewWindowAPICommand=i,i.ID="vscode.newWindow",k.CommandsRegistry.registerCommand({id:i.ID,handler:D(i.execute),description:{description:"Opens an new window",args:[]}}),k.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(d,E){return d.get(A.IWorkspacesService).removeRecentlyOpened([E])});class T{static execute(E,w){return typeof w=="string"?w=w.match(/^[^:/?#]+:\/\//)?_.URI.parse(w):_.URI.file(w):w=_.URI.revive(w),E.executeCommand("_workbench.removeFromRecentlyOpened",w)}}e.RemoveFromRecentlyOpenedAPICommand=T,T.ID="vscode.removeFromRecentlyOpened",k.CommandsRegistry.registerCommand(T.ID,D(T.execute));class C{static execute(E,w){const b=typeof w=="string"?{extensionId:w}:w;return E.executeCommand("workbench.action.openIssueReporter",b)}}e.OpenIssueReporter=C,C.ID="vscode.openIssueReporter",k.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(d,E){const w=d.get(A.IWorkspacesService);let b;const p=E.uri,c=E.label,g=E.remoteAuthority;return E.type==="workspace"?b={workspace:await w.getWorkspaceIdentifier(p),label:c,remoteAuthority:g}:E.type==="folder"?b={folderUri:p,label:c,remoteAuthority:g}:b={fileUri:p,label:c,remoteAuthority:g},w.addRecentlyOpened([b])}),k.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(d){return d.get(A.IWorkspacesService).getRecentlyOpened()}),k.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(d,E){const w=d.get(I.ILogService),b=d.get(y.IEnvironmentService);b.isExtensionDevelopment&&!!b.extensionTestsLocationURI&&w.setLevel(E)}),k.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(d){return d.get(I.ILogService).getLevel()}),k.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(d,E){const w=d.get(P.IViewDescriptorService),b=w.getViewContainerById(E.destinationId);if(!!b){for(const p of E.viewIds){const c=w.getViewDescriptorById(p);(c==null?void 0:c.canMoveView)&&w.moveViewsToContainer([c],b,P.ViewVisibilityState.Default)}await d.get(P.IViewsService).openViewContainer(b.id,!0)}});class m{static execute(E,w){return!Array.isArray(w==null?void 0:w.viewIds)||typeof(w==null?void 0:w.destinationId)!="string"?Promise.reject("Invalid arguments"):E.executeCommand("_workbench.action.moveViews",w)}}e.MoveViewsAPICommand=m,m.ID="vscode.moveViews",k.CommandsRegistry.registerCommand({id:m.ID,handler:D(m.execute),description:{description:"Move Views",args:[]}});class f{static execute(E,w){return E.executeCommand("_workbench.open",w)}}f.ID="vscode.open",k.CommandsRegistry.registerCommand(f.ID,D(f.execute));class a{static execute(E,w,b,p,c){return E.executeCommand("_workbench.diff",[w,b,p])}}a.ID="vscode.diff",k.CommandsRegistry.registerCommand(a.ID,D(a.execute))}),define(me[120],ge([0,1,3,19,170]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class I{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new _.Emitter,this._onExit=new _.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,D,i,T){const C={command:P};if(D&&Object.keys(D).length>0&&(C.arguments=D),this.internalSend("request",C),typeof T=="number"){const m=setTimeout(()=>{clearTimeout(m);const f=this.pendingRequests.get(C.seq);if(f){this.pendingRequests.delete(C.seq);const a={type:"response",seq:0,request_seq:C.seq,success:!1,command:P,message:(0,A.localize)(0,null,T,P)};f(a)}},T)}return i&&this.pendingRequests.set(C.seq,i),C.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,D){return P.type!=="event"||D.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,k.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":const D=P,i=this.pendingRequests.get(D.request_seq);i&&(this.pendingRequests.delete(D.request_seq),i(D));break}}}internalSend(P,D){D.type=P,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((D,i)=>P.set(i,D)),await(0,k.timeout)(500),P.forEach((D,i)=>{D({type:"response",seq:0,request_seq:i,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(i)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=I}),define(me[204],ge([0,1,10,2,8,23,11]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function D(n,s,r){return n.replace(P,function(o,l){return s&&l.length>0&&l[0]!=="_"?o:r&&r.hasOwnProperty(l)?r[l]:o})}e.formatPII=D;function i(n){const s={};for(const r of Object.keys(n))r.startsWith("!")||(s[r]=n[r]);return s}e.filterExceptionsFromTelemetry=i;function T(n){return n.configuration.request==="attach"&&!C(n)}e.isSessionAttach=T;function C(n){let s=n.configuration.type;if(!!s)return s==="vslsShare"&&(s=n.configuration.adapterProxy.configuration.type),(0,_.equalsIgnoreCase)(s,"extensionhost")||(0,_.equalsIgnoreCase)(s,"pwa-extensionhost")?n:n.parentSession?C(n.parentSession):void 0}e.getExtensionHostDebugSession=C;function m(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=m;function f(n,s,r){let o,l=0,h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,S=null;for(;S=h.exec(n);){let u=S.index+1,v=u+S[0].length;if(u<=s&&v>=r){o=S[0],l=u;break}}if(o){let u=/\w+/g,v=null;for(;(v=u.exec(o))&&!(v.index+1+l+v[0].length>=r););v&&(o=o.substring(0,u.lastIndex))}return o?{start:l,end:l+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(n){return!!(n&&n.match(a))}e.isUri=d;function E(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(d(n.path))return k.URI.parse(n.path);if((0,A.isAbsolute)(n.path))return k.URI.file(n.path)}return n.path}function w(n){if(typeof n.path=="object"){const s=k.URI.revive(n.path);if(s)return s.scheme===y.Schemas.file?s.fsPath:s.toString()}return n.path}function b(n,s){const r=s?E:w,o=(0,I.deepClone)(n);return c(o,(l,h)=>{l&&h&&(h.path=r(h))}),o}e.convertToDAPaths=b;function p(n,s){const r=s?E:w,o=(0,I.deepClone)(n);return c(o,(l,h)=>{!l&&h&&(h.path=r(h))}),o}e.convertToVSCPaths=p;function c(n,s){switch(n.type){case"event":const r=n;switch(r.event){case"output":s(!1,r.body.source);break;case"loadedSource":s(!1,r.body.source);break;case"breakpoint":s(!1,r.body.breakpoint.source);break;default:break}break;case"request":const o=n;switch(o.command){case"setBreakpoints":s(!0,o.arguments.source);break;case"breakpointLocations":s(!0,o.arguments.source);break;case"source":s(!0,o.arguments.source);break;case"gotoTargets":s(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(h=>s(!1,h));break;default:break}break;case"response":const l=n;if(l.success&&l.body)switch(l.command){case"stackTrace":l.body.stackFrames.forEach(h=>s(!1,h.source));break;case"loadedSources":l.body.sources.forEach(h=>s(!1,h));break;case"scopes":l.body.scopes.forEach(h=>s(!1,h.source));break;case"setFunctionBreakpoints":l.body.breakpoints.forEach(h=>s(!1,h.source));break;case"setBreakpoints":l.body.breakpoints.forEach(h=>s(!1,h.source));break;default:break}break}}function g(n){return n.filter(s=>{var r;return!((r=s.presentation)===null||r===void 0?void 0:r.hidden)}).sort((s,r)=>s.presentation?r.presentation?s.presentation.group?r.presentation.group?s.presentation.group!==r.presentation.group?s.presentation.group.localeCompare(r.presentation.group):t(s.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(s.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=g;function t(n,s){return typeof n!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:n-s}}),define(me[205],ge([0,1,26,38,171,121,8,10,23,9,183,120]),function(G,e,_,k,A,I,y,P,D,i,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class m extends C.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,p){this.outputStream=p,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",c=>this.handleData(c))}sendMessage(b){if(this.outputStream){const p=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(p,"utf8")}${m.TWO_CRLF}${p}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const p=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,p.length>0)try{this.acceptMessage(JSON.parse(p))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+p))}continue}}else{const p=this.rawData.indexOf(m.TWO_CRLF);if(p!==-1){const g=this.rawData.toString("utf8",0,p).split(m.HEADER_LINESEPARATOR);for(const t of g){const n=t.split(m.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(p+m.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=m,m.TWO_CRLF=`\r
\r
`,m.HEADER_LINESEPARATOR=/\r?\n/,m.HEADER_FIELDSEPARATOR=/: */;class f extends m{startSession(){return new Promise((b,p)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):p(new Error("connection closed"))}),this.socket.on("error",g=>{c?this._onError.fire(g):p(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=f;class a extends f{constructor(b){super();this.adapterServer=b}createConnection(b){return I.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=a;class d extends f{constructor(b){super();this.adapterServer=b}createConnection(b){return I.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=d;class E extends m{constructor(b,p,c){super();this.adapterExecutable=b,this.debugType=p,this.outputService=c}async startSession(){const b=this.adapterExecutable.command,p=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(b)if(y.isAbsolute(b)){if(!await(0,_.exists)(b))throw new Error(A.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(A.localize(1,null,this.debugType));let g=process.env;if(c.env&&Object.keys(c.env).length>0&&(g=D.mixin(D.deepClone(process.env),c.env)),b==="node")if(Array.isArray(p)&&p.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:g,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(s.cwd=c.cwd);const r=k.fork(p[0],p.slice(1),s);if(!r.pid)throw new Error(A.localize(2,null,p[0]));this.serverProcess=r}else throw new Error(A.localize(3,null));else{const n={env:g};c.cwd&&(n.cwd=c.cwd),this.serverProcess=k.spawn(b,p,n)}this.serverProcess.on("error",n=>{this._onError.fire(n)}),this.serverProcess.on("exit",(n,s)=>{this._onExit.fire(n)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",n=>{this._onError.fire(n)}),this.serverProcess.stdin.on("error",n=>{this._onError.fire(n)});const t=this.outputService;if(t){const n=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const r=t.getChannel(T.ExtensionsChannelId);r&&r.append(n(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),i.isWindows?new Promise((b,p)=>{const c=k.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,t,n){if(g)return p(g)});c.on("exit",b),c.on("error",p)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,p){if(!!b){const c=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?c.runtime=y.join(p,b.runtime):c.runtime=b.runtime),b.runtimeArgs&&(c.runtimeArgs=b.runtimeArgs),b.program&&(y.isAbsolute(b.program)?c.program=b.program:c.program=y.join(p,b.program)),b.args&&(c.args=b.args);const g=b;return g.win&&(c.win=E.extract(g.win,p)),g.winx86&&(c.winx86=E.extract(g.winx86,p)),g.windows&&(c.windows=E.extract(g.windows,p)),g.osx&&(c.osx=E.extract(g.osx,p)),g.linux&&(c.linux=E.extract(g.linux,p)),c}}static platformAdapterExecutable(b,p){let c=Object.create(null);p=p.toLowerCase();for(const o of b)if(o.contributes){const l=o.contributes.debuggers;l&&l.length>0&&l.filter(h=>typeof h.type=="string"&&P.equalsIgnoreCase(h.type,p)).forEach(h=>{const S=E.extract(h,o.extensionLocation.fsPath);c=D.mixin(c,S,o.isBuiltin)})}let g;i.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=c.winx86||c.win||c.windows:i.isWindows?g=c.win||c.windows:i.isMacintosh?g=c.osx:i.isLinux&&(g=c.linux),g=g||c;let t=g.program||c.program;const n=g.args||c.args;let s=g.runtime||c.runtime;const r=g.runtimeArgs||c.runtimeArgs;if(s)return{type:"executable",command:s,args:(r||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=E}),define(me[206],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=void 0,e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(me[207],ge([0,1,38,8,78,172,26,9,84,4,206,11]),function(G,e,_,k,A,I,y,P,D,i,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const m=I.localize(0,null);let f=class Bt{constructor(p){this._configurationService=p}openTerminal(p){if(this._configurationService){const c=this._configurationService.getValue();this.spawnTerminal(_,c,A.getWindowsShell(),p)}}runInTerminal(p,c,g,t,n){const s=n.windowsExec||Bt.getDefaultTerminalWindows();return new Promise((r,o)=>{const l=`"${c} - ${m}"`,h=`""${g.join('" "')}" & pause"`,S=["/c","start",l,"/wait",s,"/c",h],u=Object.assign({},process.env,t);Object.keys(u).filter(L=>u[L]===null).forEach(L=>delete u[L]);const v={cwd:c,env:u,windowsVerbatimArguments:!0};_.spawn(Bt.CMD,S,v).on("error",L=>{o(E(L))}),r(void 0)})}spawnTerminal(p,c,g,t){const s=c.terminal.external.windowsExec||Bt.getDefaultTerminalWindows();t&&t[1]===":"&&(t=t[0].toUpperCase()+t.substr(1));const r=k.basename(s).toLowerCase();if(r==="cmder"||r==="cmder.exe")return p.spawn(s,t?[t]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return s.indexOf(" ")>=0&&o.push('""'),o.push(s),(r==="wt"||r==="wt.exe")&&o.push("-d ."),new Promise((l,h)=>{const S=t?{cwd:t}:void 0,u=p.spawn(g,o,S);u.on("error",h),u.on("exit",()=>l())})}static getDefaultTerminalWindows(){if(!Bt._DEFAULT_TERMINAL_WINDOWS){const p=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Bt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${p?"Sysnative":"System32"}\\cmd.exe`}return Bt._DEFAULT_TERMINAL_WINDOWS}};f.CMD="cmd.exe",f=je([Be(0,(0,i.optional)(D.IConfigurationService))],f),e.WindowsExternalTerminalService=f;let a=class Fn{constructor(p){this._configurationService=p}openTerminal(p){if(this._configurationService){const c=this._configurationService.getValue();this.spawnTerminal(_,c,p)}}runInTerminal(p,c,g,t,n){const s=n.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((r,o)=>{if(s===T.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const l=s===T.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",S=[C.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,G).fsPath,"-t",p||m,"-w",c];for(let R of g)S.push("-a"),S.push(R);if(t)for(let R in t){const L=t[R];L===null?(S.push("-u"),S.push(R)):(S.push("-e"),S.push(`${R}=${L}`))}let u="";const v=_.spawn(Fn.OSASCRIPT,S);v.on("error",R=>{o(E(R))}),v.stderr.on("data",R=>{u+=R.toString()}),v.on("exit",R=>{if(R===0)r(void 0);else if(u){const L=u.split(`
`,1);o(new Error(L[0]))}else o(new Error(I.localize(1,null,l,R)))})}else o(new Error(I.localize(2,null,s)))})}spawnTerminal(p,c,g){const n=c.terminal.external.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((s,r)=>{const o=["-a",n];g&&o.push(g);const l=p.spawn("/usr/bin/open",o);l.on("error",r),l.on("exit",()=>s())})}};a.OSASCRIPT="/usr/bin/osascript",a=je([Be(0,(0,i.optional)(D.IConfigurationService))],a),e.MacExternalTerminalService=a;let d=class Wt{constructor(p){this._configurationService=p}openTerminal(p){if(this._configurationService){const c=this._configurationService.getValue();this.spawnTerminal(_,c,p)}}runInTerminal(p,c,g,t,n){const s=n.linuxExec?Promise.resolve(n.linuxExec):Wt.getDefaultTerminalLinuxReady();return new Promise((r,o)=>{let l=[];s.then(h=>{h.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const S=`${w(g)}; echo; read -p "${Wt.WAIT_MESSAGE}" -n1;`;l.push(`''${S}''`);const u=Object.assign({},process.env,t);Object.keys(u).filter(H=>u[H]===null).forEach(H=>delete u[H]);const v={cwd:c,env:u};let R="";const L=_.spawn(h,l,v);L.on("error",H=>{o(E(H))}),L.stderr.on("data",H=>{R+=H.toString()}),L.on("exit",H=>{if(H===0)r(void 0);else if(R){const ie=R.split(`
`,1);o(new Error(ie[0]))}else o(new Error(I.localize(4,null,h,H)))})})})}spawnTerminal(p,c,g){const t=c.terminal.external,n=t.linuxExec?Promise.resolve(t.linuxExec):Wt.getDefaultTerminalLinuxReady();return new Promise((s,r)=>{n.then(o=>{const l=g?{cwd:g}:void 0,h=p.spawn(o,[],l);h.on("error",r),h.on("exit",()=>s())})})}static async getDefaultTerminalLinuxReady(){return Wt._DEFAULT_TERMINAL_LINUX_READY||(Wt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async p=>{P.isLinux?await y.exists("/etc/debian_version")?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm"):p("xterm")})),Wt._DEFAULT_TERMINAL_LINUX_READY}};d.WAIT_MESSAGE=I.localize(3,null),d=je([Be(0,(0,i.optional)(D.IConfigurationService))],d),e.LinuxExternalTerminalService=d;function E(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(I.localize(5,null,b.path)):b}function w(b){let p="";for(let c of b)c.indexOf(" ")>=0?p+='"'+c+'"':p+=c,p+=" ";return p}}),define(me[208],ge([0,1,38,9,207,30]),function(G,e,_,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;let y;function P(m,f){if(!y)if(k.isWindows)y=new A.WindowsExternalTerminalService(void 0);else if(k.isMacintosh)y=new A.MacExternalTerminalService(void 0);else if(k.isLinux)y=new A.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const a=f.getConfiguration("terminal");return y.runInTerminal(m.title,m.cwd,m.args,m.env||{},a.external||{})}e.runInExternalTerminal=P;function D(m,f){return new Promise((a,d)=>{let E="";const w=_.spawn(m,f);w.pid&&w.stdout.on("data",b=>{E+=b.toString()}),w.on("error",b=>{d(b)}),w.on("close",b=>{a(E)})})}function i(m){return m?k.isWindows?D("wmic",["process","get","ParentProcessId"]).then(f=>f.split(`\r
`).some(d=>parseInt(d)===m),f=>!0):D("/usr/bin/pgrep",["-lP",String(m)]).then(f=>{const a=f.trim();return!(a.length===0||a.indexOf(" tmux")>=0)},f=>!0):Promise.resolve(!0)}e.hasChildProcesses=i;var T;(function(m){m[m.cmd=0]="cmd",m[m.powershell=1]="powershell",m[m.bash=2]="bash"})(T||(T={}));function C(m,f,a,d){m=m.trim().toLowerCase();let E;m.indexOf("powershell")>=0||m.indexOf("pwsh")>=0?E=1:m.indexOf("cmd.exe")>=0?E=0:m.indexOf("bash")>=0?E=2:k.isWindows?E=0:E=2;let w,b=" ";switch(E){case 1:if(w=c=>(c=c.replace(/\'/g,"''"),c.length>0&&c.charAt(c.length-1)==="\\"?`'${c}\\'`:`'${c}'`),a){const c=(0,I.getDriveLetter)(a);c&&(b+=`${c}:; `),b+=`cd ${w(a)}; `}if(d)for(let c in d){const g=d[c];g===null?b+=`Remove-Item env:${c}; `:b+=`\${env:${c}}='${g}'; `}if(f.length>0){const c=w(f.shift());b+=c[0]==="'"?`& ${c} `:`${c} `;for(let g of f)b+=`${w(g)} `}break;case 0:if(w=c=>(c=c.replace(/\"/g,'""'),c.indexOf(" ")>=0||c.indexOf('"')>=0||c.length===0?`"${c}"`:c),a){const c=(0,I.getDriveLetter)(a);c&&(b+=`${c}: && `),b+=`cd ${w(a)} && `}if(d){b+='cmd /C "';for(let c in d){let g=d[c];g===null?b+=`set "${c}=" && `:(g=g.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),b+=`set "${c}=${g}" && `)}}for(let c of f)b+=`${w(c)} `;d&&(b+='"');break;case 2:w=c=>(c=c.replace(/(["'\\\$])/g,"\\$1"),c.indexOf(" ")>=0||c.indexOf(";")>=0||c.length===0?`"${c}"`:c);const p=c=>/[^\w@%\/+=,.:^-]/.test(c)?`'${c.replace(/'/g,"'\\''")}'`:c;if(a&&(b+=`cd ${w(a)} ; `),d){b+="/usr/bin/env";for(let c in d){const g=d[c];g===null?b+=` -u ${p(c)}`:b+=` ${p(`${c}=${g}`)}`}b+=" "}for(let c of f)b+=`${w(c)} `;break}return b}e.prepareCommand=C}),define(me[88],ge([0,1,33,11,8,9,81]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var P;(function(L){L[L.Markdown=1]="Markdown",L[L.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(L){L[L.Running=1]="Running",L[L.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{},trusted:!0};var i;(function(L){L[L.Idle=1]="Idle",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var T;(function(L){L[L.WithHardKernelDependency=0]="WithHardKernelDependency",L[L.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",L[L.Pure=2]="Pure",L[L.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(L){L[L.ModelChange=1]="ModelChange",L[L.Move=2]="Move",L[L.CellClearOutput=3]="CellClearOutput",L[L.CellsClearOutput=4]="CellsClearOutput",L[L.ChangeLanguage=5]="ChangeLanguage",L[L.Initialize=6]="Initialize",L[L.ChangeCellMetadata=7]="ChangeCellMetadata",L[L.Output=8]="Output",L[L.OutputItem=9]="OutputItem",L[L.ChangeCellContent=10]="ChangeCellContent",L[L.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",L[L.Unknown=12]="Unknown"})(C=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var m;(function(L){L[L.Handle=0]="Handle",L[L.Index=1]="Index"})(m=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(L){L[L.Replace=1]="Replace",L[L.Output=2]="Output",L[L.Metadata=3]="Metadata",L[L.CellLanguage=4]="CellLanguage",L[L.DocumentMetadata=5]="DocumentMetadata",L[L.OutputsSplice=6]="OutputsSplice",L[L.Move=7]="Move",L[L.Unknown=8]="Unknown",L[L.CellContent=9]="CellContent",L[L.OutputItems=10]="OutputItems",L[L.PartialMetadata=11]="PartialMetadata"})(f=e.CellEditType||(e.CellEditType={}));function a(L){const H=d.parse(L);return H?H.notebook.toString():L.toString()}e.getCellUndoRedoComparisonKey=a;var d;(function(L){L.scheme=k.Schemas.vscodeNotebookCell;const H=/^ch(\d{7,})/;function ie(N,M){return N.with({scheme:L.scheme,fragment:`ch${M.toString().padStart(7,"0")}${N.scheme!==k.Schemas.file?N.scheme:""}`})}L.generate=ie;function j(N){if(N.scheme===L.scheme){const M=H.exec(N.fragment);if(!!M)return{handle:Number(M[1]),notebook:N.with({scheme:N.fragment.substr(M[0].length)||k.Schemas.file,fragment:null})}}}L.parse=j;function B(N,M){return N.with({scheme:k.Schemas.vscodeNotebookCellMetadata,fragment:`ch${M.toString().padStart(7,"0")}${N.scheme!==k.Schemas.file?N.scheme:""}`})}L.generateCellMetadataUri=B;function $(N){if(N.scheme===k.Schemas.vscodeNotebookCellMetadata){const M=H.exec(N.fragment);if(!!M)return{handle:Number(M[1]),notebook:N.with({scheme:N.fragment.substr(M[0].length)||k.Schemas.file,fragment:null})}}}L.parseCellMetadataUri=$})(d=e.CellUri||(e.CellUri={}));const E=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(L){var H,ie;return(ie=(H=E.get(L))===null||H===void 0?void 0:H.alwaysSecure)!==null&&ie!==void 0?ie:!1}e.mimeTypeIsAlwaysSecure=w;function b(L){var H,ie;return(ie=(H=E.get(L))===null||H===void 0?void 0:H.supportedByCore)!==null&&ie!==void 0?ie:!1}e.mimeTypeSupportedByCore=b;function p(L){var H,ie;return(ie=(H=E.get(L))===null||H===void 0?void 0:H.mergeable)!==null&&ie!==void 0?ie:!1}e.mimeTypeIsMergeable=p;function c(L,H){return I.isWindows&&(L=L.replace(/\//g,"\\"),H=H.replace(/\//g,"\\")),_.match(L,H)}function g(L,H,ie){let j=0;for(let B=0;B<H.length;B++){if(c(H[B],L))return j;j++}for(let B=0;B<ie.length;B++){if(c(ie[B],L))return j;j++}return j}function t(L,H,ie){return L.sort((j,B)=>g(j,H,ie)-g(B,H,ie))}e.sortMimeTypes=t;function n(L,H,ie,j=(B,$)=>B===$){const B=[];function $(F,U,O){if(!(U===0&&O.length===0)){const W=B[B.length-1];W&&W.start+W.deleteCount===F?(W.deleteCount+=U,W.toInsert.push(...O)):B.push({start:F,deleteCount:U,toInsert:O})}}let N=0,M=0;for(;;){if(N===L.length){$(N,0,H.slice(M));break}if(M===H.length){$(N,L.length-N,[]);break}const F=L[N],U=H[M];if(j(F,U)){N+=1,M+=1;continue}ie(U)?($(N,1,[]),N+=1):($(N,0,[U]),M+=1)}return B}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(L){L.default="default",L.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(L){const H=L;return!!((typeof H.include=="string"||_.isRelativePattern(H.include))&&(typeof H.exclude=="string"||_.isRelativePattern(H.exclude)))}e.isDocumentExcludePattern=r;function o(L,H,ie){if(Array.isArray(L.viewType)&&L.viewType.indexOf(H)>=0||L.viewType===H)return!0;if(L.filenamePattern){let j=r(L.filenamePattern)?L.filenamePattern.include:L.filenamePattern,B=r(L.filenamePattern)?L.filenamePattern.exclude:void 0;if(_.match(j,(0,A.basename)(ie.fsPath).toLowerCase()))return!(B&&_.match(B,(0,A.basename)(ie.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class l{constructor(H){this.textModel=H}getElements(){const H=new Int32Array(this.textModel.cells.length);for(let ie=0;ie<this.textModel.cells.length;ie++)H[ie]=this.textModel.cells[ie].getHashValue();return H}}e.CellSequence=l,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var h;(function(L){L[L.Left=1]="Left",L[L.Right=2]="Right"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function S(L){L.sort((ie,j)=>ie-j);const H=L.shift();return H===void 0?[]:L.reduce(function(ie,j){return j<=ie[0][1]?ie[0][1]=j+1:ie.unshift([j,j+1]),ie},[[H,H+1]]).reverse().map(ie=>({start:ie[0],end:ie[1]}))}e.cellIndexesToRanges=S;function u(L){return L.reduce((ie,j)=>{for(let B=j.start;B<j.end;B++)ie.push(B);return ie},[])}e.cellRangesToIndexes=u;function v(L){const H=L.sort((j,B)=>j.start-B.start),ie=H[0];return ie?H.reduce((j,B)=>{const $=j[j.length-1];return $.end>=B.start?$.end=Math.max($.end,B.end):j.push(B),j},[ie]):[]}e.reduceRanges=v;function R(L,H){return H.start>=L.start&&H.end<=L.end}e.cellRangeContains=R}),define(me[209],ge([0,1,174,4,81]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new A.RawContextKey("customExecutionSupported",!0,_.localize(0,null)),e.ShellExecutionSupportedContext=new A.RawContextKey("shellExecutionSupported",!1,_.localize(1,null)),e.ProcessExecutionSupportedContext=new A.RawContextKey("processExecutionSupported",!1,_.localize(2,null)),e.ITaskService=(0,k.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[210],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function _(A){return[...A.entries()]}e.serializeEnvironmentVariableCollection=_;function k(A){return new Map(A)}e.deserializeEnvironmentVariableCollection=k}),define(me[211],ge([0,1,8,135,9]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function I(g,t){if(!!t)if(A.isWindows)for(const n in t){let s=n;for(const o in g)if(n.toLowerCase()===o.toLowerCase()){s=o;break}const r=t[n];r!==void 0&&y(g,s,r)}else Object.keys(t).forEach(n=>{const s=t[n];s!==void 0&&y(g,n,s)})}e.mergeEnvironments=I;function y(g,t,n){typeof n=="string"?g[t]=n:delete g[t]}function P(g,t,n,s){g.TERM_PROGRAM="vscode",t&&(g.TERM_PROGRAM_VERSION=t),T(g,s)&&(g.LANG=C(n)),g.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=P;function D(g,t){if(!!t)for(const n of Object.keys(t)){const s=t[n];s&&(g[n]=s)}}function i(g,t){return Object.keys(t).forEach(n=>{const s=t[n];if(typeof s=="string")try{t[n]=g(s)}catch(r){t[n]=s}}),t}function T(g,t){if(t==="on")return!0;if(t==="auto"){const n=g.LANG;return!n||n.search(/\.UTF\-8$/)===-1&&n.search(/\.utf8$/)===-1&&n.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=T;function C(g){const t=g?g.split("-"):[],n=t.length;if(n===0)return"en_US.UTF-8";if(n===1){const s={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in s&&t.push(s[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=C;function m(g,t,n,s,r,o){if(g.cwd){const h=typeof g.cwd=="object"?g.cwd.fsPath:g.cwd,S=f(h,n);return a(S||h)}let l;return!g.ignoreConfigurationCwd&&r&&(n&&(r=f(r,n,o)),r&&(_.isAbsolute(r)?l=r:s&&(l=_.join(s.fsPath,r)))),l||(l=s?s.fsPath:t||""),a(l)}e.getCwd=m;function f(g,t,n){if(t)try{return t(g)}catch(s){n==null||n.error("Could not resolve terminal cwd",s);return}return g}function a(g){return A.OS===1&&g&&g[1]===":"?g[0].toUpperCase()+g.substr(1):g}function d(g){let t=g;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\"));const n=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(n,""),`'${t}'`}e.escapeNonWindowsPath=d;function E(g,t){if(!!t)return n=>t.resolve(g,n)}e.createVariableResolver=E;function w(g,t,n,s,r,o,l,h=A.platform){let S;l&&(S=p(g,"automationShell",h)),S||(S=p(g,"shell",h));let u=S||t;if(h===3&&!n&&s){const v=_.join(s,"Sysnative").replace(/\//g,"\\").toLowerCase();u&&u.toLowerCase().indexOf(v)===0&&(u=_.join(s,"System32",u.substr(v.length+1)))}if(u&&h===3&&(u=u.replace(/\//g,"\\")),r)try{u=r(u)}catch(v){o.error("Could not resolve shell",v)}return u}e.getDefaultShell=w;function b(g,t,n,s,r=A.platform){if(t&&p(g,"automationShell",r))return[];const o=r===3?"windows":r===1?"osx":"linux";let l=g(`terminal.integrated.shellArgs.${o}`);if(!l)return[];if(typeof l=="string"&&r===3)return n?n(l):l;if(n){const h=[];for(const S of l)try{h.push(n(S))}catch(u){s.error(`Could not resolve terminal.integrated.shellArgs.${o}`,u),h.push(S)}l=h}return l}e.getDefaultShellArgs=b;function p(g,t,n=A.platform){return g(`terminal.integrated.${t}.${n===3?"windows":n===1?"osx":"linux"}`)}function c(g,t,n,s,r,o){let l={};if(g.strictEnv)D(l,g.env);else{D(l,o);const h=Object.assign({},t);n&&(h&&i(n,h),g.env&&i(n,g.env)),(0,k.sanitizeProcessEnvironment)(l,"VSCODE_IPC_HOOK_CLI"),I(l,h),I(l,g.env),P(l,s,A.locale,r)}return l}e.createTerminalEnvironment=c});var hn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],_;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),_={},k("next"),k("throw"),k("return"),_[Symbol.asyncIterator]=function(){return this},_);function k(I){_[I]=G[I]&&function(y){return new Promise(function(P,D){y=G[I](y),A(P,D,y.done,y.value)})}}function A(I,y,P,D){Promise.resolve(D).then(function(i){I({value:i,done:P})},y)}};define(me[212],ge([0,1,37,8,103,191,38,26,43,9]),function(G,e,_,k,A,I,y,P,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let T;function C(c,g,t,n,s,r,o){return g=g||{existsFile:P.SymlinkSupport.existsFile,readFile:_.promises.readFile},i.isWindows?m(c,g,t,n==null?void 0:n.useWslProfiles,n==null?void 0:n.profiles.windows,s,r):w(g,t,c,i.isMacintosh?n==null?void 0:n.profiles.osx:n==null?void 0:n.profiles.linux,o,s,r)}e.detectAvailableProfiles=C;async function m(c,g,t,n,s,r,o){const l=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),h=`${process.env.windir}\\${l?"Sysnative":"System32"}`;let S=!1;(0,I.getWindowsBuildNumber)()>=16299&&(S=!0),await a();const u=new Map;c||(u.set("PowerShell",{source:"PowerShell",icon:D.Codicon.terminalPowershell.id,isAutoDetected:!0}),u.set("Windows PowerShell",{path:`${h}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.Codicon.terminalPowershell.id,isAutoDetected:!0}),u.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),u.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),u.set("Command Prompt",{path:`${h}\\cmd.exe`,icon:D.Codicon.terminalCmd.id,isAutoDetected:!0})),b(s,u);const v=await f(u.entries(),g,t,r,o);if(!c||c&&n)try{const R=await E(`${h}\\${S?"wsl.exe":"bash.exe"}`,n);R&&v.push(...R)}catch(R){t==null||t.info("WSL is not installed, so could not detect WSL profiles")}return v}async function f(c,g,t,n,s){const r=[];for(const[o,l]of c)if(l!==null){let h,S,u;if("source"in l){const L=T==null?void 0:T.get(l.source);if(!L)continue;h=L.paths,S=l.args||L.args,u=l.icon||L.icon}else h=Array.isArray(l.path)?l.path:[l.path],S=i.isWindows||Array.isArray(l.args)?l.args:void 0,u=l.icon;const v=h.slice();for(let L=0;L<v.length;L++)v[L]=await(n==null?void 0:n.resolveAsync(s,v[L]))||v[L];const R=await p(o,v,g,S,l.env,l.overrideName,l.isAutoDetected,t);R?(R.isAutoDetected=l.isAutoDetected,R.icon=u,r.push(R)):t==null||t.trace("profile not validated",o,h)}return r}async function a(){T||(T=new Map,T.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`],args:["--login"]}),T.set("PowerShell",{profileName:"PowerShell",paths:await d(),icon:"terminal-powershell"}))}async function d(){var c,g;const t=[];try{for(var n=hn((0,A.enumeratePowerShellInstallations)()),s;s=await n.next(),!s.done;){const r=s.value;t.push(r.exePath)}}catch(r){c={error:r}}finally{try{s&&!s.done&&(g=n.return)&&await g.call(n)}finally{if(c)throw c.error}}return t}async function E(c,g){const t=[];if(g){const n=await new Promise((s,r)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le"},(o,l)=>{if(o)return r("Problem occurred when getting wsl distros");s(l)})});if(n){const s=new RegExp(/[\r?\n]/),r=n.split(s).filter(o=>o.trim().length>0&&o!=="");for(let o of r)if(o!==""&&!o.startsWith("docker-desktop")){const l={profileName:`${o} (WSL)`,path:c,args:["-d",`${o}`]};o.includes("Debian")?l.icon="terminal-debian":l.icon="terminal-linux",t.push(l)}return t}}return[]}async function w(c,g,t,n,s,r,o){const l=new Map;if(!t){const h=await c.readFile("/etc/shells","utf8"),S=s||h.split(`
`).filter(v=>v.trim().indexOf("#")!==0&&v.trim().length>0),u=new Map;for(const v of S){let R=(0,k.basename)(v),L=u.get(R)||0;L++,L>1&&(R=`${R} (${L})`),u.set(R,L),l.set(R,{path:v,isAutoDetected:!0})}}return b(n,l),await f(l.entries(),c,g,r,o)}function b(c,g){if(!!c)for(const[t,n]of Object.entries(c))n===null||!("path"in n)&&!("source"in n)?g.delete(t):g.set(t,n)}async function p(c,g,t,n,s,r,o,l){if(g.length===0)return Promise.resolve(void 0);const h=g.shift();if(h==="")return p(c,g,t,n,s,r,o);const S={profileName:c,path:h,args:n,env:s,overrideName:r,isAutoDetected:o};if((0,k.basename)(h)===h){const v=process.env.PATH?process.env.PATH.split(k.delimiter):void 0;return await(0,I.findExecutable)(h,void 0,v,void 0,t.existsFile)?S:p(c,g,t,n)}return await t.existsFile((0,k.normalize)(h))?S:p(c,g,t,n,s,r,o)}}),define(me[122],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var _;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(_=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(D,i)=>{i.expand!==void 0&&(D.expand=i.expand),i.item!==void 0&&Object.assign(D.item,i.item)};e.applyTestItemUpdate=k;var A;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.DeltaRootsComplete=3]="DeltaRootsComplete",D[D.Retire=4]="Retire"})(A=e.TestDiffOpType||(e.TestDiffOpType={}));const I=(D,i)=>`${D}:${i.toString()}`;e.getTestSubscriptionKey=I;class y{add(i){}update(i){}remove(i,T){}complete(){}}e.IncrementalChangeCollector=y;class P{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(i){const T=this.createChangeCollector();for(const C of i)switch(C[0]){case 0:{const m=C[1];if(m.parent){if(this.items.has(m.parent)){const f=this.items.get(m.parent);f.children.add(m.item.extId);const a=this.createItem(m,f);this.items.set(m.item.extId,a),T.add(a)}}else{this.roots.add(m.item.extId);const f=this.createItem(m);this.items.set(m.item.extId,f),T.add(f)}m.expand===2&&this.updateBusyControllers(1);break}case 1:{const m=C[1],f=this.items.get(m.extId);if(!f)break;(0,e.applyTestItemUpdate)(f,m),T.update(f),m.expand!==void 0&&f.expand===2&&m.expand!==2&&this.updateBusyControllers(-1);break}case 2:{const m=this.items.get(C[1]);if(!m)break;m.parent?this.items.get(m.parent).children.delete(m.item.extId):this.roots.delete(m.item.extId);const f=[[C[1]]];for(;f.length;)for(const a of f.pop()){const d=this.items.get(a);d&&(f.push(d.children),this.items.delete(a),T.remove(d,d!==m),d.expand===2&&this.updateBusyControllers(-1))}break}case 4:this.retireTest(C[1]);break;case 3:this.updatePendingRoots(C[1]);break}T.complete()}retireTest(i){}updateBusyControllers(i){this.busyControllerCount+=i}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=P}),define(me[213],ge([0,1,8,36,12,23,9,76,175]),function(G,e,_,k,A,I,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class i{constructor(C,m,f,a){if(this._contributedVariables=new Map,this._context=C,this._labelService=m,f)if(y.isWindows){const d=Object.create(null);this._envVariables=d,Object.keys(f).forEach(E=>{d[E.toLowerCase()]=f[E]})}else this._envVariables=f}resolveWithEnvironment(C,m,f){return this.recursiveResolve(C,m?m.uri:void 0,f)}async resolveAsync(C,m){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,m)}resolve(C,m){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,m)}resolveAnyBase(C,m,f,a){const d=I.deepClone(m);return y.isWindows&&d.windows?Object.keys(d.windows).forEach(E=>d[E]=d.windows[E]):y.isMacintosh&&d.osx?Object.keys(d.osx).forEach(E=>d[E]=d.osx[E]):y.isLinux&&d.linux&&Object.keys(d.linux).forEach(E=>d[E]=d.linux[E]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(this._envVariables,C?C.uri:void 0,d,f,a)}resolveAny(C,m,f){return this.resolveAnyBase(C,m,f)}async resolveAnyAsync(C,m,f){return this.resolveAnyBase(C,m,f)}resolveAnyMap(C,m,f){const a=new Map;return{newConfig:this.resolveAnyBase(C,m,f,a),resolvedVariables:a}}resolveWithInteractionReplace(C,m,f,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,m,f,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,m){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,m)}recursiveResolve(C,m,f,a,d){if(A.isString(f))return this.resolveString(C,m,f,a,d);if(A.isArray(f))return f.map(E=>this.recursiveResolve(C,m,E,a,d));if(A.isObject(f)){let E=Object.create(null);return Object.keys(f).forEach(w=>{const b=this.resolveString(C,m,w,a,d);E[b]=this.recursiveResolve(C,m,f[w],a,d)}),E}return f}resolveString(C,m,f,a,d){return f.replace(i.VARIABLE_REGEXP,(w,b)=>{if(b.includes(i.VARIABLE_LHS))return w;let p=this.evaluateSingleVariable(C,w,b,m,a);return d&&d.set(b,p),p})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,m,f,a,d){let E;const w=f.split(":");w.length>1&&(f=w[0],E=w[1]);const b=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error((0,D.localize)(0,null,m))},p=()=>{const g=b();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,m,_.basename(g)))},c=()=>{if(E){const g=this._context.getFolderUri(E);if(g)return g;throw new Error((0,D.localize)(2,null,m,E))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,m)):new Error((0,D.localize)(4,null,m))};switch(f){case"env":if(E){if(C){const g=C[y.isWindows?E.toLowerCase():E];if(A.isString(g))return g}return""}throw new Error((0,D.localize)(5,null,m));case"config":if(E){const g=this._context.getConfigurationValue(a,E);if(A.isUndefinedOrNull(g))throw new Error((0,D.localize)(6,null,m,E));if(A.isObject(g))throw new Error((0,D.localize)(7,null,m,E));return g}throw new Error((0,D.localize)(8,null,m));case"command":return this.resolveFromMap(m,E,d,"command");case"input":return this.resolveFromMap(m,E,d,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return a||E?(0,P.normalizeDriveLetter)(this.fsPath(c())):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return _.basename(this.fsPath(c()));case"lineNumber":const g=this._context.getLineNumber();if(g)return g;throw new Error((0,D.localize)(9,null,m));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,m));case"file":return b();case"fileWorkspaceFolder":return p();case"relativeFile":return a||E?_.relative(this.fsPath(c()),b()):b();case"relativeFileDirname":const n=_.dirname(b());if(a||E){const l=_.relative(this.fsPath(c()),n);return l.length===0?".":l}return n;case"fileDirname":return _.dirname(b());case"fileExtname":return _.extname(b());case"fileBasename":return _.basename(b());case"fileBasenameNoExtension":const s=_.basename(b());return s.slice(0,s.length-_.extname(s).length);case"fileDirnameBasename":return _.basename(_.dirname(b()));case"execPath":const r=this._context.getExecPath();return r||m;case"execInstallFolder":const o=this._context.getAppRoot();return o||m;case"pathSeparator":return _.sep;default:try{const l=E?`${f}:${E}`:f;return this.resolveFromMap(m,l,d,void 0)}catch(l){return m}}}}resolveFromMap(C,m,f,a){if(m&&f){const d=a===void 0?f[m]:f[a+":"+m];if(typeof d=="string")return d;throw new Error((0,D.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=i,i.VARIABLE_LHS="${",i.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[214],ge([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,_.createDecorator)("editorGroupsService");var k;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var A;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var y;(function(m){m[m.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var P;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(P=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var i;(function(m){m[m.GROUP_ACTIVE=0]="GROUP_ACTIVE",m[m.GROUP_INDEX=1]="GROUP_INDEX",m[m.EDITOR_OPEN=2]="EDITOR_OPEN",m[m.EDITOR_CLOSE=3]="EDITOR_CLOSE",m[m.EDITOR_MOVE=4]="EDITOR_MOVE",m[m.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",m[m.EDITOR_LABEL=6]="EDITOR_LABEL",m[m.EDITOR_PIN=7]="EDITOR_PIN",m[m.EDITOR_STICKY=8]="EDITOR_STICKY",m[m.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(i=e.GroupChangeKind||(e.GroupChangeKind={}));var T;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function C(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(me[215],ge([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,_.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(me[20],ge([0,1,15,97,286,58,23,12,2,44,80,176,113,88,215,7]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(ue){function De(Y){const{selectionStartLineNumber:Ne,selectionStartColumn:Te,positionLineNumber:Je,positionColumn:et}=Y,ut=new d.Position(Ne-1,Te-1),rt=new d.Position(Je-1,et-1);return new d.Selection(ut,rt)}ue.to=De;function le(Y){const{anchor:Ne,active:Te}=Y;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}ue.from=le})(E=e.Selection||(e.Selection={}));var w;(function(ue){function De(Y){if(!!Y){const{start:Ne,end:Te}=Y;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}}ue.from=De;function le(Y){if(!!Y){const{startLineNumber:Ne,startColumn:Te,endLineNumber:Je,endColumn:et}=Y;return new d.Range(Ne-1,Te-1,Je-1,et-1)}}ue.to=le})(w=e.Range||(e.Range={}));var b;(function(ue){function De(le){switch(le){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 4:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}ue.to=De})(b=e.TokenType||(e.TokenType={}));var p;(function(ue){function De(Y){return new d.Position(Y.lineNumber-1,Y.column-1)}ue.to=De;function le(Y){return{lineNumber:Y.line+1,column:Y.character+1}}ue.from=le})(p=e.Position||(e.Position={}));var c;(function(ue){function De(Y){switch(Y){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}ue.from=De;function le(Y){switch(Y){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}ue.to=le})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(ue){function De(Y){let Ne;return Y.code&&((0,P.isString)(Y.code)||(0,P.isNumber)(Y.code)?Ne=String(Y.code):Ne={value:String(Y.code.value),target:Y.code.target}),Object.assign(Object.assign({},w.from(Y.range)),{message:Y.message,source:Y.source,code:Ne,severity:n.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(t.from),tags:Array.isArray(Y.tags)?(0,_.coalesce)(Y.tags.map(c.from)):void 0})}ue.from=De;function le(Y){var Ne;const Te=new d.Diagnostic(w.to(Y),Y.message,n.to(Y.severity));return Te.source=Y.source,Te.code=(0,P.isString)(Y.code)?Y.code:(Ne=Y.code)===null||Ne===void 0?void 0:Ne.value,Te.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(t.to),Te.tags=Y.tags&&(0,_.coalesce)(Y.tags.map(c.to)),Te}ue.to=le})(g=e.Diagnostic||(e.Diagnostic={}));var t;(function(ue){function De(Y){return Object.assign(Object.assign({},w.from(Y.location.range)),{message:Y.message,resource:Y.location.uri})}ue.from=De;function le(Y){return new d.DiagnosticRelatedInformation(new d.Location(Y.resource,w.to(Y)),Y.message)}ue.to=le})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(ue){function De(Y){switch(Y){case d.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}ue.from=De;function le(Y){switch(Y){case m.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}ue.to=le})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(ue){function De(Y){return typeof Y=="number"&&Y>=d.ViewColumn.One?Y-1:Y===d.ViewColumn.Beside?a.SIDE_GROUP:a.ACTIVE_GROUP}ue.from=De;function le(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}ue.to=le})(s=e.ViewColumn||(e.ViewColumn={}));function r(ue){return typeof ue.range!="undefined"}function o(ue){return ue.length===0?!0:!!r(ue[0])}e.isDecorationOptionsArr=o;var l;(function(ue){function De(et){return et.map(ue.from)}ue.fromMany=De;function le(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function Y(et){let ut;if(le(et)){const{language:ot,value:vt}=et;ut={value:"```"+ot+`
`+vt+"\n```\n"}}else d.MarkdownString.isMarkdownString(et)?ut={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ut={value:et}:ut={value:""};const rt=Object.create(null);ut.uris=rt;const Ge=ot=>{try{let vt=D.URI.parse(ot,!0);vt=vt.with({query:Ne(vt.query,rt)}),rt[ot]=vt}catch(vt){}return""},ht=new A.Renderer;return ht.link=Ge,ht.image=ot=>Ge(k.parseHrefAndDimensions(ot).href),A(ut.value,{renderer:ht}),ut}ue.from=Y;function Ne(et,ut){if(!et)return et;let rt;try{rt=(0,I.parse)(et)}catch(ht){}if(!rt)return et;let Ge=!1;return rt=(0,y.cloneAndChange)(rt,ht=>{if(D.URI.isUri(ht)){const ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ot]=ht,Ge=!0,ot}else return}),Ge?JSON.stringify(rt):et}function Te(et){const ut=new d.MarkdownString(et.value,et.supportThemeIcons);return ut.isTrusted=et.isTrusted,ut}ue.to=Te;function Je(et){if(!!et)return typeof et=="string"?et:ue.from(et)}ue.fromStrict=Je})(l=e.MarkdownString||(e.MarkdownString={}));function h(ue){return o(ue)?ue.map(De=>({range:w.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?l.fromMany(De.hoverMessage):De.hoverMessage?l.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):ue.map(De=>({range:w.from(De)}))}e.fromRangeOrRangeWithMessage=h;function S(ue){return typeof ue=="undefined"?ue:typeof ue=="string"?D.URI.file(ue):ue}e.pathOrURIToURI=S;var u;(function(ue){function De(le){return typeof le=="undefined"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?S(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}ue.from=De})(u=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var v;(function(ue){function De(le){return typeof le=="undefined"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?S(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?u.from(le.before):void 0,after:le.after?u.from(le.after):void 0}}ue.from=De})(v=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(ue){function De(le){if(typeof le=="undefined")return le;switch(le){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}ue.from=De})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(ue){function De(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?R.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?v.from(le.light):void 0,dark:le.dark?v.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?S(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?u.from(le.before):void 0,after:le.after?u.from(le.after):void 0}}ue.from=De})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var H;(function(ue){function De(Y){return{text:Y.newText,eol:Y.newEol&&re.from(Y.newEol),range:w.from(Y.range)}}ue.from=De;function le(Y){const Ne=new d.TextEdit(w.to(Y.range),Y.text);return Ne.newEol=typeof Y.eol=="undefined"?void 0:re.to(Y.eol),Ne}ue.to=le})(H=e.TextEdit||(e.TextEdit={}));var ie;(function(ue){function De(Y,Ne,Te){var Je,et,ut;const rt={edits:[]};if(Y instanceof d.WorkspaceEdit)for(let Ge of Y._allEntries())if(Ge._type===1)rt.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const ht=Ne==null?void 0:Ne.getDocument(Ge.uri);rt.edits.push({_type:2,resource:Ge.uri,edit:H.from(Ge.edit),modelVersionId:ht==null?void 0:ht.version,metadata:Ge.metadata})}else Ge._type===3?rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:(Je=Te==null?void 0:Te.lookupNotebookDocument(Ge.uri))===null||Je===void 0?void 0:Je.notebookDocument.version}):Ge._type===4?(Ge.newOutputs&&rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:2,index:Ge.index,append:Ge.append,outputs:Ge.newOutputs.map(qe.from)}}),Ge.newMetadata&&rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:11,index:Ge.index,metadata:Ge.newMetadata}})):Ge._type===5?rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:(et=Te==null?void 0:Te.lookupNotebookDocument(Ge.uri))===null||et===void 0?void 0:et.notebookDocument.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(pe.from)}}):Ge._type===6&&rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:10,outputId:Ge.outputId,items:((ut=Ge.newOutputItems)===null||ut===void 0?void 0:ut.map(Se.from))||[],append:Ge.append}});return rt}ue.from=De;function le(Y){const Ne=new d.WorkspaceEdit;for(const Te of Y.edits)Te.edit?Ne.replace(D.URI.revive(Te.resource),w.to(Te.edit.range),Te.edit.text):Ne.renameFile(D.URI.revive(Te.oldUri),D.URI.revive(Te.newUri),Te.options);return Ne}ue.to=le})(ie=e.WorkspaceEdit||(e.WorkspaceEdit={}));var j;(function(ue){const De=Object.create(null);De[d.SymbolKind.File]=0,De[d.SymbolKind.Module]=1,De[d.SymbolKind.Namespace]=2,De[d.SymbolKind.Package]=3,De[d.SymbolKind.Class]=4,De[d.SymbolKind.Method]=5,De[d.SymbolKind.Property]=6,De[d.SymbolKind.Field]=7,De[d.SymbolKind.Constructor]=8,De[d.SymbolKind.Enum]=9,De[d.SymbolKind.Interface]=10,De[d.SymbolKind.Function]=11,De[d.SymbolKind.Variable]=12,De[d.SymbolKind.Constant]=13,De[d.SymbolKind.String]=14,De[d.SymbolKind.Number]=15,De[d.SymbolKind.Boolean]=16,De[d.SymbolKind.Array]=17,De[d.SymbolKind.Object]=18,De[d.SymbolKind.Key]=19,De[d.SymbolKind.Null]=20,De[d.SymbolKind.EnumMember]=21,De[d.SymbolKind.Struct]=22,De[d.SymbolKind.Event]=23,De[d.SymbolKind.Operator]=24,De[d.SymbolKind.TypeParameter]=25;function le(Ne){return typeof De[Ne]=="number"?De[Ne]:6}ue.from=le;function Y(Ne){for(const Te in De)if(De[Te]===Ne)return Number(Te);return d.SymbolKind.Property}ue.to=Y})(j=e.SymbolKind||(e.SymbolKind={}));var B;(function(ue){function De(Y){switch(Y){case d.SymbolTag.Deprecated:return 1}}ue.from=De;function le(Y){switch(Y){case 1:return d.SymbolTag.Deprecated}}ue.to=le})(B=e.SymbolTag||(e.SymbolTag={}));var $;(function(ue){function De(Y){return{name:Y.name,kind:j.from(Y.kind),tags:Y.tags&&Y.tags.map(B.from),containerName:Y.containerName,location:O.from(Y.location)}}ue.from=De;function le(Y){const Ne=new d.SymbolInformation(Y.name,j.to(Y.kind),Y.containerName,O.to(Y.location));return Ne.tags=Y.tags&&Y.tags.map(B.to),Ne}ue.to=le})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var N;(function(ue){function De(Y){var Ne,Te;const Je={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:w.from(Y.range),selectionRange:w.from(Y.selectionRange),kind:j.from(Y.kind),tags:(Te=(Ne=Y.tags)===null||Ne===void 0?void 0:Ne.map(B.from))!==null&&Te!==void 0?Te:[]};return Y.children&&(Je.children=Y.children.map(De)),Je}ue.from=De;function le(Y){const Ne=new d.DocumentSymbol(Y.name,Y.detail,j.to(Y.kind),w.to(Y.range),w.to(Y.selectionRange));return(0,_.isNonEmptyArray)(Y.tags)&&(Ne.tags=Y.tags.map(B.to)),Y.children&&(Ne.children=Y.children.map(le)),Ne}ue.to=le})(N=e.DocumentSymbol||(e.DocumentSymbol={}));var M;(function(ue){function De(le){const Y=new d.CallHierarchyItem(j.to(le.kind),le.name,le.detail||"",D.URI.revive(le.uri),w.to(le.range),w.to(le.selectionRange));return Y._sessionId=le._sessionId,Y._itemId=le._itemId,Y}ue.to=De})(M=e.CallHierarchyItem||(e.CallHierarchyItem={}));var F;(function(ue){function De(le){return new d.CallHierarchyIncomingCall(M.to(le.from),le.fromRanges.map(Y=>w.to(Y)))}ue.to=De})(F=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var U;(function(ue){function De(le){return new d.CallHierarchyOutgoingCall(M.to(le.to),le.fromRanges.map(Y=>w.to(Y)))}ue.to=De})(U=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var O;(function(ue){function De(Y){return{range:Y.range&&w.from(Y.range),uri:Y.uri}}ue.from=De;function le(Y){return new d.Location(D.URI.revive(Y.uri),w.to(Y.range))}ue.to=le})(O=e.location||(e.location={}));var W;(function(ue){function De(Y){const Ne=Y,Te=Y;return{originSelectionRange:Ne.originSelectionRange?w.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:Te.uri,range:w.from(Ne.targetRange?Ne.targetRange:Te.range),targetSelectionRange:Ne.targetSelectionRange?w.from(Ne.targetSelectionRange):void 0}}ue.from=De;function le(Y){return{targetUri:D.URI.revive(Y.uri),targetRange:w.to(Y.range),targetSelectionRange:Y.targetSelectionRange?w.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?w.to(Y.originSelectionRange):void 0}}ue.to=le})(W=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(ue){function De(Y){return{range:w.from(Y.range),contents:l.fromMany(Y.contents)}}ue.from=De;function le(Y){return new d.Hover(Y.contents.map(l.to),w.to(Y.range))}ue.to=le})(q=e.Hover||(e.Hover={}));var Q;(function(ue){function De(Y){return{range:w.from(Y.range),expression:Y.expression}}ue.from=De;function le(Y){return new d.EvaluatableExpression(w.to(Y.range),Y.expression)}ue.to=le})(Q=e.EvaluatableExpression||(e.EvaluatableExpression={}));var he;(function(ue){function De(Y){if(Y instanceof d.InlineValueText)return{type:"text",range:w.from(Y.range),text:Y.text};if(Y instanceof d.InlineValueVariableLookup)return{type:"variable",range:w.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}ue.from=De;function le(Y){switch(Y.type){case"text":return{range:w.to(Y.range),text:Y.text};case"variable":return{range:w.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:w.to(Y.range),expression:Y.expression}}}ue.to=le})(he=e.InlineValue||(e.InlineValue={}));var ve;(function(ue){function De(Y){return{frameId:Y.frameId,stoppedLocation:w.from(Y.stoppedLocation)}}ue.from=De;function le(Y){return new d.InlineValueContext(Y.frameId,w.to(Y.stoppedLocation))}ue.to=le})(ve=e.InlineValueContext||(e.InlineValueContext={}));var Ie;(function(ue){function De(Y){return{range:w.from(Y.range),kind:Y.kind}}ue.from=De;function le(Y){return new d.DocumentHighlight(w.to(Y.range),Y.kind)}ue.to=le})(Ie=e.DocumentHighlight||(e.DocumentHighlight={}));var ke;(function(ue){function De(le){switch(le){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}ue.to=De})(ke=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Le;(function(ue){function De(le){return{triggerKind:ke.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}ue.to=De})(Le=e.CompletionContext||(e.CompletionContext={}));var V;(function(ue){function De(Y){switch(Y){case d.CompletionItemTag.Deprecated:return 1}}ue.from=De;function le(Y){switch(Y){case 1:return d.CompletionItemTag.Deprecated}}ue.to=le})(V=e.CompletionItemTag||(e.CompletionItemTag={}));var J;(function(ue){const De=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function le(Te){var Je;return(Je=De.get(Te))!==null&&Je!==void 0?Je:9}ue.from=le;const Y=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Ne(Te){var Je;return(Je=Y.get(Te))!==null&&Je!==void 0?Je:d.CompletionItemKind.Property}ue.to=Ne})(J=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(ue){function De(le,Y){var Ne;const Te=new d.CompletionItem(typeof le.label=="string"?le.label:le.label.name);return typeof le.label!="string"&&(Te.label2=le.label),Te.insertText=le.insertText,Te.kind=J.to(le.kind),Te.tags=(Ne=le.tags)===null||Ne===void 0?void 0:Ne.map(V.to),Te.detail=le.detail,Te.documentation=k.isMarkdownString(le.documentation)?l.to(le.documentation):le.documentation,Te.sortText=le.sortText,Te.filterText=le.filterText,Te.preselect=le.preselect,Te.commitCharacters=le.commitCharacters,i.Range.isIRange(le.range)?Te.range=w.to(le.range):typeof le.range=="object"&&(Te.range={inserting:w.to(le.range.insert),replacing:w.to(le.range.replace)}),Te.keepWhitespace=typeof le.insertTextRules=="undefined"?!1:Boolean(le.insertTextRules&1),typeof le.insertTextRules!="undefined"&&le.insertTextRules&4?Te.insertText=new d.SnippetString(le.insertText):(Te.insertText=le.insertText,Te.textEdit=Te.range instanceof d.Range?new d.TextEdit(Te.range,Te.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Te.additionalTextEdits=le.additionalTextEdits.map(Je=>H.to(Je))),Te.command=Y&&le.command?Y.fromInternal(le.command):void 0,Te}ue.to=De})(ee=e.CompletionItem||(e.CompletionItem={}));var ae;(function(ue){function De(Y){return{label:Y.label,documentation:Y.documentation?l.fromStrict(Y.documentation):void 0}}ue.from=De;function le(Y){return{label:Y.label,documentation:k.isMarkdownString(Y.documentation)?l.to(Y.documentation):Y.documentation}}ue.to=le})(ae=e.ParameterInformation||(e.ParameterInformation={}));var we;(function(ue){function De(Y){return{label:Y.label,documentation:Y.documentation?l.fromStrict(Y.documentation):void 0,parameters:Array.isArray(Y.parameters)?Y.parameters.map(ae.from):[],activeParameter:Y.activeParameter}}ue.from=De;function le(Y){return{label:Y.label,documentation:k.isMarkdownString(Y.documentation)?l.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(ae.to):[],activeParameter:Y.activeParameter}}ue.to=le})(we=e.SignatureInformation||(e.SignatureInformation={}));var Ce;(function(ue){function De(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(we.from):[]}}ue.from=De;function le(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(we.to):[]}}ue.to=le})(Ce=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(ue){function De(Y){var Ne;return{text:Y.text,range:w.from(Y.range),kind:be.from((Ne=Y.kind)!==null&&Ne!==void 0?Ne:d.InlineHintKind.Other),description:Y.description&&l.fromStrict(Y.description),whitespaceBefore:Y.whitespaceBefore,whitespaceAfter:Y.whitespaceAfter}}ue.from=De;function le(Y){const Ne=new d.InlineHint(Y.text,w.to(Y.range),be.to(Y.kind));return Ne.whitespaceAfter=Y.whitespaceAfter,Ne.whitespaceBefore=Y.whitespaceBefore,Ne.description=k.isMarkdownString(Y.description)?l.to(Y.description):Y.description,Ne}ue.to=le})(Oe=e.InlineHint||(e.InlineHint={}));var be;(function(ue){function De(Y){return Y}ue.from=De;function le(Y){return Y}ue.to=le})(be=e.InlineHintKind||(e.InlineHintKind={}));var Pe;(function(ue){function De(Y){return{range:w.from(Y.range),url:Y.target,tooltip:Y.tooltip}}ue.from=De;function le(Y){let Ne;if(Y.url)try{Ne=typeof Y.url=="string"?D.URI.parse(Y.url,!0):D.URI.revive(Y.url)}catch(Te){}return new d.DocumentLink(w.to(Y.range),Ne)}ue.to=le})(Pe=e.DocumentLink||(e.DocumentLink={}));var Re;(function(ue){function De(Y){const Ne=new d.ColorPresentation(Y.label);return Y.textEdit&&(Ne.textEdit=H.to(Y.textEdit)),Y.additionalTextEdits&&(Ne.additionalTextEdits=Y.additionalTextEdits.map(Te=>H.to(Te))),Ne}ue.to=De;function le(Y){return{label:Y.label,textEdit:Y.textEdit?H.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Ne=>H.from(Ne)):void 0}}ue.from=le})(Re=e.ColorPresentation||(e.ColorPresentation={}));var We;(function(ue){function De(Y){return new d.Color(Y[0],Y[1],Y[2],Y[3])}ue.to=De;function le(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}ue.from=le})(We=e.Color||(e.Color={}));var Ee;(function(ue){function De(Y){return{range:w.from(Y.range)}}ue.from=De;function le(Y){return new d.SelectionRange(w.to(Y.range))}ue.to=le})(Ee=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(ue){function De(le){switch(le){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}ue.to=De})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(ue){function De(Y){switch(Y){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}ue.from=De;function le(Y){switch(Y){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}ue.to=le})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var re;(function(ue){function De(Y){if(Y===d.EndOfLine.CRLF)return 1;if(Y===d.EndOfLine.LF)return 0}ue.from=De;function le(Y){if(Y===1)return d.EndOfLine.CRLF;if(Y===0)return d.EndOfLine.LF}ue.to=le})(re=e.EndOfLine||(e.EndOfLine={}));var _e;(function(ue){function De(le){if(typeof le=="object")return le.viewId;switch(le){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ue.from=De})(_e=e.ProgressLocation||(e.ProgressLocation={}));var xe;(function(ue){function De(le){const Y={start:le.start+1,end:le.end+1};return le.kind&&(Y.kind=ze.from(le.kind)),Y}ue.from=De})(xe=e.FoldingRange||(e.FoldingRange={}));var ze;(function(ue){function De(le){if(le)switch(le){case d.FoldingRangeKind.Comment:return T.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return T.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return T.FoldingRangeKind.Region}}ue.from=De})(ze=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $e;(function(ue){function De(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?w.from(le.selection):void 0,override:typeof le.override=="boolean"?C.EditorOverride.DISABLED:void 0}}ue.from=De})($e=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ye;(function(ue){function De(Y){return Y instanceof d.RelativePattern||typeof Y=="string"?Y:le(Y)?new d.RelativePattern(Y.base,Y.pattern):Y}ue.from=De;function le(Y){const Ne=Y;return Ne&&typeof Ne.base=="string"&&typeof Ne.pattern=="string"}})(Ye=e.GlobPattern||(e.GlobPattern={}));var K;(function(ue){function De(le){if(le){if(Array.isArray(le))return le.map(De);if(typeof le=="string")return le;{const Y=le;return{language:Y.language,scheme:Y.scheme,pattern:typeof Y.pattern=="undefined"?void 0:Ye.from(Y.pattern),exclusive:Y.exclusive}}}else return}ue.from=De})(K=e.LanguageSelector||(e.LanguageSelector={}));var oe;(function(ue){function De(Y){return{start:Y.start,end:Y.end}}ue.from=De;function le(Y){return new d.NotebookRange(Y.start,Y.end)}ue.to=le})(oe=e.NotebookRange||(e.NotebookRange={}));var fe;(function(ue){function De(le){return new d.NotebookCellMetadata().with(Object.assign(Object.assign({},le),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}ue.to=De})(fe=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var Z;(function(ue){function De(Y){return Y}ue.from=De;function le(Y){return new d.NotebookDocumentMetadata().with(Y)}ue.to=le})(Z=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ne;(function(ue){function De(Y){return{startTime:Y.runStartTime,endTime:Y.runEndTime,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}ue.to=De;function le(Y){return{lastRunSuccess:Y.success,runStartTime:Y.startTime,runEndTime:Y.endTime,executionOrder:Y.executionOrder}}ue.from=le})(ne=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var ce;(function(ue){function De(Y){switch(Y){case d.NotebookCellKind.Markdown:return f.CellKind.Markdown;case d.NotebookCellKind.Code:default:return f.CellKind.Code}}ue.from=De;function le(Y){switch(Y){case f.CellKind.Markdown:return d.NotebookCellKind.Markdown;case f.CellKind.Code:default:return d.NotebookCellKind.Code}}ue.to=le})(ce=e.NotebookCellKind||(e.NotebookCellKind={}));var pe;(function(ue){function De(Y){var Ne;return{cellKind:ce.from(Y.kind),language:Y.language,source:Y.source,metadata:Object.assign(Object.assign({},Y.metadata),ne.from((Ne=Y.latestExecutionSummary)!==null&&Ne!==void 0?Ne:{})),outputs:Y.outputs?Y.outputs.map(qe.from):[]}}ue.from=De;function le(Y){return new d.NotebookCellData(ce.to(Y.cellKind),Y.source,Y.language,Y.outputs?Y.outputs.map(qe.to):void 0,Y.metadata?fe.to(Y.metadata):void 0)}ue.to=le})(pe=e.NotebookCellData||(e.NotebookCellData={}));var Se;(function(ue){function De(Y){return{mime:Y.mime,value:Y.value,metadata:Y.metadata}}ue.from=De;function le(Y){return new d.NotebookCellOutputItem(Y.mime,Y.value,Y.metadata)}ue.to=le})(Se=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var qe;(function(ue){function De(Y){return{outputId:Y.id,outputs:Y.outputs.map(Se.from),metadata:Y.metadata}}ue.from=De;function le(Y){const Ne=Y.outputs.map(Se.to);return new d.NotebookCellOutput(Ne,Y.outputId,Y.metadata)}ue.to=le})(qe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Me;(function(ue){function De(Te){if(Te!=null){if(Te instanceof d.RelativePattern||typeof Te=="string")return Te;if(Ne(Te))return new d.RelativePattern(Te.base,Te.pattern);if(Y(Te))return{include:Ye.from(Te.include)||void 0,exclude:Ye.from(Te.exclude)||void 0}}}ue.from=De;function le(Te){return typeof Te=="string"?Te:Ne(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}ue.to=le;function Y(Te){const Je=Te,et=Ye.from(Je.include);if(!(et&&et instanceof d.RelativePattern||typeof et=="string"))return!1;const ut=Ye.from(Je.exclude);return!!(ut&&ut instanceof d.RelativePattern||typeof ut=="string")}function Ne(Te){const Je=Te;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(Me=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var He;(function(ue){function De(le){return{backgroundColor:le.backgroundColor,borderColor:le.borderColor,top:le.top?u.from(le.top):void 0}}ue.from=De})(He=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Qe;(function(ue){function De(le,Y,Ne){const Te=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(Te,Ne),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}ue.from=De})(Qe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var it;(function(ue){function De(le){var Y,Ne,Te;return{transientOutputs:(Y=le==null?void 0:le.transientOutputs)!==null&&Y!==void 0?Y:!1,transientCellMetadata:Object.assign(Object.assign({},(Ne=le==null?void 0:le.transientCellMetadata)!==null&&Ne!==void 0?Ne:le==null?void 0:le.transientMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Te=le==null?void 0:le.transientDocumentMetadata)!==null&&Te!==void 0?Te:{}}}ue.from=De})(it=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var at;(function(ue){function De(Y){var Ne;return{uri:Y.uri,provides:typeof Y.provides=="string"?[Y.provides]:(Ne=Y.provides)!==null&&Ne!==void 0?Ne:[]}}ue.from=De;function le(Y){return{uri:D.URI.revive(Y.uri),provides:Y.provides}}ue.to=le})(at=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var Ze;(function(ue){function De(Y){return{message:l.fromStrict(Y.message)||"",severity:Y.severity,expectedOutput:Y.expectedOutput,actualOutput:Y.actualOutput,location:Y.location?O.from(Y.location):void 0}}ue.from=De;function le(Y){const Ne=new d.TestMessage(typeof Y.message=="string"?Y.message:l.to(Y.message));return Ne.severity=Y.severity,Ne.actualOutput=Y.actualOutput,Ne.expectedOutput=Y.expectedOutput,Ne}ue.to=le})(Ze=e.TestMessage||(e.TestMessage={}));var nt;(function(ue){function De(Te){var Je,et;return{extId:Te.id,label:Te.label,uri:Te.uri,range:w.from(Te.range),debuggable:(Je=Te.debuggable)!==null&&Je!==void 0?Je:!1,description:Te.description,runnable:(et=Te.runnable)!==null&&et!==void 0?et:!0}}ue.from=De;function le(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:w.from(Te.range),debuggable:!1,description:Te.description,runnable:!0}}ue.fromResultSnapshot=le;function Y(Te){return{id:Te.extId,label:Te.label,uri:D.URI.revive(Te.uri),range:w.to(Te.range),addChild:()=>{},dispose:()=>{},status:d.TestItemStatus.Pending,data:void 0,debuggable:Te.debuggable,description:Te.description,runnable:Te.runnable}}ue.toPlain=Y;function Ne(Te){const Je=new d.TestItemImpl(Te.extId,Te.label,D.URI.revive(Te.uri),void 0);return Je.range=w.to(Te.range),Je.debuggable=Te.debuggable,Je.description=Te.description,Je.runnable=Te.runnable,Je}ue.to=Ne})(nt=e.TestItem||(e.TestItem={}));var dt;(function(ue){const De=(Y,Ne)=>Object.assign(Object.assign({},nt.toPlain(Y.item)),{taskStates:Y.tasks.map(Te=>({state:Te.state,duration:Te.duration,messages:Te.messages.map(Ze.to)})),children:Y.children.map(Te=>Ne.get(Te)).filter(P.isDefined).map(Te=>De(Te,Ne))});function le(Y){const Ne=[],Te=new Map;for(const Je of Y.items)Te.set(Je.item.extId,Je),Je.direct&&Ne.push(Je);return{completedAt:Y.completedAt,results:Ne.map(Je=>De(Je,Te))}}ue.to=le})(dt=e.TestResults||(e.TestResults={}));var _t;(function(ue){function De(le){switch(le){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}ue.to=De})(_t=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(me[216],ge([0,1,2,18,7,20,56]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(i,T,C,m={timeout:1500,errors:3}){this._logService=i,this._documents=T,this._mainThreadBulkEdits=C,this._thresholds=m,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(i){return(T,C,m)=>{const a={dispose:this._callbacks.push([T,C,i])};return Array.isArray(m)&&m.push(a),a}}async $participateInSave(i,T){const C=_.URI.revive(i);let m=!1;const f=setTimeout(()=>m=!0,this._thresholds.timeout),a=[];try{for(let d of[...this._callbacks]){if(m)break;const E=this._documents.getDocument(C),w=await this._deliverEventAsyncAndBlameBadListeners(d,{document:E,reason:I.TextDocumentSaveReason.to(T)});a.push(w)}}finally{clearTimeout(f)}return a}_deliverEventAsyncAndBlameBadListeners([i,T,C],m){const f=this._badListeners.get(i);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,i,T,m).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const d=this._badListeners.get(i);this._badListeners.set(i,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(i,T,C,m){const f=[],a=Date.now(),{document:d,reason:E}=m,{version:w}=d,b=Object.freeze({document:d,reason:E,waitUntil(p){if(Object.isFrozen(f))throw(0,k.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(p))}});try{T.apply(C,[b])}catch(p){return Promise.reject(p)}return Object.freeze(f),new Promise((p,c)=>{const g=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${i.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(g),p(t)}).catch(t=>{clearTimeout(g),c(t)})}).then(p=>{const c={edits:[]};for(const g of p)if(Array.isArray(g)&&g.every(t=>t instanceof A.TextEdit))for(const{newText:t,newEol:n,range:s}of g)c.edits.push({_type:2,resource:d.uri,edit:{range:s&&I.Range.from(s),text:t,eol:n&&I.EndOfLine.from(n)}});if(c.edits.length!==0)return w===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(me[217],ge([0,1,3,19,33,2,20,7]),function(G,e,_,k,A,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(C,m,f,a,d){this._onDidCreate=new _.Emitter,this._onDidChange=new _.Emitter,this._onDidDelete=new _.Emitter,this._config=0,f&&(this._config+=1),a&&(this._config+=2),d&&(this._config+=4);const E=(0,A.parse)(m),w=C(b=>{if(!f)for(let p of b.created){const c=I.URI.revive(p);E(c.fsPath)&&this._onDidCreate.fire(c)}if(!a)for(let p of b.changed){const c=I.URI.revive(p);E(c.fsPath)&&this._onDidChange.fire(c)}if(!d)for(let p of b.deleted){const c=I.URI.revive(p);E(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class i{constructor(C,m,f){this._logService=m,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new _.Emitter,this._onDidRenameFile=new _.Emitter,this._onDidCreateFile=new _.Emitter,this._onDidDeleteFile=new _.Emitter,this._onWillRenameFile=new k.AsyncEmitter,this._onWillCreateFile=new k.AsyncEmitter,this._onWillDeleteFile=new k.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,m,f,a){return new D(this._onFileSystemEvent.event,C,m,f,a)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,m){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:m.map(f=>({oldUri:I.URI.revive(f.source),newUri:I.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:m.map(f=>I.URI.revive(f.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:m.map(f=>I.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,m){return(f,a,d)=>{const E=function(b){f.call(a,b)};return E.extension=C,m.event(E,void 0,d)}}async $onWillRunFileOperation(C,m,f,a){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:m.map(d=>({oldUri:I.URI.revive(d.source),newUri:I.URI.revive(d.target)}))},f,a);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:m.map(d=>I.URI.revive(d.target))},f,a);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:m.map(d=>I.URI.revive(d.target))},f,a)}}async _fireWillEvent(C,m,f,a){const d=new Set,E=[];if(await C.fireAsync(m,a,async(b,p)=>{var c;const g=Date.now(),t=await Promise.resolve(b);t instanceof P.WorkspaceEdit&&(E.push(t),d.add((c=p.extension.displayName)!==null&&c!==void 0?c:p.extension.identifier.value)),Date.now()-g>f&&this._logService.warn("SLOW file-participant",p.extension.identifier)}),!a.isCancellationRequested&&E.length!==0){const w={edits:[]};for(let b of E){let{edits:p}=y.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(p)}return{edit:w,extensionNames:Array.from(d)}}}}e.ExtHostFileSystemEventService=i}),define(me[218],ge([0,1,11,23,2,20,7,88]),function(G,e,_,k,A,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(m,f,a,d){this.start=m,this.deletedCount=f,this.deletedItems=a,this.items=d}static asApiEvents(m){return m.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(a=>a.cell)}))}}class i{constructor(m,f,a){var d;this._notebook=m,this._extHostDocument=f,this._cellData=a,this.handle=a.handle,this.uri=A.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(I.NotebookCellOutput.to),this._internalMetadata=(d=a.metadata)!==null&&d!==void 0?d:{},this._metadata=I.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=I.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(m,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:m}}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const m=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return m._notebook.getCellIndex(m)},notebook:m._notebook.notebookDocument,kind:I.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get outputs(){return m._outputs.slice(0)},get metadata(){return m._metadata},get latestExecutionSummary(){return m._previousResult}})}return this._cell}setOutputs(m){this._outputs=m.map(I.NotebookCellOutput.to)}setOutputItems(m,f,a){const d=a.map(I.NotebookCellOutputItem.to),E=this._outputs.find(w=>w.id===m);E&&(f||(E.outputs.length=0),E.outputs.push(...d))}setMetadata(m){this._internalMetadata=m,this._metadata=I.NotebookCellMetadata.to(m),this._previousResult=I.NotebookCellPreviousExecutionResult.to(m)}}e.ExtHostCell=i;class T{constructor(m,f,a,d,E,w,b){this._proxy=m,this._textDocumentsAndEditors=f,this._textDocuments=a,this._emitter=d,this._viewType=E,this._metadata=w,this.uri=b,this.handle=T._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get notebookDocument(){if(!this._notebook){const m=this;this._notebook={get uri(){return m.uri},get version(){return m._versionId},get viewType(){return m._viewType},get isDirty(){return m._isDirty},get isUntitled(){return m.uri.scheme===_.Schemas.untitled},get isClosed(){return m._disposed},get metadata(){return m._metadata},get cellCount(){return m._cells.length},cellAt(f){return f=m._validateIndex(f),m._cells[f].cell},getCells(f){return(f?m._getCells(f):m._cells).map(d=>d.cell)},save(){return m._save()}}}return this._notebook}updateBackup(m){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=m}disposeBackup(){var m;(m=this._backup)===null||m===void 0||m.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(m){m.metadata&&(this._metadata=this._metadata.with(m.metadata))}acceptModelChanged(m,f){this._versionId=m.versionId,this._isDirty=f;for(const a of m.rawEvents)a.kind===P.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(a.changes,!0),a.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===P.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===P.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(a.index,a.metadata)}_validateIndex(m){return m<0?0:m>=this._cells.length?this._cells.length-1:m}_validateRange(m){return m.start<0&&(m=m.with({start:0})),m.end>this._cells.length&&(m=m.with({end:this._cells.length})),m}_getCells(m){m=this._validateRange(m);const f=[];for(let a=m.start;a<m.end;a++)f.push(this._cells[a]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(m,f){if(!this._disposed){const a=[],d=[],E=[];m.reverse().forEach(w=>{const p=w[2].map(t=>{const n=new i(this,this._textDocumentsAndEditors,t);return f||d.push(i.asModelAddData(this.notebookDocument,t)),n}),c=new D(w[0],w[1],[],p),g=this._cells.splice(w[0],w[1],...p);for(let t of g)E.push(t.uri),c.deletedItems.push(t.cell);a.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:E}),f||this._emitter.emitModelChange((0,k.deepFreeze)({document:this.notebookDocument,changes:D.asApiEvents(a)}))}}_moveCell(m,f){const a=this._cells.splice(m,1);this._cells.splice(f,0,...a);const d=[new D(m,1,a.map(E=>E.cell),[]),new D(f,0,[],a)];this._emitter.emitModelChange((0,k.deepFreeze)({document:this.notebookDocument,changes:D.asApiEvents(d)}))}_setCellOutputs(m,f){const a=this._cells[m];a.setOutputs(f),this._emitter.emitCellOutputsChange((0,k.deepFreeze)({document:this.notebookDocument,cells:[a.cell]}))}_setCellOutputItems(m,f,a,d){const E=this._cells[m];E.setOutputItems(f,a,d),this._emitter.emitCellOutputsChange((0,k.deepFreeze)({document:this.notebookDocument,cells:[E.cell]}))}_changeCellLanguage(m,f){const a=this._cells[m];a.cell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(a.uri,f)}_changeCellMetadata(m,f){var a;const d=this._cells[m],E=d.internalMetadata,w=d.cell.metadata;d.setMetadata(f);const b=d.cell.metadata;if((0,k.equals)(w,b)||this._emitter.emitCellMetadataChange((0,k.deepFreeze)({document:this.notebookDocument,cell:d.cell})),E.runState!==f.runState){const p=(a=f.runState)!==null&&a!==void 0?a:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,k.deepFreeze)({document:this.notebookDocument,cell:d.cell,executionState:p}))}}getCellFromIndex(m){return this._cells[m]}getCell(m){return this._cells.find(f=>f.handle===m)}getCellIndex(m){return this._cells.indexOf(m)}}e.ExtHostNotebookDocument=T,T._handlePool=0}),define(me[219],ge([0,1,7,20]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(P){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=P}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(P){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:P})}replaceCellMetadata(P,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:P,metadata:D})}replaceCellOutput(P,D){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:P,outputs:D.map(i=>k.NotebookCellOutput.from(i))})}replaceCells(P,D,i){this._throwIfFinalized(),!(P===D&&i.length===0)&&this._collectedEdits.push({editType:1,index:P,count:D-P,cells:i.map(k.NotebookCellData.from)})}}class I{constructor(P,D,i,T,C,m){this.id=P,this._proxy=D,this.notebookData=i,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=C,this._visibleRanges=T,this._viewColumn=m}get apiEditor(){if(!this._editor){const P=this;this._editor={get document(){return P.notebookData.notebookDocument},get selections(){return P._selections},get visibleRanges(){return P._visibleRanges},revealRange(D,i){P._proxy.$tryRevealRange(P.id,k.NotebookRange.from(D),i!=null?i:_.NotebookEditorRevealType.Default)},get viewColumn(){return P._viewColumn},edit(D){const i=new A(this.document.version);return D(i),P._applyEdit(i.finalize())},get kernel(){return P._kernel},setDecorations(D,i){return P.setDecorations(D,i)}}}return this._editor}_acceptKernel(P){this._kernel=P}get visible(){return this._visible}_acceptVisibility(P){this._visible=P}_acceptVisibleRanges(P){this._visibleRanges=P}_acceptSelections(P){this._selections=P}_acceptViewColumn(P){this._viewColumn=P}_applyEdit(P){if(P.cellEdits.length===0)return Promise.resolve(!0);const D=[];let i=-1;for(let T=0;T<P.cellEdits.length;T++){if(i<0){D.push(P.cellEdits[T]),i++;continue}const m=D[i],f=P.cellEdits[T];if(m.editType===1&&f.editType===1&&m.index===f.index){m.cells.push(...P.cellEdits[T].cells),m.count+=P.cellEdits[T].count;continue}D.push(P.cellEdits[T]),i++}return this._proxy.$tryApplyEdits(this.id,P.documentVersionId,D)}setDecorations(P,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(P.key)))return D.isEmpty?this._hasDecorationsForKey.delete(P.key):this._hasDecorationsForKey.add(P.key),this._proxy.$trySetDecorations(this.id,k.NotebookRange.from(D),P.key)}}e.ExtHostNotebookEditor=I}),define(me[220],ge([0,1,20,114,163,21,70]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class P{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,m,f){const a=this._handles++,{title:d,location:E,cancellable:w}=m,b={label:(0,A.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(a,{location:_.ProgressLocation.from(E),title:d,source:b,cancellable:w},C),this._withProgress(a,f,!!w)}_withProgress(C,m,f){let a;f&&(a=new I.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,a));const d=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),a&&a.dispose()};let E;try{E=m(new i(this._proxy,C),f&&a?a.token:I.CancellationToken.None)}catch(w){throw d(C),w}return E.then(w=>d(C),w=>d(C)),E}$acceptProgressCanceled(C){const m=this._mapHandleToCancellationSource.get(C);m&&(m.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=P;function D(T,C){return T.message=C.message,typeof C.increment=="number"&&(typeof T.increment=="number"?T.increment+=C.increment:T.increment=C.increment),T}class i extends k.Progress{constructor(C,m){super(f=>this.throttledReport(f));this._proxy=C,this._handle=m}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}je([(0,y.throttle)(100,(T,C)=>D(T,C),()=>Object.create(null))],i.prototype,"throttledReport",null)}),define(me[123],ge([0,1,52,18,72,20,7]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(m,f){const a=P._Keys.nextId();m.$registerTextEditorDecorationType(a,I.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:a,dispose(){m.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=P,P._Keys=new A.IdGenerator("TextEditorDecorationType");class D{constructor(m,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=m,this._documentVersionId=m.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(m,f){this._throwIfFinalized();let a=null;if(m instanceof y.Position)a=new y.Range(m,m);else if(m instanceof y.Range)a=m;else throw new Error("Unrecognized location");this._pushEdit(a,f,!1)}insert(m,f){this._throwIfFinalized(),this._pushEdit(new y.Range(m,m),f,!0)}delete(m){this._throwIfFinalized();let f=null;if(m instanceof y.Range)f=m;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(m,f,a){const d=this._document.validateRange(m);this._collectedEdits.push({range:d,text:f,forceMoveMarkers:a})}setEndOfLine(m){if(this._throwIfFinalized(),m!==y.EndOfLine.LF&&m!==y.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this._setEndOfLine=m}}e.TextEditorEdit=D;class i{constructor(m,f,a,d){this._proxy=m,this._id=f,this._accept(a),this._logService=d;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(w){E._setTabSize(w)},get insertSpaces(){return E._insertSpaces},set insertSpaces(w){E._setInsertSpaces(w)},get cursorStyle(){return E._cursorStyle},set cursorStyle(w){E._setCursorStyle(w)},get lineNumbers(){return E._lineNumbers},set lineNumbers(w){E._setLineNumbers(w)}}}_accept(m){this._tabSize=m.tabSize,this._insertSpaces=m.insertSpaces,this._cursorStyle=m.cursorStyle,this._lineNumbers=I.TextEditorLineNumbersStyle.to(m.lineNumbers)}_validateTabSize(m){if(m==="auto")return"auto";if(typeof m=="number"){const f=Math.floor(m);return f>0?f:null}if(typeof m=="string"){const f=parseInt(m,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(m){const f=this._validateTabSize(m);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}_setInsertSpaces(m){const f=this._validateInsertSpaces(m);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(m){this._cursorStyle!==m&&(this._cursorStyle=m,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:m})))}_setLineNumbers(m){this._lineNumbers!==m&&(this._lineNumbers=m,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:I.TextEditorLineNumbersStyle.from(m)})))}assign(m){const f={};let a=!1;if(typeof m.tabSize!="undefined"){const d=this._validateTabSize(m.tabSize);d==="auto"?(a=!0,f.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,a=!0,f.tabSize=d)}if(typeof m.insertSpaces!="undefined"){const d=this._validateInsertSpaces(m.insertSpaces);d==="auto"?(a=!0,f.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,a=!0,f.insertSpaces=d)}typeof m.cursorStyle!="undefined"&&this._cursorStyle!==m.cursorStyle&&(this._cursorStyle=m.cursorStyle,a=!0,f.cursorStyle=m.cursorStyle),typeof m.lineNumbers!="undefined"&&this._lineNumbers!==m.lineNumbers&&(this._lineNumbers=m.lineNumbers,a=!0,f.lineNumbers=I.TextEditorLineNumbersStyle.from(m.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(m){m.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=i;class T{constructor(m,f,a,d,E,w,b,p){this.id=m,this._proxy=f,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new i(this._proxy,this.id,w,a),this._visibleRanges=b,this._viewColumn=p;const c=this;this.value=Object.freeze({get document(){return d.getValue()},set document(g){throw(0,k.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(g){if(!(g instanceof y.Selection))throw(0,k.illegalArgument)("selection");c._selections=[g],c._trySetSelection()},get selections(){return c._selections},set selections(g){if(!Array.isArray(g)||g.some(t=>!(t instanceof y.Selection)))throw(0,k.illegalArgument)("selections");c._selections=g,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(g){throw(0,k.readonly)("visibleRanges")},get options(){return c._options.value},set options(g){c._disposed||c._options.assign(g)},get viewColumn(){return c._viewColumn},set viewColumn(g){throw(0,k.readonly)("viewColumn")},edit(g,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new D(d.getValue(),t);return g(n),c._applyEdit(n)},insertSnippet(g,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=c._selections.map(r=>I.Range.from(r));else if(t instanceof y.Position){const{lineNumber:r,column:o}=I.Position.from(t);s=[{startLineNumber:r,startColumn:o,endLineNumber:r,endColumn:o}]}else if(t instanceof y.Range)s=[I.Range.from(t)];else{s=[];for(const r of t)if(r instanceof y.Range)s.push(I.Range.from(r));else{const{lineNumber:o,column:l}=I.Position.from(r);s.push({startLineNumber:o,startColumn:l,endLineNumber:o,endColumn:l})}}return f.$tryInsertSnippet(m,g.value,s,n)},setDecorations(g,t){const n=t.length===0;n&&!c._hasDecorationsForKey.has(g.key)||(n?c._hasDecorationsForKey.delete(g.key):c._hasDecorationsForKey.add(g.key),c._runOnProxy(()=>{if(I.isDecorationOptionsArr(t))return f.$trySetDecorations(m,g.key,I.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let r=0,o=t.length;r<o;r++){const l=t[r];s[4*r]=l.start.line+1,s[4*r+1]=l.start.character+1,s[4*r+2]=l.end.line+1,s[4*r+3]=l.end.character+1}return f.$trySetDecorationsFast(m,g.key,s)}}))},revealRange(g,t){c._runOnProxy(()=>f.$tryRevealRange(m,I.Range.from(g),t||y.TextEditorRevealType.Default))},show(g){f.$tryShowEditor(m,I.ViewColumn.from(g))},hide(){f.$tryHideEditor(m)}})}dispose(){(0,_.ok)(!this._disposed),this._disposed=!0}_acceptOptions(m){(0,_.ok)(!this._disposed),this._options._accept(m)}_acceptVisibleRanges(m){(0,_.ok)(!this._disposed),this._visibleRanges=m}_acceptViewColumn(m){(0,_.ok)(!this._disposed),this._viewColumn=m}_acceptSelections(m){(0,_.ok)(!this._disposed),this._selections=m}async _trySetSelection(){const m=this._selections.map(I.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,m)),this.value}_applyEdit(m){const f=m.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const a=f.edits.map(E=>E.range);a.sort((E,w)=>E.end.line===w.end.line?E.end.character===w.end.character?E.start.line===w.start.line?E.start.character-w.start.character:E.start.line-w.start.line:E.end.character-w.end.character:E.end.line-w.end.line);for(let E=0,w=a.length-1;E<w;E++){const b=a[E].end;if(a[E+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=f.edits.map(E=>({range:I.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,d,{setEndOfLine:typeof f.setEndOfLine=="number"?I.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(m){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=T}),define(me[221],ge([0,1,166,25,2,3,6,19,7,12,15,20,21]),function(G,e,_,k,A,I,y,P,D,i,T,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(E,w){if((0,i.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let b;return Array.isArray(E.highlights)&&(b=E.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),b=b.length?b:void 0),{label:E.label,highlights:b}}}class a{constructor(w,b,p){this._proxy=w,this.commands=b,this.logService=p,this.treeViews=new Map;function c(g){return g&&g.$treeViewId&&g.$treeItemHandle}b.registerArgumentProcessor({processArgument:g=>c(g)?this.convertArgument(g):Array.isArray(g)&&g.length>0?g.map(t=>c(t)?this.convertArgument(t):t):g})}registerTreeDataProvider(w,b,p){const c=this.createTreeView(w,{treeDataProvider:b},p);return{dispose:()=>c.dispose()}}createTreeView(w,b,p){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany}),g=this.createExtHostTreeView(w,b,p);return{get onDidCollapseElement(){return g.onDidCollapseElement},get onDidExpandElement(){return g.onDidExpandElement},get selection(){return g.selectedElements},get onDidChangeSelection(){return g.onDidChangeSelection},get visible(){return g.visible},get onDidChangeVisibility(){return g.onDidChangeVisibility},get message(){return g.message},set message(t){g.message=t},get title(){return g.title},set title(t){g.title=t},get description(){return g.description},set description(t){g.description=t},reveal:(t,n)=>g.reveal(t,n),dispose:async()=>{await c,this.treeViews.delete(w),g.dispose()}}}$getChildren(w,b){const p=this.treeViews.get(w);return p?p.getChildren(b):Promise.reject(new Error((0,_.localize)(0,null,w)))}async $hasResolve(w){const b=this.treeViews.get(w);if(!b)throw new Error((0,_.localize)(1,null,w));return b.hasResolve}$resolve(w,b,p){const c=this.treeViews.get(w);if(!c)throw new Error((0,_.localize)(2,null,w));return c.resolveTreeItem(b,p)}$setExpanded(w,b,p){const c=this.treeViews.get(w);if(!c)throw new Error((0,_.localize)(3,null,w));c.setExpanded(b,p)}$setSelection(w,b){const p=this.treeViews.get(w);if(!p)throw new Error((0,_.localize)(4,null,w));p.setSelection(b)}$setVisible(w,b){const p=this.treeViews.get(w);if(!p)throw new Error((0,_.localize)(5,null,w));p.setVisible(b)}createExtHostTreeView(w,b,p){const c=new d(w,b,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(w,c),c}convertArgument(w){const b=this.treeViews.get(w.$treeViewId);return b?b.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=a;class d extends y.Disposable{constructor(w,b,p,c,g,t){super();if(this.viewId=w,this.proxy=p,this.commands=c,this.logService=g,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new I.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new I.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new I.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new I.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new I.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const o of t.contributes.views[r])o.id===w&&(this._title=o.name);this.dataProvider=b.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,s;this._register(I.Event.debounce(this._onDidChangeData.event,(r,o)=>(r||(r={message:!1,elements:[]}),o.element!==!1&&(n||(n=new Promise(l=>s=l),this.refreshPromise=this.refreshPromise.then(()=>n)),r.elements.push(o.element)),o.message&&(r.message=!0),r),200,!0)(({message:r,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const l=s;return n=null,this.refresh(o).then(()=>l())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,i.isUndefinedOrNull)(w))}getChildren(w){const b=w?this.getExtensionElement(w):void 0;if(w&&!b)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const p=this.getChildrenNodes(w);return(p?Promise.resolve(p):this.fetchChildrenNodes(b)).then(c=>c.map(g=>g.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,b){b=b||{select:!0,focus:!1};const p=(0,i.isUndefinedOrNull)(b.select)?!0:b.select,c=(0,i.isUndefinedOrNull)(b.focus)?!1:b.focus,g=(0,i.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(s=>s.item)},{select:p,focus:c,expand:g})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:c,expand:g})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,b){const p=this.getExtensionElement(w);p&&(b?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(w){(0,T.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,b){var p;if(!!this.dataProvider.resolveTreeItem){const c=this.elements.get(w);if(c){const g=this.nodes.get(c);if(g){const t=(p=await this.dataProvider.resolveTreeItem(g.extensionItem,c,b))!==null&&p!==void 0?p:g.extensionItem;return g.item.tooltip=this.getTooltip(t.tooltip),g.item.command=this.getCommand(g.disposableStore,t.command),g.item}}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(b=>b?this.resolveUnknownParentChain(b).then(p=>this.resolveTreeNode(b,p[p.length-1]).then(c=>(p.push(c),p))):Promise.resolve([]))}resolveParent(w){const b=this.nodes.get(w);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,b){const p=this.nodes.get(w);return p?Promise.resolve(p):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(c=>this.createHandle(w,c,b,!0)).then(c=>this.getChildren(b?b.item.handle:void 0).then(()=>{const g=this.getExtensionElement(c);if(g){const t=this.nodes.get(g);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(w){if(w){let b;if(typeof w=="string"){const p=this.getExtensionElement(w);b=p?this.nodes.get(p):void 0}else b=w;return b&&b.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const b=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=w?this.nodes.get(w):void 0,c=await this.dataProvider.getChildren(w);if(b.token.isCancellationRequested)return[];const g=await Promise.all((0,T.coalesce)(c||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,p):null}));return b.token.isCancellationRequested?[]:(0,T.coalesce)(g)}finally{b.dispose()}}refresh(w){if(w.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(w);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const b=new Set,p=w.map(g=>this.nodes.get(g));for(const g of p)if(g&&!b.has(g.item.handle)){let t=g;for(;t&&t.parent&&p.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&b.add(g.item.handle)}const c=[];return b.forEach(g=>{const t=this.elements.get(g);if(t){const n=this.nodes.get(t);n&&(!n.parent||!b.has(n.parent.item.handle))&&c.push(g)}}),c}refreshHandles(w){const b={};return Promise.all(w.map(p=>this.refreshNode(p).then(c=>{c&&(b[p]=c.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(w){const b=this.getExtensionElement(w);if(b){const p=this.nodes.get(b);if(p)return this.clearChildren(b),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(c=>{if(c){const g=this.createTreeNode(b,c,p.parent);return this.updateNodeCache(b,g,p,p.parent),p.dispose(),g}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,b,p){const c=this.createTreeNode(w,b,p);if(b.id&&this.elements.has(c.item.handle))throw new Error((0,_.localize)(6,null,b.id));return this.addNodeToCache(w,c),this.addNodeToParentCache(c,p),c}getTooltip(w){return D.MarkdownString.isMarkdownString(w)?C.MarkdownString.from(w):w}getCommand(w,b){return b?this.commands.toInternal(b,w):void 0}createTreeNode(w,b,p){const c=new y.DisposableStore,g=this.createHandle(w,b,p),t=this.getLightIconPath(b);return{item:{handle:g,parentHandle:p?p.item.handle:void 0,label:f(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(c,b.command),contextValue:b.contextValue,icon:t,iconDark:this.getDarkIconPath(b)||t,themeIcon:this.getThemeIcon(b),collapsibleState:(0,i.isUndefinedOrNull)(b.collapsibleState)?D.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation},extensionItem:b,parent:p,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(w){return w.iconPath instanceof D.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:b,label:p,resourceUri:c},g,t){if(b)return`${d.ID_HANDLE_PREFIX}/${b}`;const n=f(p,this.extension),s=g?g.item.handle:d.LABEL_HANDLE_PREFIX;let r=n?n.label:c?(0,k.basename)(c):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const o=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,l=this.getChildrenNodes(g)||[];let h,S=0;do{if(h=`${s}/${S}:${r}`,t||!this.elements.has(h)||o===h)break;S++}while(S<=l.length);return h}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon))return typeof w.iconPath=="string"||A.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return A.URI.isUri(w)?w:A.URI.file(w)}addNodeToCache(w,b){this.elements.set(b.item.handle,w),this.nodes.set(w,b)}updateNodeCache(w,b,p,c){this.elements.delete(b.item.handle),this.nodes.delete(w),b.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(w,b);const g=this.getChildrenNodes(c)||[],t=g.filter(n=>n.item.handle===p.item.handle)[0];t&&g.splice(g.indexOf(t),1,b)}addNodeToParentCache(w,b){b?(b.children||(b.children=[]),b.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const b=this.nodes.get(w);if(b){if(b.children)for(const p of b.children){const c=this.elements.get(p.item.handle);c&&this.clear(c)}b.children=void 0}}else this.clearAll()}clear(w){const b=this.nodes.get(w);if(b){if(b.children)for(const p of b.children){const c=this.elements.get(p.item.handle);c&&this.clear(c)}this.nodes.delete(w),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}d.LABEL_HANDLE_PREFIX="0",d.ID_HANDLE_PREFIX="1"}),define(me[222],ge([0,1,15,19,21,12,87,20,7,122]),function(G,e,_,k,A,I,y,P,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class T{constructor(){this.testIdsToInternal=new Map}getTestById(E,w){if(w!==void 0){const b=this.testIdsToInternal.get(w),p=b==null?void 0:b.get(E);if(p)return[b,p]}return(0,_.mapFind)(this.testIdsToInternal.values(),b=>{const p=b.get(E);return p&&[b,p]})}createForHierarchy(E=()=>{}){return new a(this.createIdMap(m++),E)}createIdMap(E){const w=new f(E);return this.testIdsToInternal.set(w.id,w),{object:w,dispose:()=>this.testIdsToInternal.delete(w.id)}}}e.OwnedTestCollection=T;var C;(function(d){d[d.Disconnected=0]="Disconnected",d[d.IsChild=1]="IsChild",d[d.IsParent=2]="IsParent",d[d.IsSame=3]="IsSame"})(C=e.TestPosition||(e.TestPosition={}));let m=0;class f{constructor(E){this.id=E,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(E){if(this.map.has(E.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${E.item.extId}`);this.map.set(E.item.extId,E),E.parent||this._roots.add(E)}has(E){return this.map.has(E)}delete(E){const w=this.map.get(E);return w?(this.map.delete(E),this._roots.delete(w),!0):!1}get(E){return this.map.get(E)}comparePositions(E,w){const b=typeof E=="string"?this.map.get(E):E,p=typeof w=="string"?this.map.get(w):w;if(!b||!p)return 0;if(b===p)return 3;for(let c=this.map.get(p.parent);c;c=this.map.get(c.parent))if(c===b)return 1;for(let c=this.map.get(b.parent);c;c=this.map.get(c.parent))if(c===p)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=f;class a{constructor(E,w){this.testIdToInternal=E,this.publishDiff=w,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new k.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(E,w){this.addItem(E,w,null)}getTestByReference(E){return this.testItemToInternal.get(E)}collectDiff(){const E=this.diff;return this.diff=[],E}pushDiff(E){const w=this.diff[this.diff.length-1];if(w&&E[0]===1){if(w[0]===1&&w[1].extId===E[1].extId){(0,i.applyTestItemUpdate)(w[1],E[1]);return}if(w[0]===0&&w[1].item.extId===E[1].extId){(0,i.applyTestItemUpdate)(w[1],E[1]);return}}this.diff.push(E),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(E,w){var b;const p=this.testIdToInternal.object.get(E);if(!!p){if((p.expandLevels===void 0||w>p.expandLevels)&&(p.expandLevels=w),p.expand===1){const c=this.refreshChildren(p);return c.isSettled?this.expandChildren(p,w-1):c.p.then(()=>this.expandChildren(p,w-1))}else if(p.expand===3)return((b=p.initialExpand)===null||b===void 0?void 0:b.isSettled)===!1?p.initialExpand.p.then(()=>this.expandChildren(p,w-1)):this.expandChildren(p,w-1)}}dispose(){var E;for(const w of this.testItemToInternal.values())(E=w.discoverCts)===null||E===void 0||E.dispose(!0),(0,y.getPrivateApiFor)(w.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(E,w){const b=E==null?void 0:E.actual.id;switch(w[0]){case 2:this.pushDiff([4,b]);break;case 1:this.removeItem(E);break;case 0:this.addItem(w[1],E.src.controller,E);break;case 3:const[p,c,g]=w;switch(c){case"status":this.updateExpandability(E);break;case"range":this.pushDiff([1,{extId:b,item:{range:P.Range.from(g)}}]);break;default:this.pushDiff([1,{extId:b,item:{[c]:g}}]);break}break;default:(0,I.assertNever)(w[0])}}addItem(E,w,b){if(!(E instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${E.id} did not`);if(this.testItemToInternal.has(E))throw new Error(`Attempted to add a single TestItem ${E.id} multiple times to the tree`);if(this.testIdToInternal.object.has(E.id))throw new Error(`Attempted to insert a duplicate test item ID ${E.id}`);const p=b?b.item.extId:null,c=E.resolveHandler?1:0,g=b==null?void 0:b.expandLevels,t={controller:w,tree:this.testIdToInternal.object.id},n={actual:E,parent:p,item:P.TestItem.from(E),expandLevels:g?g-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(E,n),this.pushDiff([0,{parent:p,src:t,expand:c,item:n.item}]);const s=(0,y.getPrivateApiFor)(E);s.parent=b==null?void 0:b.actual,s.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const r of s.children.values())this.testItemToInternal.has(r)||this.addItem(r,w,n)}updateExpandability(E){var w;let b;E.actual.resolveHandler?E.actual.status===D.TestItemStatus.Pending?b=E.discoverCts?2:1:((w=E.initialExpand)===null||w===void 0||w.complete(),b=3):b=0,b!==E.expand&&(E.expand=b,this.pushDiff([1,{extId:E.actual.id,expand:b}]),b===1&&E.expandLevels!==void 0&&this.refreshChildren(E))}expandChildren(E,w){if(!(w<0)){const b=[...E.actual.children.values()].map(p=>this.expand(p.id,w)).filter(k.isThenable);if(b.length)return Promise.all(b).then(()=>{})}}refreshChildren(E){if(E.discoverCts&&E.discoverCts.dispose(!0),!E.actual.resolveHandler){const w=new k.DeferredPromise;return w.complete(),w}return E.expand=2,E.discoverCts=new A.CancellationTokenSource,this.pushExpandStateUpdate(E),E.initialExpand=new k.DeferredPromise,E.actual.resolveHandler(E.discoverCts.token),E.initialExpand}pushExpandStateUpdate(E){this.pushDiff([1,{extId:E.actual.id,expand:E.expand}])}removeItem(E){var w;this.pushDiff([2,E.actual.id]);const b=[E];for(;b.length;){const p=b.pop();if(!!p){(w=p.discoverCts)===null||w===void 0||w.dispose(!0),this.testIdToInternal.object.delete(p.item.extId),this.testItemToInternal.delete(p.actual);for(const c of p.actual.children.values())b.push(this.testIdToInternal.object.get(c.id))}}}flushDiff(){const E=this.collectDiff();E.length&&this.publishDiff(E)}}e.SingleUseTestCollection=a}),define(me[223],ge([0,1,29,3,8]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class I{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=I;class y{constructor(T){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=T,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const T of this._extensionDescriptions){if(this._extensionsMap.has(_.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(_.ExtensionIdentifier.toKey(T.identifier),T),this._extensionsArr.push(T),Array.isArray(T.activationEvents))for(let C of T.activationEvents)C==="onUri"&&(C=`onUri:${_.ExtensionIdentifier.toKey(T.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(T)}}keepOnly(T){const C=new Set;T.forEach(m=>C.add(_.ExtensionIdentifier.toKey(m))),this._extensionDescriptions=this._extensionDescriptions.filter(m=>C.has(_.ExtensionIdentifier.toKey(m.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(T,C){T.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(T));const m=y._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(m.map(f=>f.identifier)),C.length>0){const f=new Set;C.forEach(a=>f.add(_.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!f.has(_.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new I(m)}static _findLoopingExtensions(T){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,w){this.addNode(E),this.addNode(w),this._arcs.has(E)?this._arcs.get(E).push(w):this._arcs.set(E,[w])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,w){const b=C.getArcs(E);for(let p=0;p<b.length;p++)if(!w.has(b[p]))return!1;return!0}getNodes(){return this._nodesArr}};let m=new Map;for(let E of T){const w=_.ExtensionIdentifier.toKey(E.identifier);if(m.set(w,E),E.extensionDependencies)for(let b of E.extensionDependencies){const p=_.ExtensionIdentifier.toKey(b);C.addArc(w,p)}}let f=new Set;C.getNodes().filter(E=>C.getArcs(E).length===0).forEach(E=>f.add(E));let a=C.getNodes().filter(E=>!f.has(E)),d;do{d=!1;for(let E=0;E<a.length;E++){const w=a[E];C.hasOnlyGoodArcs(w,f)&&(a.splice(E,1),E--,f.add(w),d=!0)}}while(d);return a.map(E=>m.get(E))}containsActivationEvent(T){return this._activationMap.has(T)}containsExtension(T){return this._extensionsMap.has(_.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const C=this._activationMap.get(T);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(T){const C=this._extensionsMap.get(_.ExtensionIdentifier.toKey(T));return C||void 0}}e.ExtensionDescriptionRegistry=y;var P;(function(i){i[i.Builtin=0]="Builtin",i[i.User=1]="User",i[i.Dev=2]="Dev"})(P||(P={}));function D(i,T){const C=i.isBuiltin?0:i.isUnderDevelopment?2:1,m=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(C!==m)return C-m;const f=A.posix.basename(i.extensionLocation.path),a=A.posix.basename(T.extensionLocation.path);return f<a?-1:f>a?1:0}}),define(me[224],ge([0,1,22]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var k;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function I(P){const D=_.VSBuffer.alloc(1);switch(P){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=I;function y(P,D){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=y}),define(me[41],ge([0,1,3,2,4,29,184]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new I.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class P{constructor(b){this.dependency=b}}e.MissingDependencyError=P;var D;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class i{constructor(b,p,c,g){this.codeLoadingTime=b,this.activateCallTime=p,this.activateResolvedTime=c,this.activationReason=g}}e.ActivationTimes=i;class T{constructor(b,p){this.description=b,this.value=p}}e.ExtensionPointContribution=T,e.ExtensionHostLogFileName="exthost";var C;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function m(w){w.enableProposedApi||f(w)}e.checkProposedApiEnabled=m;function f(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=f;function a(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=a;function d(w){return Object.assign(Object.assign({identifier:new I.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!1,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=d;class E{constructor(){this.onDidRegisterExtensions=_.Event.None,this.onDidChangeExtensionsStatus=_.Event.None,this.onDidChangeExtensions=_.Event.None,this.onWillActivateByEvent=_.Event.None,this.onDidChangeResponsiveChange=_.Event.None}activateByEvent(b){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(b){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(b,p){}_activateById(b,p){return Promise.resolve()}_onWillActivateExtension(b){}_onDidActivateExtension(b,p,c,g,t){}_onExtensionRuntimeError(b,p){}_onExtensionHostExit(b){}}e.NullExtensionService=E}),define(me[225],ge([0,1,161,29,41,13]),function(G,e,_,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class P{constructor(d,E,w,b){this.startup=d,this.codeLoadingTime=E,this.activateCallTime=w,this.activateResolvedTime=b}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class D{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,E){return d===-1||E===-1?-1:E-d}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class i{constructor(d,E,w,b,p,c){this.activationFailed=d,this.activationFailedError=E,this.activationTimes=w,this.module=b,this.exports=p,this.subscriptions=c}}e.ActivatedExtension=i;class T extends i{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class C extends i{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class m extends i{constructor(d){super(!0,d,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=m;let f=class{constructor(d,E,w,b,p){this._logService=p,this._registry=d,this._resolvedExtensionsSet=new Set,E.forEach(c=>this._resolvedExtensionsSet.add(k.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,w.forEach(c=>this._hostExtensionsMap.set(k.ExtensionIdentifier.toKey(c),c)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(d){const E=k.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(E)}getActivatedExtension(d){const E=k.ExtensionIdentifier.toKey(d),w=this._activatedExtensions.get(E);if(!w)throw new Error("Extension `"+d.value+"` is not known or not activated");return w}activateByEvent(d,E){if(this._alreadyActivatedEvents[d])return y;const w=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(w.map(b=>({id:b.identifier,reason:{startup:E,extensionId:b.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,E){const w=this._registry.getExtensionDescription(d);if(!w)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:w.identifier,reason:E}])}_handleActivateRequest(d,E,w){if(this._hostExtensionsMap.has(k.ExtensionIdentifier.toKey(d.id))){E[k.ExtensionIdentifier.toKey(d.id)]=d;return}const b=this._registry.getExtensionDescription(d.id);if(!b){this._host.onExtensionActivationError(d.id,new A.MissingDependencyError(d.id.value));const g=new Error(`Unknown dependency '${d.id.value}'`);this._activatedExtensions.set(k.ExtensionIdentifier.toKey(d.id),new m(g));return}const p=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let c=!0;for(let g=0,t=p.length;g<t;g++){const n=p[g];if(!this._resolvedExtensionsSet.has(k.ExtensionIdentifier.toKey(n))){const s=this._activatedExtensions.get(k.ExtensionIdentifier.toKey(n));if(!(s&&!s.activationFailed)){if(s&&s.activationFailed){this._host.onExtensionActivationError(b.identifier,_.localize(0,null,b.displayName||b.identifier.value,n));const l=new Error(`Dependency ${n} failed to activate`);l.detail=s.activationFailedError,this._activatedExtensions.set(k.ExtensionIdentifier.toKey(b.identifier),new m(l));return}if(this._hostExtensionsMap.has(k.ExtensionIdentifier.toKey(n))){c=!1,E[k.ExtensionIdentifier.toKey(n)]={id:this._hostExtensionsMap.get(k.ExtensionIdentifier.toKey(n)),reason:d.reason};continue}const r=this._registry.getExtensionDescription(n);if(r){c=!1,E[k.ExtensionIdentifier.toKey(n)]={id:r.identifier,reason:d.reason};continue}this._host.onExtensionActivationError(b.identifier,new A.MissingDependencyError(n));const o=new Error(`Unknown dependency '${n}'`);this._activatedExtensions.set(k.ExtensionIdentifier.toKey(b.identifier),new m(o));return}}}c?E[k.ExtensionIdentifier.toKey(b.identifier)]=d:w.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(p=>!this._activatedExtensions.has(k.ExtensionIdentifier.toKey(p.id))),d.length===0))return Promise.resolve(void 0);const E=Object.create(null),w=[];for(let p=0,c=d.length;p<c;p++)this._handleActivateRequest(d[p],E,w);for(let p=0,c=w.length;p<c;p++){const g=k.ExtensionIdentifier.toKey(w[p].id);E[g]&&delete E[g]}const b=Object.keys(E).map(p=>E[p]);return w.length===0?Promise.all(b.map(p=>this._activateExtension(p.id,p.reason))).then(p=>{}):this._activateExtensions(b).then(p=>this._activateExtensions(w))}_activateExtension(d,E){const w=k.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(w))return Promise.resolve(void 0);const b=this._activatingExtensions.get(w);if(b)return b;const p=this._host.actualActivateExtension(d,E).then(void 0,c=>(this._host.onExtensionActivationError(d,_.localize(1,null,d.value,c.message)),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(c),new m(c))).then(c=>{this._activatedExtensions.set(w,c),this._activatingExtensions.delete(w)});return this._activatingExtensions.set(w,p),p}};f=je([Be(4,I.ILogService)],f),e.ExtensionsActivator=f}),define(me[226],ge([0,1,13,41,27,11,112]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends _.LogService{constructor(i){if(i.logFile.scheme!==I.Schemas.file)throw new Error("Only file-logging supported");super(new y.SpdLogLogger(k.ExtensionHostLogFileName,i.logFile.fsPath,!0,i.logLevel))}$setLevel(i){this.setLevel(i)}};P=je([Be(0,A.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(me[227],ge([0,1,18]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class k{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((I,y)=>{this._actualOk=I,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(I){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=I,this._actual&&this._actualOk(I))}resolveErr(I){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=I,this._actual?this._actualErr(I):(0,_.onUnexpectedError)(I))}then(I,y){return this._ensureActual().then(I,y)}catch(I){return this._ensureActual().then(void 0,I)}finally(I){return this._ensureActual().finally(I)}}e.LazyPromise=k}),define(me[124],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class _{constructor(D,i){this.isMain=D,this.sid=i,this.nid=++_.count}}e.ProxyIdentifier=_,_.count=0;const k=[];function A(P){const D=new _(!0,P);return k[D.nid]=D,D}e.createMainContextProxyIdentifier=A;function I(P){const D=new _(!1,P);return k[D.nid]=D,D}e.createExtHostContextProxyIdentifier=I;function y(P){return k[P].sid}e.getStringIdentifierForProxy=y}),define(me[5],ge([0,1,2,124,58]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var I;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(I=e.UIKind||(e.UIKind={}));var y;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var i;(function(c){c[c.Markdown=1]="Markdown",c[c.Code=2]="Code"})(i=e.CellKind||(e.CellKind={}));var T;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var m;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(m=e.CandidatePortSource||(e.CandidatePortSource={}));var f;(function(c){c.name="$ident";function g(n,s){return Object.defineProperty(n,c.name,{value:s,enumerable:!0}),n}c.mixin=g;function t(n){return n[c.name]}c.of=t})(f=e.ObjectIdentifier||(e.ObjectIdentifier={}));class a{static mixin(g){return g._id=a._n++,g}}e.IdObject=a,a._n=0;var d;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n",c.label2="o"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function b(c){if(c&&c.edits)for(const g of c.edits)typeof g.resource=="object"?g.resource=_.URI.revive(g.resource):(g.newUri=_.URI.revive(g.newUri),g.oldUri=_.URI.revive(g.oldUri)),g.metadata&&g.metadata.iconPath&&(g.metadata=(0,A.revive)(g.metadata));return c}e.reviveWorkspaceEditDto=b;var p;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,k.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[89],ge([0,1,5,3,4]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class I{constructor(P){this._onDidChangePassword=new k.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(_.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,D){return this._proxy.$getPassword(P,D)}store(P,D,i){return this._proxy.$setPassword(P,D,i)}delete(P,D){return this._proxy.$deletePassword(P,D)}}e.ExtHostSecretState=I,e.IExtHostSecretState=(0,A.createDecorator)("IExtHostSecretState")}),define(me[64],ge([0,1,4,13,5,14]),function(G,e,_,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,_.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(D,i){this._extHostLogService=i,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(A.MainContext.MainThreadTelemetry)}report(D,i,T){const C=this.getUsageKey(D,i);this._reportedUsages.has(C)||(this._reportedUsages.add(C),i.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:i.identifier.value,apiId:D}))}getUsageKey(D,i){return`${D}-${i.identifier.value}`}};y=je([Be(0,I.IExtHostRpcService),Be(1,k.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(P,D,i){}})}),define(me[228],ge([0,1,3,5,7,29]),function(G,e,_,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new _.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new _.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,i,T,C={}){const m=I.ExtensionIdentifier.toKey(D.identifier),f=this._inFlightRequests.get(m)||[],a=T.sort().join(" ");let d=f.find(E=>E.scopes===a);if(d)return d.result;{const E=this._getSession(D,m,i,T,C);d={scopes:a,result:E},f.push(d),this._inFlightRequests.set(m,f);try{await E}finally{const w=f.findIndex(b=>b.scopes===a);w>-1&&(f.splice(w),this._inFlightRequests.set(m,f))}return E}}async _getSession(D,i,T,C,m={}){await this._proxy.$ensureProvider(T);const f=D.displayName||D.name;return this._proxy.$getSession(T,C,i,f,m)}async removeSession(D,i){const T=this._authenticationProviders.get(D);return T?T.provider.removeSession(i):this._proxy.$removeSession(D,i)}registerAuthenticationProvider(D,i,T,C){var m;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:i,provider:T,options:C!=null?C:{supportsMultipleAccounts:!1}}),this._providers.find(a=>a.id===D)||this._providers.push({id:D,label:i});const f=T.onDidChangeSessions(a=>{var d,E,w;this._proxy.$sendDidChangeSessions(D,{added:(d=a.added)!==null&&d!==void 0?d:[],changed:(E=a.changed)!==null&&E!==void 0?E:[],removed:(w=a.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(D,i,(m=C==null?void 0:C.supportsMultipleAccounts)!==null&&m!==void 0?m:!1),new A.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(D);const a=this._providers.findIndex(d=>d.id===D);a>-1&&this._providers.splice(a),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,i){const T=this._authenticationProviders.get(D);if(T)return Promise.resolve(T.provider.createSession(i));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,i){const T=this._authenticationProviders.get(D);if(T)return Promise.resolve(T.provider.removeSession(i));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,i){const T=this._authenticationProviders.get(D);if(T)return Promise.resolve(T.provider.getSessions(i));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,i){return this._onDidChangeSessions.fire({provider:{id:D,label:i}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,i){return D.forEach(T=>{this._providers.some(C=>C.id===T.id)||this._providers.push(T)}),i.forEach(T=>{const C=this._providers.findIndex(m=>m.id===T.id);C>-1&&this._providers.splice(C)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:i}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(me[229],ge([0,1,5,14,20]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let I=class{constructor(P,D){this._extHostDocumentsAndEditors=D,this._proxy=P.getProxy(_.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const D=A.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};I=je([Be(0,k.IExtHostRpcService)],I),e.ExtHostBulkEdits=I}),define(me[230],ge([0,1,5]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(I){const y=I.getProxy(_.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(P){return y.$writeText(P)}})}}e.ExtHostClipboard=k}),define(me[51],ge([0,1,12,7,20,23,5,15,13,58,44,49,2,6,4,14]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new w(this,s=>{const r=this._apiCommands.get(s);return(r==null?void 0:r.result)===p.Void?r:void 0},n),this._argumentProcessors=[{processArgument(s){return(0,i.revive)(s)}},{processArgument(s){return(0,I.cloneAndChange)(s,function(r){if(T.Range.isIRange(r))return A.Range.to(r);if(C.Position.isIPosition(r))return A.Position.to(r);if(T.Range.isIRange(r.range)&&m.URI.isUri(r.uri))return A.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...s)=>{const r=t.args.map((l,h)=>{if(!l.validate(s[h]))throw new Error(`Invalid argument '${l.name}' when running '${t.id}', received: ${s[h]}`);return l.convert(s[h])}),o=await this.executeCommand(t.internalId,...r);return t.result.convert(o,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new k.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,s,r,o){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:s,thisArg:r,description:o}),t&&this._proxy.$registerCommand(n),new k.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,s){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const r=(0,I.cloneAndChange)(n,function(o){if(o instanceof k.Position)return A.Position.from(o);if(o instanceof k.Range)return A.Range.from(o);if(o instanceof k.Location)return A.location.from(o);if(!Array.isArray(o))return o});try{const o=await this._proxy.$executeCommand(t,r,s);return(0,i.revive)(o)}catch(o){if(o instanceof Error&&o.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw o}}}async _executeContributedCommand(t,n){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:r,thisArg:o,description:l}=s;if(l)for(let h=0;h<l.args.length;h++)try{(0,_.validateConstraint)(n[h],l.args[h].constraint)}catch(S){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${l.args[h].name}' - ${l.args[h].description}`)}try{return await r.apply(o,n)}catch(h){if(t===this.converter.delegatingCommandId){const S=this.converter.getActualCommand(...n);S&&(t=S.command)}throw this._logService.error(h,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(s=>this._argumentProcessors.reduce((r,o)=>o.processArgument(r),s)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(s=>s[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,s]of this._commands){let{description:r}=s;r&&(t[n]=r)}return Promise.resolve(t)}};E=je([Be(0,d.IExtHostRpcService),Be(1,D.ILogService)],E),e.ExtHostCommands=E,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class w{constructor(t,n,s){this._commands=t,this._lookupApiCommand=n,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const r=this._lookupApiCommand(t.command);if(r)s.id=r.internalId,s.arguments=r.args.map((o,l)=>o.convert(t.arguments&&t.arguments[l]));else if((0,P.isNonEmptyArray)(t.arguments)){const o=++this._cachIdPool;this._cache.set(o,t),n.add((0,f.toDisposable)(()=>{this._cache.delete(o),this._logService.trace("CommandsConverter#DISPOSE",o)})),s.$ident=o,s.id=this.delegatingCommandId,s.arguments=[o],this._logService.trace("CommandsConverter#CREATE",t.command,o)}return s}}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class b{constructor(t,n,s,r){this.name=t,this.description=n,this.validate=s,this.convert=r}optional(){return new b(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new b(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",g=>m.URI.isUri(g),g=>g),b.Position=new b("position","A position in a text document",g=>k.Position.isPosition(g),A.Position.from),b.Range=new b("range","A range in a text document",g=>k.Range.isRange(g),A.Range.from),b.Selection=new b("selection","A selection in a text document",g=>k.Selection.isSelection(g),A.Selection.from),b.Number=new b("number","",g=>typeof g=="number",g=>g),b.String=new b("string","",g=>typeof g=="string",g=>g),b.CallHierarchyItem=new b("item","A call hierarchy item",g=>g instanceof k.CallHierarchyItem,A.CallHierarchyItem.to);class p{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=p,p.Void=new p("no result",g=>g);class c{constructor(t,n,s,r,o){this.id=t,this.internalId=n,this.description=s,this.args=r,this.result=o}}e.ApiCommand=c}),define(me[231],ge([0,1,6,20,7,80,51,203,15,109]),function(G,e,_,k,A,I,y,P,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",m(k.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(a,d)=>{if(!(0,D.isFalsyOrEmpty)(a)){class E extends A.SymbolInformation{static to(b){const p=new E(b.name,k.SymbolKind.to(b.kind),b.containerName||"",new A.Location(d[0],k.Range.to(b.range)));return p.detail=b.detail,p.range=p.location.range,p.selectionRange=k.Range.to(b.selectionRange),p.children=b.children?b.children.map(E.to):[],p}}return a.map(E.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",m(k.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",m(k.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",m(k.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",m(k.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",m(k.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(d=>A.Position.isPosition(d)),a=>a.map(k.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(d=>{let E;for(const w of d.reverse())E=new A.SelectionRange(k.Range.to(w),E);return E}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const d=[];if(Array.isArray(a))for(let E of a)d.push(...E[1].map(k.WorkspaceSymbol.to));return d})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(k.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(k.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(k.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return k.WorkspaceEdit.to(a)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(k.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new A.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const d=(0,i.decodeSemanticTokensDto)(a);if(d.type==="full")return new A.SemanticTokens(d.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new A.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const d=(0,i.decodeSemanticTokensDto)(a);if(d.type==="full")return new A.SemanticTokens(d.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,d,E)=>{if(!a)return new A.CompletionList([]);const w=a.suggestions.map(b=>k.CompletionItem.to(b,E));return new A.CompletionList(w,a.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return k.SignatureHelp.to(a)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,d,E)=>m(w=>new A.CodeLens(k.Range.to(w.range),w.command&&E.fromInternal(w.command)))(a))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>A.Range.isRange(a),a=>A.Selection.isSelection(a)?k.Selection.from(a):k.Range.from(a)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,d,E)=>m(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return E.fromInternal(w.command)}else{const b=new A.CodeAction(w.title,w.kind?new A.CodeActionKind(w.kind):void 0);return w.edit&&(b.edit=k.WorkspaceEdit.to(w.edit)),w.command&&(b.command=E.fromInternal(w.command)),b.isPreferred=w.isPreferred,b}})(a))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(d=>new A.ColorInformation(k.Range.to(d.range),k.Color.to(d.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",a=>a instanceof A.Color,k.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:k.Range.from(a.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(k.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineHint objects",a=>a.map(k.InlineHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",m(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientMetadata:a.options.transientCellMetadata,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(d=>k.NotebookExclusiveDocumentPattern.to(d))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(k.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[k.ViewColumn.from(a.viewColumn),k.TextEditorOpenOptions.from(a)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[k.ViewColumn.from(a.viewColumn),k.TextEditorOpenOptions.from(a)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[k.ViewColumn.from(a.viewColumn),k.TextEditorOpenOptions.from(a)]).optional()],y.ApiCommandResult.Void)];class C{constructor(d){this._disposables=new _.DisposableStore,this._commands=d}static register(d){return T.forEach(d.registerApiCommand,d),new C(d).registerCommands()}registerCommands(){const d=E=>(...w)=>E(this._commands,...w);this._register(P.RemoveFromRecentlyOpenedAPICommand.ID,d(P.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:E=>typeof E=="string"}]}),this._register(P.OpenIssueReporter.ID,d(P.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:E=>typeof E=="string"||typeof E=="object"&&typeof E.extensionId=="string"}]})}_register(d,E,w){const b=this._commands.registerCommand(!1,d,E,this,w);this._disposables.add(b)}}e.ExtHostApiCommands=C;function m(a){return d=>{if(Array.isArray(d))return d.map(a)}}function f(a){if(!!Array.isArray(a)){const d=[];for(const E of a)I.isLocationLink(E)?d.push(k.DefinitionLink.to(E)):d.push(k.location.to(E));return d}}}),define(me[232],ge([0,1,19,70,3,6,2,80,29,20,7,5]),function(G,e,_,k,A,I,y,P,D,i,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class m{constructor(c,g,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=c.getProxy(C.MainContext.MainThreadComments),g.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const s=this._commentControllers.get(n.handle);return s||n}else if(n&&n.$mid===7){const s=this._commentControllers.get(n.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.commentThreadHandle);return r||n}else if(n&&n.$mid===8){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);return r?{thread:r,text:n.text}:n}else if(n&&n.$mid===9){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let o=n.commentUniqueId,l=r.getCommentByUniqueId(o);return l||n}else if(n&&n.$mid===10){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let o=n.text,l=n.commentUniqueId,h=r.getCommentByUniqueId(l);return h?(h.body=o,h):n}return n}})}createCommentController(c,g,t){const n=m.handlePool++,s=new a(c,n,this._proxy,g,t);this._commentControllers.set(s.handle,s);const r=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(c.identifier))||[];return r.push(s),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(c.identifier),r),s}$createCommentThreadTemplate(c,g,t){const n=this._commentControllers.get(c);!n||n.$createCommentThreadTemplate(g,t)}async $updateCommentThreadTemplate(c,g,t){const n=this._commentControllers.get(c);!n||n.$updateCommentThreadTemplate(g,t)}$deleteCommentThread(c,g){const t=this._commentControllers.get(c);t&&t.$deleteCommentThread(g)}$provideCommentingRanges(c,g,t){const n=this._commentControllers.get(c);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(y.URI.revive(g));return(0,_.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(s,t)).then(r=>r?r.map(o=>i.Range.from(o)):void 0)}$toggleReaction(c,g,t,n,s){const r=this._commentControllers.get(c);return!r||!r.reactionHandler?Promise.resolve(void 0):(0,_.asPromise)(()=>{const o=r.getCommentThread(g);if(o){const l=o.getCommentByUniqueId(n.uniqueIdInThread);if(r!==void 0&&l&&r.reactionHandler)return r.reactionHandler(l,w(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=m,m.handlePool=0;class f{constructor(c,g,t,n,s,r,o){this._proxy=c,this._commentController=g,this._id=t,this._uri=n,this._range=s,this._comments=r,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new A.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new I.MutableDisposable,this._acceptInputDisposables.value=new I.DisposableStore,this._id===void 0&&(this._id=`${g.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,i.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new I.DisposableStore);const c=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),g={};c("range")&&(g.range=i.Range.from(this._range)),c("label")&&(g.label=this.label),c("contextValue")&&(g.contextValue=this.contextValue),c("comments")&&(g.comments=this._comments.map(t=>d(this,this._commentController,t,this._commentsMap))),c("collapsibleState")&&(g.collapseState=b(this._collapseState)),c("canReply")&&(g.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,g)}}getCommentByUniqueId(c){for(let g of this._commentsMap){let t=g[0],n=g[1];if(c===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}f._handlePool=0,je([(0,k.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=f;class a{constructor(c,g,t,n,s){this._extension=c,this._handle=g,this._proxy=t,this._id=n,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(c,g,t,n){if(typeof c=="string"){const s=new f(this._proxy,this,c,g,t,n,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new f(this._proxy,this,void 0,c,g,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(c,g){const t=new f(this._proxy,this,void 0,y.URI.revive(c),i.Range.to(g),[],this._extension.identifier);return t.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(c,g){let t=this._threads.get(c);t&&(t.range=i.Range.to(g))}$deleteCommentThread(c){let g=this._threads.get(c);g&&g.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function d(p,c,g,t){let n=t.get(g);n||(n=++p.commentHandle,t.set(g,n));const s=g.author&&g.author.iconPath?g.author.iconPath.toString():void 0;return{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:n,body:i.MarkdownString.from(g.body),userName:g.author.name,userIconPath:s,label:g.label,commentReactions:g.reactions?g.reactions.map(r=>E(r)):void 0}}function E(p){return{label:p.label,iconPath:p.iconPath?i.pathOrURIToURI(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted}}function w(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?y.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1}}function b(p){if(p!==void 0)switch(p){case T.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}}),define(me[125],ge([0,1,2,5,7,4,14,13,15,10,8]),function(G,e,_,k,A,I,y,P,D,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class bn{constructor(f,a){this._logService=a,this._provider=new Map,this._proxy=f.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,a){const d=bn._handlePool++;this._provider.set(d,{provider:f,extensionId:a}),this._proxy.$registerDecorationProvider(d,a.value);const E=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(d,null);return}let b=(0,D.asArray)(w);if(b.length<=bn._maxEventSize){this._proxy.$onDidChange(d,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,b.length);const p=b.map(t=>({uri:t,rank:(0,i.count)(t.path,"/")})),c=(0,D.groupBy)(p,(t,n)=>t.rank-n.rank||(0,i.compare)(t.uri.path,n.uri.path));let g=[];e:for(let t of c){let n;for(let s of t){let r=(0,T.dirname)(s.uri.path);if(n!==r&&(n=r,g.push(s.uri)>=bn._maxEventSize))break e}}this._proxy.$onDidChange(d,g)});return new A.Disposable(()=>{E==null||E.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(f,a,d){if(!this._provider.has(f))return Object.create(null);const E=Object.create(null),{provider:w,extensionId:b}=this._provider.get(f);return await Promise.all(a.map(async p=>{try{const{uri:c,id:g}=p,t=await Promise.resolve(w.provideFileDecoration(_.URI.revive(c),d));if(!t)return;try{A.FileDecoration.validate(t),E[g]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${b.value}': ${n}`)}}catch(c){this._logService.error(c)}})),E}};C._handlePool=0,C._maxEventSize=250,C=je([Be(0,y.IExtHostRpcService),Be(1,P.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,I.createDecorator)("IExtHostDecorations")}),define(me[233],ge([0,1,160,113,2,5,7,20,3,13,24]),function(G,e,_,k,A,I,y,P,D,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(a,d,E,w,b){this._name=a,this._owner=d,this._maxDiagnosticsPerFile=E,this._proxy=w,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new T.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,d){if(!a){this.clear();return}this._checkDisposed();let E=[];if(A.URI.isUri(a)){if(!d){this.delete(a);return}this._data.set(a,d.slice()),E=[a]}else if(Array.isArray(a)){E=[];let b;a=[...a].sort(C._compareIndexedTuplesByUri);for(const p of a){const[c,g]=p;if((!b||c.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=c,E.push(c),this._data.set(c,[])),g){const t=this._data.get(c);t&&t.push(...g)}else{const t=this._data.get(c);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(E),!!this._proxy){const w=[];for(let b of E){let p=[];const c=this._data.get(b);if(c)if(c.length>this._maxDiagnosticsPerFile){p=[];const g=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of c)if(n.severity===g[t]&&p.push(P.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;p.push({severity:k.MarkerSeverity.Info,message:(0,_.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:p[p.length-1].startLineNumber,startColumn:p[p.length-1].startColumn,endLineNumber:p[p.length-1].endLineNumber,endColumn:p[p.length-1].endColumn})}else p=c.map(g=>P.Diagnostic.from(g));w.push([b,p])}this._proxy.$changeMany(this._owner,w)}}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,d){this._checkDisposed();for(let E of this._data.keys())a.apply(d,[E,this.get(E),this])}get(a){this._checkDisposed();const d=this._data.get(a);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,d){return a[0].toString()<d[0].toString()?-1:a[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=C;let m=class $t{constructor(a,d){this._logService=d,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,$t._debouncer,50),$t._mapper),this._proxy=a.getProxy(I.MainContext.MainThreadDiagnostics)}static _debouncer(a,d){return a?a.concat(d):d}static _mapper(a){const d=[],E=new Set;for(const w of a)typeof w=="string"?E.has(w)||(E.add(w),d.push(A.URI.parse(w))):E.has(w.toString())||(E.add(w.toString()),d.push(w));return Object.freeze(d),{uris:d}}createDiagnosticCollection(a,d){const{_collections:E,_proxy:w,_onDidChangeDiagnostics:b,_logService:p}=this,c=new class{$changeMany(n,s){w.$changeMany(n,s),p.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,n,s.length===0?"CLEARING":s)}$clear(n){w.$clear(n),p.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,n)}dispose(){w.dispose()}};let g;if(!d)d="_generated_diagnostic_collection_name_#"+$t._idPool++,g=d;else if(!E.has(d))g=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do g=d+$t._idPool++;while(E.has(g))}return new class extends C{constructor(){super(d,g,$t._maxDiagnosticsPerFile,c,b);E.set(g,this)}dispose(){super.dispose(),E.delete(g)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const d=new Map,E=[];for(const w of this._collections.values())w.forEach((b,p)=>{let c=d.get(b.toString());typeof c=="undefined"&&(c=E.length,d.set(b.toString(),c),E.push([b,[]])),E[c][1]=E[c][1].concat(...p)});return E}}_getDiagnostics(a){let d=[];for(let E of this._collections.values())E.has(a)&&(d=d.concat(E.get(a)));return d}$acceptMarkersChange(a){if(!this._mirrorCollection){const d="_generated_mirror",E=new C(d,d,$t._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(d,E),this._mirrorCollection=E}for(const[d,E]of a)this._mirrorCollection.set(A.URI.revive(d),E.map(P.Diagnostic.to))}};m._idPool=0,m._maxDiagnosticsPerFile=1e3,m=je([Be(1,i.ILogService)],m),e.ExtHostDiagnostics=m}),define(me[234],ge([0,1,2,5]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(y){this._proxy=y.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(P=>P?P.map(D=>_.URI.revive(D)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(P=>P?_.URI.revive(P):void 0)}}e.ExtHostDialogs=A}),define(me[235],ge([0,1,18,2,7,5,11,21,10]),function(G,e,_,k,A,I,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class i{constructor(C,m,f){this._documentsAndEditors=m,this._logService=f,this._documentContentProviders=new Map,this._proxy=C.getProxy(I.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,m){if(Object.keys(y.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const f=i._handlePool++;this._documentContentProviders.set(f,m),this._proxy.$registerTextContentProvider(f,C);let a;return typeof m.onDidChange=="function"&&(a=m.onDidChange(d=>{if(d.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(f,d).then(E=>{if(!(!E&&typeof E!="string")){const w=this._documentsAndEditors.getDocument(d);if(!!w){const b=(0,D.splitLines)(E);if(!w.equalLines(b))return this._proxy.$onVirtualDocumentChange(d,E)}}},_.onUnexpectedError)})),new A.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(C,m){const f=this._documentContentProviders.get(C);return f?Promise.resolve(f.provideTextDocumentContent(k.URI.revive(m),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=i,i._handlePool=0}),define(me[236],ge([0,1,3,6,2,5,119,20,12,23]),function(G,e,_,k,A,I,y,P,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(m,f){this._onDidAddDocument=new _.Emitter,this._onDidRemoveDocument=new _.Emitter,this._onDidChangeDocument=new _.Emitter,this._onDidSaveDocument=new _.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new k.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(I.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const d of a)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const d of a)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!!m){const f=this._documentsAndEditors.getDocument(m);if(f)return f}}getDocument(m){const f=this.getDocumentData(m);if(!(f==null?void 0:f.document))throw new Error(`Unable to retrieve document from URI '${m}'`);return f.document}ensureDocumentData(m){const f=this._documentsAndEditors.getDocument(m);if(f)return Promise.resolve(f);let a=this._documentLoader.get(m.toString());return a||(a=this._proxy.$tryOpenDocument(m).then(d=>{this._documentLoader.delete(m.toString());const E=A.URI.revive(d);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(E))},d=>(this._documentLoader.delete(m.toString()),Promise.reject(d))),this._documentLoader.set(m.toString(),a)),a}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(f=>A.URI.revive(f))}$acceptModelModeChanged(m,f){const a=A.URI.revive(m),d=this._documentsAndEditors.getDocument(a);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(f),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(m){const f=A.URI.revive(m),a=this._documentsAndEditors.getDocument(f);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(m,f){const a=A.URI.revive(m),d=this._documentsAndEditors.getDocument(a);if(!d)throw new Error("unknown document");d._acceptIsDirty(f),this._onDidChangeDocument.fire({document:d.document,contentChanges:[]})}$acceptModelChanged(m,f,a){const d=A.URI.revive(m),E=this._documentsAndEditors.getDocument(d);if(!E)throw new Error("unknown document");E._acceptIsDirty(a),E.onEvents(f),this._onDidChangeDocument.fire((0,i.deepFreeze)({document:E.document,contentChanges:f.changes.map(w=>({range:P.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(m,f){(0,y.setWordDefinitionFor)(m,f)}}e.ExtHostDocuments=T}),define(me[39],ge([0,1,52,3,6,2,4,5,119,14,123,20,13,24,11,54,134]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(c,g){this._extHostRpc=c,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new k.Emitter,this._onDidRemoveDocuments=new k.Emitter,this._onDidChangeVisibleTextEditors=new k.Emitter,this._onDidChangeActiveTextEditor=new k.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const g=[],t=[],n=[];if(c.removedDocuments)for(const s of c.removedDocuments){const r=I.URI.revive(s),o=this._documents.get(r);(o==null?void 0:o.unref())&&(this._documents.delete(r),g.push(o.value))}if(c.addedDocuments)for(const s of c.addedDocuments){const r=I.URI.revive(s.uri);let o=this._documents.get(r);if(o&&r.scheme!==a.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);o||(o=new w(new D.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),r,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(r,o),t.push(o.value)),o.ref()}if(c.removedEditors)for(const s of c.removedEditors){const r=this._editors.get(s);this._editors.delete(s),r&&n.push(r)}if(c.addedEditors)for(const s of c.addedEditors){const r=I.URI.revive(s.documentUri);_.ok(this._documents.has(r),`document '${r}' does not exist`),_.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const o=this._documents.get(r).value,l=new T.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>o.document),s.selections.map(C.Selection.to),s.options,s.visibleRanges.map(h=>C.Range.to(h)),typeof s.editorPosition=="number"?C.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,l)}c.newActiveEditor!==void 0&&(_.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,A.dispose)(g),(0,A.dispose)(n),c.removedDocuments&&this._onDidRemoveDocuments.fire(g),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){var g;return(g=this._documents.get(c))===null||g===void 0?void 0:g.value}allDocuments(){return d.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!!this._activeEditorId){const g=this._editors.get(this._activeEditorId);return c?g:g==null?void 0:g.value}}allEditors(){return[...this._editors.values()]}};b=je([Be(0,i.IExtHostRpcService),Be(1,m.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[237],ge([0,1,2,5,6,7,20,142,10,22]),function(G,e,_,k,A,I,y,P,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const a=this._schemes.indexOf(f);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),a=[];let d,E,w=14,b=14;for(const p of f){let c=d?(0,D.commonPrefixLength)(d,p):0;for(c===0?E=1:E=b;c<p.length;c++)c+1===p.length?(w=b,b=9):b+=1,a.push([E,p.toUpperCase().charCodeAt(c),b]),a.push([E,p.toLowerCase().charCodeAt(c),b]),E=b;d=p,b=w}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new P.StateMachine(a)}}provideDocumentLinks(f){this._initStateMachine();const a=[],d=P.LinkComputer.computeLinks({getLineContent(E){return f.lineAt(E-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const E of d){const w=y.DocumentLink.to(E);w.target&&a.push(w)}return a}}class C{constructor(f,a){this._extHostLanguageFeatures=a,this._linkProvider=new T,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){var f;(f=this._linkProviderRegistration)===null||f===void 0||f.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,a,d,E={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(w,d);let b=2;E.isCaseSensitive&&(b+=1024),E.isReadonly&&(b+=2048),typeof d.copy=="function"&&(b+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&(b+=4),this._proxy.$registerFileSystemProvider(w,a,b).catch(c=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${a}`),console.error(c)});const p=d.onDidChangeFile(c=>{const g=[];for(const t of c){let{uri:n,type:s}=t;if(n.scheme===a){let r;switch(s){case I.FileChangeType.Changed:r=0;break;case I.FileChangeType.Created:r=1;break;case I.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}g.push({resource:n,type:r})}}this._proxy.$onFileSystemChange(w,g)});return(0,A.toDisposable)(()=>{p.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(f){const{type:a,ctime:d,mtime:E,size:w}=f;return{type:a,ctime:d,mtime:E,size:w}}$stat(f,a){return Promise.resolve(this._getFsProvider(f).stat(_.URI.revive(a))).then(C._asIStat)}$readdir(f,a){return Promise.resolve(this._getFsProvider(f).readDirectory(_.URI.revive(a)))}$readFile(f,a){return Promise.resolve(this._getFsProvider(f).readFile(_.URI.revive(a))).then(d=>i.VSBuffer.wrap(d))}$writeFile(f,a,d,E){return Promise.resolve(this._getFsProvider(f).writeFile(_.URI.revive(a),d.buffer,E))}$delete(f,a,d){return Promise.resolve(this._getFsProvider(f).delete(_.URI.revive(a),d))}$rename(f,a,d,E){return Promise.resolve(this._getFsProvider(f).rename(_.URI.revive(a),_.URI.revive(d),E))}$copy(f,a,d,E){const w=this._getFsProvider(f);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(_.URI.revive(a),_.URI.revive(d),E))}$mkdir(f,a){return Promise.resolve(this._getFsProvider(f).createDirectory(_.URI.revive(a)))}$watch(f,a,d,E){const w=this._getFsProvider(f).watch(_.URI.revive(d),E);this._watches.set(a,w)}$unwatch(f,a){const d=this._watches.get(a);d&&(d.dispose(),this._watches.delete(a))}$open(f,a,d){const E=this._getFsProvider(f);if(!E.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(E.open(_.URI.revive(a),d))}$close(f,a){const d=this._getFsProvider(f);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(a))}$read(f,a,d,E){const w=this._getFsProvider(f);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const b=i.VSBuffer.alloc(E);return Promise.resolve(w.read(a,d,b.buffer,0,E)).then(p=>b.slice(0,p))}$write(f,a,d,E){const w=this._getFsProvider(f);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(a,d,E.buffer,0,E.byteLength))}_getFsProvider(f){const a=this._fsProvider.get(f);if(!a){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return a}}e.ExtHostFileSystem=C}),define(me[90],ge([0,1,5,45,7,22,4,14,61]),function(G,e,_,k,A,I,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let i=class Ft{constructor(C,m){const f=C.getProxy(_.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return f.$stat(a).catch(Ft._handleError)},readDirectory(a){return f.$readdir(a).catch(Ft._handleError)},createDirectory(a){return f.$mkdir(a).catch(Ft._handleError)},async readFile(a){return f.$readFile(a).then(d=>d.buffer).catch(Ft._handleError)},writeFile(a,d){return f.$writeFile(a,I.VSBuffer.wrap(d)).catch(Ft._handleError)},delete(a,d){return f.$delete(a,Object.assign({recursive:!1,useTrash:!1},d)).catch(Ft._handleError)},rename(a,d,E){return f.$rename(a,d,Object.assign({overwrite:!1},E)).catch(Ft._handleError)},copy(a,d,E){return f.$copy(a,d,Object.assign({overwrite:!1},E)).catch(Ft._handleError)},isWritableFileSystem(a){const d=m.getCapabilities(a);if(typeof d=="number")return!(d&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new A.FileSystemError(String(C));if(C.name==="ENOPRO")throw A.FileSystemError.Unavailable(C.message);switch(C.name){case k.FileSystemProviderErrorCode.FileExists:throw A.FileSystemError.FileExists(C.message);case k.FileSystemProviderErrorCode.FileNotFound:throw A.FileSystemError.FileNotFound(C.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw A.FileSystemError.FileNotADirectory(C.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw A.FileSystemError.FileIsADirectory(C.message);case k.FileSystemProviderErrorCode.NoPermissions:throw A.FileSystemError.NoPermissions(C.message);case k.FileSystemProviderErrorCode.Unavailable:throw A.FileSystemError.Unavailable(C.message);default:throw new A.FileSystemError(C.message,C.name)}}};i=je([Be(0,P.IExtHostRpcService),Be(1,D.IExtHostFileSystemInfo)],i),e.ExtHostConsumerFileSystem=i,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(me[238],ge([0,1,6,5]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class A{constructor(y){this._handlePool=0,this._proxy=y.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,y),(0,_.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=A}),define(me[239],ge([0,1,2,23,20,7,19,5,10,44,15,12,139,6,109,72,86,47,18]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d,E,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class p{constructor(V,J){this._documents=V,this._provider=J}provideDocumentSymbols(V,J){const ee=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(ee,J)).then(ae=>{if(!(0,T.isFalsyOrEmpty)(ae))return ae[0]instanceof I.DocumentSymbol?ae.map(A.DocumentSymbol.from):p._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(V){var J;V=V.slice(0).sort((we,Ce)=>{let Oe=we.location.range.start.compareTo(Ce.location.range.start);return Oe===0&&(Oe=Ce.location.range.end.compareTo(we.location.range.end)),Oe});const ee=[],ae=[];for(const we of V){const Ce={name:we.name||"!!MISSING: name!!",kind:A.SymbolKind.from(we.kind),tags:((J=we.tags)===null||J===void 0?void 0:J.map(A.SymbolTag.from))||[],detail:"",containerName:we.containerName,range:A.Range.from(we.location.range),selectionRange:A.Range.from(we.location.range),children:[]};for(;;){if(ae.length===0){ae.push(Ce),ee.push(Ce);break}const Oe=ae[ae.length-1];if(i.Range.containsRange(Oe.range,Ce.range)&&!i.Range.equalsRange(Oe.range,Ce.range)){Oe.children&&Oe.children.push(Ce),ae.push(Ce);break}ae.pop()}}return ee}}class c{constructor(V,J,ee){this._documents=V,this._commands=J,this._provider=ee,this._cache=new E.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(V,J){const ee=this._documents.getDocument(V),ae=await this._provider.provideCodeLenses(ee,J);if(!(!ae||J.isCancellationRequested)){const we=this._cache.add(ae),Ce=new f.DisposableStore;this._disposables.set(we,Ce);const Oe={cacheId:we,lenses:[]};for(let be=0;be<ae.length;be++)Oe.lenses.push({cacheId:[we,be],range:A.Range.from(ae[be].range),command:this._commands.toInternal(ae[be].command,Ce)});return Oe}}async resolveCodeLens(V,J){var ee;const ae=V.cacheId&&this._cache.get(...V.cacheId);if(!!ae){let we;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?we=ae:we=await this._provider.resolveCodeLens(ae,J),we||(we=ae),!J.isCancellationRequested){const Ce=V.cacheId&&this._disposables.get(V.cacheId[0]);if(!!Ce)return V.command=this._commands.toInternal((ee=we.command)!==null&&ee!==void 0?ee:c._badCmd,Ce),V}}}releaseCodeLenses(V){var J;(J=this._disposables.get(V))===null||J===void 0||J.dispose(),this._disposables.delete(V),this._cache.delete(V)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function g(Le){return Array.isArray(Le)?Le.map(A.DefinitionLink.from):Le?[A.DefinitionLink.from(Le)]:[]}class t{constructor(V,J){this._documents=V,this._provider=J}provideDefinition(V,J,ee){const ae=this._documents.getDocument(V),we=A.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideDefinition(ae,we,ee)).then(g)}}class n{constructor(V,J){this._documents=V,this._provider=J}provideDeclaration(V,J,ee){const ae=this._documents.getDocument(V),we=A.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideDeclaration(ae,we,ee)).then(g)}}class s{constructor(V,J){this._documents=V,this._provider=J}provideImplementation(V,J,ee){const ae=this._documents.getDocument(V),we=A.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideImplementation(ae,we,ee)).then(g)}}class r{constructor(V,J){this._documents=V,this._provider=J}provideTypeDefinition(V,J,ee){const ae=this._documents.getDocument(V),we=A.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(ae,we,ee)).then(g)}}class o{constructor(V,J){this._documents=V,this._provider=J}provideHover(V,J,ee){const ae=this._documents.getDocument(V),we=A.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideHover(ae,we,ee)).then(Ce=>{if(!(!Ce||(0,T.isFalsyOrEmpty)(Ce.contents)))return Ce.range||(Ce.range=ae.getWordRangeAtPosition(we)),Ce.range||(Ce.range=new I.Range(we,we)),A.Hover.from(Ce)})}}class l{constructor(V,J){this._documents=V,this._provider=J}provideEvaluatableExpression(V,J,ee){const ae=this._documents.getDocument(V),we=A.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(ae,we,ee)).then(Ce=>{if(Ce)return A.EvaluatableExpression.from(Ce)})}}class h{constructor(V,J){this._documents=V,this._provider=J}provideInlineValues(V,J,ee,ae){const we=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideInlineValues(we,A.Range.to(J),A.InlineValueContext.to(ee),ae)).then(Ce=>{if(Array.isArray(Ce))return Ce.map(Oe=>A.InlineValue.from(Oe))})}}class S{constructor(V,J){this._documents=V,this._provider=J}provideDocumentHighlights(V,J,ee){const ae=this._documents.getDocument(V),we=A.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(ae,we,ee)).then(Ce=>{if(Array.isArray(Ce))return Ce.map(A.DocumentHighlight.from)})}}class u{constructor(V,J){this._documents=V,this._provider=J}provideLinkedEditingRanges(V,J,ee){const ae=this._documents.getDocument(V),we=A.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(ae,we,ee)).then(Ce=>{if(Ce&&Array.isArray(Ce.ranges))return{ranges:(0,T.coalesce)(Ce.ranges.map(A.Range.from)),wordPattern:Ce.wordPattern}})}}class v{constructor(V,J){this._documents=V,this._provider=J}provideReferences(V,J,ee,ae){const we=this._documents.getDocument(V),Ce=A.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideReferences(we,Ce,ee,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(A.location.from)})}}class R{constructor(V,J,ee,ae,we,Ce,Oe){this._documents=V,this._commands=J,this._diagnostics=ee,this._provider=ae,this._logService=we,this._extension=Ce,this._apiDeprecation=Oe,this._cache=new E.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(V,J,ee,ae){const we=this._documents.getDocument(V),Ce=m.Selection.isISelection(J)?A.Selection.to(J):A.Range.to(J),Oe=[];for(const Pe of this._diagnostics.getDiagnostics(V))if(Ce.intersection(Pe.range)&&Oe.push(Pe)>R._maxCodeActionsPerFile)break;const be={diagnostics:Oe,only:ee.only?new I.CodeActionKind(ee.only):void 0,triggerKind:A.CodeActionTriggerKind.to(ee.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(we,Ce,be,ae)).then(Pe=>{var Re;if(!(!(0,T.isNonEmptyArray)(Pe)||ae.isCancellationRequested)){const We=this._cache.add(Pe),Ee=new f.DisposableStore;this._disposables.set(We,Ee);const Ke=[];for(let X=0;X<Pe.length;X++){const re=Pe[X];!re||(R._isCommand(re)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:re.title,command:this._commands.toInternal(re,Ee)})):(be.only&&(re.kind?be.only.contains(re.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action is of kind '${re.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[We,X],title:re.title,command:re.command&&this._commands.toInternal(re.command,Ee),diagnostics:re.diagnostics&&re.diagnostics.map(A.Diagnostic.from),edit:re.edit&&A.WorkspaceEdit.from(re.edit),kind:re.kind&&re.kind.value,isPreferred:re.isPreferred,disabled:(Re=re.disabled)===null||Re===void 0?void 0:Re.reason})))}return{cacheId:We,actions:Ke}}})}async resolveCodeAction(V,J){var ee;const[ae,we]=V,Ce=this._cache.get(ae,we);if(!(!Ce||R._isCommand(Ce))&&!!this._provider.resolveCodeAction){const Oe=(ee=await this._provider.resolveCodeAction(Ce,J))!==null&&ee!==void 0?ee:Ce;return(Oe==null?void 0:Oe.edit)?A.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(V){var J;(J=this._disposables.get(V))===null||J===void 0||J.dispose(),this._disposables.delete(V),this._cache.delete(V)}static _isCommand(V){return typeof V.command=="string"&&typeof V.title=="string"}}R._maxCodeActionsPerFile=1e3;class L{constructor(V,J){this._documents=V,this._provider=J}provideDocumentFormattingEdits(V,J,ee){const ae=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ae,J,ee)).then(we=>{if(Array.isArray(we))return we.map(A.TextEdit.from)})}}class H{constructor(V,J){this._documents=V,this._provider=J}provideDocumentRangeFormattingEdits(V,J,ee,ae){const we=this._documents.getDocument(V),Ce=A.Range.to(J);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(we,Ce,ee,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(A.TextEdit.from)})}}class ie{constructor(V,J){this._documents=V,this._provider=J,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(V,J,ee,ae,we){const Ce=this._documents.getDocument(V),Oe=A.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Ce,Oe,ee,ae,we)).then(be=>{if(Array.isArray(be))return be.map(A.TextEdit.from)})}}class j{constructor(V,J){this._provider=V,this._logService=J,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(V,J){const ee=P.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(V,J)).then(ae=>{if((0,T.isNonEmptyArray)(ae)){for(const we of ae)if(!!we){if(!we.name){this._logService.warn("INVALID SymbolInformation, lacks name",we);continue}const Ce=P.IdObject.mixin(A.WorkspaceSymbol.from(we));this._symbolCache.set(Ce._id,we),ee.symbols.push(Ce)}}}).then(()=>(ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee))}async resolveWorkspaceSymbol(V,J){if(typeof this._provider.resolveWorkspaceSymbol!="function")return V;const ee=this._symbolCache.get(V._id);if(ee){const ae=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ee,J));return ae&&(0,k.mixin)(V,A.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(V){const J=this._resultCache.get(V);if(J){for(let[ee,ae]=J;ee<=ae;ee++)this._symbolCache.delete(ee);this._resultCache.delete(V)}}}class B{constructor(V,J,ee){this._documents=V,this._provider=J,this._logService=ee}static supportsResolving(V){return typeof V.prepareRename=="function"}provideRenameEdits(V,J,ee,ae){const we=this._documents.getDocument(V),Ce=A.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(we,Ce,ee,ae)).then(Oe=>{if(!!Oe)return A.WorkspaceEdit.from(Oe)},Oe=>{const be=B._asMessage(Oe);return be?{rejectReason:be,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(V,J,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(V),we=A.Position.to(J);return(0,y.asPromise)(()=>this._provider.prepareRename(ae,we,ee)).then(Ce=>{let Oe,be;if(I.Range.isRange(Ce)?(Oe=Ce,be=ae.getText(Ce)):(0,C.isObject)(Ce)&&(Oe=Ce.range,be=Ce.placeholder),!!Oe){if(Oe.start.line>we.line||Oe.end.line<we.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:A.Range.from(Oe),text:be}}},Ce=>{const Oe=B._asMessage(Ce);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(Ce)})}static _asMessage(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class ${constructor(V,J){this.resultId=V,this.tokens=J}}class N{constructor(V,J){this._documents=V,this._provider=J,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(V,J,ee){const ae=this._documents.getDocument(V),we=J!==0?this._previousResults.get(J):null;return(0,y.asPromise)(()=>we&&typeof we.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,we.resultId,ee):this._provider.provideDocumentSemanticTokens(ae,ee)).then(Ce=>(we&&this._previousResults.delete(J),Ce?(Ce=N._fixProvidedSemanticTokens(Ce),this._send(N._convertToEdits(we,Ce),Ce)):null))}async releaseDocumentSemanticColoring(V){this._previousResults.delete(V)}static _fixProvidedSemanticTokens(V){return N._isSemanticTokens(V)?N._isCorrectSemanticTokens(V)?V:new I.SemanticTokens(new Uint32Array(V.data),V.resultId):N._isSemanticTokensEdits(V)?N._isCorrectSemanticTokensEdits(V)?V:new I.SemanticTokensEdits(V.edits.map(J=>new I.SemanticTokensEdit(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),V.resultId):V}static _isSemanticTokens(V){return V&&!!V.data}static _isCorrectSemanticTokens(V){return V.data instanceof Uint32Array}static _isSemanticTokensEdits(V){return V&&Array.isArray(V.edits)}static _isCorrectSemanticTokensEdits(V){for(const J of V.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(V,J){if(!N._isSemanticTokens(J)||!V||!V.tokens)return J;const ee=V.tokens,ae=ee.length,we=J.data,Ce=we.length;let Oe=0;const be=Math.min(ae,Ce);for(;Oe<be&&ee[Oe]===we[Oe];)Oe++;if(Oe===ae&&Oe===Ce)return new I.SemanticTokensEdits([],J.resultId);let Pe=0;const Re=be-Oe;for(;Pe<Re&&ee[ae-Pe-1]===we[Ce-Pe-1];)Pe++;return new I.SemanticTokensEdits([{start:Oe,deleteCount:ae-Oe-Pe,data:we.subarray(Oe,Ce-Pe)}],J.resultId)}_send(V,J){if(N._isSemanticTokens(V)){const ee=this._nextResultId++;return this._previousResults.set(ee,new $(V.resultId,V.data)),(0,a.encodeSemanticTokensDto)({id:ee,type:"full",data:V.data})}if(N._isSemanticTokensEdits(V)){const ee=this._nextResultId++;return N._isSemanticTokens(J)?this._previousResults.set(ee,new $(J.resultId,J.data)):this._previousResults.set(ee,new $(V.resultId)),(0,a.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(V.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=N;class M{constructor(V,J){this._documents=V,this._provider=J}provideDocumentRangeSemanticTokens(V,J,ee){const ae=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ae,A.Range.to(J),ee)).then(we=>we?this._send(we):null)}_send(V){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:V.data})}}e.DocumentRangeSemanticTokensAdapter=M;class F{constructor(V,J,ee,ae,we){this._documents=V,this._commands=J,this._provider=ee,this._apiDeprecation=ae,this._extension=we,this._cache=new E.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}async provideCompletionItems(V,J,ee,ae){const we=this._documents.getDocument(V),Ce=A.Position.to(J),Oe=we.getWordRangeAtPosition(Ce)||new I.Range(Ce,Ce),be=Oe.with({end:Ce}),Pe=new w.StopWatch(!0),Re=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(we,Ce,ae,A.CompletionContext.to(ee)));if(!!Re&&!ae.isCancellationRequested){const We=Array.isArray(Re)?new I.CompletionList(Re):Re,Ee=F.supportsResolving(this._provider)?this._cache.add(We.items):this._cache.add([]),Ke=new f.DisposableStore;this._disposables.set(Ee,Ke);const X=[],re={x:Ee,b:X,a:{replace:A.Range.from(Oe),insert:A.Range.from(be)},c:We.isIncomplete||void 0,d:Pe.elapsed()};for(let _e=0;_e<We.items.length;_e++){const xe=We.items[_e],ze=this._convertCompletionItem(xe,[Ee,_e],be,Oe);X.push(ze)}return re}}async resolveCompletionItem(V,J){if(typeof this._provider.resolveCompletionItem=="function"){const ee=this._cache.get(...V);if(!!ee){const ae=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(ee,J));if(!!ae)return this._convertCompletionItem(ae,V)}}}releaseCompletionItems(V){var J;(J=this._disposables.get(V))===null||J===void 0||J.dispose(),this._disposables.delete(V),this._cache.delete(V)}_convertCompletionItem(V,J,ee,ae){var we;const Ce=this._disposables.get(J[0]);if(!Ce)throw Error("DisposableStore is missing...");const Oe={x:J,a:(we=V.label)!==null&&we!==void 0?we:"",o:V.label2,b:V.kind!==void 0?A.CompletionItemKind.from(V.kind):void 0,n:V.tags&&V.tags.map(A.CompletionItemTag.from),c:V.detail,d:typeof V.documentation=="undefined"?void 0:A.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters,l:V.additionalTextEdits&&V.additionalTextEdits.map(A.TextEdit.from),m:this._commands.toInternal(V.command,Ce)};V.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=V.textEdit.newText):typeof V.insertText=="string"?Oe.h=V.insertText:V.insertText instanceof I.SnippetString&&(Oe.h=V.insertText.value,Oe.i|=4);let be;return V.textEdit?be=V.textEdit.range:V.range&&(be=V.range),I.Range.isRange(be)?Oe.j=A.Range.from(be):be&&(!(ee==null?void 0:ee.isEqual(be.inserting))||!(ae==null?void 0:ae.isEqual(be.replacing)))&&(Oe.j={insert:A.Range.from(be.inserting),replace:A.Range.from(be.replacing)}),Oe}}class U{constructor(V,J){this._documents=V,this._provider=J,this._cache=new E.Cache("SignatureHelp")}provideSignatureHelp(V,J,ee,ae){const we=this._documents.getDocument(V),Ce=A.Position.to(J),Oe=this.reviveContext(ee);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(we,Ce,ae,Oe)).then(be=>{if(be){const Pe=this._cache.add([be]);return Object.assign(Object.assign({},A.SignatureHelp.from(be)),{id:Pe})}})}reviveContext(V){let J;if(V.activeSignatureHelp){const ee=A.SignatureHelp.to(V.activeSignatureHelp),ae=this._cache.get(V.activeSignatureHelp.id,0);ae?(J=ae,J.activeSignature=ee.activeSignature,J.activeParameter=ee.activeParameter):J=ee}return Object.assign(Object.assign({},V),{activeSignatureHelp:J})}releaseSignatureHelp(V){this._cache.delete(V)}}class O{constructor(V,J){this._documents=V,this._provider=J}provideInlineHints(V,J,ee){const ae=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideInlineHints(ae,A.Range.to(J),ee)).then(we=>we?{hints:we.map(A.InlineHint.from)}:void 0)}}class W{constructor(V,J){this._documents=V,this._provider=J,this._cache=new E.Cache("DocumentLink")}provideLinks(V,J){const ee=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(ee,J)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!J.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(A.DocumentLink.from)};{const we=this._cache.add(ae),Ce={links:[],id:we};for(let Oe=0;Oe<ae.length;Oe++){const be=A.DocumentLink.from(ae[Oe]);be.cacheId=[we,Oe],Ce.links.push(be)}return Ce}}})}resolveLink(V,J){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ee=this._cache.get(...V);return ee?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(ee,J)).then(ae=>ae&&A.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(V){this._cache.delete(V)}}class q{constructor(V,J){this._documents=V,this._provider=J}provideColors(V,J){const ee=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(ee,J)).then(ae=>Array.isArray(ae)?ae.map(Ce=>({color:A.Color.from(Ce.color),range:A.Range.from(Ce.range)})):[])}provideColorPresentations(V,J,ee){const ae=this._documents.getDocument(V),we=A.Range.to(J.range),Ce=A.Color.to(J.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(Ce,{document:ae,range:we},ee)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(A.ColorPresentation.from)})}}class Q{constructor(V,J){this._documents=V,this._provider=J}provideFoldingRanges(V,J,ee){const ae=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(ae,J,ee)).then(we=>{if(!!Array.isArray(we))return we.map(A.FoldingRange.from)})}}class he{constructor(V,J,ee){this._documents=V,this._provider=J,this._logService=ee}provideSelectionRanges(V,J,ee){const ae=this._documents.getDocument(V),we=J.map(A.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(ae,we,ee)).then(Ce=>{if(!(0,T.isNonEmptyArray)(Ce))return[];if(Ce.length!==we.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let be=0;be<we.length;be++){const Pe=[];Oe.push(Pe);let Re=we[be],We=Ce[be];for(;;){if(!We.range.contains(Re))throw new Error("INVALID selection range, must contain the previous range");if(Pe.push(A.SelectionRange.from(We)),!We.parent)break;Re=We.range,We=We.parent}}return Oe})}}class ve{constructor(V,J){this._documents=V,this._provider=J,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(V,J,ee){const ae=this._documents.getDocument(V),we=A.Position.to(J),Ce=await this._provider.prepareCallHierarchy(ae,we,ee);if(!!Ce){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(Ce)?Ce.map(be=>this._cacheAndConvertItem(Oe,be)):[this._cacheAndConvertItem(Oe,Ce)]}}async provideCallsTo(V,J,ee){const ae=this._itemFromCache(V,J);if(!ae)throw new Error("missing call hierarchy item");const we=await this._provider.provideCallHierarchyIncomingCalls(ae,ee);if(!!we)return we.map(Ce=>({from:this._cacheAndConvertItem(V,Ce.from),fromRanges:Ce.fromRanges.map(Oe=>A.Range.from(Oe))}))}async provideCallsFrom(V,J,ee){const ae=this._itemFromCache(V,J);if(!ae)throw new Error("missing call hierarchy item");const we=await this._provider.provideCallHierarchyOutgoingCalls(ae,ee);if(!!we)return we.map(Ce=>({to:this._cacheAndConvertItem(V,Ce.to),fromRanges:Ce.fromRanges.map(Oe=>A.Range.from(Oe))}))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,J){var ee;const ae=this._cache.get(V),we={_sessionId:V,_itemId:ae.size.toString(36),name:J.name,detail:J.detail,kind:A.SymbolKind.from(J.kind),uri:J.uri,range:A.Range.from(J.range),selectionRange:A.Range.from(J.selectionRange),tags:(ee=J.tags)===null||ee===void 0?void 0:ee.map(A.SymbolTag.from)};return ae.set(we._itemId,J),we}_itemFromCache(V,J){const ee=this._cache.get(V);return ee==null?void 0:ee.get(J)}}class Ie{constructor(V,J){this.adapter=V,this.extension=J}}class ke{constructor(V,J,ee,ae,we,Ce,Oe){this._adapter=new Map,this._uriTransformer=J,this._proxy=V.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ae,this._diagnostics=we,this._logService=Ce,this._apiDeprecation=Oe}_transformDocumentSelector(V){return(0,T.coalesce)((0,T.asArray)(V).map(J=>this._doTransformDocumentSelector(J)))}_doTransformDocumentSelector(V){if(typeof V=="string")return{$serialized:!0,language:V};if(V)return{$serialized:!0,language:V.language,scheme:this._transformScheme(V.scheme),pattern:typeof V.pattern=="undefined"?void 0:A.GlobPattern.from(V.pattern),exclusive:V.exclusive}}_transformScheme(V){return this._uriTransformer&&typeof V=="string"?this._uriTransformer.transformOutgoingScheme(V):V}_createDisposable(V){return new I.Disposable(()=>{this._adapter.delete(V),this._proxy.$unregister(V)})}_nextHandle(){return ke._handlePool++}_withAdapter(V,J,ee,ae,we=!1){const Ce=this._adapter.get(V);if(!Ce)return Promise.resolve(ae);if(Ce.adapter instanceof J){let Oe;Ce.extension&&(Oe=Date.now(),this._logService.trace(`[${Ce.extension.identifier.value}] INVOKE provider '${J.name}'`));const be=ee(Ce.adapter,Ce.extension),Pe=Ce.extension;return Pe&&Promise.resolve(be).then(()=>this._logService.trace(`[${Pe.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Re=>{we&&Re instanceof b.CancellationError||(this._logService.error(`[${Pe.identifier.value}] provider FAILED`),this._logService.error(Re))}),be}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(V,J){const ee=this._nextHandle();return this._adapter.set(ee,new Ie(V,J)),ee}static _extLabel(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,J,ee,ae){const we=this._addNewAdapter(new p(this._documents,ee),V),Ce=ae&&ae.label||ke._extLabel(V);return this._proxy.$registerDocumentSymbolProvider(we,this._transformDocumentSelector(J),Ce),this._createDisposable(we)}$provideDocumentSymbols(V,J,ee){return this._withAdapter(V,p,ae=>ae.provideDocumentSymbols(_.URI.revive(J),ee),void 0)}registerCodeLensProvider(V,J,ee){const ae=this._nextHandle(),we=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ie(new c(this._documents,this._commands.converter,ee),V)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(J),we);let Ce=this._createDisposable(ae);if(we!==void 0){const Oe=ee.onDidChangeCodeLenses(be=>this._proxy.$emitCodeLensEvent(we));Ce=I.Disposable.from(Ce,Oe)}return Ce}$provideCodeLenses(V,J,ee){return this._withAdapter(V,c,ae=>ae.provideCodeLenses(_.URI.revive(J),ee),void 0)}$resolveCodeLens(V,J,ee){return this._withAdapter(V,c,ae=>ae.resolveCodeLens(J,ee),void 0)}$releaseCodeLenses(V,J){this._withAdapter(V,c,ee=>Promise.resolve(ee.releaseCodeLenses(J)),void 0)}registerDefinitionProvider(V,J,ee){const ae=this._addNewAdapter(new t(this._documents,ee),V);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDefinition(V,J,ee,ae){return this._withAdapter(V,t,we=>we.provideDefinition(_.URI.revive(J),ee,ae),[])}registerDeclarationProvider(V,J,ee){const ae=this._addNewAdapter(new n(this._documents,ee),V);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDeclaration(V,J,ee,ae){return this._withAdapter(V,n,we=>we.provideDeclaration(_.URI.revive(J),ee,ae),[])}registerImplementationProvider(V,J,ee){const ae=this._addNewAdapter(new s(this._documents,ee),V);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideImplementation(V,J,ee,ae){return this._withAdapter(V,s,we=>we.provideImplementation(_.URI.revive(J),ee,ae),[])}registerTypeDefinitionProvider(V,J,ee){const ae=this._addNewAdapter(new r(this._documents,ee),V);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideTypeDefinition(V,J,ee,ae){return this._withAdapter(V,r,we=>we.provideTypeDefinition(_.URI.revive(J),ee,ae),[])}registerHoverProvider(V,J,ee,ae){const we=this._addNewAdapter(new o(this._documents,ee),V);return this._proxy.$registerHoverProvider(we,this._transformDocumentSelector(J)),this._createDisposable(we)}$provideHover(V,J,ee,ae){return this._withAdapter(V,o,we=>we.provideHover(_.URI.revive(J),ee,ae),void 0)}registerEvaluatableExpressionProvider(V,J,ee,ae){const we=this._addNewAdapter(new l(this._documents,ee),V);return this._proxy.$registerEvaluatableExpressionProvider(we,this._transformDocumentSelector(J)),this._createDisposable(we)}$provideEvaluatableExpression(V,J,ee,ae){return this._withAdapter(V,l,we=>we.provideEvaluatableExpression(_.URI.revive(J),ee,ae),void 0)}registerInlineValuesProvider(V,J,ee,ae){const we=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ce=this._addNewAdapter(new h(this._documents,ee),V);this._proxy.$registerInlineValuesProvider(Ce,this._transformDocumentSelector(J),we);let Oe=this._createDisposable(Ce);if(we!==void 0){const be=ee.onDidChangeInlineValues(Pe=>this._proxy.$emitInlineValuesEvent(we));Oe=I.Disposable.from(Oe,be)}return Oe}$provideInlineValues(V,J,ee,ae,we){return this._withAdapter(V,h,Ce=>Ce.provideInlineValues(_.URI.revive(J),ee,ae,we),void 0)}registerDocumentHighlightProvider(V,J,ee){const ae=this._addNewAdapter(new S(this._documents,ee),V);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDocumentHighlights(V,J,ee,ae){return this._withAdapter(V,S,we=>we.provideDocumentHighlights(_.URI.revive(J),ee,ae),void 0)}registerLinkedEditingRangeProvider(V,J,ee){const ae=this._addNewAdapter(new u(this._documents,ee),V);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideLinkedEditingRanges(V,J,ee,ae){return this._withAdapter(V,u,async we=>{const Ce=await we.provideLinkedEditingRanges(_.URI.revive(J),ee,ae);if(Ce)return{ranges:Ce.ranges,wordPattern:Ce.wordPattern?ke._serializeRegExp(Ce.wordPattern):void 0}},void 0)}registerReferenceProvider(V,J,ee){const ae=this._addNewAdapter(new v(this._documents,ee),V);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideReferences(V,J,ee,ae,we){return this._withAdapter(V,v,Ce=>Ce.provideReferences(_.URI.revive(J),ee,ae,we),void 0)}registerCodeActionProvider(V,J,ee,ae){var we,Ce;const Oe=new f.DisposableStore,be=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,V,this._apiDeprecation),V);return this._proxy.$registerQuickFixSupport(be,this._transformDocumentSelector(J),{providedKinds:(we=ae==null?void 0:ae.providedCodeActionKinds)===null||we===void 0?void 0:we.map(Pe=>Pe.value),documentation:(Ce=ae==null?void 0:ae.documentation)===null||Ce===void 0?void 0:Ce.map(Pe=>({kind:Pe.kind.value,command:this._commands.converter.toInternal(Pe.command,Oe)}))},ke._extLabel(V),Boolean(ee.resolveCodeAction)),Oe.add(this._createDisposable(be)),Oe}$provideCodeActions(V,J,ee,ae,we){return this._withAdapter(V,R,Ce=>Ce.provideCodeActions(_.URI.revive(J),ee,ae,we),void 0)}$resolveCodeAction(V,J,ee){return this._withAdapter(V,R,ae=>ae.resolveCodeAction(J,ee),void 0)}$releaseCodeActions(V,J){this._withAdapter(V,R,ee=>Promise.resolve(ee.releaseCodeActions(J)),void 0)}registerDocumentFormattingEditProvider(V,J,ee){const ae=this._addNewAdapter(new L(this._documents,ee),V);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(J),V.identifier,V.displayName||V.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(V,J,ee,ae){return this._withAdapter(V,L,we=>we.provideDocumentFormattingEdits(_.URI.revive(J),ee,ae),void 0)}registerDocumentRangeFormattingEditProvider(V,J,ee){const ae=this._addNewAdapter(new H(this._documents,ee),V);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(J),V.identifier,V.displayName||V.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(V,J,ee,ae,we){return this._withAdapter(V,H,Ce=>Ce.provideDocumentRangeFormattingEdits(_.URI.revive(J),ee,ae,we),void 0)}registerOnTypeFormattingEditProvider(V,J,ee,ae){const we=this._addNewAdapter(new ie(this._documents,ee),V);return this._proxy.$registerOnTypeFormattingSupport(we,this._transformDocumentSelector(J),ae,V.identifier),this._createDisposable(we)}$provideOnTypeFormattingEdits(V,J,ee,ae,we,Ce){return this._withAdapter(V,ie,Oe=>Oe.provideOnTypeFormattingEdits(_.URI.revive(J),ee,ae,we,Ce),void 0)}registerWorkspaceSymbolProvider(V,J){const ee=this._addNewAdapter(new j(J,this._logService),V);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(V,J,ee){return this._withAdapter(V,j,ae=>ae.provideWorkspaceSymbols(J,ee),{symbols:[]})}$resolveWorkspaceSymbol(V,J,ee){return this._withAdapter(V,j,ae=>ae.resolveWorkspaceSymbol(J,ee),void 0)}$releaseWorkspaceSymbols(V,J){this._withAdapter(V,j,ee=>ee.releaseWorkspaceSymbols(J),void 0)}registerRenameProvider(V,J,ee){const ae=this._addNewAdapter(new B(this._documents,ee,this._logService),V);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(J),B.supportsResolving(ee)),this._createDisposable(ae)}$provideRenameEdits(V,J,ee,ae,we){return this._withAdapter(V,B,Ce=>Ce.provideRenameEdits(_.URI.revive(J),ee,ae,we),void 0)}$resolveRenameLocation(V,J,ee,ae){return this._withAdapter(V,B,we=>we.resolveRenameLocation(_.URI.revive(J),ee,ae),void 0)}registerDocumentSemanticTokensProvider(V,J,ee,ae){const we=this._nextHandle(),Ce=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(we,new Ie(new N(this._documents,ee),V)),this._proxy.$registerDocumentSemanticTokensProvider(we,this._transformDocumentSelector(J),ae,Ce);let Oe=this._createDisposable(we);if(Ce){const be=ee.onDidChangeSemanticTokens(Pe=>this._proxy.$emitDocumentSemanticTokensEvent(Ce));Oe=I.Disposable.from(Oe,be)}return Oe}$provideDocumentSemanticTokens(V,J,ee,ae){return this._withAdapter(V,N,we=>we.provideDocumentSemanticTokens(_.URI.revive(J),ee,ae),null,!0)}$releaseDocumentSemanticTokens(V,J){this._withAdapter(V,N,ee=>ee.releaseDocumentSemanticColoring(J),void 0)}registerDocumentRangeSemanticTokensProvider(V,J,ee,ae){const we=this._addNewAdapter(new M(this._documents,ee),V);return this._proxy.$registerDocumentRangeSemanticTokensProvider(we,this._transformDocumentSelector(J),ae),this._createDisposable(we)}$provideDocumentRangeSemanticTokens(V,J,ee,ae){return this._withAdapter(V,M,we=>we.provideDocumentRangeSemanticTokens(_.URI.revive(J),ee,ae),null,!0)}registerCompletionItemProvider(V,J,ee,ae){const we=this._addNewAdapter(new F(this._documents,this._commands.converter,ee,this._apiDeprecation,V),V);return this._proxy.$registerSuggestSupport(we,this._transformDocumentSelector(J),ae,F.supportsResolving(ee),`${V.identifier.value}(${ae.join("")})`),this._createDisposable(we)}$provideCompletionItems(V,J,ee,ae,we){return this._withAdapter(V,F,Ce=>Ce.provideCompletionItems(_.URI.revive(J),ee,ae,we),void 0)}$resolveCompletionItem(V,J,ee){return this._withAdapter(V,F,ae=>ae.resolveCompletionItem(J,ee),void 0)}$releaseCompletionItems(V,J){this._withAdapter(V,F,ee=>ee.releaseCompletionItems(J),void 0)}registerSignatureHelpProvider(V,J,ee,ae){const we=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,Ce=this._addNewAdapter(new U(this._documents,ee),V);return this._proxy.$registerSignatureHelpProvider(Ce,this._transformDocumentSelector(J),we),this._createDisposable(Ce)}$provideSignatureHelp(V,J,ee,ae,we){return this._withAdapter(V,U,Ce=>Ce.provideSignatureHelp(_.URI.revive(J),ee,ae,we),void 0)}$releaseSignatureHelp(V,J){this._withAdapter(V,U,ee=>ee.releaseSignatureHelp(J),void 0)}registerInlineHintsProvider(V,J,ee){const ae=typeof ee.onDidChangeInlineHints=="function"?this._nextHandle():void 0,we=this._addNewAdapter(new O(this._documents,ee),V);this._proxy.$registerInlineHintsProvider(we,this._transformDocumentSelector(J),ae);let Ce=this._createDisposable(we);if(ae!==void 0){const Oe=ee.onDidChangeInlineHints(be=>this._proxy.$emitInlineHintsEvent(ae));Ce=I.Disposable.from(Ce,Oe)}return Ce}$provideInlineHints(V,J,ee,ae){return this._withAdapter(V,O,we=>we.provideInlineHints(_.URI.revive(J),ee,ae),void 0)}registerDocumentLinkProvider(V,J,ee){const ae=this._addNewAdapter(new W(this._documents,ee),V);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(J),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(V,J,ee){return this._withAdapter(V,W,ae=>ae.provideLinks(_.URI.revive(J),ee),void 0)}$resolveDocumentLink(V,J,ee){return this._withAdapter(V,W,ae=>ae.resolveLink(J,ee),void 0)}$releaseDocumentLinks(V,J){this._withAdapter(V,W,ee=>ee.releaseLinks(J),void 0)}registerColorProvider(V,J,ee){const ae=this._addNewAdapter(new q(this._documents,ee),V);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDocumentColors(V,J,ee){return this._withAdapter(V,q,ae=>ae.provideColors(_.URI.revive(J),ee),[])}$provideColorPresentations(V,J,ee,ae){return this._withAdapter(V,q,we=>we.provideColorPresentations(_.URI.revive(J),ee,ae),void 0)}registerFoldingRangeProvider(V,J,ee){const ae=this._nextHandle(),we=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ie(new Q(this._documents,ee),V)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(J),we);let Ce=this._createDisposable(ae);if(we!==void 0){const Oe=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(we));Ce=I.Disposable.from(Ce,Oe)}return Ce}$provideFoldingRanges(V,J,ee,ae){return this._withAdapter(V,Q,we=>we.provideFoldingRanges(_.URI.revive(J),ee,ae),void 0)}registerSelectionRangeProvider(V,J,ee){const ae=this._addNewAdapter(new he(this._documents,ee,this._logService),V);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideSelectionRanges(V,J,ee,ae){return this._withAdapter(V,he,we=>we.provideSelectionRanges(_.URI.revive(J),ee,ae),[])}registerCallHierarchyProvider(V,J,ee){const ae=this._addNewAdapter(new ve(this._documents,ee),V);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$prepareCallHierarchy(V,J,ee,ae){return this._withAdapter(V,ve,we=>Promise.resolve(we.prepareSession(_.URI.revive(J),ee,ae)),void 0)}$provideCallHierarchyIncomingCalls(V,J,ee,ae){return this._withAdapter(V,ve,we=>we.provideCallsTo(J,ee,ae),void 0)}$provideCallHierarchyOutgoingCalls(V,J,ee,ae){return this._withAdapter(V,ve,we=>we.provideCallsFrom(J,ee,ae),void 0)}$releaseCallHierarchy(V,J){this._withAdapter(V,ve,ee=>Promise.resolve(ee.releaseSession(J)),void 0)}static _serializeRegExp(V){return{pattern:V.source,flags:(0,D.regExpFlags)(V)}}static _serializeIndentationRule(V){return{decreaseIndentPattern:ke._serializeRegExp(V.decreaseIndentPattern),increaseIndentPattern:ke._serializeRegExp(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?ke._serializeRegExp(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?ke._serializeRegExp(V.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(V){return{beforeText:ke._serializeRegExp(V.beforeText),afterText:V.afterText?ke._serializeRegExp(V.afterText):void 0,previousLineText:V.previousLineText?ke._serializeRegExp(V.previousLineText):void 0,action:V.action}}static _serializeOnEnterRules(V){return V.map(ke._serializeOnEnterRule)}setLanguageConfiguration(V,J,ee){let{wordPattern:ae}=ee;if(ae&&(0,D.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(J,ae):this._documents.setWordDefinitionFor(J,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const we=this._nextHandle(),Ce={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?ke._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?ke._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?ke._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(we,J,Ce),this._createDisposable(we)}$setWordDefinitions(V){for(const J of V)this._documents.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.ExtHostLanguageFeatures=ke,ke._handlePool=0}),define(me[240],ge([0,1,5,20,7]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class I{constructor(P,D){this._proxy=P.getProxy(_.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,D){await this._proxy.$changeLanguage(P,D);const i=this._documents.getDocumentData(P);if(!i)throw new Error(`document '${P.toString}' NOT found`);return i.document}async tokenAtPosition(P,D){var i;const T=P.version,C=k.Position.from(D),m=await this._proxy.$tokensAtPosition(P.uri,C),f={type:A.StandardTokenType.Other,range:(i=P.getWordRangeAtPosition(D))!==null&&i!==void 0?i:new A.Range(D.line,D.character,D.line,D.character)};if(!m)return f;const a={range:k.Range.to(m.range),type:k.TokenType.to(m.type)};return!a.range.contains(D)||T!==P.version?f:a}}e.ExtHostLanguages=I}),define(me[241],ge([0,1,5,13,41]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function I(P){return P&&P.title}let y=class{constructor(D,i){this._logService=i,this._proxy=D.getProxy(_.MainContext.MainThreadMessageService)}showMessage(D,i,T,C,m){const f={extension:D};let a;typeof C=="string"||I(C)?a=[C,...m]:(f.modal=C&&C.modal,f.useCustom=C&&C.useCustom,a=m),f.useCustom&&(0,A.checkProposedApiEnabled)(D);const d=[];for(let E=0;E<a.length;E++){const w=a[E];if(typeof w=="string")d.push({title:w,handle:E,isCloseAffordance:!1});else if(typeof w=="object"){let{title:b,isCloseAffordance:p}=w;d.push({title:b,isCloseAffordance:!!p,handle:E})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(i,T,f,d).then(E=>{if(typeof E=="number")return a[E]})}};y=je([Be(1,k.ILogService)],y),e.ExtHostMessageService=y}),define(me[242],ge([0,1,21,3,6,2,28,5,20,7,63,88,24,218,219,72,12,22,74,86]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d,E,w,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class c extends A.Disposable{constructor(l,h,S,u,v){super();this._editorId=l,this.uri=h,this._proxy=S,this._webviewInitData=u,this.document=v,this._onDidReceiveDocumentMessage=new k.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:R=>this._proxy.$postMessage(this._editorId,void 0,R),asWebviewUri:R=>this._asWebviewUri(R)}}onDidReceiveMessage(l,h){var S;this._onDidReceiveDocumentMessage.fire(h),l!==void 0&&((S=this._rendererIdToEmitters.get(l))===null||S===void 0||S.fire(h))}getRendererComm(l){const h=new k.Emitter;return this._rendererIdToEmitters.set(l,h),{editorId:this._editorId,onDidReceiveMessage:h.event,postMessage:S=>this._proxy.$postMessage(this._editorId,l,S),asWebviewUri:S=>this._asWebviewUri(S)}}_asWebviewUri(l){return(0,T.asWebviewUri)(this._webviewInitData,this._editorId,l)}}class g extends A.Disposable{constructor(l,h,S,u){super();this._proxy=l,this._handle=h,this._extension=S,this._provider=u,this._kernelToFriendlyId=new m.ResourceMap,this._friendlyIdToKernel=new m.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(v=>{const R=v==null?void 0:v.uri;this._proxy.$onNotebookKernelChange(this._handle,R)}))}async provideKernels(l,h){const S=await this._provider.provideKernels(l.notebookDocument,h)||[],u=new Map;let v=0;const R=new Set,L=this._kernelToFriendlyId.get(l.uri),H=S.map(j=>{var B;let $=L==null?void 0:L.get(j);return $===void 0&&(j.id&&R.has(j.id)?$=`${this._extension.identifier.value}_${j.id}_${v++}`:$=`${this._extension.identifier.value}_${j.id||y.generateUuid()}`),u.set(j,$),{id:j.id,friendlyId:$,label:j.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:j.description,detail:j.detail,isPreferred:j.isPreferred,preloads:(B=j.preloads)===null||B===void 0?void 0:B.map(N=>(I.URI.isUri(N)&&(N={uri:N,provides:[]}),{uri:N.uri,provides:typeof N.provides=="string"?[N.provides]:N.provides===void 0?[]:N.provides})),supportedLanguages:j.supportedLanguages,implementsInterrupt:!!j.interrupt}});this._kernelToFriendlyId.set(l.uri,u);const ie=new Map;return u.forEach((j,B)=>{ie.set(j,B)}),this._friendlyIdToKernel.set(l.uri,ie),H}getKernelByFriendlyId(l,h){var S;return(S=this._friendlyIdToKernel.get(l))===null||S===void 0?void 0:S.get(h)}async resolveNotebook(l,h,S,u){var v;const R=(v=this._friendlyIdToKernel.get(h.uri))===null||v===void 0?void 0:v.get(l);if(R&&this._provider.resolveKernel)return this._provider.resolveKernel(R,h.notebookDocument,S,u)}async executeNotebook(l,h,S){var u;const v=(u=this._friendlyIdToKernel.get(h.uri))===null||u===void 0?void 0:u.get(l);if(!!v){const R=S.map(L=>D.NotebookRange.to(L));return v.executeCellsRequest(h.notebookDocument,R)}}async interruptNotebookExecution(l,h){var S;const u=(S=this._friendlyIdToKernel.get(h.uri))===null||S===void 0?void 0:S.get(l);if(!(!u||!u.interrupt))return u.interrupt(h.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=g;class t{constructor(l,h){const S=t._Keys.nextId();l.$registerNotebookEditorDecorationType(S,D.NotebookDecorationRenderOptions.from(h)),this.value={key:S,dispose(){l.$removeNotebookEditorDecorationType(S)}}}}e.NotebookEditorDecorationType=t,t._Keys=new d.IdGenerator("NotebookEditorDecorationType");class n{constructor(l,h,S,u,v,R,L){this._textDocumentsAndEditors=S,this._textDocuments=u,this._webviewInitData=v,this.logService=R,this._extensionStoragePaths=L,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new m.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new k.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new k.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new k.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new k.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new k.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new k.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new k.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new k.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new k.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new k.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new k.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new k.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new k.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new m.ResourceMap,this._statusBarCache=new p.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(P.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(P.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(P.MainContext.MainThreadNotebookEditors),this._commandsConverter=h.converter,h.registerArgumentProcessor({processArgument:H=>{var ie;if(H&&H.$mid===12){const j=(ie=H.notebookEditor)===null||ie===void 0?void 0:ie.notebookUri,B=H.cell.handle,$=this._documents.get(j),N=$==null?void 0:$.getCell(B);if(N)return N.cell}return H}})}get activeNotebookEditor(){var l;return(l=this._activeNotebookEditor)===null||l===void 0?void 0:l.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){return this._editors.get(l)}getIdByEditor(l){for(const[h,S]of this._editors)if(S.apiEditor===l)return h}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(l){return this._documents.get(l)}_getNotebookDocument(l){const h=this._documents.get(l);if(!h)throw new Error(`NO notebook document for '${l}'`);return h}_getProviderData(l){const h=this._notebookContentProviders.get(l);if(!h)throw new Error(`NO provider for '${l}'`);return h}registerNotebookContentProvider(l,h,S,u){var v,R,L;if(this._notebookContentProviders.has(h))throw new Error(`Notebook provider for '${h}' already registered`);this._notebookContentProviders.set(h,{extension:l,provider:S});let H;S.onDidChangeNotebookContentOptions&&(H=S.onDidChangeNotebookContentOptions(()=>{const B=D.NotebookDocumentContentOptions.from(S.options);this._notebookProxy.$updateNotebookProviderOptions(h,B)}));const ie=(v=u==null?void 0:u.viewOptions)===null||v===void 0?void 0:v.filenamePattern.map(B=>D.NotebookExclusiveDocumentPattern.from(B)).filter(B=>B!==void 0);((R=u==null?void 0:u.viewOptions)===null||R===void 0?void 0:R.filenamePattern)&&!ie&&console.warn(`Notebook content provider view options file name pattern is invalid ${(L=u==null?void 0:u.viewOptions)===null||L===void 0?void 0:L.filenamePattern}`);const j=D.NotebookDocumentContentOptions.from(u);return this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation,description:l.description},h,{transientOutputs:j.transientOutputs,transientCellMetadata:j.transientCellMetadata,transientDocumentMetadata:j.transientDocumentMetadata,viewOptions:(u==null?void 0:u.viewOptions)&&ie?{displayName:u.viewOptions.displayName,filenamePattern:ie,exclusive:u.viewOptions.exclusive||!1}:void 0}),new i.Disposable(()=>{H==null||H.dispose(),this._notebookContentProviders.delete(h),this._notebookProxy.$unregisterNotebookProvider(h)})}registerNotebookKernelProvider(l,h,S){const u=n._notebookKernelProviderHandlePool++,v=new g(this._notebookProxy,u,l,S);return this._notebookKernelProviders.set(u,v),this._notebookProxy.$registerNotebookKernelProvider({id:l.identifier,location:l.extensionLocation,description:l.description},u,{viewType:h.viewType,filenamePattern:h.filenamePattern?D.NotebookExclusiveDocumentPattern.from(h.filenamePattern):void 0}),new i.Disposable(()=>{v.dispose(),this._notebookKernelProviders.delete(u),this._notebookProxy.$unregisterNotebookKernelProvider(u)})}registerNotebookCellStatusBarItemProvider(l,h,S){const u=n._notebookStatusBarItemProviderHandlePool++,v=typeof S.onDidChangeCellStatusBarItems=="function"?n._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(u,S),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(u,v,{viewType:h.viewType,filenamePattern:h.filenamePattern?D.NotebookExclusiveDocumentPattern.from(h.filenamePattern):void 0});let R;return v!==void 0&&(R=S.onDidChangeCellStatusBarItems(L=>this._notebookProxy.$emitCellStatusBarEvent(v))),new i.Disposable(()=>{this._notebookStatusBarItemProviders.delete(u),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(u,v),R&&R.dispose()})}createNotebookEditorDecorationType(l){return new t(this._notebookEditorsProxy,l).value}async openNotebookDocument(l){const h=this._documents.get(l);if(h)return h.notebookDocument;const S=await this._notebookDocumentsProxy.$tryOpenDocument(l),u=this._documents.get(I.URI.revive(S));return(0,E.assertIsDefined)(u==null?void 0:u.notebookDocument)}_withAdapter(l,h,S){const u=this._documents.get(I.URI.revive(h));if(!u)return[];const v=this._notebookKernelProviders.get(l);return v?S(v,u):[]}async showNotebookDocument(l,h){var S;I.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let u;typeof h=="object"?u={position:D.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(D.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:u={preserveFocus:!1};const v=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.viewType,u),R=v&&((S=this._editors.get(v))===null||S===void 0?void 0:S.apiEditor);if(R)return R;throw v?new Error(`Could NOT open editor for "${l.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.toString()}".`)}async $provideNotebookKernels(l,h,S){return this._withAdapter(l,h,(u,v)=>u.provideKernels(v,S))}async $resolveNotebookKernel(l,h,S,u,v){await this._withAdapter(l,S,async(R,L)=>{const H=this._webviewComm.get(h);H&&await R.resolveNotebook(u,L,H.contentProviderComm,v)})}async $provideNotebookCellStatusBarItems(l,h,S,u){var v;const R=this._notebookStatusBarItemProviders.get(l),L=I.URI.revive(h),H=this._documents.get(L);if(!(!H||!R)){const ie=H.getCellFromIndex(S);if(!!ie){const j=await R.provideCellStatusBarItems(ie.cell,u);if(!!j){const B=new A.DisposableStore,$=this._statusBarCache.add([B]),N=(v=j&&j.map(M=>D.NotebookStatusBarItem.from(M,this._commandsConverter,B)))!==null&&v!==void 0?v:void 0;return{cacheId:$,items:N}}}}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}async $resolveNotebookEditor(l,h,S){const u=this._notebookContentProviders.get(l),v=I.URI.revive(h),R=this._documents.get(v);if(!(!R||!u)){let L=this._webviewComm.get(S);L||(L=new c(S,v,this._notebookProxy,this._webviewInitData,R),this._webviewComm.set(S,L))}}async $executeNotebookKernelFromProvider(l,h,S,u){await this._withAdapter(l,h,async(v,R)=>v.executeNotebook(S,R,u))}registerNotebookSerializer(l,h,S,u){const v=this._handlePool++;this._notebookSerializer.set(v,S);const R=D.NotebookDocumentContentOptions.from(u);return this._notebookProxy.$registerNotebookSerializer(v,{id:l.identifier,location:l.extensionLocation,description:l.description},h,R),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(v)})}async $dataToNotebook(l,h,S){const u=this._notebookSerializer.get(l);if(!u)throw new Error("NO serializer found");const v=await u.deserializeNotebook(h.buffer,S);return{metadata:D.NotebookDocumentMetadata.from(v.metadata),cells:v.cells.map(D.NotebookCellData.from)}}async $notebookToData(l,h,S){const u=this._notebookSerializer.get(l);if(!u)throw new Error("NO serializer found");const v=await u.serializeNotebook({metadata:D.NotebookDocumentMetadata.to(h.metadata),cells:h.cells.map(D.NotebookCellData.to)},S);return w.VSBuffer.wrap(v)}async $cancelNotebookCellExecution(l,h,S,u){await this._withAdapter(l,h,async(R,L)=>R.interruptNotebookExecution(S,L));const v=this._documents.get(I.URI.revive(h));if(!!v)for(let R of u)for(let L=R.start;L<R.end;L++){const H=v.getCellFromIndex(L);H&&this.cancelOneNotebookCellExecution(H)}}cancelOneNotebookCellExecution(l){const h=this._activeExecutions.get(l.uri);h==null||h.cancel()}async $openNotebook(l,h,S,u,v){const{provider:R}=this._getProviderData(l),L=await R.openNotebook(I.URI.revive(h),{backupId:S,untitledDocumentData:u==null?void 0:u.buffer},v);return{metadata:D.NotebookDocumentMetadata.from(L.metadata),cells:L.cells.map(D.NotebookCellData.from)}}async $saveNotebook(l,h,S){const u=this._getNotebookDocument(I.URI.revive(h)),{provider:v}=this._getProviderData(l);return await v.saveNotebook(u.notebookDocument,S),!0}async $saveNotebookAs(l,h,S,u){const v=this._getNotebookDocument(I.URI.revive(h)),{provider:R}=this._getProviderData(l);return await R.saveNotebookAs(I.URI.revive(S),v.notebookDocument,u),!0}async $backupNotebook(l,h,S){var u;const v=this._getNotebookDocument(I.URI.revive(h)),R=this._getProviderData(l),L=(u=this._extensionStoragePaths.workspaceValue(R.extension))!==null&&u!==void 0?u:this._extensionStoragePaths.globalValue(R.extension),H=String((0,b.hash)([v.uri.toString(),this._backupIdPool++])),ie=I.URI.joinPath(L,H),j=await R.provider.backupNotebook(v.notebookDocument,{destination:ie},S);return v.updateBackup(j),j.id}$acceptNotebookActiveKernelChange(l){l.providerHandle!==void 0&&this._withAdapter(l.providerHandle,l.uri,async(h,S)=>{const u=l.kernelFriendlyId?h.getKernelByFriendlyId(I.URI.revive(l.uri),l.kernelFriendlyId):void 0;this._editors.forEach(v=>{v.notebookData===S&&v._acceptKernel(u)}),this._onDidChangeActiveNotebookKernel.fire({document:S.notebookDocument,kernel:u})})}$onDidReceiveMessage(l,h,S){var u;(u=this._webviewComm.get(l))===null||u===void 0||u.onDidReceiveMessage(h,S)}$acceptModelChanged(l,h,S){this._getNotebookDocument(I.URI.revive(l)).acceptModelChanged(h,S)}$acceptDirtyStateChanged(l,h){const S=this._getNotebookDocument(I.URI.revive(l));S.acceptModelChanged({rawEvents:[],versionId:S.notebookDocument.version},h)}$acceptModelSaved(l){const h=this._getNotebookDocument(I.URI.revive(l));this._onDidSaveNotebookDocument.fire(h.notebookDocument)}$acceptEditorPropertiesChanged(l,h){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",l,h);const S=this._editors.get(l);if(!S)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);h.visibleRanges&&S._acceptVisibleRanges(h.visibleRanges.ranges.map(D.NotebookRange.to)),h.selections&&S._acceptSelections(h.selections.selections.map(D.NotebookRange.to)),h.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:S.apiEditor,visibleRanges:S.apiEditor.visibleRanges}),h.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:S.apiEditor,selections:S.apiEditor.selections}))}$acceptEditorViewColumns(l){for(const h in l){const S=this._editors.get(h);if(!S)throw new Error(`unknown text editor: ${h}. known editors: ${[...this._editors.keys()]} `);S._acceptViewColumn(D.ViewColumn.to(l[h]))}}$acceptDocumentPropertiesChanged(l,h){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",l.path,h);const S=this._getNotebookDocument(I.URI.revive(l));S.acceptDocumentPropertiesChanged(h),h.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:S.notebookDocument})}_createExtHostEditor(l,h,S){if(this._editors.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const u=l.uri;let v=this._webviewComm.get(h);v||(v=new c(h,u,this._notebookProxy,this._webviewInitData,l),this._webviewComm.set(h,v));const R=new a.ExtHostNotebookEditor(h,this._notebookEditorsProxy,l,S.visibleRanges.map(D.NotebookRange.to),S.selections.map(D.NotebookRange.to),typeof S.viewColumn=="number"?D.ViewColumn.to(S.viewColumn):void 0);this._editors.set(h,R)}$acceptDocumentAndEditorsDelta(l){var h,S,u;if(l.removedDocuments)for(const R of l.removedDocuments){const L=I.URI.revive(R),H=this._documents.get(L);H&&(H.dispose(),this._documents.delete(L),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:H.notebookDocument.getCells().map(ie=>ie.document.uri)}),this._onDidCloseNotebookDocument.fire(H.notebookDocument));for(const ie of this._editors.values())ie.notebookData.uri.toString()===L.toString()&&this._editors.delete(ie.id)}if(l.addedDocuments){const R=[];for(const L of l.addedDocuments){const H=I.URI.revive(L.uri),ie=L.viewType;if(this._documents.has(H))throw new Error(`adding EXISTING notebook ${H} `);const j=this,B=new f.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange($){j._onDidChangeNotebookCells.fire($)},emitCellOutputsChange($){j._onDidChangeCellOutputs.fire($)},emitCellMetadataChange($){j._onDidChangeCellMetadata.fire($)},emitCellExecutionStateChange($){j._onDidChangeCellExecutionState.fire($)}},ie,L.metadata?D.NotebookDocumentMetadata.to(L.metadata):new i.NotebookDocumentMetadata,H);B.acceptModelChanged({versionId:L.versionId,rawEvents:[{kind:C.NotebookCellsChangeType.Initialize,changes:[[0,0,L.cells]]}]},!1),R.push(...L.cells.map($=>f.ExtHostCell.asModelAddData(B.notebookDocument,$))),(h=this._documents.get(H))===null||h===void 0||h.dispose(),this._documents.set(H,B),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:R}),this._onDidOpenNotebookDocument.fire(B.notebookDocument)}}if(l.addedEditors)for(const R of l.addedEditors){if(this._editors.has(R.id))return;const L=I.URI.revive(R.documentUri),H=this._documents.get(L);H&&this._createExtHostEditor(H,R.id,R)}const v=[];if(l.removedEditors)for(const R of l.removedEditors){const L=this._editors.get(R);L&&(this._editors.delete(R),((S=this._activeNotebookEditor)===null||S===void 0?void 0:S.id)===L.id&&(this._activeNotebookEditor=void 0),v.push(L))}if(l.visibleEditors){this._visibleNotebookEditors=l.visibleEditors.map(L=>this._editors.get(L)).filter(L=>!!L);const R=new Set;this._visibleNotebookEditors.forEach(L=>R.add(L.id));for(const L of this._editors.values()){const H=R.has(L.id);L._acceptVisibility(H)}this._visibleNotebookEditors=[...this._editors.values()].map(L=>L).filter(L=>L.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.newActiveEditor===null?this._activeNotebookEditor=void 0:l.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.newActiveEditor)),l.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((u=this._activeNotebookEditor)===null||u===void 0?void 0:u.apiEditor)}createNotebookCellExecution(l,h,S){const u=this.lookupNotebookDocument(l);if(!u)throw new Error(`Invalid cell uri / index: ${l}, ${h} `);const v=u.getCellFromIndex(h);if(!v)throw new Error(`Invalid cell uri / index: ${l}, ${h} `);if(!this._activeExecutions.has(v.uri)){const R=new r(l,u,v,this._notebookDocumentsProxy);this._activeExecutions.set(v.uri,R);const L=R.onDidChangeState(()=>{R.state===s.Resolved&&(R.dispose(),L.dispose(),this._activeExecutions.delete(v.uri))});return R.asApiObject()}}}e.ExtHostNotebookController=n,n._notebookKernelProviderHandlePool=0,n._notebookStatusBarItemProviderHandlePool=0;var s;(function(o){o[o.Init=0]="Init",o[o.Started=1]="Started",o[o.Resolved=2]="Resolved"})(s||(s={}));class r extends A.Disposable{constructor(l,h,S,u){super();this._uri=l,this._document=h,this._cell=S,this._proxy=u,this._onDidChangeState=new k.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new _.CancellationTokenSource),this._executionOrder=S.internalMetadata.executionOrder,this.mixinMetadata({runState:i.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(l){return this._proxy.$applyEdits(this._uri,l,!1)}verifyStateForOutput(){if(this._state===s.Init)throw new Error("Must call start before modifying cell output");if(this._state===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(l){const h=[{editType:11,handle:this._cell.handle,metadata:l}];this.applyEdits(h)}cellIndexToHandle(l){const h=typeof l=="number"?this._document.getCellFromIndex(l):this._cell;if(!!h)return h.handle}asApiObject(){const l=this;return Object.freeze({get document(){return l._document.notebookDocument},get cell(){return l._cell.cell},get executionOrder(){return l._executionOrder},set executionOrder(h){l._executionOrder=h,l.mixinMetadata({executionOrder:h})},start(h){if(l._state===s.Resolved||l._state===s.Started)throw new Error("Cannot call start again");l._state=s.Started,l._onDidChangeState.fire(),l.mixinMetadata({runState:i.NotebookCellExecutionState.Executing,runStartTime:h==null?void 0:h.startTime})},end(h){var S,u;if(l._state===s.Resolved)throw new Error("Cannot call resolve twice");l._state=s.Resolved,l._onDidChangeState.fire(),l.mixinMetadata({runState:i.NotebookCellExecutionState.Idle,lastRunSuccess:(S=h==null?void 0:h.success)!==null&&S!==void 0?S:null,runEndTime:(u=h==null?void 0:h.endTime)!==null&&u!==void 0?u:null})},clearOutput(h){return l.verifyStateForOutput(),this.replaceOutput([],h)},async appendOutput(h,S){l.verifyStateForOutput();const u=l.cellIndexToHandle(S);if(typeof u=="number")return h=Array.isArray(h)?h:[h],l.applyEdits([{editType:2,handle:u,append:!0,outputs:h.map(D.NotebookCellOutput.from)}])},async replaceOutput(h,S){l.verifyStateForOutput();const u=l.cellIndexToHandle(S);if(typeof u=="number")return h=Array.isArray(h)?h:[h],l.applyEdits([{editType:2,handle:u,outputs:h.map(D.NotebookCellOutput.from)}])},async appendOutputItems(h,S){return l.verifyStateForOutput(),h=Array.isArray(h)?h:[h],l.applyEdits([{editType:10,append:!0,items:h.map(D.NotebookCellOutputItem.from),outputId:S}])},async replaceOutputItems(h,S){return l.verifyStateForOutput(),h=Array.isArray(h)?h:[h],l.applyEdits([{editType:10,items:h.map(D.NotebookCellOutputItem.from),outputId:S}])},token:l._tokenSource.token})}}}),define(me[243],ge([0,1,3,6,5,2,20,15,63]),function(G,e,_,k,A,I,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class i{constructor(C,m,f){this._initData=m,this._extHostNotebook=f,this._kernelData=new Map,this._handlePool=0,this._proxy=C.getProxy(A.MainContext.MainThreadNotebookKernels)}createNotebookController(C,m,f,a,d,E){for(let v of this._kernelData.values())if(v.controller.id===m)throw new Error(`notebook controller with id '${m}' ALREADY exist`);const w=this._handlePool++,b=this,p=["plaintext"],c=()=>console.warn(`NO execute handler from notebook controller '${r.id}' of extension: '${C.identifier}'`);let g=!1;const t=new k.DisposableStore,n=new _.Emitter,s=new _.Emitter,r={id:m,selector:f,extensionId:C.identifier,extensionLocation:C.extensionLocation,label:a||C.identifier.value,supportedLanguages:p,preloads:E?E.map(y.NotebookKernelPreload.from):[]};let o=d!=null?d:c,l;this._proxy.$addKernel(w,r).catch(v=>{console.log(v),g=!0});let h=0;const S=()=>{if(!g){const v=++h;Promise.resolve().then(()=>{v===h&&this._proxy.$updateKernel(w,r)})}},u={get id(){return r.id},get selector(){return r.selector},onDidChangeNotebookAssociation:n.event,get label(){return r.label},set label(v){var R;r.label=(R=v!=null?v:C.displayName)!==null&&R!==void 0?R:C.name,S()},get description(){var v;return(v=r.description)!==null&&v!==void 0?v:""},set description(v){r.description=v,S()},get isPreferred(){var v;return(v=r.isPreferred)!==null&&v!==void 0?v:!1},set isPreferred(v){r.isPreferred=v,S()},get supportedLanguages(){return r.supportedLanguages},set supportedLanguages(v){r.supportedLanguages=(0,P.isNonEmptyArray)(v)?v:p,S()},get hasExecutionOrder(){var v;return(v=r.hasExecutionOrder)!==null&&v!==void 0?v:!1},set hasExecutionOrder(v){r.hasExecutionOrder=v,S()},get preloads(){return r.preloads?r.preloads.map(y.NotebookKernelPreload.to):[]},get executeHandler(){return o},set executeHandler(v){o=v!=null?v:c},get interruptHandler(){return l},set interruptHandler(v){l=v,r.supportsInterrupt=Boolean(v),S()},createNotebookCellExecutionTask(v){if(g)throw new Error("notebook controller is DISPOSED");return b._extHostNotebook.createNotebookCellExecution(v.notebook.uri,v.index,r.id)},dispose:()=>{g||(g=!0,this._kernelData.delete(w),t.dispose(),n.dispose(),s.dispose(),this._proxy.$removeKernel(w))},onDidReceiveMessage:s.event,postMessage(v,R){return b._proxy.$postMessage(w,R&&b._extHostNotebook.getIdByEditor(R),v)},asWebviewUri(v){return(0,D.asWebviewUri)(b._initData.environment,r.id,v)}};return this._kernelData.set(w,{extensionId:C.identifier,controller:u,onDidChangeSelection:n,onDidReceiveMessage:s}),u}$acceptSelection(C,m,f){const a=this._kernelData.get(C);a&&a.onDidChangeSelection.fire({selected:f,notebook:this._extHostNotebook.lookupNotebookDocument(I.URI.revive(m)).notebookDocument})}$executeCells(C,m,f){const a=this._kernelData.get(C);if(!!a){const d=this._extHostNotebook.lookupNotebookDocument(I.URI.revive(m));if(!d)throw new Error("MISSING notebook");const E=[];for(let w of f)E.push(...d.notebookDocument.getCells(y.NotebookRange.to(w)));try{a.controller.executeHandler.call(a.controller,E,a.controller)}catch(w){console.error(w)}}}$cancelCells(C,m,f){const a=this._kernelData.get(C);if(!!a){const d=this._extHostNotebook.lookupNotebookDocument(I.URI.revive(m));if(!d)throw new Error("MISSING notebook");a.controller.interruptHandler&&a.controller.interruptHandler.call(a.controller);for(const E of f)for(let w=E.start;w<E.end;w++){const b=d.getCellFromIndex(w);b&&this._extHostNotebook.cancelOneNotebookCellExecution(b)}}}$acceptRendererMessage(C,m,f){const a=this._kernelData.get(C);if(!!a){const d=this._extHostNotebook.getEditorById(m);if(!d)throw new Error(`send message for UNKNOWN editor: ${m}`);a.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:f}))}}}e.ExtHostNotebookKernels=i}),define(me[65],ge([0,1,5,3,6,22,4,14]),function(G,e,_,k,A,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends A.Disposable{constructor(a,d,E,w){super();this._onDidAppend=this._register(new k.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=w,this._id=w.$register(this.name,d,E),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?I.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(d=>this._proxy.$clear(d,a))}show(a,d){this.validate(),this._id.then(E=>this._proxy.$reveal(E,!!(typeof a=="boolean"?a:d)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class i extends D{constructor(a,d){super(a,!1,void 0,d)}append(a){super.append(a),this._id.then(d=>this._proxy.$append(d,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=i;class T extends D{constructor(a,d,E){super(a,!0,d,E)}append(a){throw new Error("Not supported")}}class C{constructor(a,d){this.name=a,this._channel=d}append(a){this._channel.then(d=>d.append(a))}appendLine(a){this._channel.then(d=>d.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,d){this._channel.then(E=>E.show(a,d))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=C;let m=class{constructor(a){this._proxy=a.getProxy(_.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new i(a,this._proxy)}createOutputChannelFromLogFile(a,d){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!d)throw new Error("illegal argument `file`. must not be falsy");return new T(a,d,this._proxy)}};m=je([Be(0,P.IExtHostRpcService)],m),e.ExtHostOutputService=m,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(me[244],ge([0,1,19,21,3,6,5,2,7,18,15,57]),function(G,e,_,k,A,I,y,P,D,i,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(f,a,d){const E=f.getProxy(y.MainContext.MainThreadQuickOpen);class w{constructor(r,o){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=o}showQuickPick(r,o,l,h=k.CancellationToken.None){this._onDidSelectItem=void 0;const S=Promise.resolve(r),u=++this._instances,v=E.$show(u,{title:l==null?void 0:l.title,placeHolder:l==null?void 0:l.placeHolder,matchOnDescription:l==null?void 0:l.matchOnDescription,matchOnDetail:l==null?void 0:l.matchOnDetail,ignoreFocusLost:l==null?void 0:l.ignoreFocusOut,canPickMany:l==null?void 0:l.canPickMany},h),R={},L=v.then(()=>R);return Promise.race([L,S]).then(H=>{if(H!==R)return S.then(ie=>{const j=[];for(let B=0;B<ie.length;B++){const $=ie[B];let N,M,F,U,O;typeof $=="string"?N=$:(N=$.label,M=$.description,F=$.detail,U=$.picked,O=$.alwaysShow),j.push({label:N,description:M,handle:B,detail:F,picked:U,alwaysShow:O})}return l&&typeof l.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{l.onDidSelectItem(ie[B])}),E.$setItems(u,j),v.then(B=>{if(typeof B=="number")return ie[B];if(Array.isArray(B))return B.map($=>ie[$])})})}).then(void 0,H=>{if(!(0,i.isPromiseCanceledError)(H))return E.$setError(u,H),Promise.reject(H)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,o=k.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,E.$input(r,typeof this._validateInput=="function",o).then(void 0,l=>{if(!(0,i.isPromiseCanceledError)(l))return Promise.reject(l)})}$validateInput(r){return this._validateInput?(0,_.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,o=k.CancellationToken.None){const l=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!!l){const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(S=>S.uri.toString()===l.uri.toString())}}createQuickPick(r,o){const l=new t(r,o,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}createInputBox(r){const o=new n(r,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(r,o){const l=this._sessions.get(r);l&&l._fireDidChangeValue(o)}$onDidAccept(r){const o=this._sessions.get(r);o&&o._fireDidAccept()}$onDidChangeActive(r,o){const l=this._sessions.get(r);l instanceof t&&l._fireDidChangeActive(o)}$onDidChangeSelection(r,o){const l=this._sessions.get(r);l instanceof t&&l._fireDidChangeSelection(o)}$onDidTriggerButton(r,o){const l=this._sessions.get(r);l&&l._fireDidTriggerButton(o)}$onDidHide(r){const o=this._sessions.get(r);o&&o._fireDidHide()}}class b{constructor(r,o){this._extensionId=r,this._onDidDispose=o,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new A.Emitter,this._onDidChangeValueEmitter=new A.Emitter,this._onDidTriggerButtonEmitter=new A.Emitter,this._onDidHideEmitter=new A.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((o,l)=>{const h=o===D.QuickInputButtons.Back?-1:l;this._handlesToButtons.set(h,o)}),this.update({buttons:r.map((o,l)=>({iconPath:p(o.iconPath),tooltip:o.tooltip,handle:o===D.QuickInputButtons.Back?-1:l}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const o=this._handlesToButtons.get(r);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,I.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),E.$dispose(this._id))}update(r){if(!this._disposed){for(const o of Object.keys(r)){const l=r[o];this._pendingUpdate[o]=l===void 0?null:l}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){E.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}b._nextId=1;function p(s){if(s instanceof D.ThemeIcon)return{id:s.id};const r=g(s),o=c(s);return{dark:typeof r=="string"?P.URI.file(r):r,light:typeof o=="string"?P.URI.file(o):o}}function c(s){return typeof s=="object"&&"light"in s?s.light:s}function g(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends b{constructor(r,o,l){super(r,l);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new A.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new A.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((o,l)=>{this._handlesToItems.set(l,o),this._itemsToHandles.set(o,l)}),this.update({items:r.map((o,l)=>({label:o.label,description:o.description,handle:l,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(r){const o=(0,T.coalesce)(r.map(l=>this._handlesToItems.get(l)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(r){const o=(0,T.coalesce)(r.map(l=>this._handlesToItems.get(l)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}}class n extends b{constructor(r,o){super(r,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?C.default.Error:C.default.Ignore})}}return new w(a,d)}e.createExtHostQuickOpen=m}),define(me[245],ge([0,1,2,3,70,6,19,5,15,98,13,29,41]),function(G,e,_,k,A,I,y,P,D,i,T,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(r){if(r)return typeof r.iconPath=="string"?_.URI.file(r.iconPath):r.iconPath}function a(r,o){if(!r.iconPath&&!o.iconPath)return 0;if(r.iconPath){if(!o.iconPath)return 1}else return-1;const l=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,h=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath;return(0,i.comparePaths)(l,h)}function d(r,o){let l=0;if(r.strikeThrough!==o.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==o.faded)return r.faded?1:-1;if(r.tooltip!==o.tooltip)return(r.tooltip||"").localeCompare(o.tooltip||"");if(l=a(r,o),l!==0)return l;if(r.light&&o.light)l=a(r.light,o.light);else{if(r.light)return 1;if(o.light)return-1}if(l!==0)return l;if(r.dark&&o.dark)l=a(r.dark,o.dark);else{if(r.dark)return 1;if(o.dark)return-1}return l}function E(r,o){if(r.command!==o.command)return r.command<o.command?-1:1;if(r.title!==o.title)return r.title<o.title?-1:1;if(r.tooltip!==o.tooltip){if(r.tooltip!==void 0&&o.tooltip!==void 0)return r.tooltip<o.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(r.arguments===o.arguments)return 0;if(r.arguments)if(o.arguments){if(r.arguments.length!==o.arguments.length)return r.arguments.length-o.arguments.length}else return 1;else return-1;for(let l=0;l<r.arguments.length;l++){const h=r.arguments[l],S=o.arguments[l];if(h!==S)return h<S?-1:1}return 0}function w(r,o){let l=(0,i.comparePaths)(r.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(l!==0)return l;if(r.command&&o.command)l=E(r.command,o.command);else{if(r.command)return 1;if(o.command)return-1}if(l!==0)return l;if(r.decorations&&o.decorations)l=d(r.decorations,o.decorations);else{if(r.decorations)return 1;if(o.decorations)return-1}return l}function b(r,o){for(let l=0;l<r.length;l++)if(r[l]!==o[l])return!1;return!0}function p(r,o){return r.command===o.command&&r.title===o.title&&r.tooltip===o.tooltip&&(r.arguments&&o.arguments?b(r.arguments,o.arguments):r.arguments===o.arguments)}function c(r,o){return(0,D.equals)(r,o,p)}class g{constructor(o,l,h){this._extension=o,this._proxy=l,this._sourceControlHandle=h,this._value="",this._onDidChange=new k.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return(0,m.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(o){if((0,m.checkProposedApiEnabled)(this._extension),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}focus(){(0,m.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(o,l){(0,m.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,o,l)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=g;class t{constructor(o,l,h,S,u){this._proxy=o,this._commands=l,this._sourceControlHandle=h,this._id=S,this._label=u,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new k.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,l){const h=this._resourceStatesCommandsMap.get(o);return h?(0,y.asPromise)(()=>this._commands.executeCommand(h.command,...h.arguments||[],l)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var o;const l=[...this._resourceStates].sort(w),S=(0,D.sortedDiff)(this._resourceSnapshot,l,w).map(R=>{const L=R.toInsert.map(H=>{const ie=this._resourceHandlePool++;this._resourceStatesMap.set(ie,H);const j=H.resourceUri,B=f(H.decorations),$=H.decorations&&f(H.decorations.light)||B,N=H.decorations&&f(H.decorations.dark)||B,M=[];let F;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"){const he=new I.DisposableStore;F=this._commands.converter.toInternal(H.command,he),this._resourceStatesDisposablesMap.set(ie,he)}else this._resourceStatesCommandsMap.set(ie,H.command);$&&M.push($),N&&N.toString()!==($==null?void 0:$.toString())&&M.push(N);const U=H.decorations&&H.decorations.tooltip||"",O=H.decorations&&!!H.decorations.strikeThrough,W=H.decorations&&!!H.decorations.faded,q=H.contextValue||"";return{rawResource:[ie,j,M,U,O,W,q,F],handle:ie}});return{start:R.start,deleteCount:R.deleteCount,toInsert:L}}),u=S.map(({start:R,deleteCount:L,toInsert:H})=>[R,L,H.map(ie=>ie.rawResource)]),v=S.reverse();for(const{start:R,deleteCount:L,toInsert:H}of v){const ie=H.map(B=>B.handle),j=this._handlesSnapshot.splice(R,L,...ie);for(const B of j)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),(o=this._resourceStatesDisposablesMap.get(B))===null||o===void 0||o.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=l,u}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(o,l,h,S,u,v){this._proxy=l,this._commands=h,this._id=S,this._label=u,this._rootUri=v,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new I.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new I.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new k.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new g(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,S,u,v)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new I.DisposableStore,this._acceptInputCommand=o;const l=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:l})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(!(this._statusBarCommands&&o&&c(this._statusBarCommands,o))){this._statusBarDisposables.value=new I.DisposableStore,this._statusBarCommands=o;const l=(o||[]).map(h=>this._commands.converter.toInternal(h,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:l})}}get selected(){return this._selected}createResourceGroup(o,l){const h=new t(this._proxy,this._commands,this.handle,o,l),S=k.Event.once(h.onDidDispose)(()=>this.createdResourceGroups.delete(h));return this.createdResourceGroups.set(h,S),this.eventuallyAddResourceGroups(),h}eventuallyAddResourceGroups(){const o=[],l=[];for(const[h,S]of this.createdResourceGroups){S.dispose();const u=h.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(h),this.eventuallyUpdateResourceStates()});k.Event.once(h.onDidDispose)(()=>{this.updatedResourceGroups.delete(h),u.dispose(),this._groups.delete(h.handle),this._proxy.$unregisterGroup(this.handle,h.handle)}),o.push([h.handle,h.id,h.label,h.features]);const v=h._takeResourceStateSnapshot();v.length>0&&l.push([h.handle,v]),this._groups.set(h.handle,h)}this._proxy.$registerGroups(this.handle,o,l),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(l=>{const h=l._takeResourceStateSnapshot();h.length!==0&&o.push([l.handle,h])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,je([(0,A.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),je([(0,A.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let s=class Mn{constructor(o,l,h){this._commands=l,this.logService=h,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new k.Emitter,this._proxy=o.getProxy(P.MainContext.MainThreadSCM),this._telemetry=o.getProxy(P.MainContext.MainThreadTelemetry),l.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===3){const u=this._sourceControls.get(S.sourceControlHandle);if(!u)return S;const v=u.getResourceGroup(S.groupHandle);return v?v.getResourceState(S.handle):S}else if(S&&S.$mid===4){const u=this._sourceControls.get(S.sourceControlHandle);return u?u.getResourceGroup(S.groupHandle):S}else if(S&&S.$mid===5){const u=this._sourceControls.get(S.handle);return u||S}return S}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,l,h,S){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,l,h,S),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const u=Mn._handlePool++,v=new n(o,this._proxy,this._commands,l,h,S);this._sourceControls.set(u,v);const R=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(o.identifier))||[];return R.push(v),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(o.identifier),R),v}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const l=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(o.identifier)),h=l&&l[l.length-1];return h&&h.inputBox}$provideOriginalResource(o,l,h){const S=_.URI.revive(l);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,S.toString());const u=this._sourceControls.get(o);return!u||!u.quickDiffProvider||!u.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>u.quickDiffProvider.provideOriginalResource(S,h)).then(v=>v||null)}$onInputBoxValueChange(o,l){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const h=this._sourceControls.get(o);return h&&h.inputBox.$onInputBoxValueChange(l),Promise.resolve(void 0)}$executeResourceCommand(o,l,h,S){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,l,h);const u=this._sourceControls.get(o);if(!u)return Promise.resolve(void 0);const v=u.getResourceGroup(l);return v?v.$executeResourceCommand(h,S):Promise.resolve(void 0)}$validateInput(o,l,h){this.logService.trace("ExtHostSCM#$validateInput",o);const S=this._sourceControls.get(o);return!S||!S.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>S.inputBox.validateInput(l,h)).then(u=>u?Promise.resolve([u.message,u.type]):Promise.resolve(void 0))}$setSelectedSourceControl(o){var l,h;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&((l=this._sourceControls.get(o))===null||l===void 0||l.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((h=this._sourceControls.get(this._selectedSourceControlHandle))===null||h===void 0||h.setSelectionState(!1)),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};s._handlePool=0,s=je([Be(2,T.ILogService)],s),e.ExtHostSCM=s});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!k:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(G):k?k.value:e.get(G)};define(me[246],ge([0,1,7,5,164,6]),function(G,e,_,k,A,I){"use strict";var y,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(m,f,a,d,E=_.StatusBarAlignment.Left,w,b){y.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new I.DisposableStore,tt(this,y,m,"f"),tt(this,P,f,"f"),this._id=D.ID_GEN++,this._statusId=a,this._statusName=d,this._alignment=E,this._priority=w,this._accessibilityInformation=b}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var m;return(m=this._command)===null||m===void 0?void 0:m.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(m){this._text=m,this.update()}set tooltip(m){this._tooltip=m,this.update()}set color(m){this._color=m,this.update()}set backgroundColor(m){m&&!D.ALLOWED_BACKGROUND_COLORS.has(m.id)&&(m=void 0),this._backgroundColor=m,this.update()}set command(m){var f;((f=this._command)===null||f===void 0?void 0:f.fromApi)!==m&&(this._internalCommandRegistration.clear(),typeof m=="string"?this._command={fromApi:m,internal:Ue(this,P,"f").toInternal({title:"",command:m},this._internalCommandRegistration)}:m?this._command={fromApi:m,internal:Ue(this,P,"f").toInternal(m,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(m){this._accessibilityInformation=m,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,y,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var m;this._timeoutHandle=void 0;let f=this._color;this._backgroundColor&&(f=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Ue(this,y,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(m=this._command)===null||m===void 0?void 0:m.internal,f,this._backgroundColor,this._alignment===_.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,y=new WeakMap,P=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new _.ThemeColor("statusBarItem.errorForeground")]]);class i{constructor(m){this._messages=[],this._item=m.createStatusBarEntry("status.extensionMessage",(0,A.localize)(0,null),_.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(m){const f={message:m};return this._messages.unshift(f),this._update(),new _.Disposable(()=>{const a=this._messages.indexOf(f);a>=0&&(this._messages.splice(a,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class T{constructor(m,f){this._proxy=m.getProxy(k.MainContext.MainThreadStatusBar),this._commands=f,this._statusMessage=new i(this)}createStatusBarEntry(m,f,a,d,E){return new D(this._proxy,this._commands,m,f,a,d,E)}setStatusBarMessage(m,f){const a=this._statusMessage.setMessage(m);let d;return typeof f=="number"?d=setTimeout(()=>a.dispose(),f):typeof f!="undefined"&&f.then(()=>a.dispose(),()=>a.dispose()),new _.Disposable(()=>{a.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=T}),define(me[91],ge([0,1,5,3,4]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class I{constructor(P){this._onDidChangeStorage=new k.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(_.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,D){this._proxy.$registerExtensionStorageKeysToSync(P,D)}getValue(P,D,i){return this._proxy.$getValue(P,D).then(T=>T||i)}setValue(P,D,i){return this._proxy.$setValue(P,D,i)}$acceptValue(P,D,i){this._onDidChangeStorage.fire({shared:P,key:D,value:i})}}e.ExtHostStorage=I,e.IExtHostStorage=(0,A.createDecorator)("IExtHostStorage")}),define(me[92],ge([0,1,4,27,13,90,2]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,_.createDecorator)("IExtensionStoragePaths");let P=class{constructor(i,T,C){var m;this._logService=T,this._extHostFileSystem=C,this._workspace=(m=i.workspace)!==null&&m!==void 0?m:void 0,this._environment=i.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getOrCreateWorkspaceStoragePath(){var i;if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,C=y.URI.joinPath(this._environment.workspaceStorageHome,T);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch(m){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(i=y.URI.revive(this._workspace.configuration))===null||i===void 0?void 0:i.toString(),name:this._workspace.name},void 0,2))),C}catch(m){this._logService.error("[ExtHostStorage]",m);return}}workspaceValue(i){if(this._value)return y.URI.joinPath(this._value,i.identifier.value)}globalValue(i){return y.URI.joinPath(this._environment.globalStorageHome,i.identifier.value.toLowerCase())}};P=je([Be(0,k.IExtHostInitDataService),Be(1,A.ILogService),Be(2,I.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(me[34],ge([0,1,3,5,4,2,14,6,7,165,18,210,21,28,190]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,A.createDecorator)("IExtHostTerminalService");class d{constructor(t,n,s,r){this._proxy=t,this._id=n,this._creationOptions=s,this._name=r,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(l=>this._pidPromiseComplete=l);const o=this;this.value={get name(){return o._name||""},get processId(){return o._pidPromise},get creationOptions(){return o._creationOptions},get exitStatus(){return o._exitStatus},sendText(l,h=!0){o._checkDisposed(),o._proxy.$sendText(o._id,l,h)},show(l){o._checkDisposed(),o._proxy.$show(o._id,l)},hide(){o._checkDisposed(),o._proxy.$hide(o._id)},dispose(){o._disposed||(o._disposed=!0,o._proxy.$dispose(o._id))},get dimensions(){if(!(o._cols===void 0||o._rows===void 0))return{columns:o._cols,rows:o._rows}}}}async create(t,n,s,r,o,l,h,S,u,v,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:s,env:r,icon:o,initialText:l,waitOnExit:h,strictEnv:S,hideFromUser:u,isFeatureTerminal:v,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=d;class E{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new _.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new _.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new _.Emitter,this._onProcessTitleChanged=new _.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new _.Emitter,this._onProcessShellTypeChanged=new _.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let w=1,b=class extends P.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new _.Emitter,this._onDidOpenTerminal=new _.Emitter,this._onDidChangeActiveTerminal=new _.Emitter,this._onDidChangeTerminalDimensions=new _.Emitter,this._proxy=n.getProxy(k.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new _.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[s,r]of this._terminalProcesses)r.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new d(this._proxy,(0,f.generateUuid)(),t,t.name),s=new E(t.pty);return n.createExtensionTerminal().then(r=>{const o=this._setupExtHostProcessListeners(r,s);this._terminalProcessDisposables[r]=o}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const r=new E(n),o=this._setupExtHostProcessListeners(t,r);this._terminalProcessDisposables[t]=o}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(t);s&&(this._activeTerminal=s,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const s=this._getTerminalById(t);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:n})}async $acceptTerminalDimensions(t,n,s){const r=this._getTerminalById(t);r&&r.setDimensions(n,s)&&this._onDidChangeTerminalDimensions.fire({terminal:r.value,dimensions:r.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,s){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,s)}async $acceptTerminalTitleChange(t,n){const s=this._getTerminalById(t);s&&(s.name=n)}async $acceptTerminalClosed(t,n){const s=this._getTerminalObjectIndexById(this._terminals,t);if(s!==null){const r=this._terminals.splice(s,1)[0];r.setExitCode(n),this._onDidCloseTerminal.fire(r.value)}}$acceptTerminalOpened(t,n,s,r){if(n){const h=this._getTerminalObjectIndexById(this._terminals,n);if(h!==null){this._terminals[h]._id=t,this._onDidOpenTerminal.fire(this.terminals[h]),this._terminals[h].isOpen=!0;return}}const o={name:r.name,shellPath:r.executable,shellArgs:r.args,cwd:typeof r.cwd=="string"?r.cwd:I.URI.revive(r.cwd),env:r.env,hideFromUser:r.hideFromUser},l=new d(this._proxy,t,o,s);this._terminals.push(l),this._onDidOpenTerminal.fire(l.value),l.isOpen=!0}async $acceptTerminalProcessId(t,n){const s=this._getTerminalById(t);s&&s._setProcessId(n)}async $startExtensionTerminal(t,n){const s=this._getTerminalById(t);if(!s)return{message:(0,i.localize)(0,null,t)};s.isOpen||await new Promise(o=>{const l=this.onDidOpenTerminal(async h=>{h===s.value&&(l.dispose(),o())})});const r=this._terminalProcesses.get(t);r?r.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const s=new P.DisposableStore;s.add(n.onProcessReady(o=>this._proxy.$sendProcessReady(t,o.pid,o.cwd))),s.add(n.onProcessTitleChanged(o=>this._proxy.$sendProcessTitle(t,o))),this._bufferer.startBuffering(t,n.onProcessData),s.add(n.onProcessExit(o=>this._onProcessExit(t,o))),n.onProcessOverrideDimensions&&s.add(n.onProcessOverrideDimensions(o=>this._proxy.$sendOverrideDimensions(t,o))),this._terminalProcesses.set(t,n);const r=this._extensionTerminalAwaitingStart[t];return r&&n instanceof E&&(n.startSendingEvents(r.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),s}$acceptProcessAckDataEvent(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.input(n)}$acceptProcessResize(t,n,s){var r;try{(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,s)}catch(o){if(o.code!=="EPIPE"&&o.code!=="ERR_IPC_CHANNEL_CLOSED")throw o}}$acceptProcessShutdown(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(t,s))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(s=>this._proxy.$sendProcessCwd(t,s))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const s=this._getTerminalById(t);if(!s)return[];this._terminalLinkCache.delete(t);const r=this._terminalLinkCancellationSource.get(t);r&&r.dispose(!0);const o=new m.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,o);const l=[],h={terminal:s.value,line:n},S=[];for(const R of this._linkProviders)S.push(new Promise(async L=>{o.token.onCancellationRequested(()=>L({provider:R,links:[]}));const H=await R.provideTerminalLinks(h,o.token)||[];o.token.isCancellationRequested||L({provider:R,links:H})}));const u=await Promise.all(S);if(o.token.isCancellationRequested)return[];const v=new Map;for(const R of u)R&&R.links.length>0&&l.push(...R.links.map(L=>{const H={id:w++,startIndex:L.startIndex,length:L.length,label:L.tooltip};return v.set(H.id,{provider:R.provider,link:L}),H}));return this._terminalLinkCache.set(t,v),l}$activateLink(t,n){var s;const r=(s=this._terminalLinkCache.get(t))===null||s===void 0?void 0:s.get(n);!r||r.provider.handleTerminalLink(r.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const s=this._terminalProcessDisposables[t];s&&(s.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const s=this._getTerminalObjectIndexById(t,n);return s!==null?t[s]:null}_getTerminalObjectIndexById(t,n){let s=null;return t.some((r,o)=>r._id===n?(s=o,!0):!1),s}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new p,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const s=(0,C.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const s=n[0],r=new p(n[1]);this._setEnvironmentVariableCollection(s,r)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};b=je([Be(1,y.IExtHostRpcService)],b),e.BaseExtHostTerminalService=b;class p{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new _.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const s=this.map.get(t);(!s||s.value!==n.value||s.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((s,r)=>t.call(n,r,s,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=p;let c=class extends b{constructor(t){super(!1,t)}createTerminal(t,n,s){throw new T.NotSupportedError}createTerminalFromOptions(t){throw new T.NotSupportedError}getDefaultShell(t,n){throw new T.NotSupportedError}getDefaultShellArgs(t,n){throw new T.NotSupportedError}$getAvailableProfiles(t){throw new T.NotSupportedError}async $getDefaultShellAndArgs(t){throw new T.NotSupportedError}};c=je([Be(0,y.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c}),define(me[247],ge([0,1,3,15,5,123,20,7]),function(G,e,_,k,A,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(T,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new _.Emitter,this._onDidChangeTextEditorOptions=new _.Emitter,this._onDidChangeTextEditorVisibleRanges=new _.Emitter,this._onDidChangeTextEditorViewColumn=new _.Emitter,this._onDidChangeActiveTextEditor=new _.Emitter,this._onDidChangeVisibleTextEditors=new _.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=T.getProxy(A.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(m=>this._onDidChangeVisibleTextEditors.fire(m)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(m=>this._onDidChangeActiveTextEditor.fire(m))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(T){const C=this._extHostDocumentsAndEditors.allEditors();return T?C:C.map(m=>m.value)}async showTextDocument(T,C,m){let f;typeof C=="number"?f={position:y.ViewColumn.from(C),preserveFocus:m}:typeof C=="object"?f={position:y.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?y.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:f={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(T.uri,f),d=a&&this._extHostDocumentsAndEditors.getEditor(a);if(d)return d.value;throw a?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T){return new I.TextEditorDecorationType(this._proxy,T).value}$acceptEditorPropertiesChanged(T,C){const m=this._extHostDocumentsAndEditors.getEditor(T);if(!m)throw new Error("unknown text editor");if(C.options&&m._acceptOptions(C.options),C.selections){const f=C.selections.selections.map(y.Selection.to);m._acceptSelections(f)}if(C.visibleRanges){const f=k.coalesce(C.visibleRanges.map(y.Range.to));m._acceptVisibleRanges(f)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:m.value,options:Object.assign(Object.assign({},C.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(C.options.lineNumbers)})}),C.selections){const f=P.TextEditorSelectionChangeKind.fromValue(C.selections.source),a=C.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:m.value,selections:a,kind:f})}if(C.visibleRanges){const f=k.coalesce(C.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:m.value,visibleRanges:f})}}$acceptEditorPositionData(T){for(const C in T){const m=this._extHostDocumentsAndEditors.getEditor(C);if(!m)throw new Error("Unknown text editor");const f=y.ViewColumn.to(T[C]);m.value.viewColumn!==f&&(m._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:m.value,viewColumn:f}))}}getDiffInformation(T){return Promise.resolve(this._proxy.$getDiffInformation(T))}}e.ExtHostEditors=D});var Ht=this&&this.__rest||function(G,e){var _={};for(var k in G)Object.prototype.hasOwnProperty.call(G,k)&&e.indexOf(k)<0&&(_[k]=G[k]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,k=Object.getOwnPropertySymbols(G);A<k.length;A++)e.indexOf(k[A])<0&&Object.prototype.propertyIsEnumerable.call(G,k[A])&&(_[k[A]]=G[k[A]]);return _};define(me[248],ge([0,1,2,4,5,6,7]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class P{constructor(T,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=T.getProxy(A.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:m=>{var f,a;if(m&&m.$mid===11){const d=m.uri===void 0?void 0:_.URI.revive(m.uri);return(a=(f=this._itemsBySourceAndUriMap.get(m.source))===null||f===void 0?void 0:f.get(D(d)))===null||a===void 0?void 0:a.get(m.handle)}return m}})}async $getTimeline(T,C,m,f,a){const d=this._providers.get(T);return d==null?void 0:d.provideTimeline(_.URI.revive(C),m,f,a)}registerTimelineProvider(T,C,m,f){const a=new I.DisposableStore,d=this.convertTimelineItem(C.id,f,a).bind(this);let E;C.onDidChange&&(E=C.onDidChange(b=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},b),{id:C.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},C),{scheme:T,onDidChange:void 0,async provideTimeline(b,p,c,g){var t;(g==null?void 0:g.resetCache)&&(a.clear(),(t=w.get(C.id))===null||t===void 0||t.clear());const n=await C.provideTimeline(b,p,c);if(n!=null){const s=d(b,g);return Object.assign(Object.assign({},n),{source:C.id,items:n.items.map(s)})}},dispose(){var b;for(const p of w.values())(b=p.get(C.id))===null||b===void 0||b.clear();E==null||E.dispose(),a.dispose()}}))}convertTimelineItem(T,C,m){return(f,a)=>{let d;if(a==null?void 0:a.cacheResults){let E=this._itemsBySourceAndUriMap.get(T);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(T,E));const w=D(f);d=E.get(w),d===void 0&&(d=new Map,E.set(w,d))}return E=>{var w,b;const{iconPath:p}=E,c=Ht(E,["iconPath"]),g=`${T}|${(w=E.id)!==null&&w!==void 0?w:E.timestamp}`;d==null||d.set(g,E);let t,n,s;return E.iconPath&&(p instanceof y.ThemeIcon?s={id:p.id}:_.URI.isUri(p)?(t=p,n=p):{light:t,dark:n}=p),Object.assign(Object.assign({},c),{id:(b=c.id)!==null&&b!==void 0?b:void 0,handle:g,source:T,command:E.command?C.toInternal(E.command,m):void 0,icon:t,iconDark:n,themeIcon:s,accessibilityInformation:E.accessibilityInformation})}}}registerTimelineProviderCore(T){if(this._providers.get(T.id))throw new Error(`Timeline Provider ${T.id} already exists.`);return this._proxy.$registerTimelineProvider({id:T.id,label:T.label,scheme:T.scheme}),this._providers.set(T.id,T),(0,I.toDisposable)(()=>{var m;for(const f of this._itemsBySourceAndUriMap.values())(m=f.get(T.id))===null||m===void 0||m.clear();this._providers.delete(T.id),this._proxy.$unregisterTimelineProvider(T.id),T.dispose()})}}e.ExtHostTimeline=P;function D(i){return i==null?void 0:i.toString()}}),define(me[249],ge([0,1,6,11,2,5]),function(G,e,_,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(D){this._openers=new Map,this._proxy=D.getProxy(I.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,i,T,C){if(this._openers.has(i))throw new Error(`Opener with id '${i}' already registered`);const m=C.schemes.find(f=>!y.supportedSchemes.has(f));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this._openers.set(i,T),this._proxy.$registerUriOpener(i,C.schemes,D,C.label),(0,_.toDisposable)(()=>{this._openers.delete(i),this._proxy.$unregisterUriOpener(i)})}async $canOpenUri(D,i,T){const C=this._openers.get(D);if(!C)throw new Error(`Unknown opener with id: ${D}`);const m=A.URI.revive(i);return C.canOpenExternalUri(m,T)}async $openUri(D,i,T){const C=this._openers.get(D);if(!C)throw new Error(`Unknown opener id: '${D}'`);return C.openExternalUri(A.URI.revive(i.resolvedUri),{sourceUri:A.URI.revive(i.sourceUri)},T)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([k.Schemas.http,k.Schemas.https])}),define(me[250],ge([0,1,5,2,6,18,29]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(i){this.handles=new Set,this.handlers=new Map,this._proxy=i.getProxy(_.MainContext.MainThreadUrls)}registerUriHandler(i,T){if(this.handles.has(y.ExtensionIdentifier.toKey(i)))throw new Error(`Protocol handler already registered for extension ${i}`);const C=P.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(i)),this.handlers.set(C,T),this._proxy.$registerUriHandler(C,i),(0,A.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(i)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(i,T){const C=this.handlers.get(i);if(!C)return Promise.resolve(void 0);try{C.handleUri(k.URI.revive(T))}catch(m){(0,I.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(i){return k.URI.revive(await this._proxy.$createAppUri(i))}}e.ExtHostUrls=P,P.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!k:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(G):k?k.value:e.get(G)};define(me[66],ge([0,1,22,3,2,177,200,63,5]),function(G,e,_,k,A,I,y,P,D){"use strict";var i,T,C,m,f,a,d,E,w,b,p,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(u,v,R,L,H,ie,j){i.set(this,void 0),T.set(this,void 0),C.set(this,void 0),m.set(this,void 0),f.set(this,void 0),a.set(this,void 0),d.set(this,""),E.set(this,void 0),w.set(this,!1),b.set(this,!1),p.set(this,!1),this._onMessageEmitter=new k.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new k.Emitter),this._onDidDispose=Ue(this,c,"f").event,tt(this,i,u,"f"),tt(this,T,v,"f"),tt(this,E,R,"f"),tt(this,m,L,"f"),tt(this,f,H,"f"),tt(this,a,ie,"f"),tt(this,p,t(ie),"f"),tt(this,C,j,"f")}dispose(){tt(this,w,!0,"f"),Ue(this,c,"f").fire(),Ue(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(u){return tt(this,b,!0,"f"),(0,P.asWebviewUri)(Ue(this,m,"f"),Ue(this,i,"f"),u)}get cspSource(){return Ue(this,m,"f").webviewCspSource.replace("{{uuid}}",Ue(this,i,"f"))}get html(){return this.assertNotDisposed(),Ue(this,d,"f")}set html(u){this.assertNotDisposed(),Ue(this,d,"f")!==u&&(tt(this,d,u,"f"),!Ue(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(u)&&(tt(this,b,!0,"f"),Ue(this,C,"f").report("Webview vscode-resource: uris",Ue(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,T,"f").$setHtml(Ue(this,i,"f"),u))}get options(){return this.assertNotDisposed(),Ue(this,E,"f")}set options(u){this.assertNotDisposed(),Ue(this,T,"f").$setOptions(Ue(this,i,"f"),o(Ue(this,a,"f"),Ue(this,f,"f"),u)),tt(this,E,u,"f")}async postMessage(u){if(Ue(this,w,"f"))return!1;const v=n(u,{serializeBuffersForPostMessage:Ue(this,p,"f")});return Ue(this,T,"f").$postMessage(Ue(this,i,"f"),v.message,...v.buffers)}assertNotDisposed(){if(Ue(this,w,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,i=new WeakMap,T=new WeakMap,C=new WeakMap,m=new WeakMap,f=new WeakMap,a=new WeakMap,d=new WeakMap,E=new WeakMap,w=new WeakMap,b=new WeakMap,p=new WeakMap,c=new WeakMap;function t(S){if(!S.enableProposedApi)return!1;try{const u=(0,I.normalizeVersion)((0,I.parseVersion)(S.engines.vscode));return!!u&&u.majorBase>=1&&u.minorBase>=56}catch(u){return!1}}e.shouldSerializeBuffersForPostMessage=t;function n(S,u){if(u.serializeBuffersForPostMessage){const v=[],R=(H,ie)=>{if(ie&&ie instanceof ArrayBuffer){let j=v.findIndex(B=>B.original===ie);if(j===-1){const B=new Uint8Array(ie),$=_.VSBuffer.wrap(B);j=v.length,v.push({original:ie,vsBuffer:$})}return{$$vscode_array_buffer_reference$$:!0,index:j}}return ie};return{message:JSON.stringify(S,R),buffers:v.map(H=>H.vsBuffer)}}else return{message:JSON.stringify(S),buffers:[]}}e.serializeMessage=n;class s{constructor(u,v,R,L,H){this.initData=v,this.workspace=R,this._logService=L,this._deprecationService=H,this._webviews=new Map,this._webviewProxy=u.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(u,v,...R){const L=this.getWebview(u);if(L){const{message:H}=(0,y.deserializeWebviewMessage)(v,R);L._onMessageEmitter.fire(H)}}$onMissingCsp(u,v){this._logService.warn(`${v} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(u,v,R){const L=new g(u,this._webviewProxy,l(v),this.initData,this.workspace,R,this._deprecationService);return this._webviews.set(u,L),L._onDidDispose(()=>{this._webviews.delete(u)}),L}deleteWebview(u){this._webviews.delete(u)}getWebview(u){return this._webviews.get(u)}}e.ExtHostWebviews=s;function r(S){return{id:S.identifier,location:S.extensionLocation}}e.toExtensionData=r;function o(S,u,v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots||h(S,u)}}e.serializeWebviewOptions=o;function l(S){var u;return{enableCommandUris:S.enableCommandUris,enableScripts:S.enableScripts,portMapping:S.portMapping,localResourceRoots:(u=S.localResourceRoots)===null||u===void 0?void 0:u.map(v=>A.URI.from(v))}}e.reviveOptions=l;function h(S,u){return[...((u==null?void 0:u.getWorkspaceFolders())||[]).map(v=>v.uri),S.extensionLocation]}}),define(me[251],ge([0,1,21,74,6,11,25,2,20,66,86,5,7]),function(G,e,_,k,A,I,y,P,D,i,T,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class a{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,s){const r=this.key(t,n.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const o=new f(n,s);return this._documents.set(r,o),o}delete(t,n){const s=this.key(t,n.uri);this._documents.delete(s)}key(t,n){return`${t}@@@${n}`}}var d;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(d||(d={}));class E{constructor(){this._providers=new Map}addTextProvider(t,n,s){return this.add(0,t,n,s)}addCustomProvider(t,n,s){return this.add(1,t,n,s)}get(t){return this._providers.get(t)}add(t,n,s,r){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:s,provider:r}),new m.Disposable(()=>this._providers.delete(n))}}class w{constructor(t,n,s,r,o){this._extHostDocuments=n,this._extensionStoragePaths=s,this._extHostWebview=r,this._extHostWebviewPanels=o,this._editorProviders=new E,this._documents=new a,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,s,r){const o=new A.DisposableStore;return b(s)?(o.add(this._editorProviders.addTextProvider(n,t,s)),this._proxy.$registerTextEditorProvider((0,i.toExtensionData)(t),n,r.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,i.shouldSerializeBuffersForPostMessage)(t))):(o.add(this._editorProviders.addCustomProvider(n,t,s)),this.supportEditing(s)&&o.add(s.onDidChangeCustomDocument(l=>{const h=this.getCustomDocumentEntry(n,l.document.uri);if(p(l)){const S=h.addEdit(l);this._proxy.$onDidEdit(l.document.uri,n,S,l.label)}else this._proxy.$onContentChange(l.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,i.toExtensionData)(t),n,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,i.shouldSerializeBuffersForPostMessage)(t))),m.Disposable.from(o,new m.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,s,r,o){var l;const h=this._editorProviders.get(n);if(!h)throw new Error(`No provider found for '${n}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${n}'`);const S=P.URI.revive(t),u=await h.provider.openCustomDocument(S,{backupId:s,untitledDocumentData:r==null?void 0:r.buffer},o);let v;return this.supportEditing(h.provider)&&this._extensionStoragePaths&&(v=(l=this._extensionStoragePaths.workspaceValue(h.extension))!==null&&l!==void 0?l:this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(n,u,v),{editable:this.supportEditing(h.provider)}}async $disposeCustomDocument(t,n){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const r=P.URI.revive(t),{document:o}=this.getCustomDocumentEntry(n,r);this._documents.delete(n,o),o.dispose()}async $resolveWebviewEditor(t,n,s,r,o,l){const h=this._editorProviders.get(s);if(!h)throw new Error(`No provider found for '${s}'`);const S=D.ViewColumn.to(o),u=this._extHostWebview.createNewWebview(n,r.webviewOptions,h.extension),v=this._extHostWebviewPanels.createNewWebviewPanel(n,s,r.title,S,r.panelOptions,u),R=P.URI.revive(t);switch(h.type){case 1:{const{document:L}=this.getCustomDocumentEntry(s,R);return h.provider.resolveCustomEditor(L,v,l)}case 0:{const L=this._extHostDocuments.getDocument(R);return h.provider.resolveCustomTextEditor(L,v,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,s){this.getCustomDocumentEntry(n,t).disposeEdits(s)}async $onMoveCustomEditor(t,n,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const o=this._extHostWebviewPanels.getWebviewPanel(t);if(!o)throw new Error("No webview found");const l=P.URI.revive(n),h=this._extHostDocuments.getDocument(l);await r.provider.moveCustomTextEditor(h,o,_.CancellationToken.None)}async $undo(t,n,s,r){return this.getCustomDocumentEntry(n,t).undo(s,r)}async $redo(t,n,s,r){return this.getCustomDocumentEntry(n,t).redo(s,r)}async $revert(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(r.document,s),r.disposeBackup()}async $onSave(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(r.document,s),r.disposeBackup()}async $onSaveAs(t,n,s,r){const o=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(o.document,P.URI.revive(s),r)}async $backup(t,n,s){const r=this.getCustomDocumentEntry(n,t),l=await this.getCustomEditorProvider(n).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},s);return r.updateBackup(l),l.id}getCustomDocumentEntry(t,n){const s=this._documents.get(t,P.URI.revive(n));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const n=this._editorProviders.get(t),s=n==null?void 0:n.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function b(g){return typeof g.resolveCustomTextEditor=="function"}function p(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function c(g){const t=g.scheme===I.Schemas.file||g.scheme===I.Schemas.untitled?g.fsPath:g.toString();return(0,k.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!k:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(G):k?k.value:e.get(G)};define(me[252],ge([0,1,3,6,2,28,20,66,5,7]),function(G,e,_,k,A,I,y,P,D,i){"use strict";var T,C,m,f,a,d,E,w,b,p,c,g,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends k.Disposable{constructor(l,h,S,u,v,R,L){super();T.set(this,void 0),C.set(this,void 0),m.set(this,void 0),f.set(this,void 0),a.set(this,void 0),d.set(this,void 0),E.set(this,void 0),w.set(this,void 0),b.set(this,!0),p.set(this,!0),c.set(this,!1),g.set(this,this._register(new _.Emitter)),this.onDidDispose=Ue(this,g,"f").event,t.set(this,this._register(new _.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,tt(this,T,l,"f"),tt(this,C,h,"f"),tt(this,m,S,"f"),tt(this,a,R,"f"),tt(this,w,v,"f"),tt(this,d,u,"f"),tt(this,f,L,"f")}dispose(){Ue(this,c,"f")||(tt(this,c,!0,"f"),Ue(this,g,"f").fire(),Ue(this,C,"f").$disposeWebview(Ue(this,T,"f")),Ue(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,f,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,m,"f")}get title(){return this.assertNotDisposed(),Ue(this,d,"f")}set title(l){this.assertNotDisposed(),Ue(this,d,"f")!==l&&(tt(this,d,l,"f"),Ue(this,C,"f").$setTitle(Ue(this,T,"f"),l))}get iconPath(){return this.assertNotDisposed(),Ue(this,E,"f")}set iconPath(l){this.assertNotDisposed(),Ue(this,E,"f")!==l&&(tt(this,E,l,"f"),Ue(this,C,"f").$setIconPath(Ue(this,T,"f"),A.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Ue(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,w,"f")=="number"&&Ue(this,w,"f")<0))return Ue(this,w,"f")}get active(){return this.assertNotDisposed(),Ue(this,p,"f")}get visible(){return this.assertNotDisposed(),Ue(this,b,"f")}_updateViewState(l){Ue(this,c,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(tt(this,p,l.active,"f"),tt(this,b,l.visible,"f"),tt(this,w,l.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(l,h){this.assertNotDisposed(),Ue(this,C,"f").$reveal(Ue(this,T,"f"),{viewColumn:l?y.ViewColumn.from(l):void 0,preserveFocus:!!h})}assertNotDisposed(){if(Ue(this,c,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,C=new WeakMap,m=new WeakMap,f=new WeakMap,a=new WeakMap,d=new WeakMap,E=new WeakMap,w=new WeakMap,b=new WeakMap,p=new WeakMap,c=new WeakMap,g=new WeakMap,t=new WeakMap;class s{constructor(l,h,S){this.webviews=h,this.workspace=S,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=l.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,I.generateUuid)()}createWebviewPanel(l,h,S,u,v={}){const R=typeof u=="object"?u.viewColumn:u,L={viewColumn:y.ViewColumn.from(R),preserveFocus:typeof u=="object"&&!!u.preserveFocus},H=(0,P.shouldSerializeBuffersForPostMessage)(l),ie=s.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(l),ie,h,{title:S,panelOptions:r(v),webviewOptions:(0,P.serializeWebviewOptions)(l,this.workspace,v),serializeBuffersForPostMessage:H},L);const j=this.webviews.createNewWebview(ie,v,l);return this.createNewWebviewPanel(ie,h,S,R,v,j)}$onDidChangeWebviewPanelViewStates(l){const h=Object.keys(l);h.sort((S,u)=>{const v=l[S],R=l[u];return v.active?1:R.active?-1:+v.visible-+R.visible});for(const S of h){const u=this.getWebviewPanel(S);if(!!u){const v=l[S];u._updateViewState({active:v.active,visible:v.visible,viewColumn:y.ViewColumn.to(v.position)})}}}async $onDidDisposeWebviewPanel(l){const h=this.getWebviewPanel(l);h==null||h.dispose(),this._webviewPanels.delete(l),this.webviews.deleteWebview(l)}registerWebviewPanelSerializer(l,h,S){if(this._serializers.has(h))throw new Error(`Serializer for '${h}' already registered`);return this._serializers.set(h,{serializer:S,extension:l}),this._proxy.$registerSerializer(h,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(l)}),new i.Disposable(()=>{this._serializers.delete(h),this._proxy.$unregisterSerializer(h)})}async $deserializeWebviewPanel(l,h,S,u){const v=this._serializers.get(h);if(!v)throw new Error(`No serializer found for '${h}'`);const{serializer:R,extension:L}=v,H=this.webviews.createNewWebview(l,S.webviewOptions,L),ie=this.createNewWebviewPanel(l,h,S.title,u,S.panelOptions,H);await R.deserializeWebviewPanel(ie,S.state)}createNewWebviewPanel(l,h,S,u,v,R){const L=new n(l,this._proxy,h,S,u,v,R);return this._webviewPanels.set(l,L),L}getWebviewPanel(l){return this._webviewPanels.get(l)}}e.ExtHostWebviewPanels=s;function r(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!k:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(G):k?k.value:e.get(G)};define(me[253],ge([0,1,3,6,66,5,7]),function(G,e,_,k,A,I,y){"use strict";var P,D,i,T,C,m,f,a,d,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends k.Disposable{constructor(c,g,t,n,s,r){super();P.set(this,void 0),D.set(this,void 0),i.set(this,void 0),T.set(this,void 0),C.set(this,!1),m.set(this,void 0),f.set(this,void 0),a.set(this,void 0),d.set(this,this._register(new _.Emitter)),this.onDidChangeVisibility=Ue(this,d,"f").event,E.set(this,this._register(new _.Emitter)),this.onDidDispose=Ue(this,E,"f").event,tt(this,i,t,"f"),tt(this,f,n,"f"),tt(this,P,c,"f"),tt(this,D,g,"f"),tt(this,T,s,"f"),tt(this,m,r,"f")}dispose(){Ue(this,C,"f")||(tt(this,C,!0,"f"),Ue(this,E,"f").fire(),Ue(this,T,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,f,"f")}set title(c){this.assertNotDisposed(),Ue(this,f,"f")!==c&&(tt(this,f,c,"f"),Ue(this,D,"f").$setWebviewViewTitle(Ue(this,P,"f"),c))}get description(){return this.assertNotDisposed(),Ue(this,a,"f")}set description(c){this.assertNotDisposed(),Ue(this,a,"f")!==c&&(tt(this,a,c,"f"),Ue(this,D,"f").$setWebviewViewDescription(Ue(this,P,"f"),c))}get visible(){return Ue(this,m,"f")}get webview(){return Ue(this,T,"f")}get viewType(){return Ue(this,i,"f")}_setVisible(c){c===Ue(this,m,"f")||Ue(this,C,"f")||(tt(this,m,c,"f"),Ue(this,d,"f").fire())}show(c){this.assertNotDisposed(),Ue(this,D,"f").$show(Ue(this,P,"f"),!!c)}assertNotDisposed(){if(Ue(this,C,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,D=new WeakMap,i=new WeakMap,T=new WeakMap,C=new WeakMap,m=new WeakMap,f=new WeakMap,a=new WeakMap,d=new WeakMap,E=new WeakMap;class b{constructor(c,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(I.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,g,t,n){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:t,extension:c}),this._proxy.$registerWebviewViewProvider((0,A.toExtensionData)(c),g,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(c,g,t,n,s){const r=this._viewProviders.get(g);if(!r)throw new Error(`No view provider found for '${g}'`);const{provider:o,extension:l}=r,h=this._extHostWebview.createNewWebview(c,{},l),S=new w(c,this._proxy,g,t,h,!0);this._webviewViews.set(c,S),await o.resolveWebviewView(S,{state:n},s)}async $onDidChangeWebviewViewVisibility(c,g){this.getWebviewView(c)._setVisible(g)}async $disposeWebviewView(c){const g=this.getWebviewView(c);this._webviewViews.delete(c),g.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const g=this._webviewViews.get(c);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=b}),define(me[126],ge([0,1,3,5,2,11,10,4,14]),function(G,e,_,k,A,I,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let i=class On{constructor(C){this._onDidChangeWindowState=new _.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=On.InitialState,this._proxy=C.getProxy(k.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:C}),this._onDidChangeWindowState.fire(this._state))}openUri(C,m){let f;if(typeof C=="string"){f=C;try{C=A.URI.parse(C)}catch(a){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,y.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,f,m)}async asExternalUri(C,m){if((0,y.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([I.Schemas.http,I.Schemas.https]).has(C.scheme))return Promise.reject(`Invalid scheme '${C.scheme}'`);const f=await this._proxy.$asExternalUri(C,m);return A.URI.from(f)}};i.InitialState={focused:!0},i=je([Be(0,D.IExtHostRpcService)],i),e.ExtHostWindow=i,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(me[254],ge([0,1,8,48,28,51,6,5,2,14]),function(G,e,_,k,A,I,y,P,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let T=class extends y.Disposable{constructor(m,f){super();const a=m.getProxy(P.MainContext.MainThreadDownloadService);f.registerCommand(!1,"_workbench.downloadResource",async d=>{const E=D.URI.file((0,_.join)((0,k.tmpdir)(),(0,A.generateUuid)()));return await a.$download(d,E),E})}};T=je([Be(0,i.IExtHostRpcService),Be(1,I.IExtHostCommands)],T),e.ExtHostDownloadService=T}),define(me[255],ge([0,1,2,8,146,26,37,65,27,14,6,13,112,45]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class a{constructor(b,p){this.file=p,this.appender=(0,m.createRotatingLogger)(b,p,30*f.ByteSize.MB,1),this.appender.clearFormatters()}append(b){this.appender.critical(b)}flush(){this.appender.flush()}}class d extends P.AbstractExtHostOutputChannel{constructor(b,p,c){super(b,!1,_.URI.file(p.file),c);this._appender=p}append(b){super.append(b),this._appender.append(b),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(b,p){this._appender.flush(),super.show(b,p)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=d;let E=class extends P.ExtHostOutputService{constructor(b,p,c){super(b);this.logService=p,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new T.MutableDisposable,this._logsLocation=c.logsLocation}$setVisibleChannel(b){if(b){const p=this._channels.get(b);p&&(this._visibleChannelDisposable.value=p.onDidAppend(()=>p.update()))}}createOutputChannel(b){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const p=this._doCreateOutChannel(b);return p.then(c=>c._id.then(g=>this._channels.set(g,c))),new P.LazyOutputChannel(b,p)}async _doCreateOutChannel(b){try{const p=(0,k.join)(this._logsLocation.fsPath,`output_logging_${(0,A.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await I.SymlinkSupport.existsDirectory(p)||await y.promises.mkdir(p,{recursive:!0});const g=`${this._namePool++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=_.URI.file((0,k.join)(p,`${g}.log`)),n=new a(g,t.fsPath);return new d(b,n,this._proxy)}catch(p){return this.logService.error(p),new P.ExtHostPushOutputChannel(b,this._proxy)}}};E=je([Be(0,i.IExtHostRpcService),Be(1,C.ILogService),Be(2,D.IExtHostInitDataService)],E),e.ExtHostOutputService2=E}),define(me[256],ge([0,1,5,14,6,27,2,38,25,37,26,7,9,50,3,73,13]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(h,S,u){this.remoteAddress=h,this.localAddress=S,this._dispose=u,this._onDispose=new a.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function b(l){const h=l.trim().split(`
`),S=[];return h.forEach(v=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(v);R&&R.length>=3&&S.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),S.reduce((v,R)=>(v[R.socket]=R,v),{})}e.getSockets=b;function p(...l){const h=[].concat(...l.map(g));return[...new Map(h.filter(S=>S.st==="0A").map(S=>{const u=S.local_address.split(":");return{socket:parseInt(S.inode,10),ip:c(u[0]),port:parseInt(u[1],16)}}).map(S=>[S.ip+":"+S.port,S])).values()]}e.loadListeningPorts=p;function c(l){let h="";if(l.length===8)for(let S=l.length-2;S>=0;S-=2)h+=parseInt(l.substr(S,2),16),S!==0&&(h+=".");else for(let S=l.length-4;S>=0;S-=4)h+=parseInt(l.substr(S,4),16).toString(16),S!==0&&(h+=":");return h}e.parseIpAddress=c;function g(l){const h=l.trim().split(`
`),S=h.shift().trim().split(/\s+/).filter(v=>v!=="rx_queue"&&v!=="tm->when");return h.map(v=>v.trim().split(/\s+/).reduce((R,L,H)=>(R[S[H]||H]=L,R),{}))}e.loadConnectionTable=g;function t(l){return!!l.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||l.indexOf("out/vs/server/main.js")!==-1||l.indexOf("_productName=VSCode")!==-1}function n(l){const h=l.trim().split(`
`),S=[];return h.forEach(u=>{const v=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(u);v&&v.length>=4&&S.push({pid:parseInt(v[1],10),ppid:parseInt(v[2]),cmd:v[3]})}),S}e.getRootProcesses=n;async function s(l,h,S){const u=S.reduce((R,L)=>(R[L.pid]=L,R),{}),v=[];return l.forEach(({socket:R,ip:L,port:H})=>{var ie;const j=h[R]?h[R].pid:void 0,B=j?(ie=u[j])===null||ie===void 0?void 0:ie.cmd:void 0;j&&B&&!t(B)&&v.push({host:L,port:H,detail:B,pid:j})}),v}e.findPorts=s;function r(l,h,S){const u=new Map,v=n(h);for(const R of l){const L=S.get(R.port);if(L){u.set(R.port,L);continue}const H=v.find(ie=>ie.cmd.includes(`${R.port}`));if(H){let ie=H,j;do j=v.find(B=>B.ppid===ie.pid),j&&(ie=j);while(j);u.set(R.port,{host:R.ip,port:R.port,pid:ie.pid,detail:ie.cmd,ppid:ie.ppid})}else u.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return u}e.tryFindRootPorts=r;let o=class extends A.Disposable{constructor(h,S,u){super();this.logService=u,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new a.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=h.getProxy(_.MainContext.MainThreadTunnelService),m.isLinux&&S.remote.isRemote&&S.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(h,S){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${h.identifier.value} called openTunnel API for ${S.remoteAddress.port}.`);const u=await this._proxy.$openTunnel(S,h.displayName);if(u){const v=new w(u.remoteAddress,u.localAddress,()=>this._proxy.$closeTunnel(u.remoteAddress));return this._register(v),v}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(h){return Math.max(h*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(h,S){const u=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(u,{selector:h,provider:S}),this._proxy.$registerPortsAttributesProvider(h,u),new C.Disposable(()=>{this._portAttributesProviders.delete(u),this._proxy.$unregisterPortsAttributesProvider(u)})}async $providePortAttributes(h,S,u,v,R){const L=[];for(const ie of h){const j=this._portAttributesProviders.get(ie);if(!j)return[];L.push(...await Promise.all(S.map(async B=>j.provider.providePortAttributes(B,u,v,R))))}const H=L.filter(ie=>!!ie);return H.length>0?H.map(ie=>({autoForwardAction:ie.autoForwardAction,port:ie.port})):[]}async $registerCandidateFinder(h){if(!(h&&this._candidateFindingEnabled)){this._candidateFindingEnabled=h;let S=new d.MovingAverage,u;for(;this._candidateFindingEnabled;){const v=new Date().getTime(),R=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(H=>H.port).join(", ")}`);const L=new Date().getTime()-v;S.update(L),(!u||JSON.stringify(u)!==JSON.stringify(R))&&(u=R,await this._proxy.$onFoundNewCandidates(u)),await new Promise(H=>setTimeout(()=>H(),this.calculateDelay(S.value)))}}}async setTunnelExtensionFunctions(h){var S;return h?(h.candidatePortSource!==void 0&&await this._proxy.$setCandidatePortSource(h.candidatePortSource),h.showCandidatePort&&(this._showCandidatePort=h.showCandidatePort,await this._proxy.$setCandidateFilter()),h.tunnelFactory&&(this._forwardPortProvider=h.tunnelFactory,await this._proxy.$setTunnelProvider((S=h.tunnelFeatures)!==null&&S!==void 0?S:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,A.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(h,S){if(this._extensionTunnels.has(h.host)){const u=this._extensionTunnels.get(h.host);u.has(h.port)&&(S&&u.get(h.port).disposeListener.dispose(),await u.get(h.port).tunnel.dispose(),u.delete(h.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(h,S){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const u=this._forwardPortProvider(h,S);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),u!==void 0){const v=await u;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(h.remoteAddress.host)||this._extensionTunnels.set(h.remoteAddress.host,new Map);const R=this._register(v.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(v.remoteAddress))));return this._extensionTunnels.get(h.remoteAddress.host).set(h.remoteAddress.port,{tunnel:v,disposeListener:R}),f.TunnelDto.fromApiTunnel(v)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(u){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(h){const S=await Promise.all(h.map(v=>{var R;return this._showCandidatePort(v.host,v.port,(R=v.detail)!==null&&R!==void 0?R:"")})),u=h.filter((v,R)=>S[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${h.map(v=>v.port).join(", ")} to ${u.map(v=>v.port).join(", ")}`),u}async findCandidatePorts(){let h="",S="";try{h=await i.promises.readFile("/proc/net/tcp","utf8"),S=await i.promises.readFile("/proc/net/tcp6","utf8")}catch(N){}const u=p(h,S),v=await new Promise(N=>{(0,P.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(M,F,U)=>{N(F)})}),R=b(v),L=await T.readdir("/proc"),H=[];for(let N of L)try{const M=Number(N),F=D.joinPath(y.URI.file("/proc"),N);if((await i.promises.stat(F.fsPath)).isDirectory()&&!isNaN(M)){const O=await i.promises.readlink(D.joinPath(F,"cwd").fsPath),W=await i.promises.readFile(D.joinPath(F,"cmdline").fsPath,"utf8");H.push({pid:M,cwd:O,cmd:W})}}catch(M){}const ie=[],j=u.filter(N=>{const M=R[N.socket];return M||ie.push(N),M}),B=s(j,R,H);let $;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${ie.length}`),ie.length>0){const N=await new Promise(M=>{(0,P.exec)("ps -F -A -l | grep root",(F,U,O)=>{M(U)})});this._foundRootPorts=r(ie,N,this._foundRootPorts),$=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${$.join(", ")}`)}return B.then(N=>$?N.concat($):N)}};o=je([Be(0,k.IExtHostRpcService),Be(1,I.IExtHostInitDataService),Be(2,E.ILogService)],o),e.ExtHostTunnelService=o}),define(me[257],ge([0,1,19,21,18,3,6,100,227,124,22]),function(G,e,_,k,A,I,y,P,D,i,T){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function m(r,o){try{return JSON.stringify(r,o)}catch(l){return"null"}}function f(r,o){return JSON.stringify(r,o)}function a(r){return r?(o,l)=>l&&l.$mid===1?r.transformOutgoing(l):l:null}var d;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},b=Symbol.for("rpcProtocol"),p=Symbol.for("rpcProxy");class c extends y.Disposable{constructor(o,l=null,h=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new I.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=o,this._logger=l,this._uriTransformer=h,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let S=0,u=i.ProxyIdentifier.count;S<u;S++)this._locals[S]=null,this._proxies[S]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new _.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(S=>this._receiveOneMessage(S))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(o=>{this._pendingRPCReplies[o].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(o){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(o){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(o){this._responsiveState!==o&&(this._responsiveState=o,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(o){return this._uriTransformer?(0,P.transformIncomingURIs)(o,this._uriTransformer):o}getProxy(o){const{nid:l,sid:h}=o;return this._proxies[l]||(this._proxies[l]=this._createProxy(l,h)),this._proxies[l]}_createProxy(o,l){let h={get:(S,u)=>(typeof u=="string"&&!S[u]&&u.charCodeAt(0)===36&&(S[u]=(...v)=>this._remoteCall(o,u,v)),u===p?l:S[u])};return new Proxy(Object.create(null),h)}set(o,l){return this._locals[o.nid]=l,l}assertRegistered(o){for(let l=0,h=o.length;l<h;l++){const S=o[l];if(!this._locals[S.nid])throw new Error(`Missing actor ${S.sid} (isMain: ${S.isMain})`)}}_receiveOneMessage(o){if(!this._isDisposed){const l=o.byteLength,h=g.read(o,0),S=h.readUInt8(),u=h.readUInt32();switch(S){case 1:case 2:{let{rpcId:v,method:R,args:L}=t.deserializeRequestJSONArgs(h);this._uriTransformer&&(L=(0,P.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(l,u,v,R,L,S===2);break}case 3:case 4:{let{rpcId:v,method:R,args:L}=t.deserializeRequestMixedArgs(h);this._uriTransformer&&(L=(0,P.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(l,u,v,R,L,S===4);break}case 5:{this._logger&&this._logger.logIncoming(l,u,0,"ack"),this._onDidReceiveAcknowledge(u);break}case 6:{this._receiveCancel(l,u);break}case 7:{this._receiveReply(l,u,void 0);break}case 9:{let v=t.deserializeReplyOKJSON(h);this._uriTransformer&&(v=(0,P.transformIncomingURIs)(v,this._uriTransformer)),this._receiveReply(l,u,v);break}case 8:{let v=t.deserializeReplyOKVSBuffer(h);this._receiveReply(l,u,v);break}case 10:{let v=t.deserializeReplyErrError(h);this._uriTransformer&&(v=(0,P.transformIncomingURIs)(v,this._uriTransformer)),this._receiveReplyErr(l,u,v);break}case 11:{this._receiveReplyErr(l,u,void 0);break}default:console.error("received unexpected message"),console.error(o)}}}_receiveRequest(o,l,h,S,u,v){this._logger&&this._logger.logIncoming(o,l,1,`receiveRequest ${(0,i.getStringIdentifierForProxy)(h)}.${S}(`,u);const R=String(l);let L,H;if(v){const j=new k.CancellationTokenSource;u.push(j.token),L=this._invokeHandler(h,S,u),H=()=>j.cancel()}else L=this._invokeHandler(h,S,u),H=w;this._cancelInvokedHandlers[R]=H;const ie=t.serializeAcknowledged(l);this._logger&&this._logger.logOutgoing(ie.byteLength,l,1,"ack"),this._protocol.send(ie),L.then(j=>{delete this._cancelInvokedHandlers[R];const B=t.serializeReplyOK(l,j,this._uriReplacer);this._logger&&this._logger.logOutgoing(B.byteLength,l,1,"reply:",j),this._protocol.send(B)},j=>{delete this._cancelInvokedHandlers[R];const B=t.serializeReplyErr(l,j);this._logger&&this._logger.logOutgoing(B.byteLength,l,1,"replyErr:",j),this._protocol.send(B)})}_receiveCancel(o,l){this._logger&&this._logger.logIncoming(o,l,1,"receiveCancel");const h=String(l);this._cancelInvokedHandlers[h]&&this._cancelInvokedHandlers[h]()}_receiveReply(o,l,h){this._logger&&this._logger.logIncoming(o,l,0,"receiveReply:",h);const S=String(l);if(!!this._pendingRPCReplies.hasOwnProperty(S)){const u=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S],u.resolveOk(h)}}_receiveReplyErr(o,l,h){this._logger&&this._logger.logIncoming(o,l,0,"receiveReplyErr:",h);const S=String(l);if(!!this._pendingRPCReplies.hasOwnProperty(S)){const u=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S];let v;h&&(h.$isError?(v=new Error,v.name=h.name,v.message=h.message,v.stack=h.stack):v=h),u.resolveErr(v)}}_invokeHandler(o,l,h){try{return Promise.resolve(this._doInvokeHandler(o,l,h))}catch(S){return Promise.reject(S)}}_doInvokeHandler(o,l,h){const S=this._locals[o];if(!S)throw new Error("Unknown actor "+(0,i.getStringIdentifierForProxy)(o));let u=S[l];if(typeof u!="function")throw new Error("Unknown method "+l+" on actor "+(0,i.getStringIdentifierForProxy)(o));return u.apply(S,h)}_remoteCall(o,l,h){if(this._isDisposed)return Promise.reject(A.canceled());let S=null;if(h.length>0&&k.CancellationToken.isCancellationToken(h[h.length-1])&&(S=h.pop()),S&&S.isCancellationRequested)return Promise.reject(A.canceled());const u=t.serializeRequestArguments(h,this._uriReplacer),v=++this._lastMessageId,R=String(v),L=new D.LazyPromise;S&&S.onCancellationRequested(()=>{const ie=t.serializeCancel(v);this._logger&&this._logger.logOutgoing(ie.byteLength,v,0,"cancel"),this._protocol.send(t.serializeCancel(v))}),this._pendingRPCReplies[R]=L,this._onWillSendRequest(v);const H=t.serializeRequest(v,o,l,u,!!S);return this._logger&&this._logger.logOutgoing(H.byteLength,v,0,`request: ${(0,i.getStringIdentifierForProxy)(o)}.${l}(`,h),this._protocol.send(H),L}}e.RPCProtocol=c,C=b,c.UNRESPONSIVE_TIME=3*1e3;class g{constructor(o,l){this._buff=o,this._offset=l}static alloc(o,l,h){let S=new g(T.VSBuffer.alloc(h+1+4),0);return S.writeUInt8(o),S.writeUInt32(l),S}static read(o,l){return new g(o,l)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(o){this._buff.writeUInt8(o,this._offset),this._offset+=1}readUInt8(){const o=this._buff.readUInt8(this._offset);return this._offset+=1,o}writeUInt32(o){this._buff.writeUInt32BE(o,this._offset),this._offset+=4}readUInt32(){const o=this._buff.readUInt32BE(this._offset);return this._offset+=4,o}static sizeShortString(o){return 1+o.byteLength}writeShortString(o){this._buff.writeUInt8(o.byteLength,this._offset),this._offset+=1,this._buff.set(o,this._offset),this._offset+=o.byteLength}readShortString(){const o=this._buff.readUInt8(this._offset);this._offset+=1;const h=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,h}static sizeLongString(o){return 4+o.byteLength}writeLongString(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readLongString(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const h=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,h}writeBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}static sizeVSBuffer(o){return 4+o.byteLength}writeVSBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readVSBuffer(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const l=this._buff.slice(this._offset,this._offset+o);return this._offset+=o,l}static sizeMixedArray(o,l){let h=0;h+=1;for(let S=0,u=o.length;S<u;S++){const v=o[S],R=l[S];switch(h+=1,R){case 1:h+=this.sizeLongString(v);break;case 2:h+=this.sizeVSBuffer(v);break;case 3:break}}return h}writeMixedArray(o,l){this._buff.writeUInt8(o.length,this._offset),this._offset+=1;for(let h=0,S=o.length;h<S;h++){const u=o[h];switch(l[h]){case 1:this.writeUInt8(1),this.writeLongString(u);break;case 2:this.writeUInt8(2),this.writeVSBuffer(u);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const o=this._buff.readUInt8(this._offset);this._offset+=1;let l=new Array(o);for(let h=0;h<o;h++)switch(this.readUInt8()){case 1:l[h]=this.readLongString();break;case 2:l[h]=this.readVSBuffer();break;case 3:l[h]=void 0;break}return l}}class t{static _arrayContainsBufferOrUndefined(o){for(let l=0,h=o.length;l<h;l++)if(o[l]instanceof T.VSBuffer||typeof o[l]=="undefined")return!0;return!1}static serializeRequestArguments(o,l){if(this._arrayContainsBufferOrUndefined(o)){let h=[],S=[];for(let u=0,v=o.length;u<v;u++){const R=o[u];R instanceof T.VSBuffer?(h[u]=R,S[u]=2):typeof R=="undefined"?(h[u]=T.VSBuffer.alloc(0),S[u]=3):(h[u]=T.VSBuffer.fromString(f(R,l)),S[u]=1)}return{type:"mixed",args:h,argsType:S}}return{type:"simple",args:f(o,l)}}static serializeRequest(o,l,h,S,u){return S.type==="mixed"?this._requestMixedArgs(o,l,h,S.args,S.argsType,u):this._requestJSONArgs(o,l,h,S.args,u)}static _requestJSONArgs(o,l,h,S,u){const v=T.VSBuffer.fromString(h),R=T.VSBuffer.fromString(S);let L=0;L+=g.sizeUInt8(),L+=g.sizeShortString(v),L+=g.sizeLongString(R);let H=g.alloc(u?2:1,o,L);return H.writeUInt8(l),H.writeShortString(v),H.writeLongString(R),H.buffer}static deserializeRequestJSONArgs(o){const l=o.readUInt8(),h=o.readShortString(),S=o.readLongString();return{rpcId:l,method:h,args:JSON.parse(S)}}static _requestMixedArgs(o,l,h,S,u,v){const R=T.VSBuffer.fromString(h);let L=0;L+=g.sizeUInt8(),L+=g.sizeShortString(R),L+=g.sizeMixedArray(S,u);let H=g.alloc(v?4:3,o,L);return H.writeUInt8(l),H.writeShortString(R),H.writeMixedArray(S,u),H.buffer}static deserializeRequestMixedArgs(o){const l=o.readUInt8(),h=o.readShortString(),S=o.readMixedArray(),u=new Array(S.length);for(let v=0,R=S.length;v<R;v++){const L=S[v];typeof L=="string"?u[v]=JSON.parse(L):u[v]=L}return{rpcId:l,method:h,args:u}}static serializeAcknowledged(o){return g.alloc(5,o,0).buffer}static serializeCancel(o){return g.alloc(6,o,0).buffer}static serializeReplyOK(o,l,h){return typeof l=="undefined"?this._serializeReplyOKEmpty(o):l instanceof T.VSBuffer?this._serializeReplyOKVSBuffer(o,l):this._serializeReplyOKJSON(o,m(l,h))}static _serializeReplyOKEmpty(o){return g.alloc(7,o,0).buffer}static _serializeReplyOKVSBuffer(o,l){let h=0;h+=g.sizeVSBuffer(l);let S=g.alloc(8,o,h);return S.writeVSBuffer(l),S.buffer}static deserializeReplyOKVSBuffer(o){return o.readVSBuffer()}static _serializeReplyOKJSON(o,l){const h=T.VSBuffer.fromString(l);let S=0;S+=g.sizeLongString(h);let u=g.alloc(9,o,S);return u.writeLongString(h),u.buffer}static deserializeReplyOKJSON(o){const l=o.readLongString();return JSON.parse(l)}static serializeReplyErr(o,l){return l?this._serializeReplyErrEror(o,l):this._serializeReplyErrEmpty(o)}static _serializeReplyErrEror(o,l){const h=T.VSBuffer.fromString(m(A.transformErrorForSerialization(l),null));let S=0;S+=g.sizeLongString(h);let u=g.alloc(10,o,S);return u.writeLongString(h),u.buffer}static deserializeReplyErrError(o){const l=o.readLongString();return JSON.parse(l)}static _serializeReplyErrEmpty(o){return g.alloc(11,o,0).buffer}}var n;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var s;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(s||(s={}))}),define(me[258],ge([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,_.createDecorator)("remoteAgentService")}),define(me[259],ge([0,1,11,8,9,2,4,258]),function(G,e,_,k,A,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=class{constructor(T,C){this.localUserHome=T,this.remoteAgentService=C,this.resolveOS=(async()=>{const m=await this.remoteAgentService.getEnvironment();return(m==null?void 0:m.os)||A.OS})(),this.resolveUserHome=(async()=>{const m=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(m==null?void 0:m.userHome)||T})()}async userHome(T){return(T==null?void 0:T.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(T=>T===1?k.win32:k.posix)}async fileURI(T){let C="";if(await this.resolveOS===1&&(T=T.replace(/\\/g,"/")),T[0]==="/"&&T[1]==="/"){const f=T.indexOf("/",2);f===-1?(C=T.substring(2),T="/"):(C=T.substring(2,f),T=T.substring(f)||"/")}return I.URI.from({scheme:_.Schemas.file,authority:C,path:T,query:"",fragment:""})}};D=je([Be(1,P.IRemoteAgentService)],D),e.AbstractPathService=D}),define(me[31],ge([0,1,15,33,23,30,10,4,8,18]),function(G,e,_,k,A,I,y,P,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const T="\u27EA ",C=" characters skipped \u27EB",m=(T.length+C.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var f;(function(N){N[N.file=0]="file",N[N.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var a;(function(N){N[N.File=1]="File",N[N.Text=2]="Text"})(a=e.QueryType||(e.QueryType={}));function d(N){return!!N.preview}e.resultIsMatch=d;function E(N){return!!N.resource}e.isFileMatch=E;function w(N){return!!N.message}e.isProgressMessage=w;var b;(function(N){N[N.Normal=0]="Normal",N[N.NewSearchStarted=1]="NewSearchStarted"})(b=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(M){this.resource=M,this.results=[]}}e.FileMatch=p;class c{constructor(M,F,U){this.ranges=F;const O=Array.isArray(F)?F:[F];if(U&&U.matchLines===1&&g(O)){M=(0,y.getNLines)(M,U.matchLines);let W="",q=0,Q=0;const he=Math.floor(U.charsPerLine/5),ve=[];for(const Ie of O){const ke=Math.max(Ie.startColumn-he,0),Le=Ie.startColumn+U.charsPerLine;if(ke>Q+he+m){const V=T+(ke-Q)+C;W+=V+M.slice(ke,Le),q+=ke-(Q+V.length)}else W+=M.slice(Q,Le);ve.push(new n(0,Ie.startColumn-q,Ie.endColumn-q)),Q=Le}this.preview={text:W,matches:Array.isArray(this.ranges)?ve:ve[0]}}else{const W=Array.isArray(F)?F[0].startLineNumber:F.startLineNumber;this.preview={text:M,matches:(0,_.mapArrayOrNot)(F,q=>new t(q.startLineNumber-W,q.startColumn,q.endLineNumber-W,q.endColumn))}}}}e.TextSearchMatch=c;function g(N){const M=N[0].startLineNumber;for(const F of N)if(F.startLineNumber!==M||F.endLineNumber!==M)return!1;return!0}class t{constructor(M,F,U,O){this.startLineNumber=M,this.startColumn=F,this.endLineNumber=U,this.endColumn=O}}e.SearchRange=t;class n extends t{constructor(M,F,U){super(M,F,M,U)}}e.OneLineRange=n;var s;(function(N){N.Default="default",N.FileNames="fileNames",N.Type="type",N.Modified="modified",N.CountDescending="countDescending",N.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function r(N,M=!0){const F=N&&N.files&&N.files.exclude,U=M&&N&&N.search&&N.search.exclude;if(!(!F&&!U)){if(!F||!U)return F||U;let O=Object.create(null);return O=A.mixin(O,A.deepClone(F)),O=A.mixin(O,A.deepClone(U),!0),O}}e.getExcludes=r;function o(N,M){return N.excludePattern&&k.match(N.excludePattern,M)?!1:N.includePattern||N.usingSearchPaths?N.includePattern&&k.match(N.includePattern,M)?!0:N.usingSearchPaths?!!N.folderQueries&&N.folderQueries.some(F=>{const U=F.folder.fsPath;if(I.isEqualOrParent(M,U)){const O=D.relative(U,M);return!F.includePattern||!!k.match(F.includePattern,O)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var l;(function(N){N[N.unknownEncoding=1]="unknownEncoding",N[N.regexParseError=2]="regexParseError",N[N.globParseError=3]="globParseError",N[N.invalidLiteral=4]="invalidLiteral",N[N.rgProcessError=5]="rgProcessError",N[N.other=6]="other",N[N.canceled=7]="canceled"})(l=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(M,F){super(M);this.code=F}}e.SearchError=h;function S(N){const M=N.message;if((0,i.isPromiseCanceledError)(N))return new h(M,l.canceled);try{const F=JSON.parse(M);return new h(F.message,F.code)}catch(F){return new h(M,l.other)}}e.deserializeSearchError=S;function u(N){const M={message:N.message,code:N.code};return new Error(JSON.stringify(M))}e.serializeSearchError=u;function v(N){return N.type==="error"?!0:N.type==="success"}e.isSerializedSearchComplete=v;function R(N){return N.type==="success"}e.isSerializedSearchSuccess=R;function L(N){return!!N.path}e.isSerializedFileMatch=L;function H(N,M){const F=N.searchPath?N.searchPath:N.relativePath;return(0,y.fuzzyContains)(F,M)}e.isFilePatternMatch=H;class ie{constructor(M){this.path=M,this.results=[]}addMatch(M){this.results.push(M)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ie;function j(N,M){const F=Object.assign(Object.assign({},N||{}),M||{});return Object.keys(F).filter(U=>{const O=F[U];return typeof O=="boolean"&&O})}e.resolvePatternsForProvider=j;class B{constructor(M,F){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},M.excludePattern||{}),F.excludePattern||{}),this._parsedExcludeExpression=k.parse(this._excludeExpression);let U=M.includePattern;F.includePattern&&(U?U=Object.assign(Object.assign({},U),F.includePattern):U=F.includePattern),U&&(this._parsedIncludeExpression=k.parse(U))}includedInQuerySync(M,F,U){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(M,F,U)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(M,F,U))}includedInQuery(M,F,U){return Promise.resolve(this._parsedExcludeExpression(M,F,U)).then(W=>!!W).then(W=>W?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(M,F,U)).then(q=>!!q):Promise.resolve(!0)).then(W=>W)}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=B;function $(N){for(const M in N)if(typeof N[M]!="boolean")return!0;return!1}}),define(me[32],ge([0,1,15,19,21,3,24,11,73,25,10,12,2,167,4,13,186,60,61,27,14,7,31,5]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d,E,w,b,p,c,g,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(R,L,H){return new i.ExtUri(ie=>h(ie,H)).isEqual(R,L)}function r(R,L,H){return s(R.uri,L.uri,H)?0:(0,T.compare)(R.uri.toString(),L.uri.toString())}function o(R,L,H){return R.index!==L.index?R.index<L.index?-1:1:s(R.uri,L.uri,H)?(0,T.compare)(R.name,L.name):(0,T.compare)(R.uri.toString(),L.uri.toString())}function l(R,L,H,ie){const j=R.slice(0).sort(($,N)=>H($,N,ie)),B=L.slice(0).sort(($,N)=>H($,N,ie));return(0,_.delta)(j,B,($,N)=>H($,N,ie))}function h(R,L){const H=L.getCapabilities(R.scheme);return!(H&&H&1024)}class S extends w.Workspace{constructor(L,H,ie,j,B,$){super(L,ie.map(N=>new w.WorkspaceFolder(N)),j,$);this._name=H,this._isUntitled=B,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris($),ie.forEach(N=>{this._workspaceFolders.push(N),this._structure.set(N.uri,N)})}static toExtHostWorkspace(L,H,ie,j){if(!L)return{workspace:null,added:[],removed:[]};const{id:B,name:$,folders:N,configuration:M,isUntitled:F}=L,U=[],O=H;H?N.forEach((he,ve)=>{const Ie=m.URI.revive(he.uri),ke=S._findFolder(ie||H,Ie,j);ke?(ke.name=he.name,ke.index=he.index,U.push(ke)):U.push({uri:Ie,name:he.name,index:ve})}):U.push(...N.map(({uri:he,name:ve,index:Ie})=>({uri:m.URI.revive(he),name:ve,index:Ie}))),U.sort((he,ve)=>he.index<ve.index?-1:1);const W=new S(B,$,U,M?m.URI.revive(M):null,!!F,he=>h(he,j)),{added:q,removed:Q}=l(O?O.workspaceFolders:[],W.workspaceFolders,r,j);return{workspace:W,added:q,removed:Q}}static _findFolder(L,H,ie){for(let j=0;j<L.folders.length;j++){const B=L.workspaceFolders[j];if(s(B.uri,H,ie))return B}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,H){return H&&this._structure.get(L)&&(L=(0,i.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let u=class{constructor(L,H,ie,j){this._onDidChangeWorkspace=new I.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidReceieveWorkspaceTrust=new I.Emitter,this.onDidReceiveWorkspaceTrust=this._onDidReceieveWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=j,this._extHostFileSystemInfo=ie,this._requestIdProvider=new D.Counter,this._barrier=new k.Barrier,this._proxy=L.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(n.MainContext.MainThreadMessageService);const B=H.workspace;this._confirmedWorkspace=B?new S(B.id,B.name,[],B.configuration?m.URI.revive(B.configuration):null,!!B.isUntitled,$=>h($,ie)):void 0}$initializeWorkspace(L,H){this._trusted=H,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?m.URI.from({scheme:P.Schemas.untitled,path:(0,i.basename)((0,i.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,H,ie,...j){const B=[];if(Array.isArray(j)&&j.forEach(U=>{m.URI.isUri(U.uri)&&!B.some(O=>s(O.uri,U.uri,this._extHostFileSystemInfo))&&B.push({uri:U.uri,name:U.name||(0,i.basenameOrAuthority)(U.uri)})}),this._unconfirmedWorkspace||[H,ie].some(U=>typeof U!="number"||U<0)||ie===0&&B.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(H+ie>$.length)return!1;const N=$.slice(0);N.splice(H,ie,...B.map(U=>({uri:U.uri,name:U.name||(0,i.basenameOrAuthority)(U.uri),index:void 0})));for(let U=0;U<N.length;U++){const O=N[U];if(N.some((W,q)=>q!==U&&s(O.uri,W.uri,this._extHostFileSystemInfo)))return!1}N.forEach((U,O)=>U.index=O);const{added:M,removed:F}=l($,N,o,this._extHostFileSystemInfo);if(M.length===0&&F.length===0)return!1;if(this._proxy){const U=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(U,H,ie,B).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(E.Severity.Error,(0,f.localize)(0,null,U,O.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(N),!0}getWorkspaceFolder(L,H){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,H)}async getWorkspaceFolder2(L,H){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,H)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!!this._actualWorkspace){const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}}getRelativePath(L,H){let ie,j="";if(typeof L=="string"?(ie=m.URI.file(L),j=L):typeof L!="undefined"&&(ie=L,j=L.fsPath),!ie)return j;const B=this.getWorkspaceFolder(ie,!0);if(!B)return j;typeof H=="undefined"&&this._actualWorkspace&&(H=this._actualWorkspace.folders.length>1);let $=(0,i.relativePath)(B.uri,ie);return H&&B.name&&($=`${B.name}/${$}`),$}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=S.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:H,added:ie,removed:j}=S.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=H||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ie,removed:j}))}findFiles(L,H,ie,j,B=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let $;if(H===null?$=!1:H&&(typeof H=="string"?$=H:$=H.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:N,folder:M}=v(L);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(N),(0,C.withUndefinedAsNull)(M),(0,C.withUndefinedAsNull)($),(0,C.withUndefinedAsNull)(ie),B).then(F=>Array.isArray(F)?F.map(U=>m.URI.revive(U)):[])}async findTextInFiles(L,H,ie,j,B=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),N=typeof H.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:H.previewOptions,{includePattern:M,folder:F}=v(H.include),U=typeof H.exclude=="string"?H.exclude:H.exclude?H.exclude.pattern:void 0,O={ignoreSymlinks:typeof H.followSymlinks=="boolean"?!H.followSymlinks:void 0,disregardIgnoreFiles:typeof H.useIgnoreFiles=="boolean"?!H.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof H.useGlobalIgnoreFiles=="boolean"?!H.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof H.useDefaultExcludes=="boolean"?!H.useDefaultExcludes:!0,fileEncoding:H.encoding,maxResults:H.maxResults,previewOptions:N,afterContext:H.afterContext,beforeContext:H.beforeContext,includePattern:M,excludePattern:U},W=!1;if(this._activeSearchCallbacks[$]=q=>{if(!W){const Q=m.URI.revive(q.resource);q.results.forEach(he=>{(0,t.resultIsMatch)(he)?ie({uri:Q,preview:{text:he.preview.text,matches:(0,_.mapArrayOrNot)(he.preview.matches,ve=>new g.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,_.mapArrayOrNot)(he.ranges,ve=>new g.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):ie({uri:Q,text:he.text,lineNumber:he.lineNumber})})}},B.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(L,(0,C.withUndefinedAsNull)(F),O,$,B);return delete this._activeSearchCallbacks[$],q||{}}catch(q){throw delete this._activeSearchCallbacks[$],q}}$handleTextSearchResult(L,H){this._activeSearchCallbacks[H]&&this._activeSearchCallbacks[H](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidReceiveWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidReceieveWorkspaceTrust.fire())}};u=je([Be(0,c.IExtHostRpcService),Be(1,p.IExtHostInitDataService),Be(2,b.IExtHostFileSystemInfo),Be(3,d.ILogService)],u),e.ExtHostWorkspace=u,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function v(R){let L,H;return R&&(typeof R=="string"?L=R:(L=R.pattern,H=R.baseFolder||m.URI.file(R.base))),{includePattern:L,folder:H}}}),define(me[35],ge([0,1,23,3,32,5,7,188,83,12,19,4,14,13,2]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(n,s){if(s){const r=s.split(".");let o=n;for(let l=0;o&&l<r.length;l++)o=o[r[l]];return o}}function E(n){return n instanceof a.URI}function w(n){return n&&n.uri instanceof a.URI&&n.languageId&&typeof n.languageId=="string"}function b(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function p(n){return n&&n.uri instanceof a.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function c(n){if(E(n))return{resource:n};if(w(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(b(n))return{overrideIdentifier:n.languageId};if(p(n))return{resource:n.uri};if(n===null)return{resource:null}}let g=class{constructor(s,r,o){this._proxy=s.getProxy(I.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=o,this._barrier=new T.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,r){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(s,r))}};g=je([Be(0,m.IExtHostRpcService),Be(1,A.IExtHostWorkspace),Be(2,f.ILogService)],g),e.ExtHostConfiguration=g;class t{constructor(s,r,o,l){this._onDidChangeConfiguration=new k.Emitter,this._proxy=s,this._logService=l,this._extHostWorkspace=r,this._configuration=P.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,r){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,o))}getConfiguration(s,r,o){const l=c(r)||{},h=this._toReadonlyValue(s?d(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,l,o==null?void 0:o.identifier);function S(v){if(v==null)return null;if(typeof v=="boolean")return v?1:4;switch(v){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(v){return typeof d(h,v)!="undefined"},get:(v,R)=>{this._validateConfigurationAccess(s?`${s}.${v}`:v,l,o==null?void 0:o.identifier);let L=d(h,v);if(typeof L=="undefined")L=R;else{let H;const ie=(j,B)=>{let $;const N=()=>{H=H||(0,_.deepClone)(h),$=$||d(H,B)};return(0,i.isObject)(j)?new Proxy(j,{get:(M,F)=>{if(typeof F=="string"&&F.toLowerCase()==="tojson")return N(),()=>$;if(H)return $=$||d(H,B),$[F];const U=M[F];return typeof F=="string"?ie(U,`${B}.${F}`):U},set:(M,F,U)=>(N(),$&&($[F]=U),!0),deleteProperty:(M,F)=>(N(),$&&delete $[F],!0),defineProperty:(M,F,U)=>(N(),$&&Object.defineProperty($,F,U),!0)}):j};L=ie(L,v)}return L},update:(v,R,L,H)=>{v=s?`${s}.${v}`:v;const ie=S(L);return R!==void 0?this._proxy.$updateConfigurationOption(ie,v,R,l,H):this._proxy.$removeConfigurationOption(ie,v,l,H)},inspect:v=>{var R,L,H,ie,j,B,$,N;v=s?`${s}.${v}`:v;const M=(0,_.deepClone)(this._configuration.inspect(v,l,this._extHostWorkspace.workspace));if(M)return{key:v,defaultValue:(R=M.default)===null||R===void 0?void 0:R.value,globalValue:(L=M.user)===null||L===void 0?void 0:L.value,workspaceValue:(H=M.workspace)===null||H===void 0?void 0:H.value,workspaceFolderValue:(ie=M.workspaceFolder)===null||ie===void 0?void 0:ie.value,defaultLanguageValue:(j=M.default)===null||j===void 0?void 0:j.override,globalLanguageValue:(B=M.user)===null||B===void 0?void 0:B.override,workspaceLanguageValue:($=M.workspace)===null||$===void 0?void 0:$.override,workspaceFolderLanguageValue:(N=M.workspaceFolder)===null||N===void 0?void 0:N.override,languageIds:M.overrideIdentifiers}}};return typeof h=="object"&&(0,_.mixin)(u,h,!1),Object.freeze(u)}_toReadonlyValue(s){const r=o=>(0,i.isObject)(o)?new Proxy(o,{get:(l,h)=>r(l[h]),set:(l,h,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(h)}' of object`)},deleteProperty:(l,h)=>{throw new Error(`TypeError: Cannot delete read only property '${String(h)}' of object`)},defineProperty:(l,h)=>{throw new Error(`TypeError: Cannot define property '${String(h)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return r(s)}_validateConfigurationAccess(s,r,o){const l=D.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),h=o?`[${o.value}] `:"";if(l===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${h}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){(r==null?void 0:r.resource)&&this._logService.warn(`${h}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,r){const o=new P.ConfigurationChangeEvent(s,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,h)=>o.affectsConfiguration(l,c(h))})}_toMap(s){return s.reduce((r,o)=>(r.set(o[0],o[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!k:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(G):k?k.value:e.get(G)};define(me[67],ge([0,1,2,19,3,5,7,32,39,35,21,34,14,27,4,11,9,13,64,209,18]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d,E,w,b,p,c){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(j){function B(N){if(N!=null)return N}j.from=B;function $(N){if(N!=null)return N}j.to=$})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(j){function B(N){if(N!=null)return N}j.from=B;function $(N){if(N!=null)return N}j.to=$})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(j){function B(N){if(N!=null)return N}j.from=B;function $(N){if(N!=null)return N}j.to=$})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(j){function B(M){if(M){const F=M;return F&&!!F.process}else return!1}j.is=B;function $(M){if(M!=null){const F={process:M.process,args:M.args};return M.options&&(F.options=s.from(M.options)),F}}j.from=$;function N(M){if(M!=null)return new y.ProcessExecution(M.process,M.args,M.options)}j.to=N})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(j){function B(N){if(N!=null)return N}j.from=B;function $(N){if(N!=null)return N}j.to=$})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var l;(function(j){function B(M){if(M){const F=M;return F&&(!!F.commandLine||!!F.command)}else return!1}j.is=B;function $(M){if(M!=null){const F={};return M.commandLine!==void 0?F.commandLine=M.commandLine:(F.command=M.command,F.args=M.args),M.options&&(F.options=o.from(M.options)),F}}j.from=$;function N(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new y.ShellExecution(M.commandLine,M.options):new y.ShellExecution(M.command,M.args?M.args:[],M.options)}j.to=N})(l=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var h;(function(j){function B(M){if(M){let F=M;return F&&F.customExecution==="customExecution"}else return!1}j.is=B;function $(M){return{customExecution:"customExecution"}}j.from=$;function N(M,F){return F.get(M)}j.to=N})(h=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var S;(function(j){function B($,N){let M;return $.scope!==void 0&&typeof $.scope!="number"?M=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===y.TaskScope.Workspace&&N&&N.workspaceFile?M=N.workspaceFile:M=p.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:M}}j.from=B})(S=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function(j){function B(M,F){if(M==null)return[];const U=[];for(let O of M){const W=$(O,F);W&&U.push(W)}return U}j.fromMany=B;function $(M,F){if(M!=null){let U;M.execution instanceof y.ProcessExecution?U=r.from(M.execution):M.execution instanceof y.ShellExecution?U=l.from(M.execution):M.execution&&M.execution instanceof y.CustomExecution&&(U=h.from(M.execution));const O=t.from(M.definition);let W;if(M.scope?typeof M.scope=="number"?W=M.scope:W=M.scope.uri:W=y.TaskScope.Workspace,!(!O||!W)){const q=M.group?M.group.id:void 0;return{_id:M._id,definition:O,name:M.name,source:{extensionId:F.identifier.value,label:M.source,scope:W},execution:U,isBackground:M.isBackground,group:q,presentationOptions:n.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}}}j.from=$;async function N(M,F,U){if(M!=null){let O;r.is(M.execution)?O=r.to(M.execution):l.is(M.execution)?O=l.to(M.execution):h.is(M.execution)&&(O=h.to(M._id,U));const W=t.to(M.definition);let q;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?q=M.source.scope:q=await F.resolveWorkspaceFolder(_.URI.revive(M.source.scope)):q=y.TaskScope.Workspace),!(!W||!q)){const Q=new y.Task(W,q,M.name,M.source.label,O,M.problemMatchers);return M.isBackground!==void 0&&(Q.isBackground=M.isBackground),M.group!==void 0&&(Q.group=y.TaskGroup.from(M.group)),M.presentationOptions&&(Q.presentationOptions=n.to(M.presentationOptions)),M._id&&(Q._id=M._id),M.detail&&(Q.detail=M.detail),Q}}}j.to=N})(u=e.TaskDTO||(e.TaskDTO={}));var v;(function(j){function B(N){return N}j.from=B;function $(N){if(!!N)return Object.assign(Object.create(null),N)}j.to=$})(v=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(B,$,N){this._id=$,this._task=N,g.set(this,void 0),tt(this,g,B,"f")}get task(){return this._task}terminate(){Ue(this,g,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}g=new WeakMap;var L;(function(j){function B($){return{id:$._id,task:void 0}}j.from=B})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let H=class{constructor(B,$,N,M,F,U,O,W){this._onDidExecuteTask=new A.Emitter,this._onDidTerminateTask=new A.Emitter,this._onDidTaskProcessStarted=new A.Emitter,this._onDidTaskProcessEnded=new A.Emitter,this._proxy=B.getProxy(I.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=M,this._configurationService=F,this._terminalService=U,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=O,this._deprecationService=W,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,$,N){if(!N)return new y.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:$,provider:N,extension:B}),this._proxy.$registerTaskProvider(M,$),new y.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(B,$){this._proxy.$registerTaskSystem(B,$)}fetchTasks(B){return this._proxy.$fetchTasks(v.from(B)).then(async $=>{const N=[];for(let M of $){const F=await u.to(M,this._workspaceProvider,this._providedCustomExecutions2);F&&N.push(F)}return N})}get taskExecutions(){const B=[];return this._taskExecutions.forEach($=>B.push($)),B}terminateTask(B){if(!(B instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,$,N){const M=this._providedCustomExecutions2.get(B.id);if(M){if(this._activeCustomExecutions2.get(B.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(B.id,M),this._terminalService.attachPtyToTerminal($,await M.callback(N))}this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const $=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const $=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:$,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const $=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:B.exitCode})}$provideTasks(B,$){const N=this._handlers.get(B);if(!N)return Promise.reject(new Error("no handler found"));const M=[],F=(0,k.asPromise)(()=>N.provider.provideTasks(T.CancellationToken.None)).then(U=>this.provideTasksInternal($,M,N,U));return new Promise(U=>{F.then(O=>{Promise.all(M).then(()=>{U(O)})})})}async $resolveTask(B,$){const N=this._handlers.get(B);if(!N)return Promise.reject(new Error("no handler found"));if($.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${N.type}].`);const M=await u.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const F=await N.provider.resolveTask(M,T.CancellationToken.None);if(!!F){this.checkDeprecation(F,N);const U=u.from(F,N.extension);if(!U)throw new Error("Unexpected: Task cannot be resolved.");if(F.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(U.execution)&&await this.addCustomExecution(U,F,!0),await this.resolveTaskInternal(U)}}nextHandle(){return this._handleCounter++}async addCustomExecution(B,$,N){const M=await this._proxy.$createTaskId(B);!N&&!this._providedCustomExecutions2.has(M)&&this._notProvidedCustomExecutions.add(M),this._providedCustomExecutions2.set(M,$.execution)}async getTaskExecution(B,$){if(typeof B=="string"){const F=this._taskExecutionPromises.get(B);if(!F)throw new Error("Unexpected: The specified task is missing an execution");return F}let N=this._taskExecutionPromises.get(B.id);if(N)return N;const M=new Promise(async(F,U)=>{const O=$||await u.to(B.task,this._workspaceProvider,this._providedCustomExecutions2);O?F(new R(this,B.id,O)):U("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(B.id,M),M.then(F=>(this._taskExecutions.set(B.id,F),F),F=>Promise.reject(F))}checkDeprecation(B,$){B._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));let N=this._notProvidedCustomExecutions.values(),M=N.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=N.next()}};H=je([Be(0,m.IExtHostRpcService),Be(1,f.IExtHostInitDataService),Be(2,P.IExtHostWorkspace),Be(3,D.IExtHostDocumentsAndEditors),Be(4,i.IExtHostConfiguration),Be(5,C.IExtHostTerminalService),Be(6,w.ILogService),Be(7,b.IExtHostApiDeprecationService)],H),e.ExtHostTaskBase=H;let ie=class extends H{constructor(B,$,N,M,F,U,O,W){super(B,$,N,M,F,U,O,W);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(B,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const N=u.from($,B);if(N===void 0)throw new Error("Task is not valid");if(h.is(N.execution))await this.addCustomExecution(N,$,!1);else throw new c.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),$);return this._proxy.$executeTask(N).catch(F=>{throw new Error(F)}),M}provideTasksInternal(B,$,N,M){const F=[];if(M)for(let U of M){this.checkDeprecation(U,N),(!U.definition||!B[U.definition.type])&&this._logService.warn(`The task [${U.source}, ${U.name}] uses an undefined task type. The task will be ignored in the future.`);const O=u.from(U,N.extension);O&&h.is(O.execution)?(F.push(O),$.push(this.addCustomExecution(O,U,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:F,extension:N.extension}}async resolveTaskInternal(B){if(h.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,$){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(B,$,N){}};ie=je([Be(0,m.IExtHostRpcService),Be(1,f.IExtHostInitDataService),Be(2,P.IExtHostWorkspace),Be(3,D.IExtHostDocumentsAndEditors),Be(4,i.IExtHostConfiguration),Be(5,C.IExtHostTerminalService),Be(6,w.ILogService),Be(7,b.IExtHostApiDeprecationService)],ie),e.WorkerExtHostTask=ie,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!k:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(G):k?k.value:e.get(G)},Ht=this&&this.__rest||function(G,e){var _={};for(var k in G)Object.prototype.hasOwnProperty.call(G,k)&&e.indexOf(k)<0&&(_[k]=G[k]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,k=Object.getOwnPropertySymbols(G);A<k.length;A++)e.indexOf(k[A])<0&&Object.prototype.propertyIsEnumerable.call(G,k[A])&&(_[k[A]]=G[k[A]]);return _};define(me[260],ge([0,1,15,19,22,21,3,71,54,6,23,12,2,28,5,39,14,87,20,7,32,222,122]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d,E,w,b,p,c,g,t){"use strict";var n,s,r,o;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const l=(N,M)=>`${N}:${M.toString()}`;let h=class{constructor(M,F,U){this.documents=F,this.workspace=U,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new g.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=M.getProxy(a.MainContext.MainThreadTesting),this.runQueue=new S(this.proxy),this.workspaceObservers=new B(this.proxy),this.textDocumentObservers=new $(this.proxy,F)}registerTestController(M,F){const U=(0,f.generateUuid)();this.controllers.set(U,{instance:F,extensionId:M}),this.proxy.$registerTestController(U);const O=[...this.testControllers.keys()];return setTimeout(()=>{var W;for(const q of O)(W=this.testControllers.get(q))===null||W===void 0||W.subscribeFn(U,F)},0),new p.Disposable(()=>{this.controllers.delete(U),this.proxy.$unregisterTestController(U)})}createTextDocumentTestObserver(M){return this.textDocumentObservers.checkout(M.uri)}createWorkspaceTestObserver(M){return this.workspaceObservers.checkout(M.uri)}async runTests(M,F=I.CancellationToken.None){const U=O=>O.map(this.getInternalTestForReference,this).filter(C.isDefined).map(W=>({src:W.src,testId:W.item.extId}));await this.proxy.$runTests({exclude:M.exclude?U(M.exclude).map(O=>O.testId):void 0,tests:U(M.tests),debug:M.debug},F)}createTestRunTask(M,F,U,O=!0){return this.runQueue.createTestRunTask(M,F,U,O)}$publishTestResults(M){this.results=Object.freeze(M.map(F=>(0,T.deepFreeze)(b.TestResults.to(F))).concat(this.results).sort((F,U)=>U.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(M,F){const U=m.URI.revive(F),O=l(M,U);if(!this.testControllers.has(O)){const W=new I.CancellationTokenSource;let q;if(M===1){let Ie=this.documents.getDocument(U);if(!Ie){const ke=new i.DisposableStore;Ie=await new Promise(Le=>{ke.add((0,k.disposableTimeout)(()=>Le(void 0),5e3)),ke.add(this.documents.onDidAddDocuments(V=>{const J=V.find(ee=>ee.document.uri.toString()===U.toString());J&&Le(J)}))}).finally(()=>ke.dispose())}if(Ie){const ke=await this.workspace.getWorkspaceFolder2(U,!1);q=Le=>Le.createDocumentTestRoot?Le.createDocumentTestRoot(Ie.document,W.token):(0,e.createDefaultDocumentTestRoot)(Le,Ie.document,ke,W.token)}}else{const Ie=await this.workspace.getWorkspaceFolder2(U,!1);Ie&&(q=ke=>ke.createWorkspaceTestRoot(Ie,W.token))}if(!!q){const Q=async(Ie,ke)=>{try{const Le=await q(ke);Le&&ve.addRoot(Le,Ie)}catch(Le){console.error(Le)}},he=new i.DisposableStore,ve=he.add(this.ownedTests.createForHierarchy(Ie=>this.proxy.$publishDiff(M,F,Ie)));he.add((0,i.toDisposable)(()=>W.dispose(!0)));for(const[Ie,ke]of this.controllers)Q(Ie,ke.instance);ve.pushDiff([3,-1]),this.testControllers.set(O,{store:he,collection:ve,subscribeFn:Q})}}}async $expandTest(M,F){const U=(0,_.mapFind)(this.testControllers.values(),O=>O.collection.treeId===M.src.tree?O:void 0);await(U==null?void 0:U.collection.expand(M.testId,F<0?Infinity:F)),this.flushCollectionDiffs()}$unsubscribeFromTests(M,F){var U;const O=m.URI.revive(F),W=l(M,O);(U=this.testControllers.get(W))===null||U===void 0||U.store.dispose(),this.testControllers.delete(W)}$acceptDiff(M,F,U){M===1?this.textDocumentObservers.acceptDiff(m.URI.revive(F),U):this.workspaceObservers.acceptDiff(m.URI.revive(F),U)}async $runTestsForProvider(M,F){const U=this.controllers.get(M.tests[0].src.controller);if(!!U){const O=M.tests.map(({testId:Q,src:he})=>this.ownedTests.getTestById(Q,he==null?void 0:he.tree)).filter(C.isDefined).map(([Q,he])=>he),W=M.excludeExtIds.map(Q=>this.ownedTests.getTestById(Q)).filter(C.isDefined).filter(([Q,he])=>O.some(ve=>Q.comparePositions(ve,he)===1));if(!!O.length){const q={tests:O.map(Q=>L.unwrap(Q.actual)),exclude:W.map(([,Q])=>L.unwrap(Q.actual)),debug:M.debug};await this.runQueue.enqueueRun({dto:u.fromInternal(M),token:F,extensionId:U.extensionId,req:q,doRun:()=>U.instance.runTests(q,F)})}}}$lookupTest(M){const F=this.ownedTests.getTestById(M.testId);if(!F)return Promise.resolve(void 0);const U=F[1],{actual:O,discoverCts:W,expandLevels:q}=U,Q=Ht(U,["actual","discoverCts","expandLevels"]);return Promise.resolve(Q)}flushCollectionDiffs(){for(const{collection:M}of this.testControllers.values())M.flushDiff()}getInternalTestForReference(M){var F,U;return(U=(F=this.workspaceObservers.getMirroredTestDataByReference(M))!==null&&F!==void 0?F:(0,_.mapFind)(this.testControllers.values(),O=>O.collection.getTestByReference(M)))!==null&&U!==void 0?U:this.textDocumentObservers.getMirroredTestDataByReference(M)}};h=je([Be(0,E.IExtHostRpcService),Be(1,d.IExtHostDocumentsAndEditors),Be(2,c.IExtHostWorkspace)],h),e.ExtHostTesting=h;class S{constructor(M){this.proxy=M,this.state=new Map}enqueueRun(M){let F=this.state.get(M.extensionId);F||(F={queue:[],current:void 0},this.state.set(M.extensionId,F));const U=new k.DeferredPromise,O=()=>{const W=[],q=new Set;F.current={publicReq:M.req,factory:Q=>{const he=new v(Q,M.dto,q,this.proxy);return W.push(he),M.token.onCancellationRequested(()=>he.end()),he}},this.invokeRunner(M.extensionId,M.dto.id,M.doRun,W).finally(()=>U.complete())};return F.queue.push(O),F.queue.length===1&&O(),U.p}createTestRunTask(M,F,U,O){var W,q;const Q=this.state.get(M);if((Q==null?void 0:Q.current.publicReq)===F)return Q.current.factory(U);const he=u.fromPublic(F),ve=new v(U,he,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:F.debug,exclude:(q=(W=F.exclude)===null||W===void 0?void 0:W.map(Ie=>Ie.id))!==null&&q!==void 0?q:[],id:he.id,tests:F.tests.map(Ie=>Ie.id),persist:O}),ve.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(he.id)),ve}invokeRunner(M,F,U,O){try{const W=U();return(0,k.isThenable)(W)?W.then(()=>this.handleInvokeResult(M,F,O,void 0)).catch(q=>this.handleInvokeResult(M,F,O,q)):this.handleInvokeResult(M,F,O,void 0)}catch(W){return this.handleInvokeResult(M,F,O,W)}}async handleInvokeResult(M,F,U,O){const W=this.state.get(M);!W||(W.queue.shift(),W.queue.length>0?W.queue[0]():this.state.delete(M),await Promise.all(U.map(q=>q.onEnd.wait())))}}class u{constructor(M,F,U){this.id=M,this.include=F,this.exclude=U}static fromPublic(M){var F,U;return new u((0,f.generateUuid)(),new Set(M.tests.map(O=>O.id)),new Set((U=(F=M.exclude)===null||F===void 0?void 0:F.map(O=>O.id))!==null&&U!==void 0?U:D.Iterable.empty()))}static fromInternal(M){return new u(M.runId,new Set(M.tests.map(F=>F.testId)),new Set(M.excludeExtIds))}isIncluded(M){for(let F=M;F;F=F.parent){if(this.include.has(F.id))return!0;if(this.exclude.has(F.id))return!1}return!0}}class v{constructor(M,F,U,O){this.name=M,n.set(this,void 0),s.set(this,void 0),r.set(this,(0,f.generateUuid)()),o.set(this,void 0),this.onEnd=new k.Barrier,tt(this,n,O,"f"),tt(this,s,F,"f"),tt(this,o,U,"f"),O.$startedTestRunTask(F.id,{id:Ue(this,r,"f"),name:M,running:!0})}setState(M,F,U){Ue(this,s,"f").isIncluded(M)&&(this.ensureTestIsKnown(M),Ue(this,n,"f").$updateTestStateInRun(Ue(this,s,"f").id,Ue(this,r,"f"),M.id,F,U))}appendMessage(M,F){Ue(this,s,"f").isIncluded(M)&&(this.ensureTestIsKnown(M),Ue(this,n,"f").$appendTestMessageInRun(Ue(this,s,"f").id,Ue(this,r,"f"),M.id,b.TestMessage.from(F)))}appendOutput(M){Ue(this,n,"f").$appendOutputToRun(Ue(this,s,"f").id,Ue(this,r,"f"),A.VSBuffer.fromString(M))}end(){Ue(this,n,"f").$finishedTestRunTask(Ue(this,s,"f").id,Ue(this,r,"f")),this.onEnd.open()}ensureTestIsKnown(M){const F=Ue(this,o,"f");if(!F.has(M.id)){const U=[];for(;U.unshift(b.TestItem.from(M)),!(F.has(M.id)||(F.add(M.id),!M.parent));)M=M.parent;Ue(this,n,"f").$addTestsToRun(Ue(this,s,"f").id,U)}}}n=new WeakMap,s=new WeakMap,r=new WeakMap,o=new WeakMap;const R=async(N,M,F,U)=>{if(!!F){const O=await N.createWorkspaceTestRoot(F,U);if(!!O)return U.onCancellationRequested(()=>{L.removeFilter(M)}),L.getWrapperForTestItem(O,M)}};e.createDefaultDocumentTestRoot=R;class L extends p.TestItemImpl{constructor(M,F,U){super(M.id,M.label,M.uri,void 0);if(this.actual=M,this.filterDocument=F,this.actualParent=U,!(M instanceof p.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${M.id} did not`);this.debuggable=M.debuggable,this.runnable=M.runnable,this.description=M.description,this.error=M.error,this.status=M.status;const O=(0,w.getPrivateApiFor)(this);(0,w.getPrivateApiFor)(M).bus.event(q=>{switch(q[0]){case 3:this[q[1]]=q[2];break;case 0:const Q=L.getWrapperForTestItem(q[1],this.filterDocument,this);(0,w.getPrivateApiFor)(Q).parent=M,Q.refreshMatch();break;default:O.bus.fire(q)}})}static removeFilter(M){this.wrapperMap.delete(M)}static getWrapperForTestItem(M,F,U){let O=this.wrapperMap.get(F);if(O==null?void 0:O.has(M))return O.get(M);O||(O=new WeakMap,this.wrapperMap.set(F,O));const W=new L(M,F,U);return O.set(M,W),W}static unwrap(M){return M instanceof L?M.actual:M}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var M;const F=this._cachedMatchesFilter;for(const O of this.actual.children.values()){const W=L.getWrapperForTestItem(O,this.filterDocument,this);W.hasNodeMatchingFilter?this.addChild(W):W.dispose()}const U=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=U,U!==F&&((M=this.actualParent)===null||M===void 0||M.refreshMatch()),this._cachedMatchesFilter}}e.TestItemFilteredWrapper=L,L.wrapperMap=new WeakMap;class H extends t.IncrementalChangeCollector{constructor(M){super();this.emitter=M,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(M){this.added.add(M)}update(M){Object.assign(M.revived,b.TestItem.toPlain(M.item)),this.added.has(M)||this.updated.add(M)}remove(M){if(this.added.has(M)){this.added.delete(M);return}if(this.updated.delete(M),M.parent&&this.alreadyRemoved.has(M.parent)){this.alreadyRemoved.add(M.item.extId);return}this.removed.add(M)}getChangeEvent(){const{added:M,updated:F,removed:U}=this;return{get added(){return[...M].map(O=>O.revived)},get updated(){return[...F].map(O=>O.revived)},get removed(){return[...U].map(O=>O.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class ie extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(M){let F=[];for(const U of M){const O=this.items.get(U);O&&F.push(O.revived)}return F}getMirroredTestDataById(M){return this.items.get(M)}getMirroredTestDataByReference(M){return this.items.get(M.id)}createItem(M,F){return Object.assign(Object.assign({},M),{revived:b.TestItem.toPlain(M.item),depth:F?F.depth+1:0,children:new Set})}createChangeCollector(){return new H(this.changeEmitter)}}e.MirroredTestCollection=ie;class j{constructor(){this.resources=new Map}checkout(M){var F,U;const O=M.toString(),W=(F=this.resources.get(O))!==null&&F!==void 0?F:this.createObserverData(M);return(U=W.pendingDeletion)===null||U===void 0||U.dispose(),W.observers++,{onDidChangeTest:W.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return W.tests.rootTestItems},dispose:(0,P.once)(()=>{--W.observers||(W.pendingDeletion=this.eventuallyDispose(M))})}}getMirroredTestDataByReference(M){for(const{tests:F}of this.resources.values()){const U=F.getMirroredTestDataByReference(M);if(U)return U}}eventuallyDispose(M){return(0,k.disposableTimeout)(()=>this.unlisten(M),10*1e3)}createObserverData(M){const F=new ie,U=this.listen(M,W=>F.apply(W)),O={observers:0,tests:F,listener:U};return this.resources.set(M.toString(),O),O}unlisten(M){var F;const U=M.toString(),O=this.resources.get(U);O&&(O.observers=-1,(F=O.pendingDeletion)===null||F===void 0||F.dispose(),O.listener.dispose(),this.resources.delete(U))}}class B extends j{constructor(M){super();this.proxy=M,this.diffListeners=new Map}acceptDiff(M,F){var U;(U=this.diffListeners.get(M.toString()))===null||U===void 0||U(F)}listen(M,F){this.proxy.$subscribeToDiffs(0,M);const U=M.toString();return this.diffListeners.set(U,F),new p.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,M),this.diffListeners.delete(U)})}}class $ extends j{constructor(M,F){super();this.proxy=M,this.documents=F,this.diffListeners=new Map}acceptDiff(M,F){var U;(U=this.diffListeners.get(M.toString()))===null||U===void 0||U(F)}listen(M,F){if(!this.documents.getDocument(M))return new p.Disposable(()=>{});const O=M.toString();return this.diffListeners.set(O,F),this.proxy.$subscribeToDiffs(1,M),new p.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,M),this.diffListeners.delete(O)})}}}),define(me[261],ge([0,1,15,53,33,76,24,11,8,25,10,12,2,140,173,84,60,214,259,31]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d,E,w,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let c=class{constructor(S,u,v,R){this.configurationService=S,this.workspaceContextService=u,this.editorGroupsService=v,this.pathService=R}text(S,u,v={}){S=this.getContentPattern(S,v);const R=this.configurationService.getValue(),L=u&&u.some(ie=>!this.configurationService.getValue({resource:ie}).search.useRipgrep),H=this.commonQuery(u==null?void 0:u.map(E.toWorkspaceFolder),v);return Object.assign(Object.assign({},H),{type:2,contentPattern:S,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:R.search.usePCRE2||L||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles})}getContentPattern(S,u){const v=this.configurationService.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},S),{wordSeparators:v.editor.wordSeparators});return this.isCaseSensitive(S,u)&&(R.isCaseSensitive=!0),this.isMultiline(S)&&(R.isMultiline=!0),R}file(S,u={}){const v=this.commonQuery(S,u);return Object.assign(Object.assign({},v),{type:1,filePattern:u.filePattern?u.filePattern.trim():u.filePattern,exists:u.exists,sortByScore:u.sortByScore,cacheKey:u.cacheKey})}handleIncludeExclude(S,u){return S?(S=Array.isArray(S)?S.map(r):r(S),u?this.parseSearchPaths(S):{pattern:t(...Array.isArray(S)?S:[S])}):{}}commonQuery(S=[],u={}){const v=this.handleIncludeExclude(u.includePattern,u.expandPatterns),R=this.handleIncludeExclude(u.excludePattern,u.expandPatterns),L=S.length>1,H=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(B=>this.getFolderQueryForSearchPath(B,u,R)):S.map(B=>this.getFolderQueryForRoot(B,u,R,L))).filter(B=>!!B),ie={_reason:u._reason,folderQueries:H,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:u.extraFileResources,excludePattern:R.pattern,includePattern:v.pattern,onlyOpenEditors:u.onlyOpenEditors,maxResults:u.maxResults};if(u.onlyOpenEditors){const $=_.coalesce(_.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(F=>F.resource)))).filter(M=>(0,p.pathIncludedInQuery)(ie,M.fsPath)),N=this.commonQueryFromFileList($);return Object.assign(Object.assign({},ie),N)}const j=u.extraFileResources&&u.extraFileResources.filter(B=>(0,p.pathIncludedInQuery)(ie,B.fsPath));return ie.extraFileResources=j&&j.length?j:void 0,ie}commonQueryFromFileList(S){const u=[],v=new y.ResourceMap,R={};let L=!1;return S.forEach(H=>{var ie,j;if(H.scheme!==P.Schemas.walkThrough)if((0,i.isAbsolutePath)(H)){const $=(j=(ie=this.workspaceContextService.getWorkspaceFolder(H))===null||ie===void 0?void 0:ie.uri)!==null&&j!==void 0?j:H.with({path:D.dirname(H.fsPath)});let N=v.get($);N||(L=!0,N={folder:$,includePattern:{}},u.push(N),v.set($,N));const M=D.relative($.fsPath,H.fsPath);(0,C.assertIsDefined)(N.includePattern)[M.replace(/\\/g,"/")]=!0}else H.fsPath&&(L=!0,R[H.fsPath]=!0)}),{folderQueries:u,includePattern:R,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(S,u){if(u.isSmartCase){if(S.isRegExp){if(T.containsUppercaseCharacter(S.pattern,!0))return!0}else if(T.containsUppercaseCharacter(S.pattern))return!0}return!!S.isCaseSensitive}isMultiline(S){return S.isMultiline||S.isRegExp&&(0,f.isMultilineRegexSource)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const u=N=>D.isAbsolute(N)||/^\.\.?([\/\\]|$)/.test(N),R=(Array.isArray(S)?S:n(S)).map(N=>{const M=this.pathService.resolvedUserHome;return M?(0,I.untildify)(N,M.scheme===P.Schemas.file?M.fsPath:M.path):N}),L=k.groupBy(R,N=>u(N)?"searchPaths":"exprSegments"),H=(L.exprSegments||[]).map(N=>T.rtrim(N,"/")).map(N=>T.rtrim(N,"\\")).map(N=>(N[0]==="."&&(N="*"+N),s(N))),ie={},j=this.expandSearchPathPatterns(L.searchPaths||[]);j&&j.length&&(ie.searchPaths=j);const B=_.flatten(H),$=t(...B);return $&&(ie.pattern=$),ie}getExcludesForFolder(S,u){return u.disregardExcludeSettings?void 0:(0,p.getExcludes)(S,!u.disregardSearchExcludeSettings)}expandSearchPathPatterns(S){if(!S||!S.length)return[];const u=_.flatten(S.map(R=>{let{pathPortion:L,globPortion:H}=g(R);H&&(H=o(H));const ie=this.expandOneSearchPath(L);return _.flatten(ie.map(j=>this.resolveOneSearchPathPattern(j,H)))})),v=new Map;return u.forEach(R=>{const L=R.searchPath.toString(),H=v.get(L);H?R.pattern&&(H.pattern=H.pattern||{},H.pattern[R.pattern]=!0):v.set(L,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(v.values())}expandOneSearchPath(S){if(D.isAbsolute(S)){const u=this.workspaceContextService.getWorkspace().folders;return u[0]&&u[0].uri.scheme!==P.Schemas.file?[{searchPath:u[0].uri.with({path:S})}]:[{searchPath:m.URI.file(D.normalize(S))}]}if(this.workspaceContextService.getWorkbenchState()===2){const u=this.workspaceContextService.getWorkspace().folders[0].uri;if(S=r(S),S.startsWith("../")||S===".."){const R=D.posix.resolve(u.path,S);return[{searchPath:u.with({path:R})}]}const v=o(S);return[{searchPath:u,pattern:v}]}else{if(S==="./"||S===".\\")return[];{const u=S.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(u){const v=u[1],R=this.workspaceContextService.getWorkspace().folders.filter(L=>L.name===v);if(R.length)return R.map(L=>{const H=u[2];return{searchPath:L.uri,pattern:H&&o(H)}});{const L=a.localize(0,null,v);throw new Error(L)}}}}return[]}resolveOneSearchPathPattern(S,u){const v=S.pattern&&u?`${S.pattern}/${u}`:S.pattern||u,R=[{searchPath:S.searchPath,pattern:v}];return v&&!v.endsWith("**")&&R.push({searchPath:S.searchPath,pattern:v+"/**"}),R}getFolderQueryForSearchPath(S,u,v){const R=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(S.searchPath),u,v,!1);return R?Object.assign(Object.assign({},R),{includePattern:S.pattern}):null}getFolderQueryForRoot(S,u,v,R){let L;const H=m.URI.isUri(S)?S:S.uri;if(v.searchPaths){const N=v.searchPaths.filter(M=>(0,i.isEqual)(M.searchPath,H))[0];if(N&&!N.pattern)return null;N&&(L=N.pattern)}const ie=this.configurationService.getValue({resource:H}),j=this.getExcludesForFolder(ie,u),B=Object.assign(Object.assign({},j||{}),L||{}),$=m.URI.isUri(S)?(0,i.basename)(S):S.name;return{folder:H,folderName:R?$:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:ie.files&&ie.files.encoding,disregardIgnoreFiles:typeof u.disregardIgnoreFiles=="boolean"?u.disregardIgnoreFiles:!ie.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof u.disregardGlobalIgnoreFiles=="boolean"?u.disregardGlobalIgnoreFiles:!ie.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof u.ignoreSymlinks=="boolean"?u.ignoreSymlinks:!ie.search.followSymlinks}}};c=je([Be(0,d.IConfigurationService),Be(1,E.IWorkspaceContextService),Be(2,w.IEditorGroupsService),Be(3,b.IPathService)],c),e.QueryBuilder=c;function g(h){const S=h.match(/[\*\{\}\(\)\[\]\?]/);if(S){const u=S.index,v=h.substr(0,u).match(/[/|\\][^/\\]*$/);if(v){let R=h.substr(0,v.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:h.substr((v.index||0)+1)}}}return{pathPortion:h}}function t(...h){return h.length?h.reduce((S,u)=>(S[u]=!0,S),Object.create(null)):void 0}function n(h){return A.splitGlobAware(h,",").map(S=>S.trim()).filter(S=>!!S.length)}function s(h){return[`**/${h}/**`,`**/${h}`].map(u=>u.replace(/\*\*\/\*\*/g,"**"))}function r(h){return h.replace(/\\/g,"/")}function o(h){return r(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(h,S){h=_.distinct(h,R=>R.toString());const u=[],v=S.getWorkspace();return h&&h.forEach(R=>{let L;if(S.getWorkbenchState()===2)L=(0,i.relativePath)(v.folders[0].uri,R),L&&L!=="."&&(L="./"+L);else{const H=S.getWorkspaceFolder(R);if(H){const ie=H.name;if(v.folders.filter(B=>B.name===ie).length===1){const B=(0,i.relativePath)(H.uri,R);B===""?L=`./${H.name}`:L=`./${H.name}/${B}`}else L=R.fsPath}}L&&u.push(L)}),u}e.resolveResourcesForSearchIncludes=l}),define(me[262],ge([0,1,25,2,21,18,4,261,31,60]),function(G,e,_,k,A,I,y,P,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const T=7e3;function C(d,E){const w=E.activationEvents;if(!w)return Promise.resolve(void 0);const b=[],p=[];for(const r of w)if(/^workspaceContains:/.test(r)){const o=r.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||d.forceUsingSearch?p.push(o):b.push(o)}if(b.length===0&&p.length===0)return Promise.resolve(void 0);let c;const g=new Promise((r,o)=>{c=r}),t=r=>c({activationEvent:r}),n=Promise.all(b.map(r=>m(d,r,t))).then(()=>{}),s=f(d,E.identifier,p,t);return Promise.all([n,s]).then(()=>{c(void 0)}),g}e.checkActivateWorkspaceContainsExtension=C;async function m(d,E,w){for(const b of d.folders)if(await d.exists(_.joinPath(k.URI.revive(b),E))){w(`workspaceContains:${E}`);return}}async function f(d,E,w,b){if(w.length===0)return Promise.resolve(void 0);const p=new A.CancellationTokenSource,c=d.checkExists(d.folders,w,p.token),g=setTimeout(async()=>{p.cancel(),b(`workspaceContainsTimeout:${w.join(",")}`)},T);let t=!1;try{t=await c}catch(n){I.isPromiseCanceledError(n)||I.onUnexpectedError(n)}p.dispose(),clearTimeout(g),t&&b(`workspaceContains:${w.join(",")}`)}function a(d,E,w,b){const p=d.get(y.IInstantiationService),c=d.get(D.ISearchService),t=p.createInstance(P.QueryBuilder).file(E.map(n=>(0,i.toWorkspaceFolder)(k.URI.revive(n))),{_reason:"checkExists",includePattern:w,exists:!0});return c.fileSearch(t,b).then(n=>!!n.limitHit,n=>I.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=a});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!k:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(G):k?k.value:e.get(G)};define(me[42],ge([0,1,162,8,68,25,19,6,24,2,13,5,35,225,91,32,41,223,18,29,11,22,196,7,85,4,27,92,14,82,50,34,3,262,89,197]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d,E,w,b,p,c,g,t,n,s,r,o,l,h,S,u,v,R,L,H,ie){"use strict";var j,B,$;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let N=class Nn extends P.Disposable{constructor(O,W,q,Q,he,ve,Ie,ke,Le,V){super();this._onDidChangeRemoteConnectionData=this._register(new R.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=W,this._extHostContext=q,this._initData=Ie,this._extHostWorkspace=Q,this._extHostConfiguration=he,this._logService=ve,this._extHostTunnelService=Le,this._extHostTerminalService=V,this._disposables=new P.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new H.ExtHostSecretState(this._extHostContext),this._storagePath=ke,this._instaService=O.createChild(new S.ServiceCollection([a.IExtHostStorage,this._storage],[H.IExtHostSecretState,this._secretState]));const J=new Set;this._initData.hostExtensions.forEach(ee=>J.add(p.ExtensionIdentifier.toKey(ee))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ee,ae)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ee,ae)},actualActivateExtension:async(ee,ae)=>{if(J.has(p.ExtensionIdentifier.toKey(ee)))return await this._mainThreadExtensionsProxy.$activateExtension(ee,ae),new f.HostExtension;const we=this._registry.getExtensionDescription(ee);return this._activateExtension(we,ae)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),A.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){b.onUnexpectedError(O)}}async deactivateAll(){let O=[];try{O=this._registry.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this._deactivate(he))}catch(W){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,W){return this._activator.activateByEvent(O,W)}_activateById(O,W){return this._activator.activateById(O,W)}activateByIdWithErrors(O,W){return this._activateById(O,W).then(()=>{const q=this._activator.getActivatedExtension(O);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=D.TernarySearchTree.forPaths(),W=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(Q=>O.set(i.URI.file(Q).fsPath,q))});this._extensionPathIndex=Promise.all(W).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let W=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return W;const q=this._activator.getActivatedExtension(O);if(!q)return W;try{typeof q.module.deactivate=="function"&&(W=Promise.resolve(q.module.deactivate()).then(void 0,Q=>Promise.resolve(void 0)))}catch(Q){}try{(0,P.dispose)(q.subscriptions)}catch(Q){}return W}async _activateExtension(O,W){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,W).then(q=>{const Q=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,Q.codeLoadingTime,Q.activateCallTime,Q.activateResolvedTime,W),this._logExtensionActivationTimes(O,W,"success",Q),q},q=>{throw this._logExtensionActivationTimes(O,W,"failure"),q})}_logExtensionActivationTimes(O,W,q,Q){const he=M(O,W);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},he),Q||{}),{outcome:q}))}_doActivateExtension(O,W){const q=M(O,W);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const Q=this._getEntryPoint(O);if(!Q)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(W)}`),this._logService.flush();const he=new f.ExtensionActivationTimesBuilder(W.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,I.joinPath)(O.extensionLocation,Q),he),this._loadExtensionContext(O)]).then(ve=>(A.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Nn._callActivate(this._logService,O.identifier,ve[0],ve[1],he))).then(ve=>(A.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),ve))}_loadExtensionContext(O){const W=new t.ExtensionGlobalMemento(O,this._storage),q=new t.ExtensionMemento(O.identifier.value,!1,this._storage),Q=new ie.ExtensionSecrets(O,this._secretState),he=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,ve=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([W.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const Ie=this;let ke;return Object.freeze({globalState:W,workspaceState:q,secrets:Q,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Le){return k.join(O.extensionLocation.fsPath,Le)},get storagePath(){var Le;return(Le=Ie._storagePath.workspaceValue(O))===null||Le===void 0?void 0:Le.fsPath},get globalStoragePath(){return Ie._storagePath.globalValue(O).fsPath},get logPath(){return k.join(Ie._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return i.URI.joinPath(Ie._initData.logsLocation,O.identifier.value)},get storageUri(){return Ie._storagePath.workspaceValue(O)},get globalStorageUri(){return Ie._storagePath.globalValue(O)},get extensionMode(){return he},get extension(){return ke===void 0&&(ke=new F(Ie,O.identifier,O,ve)),ke},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(O),Ie.extensionRuntime},get environmentVariableCollection(){return Ie._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,W,q,Q,he){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,W,q,Q,he).then(ve=>new f.ActivatedExtension(!1,null,he.build(),q,ve,Q.subscriptions))}static _callActivateOptional(O,W,q,Q,he){if(typeof q.activate=="function")try{he.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${W.value}`);const ve=typeof global=="object"?global:self,Ie=q.activate.apply(ve,[Q]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(Ie).then(ke=>(he.activateResolveStop(),ke))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(q)}_activateOneStartupFinished(O,W){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:W}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(A.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const W of O.activationEvents)W==="onStartupFinished"&&this._activateOneStartupFinished(O,W)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,he=>{this._logService.error(he)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(he=>this._handleWorkspaceContainsEagerExtensions(he.added)));const W=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(W),Q=Promise.all([O,q]).then(()=>{});return Promise.race([Q,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Q}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(W=>this._handleWorkspaceContainsEagerExtension(O,W))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,W){if(!this.isActivated(W.identifier)){const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Q={folders:O.map(ve=>ve.uri),forceUsingSearch:q,exists:ve=>this._hostUtils.exists(ve.fsPath),checkExists:(ve,Ie,ke)=>this._mainThreadWorkspaceProxy.$checkExists(ve,Ie,ke)},he=await(0,L.checkActivateWorkspaceContainsExtension)(Q,W);if(!!he)return this._activateById(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:he.activationEvent}).then(void 0,ve=>this._logService.error(ve))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:W}=this._initData.environment;if(!O||!W||W.scheme!==c.Schemas.file)throw new Error(_.localize(0,null));const q=(0,I.originalFSPath)(W),Q=await this._loadCommonJSModule(null,W,new f.ExtensionActivationTimesBuilder(!1));if(!Q||typeof Q.run!="function")throw new Error(_.localize(1,null,q));return new Promise((he,ve)=>{const Ie=(Le,V)=>{Le?ve(Le):he(typeof V=="number"&&V>0?1:0)},ke=Q.run(q,Ie);ke&&ke.then&&ke.then(()=>{he(0)}).catch(Le=>{ve(Le.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,W){return this._resolvers[O]=W,(0,P.toDisposable)(()=>{delete this._resolvers[O]})}async $resolveAuthority(O,W){const q=O.indexOf("+");if(q===-1)throw new Error("Not an authority that can be resolved!");const Q=O.substr(0,q);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Q}`,!1);const he=this._resolvers[Q];if(!he)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Q}.`,detail:void 0}};try{A.mark(`code/extHost/willResolveAuthority/${Q}`);const ve=await he.resolve(O,{resolveAttempt:W});A.mark(`code/extHost/didResolveAuthorityOK/${Q}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(he));const Ie={authority:O,host:ve.host,port:ve.port,connectionToken:ve.connectionToken},ke={extensionHostEnv:ve.extensionHostEnv,trust:ve.trust};return{type:"ok",value:{authority:Ie,options:ke,tunnelInformation:{environmentTunnels:ve.environmentTunnels}}}}catch(ve){if(A.mark(`code/extHost/didResolveAuthorityError/${Q}`),ve instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve}}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,W){return W===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(O,!1))}async $activate(O,W){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,W),!0):!1}async $deltaExtensions(O,W){O.forEach(Q=>Q.extensionLocation=i.URI.revive(Q.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(W.map(async Q=>{const he=this._registry.getExtensionDescription(Q);if(!!he){const ve=await this._hostUtils.realpath(he.extensionLocation.fsPath);q.delete(i.URI.file(ve).fsPath)}})),await Promise.all(O.map(async Q=>{const he=await this._hostUtils.realpath(Q.extensionLocation.fsPath);q.set(i.URI.file(he).fsPath,Q)})),this._registry.deltaExtensions(O,W),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let W=g.VSBuffer.alloc(O),q=Math.random()%256;for(let Q=0;Q<O;Q++)W.writeUInt8(q,Q);return W}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};N=je([Be(0,r.IInstantiationService),Be(1,e.IHostUtils),Be(2,h.IExtHostRpcService),Be(3,d.IExtHostWorkspace),Be(4,m.IExtHostConfiguration),Be(5,T.ILogService),Be(6,o.IExtHostInitDataService),Be(7,l.IExtensionStoragePaths),Be(8,u.IExtHostTunnelService),Be(9,v.IExtHostTerminalService)],N),e.AbstractExtHostExtensionService=N;function M(U,O){return{id:U.identifier.value,name:U.name,extensionVersion:U.version,publisherDisplayName:U.publisher,activationEvents:U.activationEvents?U.activationEvents.join(","):null,isBuiltin:U.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class F{constructor(O,W,q,Q){j.set(this,void 0),B.set(this,void 0),$.set(this,void 0),tt(this,j,O,"f"),tt(this,B,W,"f"),tt(this,$,q.identifier,"f"),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=k.normalize((0,I.originalFSPath)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=Q}get isActive(){return Ue(this,j,"f").isActivated(Ue(this,$,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,j,"f").getExtensionExports(Ue(this,$,"f"))}activate(){return Ue(this,j,"f").activateByIdWithErrors(Ue(this,$,"f"),{startup:!1,extensionId:Ue(this,B,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,j=new WeakMap,B=new WeakMap,$=new WeakMap}),define(me[46],ge([0,1,8,2,3,19,5,7,120,32,42,39,213,35,204,14,4,12,36]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d,E,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let p=class{constructor(l,h,S,u,v){this._workspaceService=h,this._extensionService=S,this._editorsService=u,this._configurationService=v,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new A.Emitter,this._onDidTerminateDebugSession=new A.Emitter,this._onDidChangeActiveDebugSession=new A.Emitter,this._onDidReceiveDebugSessionCustomEvent=new A.Emitter,this._debugServiceProxy=l.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new A.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new g(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange(L=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(l,h){const S=l;if(typeof S.sourceReference=="number"&&S.sourceReference>0){let u=`debug:${encodeURIComponent(S.path||"")}`,v="?";return h&&(u+=`${v}session=${encodeURIComponent(h.id)}`,v="&"),u+=`${v}ref=${S.sourceReference}`,k.URI.parse(u)}else{if(S.path)return k.URI.file(S.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(l){const h=[];for(const S of l.getAllExtensionDescriptions())if(S.contributes){const u=S.contributes.debuggers;if(u&&u.length>0)for(const v of u)(0,a.isDebuggerMainContribution)(v)&&h.push(v.type)}this._debugServiceProxy.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const l=[];return this._breakpoints.forEach(h=>l.push(h)),l}addBreakpoints(l){this.startBreakpoints();const h=l.filter(v=>{const R=v.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,v),!0)});this.fireBreakpointChanges(h,[],[]);const S=[],u=new Map;for(const v of h)if(v instanceof P.SourceBreakpoint){let R=u.get(v.location.uri.toString());R||(R={type:"sourceMulti",uri:v.location.uri,lines:[]},u.set(v.location.uri.toString(),R),S.push(R)),R.lines.push({id:v.id,enabled:v.enabled,condition:v.condition,hitCondition:v.hitCondition,logMessage:v.logMessage,line:v.location.range.start.line,character:v.location.range.start.character})}else v instanceof P.FunctionBreakpoint&&S.push({type:"function",id:v.id,enabled:v.enabled,hitCondition:v.hitCondition,logMessage:v.logMessage,condition:v.condition,functionName:v.functionName});return this._debugServiceProxy.$registerBreakpoints(S)}removeBreakpoints(l){this.startBreakpoints();const h=l.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],h,[]);const S=h.filter(R=>R instanceof P.SourceBreakpoint).map(R=>R.id),u=h.filter(R=>R instanceof P.FunctionBreakpoint).map(R=>R.id),v=h.filter(R=>R instanceof P.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(S,u,v)}startDebugging(l,h,S){return this._debugServiceProxy.$startDebugging(l?l.uri:void 0,h,{parentSessionID:S.parentSession?S.parentSession.id:void 0,repl:S.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:S.noDebug,compact:S.compact})}stopDebugging(l){return this._debugServiceProxy.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,h,S){if(!h)return new P.Disposable(()=>{});const u=this._configProviderHandleCounter++;return this._configProviders.push({type:l,handle:u,provider:h}),this._debugServiceProxy.$registerDebugConfigurationProvider(l,S,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,u),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(v=>v.provider!==h),this._debugServiceProxy.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(l,h,S){if(!S)return new P.Disposable(()=>{});if(!this.definesDebugType(l,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.getAdapterDescriptorFactoryByType(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:h,handle:u,factory:S}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(h,u),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(v=>v.factory!==S),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(l,h){if(!h)return new P.Disposable(()=>{});const S=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:l,handle:S,factory:h}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(u=>u.factory!==h)})}async $runInTerminal(l,h){return Promise.resolve(void 0)}async $substituteVariables(l,h){if(!this._variableResolver){const[v,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(v||[],this._editorsService,R)}let S;const u=await this.getFolder(l);return u&&(S={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(S,h)}createDebugAdapter(l,h){if(l.type==="implementation")return new s(l.implementation)}createSignService(){}async $startDASession(l,h){const S=this,u=await this.getSession(h);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(u.type),u).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const R=this.convertToDto(v),L=this.createDebugAdapter(R,u);if(!L)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const H=L;return this._debugAdapters.set(l,H),this.getDebugAdapterTrackers(u).then(ie=>(ie&&this._debugAdaptersTrackers.set(l,ie),H.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const B=j,$={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(B.arguments.value);$.body={signature:N},H.sendResponse($)}else throw new Error("no signer")}catch(N){$.success=!1,$.message=N.message,H.sendResponse($)}}else ie&&ie.onDidSendMessage&&ie.onDidSendMessage(j),j=(0,a.convertToVSCPaths)(j,!0),S._debugServiceProxy.$acceptDAMessage(l,j)}),H.onError(j=>{ie&&ie.onError&&ie.onError(j),this._debugServiceProxy.$acceptDAError(l,j.name,j.message,j.stack)}),H.onExit(j=>{ie&&ie.onExit&&ie.onExit((0,w.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(l,(0,w.withNullAsUndefined)(j),void 0)}),ie&&ie.onWillStartSession&&ie.onWillStartSession(),H.startSession()))})}$sendDAMessage(l,h){h=(0,a.convertToDAPaths)(h,!1);const S=this._debugAdaptersTrackers.get(l);S&&S.onWillReceiveMessage&&S.onWillReceiveMessage(h);const u=this._debugAdapters.get(l);u&&u.sendMessage(h)}$stopDASession(l){const h=this._debugAdaptersTrackers.get(l);this._debugAdaptersTrackers.delete(l),h&&h.onWillStopSession&&h.onWillStopSession();const S=this._debugAdapters.get(l);return this._debugAdapters.delete(l),S?S.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const h=[],S=[],u=[];if(l.added)for(const v of l.added){const R=v.id;if(R&&!this._breakpoints.has(R)){let L;if(v.type==="function")L=new P.FunctionBreakpoint(v.functionName,v.enabled,v.condition,v.hitCondition,v.logMessage);else if(v.type==="data")L=new P.DataBreakpoint(v.label,v.dataId,v.canPersist,v.enabled,v.hitCondition,v.condition,v.logMessage);else{const H=k.URI.revive(v.uri);L=new P.SourceBreakpoint(new P.Location(H,new P.Position(v.line,v.character)),v.enabled,v.condition,v.hitCondition,v.logMessage)}L._id=R,this._breakpoints.set(R,L),h.push(L)}}if(l.removed)for(const v of l.removed){const R=this._breakpoints.get(v);R&&(this._breakpoints.delete(v),S.push(R))}if(l.changed){for(const v of l.changed)if(v.id){const R=this._breakpoints.get(v.id);if(R){if(R instanceof P.FunctionBreakpoint&&v.type==="function"){const L=R;L.enabled=v.enabled,L.condition=v.condition,L.hitCondition=v.hitCondition,L.logMessage=v.logMessage,L.functionName=v.functionName}else if(R instanceof P.SourceBreakpoint&&v.type==="source"){const L=R;L.enabled=v.enabled,L.condition=v.condition,L.hitCondition=v.hitCondition,L.logMessage=v.logMessage,L.location=new P.Location(k.URI.revive(v.uri),new P.Position(v.line,v.character))}u.push(R)}}}this.fireBreakpointChanges(h,S,u)}$provideDebugConfigurations(l,h,S){return(0,I.asPromise)(async()=>{const u=this.getConfigProviderByHandle(l);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const v=await this.getFolder(h);return u.provideDebugConfigurations(v,S)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(l,h,S,u){return(0,I.asPromise)(async()=>{const v=this.getConfigProviderByHandle(l);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(h);return v.resolveDebugConfiguration(R,S,u)})}$resolveDebugConfigurationWithSubstitutedVariables(l,h,S,u){return(0,I.asPromise)(async()=>{const v=this.getConfigProviderByHandle(l);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(h);return v.resolveDebugConfigurationWithSubstitutedVariables(R,S,u)})}async $provideDebugAdapter(l,h){const S=this.getAdapterDescriptorFactoryByHandle(l);if(!S)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.getSession(h);return this.getAdapterDescriptor(S,u).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.convertToDto(v)})}async $acceptDebugSessionStarted(l){const h=await this.getSession(l);this._onDidStartDebugSession.fire(h)}async $acceptDebugSessionTerminated(l){const h=await this.getSession(l);h&&(this._onDidTerminateDebugSession.fire(h),this._debugSessions.delete(h.id))}async $acceptDebugSessionActiveChanged(l){this._activeDebugSession=l?await this.getSession(l):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(l,h){const S=await this.getSession(l);S&&S._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(l,h){const u={session:await this.getSession(l),event:h.event,body:h.body};this._onDidReceiveDebugSessionCustomEvent.fire(u)}convertToDto(l){if(l instanceof P.DebugAdapterExecutable)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof P.DebugAdapterServer)return{type:"server",port:l.port,host:l.host};if(l instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:l.path};if(l instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(l){const h=this._adapterFactories.filter(S=>S.type===l);if(h.length>0)return h[0].factory}getAdapterDescriptorFactoryByHandle(l){const h=this._adapterFactories.filter(S=>S.handle===l);if(h.length>0)return h[0].factory}getConfigProviderByHandle(l){const h=this._configProviders.filter(S=>S.handle===l);if(h.length>0)return h[0].provider}definesDebugType(l,h){if(l.contributes){const S=l.contributes.debuggers;if(S&&S.length>0){for(const u of S)if(u.label&&u.type&&u.type===h)return!0}}return!1}getDebugAdapterTrackers(l){const S=l.configuration.type,u=this._trackerFactories.filter(v=>v.type===S||v.type==="*").map(v=>(0,I.asPromise)(()=>v.factory.createDebugAdapterTracker(l)).then(R=>R,R=>null));return Promise.race([Promise.all(u).then(v=>{const R=v.filter(L=>!!L);if(R.length>0)return new n(R)}),new Promise((v,R)=>{const L=setTimeout(()=>{clearTimeout(L),R(new Error("timeout"))},1e3)})]).catch(v=>{})}async getAdapterDescriptor(l,h){const S=h.configuration.debugServer;if(typeof S=="number")return Promise.resolve(new P.DebugAdapterServer(S));if(l){const v=await this._extensionService.getExtensionRegistry();return(0,I.asPromise)(()=>l.createDebugAdapterDescriptor(h,this.daExecutableFromPackage(h,v))).then(R=>{if(R)return R})}const u=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(h,u))}daExecutableFromPackage(l,h){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(l,h,S){(l.length>0||h.length>0||S.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:l,removed:h,changed:S}))}async getSession(l){if(l)if(typeof l=="string"){const h=this._debugSessions.get(l);if(h)return h}else{let h=this._debugSessions.get(l.id);if(!h){const S=await this.getFolder(l.folderUri);h=new c(this._debugServiceProxy,l.id,l.type,l.name,S,l.configuration),this._debugSessions.set(h.id,h),this._debugServiceProxy.$sessionCached(h.id)}return h}throw new Error("cannot find session")}getFolder(l){if(l){const h=k.URI.revive(l);return this._workspaceService.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};p=je([Be(0,d.IExtHostRpcService),Be(1,i.IExtHostWorkspace),Be(2,T.IExtHostExtensionService),Be(3,C.IExtHostDocumentsAndEditors),Be(4,f.IExtHostConfiguration)],p),e.ExtHostDebugServiceBase=p;class c{constructor(l,h,S,u,v,R){this._debugServiceProxy=l,this._id=h,this._type=S,this._name=u,this._workspaceFolder=v,this._configuration=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(l){this._name=l,this._debugServiceProxy.$setDebugSessionName(this._id,l)}_acceptNameChanged(l){this._name=l}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(l,h){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,l,h)}getDebugProtocolBreakpoint(l){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,l.id)}}e.ExtHostDebugSession=c;class g{constructor(l){this.value=Object.freeze({append(h){l.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=g;class t extends m.AbstractVariableResolverService{constructor(l,h,S,u){super({getFolderUri:v=>{const R=l.filter(L=>L.name===v);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>l.length,getConfigurationValue:(v,R)=>S.getConfiguration(void 0,v).get(R),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(h){const v=h.activeEditor();if(v)return _.normalize(v.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(h&&u){const v=h.activeEditor();if(v){const R=u.getWorkspaceFolder(v.document.uri);if(R)return _.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(h){const v=h.activeEditor();if(v&&!v.selection.isEmpty)return v.document.getText(v.selection)}},getLineNumber:()=>{if(h){const v=h.activeEditor();if(v)return String(v.selection.end.line+1)}}},void 0,b.env)}}e.ExtHostVariableResolverService=t;class n{constructor(l){this.trackers=l}onWillStartSession(){this.trackers.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.trackers.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.trackers.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(l):void 0)}onWillStopSession(){this.trackers.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.trackers.forEach(h=>h.onError?h.onError(l):void 0)}onExit(l,h){this.trackers.forEach(S=>S.onExit?S.onExit(l,h):void 0)}}class s extends D.AbstractDebugAdapter{constructor(l){super();this.implementation=l,l.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.implementation.handleMessage(l)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends p{constructor(l,h,S,u,v){super(l,h,S,u,v)}createVariableResolver(l,h,S){return new t(l,h,S)}};r=je([Be(0,d.IExtHostRpcService),Be(1,i.IExtHostWorkspace),Be(2,T.IExtHostExtensionService),Be(3,C.IExtHostDocumentsAndEditors),Be(4,f.IExtHostConfiguration)],r),e.WorkerExtHostDebugService=r}),define(me[263],ge([0,1,68,2,5,35,41,29,14,27,4,42,36,13]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(p,c,g,t,n,s,r){this._apiFactory=p,this._extensionRegistry=c,this._instaService=g,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=s,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),_.mark("code/extHost/willWaitForConfig");const p=await this._extHostConfiguration.getConfigProvider();_.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,c,this._extensionRegistry,p,this._logService)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,c,this._initData.environment.appUriScheme))}register(p){if(Array.isArray(p.nodeModuleName))for(let c of p.nodeModuleName)this._factories.set(c,p);else this._factories.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this._alternatives.push(c=>p.alternativeModuleName(c))}};a=je([Be(2,T.IInstantiationService),Be(3,I.IExtHostConfiguration),Be(4,C.IExtHostExtensionService),Be(5,i.IExtHostInitDataService),Be(6,f.ILogService)],a),e.RequireInterceptor=a;class d{constructor(p,c,g,t,n){this._apiFactory=p,this._extensionPaths=c,this._extensionRegistry=g,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(p,c){const g=this._extensionPaths.findSubstr(c.fsPath);if(g){let t=this._extApiImpl.get(P.ExtensionIdentifier.toKey(g.identifier));return t||(t=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(g.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,s)=>t+=`	${s} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(p,c){this.nodeModuleName="keytar";const{environment:g}=c,t=p.getProxy(A.MainContext.MainThreadKeytar);if(g.appRoot){let n=g.appRoot.fsPath;m.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,s)=>t.$getPassword(n,s),setPassword:(n,s,r)=>t.$setPassword(n,s,r),deletePassword:(n,s)=>t.$deletePassword(n,s),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(p,c){return this._impl}alternativeModuleName(p){const c=p.length;if(!(c<=7||!this.alternativeNames)){const g=c-7;if((p.charAt(g)==="/"||p.charAt(g)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.alternativeNames.has(p)))return"keytar"}}};E=je([Be(0,D.IExtHostRpcService),Be(1,i.IExtHostInitDataService)],E);let w=class{constructor(p,c,g){this._extensionPaths=p,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(A.MainContext.MainThreadTelemetry);const t=g.getProxy(A.MainContext.MainThreadWindow);this._impl=(n,s)=>{const r=k.URI.parse(n);return s?this.callOriginal(n,s):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,n,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,n,{}):this.callOriginal(n,s)}}load(p,c,g){const t=this._extensionPaths.findSubstr(c.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=g(p),this._impl}callOriginal(p,c){return this.sendNoForwardTelemetry(),this._original(p,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=je([Be(2,D.IExtHostRpcService)],w)}),define(me[264],ge([0,1,168,9,7,205,32,42,39,35,34,14,46,189,208,19]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let E=class extends m.ExtHostDebugServiceBase{constructor(p,c,g,t,n,s){super(p,c,g,t,n);this._terminalService=s,this._integratedTerminalInstances=new w}createDebugAdapter(p,c){switch(p.type){case"server":return new I.SocketDebugAdapter(p);case"pipeServer":return new I.NamedPipeDebugAdapter(p);case"executable":return new I.ExecutableDebugAdapter(p,c.type)}return super.createDebugAdapter(p,c)}daExecutableFromPackage(p,c){const g=I.ExecutableDebugAdapter.platformAdapterExecutable(c.getAllExtensionDescriptions(),p.type);if(g)return new A.DebugAdapterExecutable(g.command,g.args,g.options)}createSignService(){return new f.SignService}async $runInTerminal(p,c){if(p.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(v=>{this._integratedTerminalInstances.onTerminalClosed(v)}));const g=await this._configurationService.getConfigProvider(),t=this._terminalService.getDefaultShell(!0,g),n=this._terminalService.getDefaultShellArgs(!0,g),s=JSON.stringify({shell:t,shellArgs:n});let r=await this._integratedTerminalInstances.checkout(s),o,l=!1;if(r)o=p.cwd;else{const v={shellPath:t,shellArgs:n,cwd:p.cwd,name:p.title||_.localize(0,null)};l=!0,r=this._terminalService.createTerminalFromOptions(v,!0),this._integratedTerminalInstances.insert(r,s)}r.show(!0);const h=await r.processId;l?await new Promise(v=>setTimeout(v,1e3)):g.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(t.indexOf("powershell")>=0||t.indexOf("pwsh")>=0||t.indexOf("cmd.exe")>=0?r.sendText("cls"):t.indexOf("bash")>=0?r.sendText("clear"):k.isWindows?r.sendText("cls"):r.sendText("clear"));const S=(0,a.prepareCommand)(t,p.args,o,p.env);r.sendText(S);const u=this.onDidTerminateDebugSession(v=>{v.id===c&&(this._integratedTerminalInstances.free(r),u.dispose())});return h}else if(p.kind==="external")return(0,a.runInExternalTerminal)(p,await this._configurationService.getConfigProvider());return super.$runInTerminal(p,c)}createVariableResolver(p,c,g){return new m.ExtHostVariableResolverService(p,c,g,this._workspaceService)}};E=je([Be(0,C.IExtHostRpcService),Be(1,y.IExtHostWorkspace),Be(2,P.IExtHostExtensionService),Be(3,D.IExtHostDocumentsAndEditors),Be(4,i.IExtHostConfiguration),Be(5,T.IExtHostTerminalService)],E),e.ExtHostDebugService=E;class w{constructor(){this._terminalInstances=new Map}async checkout(p){const g=[...this._terminalInstances.entries()].map(([t,n])=>(0,d.createCancelablePromise)(async s=>{if(n.lastUsedAt!==-1&&await(0,a.hasChildProcesses)(await t.processId))return null;const r=Date.now();return n.lastUsedAt+w.minUseDelay>r||s.isCancellationRequested||n.config!==p?null:(n.lastUsedAt=r,t)}));return await(0,d.firstParallel)(g,t=>!!t)}insert(p,c){this._terminalInstances.set(p,{lastUsedAt:Date.now(),config:c})}free(p){const c=this._terminalInstances.get(p);c&&(c.lastUsedAt=-1)}onTerminalClosed(p){this._terminalInstances.delete(p)}}w.minUseDelay=1e3}),define(me[265],ge([0,1,8,2,78,32,46,39,35,34,14,27,67,11,13,64]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let E=class extends m.ExtHostTaskBase{constructor(b,p,c,g,t,n,s,r){super(b,p,c,g,t,n,s,r);this.workspaceService=c,p.remote.isRemote&&p.remote.authority?this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:p.remote.authority,platform:process.platform}):this.registerTaskSystem(f.Schemas.file,{scheme:f.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(b,p){const c=p;if(!p.execution&&c._id===void 0)throw new Error("Tasks to execute must include an execution");if(c._id!==void 0){const g=m.TaskHandleDTO.from(c,this.workspaceService),t=await this._proxy.$getTaskExecution(g);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.getTaskExecution(t,p);return this._proxy.$executeTask(g).catch(()=>{}),n}else{const g=m.TaskDTO.from(p,b);if(g===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(g.execution)&&await this.addCustomExecution(g,p,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(g),p);return this._proxy.$executeTask(g).catch(()=>{}),t}}provideTasksInternal(b,p,c,g){const t=[];if(g)for(let n of g){this.checkDeprecation(n,c),(!n.definition||!b[n.definition.type])&&this._logService.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const s=m.TaskDTO.from(n,c.extension);s&&(t.push(s),m.CustomExecutionDTO.is(s.execution)&&p.push(this.addCustomExecution(s,n,!0)))}return{tasks:t,extension:c.extension}}async resolveTaskInternal(b){return b}async getVariableResolver(b){if(this._variableResolver===void 0){const p=await this._configurationService.getConfigProvider();this._variableResolver=new y.ExtHostVariableResolverService(b,this._editorService,p,this.workspaceService)}return this._variableResolver}async $resolveVariables(b,p){const c=k.URI.revive(b),g={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(c),n=await this._workspaceProvider.getWorkspaceFolders2();if(!n||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const s=await this.getVariableResolver(n),r={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let o of p.variables)g.variables[o]=await s.resolveAsync(r,o);if(p.process!==void 0){let o;if(p.process.path!==void 0){o=p.process.path.split(_.delimiter);for(let l=0;l<o.length;l++)o[l]=await s.resolveAsync(r,o[l])}g.process=await A.win32.findExecutable(await s.resolveAsync(r,p.process.name),p.process.cwd!==void 0?await s.resolveAsync(r,p.process.cwd):void 0,o)}return g}$getDefaultShellAndArgs(){return this._terminalService.$getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(b,p,c){return A.win32.findExecutable(b,p,c)}};E=je([Be(0,T.IExtHostRpcService),Be(1,C.IExtHostInitDataService),Be(2,I.IExtHostWorkspace),Be(3,P.IExtHostDocumentsAndEditors),Be(4,D.IExtHostConfiguration),Be(5,i.IExtHostTerminalService),Be(6,a.ILogService),Be(7,d.IExtHostApiDeprecationService)],E),e.ExtHostTask=E}),define(me[266],ge([0,1,9,12,28,149,13,35,46,39,14,34,32,211,212]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let d=class extends C.BaseExtHostTerminalService{constructor(w,b,p,c,g){super(!0,w);this._extHostConfiguration=b,this._extHostWorkspace=p,this._extHostDocumentsAndEditors=c,this._logService=g,(0,I.getSystemShell)(_.OS,process.env).then(t=>this._defaultShell=t),this._updateLastActiveWorkspace(),this._variableResolverPromise=this._updateVariableResolver(),this._registerListeners()}createTerminal(w,b,p){const c=new C.ExtHostTerminal(this._proxy,(0,A.generateUuid)(),{name:w,shellPath:b,shellArgs:p},w);return this._terminals.push(c),c.create(b,p),c.value}createTerminalFromOptions(w,b){const p=new C.ExtHostTerminal(this._proxy,(0,A.generateUuid)(),w,w.name);return this._terminals.push(p),p.create((0,k.withNullAsUndefined)(w.shellPath),(0,k.withNullAsUndefined)(w.shellArgs),(0,k.withNullAsUndefined)(w.cwd),(0,k.withNullAsUndefined)(w.env),(0,k.withNullAsUndefined)(w.icon),(0,k.withNullAsUndefined)(w.message),void 0,(0,k.withNullAsUndefined)(w.strictEnv),(0,k.withNullAsUndefined)(w.hideFromUser),(0,k.withNullAsUndefined)(b),!0),p.value}getDefaultShell(w,b){var p;const c=g=>b.getConfiguration(g.substr(0,g.lastIndexOf("."))).get(g.substr(g.lastIndexOf(".")+1));return f.getDefaultShell(c,(p=this._defaultShell)!==null&&p!==void 0?p:(0,I.getSystemShellSync)(_.OS,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,f.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService,w)}getDefaultShellArgs(w,b){const p=c=>b.getConfiguration(c.substr(0,c.lastIndexOf("."))).get(c.substr(c.lastIndexOf(".")+1));return f.getDefaultShellArgs(p,w,f.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService)}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>{this._variableResolverPromise=this._updateVariableResolver()})}_updateLastActiveWorkspace(){const w=this._extHostDocumentsAndEditors.activeEditor();w&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(w.document.uri))}async _updateVariableResolver(){const w=await this._extHostConfiguration.getConfigProvider(),b=await this._extHostWorkspace.getWorkspaceFolders2();return this._variableResolver=new D.ExtHostVariableResolverService(b||[],this._extHostDocumentsAndEditors,w),this._variableResolver}async $getAvailableProfiles(w){const b=await(await this._extHostConfiguration.getConfigProvider()).getConfiguration().get("terminal.integrated");return(0,a.detectAvailableProfiles)(w,void 0,this._logService,b,await this._variableResolverPromise,this._lastActiveWorkspace)}async $getDefaultShellAndArgs(w){const b=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(w,b),args:this.getDefaultShellArgs(w,b)}}};d=je([Be(0,T.IExtHostRpcService),Be(1,P.IExtHostConfiguration),Be(2,m.IExtHostWorkspace),Be(3,i.IExtHostDocumentsAndEditors),Be(4,y.ILogService)],d),e.ExtHostTerminalService=d}),define(me[267],ge([0,1,19,18,68,6,2,5,257,13,79,82,27,185,14,62,42,34]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(c,g,t,n){this._disposables=new I.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const s=new D.RPCProtocol(c,null,n);g=b._transform(g,s);const r=new C.ServiceCollection(...(0,T.getSingletonServiceDescriptors)());r.set(m.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},g)),r.set(a.IExtHostRpcService,new a.ExtHostRpcService(s)),r.set(d.IURITransformerService,new d.URITransformerService(n)),r.set(E.IHostUtils,t);const o=new f.InstantiationService(r,!0),l=o.invokeFunction(v=>v.get(w.IExtHostTerminalService));this._disposables.add(l),this._logService=o.invokeFunction(v=>v.get(i.ILogService)),A.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",g),this._extensionService=o.invokeFunction(v=>v.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const h=new WeakMap;this._extensionService.getExtensionPathIndex().then(v=>{Error.prepareStackTrace=(R,L)=>{let H="",ie,j;for(const B of L)H+=`
	at ${B.toString()}`,j=B.getFileName(),!ie&&j&&(ie=v.findSubstr(j));return h.set(R,ie),`${R.name||"Error"}: ${R.message||""}${H}`}});const S=s.getProxy(P.MainContext.MainThreadExtensionService),u=s.getProxy(P.MainContext.MainThreadErrors);k.setUnexpectedErrorHandler(v=>{const R=k.transformErrorForSerialization(v),L=h.get(v);L?S.$onExtensionRuntimeError(L.identifier,R):u.$onUnexpectedError(R)})}terminate(c){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),k.setUnexpectedErrorHandler(t=>{});const g=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,_.timeout)(4e3),g]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(c,g){c.extensions.forEach(n=>n.extensionLocation=y.URI.revive(g.transformIncomingURIs(n.extensionLocation))),c.environment.appRoot=y.URI.revive(g.transformIncomingURIs(c.environment.appRoot));const t=c.environment.extensionDevelopmentLocationURI;return t&&(c.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(g.transformIncomingURIs(n)))),c.environment.extensionTestsLocationURI=y.URI.revive(g.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=y.URI.revive(g.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=y.URI.revive(g.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=y.URI.revive(g.transformIncomingURIs(c.logsLocation)),c.logFile=y.URI.revive(g.transformIncomingURIs(c.logFile)),c.workspace=g.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=b}),define(me[268],ge([0,1,8,21,59,33,25,47,31]),function(G,e,_,k,A,I,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class i{constructor(m,f,a){this.config=m,this.provider=f,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&I.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&I.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const f=this.config.folderQueries||[];return new Promise((a,d)=>{const E=w=>{this.resultCount++,m(w)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const b=w.toString(),p=_.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,p)||this.matchFile(E,{base:w,basename:p})}),Promise.all(f.map(w=>this.searchInFolder(w,E))).then(w=>{a({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{d(new Error((0,A.toErrorMessage)(w)))})})}async searchInFolder(m,f){const a=new k.CancellationTokenSource,d=this.getSearchOptionsForFolder(m),E=this.initDirectoryTree(),w=new D.QueryGlobTester(this.config,m),b=!w.hasSiblingExcludeClauses();let p;try{this.activeCancellationTokens.add(a),p=P.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,a.token),g=p.elapsed(),t=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(n=>{const s=_.posix.relative(m.folder.path,n.path);if(b){const r=_.basename(n.path);this.matchFile(f,{base:m.folder,relativePath:s,basename:r});return}this.addDirectoryEntries(E,m.folder,s,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,w,f),{providerTime:g,postProcessTime:t.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(m){const f=(0,D.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),a=(0,D.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:a,includes:f,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},f,a,d){if(a===this.filePattern){const w=_.basename(this.filePattern);this.matchFile(d,{base:f,relativePath:this.filePattern,basename:w})}function E(w){const b=_.basename(w),p=_.dirname(w);let c=m[p];c||(c=m[p]=[],E(p)),c.push({base:f,relativePath:w,basename:b})}E(a)}matchDirectoryTree({rootEntries:m,pathToEntries:f},a,d){const E=this,w=this.filePattern;function b(p){const c=I.hasSiblingFn(()=>p.map(g=>g.basename));for(let g=0,t=p.length;g<t;g++){const n=p[g],{relativePath:s,basename:r}=n;if(!!a.includedInQuerySync(s,r,w!==r?c:void 0)){const o=f[s];if(o)b(o);else{if(s===w)continue;E.matchFile(d,n)}if(E.isLimitHit)break}}}b(m)}matchFile(m,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(f))}}class T{constructor(){this.sessions=new Map}fileSearch(m,f,a,d){const E=this.getSessionTokenSource(m.cacheKey),w=new i(m,f,E&&E.token);let b=0;const p=c=>{b+=c.length,a(c.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(w,T.BATCH_SIZE,p,d).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:c.stats}}))}clearCache(m){const f=this.getSessionTokenSource(m);f&&f.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new k.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:y.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,f,a,d){d.onCancellationRequested(()=>{m.cancel()});const E=b=>{b&&(w.push(b),f>0&&w.length>=f&&(a(w),w=[]))};let w=[];return m.search(E).then(b=>(w.length&&a(w),b),b=>(w.length&&a(w),Promise.reject(b)))}}e.FileSearchManager=T,T.BATCH_SIZE=512}),define(me[127],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=e.Position=void 0;class _{constructor(I,y){this.line=I,this.character=y}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,y){return new _(0,0)}with(I){return new _(0,0)}}e.Position=_;class k{constructor(I,y,P,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new _(I,y),this.end=new _(P,D)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new k(0,0,0,0)}with(I){return new k(0,0,0,0)}}e.Range=k}),define(me[128],ge([0,1,8,15,21,59,25,33,2,31,11]),function(G,e,_,k,A,I,y,P,D,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class C{constructor(b,p,c){this.query=b,this.provider=p,this.fileUtils=c,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(b,p){const c=this.query.folderQueries||[],g=new A.CancellationTokenSource;return p.onCancellationRequested(()=>g.cancel()),new Promise((t,n)=>{this.collector=new f(b);let s=!1;const r=(o,l)=>{if(!s&&!this.isLimitHit){const h=this.resultSize(o);d(o)&&typeof this.query.maxResults=="number"&&this.resultCount+h>this.query.maxResults&&(this.isLimitHit=!0,s=!0,g.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const S=this.resultSize(o);this.resultCount+=S,(S>0||!d(o))&&this.collector.add(o,l)}};Promise.all(c.map((o,l)=>this.searchInFolder(o,h=>r(h,l),g.token))).then(o=>{g.dispose(),this.collector.flush();const l=o.some(h=>!!h&&!!h.limitHit);t({limitHit:this.isLimitHit||l,stats:{type:"textSearchProvider"}})},o=>{g.dispose();const l=(0,I.toErrorMessage)(o);n(new Error(l))})})}resultSize(b){return d(b)?Array.isArray(b.ranges)?b.ranges.length:1:0}trimResultToSize(b,p){const c=Array.isArray(b.ranges)?b.ranges:[b.ranges],g=Array.isArray(b.preview.matches)?b.preview.matches:[b.preview.matches];return{ranges:c.slice(0,p),preview:{matches:g.slice(0,p),text:b.preview.text},uri:b.uri}}async searchInFolder(b,p,c){const g=new i.QueryGlobTester(this.query,b),t=[],n={report:o=>{if(!!this.validateProviderResult(o)){const l=b.folder.scheme===T.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(o.uri))):void 0,h=y.relativePath(b.folder,o.uri);h&&t.push(g.includedInQuery(h,_.basename(h),l).then(S=>{S&&p(o)}))}}},s=this.getSearchOptionsForFolder(b),r=await this.provider.provideTextSearchResults(m(this.query.contentPattern),s,n,c);return await Promise.all(t),r}validateProviderResult(b){if(d(b)){if(Array.isArray(b.ranges)){if(!Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(b.preview.matches.length!==b.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(b){const p=(0,i.resolvePatternsForProvider)(this.query.includePattern,b.includePattern),c=(0,i.resolvePatternsForProvider)(this.query.excludePattern,b.excludePattern),g={folder:D.URI.from(b.folder),excludes:c,includes:p,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,followSymlinks:!b.ignoreSymlinks,encoding:b.fileEncoding&&this.fileUtils.toCanonicalName(b.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return g.usePCRE2=this.query.usePCRE2,g}}e.TextSearchManager=C;function m(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class f{constructor(b){this._onResult=b,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new E(512,p=>this.sendItems(p))}add(b,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!y.isEqual(this._currentUri,b.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:b.uri,results:[]}),this._currentFileMatch.results.push(a(b))}pushToCollector(){const b=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,b)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(b){this._onResult(b)}}e.TextSearchResultsCollector=f;function a(w){return d(w)?{preview:{matches:(0,k.mapArrayOrNot)(w.preview.matches,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character})),text:w.preview.text},ranges:(0,k.mapArrayOrNot)(w.ranges,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function d(w){return!!w.preview}e.extensionResultIsMatch=d;class E{constructor(b,p){this.maxBatchSize=b,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(b,p){!b||this.addItemToBatch(b,p)}addItems(b,p){!b||this.addItemsToBatch(b,p)}addItemToBatch(b,p){this.batch.push(b),this.batchSize+=p,this.onUpdate()}addItemsToBatch(b,p){this.batch=this.batch.concat(b),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<E.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},E.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=E,E.TIMEOUT=4e3,E.START_BATCH_AFTER_COUNT=50}),define(me[69],ge([0,1,6,5,4,268,14,62,13,2,128]),function(G,e,_,k,A,I,y,P,D,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,A.createDecorator)("IExtHostSearch");let C=class{constructor(d,E,w){this.extHostRpc=d,this._uriTransformer=E,this._logService=w,this._proxy=this.extHostRpc.getProxy(k.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new I.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,E){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const w=this._handlePool++;return this._textSearchProvider.set(w,E),this._proxy.$registerTextSearchProvider(w,this._transformScheme(d)),(0,_.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(d,E){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const w=this._handlePool++;return this._fileSearchProvider.set(w,E),this._proxy.$registerFileSearchProvider(w,this._transformScheme(d)),(0,_.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(d,E,w,b){const p=m(w),c=this._fileSearchProvider.get(d);if(c)return this._fileSearchManager.fileSearch(p,c,g=>{this._proxy.$handleFileMatch(d,E,g.map(t=>t.resource))},b);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,E,w,b){const p=this._textSearchProvider.get(d);if(!p||!p.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const c=m(w);return this.createTextSearchManager(c,p).search(t=>this._proxy.$handleTextMatch(d,E,t),b)}createTextSearchManager(d,E){return new T.TextSearchManager(d,E,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};C=je([Be(0,y.IExtHostRpcService),Be(1,P.IURITransformerService),Be(2,D.ILogService)],C),e.ExtHostSearch=C;function m(a){return Object.assign(Object.assign({},a),{folderQueries:a.folderQueries&&a.folderQueries.map(f),extraFileResources:a.extraFileResources&&a.extraFileResources.map(d=>i.URI.revive(d))})}e.reviveQuery=m;function f(a){return Object.assign(Object.assign({},a),{folder:i.URI.revive(a.folder)})}}),define(me[269],ge([0,1,159,21,18,3,57,2,151,107,141,77,45,5,231,230,51,232,35,233,234,235,216,236,39,42,237,217,239,240,241,65,220,244,245,246,91,34,247,221,20,7,250,66,126,32,41,53,201,238,116,125,67,46,69,13,62,14,27,242,199,50,64,228,248,198,92,90,253,251,252,229,61,260,249,89,195,118,243,85]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d,E,w,b,p,c,g,t,n,s,r,o,l,h,S,u,v,R,L,H,ie,j,B,$,N,M,F,U,O,W,q,Q,he,ve,Ie,ke,Le,V,J,ee,ae,we,Ce,Oe,be,Pe,Re,We,Ee,Ke,X,re,_e,xe,ze,$e,Ye,K,oe,fe,Z,ne,ce,pe,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function qe(Me){const He=Me.get(Oe.IExtHostInitDataService),Qe=Me.get(K.IExtHostFileSystemInfo),it=Me.get(_e.IExtHostConsumerFileSystem),at=Me.get(r.IExtHostExtensionService),Ze=Me.get(q.IExtHostWorkspace),nt=Me.get(ce.IExtHostTelemetry),dt=Me.get(b.IExtHostConfiguration),_t=Me.get(we.IURITransformerService),ue=Me.get(Ce.IExtHostRpcService),De=Me.get(j.IExtHostStorage),le=Me.get(re.IExtensionStoragePaths),Y=Me.get(ae.ILogService),Ne=Me.get(Re.IExtHostTunnelService),Te=Me.get(We.IExtHostApiDeprecationService),Je=Me.get(W.IExtHostWindow),et=Me.get(Z.IExtHostSecretState);ue.set(f.ExtHostContext.ExtHostFileSystemInfo,Qe),ue.set(f.ExtHostContext.ExtHostLogService,Y),ue.set(f.ExtHostContext.ExtHostWorkspace,Ze),ue.set(f.ExtHostContext.ExtHostConfiguration,dt),ue.set(f.ExtHostContext.ExtHostExtensionService,at),ue.set(f.ExtHostContext.ExtHostStorage,De),ue.set(f.ExtHostContext.ExtHostTunnelService,Ne),ue.set(f.ExtHostContext.ExtHostWindow,Je),ue.set(f.ExtHostContext.ExtHostSecretState,et),ue.set(f.ExtHostContext.ExtHostTelemetry,nt);const ut=ue.set(f.ExtHostContext.ExtHostDecorations,Me.get(Le.IExtHostDecorations)),rt=ue.set(f.ExtHostContext.ExtHostDocumentsAndEditors,Me.get(s.IExtHostDocumentsAndEditors)),Ge=ue.set(f.ExtHostContext.ExtHostCommands,Me.get(E.IExtHostCommands)),ht=ue.set(f.ExtHostContext.ExtHostTerminalService,Me.get(B.IExtHostTerminalService)),ot=ue.set(f.ExtHostContext.ExtHostDebugService,Me.get(J.IExtHostDebugService)),vt=ue.set(f.ExtHostContext.ExtHostSearch,Me.get(ee.IExtHostSearch)),pt=ue.set(f.ExtHostContext.ExtHostTask,Me.get(V.IExtHostTask)),Et=ue.set(f.ExtHostContext.ExtHostOutputService,Me.get(v.IExtHostOutputService)),yt=ue.set(f.ExtHostContext.ExtHostEditorTabs,new ne.ExtHostEditorTabs),It=ue.set(f.ExtHostContext.ExtHostUrls,new U.ExtHostUrls(ue)),bt=ue.set(f.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(ue,rt)),At=ue.set(f.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(ue,rt,Y)),Qt=ue.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Y,bt,ue.getProxy(f.MainContext.MainThreadBulkEdits))),ft=ue.set(f.ExtHostContext.ExtHostNotebook,new be.ExtHostNotebookController(ue,Ge,rt,bt,He.environment,Y,le)),Xt=ue.set(f.ExtHostContext.ExtHostNotebookKernels,new pe.ExtHostNotebookKernels(ue,He,ft)),St=ue.set(f.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(ue,rt)),zt=ue.set(f.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(ue.getProxy(f.MainContext.MainThreadTreeViews),Ge,Y)),Yt=ue.set(f.ExtHostContext.ExtHostEditorInsets,new ve.ExtHostEditorInsets(ue.getProxy(f.MainContext.MainThreadEditorInsets),St,He.environment)),Vt=ue.set(f.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(ue,Y)),lt=ue.set(f.ExtHostContext.ExtHostLanguageFeatures,new h.ExtHostLanguageFeatures(ue,_t,bt,Ge,Vt,Y,Te)),Jt=ue.set(f.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(ue,lt)),Tt=ue.set(f.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(ue,Y,rt)),Nt=ue.set(f.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(ue,Ze,Ge)),fn=ue.set(f.ExtHostContext.ExtHostSCM,new H.ExtHostSCM(ue,Ge,Y)),_n=ue.set(f.ExtHostContext.ExtHostComments,new w.ExtHostComments(ue,Ge,bt)),mn=ue.set(f.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(ue.getProxy(f.MainContext.MainThreadProgress))),Zt=ue.set(f.ExtHostContext.ExtHosLabelService,new Ie.ExtHostLabelService(ue)),jt=ue.set(f.ExtHostContext.ExtHostTheming,new Pe.ExtHostTheming(ue)),Mt=ue.set(f.ExtHostContext.ExtHostAuthentication,new Ee.ExtHostAuthentication(ue)),En=ue.set(f.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(ue,Ge)),en=ue.set(f.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(ue,He.environment,Ze,Y,Te)),tn=ue.set(f.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(ue,en,Ze)),qt=ue.set(f.ExtHostContext.ExtHostCustomEditors,new ze.ExtHostCustomEditors(ue,bt,le,en,tn)),Sn=ue.set(f.ExtHostContext.ExtHostWebviewViews,new xe.ExtHostWebviewViews(ue,en)),Rt=ue.set(f.ExtHostContext.ExtHostTesting,new oe.ExtHostTesting(ue,rt,Ze)),nn=ue.set(f.ExtHostContext.ExtHostUriOpeners,new fe.ExtHostUriOpeners(ue)),yn=(0,he.values)(f.ExtHostContext);ue.assertRegistered(yn);const rn=new Ye.ExtHostBulkEdits(ue,rt),sn=new d.ExtHostClipboard(ue),Ot=new u.ExtHostMessageService(ue,Y),gn=new c.ExtHostDialogs(ue),pn=new ie.ExtHostStatusBar(ue,Ge.converter),Ut=new S.ExtHostLanguages(ue,bt);return a.ExtHostApiCommands.register(Ge),function(Fe,on,an){const mt=function(){let te=!Fe.isUnderDevelopment;function de(Ae){te||(Y.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Ae(st){if(Array.isArray(st))st.forEach(Ae);else if(typeof st=="string")de(st);else{const z=st;typeof z.scheme=="undefined"&&de(st),!Fe.enableProposedApi&&typeof z.exclusive=="boolean"&&(0,Q.throwProposedApiError)(Fe)}return st}}(),Dn={getSession(te,de,Ae){return Mt.getSession(Fe,te,de,Ae)},get onDidChangeSessions(){return Mt.onDidChangeSessions},registerAuthenticationProvider(te,de,Ae,st){return Mt.registerAuthenticationProvider(te,de,Ae,st)},get onDidChangeAuthenticationProviders(){return(0,Q.checkProposedApiEnabled)(Fe),Mt.onDidChangeAuthenticationProviders},get providers(){return(0,Q.checkProposedApiEnabled)(Fe),Mt.providers},logout(te,de){return(0,Q.checkProposedApiEnabled)(Fe),Mt.removeSession(te,de)}},Cn={registerCommand(te,de,Ae){return Ge.registerCommand(!0,te,de,Ae)},registerTextEditorCommand(te,de,Ae){return Ge.registerCommand(!0,te,(...st)=>{const z=St.getActiveTextEditor();if(!z){Y.warn("Cannot execute "+te+" because there is no active text editor.");return}return z.edit(x=>{de.apply(Ae,[z,x,...st])}).then(x=>{x||Y.warn("Edits from command "+te+" were not applied.")},x=>{Y.warn("An error occurred while running command "+te,x)})})},registerDiffInformationCommand:(te,de,Ae)=>((0,Q.checkProposedApiEnabled)(Fe),Ge.registerCommand(!0,te,async(...st)=>{const z=rt.activeEditor(!0);if(!z){Y.warn("Cannot execute "+te+" because there is no active text editor.");return}const x=await St.getDiffInformation(z.id);de.apply(Ae,[x,...st])})),executeCommand(te,...de){return Ge.executeCommand(te,...de)},getCommands(te=!1){return Ge.getCommands(te)}},Kt={get machineId(){return He.telemetryInfo.machineId},get sessionId(){return He.telemetryInfo.sessionId},get language(){return He.environment.appLanguage},get appName(){return He.environment.appName},get appRoot(){var te,de;return(de=(te=He.environment.appRoot)===null||te===void 0?void 0:te.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return He.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return ht.getDefaultShell(!1,an)},get isTelemetryEnabled(){return nt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return nt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(He.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,de){return Je.openUri(te,{allowTunneling:!!He.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},asExternalUri(te){return te.scheme===He.environment.appUriScheme?It.createAppUri(te):Je.asExternalUri(te,{allowTunneling:!!He.remote.authority})},get remoteName(){return(0,ke.getRemoteName)(He.remote.authority)},get uiKind(){return He.uiKind}};He.environment.extensionTestsLocationURI||Object.freeze(Kt);const vn=He.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,kn={registerTestController(te){return(0,Q.checkProposedApiEnabled)(Fe),Rt.registerTestController(Fe.identifier.value,te)},createDocumentTestObserver(te){return(0,Q.checkProposedApiEnabled)(Fe),Rt.createTextDocumentTestObserver(te)},createWorkspaceTestObserver(te){return(0,Q.checkProposedApiEnabled)(Fe),Rt.createWorkspaceTestObserver(te)},runTests(te){return(0,Q.checkProposedApiEnabled)(Fe),Rt.runTests(te)},createTestItem(te,de){return new F.TestItemImpl(te.id,te.label,te.uri,de)},createTestRunTask(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),Rt.createTestRunTask(Fe.identifier.value,te,de,Ae)},get onDidChangeTestResults(){return(0,Q.checkProposedApiEnabled)(Fe),Rt.onResultsChanged},get testResults(){return(0,Q.checkProposedApiEnabled)(Fe),Rt.results}},Pn={getExtension(te){const de=on.getExtensionDescription(te);if(de)return new r.Extension(at,Fe.identifier,de,vn)},get all(){return on.getAllExtensionDescriptions().map(te=>new r.Extension(at,Fe.identifier,te,vn))},get onDidChange(){return on.onDidChange}},In={createDiagnosticCollection(te){return Vt.createDiagnosticCollection(Fe.identifier,te)},get onDidChangeDiagnostics(){return Vt.onDidChangeDiagnostics},getDiagnostics:te=>Vt.getDiagnostics(te),getLanguages(){return Ut.getLanguages()},setTextDocumentLanguage(te,de){return Ut.changeLanguage(te.uri,de)},match(te,de){return(0,C.score)(M.LanguageSelector.from(te),de.uri,de.languageId,!0)},registerCodeActionsProvider(te,de,Ae){return lt.registerCodeActionProvider(Fe,mt(te),de,Ae)},registerCodeLensProvider(te,de){return lt.registerCodeLensProvider(Fe,mt(te),de)},registerDefinitionProvider(te,de){return lt.registerDefinitionProvider(Fe,mt(te),de)},registerDeclarationProvider(te,de){return lt.registerDeclarationProvider(Fe,mt(te),de)},registerImplementationProvider(te,de){return lt.registerImplementationProvider(Fe,mt(te),de)},registerTypeDefinitionProvider(te,de){return lt.registerTypeDefinitionProvider(Fe,mt(te),de)},registerHoverProvider(te,de){return lt.registerHoverProvider(Fe,mt(te),de,Fe.identifier)},registerEvaluatableExpressionProvider(te,de){return lt.registerEvaluatableExpressionProvider(Fe,mt(te),de,Fe.identifier)},registerInlineValuesProvider(te,de){return lt.registerInlineValuesProvider(Fe,mt(te),de,Fe.identifier)},registerDocumentHighlightProvider(te,de){return lt.registerDocumentHighlightProvider(Fe,mt(te),de)},registerLinkedEditingRangeProvider(te,de){return lt.registerLinkedEditingRangeProvider(Fe,mt(te),de)},registerReferenceProvider(te,de){return lt.registerReferenceProvider(Fe,mt(te),de)},registerRenameProvider(te,de){return lt.registerRenameProvider(Fe,mt(te),de)},registerDocumentSymbolProvider(te,de,Ae){return lt.registerDocumentSymbolProvider(Fe,mt(te),de,Ae)},registerWorkspaceSymbolProvider(te){return lt.registerWorkspaceSymbolProvider(Fe,te)},registerDocumentFormattingEditProvider(te,de){return lt.registerDocumentFormattingEditProvider(Fe,mt(te),de)},registerDocumentRangeFormattingEditProvider(te,de){return lt.registerDocumentRangeFormattingEditProvider(Fe,mt(te),de)},registerOnTypeFormattingEditProvider(te,de,Ae,...st){return lt.registerOnTypeFormattingEditProvider(Fe,mt(te),de,[Ae].concat(st))},registerDocumentSemanticTokensProvider(te,de,Ae){return lt.registerDocumentSemanticTokensProvider(Fe,mt(te),de,Ae)},registerDocumentRangeSemanticTokensProvider(te,de,Ae){return lt.registerDocumentRangeSemanticTokensProvider(Fe,mt(te),de,Ae)},registerSignatureHelpProvider(te,de,Ae,...st){return typeof Ae=="object"?lt.registerSignatureHelpProvider(Fe,mt(te),de,Ae):lt.registerSignatureHelpProvider(Fe,mt(te),de,typeof Ae=="undefined"?[]:[Ae,...st])},registerCompletionItemProvider(te,de,...Ae){return lt.registerCompletionItemProvider(Fe,mt(te),de,Ae)},registerDocumentLinkProvider(te,de){return lt.registerDocumentLinkProvider(Fe,mt(te),de)},registerColorProvider(te,de){return lt.registerColorProvider(Fe,mt(te),de)},registerFoldingRangeProvider(te,de){return lt.registerFoldingRangeProvider(Fe,mt(te),de)},registerSelectionRangeProvider(te,de){return lt.registerSelectionRangeProvider(Fe,te,de)},registerCallHierarchyProvider(te,de){return lt.registerCallHierarchyProvider(Fe,te,de)},setLanguageConfiguration:(te,de)=>lt.setLanguageConfiguration(Fe,te,de),getTokenInformationAtPosition(te,de){return(0,Q.checkProposedApiEnabled)(Fe),Ut.tokenAtPosition(te,de)},registerInlineHintsProvider(te,de){return(0,Q.checkProposedApiEnabled)(Fe),lt.registerInlineHintsProvider(Fe,te,de)}},An={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return ht.activeTerminal},get terminals(){return ht.terminals},async showTextDocument(te,de,Ae){const st=await(P.URI.isUri(te)?Promise.resolve(ln.openTextDocument(te)):Promise.resolve(te));return St.showTextDocument(st,de,Ae)},createTextEditorDecorationType(te){return St.createTextEditorDecorationType(te)},onDidChangeActiveTextEditor(te,de,Ae){return St.onDidChangeActiveTextEditor(te,de,Ae)},onDidChangeVisibleTextEditors(te,de,Ae){return St.onDidChangeVisibleTextEditors(te,de,Ae)},onDidChangeTextEditorSelection(te,de,Ae){return St.onDidChangeTextEditorSelection(te,de,Ae)},onDidChangeTextEditorOptions(te,de,Ae){return St.onDidChangeTextEditorOptions(te,de,Ae)},onDidChangeTextEditorVisibleRanges(te,de,Ae){return St.onDidChangeTextEditorVisibleRanges(te,de,Ae)},onDidChangeTextEditorViewColumn(te,de,Ae){return St.onDidChangeTextEditorViewColumn(te,de,Ae)},onDidCloseTerminal(te,de,Ae){return ht.onDidCloseTerminal(te,de,Ae)},onDidOpenTerminal(te,de,Ae){return ht.onDidOpenTerminal(te,de,Ae)},onDidChangeActiveTerminal(te,de,Ae){return ht.onDidChangeActiveTerminal(te,de,Ae)},onDidChangeTerminalDimensions(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ht.onDidChangeTerminalDimensions(te,de,Ae)},onDidWriteTerminalData(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ht.onDidWriteTerminalData(te,de,Ae)},get state(){return Je.state},onDidChangeWindowState(te,de,Ae){return Je.onDidChangeWindowState(te,de,Ae)},showInformationMessage(te,...de){return Ot.showMessage(Fe,y.default.Info,te,de[0],de.slice(1))},showWarningMessage(te,...de){return Ot.showMessage(Fe,y.default.Warning,te,de[0],de.slice(1))},showErrorMessage(te,...de){return Ot.showMessage(Fe,y.default.Error,te,de[0],de.slice(1))},showQuickPick(te,de,Ae){return Nt.showQuickPick(te,!!Fe.enableProposedApi,de,Ae)},showWorkspaceFolderPick(te){return Nt.showWorkspaceFolderPick(te)},showInputBox(te,de){return Nt.showInput(te,de)},showOpenDialog(te){return gn.showOpenDialog(te)},showSaveDialog(te){return gn.showSaveDialog(te)},createStatusBarItem(te,de){let Ae,st,z,x;return te&&typeof te!="number"?(Ae=te.id,st=te.name,z=te.alignment,de=te.priority,x=te.accessibilityInformation):(Ae=Fe.identifier.value,st=_.localize(0,null,Fe.displayName||Fe.name),z=te),pn.createStatusBarEntry(Ae,st,z,de,x)},setStatusBarMessage(te,de){return pn.setStatusBarMessage(te,de)},withScmProgress(te){return Te.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),mn.withProgress(Fe,{location:F.ProgressLocation.SourceControl},(de,Ae)=>te({report(st){}}))},withProgress(te,de){return mn.withProgress(Fe,te,de)},createOutputChannel(te){return Et.createOutputChannel(te)},createWebviewPanel(te,de,Ae,st){return tn.createWebviewPanel(Fe,te,de,Ae,st)},createWebviewTextEditorInset(te,de,Ae,st){return(0,Q.checkProposedApiEnabled)(Fe),Yt.createWebviewEditorInset(te,de,Ae,st,Fe)},createTerminal(te,de,Ae){return typeof te=="object"?"pty"in te?ht.createExtensionTerminal(te):(te.message&&(0,Q.checkProposedApiEnabled)(Fe),te.icon&&(0,Q.checkProposedApiEnabled)(Fe),ht.createTerminalFromOptions(te)):ht.createTerminal(te,de,Ae)},registerTerminalLinkProvider(te){return ht.registerLinkProvider(te)},registerTreeDataProvider(te,de){return zt.registerTreeDataProvider(te,de,Fe)},createTreeView(te,de){return zt.createTreeView(te,de,Fe)},registerWebviewPanelSerializer:(te,de)=>tn.registerWebviewPanelSerializer(Fe,te,de),registerCustomEditorProvider:(te,de,Ae={})=>qt.registerCustomEditorProvider(Fe,te,de,Ae),registerFileDecorationProvider(te){return ut.registerFileDecorationProvider(te,Fe.identifier)},registerUriHandler(te){return It.registerUriHandler(Fe.identifier,te)},createQuickPick(){return Nt.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Nt.createInputBox(Fe.identifier)},get activeColorTheme(){return jt.activeColorTheme},onDidChangeActiveColorTheme(te,de,Ae){return jt.onDidChangeActiveColorTheme(te,de,Ae)},registerWebviewViewProvider(te,de,Ae){return Sn.registerWebviewViewProvider(Fe,te,de,Ae==null?void 0:Ae.webviewOptions)},get activeNotebookEditor(){return(0,Q.checkProposedApiEnabled)(Fe),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeActiveNotebookEditor(te,de,Ae)},get visibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Fe),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookEditorSelection(te,de,Ae)},onDidChangeNotebookEditorVisibleRanges(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookEditorVisibleRanges(te,de,Ae)},showNotebookDocument(te,de){return(0,Q.checkProposedApiEnabled)(Fe),ft.showNotebookDocument(te,de)},registerExternalUriOpener(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),nn.registerExternalUriOpener(Fe.identifier,te,de,Ae)},get openEditors(){return(0,Q.checkProposedApiEnabled)(Fe),yt.tabs},get onDidChangeOpenEditors(){return(0,Q.checkProposedApiEnabled)(Fe),yt.onDidChangeTabs}},ln={get rootPath(){return Te.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(te){throw A.readonly()},getWorkspaceFolder(te){return Ze.getWorkspaceFolder(te)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(te){throw A.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(te){throw A.readonly()},updateWorkspaceFolders:(te,de,...Ae)=>Ze.updateWorkspaceFolders(Fe,te,de||0,...Ae),onDidChangeWorkspaceFolders:function(te,de,Ae){return Ze.onDidChangeWorkspace(te,de,Ae)},asRelativePath:(te,de)=>Ze.getRelativePath(te,de),findFiles:(te,de,Ae,st)=>Ze.findFiles(M.GlobPattern.from(te),M.GlobPattern.from(de),Ae,Fe.identifier,st),findTextInFiles:(te,de,Ae,st)=>{let z,x;return typeof de=="object"?(z=de,x=Ae):(z={},x=de,st=Ae),Ze.findTextInFiles(te,z||{},x,Fe.identifier,st)},saveAll:te=>Ze.saveAll(te),applyEdit(te){return rn.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,de,Ae,st)=>Tt.createFileSystemWatcher(M.GlobPattern.from(te),de,Ae,st),get textDocuments(){return bt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw A.readonly()},openTextDocument(te){let de;const Ae=te;if(typeof te=="string")de=Promise.resolve(P.URI.file(te));else if(P.URI.isUri(te))de=Promise.resolve(te);else if(!Ae||typeof Ae=="object")de=bt.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(st=>bt.ensureDocumentData(st).then(z=>z.document))},onDidOpenTextDocument:(te,de,Ae)=>bt.onDidAddDocument(te,de,Ae),onDidCloseTextDocument:(te,de,Ae)=>bt.onDidRemoveDocument(te,de,Ae),onDidChangeTextDocument:(te,de,Ae)=>bt.onDidChangeDocument(te,de,Ae),onDidSaveTextDocument:(te,de,Ae)=>bt.onDidSaveDocument(te,de,Ae),onWillSaveTextDocument:(te,de,Ae)=>Qt.getOnWillSaveTextDocumentEvent(Fe)(te,de,Ae),onDidChangeConfiguration:(te,de,Ae)=>an.onDidChangeConfiguration(te,de,Ae),getConfiguration(te,de){return de=arguments.length===1?void 0:de,an.getConfiguration(te,de,Fe)},registerTextDocumentContentProvider(te,de){return At.registerTextDocumentContentProvider(te,de)},registerTaskProvider:(te,de)=>(Te.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(Fe,te,de)),registerFileSystemProvider(te,de,Ae){return Jt.registerFileSystemProvider(Fe.identifier,te,de,Ae)},get fs(){return it.value},registerFileSearchProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),vt.registerFileSearchProvider(te,de)),registerTextSearchProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),vt.registerTextSearchProvider(te,de)),registerRemoteAuthorityResolver:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),at.registerRemoteAuthorityResolver(te,de)),registerResourceLabelFormatter:te=>((0,Q.checkProposedApiEnabled)(Fe),Zt.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,de,Ae)=>Tt.onDidCreateFile(te,de,Ae),onDidDeleteFiles:(te,de,Ae)=>Tt.onDidDeleteFile(te,de,Ae),onDidRenameFiles:(te,de,Ae)=>Tt.onDidRenameFile(te,de,Ae),onWillCreateFiles:(te,de,Ae)=>Tt.getOnWillCreateFileEvent(Fe)(te,de,Ae),onWillDeleteFiles:(te,de,Ae)=>Tt.getOnWillDeleteFileEvent(Fe)(te,de,Ae),onWillRenameFiles:(te,de,Ae)=>Tt.getOnWillRenameFileEvent(Fe)(te,de,Ae),openTunnel:te=>((0,Q.checkProposedApiEnabled)(Fe),Ne.openTunnel(Fe,te).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Q.checkProposedApiEnabled)(Fe),Ne.getTunnels()},onDidChangeTunnels:(te,de,Ae)=>((0,Q.checkProposedApiEnabled)(Fe),Ne.onDidChangeTunnels(te,de,Ae)),registerPortAttributesProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),Ne.registerPortsAttributesProvider(te,de)),registerTimelineProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),En.registerTimelineProvider(te,de,Fe.identifier,Ge.converter)),get isTrusted(){return(0,Q.checkProposedApiEnabled)(Fe),Ze.trusted},requestWorkspaceTrust:te=>((0,Q.checkProposedApiEnabled)(Fe),Ze.requestWorkspaceTrust(te)),onDidReceiveWorkspaceTrust:(te,de,Ae)=>Ze.onDidReceiveWorkspaceTrust(te,de,Ae)},wn={get inputBox(){return Te.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),fn.getLastInputBox(Fe)},createSourceControl(te,de,Ae){return fn.createSourceControl(Fe,te,de,Ae)}},xt={createCommentController(te,de){return _n.createCommentController(Fe,te,de)}},Gt={get activeDebugSession(){return ot.activeDebugSession},get activeDebugConsole(){return ot.activeDebugConsole},get breakpoints(){return ot.breakpoints},onDidStartDebugSession(te,de,Ae){return ot.onDidStartDebugSession(te,de,Ae)},onDidTerminateDebugSession(te,de,Ae){return ot.onDidTerminateDebugSession(te,de,Ae)},onDidChangeActiveDebugSession(te,de,Ae){return ot.onDidChangeActiveDebugSession(te,de,Ae)},onDidReceiveDebugSessionCustomEvent(te,de,Ae){return ot.onDidReceiveDebugSessionCustomEvent(te,de,Ae)},onDidChangeBreakpoints(te,de,Ae){return ot.onDidChangeBreakpoints(te,de,Ae)},registerDebugConfigurationProvider(te,de,Ae){return ot.registerDebugConfigurationProvider(te,de,Ae||F.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,de){return ot.registerDebugAdapterDescriptorFactory(Fe,te,de)},registerDebugAdapterTrackerFactory(te,de){return ot.registerDebugAdapterTrackerFactory(te,de)},startDebugging(te,de,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?ot.startDebugging(te,de,{parentSession:Ae}):ot.startDebugging(te,de,Ae||{})},stopDebugging(te){return ot.stopDebugging(te)},addBreakpoints(te){return ot.addBreakpoints(te)},removeBreakpoints(te){return ot.removeBreakpoints(te)},asDebugSourceUri(te,de){return ot.asDebugSourceUri(te,de)}},Tn={registerTaskProvider:(te,de)=>pt.registerTaskProvider(Fe,te,de),fetchTasks:te=>pt.fetchTasks(te),executeTask:te=>pt.executeTask(Fe,te),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(te,de,Ae)=>pt.onDidStartTask(te,de,Ae),onDidEndTask:(te,de,Ae)=>pt.onDidEndTask(te,de,Ae),onDidStartTaskProcess:(te,de,Ae)=>pt.onDidStartTaskProcess(te,de,Ae),onDidEndTaskProcess:(te,de,Ae)=>pt.onDidEndTaskProcess(te,de,Ae)},cn={openNotebookDocument:te=>((0,Q.checkProposedApiEnabled)(Fe),ft.openNotebookDocument(te)),get onDidOpenNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidSaveNotebookDocument},get notebookDocuments(){return(0,Q.checkProposedApiEnabled)(Fe),ft.notebookDocuments.map(te=>te.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeActiveNotebookKernel},registerNotebookSerializer(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.registerNotebookSerializer(Fe,te,de,Ae)},registerNotebookContentProvider:(te,de,Ae)=>((0,Q.checkProposedApiEnabled)(Fe),ft.registerNotebookContentProvider(Fe,te,de,Ae)),registerNotebookKernelProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),ft.registerNotebookKernelProvider(Fe,te,de)),registerNotebookCellStatusBarItemProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),ft.registerNotebookCellStatusBarItemProvider(Fe,te,de)),createNotebookEditorDecorationType(te){return(0,Q.checkProposedApiEnabled)(Fe),ft.createNotebookEditorDecorationType(te)},onDidChangeNotebookDocumentMetadata(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookDocumentMetadata(te,de,Ae)},onDidChangeNotebookCells(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookCells(te,de,Ae)},onDidChangeCellExecutionState(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookCellExecutionState(te,de,Ae)},onDidChangeCellOutputs(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeCellOutputs(te,de,Ae)},onDidChangeCellMetadata(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeCellMetadata(te,de,Ae)},createConcatTextDocument(te,de){return(0,Q.checkProposedApiEnabled)(Fe),new X.ExtHostNotebookConcatDocument(ft,bt,te,de)},createNotebookCellExecutionTask(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.createNotebookCellExecution(te,de,Ae)},createNotebookController(te,de,Ae,st,z){return(0,Q.checkProposedApiEnabled)(Fe),Xt.createNotebookController(Fe,te,de,Ae,st,z)}};return{version:He.version,authentication:Dn,commands:Cn,comments:xt,debug:Gt,env:Kt,extensions:Pn,languages:In,notebook:cn,scm:wn,tasks:Tn,test:kn,window:An,workspace:ln,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:k.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:F.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,EventEmitter:I.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:m.FileType,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,Hover:F.Hover,IndentAction:T.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:i.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,UIKind:f.UIKind,Uri:P.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,InlineHint:F.InlineHint,InlineHintKind:F.InlineHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,RemoteTrustOption:Se.RemoteTrustOption,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookDocumentMetadata:F.NotebookDocumentMetadata,NotebookCellMetadata:F.NotebookCellMetadata,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,LinkedEditingRanges:F.LinkedEditingRanges,TestItemStatus:F.TestItemStatus,TestResultState:F.TestResultState,TestMessage:F.TestMessage,TestMessageSeverity:F.TestMessageSeverity,WorkspaceTrustState:F.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=qe}),define(me[270],ge([0,1,79,65,32,125,35,51,39,34,67,46,69,92,91,50,64,126,90,61,89,118]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d,E,w,b,p,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(f.IExtensionStoragePaths,f.ExtensionStoragePaths),(0,_.registerSingleton)(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService),(0,_.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,_.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,_.registerSingleton)(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),(0,_.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,_.registerSingleton)(I.IExtHostDecorations,I.ExtHostDecorations),(0,_.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,_.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo),(0,_.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService),(0,_.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch),(0,_.registerSingleton)(a.IExtHostStorage,a.ExtHostStorage),(0,_.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask),(0,_.registerSingleton)(i.IExtHostTerminalService,i.WorkerExtHostTerminalService),(0,_.registerSingleton)(d.IExtHostTunnelService,d.ExtHostTunnelService),(0,_.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,_.registerSingleton)(A.IExtHostWorkspace,A.ExtHostWorkspace),(0,_.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,_.registerSingleton)(g.IExtHostTelemetry,g.ExtHostTelemetry)}),define(me[93],ge([0,1,15,13,31,127]),function(G,e,_,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=y;function P(C,m,f,a){const d=(0,_.mapArrayOrNot)(f,D),E=new A.TextSearchMatch(m,d,a),w=E.preview.matches;return{ranges:(0,_.mapArrayOrNot)(d,i),uri:C,preview:{text:E.preview.text,matches:(0,_.mapArrayOrNot)(w,i)}}}e.createTextSearchResult=P;function D(C){return new A.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function i(C){return new I.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let T=class{constructor(m,f){this.prefix=m,this.logService=f}appendLine(m){this.logService.debug(`${this.prefix}#search`,m)}};T=je([Be(1,k.ILogService)],T),e.OutputChannel=T}),define(me[271],ge([0,1,94,22]),function(G,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function A(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===t)}e.isUTFEncoding=A,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const I=512,y=512,P=512*8,D=512*128;class i{constructor(n){this.iconvLiteDecoder=n}static async create(n){let s;if(n!==e.UTF8)s=(await new Promise((o,l)=>{G(["iconv-lite-umd"],o,l)})).getDecoder(f(n));else{const r=new TextDecoder;s={write(o){return r.decode(o,{stream:!0})},end(){return r.decode()}}}return new i(s)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function T(t,n){var s;const r=((s=n.minBytesRequiredForDetection)!==null&&s!==void 0?s:n.guessEncoding)?P:y;return new Promise((o,l)=>{const h=(0,_.newWriteableStream)(L=>L.join("")),S=[];let u=0,v;const R=async()=>{try{const L=await g({buffer:k.VSBuffer.concat(S),bytesRead:u},n.guessEncoding);L.encoding=await n.overwriteEncoding(L.encoding),v=await i.create(L.encoding);const H=v.write(k.VSBuffer.concat(S).buffer);h.write(H),S.length=0,u=0,o({stream:h,detected:L})}catch(L){l(L)}};(0,_.listenStream)(t,{onData:async L=>{v?h.write(v.write(L.buffer)):(S.push(L),u+=L.byteLength,u>=r&&(t.pause(),await R(),setTimeout(()=>t.resume())))},onError:L=>h.error(L),onEnd:async()=>{v||await R(),h.end(v==null?void 0:v.end())}})})}e.toDecodeStream=T;async function C(t,n,s){const o=(await new Promise((S,u)=>{G(["iconv-lite-umd"],S,u)})).getEncoder(f(n),s);let l=!1,h=!1;return{read(){if(h)return null;const S=t.read();if(typeof S!="string"){if(h=!0,!l&&(s==null?void 0:s.addBOM))switch(n){case e.UTF8:case e.UTF8_with_bom:return k.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return k.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return k.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const u=o.end();return u&&u.length>0?(l=!0,k.VSBuffer.wrap(u)):null}return l=!0,k.VSBuffer.wrap(o.write(S))}}}e.toEncodeReadable=C;async function m(t){return(await new Promise((s,r)=>{G(["iconv-lite-umd"],s,r)})).encodingExists(f(t))}e.encodingExists=m;function f(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=f;function a(t,n){if(!t||n<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),r=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&r===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&r===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const o=t.readUInt8(2);return s===e.UTF8_BOM[0]&&r===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=a;const d=["ascii","utf-16","utf-32"];async function E(t){const n=await new Promise((h,S)=>{G(["jschardet"],h,S)}),s=t.slice(0,D),r=p(s.buffer),o=n.detect(r);if(!o||!o.encoding)return null;const l=o.encoding.toLowerCase();return 0<=d.indexOf(l)?null:b(o.encoding)}const w={ibm866:"cp866",big5:"cp950"};function b(t){const n=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[n]||n}function p(t){let n="";for(let s=0;s<t.length;s++)n+=String.fromCharCode(t[s]);return n}function c(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const n=t.match(/windows(\d+)/);return n?"windows-"+n[1]:t}}e.toCanonicalName=c;function g({buffer:t,bytesRead:n},s){let r=a(t,n),o=!1;if(r!==e.UTF16be&&r!==e.UTF16le&&t){let l=!0,h=!0,S=!1;for(let u=0;u<n&&u<I;u++){const v=u%2==1,R=t.readUInt8(u)===0;if(R&&(S=!0),l&&(v&&!R||!v&&R)&&(l=!1),h&&(v&&R||!v&&!R)&&(h=!1),R&&!l&&!h)break}S&&(l?r=e.UTF16le:h?r=e.UTF16be:o=!0)}return s&&!o&&!r&&t?E(t.slice(0,n)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:o,encoding:r}}e.detectEncodingFromBuffer=g,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[129],ge([0,1,271,26,128]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class I extends A.TextSearchManager{constructor(P,D,i=k){super(P,D,{readdir:T=>i.readdir(T.fsPath),toCanonicalName:T=>(0,_.toCanonicalName)(T)})}}e.NativeTextSearchManager=I}),define(me[272],ge([0,1,273,287,288,2,289]),function(G,e,_,k,A,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(C,m,f,a,d,E){const w=E.environment.useHostProxy,b=typeof w=="boolean"?w:!E.remote.isRemote,p=(0,y.createProxyResolver)({resolveProxy:g=>C.resolveProxy(g),getHttpProxySetting:()=>m.getConfiguration("http").get("proxy"),log:(g,t,...n)=>{switch(g){case y.LogLevel.Trace:a.trace(t,...n);break;case y.LogLevel.Debug:a.debug(t,...n);break;case y.LogLevel.Info:a.info(t,...n);break;case y.LogLevel.Warning:a.warn(t,...n);break;case y.LogLevel.Error:a.error(t,...n);break;case y.LogLevel.Critical:a.critical(t,...n);break;case y.LogLevel.Off:break;default:s(g,t,n);break}function s(r,o,...l){a.error("Unknown log level",r),a.error(o,...l)}},getLogLevel:()=>a.getLevel(),proxyResolveTelemetry:g=>{d.$publicLog2("resolveProxy",g)},useHostProxy:b,env:process.env}),c=D(m,p);return T(f,c)}e.connectProxyResolver=P;function D(C,m){const f={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(d=>{f.config=C.getConfiguration("http").get("proxySupport")||"off"});const a={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(d=>{a.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},_,(0,y.createHttpPatch)(_,m,{config:"off"},a,!0)),on:Object.assign({},_,(0,y.createHttpPatch)(_,m,{config:"on"},a,!0)),override:Object.assign({},_,(0,y.createHttpPatch)(_,m,{config:"override"},a,!0)),onRequest:Object.assign({},_,(0,y.createHttpPatch)(_,m,f,a,!0)),default:Object.assign(_,(0,y.createHttpPatch)(_,m,f,a,!1))},https:{off:Object.assign({},k,(0,y.createHttpPatch)(k,m,{config:"off"},a,!0)),on:Object.assign({},k,(0,y.createHttpPatch)(k,m,{config:"on"},a,!0)),override:Object.assign({},k,(0,y.createHttpPatch)(k,m,{config:"override"},a,!0)),onRequest:Object.assign({},k,(0,y.createHttpPatch)(k,m,f,a,!0)),default:Object.assign(k,(0,y.createHttpPatch)(k,m,f,a,!1))},tls:Object.assign(A,(0,y.createTlsPatch)(A))}}const i=new Map;function T(C,m){return C.getExtensionPathIndex().then(f=>{const a=G.__$__nodeRequire("module"),d=a._load;a._load=function(w,b,p){if(w==="tls")return m.tls;if(w!=="http"&&w!=="https")return d.apply(this,arguments);const c=m[w],g=f.findSubstr(I.URI.file(b.filename).fsPath);let t=i.get(g);if(t||i.set(g,t={}),!t[w]){let n=c.default;g&&g.enableProposedApi&&(n=c[g.proxySupport]||c.onRequest),t[w]=Object.assign({},n)}return t[w]}})}}),define(me[274],ge([0,1,38,8,75,30,9,10,93,275]),function(G,e,_,k,A,I,y,P,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const T=i.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(p,c,g,t){const n=m(p,c,g,t),s=c.folder.fsPath;return{cmd:_.spawn(T,n.args,{cwd:s}),rgDiskPath:T,siblingClauses:n.siblingClauses,rgArgs:n,cwd:s}}e.spawnRipgrepCmd=C;function m(p,c,g,t){const n=["--files","--hidden","--case-sensitive"];a([c],g,!1).forEach(r=>{const o=(0,D.anchorGlob)(r);if(n.push("-g",o),y.isMacintosh){const l=(0,A.normalizeNFD)(o);l!==o&&n.push("-g",l)}});const s=f([c],t,void 0,!1);return s.globArgs.forEach(r=>{const o=`!${(0,D.anchorGlob)(r)}`;if(n.push("-g",o),y.isMacintosh){const l=(0,A.normalizeNFD)(o);l!==o&&n.push("-g",l)}}),c.disregardIgnoreFiles!==!1?n.push("--no-ignore"):n.push("--no-ignore-parent"),c.ignoreSymlinks||n.push("--follow"),p.exists&&n.push("--quiet"),n.push("--no-config"),c.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:s.siblingClauses}}function f(p,c,g,t=!0){const n=[];let s={};return p.forEach(r=>{const o=Object.assign({},r.excludePattern||{},c||{}),l=d(o,t?r.folder.fsPath:void 0,g);n.push(...l.globArgs),l.siblingClauses&&(s=Object.assign(s,l.siblingClauses))}),{globArgs:n,siblingClauses:s}}e.foldersToRgExcludeGlobs=f;function a(p,c,g=!0){const t=[];return p.forEach(n=>{const s=Object.assign({},c||{},n.includePattern||{}),r=d(s,g?n.folder.fsPath:void 0);t.push(...r.globArgs)}),t}e.foldersToIncludeGlobs=a;function d(p,c,g){const t=[],n={};return Object.keys(p).forEach(s=>{if(!(g&&g.has(s))&&!!s){const r=p[s];s=w(c?E(c,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof r=="boolean"&&r?(s.startsWith("\\\\")&&(s+="**"),t.push(b(s))):r&&r.when&&(n[s]=r)}}),{globArgs:t,siblingClauses:n}}function E(p,c){return k.isAbsolute(c)?c:k.join(p,c)}e.getAbsoluteGlob=E;function w(p){return p=P.rtrim(p,"\\"),P.rtrim(p,"/")}function b(p){return I.getRoot(p).toLowerCase()==="c:/"?p.replace(/^c:[/\\]/i,"/"):p}e.fixDriveC=b}),define(me[276],ge([0,1,38,37,8,101,15,59,33,75,30,9,47,10,12,26,31,274,99]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d,E,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const p=new Set;process.on("exit",()=>{p.forEach(s=>s())});class c{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&D.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&D.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(o=>{const l=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),h=o.folder.fsPath;r.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==h).forEach(S=>{(0,T.isEqualOrParent)(S,h)&&(l[A.relative(h,S)]=!0)}),this.folderExcludePatterns.set(h,new t(l,h))})}cancel(){this.isCanceled=!0}walk(r,o,l,h,S){if(this.fileWalkSW=m.StopWatch.create(!1),this.isCanceled)return S(null,this.isLimitHit);o.forEach(u=>{const v=A.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,v)||this.matchFile(l,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=m.StopWatch.create(!1),this.parallel(r,(u,v)=>{this.call(this.cmdTraversal,this,u,l,h,R=>{if(R){const L=(0,P.toErrorMessage)(R);console.error(L),this.errors.push(L),v(R,void 0)}else v(null,void 0)})},(u,v)=>{this.fileWalkSW.stop();const R=u?y.coalesce(u)[0]:null;S(R,this.isLimitHit)})}parallel(r,o,l){const h=new Array(r.length),S=new Array(r.length);let u=!1,v=0;if(r.length===0)return l(null,[]);r.forEach((R,L)=>{o(R,(H,ie)=>{if(H?(u=!0,h[L]=null,S[L]=H):(h[L]=ie,S[L]=null),++v===r.length)return l(u?S:null,h)})})}call(r,o,...l){try{r.apply(o,l)}catch(h){l[l.length-1](h)}}cmdTraversal(r,o,l,h){const S=r.folder.fsPath,u=C.isMacintosh;let v;const R=()=>v&&v.kill();p.add(R);let L=M=>{p.delete(R),L=()=>{},h(M)},H="";const ie=this.initDirectoryTree();let j;const B=(0,w.spawnRipgrepCmd)(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression);v=B.cmd,j=!Object.keys(B.siblingClauses).length;const $=B.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let N=`${B.rgDiskPath} ${$}
 - cwd: ${B.cwd}`;B.rgArgs.siblingClauses&&(N+=`
 - Sibling clauses: ${JSON.stringify(B.rgArgs.siblingClauses)}`),l({message:N}),this.cmdResultCount=0,this.collectStdout(v,"utf8",l,(M,F,U)=>{if(M){L(M);return}if(this.isLimitHit){L();return}const W=(H+(u?i.normalizeNFC(F||""):F)).split(`
`);if(U){const q=W.length;W[q-1]=W[q-1].trim(),W[q-1]||W.pop()}else H=W.pop()||"";if(W.length&&W[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=W.length,j){for(const q of W)if(this.matchFile(o,{base:S,relativePath:q,searchPath:this.getSearchPath(r,q)}),this.isLimitHit){R();break}(U||this.isLimitHit)&&L();return}this.addDirectoryEntries(r,ie,S,W,o),U&&(this.matchDirectoryTree(ie,S,o),L())})}spawnFindCmd(r){const o=this.folderExcludePatterns.get(r.folder.fsPath),l=o.getBasenameTerms(),h=o.getPathTerms(),S=["-L","."];if(l.length||h.length){S.push("-not","(","(");for(const u of l)S.push("-name",u),S.push("-o");for(const u of h)S.push("-path",u),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),_.spawn("find",S,{cwd:r.folder.fsPath})}readStdout(r,o,l){let h="";this.collectStdout(r,o,()=>{},(S,u,v)=>{if(S){l(S);return}h+=u,v&&l(null,h)})}collectStdout(r,o,l,h){let S=(R,L,H)=>{(R||H)&&(S=()=>{},this.cmdSW&&this.cmdSW.stop()),h(R,L,H)},u=!1;r.stdout?(this.forwardData(r.stdout,o,S),r.stdout.once("data",()=>u=!0)):l({message:"stdout is null"});let v;r.stderr?v=this.collectData(r.stderr):l({message:"stderr is null"}),r.on("error",R=>{S(R)}),r.on("close",R=>{let L;!u&&(L=this.decodeData(v,o))&&n(L)?S(new Error(`command failed with error code ${R}: ${this.decodeData(v,o)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),S(null,"",!0))})}forwardData(r,o,l){const h=new I.StringDecoder(o);return r.on("data",S=>{l(null,h.write(S))}),h}collectData(r){const o=[];return r.on("data",l=>{o.push(l)}),o}decodeData(r,o){const l=new I.StringDecoder(o);return r.map(h=>l.write(h)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:o},l,h,S){h.indexOf(this.filePattern)!==-1&&this.matchFile(S,{base:l,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const u=v=>{const R=A.basename(v),L=A.dirname(v);let H=o[L];H||(H=o[L]=[],u(L)),H.push({base:l,relativePath:v,basename:R,searchPath:this.getSearchPath(r,v)})};h.forEach(u)}matchDirectoryTree({rootEntries:r,pathToEntries:o},l,h){const S=this,u=this.folderExcludePatterns.get(l),v=this.filePattern;function R(L){S.directoriesWalked++;const H=D.hasSiblingFn(()=>L.map(ie=>ie.basename));for(let ie=0,j=L.length;ie<j;ie++){const B=L[ie],{relativePath:$,basename:N}=B;if(!u.test($,N,v!==N?H:void 0)){const M=o[$];if(M)R(M);else{if(S.filesWalked++,$===v)continue;S.matchFile(h,B)}if(S.isLimitHit)break}}}R(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,o,l,h,S){const u=r.folder,v=D.hasSiblingFn(()=>l);this.parallel(l,(R,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const H=o?[o,R].join(A.sep):R;if(this.folderExcludePatterns.get(r.folder.fsPath).test(H,R,this.config.filePattern!==R?v:void 0))return L(null);const ie=[u.fsPath,H].join(A.sep);k.lstat(ie,(j,B)=>{if(j||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(ie,B,($,N)=>$||this.isCanceled||this.isLimitHit?L(null):N.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(ie,B,(M,F)=>M||this.isCanceled||this.isLimitHit||(F=F||"",this.walkedPaths[F])?L(null):(this.walkedPaths[F]=!0,(0,d.readdir)(ie).then(U=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(r,H,U,h,O=>L(O||null))},U=>{L(null)})))):(this.filesWalked++,H===this.filePattern||this.maxFilesize&&a.isNumber(N.size)&&N.size>this.maxFilesize||this.matchFile(h,{base:u.fsPath,relativePath:H,searchPath:this.getSearchPath(r,H)}),L(null,void 0)))})},R=>{const L=R&&y.coalesce(R);return S(L&&L.length>0?L[0]:void 0)})}matchFile(r,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,A.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(o))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,o,l){return o.isSymbolicLink()?k.stat(r,l):l(null,o)}realPathIfNeeded(r,o,l){return o.isSymbolicLink()?k.realpath(r,(h,S)=>h?l(h):l(null,S)):l(null,r)}getSearchPath(r,o){return r.folderName?A.join(r.folderName,o):o}}e.FileWalker=c;class g{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new c(r)}search(r,o,l){this.walker.walk(this.folderQueries,this.extraFiles,r,o,(h,S)=>{l(h,{limitHit:S,stats:this.walker.getStats()})})}cancel(){this.walker.cancel()}}e.Engine=g;class t{constructor(r,o){this.expression=r,this.root=o,this.init(r)}init(r){let o,l;Object.keys(r).filter(h=>r[h]).forEach(h=>{A.isAbsolute(h)?(o=o||D.getEmptyExpression(),o[h]=r[h]):(l=l||D.getEmptyExpression(),l[h]=r[h])}),this.absoluteParsedExpr=o&&D.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=l&&D.parse(l,{trimForExclusions:!0})}test(r,o,l){return this.relativeParsedExpr&&this.relativeParsedExpr(r,o,l)||this.absoluteParsedExpr&&this.absoluteParsedExpr(A.join(this.root,r),o,l)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getPathTerms(this.relativeParsedExpr)),r}}function n(s){const r=s.trim().split(`
`),o=r[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return f.uppercaseFirstLetter(r[r.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=n}),define(me[130],ge([0,1,38,290,101,15,53,33,8,10,2,31,127,291,275,93]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=a.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(u){this.outputChannel=u}provideTextSearchResults(u,v,R,L){return this.outputChannel.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify(Object.assign(Object.assign({},v),{folder:v.folder.toString()}))}`),new Promise((H,ie)=>{L.onCancellationRequested(()=>O());const j=n(u,v),B=v.folder.fsPath,$=j.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.outputChannel.appendLine(`${E} ${$}
 - cwd: ${B}`);let N=_.spawn(E,j,{cwd:B});N.on("error",ve=>{console.error(ve),this.outputChannel.appendLine("Error: "+(ve&&ve.message)),ie((0,C.serializeSearchError)(new C.SearchError(ve&&ve.message,C.SearchErrorCode.rgProcessError)))});let M=!1;const F=new c(v.maxResults,B,v.previewOptions);F.on("result",ve=>{M=!0,q="",R.report(ve)});let U=!1;const O=()=>{U=!0,N&&N.kill(),F&&F.cancel()};let W=!1;F.on("hitLimit",()=>{W=!0,O()});let q="";N.stdout.on("data",ve=>{F.handleData(ve),M||(q+=ve)});let Q=!1;N.stdout.once("data",()=>Q=!0);let he="";N.stderr.on("data",ve=>{const Ie=ve.toString();this.outputChannel.appendLine(Ie),he+=Ie}),N.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(M?"Got result from parser":"No result from parser"),q&&this.outputChannel.appendLine(`Got data without result: ${q}`),this.outputChannel.appendLine(""),U)H({limitHit:W});else{F.flush(),N=null;let ve;he&&!Q&&(ve=b(he))?ie((0,C.serializeSearchError)(new C.SearchError(ve.message,ve.code))):H({limitHit:W})}})})}}e.RipgrepTextSearchEngine=w;function b(S){const u=S.split(`
`),v=u[0].trim();if(u.some(L=>L.startsWith("regex parse error")))return new C.SearchError(p(u),C.SearchErrorCode.regexParseError);const R=v.match(/grep config error: unknown encoding: (.*)/);if(R)return new C.SearchError(`Unknown encoding: ${R[1]}`,C.SearchErrorCode.unknownEncoding);if(v.startsWith("error parsing glob"))return new C.SearchError(v.charAt(0).toUpperCase()+v.substr(1),C.SearchErrorCode.globParseError);if(v.startsWith("the literal"))return new C.SearchError(v.charAt(0).toUpperCase()+v.substr(1),C.SearchErrorCode.invalidLiteral);if(v.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(v,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function p(S){const u=["Regex parse error"],v=S.filter(R=>R.startsWith("PCRE2:"));if(v.length>=1){const R=v[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const L=R.split(":")[1];u.push(":"+L)}}return u.join("")}e.buildRegexParseError=p;class c extends k.EventEmitter{constructor(u,v,R){super();this.maxResults=u,this.rootFolder=v,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new A.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(u,v){return super.on(u,v),this}handleData(u){if(!this.isDone){const v=typeof u=="string"?u:this.stringDecoder.write(u);this.handleDecodedData(v)}}handleDecodedData(u){let v=u.indexOf(`
`);const R=this.remainder+u;if(v>=0)v+=this.remainder.length;else{this.remainder=R;return}let L=0;for(;v>=0;)this.handleLine(R.substring(L,v).trim()),L=v+1,v=R.indexOf(`
`,L);this.remainder=R.substring(L)}handleLine(u){if(!(this.isDone||!u)){let v;try{v=JSON.parse(u)}catch(R){throw new Error(`malformed line from rg: ${u}`)}if(v.type==="match"){const R=g(v.data.path),L=T.URI.file(D.join(this.rootFolder,R)),H=this.createTextSearchMatch(v.data,L);this.onResult(H),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(v.type==="context"){const R=g(v.data.path),L=T.URI.file(D.join(this.rootFolder,R));this.createTextSearchContext(v.data,L).forEach(ie=>this.onResult(ie))}}}createTextSearchMatch(u,v){const R=u.line_number-1;let L=!1,H=g(u.lines);R===0&&(0,i.startsWithUTF8BOM)(H)&&(L=!0,H=(0,i.stripUTF8BOM)(H));const ie=Buffer.from(H);let j=0,B=0,$=R;u.submatches.length===0&&u.submatches.push(H.length?{start:0,end:1,match:{text:H[0]}}:{start:0,end:0,match:{text:""}});const N=(0,I.coalesce)(u.submatches.map((M,F)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let U=g(M.match);R===0&&F===0&&L&&(U=(0,i.stripUTF8BOM)(U),M.start=M.start<=3?0:M.start-3,M.end=M.end<=3?0:M.end-3);const O=ie.slice(j,M.start).toString().length,W=B+O,q=t(U),Q=$,he=q.numLines+Q,ve=q.numLines>0?q.lastLineLength:q.lastLineLength+W;return j=M.end,B=ve,$=he,new m.Range(Q,W,he,ve)}));return(0,d.createTextSearchResult)(v,H,N,this.previewOptions)}createTextSearchContext(u,v){const R=g(u.lines),L=u.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((H,ie)=>({text:H,uri:v,lineNumber:L+ie}))}onResult(u){this.emit("result",u)}}e.RipgrepParser=c;function g(S){return S.bytes?Buffer.from(S.bytes,"base64").toString():S.text}function t(S){const u=/\n/g;let v=0,R=-1,L;for(;L=u.exec(S);)v++,R=L.index;const H=R>=0?S.length-R-1:S.length;return{numLines:v,lastLineLength:H}}function n(S,u){const v=["--hidden"];v.push(S.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:L}=(0,y.groupBy)(u.includes,ie=>ie.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const ie=new Set;L.forEach(j=>{ie.add(j)}),v.push("-g","!*"),ie.forEach(j=>{s(j).map(d.anchorGlob).forEach(B=>{v.push("-g",B)})})}R&&R.length&&R.forEach(ie=>{v.push("-g",ie)}),u.excludes.map(d.anchorGlob).forEach(ie=>v.push("-g",`!${ie}`)),u.maxFileSize&&v.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?v.push("--no-ignore-parent"):v.push("--no-ignore"),u.followSymlinks&&v.push("--follow"),u.encoding&&u.encoding!=="utf8"&&v.push("--encoding",u.encoding),S.pattern==="--"&&(S.isRegExp=!0,S.pattern="\\-\\-"),S.isMultiline&&!S.isRegExp&&(S.pattern=(0,i.escapeRegExpCharacters)(S.pattern),S.isRegExp=!0),u.usePCRE2&&v.push("--pcre2"),v.push("--crlf"),S.isRegExp&&(S.pattern=r(S.pattern),v.push("--auto-hybrid-regex"));let H;if(S.isWordMatch){const j=(0,i.createRegExp)(S.pattern,!!S.isRegExp,{wholeWord:S.isWordMatch}).source.replace(/\\\//g,"/");v.push("--regexp",j)}else if(S.isRegExp){let ie=l(S.pattern);ie=h(ie),v.push("--regexp",ie)}else H=S.pattern,v.push("--fixed-strings");return v.push("--no-config"),u.useGlobalIgnoreFiles||v.push("--no-ignore-global"),v.push("--json"),S.isMultiline&&v.push("--multiline"),u.beforeContext&&v.push("--before-context",u.beforeContext+""),u.afterContext&&v.push("--after-context",u.afterContext+""),v.push("--"),H&&v.push(H),v.push("."),v}function s(S){const u=(0,P.splitGlobAware)(S,"/");return u.map((v,R)=>u.slice(0,R+1).join("/"))}e.spreadGlobComponents=s;function r(S){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;S.match(u);)S=S.replace(u,"$1\\x{$2}");const v=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;S.match(v);)S=S.replace(v,"$1\\x{$2}");return S}e.unicodeEscapesToPCRE2=r;const o=S=>S.type==="Assertion"&&S.kind==="lookbehind";function l(S){let u;try{u=new f.RegExpParser().parsePattern(S)}catch(j){return S}let v="",R=0;const L=(j,B,$)=>{v+=S.slice(R,j)+$,R=B},H=[];return new f.RegExpVisitor({onCharacterEnter(j){if(j.raw==="\\n"){const B=H[0];if(!B)L(j.start,j.end,"\\r?\\n");else if(!H.some(o))if(B.type==="CharacterClass"){const $=S.slice(B.start+1,j.start)+S.slice(j.end,B.end-1);L(B.start,B.end,$===""?"\\r?\\n":`(?:[${$}]|\\r?\\n)`)}else B.type==="Quantifier"&&L(j.start,j.end,"(?:\\r?\\n)")}},onQuantifierEnter(j){H.unshift(j)},onQuantifierLeave(){H.shift()},onCharacterClassRangeEnter(j){H.unshift(j)},onCharacterClassRangeLeave(){H.shift()},onCharacterClassEnter(j){H.unshift(j)},onCharacterClassLeave(){H.shift()},onAssertionEnter(j){o(j)&&H.push(j)},onAssertionLeave(j){H[0]===j&&H.shift()}}).visit(u),v+=S.slice(R),v}e.fixRegexNewline=l;function h(S){return S.replace(/\n/g,"\\r?\\n")}e.fixNewline=h}),define(me[277],ge([0,1,21,130,114,11]),function(G,e,_,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(i){this.outputChannel=i,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(i,T,C,m){const f=new k.RipgrepTextSearchEngine(this.outputChannel);if(T.folder.scheme===I.Schemas.userData){const a=Object.assign(Object.assign({},T),{folder:T.folder.with({scheme:I.Schemas.file})}),d=new A.Progress(E=>C.report(Object.assign(Object.assign({},E),{uri:E.uri.with({scheme:T.folder.scheme})})));return this.withToken(m,E=>f.provideTextSearchResults(i,a,d,E))}else return this.withToken(m,a=>f.provideTextSearchResults(i,T,C,a))}async withToken(i,T){const C=P(i);this.inProgress.add(C);const m=await T(C.token);return this.inProgress.delete(C),m}dispose(){this.inProgress.forEach(i=>i.cancel())}}e.RipgrepSearchProvider=y;function P(D){const i=new _.CancellationTokenSource;return D.onCancellationRequested(()=>i.cancel()),i}}),define(me[278],ge([0,1,26,130,129]),function(G,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class I{constructor(D){this.query=D}search(D,i,T){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(f){T({message:f})}},m=new A.NativeTextSearchManager(this.query,new k.RipgrepTextSearchEngine(C),_);return new Promise((f,a)=>m.search(d=>{i(d.map(y))},D).then(d=>f({limitHit:d.limitHit,type:"success"}),a))}}e.TextSearchEngineAdapter=I;function y(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((D,i)=>{if(i.ranges){const T=i;return D+(Array.isArray(T.ranges)?T.ranges.length:1)}else return D+1},0)}}}),define(me[279],ge([0,1,37,292,15,19,18,3,99,8,47,2,45,31,276,278]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,k.gracefulify(_);class E{constructor(){this.caches=Object.create(null)}fileSearch(t){let n;const s=p(t),r=new P.Emitter({onFirstListenerDidAdd:()=>{n=(0,I.createCancelablePromise)(o=>this.doFileSearchWithEngine(a.Engine,s,l=>r.fire(l),o)),n.then(o=>r.fire(o),o=>r.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}textSearch(t){let n;const s=p(t),r=new P.Emitter({onFirstListenerDidAdd:()=>{n=(0,I.createCancelablePromise)(o=>this.ripgrepTextSearch(s,l=>r.fire(l),o)),n.then(o=>r.fire(o),o=>r.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}ripgrepTextSearch(t,n,s){return t.maxFileSize=(0,m.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new d.TextSearchEngineAdapter(t).search(s,n,n)}doFileSearch(t,n,s){return this.doFileSearchWithEngine(a.Engine,t,n,s)}doFileSearchWithEngine(t,n,s,r,o=E.BATCH_SIZE){let l=0;const h=u=>{Array.isArray(u)?(l+=u.length,s(u.map(v=>this.rawMatchToSearchItem(v)))):u.relativePath?(l++,s(this.rawMatchToSearchItem(u))):s(u)};if(n.sortByScore){let u=this.trySortedSearchFromCache(n,h,r);if(!u){const v=n.maxResults?Object.assign({},n,{maxResults:null}):n,R=new t(v);u=this.doSortedSearch(R,n,s,h,r)}return new Promise((v,R)=>{u.then(([L,H])=>{const ie=H.map(j=>this.rawMatchToSearchItem(j));this.sendProgress(ie,s,o),v(L)},R)})}const S=new t(n);return this.doSearch(S,h,o,r).then(u=>({limitHit:u.limitHit,type:"success",stats:{detailStats:u.stats,type:"searchProcess",fromCache:!1,resultCount:l,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,i.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,s,r,o){const l=new P.Emitter;let h=(0,I.createCancelablePromise)(u=>{let v=[];const R=L=>{Array.isArray(L)?v=L:(r(L),l.fire(L))};return this.doSearch(t,R,-1,u).then(L=>[L,v])}),S;if(n.cacheKey){S=this.getOrCreateCache(n.cacheKey);const u={promise:h,event:l.event,resolved:!1};S.resultsToSearchCache[n.filePattern||""]=u,h.then(()=>{u.resolved=!0},v=>{delete S.resultsToSearchCache[n.filePattern||""]}),h=this.preventCancellation(h)}return h.then(([u,v])=>{const R=S?S.scorerCache:Object.create(null),L=(typeof n.maxResults!="number"||n.maxResults>0)&&T.StopWatch.create(!1);return this.sortResults(n,v,R,o).then(H=>{const ie=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:u.stats,sortingTime:ie,fromCache:!1,type:"searchProcess",workspaceFolderCount:n.folderQueries.length,resultCount:H.length},limitHit:u.limitHit||typeof n.maxResults=="number"&&v.length>n.maxResults},H]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new w)}trySortedSearchFromCache(t,n,s){const r=t.cacheKey&&this.caches[t.cacheKey];if(!!r){const o=this.getResultsFromCache(r,t.filePattern||"",n,s);if(o)return o.then(([l,h,S])=>{const u=T.StopWatch.create(!1);return this.sortResults(t,h,r.scorerCache,s).then(v=>{const R=u.elapsed(),L={fromCache:!0,detailStats:S,type:"searchProcess",resultCount:h.length,sortingTime:R};return[{type:"success",limitHit:l.limitHit||typeof t.maxResults=="number"&&h.length>t.maxResults,stats:L},v]})})}}sortResults(t,n,s,r){const o=(0,D.prepareQuery)(t.filePattern||""),l=(S,u)=>(0,D.compareItemsByFuzzyScore)(S,u,o,!0,b,s),h=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return A.topAsync(n,l,h,1e4,r)}sendProgress(t,n,s){if(s&&s>0)for(let r=0;r<t.length;r+=s)n(t.slice(r,r+s));else n(t)}getResultsFromCache(t,n,s,r){const o=T.StopWatch.create(!1),l=n.indexOf(i.sep)>=0;let h;for(const R in t.resultsToSearchCache)if(n.startsWith(R)){if(l&&R.indexOf(i.sep)<0&&R!=="")continue;const L=t.resultsToSearchCache[R];h={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!h)return null;const S=o.elapsed(),u=T.StopWatch.create(!1),v=h.event(s);return r&&r.onCancellationRequested(()=>{v.dispose()}),h.promise.then(([R,L])=>{if(r&&r.isCancellationRequested)throw(0,y.canceled)();const H=[],ie=(0,D.prepareQuery)(n).normalizedLowercase;for(const j of L)!(0,f.isFilePatternMatch)(j,ie)||H.push(j);return[R,H,{cacheWasResolved:h.resolved,cacheLookupTime:S,cacheFilterTime:u.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,n,s,r){return new Promise((o,l)=>{let h=[];r&&r.onCancellationRequested(()=>t.cancel()),t.search(S=>{S&&(s?(h.push(S),s>0&&h.length>=s&&(n(h),h=[])):n(S))},S=>{n(S)},(S,u)=>{h.length&&n(h),S?l(S):o(u)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,s){return t.then(n,s)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=E,E.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(g){return(0,i.basename)(g.relativePath)}getItemDescription(g){return(0,i.dirname)(g.relativePath)}getItemPath(g){return g.relativePath}};function p(g){return Object.assign(Object.assign({},g),{folderQueries:g.folderQueries&&g.folderQueries.map(c),extraFileResources:g.extraFileResources&&g.extraFileResources.map(t=>C.URI.revive(t))})}function c(g){return Object.assign(Object.assign({},g),{folder:C.URI.revive(g.folder)})}}),define(me[280],ge([0,1,6,2,26,13,31,279,277,93,14,62,27,69,11,129]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends f.ExtHostSearch{constructor(b,p,c,g){super(b,c,g);this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new i.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(a.Schemas.userData,new D.RipgrepSearchProvider(t)),p.remote.isRemote&&p.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const b=new i.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(a.Schemas.file,new D.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(a.Schemas.file,new P.SearchService)}registerInternalFileSearchProvider(b,p){const c=this._handlePool++;return this._internalFileSearchProvider=p,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(b)),(0,_.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(b,p,c,g){const t=(0,f.reviveQuery)(c);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,p,t,g):super.$provideFileSearchResults(b,p,c,g)}doInternalFileSearch(b,p,c,g){const t=n=>{if((0,y.isSerializedFileMatch)(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(b,p,n.map(s=>k.URI.file(s.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,t,g)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,p){return new d.NativeTextSearchManager(b,p)}};E=je([Be(0,T.IExtHostRpcService),Be(1,m.IExtHostInitDataService),Be(2,C.IURITransformerService),Be(3,I.ILogService)],E),e.NativeExtHostSearch=E}),define(me[131],ge([0,1,293,121,294,3,104,8,48,28,6,22,105,18,9]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(h){this.socket=h,this._errorListener=S=>{if(S){if(S.code==="EPIPE")return;(0,f.onUnexpectedError)(S)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(h){const S=u=>h(C.VSBuffer.wrap(u));return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(h){return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(h){return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(h){if(!this.socket.destroyed)try{this.socket.write(h.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,f.onUnexpectedError)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,f.onUnexpectedError)(S)}}end(){this.socket.end()}drain(){return new Promise((h,S)=>{if(this.socket.bufferSize===0){h();return}const u=()=>{this.socket.off("close",u),this.socket.off("end",u),this.socket.off("error",u),this.socket.off("timeout",u),this.socket.off("drain",u),h()};this.socket.on("close",u),this.socket.on("end",u),this.socket.on("error",u),this.socket.on("timeout",u),this.socket.on("drain",u)})}}e.NodeSocket=d;var E;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var w;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(w||(w={}));class b extends T.Disposable{constructor(h,S,u,v){super();this._onDidZlibFlush=this._register(new I.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=h,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=S,this._recordInflateBytes=v,S?(this._zlibInflate=A.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",R=>{console.error(R),(0,f.onUnexpectedError)(R),this._onClose.fire()}),this._zlibInflate.on("data",R=>{this._pendingInflateData.push(R)}),u&&(this._zlibInflate.write(u.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=A.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",R=>{console.error(R),(0,f.onUnexpectedError)(R),this._onClose.fire()}),this._zlibDeflate.on("data",R=>{this._pendingDeflateData.push(R)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new m.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this._onData.event(h)}onClose(h){return this._onClose.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){this._totalOutgoingDataBytes+=h.byteLength,this._zlibDeflate?(this._zlibDeflate.write(h.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let S=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,S=S.slice(0,S.length-4),this._isEnded||this._write(C.VSBuffer.wrap(S),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(h,!1)}_write(h,S){let u=2;h.byteLength<126?u+=0:h.byteLength<2**16?u+=2:u+=8;const v=C.VSBuffer.alloc(u);if(S?v.writeUInt8(194,0):v.writeUInt8(130,0),h.byteLength<126)v.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){v.writeUInt8(126,1);let R=1;v.writeUInt8(h.byteLength>>>8&255,++R),v.writeUInt8(h.byteLength>>>0&255,++R)}else{v.writeUInt8(127,1);let R=1;v.writeUInt8(0,++R),v.writeUInt8(0,++R),v.writeUInt8(0,++R),v.writeUInt8(0,++R),v.writeUInt8(h.byteLength>>>24&255,++R),v.writeUInt8(h.byteLength>>>16&255,++R),v.writeUInt8(h.byteLength>>>8&255,++R),v.writeUInt8(h.byteLength>>>0&255,++R)}this._totalOutgoingWireBytes+=v.byteLength+h.byteLength,this.socket.write(C.VSBuffer.concat([v,h]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(h){if(h.byteLength!==0){for(this._totalIncomingWireBytes+=h.byteLength,this._incomingData.acceptChunk(h);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const S=this._incomingData.peek(this._state.readLen),v=(S.readUInt8(0)&128)>>>7,R=S.readUInt8(1),L=(R&128)>>>7,H=R&127;this._state.state=2,this._state.readLen=2+(L?4:0)+(H===126?2:0)+(H===127?8:0),this._state.fin=v,this._state.mask=0}else if(this._state.state===2){const S=this._incomingData.read(this._state.readLen),u=S.readUInt8(1),v=(u&128)>>>7;let R=u&127,L=1;R===126?R=S.readUInt8(++L)*2**8+S.readUInt8(++L):R===127&&(R=S.readUInt8(++L)*0+S.readUInt8(++L)*0+S.readUInt8(++L)*0+S.readUInt8(++L)*0+S.readUInt8(++L)*2**24+S.readUInt8(++L)*2**16+S.readUInt8(++L)*2**8+S.readUInt8(++L));let H=0;v&&(H=S.readUInt8(++L)*2**24+S.readUInt8(++L)*2**16+S.readUInt8(++L)*2**8+S.readUInt8(++L)),this._state.state=3,this._state.readLen=R,this._state.mask=H}else if(this._state.state===3){const S=this._incomingData.read(this._state.readLen);p(S,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(S.buffer)),this._zlibInflate.write(S.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const u=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=u.length,this._onData.fire(C.VSBuffer.wrap(u))})):(this._totalIncomingDataBytes+=S.byteLength,this._onData.fire(S))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await I.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function p(l,h){if(h!==0){let S=l.byteLength>>>2;for(let ie=0;ie<S;ie++){const j=l.readUInt32BE(ie*4);l.writeUInt32BE(j^h,ie*4)}let u=S*4,v=l.byteLength-u;const R=h>>>24&255,L=h>>>16&255,H=h>>>8&255;v>=1&&l.writeUInt8(l.readUInt8(u)^R,u),v>=2&&l.writeUInt8(l.readUInt8(u+1)^L,u+1),v>=3&&l.writeUInt8(l.readUInt8(u+2)^H,u+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function g(){const l=(0,i.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let h;return e.XDG_RUNTIME_DIR?h=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):h=(0,P.join)((0,D.tmpdir)(),`vscode-ipc-${l}.sock`),n(h),h}e.createRandomIPCHandle=g;function t(l,h,S){const u=(0,_.createHash)("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${u}-${S}-${h}-sock`;let v;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?v=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${u.substr(0,8)}-${S}-${h}.sock`):v=(0,P.join)(l,`${S}-${h}.sock`),n(v),v}e.createStaticIPCHandle=t;function n(l){const h=c[a.platform];typeof h=="number"&&l.length>=h&&console.warn(`WARNING: IPC handle "${l}" is longer than ${h} chars, try a shorter --user-data-dir`)}class s extends y.IPCServer{constructor(h){super(s.toClientConnectionEvent(h));this.server=h}static toClientConnectionEvent(h){const S=I.Event.fromNodeEventEmitter(h,"connection");return I.Event.map(S,u=>({protocol:new m.Protocol(new d(u)),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(u,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function r(l){return new Promise((h,S)=>{const u=(0,k.createServer)();u.on("error",S),u.listen(l,()=>{u.removeListener("error",S),h(new s(u))})})}e.serve=r;function o(l,h){return new Promise((S,u)=>{const v=(0,k.createConnection)(l,()=>{v.removeListener("error",u),S(m.Client.fromSocket(new d(v),h))});v.once("error",u)})}e.connect=o}),define(me[281],ge([0,1,131,273,37,51,2,117,13]),function(G,e,_,k,A,I,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class i{constructor(m,f,a){this._commands=m,this.logService=f,this._ipcHandlePath=a,this._server=k.createServer((d,E)=>this.onRequest(d,E)),this.setup().catch(d=>(f.error(d),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",m=>this.logService.error(m))}catch(m){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(m,f){const a=[];m.setEncoding("utf8"),m.on("data",d=>a.push(d)),m.on("end",()=>{const d=JSON.parse(a.join(""));switch(d.type){case"open":this.open(d,f);break;case"openExternal":this.openExternal(d,f);break;case"status":this.getStatus(d,f);break;case"extensionManagement":this.manageExtensions(d,f).catch(this.logService.error);break;default:f.writeHead(404),f.write(`Unknown message type: ${d.type}`,E=>{E&&this.logService.error(E)}),f.end();break}})}open(m,f){let{fileURIs:a,folderURIs:d,forceNewWindow:E,diffMode:w,addMode:b,forceReuseWindow:p,gotoLineMode:c,waitMarkerFilePath:g}=m;const t=[];if(Array.isArray(d))for(const n of d)try{t.push({folderUri:y.URI.parse(n)})}catch(s){}if(Array.isArray(a))for(const n of a)try{(0,P.hasWorkspaceFileExtension)(n)?t.push({workspaceUri:y.URI.parse(n)}):t.push({fileUri:y.URI.parse(n)})}catch(s){}if(t.length){const n=g?y.URI.file(g):void 0,r={forceNewWindow:E,diffMode:w,addMode:b,gotoLineMode:c,forceReuseWindow:p,preferNewWindow:!p&&!n&&!b,waitMarkerFileURI:n};this._commands.executeCommand("_remoteCLI.windowOpen",t,r)}f.writeHead(200),f.end()}async openExternal(m,f){for(const a of m.uris){const d=y.URI.parse(a),E=d.scheme==="file"?d:a;await this._commands.executeCommand("_remoteCLI.openExternal",E)}f.writeHead(200),f.end()}async manageExtensions(m,f){try{const a=w=>w==null?void 0:w.map(b=>/\.vsix$/i.test(b)?y.URI.parse(b):b),d={list:m.list,install:a(m.install),uninstall:a(m.uninstall),force:m.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",d);f.writeHead(200),f.write(E)}catch(a){f.writeHead(500),f.write(String(a),d=>{d&&this.logService.error(d)})}f.end()}async getStatus(m,f){try{const a=await this._commands.executeCommand("_remoteCLI.getSystemStatus");f.writeHead(200),f.write(a),f.end()}catch(a){f.writeHead(500),f.write(String(a),d=>{d&&this.logService.error(d)}),f.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&A.existsSync(this._ipcHandlePath)&&A.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=i;let T=class extends i{constructor(m,f){super(m,f,(0,_.createRandomIPCHandle)())}};T=je([Be(0,I.IExtHostCommands),Be(1,D.ILogService)],T),e.CLIServer=T}),define(me[282],ge([0,1,68,269,263,5,272,42,254,2,11,7,281,102]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class a extends A.RequireInterceptor{_installInterceptor(){const w=this,b=G.__$__nodeRequire("module"),p=b._load;b._load=function(g,t,n){for(let s of w._alternatives){let r=s(g);if(r){g=r;break}}return w._factories.has(g)?w._factories.get(g).load(g,i.URI.file((0,f.realpathSync)(t.filename)),s=>p.apply(this,[s,t,n])):p.apply(this,arguments)}}}class d extends P.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(k.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(m.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(a,w,this._registry).install(),_.mark("code/extHost/didInitAPI");const p=await this._extHostConfiguration.getConfigProvider();await(0,y.connectProxyResolver)(this._extHostWorkspace,p,this,this._logService,this._mainThreadTelemetryProxy,this._initData),_.mark("code/extHost/didInitProxyResolver");const c=process.send,g=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?c.apply(process,t):(g.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,b,p){if(b.scheme!==T.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let c=null;p.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{w&&_.mark(`code/extHost/willLoadExtensionCode/${w.value}`),c=G.__$__nodeRequire(b.fsPath)}catch(g){return Promise.reject(g)}finally{w&&_.mark(`code/extHost/didLoadExtensionCode/${w.value}`),p.codeLoadingStop()}return Promise.resolve(c)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const b in w){const p=w[b];p===null?delete process.env[b]:process.env[b]=p}}}e.ExtHostExtensionService=d}),define(me[283],ge([0,1,79,255,266,265,264,280,282,226,256,46,42,65,69,67,34,50,13]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d,E,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(m.IExtHostExtensionService,D.ExtHostExtensionService),(0,_.registerSingleton)(b.ILogService,i.ExtHostLogService),(0,_.registerSingleton)(C.IExtHostDebugService,y.ExtHostDebugService),(0,_.registerSingleton)(f.IExtHostOutputService,k.ExtHostOutputService2),(0,_.registerSingleton)(a.IExtHostSearch,P.NativeExtHostSearch),(0,_.registerSingleton)(d.IExtHostTask,I.ExtHostTask),(0,_.registerSingleton)(E.IExtHostTerminalService,A.ExtHostTerminalService),(0,_.registerSingleton)(w.IExtHostTunnelService,T.ExtHostTunnelService)}),define(me[284],ge([0,1,121,295,68,18,105,131,187,224,267,22,100,26,102,19,270,283]),function(G,e,_,k,A,I,y,P,D,i,T,C,m,f,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const E=k(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const s=G.__$__nodeRequire("module"),r=s._load;s._load=function(o){if(o==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const w=process.exit.bind(process);function b(s){process.exit=function(r){if(s)w(r);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let p=function(s){w()};function c(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,r)=>{let o=null,l=setTimeout(()=>{r(new Error("VSCODE_EXTHOST_IPC_SOCKET timeout"))},6e4);const h=108e5,S=3e5,u=new d.RunOnceScheduler(()=>p("renderer disconnected for too long (1)"),h),v=new d.RunOnceScheduler(()=>p("renderer disconnected for too long (2)"),S);process.on("message",(L,H)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ie=C.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let j;if(L.skipWebSocketFrames)j=new P.NodeSocket(H);else{const B=C.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));j=new P.WebSocketNodeSocket(new P.NodeSocket(H),L.permessageDeflate,B,!1)}o?(u.cancel(),v.cancel(),o.beginAcceptReconnection(j,ie),o.endAcceptReconnection()):(clearTimeout(l),o=new y.PersistentProtocol(j,ie),o.onDidDispose(()=>p("renderer disconnected")),s(o),o.onSocketClose(()=>{u.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(v.isScheduled())return;u.isScheduled()&&v.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,o)=>{const l=_.createConnection(s,()=>{l.removeListener("error",o),r(new y.PersistentProtocol(new P.NodeSocket(l)))});l.once("error",o)})}}async function g(){const s=await c();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(r=>{(0,i.isMessageOfType)(r,2)?(this._terminating=!0,p("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||s.send(r)}drain(){return s.drain()}}}function t(s){return new Promise(r=>{const o=s.onMessage(l=>{o.dispose();const h=JSON.parse(l.toString()),S=h.commit,u=D.default.commit;S&&u&&S!==u&&w(55);const v=[];process.on("unhandledRejection",(H,ie)=>{v.push(ie),setTimeout(()=>{const j=v.indexOf(ie);j>=0&&ie.catch(B=>{v.splice(j,1),console.warn(`rejected promise not handled within 1 second: ${B}`),B&&B.stack&&console.warn(`stack trace: ${B.stack}`),(0,I.onUnexpectedError)(H)})},1e3)}),process.on("rejectionHandled",H=>{const ie=v.indexOf(H);ie>=0&&v.splice(ie,1)}),process.on("uncaughtException",function(H){(0,I.onUnexpectedError)(H)});let R=0;setInterval(function(){try{process.kill(h.parentPid,0),R=0}catch(H){H&&H.code==="EPERM"?(R++,R>=3&&p(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${H.message} (code: ${H.code}) (errno: ${H.errno})`)):p(`parent process ${h.parentPid} does not exist anymore: ${H.message} (code: ${H.code}) (errno: ${H.errno})`)}},1e3);let L;try{L=G.__$__nodeRequire("native-watchdog"),L.start(h.parentPid)}catch(H){(0,I.onUnexpectedError)(H)}s.send((0,i.createMessageOfType)(0)),r({protocol:s,initData:h})});s.send((0,i.createMessageOfType)(1))})}async function n(){A.mark("code/extHost/willConnectToRenderer");const s=await g();A.mark("code/extHost/didConnectToRenderer");const r=await t(s);A.mark("code/extHost/didWaitForInitData");const{initData:o}=r;b(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=E.useHostProxy!==void 0?E.useHostProxy!=="false":void 0;const l=new class{exit(v){w(v)}exists(v){return(0,f.exists)(v)}realpath(v){return(0,a.realpath)(v)}};let h=null;if(o.remote.authority&&E.uriTransformerPath)try{const v=G.__$__nodeRequire(E.uriTransformerPath)(o.remote.authority);h=new m.URITransformer(v)}catch(u){console.error(u)}const S=new T.ExtensionHostMain(r.protocol,o,l,h);p=u=>S.terminate(u)}e.startExtensionHostProcess=n}),define(me[296],ge([0,1,284]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.startExtensionHostProcess)().catch(k=>console.log(k))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8aff878db2542eea2dfb571c8bb485118bbb3113/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
