/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/network","vs/platform/log/common/log","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/shared/webview","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],we=function(Y){for(var e=[],E=0,C=Y.length;E<C;E++)e[E]=be[Y[E]];return e};define(be[42],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function E(C,I){if(!C)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=E}),define(be[52],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const E=Object.prototype.hasOwnProperty;function C(T){const k=[];for(let f in T)E.call(T,f)&&k.push(T[f]);return k}e.values=C;function I(T,k){for(let f in T)if(E.call(T,f)&&k({key:f,value:T[f]},function(){delete T[f]})===!1)return}e.forEach=I;function P(T,k){const f=Object.create(null);for(const h of T){const r=k(h);let a=f[r];a||(a=f[r]=[]),a.push(h)}return f}e.groupBy=P;function S(T){const k=Object.create(null);return T&&T.forEach((f,h)=>{k[h]=f}),k}e.fromMap=S;function D(T,k){const f=[],h=[];for(let r of T)k.has(r)||f.push(r);for(let r of k)T.has(r)||h.push(r);return{removed:f,added:h}}e.diffSets=D;function y(T,k){const f=[],h=[];for(let[r,a]of T)k.has(r)||f.push(a);for(let[r,a]of k)T.has(r)||h.push(a);return{removed:f,added:h}}e.diffMaps=y;class n{constructor(){this.map=new Map}add(k,f){let h=this.map.get(k);h||(h=new Set,this.map.set(k,h)),h.add(f)}delete(k,f){const h=this.map.get(k);!h||(h.delete(f),h.size===0&&this.map.delete(k))}forEach(k,f){const h=this.map.get(k);!h||h.forEach(f)}}e.SetMap=n}),define(be[53],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function E(y){return(n,T,k)=>{let f=null,h=null;if(typeof k.value=="function"?(f="value",h=k.value):typeof k.get=="function"&&(f="get",h=k.get),!h)throw new Error("not supported");k[f]=y(h,T)}}e.createDecorator=E;let C=0;function I(){const y=`$memoize${C++}`;let n;const T=function(f,h,r){let a=null,p=null;if(typeof r.value=="function"?(a="value",p=r.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof r.get=="function"&&(a="get",p=r.get),!p)throw new Error("not supported");const d=`${y}:${h}`;r[a]=function(...b){return n=this,this.hasOwnProperty(d)||Object.defineProperty(this,d,{configurable:!0,enumerable:!1,writable:!0,value:p.apply(this,b)}),this[d]}};return T.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(k=>{k.indexOf(y)===0&&delete n[k]})},T}e.createMemoizer=I;function P(y,n,T){return I()(y,n,T)}e.memoize=P;function S(y,n,T){return E((k,f)=>{const h=`$debounce$${f}`,r=`$debounce$result$${f}`;return function(...a){this[r]||(this[r]=T?T():void 0),clearTimeout(this[h]),n&&(this[r]=n(this[r],...a),a=[this[r]]),this[h]=setTimeout(()=>{k.apply(this,a),this[r]=T?T():void 0},y)}})}e.debounce=S;function D(y,n,T){return E((k,f)=>{const h=`$throttle$timer$${f}`,r=`$throttle$result$${f}`,a=`$throttle$lastRun$${f}`,p=`$throttle$pending$${f}`;return function(...d){if(this[r]||(this[r]=T?T():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),n&&(this[r]=n(this[r],...d)),!this[p]){const b=this[a]+y;b<=Date.now()?(this[a]=Date.now(),k.apply(this,[this[r]]),this[r]=T?T():void 0):(this[p]=!0,this[h]=setTimeout(()=>{this[p]=!1,this[a]=Date.now(),k.apply(this,[this[r]]),this[r]=T?T():void 0},b-Date.now()))}}})}e.throttle=D}),define(be[11],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=E,e.errorHandler=new E;function C(w){e.errorHandler.setUnexpectedErrorHandler(w)}e.setUnexpectedErrorHandler=C;function I(w){y(w)||e.errorHandler.onUnexpectedError(w)}e.onUnexpectedError=I;function P(w){y(w)||e.errorHandler.onUnexpectedExternalError(w)}e.onUnexpectedExternalError=P;function S(w){if(w instanceof Error){let{name:t,message:i}=w;const l=w.stacktrace||w.stack;return{$isError:!0,name:t,message:i,stack:l}}return w}e.transformErrorForSerialization=S;const D="Canceled";function y(w){return w instanceof Error&&w.name===D&&w.message===D}e.isPromiseCanceledError=y;class n extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=n;function T(){const w=new Error(D);return w.name=w.message,w}e.canceled=T;function k(w){return w?new Error(`Illegal argument: ${w}`):new Error("Illegal argument")}e.illegalArgument=k;function f(w){return w?new Error(`Illegal state: ${w}`):new Error("Illegal state")}e.illegalState=f;function h(w){return w?new Error(`readonly property '${w} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function r(w){const t=new Error(`${w} has been disposed`);return t.name="DISPOSED",t}e.disposed=r;function a(w){return w?w.message?w.message:w.stack?w.stack.split(`
`)[0]:String(w):"Error"}e.getErrorMessage=a;class p extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=p;class d extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=d;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function g(w){const t=w;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=g;function c(w,t=Object.create(null)){const i=new Error(w);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=c}),define(be[12],we([0,1,11]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function C(O,F=0){return O[O.length-(1+F)]}e.tail=C;function I(O){if(O.length===0)throw new Error("Invalid tail call");return[O.slice(0,O.length-1),O[O.length-1]]}e.tail2=I;function P(O,F,N=(B,U)=>B===U){if(O===F)return!0;if(!O||!F||O.length!==F.length)return!1;for(let B=0,U=O.length;B<U;B++)if(!N(O[B],F[B]))return!1;return!0}e.equals=P;function S(O,F,N){let B=0,U=O.length-1;for(;B<=U;){const Q=(B+U)/2|0,Z=N(O[Q],F);if(Z<0)B=Q+1;else if(Z>0)U=Q-1;else return Q}return-(B+1)}e.binarySearch=S;function D(O,F){let N=0,B=O.length;if(B===0)return 0;for(;N<B;){const U=Math.floor((N+B)/2);F(O[U])?B=U:N=U+1}return N}e.findFirstInSorted=D;function y(O,F,N){if(O=O|0,O>=F.length)throw new TypeError("invalid index");let B=F[Math.floor(F.length*Math.random())],U=[],Q=[],Z=[];for(let ne of F){const pe=N(ne,B);pe<0?U.push(ne):pe>0?Q.push(ne):Z.push(ne)}return O<U.length?y(O,U,N):O<U.length+Z.length?Z[0]:y(O-(U.length+Z.length),Q,N)}e.quickSelect=y;function n(O,F){const N=[];let B;for(const U of O.slice(0).sort(F))!B||F(B[0],U)!==0?(B=[U],N.push(B)):B.push(U);return N}e.groupBy=n;function T(O,F,N){const B=[];function U(ne,pe,Pe){if(!(pe===0&&Pe.length===0)){const Oe=B[B.length-1];Oe&&Oe.start+Oe.deleteCount===ne?(Oe.deleteCount+=pe,Oe.toInsert.push(...Pe)):B.push({start:ne,deleteCount:pe,toInsert:Pe})}}let Q=0,Z=0;for(;;){if(Q===O.length){U(Q,0,F.slice(Z));break}if(Z===F.length){U(Q,O.length-Q,[]);break}const ne=O[Q],pe=F[Z],Pe=N(ne,pe);Pe===0?(Q+=1,Z+=1):Pe<0?(U(Q,1,[]),Q+=1):Pe>0&&(U(Q,0,[pe]),Z+=1)}return B}e.sortedDiff=T;function k(O,F,N){const B=T(O,F,N),U=[],Q=[];for(const Z of B)U.push(...O.slice(Z.start,Z.start+Z.deleteCount)),Q.push(...Z.toInsert);return{removed:U,added:Q}}e.delta=k;function f(O,F,N){if(N===0)return[];const B=O.slice(0,N).sort(F);return r(O,F,B,N,O.length),B}e.top=f;function h(O,F,N,B,U){return N===0?Promise.resolve([]):new Promise((Q,Z)=>{(async()=>{const ne=O.length,pe=O.slice(0,N).sort(F);for(let Pe=N,Oe=Math.min(N+B,ne);Pe<ne;Pe=Oe,Oe=Math.min(Oe+B,ne)){if(Pe>N&&await new Promise(Te=>setTimeout(Te)),U&&U.isCancellationRequested)throw(0,E.canceled)();r(O,F,pe,Pe,Oe)}return pe})().then(Q,Z)})}e.topAsync=h;function r(O,F,N,B,U){for(const Q=N.length;B<U;B++){const Z=O[B];if(F(Z,N[Q-1])<0){N.pop();const ne=D(N,pe=>F(Z,pe)<0);N.splice(ne,0,Z)}}}function a(O){return O.filter(F=>!!F)}e.coalesce=a;function p(O){let F=0;for(let N=0;N<O.length;N++)O[N]&&(O[F]=O[N],F+=1);O.length=F}e.coalesceInPlace=p;function d(O,F,N){O.splice(N,0,O.splice(F,1)[0])}e.move=d;function b(O){return!Array.isArray(O)||O.length===0}e.isFalsyOrEmpty=b;function g(O){return Array.isArray(O)&&O.length>0}e.isNonEmptyArray=g;function c(O,F){if(!F)return O.filter((B,U)=>O.indexOf(B)===U);const N=Object.create(null);return O.filter(B=>{const U=F(B);return N[U]?!1:(N[U]=!0,!0)})}e.distinct=c;function w(O){const F=new Set;return O.filter(N=>F.has(N)?!1:(F.add(N),!0))}e.distinctES6=w;function t(O){const F=Object.create(null);return N=>{const B=O(N);return F[B]?!1:(F[B]=!0,!0)}}e.uniqueFilter=t;function i(O,F){for(let N=O.length-1;N>=0;N--){const B=O[N];if(F(B))return N}return-1}e.lastIndex=i;function l(O,F){return O.length>0?O[0]:F}e.firstOrDefault=l;function s(O,F,N=(B,U)=>B===U){let B=0;for(let U=0,Q=Math.min(O.length,F.length);U<Q&&N(O[U],F[U]);U++)B++;return B}e.commonPrefixLength=s;function o(O){return[].concat(...O)}e.flatten=o;function u(O,F){let N=typeof F=="number"?O:0;typeof F=="number"?N=O:(N=0,F=O);const B=[];if(N<=F)for(let U=N;U<F;U++)B.push(U);else for(let U=N;U>F;U--)B.push(U);return B}e.range=u;function v(O,F,N){return O.reduce((B,U)=>(B[F(U)]=N?N(U):U,B),Object.create(null))}e.index=v;function A(O,F){return O.push(F),()=>m(O,F)}e.insert=A;function m(O,F){const N=O.indexOf(F);if(N>-1)return O.splice(N,1),F}e.remove=m;function _(O,F,N){const B=O.slice(0,F),U=O.slice(F);return B.concat(N,U)}e.arrayInsert=_;function R(O,F){let N;if(typeof F=="number"){let B=F;N=()=>{const U=Math.sin(B++)*179426549;return U-Math.floor(U)}}else N=Math.random;for(let B=O.length-1;B>0;B-=1){const U=Math.floor(N()*(B+1)),Q=O[B];O[B]=O[U],O[U]=Q}}e.shuffle=R;function L(O,F){const N=O.indexOf(F);N>-1&&(O.splice(N,1),O.unshift(F))}e.pushToStart=L;function V(O,F){const N=O.indexOf(F);N>-1&&(O.splice(N,1),O.push(F))}e.pushToEnd=V;function he(O,F){return Array.isArray(O)?O.map(F):F(O)}e.mapArrayOrNot=he;function z(O){return Array.isArray(O)?O:[O]}e.asArray=z;function W(O){return O[Math.floor(Math.random()*O.length)]}e.getRandomElement=W;function J(O,F){for(const N of O){const B=F(N);if(B!==void 0)return B}}e.mapFind=J}),define(be[54],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(C){const I=this;let P=!1,S;return function(){return P||(P=!0,S=C.apply(I,arguments)),S}}e.once=E}),define(be[55],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class E{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=E,e.defaultGenerator=new E("id#")}),define(be[43],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(C){function I(w){return w&&typeof w=="object"&&typeof w[Symbol.iterator]=="function"}C.is=I;const P=Object.freeze([]);function S(){return P}C.empty=S;function*D(w){yield w}C.single=D;function y(w){return w||P}C.from=y;function n(w){return!w||w[Symbol.iterator]().next().done===!0}C.isEmpty=n;function T(w){return w[Symbol.iterator]().next().value}C.first=T;function k(w,t){for(const i of w)if(t(i))return!0;return!1}C.some=k;function f(w,t){for(const i of w)if(t(i))return i}C.find=f;function*h(w,t){for(const i of w)t(i)&&(yield i)}C.filter=h;function*r(w,t){for(const i of w)yield t(i)}C.map=r;function*a(...w){for(const t of w)for(const i of t)yield i}C.concat=a;function*p(w){for(const t of w)for(const i of t)yield i}C.concatNested=p;function d(w,t,i){let l=i;for(const s of w)l=t(l,s);return l}C.reduce=d;function*b(w,t,i=w.length){for(t<0&&(t+=w.length),i<0?i+=w.length:i>w.length&&(i=w.length);t<i;t++)yield w[t]}C.slice=b;function g(w,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,w];const l=w[Symbol.iterator]();for(let s=0;s<t;s++){const o=l.next();if(o.done)return[i,C.empty()];i.push(o.value)}return[i,{[Symbol.iterator](){return l}}]}C.consume=g;function c(w,t,i=(l,s)=>l===s){const l=w[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const o=l.next(),u=s.next();if(o.done!==u.done)return!1;if(o.done)return!0;if(!i(o.value,u.value))return!1}}C.equals=c})(E=e.Iterable||(e.Iterable={}))}),define(be[44],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function S(t,i=!1){let l=0,s=t.length,o="",u=0,v=16,A=0;function m(W){let J=0,O=0;for(;J<W;){const F=t.charCodeAt(l);if(F>=48&&F<=57)O=O*16+F-48;else if(F>=65&&F<=70)O=O*16+F-65+10;else if(F>=97&&F<=102)O=O*16+F-97+10;else break;l++,J++}return J<W&&(O=-1),O}function _(W){l=W,o="",u=0,v=16,A=0}function R(){const W=l;if(t.charCodeAt(l)===48)l++;else for(l++;l<t.length&&n(t.charCodeAt(l));)l++;if(l<t.length&&t.charCodeAt(l)===46)if(l++,l<t.length&&n(t.charCodeAt(l)))for(l++;l<t.length&&n(t.charCodeAt(l));)l++;else return A=3,t.substring(W,l);let J=l;if(l<t.length&&(t.charCodeAt(l)===69||t.charCodeAt(l)===101))if(l++,(l<t.length&&t.charCodeAt(l)===43||t.charCodeAt(l)===45)&&l++,l<t.length&&n(t.charCodeAt(l))){for(l++;l<t.length&&n(t.charCodeAt(l));)l++;J=l}else A=3;return t.substring(W,J)}function L(){let W="",J=l;for(;;){if(l>=s){W+=t.substring(J,l),A=2;break}const O=t.charCodeAt(l);if(O===34){W+=t.substring(J,l),l++;break}if(O===92){if(W+=t.substring(J,l),l++,l>=s){A=2;break}switch(t.charCodeAt(l++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:const N=m(4);N>=0?W+=String.fromCharCode(N):A=4;break;default:A=5}J=l;continue}if(O>=0&&O<=31)if(y(O)){W+=t.substring(J,l),A=2;break}else A=6;l++}return W}function V(){if(o="",A=0,u=l,l>=s)return u=s,v=17;let W=t.charCodeAt(l);if(D(W)){do l++,o+=String.fromCharCode(W),W=t.charCodeAt(l);while(D(W));return v=15}if(y(W))return l++,o+=String.fromCharCode(W),W===13&&t.charCodeAt(l)===10&&(l++,o+=`
`),v=14;switch(W){case 123:return l++,v=1;case 125:return l++,v=2;case 91:return l++,v=3;case 93:return l++,v=4;case 58:return l++,v=6;case 44:return l++,v=5;case 34:return l++,o=L(),v=10;case 47:const J=l-1;if(t.charCodeAt(l+1)===47){for(l+=2;l<s&&!y(t.charCodeAt(l));)l++;return o=t.substring(J,l),v=12}if(t.charCodeAt(l+1)===42){l+=2;const O=s-1;let F=!1;for(;l<O;){if(t.charCodeAt(l)===42&&t.charCodeAt(l+1)===47){l+=2,F=!0;break}l++}return F||(l++,A=1),o=t.substring(J,l),v=13}return o+=String.fromCharCode(W),l++,v=16;case 45:if(o+=String.fromCharCode(W),l++,l===s||!n(t.charCodeAt(l)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=R(),v=11;default:for(;l<s&&he(W);)l++,W=t.charCodeAt(l);if(u!==l){switch(o=t.substring(u,l),o){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return o+=String.fromCharCode(W),l++,v=16}}function he(W){if(D(W)||y(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let W;do W=V();while(W>=12&&W<=15);return W}return{setPosition:_,getPosition:()=>l,scan:i?z:V,getToken:()=>v,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>l-u,getTokenError:()=>A}}e.createScanner=S;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function k(t,i){const l=[],s=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function A(m,_,R,L){u.value=m,u.offset=_,u.length=R,u.type=L,u.colonOffset=void 0,o=u}try{g(t,{onObjectBegin:(m,_)=>{if(i<=m)throw s;o=void 0,v=i>m,l.push("")},onObjectProperty:(m,_,R)=>{if(i<_||(A(m,_,R,"property"),l[l.length-1]=m,i<=_+R))throw s},onObjectEnd:(m,_)=>{if(i<=m)throw s;o=void 0,l.pop()},onArrayBegin:(m,_)=>{if(i<=m)throw s;o=void 0,l.push(0)},onArrayEnd:(m,_)=>{if(i<=m)throw s;o=void 0,l.pop()},onLiteralValue:(m,_,R)=>{if(i<_||(A(m,_,R,w(m)),i<=_+R))throw s},onSeparator:(m,_,R)=>{if(i<=_)throw s;if(m===":"&&o&&o.type==="property")o.colonOffset=_,v=!1,o=void 0;else if(m===","){const L=l[l.length-1];typeof L=="number"?l[l.length-1]=L+1:(v=!0,l[l.length-1]=""),o=void 0}}})}catch(m){if(m!==s)throw m}return{path:l,previousNode:o,isAtPropertyKey:v,matches:m=>{let _=0;for(let R=0;_<m.length&&R<l.length;R++)if(m[_]===l[R]||m[_]==="*")_++;else if(m[_]!=="**")return!1;return _===m.length}}}e.getLocation=k;function f(t,i=[],l=P.DEFAULT){let s=null,o=[];const u=[];function v(m){Array.isArray(o)?o.push(m):s!==null&&(o[s]=m)}return g(t,{onObjectBegin:()=>{const m={};v(m),u.push(o),o=m,s=null},onObjectProperty:m=>{s=m},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const m=[];v(m),u.push(o),o=m,s=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:v,onError:(m,_,R)=>{i.push({error:m,offset:_,length:R})}},l),o[0]}e.parse=f;function h(t,i=[],l=P.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(m){s.type==="property"&&(s.length=m-s.offset,s=s.parent)}function u(m){return s.children.push(m),m}g(t,{onObjectBegin:m=>{s=u({type:"object",offset:m,length:-1,parent:s,children:[]})},onObjectProperty:(m,_,R)=>{s=u({type:"property",offset:_,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:m,offset:_,length:R,parent:s})},onObjectEnd:(m,_)=>{s.length=m+_-s.offset,s=s.parent,o(m+_)},onArrayBegin:(m,_)=>{s=u({type:"array",offset:m,length:-1,parent:s,children:[]})},onArrayEnd:(m,_)=>{s.length=m+_-s.offset,s=s.parent,o(m+_)},onLiteralValue:(m,_,R)=>{u({type:w(m),offset:_,length:R,parent:s,value:m}),o(_+R)},onSeparator:(m,_,R)=>{s.type==="property"&&(m===":"?s.colonOffset=_:m===","&&o(_))},onError:(m,_,R)=>{i.push({error:m,offset:_,length:R})}},l);const A=s.children[0];return A&&delete A.parent,A}e.parseTree=h;function r(t,i){if(!!t){let l=t;for(let s of i)if(typeof s=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let o=!1;for(const u of l.children)if(Array.isArray(u.children)&&u.children[0].value===s){l=u.children[1],o=!0;break}if(!o)return}else{const o=s;if(l.type!=="array"||o<0||!Array.isArray(l.children)||o>=l.children.length)return;l=l.children[o]}return l}}e.findNodeAtLocation=r;function a(t){if(!t.parent||!t.parent.children)return[];const i=a(t.parent);if(t.parent.type==="property"){const l=t.parent.children[0].value;i.push(l)}else if(t.parent.type==="array"){const l=t.parent.children.indexOf(t);l!==-1&&i.push(l)}return i}e.getNodePath=a;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":const i=Object.create(null);for(let l of t.children){const s=l.children[1];s&&(i[l.children[0].value]=p(s))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=p;function d(t,i,l=!1){return i>=t.offset&&i<t.offset+t.length||l&&i===t.offset+t.length}e.contains=d;function b(t,i,l=!1){if(d(t,i,l)){const s=t.children;if(Array.isArray(s))for(let o=0;o<s.length&&s[o].offset<=i;o++){const u=b(s[o],i,l);if(u)return u}return t}}e.findNodeAtOffset=b;function g(t,i,l=P.DEFAULT){const s=S(t,!1);function o(pe){return pe?()=>pe(s.getTokenOffset(),s.getTokenLength()):()=>!0}function u(pe){return pe?Pe=>pe(Pe,s.getTokenOffset(),s.getTokenLength()):()=>!0}const v=o(i.onObjectBegin),A=u(i.onObjectProperty),m=o(i.onObjectEnd),_=o(i.onArrayBegin),R=o(i.onArrayEnd),L=u(i.onLiteralValue),V=u(i.onSeparator),he=o(i.onComment),z=u(i.onError),W=l&&l.disallowComments,J=l&&l.allowTrailingComma;function O(){for(;;){const pe=s.scan();switch(s.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:W||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(pe){case 12:case 13:W?F(10):he();break;case 16:F(1);break;case 15:case 14:break;default:return pe}}}function F(pe,Pe=[],Oe=[]){if(z(pe),Pe.length+Oe.length>0){let Te=s.getToken();for(;Te!==17;){if(Pe.indexOf(Te)!==-1){O();break}else if(Oe.indexOf(Te)!==-1)break;Te=O()}}}function N(pe){const Pe=s.getTokenValue();return pe?L(Pe):A(Pe),O(),!0}function B(){switch(s.getToken()){case 11:let pe=0;try{pe=JSON.parse(s.getTokenValue()),typeof pe!="number"&&(F(2),pe=0)}catch(Pe){F(2)}L(pe);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return O(),!0}function U(){return s.getToken()!==10?(F(3,[],[2,5]),!1):(N(!1),s.getToken()===6?(V(":"),O(),ne()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function Q(){v(),O();let pe=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(pe||F(4,[],[]),V(","),O(),s.getToken()===2&&J)break}else pe&&F(6,[],[]);U()||F(4,[],[2,5]),pe=!0}return m(),s.getToken()!==2?F(7,[2],[]):O(),!0}function Z(){_(),O();let pe=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(pe||F(4,[],[]),V(","),O(),s.getToken()===4&&J)break}else pe&&F(6,[],[]);ne()||F(4,[],[4,5]),pe=!0}return R(),s.getToken()!==4?F(8,[4],[]):O(),!0}function ne(){switch(s.getToken()){case 3:return Z();case 1:return Q();case 10:return N(!0);default:return B()}}return O(),s.getToken()===17?l.allowEmptyContent?!0:(F(4,[],[]),!1):ne()?(s.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=g;function c(t,i){let l=S(t),s=[],o,u=0,v;do switch(v=l.getPosition(),o=l.scan(),o){case 12:case 13:case 17:u!==v&&s.push(t.substring(u,v)),i!==void 0&&s.push(l.getTokenValue().replace(/[^\r\n]/g,i)),u=l.getPosition();break}while(o!==17);return s.join("")}e.stripComments=c;function w(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(be[105],we([0,1,44]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function C(y,n,T){let k,f,h,r,a;if(n){for(r=n.offset,a=r+n.length,h=r;h>0&&!D(y,h-1);)h--;let u=a;for(;u<y.length&&!D(y,u);)u++;f=y.substring(h,u),k=P(f,T)}else f=y,k=0,h=0,r=0,a=y.length;const p=S(T,y);let d=!1,b=0,g;T.insertSpaces?g=I(" ",T.tabSize||4):g="	";const c=(0,E.createScanner)(f,!1);let w=!1;function t(){return p+I(g,k+b)}function i(){let u=c.scan();for(d=!1;u===15||u===14;)d=d||u===14,u=c.scan();return w=u===16||c.getTokenError()!==0,u}const l=[];function s(u,v,A){!w&&v<a&&A>r&&y.substring(v,A)!==u&&l.push({offset:v,length:A-v,content:u})}let o=i();if(o!==17){const u=c.getTokenOffset()+h,v=I(g,k);s(v,h,u)}for(;o!==17;){let u=c.getTokenOffset()+c.getTokenLength()+h,v=i(),A="";for(;!d&&(v===12||v===13);){const _=c.getTokenOffset()+h;s(" ",u,_),u=c.getTokenOffset()+c.getTokenLength()+h,A=v===12?t():"",v=i()}if(v===2)o!==1&&(b--,A=t());else if(v===4)o!==3&&(b--,A=t());else{switch(o){case 3:case 1:b++,A=t();break;case 5:case 12:A=t();break;case 13:d?A=t():A=" ";break;case 6:A=" ";break;case 10:if(v===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?A=" ":v!==5&&v!==17&&(w=!0);break;case 16:w=!0;break}d&&(v===12||v===13)&&(A=t())}const m=c.getTokenOffset()+h;s(A,u,m),o=v}return l}e.format=C;function I(y,n){let T="";for(let k=0;k<n;k++)T+=y;return T}function P(y,n){let T=0,k=0;const f=n.tabSize||4;for(;T<y.length;){const h=y.charAt(T);if(h===" ")k++;else if(h==="	")k+=f;else break;T++}return Math.floor(k/f)}function S(y,n){for(let T=0;T<n.length;T++){const k=n.charAt(T);if(k==="\r")return T+1<n.length&&n.charAt(T+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=S;function D(y,n){return`\r
`.indexOf(y.charAt(n))!==-1}e.isEOL=D}),define(be[106],we([0,1,44,105]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function I(n,T,k){return P(n,T,void 0,k)}e.removeProperty=I;function P(n,T,k,f,h){const r=T.slice(),a=[],p=(0,E.parseTree)(n,a);let d,b;for(;r.length>0&&(b=r.pop(),d=(0,E.findNodeAtLocation)(p,r),d===void 0&&k!==void 0);)typeof b=="string"?k={[b]:k}:k=[k];if(d)if(d.type==="object"&&typeof b=="string"&&Array.isArray(d.children)){const g=(0,E.findNodeAtLocation)(d,[b]);if(g!==void 0)if(k===void 0){if(!g.parent)throw new Error("Malformed AST");const c=d.children.indexOf(g.parent);let w,t=g.parent.offset+g.parent.length;if(c>0){const i=d.children[c-1];w=i.offset+i.length}else w=d.offset+1,d.children.length>1&&(t=d.children[1].offset);return S(n,{offset:w,length:t-w,content:""},f)}else return S(n,{offset:g.offset,length:g.length,content:JSON.stringify(k)},f);else{if(k===void 0)return[];const c=`${JSON.stringify(b)}: ${JSON.stringify(k)}`,w=h?h(d.children.map(i=>i.children[0].value)):d.children.length;let t;if(w>0){const i=d.children[w-1];t={offset:i.offset+i.length,length:0,content:","+c}}else d.children.length===0?t={offset:d.offset+1,length:0,content:c}:t={offset:d.offset+1,length:0,content:c+","};return S(n,t,f)}}else if(d.type==="array"&&typeof b=="number"&&Array.isArray(d.children))if(k!==void 0){const g=`${JSON.stringify(k)}`;let c;if(d.children.length===0||b===0)c={offset:d.offset+1,length:0,content:d.children.length===0?g:g+","};else{const w=b===-1||b>d.children.length?d.children.length:b,t=d.children[w-1];c={offset:t.offset+t.length,length:0,content:","+g}}return S(n,c,f)}else{const g=b,c=d.children[g];let w;if(d.children.length===1)w={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===g){const t=d.children[g-1],i=t.offset+t.length,l=d.offset+d.length;w={offset:i,length:l-2-i,content:""}}else w={offset:c.offset,length:d.children[g+1].offset-c.offset,content:""};return S(n,w,f)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${d.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return S(n,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(k)},f)}}e.setProperty=P;function S(n,T,k){let f=D(n,T),h=T.offset,r=T.offset+T.content.length;if(T.length===0||T.content.length===0){for(;h>0&&!(0,C.isEOL)(f,h-1);)h--;for(;r<f.length&&!(0,C.isEOL)(f,r);)r++}const a=(0,C.format)(f,{offset:h,length:r-h},k);for(let d=a.length-1;d>=0;d--){const b=a[d];f=D(f,b),h=Math.min(h,b.offset),r=Math.max(r,b.offset+b.length),r+=b.content.length-b.length}const p=n.length-(f.length-r)-h;return[{offset:h,length:p,content:f.substring(h,r)}]}e.withFormatting=S;function D(n,T){return n.substring(0,T.offset)+T.content+n.substring(T.offset+T.length)}e.applyEdit=D;function y(n,T){let k=T.slice(0).sort((h,r)=>{const a=h.offset-r.offset;return a===0?h.length-r.length:a}),f=n.length;for(let h=k.length-1;h>=0;h--){let r=k[h];if(r.offset+r.length<=f)n=D(n,r);else throw new Error("Overlapping edit");f=r.offset}return n}e.applyEdits=y}),define(be[107],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new E(()=>I(this.getValue()))}}e.Lazy=E}),define(be[6],we([0,1,54,43]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const I=!1;let P=null;function S(g){P=g}if(e.setDisposableTracker=S,I){const g="__is_disposable_tracked__";P=new class{trackDisposable(c){const w=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[g]||console.log(w)},3e3)}markTracked(c){if(c&&c!==a.None)try{c[g]=!0}catch(w){}}}}function D(g){!P||P.markTracked(g)}function y(g){return P&&P.trackDisposable(g),g}e.trackDisposable=y;class n extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=n;function T(g){return typeof g.dispose=="function"&&g.dispose.length===0}e.isDisposable=T;function k(g){if(C.Iterable.is(g)){let c=[];for(const w of g)if(w){D(w);try{w.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new n(c);return Array.isArray(g)?[]:g}else if(g)return D(g),g.dispose(),g}e.dispose=k;function f(...g){return g.forEach(D),h(()=>k(g))}e.combinedDisposable=f;function h(g){const c=y({dispose:()=>{D(c),g()}});return c}e.toDisposable=h;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{k(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return D(c),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class a{constructor(){this._store=new r,y(this)}dispose(){D(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=a,a.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var w;this._isDisposed||c===this._value||((w=this._value)===null||w===void 0||w.dispose(),c&&D(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,D(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=p;class d{constructor(){this.references=new Map}acquire(c,...w){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...w)},this.references.set(c,t));const{object:i}=t,l=(0,E.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:i,dispose:l}}}e.ReferenceCollection=d;class b{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=b}),define(be[45],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(P){this.element=P,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class C{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,S){const D=new E(P);if(this._first===E.Undefined)this._first=D,this._last=D;else if(S){const n=this._last;this._last=D,D.prev=n,n.next=D}else{const n=this._first;this._first=D,D.next=n,n.prev=D}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(D))}}shift(){if(this._first!==E.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==E.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==E.Undefined&&P.next!==E.Undefined){const S=P.prev;S.next=P.next,P.next.prev=S}else P.prev===E.Undefined&&P.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):P.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):P.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==E.Undefined;)yield P.element,P=P.next}}e.LinkedList=C}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(H,se){for(var de=0;de<se.length;de++){var K=se[de];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(H,K.key,K)}}function e(H,se,de){return se&&Y(H.prototype,se),de&&Y(H,de),H}function E(H,se){if(!!H){if(typeof H=="string")return C(H,se);var de=Object.prototype.toString.call(H).slice(8,-1);if(de==="Object"&&H.constructor&&(de=H.constructor.name),de==="Map"||de==="Set")return Array.from(H);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return C(H,se)}}function C(H,se){(se==null||se>H.length)&&(se=H.length);for(var de=0,K=new Array(se);de<se;de++)K[de]=H[de];return K}function I(H,se){var de;if(typeof Symbol=="undefined"||H[Symbol.iterator]==null){if(Array.isArray(H)||(de=E(H))||se&&H&&typeof H.length=="number"){de&&(H=de);var K=0;return function(){return K>=H.length?{done:!0}:{done:!1,value:H[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return de=H[Symbol.iterator](),de.next.bind(de)}function P(H){var se={exports:{}};return H(se,se.exports),se.exports}var S=P(function(H){function se(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function de(K){H.exports.defaults=K}H.exports={defaults:se(),getDefaults:se,changeDefaults:de}}),D=/[&<>"']/,y=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,k={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(se){return k[se]};function h(H,se){if(se){if(D.test(H))return H.replace(y,f)}else if(n.test(H))return H.replace(T,f);return H}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(H){return H.replace(r,function(se,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var p=/(^|[^\[])\^/g;function d(H,se){H=H.source||H,se=se||"";var de={replace:function(ee,le){return le=le.source||le,le=le.replace(p,"$1"),H=H.replace(ee,le),de},getRegex:function(){return new RegExp(H,se)}};return de}var b=/[^\w:]/g,g=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(H,se,de){if(H){var K;try{K=decodeURIComponent(a(de)).replace(b,"").toLowerCase()}catch(ee){return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}se&&!g.test(de)&&(de=s(se,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch(ee){return null}return de}var w={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(H,se){w[" "+H]||(t.test(H)?w[" "+H]=H+"/":w[" "+H]=A(H,"/",!0)),H=w[" "+H];var de=H.indexOf(":")===-1;return se.substring(0,2)==="//"?de?se:H.replace(i,"$1")+se:se.charAt(0)==="/"?de?se:H.replace(l,"$1")+se:H+se}var o={exec:function(){}};function u(H){for(var se=1,de,K;se<arguments.length;se++){de=arguments[se];for(K in de)Object.prototype.hasOwnProperty.call(de,K)&&(H[K]=de[K])}return H}function v(H,se){var de=H.replace(/\|/g,function(le,fe,Ee){for(var Ve=!1,Fe=fe;--Fe>=0&&Ee[Fe]==="\\";)Ve=!Ve;return Ve?"|":" |"}),K=de.split(/ \|/),ee=0;if(K.length>se)K.splice(se);else for(;K.length<se;)K.push("");for(;ee<K.length;ee++)K[ee]=K[ee].trim().replace(/\\\|/g,"|");return K}function A(H,se,de){var K=H.length;if(K===0)return"";for(var ee=0;ee<K;){var le=H.charAt(K-ee-1);if(le===se&&!de)ee++;else if(le!==se&&de)ee++;else break}return H.substr(0,K-ee)}function m(H,se){if(H.indexOf(se[1])===-1)return-1;for(var de=H.length,K=0,ee=0;ee<de;ee++)if(H[ee]==="\\")ee++;else if(H[ee]===se[0])K++;else if(H[ee]===se[1]&&(K--,K<0))return ee;return-1}function _(H){H&&H.sanitize&&!H.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(H,se){if(se<1)return"";for(var de="";se>1;)se&1&&(de+=H),se>>=1,H+=H;return de+H}var L={escape:h,unescape:a,edit:d,cleanUrl:c,resolveUrl:s,noopTest:o,merge:u,splitCells:v,rtrim:A,findClosingBracket:m,checkSanitizeDeprecation:_,repeatString:R},V=S.defaults,he=L.rtrim,z=L.splitCells,W=L.escape,J=L.findClosingBracket;function O(H,se,de){var K=se.href,ee=se.title?W(se.title):null,le=H[1].replace(/\\([\[\]])/g,"$1");return H[0].charAt(0)!=="!"?{type:"link",raw:de,href:K,title:ee,text:le}:{type:"image",raw:de,href:K,title:ee,text:W(le)}}function F(H,se){var de=H.match(/^(\s+)(?:```)/);if(de===null)return se;var K=de[1];return se.split(`
`).map(function(ee){var le=ee.match(/^\s+/);if(le===null)return ee;var fe=le[0];return fe.length>=K.length?ee.slice(K.length):ee}).join(`
`)}var N=function(){function H(de){this.options=de||V}var se=H.prototype;return se.space=function(K){var ee=this.rules.block.newline.exec(K);if(ee)return ee[0].length>1?{type:"space",raw:ee[0]}:{raw:`
`}},se.code=function(K){var ee=this.rules.block.code.exec(K);if(ee){var le=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?le:he(le,`
`)}}},se.fences=function(K){var ee=this.rules.block.fences.exec(K);if(ee){var le=ee[0],fe=F(le,ee[3]||"");return{type:"code",raw:le,lang:ee[2]?ee[2].trim():ee[2],text:fe}}},se.heading=function(K){var ee=this.rules.block.heading.exec(K);if(ee){var le=ee[2].trim();if(/#$/.test(le)){var fe=he(le,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(le=fe.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:le}}},se.nptable=function(K){var ee=this.rules.block.nptable.exec(K);if(ee){var le={type:"table",header:z(ee[1].replace(/^ *| *\| *$/g,"")),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ee[3]?ee[3].replace(/\n$/,"").split(`
`):[],raw:ee[0]};if(le.header.length===le.align.length){var fe=le.align.length,Ee;for(Ee=0;Ee<fe;Ee++)/^ *-+: *$/.test(le.align[Ee])?le.align[Ee]="right":/^ *:-+: *$/.test(le.align[Ee])?le.align[Ee]="center":/^ *:-+ *$/.test(le.align[Ee])?le.align[Ee]="left":le.align[Ee]=null;for(fe=le.cells.length,Ee=0;Ee<fe;Ee++)le.cells[Ee]=z(le.cells[Ee],le.header.length);return le}}},se.hr=function(K){var ee=this.rules.block.hr.exec(K);if(ee)return{type:"hr",raw:ee[0]}},se.blockquote=function(K){var ee=this.rules.block.blockquote.exec(K);if(ee){var le=ee[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ee[0],text:le}}},se.list=function(K){var ee=this.rules.block.list.exec(K);if(ee){var le=ee[0],fe=ee[2],Ee=fe.length>1,Ve={type:"list",raw:le,ordered:Ee,start:Ee?+fe.slice(0,-1):"",loose:!1,items:[]},Fe=ee[0].match(this.rules.block.item),We=!1,Qe,it,at,Ze,nt,dt,wt,ue,Se=Fe.length;at=this.rules.block.listItemStart.exec(Fe[0]);for(var ae=0;ae<Se;ae++){if(Qe=Fe[ae],le=Qe,ae!==Se-1){if(Ze=this.rules.block.listItemStart.exec(Fe[ae+1]),this.options.pedantic?Ze[1].length>at[1].length:Ze[1].length>at[0].length||Ze[1].length>3){Fe.splice(ae,2,Fe[ae]+`
`+Fe[ae+1]),ae--,Se--;continue}else(!this.options.pedantic||this.options.smartLists?Ze[2][Ze[2].length-1]!==fe[fe.length-1]:Ee===(Ze[2].length===1))&&(nt=Fe.slice(ae+1).join(`
`),Ve.raw=Ve.raw.substring(0,Ve.raw.length-nt.length),ae=Se-1);at=Ze}it=Qe.length,Qe=Qe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Qe.indexOf(`
 `)&&(it-=Qe.length,Qe=this.options.pedantic?Qe.replace(/^ {1,4}/gm,""):Qe.replace(new RegExp("^ {1,"+it+"}","gm"),"")),dt=We||/\n\n(?!\s*$)/.test(Qe),ae!==Se-1&&(We=Qe.charAt(Qe.length-1)===`
`,dt||(dt=We)),dt&&(Ve.loose=!0),this.options.gfm&&(wt=/^\[[ xX]\] /.test(Qe),ue=void 0,wt&&(ue=Qe[1]!==" ",Qe=Qe.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:le,task:wt,checked:ue,loose:dt,text:Qe})}return Ve}},se.html=function(K){var ee=this.rules.block.html.exec(K);if(ee)return{type:this.options.sanitize?"paragraph":"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):W(ee[0]):ee[0]}},se.def=function(K){var ee=this.rules.block.def.exec(K);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var le=ee[1].toLowerCase().replace(/\s+/g," ");return{tag:le,raw:ee[0],href:ee[2],title:ee[3]}}},se.table=function(K){var ee=this.rules.block.table.exec(K);if(ee){var le={type:"table",header:z(ee[1].replace(/^ *| *\| *$/g,"")),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ee[3]?ee[3].replace(/\n$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=ee[0];var fe=le.align.length,Ee;for(Ee=0;Ee<fe;Ee++)/^ *-+: *$/.test(le.align[Ee])?le.align[Ee]="right":/^ *:-+: *$/.test(le.align[Ee])?le.align[Ee]="center":/^ *:-+ *$/.test(le.align[Ee])?le.align[Ee]="left":le.align[Ee]=null;for(fe=le.cells.length,Ee=0;Ee<fe;Ee++)le.cells[Ee]=z(le.cells[Ee].replace(/^ *\| *| *\| *$/g,""),le.header.length);return le}}},se.lheading=function(K){var ee=this.rules.block.lheading.exec(K);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1]}},se.paragraph=function(K){var ee=this.rules.block.paragraph.exec(K);if(ee)return{type:"paragraph",raw:ee[0],text:ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1]}},se.text=function(K){var ee=this.rules.block.text.exec(K);if(ee)return{type:"text",raw:ee[0],text:ee[0]}},se.escape=function(K){var ee=this.rules.inline.escape.exec(K);if(ee)return{type:"escape",raw:ee[0],text:W(ee[1])}},se.tag=function(K,ee,le){var fe=this.rules.inline.tag.exec(K);if(fe)return!ee&&/^<a /i.test(fe[0])?ee=!0:ee&&/^<\/a>/i.test(fe[0])&&(ee=!1),!le&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?le=!0:le&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(le=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:ee,inRawBlock:le,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):W(fe[0]):fe[0]}},se.link=function(K){var ee=this.rules.inline.link.exec(K);if(ee){var le=ee[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var fe=he(le.slice(0,-1),"\\");if((le.length-fe.length)%2==0)return}else{var Ee=J(ee[2],"()");if(Ee>-1){var Ve=ee[0].indexOf("!")===0?5:4,Fe=Ve+ee[1].length+Ee;ee[2]=ee[2].substring(0,Ee),ee[0]=ee[0].substring(0,Fe).trim(),ee[3]=""}}var We=ee[2],Qe="";if(this.options.pedantic){var it=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(We);it&&(We=it[1],Qe=it[3])}else Qe=ee[3]?ee[3].slice(1,-1):"";return We=We.trim(),/^</.test(We)&&(this.options.pedantic&&!/>$/.test(le)?We=We.slice(1):We=We.slice(1,-1)),O(ee,{href:We&&We.replace(this.rules.inline._escapes,"$1"),title:Qe&&Qe.replace(this.rules.inline._escapes,"$1")},ee[0])}},se.reflink=function(K,ee){var le;if((le=this.rules.inline.reflink.exec(K))||(le=this.rules.inline.nolink.exec(K))){var fe=(le[2]||le[1]).replace(/\s+/g," ");if(fe=ee[fe.toLowerCase()],!fe||!fe.href){var Ee=le[0].charAt(0);return{type:"text",raw:Ee,text:Ee}}return O(le,fe,le[0])}},se.emStrong=function(K,ee,le){le===void 0&&(le="");var fe=this.rules.inline.emStrong.lDelim.exec(K);if(!!fe&&!(fe[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ee=fe[1]||fe[2]||"";if(!Ee||Ee&&(le===""||this.rules.inline.punctuation.exec(le))){var Ve=fe[0].length-1,Fe,We,Qe=Ve,it=0,at=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(at.lastIndex=0,ee=ee.slice(-1*K.length+Ve);(fe=at.exec(ee))!=null;)if(Fe=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Fe){if(We=Fe.length,fe[3]||fe[4]){Qe+=We;continue}else if((fe[5]||fe[6])&&Ve%3&&!((Ve+We)%3)){it+=We;continue}if(Qe-=We,!(Qe>0)){if(Qe+it-We<=0&&!ee.slice(at.lastIndex).match(at)&&(We=Math.min(We,We+Qe+it)),Math.min(Ve,We)%2)return{type:"em",raw:K.slice(0,Ve+fe.index+We+1),text:K.slice(1,Ve+fe.index+We)};if(Math.min(Ve,We)%2==0)return{type:"strong",raw:K.slice(0,Ve+fe.index+We+1),text:K.slice(2,Ve+fe.index+We-1)}}}}}},se.codespan=function(K){var ee=this.rules.inline.code.exec(K);if(ee){var le=ee[2].replace(/\n/g," "),fe=/[^ ]/.test(le),Ee=/^ /.test(le)&&/ $/.test(le);return fe&&Ee&&(le=le.substring(1,le.length-1)),le=W(le,!0),{type:"codespan",raw:ee[0],text:le}}},se.br=function(K){var ee=this.rules.inline.br.exec(K);if(ee)return{type:"br",raw:ee[0]}},se.del=function(K){var ee=this.rules.inline.del.exec(K);if(ee)return{type:"del",raw:ee[0],text:ee[2]}},se.autolink=function(K,ee){var le=this.rules.inline.autolink.exec(K);if(le){var fe,Ee;return le[2]==="@"?(fe=W(this.options.mangle?ee(le[1]):le[1]),Ee="mailto:"+fe):(fe=W(le[1]),Ee=fe),{type:"link",raw:le[0],text:fe,href:Ee,tokens:[{type:"text",raw:fe,text:fe}]}}},se.url=function(K,ee){var le;if(le=this.rules.inline.url.exec(K)){var fe,Ee;if(le[2]==="@")fe=W(this.options.mangle?ee(le[0]):le[0]),Ee="mailto:"+fe;else{var Ve;do Ve=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(Ve!==le[0]);fe=W(le[0]),le[1]==="www."?Ee="http://"+fe:Ee=fe}return{type:"link",raw:le[0],text:fe,href:Ee,tokens:[{type:"text",raw:fe,text:fe}]}}},se.inlineText=function(K,ee,le){var fe=this.rules.inline.text.exec(K);if(fe){var Ee;return ee?Ee=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):W(fe[0]):fe[0]:Ee=W(this.options.smartypants?le(fe[0]):fe[0]),{type:"text",raw:fe[0],text:Ee}}},H}(),B=L.noopTest,U=L.edit,Q=L.merge,Z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:B,table:B,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Z._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Z.def=U(Z.def).replace("label",Z._label).replace("title",Z._title).getRegex(),Z.bullet=/(?:[*+-]|\d{1,9}[.)])/,Z.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,Z.item=U(Z.item,"gm").replace(/bull/g,Z.bullet).getRegex(),Z.listItemStart=U(/^( *)(bull)/).replace("bull",Z.bullet).getRegex(),Z.list=U(Z.list).replace(/bull/g,Z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Z.def.source+")").getRegex(),Z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Z.html=U(Z.html,"i").replace("comment",Z._comment).replace("tag",Z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Z.paragraph=U(Z._paragraph).replace("hr",Z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",Z._tag).getRegex(),Z.blockquote=U(Z.blockquote).replace("paragraph",Z.paragraph).getRegex(),Z.normal=Q({},Z),Z.gfm=Q({},Z.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Z.gfm.nptable=U(Z.gfm.nptable).replace("hr",Z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",Z._tag).getRegex(),Z.gfm.table=U(Z.gfm.table).replace("hr",Z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",Z._tag).getRegex(),Z.pedantic=Q({},Z.normal,{html:U(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:B,paragraph:U(Z.normal._paragraph).replace("hr",Z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ne={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:B,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:B,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ne._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ne.punctuation=U(ne.punctuation).replace(/punctuation/g,ne._punctuation).getRegex(),ne.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ne.escapedEmSt=/\\\*|\\_/g,ne._comment=U(Z._comment).replace("(?:-->|$)","-->").getRegex(),ne.emStrong.lDelim=U(ne.emStrong.lDelim).replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimAst=U(ne.emStrong.rDelimAst,"g").replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimUnd=U(ne.emStrong.rDelimUnd,"g").replace(/punct/g,ne._punctuation).getRegex(),ne._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ne._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ne._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ne.autolink=U(ne.autolink).replace("scheme",ne._scheme).replace("email",ne._email).getRegex(),ne._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ne.tag=U(ne.tag).replace("comment",ne._comment).replace("attribute",ne._attribute).getRegex(),ne._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ne._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ne._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ne.link=U(ne.link).replace("label",ne._label).replace("href",ne._href).replace("title",ne._title).getRegex(),ne.reflink=U(ne.reflink).replace("label",ne._label).getRegex(),ne.reflinkSearch=U(ne.reflinkSearch,"g").replace("reflink",ne.reflink).replace("nolink",ne.nolink).getRegex(),ne.normal=Q({},ne),ne.pedantic=Q({},ne.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:U(/^!?\[(label)\]\((.*?)\)/).replace("label",ne._label).getRegex(),reflink:U(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ne._label).getRegex()}),ne.gfm=Q({},ne.normal,{escape:U(ne.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),ne.gfm.url=U(ne.gfm.url,"i").replace("email",ne.gfm._extended_email).getRegex(),ne.breaks=Q({},ne.gfm,{br:U(ne.br).replace("{2,}","*").getRegex(),text:U(ne.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var pe={block:Z,inline:ne},Pe=S.defaults,Oe=pe.block,Te=pe.inline,xe=L.repeatString;function $(H){return H.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(H){var se="",de,K,ee=H.length;for(de=0;de<ee;de++)K=H.charCodeAt(de),Math.random()>.5&&(K="x"+K.toString(16)),se+="&#"+K+";";return se}var ie=function(){function H(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||Pe,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var K={block:Oe.normal,inline:Te.normal};this.options.pedantic?(K.block=Oe.pedantic,K.inline=Te.pedantic):this.options.gfm&&(K.block=Oe.gfm,this.options.breaks?K.inline=Te.breaks:K.inline=Te.gfm),this.tokenizer.rules=K}H.lex=function(K,ee){var le=new H(ee);return le.lex(K)},H.lexInline=function(K,ee){var le=new H(ee);return le.inlineTokens(K)};var se=H.prototype;return se.lex=function(K){return K=K.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(K,this.tokens,!0),this.inline(this.tokens),this.tokens},se.blockTokens=function(K,ee,le){ee===void 0&&(ee=[]),le===void 0&&(le=!0),this.options.pedantic&&(K=K.replace(/^ +$/gm,""));for(var fe,Ee,Ve,Fe;K;){if(fe=this.tokenizer.space(K)){K=K.substring(fe.raw.length),fe.type&&ee.push(fe);continue}if(fe=this.tokenizer.code(K)){K=K.substring(fe.raw.length),Fe=ee[ee.length-1],Fe&&Fe.type==="paragraph"?(Fe.raw+=`
`+fe.raw,Fe.text+=`
`+fe.text):ee.push(fe);continue}if(fe=this.tokenizer.fences(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.heading(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.nptable(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.hr(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.blockquote(K)){K=K.substring(fe.raw.length),fe.tokens=this.blockTokens(fe.text,[],le),ee.push(fe);continue}if(fe=this.tokenizer.list(K)){for(K=K.substring(fe.raw.length),Ve=fe.items.length,Ee=0;Ee<Ve;Ee++)fe.items[Ee].tokens=this.blockTokens(fe.items[Ee].text,[],!1);ee.push(fe);continue}if(fe=this.tokenizer.html(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(le&&(fe=this.tokenizer.def(K))){K=K.substring(fe.raw.length),this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.lheading(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(le&&(fe=this.tokenizer.paragraph(K))){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.text(K)){K=K.substring(fe.raw.length),Fe=ee[ee.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+fe.raw,Fe.text+=`
`+fe.text):ee.push(fe);continue}if(K){var We="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(We);break}else throw new Error(We)}}return ee},se.inline=function(K){var ee,le,fe,Ee,Ve,Fe,We=K.length;for(ee=0;ee<We;ee++)switch(Fe=K[ee],Fe.type){case"paragraph":case"text":case"heading":{Fe.tokens=[],this.inlineTokens(Fe.text,Fe.tokens);break}case"table":{for(Fe.tokens={header:[],cells:[]},Ee=Fe.header.length,le=0;le<Ee;le++)Fe.tokens.header[le]=[],this.inlineTokens(Fe.header[le],Fe.tokens.header[le]);for(Ee=Fe.cells.length,le=0;le<Ee;le++)for(Ve=Fe.cells[le],Fe.tokens.cells[le]=[],fe=0;fe<Ve.length;fe++)Fe.tokens.cells[le][fe]=[],this.inlineTokens(Ve[fe],Fe.tokens.cells[le][fe]);break}case"blockquote":{this.inline(Fe.tokens);break}case"list":{for(Ee=Fe.items.length,le=0;le<Ee;le++)this.inline(Fe.items[le].tokens);break}}return K},se.inlineTokens=function(K,ee,le,fe){ee===void 0&&(ee=[]),le===void 0&&(le=!1),fe===void 0&&(fe=!1);var Ee,Ve,Fe=K,We,Qe,it;if(this.tokens.links){var at=Object.keys(this.tokens.links);if(at.length>0)for(;(We=this.tokenizer.rules.inline.reflinkSearch.exec(Fe))!=null;)at.includes(We[0].slice(We[0].lastIndexOf("[")+1,-1))&&(Fe=Fe.slice(0,We.index)+"["+xe("a",We[0].length-2)+"]"+Fe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(We=this.tokenizer.rules.inline.blockSkip.exec(Fe))!=null;)Fe=Fe.slice(0,We.index)+"["+xe("a",We[0].length-2)+"]"+Fe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(We=this.tokenizer.rules.inline.escapedEmSt.exec(Fe))!=null;)Fe=Fe.slice(0,We.index)+"++"+Fe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;){if(Qe||(it=""),Qe=!1,Ee=this.tokenizer.escape(K)){K=K.substring(Ee.raw.length),ee.push(Ee);continue}if(Ee=this.tokenizer.tag(K,le,fe)){K=K.substring(Ee.raw.length),le=Ee.inLink,fe=Ee.inRawBlock;var Ze=ee[ee.length-1];Ze&&Ee.type==="text"&&Ze.type==="text"?(Ze.raw+=Ee.raw,Ze.text+=Ee.text):ee.push(Ee);continue}if(Ee=this.tokenizer.link(K)){K=K.substring(Ee.raw.length),Ee.type==="link"&&(Ee.tokens=this.inlineTokens(Ee.text,[],!0,fe)),ee.push(Ee);continue}if(Ee=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(Ee.raw.length);var nt=ee[ee.length-1];Ee.type==="link"?(Ee.tokens=this.inlineTokens(Ee.text,[],!0,fe),ee.push(Ee)):nt&&Ee.type==="text"&&nt.type==="text"?(nt.raw+=Ee.raw,nt.text+=Ee.text):ee.push(Ee);continue}if(Ee=this.tokenizer.emStrong(K,Fe,it)){K=K.substring(Ee.raw.length),Ee.tokens=this.inlineTokens(Ee.text,[],le,fe),ee.push(Ee);continue}if(Ee=this.tokenizer.codespan(K)){K=K.substring(Ee.raw.length),ee.push(Ee);continue}if(Ee=this.tokenizer.br(K)){K=K.substring(Ee.raw.length),ee.push(Ee);continue}if(Ee=this.tokenizer.del(K)){K=K.substring(Ee.raw.length),Ee.tokens=this.inlineTokens(Ee.text,[],le,fe),ee.push(Ee);continue}if(Ee=this.tokenizer.autolink(K,G)){K=K.substring(Ee.raw.length),ee.push(Ee);continue}if(!le&&(Ee=this.tokenizer.url(K,G))){K=K.substring(Ee.raw.length),ee.push(Ee);continue}if(Ee=this.tokenizer.inlineText(K,fe,$)){K=K.substring(Ee.raw.length),Ee.raw.slice(-1)!=="_"&&(it=Ee.raw.slice(-1)),Qe=!0,Ve=ee[ee.length-1],Ve&&Ve.type==="text"?(Ve.raw+=Ee.raw,Ve.text+=Ee.text):ee.push(Ee);continue}if(K){var dt="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(dt);break}else throw new Error(dt)}}return ee},e(H,null,[{key:"rules",get:function(){return{block:Oe,inline:Te}}}]),H}(),oe=S.defaults,me=L.cleanUrl,De=L.escape,Ne=function(){function H(de){this.options=de||oe}var se=H.prototype;return se.code=function(K,ee,le){var fe=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Ee=this.options.highlight(K,fe);Ee!=null&&Ee!==K&&(le=!0,K=Ee)}return K=K.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+De(fe,!0)+'">'+(le?K:De(K,!0))+`</code></pre>
`:"<pre><code>"+(le?K:De(K,!0))+`</code></pre>
`},se.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},se.html=function(K){return K},se.heading=function(K,ee,le,fe){return this.options.headerIds?"<h"+ee+' id="'+this.options.headerPrefix+fe.slug(le)+'">'+K+"</h"+ee+`>
`:"<h"+ee+">"+K+"</h"+ee+`>
`},se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},se.list=function(K,ee,le){var fe=ee?"ol":"ul",Ee=ee&&le!==1?' start="'+le+'"':"";return"<"+fe+Ee+`>
`+K+"</"+fe+`>
`},se.listitem=function(K){return"<li>"+K+`</li>
`},se.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},se.paragraph=function(K){return"<p>"+K+`</p>
`},se.table=function(K,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+ee+`</table>
`},se.tablerow=function(K){return`<tr>
`+K+`</tr>
`},se.tablecell=function(K,ee){var le=ee.header?"th":"td",fe=ee.align?"<"+le+' align="'+ee.align+'">':"<"+le+">";return fe+K+"</"+le+`>
`},se.strong=function(K){return"<strong>"+K+"</strong>"},se.em=function(K){return"<em>"+K+"</em>"},se.codespan=function(K){return"<code>"+K+"</code>"},se.br=function(){return this.options.xhtml?"<br/>":"<br>"},se.del=function(K){return"<del>"+K+"</del>"},se.link=function(K,ee,le){if(K=me(this.options.sanitize,this.options.baseUrl,K),K===null)return le;var fe='<a href="'+De(K)+'"';return ee&&(fe+=' title="'+ee+'"'),fe+=">"+le+"</a>",fe},se.image=function(K,ee,le){if(K=me(this.options.sanitize,this.options.baseUrl,K),K===null)return le;var fe='<img src="'+K+'" alt="'+le+'"';return ee&&(fe+=' title="'+ee+'"'),fe+=this.options.xhtml?"/>":">",fe},se.text=function(K){return K},H}(),ge=function(){function H(){}var se=H.prototype;return se.strong=function(K){return K},se.em=function(K){return K},se.codespan=function(K){return K},se.del=function(K){return K},se.html=function(K){return K},se.text=function(K){return K},se.link=function(K,ee,le){return""+le},se.image=function(K,ee,le){return""+le},se.br=function(){return""},H}(),Ce=function(){function H(){this.seen={}}var se=H.prototype;return se.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},se.getNextSafeSlug=function(K,ee){var le=K,fe=0;if(this.seen.hasOwnProperty(le)){fe=this.seen[K];do fe++,le=K+"-"+fe;while(this.seen.hasOwnProperty(le))}return ee||(this.seen[K]=fe,this.seen[le]=0),le},se.slug=function(K,ee){ee===void 0&&(ee={});var le=this.serialize(K);return this.getNextSafeSlug(le,ee.dryrun)},H}(),Ae=S.defaults,Be=L.unescape,_e=function(){function H(de){this.options=de||Ae,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ge,this.slugger=new Ce}H.parse=function(K,ee){var le=new H(ee);return le.parse(K)},H.parseInline=function(K,ee){var le=new H(ee);return le.parseInline(K)};var se=H.prototype;return se.parse=function(K,ee){ee===void 0&&(ee=!0);var le="",fe,Ee,Ve,Fe,We,Qe,it,at,Ze,nt,dt,wt,ue,Se,ae,q,Le,Ie,Xe=K.length;for(fe=0;fe<Xe;fe++)switch(nt=K[fe],nt.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(nt.tokens),nt.depth,Be(this.parseInline(nt.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(nt.text,nt.lang,nt.escaped);continue}case"table":{for(at="",it="",Fe=nt.header.length,Ee=0;Ee<Fe;Ee++)it+=this.renderer.tablecell(this.parseInline(nt.tokens.header[Ee]),{header:!0,align:nt.align[Ee]});for(at+=this.renderer.tablerow(it),Ze="",Fe=nt.cells.length,Ee=0;Ee<Fe;Ee++){for(Qe=nt.tokens.cells[Ee],it="",We=Qe.length,Ve=0;Ve<We;Ve++)it+=this.renderer.tablecell(this.parseInline(Qe[Ve]),{header:!1,align:nt.align[Ve]});Ze+=this.renderer.tablerow(it)}le+=this.renderer.table(at,Ze);continue}case"blockquote":{Ze=this.parse(nt.tokens),le+=this.renderer.blockquote(Ze);continue}case"list":{for(dt=nt.ordered,wt=nt.start,ue=nt.loose,Fe=nt.items.length,Ze="",Ee=0;Ee<Fe;Ee++)ae=nt.items[Ee],q=ae.checked,Le=ae.task,Se="",ae.task&&(Ie=this.renderer.checkbox(q),ue?ae.tokens.length>0&&ae.tokens[0].type==="text"?(ae.tokens[0].text=Ie+" "+ae.tokens[0].text,ae.tokens[0].tokens&&ae.tokens[0].tokens.length>0&&ae.tokens[0].tokens[0].type==="text"&&(ae.tokens[0].tokens[0].text=Ie+" "+ae.tokens[0].tokens[0].text)):ae.tokens.unshift({type:"text",text:Ie}):Se+=Ie),Se+=this.parse(ae.tokens,ue),Ze+=this.renderer.listitem(Se,Le,q);le+=this.renderer.list(Ze,dt,wt);continue}case"html":{le+=this.renderer.html(nt.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(nt.tokens));continue}case"text":{for(Ze=nt.tokens?this.parseInline(nt.tokens):nt.text;fe+1<Xe&&K[fe+1].type==="text";)nt=K[++fe],Ze+=`
`+(nt.tokens?this.parseInline(nt.tokens):nt.text);le+=ee?this.renderer.paragraph(Ze):Ze;continue}default:{var et='Token with "'+nt.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}return le},se.parseInline=function(K,ee){ee=ee||this.renderer;var le="",fe,Ee,Ve=K.length;for(fe=0;fe<Ve;fe++)switch(Ee=K[fe],Ee.type){case"escape":{le+=ee.text(Ee.text);break}case"html":{le+=ee.html(Ee.text);break}case"link":{le+=ee.link(Ee.href,Ee.title,this.parseInline(Ee.tokens,ee));break}case"image":{le+=ee.image(Ee.href,Ee.title,Ee.text);break}case"strong":{le+=ee.strong(this.parseInline(Ee.tokens,ee));break}case"em":{le+=ee.em(this.parseInline(Ee.tokens,ee));break}case"codespan":{le+=ee.codespan(Ee.text);break}case"br":{le+=ee.br();break}case"del":{le+=ee.del(this.parseInline(Ee.tokens,ee));break}case"text":{le+=ee.text(Ee.text);break}default:{var Fe='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Fe);return}else throw new Error(Fe)}}return le},H}(),qe=L.merge,j=L.checkSanitizeDeprecation,te=L.escape,ve=S.getDefaults,Ue=S.changeDefaults,He=S.defaults;function $e(H,se,de){if(typeof H=="undefined"||H===null)throw new Error("marked(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");if(typeof se=="function"&&(de=se,se=null),se=qe({},$e.defaults,se||{}),j(se),de){var K=se.highlight,ee;try{ee=ie.lex(H,se)}catch(Ve){return de(Ve)}var le=function(Fe){var We;if(!Fe)try{We=_e.parse(ee,se)}catch(Qe){Fe=Qe}return se.highlight=K,Fe?de(Fe):de(null,We)};if(!K||K.length<3||(delete se.highlight,!ee.length))return le();var fe=0;$e.walkTokens(ee,function(Ve){Ve.type==="code"&&(fe++,setTimeout(function(){K(Ve.text,Ve.lang,function(Fe,We){if(Fe)return le(Fe);We!=null&&We!==Ve.text&&(Ve.text=We,Ve.escaped=!0),fe--,fe===0&&le()})},0))}),fe===0&&le();return}try{var Ee=ie.lex(H,se);return se.walkTokens&&$e.walkTokens(Ee,se.walkTokens),_e.parse(Ee,se)}catch(Ve){if(Ve.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+te(Ve.message+"",!0)+"</pre>";throw Ve}}$e.options=$e.setOptions=function(H){return qe($e.defaults,H),Ue($e.defaults),$e},$e.getDefaults=ve,$e.defaults=He,$e.use=function(H){var se=qe({},H);if(H.renderer&&function(){var K=$e.defaults.renderer||new Ne,ee=function(Ee){var Ve=K[Ee];K[Ee]=function(){for(var Fe=arguments.length,We=new Array(Fe),Qe=0;Qe<Fe;Qe++)We[Qe]=arguments[Qe];var it=H.renderer[Ee].apply(K,We);return it===!1&&(it=Ve.apply(K,We)),it}};for(var le in H.renderer)ee(le);se.renderer=K}(),H.tokenizer&&function(){var K=$e.defaults.tokenizer||new N,ee=function(Ee){var Ve=K[Ee];K[Ee]=function(){for(var Fe=arguments.length,We=new Array(Fe),Qe=0;Qe<Fe;Qe++)We[Qe]=arguments[Qe];var it=H.tokenizer[Ee].apply(K,We);return it===!1&&(it=Ve.apply(K,We)),it}};for(var le in H.tokenizer)ee(le);se.tokenizer=K}(),H.walkTokens){var de=$e.defaults.walkTokens;se.walkTokens=function(K){H.walkTokens(K),de&&de(K)}}$e.setOptions(se)},$e.walkTokens=function(H,se){for(var de=I(H),K;!(K=de()).done;){var ee=K.value;switch(se(ee),ee.type){case"table":{for(var le=I(ee.tokens.header),fe;!(fe=le()).done;){var Ee=fe.value;$e.walkTokens(Ee,se)}for(var Ve=I(ee.tokens.cells),Fe;!(Fe=Ve()).done;)for(var We=Fe.value,Qe=I(We),it;!(it=Qe()).done;){var at=it.value;$e.walkTokens(at,se)}break}case"list":{$e.walkTokens(ee.items,se);break}default:ee.tokens&&$e.walkTokens(ee.tokens,se)}}},$e.parseInline=function(H,se){if(typeof H=="undefined"||H===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");se=qe({},$e.defaults,se||{}),j(se);try{var de=ie.lexInline(H,se);return se.walkTokens&&$e.walkTokens(de,se.walkTokens),_e.parseInline(de,se)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+te(K.message+"",!0)+"</pre>";throw K}},$e.Parser=_e,$e.parser=_e.parse,$e.Renderer=Ne,$e.TextRenderer=ge,$e.Lexer=ie,$e.lexer=ie.lex,$e.Tokenizer=N,$e.Slugger=Ce,$e.parse=$e;var Ye=$e;return Ye}),define(be[81],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(S,D,y){return Math.min(Math.max(S,D),y)}e.clamp=E;function C(S,D){return(D+S%D)%D}e.rot=C;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class P{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=P});"use strict";(function(){function Y(I){const P=[];typeof I=="number"&&P.push("code/timeOrigin",I);function S(y){P.push(y,Date.now())}function D(){const y=[];for(let n=0;n<P.length;n+=2)y.push({name:P[n],startTime:P[n+1]});return y}return{mark:S,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const S of performance.getEntriesByType("mark"))P.push({name:S.name,startTime:Math.round(I+S.startTime)});return P}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function E(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=E(C))})(),define(be[21],we([0,1]),function(Y,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const C="en";let I=!1,P=!1,S=!1,D=!1,y=!1,n=!1,T=!1,k,f=C,h,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode!="undefined"?a=e.globals.vscode.process:typeof process!="undefined"&&(a=process);const p=typeof((E=a==null?void 0:a.versions)===null||E===void 0?void 0:E.electron)=="string"&&a.type==="renderer";if(e.isElectronSandboxed=p&&(a==null?void 0:a.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=a==null?void 0:a.env.VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!p)r=navigator.userAgent,I=r.indexOf("Windows")>=0,P=r.indexOf("Macintosh")>=0,T=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=r.indexOf("Linux")>=0,n=!0,k=navigator.language,f=k;else if(typeof a=="object"){I=a.platform==="win32",P=a.platform==="darwin",S=a.platform==="linux",D=S&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,k=C,f=C;const s=a.env.VSCODE_NLS_CONFIG;if(s)try{const o=JSON.parse(s),u=o.availableLanguages["*"];k=o.locale,f=u||C,h=o._translationsConfigFile}catch(o){}y=!0}else console.error("Unable to resolve platform.");var d;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(d=e.Platform||(e.Platform={}));function b(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let g=0;P?g=1:I?g=3:S&&(g=2),e.isWindows=I,e.isMacintosh=P,e.isLinux=S,e.isLinuxSnap=D,e.isNative=y,e.isWeb=n,e.isIOS=T,e.platform=g,e.userAgent=r,e.language=f;var c;(function(s){function o(){return e.language}s.value=o;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=u;function v(){return e.language==="en"}s.isDefault=v})(c=e.Language||(e.Language={})),e.locale=k,e.translationsConfigFile=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",A=>{if(A.data&&A.data.vscodeSetImmediateId)for(let m=0,_=u.length;m<_;m++){const R=u[m];if(R.id===A.data.vscodeSetImmediateId){u.splice(m,1),R.callback();return}}});let v=0;return A=>{const m=++v;u.push({id:m,callback:A}),e.globals.postMessage({vscodeSetImmediateId:m},"*")}}if(typeof(a==null?void 0:a.nextTick)=="function")return a.nextTick.bind(a);const o=Promise.resolve();return u=>o.then(u)}();var w;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(w=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||T?2:I?1:3;let t=!0,i=!1;function l(){if(!i){i=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,t=new Uint16Array(s.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=l}),define(be[46],we([0,1,21]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let C;if(typeof E.globals.vscode!="undefined"){const I=E.globals.vscode.process;C={get platform(){return I.platform},get env(){return I.env},cwd(){return I.cwd()},nextTick(P){return(0,E.setImmediate)(P)}}}else typeof process!="undefined"?C={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(I){return process.nextTick(I)}}:C={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},nextTick(I){return(0,E.setImmediate)(I)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=C.cwd,e.env=C.env,e.platform=C.platform,e.nextTick=C.nextTick}),define(be[13],we([0,1,46]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const C=65,I=97,P=90,S=122,D=46,y=47,n=92,T=58,k=63;class f extends Error{constructor(c,w,t){let i;typeof w=="string"&&w.indexOf("not ")===0?(i="must not be",w=w.replace(/^not /,"")):i="must be";const l=c.indexOf(".")!==-1?"property":"argument";let s=`The "${c}" ${l} ${i} of type ${w}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function h(g,c){if(typeof g!="string")throw new f(c,"string",g)}function r(g){return g===y||g===n}function a(g){return g===y}function p(g){return g>=C&&g<=P||g>=I&&g<=S}function d(g,c,w,t){let i="",l=0,s=-1,o=0,u=0;for(let v=0;v<=g.length;++v){if(v<g.length)u=g.charCodeAt(v);else{if(t(u))break;u=y}if(t(u)){if(!(s===v-1||o===1))if(o===2){if(i.length<2||l!==2||i.charCodeAt(i.length-1)!==D||i.charCodeAt(i.length-2)!==D){if(i.length>2){const A=i.lastIndexOf(w);A===-1?(i="",l=0):(i=i.slice(0,A),l=i.length-1-i.lastIndexOf(w)),s=v,o=0;continue}else if(i.length!==0){i="",l=0,s=v,o=0;continue}}c&&(i+=i.length>0?`${w}..`:"..",l=2)}else i.length>0?i+=`${w}${g.slice(s+1,v)}`:i=g.slice(s+1,v),l=v-s-1;s=v,o=0}else u===D&&o!==-1?++o:o=-1}return i}function b(g,c){if(c===null||typeof c!="object")throw new f("pathObject","Object",c);const w=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return w?w===c.root?`${w}${t}`:`${w}${g}${t}`:t}e.win32={resolve(...g){let c="",w="",t=!1;for(let i=g.length-1;i>=-1;i--){let l;if(i>=0){if(l=g[i],h(l,"path"),l.length===0)continue}else c.length===0?l=E.cwd():(l=E.env[`=${c}`]||E.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==c.toLowerCase()&&l.charCodeAt(2)===n)&&(l=`${c}\\`));const s=l.length;let o=0,u="",v=!1;const A=l.charCodeAt(0);if(s===1)r(A)&&(o=1,v=!0);else if(r(A))if(v=!0,r(l.charCodeAt(1))){let m=2,_=m;for(;m<s&&!r(l.charCodeAt(m));)m++;if(m<s&&m!==_){const R=l.slice(_,m);for(_=m;m<s&&r(l.charCodeAt(m));)m++;if(m<s&&m!==_){for(_=m;m<s&&!r(l.charCodeAt(m));)m++;(m===s||m!==_)&&(u=`\\\\${R}\\${l.slice(_,m)}`,o=m)}}}else o=1;else p(A)&&l.charCodeAt(1)===T&&(u=l.slice(0,2),o=2,s>2&&r(l.charCodeAt(2))&&(v=!0,o=3));if(u.length>0)if(c.length>0){if(u.toLowerCase()!==c.toLowerCase())continue}else c=u;if(t){if(c.length>0)break}else if(w=`${l.slice(o)}\\${w}`,t=v,v&&c.length>0)break}return w=d(w,!t,"\\",r),t?`${c}\\${w}`:`${c}${w}`||"."},normalize(g){h(g,"path");const c=g.length;if(c===0)return".";let w=0,t,i=!1;const l=g.charCodeAt(0);if(c===1)return a(l)?"\\":g;if(r(l))if(i=!0,r(g.charCodeAt(1))){let o=2,u=o;for(;o<c&&!r(g.charCodeAt(o));)o++;if(o<c&&o!==u){const v=g.slice(u,o);for(u=o;o<c&&r(g.charCodeAt(o));)o++;if(o<c&&o!==u){for(u=o;o<c&&!r(g.charCodeAt(o));)o++;if(o===c)return`\\\\${v}\\${g.slice(u)}\\`;o!==u&&(t=`\\\\${v}\\${g.slice(u,o)}`,w=o)}}}else w=1;else p(l)&&g.charCodeAt(1)===T&&(t=g.slice(0,2),w=2,c>2&&r(g.charCodeAt(2))&&(i=!0,w=3));let s=w<c?d(g.slice(w),!i,"\\",r):"";return s.length===0&&!i&&(s="."),s.length>0&&r(g.charCodeAt(c-1))&&(s+="\\"),t===void 0?i?`\\${s}`:s:i?`${t}\\${s}`:`${t}${s}`},isAbsolute(g){h(g,"path");const c=g.length;if(c===0)return!1;const w=g.charCodeAt(0);return r(w)||c>2&&p(w)&&g.charCodeAt(1)===T&&r(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let c,w;for(let l=0;l<g.length;++l){const s=g[l];h(s,"path"),s.length>0&&(c===void 0?c=w=s:c+=`\\${s}`)}if(c===void 0)return".";let t=!0,i=0;if(typeof w=="string"&&r(w.charCodeAt(0))){++i;const l=w.length;l>1&&r(w.charCodeAt(1))&&(++i,l>2&&(r(w.charCodeAt(2))?++i:t=!1))}if(t){for(;i<c.length&&r(c.charCodeAt(i));)i++;i>=2&&(c=`\\${c.slice(i)}`)}return e.win32.normalize(c)},relative(g,c){if(h(g,"from"),h(c,"to"),g===c)return"";const w=e.win32.resolve(g),t=e.win32.resolve(c);if(w===t||(g=w.toLowerCase(),c=t.toLowerCase(),g===c))return"";let i=0;for(;i<g.length&&g.charCodeAt(i)===n;)i++;let l=g.length;for(;l-1>i&&g.charCodeAt(l-1)===n;)l--;const s=l-i;let o=0;for(;o<c.length&&c.charCodeAt(o)===n;)o++;let u=c.length;for(;u-1>o&&c.charCodeAt(u-1)===n;)u--;const v=u-o,A=s<v?s:v;let m=-1,_=0;for(;_<A;_++){const L=g.charCodeAt(i+_);if(L!==c.charCodeAt(o+_))break;L===n&&(m=_)}if(_!==A){if(m===-1)return t}else{if(v>A){if(c.charCodeAt(o+_)===n)return t.slice(o+_+1);if(_===2)return t.slice(o+_)}s>A&&(g.charCodeAt(i+_)===n?m=_:_===2&&(m=3)),m===-1&&(m=0)}let R="";for(_=i+m+1;_<=l;++_)(_===l||g.charCodeAt(_)===n)&&(R+=R.length===0?"..":"\\..");return o+=m,R.length>0?`${R}${t.slice(o,u)}`:(t.charCodeAt(o)===n&&++o,t.slice(o,u))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const c=e.win32.resolve(g);if(c.length<=2)return g;if(c.charCodeAt(0)===n){if(c.charCodeAt(1)===n){const w=c.charCodeAt(2);if(w!==k&&w!==D)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(p(c.charCodeAt(0))&&c.charCodeAt(1)===T&&c.charCodeAt(2)===n)return`\\\\?\\${c}`;return g},dirname(g){h(g,"path");const c=g.length;if(c===0)return".";let w=-1,t=0;const i=g.charCodeAt(0);if(c===1)return r(i)?g:".";if(r(i)){if(w=t=1,r(g.charCodeAt(1))){let o=2,u=o;for(;o<c&&!r(g.charCodeAt(o));)o++;if(o<c&&o!==u){for(u=o;o<c&&r(g.charCodeAt(o));)o++;if(o<c&&o!==u){for(u=o;o<c&&!r(g.charCodeAt(o));)o++;if(o===c)return g;o!==u&&(w=t=o+1)}}}}else p(i)&&g.charCodeAt(1)===T&&(w=c>2&&r(g.charCodeAt(2))?3:2,t=w);let l=-1,s=!0;for(let o=c-1;o>=t;--o)if(r(g.charCodeAt(o))){if(!s){l=o;break}}else s=!1;if(l===-1){if(w===-1)return".";l=w}return g.slice(0,l)},basename(g,c){c!==void 0&&h(c,"ext"),h(g,"path");let w=0,t=-1,i=!0,l;if(g.length>=2&&p(g.charCodeAt(0))&&g.charCodeAt(1)===T&&(w=2),c!==void 0&&c.length>0&&c.length<=g.length){if(c===g)return"";let s=c.length-1,o=-1;for(l=g.length-1;l>=w;--l){const u=g.charCodeAt(l);if(r(u)){if(!i){w=l+1;break}}else o===-1&&(i=!1,o=l+1),s>=0&&(u===c.charCodeAt(s)?--s==-1&&(t=l):(s=-1,t=o))}return w===t?t=o:t===-1&&(t=g.length),g.slice(w,t)}for(l=g.length-1;l>=w;--l)if(r(g.charCodeAt(l))){if(!i){w=l+1;break}}else t===-1&&(i=!1,t=l+1);return t===-1?"":g.slice(w,t)},extname(g){h(g,"path");let c=0,w=-1,t=0,i=-1,l=!0,s=0;g.length>=2&&g.charCodeAt(1)===T&&p(g.charCodeAt(0))&&(c=t=2);for(let o=g.length-1;o>=c;--o){const u=g.charCodeAt(o);if(r(u)){if(!l){t=o+1;break}continue}i===-1&&(l=!1,i=o+1),u===D?w===-1?w=o:s!==1&&(s=1):w!==-1&&(s=-1)}return w===-1||i===-1||s===0||s===1&&w===i-1&&w===t+1?"":g.slice(w,i)},format:b.bind(null,"\\"),parse(g){h(g,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return c;const w=g.length;let t=0,i=g.charCodeAt(0);if(w===1)return r(i)?(c.root=c.dir=g,c):(c.base=c.name=g,c);if(r(i)){if(t=1,r(g.charCodeAt(1))){let m=2,_=m;for(;m<w&&!r(g.charCodeAt(m));)m++;if(m<w&&m!==_){for(_=m;m<w&&r(g.charCodeAt(m));)m++;if(m<w&&m!==_){for(_=m;m<w&&!r(g.charCodeAt(m));)m++;m===w?t=m:m!==_&&(t=m+1)}}}}else if(p(i)&&g.charCodeAt(1)===T){if(w<=2)return c.root=c.dir=g,c;if(t=2,r(g.charCodeAt(2))){if(w===3)return c.root=c.dir=g,c;t=3}}t>0&&(c.root=g.slice(0,t));let l=-1,s=t,o=-1,u=!0,v=g.length-1,A=0;for(;v>=t;--v){if(i=g.charCodeAt(v),r(i)){if(!u){s=v+1;break}continue}o===-1&&(u=!1,o=v+1),i===D?l===-1?l=v:A!==1&&(A=1):l!==-1&&(A=-1)}return o!==-1&&(l===-1||A===0||A===1&&l===o-1&&l===s+1?c.base=c.name=g.slice(s,o):(c.name=g.slice(s,l),c.base=g.slice(s,o),c.ext=g.slice(l,o))),s>0&&s!==t?c.dir=g.slice(0,s-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let c="",w=!1;for(let t=g.length-1;t>=-1&&!w;t--){const i=t>=0?g[t]:E.cwd();h(i,"path"),i.length!==0&&(c=`${i}/${c}`,w=i.charCodeAt(0)===y)}return c=d(c,!w,"/",a),w?`/${c}`:c.length>0?c:"."},normalize(g){if(h(g,"path"),g.length===0)return".";const c=g.charCodeAt(0)===y,w=g.charCodeAt(g.length-1)===y;return g=d(g,!c,"/",a),g.length===0?c?"/":w?"./":".":(w&&(g+="/"),c?`/${g}`:g)},isAbsolute(g){return h(g,"path"),g.length>0&&g.charCodeAt(0)===y},join(...g){if(g.length===0)return".";let c;for(let w=0;w<g.length;++w){const t=g[w];h(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(g,c){if(h(g,"from"),h(c,"to"),g===c||(g=e.posix.resolve(g),c=e.posix.resolve(c),g===c))return"";const w=1,t=g.length,i=t-w,l=1,s=c.length-l,o=i<s?i:s;let u=-1,v=0;for(;v<o;v++){const m=g.charCodeAt(w+v);if(m!==c.charCodeAt(l+v))break;m===y&&(u=v)}if(v===o)if(s>o){if(c.charCodeAt(l+v)===y)return c.slice(l+v+1);if(v===0)return c.slice(l+v)}else i>o&&(g.charCodeAt(w+v)===y?u=v:v===0&&(u=0));let A="";for(v=w+u+1;v<=t;++v)(v===t||g.charCodeAt(v)===y)&&(A+=A.length===0?"..":"/..");return`${A}${c.slice(l+u)}`},toNamespacedPath(g){return g},dirname(g){if(h(g,"path"),g.length===0)return".";const c=g.charCodeAt(0)===y;let w=-1,t=!0;for(let i=g.length-1;i>=1;--i)if(g.charCodeAt(i)===y){if(!t){w=i;break}}else t=!1;return w===-1?c?"/":".":c&&w===1?"//":g.slice(0,w)},basename(g,c){c!==void 0&&h(c,"ext"),h(g,"path");let w=0,t=-1,i=!0,l;if(c!==void 0&&c.length>0&&c.length<=g.length){if(c===g)return"";let s=c.length-1,o=-1;for(l=g.length-1;l>=0;--l){const u=g.charCodeAt(l);if(u===y){if(!i){w=l+1;break}}else o===-1&&(i=!1,o=l+1),s>=0&&(u===c.charCodeAt(s)?--s==-1&&(t=l):(s=-1,t=o))}return w===t?t=o:t===-1&&(t=g.length),g.slice(w,t)}for(l=g.length-1;l>=0;--l)if(g.charCodeAt(l)===y){if(!i){w=l+1;break}}else t===-1&&(i=!1,t=l+1);return t===-1?"":g.slice(w,t)},extname(g){h(g,"path");let c=-1,w=0,t=-1,i=!0,l=0;for(let s=g.length-1;s>=0;--s){const o=g.charCodeAt(s);if(o===y){if(!i){w=s+1;break}continue}t===-1&&(i=!1,t=s+1),o===D?c===-1?c=s:l!==1&&(l=1):c!==-1&&(l=-1)}return c===-1||t===-1||l===0||l===1&&c===t-1&&c===w+1?"":g.slice(c,t)},format:b.bind(null,"/"),parse(g){h(g,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return c;const w=g.charCodeAt(0)===y;let t;w?(c.root="/",t=1):t=0;let i=-1,l=0,s=-1,o=!0,u=g.length-1,v=0;for(;u>=t;--u){const A=g.charCodeAt(u);if(A===y){if(!o){l=u+1;break}continue}s===-1&&(o=!1,s=u+1),A===D?i===-1?i=u:v!==1&&(v=1):i!==-1&&(v=-1)}if(s!==-1){const A=l===0&&w?1:l;i===-1||v===0||v===1&&i===s-1&&i===l+1?c.base=c.name=g.slice(A,s):(c.name=g.slice(A,i),c.base=g.slice(A,s),c.ext=g.slice(i,s))}return l>0?c.dir=g.slice(0,l-1):w&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=E.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E.platform==="win32"?e.win32.join:e.posix.join,e.resolve=E.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=E.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=E.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=E.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=E.platform==="win32"?e.win32.extname:e.posix.extname,e.format=E.platform==="win32"?e.win32.format:e.posix.format,e.parse=E.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=E.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=E.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[56],we([0,1,21]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const C=E.globals.performance&&typeof E.globals.performance.now=="function";class I{constructor(S){this._highResolution=C&&S,this._startTime=this._now(),this._stopTime=-1}static create(S=!0){return new I(S)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=I}),define(be[3],we([0,1,11,54,6,45,56]),function(Y,e,E,C,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(d){d.None=()=>I.Disposable.None;function b(z){return(W,J=null,O)=>{let F=!1,N;return N=z(B=>{if(!F)return N?N.dispose():F=!0,W.call(J,B)},null,O),F&&N.dispose(),N}}d.once=b;function g(z,W){return s((J,O=null,F)=>z(N=>J.call(O,W(N)),null,F))}d.map=g;function c(z,W){return s((J,O=null,F)=>z(N=>{W(N),J.call(O,N)},null,F))}d.forEach=c;function w(z,W){return s((J,O=null,F)=>z(N=>W(N)&&J.call(O,N),null,F))}d.filter=w;function t(z){return z}d.signal=t;function i(...z){return(W,J=null,O)=>(0,I.combinedDisposable)(...z.map(F=>F(N=>W.call(J,N),null,O)))}d.any=i;function l(z,W,J){let O=J;return g(z,F=>(O=W(O,F),O))}d.reduce=l;function s(z){let W;const J=new f({onFirstListenerAdd(){W=z(J.fire,J)},onLastListenerRemove(){W.dispose()}});return J.event}d.snapshot=s;function o(z,W,J=100,O=!1,F){let N,B,U,Q=0;const Z=new f({leakWarningThreshold:F,onFirstListenerAdd(){N=z(ne=>{Q++,B=W(B,ne),O&&!U&&(Z.fire(B),B=void 0),clearTimeout(U),U=setTimeout(()=>{const pe=B;B=void 0,U=void 0,(!O||Q>1)&&Z.fire(pe),Q=0},J)})},onLastListenerRemove(){N.dispose()}});return Z.event}d.debounce=o;function u(z){const W=new Date().getTime();return g(b(z),J=>new Date().getTime()-W)}d.stopwatch=u;function v(z){let W=!0,J;return w(z,O=>{const F=W||O!==J;return W=!1,J=O,F})}d.latch=v;function A(z,W=!1,J=[]){let O=J.slice(),F=z(U=>{O?O.push(U):B.fire(U)});const N=()=>{O&&O.forEach(U=>B.fire(U)),O=null},B=new f({onFirstListenerAdd(){F||(F=z(U=>B.fire(U)))},onFirstListenerDidAdd(){O&&(W?setTimeout(N):N())},onLastListenerRemove(){F&&F.dispose(),F=null}});return B.event}d.buffer=A;class m{constructor(W){this.event=W}map(W){return new m(g(this.event,W))}forEach(W){return new m(c(this.event,W))}filter(W){return new m(w(this.event,W))}reduce(W,J){return new m(l(this.event,W,J))}latch(){return new m(v(this.event))}debounce(W,J=100,O=!1,F){return new m(o(this.event,W,J,O,F))}on(W,J,O){return this.event(W,J,O)}once(W,J,O){return b(this.event)(W,J,O)}}function _(z){return new m(z)}d.chain=_;function R(z,W,J=O=>O){const O=(...U)=>B.fire(J(...U)),F=()=>z.on(W,O),N=()=>z.removeListener(W,O),B=new f({onFirstListenerAdd:F,onLastListenerRemove:N});return B.event}d.fromNodeEventEmitter=R;function L(z,W,J=O=>O){const O=(...U)=>B.fire(J(...U)),F=()=>z.addEventListener(W,O),N=()=>z.removeEventListener(W,O),B=new f({onFirstListenerAdd:F,onLastListenerRemove:N});return B.event}d.fromDOMEventEmitter=L;function V(z){const W=new f;let J=!1;return z.then(void 0,()=>null).then(()=>{J?W.fire(void 0):setTimeout(()=>W.fire(void 0),0)}),J=!0,W.event}d.fromPromise=V;function he(z){return new Promise(W=>b(z)(W))}d.toPromise=he})(D=e.Event||(e.Event={}));class y{constructor(b){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${b}_${y._idPool++}`}start(b){this._stopWatch=new S.StopWatch(!0),this._listenerCount=b}stop(){if(this._stopWatch){const b=this._stopWatch.elapsed();this._elapsedOverall+=b,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${b.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let n=-1;function T(d){const b=n;return n=d,{dispose(){n=b}}}e.setGlobalLeakWarningThreshold=T;class k{constructor(b,g=Math.random().toString(18).slice(2,5)){this.customThreshold=b,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(b){let g=n;if(typeof this.customThreshold=="number"&&(g=this.customThreshold),!(g<=0||b<g)){this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),w=this._stacks.get(c)||0;if(this._stacks.set(c,w+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=g*.5;let t,i=0;for(const[l,s]of this._stacks)(!t||i<s)&&(t=l,i=s);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}}class f{constructor(b){var g;this._disposed=!1,this._options=b,this._leakageMon=n>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((g=this._options)===null||g===void 0?void 0:g._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(b,g,c)=>{var w;this._listeners||(this._listeners=new P.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(g?[b,g]:b);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,b,g);const l=(w=this._leakageMon)===null||w===void 0?void 0:w.check(this._listeners.size);let s;return s={dispose:()=>{l&&l(),s.dispose=f._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof I.DisposableStore?c.add(s):Array.isArray(c)&&c.push(s),s}),this._event}fire(b){var g,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new P.LinkedList);for(let w of this._listeners)this._deliveryQueue.push([w,b]);for((g=this._perfMon)===null||g===void 0||g.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[w,t]=this._deliveryQueue.shift();try{typeof w=="function"?w.call(void 0,t):w[0].call(w[1],t)}catch(i){(0,E.onUnexpectedError)(i)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var b,g,c;(b=this._listeners)===null||b===void 0||b.clear(),(g=this._deliveryQueue)===null||g===void 0||g.clear(),(c=this._leakageMon)===null||c===void 0||c.dispose(),this._disposed=!0}}e.Emitter=f,f._noop=function(){};class h extends f{constructor(b){super(b);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=b==null?void 0:b.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const b=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(b))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(b){this._listeners&&(this._isPaused!==0?this._eventQueue.push(b):super.fire(b))}}e.PauseableEmitter=h;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(b){const g={event:b,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const c=()=>{this.hasListeners&&this.unhook(g);const w=this.events.indexOf(g);this.events.splice(w,1)};return(0,I.toDisposable)((0,C.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(b=>this.hook(b))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(b=>this.unhook(b))}hook(b){b.listener=b.event(g=>this.emitter.fire(g))}unhook(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class a{constructor(){this.buffers=[]}wrapEvent(b){return(g,c,w)=>b(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>g.call(c,t)):g.call(c,t)},void 0,w)}bufferEvents(b){const g=[];this.buffers.push(g);const c=b();return this.buffers.pop(),g.forEach(w=>w()),c}}e.EventBufferer=a;class p{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=I.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(b){this.inputEvent=b,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=b(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p}),define(be[20],we([0,1,3]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const C=Object.freeze(function(D,y){const n=setTimeout(D.bind(y),0);return{dispose(){clearTimeout(n)}}});var I;(function(D){function y(n){return n===D.None||n===D.Cancelled||n instanceof P?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}D.isCancellationToken=y,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(I=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?C:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class S{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=I.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=S}),define(be[36],we([0,1,3]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class C{constructor(){this._icons=new Map,this._onDidRegister=new E.Emitter}add(T){const k=this._icons.get(T.id);k?T.description?k.description=T.description:console.error(`Duplicate registration of codicon ${T.id}`):(this._icons.set(T.id,T),this._onDidRegister.fire(T))}get(T){return this._icons.get(T)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const I=new C;e.iconRegistry=I;function P(n,T){return new S(n,T)}e.registerCodicon=P;class S{constructor(T,k,f){this.id=T,this.definition=k,this.description=f,I.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=S;function D(n,T){const k=["codicon","codicon-"+n];return T&&k.push("codicon-modifier-"+T),k}e.getClassNamesArray=D;var y;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const T=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function k(r){if(r instanceof S)return["codicon","codicon-"+r.id];const a=T.exec(r.id);if(!a)return k(S.error);let[,p,d]=a;const b=["codicon","codicon-"+p];return d&&b.push("codicon-modifier-"+d.substr(1)),b}n.asClassNameArray=k;function f(r){return k(r).join(" ")}n.asClassName=f;function h(r){return"."+k(r).join(".")}n.asCSSSelector=h})(y=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(S=e.Codicon||(e.Codicon={}))}),define(be[108],we([0,1,11,6]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function I(d){const b=d;return b&&[b.on,b.pause,b.resume,b.destroy].every(g=>typeof g=="function")}e.isReadableStream=I;function P(d){const b=d;return b&&I(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean"}e.isReadableBufferedStream=P;function S(d,b){return new D(d,b)}e.newWriteableStream=S;class D{constructor(b,g){this.reducer=b,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(b){var g;if(!this.state.destroyed){if(this.state.flowing)this.emitData(b);else if(this.buffer.data.push(b),typeof((g=this.options)===null||g===void 0?void 0:g.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(b){this.state.destroyed||(this.state.flowing?this.emitError(b):this.buffer.error.push(b))}end(b){this.state.destroyed||(typeof b!="undefined"&&this.write(b),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(b){this.listeners.data.slice(0).forEach(g=>g(b))}emitError(b){this.listeners.error.length===0?(0,E.onUnexpectedError)(b):this.listeners.error.slice(0).forEach(g=>g(b))}emitEnd(){this.listeners.end.slice(0).forEach(b=>b())}on(b,g){if(!this.state.destroyed)switch(b){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(b,g){if(!this.state.destroyed){let c;switch(b){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const w=c.indexOf(g);w>=0&&c.splice(w,1)}}}flowData(){if(this.buffer.data.length>0){const b=this.reducer(this.buffer.data);this.emitData(b),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const b of this.buffer.error)this.emitError(b);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(d,b){const g=[];let c;for(;(c=d.read())!==null;)g.push(c);return b(g)}e.consumeReadable=y;function n(d,b,g){const c=[];let w;for(;(w=d.read())!==null&&c.length<g;)c.push(w);return w===null&&c.length>0?b(c):{read:()=>{if(c.length>0)return c.shift();if(typeof w!="undefined"){const t=w;return w=void 0,t}return d.read()}}}e.peekReadable=n;function T(d,b){return new Promise((g,c)=>{const w=[];k(d,{onData:t=>{b&&w.push(t)},onError:t=>{b?c(t):g(void 0)},onEnd:()=>{g(b?b(w):void 0)}})})}e.consumeStream=T;function k(d,b){d.on("error",g=>b.onError(g)),d.on("end",()=>b.onEnd()),d.on("data",g=>b.onData(g))}e.listenStream=k;function f(d,b){return new Promise((g,c)=>{const w=new C.DisposableStore,t=[],i=o=>{if(t.push(o),t.length>b)return w.dispose(),d.pause(),g({stream:d,buffer:t,ended:!1})},l=o=>c(o),s=()=>g({stream:d,buffer:t,ended:!0});w.add((0,C.toDisposable)(()=>d.removeListener("error",l))),d.on("error",l),w.add((0,C.toDisposable)(()=>d.removeListener("end",s))),d.on("end",s),w.add((0,C.toDisposable)(()=>d.removeListener("data",i))),d.on("data",i)})}e.peekStream=f;function h(d,b){const g=S(b);return g.end(d),g}e.toStream=h;function r(){const d=S(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=r;function a(d){let b=!1;return{read:()=>b?null:(b=!0,d)}}e.toReadable=a;function p(d,b,g){const c=S(g);return k(d,{onData:w=>c.write(b.data(w)),onError:w=>c.error(b.error?b.error(w):w),onEnd:()=>c.end()}),c}e.transform=p}),define(be[8],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function E(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=E;const C=/{(\d+)}/g;function I(H,...se){return se.length===0?H:H.replace(C,function(de,K){const ee=parseInt(K,10);return isNaN(ee)||ee<0||ee>=se.length?de:se[ee]})}e.format=I;function P(H){return H.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=P;function S(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function D(H,se){let de=0;const K=se.charCodeAt(0);for(let ee=H.length-1;ee>=0;ee--)H.charCodeAt(ee)===K&&de++;return de}e.count=D;function y(H,se,de="\u2026"){return H.length<=se?H:`${H.substr(0,se)}${de}`}e.truncate=y;function n(H,se=" "){const de=T(H,se);return k(de,se)}e.trim=n;function T(H,se){if(!H||!se)return H;const de=se.length;if(de===0||H.length===0)return H;let K=0;for(;H.indexOf(se,K)===K;)K=K+de;return H.substring(K)}e.ltrim=T;function k(H,se){if(!H||!se)return H;const de=se.length,K=H.length;if(de===0||K===0)return H;let ee=K,le=-1;for(;le=H.lastIndexOf(se,ee-1),!(le===-1||le+de!==ee);){if(le===0)return"";ee=le}return H.substring(0,ee)}e.rtrim=k;function f(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function h(H){return H.replace(/\*/g,"")}e.stripWildcards=h;function r(H,se,de={}){if(!H)throw new Error("Cannot create regex from empty string");se||(H=S(H)),de.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let K="";return de.global&&(K+="g"),de.matchCase||(K+="i"),de.multiline&&(K+="m"),de.unicode&&(K+="u"),new RegExp(H,K)}e.createRegExp=r;function a(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function p(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function d(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=d;function b(H){return H.split(/\r\n|\r|\n/)}e.splitLines=b;function g(H){for(let se=0,de=H.length;se<de;se++){const K=H.charCodeAt(se);if(K!==32&&K!==9)return se}return-1}e.firstNonWhitespaceIndex=g;function c(H,se=0,de=H.length){for(let K=se;K<de;K++){const ee=H.charCodeAt(K);if(ee!==32&&ee!==9)return H.substring(se,K)}return H.substring(se,de)}e.getLeadingWhitespace=c;function w(H,se=H.length-1){for(let de=se;de>=0;de--){const K=H.charCodeAt(de);if(K!==32&&K!==9)return de}return-1}e.lastNonWhitespaceIndex=w;function t(H,se){return H<se?-1:H>se?1:0}e.compare=t;function i(H,se,de=0,K=H.length,ee=0,le=se.length){for(;de<K&&ee<le;de++,ee++){let Ve=H.charCodeAt(de),Fe=se.charCodeAt(ee);if(Ve<Fe)return-1;if(Ve>Fe)return 1}const fe=K-de,Ee=le-ee;return fe<Ee?-1:fe>Ee?1:0}e.compareSubstring=i;function l(H,se){return s(H,se,0,H.length,0,se.length)}e.compareIgnoreCase=l;function s(H,se,de=0,K=H.length,ee=0,le=se.length){for(;de<K&&ee<le;de++,ee++){let Ve=H.charCodeAt(de),Fe=se.charCodeAt(ee);if(Ve!==Fe){const We=Ve-Fe;if(!(We===32&&u(Fe))&&!(We===-32&&u(Ve)))return o(Ve)&&o(Fe)?We:i(H.toLowerCase(),se.toLowerCase(),de,K,ee,le)}}const fe=K-de,Ee=le-ee;return fe<Ee?-1:fe>Ee?1:0}e.compareSubstringIgnoreCase=s;function o(H){return H>=97&&H<=122}e.isLowerAsciiLetter=o;function u(H){return H>=65&&H<=90}e.isUpperAsciiLetter=u;function v(H){return o(H)||u(H)}function A(H,se){return H.length===se.length&&m(H,se)}e.equalsIgnoreCase=A;function m(H,se,de=H.length){for(let K=0;K<de;K++){const ee=H.charCodeAt(K),le=se.charCodeAt(K);if(ee!==le){if(v(ee)&&v(le)){const fe=Math.abs(ee-le);if(fe!==0&&fe!==32)return!1}else if(String.fromCharCode(ee).toLowerCase()!==String.fromCharCode(le).toLowerCase())return!1}}return!0}function _(H,se){const de=se.length;return se.length>H.length?!1:m(H,se,de)}e.startsWithIgnoreCase=_;function R(H,se){let de,K=Math.min(H.length,se.length);for(de=0;de<K;de++)if(H.charCodeAt(de)!==se.charCodeAt(de))return de;return K}e.commonPrefixLength=R;function L(H,se){let de,K=Math.min(H.length,se.length);const ee=H.length-1,le=se.length-1;for(de=0;de<K;de++)if(H.charCodeAt(ee-de)!==se.charCodeAt(le-de))return de;return K}e.commonSuffixLength=L;function V(H){return 55296<=H&&H<=56319}e.isHighSurrogate=V;function he(H){return 56320<=H&&H<=57343}e.isLowSurrogate=he;function z(H,se){return(H-55296<<10)+(se-56320)+65536}e.computeCodePoint=z;function W(H,se,de){const K=H.charCodeAt(de);if(V(K)&&de+1<se){const ee=H.charCodeAt(de+1);if(he(ee))return z(K,ee)}return K}e.getNextCodePoint=W;function J(H,se){const de=H.charCodeAt(se-1);if(he(de)&&se>1){const K=H.charCodeAt(se-2);if(V(K))return z(K,de)}return de}function O(H,se){const de=$e.getInstance(),K=se,ee=H.length,le=W(H,ee,se);se+=le>=65536?2:1;let fe=de.getGraphemeBreakType(le);for(;se<ee;){const Ee=W(H,ee,se),Ve=de.getGraphemeBreakType(Ee);if(Ue(fe,Ve))break;se+=Ee>=65536?2:1,fe=Ve}return se-K}e.nextCharLength=O;function F(H,se){const de=$e.getInstance(),K=se,ee=J(H,se);se-=ee>=65536?2:1;let le=de.getGraphemeBreakType(ee);for(;se>0;){const fe=J(H,se),Ee=de.getGraphemeBreakType(fe);if(Ue(Ee,le))break;se-=fe>=65536?2:1,le=Ee}return K-se}e.prevCharLength=F;function N(H,se){const de=$e.getInstance(),K=H.length,ee=se,le=W(H,K,se),fe=de.getGraphemeBreakType(le);se+=le>=65536?2:1;let Ee=fe;for(;se<K;){const Fe=W(H,K,se),We=de.getGraphemeBreakType(Fe);if(Ue(Ee,We))break;se+=Fe>=65536?2:1,Ee=We}const Ve=se;for(se=ee,Ee=fe;se>0;){const Fe=J(H,se),We=de.getGraphemeBreakType(Fe);if(Ue(We,Ee))break;se-=Fe>=65536?2:1,Ee=We}return[se,Ve]}function B(H,se){return se>0&&he(H.charCodeAt(se))?N(H,se-1):N(H,se)}e.getCharContainingOffset=B;function U(H){const se=H.length;let de=0,K=0;for(;K<se;){const fe=W(H,se,K);K+=fe>=65536?2:1,fe<128?de+=1:fe<2048?de+=2:fe<65536?de+=3:de+=4}const ee=new Uint8Array(de);K=0;let le=0;for(;K<se;){const fe=W(H,se,K);K+=fe>=65536?2:1,fe<128?ee[le++]=fe:fe<2048?(ee[le++]=192|(fe&1984)>>>6,ee[le++]=128|(fe&63)>>>0):fe<65536?(ee[le++]=224|(fe&61440)>>>12,ee[le++]=128|(fe&4032)>>>6,ee[le++]=128|(fe&63)>>>0):(ee[le++]=240|(fe&1835008)>>>18,ee[le++]=128|(fe&258048)>>>12,ee[le++]=128|(fe&4032)>>>6,ee[le++]=128|(fe&63)>>>0)}return ee}e.encodeUTF8=U;function Q(H){const se=H.byteLength,de=[];let K=0;for(;K<se;){const ee=H[K];let le;if(ee>=240&&K+3<se?le=(H[K++]&7)<<18>>>0|(H[K++]&63)<<12>>>0|(H[K++]&63)<<6>>>0|(H[K++]&63)<<0>>>0:ee>=224&&K+2<se?le=(H[K++]&15)<<12>>>0|(H[K++]&63)<<6>>>0|(H[K++]&63)<<0>>>0:ee>=192&&K+1<se?le=(H[K++]&31)<<6>>>0|(H[K++]&63)<<0>>>0:le=H[K++],le>=0&&le<=55295||le>=57344&&le<=65535)de.push(String.fromCharCode(le));else if(le>=65536&&le<=1114111){const fe=le-65536,Ee=55296+((fe&1047552)>>>10),Ve=56320+((fe&1023)>>>0);de.push(String.fromCharCode(Ee)),de.push(String.fromCharCode(Ve))}else de.push(String.fromCharCode(65533))}return de.join("")}e.decodeUTF8=Q;const Z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ne(H){return Z.test(H)}e.containsRTL=ne;const pe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Pe(H){return pe.test(H)}e.containsEmoji=Pe;const Oe=/^[\t\n\r\x20-\x7E]*$/;function Te(H){return Oe.test(H)}e.isBasicASCII=Te,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function xe(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=xe;function $(H){for(let se=0,de=H.length;se<de;se++)if(G(H.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=$;function G(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=G;function ie(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=ie;function oe(H,se){if(H.length<se)return H;const de=/\b/g;let K=0;for(;de.test(H)&&!(H.length-de.lastIndex<se);)K=de.lastIndex,de.lastIndex+=1;return H.substring(K).replace(/^\s/,"")}e.lcut=oe;const me=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Ne=/\x1b\[0?m/g;function ge(H){return H&&(H=H.replace(me,""),H=H.replace(De,""),H=H.replace(Ne,"")),H}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Ae(H){return Ce(H)?H.substr(1):H}e.stripUTF8BOM=Ae;function Be(H,se){if(!H||!se||H.length<se.length)return!1;const de=se.length,K=H.toLowerCase();let ee=0,le=-1;for(;ee<de;){const fe=K.indexOf(se[ee],le+1);if(fe<0)return!1;le=fe,ee++}return!0}e.fuzzyContains=Be;function _e(H,se=!1){return H?(se&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=_e;function qe(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=qe;function j(H,se=1){if(se===0)return"";let de=-1;do de=H.indexOf(`
`,de+1),se--;while(se>0&&de>=0);return de===-1?H:(H[de-1]==="\r"&&de--,H.substr(0,de))}e.getNLines=j;function te(H){const se=90-65+1;return H=H%(2*se),H<se?String.fromCharCode(97+H):String.fromCharCode(65+H-se)}e.singleLetterHash=te;function ve(H){return $e.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=ve;function Ue(H,se){return H===0?se!==5&&se!==7:H===2&&se===3?!1:H===4||H===2||H===3||se===4||se===2||se===3?!0:!(H===8&&(se===8||se===9||se===11||se===12)||(H===11||H===9)&&(se===9||se===10)||(H===12||H===10)&&se===10||se===5||se===13||se===7||H===1||H===13&&se===14||H===6&&se===6)}e.breakBetweenGraphemeBreakType=Ue;var He;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Ye()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const de=this._data,K=de.length/3;let ee=1;for(;ee<=K;)if(se<de[3*ee])ee=2*ee;else if(se>de[3*ee+1])ee=2*ee+1;else return de[3*ee+2];return 0}}$e._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(be[23],we([0,1,8,108]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const I=typeof Buffer!="undefined",P=typeof TextEncoder!="undefined",S=typeof TextDecoder!="undefined";let D,y;class n{constructor(o){this.buffer=o,this.byteLength=this.buffer.byteLength}static alloc(o){return I?new n(Buffer.allocUnsafe(o)):new n(new Uint8Array(o))}static wrap(o){return I&&!Buffer.isBuffer(o)&&(o=Buffer.from(o.buffer,o.byteOffset,o.byteLength)),new n(o)}static fromString(o,u){return!((u==null?void 0:u.dontUseNodeBuffer)||!1)&&I?new n(Buffer.from(o)):P?(D||(D=new TextEncoder),new n(D.encode(o))):new n(E.encodeUTF8(o))}static concat(o,u){if(typeof u=="undefined"){u=0;for(let m=0,_=o.length;m<_;m++)u+=o[m].byteLength}const v=n.alloc(u);let A=0;for(let m=0,_=o.length;m<_;m++){const R=o[m];v.set(R,A),A+=R.byteLength}return v}toString(){return I?this.buffer.toString():S?(y||(y=new TextDecoder),y.decode(this.buffer)):E.decodeUTF8(this.buffer)}slice(o,u){return new n(this.buffer.subarray(o,u))}set(o,u){o instanceof n?this.buffer.set(o.buffer,u):this.buffer.set(o,u)}readUInt32BE(o){return f(this.buffer,o)}writeUInt32BE(o,u){h(this.buffer,o,u)}readUInt32LE(o){return r(this.buffer,o)}writeUInt32LE(o,u){a(this.buffer,o,u)}readUInt8(o){return p(this.buffer,o)}writeUInt8(o,u){d(this.buffer,o,u)}}e.VSBuffer=n;function T(s,o){return s[o+0]<<0>>>0|s[o+1]<<8>>>0}e.readUInt16LE=T;function k(s,o,u){s[u+0]=o&255,o=o>>>8,s[u+1]=o&255}e.writeUInt16LE=k;function f(s,o){return s[o]*2**24+s[o+1]*2**16+s[o+2]*2**8+s[o+3]}e.readUInt32BE=f;function h(s,o,u){s[u+3]=o,o=o>>>8,s[u+2]=o,o=o>>>8,s[u+1]=o,o=o>>>8,s[u]=o}e.writeUInt32BE=h;function r(s,o){return s[o+0]<<0>>>0|s[o+1]<<8>>>0|s[o+2]<<16>>>0|s[o+3]<<24>>>0}e.readUInt32LE=r;function a(s,o,u){s[u+0]=o&255,o=o>>>8,s[u+1]=o&255,o=o>>>8,s[u+2]=o&255,o=o>>>8,s[u+3]=o&255}e.writeUInt32LE=a;function p(s,o){return s[o]}e.readUInt8=p;function d(s,o,u){s[u]=o}e.writeUInt8=d;function b(s){return C.consumeReadable(s,o=>n.concat(o))}e.readableToBuffer=b;function g(s){return C.toReadable(s)}e.bufferToReadable=g;function c(s){return C.consumeStream(s,o=>n.concat(o))}e.streamToBuffer=c;async function w(s){return s.ended?n.concat(s.buffer):n.concat([...s.buffer,await c(s.stream)])}e.bufferedStreamToBuffer=w;function t(s){return C.toStream(s,o=>n.concat(o))}e.bufferToStream=t;function i(s){return C.transform(s,{data:o=>typeof o=="string"?n.fromString(o):n.wrap(o)},o=>n.concat(o))}e.streamToBufferReadableStream=i;function l(s){return C.newWriteableStream(o=>n.concat(o),s)}e.newWriteableBufferStream=l}),define(be[57],we([0,1,8]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function C(d){return I(d,0)}e.hash=C;function I(d,b){switch(typeof d){case"object":return d===null?P(349,b):Array.isArray(d)?y(d,b):n(d,b);case"string":return D(d,b);case"boolean":return S(d,b);case"number":return P(d,b);case"undefined":return P(937,b);default:return P(617,b)}}e.doHash=I;function P(d,b){return(b<<5)-b+d|0}function S(d,b){return P(d?433:863,b)}function D(d,b){b=P(149417,b);for(let g=0,c=d.length;g<c;g++)b=P(d.charCodeAt(g),b);return b}e.stringHash=D;function y(d,b){return b=P(104579,b),d.reduce((g,c)=>I(c,g),b)}function n(d,b){return b=P(181387,b),Object.keys(d).sort().reduce((g,c)=>(g=D(c,g),I(d[c],g)),b)}class T{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=I(b,this._value),this._value}}e.Hasher=T;var k;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function f(d,b,g=32){const c=g-b,w=~((1<<c)-1);return(d<<b|(w&d)>>>c)>>>0}function h(d,b=0,g=d.byteLength,c=0){for(let w=0;w<g;w++)d[b+w]=c}function r(d,b,g="0"){for(;d.length<b;)d=g+d;return d}function a(d,b=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(g=>g.toString(16).padStart(2,"0")).join(""):r((d>>>0).toString(16),b/4)}e.toHexString=a;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const g=b.length;if(g!==0){const c=this._buff;let w=this._buffLen,t=this._leftoverHighSurrogate,i,l;for(t!==0?(i=t,l=-1,t=0):(i=b.charCodeAt(0),l=0);;){let s=i;if(E.isHighSurrogate(i))if(l+1<g){const o=b.charCodeAt(l+1);E.isLowSurrogate(o)?(l++,s=E.computeCodePoint(i,o)):s=65533}else{t=i;break}else E.isLowSurrogate(i)&&(s=65533);if(w=this._push(c,w,s),l++,l<g)i=b.charCodeAt(l);else break}this._buffLen=w,this._leftoverHighSurrogate=t}}_push(b,g,c){return c<128?b[g++]=c:c<2048?(b[g++]=192|(c&1984)>>>6,b[g++]=128|(c&63)>>>0):c<65536?(b[g++]=224|(c&61440)>>>12,b[g++]=128|(c&4032)>>>6,b[g++]=128|(c&63)>>>0):(b[g++]=240|(c&1835008)>>>18,b[g++]=128|(c&258048)>>>12,b[g++]=128|(c&4032)>>>6,b[g++]=128|(c&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),a(this._h0)+a(this._h1)+a(this._h2)+a(this._h3)+a(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=p._bigBlock32,g=this._buffDV;for(let v=0;v<64;v+=4)b.setUint32(v,g.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)b.setUint32(v,f(b.getUint32(v-12,!1)^b.getUint32(v-32,!1)^b.getUint32(v-56,!1)^b.getUint32(v-64,!1),1),!1);let c=this._h0,w=this._h1,t=this._h2,i=this._h3,l=this._h4,s,o,u;for(let v=0;v<80;v++)v<20?(s=w&t|~w&i,o=1518500249):v<40?(s=w^t^i,o=1859775393):v<60?(s=w&t|w&i|t&i,o=2400959708):(s=w^t^i,o=3395469782),u=f(c,5)+s+l+o+b.getUint32(v*4,!1)&4294967295,l=i,i=t,t=f(w,30),w=c,c=u;this._h0=this._h0+c&4294967295,this._h1=this._h1+w&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+l&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),define(be[47],we([0,1,8]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(C||(C={})),function(I){const P="error",S="warning",D="warn",y="info";function n(T){return T?E.equalsIgnoreCase(P,T)?I.Error:E.equalsIgnoreCase(S,T)||E.equalsIgnoreCase(D,T)?I.Warning:E.equalsIgnoreCase(y,T)?I.Info:I.Ignore:I.Ignore}I.fromValue=n}(C||(C={})),e.default=C}),define(be[10],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function E(v){return Array.isArray(v)}e.isArray=E;function C(v){return typeof v=="string"}e.isString=C;function I(v){return Array.isArray(v)&&v.every(A=>C(A))}e.isStringArray=I;function P(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.isObject=P;function S(v){return typeof v=="number"&&!isNaN(v)}e.isNumber=S;function D(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.isIterable=D;function y(v){return v===!0||v===!1}e.isBoolean=y;function n(v){return typeof v=="undefined"}e.isUndefined=n;function T(v){return!k(v)}e.isDefined=T;function k(v){return n(v)||v===null}e.isUndefinedOrNull=k;function f(v,A){if(!v)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}e.assertType=f;function h(v){if(k(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.assertIsDefined=h;function r(...v){const A=[];for(let m=0;m<v.length;m++){const _=v[m];if(k(_))throw new Error(`Assertion Failed: argument at index ${m} is undefined or null`);A.push(_)}return A}e.assertAllDefined=r;const a=Object.prototype.hasOwnProperty;function p(v){if(!P(v))return!1;for(let A in v)if(a.call(v,A))return!1;return!0}e.isEmptyObject=p;function d(v){return typeof v=="function"}e.isFunction=d;function b(...v){return v.length>0&&v.every(d)}e.areFunctions=b;function g(v,A){const m=Math.min(v.length,A.length);for(let _=0;_<m;_++)c(v[_],A[_])}e.validateConstraints=g;function c(v,A){if(C(A)){if(typeof v!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(d(A)){try{if(v instanceof A)return}catch(m){}if(!k(v)&&v.constructor===A||A.length===1&&A.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function w(v){let A=[],m=Object.getPrototypeOf(v);for(;Object.prototype!==m;)A=A.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return A}e.getAllPropertyNames=w;function t(v){const A=[];for(const m of w(v))typeof v[m]=="function"&&A.push(m);return A}e.getAllMethodNames=t;function i(v,A){const m=R=>function(){const L=Array.prototype.slice.call(arguments,0);return A(R,L)};let _={};for(const R of v)_[R]=m(R);return _}e.createProxyObject=i;function l(v){return v===null?void 0:v}e.withNullAsUndefined=l;function s(v){return typeof v=="undefined"?null:v}e.withUndefinedAsNull=s;function o(v){return class{constructor(){return new Proxy({},{get(A,m){if(A[m])return A[m];throw new Error(`Not Implemented: ${v}->${String(m)}`)}})}}}e.NotImplementedProxy=o;function u(v){throw new Error("Unreachable")}e.assertNever=u}),define(be[37],we([0,1,21,8,13,10]),function(Y,e,E,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function S(i){return i===47||i===92}e.isPathSeparator=S;function D(i){return i.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=D;function y(i,l=I.posix.sep){if(!i)return"";const s=i.length,o=i.charCodeAt(0);if(S(o)){if(S(i.charCodeAt(1))&&!S(i.charCodeAt(2))){let v=3;const A=v;for(;v<s&&!S(i.charCodeAt(v));v++);if(A!==v&&!S(i.charCodeAt(v+1))){for(v+=1;v<s;v++)if(S(i.charCodeAt(v)))return i.slice(0,v+1).replace(/[\\/]/g,l)}}return l}else if(p(o)&&i.charCodeAt(1)===58)return S(i.charCodeAt(2))?i.slice(0,2)+l:i.slice(0,2);let u=i.indexOf("://");if(u!==-1){for(u+=3;u<s;u++)if(S(i.charCodeAt(u)))return i.slice(0,u+1)}return""}e.getRoot=y;function n(i){if(!E.isWindows||!i||i.length<5)return!1;let l=i.charCodeAt(0);if(l!==92||(l=i.charCodeAt(1),l!==92))return!1;let s=2;const o=s;for(;s<i.length&&(l=i.charCodeAt(s),l!==92);s++);return!(o===s||(l=i.charCodeAt(s+1),isNaN(l)||l===92))}e.isUNC=n;const T=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(i,l=E.isWindows){const s=l?T:k;return!(!i||i.length===0||/^\s+$/.test(i)||(s.lastIndex=0,s.test(i))||l&&f.test(i)||i==="."||i===".."||l&&i[i.length-1]==="."||l&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=h;function r(i,l,s){const o=i===l;return!s||o?o:!i||!l?!1:(0,C.equalsIgnoreCase)(i,l)}e.isEqual=r;function a(i,l,s,o=I.sep){if(i===l)return!0;if(!i||!l||l.length>i.length)return!1;if(s){if(!(0,C.startsWithIgnoreCase)(i,l))return!1;if(l.length===i.length)return!0;let v=l.length;return l.charAt(l.length-1)===o&&v--,i.charAt(v)===o}return l.charAt(l.length-1)!==o&&(l+=o),i.indexOf(l)===0}e.isEqualOrParent=a;function p(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=p;function d(i,l){return E.isWindows&&i.endsWith(":")&&(i+=I.sep),(0,I.isAbsolute)(i)||(i=(0,I.join)(l,i)),i=(0,I.normalize)(i),E.isWindows?(i=(0,C.rtrim)(i,I.sep),i.endsWith(":")&&(i+=I.sep)):(i=(0,C.rtrim)(i,I.sep),i||(i=I.sep)),i}e.sanitizeFilePath=d;function b(i){const l=(0,I.normalize)(i);return E.isWindows?i.length>3?!1:g(l)&&(i.length===2||l.charCodeAt(2)===92):l===I.posix.sep}e.isRootOrDriveLetter=b;function g(i){return E.isWindows?p(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function c(i){return g(i)?i[0]:void 0}e.getDriveLetter=c;function w(i,l,s){return l.length>i.length?-1:i===l?0:(s&&(i=i.toLowerCase(),l=l.toLowerCase()),i.indexOf(l))}e.indexOfPath=w;function t(i){const l=i.split(":");let s,o,u;if(l.forEach(v=>{const A=Number(v);(0,P.isNumber)(A)?o===void 0?o=A:u===void 0&&(u=A):s=s?[s,v].join(":"):v}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:o!==void 0?o:void 0,column:u!==void 0?u:o!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(be[24],we([0,1,10]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function C(r){if(!r||typeof r!="object"||r instanceof RegExp)return r;const a=Array.isArray(r)?[]:{};return Object.keys(r).forEach(p=>{r[p]&&typeof r[p]=="object"?a[p]=C(r[p]):a[p]=r[p]}),a}e.deepClone=C;function I(r){if(!r||typeof r!="object")return r;const a=[r];for(;a.length>0;){const p=a.shift();Object.freeze(p);for(const d in p)if(P.call(p,d)){const b=p[d];typeof b=="object"&&!Object.isFrozen(b)&&a.push(b)}}return r}e.deepFreeze=I;const P=Object.prototype.hasOwnProperty;function S(r,a){return D(r,a,new Set)}e.cloneAndChange=S;function D(r,a,p){if((0,E.isUndefinedOrNull)(r))return r;const d=a(r);if(typeof d!="undefined")return d;if((0,E.isArray)(r)){const b=[];for(const g of r)b.push(D(g,a,p));return b}if((0,E.isObject)(r)){if(p.has(r))throw new Error("Cannot clone recursive data-structure");p.add(r);const b={};for(let g in r)P.call(r,g)&&(b[g]=D(r[g],a,p));return p.delete(r),b}return r}function y(r,a,p=!0){return(0,E.isObject)(r)?((0,E.isObject)(a)&&Object.keys(a).forEach(d=>{d in r?p&&((0,E.isObject)(r[d])&&(0,E.isObject)(a[d])?y(r[d],a[d],p):r[d]=a[d]):r[d]=a[d]}),r):a}e.mixin=y;function n(r,a){if(r===a)return!0;if(r==null||a===null||a===void 0||typeof r!=typeof a||typeof r!="object"||Array.isArray(r)!==Array.isArray(a))return!1;let p,d;if(Array.isArray(r)){if(r.length!==a.length)return!1;for(p=0;p<r.length;p++)if(!n(r[p],a[p]))return!1}else{const b=[];for(d in r)b.push(d);b.sort();const g=[];for(d in a)g.push(d);if(g.sort(),!n(b,g))return!1;for(p=0;p<b.length;p++)if(!n(r[b[p]],a[b[p]]))return!1}return!0}e.equals=n;function T(r){const a=new Set;return JSON.stringify(r,(p,d)=>{if((0,E.isObject)(d)||Array.isArray(d)){if(a.has(d))return"[Circular]";a.add(d)}return d})}e.safeStringify=T;function k(r,a,p){const d=a(r);return typeof d=="undefined"?p:d}e.getOrDefault=k;function f(r,a){const p=Object.create(null);return!r||!a||Object.keys(a).forEach(b=>{const g=r[b],c=a[b];n(g,c)||(p[b]=c)}),p}e.distinct=f;function h(r,a){const p=a.toLowerCase(),d=Object.keys(r).find(b=>b.toLowerCase()===p);return d?r[d]:r[a]}e.getCaseInsensitive=h}),define(be[82],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var E;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(E=e.Constants||(e.Constants={}));function C(P){return P<0?0:P>255?255:P|0}e.toUint8=C;function I(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=I}),define(be[2],we([0,1,21,13]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,P=/^\//,S=/^\/\//;function D(l,s){if(!l.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!I.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!P.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(l,s){return!l&&!s?"file":l}function n(l,s){switch(l){case"https":case"http":case"file":s?s[0]!==k&&(s=k+s):s=k;break}return s}const T="",k="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(s,o,u,v,A,m=!1){typeof s=="object"?(this.scheme=s.scheme||T,this.authority=s.authority||T,this.path=s.path||T,this.query=s.query||T,this.fragment=s.fragment||T):(this.scheme=y(s,m),this.authority=o||T,this.path=n(this.scheme,u||T),this.query=v||T,this.fragment=A||T,D(this,m))}static isUri(s){return s instanceof h?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return g(this,!1)}with(s){if(!s)return this;let{scheme:o,authority:u,path:v,query:A,fragment:m}=s;return o===void 0?o=this.scheme:o===null&&(o=T),u===void 0?u=this.authority:u===null&&(u=T),v===void 0?v=this.path:v===null&&(v=T),A===void 0?A=this.query:A===null&&(A=T),m===void 0?m=this.fragment:m===null&&(m=T),o===this.scheme&&u===this.authority&&v===this.path&&A===this.query&&m===this.fragment?this:new a(o,u,v,A,m)}static parse(s,o=!1){const u=f.exec(s);return u?new a(u[2]||T,i(u[4]||T),i(u[5]||T),i(u[7]||T),i(u[9]||T),o):new a(T,T,T,T,T)}static file(s){let o=T;if(E.isWindows&&(s=s.replace(/\\/g,k)),s[0]===k&&s[1]===k){const u=s.indexOf(k,2);u===-1?(o=s.substring(2),s=k):(o=s.substring(2,u),s=s.substring(u)||k)}return new a("file",o,s,T,T)}static from(s){return new a(s.scheme,s.authority,s.path,s.query,s.fragment)}static joinPath(s,...o){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return E.isWindows&&s.scheme==="file"?u=h.file(C.win32.join(g(s,!0),...o)).path:u=C.posix.join(s.path,...o),s.with({path:u})}toString(s=!1){return c(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof h)return s;{const o=new a(s);return o._formatted=s.external,o._fsPath=s._sep===r?s.fsPath:null,o}}else return s}}e.URI=h;const r=E.isWindows?1:void 0;class a extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(s=!1){return s?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=r),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(l,s){let o,u=-1;for(let v=0;v<l.length;v++){const A=l.charCodeAt(v);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||s&&A===47)u!==-1&&(o+=encodeURIComponent(l.substring(u,v)),u=-1),o!==void 0&&(o+=l.charAt(v));else{o===void 0&&(o=l.substr(0,v));const m=p[A];m!==void 0?(u!==-1&&(o+=encodeURIComponent(l.substring(u,v)),u=-1),o+=m):u===-1&&(u=v)}}return u!==-1&&(o+=encodeURIComponent(l.substring(u))),o!==void 0?o:l}function b(l){let s;for(let o=0;o<l.length;o++){const u=l.charCodeAt(o);u===35||u===63?(s===void 0&&(s=l.substr(0,o)),s+=p[u]):s!==void 0&&(s+=l[o])}return s!==void 0?s:l}function g(l,s){let o;return l.authority&&l.path.length>1&&l.scheme==="file"?o=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?s?o=l.path.substr(1):o=l.path[1].toLowerCase()+l.path.substr(2):o=l.path,E.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=g;function c(l,s){const o=s?b:d;let u="",{scheme:v,authority:A,path:m,query:_,fragment:R}=l;if(v&&(u+=v,u+=":"),(A||v==="file")&&(u+=k,u+=k),A){let L=A.indexOf("@");if(L!==-1){const V=A.substr(0,L);A=A.substr(L+1),L=V.indexOf(":"),L===-1?u+=o(V,!1):(u+=o(V.substr(0,L),!1),u+=":",u+=o(V.substr(L+1),!1)),u+="@"}A=A.toLowerCase(),L=A.indexOf(":"),L===-1?u+=o(A,!1):(u+=o(A.substr(0,L),!1),u+=A.substr(L))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const L=m.charCodeAt(1);L>=65&&L<=90&&(m=`/${String.fromCharCode(L+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const L=m.charCodeAt(0);L>=65&&L<=90&&(m=`${String.fromCharCode(L+32)}:${m.substr(2)}`)}u+=o(m,!0)}return _&&(u+="?",u+=o(_,!1)),R&&(u+="#",u+=s?R:d(R,!1)),u}function w(l){try{return decodeURIComponent(l)}catch(s){return l.length>3?l.substr(0,3)+w(l.substr(3)):l}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(l){return l.match(t)?l.replace(t,s=>w(s)):l}});var tt=this&&this.__classPrivateFieldSet||function(Y,e,E,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(Y,E):I?I.value=E:e.set(Y,E),E},Me=this&&this.__classPrivateFieldGet||function(Y,e,E,C){if(E==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?C:E==="a"?C.call(Y):C?C.value:e.get(Y)};define(be[22],we([0,1,2,8]),function(Y,e,E,C){"use strict";var I,P,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(t,i,l){let s=t.get(i);return s===void 0&&(s=l,t.set(i,s)),s}e.getOrSet=D;function y(t){const i=[];return t.forEach((l,s)=>{i.push(`${s} => ${l}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=y;function n(t){const i=[];return t.forEach(l=>{i.push(l)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=n;class T{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const l=i.charCodeAt(0),s=this._value.charCodeAt(this._pos);return l-s}value(){return this._value[this._pos]}}e.StringIterator=T;class k{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,C.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class f{constructor(i=!0,l=!0){this._splitOnBackslash=i,this._caseSensitive=l}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const l=this._value.charCodeAt(this._to);if(l===47||this._splitOnBackslash&&l===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,C.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var h;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(h||(h={}));class r{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,C.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,C.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,C.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,C.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=r;class a{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class p{constructor(i){this._iter=i}static forUris(i=()=>!1){return new p(new r(i))}static forPaths(){return new p(new f)}static forStrings(){return new p(new T)}static forConfigKeys(){return new p(new k)}clear(){this._root=void 0}set(i,l){const s=this._iter.reset(i);let o;for(this._root||(this._root=new a,this._root.segment=s.value()),o=this._root;;){const v=s.cmp(o.segment);if(v>0)o.left||(o.left=new a,o.left.segment=s.value()),o=o.left;else if(v<0)o.right||(o.right=new a,o.right.segment=s.value()),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new a,o.mid.segment=s.value()),o=o.mid;else break}const u=o.value;return o.value=l,o.key=i,u}get(i){var l;return(l=this._getNode(i))===null||l===void 0?void 0:l.value}_getNode(i){const l=this._iter.reset(i);let s=this._root;for(;s;){const o=l.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(l.hasNext())l.next(),s=s.mid;else break}return s}has(i){const l=this._getNode(i);return!((l==null?void 0:l.value)===void 0&&(l==null?void 0:l.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,l){const s=this._iter.reset(i),o=[];let u=this._root;for(;u;){const v=s.cmp(u.segment);if(v>0)o.push([1,u]),u=u.left;else if(v<0)o.push([-1,u]),u=u.right;else if(s.hasNext())s.next(),o.push([0,u]),u=u.mid;else{for(l?(u.left=void 0,u.mid=void 0,u.right=void 0):u.value=void 0;o.length>0&&u.isEmpty();){let[A,m]=o.pop();switch(A){case 1:m.left=void 0;break;case 0:m.mid=void 0;break;case-1:m.right=void 0;break}u=m}break}}}findSubstr(i){const l=this._iter.reset(i);let s=this._root,o;for(;s;){const u=l.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(l.hasNext())l.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(i){const l=this._iter.reset(i);let s=this._root;for(;s;){const o=l.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(l.hasNext())l.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(i){for(const[l,s]of this)i(s,l)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){i&&(yield*this._entries(i.left),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid),yield*this._entries(i.right))}}e.TernarySearchTree=p;class d{constructor(i,l){this[I]="ResourceMap",i instanceof d?(this.map=new Map(i.map),this.toKey=l!=null?l:d.defaultToKey):(this.map=new Map,this.toKey=i!=null?i:d.defaultToKey)}set(i,l){return this.map.set(this.toKey(i),l),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,l){typeof l!="undefined"&&(i=i.bind(l));for(let[s,o]of this.map)i(o,E.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield E.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[E.URI.parse(i[0]),i[1]]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[E.URI.parse(i[0]),i[1]]}}e.ResourceMap=d,d.defaultToKey=t=>t.toString();var b;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class g{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,l=0){const s=this._map.get(i);if(!!s)return l!==0&&this.touch(s,l),s.value}set(i,l,s=0){let o=this._map.get(i);if(o)o.value=l,s!==0&&this.touch(o,s);else{switch(o={key:i,value:l,next:void 0,previous:void 0},s){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(i,o),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const l=this._map.get(i);if(!!l)return this._map.delete(i),this.removeItem(l),this._size--,l.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}}forEach(i,l){const s=this._state;let o=this._head;for(;o;){if(l?i.bind(l)(o.value,o.key,this):i(o.value,o.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,l=this._state;let s=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==l)throw new Error("LinkedMap got modified during iteration.");if(s){const u={value:s.key,done:!1};return s=s.next,u}else return{value:void 0,done:!0}}};return o}values(){const i=this,l=this._state;let s=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==l)throw new Error("LinkedMap got modified during iteration.");if(s){const u={value:s.value,done:!1};return s=s.next,u}else return{value:void 0,done:!0}}};return o}entries(){const i=this,l=this._state;let s=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==l)throw new Error("LinkedMap got modified during iteration.");if(s){const u={value:[s.key,s.value],done:!1};return s=s.next,u}else return{value:void 0,done:!0}}};return o}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(!(i>=this.size)){if(i===0){this.clear();return}let l=this._head,s=this.size;for(;l&&s>i;)this._map.delete(l.key),l=l.next,s--;this._head=l,this._size=s,l&&(l.previous=void 0),this._state++}}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const l=i.next,s=i.previous;if(!l||!s)throw new Error("Invalid list");l.previous=s,s.next=l}i.next=void 0,i.previous=void 0,this._state++}touch(i,l){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(i===this._head)return;const s=i.next,o=i.previous;i===this._tail?(o.next=void 0,this._tail=o):(s.previous=o,o.next=s),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(l===2){if(i===this._tail)return;const s=i.next,o=i.previous;i===this._head?(s.previous=void 0,this._head=s):(s.previous=o,o.next=s),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((l,s)=>{i.push([s,l])}),i}fromJSON(i){this.clear();for(const[l,s]of i)this.set(l,s)}}e.LinkedMap=g;class c extends g{constructor(i,l=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,l),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,l=2){return super.get(i,l)}peek(i){return super.get(i,0)}set(i,l){return super.set(i,l,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class w{constructor(i){S.set(this,void 0),tt(this,S,i,"f")}get size(){return Me(this,S,"f").size}forEach(i,l){Me(this,S,"f").forEach(i,l)}get(i){return Me(this,S,"f").get(i)}has(i){return Me(this,S,"f").has(i)}entries(){return Me(this,S,"f").entries()}keys(){return Me(this,S,"f").keys()}values(){return Me(this,S,"f").values()}[(S=new WeakMap,Symbol.iterator)](){return Me(this,S,"f").entries()}}e.ReadonlyMapView=w}),define(be[109],we([0,1,22,8]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...ge){return function(Ce,Ae){for(let Be=0,_e=ge.length;Be<_e;Be++){const qe=ge[Be](Ce,Ae);if(qe)return qe}return null}}e.or=I,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(ge,Ce,Ae){if(!Ae||Ae.length<Ce.length)return null;let Be;return ge?Be=C.startsWithIgnoreCase(Ae,Ce):Be=Ae.indexOf(Ce)===0,Be?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function S(ge,Ce){const Ae=Ce.toLowerCase().indexOf(ge.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+ge.length}]}e.matchesContiguousSubString=S;function D(ge,Ce){return y(ge.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=D;function y(ge,Ce,Ae,Be){if(Ae===ge.length)return[];if(Be===Ce.length)return null;if(ge[Ae]===Ce[Be]){let _e=null;return(_e=y(ge,Ce,Ae+1,Be+1))?d({start:Be,end:Be+1},_e):null}return y(ge,Ce,Ae,Be+1)}function n(ge){return 97<=ge&&ge<=122}function T(ge){return 65<=ge&&ge<=90}e.isUpper=T;function k(ge){return 48<=ge&&ge<=57}function f(ge){return ge===32||ge===9||ge===10||ge===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(ge=>h.add(ge.charCodeAt(0)));function r(ge){return f(ge)||h.has(ge)}function a(ge,Ce){return ge===Ce||r(ge)&&r(Ce)}function p(ge){return n(ge)||T(ge)||k(ge)}function d(ge,Ce){return Ce.length===0?Ce=[ge]:ge.end===Ce[0].start?Ce[0].start=ge.start:Ce.unshift(ge),Ce}function b(ge,Ce){for(let Ae=Ce;Ae<ge.length;Ae++){const Be=ge.charCodeAt(Ae);if(T(Be)||k(Be)||Ae>0&&!p(ge.charCodeAt(Ae-1)))return Ae}return ge.length}function g(ge,Ce,Ae,Be){if(Ae===ge.length)return[];if(Be===Ce.length)return null;if(ge[Ae]!==Ce[Be].toLowerCase())return null;{let _e=null,qe=Be+1;for(_e=g(ge,Ce,Ae+1,Be+1);!_e&&(qe=b(Ce,qe))<Ce.length;)_e=g(ge,Ce,Ae+1,qe),qe++;return _e===null?null:d({start:Be,end:Be+1},_e)}}function c(ge){let Ce=0,Ae=0,Be=0,_e=0,qe=0;for(let He=0;He<ge.length;He++)qe=ge.charCodeAt(He),T(qe)&&Ce++,n(qe)&&Ae++,p(qe)&&Be++,k(qe)&&_e++;const j=Ce/ge.length,te=Ae/ge.length,ve=Be/ge.length,Ue=_e/ge.length;return{upperPercent:j,lowerPercent:te,alphaPercent:ve,numericPercent:Ue}}function w(ge){const{upperPercent:Ce,lowerPercent:Ae}=ge;return Ae===0&&Ce>.6}function t(ge){const{upperPercent:Ce,lowerPercent:Ae,alphaPercent:Be,numericPercent:_e}=ge;return Ae>.2&&Ce<.8&&Be>.6&&_e<.2}function i(ge){let Ce=0,Ae=0,Be=0,_e=0;for(let qe=0;qe<ge.length;qe++)Be=ge.charCodeAt(qe),T(Be)&&Ce++,n(Be)&&Ae++,f(Be)&&_e++;return(Ce===0||Ae===0)&&_e===0?ge.length<=30:Ce<=5}function l(ge,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!i(ge)||Ce.length>60)return null;const Ae=c(Ce);if(!t(Ae)){if(!w(Ae))return null;Ce=Ce.toLowerCase()}let Be=null,_e=0;for(ge=ge.toLowerCase();_e<Ce.length&&(Be=g(ge,Ce,0,_e))===null;)_e=b(Ce,_e+1);return Be}e.matchesCamelCase=l;function s(ge,Ce,Ae=!1){if(!Ce||Ce.length===0)return null;let Be=null,_e=0;for(ge=ge.toLowerCase(),Ce=Ce.toLowerCase();_e<Ce.length&&(Be=o(ge,Ce,0,_e,Ae))===null;)_e=u(Ce,_e+1);return Be}e.matchesWords=s;function o(ge,Ce,Ae,Be,_e){if(Ae===ge.length)return[];if(Be===Ce.length)return null;if(a(ge.charCodeAt(Ae),Ce.charCodeAt(Be))){let qe=null,j=Be+1;if(qe=o(ge,Ce,Ae+1,Be+1,_e),!_e)for(;!qe&&(j=u(Ce,j))<Ce.length;)qe=o(ge,Ce,Ae+1,j,_e),j++;return qe===null?null:d({start:Be,end:Be+1},qe)}else return null}function u(ge,Ce){for(let Ae=Ce;Ae<ge.length;Ae++)if(r(ge.charCodeAt(Ae))||Ae>0&&r(ge.charCodeAt(Ae-1)))return Ae;return ge.length}const v=I(e.matchesPrefix,l,S),A=I(e.matchesPrefix,l,D),m=new E.LRUCache(1e4);function _(ge,Ce,Ae=!1){if(typeof ge!="string"||typeof Ce!="string")return null;let Be=m.get(ge);Be||(Be=new RegExp(C.convertSimple2RegExpPattern(ge),"i"),m.set(ge,Be));const _e=Be.exec(Ce);return _e?[{start:_e.index,end:_e.index+_e[0].length}]:Ae?A(ge,Ce):v(ge,Ce)}e.matchesFuzzy=_;function R(ge,Ce){const Ae=$(ge,ge.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Ae?V(Ae):null}e.matchesFuzzy2=R;function L(ge,Ce,Ae,Be,_e,qe){const j=Math.min(13,ge.length);for(;Ae<j;Ae++){const te=$(ge,Ce,Ae,Be,_e,qe,!1);if(te)return te}return[0,qe]}e.anyScore=L;function V(ge){if(typeof ge=="undefined")return[];const Ce=[],Ae=ge[1];for(let Be=ge.length-1;Be>1;Be--){const _e=ge[Be]+Ae,qe=Ce[Ce.length-1];qe&&qe.end===_e?qe.end=_e+1:Ce.push({start:_e,end:_e+1})}return Ce}e.createMatches=V;const he=128;function z(){const ge=[],Ce=[];for(let Ae=0;Ae<=he;Ae++)Ce[Ae]=0;for(let Ae=0;Ae<=he;Ae++)ge.push(Ce.slice(0));return ge}function W(ge){const Ce=[];for(let Ae=0;Ae<=ge;Ae++)Ce[Ae]=0;return Ce}const J=W(2*he),O=W(2*he),F=z(),N=z(),B=z(),U=!1;function Q(ge,Ce,Ae,Be,_e){function qe(te,ve,Ue=" "){for(;te.length<ve;)te=Ue+te;return te}let j=` |   |${Be.split("").map(te=>qe(te,3)).join("|")}
`;for(let te=0;te<=Ae;te++)te===0?j+=" |":j+=`${Ce[te-1]}|`,j+=ge[te].slice(0,_e+1).map(ve=>qe(ve.toString(),3)).join("|")+`
`;return j}function Z(ge,Ce,Ae,Be){ge=ge.substr(Ce),Ae=Ae.substr(Be),console.log(Q(N,ge,ge.length,Ae,Ae.length)),console.log(Q(B,ge,ge.length,Ae,Ae.length)),console.log(Q(F,ge,ge.length,Ae,Ae.length))}function ne(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;const Ae=ge.codePointAt(Ce);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise(Ae)}}function pe(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;switch(ge.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Pe(ge,Ce,Ae){return Ce[ge]!==Ae[ge]}function Oe(ge,Ce,Ae,Be,_e,qe,j=!1){for(;Ce<Ae&&_e<qe;)ge[Ce]===Be[_e]&&(j&&(J[Ce]=_e),Ce+=1),_e+=1;return Ce===Ae}e.isPatternInWord=Oe;var Te;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(Te||(Te={}));var xe;(function(ge){ge.Default=[-100,0];function Ce(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}ge.isDefault=Ce})(xe=e.FuzzyScore||(e.FuzzyScore={}));function $(ge,Ce,Ae,Be,_e,qe,j){const te=ge.length>he?he:ge.length,ve=Be.length>he?he:Be.length;if(!(Ae>=te||qe>=ve||te-Ae>ve-qe)&&!!Oe(Ce,Ae,te,_e,qe,ve,!0)){G(te,ve,Ae,qe,Ce,_e);let Ue=1,He=1,$e=Ae,Ye=qe;const H=[!1];for(Ue=1,$e=Ae;$e<te;Ue++,$e++){const le=J[$e],fe=O[$e],Ee=$e+1<te?O[$e+1]:ve;for(He=le-qe+1,Ye=le;Ye<Ee;He++,Ye++){let Ve=Number.MIN_SAFE_INTEGER,Fe=!1;Ye<=fe&&(Ve=ie(ge,Ce,$e,Ae,Be,_e,Ye,ve,qe,F[Ue-1][He-1]===0,H));let We=0;Ve!==Number.MAX_SAFE_INTEGER&&(Fe=!0,We=Ve+N[Ue-1][He-1]);const Qe=Ye>le,it=Qe?N[Ue][He-1]+(F[Ue][He-1]>0?-5:0):0,at=Ye>le+1&&F[Ue][He-1]>0,Ze=at?N[Ue][He-2]+(F[Ue][He-2]>0?-5:0):0;if(at&&(!Qe||Ze>=it)&&(!Fe||Ze>=We))N[Ue][He]=Ze,B[Ue][He]=3,F[Ue][He]=0;else if(Qe&&(!Fe||it>=We))N[Ue][He]=it,B[Ue][He]=2,F[Ue][He]=0;else if(Fe)N[Ue][He]=We,B[Ue][He]=1,F[Ue][He]=F[Ue-1][He-1]+1;else throw new Error("not possible")}}if(U&&Z(ge,Ae,Be,qe),!(!H[0]&&!j)){Ue--,He--;const se=[N[Ue][He],qe];let de=0,K=0;for(;Ue>=1;){let le=He;do{const fe=B[Ue][le];if(fe===3)le=le-2;else if(fe===2)le=le-1;else break}while(le>=1);de>1&&Ce[Ae+Ue-1]===_e[qe+He-1]&&!Pe(le+qe-1,Be,_e)&&de+1>F[Ue][le]&&(le=He),le===He?de++:de=1,K||(K=le),Ue--,He=le-1,se.push(He)}ve===te&&(se[0]+=2);const ee=K-te;return se[0]-=ee,se}}}e.fuzzyScore=$;function G(ge,Ce,Ae,Be,_e,qe){let j=ge-1,te=Ce-1;for(;j>=Ae&&te>=Be;)_e[j]===qe[te]&&(O[j]=te,j--),te--}function ie(ge,Ce,Ae,Be,_e,qe,j,te,ve,Ue,He){if(Ce[Ae]!==qe[j])return Number.MIN_SAFE_INTEGER;let $e=1,Ye=!1;return j===Ae-Be?$e=ge[Ae]===_e[j]?7:5:Pe(j,_e,qe)&&(j===0||!Pe(j-1,_e,qe))?($e=ge[Ae]===_e[j]?7:5,Ye=!0):ne(qe,j)&&(j===0||!ne(qe,j-1))?$e=5:(ne(qe,j-1)||pe(qe,j-1))&&($e=5,Ye=!0),$e>1&&Ae===Be&&(He[0]=!0),Ye||(Ye=Pe(j,_e,qe)||ne(qe,j-1)||pe(qe,j-1)),Ae===Be?j>ve&&($e-=Ye?3:5):Ue?$e+=Ye?2:0:$e+=Ye?0:1,j+1===te&&($e-=Ye?3:5),$e}function oe(ge,Ce,Ae,Be,_e,qe,j){return De(ge,Ce,Ae,Be,_e,qe,!0,j)}e.fuzzyScoreGracefulAggressive=oe;function me(ge,Ce,Ae,Be,_e,qe,j){return De(ge,Ce,Ae,Be,_e,qe,!1,j)}e.fuzzyScoreGraceful=me;function De(ge,Ce,Ae,Be,_e,qe,j,te){let ve=$(ge,Ce,Ae,Be,_e,qe,te);if(ve&&!j)return ve;if(ge.length>=3){const Ue=Math.min(7,ge.length-1);for(let He=Ae+1;He<Ue;He++){const $e=Ne(ge,He);if($e){const Ye=$($e,$e.toLowerCase(),Ae,Be,_e,qe,te);Ye&&(Ye[0]-=3,(!ve||Ye[0]>ve[0])&&(ve=Ye))}}}return ve}function Ne(ge,Ce){if(!(Ce+1>=ge.length)){const Ae=ge[Ce],Be=ge[Ce+1];if(Ae!==Be)return ge.slice(0,Ce)+Be+Ae+ge.slice(Ce+2)}}}),define(be[110],we([0,1,36,109,8]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${P.source}`,"g");function D(a){return a.replace(S,(p,d)=>d?p:`\\${p}`)}e.escapeIcons=D;const y=new RegExp(`\\\\${P.source}`,"g");function n(a){return a.replace(y,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=n;const T=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function k(a){return a.indexOf(e.iconStartMarker)===-1?a:a.replace(T,(p,d,b,g)=>b?p:d||g||"")}e.stripIcons=k;function f(a){const p=a.indexOf(e.iconStartMarker);return p===-1?{text:a}:h(a,p)}e.parseLabelWithIcons=f;function h(a,p){const d=[];let b="";function g(u){if(u){b+=u;for(const v of u)d.push(t)}}let c=-1,w="",t=0,i,l,s=p;const o=a.length;for(g(a.substr(0,p));s<o;)i=a[s],l=a[s+1],i===e.iconStartMarker[0]&&l===e.iconStartMarker[1]?(c=s,g(w),w=e.iconStartMarker,s++):i===")"&&c!==-1?(t+=s-c+1,c=-1,w=""):c!==-1?/^[a-z0-9\-]$/i.test(i)?w+=i:(g(w),c=-1,w=""):g(i),s++;return g(w),{text:b,iconOffsets:d}}function r(a,p,d=!1){const{text:b,iconOffsets:g}=p;if(!g||g.length===0)return(0,C.matchesFuzzy)(a,b,d);const c=(0,I.ltrim)(b," "),w=b.length-c.length,t=(0,C.matchesFuzzy)(a,c,d);if(t)for(const i of t){const l=g[i.start+w]+w;i.start+=l,i.end+=l}return t}e.matchesFuzzyIconAware=r}),define(be[83],we([0,1,12,110,11]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(a="",p=!1){var d,b;if(this.value=a,typeof this.value!="string")throw(0,I.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1):(this.isTrusted=(d=p.isTrusted)!==null&&d!==void 0?d:void 0,this.supportThemeIcons=(b=p.supportThemeIcons)!==null&&b!==void 0?b:!1)}appendText(a,p=0){return this.value+=k(this.supportThemeIcons?(0,C.escapeIcons)(a):a).replace(/([ \t]+)/g,(d,b)=>"&nbsp;".repeat(b.length)).replace(/^>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,p){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=S;function D(r){return y(r)?!r.value:Array.isArray(r)?r.every(D):!0}e.isEmptyMarkdownString=D;function y(r){return r instanceof S?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function n(r,a){return!r&&!a?!0:!r||!a?!1:Array.isArray(r)&&Array.isArray(a)?(0,E.equals)(r,a,T):y(r)&&y(a)?T(r,a):!1}e.markedStringsEquals=n;function T(r,a){return r===a?!0:!r||!a?!1:r.value===a.value&&r.isTrusted===a.isTrusted&&r.supportThemeIcons===a.supportThemeIcons}function k(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function f(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function h(r){const a=[],p=r.split("|").map(b=>b.trim());r=p[0];const d=p[1];if(d){const b=/height=(\d+)/.exec(d),g=/width=(\d+)/.exec(d),c=b?b[1]:"",w=g?g[1]:"",t=isFinite(parseInt(w)),i=isFinite(parseInt(c));t&&a.push(`width="${w}"`),i&&a.push(`height="${c}"`)}return{href:r,dimensions:a}}e.parseHrefAndDimensions=h}),define(be[58],we([0,1,23,8,2]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(n){return JSON.stringify(n,D)}e.stringify=P;function S(n){let T=JSON.parse(n);return T=y(T),T}e.parse=S;function D(n,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,C.regExpFlags)(T)}:T}function y(n,T=0){if(!n||T>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return I.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof E.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let k=0;k<n.length;++k)n[k]=y(n[k],T+1);else for(const k in n)Object.hasOwnProperty.call(n,k)&&(n[k]=y(n[k],T+1))}return n}e.revive=y}),define(be[18],we([0,1,2,21]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var I;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file"})(I=e.Schemas||(e.Schemas={}));class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,n,T){this._hosts[y]=n,this._ports[y]=T}setConnectionToken(y,n){this._connectionTokens[y]=n}rewrite(y){if(this._delegate)return this._delegate(y);const n=y.authority;let T=this._hosts[n];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const k=this._ports[n],f=this._connectionTokens[n];let h=`path=${encodeURIComponent(y.path)}`;return typeof f=="string"&&(h+=`&tkn=${encodeURIComponent(f)}`),E.URI.from({scheme:C.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${T}:${k}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new P;class S{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,n,T){const k=this.toUri(y,n);return k.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(k):C.isNative&&(T||C.isPreferringBrowserCodeLoad)&&k.scheme===I.file?k.with({scheme:I.vscodeFileResource,authority:k.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(y,n){const T=this.toUri(y,n);return T.scheme===I.vscodeFileResource?T.with({scheme:I.file,authority:T.authority!==this.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(y,n){return E.URI.isUri(y)?y:E.URI.parse(n.toUrl(y))}}e.FileAccess=new S}),define(be[25],we([0,1,37,13,2,8,18,21]),function(Y,e,E,C,I,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(h){return(0,I.uriToFsPath)(h,!0)}e.originalFSPath=y;class n{constructor(r){this._ignorePathCasing=r}compare(r,a,p=!1){return r===a?0:(0,P.compare)(this.getComparisonKey(r,p),this.getComparisonKey(a,p))}isEqual(r,a,p=!1){return r===a?!0:!r||!a?!1:this.getComparisonKey(r,p)===this.getComparisonKey(a,p)}getComparisonKey(r,a=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,a,p=!1){if(r.scheme===a.scheme){if(r.scheme===S.Schemas.file)return E.isEqualOrParent(y(r),y(a),this._ignorePathCasing(r))&&r.query===a.query&&(p||r.fragment===a.fragment);if((0,e.isEqualAuthority)(r.authority,a.authority))return E.isEqualOrParent(r.path,a.path,this._ignorePathCasing(r),"/")&&r.query===a.query&&(p||r.fragment===a.fragment)}return!1}joinPath(r,...a){return I.URI.joinPath(r,...a)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return C.posix.basename(r.path)}extname(r){return C.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let a;return r.scheme===S.Schemas.file?a=I.URI.file(C.dirname(y(r))).path:(a=C.posix.dirname(r.path),r.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),a="/")),r.with({path:a})}normalizePath(r){if(!r.path.length)return r;let a;return r.scheme===S.Schemas.file?a=I.URI.file(C.normalize(y(r))).path:a=C.posix.normalize(r.path),r.with({path:a})}relativePath(r,a){if(!(r.scheme!==a.scheme||!(0,e.isEqualAuthority)(r.authority,a.authority))){if(r.scheme===S.Schemas.file){const b=C.relative(y(r),y(a));return D.isWindows?E.toSlashes(b):b}let p=r.path||"/",d=a.path||"/";if(this._ignorePathCasing(r)){let b=0;for(const g=Math.min(p.length,d.length);b<g&&!(p.charCodeAt(b)!==d.charCodeAt(b)&&p.charAt(b).toLowerCase()!==d.charAt(b).toLowerCase());b++);p=d.substr(0,b)+p.substr(b)}return C.posix.relative(p,d)}}resolvePath(r,a){if(r.scheme===S.Schemas.file){const p=I.URI.file(C.resolve(y(r),a));return r.with({authority:p.authority,path:p.path})}return a.indexOf("/")===-1&&(a=E.toSlashes(a),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a)),r.with({path:C.posix.resolve(r.path,a)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,a){return r===a||(0,P.equalsIgnoreCase)(r,a)}hasTrailingPathSeparator(r,a=C.sep){if(r.scheme===S.Schemas.file){const p=y(r);return p.length>E.getRoot(p).length&&p[p.length-1]===a}else{const p=r.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,a=C.sep){return(0,e.hasTrailingPathSeparator)(r,a)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,a=C.sep){let p=!1;if(r.scheme===S.Schemas.file){const d=y(r);p=d!==void 0&&d.length===E.getRoot(d).length&&d[d.length-1]===a}else{a="/";const d=r.path;p=d.length===1&&d.charCodeAt(d.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(r,a)?r.with({path:r.path+"/"}):r}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(h=>h.scheme===S.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new n(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(h,r){const a=[];for(let p=0;p<h.length;p++){const d=r(h[p]);h.some((b,g)=>g===p?!1:(0,e.isEqualOrParent)(d,r(b)))||a.push(h[p])}return a}e.distinctParents=T;var k;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function r(a){const p=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(g=>{const[c,w]=g.split(":");c&&w&&p.set(c,w)});const b=a.path.substring(0,a.path.indexOf(";"));return b&&p.set(h.META_DATA_MIME,b),p}h.parseMetaData=r})(k=e.DataUri||(e.DataUri={}));function f(h,r,a){if(r){let p=h.path;return p&&p[0]!==C.posix.sep&&(p=C.posix.sep+p),h.with({scheme:a,authority:r,path:p})}return h.with({scheme:a})}e.toLocalResource=f}),define(be[14],we([0,1,20,11,3,6,45,25]),function(Y,e,E,C,I,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(N){return!!N&&typeof N.then=="function"}e.isThenable=y;function n(N){const B=new E.CancellationTokenSource,U=N(B.token),Q=new Promise((Z,ne)=>{B.token.onCancellationRequested(()=>{ne((0,C.canceled)())}),Promise.resolve(U).then(pe=>{B.dispose(),Z(pe)},pe=>{B.dispose(),ne(pe)})});return new class{cancel(){B.cancel()}then(Z,ne){return Q.then(Z,ne)}catch(Z){return this.then(void 0,Z)}finally(Z){return Q.finally(Z)}}}e.createCancelablePromise=n;function T(N,B,U){return Promise.race([N,new Promise(Q=>B.onCancellationRequested(()=>Q(U)))])}e.raceCancellation=T;async function k(N){let B=-1;const U=N.map((Z,ne)=>Z.then(pe=>(B=ne,pe))),Q=await Promise.race(U);return N.forEach((Z,ne)=>{ne!==B&&Z.cancel()}),Q}e.raceCancellablePromises=k;function f(N,B,U){let Q;const Z=setTimeout(()=>{Q==null||Q(void 0),U==null||U()},B);return Promise.race([N.finally(()=>clearTimeout(Z)),new Promise(ne=>Q=ne)])}e.raceTimeout=f;function h(N){return new Promise((B,U)=>{const Q=N();y(Q)?Q.then(B,U):B(Q)})}e.asPromise=h;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const Q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Q};this.queuedPromise=new Promise(Q=>{this.activePromise.then(U,U).then(Q)})}return new Promise((U,Q)=>{this.queuedPromise.then(U,Q)})}return this.activePromise=B(),new Promise((U,Q)=>{this.activePromise.then(Z=>{this.activePromise=null,U(Z)},Z=>{this.activePromise=null,Q(Z)})})}}e.Throttler=r;class a{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=a;class p{constructor(){this.promiseMap=new Map}queue(B,U){var Q;const ne=((Q=this.promiseMap.get(B))!==null&&Q!==void 0?Q:Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(B)===ne&&this.promiseMap.delete(B)});return this.promiseMap.set(B,ne),ne}}e.SequencerByKey=p;class d{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,U=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Q,Z)=>{this.doResolve=Q,this.doReject=Z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Q=this.task;return this.task=null,Q()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},U),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,C.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=d;class b{constructor(B){this.delayer=new d(B),this.throttler=new r}trigger(B,U){return this.delayer.trigger(()=>this.throttler.queue(B),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class g{constructor(){this._isOpen=!1,this._promise=new Promise((B,U)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=g;class c extends g{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function w(N,B){return B?new Promise((U,Q)=>{const Z=setTimeout(U,N);B.onCancellationRequested(()=>{clearTimeout(Z),Q((0,C.canceled)())})}):n(U=>w(N,U))}e.timeout=w;function t(N,B=0){const U=setTimeout(N,B);return(0,P.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=t;function i(N){return N.then(void 0,B=>{})}e.ignoreErrors=i;function l(N){const B=[];let U=0;const Q=N.length;function Z(){return U<Q?N[U++]():null}function ne(pe){pe!=null&&B.push(pe);const Pe=Z();return Pe?Pe.then(ne):Promise.resolve(B)}return Promise.resolve(null).then(ne)}e.sequence=l;function s(N,B=Q=>!!Q,U=null){let Q=0;const Z=N.length,ne=()=>{if(Q>=Z)return Promise.resolve(U);const pe=N[Q++];return Promise.resolve(pe()).then(Oe=>B(Oe)?Promise.resolve(Oe):ne())};return ne()}e.first=s;function o(N,B=Q=>!!Q,U=null){if(N.length===0)return Promise.resolve(U);let Q=N.length;const Z=()=>{var ne,pe;Q=-1;for(const Pe of N)(pe=(ne=Pe).cancel)===null||pe===void 0||pe.call(ne)};return new Promise((ne,pe)=>{for(const Pe of N)Pe.then(Oe=>{--Q>=0&&B(Oe)?(Z(),ne(Oe)):Q===0&&ne(U)}).catch(Oe=>{--Q>=0&&(Z(),pe(Oe))})})}e.firstParallel=o;class u{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((U,Q)=>{this.outstandingPromises.push({factory:B,c:U,e:Q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const U=B.factory();U.then(B.c,B.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=u;class v extends u{constructor(){super(1)}}e.Queue=v;class A{constructor(){this.queues=new Map}queueFor(B,U=D.extUri){const Q=U.getComparisonKey(B);let Z=this.queues.get(Q);return Z||(Z=new v,I.Event.once(Z.onFinished)(()=>{Z==null||Z.dispose(),this.queues.delete(Q)}),this.queues.set(Q,Z)),Z}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=A;class m{constructor(B,U){this._token=-1,typeof B=="function"&&typeof U=="number"&&this.setIfNotSet(B,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},U)}setIfNotSet(B,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},U))}}e.TimeoutTimer=m;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,U){this.cancel(),this._token=setInterval(()=>{B()},U)}}e.IntervalTimer=_;class R{constructor(B,U){this.timeoutToken=-1,this.runner=B,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class L extends R{constructor(B,U){super(B,U);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=B=>{const U=setTimeout(()=>B(N));let Q=!1;return{dispose(){Q||(Q=!0,clearTimeout(U))}}}}else e.runWhenIdle=(N,B)=>{const U=requestIdleCallback(N,typeof B=="number"?{timeout:B}:void 0);let Q=!1;return{dispose(){Q||(Q=!0,cancelIdleCallback(U))}}}}();class V{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=V;async function he(N,B,U){let Q;for(let Z=0;Z<U;Z++)try{return await N()}catch(ne){Q=ne,await w(B)}throw Q}e.retry=he;class z{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var B;(B=this._pending)===null||B===void 0||B.cancel()}setPending(B,U,Q){return this._pending={taskId:B,cancel:()=>Q==null?void 0:Q(),promise:U},U.then(()=>this.donePending(B),()=>this.donePending(B)),U}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let U,Q;const Z=new Promise((ne,pe)=>{U=ne,Q=pe});this._next={run:B,promise:Z,promiseResolve:U,promiseReject:Q}}return this._next.promise}}e.TaskSequentializer=z;class W{constructor(B){this.interval=B,this.lastIncrementTime=0,this.value=0}increment(){const B=Date.now();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class J{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,U)=>{this.completeCallback=B,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(U=>{this.completeCallback(B),this.resolved=!0,U()})}error(B){return new Promise(U=>{this.errorCallback(B),this.rejected=!0,U()})}cancel(){new Promise(B=>{this.errorCallback((0,C.canceled)()),this.rejected=!0,B()})}}e.DeferredPromise=J;class O extends I.Emitter{async fireAsync(B,U,Q){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const Z of this._listeners)this._asyncDeliveryQueue.push([Z,B]);for(;this._asyncDeliveryQueue.size>0&&!U.isCancellationRequested;){const[Z,ne]=this._asyncDeliveryQueue.shift(),pe=[],Pe=Object.assign(Object.assign({},ne),{waitUntil:Oe=>{if(Object.isFrozen(pe))throw new Error("waitUntil can NOT be called asynchronous");Q&&(Oe=Q(Oe,typeof Z=="function"?Z:Z[0])),pe.push(Oe)}});try{typeof Z=="function"?Z.call(void 0,Pe):Z[0].call(Z[1],Pe)}catch(Oe){(0,C.onUnexpectedError)(Oe);continue}Object.freeze(pe),await F.settled(pe).catch(Oe=>(0,C.onUnexpectedError)(Oe))}}}}e.AsyncEmitter=O;var F;(function(N){async function B(ne){return typeof Promise.allSettled=="function"?U(ne):Q(ne)}N.allSettled=B;async function U(ne){return Promise.allSettled(ne)}async function Q(ne){return Promise.all(ne.map(pe=>pe.then(Pe=>({status:"fulfilled",value:Pe}),Pe=>({status:"rejected",reason:Pe}))))}async function Z(ne){let pe;const Pe=await Promise.all(ne.map(Oe=>Oe.then(Te=>Te,Te=>{pe||(pe=Te)})));if(typeof pe!="undefined")throw pe;return Pe}N.settled=Z})(F=e.Promises||(e.Promises={}))}),define(be[111],we([0,1,13,14]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new C.IdleValue(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),P=new C.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new C.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(c,w,t=!1){const i=c||"",l=w||"",s=I.value.collator.compare(i,l);return I.value.collatorIsNumeric&&s===0&&i!==l?i<l?-1:1:s}e.compareFileNames=D;function y(c,w){const t=P.value.collator;return c=c||"",w=w||"",a(t,c,w)}e.compareFileNamesDefault=y;function n(c,w,t=!1){t||(c=c&&c.toLowerCase(),w=w&&w.toLowerCase());const[i,l]=h(c),[s,o]=h(w);return i!==s?i<s?-1:1:l===o?0:l<o?-1:1}e.noIntlCompareFileNames=n;function T(c,w){const[t,i]=h(c),[l,s]=h(w);let o=I.value.collator.compare(i,s);if(o===0){if(I.value.collatorIsNumeric&&i!==s)return i<s?-1:1;if(o=I.value.collator.compare(t,l),I.value.collatorIsNumeric&&o===0&&t!==l)return t<l?-1:1}return o}e.compareFileExtensions=T;function k(c,w){c=c||"",w=w||"";const t=r(c),i=r(w),l=P.value.collator,s=S.value.collator;let o;return o=a(s,t,i),o!==0?o:a(l,c,w)}e.compareFileExtensionsDefault=k;const f=/^(.*?)(\.([^.]*))?$/;function h(c,w=!1){const t=c?f.exec(c):[];let i=[t&&t[1]||"",t&&t[3]||""];return w&&(!i[0]&&i[1]||i[0]&&i[0].charAt(0)===".")&&(i=[i[0]+"."+i[1],""]),i}function r(c){const w=c?f.exec(c):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function a(c,w,t){let i=c.compare(w,t);return i!==0?i:w.length!==t.length?w.length<t.length?-1:1:0}function p(c,w,t=!1){return t||(c=c&&c.toLowerCase(),w=w&&w.toLowerCase()),c===w?0:c<w?-1:1}function d(c,w,t=!1){const i=c.split(E.sep),l=w.split(E.sep),s=i.length-1,o=l.length-1;let u,v;for(let A=0;;A++){if(u=s===A,v=o===A,u&&v)return D(i[A],l[A],t);if(u)return-1;if(v)return 1;const m=p(i[A],l[A],t);if(m!==0)return m}}e.comparePaths=d;function b(c,w,t){const i=c.toLowerCase(),l=w.toLowerCase(),s=g(c,w,t);if(s)return s;const o=i.endsWith(t),u=l.endsWith(t);if(o!==u)return o?-1:1;const v=D(i,l);return v!==0?v:i.localeCompare(l)}e.compareAnything=b;function g(c,w,t){const i=c.toLowerCase(),l=w.toLowerCase(),s=i.startsWith(t),o=l.startsWith(t);if(s!==o)return s?-1:1;if(s&&o){if(i.length<l.length)return-1;if(i.length>l.length)return 1}return 0}e.compareByPrefix=g}),define(be[28],we([0,1,8,37,13,22,14]),function(Y,e,E,C,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const y="**",n="/",T="[/\\\\]",k="[^/\\\\]",f=/\//g;function h(U){switch(U){case 0:return"";case 1:return`${k}*?`;default:return`(?:${T}|${k}+${T}|${T}${k}+)*?`}}function r(U,Q){if(!U)return[];const Z=[];let ne=!1,pe=!1,Pe="";for(const Oe of U){switch(Oe){case Q:if(!ne&&!pe){Z.push(Pe),Pe="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}Pe+=Oe}return Pe&&Z.push(Pe),Z}e.splitGlobAware=r;function a(U){if(!U)return"";let Q="";const Z=r(U,n);if(Z.every(ne=>ne===y))Q=".*";else{let ne=!1;Z.forEach((pe,Pe)=>{if(pe===y){ne||(Q+=h(2),ne=!0);return}let Oe=!1,Te="",xe=!1,$="";for(const G of pe){if(G!=="}"&&Oe){Te+=G;continue}if(xe&&(G!=="]"||!$)){let ie;G==="-"?ie=G:(G==="^"||G==="!")&&!$?ie="^":G===n?ie="":ie=E.escapeRegExpCharacters(G),$+=ie;continue}switch(G){case"{":Oe=!0;continue;case"[":xe=!0;continue;case"}":Q+=`(?:${r(Te,",").map(me=>a(me)).join("|")})`,Oe=!1,Te="";break;case"]":Q+="["+$+"]",xe=!1,$="";break;case"?":Q+=k;continue;case"*":Q+=h(1);continue;default:Q+=E.escapeRegExpCharacters(G)}}Pe<Z.length-1&&(Z[Pe+1]!==y||Pe+2<Z.length)&&(Q+=T),ne=!1})}return Q}const p=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.LRUCache(1e4),i=function(){return!1},l=function(){return null};function s(U,Q){if(!U)return l;let Z;typeof U!="string"?Z=U.pattern:Z=U,Z=Z.trim();const ne=`${Z}_${!!Q.trimForExclusions}`;let pe=t.get(ne);if(pe)return o(pe,U);let Pe;if(p.test(Z)){const Oe=Z.substr(4);pe=function(Te,xe){return typeof Te=="string"&&Te.endsWith(Oe)?Z:null}}else(Pe=d.exec(u(Z,Q)))?pe=v(Pe[1],Z):(Q.trimForExclusions?g:b).test(Z)?pe=A(Z,Q):(Pe=c.exec(u(Z,Q)))?pe=m(Pe[1].substr(1),Z,!0):(Pe=w.exec(u(Z,Q)))?pe=m(Pe[1],Z,!1):pe=_(Z);return t.set(ne,pe),o(pe,U)}function o(U,Q){return typeof Q=="string"?U:function(Z,ne){return C.isEqualOrParent(Z,Q.base)?U(I.relative(Q.base,Z),ne):null}}function u(U,Q){return Q.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function v(U,Q){const Z=`/${U}`,ne=`\\${U}`,pe=function(Oe,Te){return typeof Oe!="string"?null:Te?Te===U?Q:null:Oe===U||Oe.endsWith(Z)||Oe.endsWith(ne)?Q:null},Pe=[U];return pe.basenames=Pe,pe.patterns=[Q],pe.allBasenames=Pe,pe}function A(U,Q){const Z=B(U.slice(1,-1).split(",").map(Te=>s(Te,Q)).filter(Te=>Te!==l),U),ne=Z.length;if(!ne)return l;if(ne===1)return Z[0];const pe=function(Te,xe){for(let $=0,G=Z.length;$<G;$++)if(Z[$](Te,xe))return U;return null},Pe=Z.find(Te=>!!Te.allBasenames);Pe&&(pe.allBasenames=Pe.allBasenames);const Oe=Z.reduce((Te,xe)=>xe.allPaths?Te.concat(xe.allPaths):Te,[]);return Oe.length&&(pe.allPaths=Oe),pe}function m(U,Q,Z){const ne=I.sep===I.posix.sep,pe=ne?U:U.replace(f,I.sep),Pe=I.sep+pe,Oe=I.posix.sep+U,Te=Z?function(xe,$){return typeof xe=="string"&&(xe===pe||xe.endsWith(Pe)||!ne&&(xe===U||xe.endsWith(Oe)))?Q:null}:function(xe,$){return typeof xe=="string"&&(xe===pe||!ne&&xe===U)?Q:null};return Te.allPaths=[(Z?"*/":"./")+U],Te}function _(U){try{const Q=new RegExp(`^${a(U)}$`);return function(Z){return Q.lastIndex=0,typeof Z=="string"&&Q.test(Z)?U:null}}catch(Q){return l}}function R(U,Q,Z){return!U||typeof Q!="string"?!1:L(U)(Q,void 0,Z)}e.match=R;function L(U,Q={}){if(!U)return i;if(typeof U=="string"||W(U)){const Z=s(U,Q);if(Z===l)return i;const ne=function(pe,Pe){return!!Z(pe,Pe)};return Z.allBasenames&&(ne.allBasenames=Z.allBasenames),Z.allPaths&&(ne.allPaths=Z.allPaths),ne}return F(U,Q)}e.parse=L;function V(U){if(!!U){let Q;return Z=>(Q||(Q=(U()||Promise.resolve([])).then(ne=>ne?z(ne):{})),Q.then(ne=>!!ne[Z]))}}e.hasSiblingPromiseFn=V;function he(U){if(!!U){let Q;return Z=>{if(!Q){const ne=U();Q=ne?z(ne):{}}return!!Q[Z]}}}e.hasSiblingFn=he;function z(U){const Q={};for(const Z of U)Q[Z]=!0;return Q}function W(U){const Q=U;return Q&&typeof Q.base=="string"&&typeof Q.pattern=="string"}e.isRelativePattern=W;function J(U){return U.allBasenames||[]}e.getBasenameTerms=J;function O(U){return U.allPaths||[]}e.getPathTerms=O;function F(U,Q){const Z=B(Object.getOwnPropertyNames(U).map(Te=>N(Te,U[Te],Q)).filter(Te=>Te!==l)),ne=Z.length;if(!ne)return l;if(!Z.some(Te=>!!Te.requiresSiblings)){if(ne===1)return Z[0];const Te=function(G,ie){for(let oe=0,me=Z.length;oe<me;oe++){const De=Z[oe](G,ie);if(De)return De}return null},xe=Z.find(G=>!!G.allBasenames);xe&&(Te.allBasenames=xe.allBasenames);const $=Z.reduce((G,ie)=>ie.allPaths?G.concat(ie.allPaths):G,[]);return $.length&&(Te.allPaths=$),Te}const pe=function(Te,xe,$){let G;for(let ie=0,oe=Z.length;ie<oe;ie++){const me=Z[ie];me.requiresSiblings&&$&&(xe||(xe=I.basename(Te)),G||(G=xe.substr(0,xe.length-I.extname(Te).length)));const De=me(Te,xe,G,$);if(De)return De}return null},Pe=Z.find(Te=>!!Te.allBasenames);Pe&&(pe.allBasenames=Pe.allBasenames);const Oe=Z.reduce((Te,xe)=>xe.allPaths?Te.concat(xe.allPaths):Te,[]);return Oe.length&&(pe.allPaths=Oe),pe}function N(U,Q,Z){if(Q===!1)return l;const ne=s(U,Z);if(ne===l)return l;if(typeof Q=="boolean")return ne;if(Q){const pe=Q.when;if(typeof pe=="string"){const Pe=(Oe,Te,xe,$)=>{if(!$||!ne(Oe,Te))return null;const G=pe.replace("$(basename)",xe),ie=$(G);return(0,S.isThenable)(ie)?ie.then(oe=>oe?U:null):ie?U:null};return Pe.requiresSiblings=!0,Pe}}return ne}function B(U,Q){const Z=U.filter(Te=>!!Te.basenames);if(Z.length<2)return U;const ne=Z.reduce((Te,xe)=>{const $=xe.basenames;return $?Te.concat($):Te},[]);let pe;if(Q){pe=[];for(let Te=0,xe=ne.length;Te<xe;Te++)pe.push(Q)}else pe=Z.reduce((Te,xe)=>{const $=xe.patterns;return $?Te.concat($):Te},[]);const Pe=function(Te,xe){if(typeof Te!="string")return null;if(!xe){let G;for(G=Te.length;G>0;G--){const ie=Te.charCodeAt(G-1);if(ie===47||ie===92)break}xe=Te.substr(G)}const $=ne.indexOf(xe);return $!==-1?pe[$]:null};Pe.basenames=ne,Pe.patterns=pe,Pe.allBasenames=ne;const Oe=U.filter(Te=>!Te.basenames);return Oe.push(Pe),Oe}}),define(be[59],we([0,1,2,13,8,18,21,25,37]),function(Y,e,E,C,I,P,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(s,o,u){if(typeof s=="string"&&(s=E.URI.file(s)),u){const A=u.getWorkspaceFolder(s);if(A){const m=u.getWorkspace().folders.length>1;let _;if((0,D.isEqual)(A.uri,s)?_="":_=(0,D.relativePath)(A.uri,s),m){const R=A.name?A.name:(0,D.basename)(A.uri);_=_?R+" \u2022 "+_:R}return _}}if(s.scheme!==P.Schemas.file&&s.scheme!==P.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(s.fsPath))return(0,C.normalize)(k(s.fsPath));let v=(0,C.normalize)(s.fsPath);return!S.isWindows&&(o==null?void 0:o.userHome)&&(v=h(v,o.userHome.fsPath)),v}e.getPathLabel=n;function T(s){if(!!s){typeof s=="string"&&(s=E.URI.file(s));const o=(0,D.basename)(s)||(s.scheme===P.Schemas.file?s.fsPath:s.path);return S.isWindows&&(0,y.isRootOrDriveLetter)(o)?k(o):o}}e.getBaseLabel=T;function k(s){return(0,y.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=k;let f=Object.create(null);function h(s,o){if(S.isWindows||!s||!o)return s;let u=f.original===o?f.normalized:void 0;return u||(u=`${(0,I.rtrim)(o,C.posix.sep)}${C.posix.sep}`,f={original:o,normalized:u}),(S.isLinux?s.startsWith(u):(0,I.startsWithIgnoreCase)(s,u))&&(s=`~/${s.substr(u.length)}`),s}e.tildify=h;function r(s,o){return s.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=r;const a="\u2026",p="\\\\",d="~";function b(s,o=C.sep){const u=new Array(s.length);let v=!1;for(let A=0;A<s.length;A++){let m=s[A];if(m===""){u[A]=`.${o}`;continue}if(!m){u[A]=m;continue}v=!0;let _="";m.indexOf(p)===0?(_=m.substr(0,m.indexOf(p)+p.length),m=m.substr(m.indexOf(p)+p.length)):m.indexOf(o)===0?(_=m.substr(0,m.indexOf(o)+o.length),m=m.substr(m.indexOf(o)+o.length)):m.indexOf(d)===0&&(_=m.substr(0,m.indexOf(d)+d.length),m=m.substr(m.indexOf(d)+d.length));const R=m.split(o);for(let L=1;v&&L<=R.length;L++)for(let V=R.length-L;v&&V>=0;V--){v=!1;let he=R.slice(V,V+L).join(o);for(let z=0;!v&&z<s.length;z++)if(z!==A&&s[z]&&s[z].indexOf(he)>-1){const W=V+L===R.length,J=V>0&&s[z].indexOf(o)>-1?o+he:he,O=s[z].endsWith(J);v=!W||O}if(!v){let z="";(R[0].endsWith(":")||_!=="")&&(V===1&&(V=0,L++,he=R[0]+o+he),V>0&&(z=R[0]+o),z=_+z),V>0&&(z=z+a+o),z=z+he,V+L<R.length&&(z=z+o+a),u[A]=z}}v&&(u[A]=m)}return u}e.shorten=b;var g;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function c(s,o=Object.create(null)){const u=[];let v=!1,A="";for(const m of s)if(m==="$"||v&&m==="{")A&&u.push({value:A,type:g.TEXT}),A="",v=!0;else if(m==="}"&&v){const _=o[A];if(typeof _=="string")_.length&&u.push({value:_,type:g.VARIABLE});else if(_){const R=u[u.length-1];(!R||R.type!==g.SEPARATOR)&&u.push({value:_.label,type:g.SEPARATOR})}A="",v=!1}else A+=m;return A&&!v&&u.push({value:A,type:g.TEXT}),u.filter((m,_)=>{if(m.type===g.SEPARATOR){const R=u[_-1],L=u[_+1];return[R,L].every(V=>V&&(V.type===g.VARIABLE||V.type===g.TEXT)&&V.value.length>0)}return!0}).map(m=>m.value).join("")}e.template=c;function w(s,o){return S.isMacintosh||o?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.isMacintosh?"&":"&&"):s.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=w;function t(s,o){return S.isMacintosh||o?s.replace(/\(&&\w\)|&&/g,""):S.isWindows?s.replace(/&&|&/g,u=>u==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=i;function l(s){const o=s.indexOf("/")!==-1?C.posix:C.win32,u=o.basename(s),v=o.dirname(s);return u.length?{name:u,parentPath:v}:{name:v,parentPath:""}}e.splitName=l}),define(be[112],we([0,1,2]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function C(T){return T.toJSON()}class I{constructor(k){this._uriTransformer=k}transformIncoming(k){const f=this._uriTransformer.transformIncoming(k);return f===k?k:C(E.URI.from(f))}transformOutgoing(k){const f=this._uriTransformer.transformOutgoing(k);return f===k?k:C(E.URI.from(f))}transformOutgoingURI(k){const f=this._uriTransformer.transformOutgoing(k);return f===k?k:E.URI.from(f)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function P(T,k,f){if(!T||f>200)return null;if(typeof T=="object"){if(T instanceof E.URI)return k.transformOutgoing(T);for(let h in T)if(Object.hasOwnProperty.call(T,h)){const r=P(T[h],k,f+1);r!==null&&(T[h]=r)}}return null}function S(T,k){const f=P(T,k,0);return f===null?T:f}e.transformOutgoingURIs=S;function D(T,k,f,h){if(!T||h>200)return null;if(typeof T=="object"){if(T.$mid===1)return f?E.URI.revive(k.transformIncoming(T)):k.transformIncoming(T);for(let r in T)if(Object.hasOwnProperty.call(T,r)){const a=D(T[r],k,f,h+1);a!==null&&(T[r]=a)}}return null}function y(T,k){const f=D(T,k,!1,0);return f===null?T:f}e.transformIncomingURIs=y;function n(T,k){const f=D(T,k,!0,0);return f===null?T:f}e.transformAndReviveIncomingURIs=n}),define(be[29],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(y){return E.test(y)}e.isUUID=C;const I=new Uint8Array(16),P=[];for(let y=0;y<256;y++)P.push(y.toString(16).padStart(2,"0"));let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(y){for(let n=0;n<y.length;n++)y[n]=Math.floor(Math.random()*256);return y};function D(){S(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let y=0,n="";return n+=P[I[y++]],n+=P[I[y++]],n+=P[I[y++]],n+=P[I[y++]],n+="-",n+=P[I[y++]],n+=P[I[y++]],n+="-",n+=P[I[y++]],n+=P[I[y++]],n+="-",n+=P[I[y++]],n+=P[I[y++]],n+="-",n+=P[I[y++]],n+=P[I[y++]],n+=P[I[y++]],n+=P[I[y++]],n+=P[I[y++]],n+=P[I[y++]],n}e.generateUuid=D}),define(be[84],we([0,1,82]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class C{constructor(D){let y=(0,E.toUint8)(D);this._defaultValue=y,this._asciiMap=C._createAsciiMap(y),this._map=new Map}static _createAsciiMap(D){let y=new Uint8Array(256);for(let n=0;n<256;n++)y[n]=D;return y}set(D,y){let n=(0,E.toUint8)(y);D>=0&&D<256?this._asciiMap[D]=n:this._map.set(D,n)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=C;var I;(function(S){S[S.False=0]="False",S[S.True=1]="True"})(I||(I={}));class P{constructor(){this._actual=new C(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=P}),define(be[113],we([0,1,84]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var C;(function(S){S[S.Regular=0]="Regular",S[S.Whitespace=1]="Whitespace",S[S.WordSeparator=2]="WordSeparator"})(C=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends E.CharacterClassifier{constructor(D){super(0);for(let y=0,n=D.length;y<n;y++)this.set(D.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function P(S){let D={};return y=>(D.hasOwnProperty(y)||(D[y]=S(y)),D[y])}e.getMapForWordSeparators=P(S=>new I(S))}),define(be[38],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class E{constructor(I,P){this.lineNumber=I,this.column=P}with(I=this.lineNumber,P=this.column){return I===this.lineNumber&&P===this.column?this:new E(I,P)}delta(I=0,P=0){return this.with(this.lineNumber+I,this.column+P)}equals(I){return E.equals(this,I)}static equals(I,P){return!I&&!P?!0:!!I&&!!P&&I.lineNumber===P.lineNumber&&I.column===P.column}isBefore(I){return E.isBefore(this,I)}static isBefore(I,P){return I.lineNumber<P.lineNumber?!0:P.lineNumber<I.lineNumber?!1:I.column<P.column}isBeforeOrEqual(I){return E.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,P){return I.lineNumber<P.lineNumber?!0:P.lineNumber<I.lineNumber?!1:I.column<=P.column}static compare(I,P){let S=I.lineNumber|0,D=P.lineNumber|0;if(S===D){let y=I.column|0,n=P.column|0;return y-n}return S-D}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new E(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=E}),define(be[32],we([0,1,38]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class C{constructor(P,S,D,y){P>D||P===D&&S>y?(this.startLineNumber=D,this.startColumn=y,this.endLineNumber=P,this.endColumn=S):(this.startLineNumber=P,this.startColumn=S,this.endLineNumber=D,this.endColumn=y)}isEmpty(){return C.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return C.containsPosition(this,P)}static containsPosition(P,S){return!(S.lineNumber<P.startLineNumber||S.lineNumber>P.endLineNumber||S.lineNumber===P.startLineNumber&&S.column<P.startColumn||S.lineNumber===P.endLineNumber&&S.column>P.endColumn)}containsRange(P){return C.containsRange(this,P)}static containsRange(P,S){return!(S.startLineNumber<P.startLineNumber||S.endLineNumber<P.startLineNumber||S.startLineNumber>P.endLineNumber||S.endLineNumber>P.endLineNumber||S.startLineNumber===P.startLineNumber&&S.startColumn<P.startColumn||S.endLineNumber===P.endLineNumber&&S.endColumn>P.endColumn)}strictContainsRange(P){return C.strictContainsRange(this,P)}static strictContainsRange(P,S){return!(S.startLineNumber<P.startLineNumber||S.endLineNumber<P.startLineNumber||S.startLineNumber>P.endLineNumber||S.endLineNumber>P.endLineNumber||S.startLineNumber===P.startLineNumber&&S.startColumn<=P.startColumn||S.endLineNumber===P.endLineNumber&&S.endColumn>=P.endColumn)}plusRange(P){return C.plusRange(this,P)}static plusRange(P,S){let D,y,n,T;return S.startLineNumber<P.startLineNumber?(D=S.startLineNumber,y=S.startColumn):S.startLineNumber===P.startLineNumber?(D=S.startLineNumber,y=Math.min(S.startColumn,P.startColumn)):(D=P.startLineNumber,y=P.startColumn),S.endLineNumber>P.endLineNumber?(n=S.endLineNumber,T=S.endColumn):S.endLineNumber===P.endLineNumber?(n=S.endLineNumber,T=Math.max(S.endColumn,P.endColumn)):(n=P.endLineNumber,T=P.endColumn),new C(D,y,n,T)}intersectRanges(P){return C.intersectRanges(this,P)}static intersectRanges(P,S){let D=P.startLineNumber,y=P.startColumn,n=P.endLineNumber,T=P.endColumn,k=S.startLineNumber,f=S.startColumn,h=S.endLineNumber,r=S.endColumn;return D<k?(D=k,y=f):D===k&&(y=Math.max(y,f)),n>h?(n=h,T=r):n===h&&(T=Math.min(T,r)),D>n||D===n&&y>T?null:new C(D,y,n,T)}equalsRange(P){return C.equalsRange(this,P)}static equalsRange(P,S){return!!P&&!!S&&P.startLineNumber===S.startLineNumber&&P.startColumn===S.startColumn&&P.endLineNumber===S.endLineNumber&&P.endColumn===S.endColumn}getEndPosition(){return C.getEndPosition(this)}static getEndPosition(P){return new E.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return C.getStartPosition(this)}static getStartPosition(P){return new E.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,S){return new C(this.startLineNumber,this.startColumn,P,S)}setStartPosition(P,S){return new C(P,S,this.endLineNumber,this.endColumn)}collapseToStart(){return C.collapseToStart(this)}static collapseToStart(P){return new C(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,S=P){return new C(P.lineNumber,P.column,S.lineNumber,S.column)}static lift(P){return P?new C(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,S){return!(P.endLineNumber<S.startLineNumber||P.endLineNumber===S.startLineNumber&&P.endColumn<S.startColumn||S.endLineNumber<P.startLineNumber||S.endLineNumber===P.startLineNumber&&S.endColumn<P.startColumn)}static areIntersecting(P,S){return!(P.endLineNumber<S.startLineNumber||P.endLineNumber===S.startLineNumber&&P.endColumn<=S.startColumn||S.endLineNumber<P.startLineNumber||S.endLineNumber===P.startLineNumber&&S.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,S){if(P&&S){const n=P.startLineNumber|0,T=S.startLineNumber|0;if(n===T){const k=P.startColumn|0,f=S.startColumn|0;if(k===f){const h=P.endLineNumber|0,r=S.endLineNumber|0;if(h===r){const a=P.endColumn|0,p=S.endColumn|0;return a-p}return h-r}return k-f}return n-T}return(P?1:0)-(S?1:0)}static compareRangesUsingEnds(P,S){return P.endLineNumber===S.endLineNumber?P.endColumn===S.endColumn?P.startLineNumber===S.startLineNumber?P.startColumn-S.startColumn:P.startLineNumber-S.startLineNumber:P.endColumn-S.endColumn:P.endLineNumber-S.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}}e.Range=C}),define(be[114],we([0,1,38,32]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(S){S[S.LTR=0]="LTR",S[S.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class P extends C.Range{constructor(D,y,n,T){super(D,y,n,T);this.selectionStartLineNumber=D,this.selectionStartColumn=y,this.positionLineNumber=n,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return P.selectionsEqual(this,D)}static selectionsEqual(D,y){return D.selectionStartLineNumber===y.selectionStartLineNumber&&D.selectionStartColumn===y.selectionStartColumn&&D.positionLineNumber===y.positionLineNumber&&D.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,y){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,D,y):new P(D,y,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,y){return this.getDirection()===0?new P(D,y,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,D,y)}static fromPositions(D,y=D){return new P(D.lineNumber,D.column,y.lineNumber,y.column)}static liftSelection(D){return new P(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,y){if(D&&!y||!D&&y)return!1;if(!D&&!y)return!0;if(D.length!==y.length)return!1;for(let n=0,T=D.length;n<T;n++)if(!this.selectionsEqual(D[n],y[n]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,y,n,T,k){return k===0?new P(D,y,n,T):new P(n,T,D,y)}}e.Selection=P}),define(be[85],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var E;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(E=e.OverviewRulerLane||(e.OverviewRulerLane={}));var C;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(C=e.MinimapPosition||(e.MinimapPosition={}));var I;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(I=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(r){this.tabSize=Math.max(1,r.tabSize|0),this.indentSize=r.tabSize|0,this.insertSpaces=Boolean(r.insertSpaces),this.defaultEOL=r.defaultEOL|0,this.trimAutoWhitespace=Boolean(r.trimAutoWhitespace)}equals(r){return this.tabSize===r.tabSize&&this.indentSize===r.indentSize&&this.insertSpaces===r.insertSpaces&&this.defaultEOL===r.defaultEOL&&this.trimAutoWhitespace===r.trimAutoWhitespace}createChangeEvent(r){return{tabSize:this.tabSize!==r.tabSize,indentSize:this.indentSize!==r.indentSize,insertSpaces:this.insertSpaces!==r.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==r.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class y{constructor(r,a){this.range=r,this.matches=a}}e.FindMatch=y;var n;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var T;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(T=e.ModelConstants||(e.ModelConstants={}));class k{constructor(r,a,p,d,b,g){this.identifier=r,this.range=a,this.text=p,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=b,this._isTracked=g}}e.ValidAnnotatedEditOperation=k;class f{constructor(r,a,p){this.reverseEdits=r,this.changes=a,this.trimAutoWhitespaceLineNumbers=p}}e.ApplyEditsResult=f}),define(be[115],we([0,1,8,113,38,32,85]),function(Y,e,E,C,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class y{constructor(g,c,w,t){this.searchString=g,this.isRegex=c,this.matchCase=w,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let g;this.isRegex?g=n(this.searchString):g=this.searchString.indexOf(`
`)>=0;let c=null;try{c=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:g,global:!0,unicode:!0})}catch(t){return null}if(!c)return null;let w=!this.isRegex&&!g;return w&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(w=this.matchCase),new T(c,this.wordSeparators?(0,C.getMapForWordSeparators)(this.wordSeparators):null,w?this.searchString:null)}}e.SearchParams=y;function n(b){if(!b||b.length===0)return!1;for(let g=0,c=b.length;g<c;g++)if(b.charCodeAt(g)===92){if(g++,g>=c)break;const t=b.charCodeAt(g);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class T{constructor(g,c,w){this.regex=g,this.wordSeparators=c,this.simpleSearch=w}}e.SearchData=T;function k(b,g,c){if(!c)return new S.FindMatch(b,null);let w=[];for(let t=0,i=g.length;t<i;t++)w[t]=g[t];return new S.FindMatch(b,w)}e.createFindMatch=k;class f{constructor(g){let c=[],w=0;for(let t=0,i=g.length;t<i;t++)g.charCodeAt(t)===10&&(c[w++]=t);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(g){const c=this._lineFeedsOffsets;let w=0,t=c.length-1;if(t===-1||g<=c[0])return 0;for(;w<t;){const i=w+((t-w)/2>>0);c[i]>=g?t=i-1:c[i+1]>=g?(w=i,t=i):w=i+1}return w+1}}class h{static findMatches(g,c,w,t,i){const l=c.parseSearchRequest();return l?l.regex.multiline?this._doFindMatchesMultiline(g,w,new d(l.wordSeparators,l.regex),t,i):this._doFindMatchesLineByLine(g,w,l,t,i):[]}static _getMultilineMatchRange(g,c,w,t,i,l){let s,o=0;t?(o=t.findLineFeedCountBeforeOffset(i),s=c+i+o):s=c+i;let u;if(t){let _=t.findLineFeedCountBeforeOffset(i+l.length)-o;u=s+l.length+_}else u=s+l.length;const v=g.getPositionAt(s),A=g.getPositionAt(u);return new P.Range(v.lineNumber,v.column,A.lineNumber,A.column)}static _doFindMatchesMultiline(g,c,w,t,i){const l=g.getOffsetAt(c.getStartPosition()),s=g.getValueInRange(c,1),o=g.getEOL()===`\r
`?new f(s):null,u=[];let v=0,A;for(w.reset(0);A=w.next(s);)if(u[v++]=k(this._getMultilineMatchRange(g,l,s,o,A.index,A[0]),A,t),v>=i)return u;return u}static _doFindMatchesLineByLine(g,c,w,t,i){const l=[];let s=0;if(c.startLineNumber===c.endLineNumber){const u=g.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return s=this._findMatchesInLine(w,u,c.startLineNumber,c.startColumn-1,s,l,t,i),l}const o=g.getLineContent(c.startLineNumber).substring(c.startColumn-1);s=this._findMatchesInLine(w,o,c.startLineNumber,c.startColumn-1,s,l,t,i);for(let u=c.startLineNumber+1;u<c.endLineNumber&&s<i;u++)s=this._findMatchesInLine(w,g.getLineContent(u),u,0,s,l,t,i);if(s<i){const u=g.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);s=this._findMatchesInLine(w,u,c.endLineNumber,0,s,l,t,i)}return l}static _findMatchesInLine(g,c,w,t,i,l,s,o){const u=g.wordSeparators;if(!s&&g.simpleSearch){const m=g.simpleSearch,_=m.length,R=c.length;let L=-_;for(;(L=c.indexOf(m,L+_))!==-1;)if((!u||p(u,c,R,L,_))&&(l[i++]=new S.FindMatch(new P.Range(w,L+1+t,w,L+1+_+t),null),i>=o))return i;return i}const v=new d(g.wordSeparators,g.regex);let A;v.reset(0);do if(A=v.next(c),A&&(l[i++]=k(new P.Range(w,A.index+1+t,w,A.index+1+A[0].length+t),A,s),i>=o))return i;while(A);return i}static findNextMatch(g,c,w,t){const i=c.parseSearchRequest();if(!i)return null;const l=new d(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(g,w,l,t):this._doFindNextMatchLineByLine(g,w,l,t)}static _doFindNextMatchMultiline(g,c,w,t){const i=new I.Position(c.lineNumber,1),l=g.getOffsetAt(i),s=g.getLineCount(),o=g.getValueInRange(new P.Range(i.lineNumber,i.column,s,g.getLineMaxColumn(s)),1),u=g.getEOL()===`\r
`?new f(o):null;w.reset(c.column-1);let v=w.next(o);return v?k(this._getMultilineMatchRange(g,l,o,u,v.index,v[0]),v,t):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(g,new I.Position(1,1),w,t):null}static _doFindNextMatchLineByLine(g,c,w,t){const i=g.getLineCount(),l=c.lineNumber,s=g.getLineContent(l),o=this._findFirstMatchInLine(w,s,l,c.column,t);if(o)return o;for(let u=1;u<=i;u++){const v=(l+u-1)%i,A=g.getLineContent(v+1),m=this._findFirstMatchInLine(w,A,v+1,1,t);if(m)return m}return null}static _findFirstMatchInLine(g,c,w,t,i){g.reset(t-1);const l=g.next(c);return l?k(new P.Range(w,l.index+1,w,l.index+1+l[0].length),l,i):null}static findPreviousMatch(g,c,w,t){const i=c.parseSearchRequest();if(!i)return null;const l=new d(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(g,w,l,t):this._doFindPreviousMatchLineByLine(g,w,l,t)}static _doFindPreviousMatchMultiline(g,c,w,t){const i=this._doFindMatchesMultiline(g,new P.Range(1,1,c.lineNumber,c.column),w,t,10*D);if(i.length>0)return i[i.length-1];const l=g.getLineCount();return c.lineNumber!==l||c.column!==g.getLineMaxColumn(l)?this._doFindPreviousMatchMultiline(g,new I.Position(l,g.getLineMaxColumn(l)),w,t):null}static _doFindPreviousMatchLineByLine(g,c,w,t){const i=g.getLineCount(),l=c.lineNumber,s=g.getLineContent(l).substring(0,c.column-1),o=this._findLastMatchInLine(w,s,l,t);if(o)return o;for(let u=1;u<=i;u++){const v=(i+l-u-1)%i,A=g.getLineContent(v+1),m=this._findLastMatchInLine(w,A,v+1,t);if(m)return m}return null}static _findLastMatchInLine(g,c,w,t){let i=null,l;for(g.reset(0);l=g.next(c);)i=k(new P.Range(w,l.index+1,w,l.index+1+l[0].length),l,t);return i}}e.TextModelSearch=h;function r(b,g,c,w,t){if(w===0)return!0;const i=g.charCodeAt(w-1);if(b.get(i)!==0||i===13||i===10)return!0;if(t>0){const l=g.charCodeAt(w);if(b.get(l)!==0)return!0}return!1}function a(b,g,c,w,t){if(w+t===c)return!0;const i=g.charCodeAt(w+t);if(b.get(i)!==0||i===13||i===10)return!0;if(t>0){const l=g.charCodeAt(w+t-1);if(b.get(l)!==0)return!0}return!1}function p(b,g,c,w,t){return r(b,g,c,w,t)&&a(b,g,c,w,t)}e.isValidMatch=p;class d{constructor(g,c){this._wordSeparators=g,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(g){this._searchRegex.lastIndex=g,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(g){const c=g.length;let w;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(w=this._searchRegex.exec(g),!w))return null;const t=w.index,i=w[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){E.getNextCodePoint(g,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||p(this._wordSeparators,g,c,t,i))return w}while(w);return null}}e.Searcher=d}),define(be[86],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function E(D=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)D.indexOf(n)>=0||(y+="\\"+n);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=E();function C(D){let y=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)y=D;else{let n="g";D.ignoreCase&&(n+="i"),D.multiline&&(n+="m"),D.unicode&&(n+="u"),y=new RegExp(D.source,n)}return y.lastIndex=0,y}e.ensureValidWordDefinition=C;const I={maxLen:1e3,windowSize:15,timeBudget:150};function P(D,y,n,T,k=I){if(n.length>k.maxLen){let p=D-k.maxLen/2;return p<0?p=0:T+=p,n=n.substring(p,D+k.maxLen/2),P(D,y,n,T,k)}const f=Date.now(),h=D-1-T;let r=-1,a=null;for(let p=1;!(Date.now()-f>=k.timeBudget);p++){const d=h-k.windowSize*p;y.lastIndex=Math.max(0,d);const b=S(y,n,h,r);if(!b&&a||(a=b,d<=0))break;r=d}if(a){let p={word:a[0],startColumn:T+1+a.index,endColumn:T+1+a.index+a[0].length};return y.lastIndex=0,p}return null}e.getWordAtText=P;function S(D,y,n,T){let k;for(;k=D.exec(y);){const f=k.index||0;if(f<=n&&D.lastIndex>=n)return k;if(T>0&&f>T)return null}return null}}),define(be[116],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var E;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(E=e.IndentAction||(e.IndentAction={}));class C{constructor(D){if(this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let y=0,n=D.notIn.length;y<n;y++)switch(D.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=C;class I{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of D)P(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),P(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),P(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),P(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&P(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=I;function P(S,D,y){S.has(D)?S.get(D).push(y):S.set(D,[y])}}),define(be[60],we([0,1,28,13]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(P,S,D,y){if(Array.isArray(P)){let n=0;for(const T of P){const k=I(T,S,D,y);if(k===10)return k;k>n&&(n=k)}return n}else{if(typeof P=="string")return y?P==="*"?5:P===D?10:0:0;if(P){const{language:n,pattern:T,scheme:k,hasAccessToAllModels:f}=P;if(!y&&!f)return 0;let h=0;if(k)if(k===S.scheme)h=10;else if(k==="*")h=5;else return 0;if(n)if(n===D)h=10;else if(n==="*")h=Math.max(h,5);else return 0;if(T){let r;if(typeof T=="string"?r=T:r=Object.assign(Object.assign({},T),{base:(0,C.normalize)(T.base)}),r===S.fsPath||(0,E.match)(r,S.fsPath))h=10;else return 0}return h}else return 0}}e.score=I}),define(be[117],we([0,1,84]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var C;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(C=e.State||(e.State={}));class I{constructor(r,a,p){const d=new Uint8Array(r*a);for(let b=0,g=r*a;b<g;b++)d[b]=p;this._data=d,this.rows=r,this.cols=a}get(r,a){return this._data[r*this.cols+a]}set(r,a,p){this._data[r*this.cols+a]=p}}e.Uint8Matrix=I;class P{constructor(r){let a=0,p=0;for(let b=0,g=r.length;b<g;b++){let[c,w,t]=r[b];w>a&&(a=w),c>p&&(p=c),t>p&&(p=t)}a++,p++;let d=new I(p,a,0);for(let b=0,g=r.length;b<g;b++){let[c,w,t]=r[b];d.set(c,w,t)}this._states=d,this._maxCharCode=a}nextState(r,a){return a<0||a>=this._maxCharCode?0:this._states.get(r,a)}}e.StateMachine=P;let S=null;function D(){return S===null&&(S=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),S}var y;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let n=null;function T(){if(n===null){n=new E.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let a=0;a<h.length;a++)n.set(h.charCodeAt(a),1);const r=".,;";for(let a=0;a<r.length;a++)n.set(r.charCodeAt(a),2)}return n}class k{static _createLink(r,a,p,d,b){let g=b-1;do{const c=a.charCodeAt(g);if(r.get(c)!==2)break;g--}while(g>d);if(d>0){const c=a.charCodeAt(d-1),w=a.charCodeAt(g);(c===40&&w===41||c===91&&w===93||c===123&&w===125)&&g--}return{range:{startLineNumber:p,startColumn:d+1,endLineNumber:p,endColumn:g+2},url:a.substring(d,g+1)}}static computeLinks(r,a=D()){const p=T();let d=[];for(let b=1,g=r.getLineCount();b<=g;b++){const c=r.getLineContent(b),w=c.length;let t=0,i=0,l=0,s=1,o=!1,u=!1,v=!1,A=!1;for(;t<w;){let m=!1;const _=c.charCodeAt(t);if(s===13){let R;switch(_){case 40:o=!0,R=0;break;case 41:R=o?0:1;break;case 91:v=!0,u=!0,R=0;break;case 93:v=!1,R=u?0:1;break;case 123:A=!0,R=0;break;case 125:R=A?0:1;break;case 39:R=l===34||l===96?0:1;break;case 34:R=l===39||l===96?0:1;break;case 96:R=l===39||l===34?0:1;break;case 42:R=l===42?1:0;break;case 124:R=l===124?1:0;break;case 32:R=v?0:1;break;default:R=p.get(_)}R===1&&(d.push(k._createLink(p,c,b,i,t)),m=!0)}else if(s===12){let R;_===91?(u=!0,R=0):R=p.get(_),R===1?m=!0:s=13}else s=a.nextState(s,_),s===0&&(m=!0);m&&(s=1,o=!1,u=!1,A=!1,i=t+1,l=_),t++}s===13&&d.push(k._createLink(p,c,b,i,w))}return d}}e.LinkComputer=k;function f(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:k.computeLinks(h)}e.computeLinks=f}),define(be[118],we([0,1,3,6]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class I{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(S){this._onDidChange.fire({changedLanguages:S,changedColorMap:!1})}register(S,D){return this._map.set(S,D),this.fire([S]),(0,C.toDisposable)(()=>{this._map.get(S)===D&&(this._map.delete(S),this.fire([S]))})}registerPromise(S,D){let y=null,n=!1;return this._promises.set(S,D.then(T=>{this._promises.delete(S),!(n||!T)&&(y=this.register(S,T))})),(0,C.toDisposable)(()=>{n=!0,y&&y.dispose()})}getPromise(S){const D=this.get(S);if(D)return Promise.resolve(D);const y=this._promises.get(S);return y?y.then(n=>this.get(S)):null}get(S){return this._map.get(S)||null}setColorMap(S){this._colorMap=S,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=I}),define(be[87],we([0,1,23,21]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(I||(I={}));function P(k){for(let f=0,h=k.length;f<h;f+=4){const r=k[f+0],a=k[f+1],p=k[f+2],d=k[f+3];k[f+0]=d,k[f+1]=p,k[f+2]=a,k[f+3]=r}}function S(k){const f=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return C.isLittleEndian()||P(f),E.VSBuffer.wrap(f)}function D(k){const f=k.buffer;if(C.isLittleEndian()||P(f),f.byteOffset%4==0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const h=new Uint8Array(f.byteLength);return h.set(f),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function y(k){const f=new Uint32Array(n(k));let h=0;if(f[h++]=k.id,k.type==="full")f[h++]=1,f[h++]=k.data.length,f.set(k.data,h),h+=k.data.length;else{f[h++]=2,f[h++]=k.deltas.length;for(const r of k.deltas)f[h++]=r.start,f[h++]=r.deleteCount,r.data?(f[h++]=r.data.length,f.set(r.data,h),h+=r.data.length):f[h++]=0}return S(f)}e.encodeSemanticTokensDto=y;function n(k){let f=0;if(f+=1+1,k.type==="full")f+=1+k.data.length;else{f+=1,f+=(1+1+1)*k.deltas.length;for(const h of k.deltas)h.data&&(f+=h.data.length)}return f}function T(k){const f=D(k);let h=0;const r=f[h++];if(f[h++]===1){const b=f[h++],g=f.subarray(h,h+b);return h+=b,{id:r,type:"full",data:g}}const p=f[h++];let d=[];for(let b=0;b<p;b++){const g=f[h++],c=f[h++],w=f[h++];let t;w>0&&(t=f.subarray(h,h+w),h+=w),d[b]={start:g,deleteCount:c,data:t}}return{id:r,type:"delta",deltas:d}}e.decodeSemanticTokensDto=T}),define(be[88],we([0,1,82]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class C{constructor(S,D){this.index=S,this.remainder=D}}e.PrefixSumIndexOfResult=C;class I{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,D){S=(0,E.toUint32)(S);const y=this.values,n=this.prefixSum,T=D.length;return T===0?!1:(this.values=new Uint32Array(y.length+T),this.values.set(y.subarray(0,S),0),this.values.set(y.subarray(S),S+T),this.values.set(D,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(S,D){return S=(0,E.toUint32)(S),D=(0,E.toUint32)(D),this.values[S]===D?!1:(this.values[S]=D,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,D){S=(0,E.toUint32)(S),D=(0,E.toUint32)(D);const y=this.values,n=this.prefixSum;if(S>=y.length)return!1;let T=y.length-S;return D>=T&&(D=T),D===0?!1:(this.values=new Uint32Array(y.length-D),this.values.set(y.subarray(0,S),0),this.values.set(y.subarray(S+D),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(S){return S<0?0:(S=(0,E.toUint32)(S),this._getAccumulatedValue(S))}_getAccumulatedValue(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),S>=this.values.length&&(S=this.values.length-1);for(let y=D;y<=S;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalValue();let D=0,y=this.values.length-1,n=0,T=0,k=0;for(;D<=y;)if(n=D+(y-D)/2|0,T=this.prefixSum[n],k=T-this.values[n],S<k)y=n-1;else if(S>=T)D=n+1;else break;return new C(n,S-k)}}e.PrefixSumComputer=I}),define(be[119],we([0,1,8,38,88]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(D,y,n,T){this._uri=D,this._lines=y,this._eol=n,this._versionId=T,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const y=D.changes;for(const n of y)this._acceptDeleteRange(n.range),this._acceptInsertText(new C.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,y=this._lines.length,n=new Uint32Array(y);for(let T=0;T<y;T++)n[T]=this._lines[T].length+D;this._lineStarts=new I.PrefixSumComputer(n)}}_setLineText(D,y){this._lines[D]=y,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,y){if(y.length!==0){let n=(0,E.splitLines)(y);if(n.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+n[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}n[n.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+n[0]);let T=new Uint32Array(n.length-1);for(let k=1;k<n.length;k++)this._lines.splice(D.lineNumber+k-1,0,n[k]),T[k-1]=n[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,T)}}}e.MirrorTextModel=P}),define(be[120],we([16,17]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(be[61],we([0,1,120,10,12]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(n,T){return T&&(n.stack||n.stacktrace)?E.localize(0,null,D(n),S(n.stack)||S(n.stacktrace)):D(n)}function S(n){return Array.isArray(n)?n.join(`
`):n}function D(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?E.localize(1,null,n.message):n.message||E.localize(2,null)}function y(n=null,T=!1){if(!n)return E.localize(3,null);if(Array.isArray(n)){const k=I.coalesce(n),f=y(k[0],T);return k.length>1?E.localize(4,null,f,k.length):f}if(C.isString(n))return n;if(n.detail){const k=n.detail;if(k.error)return P(k.error,T);if(k.exception)return P(k.exception,T)}return n.stack?P(n,T):n.message?n.message:E.localize(5,null)}e.toErrorMessage=y}),define(be[121],we([16,17]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(be[122],we([0,1,121,21,86]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(j){j[j.None=0]="None",j[j.Keep=1]="Keep",j[j.Brackets=2]="Brackets",j[j.Advanced=3]="Advanced",j[j.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=S;class D{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,ve){this._values[te]=ve}}e.ValidatedEditorOptions=D;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class n{constructor(te,ve,Ue,He){this.id=te,this.name=ve,this.defaultValue=Ue,this.schema=He}compute(te,ve,Ue){return Ue}}class T{constructor(te,ve=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(te){return this.defaultValue}}class k{constructor(te,ve,Ue,He){this.id=te,this.name=ve,this.defaultValue=Ue,this.schema=He}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,ve,Ue){return Ue}}function f(j,te){return typeof j=="undefined"?te:j==="false"?!1:Boolean(j)}e.boolean=f;class h extends k{constructor(te,ve,Ue,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Ue),super(te,ve,Ue,He)}validate(te){return f(te,this.defaultValue)}}class r extends k{constructor(te,ve,Ue,He,$e,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="integer",Ye.default=Ue,Ye.minimum=He,Ye.maximum=$e),super(te,ve,Ue,Ye),this.minimum=He,this.maximum=$e}static clampedInt(te,ve,Ue,He){if(typeof te=="undefined")return ve;let $e=parseInt(te,10);return isNaN($e)?ve:($e=Math.max(Ue,$e),$e=Math.min(He,$e),$e|0)}validate(te){return r.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class a extends k{constructor(te,ve,Ue,He,$e){typeof $e!="undefined"&&($e.type="number",$e.default=Ue),super(te,ve,Ue,$e),this.validationFn=He}static clamp(te,ve,Ue){return te<ve?ve:te>Ue?Ue:te}static float(te,ve){if(typeof te=="number")return te;if(typeof te=="undefined")return ve;const Ue=parseFloat(te);return isNaN(Ue)?ve:Ue}validate(te){return this.validationFn(a.float(te,this.defaultValue))}}class p extends k{static string(te,ve){return typeof te!="string"?ve:te}constructor(te,ve,Ue,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Ue),super(te,ve,Ue,He)}validate(te){return p.string(te,this.defaultValue)}}function d(j,te,ve){return typeof j!="string"||ve.indexOf(j)===-1?te:j}e.stringSet=d;class b extends k{constructor(te,ve,Ue,He,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=He,$e.default=Ue),super(te,ve,Ue,$e),this._allowedValues=He}validate(te){return d(te,this.defaultValue,this._allowedValues)}}class g extends n{constructor(te,ve,Ue,He,$e,Ye,H=void 0){typeof H!="undefined"&&(H.type="string",H.enum=$e,H.default=He),super(te,ve,Ue,H),this._allowedValues=$e,this._convert=Ye}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function c(j){switch(j){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class w extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[E.localize(0,null),E.localize(1,null),E.localize(2,null)],default:"auto",description:E.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,ve,Ue){return Ue===0?te.accessibilitySupport:Ue}}class t extends n{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:E.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:E.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{insertSpace:f(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(j){j[j.Hidden=0]="Hidden",j[j.Blink=1]="Blink",j[j.Smooth=2]="Smooth",j[j.Phase=3]="Phase",j[j.Expand=4]="Expand",j[j.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function l(j){switch(j){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var s;(function(j){j[j.Line=1]="Line",j[j.Block=2]="Block",j[j.Underline=3]="Underline",j[j.LineThin=4]="LineThin",j[j.BlockOutline=5]="BlockOutline",j[j.UnderlineThin=6]="UnderlineThin"})(s=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(j){switch(j){case s.Line:return"line";case s.Block:return"block";case s.Underline:return"underline";case s.LineThin:return"line-thin";case s.BlockOutline:return"block-outline";case s.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function u(j){switch(j){case"line":return s.Line;case"block":return s.Block;case"underline":return s.Underline;case"line-thin":return s.LineThin;case"block-outline":return s.BlockOutline;case"underline-thin":return s.UnderlineThin}}class v extends T{constructor(){super(123,[62,31])}compute(te,ve,Ue){const He=["monaco-editor"];return ve.get(31)&&He.push(ve.get(31)),te.extraEditorClassName&&He.push(te.extraEditorClassName),ve.get(62)==="default"?He.push("mouse-default"):ve.get(62)==="copy"&&He.push("mouse-copy"),ve.get(97)&&He.push("showUnused"),ve.get(121)&&He.push("showDeprecated"),He.join(" ")}}class A extends h{constructor(){super(30,"emptySelectionClipboard",!0,{description:E.localize(6,null)})}compute(te,ve,Ue){return Ue&&te.emptySelectionClipboard}}class m extends n{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:E.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:te.seedSearchStringFromSelection,description:E.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[E.localize(9,null),E.localize(10,null),E.localize(11,null)],description:E.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:E.localize(13,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:E.localize(14,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:E.localize(15,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{cursorMoveOnType:f(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:f(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":d(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(ve.loop,this.defaultValue.loop)}}}class _ extends n{constructor(){super(41,"fontLigatures",_.OFF,{anyOf:[{type:"boolean",description:E.localize(16,null)},{type:"string",description:E.localize(17,null)}],description:E.localize(18,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?_.OFF:te==="true"?_.ON:te:Boolean(te)?_.ON:_.OFF}}e.EditorFontLigatures=_,_.OFF='"liga" off, "calt" off',_.ON='"liga" on, "calt" on';class R extends T{constructor(){super(40)}compute(te,ve,Ue){return te.fontInfo}}class L extends k{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:E.localize(19,null)})}validate(te){let ve=a.float(te,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(ve,6,100)}compute(te,ve,Ue){return te.fontInfo.fontSize}}class V extends n{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.MINIMUM_VALUE,maximum:V.MAXIMUM_VALUE,errorMessage:E.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:E.localize(21,null)})}validate(te){return te==="normal"||te==="bold"?te:String(r.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,V.MINIMUM_VALUE,V.MAXIMUM_VALUE))}}V.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],V.MINIMUM_VALUE=1,V.MAXIMUM_VALUE=1e3;class he extends n{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[E.localize(22,null),E.localize(23,null),E.localize(24,null)]};super(47,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:E.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:E.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:E.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:E.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:E.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:E.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,description:E.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,description:E.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,description:E.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,description:E.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,description:E.localize(35,null)}})}validate(te){var ve,Ue,He,$e,Ye;if(!te||typeof te!="object")return this.defaultValue;const H=te;return{multiple:d(H.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=H.multipleDefinitions)!==null&&ve!==void 0?ve:d(H.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ue=H.multipleTypeDefinitions)!==null&&Ue!==void 0?Ue:d(H.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=H.multipleDeclarations)!==null&&He!==void 0?He:d(H.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:($e=H.multipleImplementations)!==null&&$e!==void 0?$e:d(H.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ye=H.multipleReferences)!==null&&Ye!==void 0?Ye:d(H.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(H.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(H.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(H.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(H.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(H.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends n{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(50,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:E.localize(36,null)},"editor.hover.delay":{type:"number",default:te.delay,description:E.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:E.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:f(ve.enabled,this.defaultValue.enabled),delay:r.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:f(ve.sticky,this.defaultValue.sticky)}}}var W;(function(j){j[j.None=0]="None",j[j.Text=1]="Text",j[j.Blocks=2]="Blocks"})(W=e.RenderMinimap||(e.RenderMinimap={}));class J extends T{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(te,ve,Ue){return J.computeLayout(ve,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const ve=te.height/te.lineHeight,Ue=te.scrollBeyondLastLine?ve-1:0,He=(te.viewLineCount+Ue)/(te.pixelRatio*te.height),$e=Math.floor(te.viewLineCount/He);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Ue,desiredRatio:He,minimapLineCount:$e}}static _computeMinimapLayout(te,ve){const Ue=te.outerWidth,He=te.outerHeight,$e=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Ye=ve.stableMinimapLayoutInput,H=Ye&&te.outerHeight===Ye.outerHeight&&te.lineHeight===Ye.lineHeight&&te.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&te.pixelRatio===Ye.pixelRatio&&te.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&te.minimap.enabled===Ye.minimap.enabled&&te.minimap.side===Ye.minimap.side&&te.minimap.size===Ye.minimap.size&&te.minimap.showSlider===Ye.minimap.showSlider&&te.minimap.renderCharacters===Ye.minimap.renderCharacters&&te.minimap.maxColumn===Ye.minimap.maxColumn&&te.minimap.scale===Ye.minimap.scale&&te.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&te.isViewportWrapping===Ye.isViewportWrapping,se=te.lineHeight,de=te.typicalHalfwidthCharacterWidth,K=te.scrollBeyondLastLine,ee=te.minimap.renderCharacters;let le=$e>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const fe=te.minimap.maxColumn,Ee=te.minimap.size,Ve=te.minimap.side,Fe=te.verticalScrollbarWidth,We=te.viewLineCount,Qe=te.remainingWidth,it=te.isViewportWrapping,at=ee?2:3;let Ze=Math.floor($e*He);const nt=Ze/$e;let dt=!1,wt=!1,ue=at*le,Se=le/$e,ae=1;if(Ee==="fill"||Ee==="fit"){const{typicalViewportLineCount:rt,extraLinesBeyondLastLine:Ge,desiredRatio:ht,minimapLineCount:ot}=J.computeContainedMinimapLineCount({viewLineCount:We,scrollBeyondLastLine:K,height:He,lineHeight:se,pixelRatio:$e});if(We/ot>1)dt=!0,wt=!0,le=1,ue=1,Se=le/$e;else{let pt=!1,_t=le+1;if(Ee==="fit"){const yt=Math.ceil((We+Ge)*ue);it&&H&&Qe<=ve.stableFitRemainingWidth?(pt=!0,_t=ve.stableFitMaxMinimapScale):(pt=yt>Ze,it&&pt?(ve.stableMinimapLayoutInput=te,ve.stableFitRemainingWidth=Qe):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0))}if(Ee==="fill"||pt){dt=!0;const yt=le;ue=Math.min(se*$e,Math.max(1,Math.floor(1/ht))),le=Math.min(_t,Math.max(1,Math.floor(ue/at))),le>yt&&(ae=Math.min(2,le/yt)),Se=le/$e/ae,Ze=Math.ceil(Math.max(rt,We+Ge)*ue),it&&pt&&(ve.stableFitMaxMinimapScale=le)}}}const q=Math.floor(fe*Se),Le=Math.min(q,Math.max(0,Math.floor((Qe-Fe-2)*Se/(de+Se)))+e.MINIMAP_GUTTER_WIDTH);let Ie=Math.floor($e*Le);const Xe=Ie/$e;Ie=Math.floor(Ie*ae);const et=ee?1:2,ct=Ve==="left"?0:Ue-Le-Fe;return{renderMinimap:et,minimapLeft:ct,minimapWidth:Le,minimapHeightIsEditorHeight:dt,minimapIsSampling:wt,minimapScale:le,minimapLineHeight:ue,minimapCanvasInnerWidth:Ie,minimapCanvasInnerHeight:Ze,minimapCanvasOuterWidth:Xe,minimapCanvasOuterHeight:nt}}static computeLayout(te,ve){const Ue=ve.outerWidth|0,He=ve.outerHeight|0,$e=ve.lineHeight|0,Ye=ve.lineNumbersDigitCount|0,H=ve.typicalHalfwidthCharacterWidth,se=ve.maxDigitWidth,de=ve.pixelRatio,K=ve.viewLineCount,ee=te.get(118),le=ee==="inherit"?te.get(117):ee,fe=le==="inherit"?te.get(113):le,Ee=te.get(116),Ve=te.get(2),Fe=ve.isDominatedByLongLines,We=te.get(46),Qe=te.get(56).renderType!==0,it=te.get(57),at=te.get(91),Ze=te.get(61),nt=te.get(89),dt=nt.verticalScrollbarSize,wt=nt.verticalHasArrows,ue=nt.arrowSize,Se=nt.horizontalScrollbarSize,ae=te.get(54),q=te.get(35);let Le;if(typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)){const Pt=parseFloat(ae.substr(0,ae.length-2));Le=r.clampedInt(Pt*H,0,0,1e3)}else Le=r.clampedInt(ae,0,0,1e3);q&&(Le+=16);let Ie=0;if(Qe){const Pt=Math.max(Ye,it);Ie=Math.round(Pt*se)}let Xe=0;We&&(Xe=$e);let et=0,ct=et+Xe,rt=ct+Ie,Ge=rt+Le;const ht=Ue-Xe-Ie-Le;let ot=!1,vt=!1,pt=-1;Ve!==2&&(le==="inherit"&&Fe?(ot=!0,vt=!0):fe==="on"||fe==="bounded"?vt=!0:fe==="wordWrapColumn"&&(pt=Ee));const _t=J._computeMinimapLayout({outerWidth:Ue,outerHeight:He,lineHeight:$e,typicalHalfwidthCharacterWidth:H,pixelRatio:de,scrollBeyondLastLine:at,minimap:Ze,verticalScrollbarWidth:dt,viewLineCount:K,remainingWidth:ht,isViewportWrapping:vt},ve.memory||new y);_t.renderMinimap!==0&&_t.minimapLeft===0&&(et+=_t.minimapWidth,ct+=_t.minimapWidth,rt+=_t.minimapWidth,Ge+=_t.minimapWidth);const yt=ht-_t.minimapWidth,It=Math.max(1,Math.floor((yt-dt-2)/H)),bt=wt?ue:0;return vt&&(pt=Math.max(1,It),fe==="bounded"&&(pt=Math.min(pt,Ee))),{width:Ue,height:He,glyphMarginLeft:et,glyphMarginWidth:Xe,lineNumbersLeft:ct,lineNumbersWidth:Ie,decorationsLeft:rt,decorationsWidth:Le,contentLeft:Ge,contentWidth:yt,minimap:_t,viewportColumn:It,isWordWrapMinified:ot,isViewportWrapping:vt,wrappingColumn:pt,verticalScrollbarWidth:dt,horizontalScrollbarHeight:Se,overviewRuler:{top:bt,width:dt,height:He-2*bt,right:0}}}}e.EditorLayoutInfoComputer=J;class O extends n{constructor(){const te={enabled:!0};super(53,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:E.localize(39,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:f(te.enabled,this.defaultValue.enabled)}}}class F extends n{constructor(){const te={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",te,{"editor.inlineHints.enabled":{type:"boolean",default:te.enabled,description:E.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:te.fontSize,description:E.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:te.fontFamily,description:E.localize(42,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:f(ve.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class N extends r{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:E.localize(43,null)})}compute(te,ve,Ue){return te.fontInfo.lineHeight}}class B extends n{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:E.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[E.localize(45,null),E.localize(46,null),E.localize(47,null)],default:te.size,description:E.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:E.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:E.localize(50,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:E.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:E.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:E.localize(53,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:f(ve.enabled,this.defaultValue.enabled),size:d(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(ve.side,this.defaultValue.side,["right","left"]),showSlider:d(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(ve.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(ve.scale,1,1,3),maxColumn:r.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function U(j){return j==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Q extends n{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(55,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{top:r.clampedInt(ve.top,0,0,1e3),bottom:r.clampedInt(ve.bottom,0,0,1e3)}}}class Z extends n{constructor(){const te={enabled:!0,cycle:!1};super(72,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:E.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:E.localize(57,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:f(ve.enabled,this.defaultValue.enabled),cycle:f(ve.cycle,this.defaultValue.cycle)}}}class ne extends T{constructor(){super(124)}compute(te,ve,Ue){return te.pixelRatio}}class pe extends n{constructor(){const te={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:E.localize(58,null)},comments:{type:"boolean",default:te.comments,description:E.localize(59,null)},other:{type:"boolean",default:te.other,description:E.localize(60,null)}}}],default:te,description:E.localize(61,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const ve=te,Ue={other:f(ve.other,this.defaultValue.other),comments:f(ve.comments,this.defaultValue.comments),strings:f(ve.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var Pe;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval",j[j.Custom=4]="Custom"})(Pe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Oe extends n{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[E.localize(62,null),E.localize(63,null),E.localize(64,null),E.localize(65,null)],default:"on",description:E.localize(66,null)})}validate(te){let ve=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(ve=4,Ue=te):te==="interval"?ve=3:te==="relative"?ve=2:te==="on"?ve=1:ve=0),{renderType:ve,renderFn:Ue}}}function Te(j){const te=j.get(84);return te==="editable"?j.get(77):te!=="on"}e.filterValidationDecorations=Te;class xe extends n{constructor(){const te=[],ve={type:"number",description:E.localize(67,null)};super(88,"rulers",te,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:E.localize(68,null),format:"color-hex"}}}]},default:te,description:E.localize(69,null)})}validate(te){if(Array.isArray(te)){let ve=[];for(let Ue of te)if(typeof Ue=="number")ve.push({column:r.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const He=Ue;ve.push({column:r.clampedInt(He.column,0,0,1e4),color:He.color})}return ve.sort((Ue,He)=>Ue.column-He.column),ve}return this.defaultValue}}function $(j,te){if(typeof j!="string")return te;switch(j){case"hidden":return 2;case"visible":return 3;default:return 1}}class G extends n{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te,Ue=r.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=r.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:$(ve.vertical,this.defaultValue.vertical),horizontal:$(ve.horizontal,this.defaultValue.horizontal),useShadows:f(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:r.clampedInt(ve.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:He,verticalSliderSize:r.clampedInt(ve.verticalSliderSize,He,0,1e3),scrollByPage:f(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class ie extends n{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[E.localize(70,null),E.localize(71,null)],default:te.insertMode,description:E.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:E.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:E.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:E.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:E.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:E.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:E.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:E.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:E.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:E.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:E.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:E.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:E.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:E.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:E.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:E.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:E.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:E.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:E.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:E.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:E.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:E.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:E.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:E.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:E.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:E.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:E.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:E.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:E.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:E.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:E.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:E.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:E.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:E.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:E.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:E.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:E.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:E.localize(109,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{insertMode:d(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:f(ve.showIcons,this.defaultValue.showIcons),showStatusBar:f(ve.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:f(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(ve.showMethods,this.defaultValue.showMethods),showFunctions:f(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:f(ve.showConstructors,this.defaultValue.showConstructors),showFields:f(ve.showFields,this.defaultValue.showFields),showVariables:f(ve.showVariables,this.defaultValue.showVariables),showClasses:f(ve.showClasses,this.defaultValue.showClasses),showStructs:f(ve.showStructs,this.defaultValue.showStructs),showInterfaces:f(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:f(ve.showModules,this.defaultValue.showModules),showProperties:f(ve.showProperties,this.defaultValue.showProperties),showEvents:f(ve.showEvents,this.defaultValue.showEvents),showOperators:f(ve.showOperators,this.defaultValue.showOperators),showUnits:f(ve.showUnits,this.defaultValue.showUnits),showValues:f(ve.showValues,this.defaultValue.showValues),showConstants:f(ve.showConstants,this.defaultValue.showConstants),showEnums:f(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:f(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(ve.showKeywords,this.defaultValue.showKeywords),showWords:f(ve.showWords,this.defaultValue.showWords),showColors:f(ve.showColors,this.defaultValue.showColors),showFiles:f(ve.showFiles,this.defaultValue.showFiles),showReferences:f(ve.showReferences,this.defaultValue.showReferences),showFolders:f(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:f(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(ve.showSnippets,this.defaultValue.showSnippets),showUsers:f(ve.showUsers,this.defaultValue.showUsers),showIssues:f(ve.showIssues,this.defaultValue.showIssues)}}}class oe extends n{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:E.localize(110,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class me extends T{constructor(){super(125,[77])}compute(te,ve,Ue){return ve.get(77)?!0:te.tabFocusMode}}var De;(function(j){j[j.None=0]="None",j[j.Same=1]="Same",j[j.Indent=2]="Indent",j[j.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Ne(j){switch(j){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends T{constructor(){super(127,[126])}compute(te,ve,Ue){const He=ve.get(126);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?Ae:C.isLinux?Be:Ce,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function _e(j){return e.editorOptionsRegistry[j.id]=j,j}var qe;(function(j){j[j.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",j[j.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",j[j.accessibilitySupport=2]="accessibilitySupport",j[j.accessibilityPageSize=3]="accessibilityPageSize",j[j.ariaLabel=4]="ariaLabel",j[j.autoClosingBrackets=5]="autoClosingBrackets",j[j.autoClosingDelete=6]="autoClosingDelete",j[j.autoClosingOvertype=7]="autoClosingOvertype",j[j.autoClosingQuotes=8]="autoClosingQuotes",j[j.autoIndent=9]="autoIndent",j[j.automaticLayout=10]="automaticLayout",j[j.autoSurround=11]="autoSurround",j[j.codeLens=12]="codeLens",j[j.codeLensFontFamily=13]="codeLensFontFamily",j[j.codeLensFontSize=14]="codeLensFontSize",j[j.colorDecorators=15]="colorDecorators",j[j.columnSelection=16]="columnSelection",j[j.comments=17]="comments",j[j.contextmenu=18]="contextmenu",j[j.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",j[j.cursorBlinking=20]="cursorBlinking",j[j.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",j[j.cursorStyle=22]="cursorStyle",j[j.cursorSurroundingLines=23]="cursorSurroundingLines",j[j.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",j[j.cursorWidth=25]="cursorWidth",j[j.disableLayerHinting=26]="disableLayerHinting",j[j.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",j[j.domReadOnly=28]="domReadOnly",j[j.dragAndDrop=29]="dragAndDrop",j[j.emptySelectionClipboard=30]="emptySelectionClipboard",j[j.extraEditorClassName=31]="extraEditorClassName",j[j.fastScrollSensitivity=32]="fastScrollSensitivity",j[j.find=33]="find",j[j.fixedOverflowWidgets=34]="fixedOverflowWidgets",j[j.folding=35]="folding",j[j.foldingStrategy=36]="foldingStrategy",j[j.foldingHighlight=37]="foldingHighlight",j[j.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",j[j.fontFamily=39]="fontFamily",j[j.fontInfo=40]="fontInfo",j[j.fontLigatures=41]="fontLigatures",j[j.fontSize=42]="fontSize",j[j.fontWeight=43]="fontWeight",j[j.formatOnPaste=44]="formatOnPaste",j[j.formatOnType=45]="formatOnType",j[j.glyphMargin=46]="glyphMargin",j[j.gotoLocation=47]="gotoLocation",j[j.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",j[j.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",j[j.hover=50]="hover",j[j.inDiffEditor=51]="inDiffEditor",j[j.letterSpacing=52]="letterSpacing",j[j.lightbulb=53]="lightbulb",j[j.lineDecorationsWidth=54]="lineDecorationsWidth",j[j.lineHeight=55]="lineHeight",j[j.lineNumbers=56]="lineNumbers",j[j.lineNumbersMinChars=57]="lineNumbersMinChars",j[j.linkedEditing=58]="linkedEditing",j[j.links=59]="links",j[j.matchBrackets=60]="matchBrackets",j[j.minimap=61]="minimap",j[j.mouseStyle=62]="mouseStyle",j[j.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",j[j.mouseWheelZoom=64]="mouseWheelZoom",j[j.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",j[j.multiCursorModifier=66]="multiCursorModifier",j[j.multiCursorPaste=67]="multiCursorPaste",j[j.occurrencesHighlight=68]="occurrencesHighlight",j[j.overviewRulerBorder=69]="overviewRulerBorder",j[j.overviewRulerLanes=70]="overviewRulerLanes",j[j.padding=71]="padding",j[j.parameterHints=72]="parameterHints",j[j.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",j[j.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",j[j.quickSuggestions=75]="quickSuggestions",j[j.quickSuggestionsDelay=76]="quickSuggestionsDelay",j[j.readOnly=77]="readOnly",j[j.renameOnType=78]="renameOnType",j[j.renderControlCharacters=79]="renderControlCharacters",j[j.renderIndentGuides=80]="renderIndentGuides",j[j.renderFinalNewline=81]="renderFinalNewline",j[j.renderLineHighlight=82]="renderLineHighlight",j[j.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",j[j.renderValidationDecorations=84]="renderValidationDecorations",j[j.renderWhitespace=85]="renderWhitespace",j[j.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",j[j.roundedSelection=87]="roundedSelection",j[j.rulers=88]="rulers",j[j.scrollbar=89]="scrollbar",j[j.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",j[j.scrollBeyondLastLine=91]="scrollBeyondLastLine",j[j.scrollPredominantAxis=92]="scrollPredominantAxis",j[j.selectionClipboard=93]="selectionClipboard",j[j.selectionHighlight=94]="selectionHighlight",j[j.selectOnLineNumbers=95]="selectOnLineNumbers",j[j.showFoldingControls=96]="showFoldingControls",j[j.showUnused=97]="showUnused",j[j.snippetSuggestions=98]="snippetSuggestions",j[j.smartSelect=99]="smartSelect",j[j.smoothScrolling=100]="smoothScrolling",j[j.stickyTabStops=101]="stickyTabStops",j[j.stopRenderingLineAfter=102]="stopRenderingLineAfter",j[j.suggest=103]="suggest",j[j.suggestFontSize=104]="suggestFontSize",j[j.suggestLineHeight=105]="suggestLineHeight",j[j.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",j[j.suggestSelection=107]="suggestSelection",j[j.tabCompletion=108]="tabCompletion",j[j.tabIndex=109]="tabIndex",j[j.unusualLineTerminators=110]="unusualLineTerminators",j[j.useTabStops=111]="useTabStops",j[j.wordSeparators=112]="wordSeparators",j[j.wordWrap=113]="wordWrap",j[j.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",j[j.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",j[j.wordWrapColumn=116]="wordWrapColumn",j[j.wordWrapOverride1=117]="wordWrapOverride1",j[j.wordWrapOverride2=118]="wordWrapOverride2",j[j.wrappingIndent=119]="wrappingIndent",j[j.wrappingStrategy=120]="wrappingStrategy",j[j.showDeprecated=121]="showDeprecated",j[j.inlineHints=122]="inlineHints",j[j.editorClassName=123]="editorClassName",j[j.pixelRatio=124]="pixelRatio",j[j.tabFocusMode=125]="tabFocusMode",j[j.layoutInfo=126]="layoutInfo",j[j.wrappingInfo=127]="wrappingInfo"})(qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:E.localize(111,null)})),acceptSuggestionOnEnter:_e(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",E.localize(112,null),""],markdownDescription:E.localize(113,null)})),accessibilitySupport:_e(new w),accessibilityPageSize:_e(new r(3,"accessibilityPageSize",10,1,1073741824,{description:E.localize(114,null)})),ariaLabel:_e(new p(4,"ariaLabel",E.localize(115,null))),autoClosingBrackets:_e(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(116,null),E.localize(117,null),""],description:E.localize(118,null)})),autoClosingDelete:_e(new b(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",E.localize(119,null),""],description:E.localize(120,null)})),autoClosingOvertype:_e(new b(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",E.localize(121,null),""],description:E.localize(122,null)})),autoClosingQuotes:_e(new b(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(123,null),E.localize(124,null),""],description:E.localize(125,null)})),autoIndent:_e(new g(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[E.localize(126,null),E.localize(127,null),E.localize(128,null),E.localize(129,null),E.localize(130,null)],description:E.localize(131,null)})),automaticLayout:_e(new h(10,"automaticLayout",!1)),autoSurround:_e(new b(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[E.localize(132,null),E.localize(133,null),E.localize(134,null),""],description:E.localize(135,null)})),stickyTabStops:_e(new h(101,"stickyTabStops",!1,{description:E.localize(136,null)})),codeLens:_e(new h(12,"codeLens",!0,{description:E.localize(137,null)})),codeLensFontFamily:_e(new p(13,"codeLensFontFamily","",{description:E.localize(138,null)})),codeLensFontSize:_e(new r(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:E.localize(139,null)})),colorDecorators:_e(new h(15,"colorDecorators",!0,{description:E.localize(140,null)})),columnSelection:_e(new h(16,"columnSelection",!1,{description:E.localize(141,null)})),comments:_e(new t),contextmenu:_e(new h(18,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new h(19,"copyWithSyntaxHighlighting",!0,{description:E.localize(142,null)})),cursorBlinking:_e(new g(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:E.localize(143,null)})),cursorSmoothCaretAnimation:_e(new h(21,"cursorSmoothCaretAnimation",!1,{description:E.localize(144,null)})),cursorStyle:_e(new g(22,"cursorStyle",s.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],u,{description:E.localize(145,null)})),cursorSurroundingLines:_e(new r(23,"cursorSurroundingLines",0,0,1073741824,{description:E.localize(146,null)})),cursorSurroundingLinesStyle:_e(new b(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[E.localize(147,null),E.localize(148,null)],description:E.localize(149,null)})),cursorWidth:_e(new r(25,"cursorWidth",0,0,1073741824,{markdownDescription:E.localize(150,null)})),disableLayerHinting:_e(new h(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new h(27,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new h(28,"domReadOnly",!1)),dragAndDrop:_e(new h(29,"dragAndDrop",!0,{description:E.localize(151,null)})),emptySelectionClipboard:_e(new A),extraEditorClassName:_e(new p(31,"extraEditorClassName","")),fastScrollSensitivity:_e(new a(32,"fastScrollSensitivity",5,j=>j<=0?5:j,{markdownDescription:E.localize(152,null)})),find:_e(new m),fixedOverflowWidgets:_e(new h(34,"fixedOverflowWidgets",!1)),folding:_e(new h(35,"folding",!0,{description:E.localize(153,null)})),foldingStrategy:_e(new b(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[E.localize(154,null),E.localize(155,null)],description:E.localize(156,null)})),foldingHighlight:_e(new h(37,"foldingHighlight",!0,{description:E.localize(157,null)})),unfoldOnClickAfterEndOfLine:_e(new h(38,"unfoldOnClickAfterEndOfLine",!1,{description:E.localize(158,null)})),fontFamily:_e(new p(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:E.localize(159,null)})),fontInfo:_e(new R),fontLigatures2:_e(new _),fontSize:_e(new L),fontWeight:_e(new V),formatOnPaste:_e(new h(44,"formatOnPaste",!1,{description:E.localize(160,null)})),formatOnType:_e(new h(45,"formatOnType",!1,{description:E.localize(161,null)})),glyphMargin:_e(new h(46,"glyphMargin",!0,{description:E.localize(162,null)})),gotoLocation:_e(new he),hideCursorInOverviewRuler:_e(new h(48,"hideCursorInOverviewRuler",!1,{description:E.localize(163,null)})),highlightActiveIndentGuide:_e(new h(49,"highlightActiveIndentGuide",!0,{description:E.localize(164,null)})),hover:_e(new z),inDiffEditor:_e(new h(51,"inDiffEditor",!1)),letterSpacing:_e(new a(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,j=>a.clamp(j,-5,20),{description:E.localize(165,null)})),lightbulb:_e(new O),lineDecorationsWidth:_e(new k(54,"lineDecorationsWidth",10)),lineHeight:_e(new N),lineNumbers:_e(new Oe),lineNumbersMinChars:_e(new r(57,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new h(58,"linkedEditing",!1,{description:E.localize(166,null)})),links:_e(new h(59,"links",!0,{description:E.localize(167,null)})),matchBrackets:_e(new b(60,"matchBrackets","always",["always","near","never"],{description:E.localize(168,null)})),minimap:_e(new B),mouseStyle:_e(new b(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new a(63,"mouseWheelScrollSensitivity",1,j=>j===0?1:j,{markdownDescription:E.localize(169,null)})),mouseWheelZoom:_e(new h(64,"mouseWheelZoom",!1,{markdownDescription:E.localize(170,null)})),multiCursorMergeOverlapping:_e(new h(65,"multiCursorMergeOverlapping",!0,{description:E.localize(171,null)})),multiCursorModifier:_e(new g(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],U,{markdownEnumDescriptions:[E.localize(172,null),E.localize(173,null)],markdownDescription:E.localize(174,null)})),multiCursorPaste:_e(new b(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[E.localize(175,null),E.localize(176,null)],markdownDescription:E.localize(177,null)})),occurrencesHighlight:_e(new h(68,"occurrencesHighlight",!0,{description:E.localize(178,null)})),overviewRulerBorder:_e(new h(69,"overviewRulerBorder",!0,{description:E.localize(179,null)})),overviewRulerLanes:_e(new r(70,"overviewRulerLanes",3,0,3)),padding:_e(new Q),parameterHints:_e(new Z),peekWidgetDefaultFocus:_e(new b(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[E.localize(180,null),E.localize(181,null)],description:E.localize(182,null)})),definitionLinkOpensInPeek:_e(new h(74,"definitionLinkOpensInPeek",!1,{description:E.localize(183,null)})),quickSuggestions:_e(new pe),quickSuggestionsDelay:_e(new r(76,"quickSuggestionsDelay",10,0,1073741824,{description:E.localize(184,null)})),readOnly:_e(new h(77,"readOnly",!1)),renameOnType:_e(new h(78,"renameOnType",!1,{description:E.localize(185,null),markdownDeprecationMessage:E.localize(186,null)})),renderControlCharacters:_e(new h(79,"renderControlCharacters",!1,{description:E.localize(187,null)})),renderIndentGuides:_e(new h(80,"renderIndentGuides",!0,{description:E.localize(188,null)})),renderFinalNewline:_e(new h(81,"renderFinalNewline",!0,{description:E.localize(189,null)})),renderLineHighlight:_e(new b(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",E.localize(190,null)],description:E.localize(191,null)})),renderLineHighlightOnlyWhenFocus:_e(new h(83,"renderLineHighlightOnlyWhenFocus",!1,{description:E.localize(192,null)})),renderValidationDecorations:_e(new b(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new b(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",E.localize(193,null),E.localize(194,null),E.localize(195,null),""],description:E.localize(196,null)})),revealHorizontalRightPadding:_e(new r(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new h(87,"roundedSelection",!0,{description:E.localize(197,null)})),rulers:_e(new xe),scrollbar:_e(new G),scrollBeyondLastColumn:_e(new r(90,"scrollBeyondLastColumn",5,0,1073741824,{description:E.localize(198,null)})),scrollBeyondLastLine:_e(new h(91,"scrollBeyondLastLine",!0,{description:E.localize(199,null)})),scrollPredominantAxis:_e(new h(92,"scrollPredominantAxis",!0,{description:E.localize(200,null)})),selectionClipboard:_e(new h(93,"selectionClipboard",!0,{description:E.localize(201,null),included:C.isLinux})),selectionHighlight:_e(new h(94,"selectionHighlight",!0,{description:E.localize(202,null)})),selectOnLineNumbers:_e(new h(95,"selectOnLineNumbers",!0)),showFoldingControls:_e(new b(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[E.localize(203,null),E.localize(204,null)],description:E.localize(205,null)})),showUnused:_e(new h(97,"showUnused",!0,{description:E.localize(206,null)})),showDeprecated:_e(new h(121,"showDeprecated",!0,{description:E.localize(207,null)})),inlineHints:_e(new F),snippetSuggestions:_e(new b(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[E.localize(208,null),E.localize(209,null),E.localize(210,null),E.localize(211,null)],description:E.localize(212,null)})),smartSelect:_e(new oe),smoothScrolling:_e(new h(100,"smoothScrolling",!1,{description:E.localize(213,null)})),stopRenderingLineAfter:_e(new r(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new ie),suggestFontSize:_e(new r(104,"suggestFontSize",0,0,1e3,{markdownDescription:E.localize(214,null)})),suggestLineHeight:_e(new r(105,"suggestLineHeight",0,0,1e3,{markdownDescription:E.localize(215,null)})),suggestOnTriggerCharacters:_e(new h(106,"suggestOnTriggerCharacters",!0,{description:E.localize(216,null)})),suggestSelection:_e(new b(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[E.localize(217,null),E.localize(218,null),E.localize(219,null)],description:E.localize(220,null)})),tabCompletion:_e(new b(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[E.localize(221,null),E.localize(222,null),E.localize(223,null)],description:E.localize(224,null)})),tabIndex:_e(new r(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new b(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[E.localize(225,null),E.localize(226,null),E.localize(227,null)],description:E.localize(228,null)})),useTabStops:_e(new h(111,"useTabStops",!0,{description:E.localize(229,null)})),wordSeparators:_e(new p(112,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:E.localize(230,null)})),wordWrap:_e(new b(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[E.localize(231,null),E.localize(232,null),E.localize(233,null),E.localize(234,null)],description:E.localize(235,null)})),wordWrapBreakAfterCharacters:_e(new p(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new p(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new r(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:E.localize(236,null)})),wordWrapOverride1:_e(new b(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new b(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new g(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ne,{enumDescriptions:[E.localize(237,null),E.localize(238,null),E.localize(239,null),E.localize(240,null)],description:E.localize(241,null)})),wrappingStrategy:_e(new b(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[E.localize(242,null),E.localize(243,null)],description:E.localize(244,null)})),editorClassName:_e(new v),pixelRatio:_e(new ne),tabFocusMode:_e(new me),layoutInfo:_e(new J),wrappingInfo:_e(new ge)}}),define(be[123],we([16,17]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[124],we([16,17]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[125],we([16,17]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(be[126],we([16,17]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(be[127],we([16,17]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(be[128],we([16,17]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(be[129],we([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHost.api.impl",e)}),define(be[130],we([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[131],we([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(be[132],we([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[133],we([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(be[134],we([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[135],we([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[136],we([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[137],we([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[138],we([16,17]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(be[139],we([16,17]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[140],we([16,17]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[141],we([16,17]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[142],we([16,17]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[143],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var E;(function(S){S[S.ACTIVATE=0]="ACTIVATE",S[S.RESTORE=1]="RESTORE",S[S.PRESERVE=2]="PRESERVE"})(E=e.EditorActivation||(e.EditorActivation={}));var C;(function(S){S[S.PICK=1]="PICK",S[S.DISABLED=2]="DISABLED"})(C=e.EditorOverride||(e.EditorOverride={}));var I;(function(S){S[S.API=0]="API",S[S.USER=1]="USER"})(I=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(S){S[S.Center=0]="Center",S[S.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",S[S.NearTop=2]="NearTop",S[S.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[144],we([0,1,124]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function I(k){return k=k.trim(),k==="*"||C.test(k)}e.isValidVersionStr=I;function P(k){if(!I(k))return null;if(k=k.trim(),k==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=k.match(C);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=P;function S(k){if(!k)return null;let f=k.majorBase,h=k.majorMustEqual,r=k.minorBase,a=k.minorMustEqual,p=k.patchBase,d=k.patchMustEqual;return k.hasCaret&&(f===0||(a=!1),d=!1),{majorBase:f,majorMustEqual:h,minorBase:r,minorMustEqual:a,patchBase:p,patchMustEqual:d,isMinimum:k.hasGreaterEquals}}e.normalizeVersion=S;function D(k,f){let h;typeof k=="string"?h=S(P(k)):h=k;let r;if(typeof f=="string"?r=S(P(f)):r=f,!h||!r)return!1;let a=h.majorBase,p=h.minorBase,d=h.patchBase,b=r.majorBase,g=r.minorBase,c=r.patchBase,w=r.majorMustEqual,t=r.minorMustEqual,i=r.patchMustEqual;return r.isMinimum?a>b?!0:a<b?!1:p>g?!0:p<g?!1:d>=c:(a===1&&b===0&&(!w||!t||!i)&&(b=1,g=0,c=0,w=!0,t=!1,i=!1),a<b?!1:a>b?!w:p<g?!1:p>g?!t:d<c?!1:d>c?!i:!0)}e.isValidVersion=D;function y(k,f,h){return f.isBuiltin||typeof f.main=="undefined"?!0:T(k,f.engines.vscode,h)}e.isValidExtensionVersion=y;function n(k,f){return k==="*"||T(f,k)}e.isEngineValid=n;function T(k,f,h=[]){let r=S(P(f));if(!r)return h.push(E.localize(0,null,f)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return h.push(E.localize(1,null,f)),!1}else if(!r.majorMustEqual)return h.push(E.localize(2,null,f)),!1;return D(k,r)?!0:(h.push(E.localize(3,null,k,f)),!1)}e.isVersionValid=T}),define(be[89],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class E{constructor(P,S=[],D=!1){this.ctor=P,this.staticArguments=S,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=E;const C=(I,...P)=>new E(I,P);e.createSyncDescriptor=C}),define(be[62],we([0,1,89]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const C=[];function I(S,D,y){D instanceof E.SyncDescriptor||(D=new E.SyncDescriptor(D,[],y)),C.push([S,D])}e.registerSingleton=I;function P(){return C}e.getSingletonServiceDescriptors=P}),define(be[145],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=E;class C{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let S of this._nodes.values())S.outgoing.size===0&&P.push(S);return P}insertEdge(P,S){const D=this.lookupOrInsertNode(P),y=this.lookupOrInsertNode(S);D.outgoing.set(this._hashFn(S),y),y.incoming.set(this._hashFn(P),D)}removeNode(P){const S=this._hashFn(P);this._nodes.delete(S);for(let D of this._nodes.values())D.outgoing.delete(S),D.incoming.delete(S)}lookupOrInsertNode(P){const S=this._hashFn(P);let D=this._nodes.get(S);return D||(D=new E(P),this._nodes.set(S,D)),D}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[S,D]of this._nodes)P.push(`${S}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(let[P,S]of this._nodes){const D=new Set([P]),y=this._findCycle(S,D);if(y)return y}}_findCycle(P,S){for(let[D,y]of P.outgoing){if(S.has(D))return[...S,D].join(" -> ");S.add(D);const n=this._findCycle(y,S);if(n)return n;S.delete(D)}}}e.Graph=C}),define(be[4],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function y(n){return n[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=y})(E=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function C(D,y,n,T){y[E.DI_TARGET]===y?y[E.DI_DEPENDENCIES].push({id:D,index:n,optional:T}):(y[E.DI_DEPENDENCIES]=[{id:D,index:n,optional:T}],y[E.DI_TARGET]=y)}function I(D){if(E.serviceIds.has(D))return E.serviceIds.get(D);const y=function(n,T,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(y,n,k,!1)};return y.toString=()=>D,E.serviceIds.set(D,y),y}e.createDecorator=I;function P(D){return D}e.refineServiceDecorator=P;function S(D){return function(y,n,T){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");C(D,y,T,!0)}}e.optional=S}),define(be[146],we([0,1,4]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,E.createDecorator)("modelService");function C(I){return!I.isTooLargeForSyncing()&&!I.isForSimpleWidget}e.shouldSynchronizeModel=C}),define(be[147],we([0,1,3,57,6,22,81,60,146]),function(Y,e,E,C,I,P,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(f){return typeof f=="string"?!1:Array.isArray(f)?f.every(n):!!f.exclusive}class T{constructor(){this._clock=0,this._entries=[],this._onDidChange=new E.Emitter}get onDidChange(){return this._onDidChange.event}register(h,r){let a={selector:h,provider:r,_score:-1,_time:this._clock++};return this._entries.push(a),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,I.toDisposable)(()=>{if(a){let p=this._entries.indexOf(a);p>=0&&(this._entries.splice(p,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),a=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const r=[];for(let a of this._entries)a._score>0&&r.push(a.provider);return r}ordered(h){const r=[];return this._orderedForEach(h,a=>r.push(a.provider)),r}orderedGroups(h){const r=[];let a,p;return this._orderedForEach(h,d=>{a&&p===d._score?a.push(d.provider):(p=d._score,a=[d.provider],r.push(a))}),r}_orderedForEach(h,r){if(!!h){this._updateScores(h);for(const a of this._entries)a._score>0&&r(a)}}_updateScores(h){let r={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===r.language&&this._lastCandidate.uri===r.uri)){this._lastCandidate=r;for(let a of this._entries)if(a._score=(0,D.score)(a.selector,h.uri,h.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(h)),n(a.selector)&&a._score>0){for(let p of this._entries)p._score=0;a._score=1e3;break}this._entries.sort(T._compareByScoreAndTime)}}static _compareByScoreAndTime(h,r){return h._score<r._score?1:h._score>r._score?-1:h._time<r._time?1:h._time>r._time?-1:0}}e.LanguageFeatureRegistry=T;class k{constructor(h,r,a=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=r,this.max=a,this._cache=new P.LRUCache(50,.7)}_key(h){return h.id+(0,C.hash)(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const r=this._key(h),a=this._cache.get(r);return this._clamp(a==null?void 0:a.value)}update(h,r){const a=this._key(h);let p=this._cache.get(a);return p||(p=new S.MovingAverage,this._cache.set(a,p)),p.update(r),this.get(h)}}e.LanguageFeatureRequestDelays=k}),define(be[63],we([0,1,2,32,147,118,36]),function(Y,e,E,C,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(m){m[m.Null=0]="Null",m[m.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class y{constructor(_,R){this.language=_,this.id=R}}e.LanguageIdentifier=y;var n;(function(m){m[m.NotSet=-1]="NotSet",m[m.None=0]="None",m[m.Italic=1]="Italic",m[m.Bold=2]="Bold",m[m.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var T;(function(m){m[m.None=0]="None",m[m.DefaultForeground=1]="DefaultForeground",m[m.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var k;(function(m){m[m.Other=0]="Other",m[m.Comment=1]="Comment",m[m.String=2]="String",m[m.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var f;(function(m){m[m.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",m[m.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",m[m.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",m[m.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",m[m.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",m[m.ITALIC_MASK=2048]="ITALIC_MASK",m[m.BOLD_MASK=4096]="BOLD_MASK",m[m.UNDERLINE_MASK=8192]="UNDERLINE_MASK",m[m.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",m[m.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",m[m.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",m[m.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",m[m.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",m[m.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",m[m.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",m[m.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",m[m.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",m[m.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(f=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(_){return(_&255)>>>0}static getTokenType(_){return(_&1792)>>>8}static getFontStyle(_){return(_&14336)>>>11}static getForeground(_){return(_&8372224)>>>14}static getBackground(_){return(_&4286578688)>>>23}static getClassNameFromMetadata(_){let R=this.getForeground(_),L="mtk"+R,V=this.getFontStyle(_);return V&1&&(L+=" mtki"),V&2&&(L+=" mtkb"),V&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(_,R){const L=this.getForeground(_),V=this.getFontStyle(_);let he=`color: ${R[L]};`;return V&1&&(he+="font-style: italic;"),V&2&&(he+="font-weight: bold;"),V&4&&(he+="text-decoration: underline;"),he}}e.TokenMetadata=h;var r;(function(m){m[m.Method=0]="Method",m[m.Function=1]="Function",m[m.Constructor=2]="Constructor",m[m.Field=3]="Field",m[m.Variable=4]="Variable",m[m.Class=5]="Class",m[m.Struct=6]="Struct",m[m.Interface=7]="Interface",m[m.Module=8]="Module",m[m.Property=9]="Property",m[m.Event=10]="Event",m[m.Operator=11]="Operator",m[m.Unit=12]="Unit",m[m.Value=13]="Value",m[m.Constant=14]="Constant",m[m.Enum=15]="Enum",m[m.EnumMember=16]="EnumMember",m[m.Keyword=17]="Keyword",m[m.Text=18]="Text",m[m.Color=19]="Color",m[m.File=20]="File",m[m.Reference=21]="Reference",m[m.Customcolor=22]="Customcolor",m[m.Folder=23]="Folder",m[m.TypeParameter=24]="TypeParameter",m[m.User=25]="User",m[m.Issue=26]="Issue",m[m.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let m=Object.create(null);return m[0]="symbol-method",m[1]="symbol-function",m[2]="symbol-constructor",m[3]="symbol-field",m[4]="symbol-variable",m[5]="symbol-class",m[6]="symbol-struct",m[7]="symbol-interface",m[8]="symbol-module",m[9]="symbol-property",m[10]="symbol-event",m[11]="symbol-operator",m[12]="symbol-unit",m[13]="symbol-value",m[14]="symbol-constant",m[15]="symbol-enum",m[16]="symbol-enum-member",m[17]="symbol-keyword",m[27]="symbol-snippet",m[18]="symbol-text",m[19]="symbol-color",m[20]="symbol-file",m[21]="symbol-reference",m[22]="symbol-customcolor",m[23]="symbol-folder",m[24]="symbol-type-parameter",m[25]="account",m[26]="issues",function(_){const R=m[_];let L=R&&S.iconRegistry.get(R);return L||(console.info("No codicon found for CompletionItemKind "+_),L=S.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let m=Object.create(null);return m.method=0,m.function=1,m.constructor=2,m.field=3,m.variable=4,m.class=5,m.struct=6,m.interface=7,m.module=8,m.property=9,m.event=10,m.operator=11,m.unit=12,m.value=13,m.constant=14,m.enum=15,m["enum-member"]=16,m.enumMember=16,m.keyword=17,m.snippet=27,m.text=18,m.color=19,m.file=20,m.reference=21,m.customcolor=22,m.folder=23,m["type-parameter"]=24,m.typeParameter=24,m.account=25,m.issue=26,function(_,R){let L=m[_];return typeof L=="undefined"&&!R&&(L=9),L}}();var a;(function(m){m[m.Deprecated=1]="Deprecated"})(a=e.CompletionItemTag||(e.CompletionItemTag={}));var p;(function(m){m[m.KeepWhitespace=1]="KeepWhitespace",m[m.InsertAsSnippet=4]="InsertAsSnippet"})(p=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var d;(function(m){m[m.Invoke=0]="Invoke",m[m.TriggerCharacter=1]="TriggerCharacter",m[m.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(m){m[m.Invoke=1]="Invoke",m[m.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(m){m[m.Invoke=1]="Invoke",m[m.TriggerCharacter=2]="TriggerCharacter",m[m.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var c;(function(m){m[m.Text=0]="Text",m[m.Read=1]="Read",m[m.Write=2]="Write"})(c=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function w(m){return m&&E.URI.isUri(m.uri)&&C.Range.isIRange(m.range)&&(C.Range.isIRange(m.originSelectionRange)||C.Range.isIRange(m.targetSelectionRange))}e.isLocationLink=w;var t;(function(m){m[m.File=0]="File",m[m.Module=1]="Module",m[m.Namespace=2]="Namespace",m[m.Package=3]="Package",m[m.Class=4]="Class",m[m.Method=5]="Method",m[m.Property=6]="Property",m[m.Field=7]="Field",m[m.Constructor=8]="Constructor",m[m.Enum=9]="Enum",m[m.Interface=10]="Interface",m[m.Function=11]="Function",m[m.Variable=12]="Variable",m[m.Constant=13]="Constant",m[m.String=14]="String",m[m.Number=15]="Number",m[m.Boolean=16]="Boolean",m[m.Array=17]="Array",m[m.Object=18]="Object",m[m.Key=19]="Key",m[m.Null=20]="Null",m[m.EnumMember=21]="EnumMember",m[m.Struct=22]="Struct",m[m.Event=23]="Event",m[m.Operator=24]="Operator",m[m.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var i;(function(m){m[m.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var l;(function(m){const _=new Map;_.set("file",0),_.set("module",1),_.set("namespace",2),_.set("package",3),_.set("class",4),_.set("method",5),_.set("property",6),_.set("field",7),_.set("constructor",8),_.set("enum",9),_.set("interface",10),_.set("function",11),_.set("variable",12),_.set("constant",13),_.set("string",14),_.set("number",15),_.set("boolean",16),_.set("array",17),_.set("object",18),_.set("key",19),_.set("null",20),_.set("enum-member",21),_.set("struct",22),_.set("event",23),_.set("operator",24),_.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function L(z){return _.get(z)}m.fromString=L;function V(z){return R.get(z)}m.toString=V;function he(z,W){const J=R.get(z);let O=J&&S.iconRegistry.get("symbol-"+J);return O||(console.info("No codicon found for SymbolKind "+z),O=S.Codicon.symbolProperty),`${W?"inline":"block"} ${O.classNames}`}m.toCssClassName=he})(l=e.SymbolKinds||(e.SymbolKinds={}));class s{constructor(_){this.value=_}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var o;(function(m){m[m.Collapsed=0]="Collapsed",m[m.Expanded=1]="Expanded"})(o=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var u;(function(m){m[m.Editing=0]="Editing",m[m.Preview=1]="Preview"})(u=e.CommentMode||(e.CommentMode={}));var v;(function(m){m[m.Other=0]="Other",m[m.Type=1]="Type",m[m.Parameter=2]="Parameter"})(v=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new I.LanguageFeatureRegistry,e.RenameProviderRegistry=new I.LanguageFeatureRegistry,e.CompletionProviderRegistry=new I.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new I.LanguageFeatureRegistry,e.HoverProviderRegistry=new I.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new I.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new I.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new I.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new I.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new I.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.LinkProviderRegistry=new I.LanguageFeatureRegistry,e.ColorProviderRegistry=new I.LanguageFeatureRegistry,e.SelectionRangeRegistry=new I.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.TokenizationRegistry=new P.TokenizationRegistryImpl;var A;(function(m){m[m.None=0]="None",m[m.Option=1]="Option",m[m.Default=2]="Default",m[m.Preferred=3]="Preferred"})(A=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[148],we([0,1,6,10,4,3,45,43]),function(Y,e,E,C,I,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,I.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new P.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,n){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:y,handler:n})}if(y.description){const r=[];for(let p of y.description.args)r.push(p.constraint);const a=y.handler;y.handler=function(p,...d){return(0,C.validateConstraints)(d,r),a(p,...d)}}const{id:T}=y;let k=this._commands.get(T);k||(k=new S.LinkedList,this._commands.set(T,k));let f=k.unshift(y),h=(0,E.toDisposable)(()=>{f();const r=this._commands.get(T);(r==null?void 0:r.isEmpty())&&this._commands.delete(T)});return this._onDidRegisterCommand.fire(T),h}registerCommandAlias(y,n){return e.CommandsRegistry.registerCommand(y,(T,...k)=>T.get(e.ICommandService).executeCommand(n,...k))}getCommand(y){const n=this._commands.get(y);if(!(!n||n.isEmpty()))return D.Iterable.first(n)}getCommands(){const y=new Map;for(const n of this._commands.keys()){const T=this.getCommand(n);T&&y.set(n,T)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>E.Disposable.None,onDidExecuteCommand:()=>E.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(be[64],we([0,1,8,4,21]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let P=I.userAgent||"";const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",I.isMacintosh),S.set("isLinux",I.isLinux),S.set("isWindows",I.isWindows),S.set("isWeb",I.isWeb),S.set("isMacNative",I.isMacintosh&&!I.isWeb),S.set("isEdge",P.indexOf("Edg/")>=0),S.set("isFirefox",P.indexOf("Firefox")>=0),S.set("isChrome",P.indexOf("Chrome")>=0),S.set("isSafari",P.indexOf("Safari")>=0),S.set("isIPad",P.indexOf("iPad")>=0);const D=Object.prototype.hasOwnProperty;var y;(function(m){m[m.False=0]="False",m[m.True=1]="True",m[m.Defined=2]="Defined",m[m.Not=3]="Not",m[m.Equals=4]="Equals",m[m.NotEquals=5]="NotEquals",m[m.And=6]="And",m[m.Regex=7]="Regex",m[m.NotRegex=8]="NotRegex",m[m.Or=9]="Or",m[m.In=10]="In",m[m.NotIn=11]="NotIn",m[m.Greater=12]="Greater",m[m.GreaterEquals=13]="GreaterEquals",m[m.Smaller=14]="Smaller",m[m.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return k.INSTANCE}static true(){return f.INSTANCE}static has(_){return h.create(_)}static equals(_,R){return r.create(_,R)}static notEquals(_,R){return d.create(_,R)}static regex(_,R){return i.create(_,R)}static in(_,R){return a.create(_,R)}static not(_){return b.create(_)}static and(..._){return s.create(_)}static or(..._){return o.create(_)}static greater(_,R){return g.create(_,R)}static less(_,R){return w.create(_,R)}static deserialize(_,R=!1){if(!!_)return this._deserializeOrExpression(_,R)}static _deserializeOrExpression(_,R){let L=_.split("||");return o.create(L.map(V=>this._deserializeAndExpression(V,R)))}static _deserializeAndExpression(_,R){let L=_.split("&&");return s.create(L.map(V=>this._deserializeOne(V,R)))}static _deserializeOne(_,R){if(_=_.trim(),_.indexOf("!=")>=0){let L=_.split("!=");return d.create(L[0].trim(),this._deserializeValue(L[1],R))}if(_.indexOf("==")>=0){let L=_.split("==");return r.create(L[0].trim(),this._deserializeValue(L[1],R))}if(_.indexOf("=~")>=0){let L=_.split("=~");return i.create(L[0].trim(),this._deserializeRegexValue(L[1],R))}if(_.indexOf(" in ")>=0){let L=_.split(" in ");return a.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(_)){const L=_.split(">=");return c.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(_)){const L=_.split(">");return g.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(_)){const L=_.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(_)){const L=_.split("<");return w.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(_)?b.create(_.substr(1).trim()):h.create(_)}static _deserializeValue(_,R){if(_=_.trim(),_==="true")return!0;if(_==="false")return!1;let L=/^'([^']*)'$/.exec(_);return L?L[1].trim():_}static _deserializeRegexValue(_,R){if((0,E.isFalsyOrWhitespace)(_)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=_.indexOf("/"),V=_.lastIndexOf("/");if(L===V||L<0){if(R)throw new Error(`bad regexp-value '${_}', missing /-enclosure`);return console.warn(`bad regexp-value '${_}', missing /-enclosure`),null}let he=_.slice(L+1,V),z=_[V+1]==="i"?"i":"";try{return new RegExp(he,z)}catch(W){if(R)throw new Error(`bad regexp-value '${_}', parse error: ${W}`);return console.warn(`bad regexp-value '${_}', parse error: ${W}`),null}}}e.ContextKeyExpr=n;function T(m,_){return m.cmp(_)}class k{constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class f{constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class h{constructor(_){this.key=_,this.type=2}static create(_){const R=S.get(_);return typeof R=="boolean"?R?f.INSTANCE:k.INSTANCE:new h(_)}cmp(_){return _.type!==this.type?this.type-_.type:v(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=h;class r{constructor(_,R){this.key=_,this.value=R,this.type=4}static create(_,R){if(typeof R=="boolean")return R?h.create(_):b.create(_);const L=S.get(_);return typeof L=="boolean"?R===(L?"true":"false")?f.INSTANCE:k.INSTANCE:new r(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeyEqualsExpr=r;class a{constructor(_,R){this.key=_,this.valueKey=R,this.type=10}static create(_,R){return new a(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}evaluate(_){const R=_.getValue(this.valueKey),L=_.getValue(this.key);return Array.isArray(R)?R.indexOf(L)>=0:typeof L=="string"&&typeof R=="object"&&R!==null?D.call(R,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return p.create(this)}}e.ContextKeyInExpr=a;class p{constructor(_){this._actual=_,this.type=11}static create(_){return new p(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new p(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class d{constructor(_,R){this.key=_,this.value=R,this.type=5}static create(_,R){if(typeof R=="boolean")return R?b.create(_):h.create(_);const L=S.get(_);return typeof L=="boolean"?R===(L?"true":"false")?k.INSTANCE:f.INSTANCE:new d(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=d;class b{constructor(_){this.key=_,this.type=3}static create(_){const R=S.get(_);return typeof R=="boolean"?R?k.INSTANCE:f.INSTANCE:new b(_)}cmp(_){return _.type!==this.type?this.type-_.type:v(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=b;class g{constructor(_,R){this.key=_,this.value=R,this.type=12}static create(_,R){return new g(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=g;class c{constructor(_,R){this.key=_,this.value=R,this.type=13}static create(_,R){return new c(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class w{constructor(_,R){this.key=_,this.value=R,this.type=14}static create(_,R){return new w(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=w;class t{constructor(_,R){this.key=_,this.value=R,this.type=15}static create(_,R){return new t(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(_,R){this.key=_,this.regexp=R,this.type=7}static create(_,R){return new i(_,R)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const R=this.regexp?this.regexp.source:"",L=_.regexp?_.regexp.source:"";return R<L?-1:R>L?1:0}equals(_){if(_.type===this.type){const R=this.regexp?this.regexp.source:"",L=_.regexp?_.regexp.source:"";return this.key===_.key&&R===L}return!1}evaluate(_){let R=_.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return l.create(this)}}e.ContextKeyRegexExpr=i;class l{constructor(_){this._actual=_,this.type=8}static create(_){return new l(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new l(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=l;class s{constructor(_){this.expr=_,this.type=6}static create(_){return s._normalizeArr(_)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let R=0,L=this.expr.length;R<L;R++){const V=T(this.expr[R],_.expr[R]);if(V!==0)return V}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let R=0,L=this.expr.length;R<L;R++)if(!this.expr[R].equals(_.expr[R]))return!1;return!0}return!1}evaluate(_){for(let R=0,L=this.expr.length;R<L;R++)if(!this.expr[R].evaluate(_))return!1;return!0}static _normalizeArr(_){const R=[];let L=!1;for(const V of _)if(!!V){if(V.type===1){L=!0;continue}if(V.type===0)return k.INSTANCE;if(V.type===6){R.push(...V.expr);continue}R.push(V)}if(R.length===0&&L)return f.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(T);R.length>1;){const V=R[R.length-1];if(V.type!==9)break;R.pop();const he=R.pop(),z=o.create(V.expr.map(W=>s.create([W,he])));z&&(R.push(z),R.sort(T))}return R.length===1?R[0]:new s(R)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(let R of this.expr)_.push(...R.keys());return _}map(_){return new s(this.expr.map(R=>R.map(_)))}negate(){let _=[];for(let R of this.expr)_.push(R.negate());return o.create(_)}}e.ContextKeyAndExpr=s;class o{constructor(_){this.expr=_,this.type=9}static create(_){const R=o._normalizeArr(_);if(R.length!==0)return R.length===1?R[0]:new o(R)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let R=0,L=this.expr.length;R<L;R++){const V=T(this.expr[R],_.expr[R]);if(V!==0)return V}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let R=0,L=this.expr.length;R<L;R++)if(!this.expr[R].equals(_.expr[R]))return!1;return!0}return!1}evaluate(_){for(let R=0,L=this.expr.length;R<L;R++)if(this.expr[R].evaluate(_))return!0;return!1}static _normalizeArr(_){let R=[],L=!1;if(_){for(let V=0,he=_.length;V<he;V++){const z=_[V];if(!!z){if(z.type===0){L=!0;continue}if(z.type===1)return[f.INSTANCE];if(z.type===9){R=R.concat(z.expr);continue}R.push(z)}}if(R.length===0&&L)return[k.INSTANCE];R.sort(T)}return R}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(let R of this.expr)_.push(...R.keys());return _}map(_){return new o(this.expr.map(R=>R.map(_)))}negate(){let _=[];for(let L of this.expr)_.push(L.negate());const R=L=>L.type===9?L.expr:[L];for(;_.length>1;){const L=_.shift(),V=_.shift(),he=[];for(const z of R(L))for(const W of R(V))he.push(n.and(z,W));_.unshift(n.or(...he))}return _[0]}}e.ContextKeyOrExpr=o;class u extends h{constructor(_,R,L){super(_);this._defaultValue=R,typeof L=="object"?u._info.push(Object.assign(Object.assign({},L),{key:_})):L!==!0&&u._info.push({key:_,description:L,type:R!=null?typeof R:void 0})}static all(){return u._info.values()}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(_){return n.equals(this.key,_)}notEqualsTo(_){return n.notEquals(this.key,_)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,C.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(m,_){return m<_?-1:m>_?1:0}function A(m,_,R,L){return m<R?-1:m>R?1:_<L?-1:_>L?1:0}}),define(be[149],we([0,1,4]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(be[26],we([0,1,8,4]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function I(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class S{constructor(T){this.value=T,this._lower=T.toLowerCase()}static equals(T,k){if(typeof T=="undefined"||T===null)return typeof k=="undefined"||k===null;if(typeof k=="undefined"||k===null)return!1;if(typeof T=="string"||typeof k=="string"){let f=typeof T=="string"?T:T.value,h=typeof k=="string"?k:k.value;return E.equalsIgnoreCase(f,h)}return T._lower===k._lower}static toKey(T){return typeof T=="string"?T.toLowerCase():T._lower}}e.ExtensionIdentifier=S;function D(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function y(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[150],we([0,1,8,26]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(h,r){return h.uuid&&r.uuid?h.uuid===r.uuid:h.id===r.id?!0:(0,E.compareIgnoreCase)(h.id,r.id)===0}e.areSameExtensions=I;class P{constructor(r,a){this.version=a,this.id=r.id,this.uuid=r.uuid}key(){return`${this.id}-${this.version}`}equals(r){return r instanceof P?I(this,r)&&this.version===r.version:!1}}e.ExtensionIdentifierWithVersion=P;function S(h,r){return`${h}.${r}`}e.getExtensionId=S;function D(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function y(h,r){return D(S(h,r))}e.getGalleryExtensionId=y;function n(h,r){const a=[],p=d=>{for(const b of a)if(b.some(g=>I(r(g),r(d))))return b;return null};for(const d of h){const b=p(d);b?b.push(d):a.push([d])}return a}e.groupByExtension=n;function T(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=T;function k(h){return Object.assign({id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0)},h.telemetryData)}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function f(h){const r=new Set;for(const a of h)a.malicious&&r.add(a.id.id);return r}e.getMaliciousExtensionsSet=f}),define(be[65],we([0,1,125,13,2,4,8,10,22]),function(Y,e,E,C,I,P,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function n(z){return z.create===!0}e.isFileOpenForWriteOptions=n;var T;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var k;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock"})(k=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=f;function h(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=h;function r(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=r;function a(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=a;var p;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class d extends Error{constructor(W,J){super(W);this.code=J}}e.FileSystemProviderError=d;function b(z,W){const J=new d(z.toString(),W);return c(J,W),J}e.createFileSystemProviderError=b;function g(z){return z||b((0,E.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=g;function c(z,W){return z.name=W?`${W} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=c;function w(z){if(!z)return p.Unknown;if(z instanceof d)return z.code;const W=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!W)return p.Unknown;switch(W[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=w;function t(z){if(z instanceof v)return z.fileOperationResult;switch(w(z)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class l{constructor(W,J,O){this.resource=W,this.operation=J,this.target=O}isOperation(W){return this.operation===W}}e.FileOperationEvent=l;var s;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class o{constructor(W,J){this.ignorePathCasing=J,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=W;for(const O of W)switch(O.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(O.resource,O);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(O.resource,O);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(O.resource,O);break}}contains(W,...J){return this.doContains(W,{includeChildren:!1},...J)}affects(W,...J){return this.doContains(W,{includeChildren:!0},...J)}doContains(W,J,...O){var F,N,B,U,Q,Z;if(!W)return!1;const ne=O.length>0;return!!((!ne||O.includes(1))&&(((F=this.added)===null||F===void 0?void 0:F.get(W))||J.includeChildren&&((N=this.added)===null||N===void 0?void 0:N.findSuperstr(W)))||(!ne||O.includes(0))&&(((B=this.updated)===null||B===void 0?void 0:B.get(W))||J.includeChildren&&((U=this.updated)===null||U===void 0?void 0:U.findSuperstr(W)))||(!ne||O.includes(2))&&(((Q=this.deleted)===null||Q===void 0?void 0:Q.findSubstr(W))||J.includeChildren&&((Z=this.deleted)===null||Z===void 0?void 0:Z.findSuperstr(W))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(W){const J=[],O=W===1?this.added:W===0?this.updated:this.deleted;if(O)for(const[,F]of O)J.push(F);return J}filter(W){return new o(this.changes.filter(J=>W(J)),this.ignorePathCasing)}}e.FileChangesEvent=o;function u(z,W,J){return!z||!W||z===W||W.length>z.length?!1:(W.charAt(W.length-1)!==C.sep&&(W+=C.sep),J?(0,S.startsWithIgnoreCase)(z,W):z.indexOf(W)===0)}e.isParent=u;class v extends Error{constructor(W,J,O){super(W);this.fileOperationResult=J,this.options=O}static isFileOperationError(W){return W instanceof Error&&!(0,D.isUndefinedOrNull)(W.fileOperationResult)}}e.FileOperationError=v;var A;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var m;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(m=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function _(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=_;async function R(z,W){if(!W.canHandleResource(I.URI.from({scheme:z.scheme})))return new Promise(J=>{const O=W.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===z.scheme&&F.added&&(O.dispose(),J())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(W){return(0,D.isNumber)(W)||(W=0),W<L.KB?(0,E.localize)(1,null,W.toFixed(0)):W<L.MB?(0,E.localize)(2,null,(W/L.KB).toFixed(2)):W<L.GB?(0,E.localize)(3,null,(W/L.MB).toFixed(2)):W<L.TB?(0,E.localize)(4,null,(W/L.GB).toFixed(2)):(0,E.localize)(5,null,(W/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var V;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function he(z){return{maxFileSize:z===0?300*L.MB:16*L.GB,maxHeapSize:z===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=he}),define(be[66],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...I){this._entries=new Map;for(let[P,S]of I)this.set(P,S)}set(I,P){const S=this._entries.get(I);return this._entries.set(I,P),S}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=E}),define(be[151],we([0,1,11,145,89,4,66,14]),function(Y,e,E,C,I,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class n extends Error{constructor(r){var a;super("cyclic dependency between services");this.message=(a=r.findCycleSlow())!==null&&a!==void 0?a:`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class T{constructor(r=new S.ServiceCollection,a=!1,p){this._activeInstantiations=new Set,this._services=r,this._strict=a,this._parent=p,this._services.set(P.IInstantiationService,this)}createChild(r){return new T(r,this._strict,this)}invokeFunction(r,...a){let p=f.traceInvocation(r),d=!1;try{return r({get:(g,c)=>{if(d)throw(0,E.illegalState)("service accessor is only valid during the invocation of its target method");const w=this._getOrCreateServiceInstance(g,p);if(!w&&c!==P.optional)throw new Error(`[invokeFunction] unknown service '${g}'`);return w}},...a)}finally{d=!0,p.stop()}}createInstance(r,...a){let p,d;return r instanceof I.SyncDescriptor?(p=f.traceCreation(r.ctor),d=this._createInstance(r.ctor,r.staticArguments.concat(a),p)):(p=f.traceCreation(r),d=this._createInstance(r,a,p)),p.stop(),d}_createInstance(r,a=[],p){let d=P._util.getServiceDependencies(r).sort((c,w)=>c.index-w.index),b=[];for(const c of d){let w=this._getOrCreateServiceInstance(c.id,p);if(!w&&this._strict&&!c.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${c.id}.`);b.push(w)}let g=d.length>0?d[0].index:a.length;if(a.length!==g){console.warn(`[createInstance] First service dependency of ${r.name} at position ${g+1} conflicts with ${a.length} static arguments`);let c=g-a.length;c>0?a=a.concat(new Array(c)):a=a.slice(0,g)}return new r(...[...a,...b])}_setServiceInstance(r,a){if(this._services.get(r)instanceof I.SyncDescriptor)this._services.set(r,a);else if(this._parent)this._parent._setServiceInstance(r,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let a=this._services.get(r);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):a}_getOrCreateServiceInstance(r,a){let p=this._getServiceInstanceOrDescriptor(r);return p instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,p,a.branch(r,!0)):(a.branch(r,!1),p)}_safeCreateAndCacheServiceInstance(r,a,p){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,a,p)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,a,p){const d=new C.Graph(c=>c.id.toString());let b=0;const g=[{id:r,desc:a,_trace:p}];for(;g.length;){const c=g.pop();if(d.lookupOrInsertNode(c),b++>1e3)throw new n(d);for(let w of P._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(w.id);if(!t&&!w.optional&&console.warn(`[createInstance] ${r} depends on ${w.id} which is NOT registered.`),t instanceof I.SyncDescriptor){const i={id:w.id,desc:t,_trace:c._trace.branch(w.id,!0)};d.insertEdge(c,i),g.push(i)}}}for(;;){const c=d.roots();if(c.length===0){if(!d.isEmpty())throw new n(d);break}for(const{data:w}of c){if(this._getServiceInstanceOrDescriptor(w.id)instanceof I.SyncDescriptor){const i=this._createServiceInstanceWithOwner(w.id,w.desc.ctor,w.desc.staticArguments,w.desc.supportsDelayedInstantiation,w._trace);this._setServiceInstance(w.id,i)}d.removeNode(w)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,a,p=[],d,b){if(this._services.get(r)instanceof I.SyncDescriptor)return this._createServiceInstance(a,p,d,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,a,p,d,b);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(r,a=[],p,d){if(p){const b=new D.IdleValue(()=>this._createInstance(r,a,d));return new Proxy(Object.create(null),{get(g,c){if(c in g)return g[c];let w=b.value,t=w[c];return typeof t!="function"||(t=t.bind(w),g[c]=t),t},set(g,c,w){return b.value[c]=w,!0}})}else return this._createInstance(r,a,d)}}e.InstantiationService=T;var k;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(k||(k={}));class f{constructor(r,a){this.type=r,this.name=a,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return y?new f(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(r){return y?new f(0,r.name):f._None}branch(r,a){let p=new f(2,r.toString());return this._dep.push([r,a,p]),p}stop(){let r=Date.now()-this._start;f._totals+=r;let a=!1;function p(b,g){let c=[],w=new Array(b+1).join("	");for(const[t,i,l]of g._dep)if(i&&l){a=!0,c.push(`${w}CREATES -> ${t}`);let s=p(b+1,l);s&&c.push(s)}else c.push(`${w}uses -> ${t}`);return c.join(`
`)}let d=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(r>2||a)&&console.log(d.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(be[19],we([0,1,4,6,21,3,61]),function(Y,e,E,C,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function D(){return new Date().toISOString()}var y;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class n extends C.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class T extends n{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(y.Error))if(t instanceof Error){const l=Array.prototype.slice.call(arguments);l[0]=t.stack,this.log(y.Error,this.format(l))}else this.log(y.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let l=0;l<t.length;l++){let s=t[l];if(typeof s=="object")try{s=JSON.stringify(s)}catch(o){}i+=(l>0?" ":"")+s}return i}}e.AbstractMessageLogger=T;class k extends n{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!I.isWindows}trace(t,...i){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}debug(t,...i){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}info(t,...i){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}warn(t,...i){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...i):console.warn(`[main ${D()}]`,t,...i))}error(t,...i){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...i):console.error(`[main ${D()}]`,t,...i))}critical(t,...i){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...i):console.error(`[main ${D()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class f extends n{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=f;class h extends n{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,S.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class r extends n{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const l of this.logServices)l.trace(t,...i)}debug(t,...i){for(const l of this.logServices)l.debug(t,...i)}info(t,...i){for(const l of this.logServices)l.info(t,...i)}warn(t,...i){for(const l of this.logServices)l.warn(t,...i)}error(t,...i){for(const l of this.logServices)l.error(t,...i)}critical(t,...i){for(const l of this.logServices)l.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=r;class a extends C.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=a;class p extends C.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(l=>{this.logLevel=l,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(l))}))}createLogger(t,i){let l=this.loggers.get(t.toString());return l||(l=this.doCreateLogger(t,(i==null?void 0:i.always)?y.Trace:this.logLevel,i),this.loggers.set(t.toString(),l),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(l)),l}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class d{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=d;function b(w){if(w.verbose)return y.Trace;if(typeof w.logLevel=="string"){const t=g(w.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function g(w){switch(w){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=g;function c(w){switch(w){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=c}),define(be[90],we([0,1,4,126,47]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var S;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function n(r,a){return a-r}y.compare=n;const T=Object.create(null);T[y.Error]=(0,C.localize)(0,null),T[y.Warning]=(0,C.localize)(1,null),T[y.Info]=(0,C.localize)(2,null);function k(r){return T[r]||""}y.toString=k;function f(r){switch(r){case I.default.Error:return y.Error;case I.default.Warning:return y.Warning;case I.default.Info:return y.Info;case I.default.Ignore:return y.Hint}}y.fromSeverity=f;function h(r){switch(r){case y.Error:return I.default.Error;case y.Warning:return I.default.Warning;case y.Info:return I.default.Info;case y.Hint:return I.default.Ignore}}y.toSeverity=h}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(y){const n="";function T(f){return k(f,!0)}y.makeKey=T;function k(f,h){let r=[n];return f.source?r.push(f.source.replace("\xA6","\\\xA6")):r.push(n),f.code?typeof f.code=="string"?r.push(f.code.replace("\xA6","\\\xA6")):r.push(f.code.value.replace("\xA6","\\\xA6")):r.push(n),f.severity!==void 0&&f.severity!==null?r.push(S.toString(f.severity)):r.push(n),f.message&&h?r.push(f.message.replace("\xA6","\\\xA6")):r.push(n),f.startLineNumber!==void 0&&f.startLineNumber!==null?r.push(f.startLineNumber.toString()):r.push(n),f.startColumn!==void 0&&f.startColumn!==null?r.push(f.startColumn.toString()):r.push(n),f.endLineNumber!==void 0&&f.endLineNumber!==null?r.push(f.endLineNumber.toString()):r.push(n),f.endColumn!==void 0&&f.endColumn!==null?r.push(f.endColumn.toString()):r.push(n),r.push(n),r.join("\xA6")}y.makeKeyOptionalMessage=k})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(be[152],we([0,1,47,4,3]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=E.default,e.INotificationService=(0,C.createDecorator)("notificationService");var P;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new y,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(T){}updateMessage(T){}updateActions(T){}close(){}}e.NoOpNotification=D;class y{infinite(){}done(){}total(T){}worked(T){}}e.NoOpProgress=y});var je=this&&this.__decorate||function(Y,e,E,C){var I=arguments.length,P=I<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,E):C,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(Y,e,E,C);else for(var D=Y.length-1;D>=0;D--)(S=Y[D])&&(P=(I<3?S(P):I>3?S(e,E,P):S(e,E))||P);return I>3&&P&&Object.defineProperty(e,E,P),P},Ke=this&&this.__param||function(Y,e){return function(E,C){e(E,C,Y)}};define(be[153],we([0,1,4,20,6,14]),function(Y,e,E,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,E.createDecorator)("progressService");var S;(function(T){T[T.Explorer=1]="Explorer",T[T.Scm=3]="Scm",T[T.Extensions=5]="Extensions",T[T.Window=10]="Window",T[T.Notification=15]="Notification",T[T.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let y=class extends I.Disposable{constructor(k,f){super();this.deferred=new P.DeferredPromise,f.withProgress(k,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};y=je([Ke(1,e.IProgressService)],y),e.UnmanagedProgress=y;class n extends I.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(k){this.stop();const f=++this.currentOperationId,h=new C.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{f===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:f,token:h.token,stop:()=>this.doStop(f),isCurrent:()=>this.currentOperationId===f}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=n,e.IEditorProgressService=(0,E.createDecorator)("editorProgressService")}),define(be[30],we([0,1,10,42]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(S,D){C.ok(E.isString(S)),C.ok(E.isObject(D)),C.ok(!this.data.has(S),"There is already an extension with this id"),this.data.set(S,D)}knows(S){return this.data.has(S)}as(S){return this.data.get(S)||null}}e.Registry=new I}),define(be[91],we([0,1,30,3]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class P{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,n){this.schemasById[I(y)]=n,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const S=new P;E.Registry.add(e.Extensions.JSONContribution,S)}),define(be[67],we([0,1,123,3,30,10,91]),function(Y,e,E,C,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=I.Registry.as(S.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:E.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(d,b=!0){this.registerConfigurations([d],b)}registerConfigurations(d,b=!0){const g=[];d.forEach(c=>{g.push(...this.validateAndRegisterProperties(c,b,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(g)}deregisterConfigurations(d){const b=[],g=c=>{if(c.properties)for(const w in c.properties)b.push(w),delete this.configurationProperties[w],this.removeFromSchema(w,c.properties[w]);c.allOf&&c.allOf.forEach(w=>g(w))};for(const c of d){g(c);const w=this.configurationContributors.indexOf(c);w!==-1&&this.configurationContributors.splice(w,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}registerDefaultConfigurations(d){const b=[],g=[];for(const c of d)for(const w in c)if(b.push(w),e.OVERRIDE_PROPERTY_PATTERN.test(w)){this.defaultValues[w]=Object.assign(Object.assign({},this.defaultValues[w]||{}),c[w]);const t={type:"object",default:this.defaultValues[w],description:E.localize(1,null,w),$ref:e.resourceLanguageSettingsSchemaId};g.push(k(w)),this.configurationProperties[w]=t,this.defaultLanguageConfigurationOverridesNode.properties[w]=t}else{this.defaultValues[w]=c[w];const t=this.configurationProperties[w];t&&(this.updatePropertyDefaultValue(w,t),this.updateSchema(w,t))}this.registerOverrideIdentifiers(g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}deregisterDefaultConfigurations(d){const b=[];for(const g of d)for(const c in g)if(b.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const w=this.configurationProperties[c];w&&(this.updatePropertyDefaultValue(c,w),this.updateSchema(c,w))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}notifyConfigurationSchemaUpdated(...d){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(d){for(const b of d)this.overrideIdentifiers.add(b);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(d,b=!0,g,c=3){var w;c=P.isUndefinedOrNull(d.scope)?c:d.scope;let t=[],i=d.properties;if(i)for(let s in i){if(b&&r(s)){delete i[s];continue}const o=i[s];if(this.updatePropertyDefaultValue(s,o),e.OVERRIDE_PROPERTY_PATTERN.test(s)?o.scope=void 0:(o.scope=P.isUndefinedOrNull(o.scope)?c:o.scope,o.requireTrust=P.isUndefinedOrNull(o.requireTrust)?!!((w=g==null?void 0:g.requireTrustForConfigurations)===null||w===void 0?void 0:w.includes(s)):o.requireTrust),i[s].hasOwnProperty("included")&&!i[s].included){this.excludedConfigurationProperties[s]=i[s],delete i[s];continue}else this.configurationProperties[s]=i[s];!i[s].deprecationMessage&&i[s].markdownDeprecationMessage&&(i[s].deprecationMessage=i[s].markdownDeprecationMessage),t.push(s)}let l=d.allOf;if(l)for(let s of l)t.push(...this.validateAndRegisterProperties(s,b,g,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(d){const b=g=>{let c=g.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let w=g.allOf;w&&w.forEach(b)};b(d)}updateSchema(d,b){switch(e.allSettings.properties[d]=b,b.scope){case 1:e.applicationSettings.properties[d]=b;break;case 2:e.machineSettings.properties[d]=b;break;case 6:e.machineOverridableSettings.properties[d]=b;break;case 3:e.windowSettings.properties[d]=b;break;case 4:e.resourceSettings.properties[d]=b;break;case 5:e.resourceSettings.properties[d]=b,this.resourceLanguageSettingsSchema.properties[d]=b;break}}removeFromSchema(d,b){switch(delete e.allSettings.properties[d],b.scope){case 1:delete e.applicationSettings.properties[d];break;case 2:delete e.machineSettings.properties[d];break;case 6:delete e.machineOverridableSettings.properties[d];break;case 3:delete e.windowSettings.properties[d];break;case 4:case 5:delete e.resourceSettings.properties[d];break}}updateOverridePropertyPatternKey(){for(const d of this.overrideIdentifiers.values()){const b=`[${d}]`,g={type:"object",description:E.localize(2,null),errorMessage:E.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(b,g),e.allSettings.properties[b]=g,e.applicationSettings.properties[b]=g,e.machineSettings.properties[b]=g,e.machineOverridableSettings.properties[b]=g,e.windowSettings.properties[b]=g,e.resourceSettings.properties[b]=g}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(d,b){let g=this.defaultValues[d];P.isUndefined(g)&&(g=b.default),P.isUndefined(g)&&(g=f(b.type)),b.default=g}}const T="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(T);function k(p){return p.substring(1,p.length-1)}e.overrideIdentifierFromKey=k;function f(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const h=new n;I.Registry.add(e.Extensions.Configuration,h);function r(p){return p.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(p)?E.localize(5,null,p):h.getConfigurationProperties()[p]!==void 0?E.localize(6,null,p):null:E.localize(4,null)}e.validateProperty=r;function a(){const p=[],d=h.getConfigurationProperties();for(const b of Object.keys(d))p.push([b,d[b].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=a}),define(be[92],we([0,1,24,10,2,30,4,67]),function(Y,e,E,C,I,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function y(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof I.URI)}e.isConfigurationOverrides=y;var n;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function T(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=T;function k(i,l){const s=l?i?l.keys.filter(R=>i.keys.indexOf(R)===-1):[...l.keys]:[],o=i?l?i.keys.filter(R=>l.keys.indexOf(R)===-1):[...i.keys]:[],u=[];if(l&&i){for(const R of i.keys)if(l.keys.indexOf(R)!==-1){const L=d(i.contents,R),V=d(l.contents,R);E.equals(L,V)||u.push(R)}}const v=[],A=R=>{const L={};for(const V of R)for(const he of V.identifiers)L[w(he)]=V;return L},m=l?A(l.overrides):{},_=i?A(i.overrides):{};if(Object.keys(m).length)for(const R of s){const L=m[R];L&&v.push([(0,D.overrideIdentifierFromKey)(R),L.keys])}if(Object.keys(_).length)for(const R of o){const L=_[R];L&&v.push([(0,D.overrideIdentifierFromKey)(R),L.keys])}if(Object.keys(m).length&&Object.keys(_).length)for(const R of u){const L=_[R],V=m[R];if(L&&V){const he=k({contents:L.contents,keys:L.keys,overrides:[]},{contents:V.contents,keys:V.keys,overrides:[]});v.push([(0,D.overrideIdentifierFromKey)(R),[...he.added,...he.removed,...he.updated]])}}return{added:s,removed:o,updated:u,overrides:v}}e.compare=k;function f(i,l){const s=[];for(const o of Object.keys(i))if(D.OVERRIDE_PROPERTY_PATTERN.test(o)){const u={};for(const v in i[o])u[v]=i[o][v];s.push({identifiers:[(0,D.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(u),contents:h(u,l)})}return s}e.toOverrides=f;function h(i,l){const s=Object.create(null);for(let o in i)r(s,o,i[o],l);return s}e.toValuesTree=h;function r(i,l,s,o){const u=l.split("."),v=u.pop();let A=i;for(let m=0;m<u.length;m++){let _=u[m],R=A[_];switch(typeof R){case"undefined":R=A[_]=Object.create(null);break;case"object":break;default:o(`Ignoring ${l} as ${u.slice(0,m+1).join(".")} is ${JSON.stringify(R)}`);return}A=R}if(typeof A=="object"&&A!==null)try{A[v]=s}catch(m){o(`Ignoring ${l} as ${u.join(".")} is ${JSON.stringify(A)}`)}else o(`Ignoring ${l} as ${u.join(".")} is ${JSON.stringify(A)}`)}e.addToValueTree=r;function a(i,l){const s=l.split(".");p(i,s)}e.removeFromValueTree=a;function p(i,l){const s=l.shift();if(l.length===0){delete i[s];return}if(Object.keys(i).indexOf(s)!==-1){const o=i[s];typeof o=="object"&&!Array.isArray(o)&&(p(o,l),Object.keys(o).length===0&&delete i[s])}}function d(i,l,s){function o(A,m){let _=A;for(const R of m){if(typeof _!="object"||_===null)return;_=_[R]}return _}const u=l.split("."),v=o(i,u);return typeof v=="undefined"?s:v}e.getConfigurationValue=d;function b(i,l,s){Object.keys(l).forEach(o=>{o!=="__proto__"&&(o in i?C.isObject(i[o])&&C.isObject(l[o])?b(i[o],l[o],s):s&&(i[o]=l[o]):i[o]=l[o])})}e.merge=b;function g(){const i=P.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=g;function c(){const i=Object.create(null),l=P.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let s in l){let o=l[s].default;r(i,s,o,u=>console.error(`Conflict in default settings: ${u}`))}return i}e.getDefaultValues=c;function w(i){return`[${i}]`}e.keyFromOverrideIdentifier=w;function t(i,l,s){const o=i.inspect(l),u=i.inspect(s);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:o.defaultValue}e.getMigratedSettingValue=t}),define(be[154],we([0,1,44,22,12,10,24,2,67,92,30,6,3]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},i=[],l=[]){this._contents=t,this._keys=i,this._overrides=l,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const l=this.getContentsForOverrideIdentifer(i);return l?t?(0,n.getConfigurationValue)(l,t):l:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let l={};for(const s of I.distinct([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[s],u=i[s];u&&(typeof o=="object"&&typeof u=="object"?(o=S.deepClone(o),this.mergeContents(o,u)):o=u),l[s]=o}return new h(l,this.keys,this.overrides)}merge(...t){const i=S.deepClone(this.contents),l=S.deepClone(this.overrides),s=[...this.keys];for(const o of t){this.mergeContents(i,o.contents);for(const u of o.overrides){const[v]=l.filter(A=>I.equals(A.identifiers,u.identifiers));v?this.mergeContents(v.contents,u.contents):l.push(S.deepClone(u))}for(const u of o.keys)s.indexOf(u)===-1&&s.push(u)}return new h(i,s,l)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const l of Object.keys(i)){if(l in t&&P.isObject(t[l])&&P.isObject(i[l])){this.mergeContents(t[l],i[l]);continue}t[l]=S.deepClone(i[l])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?S.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,n.addToValueTree)(this.contents,t,i,l=>{throw new Error(l)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let l=0;l<i;l++)t.indexOf(this.keys[l])===0&&(i=l);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=h;class r extends h{constructor(){const t=(0,n.getDefaultValues)(),i=(0,n.getConfigurationKeys)(),l=[];for(const s of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(s)&&l.push({identifiers:[(0,y.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,n.toValuesTree)(t[s],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,i,l)}}e.DefaultConfigurationModel=r;class a{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!P.isUndefinedOrNull(t)){const l=this.doParseContent(t);this.parseRaw(l,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:l,keys:s,overrides:o,untrusted:u}=this.doParseRaw(t,i);this._configurationModel=new h(l,s,o),this._untrustedConfigurations=u||[]}doParseContent(t){let i={},l=null,s=[],o=[],u=[];function v(m){Array.isArray(s)?s.push(m):l&&(s[l]=m)}let A={onObjectBegin:()=>{let m={};v(m),o.push(s),s=m,l=null},onObjectProperty:m=>{l=m},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{let m=[];v(m),o.push(s),s=m,l=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:v,onError:(m,_,R)=>{u.push({error:m,offset:_,length:R})}};if(t)try{E.visit(t,A),i=s[0]||{}}catch(m){console.error(`Error while parsing settings file ${this._name}: ${m}`),this._parseErrors=[m]}return i}doParseRaw(t,i){const l=T.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,l,!0,i);t=s.raw;const o=(0,n.toValuesTree)(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),u=Object.keys(t),v=(0,n.toOverrides)(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:o,keys:u,overrides:v,untrusted:s.untrusted}}filter(t,i,l,s){if(!(s==null?void 0:s.scopes)&&!(s==null?void 0:s.isUntrusted))return{raw:t,untrusted:[]};const o={},u=[];for(let v in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(v)&&l){const A=this.filter(t[v],i,!1,s);o[v]=A.raw,u.push(...A.untrusted)}else{const A=i[v],m=A?typeof A.scope!="undefined"?A.scope:3:void 0;(m===void 0||s.scopes===void 0||s.scopes.includes(m))&&(s.isUntrusted&&(A==null?void 0:A.requireTrust)?u.push(v):o[v]=t[v])}return{raw:o,untrusted:u}}}e.ConfigurationModelParser=a;class p extends k.Disposable{constructor(t,i,l,s){super();this.userSettingsResource=t,this.scopes=i,this.fileService=s,this._onDidChange=this._register(new f.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new a(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(l.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(f.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=p;class d{constructor(t,i,l=new h,s=new h,o=new C.ResourceMap,u=new h,v=new C.ResourceMap,A=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=l,this._workspaceConfiguration=s,this._folderConfigurations=o,this._memoryConfiguration=u,this._memoryConfigurationByResource=v,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(t,i,l){return this.getConsolidateConfigurationModel(i,l).getValue(t)}updateValue(t,i,l={}){let s;l.resource?(s=this._memoryConfigurationByResource.get(l.resource),s||(s=new h,this._memoryConfigurationByResource.set(l.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(t):s.setValue(t,i),l.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,l){const s=this.getConsolidateConfigurationModel(i,l),o=this.getFolderConfigurationModelForResource(i.resource,l),u=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,v=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),A=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),m=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),_=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=l?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=o?i.overrideIdentifier?o.freeze().override(i.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,V=i.overrideIdentifier?u.override(i.overrideIdentifier).getValue(t):u.getValue(t),he=s.getValue(t),z=I.distinct(I.flatten(s.overrides.map(W=>W.identifiers))).filter(W=>s.getOverrideValue(t,W)!==void 0);return{defaultValue:v,userValue:A,userLocalValue:m,userRemoteValue:_,workspaceValue:R,workspaceFolderValue:L,memoryValue:V,value:he,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:m!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:o==null?void 0:o.freeze().getValue(t),override:i.overrideIdentifier?o==null?void 0:o.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:V!==void 0?{value:u.getValue(t),override:i.overrideIdentifier?u.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const l=i.filter(s=>y.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const o=(0,y.overrideIdentifierFromKey)(s),u=this._defaultConfiguration.getKeysForOverrideIdentifier(o),v=t.getKeysForOverrideIdentifier(o),A=[...v.filter(m=>u.indexOf(m)===-1),...u.filter(m=>v.indexOf(m)===-1),...u.filter(m=>!S.equals(this._defaultConfiguration.override(o).getValue(m),t.override(o).getValue(m)))];return[o,A]});return this.updateDefaultConfiguration(t),{keys:i,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:l,removed:s,overrides:o}=(0,n.compare)(this.localUserConfiguration,t),u=[...i,...l,...s];return u.length&&this.updateLocalUserConfiguration(t),{keys:u,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:l,removed:s,overrides:o}=(0,n.compare)(this.remoteUserConfiguration,t);let u=[...i,...l,...s];return u.length&&this.updateRemoteUserConfiguration(t),{keys:u,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:l,removed:s,overrides:o}=(0,n.compare)(this.workspaceConfiguration,t);let u=[...i,...l,...s];return u.length&&this.updateWorkspaceConfiguration(t),{keys:u,overrides:o}}compareAndUpdateFolderConfiguration(t,i){const l=this.folderConfigurations.get(t),{added:s,updated:o,removed:u,overrides:v}=(0,n.compare)(l,i);let A=[...s,...o,...u];return(A.length||!l)&&this.updateFolderConfiguration(t,i),{keys:A,overrides:v}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:l,updated:s,removed:o,overrides:u}=(0,n.compare)(i,void 0);return{keys:[...l,...s,...o],overrides:u}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let l=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?l.override(t.overrideIdentifier):l}getConsolidatedConfigurationModelForResource({resource:t},i){let l=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const s=i.getFolder(t);s&&(l=this.getFolderConsolidatedConfiguration(s.uri)||l);const o=this._memoryConfigurationByResource.get(t);o&&(l=l.merge(o))}return l}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const l=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(i=l.merge(s),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=l}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const l=i.getFolder(t);if(l)return this._folderConfigurations.get(l.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:l,overrides:s,keys:o}=this._folderConfigurations.get(i);return t.push([i,{contents:l,overrides:s,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(l=>t.add(l))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>i.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>i.add(l)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>i.add(l)),this._folderConfigurations.forEach(l=>l.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),l=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((u,v)=>(u.set(D.URI.revive(v[0]),this.parseConfigurationModel(v[1])),u),new C.ResourceMap);return new d(i,l,new h,s,o,new h,new C.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=d;function b(...w){if(w.length===0)return{keys:[],overrides:[]};if(w.length===1)return w[0];const t=new Set,i=new Map;for(const s of w)s.keys.forEach(o=>t.add(o)),s.overrides.forEach(([o,u])=>{const v=(0,C.getOrSet)(i,o,new Set);u.forEach(A=>v.add(A))});const l=[];return i.forEach((s,o)=>l.push([o,[...s.values()]])),{keys:[...t.values()],overrides:l}}e.mergeChanges=b;class g{constructor(t,i,l,s){this.change=t,this.previous=i,this.currentConfiguraiton=l,this.currentWorkspace=s,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(v=>o.add(v)),t.overrides.forEach(([,v])=>v.forEach(A=>o.add(A))),this.affectedKeys=[...o.values()];const u=new h;this.affectedKeys.forEach(v=>u.setValue(v,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var l;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(l=this.previous)===null||l===void 0?void 0:l.workspace):void 0,o=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!S.equals(s,o)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let l=(0,n.toValuesTree)({[i]:!0},()=>{}),s;for(;typeof l=="object"&&(s=Object.keys(l)[0]);){if(t=t[s],!t)return!1;l=l[s]}return!0}}e.ConfigurationChangeEvent=g;class c extends g{constructor(t,i,l,s){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=l,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=c}),define(be[68],we([0,1,4]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,E.createDecorator)("remoteAuthorityResolverService");var C;(function(S){S[S.Unknown=0]="Unknown",S[S.DisableTrust=1]="DisableTrust",S[S.MachineTrusted=2]="MachineTrusted"})(C=e.RemoteTrustOption||(e.RemoteTrustOption={}));var I;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends Error{constructor(D,y=I.Unknown,n){super(D);this._message=D,this._code=y,this._detail=n,this.isHandled=y===I.NotAvailable&&n===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(D){return D instanceof P&&D._code===I.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof P&&D._code===I.NoResolverFound}static isHandled(D){return D instanceof P&&D.isHandled}}e.RemoteAuthorityResolverError=P}),define(be[93],we([0,1,18]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function C(y){return y.scheme===E.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=C;function I(y){if(!!y){const n=y.indexOf("+");return n<0?y:y.substr(0,n)}}e.getRemoteName=I;function P(y){return y.scheme!==E.Schemas.file&&y.scheme!==E.Schemas.vscodeRemote}function S(y){if(y.folders.length)return y.folders.every(n=>P(n.uri))?y.folders[0].uri:void 0;if(y.configuration&&P(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=S;function D(y){var n;return(n=S(y))===null||n===void 0?void 0:n.scheme}e.getVirtualWorkspaceScheme=D}),define(be[155],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class E{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,P,S=5){let D;return D=P(y=>{const n=typeof y=="string"?y:y.data;let T=this._terminalBufferMap.get(I);if(T){T.data.push(n);return}const k=setTimeout(()=>this.flushBuffer(I),S);T={data:[n],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(I),D.dispose()}},this._terminalBufferMap.set(I,T)}),D}stopBuffering(I){const P=this._terminalBufferMap.get(I);P&&P.dispose()}flushBuffer(I){const P=this._terminalBufferMap.get(I);P&&(this._terminalBufferMap.delete(I),this._callback(I,P.data.join("")))}}e.TerminalDataBufferer=E}),define(be[156],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var E;(function(C){C.DARK="dark",C.LIGHT="light",C.HIGH_CONTRAST="hc"})(E=e.ColorScheme||(e.ColorScheme={}))}),define(be[157],we([0,1,4,6,30,3,156,36]),function(Y,e,E,C,I,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,E.createDecorator)("themeService");var y;(function(p){function d(b){return b&&typeof b=="object"&&typeof b.id=="string"}p.isThemeColor=d})(y=e.ThemeColor||(e.ThemeColor={}));function n(p){return{id:p}}e.themeColorFromId=n;var T;(function(p){function d(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}p.isThemeIcon=d;const b=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function g(t){const i=b.exec(t);if(!!i){let[,l]=i;return{id:l}}}p.fromString=g;function c(t,i){let l=t.id;const s=l.lastIndexOf("~");return s!==-1&&(l=l.substring(0,s)),i&&(l=`${l}~${i}`),{id:l}}p.modify=c;function w(t,i){var l,s;return t.id===i.id&&((l=t.color)===null||l===void 0?void 0:l.id)===((s=i.color)===null||s===void 0?void 0:s.id)}p.isEqual=w,p.asClassNameArray=D.CSSIcon.asClassNameArray,p.asClassName=D.CSSIcon.asClassName,p.asCSSSelector=D.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function k(p){switch(p){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new P.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,C.toDisposable)(()=>{const b=this.themingParticipants.indexOf(d);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new f;I.Registry.add(e.Extensions.ThemingContribution,h);function r(p){return h.onColorThemeChange(p)}e.registerThemingParticipant=r;class a extends C.Disposable{constructor(d){super();this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,b){let g=this.theme.getColor(d);return g&&b&&(g=b(g,this.theme)),g?g.toString():null}}e.Themable=a}),define(be[158],we([0,1,30,157,3,127,91,14,36]),function(Y,e,E,C,I,P,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,P.localize)(0,null)},fontCharacter:{type:"string",description:(0,P.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(d,b,g,c){const w=this.iconsById[d];if(w){if(g&&!w.description){w.description=g,this.iconSchema.properties[d].markdownDescription=`${g} $(${d})`;const l=this.iconReferenceSchema.enum.indexOf(d);l!==-1&&(this.iconReferenceSchema.enumDescriptions[l]=g),this._onDidChange.fire()}return w}let t={id:d,description:g,defaults:b,deprecationMessage:c};this.iconsById[d]=t;let i={$ref:"#/definitions/icons"};return c&&(i.deprecationMessage=c),g&&(i.markdownDescription=`${g}: $(${d})`),this.iconSchema.properties[d]=i,this.iconReferenceSchema.enum.push(d),this.iconReferenceSchema.enumDescriptions.push(g||""),this._onDidChange.fire(),{id:d}}deregisterIcon(d){delete this.iconsById[d],delete this.iconSchema.properties[d];const b=this.iconReferenceSchema.enum.indexOf(d);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(d=>this.iconsById[d])}getIcon(d){return this.iconsById[d]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(d,b){const g=this.iconFontsById[d];if(g)return g;let c={id:d,definition:b};return this.iconFontsById[d]=c,this._onDidChange.fire(),c}deregisterIconFont(d){delete this.iconFontsById[d]}getIconFonts(){return Object.keys(this.iconFontsById).map(d=>this.iconFontsById[d])}getIconFont(d){return this.iconFontsById[d]}toString(){const d=(w,t)=>w.id.localeCompare(t.id),b=w=>{for(;C.ThemeIcon.isThemeIcon(w.defaults);)w=this.iconsById[w.defaults.id];return`codicon codicon-${w?w.id:""}`};let g=[];g.push("| preview     | identifier                        | default codicon ID                | description"),g.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(w=>this.iconsById[w]);for(const w of c.filter(t=>!!t.description).sort(d))g.push(`|<i class="${b(w)}"></i>|${w.id}|${C.ThemeIcon.isThemeIcon(w.defaults)?w.defaults.id:w.id}|${w.description||""}|`);g.push("| preview     | identifier                        "),g.push("| ----------- | --------------------------------- |");for(const w of c.filter(t=>!C.ThemeIcon.isThemeIcon(t.defaults)).sort(d))g.push(`|<i class="${b(w)}"></i>|${w.id}|`);return g.join(`
`)}}const T=new n;E.Registry.add(e.Extensions.IconContribution,T);function k(p,d,b,g){return T.registerIcon(p,d,b,g)}e.registerIcon=k;function f(){return T}e.getIconRegistry=f;function h(){for(const p of y.iconRegistry.all)T.registerIcon(p.id,p.definition,p.description);y.iconRegistry.onDidRegister(p=>T.registerIcon(p.id,p.definition,p.description))}h(),e.iconsSchemaId="vscode://schemas/icons";let r=E.Registry.as(S.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,T.getIconSchema());const a=new D.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);T.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.widgetClose=k("widget-close",y.Codicon.close,(0,P.localize)(2,null)),e.gotoPreviousLocation=k("goto-previous-location",y.Codicon.arrowUp,(0,P.localize)(3,null)),e.gotoNextLocation=k("goto-next-location",y.Codicon.arrowDown,(0,P.localize)(4,null)),e.syncing=C.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(be[48],we([0,1,2,25,4,22]),function(Y,e,E,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");var S;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function D(f){const h=f;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=D;function y(f){const h=f;return!!(h&&typeof h=="object"&&E.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=y;class n{constructor(h,r,a,p){this._id=h,this._configuration=a,this._ignorePathCasing=p,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class T{constructor(h,r){this.raw=r,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,C.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=T;function k(f){return new T({uri:f,index:0,name:(0,C.basenameOrAuthority)(f)},{uri:f.toString()})}e.toWorkspaceFolder=k}),define(be[159],we([0,1,4,128,48,2,21,13,25,106,44,18,59,37,93]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const a=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,C.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(J){return(typeof J=="string"?(0,D.extname)(J):(0,y.extname)(J))===a}e.hasWorkspaceFileExtension=p,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function d(J){return J.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function b(J){return J.hasOwnProperty("folderUri")}e.isRecentFolder=b;function g(J){return J.hasOwnProperty("fileUri")}e.isRecentFile=g;function c(J){const O=J;return typeof(O==null?void 0:O.id)=="string"&&P.URI.isUri(O.uri)}e.isSingleFolderWorkspaceIdentifier=c;function w(J){if(J.configuration)return{id:J.id,configPath:J.configuration};if(J.folders.length===1)return{id:J.id,uri:J.folders[0].uri}}e.toWorkspaceIdentifier=w;function t(J){const O=J;return typeof(O==null?void 0:O.id)=="string"&&P.URI.isUri(O.configPath)}e.isWorkspaceIdentifier=t;function i(J){const O=J;if(O==null?void 0:O.uri)return{id:O.id,uri:P.URI.revive(O.uri)};const F=J;if(F==null?void 0:F.configPath)return{id:F.id,configPath:P.URI.revive(F.configPath)};if(J==null?void 0:J.id)return{id:J.id}}e.reviveIdentifier=i;function l(J,O){return y.extUriBiasedIgnorePathCase.isEqualOrParent(J,O.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function s(J){return o(J)||u(J)}e.isStoredWorkspaceFolder=s;function o(J){const O=J;return typeof(O==null?void 0:O.path)=="string"&&(!O.name||typeof O.name=="string")}e.isRawFileWorkspaceFolder=o;function u(J){const O=J;return typeof(O==null?void 0:O.uri)=="string"&&(!O.name||typeof O.name=="string")}e.isRawUriWorkspaceFolder=u;function v(J,O,F,N,B=!S.isWindows,U){if(J.scheme!==N.scheme)return{name:F,uri:J.toString(!0)};let Q=O?void 0:U.relativePath(N,J);if(Q!==void 0)Q.length===0?Q=".":S.isWindows&&J.scheme===k.Schemas.file&&!B&&(Q=Q.replace(/\//g,"\\"));else if(J.scheme===k.Schemas.file)Q=J.fsPath,S.isWindows&&(Q=(0,f.normalizeDriveLetter)(Q),B&&(Q=(0,h.toSlashes)(Q)));else{if(!U.isEqualAuthority(J.authority,N.authority))return{name:F,uri:J.toString(!0)};Q=J.path}return{name:F,path:Q}}e.getStoredWorkspaceFolder=v;function A(J,O,F){let N=[],B=new Set;const U=F.dirname(O);for(let Q of J){let Z=null;if(o(Q))Q.path&&(Z=F.resolvePath(U,Q.path));else if(u(Q))try{Z=P.URI.parse(Q.uri),Z.path[0]!=="/"&&(Z=Z.with({path:"/"+Z.path}))}catch(ne){console.warn(ne)}if(Z){let ne=F.getComparisonKey(Z);if(!B.has(ne)){B.add(ne);const pe=Q.name||F.basenameOrAuthority(Z);N.push(new I.WorkspaceFolder({uri:Z,name:pe,index:N.length},Q))}}}return N}e.toWorkspaceFolders=A;function m(J,O,F,N,B){let U=_(O,J);const Q=B.dirname(O),Z=B.dirname(N),ne=[],pe=R(U.folders);for(const xe of U.folders){const $=o(xe)?B.resolvePath(Q,xe.path):P.URI.parse(xe.uri);let G;F?G=!1:G=!o(xe)||(0,D.isAbsolute)(xe.path),ne.push(v($,G,xe.name,Z,pe,B))}const Pe={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},Oe=n.setProperty(J,["folders"],ne,Pe);let Te=n.applyEdits(J,Oe);return U.remoteAuthority===(0,r.getRemoteAuthority)(N)&&(Te=n.applyEdits(Te,n.removeProperty(Te,["remoteAuthority"],Pe))),Te}e.rewriteWorkspaceFileForNewLocation=m;function _(J,O){let F=T.parse(O);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(N=>s(N));else throw new Error(`${J} looks like an invalid workspace file.`);return F}function R(J){return S.isWindows?J.some(O=>o(O)&&O.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function L(J){return J.workspace&&typeof J.workspace=="object"&&typeof J.workspace.id=="string"&&typeof J.workspace.configPath=="string"}function V(J){return typeof J.folderUri=="string"}function he(J){return typeof J.fileUri=="string"}function z(J,O){const F={workspaces:[],files:[]};if(J){const N=function(U,Q){for(let Z=0;Z<U.length;Z++)try{Q(U[Z],Z)}catch(ne){O.warn(`Error restoring recent entry ${JSON.stringify(U[Z])}: ${ne.toString()}. Skip entry.`)}},B=J;if(Array.isArray(B.entries))N(B.entries,U=>{const Q=U.label,Z=U.remoteAuthority;L(U)?F.workspaces.push({label:Q,remoteAuthority:Z,workspace:{id:U.workspace.id,configPath:P.URI.parse(U.workspace.configPath)}}):V(U)?F.workspaces.push({label:Q,remoteAuthority:Z,folderUri:P.URI.parse(U.folderUri)}):he(U)&&F.files.push({label:Q,remoteAuthority:Z,fileUri:P.URI.parse(U.fileUri)})});else{const U=J;Array.isArray(U.workspaces3)&&N(U.workspaces3,(Q,Z)=>{const ne=Array.isArray(U.workspaceLabels)&&U.workspaceLabels[Z]||void 0;typeof Q=="object"&&typeof Q.id=="string"&&typeof Q.configURIPath=="string"?F.workspaces.push({label:ne,workspace:{id:Q.id,configPath:P.URI.parse(Q.configURIPath)}}):typeof Q=="string"&&F.workspaces.push({label:ne,folderUri:P.URI.parse(Q)})}),Array.isArray(U.files2)&&N(U.files2,(Q,Z)=>{const ne=Array.isArray(U.fileLabels)&&U.fileLabels[Z]||void 0;typeof Q=="string"&&F.files.push({label:ne,fileUri:P.URI.parse(Q)})})}}return F}e.restoreRecentlyOpened=z;function W(J){const O={entries:[]};for(const F of J.workspaces)b(F)?O.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):O.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of J.files)O.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return O}e.toStoreData=W}),define(be[69],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class E{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const P=this._idPool++;return this._data.set(P,I),this.logDebugInfo(),P}get(I,P){return this._data.has(I)?this._data.get(I)[P]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!E.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=E,E.enableDebugLogging=!1}),define(be[160],we([0,1,2,3]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class I{constructor(){this._onDidChangeTabs=new C.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(S){this._tabs=S.map(D=>({name:D.name,group:D.group,resource:E.URI.revive(D.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=I}),define(be[49],we([0,1,18,4]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class I{constructor(){this._systemSchemes=new Set(Object.keys(E.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(S,D){D===null?this._providerInfo.delete(S):this._providerInfo.set(S,D)}isFreeScheme(S){return!this._providerInfo.has(S)&&!this._systemSchemes.has(S)}getCapabilities(S){return this._providerInfo.get(S)}}e.ExtHostFileSystemInfo=I,e.IExtHostFileSystemInfo=(0,C.createDecorator)("IExtHostFileSystemInfo")}),define(be[27],we([0,1,4]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,E.createDecorator)("IExtHostInitDataService")}),define(be[161],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class E{constructor(P,S,D){this._id=P,this._shared=S,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)})}get whenReady(){return this._init}get(P,S){let D=this._value[P];return typeof D=="undefined"&&(D=S),D}update(P,S){return this._value[P]=S,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=E;class C extends E{constructor(P,S){super(P.identifier.value,!0,S);this._extension=P}setKeysForSync(P){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},P)}}e.ExtensionGlobalMemento=C}),define(be[15],we([0,1,4]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,E.createDecorator)("IExtHostRpcService");class C{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=C});var tt=this&&this.__classPrivateFieldSet||function(Y,e,E,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(Y,E):I?I.value=E:e.set(Y,E),E},Me=this&&this.__classPrivateFieldGet||function(Y,e,E,C){if(E==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?C:E==="a"?C.call(Y):C?C.value:e.get(Y)};define(be[162],we([0,1,26,3]),function(Y,e,E,C){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(D,y){I.set(this,void 0),this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._id=E.ExtensionIdentifier.toKey(D.identifier),tt(this,I,y,"f"),Me(this,I,"f").onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(D){return Me(this,I,"f").get(this._id,D)}store(D,y){return Me(this,I,"f").store(this._id,D,y)}delete(D){return Me(this,I,"f").delete(this._id,D)}}e.ExtensionSecrets=P,I=new WeakMap}),define(be[94],we([0,1,4,3]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new C.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(S){this._enabled=S}$onDidChangeTelemetryEnabled(S){this._enabled=S,this._onDidChangeTelemetryEnabled.fire(S)}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,E.createDecorator)("IExtHostTelemetry")}),define(be[70],we([0,1,3]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var C;(function(S){S[S.NewChild=0]="NewChild",S[S.Disposed=1]="Disposed",S[S.Invalidated=2]="Invalidated",S[S.SetProp=3]="SetProp"})(C=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const I=new WeakMap,P=S=>{let D=I.get(S);return D||(D={children:new Map,bus:new E.Emitter},I.set(S,D)),D};e.getPrivateApiFor=P}),define(be[71],we([0,1,4,3,15]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var P;(function(D){function y(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public}}D.fromApiTunnel=y;function n(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.public}}D.fromServiceTunnel=n})(P=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,E.createDecorator)("IExtHostTunnelService");let S=class{constructor(y){this.onDidChangeTunnels=new C.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,n){return{dispose:()=>{}}}async $providePortAttributes(y,n,T,k,f){return[]}async $forwardPort(y,n){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};S=je([Ke(0,I.IExtHostRpcService)],S),e.ExtHostTunnelService=S});var tt=this&&this.__classPrivateFieldSet||function(Y,e,E,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(Y,E):I?I.value=E:e.set(Y,E),E},Me=this&&this.__classPrivateFieldGet||function(Y,e,E,C){if(E==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?C:E==="a"?C.call(Y):C?C.value:e.get(Y)},$t=this&&this.__rest||function(Y,e){var E={};for(var C in Y)Object.prototype.hasOwnProperty.call(Y,C)&&e.indexOf(C)<0&&(E[C]=Y[C]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function")for(var I=0,C=Object.getOwnPropertySymbols(Y);I<C.length;I++)e.indexOf(C[I])<0&&Object.prototype.propertyIsEnumerable.call(Y,C[I])&&(E[C[I]]=Y[C[I]]);return E};define(be[7],we([0,1,12,11,83,22,10,2,29,65,68,70]),function(Y,e,E,C,I,P,S,D,y,n,T,k){"use strict";var f,h,r,a,p,d,b,g,c,w,t,i,l,s,o,u;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function v(x){function M(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(M,x),Object.setPrototypeOf(M.prototype,x.prototype),M}let A=r=class{constructor(M){f.set(this,void 0),tt(this,f,M,"f")}static from(...M){let re=M;return new r(function(){if(re){for(const ye of re)ye&&typeof ye.dispose=="function"&&ye.dispose();re=void 0}})}dispose(){typeof Me(this,f,"f")=="function"&&(Me(this,f,"f").call(this),tt(this,f,void 0,"f"))}};f=new WeakMap,A=r=je([v],A),e.Disposable=A;let m=a=class{constructor(M,re){if(M<0)throw(0,C.illegalArgument)("line must be non-negative");if(re<0)throw(0,C.illegalArgument)("character must be non-negative");this._line=M,this._character=re}static Min(...M){if(M.length===0)throw new TypeError;let re=M[0];for(let ye=1;ye<M.length;ye++){const ze=M[ye];ze.isBefore(re)&&(re=ze)}return re}static Max(...M){if(M.length===0)throw new TypeError;let re=M[0];for(let ye=1;ye<M.length;ye++){const ze=M[ye];ze.isAfter(re)&&(re=ze)}return re}static isPosition(M){if(!M)return!1;if(M instanceof a)return!0;let{line:re,character:ye}=M;return typeof re=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,re=0){if(M===null||re===null)throw(0,C.illegalArgument)();let ye;return typeof M=="undefined"?ye=0:typeof M=="number"?ye=M:(ye=typeof M.lineDelta=="number"?M.lineDelta:0,re=typeof M.characterDelta=="number"?M.characterDelta:0),ye===0&&re===0?this:new a(this.line+ye,this.character+re)}with(M,re=this.character){if(M===null||re===null)throw(0,C.illegalArgument)();let ye;return typeof M=="undefined"?ye=this.line:typeof M=="number"?ye=M:(ye=typeof M.line=="number"?M.line:this.line,re=typeof M.character=="number"?M.character:this.character),ye===this.line&&re===this.character?this:new a(ye,re)}toJSON(){return{line:this.line,character:this.character}}};m=a=je([v],m),e.Position=m;let _=p=class{constructor(M,re,ye,ze){let Je,ut;if(typeof M=="number"&&typeof re=="number"&&typeof ye=="number"&&typeof ze=="number"?(Je=new m(M,re),ut=new m(ye,ze)):M instanceof m&&re instanceof m&&(Je=M,ut=re),!Je||!ut)throw new Error("Invalid arguments");Je.isBefore(ut)?(this._start=Je,this._end=ut):(this._start=ut,this._end=Je)}static isRange(M){return M instanceof p?!0:M?m.isPosition(M.start)&&m.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof p?this.contains(M._start)&&this.contains(M._end):M instanceof m?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const re=m.Max(M.start,this._start),ye=m.Min(M.end,this._end);if(!re.isAfter(ye))return new p(re,ye)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const re=m.Min(M.start,this._start),ye=m.Max(M.end,this.end);return new p(re,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,re=this.end){if(M===null||re===null)throw(0,C.illegalArgument)();let ye;return M?m.isPosition(M)?ye=M:(ye=M.start||this.start,re=M.end||this.end):ye=this.start,ye.isEqual(this._start)&&re.isEqual(this.end)?this:new p(ye,re)}toJSON(){return[this.start,this.end]}};_=p=je([v],_),e.Range=_;let R=d=class extends _{constructor(M,re,ye,ze){let Je,ut;if(typeof M=="number"&&typeof re=="number"&&typeof ye=="number"&&typeof ze=="number"?(Je=new m(M,re),ut=new m(ye,ze)):M instanceof m&&re instanceof m&&(Je=M,ut=re),!Je||!ut)throw new Error("Invalid arguments");super(Je,ut);this._anchor=Je,this._active=ut}static isSelection(M){return M instanceof d?!0:M?_.isRange(M)&&m.isPosition(M.anchor)&&m.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};R=d=je([v],R),e.Selection=R;class L{constructor(M,re,ye){if(typeof M!="string"||M.length===0)throw(0,C.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,C.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,C.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(re),this.connectionToken=ye}}e.ResolvedAuthority=L;class V extends Error{constructor(M,re=T.RemoteAuthorityResolverErrorCode.Unknown,ye){super(M);this._message=M,this._code=re,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(M,re){return new V(M,T.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(M){return new V(M,T.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var he;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(he=e.EndOfLine||(e.EndOfLine={}));var z;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let W=b=class{constructor(M,re){this._range=M,this._newText=re}static isTextEdit(M){return M instanceof b?!0:M?_.isRange(M)&&typeof M.newText=="string":!1}static replace(M,re){return new b(M,re)}static insert(M,re){return b.replace(new _(M,M),re)}static delete(M){return b.replace(M,"")}static setEndOfLine(M){const re=new b(new _(new m(0,0),new m(0,0)),"");return re.newEol=M,re}get range(){return this._range}set range(M){if(M&&!_.isRange(M))throw(0,C.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,C.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,C.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};W=b=je([v],W),e.TextEdit=W;var J;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellOutput=4]="CellOutput",x[x.CellReplace=5]="CellReplace",x[x.CellOutputItem=6]="CellOutputItem"})(J=e.FileEditType||(e.FileEditType={}));let O=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,re,ye,ze){this._edits.push({_type:1,from:M,to:re,options:ye,metadata:ze})}createFile(M,re,ye){this._edits.push({_type:1,from:void 0,to:M,options:re,metadata:ye})}deleteFile(M,re,ye){this._edits.push({_type:1,from:M,to:void 0,options:re,metadata:ye})}replaceNotebookMetadata(M,re,ye){this._edits.push({_type:3,metadata:ye,uri:M,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells(M,re,ye,ze,Je){(re!==ye||ze.length>0)&&this._edits.push({_type:5,uri:M,index:re,count:ye-re,cells:ze,metadata:Je})}replaceNotebookCellOutput(M,re,ye,ze){this._editNotebookCellOutput(M,re,!1,ye,ze)}appendNotebookCellOutput(M,re,ye,ze){this._editNotebookCellOutput(M,re,!0,ye,ze)}replaceNotebookCellOutputItems(M,re,ye,ze,Je){this._editNotebookCellOutputItems(M,re,ye,!1,ze,Je)}appendNotebookCellOutputItems(M,re,ye,ze,Je){this._editNotebookCellOutputItems(M,re,ye,!0,ze,Je)}_editNotebookCellOutputItems(M,re,ye,ze,Je,ut){this._edits.push({_type:6,metadata:ut,uri:M,index:re,outputId:ye,append:ze,newOutputItems:Je})}_editNotebookCellOutput(M,re,ye,ze,Je){this._edits.push({_type:4,metadata:Je,uri:M,index:re,append:ye,newOutputs:ze,newMetadata:void 0})}replaceNotebookCellMetadata(M,re,ye,ze){this._edits.push({_type:3,metadata:ze,uri:M,edit:{editType:11,index:re,metadata:ye}})}replace(M,re,ye,ze){this._edits.push({_type:2,uri:M,edit:new W(re,ye),metadata:ze})}insert(M,re,ye,ze){this.replace(M,new _(re,re),ye,ze)}delete(M,re,ye){this.replace(M,re,"",ye)}has(M){return this._edits.some(re=>re._type===2&&re.uri.toString()===M.toString())}set(M,re){if(re)for(const ye of re)ye&&this._edits.push({_type:2,uri:M,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const ze=this._edits[ye];ze._type===2&&ze.uri.toString()===M.toString()&&(this._edits[ye]=void 0)}(0,E.coalesceInPlace)(this._edits)}}get(M){const re=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===M.toString()&&re.push(ye.edit);return re}entries(){const M=new P.ResourceMap;for(let re of this._edits)if(re._type===2){let ye=M.get(re.uri);ye||(ye=[re.uri,[]],M.set(re.uri,ye)),ye[1].push(re.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};O=je([v],O),e.WorkspaceEdit=O;let F=g=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof g?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=g._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,re=this._tabstop++){if(typeof M=="function"){const ye=new g;ye._tabstop=this._tabstop,M(ye),this._tabstop=ye._tabstop,M=ye.value}else M=g._escape(M);return this.value+="${",this.value+=re,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,re=this._tabstop++){const ye=M.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(M,re){if(typeof re=="function"){const ye=new g;ye._tabstop=this._tabstop,re(ye),this._tabstop=ye._tabstop,re=ye.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,re&&(this.value+=":",this.value+=re),this.value+="}",this}};F=g=je([v],F),e.SnippetString=F;var N;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(N=e.DiagnosticTag||(e.DiagnosticTag={}));var B;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(B=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let U=c=class{constructor(M,re){if(this.uri=M,re)if(re instanceof _)this.range=re;else if(re instanceof m)this.range=new _(re,re);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof c?!0:M?_.isRange(M.range)&&D.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};U=c=je([v],U),e.Location=U;let Q=class{constructor(M,re){this.location=M,this.message=re}static is(M){return M?typeof M.message=="string"&&M.location&&_.isRange(M.location.range)&&D.URI.isUri(M.location.uri):!1}static isEqual(M,re){return M===re?!0:!M||!re?!1:M.message===re.message&&M.location.range.isEqual(re.location.range)&&M.location.uri.toString()===re.location.uri.toString()}};Q=je([v],Q),e.DiagnosticRelatedInformation=Q;let Z=class{constructor(M,re,ye=B.Error){if(!_.isRange(M))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=M,this.message=re,this.severity=ye}toJSON(){return{severity:B[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,re){return M===re?!0:!M||!re?!1:M.message===re.message&&M.severity===re.severity&&M.code===re.code&&M.severity===re.severity&&M.source===re.source&&M.range.isEqual(re.range)&&(0,E.equals)(M.tags,re.tags)&&(0,E.equals)(M.relatedInformation,re.relatedInformation,Q.isEqual)}};Z=je([v],Z),e.Diagnostic=Z;let ne=class{constructor(M,re){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:(0,I.isMarkdownString)(M)?this.contents=[M]:this.contents=[M],this.range=re}};ne=je([v],ne),e.Hover=ne;var pe;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(pe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Pe=class{constructor(M,re=pe.Text){this.range=M,this.kind=re}toJSON(){return{range:this.range,kind:pe[this.kind]}}};Pe=je([v],Pe),e.DocumentHighlight=Pe;var Oe;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(Oe=e.SymbolKind||(e.SymbolKind={}));var Te;(function(x){x[x.Deprecated=1]="Deprecated"})(Te=e.SymbolTag||(e.SymbolTag={}));let xe=w=class{constructor(M,re,ye,ze,Je){this.name=M,this.kind=re,this.containerName=Je,typeof ye=="string"&&(this.containerName=ye),ze instanceof U?this.location=ze:ye instanceof _&&(this.location=new U(ze,ye)),w.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Oe[this.kind],location:this.location,containerName:this.containerName}}};xe=w=je([v],xe),e.SymbolInformation=xe;let $=t=class{constructor(M,re,ye,ze,Je){this.name=M,this.detail=re,this.kind=ye,this.range=ze,this.selectionRange=Je,this.children=[],t.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(t.validate)}};$=t=je([v],$),e.DocumentSymbol=$;var G;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(G=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ie=class{constructor(M,re){this.title=M,this.kind=re}};ie=je([v],ie),e.CodeAction=ie;let oe=i=class{constructor(M){this.value=M}append(M){return new i(this.value?this.value+i.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+i.sep)}};oe.sep=".",oe=i=je([v],oe),e.CodeActionKind=oe,oe.Empty=new oe(""),oe.QuickFix=oe.Empty.append("quickfix"),oe.Refactor=oe.Empty.append("refactor"),oe.RefactorExtract=oe.Refactor.append("extract"),oe.RefactorInline=oe.Refactor.append("inline"),oe.RefactorRewrite=oe.Refactor.append("rewrite"),oe.Source=oe.Empty.append("source"),oe.SourceOrganizeImports=oe.Source.append("organizeImports"),oe.SourceFixAll=oe.Source.append("fixAll");let me=class{constructor(M,re){if(this.range=M,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};me=je([v],me),e.SelectionRange=me;class De{constructor(M,re,ye,ze,Je,ut){this.kind=M,this.name=re,this.detail=ye,this.uri=ze,this.range=Je,this.selectionRange=ut}}e.CallHierarchyItem=De;class Ne{constructor(M,re){this.fromRanges=re,this.from=M}}e.CallHierarchyIncomingCall=Ne;class ge{constructor(M,re){this.fromRanges=re,this.to=M}}e.CallHierarchyOutgoingCall=ge;let Ce=class{constructor(M,re){this.range=M,this.command=re}get isResolved(){return!!this.command}};Ce=je([v],Ce),e.CodeLens=Ce;let Ae=l=class{constructor(M,re=!1){h.set(this,void 0),tt(this,h,new I.MarkdownString(M,{supportThemeIcons:re}),"f")}static isMarkdownString(M){return M instanceof l?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return Me(this,h,"f").value}set value(M){Me(this,h,"f").value=M}get isTrusted(){return Me(this,h,"f").isTrusted}set isTrusted(M){Me(this,h,"f").isTrusted=M}get supportThemeIcons(){return Me(this,h,"f").supportThemeIcons}appendText(M){return Me(this,h,"f").appendText(M),this}appendMarkdown(M){return Me(this,h,"f").appendMarkdown(M),this}appendCodeblock(M,re){return Me(this,h,"f").appendCodeblock(re!=null?re:"",M),this}};h=new WeakMap,Ae=l=je([v],Ae),e.MarkdownString=Ae;let Be=class{constructor(M,re){this.label=M,this.documentation=re}};Be=je([v],Be),e.ParameterInformation=Be;let _e=class{constructor(M,re){this.label=M,this.documentation=re,this.parameters=[]}};_e=je([v],_e),e.SignatureInformation=_e;let qe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};qe=je([v],qe),e.SignatureHelp=qe;var j;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(j=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var te;(function(x){x[x.Other=0]="Other",x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(te=e.InlineHintKind||(e.InlineHintKind={}));let ve=class{constructor(M,re,ye){this.text=M,this.range=re,this.kind=ye}};ve=je([v],ve),e.InlineHint=ve;var Ue;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var He;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(He=e.CompletionItemKind||(e.CompletionItemKind={}));var $e;(function(x){x[x.Deprecated=1]="Deprecated"})($e=e.CompletionItemTag||(e.CompletionItemTag={}));let Ye=class{constructor(M,re){this.label=M,this.kind=re}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&He[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ye=je([v],Ye),e.CompletionItem=Ye;let H=class{constructor(M=[],re=!1){this.items=M,this.isIncomplete=re}};H=je([v],H),e.CompletionList=H;var se;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(se=e.ViewColumn||(e.ViewColumn={}));var de;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(de=e.StatusBarAlignment||(e.StatusBarAlignment={}));var K;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(K=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ee;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(ee=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var le;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(le=e.TextEditorRevealType||(e.TextEditorRevealType={}));var fe;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(fe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ee;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(Ee=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function M(re){switch(re){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=M}(fe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ve=class{constructor(M,re){if(re&&!D.URI.isUri(re))throw(0,C.illegalArgument)("target");if(!_.isRange(M)||M.isEmpty)throw(0,C.illegalArgument)("range");this.range=M,this.target=re}};Ve=je([v],Ve),e.DocumentLink=Ve;let Fe=class{constructor(M,re,ye,ze){this.red=M,this.green=re,this.blue=ye,this.alpha=ze}};Fe=je([v],Fe),e.Color=Fe;let We=class{constructor(M,re){if(re&&!(re instanceof Fe))throw(0,C.illegalArgument)("color");if(!_.isRange(M)||M.isEmpty)throw(0,C.illegalArgument)("range");this.range=M,this.color=re}};We=je([v],We),e.ColorInformation=We;let Qe=class{constructor(M){if(!M||typeof M!="string")throw(0,C.illegalArgument)("label");this.label=M}};Qe=je([v],Qe),e.ColorPresentation=Qe;var it;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(it=e.ColorFormat||(e.ColorFormat={}));var at;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(at=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ze;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(Ze=e.TaskRevealKind||(e.TaskRevealKind={}));var nt;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(nt=e.TaskPanelKind||(e.TaskPanelKind={}));let dt=s=class{constructor(M,re){if(typeof M!="string"||typeof re!="string")throw(0,C.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};dt.Clean=new s("clean","Clean"),dt.Build=new s("build","Build"),dt.Rebuild=new s("rebuild","Rebuild"),dt.Test=new s("test","Test"),dt=s=je([v],dt),e.TaskGroup=dt;function wt(x){let M="";for(let re=0;re<x.length;re++)M+=x[re].replace(/,/g,",,")+",";return M}let ue=class{constructor(M,re,ye){if(typeof M!="string")throw(0,C.illegalArgument)("process");this._args=[],this._process=M,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=ye):this._options=re)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,C.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let re of this._args)M.push(re);return wt(M)}};ue=je([v],ue),e.ProcessExecution=ue;let Se=class{constructor(M,re,ye){if(this._args=[],Array.isArray(re)){if(!M)throw(0,C.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,C.illegalArgument)("command");this._command=M,this._args=re,this._options=ye}else{if(typeof M!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=M,this._options=re}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,C.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let re of this._args)M.push(typeof re=="string"?re:re.value);return wt(M)}};Se=je([v],Se),e.ShellExecution=Se;var ae;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(ae=e.ShellQuoting||(e.ShellQuoting={}));var q;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(q=e.TaskScope||(e.TaskScope={}));class Le{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=Le;let Ie=o=class{constructor(M,re,ye,ze,Je,ut){this.__deprecated=!1,this._definition=this.definition=M;let gt;typeof re=="string"?(this._name=this.name=re,this._source=this.source=ye,this.execution=ze,gt=Je,this.__deprecated=!0):re===q.Global||re===q.Workspace?(this.target=re,this._name=this.name=ye,this._source=this.source=ze,this.execution=Je,gt=ut):(this.target=re,this._name=this.name=ye,this._source=this.source=ze,this.execution=Je,gt=ut),typeof gt=="string"?(this._problemMatchers=[gt],this._hasDefinedMatchers=!0):Array.isArray(gt)?(this._problemMatchers=gt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ue?this._definition={type:o.ProcessType,id:this._execution.computeId()}:this._execution instanceof Se?this._definition={type:o.ShellType,id:this._execution.computeId()}:this._execution instanceof Le?this._definition={type:o.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:o.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,C.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,C.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const re=this._definition.type;(o.EmptyType===re||o.ProcessType===re||o.ShellType===re||o.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,C.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};Ie.ExtensionCallbackType="customExecution",Ie.ProcessType="process",Ie.ShellType="shell",Ie.EmptyType="$empty",Ie=o=je([v],Ie),e.Task=Ie;var Xe;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(Xe=e.ProgressLocation||(e.ProgressLocation={}));let et=class{constructor(M,re=ct.None){this.collapsibleState=re,D.URI.isUri(M)?this.resourceUri=M:this.label=M}};et=je([v],et),e.TreeItem=et;var ct;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let rt=class{constructor(M,re){this.id=M,this.color=re}};rt=je([v],rt),e.ThemeIcon=rt,rt.File=new rt("file"),rt.Folder=new rt("folder");let Ge=class{constructor(M){this.id=M}};Ge=je([v],Ge),e.ThemeColor=Ge;var ht;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(ht=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ot=class{constructor(M,re){if(typeof M!="string"&&(!M||!D.URI.isUri(M)&&!D.URI.isUri(M.uri)))throw(0,C.illegalArgument)("base");if(typeof re!="string")throw(0,C.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=D.URI.file(M),this.base=M):D.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=re}};ot=je([v],ot),e.RelativePattern=ot;let vt=class{constructor(M,re,ye,ze){this.enabled=typeof M=="boolean"?M:!0,typeof re=="string"&&(this.condition=re),typeof ye=="string"&&(this.hitCondition=ye),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};vt=je([v],vt),e.Breakpoint=vt;let pt=class extends vt{constructor(M,re,ye,ze,Je){super(re,ye,ze,Je);if(M===null)throw(0,C.illegalArgument)("location");this.location=M}};pt=je([v],pt),e.SourceBreakpoint=pt;let _t=class extends vt{constructor(M,re,ye,ze,Je){super(re,ye,ze,Je);this.functionName=M}};_t=je([v],_t),e.FunctionBreakpoint=_t;let yt=class extends vt{constructor(M,re,ye,ze,Je,ut,gt){super(ze,Je,ut,gt);if(!re)throw(0,C.illegalArgument)("dataId");this.label=M,this.dataId=re,this.canPersist=ye}};yt=je([v],yt),e.DataBreakpoint=yt;let It=class{constructor(M,re,ye){this.command=M,this.args=re||[],this.options=ye}};It=je([v],It),e.DebugAdapterExecutable=It;let bt=class{constructor(M,re){this.port=M,this.host=re}};bt=je([v],bt),e.DebugAdapterServer=bt;let Pt=class{constructor(M){this.path=M}};Pt=je([v],Pt),e.DebugAdapterNamedPipeServer=Pt;let qt=class{constructor(M){this.implementation=M}};qt=je([v],qt),e.DebugAdapterInlineImplementation=qt;let ft=class{constructor(M,re){this.range=M,this.expression=re}};ft=je([v],ft),e.EvaluatableExpression=ft;let Kt=class{constructor(M,re){this.range=M,this.text=re}};Kt=je([v],Kt),e.InlineValueText=Kt;let Et=class{constructor(M,re,ye=!0){this.range=M,this.variableName=re,this.caseSensitiveLookup=ye}};Et=je([v],Et),e.InlineValueVariableLookup=Et;let Bt=class{constructor(M,re){this.range=M,this.expression=re}};Bt=je([v],Bt),e.InlineValueEvaluatableExpression=Bt;let Gt=class{constructor(M,re){this.frameId=M,this.stoppedLocation=re}};Gt=je([v],Gt),e.InlineValueContext=Gt;var Wt;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Wt=e.FileChangeType||(e.FileChangeType={}));let lt=u=class extends Error{constructor(M,re=n.FileSystemProviderErrorCode.Unknown,ye){var ze;super(D.URI.isUri(M)?M.toString(!0):M);this.code=(ze=ye==null?void 0:ye.name)!==null&&ze!==void 0?ze:"Unknown",(0,n.markAsFileSystemProviderError)(this,re),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(M){return new u(M,n.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(M){return new u(M,n.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(M){return new u(M,n.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(M){return new u(M,n.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(M){return new u(M,n.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(M){return new u(M,n.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}};lt=u=je([v],lt),e.FileSystemError=lt;let Qt=class{constructor(M,re,ye){this.start=M,this.end=re,this.kind=ye}};Qt=je([v],Qt),e.FoldingRange=Qt;var At;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(At=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ot;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Ot=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var un;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(un=e.CommentMode||(e.CommentMode={}));class pn{constructor(M,re=[]){this.tokenTypes=M,this.tokenModifiers=re}}e.SemanticTokensLegend=pn;function cn(x){return typeof x=="undefined"||(0,S.isStringArray)(x)}class Jt{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let re=0,ye=M.tokenTypes.length;re<ye;re++)this._tokenTypeStrToInt.set(M.tokenTypes[re],re);for(let re=0,ye=M.tokenModifiers.length;re<ye;re++)this._tokenModifierStrToInt.set(M.tokenModifiers[re],re)}}push(M,re,ye,ze,Je){if(typeof M=="number"&&typeof re=="number"&&typeof ye=="number"&&typeof ze=="number"&&(typeof Je=="number"||typeof Je=="undefined"))return typeof Je=="undefined"&&(Je=0),this._pushEncoded(M,re,ye,ze,Je);if(_.isRange(M)&&typeof re=="string"&&cn(ye))return this._push(M,re,ye);throw(0,C.illegalArgument)()}_push(M,re,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const ze=M.start.line,Je=M.start.character,ut=M.end.character-M.start.character,gt=this._tokenTypeStrToInt.get(re);let St=0;if(ye)for(const Dt of ye){if(!this._tokenModifierStrToInt.has(Dt))throw new Error("`tokenModifier` is not in the provided legend");const Ct=this._tokenModifierStrToInt.get(Dt);St|=1<<Ct>>>0}this._pushEncoded(ze,Je,ut,gt,St)}_pushEncoded(M,re,ye,ze,Je){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let Dt=0,Ct=0;for(let kt=0;kt<St;kt++){let Rt=this._data[5*kt],an=this._data[5*kt+1];Rt===0?(Rt=Dt,an+=Ct):Rt+=Dt,this._data[5*kt]=Rt,this._data[5*kt+1]=an,Dt=Rt,Ct=an}}let ut=M,gt=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(gt-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=gt,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=Je,this._prevLine=M,this._prevChar=re}static _sortAndDeltaEncode(M){let re=[];const ye=M.length/5|0;for(let gt=0;gt<ye;gt++)re[gt]=gt;re.sort((gt,St)=>{const Dt=M[5*gt],Ct=M[5*St];if(Dt===Ct){const kt=M[5*gt+1],Rt=M[5*St+1];return kt-Rt}return Dt-Ct});const ze=new Uint32Array(M.length);let Je=0,ut=0;for(let gt=0;gt<ye;gt++){const St=5*re[gt],Dt=M[St+0],Ct=M[St+1],kt=M[St+2],Rt=M[St+3],an=M[St+4],In=Dt-Je,Rn=In===0?Ct-ut:Ct,ln=5*gt;ze[ln+0]=In,ze[ln+1]=Rn,ze[ln+2]=kt,ze[ln+3]=Rt,ze[ln+4]=an,Je=Dt,ut=Ct}return ze}build(M){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),M):new Ht(Jt._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=Jt;class Ht{constructor(M,re){this.resultId=re,this.data=M}}e.SemanticTokens=Ht;class Lt{constructor(M,re,ye){this.start=M,this.deleteCount=re,this.data=ye}}e.SemanticTokensEdit=Lt;class vn{constructor(M,re){this.resultId=re,this.edits=M}}e.SemanticTokensEdits=vn;var Yt;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Yt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Xt;(function(x){x[x.Initial=1]="Initial",x[x.Dynamic=2]="Dynamic"})(Xt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let zt=class{constructor(){}};zt.Back={iconPath:new rt("arrow-left")},zt=je([v],zt),e.QuickInputButtons=zt;var bn;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(bn=e.ExtensionKind||(e.ExtensionKind={}));class Tt{constructor(M,re,ye){this.badge=M,this.tooltip=re,this.color=ye}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Tt;let Zt=class{constructor(M){this.kind=M}};Zt=je([v],Zt),e.ColorTheme=Zt;var wn;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast"})(wn=e.ColorThemeKind||(e.ColorThemeKind={}));class en{constructor(M,re){if(M<0)throw(0,C.illegalArgument)("start must be positive");if(re<0)throw(0,C.illegalArgument)("end must be positive");M<=re?(this._start=M,this._end=re):(this._start=re,this._end=M)}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(M){let re=this._start,ye=this._end;return M.start!==void 0&&(re=M.start),M.end!==void 0&&(ye=M.end),re===this._start&&ye===this._end?this:new en(re,ye)}}e.NotebookRange=en;class tn{constructor(M,re){typeof M=="object"?Object.assign(this,M):(this.inputCollapsed=M,this.outputCollapsed=re)}with(M){let{inputCollapsed:re,outputCollapsed:ye,custom:ze}=M,Je=$t(M,["inputCollapsed","outputCollapsed","custom"]);return re===void 0?re=this.inputCollapsed:re===null&&(re=void 0),ye===void 0?ye=this.outputCollapsed:ye===null&&(ye=void 0),ze===void 0?ze=this.custom:ze===null&&(ze=void 0),re===this.inputCollapsed&&ye===this.outputCollapsed&&ze===this.custom&&Object.keys(Je).length===0?this:new tn(Object.assign({inputCollapsed:re,outputCollapsed:ye,custom:ze},Je))}}e.NotebookCellMetadata=tn;class Mt{constructor(M=!0,re={}){var ye,ze;typeof M=="object"?(Object.assign(this,M),this.trusted=(ye=M.trusted)!==null&&ye!==void 0?ye:!0,this.custom=(ze=M.custom)!==null&&ze!==void 0?ze:{}):(this.trusted=M,this.custom=re)}with(M){let{custom:re,trusted:ye}=M,ze=$t(M,["custom","trusted"]);return re===void 0?re=this.custom:re===null&&(re=void 0),ye===void 0?ye=this.trusted:ye===null&&(ye=void 0),re===this.custom&&ye===this.trusted&&Object.keys(ze).length===0?this:new Mt(Object.assign({trusted:ye,custom:re},ze))}}e.NotebookDocumentMetadata=Mt;class dn{constructor(M,re,ye,ze,Je,ut){this.kind=M,this.source=re,this.language=ye,this.outputs=ze!=null?ze:[],this.metadata=Je,this.latestExecutionSummary=ut}}e.NotebookCellData=dn;class hn{constructor(M,re){this.cells=M,this.metadata=re!=null?re:new Mt}}e.NotebookData=hn;class Nt{constructor(M,re,ye){this.mime=M,this.value=re,this.metadata=ye}static isNotebookCellOutputItem(M){return M instanceof Nt}}e.NotebookCellOutputItem=Nt;class Re{constructor(M,re,ye){this.outputs=M,typeof re=="string"?(this.id=re,this.metadata=ye):(this.id=(0,y.generateUuid)(),this.metadata=re!=null?re:ye)}}e.NotebookCellOutput=Re;var nn;(function(x){x[x.Markdown=1]="Markdown",x[x.Code=2]="Code"})(nn=e.NotebookCellKind||(e.NotebookCellKind={}));var rn;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(rn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var mt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(mt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var _n;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(_n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class En{constructor(M,re,ye,ze,Je,ut){this.text=M,this.alignment=re,this.command=ye,this.tooltip=ze,this.priority=Je,this.accessibilityInformation=ut}}e.NotebookCellStatusBarItem=En;let Vt=class{constructor(M,re){this.label=M,this.timestamp=re}};Vt=je([v],Vt),e.TimelineItem=Vt;var fn;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(fn=e.ExtensionMode||(e.ExtensionMode={}));var yn;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(yn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Sn;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=4]="RegEx"})(Sn=e.StandardTokenType||(e.StandardTokenType={}));class Dn{constructor(M,re){this.ranges=M,this.wordPattern=re}}e.LinkedEditingRanges=Dn;var Cn;(function(x){x[x.Unset=0]="Unset",x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(Cn=e.TestResultState||(e.TestResultState={}));var sn;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information",x[x.Hint=3]="Hint"})(sn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var mn;(function(x){x[x.Pending=0]="Pending",x[x.Resolved=1]="Resolved"})(mn=e.TestItemStatus||(e.TestItemStatus={}));const Ut=(x,M,re,ye)=>{let ze=re;return{enumerable:!0,configurable:!1,get(){return ze},set(Je){ye(ze,Je)||(ze=Je,x.bus.fire([3,M,Je]))}}},jt=(x,M)=>x===M,kn=(x,M)=>x===M?!0:!x||!M?!1:x.isEqual(M);class on{constructor(M,re,ye,ze){this.label=re,this.data=ze;const Je=(0,k.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:M,enumerable:!0,writable:!1},uri:{value:ye,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>Je.parent},children:{value:new P.ReadonlyMapView(Je.children),enumerable:!0,writable:!1},range:Ut(Je,"range",void 0,kn),description:Ut(Je,"description",void 0,jt),runnable:Ut(Je,"runnable",!0,jt),debuggable:Ut(Je,"debuggable",!0,jt),status:Ut(Je,"status",mn.Resolved,jt)})}invalidate(){(0,k.getPrivateApiFor)(this).bus.fire([2])}dispose(){const M=(0,k.getPrivateApiFor)(this);M.parent&&(0,k.getPrivateApiFor)(M.parent).children.delete(this.id),M.bus.fire([1])}addChild(M){if(!(M instanceof on))throw new Error("Test child must be created through vscode.test.createTestItem()");const re=(0,k.getPrivateApiFor)(this);if(re.children.has(M.id))throw new Error(`Attempted to insert a duplicate test item ID ${M.id}`);re.children.set(M.id,M),re.bus.fire([0,M])}}e.TestItemImpl=on;class X{constructor(M){this.message=M,this.severity=sn.Error}static diff(M,re,ye){const ze=new X(M);return ze.expectedOutput=re,ze.actualOutput=ye,ze}}e.TestMessage=X;var ce;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(ce=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ke;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(ke=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var st;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore"})(st=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(be[95],we([0,1,42,18,8,119,86,7,12]),function(Y,e,E,C,I,P,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function T(r,a){a?n.set(r,a):n.delete(r)}e.setWordDefinitionFor=T;function k(r){return n.get(r)}e.getWordDefinitionFor=k;class f extends P.MirrorTextModel{constructor(a,p,d,b,g,c,w,t){super(p,d,b,g);this._proxy=a,this._languageId=c,this._isDirty=w,this._notebook=t,this._isDisposed=!1}dispose(){(0,E.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,y.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===C.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},get notebook(){return a._notebook},save(){return a._save()},getText(p){return p?a._getTextInRange(p):a.getText()},get eol(){return a._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(p){return a._lineAt(p)},offsetAt(p){return a._offsetAt(p)},positionAt(p){return a._positionAt(p)},validateRange(p){return a._validateRange(p)},validatePosition(p){return a._validatePosition(p)},getWordRangeAtPosition(p,d){return a._getWordRangeAtPosition(p,d)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,E.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,E.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const p=this._validateRange(a);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const d=this._eol,b=p.start.line,g=p.end.line,c=[];c.push(this._lines[b].substring(p.start.character));for(let w=b+1;w<g;w++)c.push(this._lines[w]);return c.push(this._lines[g].substring(0,p.end.character)),c.join(d)}_lineAt(a){let p;if(a instanceof D.Position?p=a.line:typeof a=="number"&&(p=a),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new h(p,this._lines[p],p===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(a),d=this._lines[p.index].length;return new D.Position(p.index,Math.min(p.remainder,d))}_validateRange(a){if(!(a instanceof D.Range))throw new Error("Invalid argument");const p=this._validatePosition(a.start),d=this._validatePosition(a.end);return p===a.start&&d===a.end?a:new D.Range(p.line,p.character,d.line,d.character)}_validatePosition(a){if(!(a instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:p,character:d}=a,b=!1;if(p<0)p=0,d=0,b=!0;else if(p>=this._lines.length)p=this._lines.length-1,d=this._lines[p].length,b=!0;else{const g=this._lines[p].length;d<0?(d=0,b=!0):d>g&&(d=g,b=!0)}return b?new D.Position(p,d):a}_getWordRangeAtPosition(a,p){const d=this._validatePosition(a);if(!p)p=k(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const b=(0,S.getWordAtText)(d.character+1,(0,S.ensureValidWordDefinition)(p),this._lines[d.line],0);if(b)return new D.Range(d.line,b.startColumn-1,d.line,b.endColumn-1)}}e.ExtHostDocumentData=f;class h{constructor(a,p,d){this._line=a,this._text=p,this._isLastLine=d}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(be[163],we([0,1,7,3,88,6,60,22,2,29]),function(Y,e,E,C,I,P,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class T{constructor(f,h,r,a){this._notebook=r,this._selector=a,this._disposables=new P.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,n.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(d=>{const b=this._cellUris.get(d.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=d=>{d===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(f.onDidChangeNotebookCells(d=>p(d.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const f=[],h=[];for(const r of this._notebook.getCells())r.kind===E.NotebookCellKind.Code&&(!this._selector||(0,S.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),f.push(r.document.getText().length+1),h.push(r.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(f)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(f){var h,r;if(!f){let g="";for(const c of this._cells)g+=c.document.getText()+`
`;return g=g.slice(0,-1),g}if(f.isEmpty)return"";const a=this.locationAt(f.start),p=this.locationAt(f.end),d=this._cells[(h=this._cellUris.get(a.uri))!==null&&h!==void 0?h:-1],b=this._cells[(r=this._cellUris.get(p.uri))!==null&&r!==void 0?r:-1];if(!d||!b)return"";if(d===b)return d.document.getText(new E.Range(a.range.start,p.range.end));{const g=d.document.getText(new E.Range(a.range.start,new E.Position(d.document.lineCount,0))),c=b.document.getText(new E.Range(new E.Position(0,0),p.range.end));return g+`
`+c}}offsetAt(f){const h=this._cellLines.getIndexOf(f.line),r=this._cellLengths.getAccumulatedValue(h.index-1),a=this._cells[h.index].document.offsetAt(f.with(h.remainder));return r+a}positionAt(f){if(typeof f=="number"){const r=this._cellLengths.getIndexOf(f),a=this._cellLines.getAccumulatedValue(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(a)}const h=this._cellUris.get(f.uri);if(h!==void 0){const r=this._cellLines.getAccumulatedValue(h-1);return new E.Position(r+f.range.start.line,f.range.start.character)}return new E.Position(0,0)}locationAt(f){E.Range.isRange(f)||(f=new E.Range(f,f));const h=this._cellLines.getIndexOf(f.start.line);let r=h;f.isEmpty||(r=this._cellLines.getIndexOf(f.end.line));const a=new E.Position(h.remainder,f.start.character),p=new E.Position(r.remainder,f.end.character),d=new E.Range(a,p),b=this._cells[h.index];return new E.Location(b.document.uri,b.document.validateRange(d))}contains(f){return this._cellUris.has(f)}validateRange(f){const h=this.validatePosition(f.start),r=this.validatePosition(f.end);return f.with(h,r)}validatePosition(f){const h=this._cellLines.getIndexOf(f.line),r=new E.Position(h.remainder,f.character),a=this._cells[h.index].document.validatePosition(r),p=this._cellLines.getAccumulatedValue(h.index-1);return new E.Position(p+a.line,a.character)}}e.ExtHostNotebookConcatDocument=T}),define(be[164],we([0,1,7,15,3]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(D){this._actual=new E.ColorTheme(E.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let y=D==="light"?E.ColorThemeKind.Light:D==="dark"?E.ColorThemeKind.Dark:E.ColorThemeKind.HighContrast;this._actual=new E.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=je([Ke(0,C.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(be[72],we([0,1,4]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,E.createDecorator)("IURITransformerService");class C{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=C}),define(be[165],we([0,1,23]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class C{constructor(){this.buffers=[]}add(y){let n=this.buffers.indexOf(y);return n<0&&(n=this.buffers.length,this.buffers.push(y)),n}}function I(D,y){if(y){const n=new C,T=(h,r)=>{if(r instanceof ArrayBuffer){const a=n.add(r);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(r)){const a=P(r);if(a){const p=n.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:a,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},k=JSON.stringify(D,T),f=n.buffers.map(h=>{const r=new Uint8Array(h);return E.VSBuffer.wrap(r)});return{message:k,buffers:f}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=I;function P(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(D,y){const n=y.map(f=>{const h=new ArrayBuffer(f.byteLength);return new Uint8Array(h).set(f.buffer),h}),T=y.length?(f,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const r=h,{index:a}=r,p=n[a];if(r.view)switch(r.view.type){case 1:return new Int8Array(p,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return h}:void 0;return{message:JSON.parse(D,T),arrayBuffers:n}}e.deserializeWebviewMessage=S}),define(be[50],we([0,1,2]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function C(P,S,D){const y=P.webviewResourceRoot.replace("{{resource}}",D.scheme+I(D)).replace("{{uuid}}",S);return E.URI.parse(y)}e.asWebviewUri=C;function I(P){return P.toString().replace(/^\S+?:/,"")}}),define(be[166],we([0,1,3,6,50,29]),function(Y,e,E,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(y,n,T){this._proxy=y,this._editors=n,this._initData=T,this._handlePool=0,this._disposables=new C.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const k=n.getVisibleTextEditors();for(const f of this._insets.values())k.indexOf(f.editor)<0&&f.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,n,T,k,f){let h;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===y){h=c;break}if(!h)throw new Error("not a visible editor");const r=this,a=this._handlePool++,p=new E.Emitter,d=new E.Emitter,b=new class{constructor(){this._uuid=(0,P.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,I.asWebviewUri)(r._initData,this._uuid,c)}get cspSource(){return r._initData.webviewCspSource}set options(c){this._options=c,r._proxy.$setOptions(a,c)}get options(){return this._options}set html(c){this._html=c,r._proxy.$setHtml(a,c)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(c){return r._proxy.$postMessage(a,c)}},g=new class{constructor(){this.editor=y,this.line=n,this.height=T,this.webview=b,this.onDidDispose=d.event}dispose(){r._insets.has(a)&&(r._insets.delete(a),r._proxy.$disposeEditorInset(a),d.fire(),d.dispose(),p.dispose())}};return this._proxy.$createEditorInset(a,h.id,h.value.document.uri,n+1,T,k||{},f.identifier,f.extensionLocation),this._insets.set(a,{editor:y,inset:g,onDidReceiveMessage:p}),g}$onDidDispose(y){const n=this._insets.get(y);n&&n.inset.dispose()}$onDidReceiveMessage(y,n){const T=this._insets.get(y);T&&T.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=S}),define(be[167],we([0,1,3,64,138,4,6,22,30,12,52,24,36,158]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",f.Codicon.window,(0,I.localize)(0,null));var r;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var a;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel"})(a=e.ViewContainerLocation||(e.ViewContainerLocation={}));function p(o){switch(o){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=p;function d(o){return`viewContainer.${o}.enabled`}e.getEnabledViewContainerContextKey=d;class b extends S.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new E.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new E.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,n.flatten)([...this.viewContainers.values()])}registerViewContainer(u,v,A){var m;const _=this.get(u.id);if(_)return _;const R=u;return R.openCommandActionDescriptor=(A==null?void 0:A.donotRegisterOpenCommand)?void 0:(m=R.openCommandActionDescriptor)!==null&&m!==void 0?m:{id:R.id},(0,D.getOrSet)(this.viewContainers,v,[]).push(R),(A==null?void 0:A.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:v}),R}deregisterViewContainer(u){for(const v of this.viewContainers.keys()){const A=this.viewContainers.get(v),m=A==null?void 0:A.indexOf(u);if(m!==-1){A==null||A.splice(m,1),A.length===0&&this.viewContainers.delete(v),this._onDidDeregister.fire({viewContainer:u,viewContainerLocation:v});return}}}get(u){return this.all.filter(v=>v.id===u)[0]}getViewContainers(u){return[...this.viewContainers.get(u)||[]]}getViewContainerLocation(u){return[...this.viewContainers.keys()].filter(v=>this.getViewContainers(v).filter(A=>(A==null?void 0:A.id)===u.id).length>0)[0]}getDefaultViewContainer(u){return this.defaultViewContainers.find(v=>this.getViewContainerLocation(v)===u)}}y.Registry.add(r.ViewContainersRegistry,new b);var g;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(g=e.ViewContentGroups||(e.ViewContentGroups={}));function c(o,u){var v,A,m,_;const R=(v=o.group)!==null&&v!==void 0?v:g.More,L=(A=u.group)!==null&&A!==void 0?A:g.More;return R!==L?R.localeCompare(L):((m=o.order)!==null&&m!==void 0?m:5)-((_=u.order)!==null&&_!==void 0?_:5)}class w extends S.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new E.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new E.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new E.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new E.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new T.SetMap}registerViews(u,v){this.registerViews2([{views:u,viewContainer:v}])}registerViews2(u){u.forEach(({views:v,viewContainer:A})=>this.addViews(v,A)),this._onViewsRegistered.fire(u)}deregisterViews(u,v){const A=this.removeViews(u,v);A.length&&this._onViewsDeregistered.fire({views:A,viewContainer:v})}moveViews(u,v){for(const A of this._views.keys())if(A!==v){const m=this.removeViews(u,A);m.length&&(this.addViews(m,v),this._onDidChangeContainer.fire({views:m,from:A,to:v}))}}getViews(u){return this._views.get(u)||[]}getView(u){for(const v of this._viewContainers){const A=(this._views.get(v)||[]).filter(m=>m.id===u)[0];if(A)return A}return null}getViewContainer(u){for(const v of this._viewContainers)if((this._views.get(v)||[]).filter(m=>m.id===u)[0])return v;return null}registerViewWelcomeContent(u,v){return this._viewWelcomeContents.add(u,v),this._onDidChangeViewWelcomeContent.fire(u),(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(u,v),this._onDidChangeViewWelcomeContent.fire(u)})}registerViewWelcomeContent2(u,v){const A=new Map;for(const[m,_]of v)this._viewWelcomeContents.add(u,_),A.set(m,(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(u,_),this._onDidChangeViewWelcomeContent.fire(u)}));return this._onDidChangeViewWelcomeContent.fire(u),A}getViewWelcomeContent(u){const v=[];return this._viewWelcomeContents.forEach(u,A=>v.push(A)),v.sort(c)}addViews(u,v){let A=this._views.get(v);A||(A=[],this._views.set(v,A),this._viewContainers.push(v));for(const m of u){if(this.getView(m.id)!==null)throw new Error((0,I.localize)(1,null,m.id));A.push(m)}}removeViews(u,v){const A=this._views.get(v);if(!A)return[];const m=[],_=[];for(const R of A)u.includes(R)?m.push(R):_.push(R);return m.length&&(_.length?this._views.set(v,_):(this._views.delete(v),this._viewContainers.splice(this._viewContainers.indexOf(v),1))),m}}y.Registry.add(r.ViewsRegistry,new w),e.IViewsService=(0,P.createDecorator)("viewsService"),e.FocusedViewContext=new C.RawContextKey("focusedView","",(0,I.localize)(2,null));function t(o){return`view.${o}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,P.createDecorator)("viewDescriptorService");var i;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(i=e.ViewVisibilityState||(e.ViewVisibilityState={}));var l;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(l=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class s{constructor(u,v){this.resolved=!1,this._hasResolve=!1,(0,k.mixin)(this,u),this._hasResolve=!!v,this.resolve=async A=>{var m,_;if(v&&!this.resolved){const R=await v(A);R&&(this.tooltip=(m=this.tooltip)!==null&&m!==void 0?m:R.tooltip,this.command=(_=this.command)!==null&&_!==void 0?_:R.command)}A.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s}),define(be[168],we([0,1,2,148,159,19,149,167]),function(Y,e,E,C,I,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(a){return(p,...d)=>a(p.get(C.ICommandService),...d)}class n{static execute(p,d){const b={forceReuseWindow:d&&d.reuseWindow,remoteAuthority:d&&d.remoteAuthority};return p.executeCommand("_files.newWindow",b)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",C.CommandsRegistry.registerCommand({id:n.ID,handler:y(n.execute),description:{description:"Opens an new window",args:[]}}),C.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(a,p){return a.get(I.IWorkspacesService).removeRecentlyOpened([p])});class T{static execute(p,d){return typeof d=="string"?d=d.match(/^[^:/?#]+:\/\//)?E.URI.parse(d):E.URI.file(d):d=E.URI.revive(d),p.executeCommand("_workbench.removeFromRecentlyOpened",d)}}e.RemoveFromRecentlyOpenedAPICommand=T,T.ID="vscode.removeFromRecentlyOpened",C.CommandsRegistry.registerCommand(T.ID,y(T.execute));class k{static execute(p,d){const b=typeof d=="string"?{extensionId:d}:d;return p.executeCommand("workbench.action.openIssueReporter",b)}}e.OpenIssueReporter=k,k.ID="vscode.openIssueReporter",C.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(a,p){const d=a.get(I.IWorkspacesService);let b;const g=p.uri,c=p.label,w=p.remoteAuthority;return p.type==="workspace"?b={workspace:await d.getWorkspaceIdentifier(g),label:c,remoteAuthority:w}:p.type==="folder"?b={folderUri:g,label:c,remoteAuthority:w}:b={fileUri:g,label:c,remoteAuthority:w},d.addRecentlyOpened([b])}),C.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(a){return a.get(I.IWorkspacesService).getRecentlyOpened()}),C.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(a,p){const d=a.get(P.ILogService),b=a.get(S.IEnvironmentService);b.isExtensionDevelopment&&!!b.extensionTestsLocationURI&&d.setLevel(p)}),C.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(a){return a.get(P.ILogService).getLevel()}),C.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(a,p){const d=a.get(D.IViewDescriptorService),b=d.getViewContainerById(p.destinationId);if(!!b){for(const g of p.viewIds){const c=d.getViewDescriptorById(g);(c==null?void 0:c.canMoveView)&&d.moveViewsToContainer([c],b,D.ViewVisibilityState.Default)}await a.get(D.IViewsService).openViewContainer(b.id,!0)}});class f{static execute(p,d){return!Array.isArray(d==null?void 0:d.viewIds)||typeof(d==null?void 0:d.destinationId)!="string"?Promise.reject("Invalid arguments"):p.executeCommand("_workbench.action.moveViews",d)}}e.MoveViewsAPICommand=f,f.ID="vscode.moveViews",C.CommandsRegistry.registerCommand({id:f.ID,handler:y(f.execute),description:{description:"Move Views",args:[]}});class h{static execute(p,d){return p.executeCommand("_workbench.open",d)}}h.ID="vscode.open",C.CommandsRegistry.registerCommand(h.ID,y(h.execute));class r{static execute(p,d,b,g,c){return p.executeCommand("_workbench.diff",[d,b,g])}}r.ID="vscode.diff",C.CommandsRegistry.registerCommand(r.ID,y(r.execute))}),define(be[169],we([0,1,3,14,139]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new E.Emitter,this._onExit=new E.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,y,n,T){const k={command:D};if(y&&Object.keys(y).length>0&&(k.arguments=y),this.internalSend("request",k),typeof T=="number"){const f=setTimeout(()=>{clearTimeout(f);const h=this.pendingRequests.get(k.seq);if(h){this.pendingRequests.delete(k.seq);const r={type:"response",seq:0,request_seq:k.seq,success:!1,command:D,message:(0,I.localize)(0,null,T,D)};h(r)}},T)}return n&&this.pendingRequests.set(k.seq,n),k.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,y){return D.type!=="event"||y.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,C.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const y=D,n=this.pendingRequests.get(y.request_seq);n&&(this.pendingRequests.delete(y.request_seq),n(y));break}}}internalSend(D,y){y.type=D,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((y,n)=>D.set(n,y)),await(0,C.timeout)(500),D.forEach((y,n)=>{y({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(be[170],we([0,1,8,2,13,24,18]),function(Y,e,E,C,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function y(i,l,s){return i.replace(D,function(o,u){return l&&u.length>0&&u[0]!=="_"?o:s&&s.hasOwnProperty(u)?s[u]:o})}e.formatPII=y;function n(i){const l={};for(const s of Object.keys(i))s.startsWith("!")||(l[s]=i[s]);return l}e.filterExceptionsFromTelemetry=n;function T(i){return i.configuration.request==="attach"&&!k(i)}e.isSessionAttach=T;function k(i){let l=i.configuration.type;if(!!l)return l==="vslsShare"&&(l=i.configuration.adapterProxy.configuration.type),(0,E.equalsIgnoreCase)(l,"extensionhost")||(0,E.equalsIgnoreCase)(l,"pwa-extensionhost")?i:i.parentSession?k(i.parentSession):void 0}e.getExtensionHostDebugSession=k;function f(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=f;function h(i,l,s){let o,u=0,v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,A=null;for(;A=v.exec(i);){let m=A.index+1,_=m+A[0].length;if(m<=l&&_>=s){o=A[0],u=m;break}}if(o){let m=/\w+/g,_=null;for(;(_=m.exec(o))&&!(_.index+1+u+_[0].length>=s););_&&(o=o.substring(0,m.lastIndex))}return o?{start:u,end:u+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(i){return!!(i&&i.match(r))}e.isUri=a;function p(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(a(i.path))return C.URI.parse(i.path);if((0,I.isAbsolute)(i.path))return C.URI.file(i.path)}return i.path}function d(i){if(typeof i.path=="object"){const l=C.URI.revive(i.path);if(l)return l.scheme===S.Schemas.file?l.fsPath:l.toString()}return i.path}function b(i,l){const s=l?p:d,o=(0,P.deepClone)(i);return c(o,(u,v)=>{u&&v&&(v.path=s(v))}),o}e.convertToDAPaths=b;function g(i,l){const s=l?p:d,o=(0,P.deepClone)(i);return c(o,(u,v)=>{!u&&v&&(v.path=s(v))}),o}e.convertToVSCPaths=g;function c(i,l){switch(i.type){case"event":const s=i;switch(s.event){case"output":l(!1,s.body.source);break;case"loadedSource":l(!1,s.body.source);break;case"breakpoint":l(!1,s.body.breakpoint.source);break;default:break}break;case"request":const o=i;switch(o.command){case"setBreakpoints":l(!0,o.arguments.source);break;case"breakpointLocations":l(!0,o.arguments.source);break;case"source":l(!0,o.arguments.source);break;case"gotoTargets":l(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(v=>l(!1,v));break;default:break}break;case"response":const u=i;if(u.success&&u.body)switch(u.command){case"stackTrace":u.body.stackFrames.forEach(v=>l(!1,v.source));break;case"loadedSources":u.body.sources.forEach(v=>l(!1,v));break;case"scopes":u.body.scopes.forEach(v=>l(!1,v.source));break;case"setFunctionBreakpoints":u.body.breakpoints.forEach(v=>l(!1,v.source));break;case"setBreakpoints":u.body.breakpoints.forEach(v=>l(!1,v.source));break;default:break}break}}function w(i){return i.filter(l=>{var s;return!((s=l.presentation)===null||s===void 0?void 0:s.hidden)}).sort((l,s)=>l.presentation?s.presentation?l.presentation.group?s.presentation.group?l.presentation.group!==s.presentation.group?l.presentation.group.localeCompare(s.presentation.group):t(l.presentation.order,s.presentation.order):-1:s.presentation.group?1:t(l.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=w;function t(i,l){return typeof i!="number"?typeof l!="number"?0:1:typeof l!="number"?-1:i-l}}),define(be[73],we([0,1,28,18,13,21,64]),function(Y,e,E,C,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(L){L[L.Markdown=1]="Markdown",L[L.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(L){L[L.Running=1]="Running",L[L.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{},trusted:!0};var n;(function(L){L[L.Idle=1]="Idle",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var T;(function(L){L[L.WithHardKernelDependency=0]="WithHardKernelDependency",L[L.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",L[L.Pure=2]="Pure",L[L.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var k;(function(L){L[L.ModelChange=1]="ModelChange",L[L.Move=2]="Move",L[L.CellClearOutput=3]="CellClearOutput",L[L.CellsClearOutput=4]="CellsClearOutput",L[L.ChangeLanguage=5]="ChangeLanguage",L[L.Initialize=6]="Initialize",L[L.ChangeCellMetadata=7]="ChangeCellMetadata",L[L.Output=8]="Output",L[L.OutputItem=9]="OutputItem",L[L.ChangeCellContent=10]="ChangeCellContent",L[L.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",L[L.Unknown=12]="Unknown"})(k=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var f;(function(L){L[L.Handle=0]="Handle",L[L.Index=1]="Index"})(f=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(L){L[L.Replace=1]="Replace",L[L.Output=2]="Output",L[L.Metadata=3]="Metadata",L[L.CellLanguage=4]="CellLanguage",L[L.DocumentMetadata=5]="DocumentMetadata",L[L.OutputsSplice=6]="OutputsSplice",L[L.Move=7]="Move",L[L.Unknown=8]="Unknown",L[L.CellContent=9]="CellContent",L[L.OutputItems=10]="OutputItems",L[L.PartialMetadata=11]="PartialMetadata"})(h=e.CellEditType||(e.CellEditType={}));function r(L){const V=a.parse(L);return V?V.notebook.toString():L.toString()}e.getCellUndoRedoComparisonKey=r;var a;(function(L){L.scheme=C.Schemas.vscodeNotebookCell;const V=/^ch(\d{7,})/;function he(O,F){return O.with({scheme:L.scheme,fragment:`ch${F.toString().padStart(7,"0")}${O.scheme!==C.Schemas.file?O.scheme:""}`})}L.generate=he;function z(O){if(O.scheme===L.scheme){const F=V.exec(O.fragment);if(!!F)return{handle:Number(F[1]),notebook:O.with({scheme:O.fragment.substr(F[0].length)||C.Schemas.file,fragment:null})}}}L.parse=z;function W(O,F){return O.with({scheme:C.Schemas.vscodeNotebookCellMetadata,fragment:`ch${F.toString().padStart(7,"0")}${O.scheme!==C.Schemas.file?O.scheme:""}`})}L.generateCellMetadataUri=W;function J(O){if(O.scheme===C.Schemas.vscodeNotebookCellMetadata){const F=V.exec(O.fragment);if(!!F)return{handle:Number(F[1]),notebook:O.with({scheme:O.fragment.substr(F[0].length)||C.Schemas.file,fragment:null})}}}L.parseCellMetadataUri=J})(a=e.CellUri||(e.CellUri={}));const p=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function d(L){var V,he;return(he=(V=p.get(L))===null||V===void 0?void 0:V.alwaysSecure)!==null&&he!==void 0?he:!1}e.mimeTypeIsAlwaysSecure=d;function b(L){var V,he;return(he=(V=p.get(L))===null||V===void 0?void 0:V.supportedByCore)!==null&&he!==void 0?he:!1}e.mimeTypeSupportedByCore=b;function g(L){var V,he;return(he=(V=p.get(L))===null||V===void 0?void 0:V.mergeable)!==null&&he!==void 0?he:!1}e.mimeTypeIsMergeable=g;function c(L,V){return P.isWindows&&(L=L.replace(/\//g,"\\"),V=V.replace(/\//g,"\\")),E.match(L,V)}function w(L,V,he){let z=0;for(let W=0;W<V.length;W++){if(c(V[W],L))return z;z++}for(let W=0;W<he.length;W++){if(c(he[W],L))return z;z++}return z}function t(L,V,he){return L.sort((z,W)=>w(z,V,he)-w(W,V,he))}e.sortMimeTypes=t;function i(L,V,he,z=(W,J)=>W===J){const W=[];function J(N,B,U){if(!(B===0&&U.length===0)){const Q=W[W.length-1];Q&&Q.start+Q.deleteCount===N?(Q.deleteCount+=B,Q.toInsert.push(...U)):W.push({start:N,deleteCount:B,toInsert:U})}}let O=0,F=0;for(;;){if(O===L.length){J(O,0,V.slice(F));break}if(F===V.length){J(O,L.length-O,[]);break}const N=L[O],B=V[F];if(z(N,B)){O+=1,F+=1;continue}he(B)?(J(O,1,[]),O+=1):(J(O,0,[B]),F+=1)}return W}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var l;(function(L){L.default="default",L.option="option"})(l=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(L){const V=L;return!!((typeof V.include=="string"||E.isRelativePattern(V.include))&&(typeof V.exclude=="string"||E.isRelativePattern(V.exclude)))}e.isDocumentExcludePattern=s;function o(L,V,he){if(Array.isArray(L.viewType)&&L.viewType.indexOf(V)>=0||L.viewType===V)return!0;if(L.filenamePattern){let z=s(L.filenamePattern)?L.filenamePattern.include:L.filenamePattern,W=s(L.filenamePattern)?L.filenamePattern.exclude:void 0;if(E.match(z,(0,I.basename)(he.fsPath).toLowerCase()))return!(W&&E.match(W,(0,I.basename)(he.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class u{constructor(V){this.textModel=V}getElements(){const V=new Int32Array(this.textModel.cells.length);for(let he=0;he<this.textModel.cells.length;he++)V[he]=this.textModel.cells[he].getHashValue();return V}}e.CellSequence=u,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var v;(function(L){L[L.Left=1]="Left",L[L.Right=2]="Right"})(v=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function A(L){L.sort((he,z)=>he-z);const V=L.shift();return V===void 0?[]:L.reduce(function(he,z){return z<=he[0][1]?he[0][1]=z+1:he.unshift([z,z+1]),he},[[V,V+1]]).reverse().map(he=>({start:he[0],end:he[1]}))}e.cellIndexesToRanges=A;function m(L){return L.reduce((he,z)=>{for(let W=z.start;W<z.end;W++)he.push(W);return he},[])}e.cellRangesToIndexes=m;function _(L){const V=L.sort((z,W)=>z.start-W.start),he=V[0];return he?V.reduce((z,W)=>{const J=z[z.length-1];return J.end>=W.start?J.end=Math.max(J.end,W.end):z.push(W),z},[he]):[]}e.reduceRanges=_;function R(L,V){return V.start>=L.start&&V.end<=L.end}e.cellRangeContains=R}),define(be[171],we([0,1,141,4,64]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,E.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,E.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,E.localize(2,null)),e.ITaskService=(0,C.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[172],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function E(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=E;function C(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=C}),define(be[96],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var E;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));const C=(y,n)=>{n.expand!==void 0&&(y.expand=n.expand),n.item!==void 0&&Object.assign(y.item,n.item)};e.applyTestItemUpdate=C;var I;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.DeltaRootsComplete=3]="DeltaRootsComplete",y[y.Retire=4]="Retire"})(I=e.TestDiffOpType||(e.TestDiffOpType={}));const P=(y,n)=>`${y}:${n.toString()}`;e.getTestSubscriptionKey=P;class S{add(n){}update(n){}remove(n,T){}complete(){}}e.IncrementalChangeCollector=S;class D{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(n){const T=this.createChangeCollector();for(const k of n)switch(k[0]){case 0:{const f=k[1];if(f.parent){if(this.items.has(f.parent)){const h=this.items.get(f.parent);h.children.add(f.item.extId);const r=this.createItem(f,h);this.items.set(f.item.extId,r),T.add(r)}}else{this.roots.add(f.item.extId);const h=this.createItem(f);this.items.set(f.item.extId,h),T.add(h)}f.expand===2&&this.updateBusyControllers(1);break}case 1:{const f=k[1],h=this.items.get(f.extId);if(!h)break;(0,e.applyTestItemUpdate)(h,f),T.update(h),f.expand!==void 0&&h.expand===2&&f.expand!==2&&this.updateBusyControllers(-1);break}case 2:{const f=this.items.get(k[1]);if(!f)break;f.parent?this.items.get(f.parent).children.delete(f.item.extId):this.roots.delete(f.item.extId);const h=[[k[1]]];for(;h.length;)for(const r of h.pop()){const a=this.items.get(r);a&&(h.push(a.children),this.items.delete(r),T.remove(a,a!==f),a.expand===2&&this.updateBusyControllers(-1))}break}case 4:this.retireTest(k[1]);break;case 3:this.updatePendingRoots(k[1]);break}T.complete()}retireTest(n){}updateBusyControllers(n){this.busyControllerCount+=n}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new S}}e.AbstractIncrementalTestCollection=D}),define(be[173],we([0,1,13,46,10,24,21,59,142]),function(Y,e,E,C,I,P,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(k,f,h,r){if(this._contributedVariables=new Map,this._context=k,this._labelService=f,h)if(S.isWindows){const a=Object.create(null);this._envVariables=a,Object.keys(h).forEach(p=>{a[p.toLowerCase()]=h[p]})}else this._envVariables=h}resolveWithEnvironment(k,f,h){return this.recursiveResolve(k,f?f.uri:void 0,h)}async resolveAsync(k,f){return this.recursiveResolve(this._envVariables,k?k.uri:void 0,f)}resolve(k,f){return this.recursiveResolve(this._envVariables,k?k.uri:void 0,f)}resolveAnyBase(k,f,h,r){const a=P.deepClone(f);return S.isWindows&&a.windows?Object.keys(a.windows).forEach(p=>a[p]=a.windows[p]):S.isMacintosh&&a.osx?Object.keys(a.osx).forEach(p=>a[p]=a.osx[p]):S.isLinux&&a.linux&&Object.keys(a.linux).forEach(p=>a[p]=a.linux[p]),delete a.windows,delete a.osx,delete a.linux,this.recursiveResolve(this._envVariables,k?k.uri:void 0,a,h,r)}resolveAny(k,f,h){return this.resolveAnyBase(k,f,h)}async resolveAnyAsync(k,f,h){return this.resolveAnyBase(k,f,h)}resolveAnyMap(k,f,h){const r=new Map;return{newConfig:this.resolveAnyBase(k,f,h,r),resolvedVariables:r}}resolveWithInteractionReplace(k,f,h,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,f,h,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,f){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,f)}recursiveResolve(k,f,h,r,a){if(I.isString(h))return this.resolveString(k,f,h,r,a);if(I.isArray(h))return h.map(p=>this.recursiveResolve(k,f,p,r,a));if(I.isObject(h)){let p=Object.create(null);return Object.keys(h).forEach(d=>{const b=this.resolveString(k,f,d,r,a);p[b]=this.recursiveResolve(k,f,h[d],r,a)}),p}return h}resolveString(k,f,h,r,a){return h.replace(n.VARIABLE_REGEXP,(d,b)=>{if(b.includes(n.VARIABLE_LHS))return d;let g=this.evaluateSingleVariable(k,d,b,f,r);return a&&a.set(b,g),g})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,f,h,r,a){let p;const d=h.split(":");d.length>1&&(h=d[0],p=d[1]);const b=()=>{const w=this._context.getFilePath();if(w)return w;throw new Error((0,y.localize)(0,null,f))},g=()=>{const w=b();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,f,E.basename(w)))},c=()=>{if(p){const w=this._context.getFolderUri(p);if(w)return w;throw new Error((0,y.localize)(2,null,f,p))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,f)):new Error((0,y.localize)(4,null,f))};switch(h){case"env":if(p){if(k){const w=k[S.isWindows?p.toLowerCase():p];if(I.isString(w))return w}return""}throw new Error((0,y.localize)(5,null,f));case"config":if(p){const w=this._context.getConfigurationValue(r,p);if(I.isUndefinedOrNull(w))throw new Error((0,y.localize)(6,null,f,p));if(I.isObject(w))throw new Error((0,y.localize)(7,null,f,p));return w}throw new Error((0,y.localize)(8,null,f));case"command":return this.resolveFromMap(f,p,a,"command");case"input":return this.resolveFromMap(f,p,a,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return r||p?(0,D.normalizeDriveLetter)(this.fsPath(c())):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return E.basename(this.fsPath(c()));case"lineNumber":const w=this._context.getLineNumber();if(w)return w;throw new Error((0,y.localize)(9,null,f));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,f));case"file":return b();case"fileWorkspaceFolder":return g();case"relativeFile":return r||p?E.relative(this.fsPath(c()),b()):b();case"relativeFileDirname":const i=E.dirname(b());if(r||p){const u=E.relative(this.fsPath(c()),i);return u.length===0?".":u}return i;case"fileDirname":return E.dirname(b());case"fileExtname":return E.extname(b());case"fileBasename":return E.basename(b());case"fileBasenameNoExtension":const l=E.basename(b());return l.slice(0,l.length-E.extname(l).length);case"fileDirnameBasename":return E.basename(E.dirname(b()));case"execPath":const s=this._context.getExecPath();return s||f;case"execInstallFolder":const o=this._context.getAppRoot();return o||f;case"pathSeparator":return E.sep;default:try{const u=p?`${h}:${p}`:h;return this.resolveFromMap(f,u,a,void 0)}catch(u){return f}}}}resolveFromMap(k,f,h,r){if(f&&h){const a=r===void 0?h[f]:h[r+":"+f];if(typeof a=="string")return a;throw new Error((0,y.localize)(11,null,k))}return k}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[174],we([0,1,4]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,E.createDecorator)("editorGroupsService");var C;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(C=e.GroupDirection||(e.GroupDirection={}));var I;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(I=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var S;(function(f){f[f.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(S=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(f){f[f.GROUP_ACTIVE=0]="GROUP_ACTIVE",f[f.GROUP_INDEX=1]="GROUP_INDEX",f[f.EDITOR_OPEN=2]="EDITOR_OPEN",f[f.EDITOR_CLOSE=3]="EDITOR_CLOSE",f[f.EDITOR_MOVE=4]="EDITOR_MOVE",f[f.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",f[f.EDITOR_LABEL=6]="EDITOR_LABEL",f[f.EDITOR_PIN=7]="EDITOR_PIN",f[f.EDITOR_STICKY=8]="EDITOR_STICKY",f[f.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var T;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function k(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(be[175],we([0,1,4]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,E.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(be[9],we([0,1,12,83,229,58,24,10,2,32,63,143,90,73,175,7]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var p;(function(ue){function Se(q){const{selectionStartLineNumber:Le,selectionStartColumn:Ie,positionLineNumber:Xe,positionColumn:et}=q,ct=new a.Position(Le-1,Ie-1),rt=new a.Position(Xe-1,et-1);return new a.Selection(ct,rt)}ue.to=Se;function ae(q){const{anchor:Le,active:Ie}=q;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Ie.line+1,positionColumn:Ie.character+1}}ue.from=ae})(p=e.Selection||(e.Selection={}));var d;(function(ue){function Se(q){if(!!q){const{start:Le,end:Ie}=q;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Ie.line+1,endColumn:Ie.character+1}}}ue.from=Se;function ae(q){if(!!q){const{startLineNumber:Le,startColumn:Ie,endLineNumber:Xe,endColumn:et}=q;return new a.Range(Le-1,Ie-1,Xe-1,et-1)}}ue.to=ae})(d=e.Range||(e.Range={}));var b;(function(ue){function Se(ae){switch(ae){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 4:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}ue.to=Se})(b=e.TokenType||(e.TokenType={}));var g;(function(ue){function Se(q){return new a.Position(q.lineNumber-1,q.column-1)}ue.to=Se;function ae(q){return{lineNumber:q.line+1,column:q.character+1}}ue.from=ae})(g=e.Position||(e.Position={}));var c;(function(ue){function Se(q){switch(q){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}ue.from=Se;function ae(q){switch(q){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}ue.to=ae})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var w;(function(ue){function Se(q){let Le;return q.code&&((0,D.isString)(q.code)||(0,D.isNumber)(q.code)?Le=String(q.code):Le={value:String(q.code.value),target:q.code.target}),Object.assign(Object.assign({},d.from(q.range)),{message:q.message,source:q.source,code:Le,severity:i.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(t.from),tags:Array.isArray(q.tags)?(0,E.coalesce)(q.tags.map(c.from)):void 0})}ue.from=Se;function ae(q){var Le;const Ie=new a.Diagnostic(d.to(q),q.message,i.to(q.severity));return Ie.source=q.source,Ie.code=(0,D.isString)(q.code)?q.code:(Le=q.code)===null||Le===void 0?void 0:Le.value,Ie.relatedInformation=q.relatedInformation&&q.relatedInformation.map(t.to),Ie.tags=q.tags&&(0,E.coalesce)(q.tags.map(c.to)),Ie}ue.to=ae})(w=e.Diagnostic||(e.Diagnostic={}));var t;(function(ue){function Se(q){return Object.assign(Object.assign({},d.from(q.location.range)),{message:q.message,resource:q.location.uri})}ue.from=Se;function ae(q){return new a.DiagnosticRelatedInformation(new a.Location(q.resource,d.to(q)),q.message)}ue.to=ae})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(ue){function Se(q){switch(q){case a.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}ue.from=Se;function ae(q){switch(q){case f.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}ue.to=ae})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var l;(function(ue){function Se(q){return typeof q=="number"&&q>=a.ViewColumn.One?q-1:q===a.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}ue.from=Se;function ae(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}ue.to=ae})(l=e.ViewColumn||(e.ViewColumn={}));function s(ue){return typeof ue.range!="undefined"}function o(ue){return ue.length===0?!0:!!s(ue[0])}e.isDecorationOptionsArr=o;var u;(function(ue){function Se(et){return et.map(ue.from)}ue.fromMany=Se;function ae(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function q(et){let ct;if(ae(et)){const{language:ot,value:vt}=et;ct={value:"```"+ot+`
`+vt+"\n```\n"}}else a.MarkdownString.isMarkdownString(et)?ct={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ct={value:et}:ct={value:""};const rt=Object.create(null);ct.uris=rt;const Ge=ot=>{try{let vt=y.URI.parse(ot,!0);vt=vt.with({query:Le(vt.query,rt)}),rt[ot]=vt}catch(vt){}return""},ht=new I.Renderer;return ht.link=Ge,ht.image=ot=>Ge(C.parseHrefAndDimensions(ot).href),I(ct.value,{renderer:ht}),ct}ue.from=q;function Le(et,ct){if(!et)return et;let rt;try{rt=(0,P.parse)(et)}catch(ht){}if(!rt)return et;let Ge=!1;return rt=(0,S.cloneAndChange)(rt,ht=>{if(y.URI.isUri(ht)){const ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ot]=ht,Ge=!0,ot}else return}),Ge?JSON.stringify(rt):et}function Ie(et){const ct=new a.MarkdownString(et.value,et.supportThemeIcons);return ct.isTrusted=et.isTrusted,ct}ue.to=Ie;function Xe(et){if(!!et)return typeof et=="string"?et:ue.from(et)}ue.fromStrict=Xe})(u=e.MarkdownString||(e.MarkdownString={}));function v(ue){return o(ue)?ue.map(Se=>({range:d.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?u.fromMany(Se.hoverMessage):Se.hoverMessage?u.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):ue.map(Se=>({range:d.from(Se)}))}e.fromRangeOrRangeWithMessage=v;function A(ue){return typeof ue=="undefined"?ue:typeof ue=="string"?y.URI.file(ue):ue}e.pathOrURIToURI=A;var m;(function(ue){function Se(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?A(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}ue.from=Se})(m=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var _;(function(ue){function Se(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?A(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?m.from(ae.before):void 0,after:ae.after?m.from(ae.after):void 0}}ue.from=Se})(_=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(ue){function Se(ae){if(typeof ae=="undefined")return ae;switch(ae){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}ue.from=Se})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(ue){function Se(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?R.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?_.from(ae.light):void 0,dark:ae.dark?_.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?A(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?m.from(ae.before):void 0,after:ae.after?m.from(ae.after):void 0}}ue.from=Se})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(ue){function Se(q){return{text:q.newText,eol:q.newEol&&te.from(q.newEol),range:d.from(q.range)}}ue.from=Se;function ae(q){const Le=new a.TextEdit(d.to(q.range),q.text);return Le.newEol=typeof q.eol=="undefined"?void 0:te.to(q.eol),Le}ue.to=ae})(V=e.TextEdit||(e.TextEdit={}));var he;(function(ue){function Se(q,Le,Ie){var Xe,et,ct;const rt={edits:[]};if(q instanceof a.WorkspaceEdit)for(let Ge of q._allEntries())if(Ge._type===1)rt.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const ht=Le==null?void 0:Le.getDocument(Ge.uri);rt.edits.push({_type:2,resource:Ge.uri,edit:V.from(Ge.edit),modelVersionId:ht==null?void 0:ht.version,metadata:Ge.metadata})}else Ge._type===3?rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:(Xe=Ie==null?void 0:Ie.lookupNotebookDocument(Ge.uri))===null||Xe===void 0?void 0:Xe.notebookDocument.version}):Ge._type===4?(Ge.newOutputs&&rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:2,index:Ge.index,append:Ge.append,outputs:Ge.newOutputs.map(Ve.from)}}),Ge.newMetadata&&rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:11,index:Ge.index,metadata:Ge.newMetadata}})):Ge._type===5?rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:(et=Ie==null?void 0:Ie.lookupNotebookDocument(Ge.uri))===null||et===void 0?void 0:et.notebookDocument.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(fe.from)}}):Ge._type===6&&rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:10,outputId:Ge.outputId,items:((ct=Ge.newOutputItems)===null||ct===void 0?void 0:ct.map(Ee.from))||[],append:Ge.append}});return rt}ue.from=Se;function ae(q){const Le=new a.WorkspaceEdit;for(const Ie of q.edits)Ie.edit?Le.replace(y.URI.revive(Ie.resource),d.to(Ie.edit.range),Ie.edit.text):Le.renameFile(y.URI.revive(Ie.oldUri),y.URI.revive(Ie.newUri),Ie.options);return Le}ue.to=ae})(he=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(ue){const Se=Object.create(null);Se[a.SymbolKind.File]=0,Se[a.SymbolKind.Module]=1,Se[a.SymbolKind.Namespace]=2,Se[a.SymbolKind.Package]=3,Se[a.SymbolKind.Class]=4,Se[a.SymbolKind.Method]=5,Se[a.SymbolKind.Property]=6,Se[a.SymbolKind.Field]=7,Se[a.SymbolKind.Constructor]=8,Se[a.SymbolKind.Enum]=9,Se[a.SymbolKind.Interface]=10,Se[a.SymbolKind.Function]=11,Se[a.SymbolKind.Variable]=12,Se[a.SymbolKind.Constant]=13,Se[a.SymbolKind.String]=14,Se[a.SymbolKind.Number]=15,Se[a.SymbolKind.Boolean]=16,Se[a.SymbolKind.Array]=17,Se[a.SymbolKind.Object]=18,Se[a.SymbolKind.Key]=19,Se[a.SymbolKind.Null]=20,Se[a.SymbolKind.EnumMember]=21,Se[a.SymbolKind.Struct]=22,Se[a.SymbolKind.Event]=23,Se[a.SymbolKind.Operator]=24,Se[a.SymbolKind.TypeParameter]=25;function ae(Le){return typeof Se[Le]=="number"?Se[Le]:6}ue.from=ae;function q(Le){for(const Ie in Se)if(Se[Ie]===Le)return Number(Ie);return a.SymbolKind.Property}ue.to=q})(z=e.SymbolKind||(e.SymbolKind={}));var W;(function(ue){function Se(q){switch(q){case a.SymbolTag.Deprecated:return 1}}ue.from=Se;function ae(q){switch(q){case 1:return a.SymbolTag.Deprecated}}ue.to=ae})(W=e.SymbolTag||(e.SymbolTag={}));var J;(function(ue){function Se(q){return{name:q.name,kind:z.from(q.kind),tags:q.tags&&q.tags.map(W.from),containerName:q.containerName,location:U.from(q.location)}}ue.from=Se;function ae(q){const Le=new a.SymbolInformation(q.name,z.to(q.kind),q.containerName,U.to(q.location));return Le.tags=q.tags&&q.tags.map(W.to),Le}ue.to=ae})(J=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var O;(function(ue){function Se(q){var Le,Ie;const Xe={name:q.name||"!!MISSING: name!!",detail:q.detail,range:d.from(q.range),selectionRange:d.from(q.selectionRange),kind:z.from(q.kind),tags:(Ie=(Le=q.tags)===null||Le===void 0?void 0:Le.map(W.from))!==null&&Ie!==void 0?Ie:[]};return q.children&&(Xe.children=q.children.map(Se)),Xe}ue.from=Se;function ae(q){const Le=new a.DocumentSymbol(q.name,q.detail,z.to(q.kind),d.to(q.range),d.to(q.selectionRange));return(0,E.isNonEmptyArray)(q.tags)&&(Le.tags=q.tags.map(W.to)),q.children&&(Le.children=q.children.map(ae)),Le}ue.to=ae})(O=e.DocumentSymbol||(e.DocumentSymbol={}));var F;(function(ue){function Se(ae){const q=new a.CallHierarchyItem(z.to(ae.kind),ae.name,ae.detail||"",y.URI.revive(ae.uri),d.to(ae.range),d.to(ae.selectionRange));return q._sessionId=ae._sessionId,q._itemId=ae._itemId,q}ue.to=Se})(F=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(ue){function Se(ae){return new a.CallHierarchyIncomingCall(F.to(ae.from),ae.fromRanges.map(q=>d.to(q)))}ue.to=Se})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var B;(function(ue){function Se(ae){return new a.CallHierarchyOutgoingCall(F.to(ae.to),ae.fromRanges.map(q=>d.to(q)))}ue.to=Se})(B=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var U;(function(ue){function Se(q){return{range:q.range&&d.from(q.range),uri:q.uri}}ue.from=Se;function ae(q){return new a.Location(y.URI.revive(q.uri),d.to(q.range))}ue.to=ae})(U=e.location||(e.location={}));var Q;(function(ue){function Se(q){const Le=q,Ie=q;return{originSelectionRange:Le.originSelectionRange?d.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Ie.uri,range:d.from(Le.targetRange?Le.targetRange:Ie.range),targetSelectionRange:Le.targetSelectionRange?d.from(Le.targetSelectionRange):void 0}}ue.from=Se;function ae(q){return{targetUri:y.URI.revive(q.uri),targetRange:d.to(q.range),targetSelectionRange:q.targetSelectionRange?d.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?d.to(q.originSelectionRange):void 0}}ue.to=ae})(Q=e.DefinitionLink||(e.DefinitionLink={}));var Z;(function(ue){function Se(q){return{range:d.from(q.range),contents:u.fromMany(q.contents)}}ue.from=Se;function ae(q){return new a.Hover(q.contents.map(u.to),d.to(q.range))}ue.to=ae})(Z=e.Hover||(e.Hover={}));var ne;(function(ue){function Se(q){return{range:d.from(q.range),expression:q.expression}}ue.from=Se;function ae(q){return new a.EvaluatableExpression(d.to(q.range),q.expression)}ue.to=ae})(ne=e.EvaluatableExpression||(e.EvaluatableExpression={}));var pe;(function(ue){function Se(q){if(q instanceof a.InlineValueText)return{type:"text",range:d.from(q.range),text:q.text};if(q instanceof a.InlineValueVariableLookup)return{type:"variable",range:d.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}ue.from=Se;function ae(q){switch(q.type){case"text":return{range:d.to(q.range),text:q.text};case"variable":return{range:d.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:d.to(q.range),expression:q.expression}}}ue.to=ae})(pe=e.InlineValue||(e.InlineValue={}));var Pe;(function(ue){function Se(q){return{frameId:q.frameId,stoppedLocation:d.from(q.stoppedLocation)}}ue.from=Se;function ae(q){return new a.InlineValueContext(q.frameId,d.to(q.stoppedLocation))}ue.to=ae})(Pe=e.InlineValueContext||(e.InlineValueContext={}));var Oe;(function(ue){function Se(q){return{range:d.from(q.range),kind:q.kind}}ue.from=Se;function ae(q){return new a.DocumentHighlight(d.to(q.range),q.kind)}ue.to=ae})(Oe=e.DocumentHighlight||(e.DocumentHighlight={}));var Te;(function(ue){function Se(ae){switch(ae){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}ue.to=Se})(Te=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var xe;(function(ue){function Se(ae){return{triggerKind:Te.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}ue.to=Se})(xe=e.CompletionContext||(e.CompletionContext={}));var $;(function(ue){function Se(q){switch(q){case a.CompletionItemTag.Deprecated:return 1}}ue.from=Se;function ae(q){switch(q){case 1:return a.CompletionItemTag.Deprecated}}ue.to=ae})($=e.CompletionItemTag||(e.CompletionItemTag={}));var G;(function(ue){const Se=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function ae(Ie){var Xe;return(Xe=Se.get(Ie))!==null&&Xe!==void 0?Xe:9}ue.from=ae;const q=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Le(Ie){var Xe;return(Xe=q.get(Ie))!==null&&Xe!==void 0?Xe:a.CompletionItemKind.Property}ue.to=Le})(G=e.CompletionItemKind||(e.CompletionItemKind={}));var ie;(function(ue){function Se(ae,q){var Le;const Ie=new a.CompletionItem(typeof ae.label=="string"?ae.label:ae.label.name);return typeof ae.label!="string"&&(Ie.label2=ae.label),Ie.insertText=ae.insertText,Ie.kind=G.to(ae.kind),Ie.tags=(Le=ae.tags)===null||Le===void 0?void 0:Le.map($.to),Ie.detail=ae.detail,Ie.documentation=C.isMarkdownString(ae.documentation)?u.to(ae.documentation):ae.documentation,Ie.sortText=ae.sortText,Ie.filterText=ae.filterText,Ie.preselect=ae.preselect,Ie.commitCharacters=ae.commitCharacters,n.Range.isIRange(ae.range)?Ie.range=d.to(ae.range):typeof ae.range=="object"&&(Ie.range={inserting:d.to(ae.range.insert),replacing:d.to(ae.range.replace)}),Ie.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Ie.insertText=new a.SnippetString(ae.insertText):(Ie.insertText=ae.insertText,Ie.textEdit=Ie.range instanceof a.Range?new a.TextEdit(Ie.range,Ie.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Ie.additionalTextEdits=ae.additionalTextEdits.map(Xe=>V.to(Xe))),Ie.command=q&&ae.command?q.fromInternal(ae.command):void 0,Ie}ue.to=Se})(ie=e.CompletionItem||(e.CompletionItem={}));var oe;(function(ue){function Se(q){return{label:q.label,documentation:q.documentation?u.fromStrict(q.documentation):void 0}}ue.from=Se;function ae(q){return{label:q.label,documentation:C.isMarkdownString(q.documentation)?u.to(q.documentation):q.documentation}}ue.to=ae})(oe=e.ParameterInformation||(e.ParameterInformation={}));var me;(function(ue){function Se(q){return{label:q.label,documentation:q.documentation?u.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(oe.from):[],activeParameter:q.activeParameter}}ue.from=Se;function ae(q){return{label:q.label,documentation:C.isMarkdownString(q.documentation)?u.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(oe.to):[],activeParameter:q.activeParameter}}ue.to=ae})(me=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(ue){function Se(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(me.from):[]}}ue.from=Se;function ae(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(me.to):[]}}ue.to=ae})(De=e.SignatureHelp||(e.SignatureHelp={}));var Ne;(function(ue){function Se(q){var Le;return{text:q.text,range:d.from(q.range),kind:ge.from((Le=q.kind)!==null&&Le!==void 0?Le:a.InlineHintKind.Other),description:q.description&&u.fromStrict(q.description),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}ue.from=Se;function ae(q){const Le=new a.InlineHint(q.text,d.to(q.range),ge.to(q.kind));return Le.whitespaceAfter=q.whitespaceAfter,Le.whitespaceBefore=q.whitespaceBefore,Le.description=C.isMarkdownString(q.description)?u.to(q.description):q.description,Le}ue.to=ae})(Ne=e.InlineHint||(e.InlineHint={}));var ge;(function(ue){function Se(q){return q}ue.from=Se;function ae(q){return q}ue.to=ae})(ge=e.InlineHintKind||(e.InlineHintKind={}));var Ce;(function(ue){function Se(q){return{range:d.from(q.range),url:q.target,tooltip:q.tooltip}}ue.from=Se;function ae(q){let Le;if(q.url)try{Le=typeof q.url=="string"?y.URI.parse(q.url,!0):y.URI.revive(q.url)}catch(Ie){}return new a.DocumentLink(d.to(q.range),Le)}ue.to=ae})(Ce=e.DocumentLink||(e.DocumentLink={}));var Ae;(function(ue){function Se(q){const Le=new a.ColorPresentation(q.label);return q.textEdit&&(Le.textEdit=V.to(q.textEdit)),q.additionalTextEdits&&(Le.additionalTextEdits=q.additionalTextEdits.map(Ie=>V.to(Ie))),Le}ue.to=Se;function ae(q){return{label:q.label,textEdit:q.textEdit?V.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Le=>V.from(Le)):void 0}}ue.from=ae})(Ae=e.ColorPresentation||(e.ColorPresentation={}));var Be;(function(ue){function Se(q){return new a.Color(q[0],q[1],q[2],q[3])}ue.to=Se;function ae(q){return[q.red,q.green,q.blue,q.alpha]}ue.from=ae})(Be=e.Color||(e.Color={}));var _e;(function(ue){function Se(q){return{range:d.from(q.range)}}ue.from=Se;function ae(q){return new a.SelectionRange(d.to(q.range))}ue.to=ae})(_e=e.SelectionRange||(e.SelectionRange={}));var qe;(function(ue){function Se(ae){switch(ae){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}ue.to=Se})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var j;(function(ue){function Se(q){switch(q){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}ue.from=Se;function ae(q){switch(q){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}ue.to=ae})(j=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var te;(function(ue){function Se(q){if(q===a.EndOfLine.CRLF)return 1;if(q===a.EndOfLine.LF)return 0}ue.from=Se;function ae(q){if(q===1)return a.EndOfLine.CRLF;if(q===0)return a.EndOfLine.LF}ue.to=ae})(te=e.EndOfLine||(e.EndOfLine={}));var ve;(function(ue){function Se(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ue.from=Se})(ve=e.ProgressLocation||(e.ProgressLocation={}));var Ue;(function(ue){function Se(ae){const q={start:ae.start+1,end:ae.end+1};return ae.kind&&(q.kind=He.from(ae.kind)),q}ue.from=Se})(Ue=e.FoldingRange||(e.FoldingRange={}));var He;(function(ue){function Se(ae){if(ae)switch(ae){case a.FoldingRangeKind.Comment:return T.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return T.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return T.FoldingRangeKind.Region}}ue.from=Se})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $e;(function(ue){function Se(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?d.from(ae.selection):void 0,override:typeof ae.override=="boolean"?k.EditorOverride.DISABLED:void 0}}ue.from=Se})($e=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ye;(function(ue){function Se(q){return q instanceof a.RelativePattern||typeof q=="string"?q:ae(q)?new a.RelativePattern(q.base,q.pattern):q}ue.from=Se;function ae(q){const Le=q;return Le&&typeof Le.base=="string"&&typeof Le.pattern=="string"}})(Ye=e.GlobPattern||(e.GlobPattern={}));var H;(function(ue){function Se(ae){if(ae){if(Array.isArray(ae))return ae.map(Se);if(typeof ae=="string")return ae;{const q=ae;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:Ye.from(q.pattern),exclusive:q.exclusive}}}else return}ue.from=Se})(H=e.LanguageSelector||(e.LanguageSelector={}));var se;(function(ue){function Se(q){return{start:q.start,end:q.end}}ue.from=Se;function ae(q){return new a.NotebookRange(q.start,q.end)}ue.to=ae})(se=e.NotebookRange||(e.NotebookRange={}));var de;(function(ue){function Se(ae){return new a.NotebookCellMetadata().with(Object.assign(Object.assign({},ae),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}ue.to=Se})(de=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var K;(function(ue){function Se(q){return q}ue.from=Se;function ae(q){return new a.NotebookDocumentMetadata().with(q)}ue.to=ae})(K=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ee;(function(ue){function Se(q){return{startTime:q.runStartTime,endTime:q.runEndTime,executionOrder:q.executionOrder,success:q.lastRunSuccess}}ue.to=Se;function ae(q){return{lastRunSuccess:q.success,runStartTime:q.startTime,runEndTime:q.endTime,executionOrder:q.executionOrder}}ue.from=ae})(ee=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var le;(function(ue){function Se(q){switch(q){case a.NotebookCellKind.Markdown:return h.CellKind.Markdown;case a.NotebookCellKind.Code:default:return h.CellKind.Code}}ue.from=Se;function ae(q){switch(q){case h.CellKind.Markdown:return a.NotebookCellKind.Markdown;case h.CellKind.Code:default:return a.NotebookCellKind.Code}}ue.to=ae})(le=e.NotebookCellKind||(e.NotebookCellKind={}));var fe;(function(ue){function Se(q){var Le;return{cellKind:le.from(q.kind),language:q.language,source:q.source,metadata:Object.assign(Object.assign({},q.metadata),ee.from((Le=q.latestExecutionSummary)!==null&&Le!==void 0?Le:{})),outputs:q.outputs?q.outputs.map(Ve.from):[]}}ue.from=Se;function ae(q){return new a.NotebookCellData(le.to(q.cellKind),q.source,q.language,q.outputs?q.outputs.map(Ve.to):void 0,q.metadata?de.to(q.metadata):void 0)}ue.to=ae})(fe=e.NotebookCellData||(e.NotebookCellData={}));var Ee;(function(ue){function Se(q){return{mime:q.mime,value:q.value,metadata:q.metadata}}ue.from=Se;function ae(q){return new a.NotebookCellOutputItem(q.mime,q.value,q.metadata)}ue.to=ae})(Ee=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ve;(function(ue){function Se(q){return{outputId:q.id,outputs:q.outputs.map(Ee.from),metadata:q.metadata}}ue.from=Se;function ae(q){const Le=q.outputs.map(Ee.to);return new a.NotebookCellOutput(Le,q.outputId,q.metadata)}ue.to=ae})(Ve=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Fe;(function(ue){function Se(Ie){if(Ie!=null){if(Ie instanceof a.RelativePattern||typeof Ie=="string")return Ie;if(Le(Ie))return new a.RelativePattern(Ie.base,Ie.pattern);if(q(Ie))return{include:Ye.from(Ie.include)||void 0,exclude:Ye.from(Ie.exclude)||void 0}}}ue.from=Se;function ae(Ie){return typeof Ie=="string"?Ie:Le(Ie)?{base:Ie.base,pattern:Ie.pattern}:{include:Ie.include,exclude:Ie.exclude}}ue.to=ae;function q(Ie){const Xe=Ie,et=Ye.from(Xe.include);if(!(et&&et instanceof a.RelativePattern||typeof et=="string"))return!1;const ct=Ye.from(Xe.exclude);return!!(ct&&ct instanceof a.RelativePattern||typeof ct=="string")}function Le(Ie){const Xe=Ie;return Xe&&typeof Xe.base=="string"&&typeof Xe.pattern=="string"}})(Fe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var We;(function(ue){function Se(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?m.from(ae.top):void 0}}ue.from=Se})(We=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Qe;(function(ue){function Se(ae,q,Le){const Ie=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Ie,Le),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}ue.from=Se})(Qe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var it;(function(ue){function Se(ae){var q,Le,Ie;return{transientOutputs:(q=ae==null?void 0:ae.transientOutputs)!==null&&q!==void 0?q:!1,transientCellMetadata:Object.assign(Object.assign({},(Le=ae==null?void 0:ae.transientCellMetadata)!==null&&Le!==void 0?Le:ae==null?void 0:ae.transientMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Ie=ae==null?void 0:ae.transientDocumentMetadata)!==null&&Ie!==void 0?Ie:{}}}ue.from=Se})(it=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var at;(function(ue){function Se(q){var Le;return{uri:q.uri,provides:typeof q.provides=="string"?[q.provides]:(Le=q.provides)!==null&&Le!==void 0?Le:[]}}ue.from=Se;function ae(q){return{uri:y.URI.revive(q.uri),provides:q.provides}}ue.to=ae})(at=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var Ze;(function(ue){function Se(q){return{message:u.fromStrict(q.message)||"",severity:q.severity,expectedOutput:q.expectedOutput,actualOutput:q.actualOutput,location:q.location?U.from(q.location):void 0}}ue.from=Se;function ae(q){const Le=new a.TestMessage(typeof q.message=="string"?q.message:u.to(q.message));return Le.severity=q.severity,Le.actualOutput=q.actualOutput,Le.expectedOutput=q.expectedOutput,Le}ue.to=ae})(Ze=e.TestMessage||(e.TestMessage={}));var nt;(function(ue){function Se(Ie){var Xe,et;return{extId:Ie.id,label:Ie.label,uri:Ie.uri,range:d.from(Ie.range),debuggable:(Xe=Ie.debuggable)!==null&&Xe!==void 0?Xe:!1,description:Ie.description,runnable:(et=Ie.runnable)!==null&&et!==void 0?et:!0}}ue.from=Se;function ae(Ie){return{extId:Ie.id,label:Ie.label,uri:Ie.uri,range:d.from(Ie.range),debuggable:!1,description:Ie.description,runnable:!0}}ue.fromResultSnapshot=ae;function q(Ie){return{id:Ie.extId,label:Ie.label,uri:y.URI.revive(Ie.uri),range:d.to(Ie.range),addChild:()=>{},dispose:()=>{},status:a.TestItemStatus.Pending,data:void 0,debuggable:Ie.debuggable,description:Ie.description,runnable:Ie.runnable}}ue.toPlain=q;function Le(Ie){const Xe=new a.TestItemImpl(Ie.extId,Ie.label,y.URI.revive(Ie.uri),void 0);return Xe.range=d.to(Ie.range),Xe.debuggable=Ie.debuggable,Xe.description=Ie.description,Xe.runnable=Ie.runnable,Xe}ue.to=Le})(nt=e.TestItem||(e.TestItem={}));var dt;(function(ue){const Se=(q,Le)=>Object.assign(Object.assign({},nt.toPlain(q.item)),{taskStates:q.tasks.map(Ie=>({state:Ie.state,duration:Ie.duration,messages:Ie.messages.map(Ze.to)})),children:q.children.map(Ie=>Le.get(Ie)).filter(D.isDefined).map(Ie=>Se(Ie,Le))});function ae(q){const Le=[],Ie=new Map;for(const Xe of q.items)Ie.set(Xe.item.extId,Xe),Xe.direct&&Le.push(Xe);return{completedAt:q.completedAt,results:Le.map(Xe=>Se(Xe,Ie))}}ue.to=ae})(dt=e.TestResults||(e.TestResults={}));var wt;(function(ue){function Se(ae){switch(ae){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}ue.to=Se})(wt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(be[176],we([0,1,2,11,7,9,45]),function(Y,e,E,C,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(n,T,k,f={timeout:1500,errors:3}){this._logService=n,this._documents=T,this._mainThreadBulkEdits=k,this._thresholds=f,this._callbacks=new S.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(T,k,f)=>{const r={dispose:this._callbacks.push([T,k,n])};return Array.isArray(f)&&f.push(r),r}}async $participateInSave(n,T){const k=E.URI.revive(n);let f=!1;const h=setTimeout(()=>f=!0,this._thresholds.timeout),r=[];try{for(let a of[...this._callbacks]){if(f)break;const p=this._documents.getDocument(k),d=await this._deliverEventAsyncAndBlameBadListeners(a,{document:p,reason:P.TextDocumentSaveReason.to(T)});r.push(d)}}finally{clearTimeout(h)}return r}_deliverEventAsyncAndBlameBadListeners([n,T,k],f){const h=this._badListeners.get(n);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,n,T,f).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const a=this._badListeners.get(n);this._badListeners.set(n,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,T,k,f){const h=[],r=Date.now(),{document:a,reason:p}=f,{version:d}=a,b=Object.freeze({document:a,reason:p,waitUntil(g){if(Object.isFrozen(h))throw(0,C.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(g))}});try{T.apply(k,[b])}catch(g){return Promise.reject(g)}return Object.freeze(h),new Promise((g,c)=>{const w=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(w),g(t)}).catch(t=>{clearTimeout(w),c(t)})}).then(g=>{const c={edits:[]};for(const w of g)if(Array.isArray(w)&&w.every(t=>t instanceof I.TextEdit))for(const{newText:t,newEol:i,range:l}of w)c.edits.push({_type:2,resource:a.uri,edit:{range:l&&P.Range.from(l),text:t,eol:i&&P.EndOfLine.from(i)}});if(c.edits.length!==0)return d===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(be[177],we([0,1,3,14,28,2,9,7]),function(Y,e,E,C,I,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(k,f,h,r,a){this._onDidCreate=new E.Emitter,this._onDidChange=new E.Emitter,this._onDidDelete=new E.Emitter,this._config=0,h&&(this._config+=1),r&&(this._config+=2),a&&(this._config+=4);const p=(0,I.parse)(f),d=k(b=>{if(!h)for(let g of b.created){const c=P.URI.revive(g);p(c.fsPath)&&this._onDidCreate.fire(c)}if(!r)for(let g of b.changed){const c=P.URI.revive(g);p(c.fsPath)&&this._onDidChange.fire(c)}if(!a)for(let g of b.deleted){const c=P.URI.revive(g);p(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=D.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,d)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class n{constructor(k,f,h){this._logService=f,this._extHostDocumentsAndEditors=h,this._onFileSystemEvent=new E.Emitter,this._onDidRenameFile=new E.Emitter,this._onDidCreateFile=new E.Emitter,this._onDidDeleteFile=new E.Emitter,this._onWillRenameFile=new C.AsyncEmitter,this._onWillCreateFile=new C.AsyncEmitter,this._onWillDeleteFile=new C.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,f,h,r){return new y(this._onFileSystemEvent.event,k,f,h,r)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,f){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:f.map(h=>({oldUri:P.URI.revive(h.source),newUri:P.URI.revive(h.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:f.map(h=>P.URI.revive(h.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:f.map(h=>P.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,f){return(h,r,a)=>{const p=function(b){h.call(r,b)};return p.extension=k,f.event(p,void 0,a)}}async $onWillRunFileOperation(k,f,h,r){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:f.map(a=>({oldUri:P.URI.revive(a.source),newUri:P.URI.revive(a.target)}))},h,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:f.map(a=>P.URI.revive(a.target))},h,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:f.map(a=>P.URI.revive(a.target))},h,r)}}async _fireWillEvent(k,f,h,r){const a=new Set,p=[];if(await k.fireAsync(f,r,async(b,g)=>{var c;const w=Date.now(),t=await Promise.resolve(b);t instanceof D.WorkspaceEdit&&(p.push(t),a.add((c=g.extension.displayName)!==null&&c!==void 0?c:g.extension.identifier.value)),Date.now()-w>h&&this._logService.warn("SLOW file-participant",g.extension.identifier)}),!r.isCancellationRequested&&p.length!==0){const d={edits:[]};for(let b of p){let{edits:g}=S.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);d.edits=d.edits.concat(g)}return{edit:d,extensionNames:Array.from(a)}}}}e.ExtHostFileSystemEventService=n}),define(be[178],we([0,1,18,24,2,9,7,73]),function(Y,e,E,C,I,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(f,h,r,a){this.start=f,this.deletedCount=h,this.deletedItems=r,this.items=a}static asApiEvents(f){return f.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(r=>r.cell)}))}}class n{constructor(f,h,r){var a;this._notebook=f,this._extHostDocument=h,this._cellData=r,this.handle=r.handle,this.uri=I.URI.revive(r.uri),this.cellKind=r.cellKind,this._outputs=r.outputs.map(P.NotebookCellOutput.to),this._internalMetadata=(a=r.metadata)!==null&&a!==void 0?a:{},this._metadata=P.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=P.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(f,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:f}}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const f=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return f._notebook.getCellIndex(f)},notebook:f._notebook.notebookDocument,kind:P.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get outputs(){return f._outputs.slice(0)},get metadata(){return f._metadata},get latestExecutionSummary(){return f._previousResult}})}return this._cell}setOutputs(f){this._outputs=f.map(P.NotebookCellOutput.to)}setOutputItems(f,h,r){const a=r.map(P.NotebookCellOutputItem.to),p=this._outputs.find(d=>d.id===f);p&&(h||(p.outputs.length=0),p.outputs.push(...a))}setMetadata(f){this._internalMetadata=f,this._metadata=P.NotebookCellMetadata.to(f),this._previousResult=P.NotebookCellPreviousExecutionResult.to(f)}}e.ExtHostCell=n;class T{constructor(f,h,r,a,p,d,b){this._proxy=f,this._textDocumentsAndEditors=h,this._textDocuments=r,this._emitter=a,this._viewType=p,this._metadata=d,this.uri=b,this.handle=T._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get notebookDocument(){if(!this._notebook){const f=this;this._notebook={get uri(){return f.uri},get version(){return f._versionId},get viewType(){return f._viewType},get isDirty(){return f._isDirty},get isUntitled(){return f.uri.scheme===E.Schemas.untitled},get isClosed(){return f._disposed},get metadata(){return f._metadata},get cellCount(){return f._cells.length},cellAt(h){return h=f._validateIndex(h),f._cells[h].cell},getCells(h){return(h?f._getCells(h):f._cells).map(a=>a.cell)},save(){return f._save()}}}return this._notebook}updateBackup(f){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=f}disposeBackup(){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(f){f.metadata&&(this._metadata=this._metadata.with(f.metadata))}acceptModelChanged(f,h){this._versionId=f.versionId,this._isDirty=h;for(const r of f.rawEvents)r.kind===D.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(r.changes,!0),r.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1):r.kind===D.NotebookCellsChangeType.Move?this._moveCell(r.index,r.newIdx):r.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(r.index,r.outputs):r.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems):r.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(r.index,r.language):r.kind===D.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(r.index,r.metadata)}_validateIndex(f){return f<0?0:f>=this._cells.length?this._cells.length-1:f}_validateRange(f){return f.start<0&&(f=f.with({start:0})),f.end>this._cells.length&&(f=f.with({end:this._cells.length})),f}_getCells(f){f=this._validateRange(f);const h=[];for(let r=f.start;r<f.end;r++)h.push(this._cells[r]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(f,h){if(!this._disposed){const r=[],a=[],p=[];f.reverse().forEach(d=>{const g=d[2].map(t=>{const i=new n(this,this._textDocumentsAndEditors,t);return h||a.push(n.asModelAddData(this.notebookDocument,t)),i}),c=new y(d[0],d[1],[],g),w=this._cells.splice(d[0],d[1],...g);for(let t of w)p.push(t.uri),c.deletedItems.push(t.cell);r.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:p}),h||this._emitter.emitModelChange((0,C.deepFreeze)({document:this.notebookDocument,changes:y.asApiEvents(r)}))}}_moveCell(f,h){const r=this._cells.splice(f,1);this._cells.splice(h,0,...r);const a=[new y(f,1,r.map(p=>p.cell),[]),new y(h,0,[],r)];this._emitter.emitModelChange((0,C.deepFreeze)({document:this.notebookDocument,changes:y.asApiEvents(a)}))}_setCellOutputs(f,h){const r=this._cells[f];r.setOutputs(h),this._emitter.emitCellOutputsChange((0,C.deepFreeze)({document:this.notebookDocument,cells:[r.cell]}))}_setCellOutputItems(f,h,r,a){const p=this._cells[f];p.setOutputItems(h,r,a),this._emitter.emitCellOutputsChange((0,C.deepFreeze)({document:this.notebookDocument,cells:[p.cell]}))}_changeCellLanguage(f,h){const r=this._cells[f];r.cell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(r.uri,h)}_changeCellMetadata(f,h){var r;const a=this._cells[f],p=a.internalMetadata,d=a.cell.metadata;a.setMetadata(h);const b=a.cell.metadata;if((0,C.equals)(d,b)||this._emitter.emitCellMetadataChange((0,C.deepFreeze)({document:this.notebookDocument,cell:a.cell})),p.runState!==h.runState){const g=(r=h.runState)!==null&&r!==void 0?r:S.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,C.deepFreeze)({document:this.notebookDocument,cell:a.cell,executionState:g}))}}getCellFromIndex(f){return this._cells[f]}getCell(f){return this._cells.find(h=>h.handle===f)}getCellIndex(f){return this._cells.indexOf(f)}}e.ExtHostNotebookDocument=T,T._handlePool=0}),define(be[179],we([0,1,7,9]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class I{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,y){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:D,metadata:y})}replaceCellOutput(D,y){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:D,outputs:y.map(n=>C.NotebookCellOutput.from(n))})}replaceCells(D,y,n){this._throwIfFinalized(),!(D===y&&n.length===0)&&this._collectedEdits.push({editType:1,index:D,count:y-D,cells:n.map(C.NotebookCellData.from)})}}class P{constructor(D,y,n,T,k,f){this.id=D,this._proxy=y,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=k,this._visibleRanges=T,this._viewColumn=f}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.notebookDocument},get selections(){return D._selections},get visibleRanges(){return D._visibleRanges},revealRange(y,n){D._proxy.$tryRevealRange(D.id,C.NotebookRange.from(y),n!=null?n:E.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(y){const n=new I(this.document.version);return y(n),D._applyEdit(n.finalize())},get kernel(){return D._kernel},setDecorations(y,n){return D.setDecorations(y,n)}}}return this._editor}_acceptKernel(D){this._kernel=D}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const y=[];let n=-1;for(let T=0;T<D.cellEdits.length;T++){if(n<0){y.push(D.cellEdits[T]),n++;continue}const f=y[n],h=D.cellEdits[T];if(f.editType===1&&h.editType===1&&f.index===h.index){f.cells.push(...D.cellEdits[T].cells),f.count+=D.cellEdits[T].count;continue}y.push(D.cellEdits[T]),n++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,y)}setDecorations(D,y){if(!(y.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return y.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,C.NotebookRange.from(y),D.key)}}e.ExtHostNotebookEditor=P}),define(be[180],we([0,1,9,153,133,20,53]),function(Y,e,E,C,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(k){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=k}withProgress(k,f,h){const r=this._handles++,{title:a,location:p,cancellable:d}=f,b={label:(0,I.localize)(0,null,k.displayName||k.name),id:k.identifier.value};return this._proxy.$startProgress(r,{location:E.ProgressLocation.from(p),title:a,source:b,cancellable:d},k),this._withProgress(r,h,!!d)}_withProgress(k,f,h){let r;h&&(r=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(k,r));const a=d=>{this._proxy.$progressEnd(d),this._mapHandleToCancellationSource.delete(d),r&&r.dispose()};let p;try{p=f(new n(this._proxy,k),h&&r?r.token:P.CancellationToken.None)}catch(d){throw a(k),d}return p.then(d=>a(k),d=>a(k)),p}$acceptProgressCanceled(k){const f=this._mapHandleToCancellationSource.get(k);f&&(f.cancel(),this._mapHandleToCancellationSource.delete(k))}}e.ExtHostProgress=D;function y(T,k){return T.message=k.message,typeof k.increment=="number"&&(typeof T.increment=="number"?T.increment+=k.increment:T.increment=k.increment),T}class n extends C.Progress{constructor(k,f){super(h=>this.throttledReport(h));this._proxy=k,this._handle=f}throttledReport(k){this._proxy.$progressReport(this._handle,k)}}je([(0,S.throttle)(100,(T,k)=>y(T,k),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(be[97],we([0,1,42,11,55,9,7]),function(Y,e,E,C,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(f,h){const r=D._Keys.nextId();f.$registerTextEditorDecorationType(r,P.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:r,dispose(){f.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=D,D._Keys=new I.IdGenerator("TextEditorDecorationType");class y{constructor(f,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=f,this._documentVersionId=f.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(f,h){this._throwIfFinalized();let r=null;if(f instanceof S.Position)r=new S.Range(f,f);else if(f instanceof S.Range)r=f;else throw new Error("Unrecognized location");this._pushEdit(r,h,!1)}insert(f,h){this._throwIfFinalized(),this._pushEdit(new S.Range(f,f),h,!0)}delete(f){this._throwIfFinalized();let h=null;if(f instanceof S.Range)h=f;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(f,h,r){const a=this._document.validateRange(f);this._collectedEdits.push({range:a,text:h,forceMoveMarkers:r})}setEndOfLine(f){if(this._throwIfFinalized(),f!==S.EndOfLine.LF&&f!==S.EndOfLine.CRLF)throw(0,C.illegalArgument)("endOfLine");this._setEndOfLine=f}}e.TextEditorEdit=y;class n{constructor(f,h,r,a){this._proxy=f,this._id=h,this._accept(r),this._logService=a;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(d){p._setTabSize(d)},get insertSpaces(){return p._insertSpaces},set insertSpaces(d){p._setInsertSpaces(d)},get cursorStyle(){return p._cursorStyle},set cursorStyle(d){p._setCursorStyle(d)},get lineNumbers(){return p._lineNumbers},set lineNumbers(d){p._setLineNumbers(d)}}}_accept(f){this._tabSize=f.tabSize,this._insertSpaces=f.insertSpaces,this._cursorStyle=f.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(f.lineNumbers)}_validateTabSize(f){if(f==="auto")return"auto";if(typeof f=="number"){const h=Math.floor(f);return h>0?h:null}if(typeof f=="string"){const h=parseInt(f,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(f){const h=this._validateTabSize(f);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(f){return f==="auto"?"auto":f==="false"?!1:Boolean(f)}_setInsertSpaces(f){const h=this._validateInsertSpaces(f);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(f){this._cursorStyle!==f&&(this._cursorStyle=f,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:f})))}_setLineNumbers(f){this._lineNumbers!==f&&(this._lineNumbers=f,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(f)})))}assign(f){const h={};let r=!1;if(typeof f.tabSize!="undefined"){const a=this._validateTabSize(f.tabSize);a==="auto"?(r=!0,h.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,r=!0,h.tabSize=a)}if(typeof f.insertSpaces!="undefined"){const a=this._validateInsertSpaces(f.insertSpaces);a==="auto"?(r=!0,h.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,r=!0,h.insertSpaces=a)}typeof f.cursorStyle!="undefined"&&this._cursorStyle!==f.cursorStyle&&(this._cursorStyle=f.cursorStyle,r=!0,h.cursorStyle=f.cursorStyle),typeof f.lineNumbers!="undefined"&&this._lineNumbers!==f.lineNumbers&&(this._lineNumbers=f.lineNumbers,r=!0,h.lineNumbers=P.TextEditorLineNumbersStyle.from(f.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(f){f.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=n;class T{constructor(f,h,r,a,p,d,b,g){this.id=f,this._proxy=h,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new n(this._proxy,this.id,d,r),this._visibleRanges=b,this._viewColumn=g;const c=this;this.value=Object.freeze({get document(){return a.getValue()},set document(w){throw(0,C.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(w){if(!(w instanceof S.Selection))throw(0,C.illegalArgument)("selection");c._selections=[w],c._trySetSelection()},get selections(){return c._selections},set selections(w){if(!Array.isArray(w)||w.some(t=>!(t instanceof S.Selection)))throw(0,C.illegalArgument)("selections");c._selections=w,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(w){throw(0,C.readonly)("visibleRanges")},get options(){return c._options.value},set options(w){c._disposed||c._options.assign(w)},get viewColumn(){return c._viewColumn},set viewColumn(w){throw(0,C.readonly)("viewColumn")},edit(w,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new y(a.getValue(),t);return w(i),c._applyEdit(i)},insertSnippet(w,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let l;if(!t||Array.isArray(t)&&t.length===0)l=c._selections.map(s=>P.Range.from(s));else if(t instanceof S.Position){const{lineNumber:s,column:o}=P.Position.from(t);l=[{startLineNumber:s,startColumn:o,endLineNumber:s,endColumn:o}]}else if(t instanceof S.Range)l=[P.Range.from(t)];else{l=[];for(const s of t)if(s instanceof S.Range)l.push(P.Range.from(s));else{const{lineNumber:o,column:u}=P.Position.from(s);l.push({startLineNumber:o,startColumn:u,endLineNumber:o,endColumn:u})}}return h.$tryInsertSnippet(f,w.value,l,i)},setDecorations(w,t){const i=t.length===0;i&&!c._hasDecorationsForKey.has(w.key)||(i?c._hasDecorationsForKey.delete(w.key):c._hasDecorationsForKey.add(w.key),c._runOnProxy(()=>{if(P.isDecorationOptionsArr(t))return h.$trySetDecorations(f,w.key,P.fromRangeOrRangeWithMessage(t));{const l=new Array(4*t.length);for(let s=0,o=t.length;s<o;s++){const u=t[s];l[4*s]=u.start.line+1,l[4*s+1]=u.start.character+1,l[4*s+2]=u.end.line+1,l[4*s+3]=u.end.character+1}return h.$trySetDecorationsFast(f,w.key,l)}}))},revealRange(w,t){c._runOnProxy(()=>h.$tryRevealRange(f,P.Range.from(w),t||S.TextEditorRevealType.Default))},show(w){h.$tryShowEditor(f,P.ViewColumn.from(w))},hide(){h.$tryHideEditor(f)}})}dispose(){(0,E.ok)(!this._disposed),this._disposed=!0}_acceptOptions(f){(0,E.ok)(!this._disposed),this._options._accept(f)}_acceptVisibleRanges(f){(0,E.ok)(!this._disposed),this._visibleRanges=f}_acceptViewColumn(f){(0,E.ok)(!this._disposed),this._viewColumn=f}_acceptSelections(f){(0,E.ok)(!this._disposed),this._selections=f}async _trySetSelection(){const f=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,f)),this.value}_applyEdit(f){const h=f.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const r=h.edits.map(p=>p.range);r.sort((p,d)=>p.end.line===d.end.line?p.end.character===d.end.character?p.start.line===d.start.line?p.start.character-d.start.character:p.start.line-d.start.line:p.end.character-d.end.character:p.end.line-d.end.line);for(let p=0,d=r.length-1;p<d;p++){const b=r[p].end;if(r[p+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=h.edits.map(p=>({range:P.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,a,{setEndOfLine:typeof h.setEndOfLine=="number"?P.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(f){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=T}),define(be[181],we([0,1,136,25,2,3,6,14,7,10,12,9,20]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(p,d){if((0,n.isString)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let b;return Array.isArray(p.highlights)&&(b=p.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),b=b.length?b:void 0),{label:p.label,highlights:b}}}class r{constructor(d,b,g){this._proxy=d,this.commands=b,this.logService=g,this.treeViews=new Map;function c(w){return w&&w.$treeViewId&&w.$treeItemHandle}b.registerArgumentProcessor({processArgument:w=>c(w)?this.convertArgument(w):Array.isArray(w)&&w.length>0?w.map(t=>c(t)?this.convertArgument(t):t):w})}registerTreeDataProvider(d,b,g){const c=this.createTreeView(d,{treeDataProvider:b},g);return{dispose:()=>c.dispose()}}createTreeView(d,b,g){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=this._proxy.$registerTreeViewDataProvider(d,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany}),w=this.createExtHostTreeView(d,b,g);return{get onDidCollapseElement(){return w.onDidCollapseElement},get onDidExpandElement(){return w.onDidExpandElement},get selection(){return w.selectedElements},get onDidChangeSelection(){return w.onDidChangeSelection},get visible(){return w.visible},get onDidChangeVisibility(){return w.onDidChangeVisibility},get message(){return w.message},set message(t){w.message=t},get title(){return w.title},set title(t){w.title=t},get description(){return w.description},set description(t){w.description=t},reveal:(t,i)=>w.reveal(t,i),dispose:async()=>{await c,this.treeViews.delete(d),w.dispose()}}}$getChildren(d,b){const g=this.treeViews.get(d);return g?g.getChildren(b):Promise.reject(new Error((0,E.localize)(0,null,d)))}async $hasResolve(d){const b=this.treeViews.get(d);if(!b)throw new Error((0,E.localize)(1,null,d));return b.hasResolve}$resolve(d,b,g){const c=this.treeViews.get(d);if(!c)throw new Error((0,E.localize)(2,null,d));return c.resolveTreeItem(b,g)}$setExpanded(d,b,g){const c=this.treeViews.get(d);if(!c)throw new Error((0,E.localize)(3,null,d));c.setExpanded(b,g)}$setSelection(d,b){const g=this.treeViews.get(d);if(!g)throw new Error((0,E.localize)(4,null,d));g.setSelection(b)}$setVisible(d,b){const g=this.treeViews.get(d);if(!g)throw new Error((0,E.localize)(5,null,d));g.setVisible(b)}createExtHostTreeView(d,b,g){const c=new a(d,b,this._proxy,this.commands.converter,this.logService,g);return this.treeViews.set(d,c),c}convertArgument(d){const b=this.treeViews.get(d.$treeViewId);return b?b.getExtensionElement(d.$treeItemHandle):null}}e.ExtHostTreeViews=r;class a extends S.Disposable{constructor(d,b,g,c,w,t){super();if(this.viewId=d,this.proxy=g,this.commands=c,this.logService=w,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new P.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new P.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new P.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new P.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,t.contributes&&t.contributes.views)for(const s in t.contributes.views)for(const o of t.contributes.views[s])o.id===d&&(this._title=o.name);this.dataProvider=b.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let i,l;this._register(P.Event.debounce(this._onDidChangeData.event,(s,o)=>(s||(s={message:!1,elements:[]}),o.element!==!1&&(i||(i=new Promise(u=>l=u),this.refreshPromise=this.refreshPromise.then(()=>i)),s.elements.push(o.element)),o.message&&(s.message=!0),s),200,!0)(({message:s,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const u=l;return i=null,this.refresh(o).then(()=>u())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(d=>this.getExtensionElement(d)).filter(d=>!(0,n.isUndefinedOrNull)(d))}getChildren(d){const b=d?this.getExtensionElement(d):void 0;if(d&&!b)return this.logService.error(`No tree item with id '${d}' found.`),Promise.resolve([]);const g=this.getChildrenNodes(d);return(g?Promise.resolve(g):this.fetchChildrenNodes(b)).then(c=>c.map(w=>w.item))}getExtensionElement(d){return this.elements.get(d)}reveal(d,b){b=b||{select:!0,focus:!1};const g=(0,n.isUndefinedOrNull)(b.select)?!0:b.select,c=(0,n.isUndefinedOrNull)(b.focus)?!1:b.focus,w=(0,n.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.refreshPromise.then(()=>this.resolveUnknownParentChain(d)).then(t=>this.resolveTreeNode(d,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(l=>l.item)},{select:g,focus:c,expand:w})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:g,focus:c,expand:w})}get message(){return this._message}set message(d){this._message=d,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(d){this._title=d,this.proxy.$setTitle(this.viewId,d,this._description)}get description(){return this._description}set description(d){this._description=d,this.proxy.$setTitle(this.viewId,this._title,d)}setExpanded(d,b){const g=this.getExtensionElement(d);g&&(b?this._onDidExpandElement.fire(Object.freeze({element:g})):this._onDidCollapseElement.fire(Object.freeze({element:g})))}setSelection(d){(0,T.equals)(this._selectedHandles,d)||(this._selectedHandles=d,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(d){d!==this._visible&&(this._visible=d,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(d,b){var g;if(!!this.dataProvider.resolveTreeItem){const c=this.elements.get(d);if(c){const w=this.nodes.get(c);if(w){const t=(g=await this.dataProvider.resolveTreeItem(w.extensionItem,c,b))!==null&&g!==void 0?g:w.extensionItem;return w.item.tooltip=this.getTooltip(t.tooltip),w.item.command=this.getCommand(w.disposableStore,t.command),w.item}}}}resolveUnknownParentChain(d){return this.resolveParent(d).then(b=>b?this.resolveUnknownParentChain(b).then(g=>this.resolveTreeNode(b,g[g.length-1]).then(c=>(g.push(c),g))):Promise.resolve([]))}resolveParent(d){const b=this.nodes.get(d);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(d))}resolveTreeNode(d,b){const g=this.nodes.get(d);return g?Promise.resolve(g):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(c=>this.createHandle(d,c,b,!0)).then(c=>this.getChildren(b?b.item.handle:void 0).then(()=>{const w=this.getExtensionElement(c);if(w){const t=this.nodes.get(w);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(d){if(d){let b;if(typeof d=="string"){const g=this.getExtensionElement(d);b=g?this.nodes.get(g):void 0}else b=d;return b&&b.children||null}return this.roots}async fetchChildrenNodes(d){this.clearChildren(d);const b=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const g=d?this.nodes.get(d):void 0,c=await this.dataProvider.getChildren(d);if(b.token.isCancellationRequested)return[];const w=await Promise.all((0,T.coalesce)(c||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,g):null}));return b.token.isCancellationRequested?[]:(0,T.coalesce)(w)}finally{b.dispose()}}refresh(d){if(d.some(g=>!g))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const g=this.getHandlesToRefresh(d);if(g.length)return this.refreshHandles(g)}return Promise.resolve(void 0)}getHandlesToRefresh(d){const b=new Set,g=d.map(w=>this.nodes.get(w));for(const w of g)if(w&&!b.has(w.item.handle)){let t=w;for(;t&&t.parent&&g.findIndex(i=>t&&t.parent&&i&&i.item.handle===t.parent.item.handle)===-1;){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&b.add(w.item.handle)}const c=[];return b.forEach(w=>{const t=this.elements.get(w);if(t){const i=this.nodes.get(t);i&&(!i.parent||!b.has(i.parent.item.handle))&&c.push(w)}}),c}refreshHandles(d){const b={};return Promise.all(d.map(g=>this.refreshNode(g).then(c=>{c&&(b[g]=c.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(d){const b=this.getExtensionElement(d);if(b){const g=this.nodes.get(b);if(g)return this.clearChildren(b),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(c=>{if(c){const w=this.createTreeNode(b,c,g.parent);return this.updateNodeCache(b,w,g,g.parent),g.dispose(),w}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(d,b,g){const c=this.createTreeNode(d,b,g);if(b.id&&this.elements.has(c.item.handle))throw new Error((0,E.localize)(6,null,b.id));return this.addNodeToCache(d,c),this.addNodeToParentCache(c,g),c}getTooltip(d){return y.MarkdownString.isMarkdownString(d)?k.MarkdownString.from(d):d}getCommand(d,b){return b?this.commands.toInternal(b,d):void 0}createTreeNode(d,b,g){const c=new S.DisposableStore,w=this.createHandle(d,b,g),t=this.getLightIconPath(b);return{item:{handle:w,parentHandle:g?g.item.handle:void 0,label:h(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(c,b.command),contextValue:b.contextValue,icon:t,iconDark:this.getDarkIconPath(b)||t,themeIcon:this.getThemeIcon(b),collapsibleState:(0,n.isUndefinedOrNull)(b.collapsibleState)?y.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation},extensionItem:b,parent:g,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(d){return d.iconPath instanceof y.ThemeIcon?d.iconPath:void 0}createHandle(d,{id:b,label:g,resourceUri:c},w,t){if(b)return`${a.ID_HANDLE_PREFIX}/${b}`;const i=h(g,this.extension),l=w?w.item.handle:a.LABEL_HANDLE_PREFIX;let s=i?i.label:c?(0,C.basename)(c):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const o=this.nodes.has(d)?this.nodes.get(d).item.handle:void 0,u=this.getChildrenNodes(w)||[];let v,A=0;do{if(v=`${l}/${A}:${s}`,t||!this.elements.has(v)||o===v)break;A++}while(A<=u.length);return v}getLightIconPath(d){if(d.iconPath&&!(d.iconPath instanceof y.ThemeIcon))return typeof d.iconPath=="string"||I.URI.isUri(d.iconPath)?this.getIconPath(d.iconPath):this.getIconPath(d.iconPath.light)}getDarkIconPath(d){if(d.iconPath&&!(d.iconPath instanceof y.ThemeIcon)&&d.iconPath.dark)return this.getIconPath(d.iconPath.dark)}getIconPath(d){return I.URI.isUri(d)?d:I.URI.file(d)}addNodeToCache(d,b){this.elements.set(b.item.handle,d),this.nodes.set(d,b)}updateNodeCache(d,b,g,c){this.elements.delete(b.item.handle),this.nodes.delete(d),b.item.handle!==g.item.handle&&this.elements.delete(g.item.handle),this.addNodeToCache(d,b);const w=this.getChildrenNodes(c)||[],t=w.filter(i=>i.item.handle===g.item.handle)[0];t&&w.splice(w.indexOf(t),1,b)}addNodeToParentCache(d,b){b?(b.children||(b.children=[]),b.children.push(d)):(this.roots||(this.roots=[]),this.roots.push(d))}clearChildren(d){if(d){const b=this.nodes.get(d);if(b){if(b.children)for(const g of b.children){const c=this.elements.get(g.item.handle);c&&this.clear(c)}b.children=void 0}}else this.clearAll()}clear(d){const b=this.nodes.get(d);if(b){if(b.children)for(const g of b.children){const c=this.elements.get(g.item.handle);c&&this.clear(c)}this.nodes.delete(d),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(d=>d.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}a.LABEL_HANDLE_PREFIX="0",a.ID_HANDLE_PREFIX="1"}),define(be[182],we([0,1,12,14,20,10,70,9,7,96]),function(Y,e,E,C,I,P,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class T{constructor(){this.testIdsToInternal=new Map}getTestById(p,d){if(d!==void 0){const b=this.testIdsToInternal.get(d),g=b==null?void 0:b.get(p);if(g)return[b,g]}return(0,E.mapFind)(this.testIdsToInternal.values(),b=>{const g=b.get(p);return g&&[b,g]})}createForHierarchy(p=()=>{}){return new r(this.createIdMap(f++),p)}createIdMap(p){const d=new h(p);return this.testIdsToInternal.set(d.id,d),{object:d,dispose:()=>this.testIdsToInternal.delete(d.id)}}}e.OwnedTestCollection=T;var k;(function(a){a[a.Disconnected=0]="Disconnected",a[a.IsChild=1]="IsChild",a[a.IsParent=2]="IsParent",a[a.IsSame=3]="IsSame"})(k=e.TestPosition||(e.TestPosition={}));let f=0;class h{constructor(p){this.id=p,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(p){if(this.map.has(p.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${p.item.extId}`);this.map.set(p.item.extId,p),p.parent||this._roots.add(p)}has(p){return this.map.has(p)}delete(p){const d=this.map.get(p);return d?(this.map.delete(p),this._roots.delete(d),!0):!1}get(p){return this.map.get(p)}comparePositions(p,d){const b=typeof p=="string"?this.map.get(p):p,g=typeof d=="string"?this.map.get(d):d;if(!b||!g)return 0;if(b===g)return 3;for(let c=this.map.get(g.parent);c;c=this.map.get(c.parent))if(c===b)return 1;for(let c=this.map.get(b.parent);c;c=this.map.get(c.parent))if(c===g)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=h;class r{constructor(p,d){this.testIdToInternal=p,this.publishDiff=d,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new C.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(p,d){this.addItem(p,d,null)}getTestByReference(p){return this.testItemToInternal.get(p)}collectDiff(){const p=this.diff;return this.diff=[],p}pushDiff(p){const d=this.diff[this.diff.length-1];if(d&&p[0]===1){if(d[0]===1&&d[1].extId===p[1].extId){(0,n.applyTestItemUpdate)(d[1],p[1]);return}if(d[0]===0&&d[1].item.extId===p[1].extId){(0,n.applyTestItemUpdate)(d[1],p[1]);return}}this.diff.push(p),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(p,d){var b;const g=this.testIdToInternal.object.get(p);if(!!g){if((g.expandLevels===void 0||d>g.expandLevels)&&(g.expandLevels=d),g.expand===1){const c=this.refreshChildren(g);return c.isSettled?this.expandChildren(g,d-1):c.p.then(()=>this.expandChildren(g,d-1))}else if(g.expand===3)return((b=g.initialExpand)===null||b===void 0?void 0:b.isSettled)===!1?g.initialExpand.p.then(()=>this.expandChildren(g,d-1)):this.expandChildren(g,d-1)}}dispose(){var p;for(const d of this.testItemToInternal.values())(p=d.discoverCts)===null||p===void 0||p.dispose(!0),(0,S.getPrivateApiFor)(d.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(p,d){const b=p==null?void 0:p.actual.id;switch(d[0]){case 2:this.pushDiff([4,b]);break;case 1:this.removeItem(p);break;case 0:this.addItem(d[1],p.src.controller,p);break;case 3:const[g,c,w]=d;switch(c){case"status":this.updateExpandability(p);break;case"range":this.pushDiff([1,{extId:b,item:{range:D.Range.from(w)}}]);break;default:this.pushDiff([1,{extId:b,item:{[c]:w}}]);break}break;default:(0,P.assertNever)(d[0])}}addItem(p,d,b){if(!(p instanceof y.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${p.id} did not`);if(this.testItemToInternal.has(p))throw new Error(`Attempted to add a single TestItem ${p.id} multiple times to the tree`);if(this.testIdToInternal.object.has(p.id))throw new Error(`Attempted to insert a duplicate test item ID ${p.id}`);const g=b?b.item.extId:null,c=p.resolveHandler?1:0,w=b==null?void 0:b.expandLevels,t={controller:d,tree:this.testIdToInternal.object.id},i={actual:p,parent:g,item:D.TestItem.from(p),expandLevels:w?w-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(i),this.testItemToInternal.set(p,i),this.pushDiff([0,{parent:g,src:t,expand:c,item:i.item}]);const l=(0,S.getPrivateApiFor)(p);l.parent=b==null?void 0:b.actual,l.bus.event(this.onTestItemEvent.bind(this,i)),this.updateExpandability(i);for(const s of l.children.values())this.testItemToInternal.has(s)||this.addItem(s,d,i)}updateExpandability(p){var d;let b;p.actual.resolveHandler?p.actual.status===y.TestItemStatus.Pending?b=p.discoverCts?2:1:((d=p.initialExpand)===null||d===void 0||d.complete(),b=3):b=0,b!==p.expand&&(p.expand=b,this.pushDiff([1,{extId:p.actual.id,expand:b}]),b===1&&p.expandLevels!==void 0&&this.refreshChildren(p))}expandChildren(p,d){if(!(d<0)){const b=[...p.actual.children.values()].map(g=>this.expand(g.id,d)).filter(C.isThenable);if(b.length)return Promise.all(b).then(()=>{})}}refreshChildren(p){if(p.discoverCts&&p.discoverCts.dispose(!0),!p.actual.resolveHandler){const d=new C.DeferredPromise;return d.complete(),d}return p.expand=2,p.discoverCts=new I.CancellationTokenSource,this.pushExpandStateUpdate(p),p.initialExpand=new C.DeferredPromise,p.actual.resolveHandler(p.discoverCts.token),p.initialExpand}pushExpandStateUpdate(p){this.pushDiff([1,{extId:p.actual.id,expand:p.expand}])}removeItem(p){var d;this.pushDiff([2,p.actual.id]);const b=[p];for(;b.length;){const g=b.pop();if(!!g){(d=g.discoverCts)===null||d===void 0||d.dispose(!0),this.testIdToInternal.object.delete(g.item.extId),this.testItemToInternal.delete(g.actual);for(const c of g.actual.children.values())b.push(this.testIdToInternal.object.get(c.id))}}}flushDiff(){const p=this.collectDiff();p.length&&this.publishDiff(p)}}e.SingleUseTestCollection=r}),define(be[183],we([0,1,26,3,13]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=P;class S{constructor(T){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=T,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const T of this._extensionDescriptions){if(this._extensionsMap.has(E.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(E.ExtensionIdentifier.toKey(T.identifier),T),this._extensionsArr.push(T),Array.isArray(T.activationEvents))for(let k of T.activationEvents)k==="onUri"&&(k=`onUri:${E.ExtensionIdentifier.toKey(T.identifier)}`),this._activationMap.has(k)||this._activationMap.set(k,[]),this._activationMap.get(k).push(T)}}keepOnly(T){const k=new Set;T.forEach(f=>k.add(E.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>k.has(E.ExtensionIdentifier.toKey(f.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(T,k){T.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(T));const f=S._findLoopingExtensions(this._extensionDescriptions);if(k=k.concat(f.map(h=>h.identifier)),k.length>0){const h=new Set;k.forEach(r=>h.add(E.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!h.has(E.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new P(f)}static _findLoopingExtensions(T){const k=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,d){this.addNode(p),this.addNode(d),this._arcs.has(p)?this._arcs.get(p).push(d):this._arcs.set(p,[d])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,d){const b=k.getArcs(p);for(let g=0;g<b.length;g++)if(!d.has(b[g]))return!1;return!0}getNodes(){return this._nodesArr}};let f=new Map;for(let p of T){const d=E.ExtensionIdentifier.toKey(p.identifier);if(f.set(d,p),p.extensionDependencies)for(let b of p.extensionDependencies){const g=E.ExtensionIdentifier.toKey(b);k.addArc(d,g)}}let h=new Set;k.getNodes().filter(p=>k.getArcs(p).length===0).forEach(p=>h.add(p));let r=k.getNodes().filter(p=>!h.has(p)),a;do{a=!1;for(let p=0;p<r.length;p++){const d=r[p];k.hasOnlyGoodArcs(d,h)&&(r.splice(p,1),p--,h.add(d),a=!0)}}while(a);return r.map(p=>f.get(p))}containsActivationEvent(T){return this._activationMap.has(T)}containsExtension(T){return this._extensionsMap.has(E.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const k=this._activationMap.get(T);return k?k.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(T){const k=this._extensionsMap.get(E.ExtensionIdentifier.toKey(T));return k||void 0}}e.ExtensionDescriptionRegistry=S;var D;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(D||(D={}));function y(n,T){const k=n.isBuiltin?0:n.isUnderDevelopment?2:1,f=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(k!==f)return k-f;const h=I.posix.basename(n.extensionLocation.path),r=I.posix.basename(T.extensionLocation.path);return h<r?-1:h>r?1:0}}),define(be[184],we([0,1,23]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var C;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(C=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var I;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(I=e.MessageType||(e.MessageType={}));function P(D){const y=E.VSBuffer.alloc(1);switch(D){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=P;function S(D,y){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=S}),define(be[33],we([0,1,3,2,4,26,150]),function(Y,e,E,C,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");class D{constructor(b){this.dependency=b}}e.MissingDependencyError=D;var y;(function(d){d[d.LocalProcess=0]="LocalProcess",d[d.LocalWebWorker=1]="LocalWebWorker",d[d.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(b,g,c,w){this.codeLoadingTime=b,this.activateCallTime=g,this.activateResolvedTime=c,this.activationReason=w}}e.ActivationTimes=n;class T{constructor(b,g){this.description=b,this.value=g}}e.ExtensionPointContribution=T,e.ExtensionHostLogFileName="exthost";var k;(function(d){d[d.Normal=0]="Normal",d[d.Immediate=1]="Immediate"})(k=e.ActivationKind||(e.ActivationKind={}));function f(d){d.enableProposedApi||h(d)}e.checkProposedApiEnabled=f;function h(d){throw new Error(`[${d.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`)}e.throwProposedApiError=h;function r(d){return{type:d.isBuiltin?0:1,isBuiltin:d.isBuiltin||d.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(d.publisher,d.name),uuid:d.uuid},manifest:d,location:d.extensionLocation}}e.toExtension=r;function a(d){return Object.assign(Object.assign({identifier:new P.ExtensionIdentifier(d.identifier.id),isBuiltin:d.type===0,isUserBuiltin:d.type===1&&d.isBuiltin,isUnderDevelopment:!1,extensionLocation:d.location},d.manifest),{uuid:d.identifier.uuid})}e.toExtensionDescription=a;class p{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None}activateByEvent(b){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(b){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(b,g){}_activateById(b,g){return Promise.resolve()}_onWillActivateExtension(b){}_onDidActivateExtension(b,g,c,w,t){}_onExtensionRuntimeError(b,g){}_onExtensionHostExit(b){}}e.NullExtensionService=p}),define(be[185],we([0,1,131,26,33,19]),function(Y,e,E,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class D{constructor(a,p,d,b){this.startup=a,this.codeLoadingTime=p,this.activateCallTime=d,this.activateResolvedTime=b}}e.ExtensionActivationTimes=D,D.NONE=new D(!1,-1,-1,-1);class y{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,p){return a===-1||p===-1?-1:p-a}build(){return new D(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class n{constructor(a,p,d,b,g,c){this.activationFailed=a,this.activationFailedError=p,this.activationTimes=d,this.module=b,this.exports=g,this.subscriptions=c}}e.ActivatedExtension=n;class T extends n{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class k extends n{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class f extends n{constructor(a){super(!0,a,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=f;let h=class{constructor(a,p,d,b,g){this._logService=g,this._registry=a,this._resolvedExtensionsSet=new Set,p.forEach(c=>this._resolvedExtensionsSet.add(C.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,d.forEach(c=>this._hostExtensionsMap.set(C.ExtensionIdentifier.toKey(c),c)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const p=C.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(p)}getActivatedExtension(a){const p=C.ExtensionIdentifier.toKey(a),d=this._activatedExtensions.get(p);if(!d)throw new Error("Extension `"+a.value+"` is not known or not activated");return d}activateByEvent(a,p){if(this._alreadyActivatedEvents[a])return S;const d=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(d.map(b=>({id:b.identifier,reason:{startup:p,extensionId:b.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,p){const d=this._registry.getExtensionDescription(a);if(!d)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:d.identifier,reason:p}])}_handleActivateRequest(a,p,d){if(this._hostExtensionsMap.has(C.ExtensionIdentifier.toKey(a.id))){p[C.ExtensionIdentifier.toKey(a.id)]=a;return}const b=this._registry.getExtensionDescription(a.id);if(!b){this._host.onExtensionActivationError(a.id,new I.MissingDependencyError(a.id.value));const w=new Error(`Unknown dependency '${a.id.value}'`);this._activatedExtensions.set(C.ExtensionIdentifier.toKey(a.id),new f(w));return}const g=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let c=!0;for(let w=0,t=g.length;w<t;w++){const i=g[w];if(!this._resolvedExtensionsSet.has(C.ExtensionIdentifier.toKey(i))){const l=this._activatedExtensions.get(C.ExtensionIdentifier.toKey(i));if(!(l&&!l.activationFailed)){if(l&&l.activationFailed){this._host.onExtensionActivationError(b.identifier,E.localize(0,null,b.displayName||b.identifier.value,i));const u=new Error(`Dependency ${i} failed to activate`);u.detail=l.activationFailedError,this._activatedExtensions.set(C.ExtensionIdentifier.toKey(b.identifier),new f(u));return}if(this._hostExtensionsMap.has(C.ExtensionIdentifier.toKey(i))){c=!1,p[C.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(C.ExtensionIdentifier.toKey(i)),reason:a.reason};continue}const s=this._registry.getExtensionDescription(i);if(s){c=!1,p[C.ExtensionIdentifier.toKey(i)]={id:s.identifier,reason:a.reason};continue}this._host.onExtensionActivationError(b.identifier,new I.MissingDependencyError(i));const o=new Error(`Unknown dependency '${i}'`);this._activatedExtensions.set(C.ExtensionIdentifier.toKey(b.identifier),new f(o));return}}}c?p[C.ExtensionIdentifier.toKey(b.identifier)]=a:d.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(g=>!this._activatedExtensions.has(C.ExtensionIdentifier.toKey(g.id))),a.length===0))return Promise.resolve(void 0);const p=Object.create(null),d=[];for(let g=0,c=a.length;g<c;g++)this._handleActivateRequest(a[g],p,d);for(let g=0,c=d.length;g<c;g++){const w=C.ExtensionIdentifier.toKey(d[g].id);p[w]&&delete p[w]}const b=Object.keys(p).map(g=>p[g]);return d.length===0?Promise.all(b.map(g=>this._activateExtension(g.id,g.reason))).then(g=>{}):this._activateExtensions(b).then(g=>this._activateExtensions(d))}_activateExtension(a,p){const d=C.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(d))return Promise.resolve(void 0);const b=this._activatingExtensions.get(d);if(b)return b;const g=this._host.actualActivateExtension(a,p).then(void 0,c=>(this._host.onExtensionActivationError(a,E.localize(1,null,a.value,c.message)),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(c),new f(c))).then(c=>{this._activatedExtensions.set(d,c),this._activatingExtensions.delete(d)});return this._activatingExtensions.set(d,g),g}};h=je([Ke(4,P.ILogService)],h),e.ExtensionsActivator=h}),define(be[186],we([0,1,11]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class C{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((P,S)=>{this._actualOk=P,this._actualErr=S,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(P){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=P,this._actual&&this._actualOk(P))}resolveErr(P){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=P,this._actual?this._actualErr(P):(0,E.onUnexpectedError)(P))}then(P,S){return this._ensureActual().then(P,S)}catch(P){return this._ensureActual().then(void 0,P)}finally(P){return this._ensureActual().finally(P)}}e.LazyPromise=C}),define(be[98],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class E{constructor(y,n){this.isMain=y,this.sid=n,this.nid=++E.count}}e.ProxyIdentifier=E,E.count=0;const C=[];function I(D){const y=new E(!0,D);return C[y.nid]=y,y}e.createMainContextProxyIdentifier=I;function P(D){const y=new E(!1,D);return C[y.nid]=y,y}e.createExtHostContextProxyIdentifier=P;function S(D){return C[D].sid}e.getStringIdentifierForProxy=S}),define(be[5],we([0,1,2,98,58]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var P;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var S;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(S=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var n;(function(c){c[c.Markdown=1]="Markdown",c[c.Code=2]="Code"})(n=e.CellKind||(e.CellKind={}));var T;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var f;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(f=e.CandidatePortSource||(e.CandidatePortSource={}));var h;(function(c){c.name="$ident";function w(i,l){return Object.defineProperty(i,c.name,{value:l,enumerable:!0}),i}c.mixin=w;function t(i){return i[c.name]}c.of=t})(h=e.ObjectIdentifier||(e.ObjectIdentifier={}));class r{static mixin(w){return w._id=r._n++,w}}e.IdObject=r,r._n=0;var a;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n",c.label2="o"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var d;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(d=e.WorkspaceEditType||(e.WorkspaceEditType={}));function b(c){if(c&&c.edits)for(const w of c.edits)typeof w.resource=="object"?w.resource=E.URI.revive(w.resource):(w.newUri=E.URI.revive(w.newUri),w.oldUri=E.URI.revive(w.oldUri)),w.metadata&&w.metadata.iconPath&&(w.metadata=(0,I.revive)(w.metadata));return c}e.reviveWorkspaceEditDto=b;var g;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(g=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,C.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,C.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,C.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,C.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,C.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,C.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,C.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,C.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,C.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,C.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,C.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,C.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,C.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,C.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,C.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,C.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,C.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,C.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,C.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,C.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,C.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,C.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,C.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,C.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,C.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,C.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,C.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,C.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,C.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,C.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,C.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,C.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,C.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,C.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,C.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,C.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,C.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,C.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,C.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,C.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,C.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,C.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,C.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,C.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,C.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,C.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,C.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,C.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,C.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,C.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,C.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,C.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,C.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,C.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,C.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,C.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,C.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,C.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,C.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,C.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[74],we([0,1,5,3,4]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(D){this._onDidChangePassword=new C.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(E.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,y){return this._proxy.$getPassword(D,y)}store(D,y,n){return this._proxy.$setPassword(D,y,n)}delete(D,y){return this._proxy.$deletePassword(D,y)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(be[75],we([0,1,4,19,5,15]),function(Y,e,E,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,E.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(y,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(I.MainContext.MainThreadTelemetry)}report(y,n,T){const k=this.getUsageKey(y,n);this._reportedUsages.has(k)||(this._reportedUsages.add(k),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:y}))}getUsageKey(y,n){return`${y}-${n.identifier.value}`}};S=je([Ke(0,P.IExtHostRpcService),Ke(1,C.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(D,y,n){}})}),define(be[187],we([0,1,3,5,7,26]),function(Y,e,E,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new E.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new E.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(C.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,n,T,k={}){const f=P.ExtensionIdentifier.toKey(y.identifier),h=this._inFlightRequests.get(f)||[],r=T.sort().join(" ");let a=h.find(p=>p.scopes===r);if(a)return a.result;{const p=this._getSession(y,f,n,T,k);a={scopes:r,result:p},h.push(a),this._inFlightRequests.set(f,h);try{await p}finally{const d=h.findIndex(b=>b.scopes===r);d>-1&&(h.splice(d),this._inFlightRequests.set(f,h))}return p}}async _getSession(y,n,T,k,f={}){await this._proxy.$ensureProvider(T);const h=y.displayName||y.name;return this._proxy.$getSession(T,k,n,h,f)}async removeSession(y,n){const T=this._authenticationProviders.get(y);return T?T.provider.removeSession(n):this._proxy.$removeSession(y,n)}registerAuthenticationProvider(y,n,T,k){var f;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:n,provider:T,options:k!=null?k:{supportsMultipleAccounts:!1}}),this._providers.find(r=>r.id===y)||this._providers.push({id:y,label:n});const h=T.onDidChangeSessions(r=>{var a,p,d;this._proxy.$sendDidChangeSessions(y,{added:(a=r.added)!==null&&a!==void 0?a:[],changed:(p=r.changed)!==null&&p!==void 0?p:[],removed:(d=r.removed)!==null&&d!==void 0?d:[]})});return this._proxy.$registerAuthenticationProvider(y,n,(f=k==null?void 0:k.supportsMultipleAccounts)!==null&&f!==void 0?f:!1),new I.Disposable(()=>{h.dispose(),this._authenticationProviders.delete(y);const r=this._providers.findIndex(a=>a.id===y);r>-1&&this._providers.splice(r),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,n){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.createSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,n){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.removeSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,n){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.getSessions(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,n){return this._onDidChangeSessions.fire({provider:{id:y,label:n}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,n){return y.forEach(T=>{this._providers.some(k=>k.id===T.id)||this._providers.push(T)}),n.forEach(T=>{const k=this._providers.findIndex(f=>f.id===T.id);k>-1&&this._providers.splice(k)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(be[188],we([0,1,5,15,9]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(D,y){this._extHostDocumentsAndEditors=y,this._proxy=D.getProxy(E.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const y=I.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};P=je([Ke(0,C.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(be[189],we([0,1,5]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class C{constructor(P){const S=P.getProxy(E.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(D){return S.$writeText(D)}})}}e.ExtHostClipboard=C}),define(be[76],we([0,1,10,7,9,24,5,12,19,58,32,38,2,6,4,15]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let p=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(S.MainContext.MainThreadCommands),this._logService=i,this.converter=new d(this,l=>{const s=this._apiCommands.get(l);return(s==null?void 0:s.result)===g.Void?s:void 0},i),this._argumentProcessors=[{processArgument(l){return(0,n.revive)(l)}},{processArgument(l){return(0,P.cloneAndChange)(l,function(s){if(T.Range.isIRange(s))return I.Range.to(s);if(k.Position.isIPosition(s))return I.Position.to(s);if(T.Range.isIRange(s.range)&&f.URI.isUri(s.uri))return I.location.to(s);if(!Array.isArray(s))return s})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...l)=>{const s=t.args.map((u,v)=>{if(!u.validate(l[v]))throw new Error(`Invalid argument '${u.name}' when running '${t.id}', received: ${l[v]}`);return u.convert(l[v])}),o=await this.executeCommand(t.internalId,...s);return t.result.convert(o,l,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new C.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,l,s,o){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:l,thisArg:s,description:o}),t&&this._proxy.$registerCommand(i),new C.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,l){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const s=(0,P.cloneAndChange)(i,function(o){if(o instanceof C.Position)return I.Position.from(o);if(o instanceof C.Range)return I.Range.from(o);if(o instanceof C.Location)return I.location.from(o);if(!Array.isArray(o))return o});try{const o=await this._proxy.$executeCommand(t,s,l);return(0,n.revive)(o)}catch(o){if(o instanceof Error&&o.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw o}}}async _executeContributedCommand(t,i){const l=this._commands.get(t);if(!l)throw new Error("Unknown command");let{callback:s,thisArg:o,description:u}=l;if(u)for(let v=0;v<u.args.length;v++)try{(0,E.validateConstraint)(i[v],u.args[v].constraint)}catch(A){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${u.args[v].name}' - ${u.args[v].description}`)}try{return await s.apply(o,i)}catch(v){if(t===this.converter.delegatingCommandId){const A=this.converter.getActualCommand(...i);A&&(t=A.command)}throw this._logService.error(v,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(l=>this._argumentProcessors.reduce((s,o)=>o.processArgument(s),l)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(l=>l[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,l]of this._commands){let{description:s}=l;s&&(t[i]=s)}return Promise.resolve(t)}};p=je([Ke(0,a.IExtHostRpcService),Ke(1,y.ILogService)],p),e.ExtHostCommands=p,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class d{constructor(t,i,l){this._commands=t,this._lookupApiCommand=i,this._logService=l,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!!t){const l={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return l;const s=this._lookupApiCommand(t.command);if(s)l.id=s.internalId,l.arguments=s.args.map((o,u)=>o.convert(t.arguments&&t.arguments[u]));else if((0,D.isNonEmptyArray)(t.arguments)){const o=++this._cachIdPool;this._cache.set(o,t),i.add((0,h.toDisposable)(()=>{this._cache.delete(o),this._logService.trace("CommandsConverter#DISPOSE",o)})),l.$ident=o,l.id=this.delegatingCommandId,l.arguments=[o],this._logService.trace("CommandsConverter#CREATE",t.command,o)}return l}}fromInternal(t){const i=S.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=d;class b{constructor(t,i,l,s){this.name=t,this.description=i,this.validate=l,this.convert=s}optional(){return new b(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new b(t!=null?t:this.name,i!=null?i:this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",w=>f.URI.isUri(w),w=>w),b.Position=new b("position","A position in a text document",w=>C.Position.isPosition(w),I.Position.from),b.Range=new b("range","A range in a text document",w=>C.Range.isRange(w),I.Range.from),b.Selection=new b("selection","A selection in a text document",w=>C.Selection.isSelection(w),I.Selection.from),b.Number=new b("number","",w=>typeof w=="number",w=>w),b.String=new b("string","",w=>typeof w=="string",w=>w),b.CallHierarchyItem=new b("item","A call hierarchy item",w=>w instanceof C.CallHierarchyItem,I.CallHierarchyItem.to);class g{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=g,g.Void=new g("no result",w=>w);class c{constructor(t,i,l,s,o){this.id=t,this.internalId=i,this.description=l,this.args=s,this.result=o}}e.ApiCommand=c}),define(be[190],we([0,1,6,9,7,63,76,168,12,87]),function(Y,e,E,C,I,P,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",f(C.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(r,a)=>{if(!(0,y.isFalsyOrEmpty)(r)){class p extends I.SymbolInformation{static to(b){const g=new p(b.name,C.SymbolKind.to(b.kind),b.containerName||"",new I.Location(a[0],C.Range.to(b.range)));return g.detail=b.detail,g.range=g.location.range,g.selectionRange=C.Range.to(b.selectionRange),g.children=b.children?b.children.map(p.to):[],g}}return r.map(p.to)}})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(C.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(C.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(C.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",f(C.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",f(C.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(a=>I.Position.isPosition(a)),r=>r.map(C.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(a=>{let p;for(const d of a.reverse())p=new I.SelectionRange(C.Range.to(d),p);return p}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const a=[];if(Array.isArray(r))for(let p of r)a.push(...p[1].map(C.WorkspaceSymbol.to));return a})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(C.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(C.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(C.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return C.WorkspaceEdit.to(r)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(C.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new I.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const a=(0,n.decodeSemanticTokensDto)(r);if(a.type==="full")return new I.SemanticTokens(a.data,void 0)}})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new I.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const a=(0,n.decodeSemanticTokensDto)(r);if(a.type==="full")return new I.SemanticTokens(a.data,void 0)}})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,a,p)=>{if(!r)return new I.CompletionList([]);const d=r.suggestions.map(b=>C.CompletionItem.to(b,p));return new I.CompletionList(d,r.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return C.SignatureHelp.to(r)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,a,p)=>f(d=>new I.CodeLens(C.Range.to(d.range),d.command&&p.fromInternal(d.command)))(r))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>I.Range.isRange(r),r=>I.Selection.isSelection(r)?C.Selection.from(r):C.Range.from(r)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,a,p)=>f(d=>{if(d._isSynthetic){if(!d.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(d.command)}else{const b=new I.CodeAction(d.title,d.kind?new I.CodeActionKind(d.kind):void 0);return d.edit&&(b.edit=C.WorkspaceEdit.to(d.edit)),d.command&&(b.command=p.fromInternal(d.command)),b.isPreferred=d.isPreferred,b}})(r))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(a=>new I.ColorInformation(C.Range.to(a.range),C.Color.to(a.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",r=>r instanceof I.Color,C.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:C.Range.from(r.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(C.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineHint objects",r=>r.map(C.InlineHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",f(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientMetadata:r.options.transientCellMetadata,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(a=>C.NotebookExclusiveDocumentPattern.to(a))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(C.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[C.ViewColumn.from(r.viewColumn),C.TextEditorOpenOptions.from(r)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[C.ViewColumn.from(r.viewColumn),C.TextEditorOpenOptions.from(r)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[C.ViewColumn.from(r.viewColumn),C.TextEditorOpenOptions.from(r)]).optional()],S.ApiCommandResult.Void)];class k{constructor(a){this._disposables=new E.DisposableStore,this._commands=a}static register(a){return T.forEach(a.registerApiCommand,a),new k(a).registerCommands()}registerCommands(){const a=p=>(...d)=>p(this._commands,...d);this._register(D.RemoveFromRecentlyOpenedAPICommand.ID,a(D.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:p=>typeof p=="string"}]}),this._register(D.OpenIssueReporter.ID,a(D.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:p=>typeof p=="string"||typeof p=="object"&&typeof p.extensionId=="string"}]})}_register(a,p,d){const b=this._commands.registerCommand(!1,a,p,this,d);this._disposables.add(b)}}e.ExtHostApiCommands=k;function f(r){return a=>{if(Array.isArray(a))return a.map(r)}}function h(r){if(!!Array.isArray(r)){const a=[];for(const p of r)P.isLocationLink(p)?a.push(C.DefinitionLink.to(p)):a.push(C.location.to(p));return a}}}),define(be[191],we([0,1,14,53,3,6,2,63,26,9,7,5]),function(Y,e,E,C,I,P,S,D,y,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class f{constructor(c,w,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=c.getProxy(k.MainContext.MainThreadComments),w.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const l=this._commentControllers.get(i.handle);return l||i}else if(i&&i.$mid===7){const l=this._commentControllers.get(i.commentControlHandle);if(!l)return i;const s=l.getCommentThread(i.commentThreadHandle);return s||i}else if(i&&i.$mid===8){const l=this._commentControllers.get(i.thread.commentControlHandle);if(!l)return i;const s=l.getCommentThread(i.thread.commentThreadHandle);return s?{thread:s,text:i.text}:i}else if(i&&i.$mid===9){const l=this._commentControllers.get(i.thread.commentControlHandle);if(!l)return i;const s=l.getCommentThread(i.thread.commentThreadHandle);if(!s)return i;let o=i.commentUniqueId,u=s.getCommentByUniqueId(o);return u||i}else if(i&&i.$mid===10){const l=this._commentControllers.get(i.thread.commentControlHandle);if(!l)return i;const s=l.getCommentThread(i.thread.commentThreadHandle);if(!s)return i;let o=i.text,u=i.commentUniqueId,v=s.getCommentByUniqueId(u);return v?(v.body=o,v):i}return i}})}createCommentController(c,w,t){const i=f.handlePool++,l=new r(c,i,this._proxy,w,t);this._commentControllers.set(l.handle,l);const s=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(c.identifier))||[];return s.push(l),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(c.identifier),s),l}$createCommentThreadTemplate(c,w,t){const i=this._commentControllers.get(c);!i||i.$createCommentThreadTemplate(w,t)}async $updateCommentThreadTemplate(c,w,t){const i=this._commentControllers.get(c);!i||i.$updateCommentThreadTemplate(w,t)}$deleteCommentThread(c,w){const t=this._commentControllers.get(c);t&&t.$deleteCommentThread(w)}$provideCommentingRanges(c,w,t){const i=this._commentControllers.get(c);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const l=this._documents.getDocument(S.URI.revive(w));return(0,E.asPromise)(()=>i.commentingRangeProvider.provideCommentingRanges(l,t)).then(s=>s?s.map(o=>n.Range.from(o)):void 0)}$toggleReaction(c,w,t,i,l){const s=this._commentControllers.get(c);return!s||!s.reactionHandler?Promise.resolve(void 0):(0,E.asPromise)(()=>{const o=s.getCommentThread(w);if(o){const u=o.getCommentByUniqueId(i.uniqueIdInThread);if(s!==void 0&&u&&s.reactionHandler)return s.reactionHandler(u,d(l))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=f,f.handlePool=0;class h{constructor(c,w,t,i,l,s,o){this._proxy=c,this._commentController=w,this._id=t,this._uri=i,this._range=l,this._comments=s,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${w.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=s}set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const c=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),w={};c("range")&&(w.range=n.Range.from(this._range)),c("label")&&(w.label=this.label),c("contextValue")&&(w.contextValue=this.contextValue),c("comments")&&(w.comments=this._comments.map(t=>a(this,this._commentController,t,this._commentsMap))),c("collapsibleState")&&(w.collapseState=b(this._collapseState)),c("canReply")&&(w.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,w)}}getCommentByUniqueId(c){for(let w of this._commentsMap){let t=w[0],i=w[1];if(c===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}h._handlePool=0,je([(0,C.debounce)(100)],h.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=h;class r{constructor(c,w,t,i,l){this._extension=c,this._handle=w,this._proxy=t,this._id=i,this._label=l,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,l)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(c,w,t,i){if(typeof c=="string"){const l=new h(this._proxy,this,c,w,t,i,this._extension.identifier);return this._threads.set(l.handle,l),l}else{const l=new h(this._proxy,this,void 0,c,w,t,this._extension.identifier);return this._threads.set(l.handle,l),l}}$createCommentThreadTemplate(c,w){const t=new h(this._proxy,this,void 0,S.URI.revive(c),n.Range.to(w),[],this._extension.identifier);return t.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(c,w){let t=this._threads.get(c);t&&(t.range=n.Range.to(w))}$deleteCommentThread(c){let w=this._threads.get(c);w&&w.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function a(g,c,w,t){let i=t.get(w);i||(i=++g.commentHandle,t.set(w,i));const l=w.author&&w.author.iconPath?w.author.iconPath.toString():void 0;return{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:i,body:n.MarkdownString.from(w.body),userName:w.author.name,userIconPath:l,label:w.label,commentReactions:w.reactions?w.reactions.map(s=>p(s)):void 0}}function p(g){return{label:g.label,iconPath:g.iconPath?n.pathOrURIToURI(g.iconPath):void 0,count:g.count,hasReacted:g.authorHasReacted}}function d(g){return{label:g.label||"",count:g.count||0,iconPath:g.iconPath?S.URI.revive(g.iconPath):"",authorHasReacted:g.hasReacted||!1}}function b(g){if(g!==void 0)switch(g){case T.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}}),define(be[99],we([0,1,2,5,7,4,15,19,12,8,13]),function(Y,e,E,C,I,P,S,D,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class gn{constructor(h,r){this._logService=r,this._provider=new Map,this._proxy=h.getProxy(C.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,r){const a=gn._handlePool++;this._provider.set(a,{provider:h,extensionId:r}),this._proxy.$registerDecorationProvider(a,r.value);const p=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(d=>{if(!d){this._proxy.$onDidChange(a,null);return}let b=(0,y.asArray)(d);if(b.length<=gn._maxEventSize){this._proxy.$onDidChange(a,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,b.length);const g=b.map(t=>({uri:t,rank:(0,n.count)(t.path,"/")})),c=(0,y.groupBy)(g,(t,i)=>t.rank-i.rank||(0,n.compare)(t.uri.path,i.uri.path));let w=[];e:for(let t of c){let i;for(let l of t){let s=(0,T.dirname)(l.uri.path);if(i!==s&&(i=s,w.push(l.uri)>=gn._maxEventSize))break e}}this._proxy.$onDidChange(a,w)});return new I.Disposable(()=>{p==null||p.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(h,r,a){if(!this._provider.has(h))return Object.create(null);const p=Object.create(null),{provider:d,extensionId:b}=this._provider.get(h);return await Promise.all(r.map(async g=>{try{const{uri:c,id:w}=g,t=await Promise.resolve(d.provideFileDecoration(E.URI.revive(c),a));if(!t)return;try{I.FileDecoration.validate(t),p[w]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${b.value}': ${i}`)}}catch(c){this._logService.error(c)}})),p}};k._handlePool=0,k._maxEventSize=250,k=je([Ke(0,S.IExtHostRpcService),Ke(1,D.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")}),define(be[192],we([0,1,130,90,2,5,7,9,3,19,22]),function(Y,e,E,C,I,P,S,D,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class k{constructor(r,a,p,d,b){this._name=r,this._owner=a,this._maxDiagnosticsPerFile=p,this._proxy=d,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new T.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,a){if(!r){this.clear();return}this._checkDisposed();let p=[];if(I.URI.isUri(r)){if(!a){this.delete(r);return}this._data.set(r,a.slice()),p=[r]}else if(Array.isArray(r)){p=[];let b;r=[...r].sort(k._compareIndexedTuplesByUri);for(const g of r){const[c,w]=g;if((!b||c.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=c,p.push(c),this._data.set(c,[])),w){const t=this._data.get(c);t&&t.push(...w)}else{const t=this._data.get(c);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(p),!!this._proxy){const d=[];for(let b of p){let g=[];const c=this._data.get(b);if(c)if(c.length>this._maxDiagnosticsPerFile){g=[];const w=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of c)if(i.severity===w[t]&&g.push(D.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;g.push({severity:C.MarkerSeverity.Info,message:(0,E.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:g[g.length-1].startLineNumber,startColumn:g[g.length-1].startColumn,endLineNumber:g[g.length-1].endLineNumber,endColumn:g[g.length-1].endColumn})}else g=c.map(w=>D.Diagnostic.from(w));d.push([b,g])}this._proxy.$changeMany(this._owner,d)}}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,a){this._checkDisposed();for(let p of this._data.keys())r.apply(a,[p,this.get(p),this])}get(r){this._checkDisposed();const a=this._data.get(r);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,a){return r[0].toString()<a[0].toString()?-1:r[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=k;let f=class xt{constructor(r,a){this._logService=a,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,xt._debouncer,50),xt._mapper),this._proxy=r.getProxy(P.MainContext.MainThreadDiagnostics)}static _debouncer(r,a){return r?r.concat(a):a}static _mapper(r){const a=[],p=new Set;for(const d of r)typeof d=="string"?p.has(d)||(p.add(d),a.push(I.URI.parse(d))):p.has(d.toString())||(p.add(d.toString()),a.push(d));return Object.freeze(a),{uris:a}}createDiagnosticCollection(r,a){const{_collections:p,_proxy:d,_onDidChangeDiagnostics:b,_logService:g}=this,c=new class{$changeMany(i,l){d.$changeMany(i,l),g.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,i,l.length===0?"CLEARING":l)}$clear(i){d.$clear(i),g.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,i)}dispose(){d.dispose()}};let w;if(!a)a="_generated_diagnostic_collection_name_#"+xt._idPool++,w=a;else if(!p.has(a))w=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do w=a+xt._idPool++;while(p.has(w))}return new class extends k{constructor(){super(a,w,xt._maxDiagnosticsPerFile,c,b);p.set(w,this)}dispose(){super.dispose(),p.delete(w)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const a=new Map,p=[];for(const d of this._collections.values())d.forEach((b,g)=>{let c=a.get(b.toString());typeof c=="undefined"&&(c=p.length,a.set(b.toString(),c),p.push([b,[]])),p[c][1]=p[c][1].concat(...g)});return p}}_getDiagnostics(r){let a=[];for(let p of this._collections.values())p.has(r)&&(a=a.concat(p.get(r)));return a}$acceptMarkersChange(r){if(!this._mirrorCollection){const a="_generated_mirror",p=new k(a,a,xt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(a,p),this._mirrorCollection=p}for(const[a,p]of r)this._mirrorCollection.set(I.URI.revive(a),p.map(D.Diagnostic.to))}};f._idPool=0,f._maxDiagnosticsPerFile=1e3,f=je([Ke(1,n.ILogService)],f),e.ExtHostDiagnostics=f}),define(be[193],we([0,1,2,5]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(S){this._proxy=S.getProxy(C.MainContext.MainThreadDialogs)}showOpenDialog(S){return this._proxy.$showOpenDialog(S).then(D=>D?D.map(y=>E.URI.revive(y)):void 0)}showSaveDialog(S){return this._proxy.$showSaveDialog(S).then(D=>D?E.URI.revive(D):void 0)}}e.ExtHostDialogs=I}),define(be[194],we([0,1,11,2,7,5,18,20,8]),function(Y,e,E,C,I,P,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(k,f,h){this._documentsAndEditors=f,this._logService=h,this._documentContentProviders=new Map,this._proxy=k.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,f){if(Object.keys(S.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const h=n._handlePool++;this._documentContentProviders.set(h,f),this._proxy.$registerTextContentProvider(h,k);let r;return typeof f.onDidChange=="function"&&(r=f.onDidChange(a=>{if(a.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(h,a).then(p=>{if(!(!p&&typeof p!="string")){const d=this._documentsAndEditors.getDocument(a);if(!!d){const b=(0,y.splitLines)(p);if(!d.equalLines(b))return this._proxy.$onVirtualDocumentChange(a,p)}}},E.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(k,f){const h=this._documentContentProviders.get(k);return h?Promise.resolve(h.provideTextDocumentContent(C.URI.revive(f),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(be[195],we([0,1,3,6,2,5,95,9,10,24]),function(Y,e,E,C,I,P,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(f,h){this._onDidAddDocument=new E.Emitter,this._onDidRemoveDocument=new E.Emitter,this._onDidChangeDocument=new E.Emitter,this._onDidSaveDocument=new E.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new C.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const a of r)this._onDidRemoveDocument.fire(a.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const a of r)this._onDidAddDocument.fire(a.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!!f){const h=this._documentsAndEditors.getDocument(f);if(h)return h}}getDocument(f){const h=this.getDocumentData(f);if(!(h==null?void 0:h.document))throw new Error(`Unable to retrieve document from URI '${f}'`);return h.document}ensureDocumentData(f){const h=this._documentsAndEditors.getDocument(f);if(h)return Promise.resolve(h);let r=this._documentLoader.get(f.toString());return r||(r=this._proxy.$tryOpenDocument(f).then(a=>{this._documentLoader.delete(f.toString());const p=I.URI.revive(a);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(p))},a=>(this._documentLoader.delete(f.toString()),Promise.reject(a))),this._documentLoader.set(f.toString(),r)),r}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(h=>I.URI.revive(h))}$acceptModelModeChanged(f,h){const r=I.URI.revive(f),a=this._documentsAndEditors.getDocument(r);if(!a)throw new Error("unknown document");this._onDidRemoveDocument.fire(a.document),a._acceptLanguageId(h),this._onDidAddDocument.fire(a.document)}$acceptModelSaved(f){const h=I.URI.revive(f),r=this._documentsAndEditors.getDocument(h);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(f,h){const r=I.URI.revive(f),a=this._documentsAndEditors.getDocument(r);if(!a)throw new Error("unknown document");a._acceptIsDirty(h),this._onDidChangeDocument.fire({document:a.document,contentChanges:[]})}$acceptModelChanged(f,h,r){const a=I.URI.revive(f),p=this._documentsAndEditors.getDocument(a);if(!p)throw new Error("unknown document");p._acceptIsDirty(r),p.onEvents(h),this._onDidChangeDocument.fire((0,n.deepFreeze)({document:p.document,contentChanges:h.changes.map(d=>({range:D.Range.to(d.range),rangeOffset:d.rangeOffset,rangeLength:d.rangeLength,text:d.text}))}))}setWordDefinitionFor(f,h){(0,S.setWordDefinitionFor)(f,h)}}e.ExtHostDocuments=T}),define(be[39],we([0,1,42,3,6,2,4,5,95,15,97,9,19,22,18,43,107]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h,r,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class d{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(c,w){this._extHostRpc=c,this._logService=w,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new C.Emitter,this._onDidRemoveDocuments=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const w=[],t=[],i=[];if(c.removedDocuments)for(const l of c.removedDocuments){const s=P.URI.revive(l),o=this._documents.get(s);(o==null?void 0:o.unref())&&(this._documents.delete(s),w.push(o.value))}if(c.addedDocuments)for(const l of c.addedDocuments){const s=P.URI.revive(l.uri);let o=this._documents.get(s);if(o&&s.scheme!==r.Schemas.vscodeNotebookCell)throw new Error(`document '${s} already exists!'`);o||(o=new d(new y.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),s,l.lines,l.EOL,l.versionId,l.modeId,l.isDirty,l.notebook)),this._documents.set(s,o),t.push(o.value)),o.ref()}if(c.removedEditors)for(const l of c.removedEditors){const s=this._editors.get(l);this._editors.delete(l),s&&i.push(s)}if(c.addedEditors)for(const l of c.addedEditors){const s=P.URI.revive(l.documentUri);E.ok(this._documents.has(s),`document '${s}' does not exist`),E.ok(!this._editors.has(l.id),`editor '${l.id}' already exists!`);const o=this._documents.get(s).value,u=new T.ExtHostTextEditor(l.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>o.document),l.selections.map(k.Selection.to),l.options,l.visibleRanges.map(v=>k.Range.to(v)),typeof l.editorPosition=="number"?k.ViewColumn.to(l.editorPosition):void 0);this._editors.set(l.id,u)}c.newActiveEditor!==void 0&&(E.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,I.dispose)(w),(0,I.dispose)(i),c.removedDocuments&&this._onDidRemoveDocuments.fire(w),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(l=>l.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){var w;return(w=this._documents.get(c))===null||w===void 0?void 0:w.value}allDocuments(){return a.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!!this._activeEditorId){const w=this._editors.get(this._activeEditorId);return c?w:w==null?void 0:w.value}}allEditors(){return[...this._editors.values()]}};b=je([Ke(0,n.IExtHostRpcService),Ke(1,f.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[196],we([0,1,2,5,6,7,9,117,8,23]),function(Y,e,E,C,I,P,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const r=this._schemes.indexOf(h);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),r=[];let a,p,d=14,b=14;for(const g of h){let c=a?(0,y.commonPrefixLength)(a,g):0;for(c===0?p=1:p=b;c<g.length;c++)c+1===g.length?(d=b,b=9):b+=1,r.push([p,g.toUpperCase().charCodeAt(c),b]),r.push([p,g.toLowerCase().charCodeAt(c),b]),p=b;a=g,b=d}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new D.StateMachine(r)}}provideDocumentLinks(h){this._initStateMachine();const r=[],a=D.LinkComputer.computeLinks({getLineContent(p){return h.lineAt(p-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const p of a){const d=S.DocumentLink.to(p);d.target&&r.push(d)}return r}}class k{constructor(h,r){this._extHostLanguageFeatures=r,this._linkProvider=new T,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(C.MainContext.MainThreadFileSystem)}dispose(){var h;(h=this._linkProviderRegistration)===null||h===void 0||h.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,r,a,p={}){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const d=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(d,a);let b=2;p.isCaseSensitive&&(b+=1024),p.isReadonly&&(b+=2048),typeof a.copy=="function"&&(b+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&(b+=4),this._proxy.$registerFileSystemProvider(d,r,b).catch(c=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${r}`),console.error(c)});const g=a.onDidChangeFile(c=>{const w=[];for(const t of c){let{uri:i,type:l}=t;if(i.scheme===r){let s;switch(l){case P.FileChangeType.Changed:s=0;break;case P.FileChangeType.Created:s=1;break;case P.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}w.push({resource:i,type:s})}}this._proxy.$onFileSystemChange(d,w)});return(0,I.toDisposable)(()=>{g.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(d),this._proxy.$unregisterProvider(d)})}static _asIStat(h){const{type:r,ctime:a,mtime:p,size:d}=h;return{type:r,ctime:a,mtime:p,size:d}}$stat(h,r){return Promise.resolve(this._getFsProvider(h).stat(E.URI.revive(r))).then(k._asIStat)}$readdir(h,r){return Promise.resolve(this._getFsProvider(h).readDirectory(E.URI.revive(r)))}$readFile(h,r){return Promise.resolve(this._getFsProvider(h).readFile(E.URI.revive(r))).then(a=>n.VSBuffer.wrap(a))}$writeFile(h,r,a,p){return Promise.resolve(this._getFsProvider(h).writeFile(E.URI.revive(r),a.buffer,p))}$delete(h,r,a){return Promise.resolve(this._getFsProvider(h).delete(E.URI.revive(r),a))}$rename(h,r,a,p){return Promise.resolve(this._getFsProvider(h).rename(E.URI.revive(r),E.URI.revive(a),p))}$copy(h,r,a,p){const d=this._getFsProvider(h);if(!d.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(d.copy(E.URI.revive(r),E.URI.revive(a),p))}$mkdir(h,r){return Promise.resolve(this._getFsProvider(h).createDirectory(E.URI.revive(r)))}$watch(h,r,a,p){const d=this._getFsProvider(h).watch(E.URI.revive(a),p);this._watches.set(r,d)}$unwatch(h,r){const a=this._watches.get(r);a&&(a.dispose(),this._watches.delete(r))}$open(h,r,a){const p=this._getFsProvider(h);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(E.URI.revive(r),a))}$close(h,r){const a=this._getFsProvider(h);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(r))}$read(h,r,a,p){const d=this._getFsProvider(h);if(!d.read)throw new Error('FileSystemProvider does not implement "read"');const b=n.VSBuffer.alloc(p);return Promise.resolve(d.read(r,a,b.buffer,0,p)).then(g=>b.slice(0,g))}$write(h,r,a,p){const d=this._getFsProvider(h);if(!d.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(d.write(r,a,p.buffer,0,p.byteLength))}_getFsProvider(h){const r=this._fsProvider.get(h);if(!r){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return r}}e.ExtHostFileSystem=k}),define(be[77],we([0,1,5,65,7,23,4,15,49]),function(Y,e,E,C,I,P,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Ft{constructor(k,f){const h=k.getProxy(E.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return h.$stat(r).catch(Ft._handleError)},readDirectory(r){return h.$readdir(r).catch(Ft._handleError)},createDirectory(r){return h.$mkdir(r).catch(Ft._handleError)},async readFile(r){return h.$readFile(r).then(a=>a.buffer).catch(Ft._handleError)},writeFile(r,a){return h.$writeFile(r,P.VSBuffer.wrap(a)).catch(Ft._handleError)},delete(r,a){return h.$delete(r,Object.assign({recursive:!1,useTrash:!1},a)).catch(Ft._handleError)},rename(r,a,p){return h.$rename(r,a,Object.assign({overwrite:!1},p)).catch(Ft._handleError)},copy(r,a,p){return h.$copy(r,a,Object.assign({overwrite:!1},p)).catch(Ft._handleError)},isWritableFileSystem(r){const a=f.getCapabilities(r);if(typeof a=="number")return!(a&2048)}})}static _handleError(k){if(!(k instanceof Error))throw new I.FileSystemError(String(k));if(k.name==="ENOPRO")throw I.FileSystemError.Unavailable(k.message);switch(k.name){case C.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(k.message);case C.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(k.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(k.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(k.message);case C.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(k.message);case C.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(k.message);default:throw new I.FileSystemError(k.message,k.name)}}};n=je([Ke(0,D.IExtHostRpcService),Ke(1,y.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(be[197],we([0,1,6,5]),function(Y,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(S){this._handlePool=0,this._proxy=S.getProxy(C.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,S),(0,E.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=I}),define(be[198],we([0,1,2,24,9,7,14,5,8,32,12,10,114,6,87,55,69,56,11]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h,r,a,p,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class g{constructor($,G){this._documents=$,this._provider=G}provideDocumentSymbols($,G){const ie=this._documents.getDocument($);return(0,S.asPromise)(()=>this._provider.provideDocumentSymbols(ie,G)).then(oe=>{if(!(0,T.isFalsyOrEmpty)(oe))return oe[0]instanceof P.DocumentSymbol?oe.map(I.DocumentSymbol.from):g._asDocumentSymbolTree(oe)})}static _asDocumentSymbolTree($){var G;$=$.slice(0).sort((me,De)=>{let Ne=me.location.range.start.compareTo(De.location.range.start);return Ne===0&&(Ne=De.location.range.end.compareTo(me.location.range.end)),Ne});const ie=[],oe=[];for(const me of $){const De={name:me.name||"!!MISSING: name!!",kind:I.SymbolKind.from(me.kind),tags:((G=me.tags)===null||G===void 0?void 0:G.map(I.SymbolTag.from))||[],detail:"",containerName:me.containerName,range:I.Range.from(me.location.range),selectionRange:I.Range.from(me.location.range),children:[]};for(;;){if(oe.length===0){oe.push(De),ie.push(De);break}const Ne=oe[oe.length-1];if(n.Range.containsRange(Ne.range,De.range)&&!n.Range.equalsRange(Ne.range,De.range)){Ne.children&&Ne.children.push(De),oe.push(De);break}oe.pop()}}return ie}}class c{constructor($,G,ie){this._documents=$,this._commands=G,this._provider=ie,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,G){const ie=this._documents.getDocument($),oe=await this._provider.provideCodeLenses(ie,G);if(!(!oe||G.isCancellationRequested)){const me=this._cache.add(oe),De=new h.DisposableStore;this._disposables.set(me,De);const Ne={cacheId:me,lenses:[]};for(let ge=0;ge<oe.length;ge++)Ne.lenses.push({cacheId:[me,ge],range:I.Range.from(oe[ge].range),command:this._commands.toInternal(oe[ge].command,De)});return Ne}}async resolveCodeLens($,G){var ie;const oe=$.cacheId&&this._cache.get(...$.cacheId);if(!!oe){let me;if(typeof this._provider.resolveCodeLens!="function"||oe.isResolved?me=oe:me=await this._provider.resolveCodeLens(oe,G),me||(me=oe),!G.isCancellationRequested){const De=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!De)return $.command=this._commands.toInternal((ie=me.command)!==null&&ie!==void 0?ie:c._badCmd,De),$}}}releaseCodeLenses($){var G;(G=this._disposables.get($))===null||G===void 0||G.dispose(),this._disposables.delete($),this._cache.delete($)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function w(xe){return Array.isArray(xe)?xe.map(I.DefinitionLink.from):xe?[I.DefinitionLink.from(xe)]:[]}class t{constructor($,G){this._documents=$,this._provider=G}provideDefinition($,G,ie){const oe=this._documents.getDocument($),me=I.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideDefinition(oe,me,ie)).then(w)}}class i{constructor($,G){this._documents=$,this._provider=G}provideDeclaration($,G,ie){const oe=this._documents.getDocument($),me=I.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideDeclaration(oe,me,ie)).then(w)}}class l{constructor($,G){this._documents=$,this._provider=G}provideImplementation($,G,ie){const oe=this._documents.getDocument($),me=I.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideImplementation(oe,me,ie)).then(w)}}class s{constructor($,G){this._documents=$,this._provider=G}provideTypeDefinition($,G,ie){const oe=this._documents.getDocument($),me=I.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideTypeDefinition(oe,me,ie)).then(w)}}class o{constructor($,G){this._documents=$,this._provider=G}provideHover($,G,ie){const oe=this._documents.getDocument($),me=I.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideHover(oe,me,ie)).then(De=>{if(!(!De||(0,T.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=oe.getWordRangeAtPosition(me)),De.range||(De.range=new P.Range(me,me)),I.Hover.from(De)})}}class u{constructor($,G){this._documents=$,this._provider=G}provideEvaluatableExpression($,G,ie){const oe=this._documents.getDocument($),me=I.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideEvaluatableExpression(oe,me,ie)).then(De=>{if(De)return I.EvaluatableExpression.from(De)})}}class v{constructor($,G){this._documents=$,this._provider=G}provideInlineValues($,G,ie,oe){const me=this._documents.getDocument($);return(0,S.asPromise)(()=>this._provider.provideInlineValues(me,I.Range.to(G),I.InlineValueContext.to(ie),oe)).then(De=>{if(Array.isArray(De))return De.map(Ne=>I.InlineValue.from(Ne))})}}class A{constructor($,G){this._documents=$,this._provider=G}provideDocumentHighlights($,G,ie){const oe=this._documents.getDocument($),me=I.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideDocumentHighlights(oe,me,ie)).then(De=>{if(Array.isArray(De))return De.map(I.DocumentHighlight.from)})}}class m{constructor($,G){this._documents=$,this._provider=G}provideLinkedEditingRanges($,G,ie){const oe=this._documents.getDocument($),me=I.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideLinkedEditingRanges(oe,me,ie)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,T.coalesce)(De.ranges.map(I.Range.from)),wordPattern:De.wordPattern}})}}class _{constructor($,G){this._documents=$,this._provider=G}provideReferences($,G,ie,oe){const me=this._documents.getDocument($),De=I.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideReferences(me,De,ie,oe)).then(Ne=>{if(Array.isArray(Ne))return Ne.map(I.location.from)})}}class R{constructor($,G,ie,oe,me,De,Ne){this._documents=$,this._commands=G,this._diagnostics=ie,this._provider=oe,this._logService=me,this._extension=De,this._apiDeprecation=Ne,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}provideCodeActions($,G,ie,oe){const me=this._documents.getDocument($),De=f.Selection.isISelection(G)?I.Selection.to(G):I.Range.to(G),Ne=[];for(const Ce of this._diagnostics.getDiagnostics($))if(De.intersection(Ce.range)&&Ne.push(Ce)>R._maxCodeActionsPerFile)break;const ge={diagnostics:Ne,only:ie.only?new P.CodeActionKind(ie.only):void 0,triggerKind:I.CodeActionTriggerKind.to(ie.trigger)};return(0,S.asPromise)(()=>this._provider.provideCodeActions(me,De,ge,oe)).then(Ce=>{var Ae;if(!(!(0,T.isNonEmptyArray)(Ce)||oe.isCancellationRequested)){const Be=this._cache.add(Ce),_e=new h.DisposableStore;this._disposables.set(Be,_e);const qe=[];for(let j=0;j<Ce.length;j++){const te=Ce[j];!te||(R._isCommand(te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:te.title,command:this._commands.toInternal(te,_e)})):(ge.only&&(te.kind?ge.only.contains(te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[Be,j],title:te.title,command:te.command&&this._commands.toInternal(te.command,_e),diagnostics:te.diagnostics&&te.diagnostics.map(I.Diagnostic.from),edit:te.edit&&I.WorkspaceEdit.from(te.edit),kind:te.kind&&te.kind.value,isPreferred:te.isPreferred,disabled:(Ae=te.disabled)===null||Ae===void 0?void 0:Ae.reason})))}return{cacheId:Be,actions:qe}}})}async resolveCodeAction($,G){var ie;const[oe,me]=$,De=this._cache.get(oe,me);if(!(!De||R._isCommand(De))&&!!this._provider.resolveCodeAction){const Ne=(ie=await this._provider.resolveCodeAction(De,G))!==null&&ie!==void 0?ie:De;return(Ne==null?void 0:Ne.edit)?I.WorkspaceEdit.from(Ne.edit):void 0}}releaseCodeActions($){var G;(G=this._disposables.get($))===null||G===void 0||G.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}R._maxCodeActionsPerFile=1e3;class L{constructor($,G){this._documents=$,this._provider=G}provideDocumentFormattingEdits($,G,ie){const oe=this._documents.getDocument($);return(0,S.asPromise)(()=>this._provider.provideDocumentFormattingEdits(oe,G,ie)).then(me=>{if(Array.isArray(me))return me.map(I.TextEdit.from)})}}class V{constructor($,G){this._documents=$,this._provider=G}provideDocumentRangeFormattingEdits($,G,ie,oe){const me=this._documents.getDocument($),De=I.Range.to(G);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(me,De,ie,oe)).then(Ne=>{if(Array.isArray(Ne))return Ne.map(I.TextEdit.from)})}}class he{constructor($,G){this._documents=$,this._provider=G,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits($,G,ie,oe,me){const De=this._documents.getDocument($),Ne=I.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Ne,ie,oe,me)).then(ge=>{if(Array.isArray(ge))return ge.map(I.TextEdit.from)})}}class z{constructor($,G){this._provider=$,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols($,G){const ie=D.IdObject.mixin({symbols:[]});return(0,S.asPromise)(()=>this._provider.provideWorkspaceSymbols($,G)).then(oe=>{if((0,T.isNonEmptyArray)(oe)){for(const me of oe)if(!!me){if(!me.name){this._logService.warn("INVALID SymbolInformation, lacks name",me);continue}const De=D.IdObject.mixin(I.WorkspaceSymbol.from(me));this._symbolCache.set(De._id,me),ie.symbols.push(De)}}}).then(()=>(ie.symbols.length>0&&this._resultCache.set(ie._id,[ie.symbols[0]._id,ie.symbols[ie.symbols.length-1]._id]),ie))}async resolveWorkspaceSymbol($,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const ie=this._symbolCache.get($._id);if(ie){const oe=await(0,S.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ie,G));return oe&&(0,C.mixin)($,I.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols($){const G=this._resultCache.get($);if(G){for(let[ie,oe]=G;ie<=oe;ie++)this._symbolCache.delete(ie);this._resultCache.delete($)}}}class W{constructor($,G,ie){this._documents=$,this._provider=G,this._logService=ie}static supportsResolving($){return typeof $.prepareRename=="function"}provideRenameEdits($,G,ie,oe){const me=this._documents.getDocument($),De=I.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideRenameEdits(me,De,ie,oe)).then(Ne=>{if(!!Ne)return I.WorkspaceEdit.from(Ne)},Ne=>{const ge=W._asMessage(Ne);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Ne)})}resolveRenameLocation($,G,ie){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument($),me=I.Position.to(G);return(0,S.asPromise)(()=>this._provider.prepareRename(oe,me,ie)).then(De=>{let Ne,ge;if(P.Range.isRange(De)?(Ne=De,ge=oe.getText(De)):(0,k.isObject)(De)&&(Ne=De.range,ge=De.placeholder),!!Ne){if(Ne.start.line>me.line||Ne.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(Ne),text:ge}}},De=>{const Ne=W._asMessage(De);return Ne?{rejectReason:Ne,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class J{constructor($,G){this.resultId=$,this.tokens=G}}class O{constructor($,G){this._documents=$,this._provider=G,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens($,G,ie){const oe=this._documents.getDocument($),me=G!==0?this._previousResults.get(G):null;return(0,S.asPromise)(()=>me&&typeof me.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(oe,me.resultId,ie):this._provider.provideDocumentSemanticTokens(oe,ie)).then(De=>(me&&this._previousResults.delete(G),De?(De=O._fixProvidedSemanticTokens(De),this._send(O._convertToEdits(me,De),De)):null))}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return O._isSemanticTokens($)?O._isCorrectSemanticTokens($)?$:new P.SemanticTokens(new Uint32Array($.data),$.resultId):O._isSemanticTokensEdits($)?O._isCorrectSemanticTokensEdits($)?$:new P.SemanticTokensEdits($.edits.map(G=>new P.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const G of $.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,G){if(!O._isSemanticTokens(G)||!$||!$.tokens)return G;const ie=$.tokens,oe=ie.length,me=G.data,De=me.length;let Ne=0;const ge=Math.min(oe,De);for(;Ne<ge&&ie[Ne]===me[Ne];)Ne++;if(Ne===oe&&Ne===De)return new P.SemanticTokensEdits([],G.resultId);let Ce=0;const Ae=ge-Ne;for(;Ce<Ae&&ie[oe-Ce-1]===me[De-Ce-1];)Ce++;return new P.SemanticTokensEdits([{start:Ne,deleteCount:oe-Ne-Ce,data:me.subarray(Ne,De-Ce)}],G.resultId)}_send($,G){if(O._isSemanticTokens($)){const ie=this._nextResultId++;return this._previousResults.set(ie,new J($.resultId,$.data)),(0,r.encodeSemanticTokensDto)({id:ie,type:"full",data:$.data})}if(O._isSemanticTokensEdits($)){const ie=this._nextResultId++;return O._isSemanticTokens(G)?this._previousResults.set(ie,new J(G.resultId,G.data)):this._previousResults.set(ie,new J($.resultId)),(0,r.encodeSemanticTokensDto)({id:ie,type:"delta",deltas:($.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=O;class F{constructor($,G){this._documents=$,this._provider=G}provideDocumentRangeSemanticTokens($,G,ie){const oe=this._documents.getDocument($);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(oe,I.Range.to(G),ie)).then(me=>me?this._send(me):null)}_send($){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=F;class N{constructor($,G,ie,oe,me){this._documents=$,this._commands=G,this._provider=ie,this._apiDeprecation=oe,this._extension=me,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,G,ie,oe){const me=this._documents.getDocument($),De=I.Position.to(G),Ne=me.getWordRangeAtPosition(De)||new P.Range(De,De),ge=Ne.with({end:De}),Ce=new d.StopWatch(!0),Ae=await(0,S.asPromise)(()=>this._provider.provideCompletionItems(me,De,oe,I.CompletionContext.to(ie)));if(!!Ae&&!oe.isCancellationRequested){const Be=Array.isArray(Ae)?new P.CompletionList(Ae):Ae,_e=N.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),qe=new h.DisposableStore;this._disposables.set(_e,qe);const j=[],te={x:_e,b:j,a:{replace:I.Range.from(Ne),insert:I.Range.from(ge)},c:Be.isIncomplete||void 0,d:Ce.elapsed()};for(let ve=0;ve<Be.items.length;ve++){const Ue=Be.items[ve],He=this._convertCompletionItem(Ue,[_e,ve],ge,Ne);j.push(He)}return te}}async resolveCompletionItem($,G){if(typeof this._provider.resolveCompletionItem=="function"){const ie=this._cache.get(...$);if(!!ie){const oe=await(0,S.asPromise)(()=>this._provider.resolveCompletionItem(ie,G));if(!!oe)return this._convertCompletionItem(oe,$)}}}releaseCompletionItems($){var G;(G=this._disposables.get($))===null||G===void 0||G.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,G,ie,oe){var me;const De=this._disposables.get(G[0]);if(!De)throw Error("DisposableStore is missing...");const Ne={x:G,a:(me=$.label)!==null&&me!==void 0?me:"",o:$.label2,b:$.kind!==void 0?I.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(I.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:I.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal($.command,De)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ne.h=$.textEdit.newText):typeof $.insertText=="string"?Ne.h=$.insertText:$.insertText instanceof P.SnippetString&&(Ne.h=$.insertText.value,Ne.i|=4);let ge;return $.textEdit?ge=$.textEdit.range:$.range&&(ge=$.range),P.Range.isRange(ge)?Ne.j=I.Range.from(ge):ge&&(!(ie==null?void 0:ie.isEqual(ge.inserting))||!(oe==null?void 0:oe.isEqual(ge.replacing)))&&(Ne.j={insert:I.Range.from(ge.inserting),replace:I.Range.from(ge.replacing)}),Ne}}class B{constructor($,G){this._documents=$,this._provider=G,this._cache=new p.Cache("SignatureHelp")}provideSignatureHelp($,G,ie,oe){const me=this._documents.getDocument($),De=I.Position.to(G),Ne=this.reviveContext(ie);return(0,S.asPromise)(()=>this._provider.provideSignatureHelp(me,De,oe,Ne)).then(ge=>{if(ge){const Ce=this._cache.add([ge]);return Object.assign(Object.assign({},I.SignatureHelp.from(ge)),{id:Ce})}})}reviveContext($){let G;if($.activeSignatureHelp){const ie=I.SignatureHelp.to($.activeSignatureHelp),oe=this._cache.get($.activeSignatureHelp.id,0);oe?(G=oe,G.activeSignature=ie.activeSignature,G.activeParameter=ie.activeParameter):G=ie}return Object.assign(Object.assign({},$),{activeSignatureHelp:G})}releaseSignatureHelp($){this._cache.delete($)}}class U{constructor($,G){this._documents=$,this._provider=G}provideInlineHints($,G,ie){const oe=this._documents.getDocument($);return(0,S.asPromise)(()=>this._provider.provideInlineHints(oe,I.Range.to(G),ie)).then(me=>me?{hints:me.map(I.InlineHint.from)}:void 0)}}class Q{constructor($,G){this._documents=$,this._provider=G,this._cache=new p.Cache("DocumentLink")}provideLinks($,G){const ie=this._documents.getDocument($);return(0,S.asPromise)(()=>this._provider.provideDocumentLinks(ie,G)).then(oe=>{if(!(!Array.isArray(oe)||oe.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.map(I.DocumentLink.from)};{const me=this._cache.add(oe),De={links:[],id:me};for(let Ne=0;Ne<oe.length;Ne++){const ge=I.DocumentLink.from(oe[Ne]);ge.cacheId=[me,Ne],De.links.push(ge)}return De}}})}resolveLink($,G){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ie=this._cache.get(...$);return ie?(0,S.asPromise)(()=>this._provider.resolveDocumentLink(ie,G)).then(oe=>oe&&I.DocumentLink.from(oe)||void 0):Promise.resolve(void 0)}releaseLinks($){this._cache.delete($)}}class Z{constructor($,G){this._documents=$,this._provider=G}provideColors($,G){const ie=this._documents.getDocument($);return(0,S.asPromise)(()=>this._provider.provideDocumentColors(ie,G)).then(oe=>Array.isArray(oe)?oe.map(De=>({color:I.Color.from(De.color),range:I.Range.from(De.range)})):[])}provideColorPresentations($,G,ie){const oe=this._documents.getDocument($),me=I.Range.to(G.range),De=I.Color.to(G.color);return(0,S.asPromise)(()=>this._provider.provideColorPresentations(De,{document:oe,range:me},ie)).then(Ne=>{if(!!Array.isArray(Ne))return Ne.map(I.ColorPresentation.from)})}}class ne{constructor($,G){this._documents=$,this._provider=G}provideFoldingRanges($,G,ie){const oe=this._documents.getDocument($);return(0,S.asPromise)(()=>this._provider.provideFoldingRanges(oe,G,ie)).then(me=>{if(!!Array.isArray(me))return me.map(I.FoldingRange.from)})}}class pe{constructor($,G,ie){this._documents=$,this._provider=G,this._logService=ie}provideSelectionRanges($,G,ie){const oe=this._documents.getDocument($),me=G.map(I.Position.to);return(0,S.asPromise)(()=>this._provider.provideSelectionRanges(oe,me,ie)).then(De=>{if(!(0,T.isNonEmptyArray)(De))return[];if(De.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ne=[];for(let ge=0;ge<me.length;ge++){const Ce=[];Ne.push(Ce);let Ae=me[ge],Be=De[ge];for(;;){if(!Be.range.contains(Ae))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(I.SelectionRange.from(Be)),!Be.parent)break;Ae=Be.range,Be=Be.parent}}return Ne})}}class Pe{constructor($,G){this._documents=$,this._provider=G,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession($,G,ie){const oe=this._documents.getDocument($),me=I.Position.to(G),De=await this._provider.prepareCallHierarchy(oe,me,ie);if(!!De){const Ne=this._idPool.nextId();return this._cache.set(Ne,new Map),Array.isArray(De)?De.map(ge=>this._cacheAndConvertItem(Ne,ge)):[this._cacheAndConvertItem(Ne,De)]}}async provideCallsTo($,G,ie){const oe=this._itemFromCache($,G);if(!oe)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(oe,ie);if(!!me)return me.map(De=>({from:this._cacheAndConvertItem($,De.from),fromRanges:De.fromRanges.map(Ne=>I.Range.from(Ne))}))}async provideCallsFrom($,G,ie){const oe=this._itemFromCache($,G);if(!oe)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(oe,ie);if(!!me)return me.map(De=>({to:this._cacheAndConvertItem($,De.to),fromRanges:De.fromRanges.map(Ne=>I.Range.from(Ne))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,G){var ie;const oe=this._cache.get($),me={_sessionId:$,_itemId:oe.size.toString(36),name:G.name,detail:G.detail,kind:I.SymbolKind.from(G.kind),uri:G.uri,range:I.Range.from(G.range),selectionRange:I.Range.from(G.selectionRange),tags:(ie=G.tags)===null||ie===void 0?void 0:ie.map(I.SymbolTag.from)};return oe.set(me._itemId,G),me}_itemFromCache($,G){const ie=this._cache.get($);return ie==null?void 0:ie.get(G)}}class Oe{constructor($,G){this.adapter=$,this.extension=G}}class Te{constructor($,G,ie,oe,me,De,Ne){this._adapter=new Map,this._uriTransformer=G,this._proxy=$.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=ie,this._commands=oe,this._diagnostics=me,this._logService=De,this._apiDeprecation=Ne}_transformDocumentSelector($){return(0,T.coalesce)((0,T.asArray)($).map(G=>this._doTransformDocumentSelector(G)))}_doTransformDocumentSelector($){if(typeof $=="string")return{$serialized:!0,language:$};if($)return{$serialized:!0,language:$.language,scheme:this._transformScheme($.scheme),pattern:typeof $.pattern=="undefined"?void 0:I.GlobPattern.from($.pattern),exclusive:$.exclusive}}_transformScheme($){return this._uriTransformer&&typeof $=="string"?this._uriTransformer.transformOutgoingScheme($):$}_createDisposable($){return new P.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return Te._handlePool++}_withAdapter($,G,ie,oe,me=!1){const De=this._adapter.get($);if(!De)return Promise.resolve(oe);if(De.adapter instanceof G){let Ne;De.extension&&(Ne=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${G.name}'`));const ge=ie(De.adapter,De.extension),Ce=De.extension;return Ce&&Promise.resolve(ge).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Ne}ms`),Ae=>{me&&Ae instanceof b.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Ae))}),ge}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,G){const ie=this._nextHandle();return this._adapter.set(ie,new Oe($,G)),ie}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,G,ie,oe){const me=this._addNewAdapter(new g(this._documents,ie),$),De=oe&&oe.label||Te._extLabel($);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector(G),De),this._createDisposable(me)}$provideDocumentSymbols($,G,ie){return this._withAdapter($,g,oe=>oe.provideDocumentSymbols(E.URI.revive(G),ie),void 0)}registerCodeLensProvider($,G,ie){const oe=this._nextHandle(),me=typeof ie.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Oe(new c(this._documents,this._commands.converter,ie),$)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(G),me);let De=this._createDisposable(oe);if(me!==void 0){const Ne=ie.onDidChangeCodeLenses(ge=>this._proxy.$emitCodeLensEvent(me));De=P.Disposable.from(De,Ne)}return De}$provideCodeLenses($,G,ie){return this._withAdapter($,c,oe=>oe.provideCodeLenses(E.URI.revive(G),ie),void 0)}$resolveCodeLens($,G,ie){return this._withAdapter($,c,oe=>oe.resolveCodeLens(G,ie),void 0)}$releaseCodeLenses($,G){this._withAdapter($,c,ie=>Promise.resolve(ie.releaseCodeLenses(G)),void 0)}registerDefinitionProvider($,G,ie){const oe=this._addNewAdapter(new t(this._documents,ie),$);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDefinition($,G,ie,oe){return this._withAdapter($,t,me=>me.provideDefinition(E.URI.revive(G),ie,oe),[])}registerDeclarationProvider($,G,ie){const oe=this._addNewAdapter(new i(this._documents,ie),$);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDeclaration($,G,ie,oe){return this._withAdapter($,i,me=>me.provideDeclaration(E.URI.revive(G),ie,oe),[])}registerImplementationProvider($,G,ie){const oe=this._addNewAdapter(new l(this._documents,ie),$);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideImplementation($,G,ie,oe){return this._withAdapter($,l,me=>me.provideImplementation(E.URI.revive(G),ie,oe),[])}registerTypeDefinitionProvider($,G,ie){const oe=this._addNewAdapter(new s(this._documents,ie),$);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideTypeDefinition($,G,ie,oe){return this._withAdapter($,s,me=>me.provideTypeDefinition(E.URI.revive(G),ie,oe),[])}registerHoverProvider($,G,ie,oe){const me=this._addNewAdapter(new o(this._documents,ie),$);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector(G)),this._createDisposable(me)}$provideHover($,G,ie,oe){return this._withAdapter($,o,me=>me.provideHover(E.URI.revive(G),ie,oe),void 0)}registerEvaluatableExpressionProvider($,G,ie,oe){const me=this._addNewAdapter(new u(this._documents,ie),$);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector(G)),this._createDisposable(me)}$provideEvaluatableExpression($,G,ie,oe){return this._withAdapter($,u,me=>me.provideEvaluatableExpression(E.URI.revive(G),ie,oe),void 0)}registerInlineValuesProvider($,G,ie,oe){const me=typeof ie.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new v(this._documents,ie),$);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(G),me);let Ne=this._createDisposable(De);if(me!==void 0){const ge=ie.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(me));Ne=P.Disposable.from(Ne,ge)}return Ne}$provideInlineValues($,G,ie,oe,me){return this._withAdapter($,v,De=>De.provideInlineValues(E.URI.revive(G),ie,oe,me),void 0)}registerDocumentHighlightProvider($,G,ie){const oe=this._addNewAdapter(new A(this._documents,ie),$);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDocumentHighlights($,G,ie,oe){return this._withAdapter($,A,me=>me.provideDocumentHighlights(E.URI.revive(G),ie,oe),void 0)}registerLinkedEditingRangeProvider($,G,ie){const oe=this._addNewAdapter(new m(this._documents,ie),$);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideLinkedEditingRanges($,G,ie,oe){return this._withAdapter($,m,async me=>{const De=await me.provideLinkedEditingRanges(E.URI.revive(G),ie,oe);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Te._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider($,G,ie){const oe=this._addNewAdapter(new _(this._documents,ie),$);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideReferences($,G,ie,oe,me){return this._withAdapter($,_,De=>De.provideReferences(E.URI.revive(G),ie,oe,me),void 0)}registerCodeActionProvider($,G,ie,oe){var me,De;const Ne=new h.DisposableStore,ge=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,ie,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(ge,this._transformDocumentSelector(G),{providedKinds:(me=oe==null?void 0:oe.providedCodeActionKinds)===null||me===void 0?void 0:me.map(Ce=>Ce.value),documentation:(De=oe==null?void 0:oe.documentation)===null||De===void 0?void 0:De.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Ne)}))},Te._extLabel($),Boolean(ie.resolveCodeAction)),Ne.add(this._createDisposable(ge)),Ne}$provideCodeActions($,G,ie,oe,me){return this._withAdapter($,R,De=>De.provideCodeActions(E.URI.revive(G),ie,oe,me),void 0)}$resolveCodeAction($,G,ie){return this._withAdapter($,R,oe=>oe.resolveCodeAction(G,ie),void 0)}$releaseCodeActions($,G){this._withAdapter($,R,ie=>Promise.resolve(ie.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider($,G,ie){const oe=this._addNewAdapter(new L(this._documents,ie),$);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(G),$.identifier,$.displayName||$.name),this._createDisposable(oe)}$provideDocumentFormattingEdits($,G,ie,oe){return this._withAdapter($,L,me=>me.provideDocumentFormattingEdits(E.URI.revive(G),ie,oe),void 0)}registerDocumentRangeFormattingEditProvider($,G,ie){const oe=this._addNewAdapter(new V(this._documents,ie),$);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(G),$.identifier,$.displayName||$.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits($,G,ie,oe,me){return this._withAdapter($,V,De=>De.provideDocumentRangeFormattingEdits(E.URI.revive(G),ie,oe,me),void 0)}registerOnTypeFormattingEditProvider($,G,ie,oe){const me=this._addNewAdapter(new he(this._documents,ie),$);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector(G),oe,$.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits($,G,ie,oe,me,De){return this._withAdapter($,he,Ne=>Ne.provideOnTypeFormattingEdits(E.URI.revive(G),ie,oe,me,De),void 0)}registerWorkspaceSymbolProvider($,G){const ie=this._addNewAdapter(new z(G,this._logService),$);return this._proxy.$registerNavigateTypeSupport(ie),this._createDisposable(ie)}$provideWorkspaceSymbols($,G,ie){return this._withAdapter($,z,oe=>oe.provideWorkspaceSymbols(G,ie),{symbols:[]})}$resolveWorkspaceSymbol($,G,ie){return this._withAdapter($,z,oe=>oe.resolveWorkspaceSymbol(G,ie),void 0)}$releaseWorkspaceSymbols($,G){this._withAdapter($,z,ie=>ie.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider($,G,ie){const oe=this._addNewAdapter(new W(this._documents,ie,this._logService),$);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(G),W.supportsResolving(ie)),this._createDisposable(oe)}$provideRenameEdits($,G,ie,oe,me){return this._withAdapter($,W,De=>De.provideRenameEdits(E.URI.revive(G),ie,oe,me),void 0)}$resolveRenameLocation($,G,ie,oe){return this._withAdapter($,W,me=>me.resolveRenameLocation(E.URI.revive(G),ie,oe),void 0)}registerDocumentSemanticTokensProvider($,G,ie,oe){const me=this._nextHandle(),De=typeof ie.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(me,new Oe(new O(this._documents,ie),$)),this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector(G),oe,De);let Ne=this._createDisposable(me);if(De){const ge=ie.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(De));Ne=P.Disposable.from(Ne,ge)}return Ne}$provideDocumentSemanticTokens($,G,ie,oe){return this._withAdapter($,O,me=>me.provideDocumentSemanticTokens(E.URI.revive(G),ie,oe),null,!0)}$releaseDocumentSemanticTokens($,G){this._withAdapter($,O,ie=>ie.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider($,G,ie,oe){const me=this._addNewAdapter(new F(this._documents,ie),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector(G),oe),this._createDisposable(me)}$provideDocumentRangeSemanticTokens($,G,ie,oe){return this._withAdapter($,F,me=>me.provideDocumentRangeSemanticTokens(E.URI.revive(G),ie,oe),null,!0)}registerCompletionItemProvider($,G,ie,oe){const me=this._addNewAdapter(new N(this._documents,this._commands.converter,ie,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(me,this._transformDocumentSelector(G),oe,N.supportsResolving(ie),`${$.identifier.value}(${oe.join("")})`),this._createDisposable(me)}$provideCompletionItems($,G,ie,oe,me){return this._withAdapter($,N,De=>De.provideCompletionItems(E.URI.revive(G),ie,oe,me),void 0)}$resolveCompletionItem($,G,ie){return this._withAdapter($,N,oe=>oe.resolveCompletionItem(G,ie),void 0)}$releaseCompletionItems($,G){this._withAdapter($,N,ie=>ie.releaseCompletionItems(G),void 0)}registerSignatureHelpProvider($,G,ie,oe){const me=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,De=this._addNewAdapter(new B(this._documents,ie),$);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(G),me),this._createDisposable(De)}$provideSignatureHelp($,G,ie,oe,me){return this._withAdapter($,B,De=>De.provideSignatureHelp(E.URI.revive(G),ie,oe,me),void 0)}$releaseSignatureHelp($,G){this._withAdapter($,B,ie=>ie.releaseSignatureHelp(G),void 0)}registerInlineHintsProvider($,G,ie){const oe=typeof ie.onDidChangeInlineHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new U(this._documents,ie),$);this._proxy.$registerInlineHintsProvider(me,this._transformDocumentSelector(G),oe);let De=this._createDisposable(me);if(oe!==void 0){const Ne=ie.onDidChangeInlineHints(ge=>this._proxy.$emitInlineHintsEvent(oe));De=P.Disposable.from(De,Ne)}return De}$provideInlineHints($,G,ie,oe){return this._withAdapter($,U,me=>me.provideInlineHints(E.URI.revive(G),ie,oe),void 0)}registerDocumentLinkProvider($,G,ie){const oe=this._addNewAdapter(new Q(this._documents,ie),$);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(G),typeof ie.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks($,G,ie){return this._withAdapter($,Q,oe=>oe.provideLinks(E.URI.revive(G),ie),void 0)}$resolveDocumentLink($,G,ie){return this._withAdapter($,Q,oe=>oe.resolveLink(G,ie),void 0)}$releaseDocumentLinks($,G){this._withAdapter($,Q,ie=>ie.releaseLinks(G),void 0)}registerColorProvider($,G,ie){const oe=this._addNewAdapter(new Z(this._documents,ie),$);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDocumentColors($,G,ie){return this._withAdapter($,Z,oe=>oe.provideColors(E.URI.revive(G),ie),[])}$provideColorPresentations($,G,ie,oe){return this._withAdapter($,Z,me=>me.provideColorPresentations(E.URI.revive(G),ie,oe),void 0)}registerFoldingRangeProvider($,G,ie){const oe=this._nextHandle(),me=typeof ie.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Oe(new ne(this._documents,ie),$)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(G),me);let De=this._createDisposable(oe);if(me!==void 0){const Ne=ie.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));De=P.Disposable.from(De,Ne)}return De}$provideFoldingRanges($,G,ie,oe){return this._withAdapter($,ne,me=>me.provideFoldingRanges(E.URI.revive(G),ie,oe),void 0)}registerSelectionRangeProvider($,G,ie){const oe=this._addNewAdapter(new pe(this._documents,ie,this._logService),$);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideSelectionRanges($,G,ie,oe){return this._withAdapter($,pe,me=>me.provideSelectionRanges(E.URI.revive(G),ie,oe),[])}registerCallHierarchyProvider($,G,ie){const oe=this._addNewAdapter(new Pe(this._documents,ie),$);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$prepareCallHierarchy($,G,ie,oe){return this._withAdapter($,Pe,me=>Promise.resolve(me.prepareSession(E.URI.revive(G),ie,oe)),void 0)}$provideCallHierarchyIncomingCalls($,G,ie,oe){return this._withAdapter($,Pe,me=>me.provideCallsTo(G,ie,oe),void 0)}$provideCallHierarchyOutgoingCalls($,G,ie,oe){return this._withAdapter($,Pe,me=>me.provideCallsFrom(G,ie,oe),void 0)}$releaseCallHierarchy($,G){this._withAdapter($,Pe,ie=>Promise.resolve(ie.releaseSession(G)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:(0,y.regExpFlags)($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:Te._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:Te._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?Te._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?Te._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:Te._serializeRegExp($.beforeText),afterText:$.afterText?Te._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?Te._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(Te._serializeOnEnterRule)}setLanguageConfiguration($,G,ie){let{wordPattern:oe}=ie;if(oe&&(0,y.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(G,oe):this._documents.setWordDefinitionFor(G,void 0),ie.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),ie.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const me=this._nextHandle(),De={comments:ie.comments,brackets:ie.brackets,wordPattern:ie.wordPattern?Te._serializeRegExp(ie.wordPattern):void 0,indentationRules:ie.indentationRules?Te._serializeIndentationRule(ie.indentationRules):void 0,onEnterRules:ie.onEnterRules?Te._serializeOnEnterRules(ie.onEnterRules):void 0,__electricCharacterSupport:ie.__electricCharacterSupport,__characterPairSupport:ie.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,G,De),this._createDisposable(me)}$setWordDefinitions($){for(const G of $)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=Te,Te._handlePool=0}),define(be[199],we([0,1,5,9,7]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class P{constructor(D,y){this._proxy=D.getProxy(E.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(D,y){await this._proxy.$changeLanguage(D,y);const n=this._documents.getDocumentData(D);if(!n)throw new Error(`document '${D.toString}' NOT found`);return n.document}async tokenAtPosition(D,y){var n;const T=D.version,k=C.Position.from(y),f=await this._proxy.$tokensAtPosition(D.uri,k),h={type:I.StandardTokenType.Other,range:(n=D.getWordRangeAtPosition(y))!==null&&n!==void 0?n:new I.Range(y.line,y.character,y.line,y.character)};if(!f)return h;const r={range:C.Range.to(f.range),type:C.TokenType.to(f.type)};return!r.range.contains(y)||T!==D.version?h:r}}e.ExtHostLanguages=P}),define(be[200],we([0,1,5,19,33]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(D){return D&&D.title}let S=class{constructor(y,n){this._logService=n,this._proxy=y.getProxy(E.MainContext.MainThreadMessageService)}showMessage(y,n,T,k,f){const h={extension:y};let r;typeof k=="string"||P(k)?r=[k,...f]:(h.modal=k&&k.modal,h.useCustom=k&&k.useCustom,r=f),h.useCustom&&(0,I.checkProposedApiEnabled)(y);const a=[];for(let p=0;p<r.length;p++){const d=r[p];if(typeof d=="string")a.push({title:d,handle:p,isCloseAffordance:!1});else if(typeof d=="object"){let{title:b,isCloseAffordance:g}=d;a.push({title:b,isCloseAffordance:!!g,handle:p})}else this._logService.warn("Invalid message item:",d)}return this._proxy.$showMessage(n,T,h,a).then(p=>{if(typeof p=="number")return r[p]})}};S=je([Ke(1,C.ILogService)],S),e.ExtHostMessageService=S}),define(be[201],we([0,1,20,3,6,2,29,5,9,7,50,73,22,178,179,55,10,23,57,69]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h,r,a,p,d,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class c extends I.Disposable{constructor(u,v,A,m,_){super();this._editorId=u,this.uri=v,this._proxy=A,this._webviewInitData=m,this.document=_,this._onDidReceiveDocumentMessage=new C.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:R=>this._proxy.$postMessage(this._editorId,void 0,R),asWebviewUri:R=>this._asWebviewUri(R)}}onDidReceiveMessage(u,v){var A;this._onDidReceiveDocumentMessage.fire(v),u!==void 0&&((A=this._rendererIdToEmitters.get(u))===null||A===void 0||A.fire(v))}getRendererComm(u){const v=new C.Emitter;return this._rendererIdToEmitters.set(u,v),{editorId:this._editorId,onDidReceiveMessage:v.event,postMessage:A=>this._proxy.$postMessage(this._editorId,u,A),asWebviewUri:A=>this._asWebviewUri(A)}}_asWebviewUri(u){return(0,T.asWebviewUri)(this._webviewInitData,this._editorId,u)}}class w extends I.Disposable{constructor(u,v,A,m){super();this._proxy=u,this._handle=v,this._extension=A,this._provider=m,this._kernelToFriendlyId=new f.ResourceMap,this._friendlyIdToKernel=new f.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(_=>{const R=_==null?void 0:_.uri;this._proxy.$onNotebookKernelChange(this._handle,R)}))}async provideKernels(u,v){const A=await this._provider.provideKernels(u.notebookDocument,v)||[],m=new Map;let _=0;const R=new Set,L=this._kernelToFriendlyId.get(u.uri),V=A.map(z=>{var W;let J=L==null?void 0:L.get(z);return J===void 0&&(z.id&&R.has(z.id)?J=`${this._extension.identifier.value}_${z.id}_${_++}`:J=`${this._extension.identifier.value}_${z.id||S.generateUuid()}`),m.set(z,J),{id:z.id,friendlyId:J,label:z.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:z.description,detail:z.detail,isPreferred:z.isPreferred,preloads:(W=z.preloads)===null||W===void 0?void 0:W.map(O=>(P.URI.isUri(O)&&(O={uri:O,provides:[]}),{uri:O.uri,provides:typeof O.provides=="string"?[O.provides]:O.provides===void 0?[]:O.provides})),supportedLanguages:z.supportedLanguages,implementsInterrupt:!!z.interrupt}});this._kernelToFriendlyId.set(u.uri,m);const he=new Map;return m.forEach((z,W)=>{he.set(z,W)}),this._friendlyIdToKernel.set(u.uri,he),V}getKernelByFriendlyId(u,v){var A;return(A=this._friendlyIdToKernel.get(u))===null||A===void 0?void 0:A.get(v)}async resolveNotebook(u,v,A,m){var _;const R=(_=this._friendlyIdToKernel.get(v.uri))===null||_===void 0?void 0:_.get(u);if(R&&this._provider.resolveKernel)return this._provider.resolveKernel(R,v.notebookDocument,A,m)}async executeNotebook(u,v,A){var m;const _=(m=this._friendlyIdToKernel.get(v.uri))===null||m===void 0?void 0:m.get(u);if(!!_){const R=A.map(L=>y.NotebookRange.to(L));return _.executeCellsRequest(v.notebookDocument,R)}}async interruptNotebookExecution(u,v){var A;const m=(A=this._friendlyIdToKernel.get(v.uri))===null||A===void 0?void 0:A.get(u);if(!(!m||!m.interrupt))return m.interrupt(v.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=w;class t{constructor(u,v){const A=t._Keys.nextId();u.$registerNotebookEditorDecorationType(A,y.NotebookDecorationRenderOptions.from(v)),this.value={key:A,dispose(){u.$removeNotebookEditorDecorationType(A)}}}}e.NotebookEditorDecorationType=t,t._Keys=new a.IdGenerator("NotebookEditorDecorationType");class i{constructor(u,v,A,m,_,R,L){this._textDocumentsAndEditors=A,this._textDocuments=m,this._webviewInitData=_,this.logService=R,this._extensionStoragePaths=L,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new f.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new C.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new C.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new C.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new C.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new C.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new C.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new C.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new C.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new C.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new C.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new C.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new C.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new C.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new f.ResourceMap,this._statusBarCache=new g.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=u.getProxy(D.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=u.getProxy(D.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=u.getProxy(D.MainContext.MainThreadNotebookEditors),this._commandsConverter=v.converter,v.registerArgumentProcessor({processArgument:V=>{var he;if(V&&V.$mid===12){const z=(he=V.notebookEditor)===null||he===void 0?void 0:he.notebookUri,W=V.cell.handle,J=this._documents.get(z),O=J==null?void 0:J.getCell(W);if(O)return O.cell}return V}})}get activeNotebookEditor(){var u;return(u=this._activeNotebookEditor)===null||u===void 0?void 0:u.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(u=>u.apiEditor)}getEditorById(u){return this._editors.get(u)}getIdByEditor(u){for(const[v,A]of this._editors)if(A.apiEditor===u)return v}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(u){return this._documents.get(u)}_getNotebookDocument(u){const v=this._documents.get(u);if(!v)throw new Error(`NO notebook document for '${u}'`);return v}_getProviderData(u){const v=this._notebookContentProviders.get(u);if(!v)throw new Error(`NO provider for '${u}'`);return v}registerNotebookContentProvider(u,v,A,m){var _,R,L;if(this._notebookContentProviders.has(v))throw new Error(`Notebook provider for '${v}' already registered`);this._notebookContentProviders.set(v,{extension:u,provider:A});let V;A.onDidChangeNotebookContentOptions&&(V=A.onDidChangeNotebookContentOptions(()=>{const W=y.NotebookDocumentContentOptions.from(A.options);this._notebookProxy.$updateNotebookProviderOptions(v,W)}));const he=(_=m==null?void 0:m.viewOptions)===null||_===void 0?void 0:_.filenamePattern.map(W=>y.NotebookExclusiveDocumentPattern.from(W)).filter(W=>W!==void 0);((R=m==null?void 0:m.viewOptions)===null||R===void 0?void 0:R.filenamePattern)&&!he&&console.warn(`Notebook content provider view options file name pattern is invalid ${(L=m==null?void 0:m.viewOptions)===null||L===void 0?void 0:L.filenamePattern}`);const z=y.NotebookDocumentContentOptions.from(m);return this._notebookProxy.$registerNotebookProvider({id:u.identifier,location:u.extensionLocation,description:u.description},v,{transientOutputs:z.transientOutputs,transientCellMetadata:z.transientCellMetadata,transientDocumentMetadata:z.transientDocumentMetadata,viewOptions:(m==null?void 0:m.viewOptions)&&he?{displayName:m.viewOptions.displayName,filenamePattern:he,exclusive:m.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{V==null||V.dispose(),this._notebookContentProviders.delete(v),this._notebookProxy.$unregisterNotebookProvider(v)})}registerNotebookKernelProvider(u,v,A){const m=i._notebookKernelProviderHandlePool++,_=new w(this._notebookProxy,m,u,A);return this._notebookKernelProviders.set(m,_),this._notebookProxy.$registerNotebookKernelProvider({id:u.identifier,location:u.extensionLocation,description:u.description},m,{viewType:v.viewType,filenamePattern:v.filenamePattern?y.NotebookExclusiveDocumentPattern.from(v.filenamePattern):void 0}),new n.Disposable(()=>{_.dispose(),this._notebookKernelProviders.delete(m),this._notebookProxy.$unregisterNotebookKernelProvider(m)})}registerNotebookCellStatusBarItemProvider(u,v,A){const m=i._notebookStatusBarItemProviderHandlePool++,_=typeof A.onDidChangeCellStatusBarItems=="function"?i._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(m,A),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(m,_,{viewType:v.viewType,filenamePattern:v.filenamePattern?y.NotebookExclusiveDocumentPattern.from(v.filenamePattern):void 0});let R;return _!==void 0&&(R=A.onDidChangeCellStatusBarItems(L=>this._notebookProxy.$emitCellStatusBarEvent(_))),new n.Disposable(()=>{this._notebookStatusBarItemProviders.delete(m),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(m,_),R&&R.dispose()})}createNotebookEditorDecorationType(u){return new t(this._notebookEditorsProxy,u).value}async openNotebookDocument(u){const v=this._documents.get(u);if(v)return v.notebookDocument;const A=await this._notebookDocumentsProxy.$tryOpenDocument(u),m=this._documents.get(P.URI.revive(A));return(0,p.assertIsDefined)(m==null?void 0:m.notebookDocument)}_withAdapter(u,v,A){const m=this._documents.get(P.URI.revive(v));if(!m)return[];const _=this._notebookKernelProviders.get(u);return _?A(_,m):[]}async showNotebookDocument(u,v){var A;P.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let m;typeof v=="object"?m={position:y.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(y.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0}:m={preserveFocus:!1};const _=await this._notebookEditorsProxy.$tryShowNotebookDocument(u.uri,u.viewType,m),R=_&&((A=this._editors.get(_))===null||A===void 0?void 0:A.apiEditor);if(R)return R;throw _?new Error(`Could NOT open editor for "${u.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.toString()}".`)}async $provideNotebookKernels(u,v,A){return this._withAdapter(u,v,(m,_)=>m.provideKernels(_,A))}async $resolveNotebookKernel(u,v,A,m,_){await this._withAdapter(u,A,async(R,L)=>{const V=this._webviewComm.get(v);V&&await R.resolveNotebook(m,L,V.contentProviderComm,_)})}async $provideNotebookCellStatusBarItems(u,v,A,m){var _;const R=this._notebookStatusBarItemProviders.get(u),L=P.URI.revive(v),V=this._documents.get(L);if(!(!V||!R)){const he=V.getCellFromIndex(A);if(!!he){const z=await R.provideCellStatusBarItems(he.cell,m);if(!!z){const W=new I.DisposableStore,J=this._statusBarCache.add([W]),O=(_=z&&z.map(F=>y.NotebookStatusBarItem.from(F,this._commandsConverter,W)))!==null&&_!==void 0?_:void 0;return{cacheId:J,items:O}}}}}$releaseNotebookCellStatusBarItems(u){this._statusBarCache.delete(u)}async $resolveNotebookEditor(u,v,A){const m=this._notebookContentProviders.get(u),_=P.URI.revive(v),R=this._documents.get(_);if(!(!R||!m)){let L=this._webviewComm.get(A);L||(L=new c(A,_,this._notebookProxy,this._webviewInitData,R),this._webviewComm.set(A,L))}}async $executeNotebookKernelFromProvider(u,v,A,m){await this._withAdapter(u,v,async(_,R)=>_.executeNotebook(A,R,m))}registerNotebookSerializer(u,v,A,m){const _=this._handlePool++;this._notebookSerializer.set(_,A);const R=y.NotebookDocumentContentOptions.from(m);return this._notebookProxy.$registerNotebookSerializer(_,{id:u.identifier,location:u.extensionLocation,description:u.description},v,R),(0,I.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(_)})}async $dataToNotebook(u,v,A){const m=this._notebookSerializer.get(u);if(!m)throw new Error("NO serializer found");const _=await m.deserializeNotebook(v.buffer,A);return{metadata:y.NotebookDocumentMetadata.from(_.metadata),cells:_.cells.map(y.NotebookCellData.from)}}async $notebookToData(u,v,A){const m=this._notebookSerializer.get(u);if(!m)throw new Error("NO serializer found");const _=await m.serializeNotebook({metadata:y.NotebookDocumentMetadata.to(v.metadata),cells:v.cells.map(y.NotebookCellData.to)},A);return d.VSBuffer.wrap(_)}async $cancelNotebookCellExecution(u,v,A,m){await this._withAdapter(u,v,async(R,L)=>R.interruptNotebookExecution(A,L));const _=this._documents.get(P.URI.revive(v));if(!!_)for(let R of m)for(let L=R.start;L<R.end;L++){const V=_.getCellFromIndex(L);V&&this.cancelOneNotebookCellExecution(V)}}cancelOneNotebookCellExecution(u){const v=this._activeExecutions.get(u.uri);v==null||v.cancel()}async $openNotebook(u,v,A,m,_){const{provider:R}=this._getProviderData(u),L=await R.openNotebook(P.URI.revive(v),{backupId:A,untitledDocumentData:m==null?void 0:m.buffer},_);return{metadata:y.NotebookDocumentMetadata.from(L.metadata),cells:L.cells.map(y.NotebookCellData.from)}}async $saveNotebook(u,v,A){const m=this._getNotebookDocument(P.URI.revive(v)),{provider:_}=this._getProviderData(u);return await _.saveNotebook(m.notebookDocument,A),!0}async $saveNotebookAs(u,v,A,m){const _=this._getNotebookDocument(P.URI.revive(v)),{provider:R}=this._getProviderData(u);return await R.saveNotebookAs(P.URI.revive(A),_.notebookDocument,m),!0}async $backupNotebook(u,v,A){var m;const _=this._getNotebookDocument(P.URI.revive(v)),R=this._getProviderData(u),L=(m=this._extensionStoragePaths.workspaceValue(R.extension))!==null&&m!==void 0?m:this._extensionStoragePaths.globalValue(R.extension),V=String((0,b.hash)([_.uri.toString(),this._backupIdPool++])),he=P.URI.joinPath(L,V),z=await R.provider.backupNotebook(_.notebookDocument,{destination:he},A);return _.updateBackup(z),z.id}$acceptNotebookActiveKernelChange(u){u.providerHandle!==void 0&&this._withAdapter(u.providerHandle,u.uri,async(v,A)=>{const m=u.kernelFriendlyId?v.getKernelByFriendlyId(P.URI.revive(u.uri),u.kernelFriendlyId):void 0;this._editors.forEach(_=>{_.notebookData===A&&_._acceptKernel(m)}),this._onDidChangeActiveNotebookKernel.fire({document:A.notebookDocument,kernel:m})})}$onDidReceiveMessage(u,v,A){var m;(m=this._webviewComm.get(u))===null||m===void 0||m.onDidReceiveMessage(v,A)}$acceptModelChanged(u,v,A){this._getNotebookDocument(P.URI.revive(u)).acceptModelChanged(v,A)}$acceptDirtyStateChanged(u,v){const A=this._getNotebookDocument(P.URI.revive(u));A.acceptModelChanged({rawEvents:[],versionId:A.notebookDocument.version},v)}$acceptModelSaved(u){const v=this._getNotebookDocument(P.URI.revive(u));this._onDidSaveNotebookDocument.fire(v.notebookDocument)}$acceptEditorPropertiesChanged(u,v){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",u,v);const A=this._editors.get(u);if(!A)throw new Error(`unknown text editor: ${u}. known editors: ${[...this._editors.keys()]} `);v.visibleRanges&&A._acceptVisibleRanges(v.visibleRanges.ranges.map(y.NotebookRange.to)),v.selections&&A._acceptSelections(v.selections.selections.map(y.NotebookRange.to)),v.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),v.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(u){for(const v in u){const A=this._editors.get(v);if(!A)throw new Error(`unknown text editor: ${v}. known editors: ${[...this._editors.keys()]} `);A._acceptViewColumn(y.ViewColumn.to(u[v]))}}$acceptDocumentPropertiesChanged(u,v){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",u.path,v);const A=this._getNotebookDocument(P.URI.revive(u));A.acceptDocumentPropertiesChanged(v),v.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:A.notebookDocument})}_createExtHostEditor(u,v,A){if(this._editors.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const m=u.uri;let _=this._webviewComm.get(v);_||(_=new c(v,m,this._notebookProxy,this._webviewInitData,u),this._webviewComm.set(v,_));const R=new r.ExtHostNotebookEditor(v,this._notebookEditorsProxy,u,A.visibleRanges.map(y.NotebookRange.to),A.selections.map(y.NotebookRange.to),typeof A.viewColumn=="number"?y.ViewColumn.to(A.viewColumn):void 0);this._editors.set(v,R)}$acceptDocumentAndEditorsDelta(u){var v,A,m;if(u.removedDocuments)for(const R of u.removedDocuments){const L=P.URI.revive(R),V=this._documents.get(L);V&&(V.dispose(),this._documents.delete(L),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:V.notebookDocument.getCells().map(he=>he.document.uri)}),this._onDidCloseNotebookDocument.fire(V.notebookDocument));for(const he of this._editors.values())he.notebookData.uri.toString()===L.toString()&&this._editors.delete(he.id)}if(u.addedDocuments){const R=[];for(const L of u.addedDocuments){const V=P.URI.revive(L.uri),he=L.viewType;if(this._documents.has(V))throw new Error(`adding EXISTING notebook ${V} `);const z=this,W=new h.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(J){z._onDidChangeNotebookCells.fire(J)},emitCellOutputsChange(J){z._onDidChangeCellOutputs.fire(J)},emitCellMetadataChange(J){z._onDidChangeCellMetadata.fire(J)},emitCellExecutionStateChange(J){z._onDidChangeCellExecutionState.fire(J)}},he,L.metadata?y.NotebookDocumentMetadata.to(L.metadata):new n.NotebookDocumentMetadata,V);W.acceptModelChanged({versionId:L.versionId,rawEvents:[{kind:k.NotebookCellsChangeType.Initialize,changes:[[0,0,L.cells]]}]},!1),R.push(...L.cells.map(J=>h.ExtHostCell.asModelAddData(W.notebookDocument,J))),(v=this._documents.get(V))===null||v===void 0||v.dispose(),this._documents.set(V,W),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:R}),this._onDidOpenNotebookDocument.fire(W.notebookDocument)}}if(u.addedEditors)for(const R of u.addedEditors){if(this._editors.has(R.id))return;const L=P.URI.revive(R.documentUri),V=this._documents.get(L);V&&this._createExtHostEditor(V,R.id,R)}const _=[];if(u.removedEditors)for(const R of u.removedEditors){const L=this._editors.get(R);L&&(this._editors.delete(R),((A=this._activeNotebookEditor)===null||A===void 0?void 0:A.id)===L.id&&(this._activeNotebookEditor=void 0),_.push(L))}if(u.visibleEditors){this._visibleNotebookEditors=u.visibleEditors.map(L=>this._editors.get(L)).filter(L=>!!L);const R=new Set;this._visibleNotebookEditors.forEach(L=>R.add(L.id));for(const L of this._editors.values()){const V=R.has(L.id);L._acceptVisibility(V)}this._visibleNotebookEditors=[...this._editors.values()].map(L=>L).filter(L=>L.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}u.newActiveEditor===null?this._activeNotebookEditor=void 0:u.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(u.newActiveEditor)),u.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((m=this._activeNotebookEditor)===null||m===void 0?void 0:m.apiEditor)}createNotebookCellExecution(u,v,A){const m=this.lookupNotebookDocument(u);if(!m)throw new Error(`Invalid cell uri / index: ${u}, ${v} `);const _=m.getCellFromIndex(v);if(!_)throw new Error(`Invalid cell uri / index: ${u}, ${v} `);if(!this._activeExecutions.has(_.uri)){const R=new s(u,m,_,this._notebookDocumentsProxy);this._activeExecutions.set(_.uri,R);const L=R.onDidChangeState(()=>{R.state===l.Resolved&&(R.dispose(),L.dispose(),this._activeExecutions.delete(_.uri))});return R.asApiObject()}}}e.ExtHostNotebookController=i,i._notebookKernelProviderHandlePool=0,i._notebookStatusBarItemProviderHandlePool=0;var l;(function(o){o[o.Init=0]="Init",o[o.Started=1]="Started",o[o.Resolved=2]="Resolved"})(l||(l={}));class s extends I.Disposable{constructor(u,v,A,m){super();this._uri=u,this._document=v,this._cell=A,this._proxy=m,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=l.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._executionOrder=A.internalMetadata.executionOrder,this.mixinMetadata({runState:n.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(u){return this._proxy.$applyEdits(this._uri,u,!1)}verifyStateForOutput(){if(this._state===l.Init)throw new Error("Must call start before modifying cell output");if(this._state===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(u){const v=[{editType:11,handle:this._cell.handle,metadata:u}];this.applyEdits(v)}cellIndexToHandle(u){const v=typeof u=="number"?this._document.getCellFromIndex(u):this._cell;if(!!v)return v.handle}asApiObject(){const u=this;return Object.freeze({get document(){return u._document.notebookDocument},get cell(){return u._cell.cell},get executionOrder(){return u._executionOrder},set executionOrder(v){u._executionOrder=v,u.mixinMetadata({executionOrder:v})},start(v){if(u._state===l.Resolved||u._state===l.Started)throw new Error("Cannot call start again");u._state=l.Started,u._onDidChangeState.fire(),u.mixinMetadata({runState:n.NotebookCellExecutionState.Executing,runStartTime:v==null?void 0:v.startTime})},end(v){var A,m;if(u._state===l.Resolved)throw new Error("Cannot call resolve twice");u._state=l.Resolved,u._onDidChangeState.fire(),u.mixinMetadata({runState:n.NotebookCellExecutionState.Idle,lastRunSuccess:(A=v==null?void 0:v.success)!==null&&A!==void 0?A:null,runEndTime:(m=v==null?void 0:v.endTime)!==null&&m!==void 0?m:null})},clearOutput(v){return u.verifyStateForOutput(),this.replaceOutput([],v)},async appendOutput(v,A){u.verifyStateForOutput();const m=u.cellIndexToHandle(A);if(typeof m=="number")return v=Array.isArray(v)?v:[v],u.applyEdits([{editType:2,handle:m,append:!0,outputs:v.map(y.NotebookCellOutput.from)}])},async replaceOutput(v,A){u.verifyStateForOutput();const m=u.cellIndexToHandle(A);if(typeof m=="number")return v=Array.isArray(v)?v:[v],u.applyEdits([{editType:2,handle:m,outputs:v.map(y.NotebookCellOutput.from)}])},async appendOutputItems(v,A){return u.verifyStateForOutput(),v=Array.isArray(v)?v:[v],u.applyEdits([{editType:10,append:!0,items:v.map(y.NotebookCellOutputItem.from),outputId:A}])},async replaceOutputItems(v,A){return u.verifyStateForOutput(),v=Array.isArray(v)?v:[v],u.applyEdits([{editType:10,items:v.map(y.NotebookCellOutputItem.from),outputId:A}])},token:u._tokenSource.token})}}}),define(be[202],we([0,1,3,6,5,2,9,12,50]),function(Y,e,E,C,I,P,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class n{constructor(k,f,h){this._initData=f,this._extHostNotebook=h,this._kernelData=new Map,this._handlePool=0,this._proxy=k.getProxy(I.MainContext.MainThreadNotebookKernels)}createNotebookController(k,f,h,r,a,p){for(let _ of this._kernelData.values())if(_.controller.id===f)throw new Error(`notebook controller with id '${f}' ALREADY exist`);const d=this._handlePool++,b=this,g=["plaintext"],c=()=>console.warn(`NO execute handler from notebook controller '${s.id}' of extension: '${k.identifier}'`);let w=!1;const t=new C.DisposableStore,i=new E.Emitter,l=new E.Emitter,s={id:f,selector:h,extensionId:k.identifier,extensionLocation:k.extensionLocation,label:r||k.identifier.value,supportedLanguages:g,preloads:p?p.map(S.NotebookKernelPreload.from):[]};let o=a!=null?a:c,u;this._proxy.$addKernel(d,s).catch(_=>{console.log(_),w=!0});let v=0;const A=()=>{if(!w){const _=++v;Promise.resolve().then(()=>{_===v&&this._proxy.$updateKernel(d,s)})}},m={get id(){return s.id},get selector(){return s.selector},onDidChangeNotebookAssociation:i.event,get label(){return s.label},set label(_){var R;s.label=(R=_!=null?_:k.displayName)!==null&&R!==void 0?R:k.name,A()},get description(){var _;return(_=s.description)!==null&&_!==void 0?_:""},set description(_){s.description=_,A()},get isPreferred(){var _;return(_=s.isPreferred)!==null&&_!==void 0?_:!1},set isPreferred(_){s.isPreferred=_,A()},get supportedLanguages(){return s.supportedLanguages},set supportedLanguages(_){s.supportedLanguages=(0,D.isNonEmptyArray)(_)?_:g,A()},get hasExecutionOrder(){var _;return(_=s.hasExecutionOrder)!==null&&_!==void 0?_:!1},set hasExecutionOrder(_){s.hasExecutionOrder=_,A()},get preloads(){return s.preloads?s.preloads.map(S.NotebookKernelPreload.to):[]},get executeHandler(){return o},set executeHandler(_){o=_!=null?_:c},get interruptHandler(){return u},set interruptHandler(_){u=_,s.supportsInterrupt=Boolean(_),A()},createNotebookCellExecutionTask(_){if(w)throw new Error("notebook controller is DISPOSED");return b._extHostNotebook.createNotebookCellExecution(_.notebook.uri,_.index,s.id)},dispose:()=>{w||(w=!0,this._kernelData.delete(d),t.dispose(),i.dispose(),l.dispose(),this._proxy.$removeKernel(d))},onDidReceiveMessage:l.event,postMessage(_,R){return b._proxy.$postMessage(d,R&&b._extHostNotebook.getIdByEditor(R),_)},asWebviewUri(_){return(0,y.asWebviewUri)(b._initData.environment,s.id,_)}};return this._kernelData.set(d,{extensionId:k.identifier,controller:m,onDidChangeSelection:i,onDidReceiveMessage:l}),m}$acceptSelection(k,f,h){const r=this._kernelData.get(k);r&&r.onDidChangeSelection.fire({selected:h,notebook:this._extHostNotebook.lookupNotebookDocument(P.URI.revive(f)).notebookDocument})}$executeCells(k,f,h){const r=this._kernelData.get(k);if(!!r){const a=this._extHostNotebook.lookupNotebookDocument(P.URI.revive(f));if(!a)throw new Error("MISSING notebook");const p=[];for(let d of h)p.push(...a.notebookDocument.getCells(S.NotebookRange.to(d)));try{r.controller.executeHandler.call(r.controller,p,r.controller)}catch(d){console.error(d)}}}$cancelCells(k,f,h){const r=this._kernelData.get(k);if(!!r){const a=this._extHostNotebook.lookupNotebookDocument(P.URI.revive(f));if(!a)throw new Error("MISSING notebook");r.controller.interruptHandler&&r.controller.interruptHandler.call(r.controller);for(const p of h)for(let d=p.start;d<p.end;d++){const b=a.getCellFromIndex(d);b&&this._extHostNotebook.cancelOneNotebookCellExecution(b)}}}$acceptRendererMessage(k,f,h){const r=this._kernelData.get(k);if(!!r){const a=this._extHostNotebook.getEditorById(f);if(!a)throw new Error(`send message for UNKNOWN editor: ${f}`);r.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:h}))}}}e.ExtHostNotebookKernels=n}),define(be[100],we([0,1,5,3,6,23,4,15]),function(Y,e,E,C,I,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends I.Disposable{constructor(r,a,p,d){super();this._onDidAppend=this._register(new C.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=d,this._id=d.$register(this.name,a,p),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?P.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(a=>this._proxy.$clear(a,r))}show(r,a){this.validate(),this._id.then(p=>this._proxy.$reveal(p,!!(typeof r=="boolean"?r:a)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class n extends y{constructor(r,a){super(r,!1,void 0,a)}append(r){super.append(r),this._id.then(a=>this._proxy.$append(a,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class T extends y{constructor(r,a,p){super(r,!0,a,p)}append(r){throw new Error("Not supported")}}class k{constructor(r,a){this.name=r,this._channel=a}append(r){this._channel.then(a=>a.append(r))}appendLine(r){this._channel.then(a=>a.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,a){this._channel.then(p=>p.show(r,a))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=k;let f=class{constructor(r){this._proxy=r.getProxy(E.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new n(r,this._proxy)}createOutputChannelFromLogFile(r,a){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!a)throw new Error("illegal argument `file`. must not be falsy");return new T(r,a,this._proxy)}};f=je([Ke(0,D.IExtHostRpcService)],f),e.ExtHostOutputService=f,e.IExtHostOutputService=(0,S.createDecorator)("IExtHostOutputService")}),define(be[203],we([0,1,14,20,3,6,5,2,7,11,12,47]),function(Y,e,E,C,I,P,S,D,y,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(h,r,a){const p=h.getProxy(S.MainContext.MainThreadQuickOpen);class d{constructor(s,o){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=o}showQuickPick(s,o,u,v=C.CancellationToken.None){this._onDidSelectItem=void 0;const A=Promise.resolve(s),m=++this._instances,_=p.$show(m,{title:u==null?void 0:u.title,placeHolder:u==null?void 0:u.placeHolder,matchOnDescription:u==null?void 0:u.matchOnDescription,matchOnDetail:u==null?void 0:u.matchOnDetail,ignoreFocusLost:u==null?void 0:u.ignoreFocusOut,canPickMany:u==null?void 0:u.canPickMany},v),R={},L=_.then(()=>R);return Promise.race([L,A]).then(V=>{if(V!==R)return A.then(he=>{const z=[];for(let W=0;W<he.length;W++){const J=he[W];let O,F,N,B,U;typeof J=="string"?O=J:(O=J.label,F=J.description,N=J.detail,B=J.picked,U=J.alwaysShow),z.push({label:O,description:F,handle:W,detail:N,picked:B,alwaysShow:U})}return u&&typeof u.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{u.onDidSelectItem(he[W])}),p.$setItems(m,z),_.then(W=>{if(typeof W=="number")return he[W];if(Array.isArray(W))return W.map(J=>he[J])})})}).then(void 0,V=>{if(!(0,n.isPromiseCanceledError)(V))return p.$setError(m,V),Promise.reject(V)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,o=C.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,p.$input(s,typeof this._validateInput=="function",o).then(void 0,u=>{if(!(0,n.isPromiseCanceledError)(u))return Promise.reject(u)})}$validateInput(s){return this._validateInput?(0,E.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,o=C.CancellationToken.None){const u=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!!u){const v=await this._workspace.getWorkspaceFolders2();if(!!v)return v.find(A=>A.uri.toString()===u.uri.toString())}}createQuickPick(s,o){const u=new t(s,o,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}createInputBox(s){const o=new i(s,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(s,o){const u=this._sessions.get(s);u&&u._fireDidChangeValue(o)}$onDidAccept(s){const o=this._sessions.get(s);o&&o._fireDidAccept()}$onDidChangeActive(s,o){const u=this._sessions.get(s);u instanceof t&&u._fireDidChangeActive(o)}$onDidChangeSelection(s,o){const u=this._sessions.get(s);u instanceof t&&u._fireDidChangeSelection(o)}$onDidTriggerButton(s,o){const u=this._sessions.get(s);u&&u._fireDidTriggerButton(o)}$onDidHide(s){const o=this._sessions.get(s);o&&o._fireDidHide()}}class b{constructor(s,o){this._extensionId=s,this._onDidDispose=o,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((o,u)=>{const v=o===y.QuickInputButtons.Back?-1:u;this._handlesToButtons.set(v,o)}),this.update({buttons:s.map((o,u)=>({iconPath:g(o.iconPath),tooltip:o.tooltip,handle:o===y.QuickInputButtons.Back?-1:u}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const o=this._handlesToButtons.get(s);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(s){if(!this._disposed){for(const o of Object.keys(s)){const u=s[o];this._pendingUpdate[o]=u===void 0?null:u}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}b._nextId=1;function g(l){if(l instanceof y.ThemeIcon)return{id:l.id};const s=w(l),o=c(l);return{dark:typeof s=="string"?D.URI.file(s):s,light:typeof o=="string"?D.URI.file(o):o}}function c(l){return typeof l=="object"&&"light"in l?l.light:l}function w(l){return typeof l=="object"&&"dark"in l?l.dark:l}class t extends b{constructor(s,o,u){super(s,u);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((o,u)=>{this._handlesToItems.set(u,o),this._itemsToHandles.set(o,u)}),this.update({items:s.map((o,u)=>({label:o.label,description:o.description,handle:u,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(s){const o=(0,T.coalesce)(s.map(u=>this._handlesToItems.get(u)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(s){const o=(0,T.coalesce)(s.map(u=>this._handlesToItems.get(u)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}}class i extends b{constructor(s,o){super(s,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?k.default.Error:k.default.Ignore})}}return new d(r,a)}e.createExtHostQuickOpen=f}),define(be[204],we([0,1,2,3,53,6,14,5,12,111,19,26,33]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(s){if(s)return typeof s.iconPath=="string"?E.URI.file(s.iconPath):s.iconPath}function r(s,o){if(!s.iconPath&&!o.iconPath)return 0;if(s.iconPath){if(!o.iconPath)return 1}else return-1;const u=typeof s.iconPath=="string"?s.iconPath:s.iconPath.fsPath,v=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath;return(0,n.comparePaths)(u,v)}function a(s,o){let u=0;if(s.strikeThrough!==o.strikeThrough)return s.strikeThrough?1:-1;if(s.faded!==o.faded)return s.faded?1:-1;if(s.tooltip!==o.tooltip)return(s.tooltip||"").localeCompare(o.tooltip||"");if(u=r(s,o),u!==0)return u;if(s.light&&o.light)u=r(s.light,o.light);else{if(s.light)return 1;if(o.light)return-1}if(u!==0)return u;if(s.dark&&o.dark)u=r(s.dark,o.dark);else{if(s.dark)return 1;if(o.dark)return-1}return u}function p(s,o){if(s.command!==o.command)return s.command<o.command?-1:1;if(s.title!==o.title)return s.title<o.title?-1:1;if(s.tooltip!==o.tooltip){if(s.tooltip!==void 0&&o.tooltip!==void 0)return s.tooltip<o.tooltip?-1:1;if(s.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(s.arguments===o.arguments)return 0;if(s.arguments)if(o.arguments){if(s.arguments.length!==o.arguments.length)return s.arguments.length-o.arguments.length}else return 1;else return-1;for(let u=0;u<s.arguments.length;u++){const v=s.arguments[u],A=o.arguments[u];if(v!==A)return v<A?-1:1}return 0}function d(s,o){let u=(0,n.comparePaths)(s.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(u!==0)return u;if(s.command&&o.command)u=p(s.command,o.command);else{if(s.command)return 1;if(o.command)return-1}if(u!==0)return u;if(s.decorations&&o.decorations)u=a(s.decorations,o.decorations);else{if(s.decorations)return 1;if(o.decorations)return-1}return u}function b(s,o){for(let u=0;u<s.length;u++)if(s[u]!==o[u])return!1;return!0}function g(s,o){return s.command===o.command&&s.title===o.title&&s.tooltip===o.tooltip&&(s.arguments&&o.arguments?b(s.arguments,o.arguments):s.arguments===o.arguments)}function c(s,o){return(0,y.equals)(s,o,g)}class w{constructor(o,u,v){this._extension=o,this._proxy=u,this._sourceControlHandle=v,this._value="",this._onDidChange=new C.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(o){if((0,f.checkProposedApiEnabled)(this._extension),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}focus(){(0,f.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(o,u){(0,f.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,o,u)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=w;class t{constructor(o,u,v,A,m){this._proxy=o,this._commands=u,this._sourceControlHandle=v,this._id=A,this._label=m,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new C.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new C.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,u){const v=this._resourceStatesCommandsMap.get(o);return v?(0,S.asPromise)(()=>this._commands.executeCommand(v.command,...v.arguments||[],u)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var o;const u=[...this._resourceStates].sort(d),A=(0,y.sortedDiff)(this._resourceSnapshot,u,d).map(R=>{const L=R.toInsert.map(V=>{const he=this._resourceHandlePool++;this._resourceStatesMap.set(he,V);const z=V.resourceUri,W=h(V.decorations),J=V.decorations&&h(V.decorations.light)||W,O=V.decorations&&h(V.decorations.dark)||W,F=[];let N;if(V.command)if(V.command.command==="vscode.open"||V.command.command==="vscode.diff"){const pe=new P.DisposableStore;N=this._commands.converter.toInternal(V.command,pe),this._resourceStatesDisposablesMap.set(he,pe)}else this._resourceStatesCommandsMap.set(he,V.command);J&&F.push(J),O&&O.toString()!==(J==null?void 0:J.toString())&&F.push(O);const B=V.decorations&&V.decorations.tooltip||"",U=V.decorations&&!!V.decorations.strikeThrough,Q=V.decorations&&!!V.decorations.faded,Z=V.contextValue||"";return{rawResource:[he,z,F,B,U,Q,Z,N],handle:he}});return{start:R.start,deleteCount:R.deleteCount,toInsert:L}}),m=A.map(({start:R,deleteCount:L,toInsert:V})=>[R,L,V.map(he=>he.rawResource)]),_=A.reverse();for(const{start:R,deleteCount:L,toInsert:V}of _){const he=V.map(W=>W.handle),z=this._handlesSnapshot.splice(R,L,...he);for(const W of z)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),(o=this._resourceStatesDisposablesMap.get(W))===null||o===void 0||o.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=u,m}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(o,u,v,A,m,_){this._proxy=u,this._commands=v,this._id=A,this._label=m,this._rootUri=_,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new C.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new w(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,A,m,_)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=o;const u=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:u})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(!(this._statusBarCommands&&o&&c(this._statusBarCommands,o))){this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=o;const u=(o||[]).map(v=>this._commands.converter.toInternal(v,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:u})}}get selected(){return this._selected}createResourceGroup(o,u){const v=new t(this._proxy,this._commands,this.handle,o,u),A=C.Event.once(v.onDidDispose)(()=>this.createdResourceGroups.delete(v));return this.createdResourceGroups.set(v,A),this.eventuallyAddResourceGroups(),v}eventuallyAddResourceGroups(){const o=[],u=[];for(const[v,A]of this.createdResourceGroups){A.dispose();const m=v.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(v),this.eventuallyUpdateResourceStates()});C.Event.once(v.onDidDispose)(()=>{this.updatedResourceGroups.delete(v),m.dispose(),this._groups.delete(v.handle),this._proxy.$unregisterGroup(this.handle,v.handle)}),o.push([v.handle,v.id,v.label,v.features]);const _=v._takeResourceStateSnapshot();_.length>0&&u.push([v.handle,_]),this._groups.set(v.handle,v)}this._proxy.$registerGroups(this.handle,o,u),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(u=>{const v=u._takeResourceStateSnapshot();v.length!==0&&o.push([u.handle,v])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,je([(0,I.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),je([(0,I.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let l=class Pn{constructor(o,u,v){this._commands=u,this.logService=v,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new C.Emitter,this._proxy=o.getProxy(D.MainContext.MainThreadSCM),this._telemetry=o.getProxy(D.MainContext.MainThreadTelemetry),u.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const m=this._sourceControls.get(A.sourceControlHandle);if(!m)return A;const _=m.getResourceGroup(A.groupHandle);return _?_.getResourceState(A.handle):A}else if(A&&A.$mid===4){const m=this._sourceControls.get(A.sourceControlHandle);return m?m.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const m=this._sourceControls.get(A.handle);return m||A}return A}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,u,v,A){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,u,v,A),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const m=Pn._handlePool++,_=new i(o,this._proxy,this._commands,u,v,A);this._sourceControls.set(m,_);const R=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(o.identifier))||[];return R.push(_),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(o.identifier),R),_}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const u=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(o.identifier)),v=u&&u[u.length-1];return v&&v.inputBox}$provideOriginalResource(o,u,v){const A=E.URI.revive(u);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,A.toString());const m=this._sourceControls.get(o);return!m||!m.quickDiffProvider||!m.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>m.quickDiffProvider.provideOriginalResource(A,v)).then(_=>_||null)}$onInputBoxValueChange(o,u){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const v=this._sourceControls.get(o);return v&&v.inputBox.$onInputBoxValueChange(u),Promise.resolve(void 0)}$executeResourceCommand(o,u,v,A){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,u,v);const m=this._sourceControls.get(o);if(!m)return Promise.resolve(void 0);const _=m.getResourceGroup(u);return _?_.$executeResourceCommand(v,A):Promise.resolve(void 0)}$validateInput(o,u,v){this.logService.trace("ExtHostSCM#$validateInput",o);const A=this._sourceControls.get(o);return!A||!A.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>A.inputBox.validateInput(u,v)).then(m=>m?Promise.resolve([m.message,m.type]):Promise.resolve(void 0))}$setSelectedSourceControl(o){var u,v;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&((u=this._sourceControls.get(o))===null||u===void 0||u.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((v=this._sourceControls.get(this._selectedSourceControlHandle))===null||v===void 0||v.setSelectionState(!1)),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};l._handlePool=0,l=je([Ke(2,T.ILogService)],l),e.ExtHostSCM=l});var tt=this&&this.__classPrivateFieldSet||function(Y,e,E,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(Y,E):I?I.value=E:e.set(Y,E),E},Me=this&&this.__classPrivateFieldGet||function(Y,e,E,C){if(E==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?C:E==="a"?C.call(Y):C?C.value:e.get(Y)};define(be[205],we([0,1,7,5,134,6]),function(Y,e,E,C,I,P){"use strict";var S,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(f,h,r,a,p=E.StatusBarAlignment.Left,d,b){S.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,S,f,"f"),tt(this,D,h,"f"),this._id=y.ID_GEN++,this._statusId=r,this._statusName=a,this._alignment=p,this._priority=d,this._accessibilityInformation=b}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var f;return(f=this._command)===null||f===void 0?void 0:f.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!y.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){var h;((h=this._command)===null||h===void 0?void 0:h.fromApi)!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Me(this,D,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Me(this,D,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Me(this,S,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var f;this._timeoutHandle=void 0;let h=this._color;this._backgroundColor&&(h=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Me(this,S,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(f=this._command)===null||f===void 0?void 0:f.internal,h,this._backgroundColor,this._alignment===E.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,S=new WeakMap,D=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new E.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(f){this._messages=[],this._item=f.createStatusBarEntry("status.extensionMessage",(0,I.localize)(0,null),E.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const h={message:f};return this._messages.unshift(h),this._update(),new E.Disposable(()=>{const r=this._messages.indexOf(h);r>=0&&(this._messages.splice(r,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class T{constructor(f,h){this._proxy=f.getProxy(C.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new n(this)}createStatusBarEntry(f,h,r,a,p){return new y(this._proxy,this._commands,f,h,r,a,p)}setStatusBarMessage(f,h){const r=this._statusMessage.setMessage(f);let a;return typeof h=="number"?a=setTimeout(()=>r.dispose(),h):typeof h!="undefined"&&h.then(()=>r.dispose(),()=>r.dispose()),new E.Disposable(()=>{r.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=T}),define(be[78],we([0,1,5,3,4]),function(Y,e,E,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(D){this._onDidChangeStorage=new C.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(E.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,y){this._proxy.$registerExtensionStorageKeysToSync(D,y)}getValue(D,y,n){return this._proxy.$getValue(D,y).then(T=>T||n)}setValue(D,y,n){return this._proxy.$setValue(D,y,n)}$acceptValue(D,y,n){this._onDidChangeStorage.fire({shared:D,key:y,value:n})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(be[79],we([0,1,4,27,19,77,2]),function(Y,e,E,C,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,E.createDecorator)("IExtensionStoragePaths");let D=class{constructor(n,T,k){var f;this._logService=T,this._extHostFileSystem=k,this._workspace=(f=n.workspace)!==null&&f!==void 0?f:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(h=>this._value=h)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,k=S.URI.joinPath(this._environment.workspaceStorageHome,T);try{return await this._extHostFileSystem.value.stat(k),this._logService.trace("[ExtHostStorage] storage dir already exists",k),k}catch(f){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",k),await this._extHostFileSystem.value.createDirectory(k),await this._extHostFileSystem.value.writeFile(S.URI.joinPath(k,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=S.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),k}catch(f){this._logService.error("[ExtHostStorage]",f);return}}workspaceValue(n){if(this._value)return S.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return S.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};D=je([Ke(0,C.IExtHostInitDataService),Ke(1,I.ILogService),Ke(2,P.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(be[40],we([0,1,3,5,4,2,15,6,7,135,11,172,20,29,155]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class a{constructor(t,i,l,s){this._proxy=t,this._id=i,this._creationOptions=l,this._name=s,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(u=>this._pidPromiseComplete=u);const o=this;this.value={get name(){return o._name||""},get processId(){return o._pidPromise},get creationOptions(){return o._creationOptions},get exitStatus(){return o._exitStatus},sendText(u,v=!0){o._checkDisposed(),o._proxy.$sendText(o._id,u,v)},show(u){o._checkDisposed(),o._proxy.$show(o._id,u)},hide(){o._checkDisposed(),o._proxy.$hide(o._id)},dispose(){o._disposed||(o._disposed=!0,o._proxy.$dispose(o._id))},get dimensions(){if(!(o._cols===void 0||o._rows===void 0))return{columns:o._cols,rows:o._rows}}}}async create(t,i,l,s,o,u,v,A,m,_,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:i,cwd:l,env:s,icon:o,initialText:u,waitOnExit:v,strictEnv:A,hideFromUser:m,isFeatureTerminal:_,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,i){return t===this._cols&&i===this._rows||t===0||i===0?!1:(this._cols=t,this._rows=i,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=a;class p{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new E.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new E.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new E.Emitter,this._onProcessTitleChanged=new E.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new E.Emitter,this._onProcessShellTypeChanged=new E.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,i){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:i})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=p;let d=1,b=class extends D.Disposable{constructor(t,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new E.Emitter,this._onDidOpenTerminal=new E.Emitter,this._onDidChangeActiveTerminal=new E.Emitter,this._onDidChangeTerminalDimensions=new E.Emitter,this._proxy=i.getProxy(C.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new E.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[l,s]of this._terminalProcesses)s.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const i=new a(this._proxy,(0,h.generateUuid)(),t,t.name),l=new p(t.pty);return i.createExtensionTerminal().then(s=>{const o=this._setupExtHostProcessListeners(s,l);this._terminalProcessDisposables[s]=o}),this._terminals.push(i),i.value}attachPtyToTerminal(t,i){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const s=new p(i),o=this._setupExtHostProcessListeners(t,s);this._terminalProcessDisposables[t]=o}async $acceptActiveTerminalChanged(t){const i=this._activeTerminal;if(t===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const l=this._getTerminalById(t);l&&(this._activeTerminal=l,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,i){const l=this._getTerminalById(t);l&&this._onDidWriteTerminalData.fire({terminal:l.value,data:i})}async $acceptTerminalDimensions(t,i,l){const s=this._getTerminalById(t);s&&s.setDimensions(i,l)&&this._onDidChangeTerminalDimensions.fire({terminal:s.value,dimensions:s.value.dimensions})}async $acceptTerminalMaximumDimensions(t,i,l){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.resize(i,l)}async $acceptTerminalTitleChange(t,i){const l=this._getTerminalById(t);l&&(l.name=i)}async $acceptTerminalClosed(t,i){const l=this._getTerminalObjectIndexById(this._terminals,t);if(l!==null){const s=this._terminals.splice(l,1)[0];s.setExitCode(i),this._onDidCloseTerminal.fire(s.value)}}$acceptTerminalOpened(t,i,l,s){if(i){const v=this._getTerminalObjectIndexById(this._terminals,i);if(v!==null){this._terminals[v]._id=t,this._onDidOpenTerminal.fire(this.terminals[v]),this._terminals[v].isOpen=!0;return}}const o={name:s.name,shellPath:s.executable,shellArgs:s.args,cwd:typeof s.cwd=="string"?s.cwd:P.URI.revive(s.cwd),env:s.env,hideFromUser:s.hideFromUser},u=new a(this._proxy,t,o,l);this._terminals.push(u),this._onDidOpenTerminal.fire(u.value),u.isOpen=!0}async $acceptTerminalProcessId(t,i){const l=this._getTerminalById(t);l&&l._setProcessId(i)}async $startExtensionTerminal(t,i){const l=this._getTerminalById(t);if(!l)return{message:(0,n.localize)(0,null,t)};l.isOpen||await new Promise(o=>{const u=this.onDidOpenTerminal(async v=>{v===l.value&&(u.dispose(),o())})});const s=this._terminalProcesses.get(t);s?s.startSendingEvents(i):this._extensionTerminalAwaitingStart[t]={initialDimensions:i}}_setupExtHostProcessListeners(t,i){const l=new D.DisposableStore;l.add(i.onProcessReady(o=>this._proxy.$sendProcessReady(t,o.pid,o.cwd))),l.add(i.onProcessTitleChanged(o=>this._proxy.$sendProcessTitle(t,o))),this._bufferer.startBuffering(t,i.onProcessData),l.add(i.onProcessExit(o=>this._onProcessExit(t,o))),i.onProcessOverrideDimensions&&l.add(i.onProcessOverrideDimensions(o=>this._proxy.$sendOverrideDimensions(t,o))),this._terminalProcesses.set(t,i);const s=this._extensionTerminalAwaitingStart[t];return s&&i instanceof p&&(i.startSendingEvents(s.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),l}$acceptProcessAckDataEvent(t,i){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.acknowledgeDataEvent(i)}$acceptProcessInput(t,i){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.input(i)}$acceptProcessResize(t,i,l){var s;try{(s=this._terminalProcesses.get(t))===null||s===void 0||s.resize(i,l)}catch(o){if(o.code!=="EPIPE"&&o.code!=="ERR_IPC_CHANNEL_CLOSED")throw o}}$acceptProcessShutdown(t,i){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.shutdown(i)}$acceptProcessRequestInitialCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getInitialCwd().then(l=>this._proxy.$sendProcessInitialCwd(t,l))}$acceptProcessRequestCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getCwd().then(l=>this._proxy.$sendProcessCwd(t,l))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,i){const l=this._getTerminalById(t);if(!l)return[];this._terminalLinkCache.delete(t);const s=this._terminalLinkCancellationSource.get(t);s&&s.dispose(!0);const o=new f.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,o);const u=[],v={terminal:l.value,line:i},A=[];for(const R of this._linkProviders)A.push(new Promise(async L=>{o.token.onCancellationRequested(()=>L({provider:R,links:[]}));const V=await R.provideTerminalLinks(v,o.token)||[];o.token.isCancellationRequested||L({provider:R,links:V})}));const m=await Promise.all(A);if(o.token.isCancellationRequested)return[];const _=new Map;for(const R of m)R&&R.links.length>0&&u.push(...R.links.map(L=>{const V={id:d++,startIndex:L.startIndex,length:L.length,label:L.tooltip};return _.set(V.id,{provider:R.provider,link:L}),V}));return this._terminalLinkCache.set(t,_),u}$activateLink(t,i){var l;const s=(l=this._terminalLinkCache.get(t))===null||l===void 0?void 0:l.get(i);!s||s.provider.handleTerminalLink(s.link)}_onProcessExit(t,i){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const l=this._terminalProcessDisposables[t];l&&(l.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,i)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,i){const l=this._getTerminalObjectIndexById(t,i);return l!==null?t[l]:null}_getTerminalObjectIndexById(t,i){let l=null;return t.some((s,o)=>s._id===i?(l=o,!0):!1),l}getEnvironmentVariableCollection(t){let i=this._environmentVariableCollections.get(t.identifier.value);return i||(i=new g,this._setEnvironmentVariableCollection(t.identifier.value,i)),i}_syncEnvironmentVariableCollection(t,i){const l=(0,k.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(t,i.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(t){t.forEach(i=>{const l=i[0],s=new g(i[1]);this._setEnvironmentVariableCollection(l,s)})}_setEnvironmentVariableCollection(t,i){this._environmentVariableCollections.set(t,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,i)})}};b=je([Ke(1,S.IExtHostRpcService)],b),e.BaseExtHostTerminalService=b;class g{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new E.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Replace})}append(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,i){const l=this.map.get(t);(!l||l.value!==i.value||l.type!==i.type)&&(this.map.set(t,i),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,i){this.map.forEach((l,s)=>t.call(i,s,l,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=g;let c=class extends b{constructor(t){super(!1,t)}createTerminal(t,i,l){throw new T.NotSupportedError}createTerminalFromOptions(t){throw new T.NotSupportedError}getDefaultShell(t,i){throw new T.NotSupportedError}getDefaultShellArgs(t,i){throw new T.NotSupportedError}$getAvailableProfiles(t){throw new T.NotSupportedError}async $getDefaultShellAndArgs(t){throw new T.NotSupportedError}};c=je([Ke(0,S.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c}),define(be[206],we([0,1,3,12,5,97,9,7]),function(Y,e,E,C,I,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(T,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new E.Emitter,this._onDidChangeTextEditorOptions=new E.Emitter,this._onDidChangeTextEditorVisibleRanges=new E.Emitter,this._onDidChangeTextEditorViewColumn=new E.Emitter,this._onDidChangeActiveTextEditor=new E.Emitter,this._onDidChangeVisibleTextEditors=new E.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=T.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(f=>this._onDidChangeVisibleTextEditors.fire(f)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(f=>this._onDidChangeActiveTextEditor.fire(f))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(T){const k=this._extHostDocumentsAndEditors.allEditors();return T?k:k.map(f=>f.value)}async showTextDocument(T,k,f){let h;typeof k=="number"?h={position:S.ViewColumn.from(k),preserveFocus:f}:typeof k=="object"?h={position:S.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?S.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:h={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(T.uri,h),a=r&&this._extHostDocumentsAndEditors.getEditor(r);if(a)return a.value;throw r?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T){return new P.TextEditorDecorationType(this._proxy,T).value}$acceptEditorPropertiesChanged(T,k){const f=this._extHostDocumentsAndEditors.getEditor(T);if(!f)throw new Error("unknown text editor");if(k.options&&f._acceptOptions(k.options),k.selections){const h=k.selections.selections.map(S.Selection.to);f._acceptSelections(h)}if(k.visibleRanges){const h=C.coalesce(k.visibleRanges.map(S.Range.to));f._acceptVisibleRanges(h)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:f.value,options:Object.assign(Object.assign({},k.options),{lineNumbers:S.TextEditorLineNumbersStyle.to(k.options.lineNumbers)})}),k.selections){const h=D.TextEditorSelectionChangeKind.fromValue(k.selections.source),r=k.selections.selections.map(S.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:f.value,selections:r,kind:h})}if(k.visibleRanges){const h=C.coalesce(k.visibleRanges.map(S.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:f.value,visibleRanges:h})}}$acceptEditorPositionData(T){for(const k in T){const f=this._extHostDocumentsAndEditors.getEditor(k);if(!f)throw new Error("Unknown text editor");const h=S.ViewColumn.to(T[k]);f.value.viewColumn!==h&&(f._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:f.value,viewColumn:h}))}}getDiffInformation(T){return Promise.resolve(this._proxy.$getDiffInformation(T))}}e.ExtHostEditors=y});var $t=this&&this.__rest||function(Y,e){var E={};for(var C in Y)Object.prototype.hasOwnProperty.call(Y,C)&&e.indexOf(C)<0&&(E[C]=Y[C]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function")for(var I=0,C=Object.getOwnPropertySymbols(Y);I<C.length;I++)e.indexOf(C[I])<0&&Object.prototype.propertyIsEnumerable.call(Y,C[I])&&(E[C[I]]=Y[C[I]]);return E};define(be[207],we([0,1,2,4,5,6,7]),function(Y,e,E,C,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,C.createDecorator)("IExtHostTimeline");class D{constructor(T,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=T.getProxy(I.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:f=>{var h,r;if(f&&f.$mid===11){const a=f.uri===void 0?void 0:E.URI.revive(f.uri);return(r=(h=this._itemsBySourceAndUriMap.get(f.source))===null||h===void 0?void 0:h.get(y(a)))===null||r===void 0?void 0:r.get(f.handle)}return f}})}async $getTimeline(T,k,f,h,r){const a=this._providers.get(T);return a==null?void 0:a.provideTimeline(E.URI.revive(k),f,h,r)}registerTimelineProvider(T,k,f,h){const r=new P.DisposableStore,a=this.convertTimelineItem(k.id,h,r).bind(this);let p;k.onDidChange&&(p=k.onDidChange(b=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},b),{id:k.id})),this));const d=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},k),{scheme:T,onDidChange:void 0,async provideTimeline(b,g,c,w){var t;(w==null?void 0:w.resetCache)&&(r.clear(),(t=d.get(k.id))===null||t===void 0||t.clear());const i=await k.provideTimeline(b,g,c);if(i!=null){const l=a(b,w);return Object.assign(Object.assign({},i),{source:k.id,items:i.items.map(l)})}},dispose(){var b;for(const g of d.values())(b=g.get(k.id))===null||b===void 0||b.clear();p==null||p.dispose(),r.dispose()}}))}convertTimelineItem(T,k,f){return(h,r)=>{let a;if(r==null?void 0:r.cacheResults){let p=this._itemsBySourceAndUriMap.get(T);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(T,p));const d=y(h);a=p.get(d),a===void 0&&(a=new Map,p.set(d,a))}return p=>{var d,b;const{iconPath:g}=p,c=$t(p,["iconPath"]),w=`${T}|${(d=p.id)!==null&&d!==void 0?d:p.timestamp}`;a==null||a.set(w,p);let t,i,l;return p.iconPath&&(g instanceof S.ThemeIcon?l={id:g.id}:E.URI.isUri(g)?(t=g,i=g):{light:t,dark:i}=g),Object.assign(Object.assign({},c),{id:(b=c.id)!==null&&b!==void 0?b:void 0,handle:w,source:T,command:p.command?k.toInternal(p.command,f):void 0,icon:t,iconDark:i,themeIcon:l,accessibilityInformation:p.accessibilityInformation})}}}registerTimelineProviderCore(T){if(this._providers.get(T.id))throw new Error(`Timeline Provider ${T.id} already exists.`);return this._proxy.$registerTimelineProvider({id:T.id,label:T.label,scheme:T.scheme}),this._providers.set(T.id,T),(0,P.toDisposable)(()=>{var f;for(const h of this._itemsBySourceAndUriMap.values())(f=h.get(T.id))===null||f===void 0||f.clear();this._providers.delete(T.id),this._proxy.$unregisterTimelineProvider(T.id),T.dispose()})}}e.ExtHostTimeline=D;function y(n){return n==null?void 0:n.toString()}}),define(be[208],we([0,1,6,18,2,5]),function(Y,e,E,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(y){this._openers=new Map,this._proxy=y.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,n,T,k){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const f=k.schemes.find(h=>!S.supportedSchemes.has(h));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,T),this._proxy.$registerUriOpener(n,k.schemes,y,k.label),(0,E.toDisposable)(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(y,n,T){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener with id: ${y}`);const f=I.URI.revive(n);return k.canOpenExternalUri(f,T)}async $openUri(y,n,T){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener id: '${y}'`);return k.openExternalUri(I.URI.revive(n.resolvedUri),{sourceUri:I.URI.revive(n.sourceUri)},T)}}e.ExtHostUriOpeners=S,S.supportedSchemes=new Set([C.Schemas.http,C.Schemas.https])}),define(be[209],we([0,1,5,2,6,11,26]),function(Y,e,E,C,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(E.MainContext.MainThreadUrls)}registerUriHandler(n,T){if(this.handles.has(S.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const k=D.HandlePool++;return this.handles.add(S.ExtensionIdentifier.toKey(n)),this.handlers.set(k,T),this._proxy.$registerUriHandler(k,n),(0,I.toDisposable)(()=>{this.handles.delete(S.ExtensionIdentifier.toKey(n)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(n,T){const k=this.handlers.get(n);if(!k)return Promise.resolve(void 0);try{k.handleUri(C.URI.revive(T))}catch(f){(0,P.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(n){return C.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=D,D.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(Y,e,E,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(Y,E):I?I.value=E:e.set(Y,E),E},Me=this&&this.__classPrivateFieldGet||function(Y,e,E,C){if(E==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?C:E==="a"?C.call(Y):C?C.value:e.get(Y)};define(be[51],we([0,1,23,3,2,144,165,50,5]),function(Y,e,E,C,I,P,S,D,y){"use strict";var n,T,k,f,h,r,a,p,d,b,g,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class w{constructor(m,_,R,L,V,he,z){n.set(this,void 0),T.set(this,void 0),k.set(this,void 0),f.set(this,void 0),h.set(this,void 0),r.set(this,void 0),a.set(this,""),p.set(this,void 0),d.set(this,!1),b.set(this,!1),g.set(this,!1),this._onMessageEmitter=new C.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new C.Emitter),this._onDidDispose=Me(this,c,"f").event,tt(this,n,m,"f"),tt(this,T,_,"f"),tt(this,p,R,"f"),tt(this,f,L,"f"),tt(this,h,V,"f"),tt(this,r,he,"f"),tt(this,g,t(he),"f"),tt(this,k,z,"f")}dispose(){tt(this,d,!0,"f"),Me(this,c,"f").fire(),Me(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return tt(this,b,!0,"f"),(0,D.asWebviewUri)(Me(this,f,"f"),Me(this,n,"f"),m)}get cspSource(){return Me(this,f,"f").webviewCspSource.replace("{{uuid}}",Me(this,n,"f"))}get html(){return this.assertNotDisposed(),Me(this,a,"f")}set html(m){this.assertNotDisposed(),Me(this,a,"f")!==m&&(tt(this,a,m,"f"),!Me(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(tt(this,b,!0,"f"),Me(this,k,"f").report("Webview vscode-resource: uris",Me(this,r,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,T,"f").$setHtml(Me(this,n,"f"),m))}get options(){return this.assertNotDisposed(),Me(this,p,"f")}set options(m){this.assertNotDisposed(),Me(this,T,"f").$setOptions(Me(this,n,"f"),o(Me(this,r,"f"),Me(this,h,"f"),m)),tt(this,p,m,"f")}async postMessage(m){if(Me(this,d,"f"))return!1;const _=i(m,{serializeBuffersForPostMessage:Me(this,g,"f")});return Me(this,T,"f").$postMessage(Me(this,n,"f"),_.message,..._.buffers)}assertNotDisposed(){if(Me(this,d,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=w,n=new WeakMap,T=new WeakMap,k=new WeakMap,f=new WeakMap,h=new WeakMap,r=new WeakMap,a=new WeakMap,p=new WeakMap,d=new WeakMap,b=new WeakMap,g=new WeakMap,c=new WeakMap;function t(A){if(!A.enableProposedApi)return!1;try{const m=(0,P.normalizeVersion)((0,P.parseVersion)(A.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=56}catch(m){return!1}}e.shouldSerializeBuffersForPostMessage=t;function i(A,m){if(m.serializeBuffersForPostMessage){const _=[],R=(V,he)=>{if(he&&he instanceof ArrayBuffer){let z=_.findIndex(W=>W.original===he);if(z===-1){const W=new Uint8Array(he),J=E.VSBuffer.wrap(W);z=_.length,_.push({original:he,vsBuffer:J})}return{$$vscode_array_buffer_reference$$:!0,index:z}}return he};return{message:JSON.stringify(A,R),buffers:_.map(V=>V.vsBuffer)}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeMessage=i;class l{constructor(m,_,R,L,V){this.initData=_,this.workspace=R,this._logService=L,this._deprecationService=V,this._webviews=new Map,this._webviewProxy=m.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(m,_,...R){const L=this.getWebview(m);if(L){const{message:V}=(0,S.deserializeWebviewMessage)(_,R);L._onMessageEmitter.fire(V)}}$onMissingCsp(m,_){this._logService.warn(`${_} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,_,R){const L=new w(m,this._webviewProxy,u(_),this.initData,this.workspace,R,this._deprecationService);return this._webviews.set(m,L),L._onDidDispose(()=>{this._webviews.delete(m)}),L}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=l;function s(A){return{id:A.identifier,location:A.extensionLocation}}e.toExtensionData=s;function o(A,m,_){return{enableCommandUris:_.enableCommandUris,enableScripts:_.enableScripts,portMapping:_.portMapping,localResourceRoots:_.localResourceRoots||v(A,m)}}e.serializeWebviewOptions=o;function u(A){var m;return{enableCommandUris:A.enableCommandUris,enableScripts:A.enableScripts,portMapping:A.portMapping,localResourceRoots:(m=A.localResourceRoots)===null||m===void 0?void 0:m.map(_=>I.URI.from(_))}}e.reviveOptions=u;function v(A,m){return[...((m==null?void 0:m.getWorkspaceFolders())||[]).map(_=>_.uri),A.extensionLocation]}}),define(be[210],we([0,1,20,57,6,18,25,2,9,51,69,5,7]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,S.joinPath)(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class r{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,l){const s=this.key(t,i.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const o=new h(i,l);return this._documents.set(s,o),o}delete(t,i){const l=this.key(t,i.uri);this._documents.delete(l)}key(t,i){return`${t}@@@${i}`}}var a;(function(w){w[w.Text=0]="Text",w[w.Custom=1]="Custom"})(a||(a={}));class p{constructor(){this._providers=new Map}addTextProvider(t,i,l){return this.add(0,t,i,l)}addCustomProvider(t,i,l){return this.add(1,t,i,l)}get(t){return this._providers.get(t)}add(t,i,l,s){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:l,provider:s}),new f.Disposable(()=>this._providers.delete(i))}}class d{constructor(t,i,l,s,o){this._extHostDocuments=i,this._extensionStoragePaths=l,this._extHostWebview=s,this._extHostWebviewPanels=o,this._editorProviders=new p,this._documents=new r,this._proxy=t.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,l,s){const o=new I.DisposableStore;return b(l)?(o.add(this._editorProviders.addTextProvider(i,t,l)),this._proxy.$registerTextEditorProvider((0,n.toExtensionData)(t),i,s.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,n.shouldSerializeBuffersForPostMessage)(t))):(o.add(this._editorProviders.addCustomProvider(i,t,l)),this.supportEditing(l)&&o.add(l.onDidChangeCustomDocument(u=>{const v=this.getCustomDocumentEntry(i,u.document.uri);if(g(u)){const A=v.addEdit(u);this._proxy.$onDidEdit(u.document.uri,i,A,u.label)}else this._proxy.$onContentChange(u.document.uri,i)})),this._proxy.$registerCustomEditorProvider((0,n.toExtensionData)(t),i,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,n.shouldSerializeBuffersForPostMessage)(t))),f.Disposable.from(o,new f.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,l,s,o){var u;const v=this._editorProviders.get(i);if(!v)throw new Error(`No provider found for '${i}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${i}'`);const A=D.URI.revive(t),m=await v.provider.openCustomDocument(A,{backupId:l,untitledDocumentData:s==null?void 0:s.buffer},o);let _;return this.supportEditing(v.provider)&&this._extensionStoragePaths&&(_=(u=this._extensionStoragePaths.workspaceValue(v.extension))!==null&&u!==void 0?u:this._extensionStoragePaths.globalValue(v.extension)),this._documents.add(i,m,_),{editable:this.supportEditing(v.provider)}}async $disposeCustomDocument(t,i){const l=this._editorProviders.get(i);if(!l)throw new Error(`No provider found for '${i}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${i}'`);const s=D.URI.revive(t),{document:o}=this.getCustomDocumentEntry(i,s);this._documents.delete(i,o),o.dispose()}async $resolveWebviewEditor(t,i,l,s,o,u){const v=this._editorProviders.get(l);if(!v)throw new Error(`No provider found for '${l}'`);const A=y.ViewColumn.to(o),m=this._extHostWebview.createNewWebview(i,s.webviewOptions,v.extension),_=this._extHostWebviewPanels.createNewWebviewPanel(i,l,s.title,A,s.panelOptions,m),R=D.URI.revive(t);switch(v.type){case 1:{const{document:L}=this.getCustomDocumentEntry(l,R);return v.provider.resolveCustomEditor(L,_,u)}case 0:{const L=this._extHostDocuments.getDocument(R);return v.provider.resolveCustomTextEditor(L,_,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,l){this.getCustomDocumentEntry(i,t).disposeEdits(l)}async $onMoveCustomEditor(t,i,l){const s=this._editorProviders.get(l);if(!s)throw new Error(`No provider found for '${l}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const o=this._extHostWebviewPanels.getWebviewPanel(t);if(!o)throw new Error("No webview found");const u=D.URI.revive(i),v=this._extHostDocuments.getDocument(u);await s.provider.moveCustomTextEditor(v,o,E.CancellationToken.None)}async $undo(t,i,l,s){return this.getCustomDocumentEntry(i,t).undo(l,s)}async $redo(t,i,l,s){return this.getCustomDocumentEntry(i,t).redo(l,s)}async $revert(t,i,l){const s=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(s.document,l),s.disposeBackup()}async $onSave(t,i,l){const s=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(s.document,l),s.disposeBackup()}async $onSaveAs(t,i,l,s){const o=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(o.document,D.URI.revive(l),s)}async $backup(t,i,l){const s=this.getCustomDocumentEntry(i,t),u=await this.getCustomEditorProvider(i).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},l);return s.updateBackup(u),u.id}getCustomDocumentEntry(t,i){const l=this._documents.get(t,D.URI.revive(i));if(!l)throw new Error("No custom document found");return l}getCustomEditorProvider(t){const i=this._editorProviders.get(t),l=i==null?void 0:i.provider;if(!l||!this.supportEditing(l))throw new Error("Custom document is not editable");return l}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=d;function b(w){return typeof w.resolveCustomTextEditor=="function"}function g(w){return typeof w.undo=="function"&&typeof w.redo=="function"}function c(w){const t=w.scheme===P.Schemas.file||w.scheme===P.Schemas.untitled?w.fsPath:w.toString();return(0,C.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(Y,e,E,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(Y,E):I?I.value=E:e.set(Y,E),E},Me=this&&this.__classPrivateFieldGet||function(Y,e,E,C){if(E==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?C:E==="a"?C.call(Y):C?C.value:e.get(Y)};define(be[211],we([0,1,3,6,2,29,9,51,5,7]),function(Y,e,E,C,I,P,S,D,y,n){"use strict";var T,k,f,h,r,a,p,d,b,g,c,w,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends C.Disposable{constructor(u,v,A,m,_,R,L){super();T.set(this,void 0),k.set(this,void 0),f.set(this,void 0),h.set(this,void 0),r.set(this,void 0),a.set(this,void 0),p.set(this,void 0),d.set(this,void 0),b.set(this,!0),g.set(this,!0),c.set(this,!1),w.set(this,this._register(new E.Emitter)),this.onDidDispose=Me(this,w,"f").event,t.set(this,this._register(new E.Emitter)),this.onDidChangeViewState=Me(this,t,"f").event,tt(this,T,u,"f"),tt(this,k,v,"f"),tt(this,f,A,"f"),tt(this,r,R,"f"),tt(this,d,_,"f"),tt(this,a,m,"f"),tt(this,h,L,"f")}dispose(){Me(this,c,"f")||(tt(this,c,!0,"f"),Me(this,w,"f").fire(),Me(this,k,"f").$disposeWebview(Me(this,T,"f")),Me(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Me(this,h,"f")}get viewType(){return this.assertNotDisposed(),Me(this,f,"f")}get title(){return this.assertNotDisposed(),Me(this,a,"f")}set title(u){this.assertNotDisposed(),Me(this,a,"f")!==u&&(tt(this,a,u,"f"),Me(this,k,"f").$setTitle(Me(this,T,"f"),u))}get iconPath(){return this.assertNotDisposed(),Me(this,p,"f")}set iconPath(u){this.assertNotDisposed(),Me(this,p,"f")!==u&&(tt(this,p,u,"f"),Me(this,k,"f").$setIconPath(Me(this,T,"f"),I.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Me(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Me(this,d,"f")=="number"&&Me(this,d,"f")<0))return Me(this,d,"f")}get active(){return this.assertNotDisposed(),Me(this,g,"f")}get visible(){return this.assertNotDisposed(),Me(this,b,"f")}_updateViewState(u){Me(this,c,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(tt(this,g,u.active,"f"),tt(this,b,u.visible,"f"),tt(this,d,u.viewColumn,"f"),Me(this,t,"f").fire({webviewPanel:this}))}reveal(u,v){this.assertNotDisposed(),Me(this,k,"f").$reveal(Me(this,T,"f"),{viewColumn:u?S.ViewColumn.from(u):void 0,preserveFocus:!!v})}assertNotDisposed(){if(Me(this,c,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,k=new WeakMap,f=new WeakMap,h=new WeakMap,r=new WeakMap,a=new WeakMap,p=new WeakMap,d=new WeakMap,b=new WeakMap,g=new WeakMap,c=new WeakMap,w=new WeakMap,t=new WeakMap;class l{constructor(u,v,A){this.webviews=v,this.workspace=A,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=u.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(u,v,A,m,_={}){const R=typeof m=="object"?m.viewColumn:m,L={viewColumn:S.ViewColumn.from(R),preserveFocus:typeof m=="object"&&!!m.preserveFocus},V=(0,D.shouldSerializeBuffersForPostMessage)(u),he=l.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(u),he,v,{title:A,panelOptions:s(_),webviewOptions:(0,D.serializeWebviewOptions)(u,this.workspace,_),serializeBuffersForPostMessage:V},L);const z=this.webviews.createNewWebview(he,_,u);return this.createNewWebviewPanel(he,v,A,R,_,z)}$onDidChangeWebviewPanelViewStates(u){const v=Object.keys(u);v.sort((A,m)=>{const _=u[A],R=u[m];return _.active?1:R.active?-1:+_.visible-+R.visible});for(const A of v){const m=this.getWebviewPanel(A);if(!!m){const _=u[A];m._updateViewState({active:_.active,visible:_.visible,viewColumn:S.ViewColumn.to(_.position)})}}}async $onDidDisposeWebviewPanel(u){const v=this.getWebviewPanel(u);v==null||v.dispose(),this._webviewPanels.delete(u),this.webviews.deleteWebview(u)}registerWebviewPanelSerializer(u,v,A){if(this._serializers.has(v))throw new Error(`Serializer for '${v}' already registered`);return this._serializers.set(v,{serializer:A,extension:u}),this._proxy.$registerSerializer(v,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(u)}),new n.Disposable(()=>{this._serializers.delete(v),this._proxy.$unregisterSerializer(v)})}async $deserializeWebviewPanel(u,v,A,m){const _=this._serializers.get(v);if(!_)throw new Error(`No serializer found for '${v}'`);const{serializer:R,extension:L}=_,V=this.webviews.createNewWebview(u,A.webviewOptions,L),he=this.createNewWebviewPanel(u,v,A.title,m,A.panelOptions,V);await R.deserializeWebviewPanel(he,A.state)}createNewWebviewPanel(u,v,A,m,_,R){const L=new i(u,this._proxy,v,A,m,_,R);return this._webviewPanels.set(u,L),L}getWebviewPanel(u){return this._webviewPanels.get(u)}}e.ExtHostWebviewPanels=l;function s(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(Y,e,E,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(Y,E):I?I.value=E:e.set(Y,E),E},Me=this&&this.__classPrivateFieldGet||function(Y,e,E,C){if(E==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?C:E==="a"?C.call(Y):C?C.value:e.get(Y)};define(be[212],we([0,1,3,6,51,5,7]),function(Y,e,E,C,I,P,S){"use strict";var D,y,n,T,k,f,h,r,a,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class d extends C.Disposable{constructor(c,w,t,i,l,s){super();D.set(this,void 0),y.set(this,void 0),n.set(this,void 0),T.set(this,void 0),k.set(this,!1),f.set(this,void 0),h.set(this,void 0),r.set(this,void 0),a.set(this,this._register(new E.Emitter)),this.onDidChangeVisibility=Me(this,a,"f").event,p.set(this,this._register(new E.Emitter)),this.onDidDispose=Me(this,p,"f").event,tt(this,n,t,"f"),tt(this,h,i,"f"),tt(this,D,c,"f"),tt(this,y,w,"f"),tt(this,T,l,"f"),tt(this,f,s,"f")}dispose(){Me(this,k,"f")||(tt(this,k,!0,"f"),Me(this,p,"f").fire(),Me(this,T,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Me(this,h,"f")}set title(c){this.assertNotDisposed(),Me(this,h,"f")!==c&&(tt(this,h,c,"f"),Me(this,y,"f").$setWebviewViewTitle(Me(this,D,"f"),c))}get description(){return this.assertNotDisposed(),Me(this,r,"f")}set description(c){this.assertNotDisposed(),Me(this,r,"f")!==c&&(tt(this,r,c,"f"),Me(this,y,"f").$setWebviewViewDescription(Me(this,D,"f"),c))}get visible(){return Me(this,f,"f")}get webview(){return Me(this,T,"f")}get viewType(){return Me(this,n,"f")}_setVisible(c){c===Me(this,f,"f")||Me(this,k,"f")||(tt(this,f,c,"f"),Me(this,a,"f").fire())}show(c){this.assertNotDisposed(),Me(this,y,"f").$show(Me(this,D,"f"),!!c)}assertNotDisposed(){if(Me(this,k,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,y=new WeakMap,n=new WeakMap,T=new WeakMap,k=new WeakMap,f=new WeakMap,h=new WeakMap,r=new WeakMap,a=new WeakMap,p=new WeakMap;class b{constructor(c,w){this._extHostWebview=w,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,w,t,i){if(this._viewProviders.has(w))throw new Error(`View provider for '${w}' already registered`);return this._viewProviders.set(w,{provider:t,extension:c}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(c),w,{retainContextWhenHidden:i==null?void 0:i.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new S.Disposable(()=>{this._viewProviders.delete(w),this._proxy.$unregisterWebviewViewProvider(w)})}async $resolveWebviewView(c,w,t,i,l){const s=this._viewProviders.get(w);if(!s)throw new Error(`No view provider found for '${w}'`);const{provider:o,extension:u}=s,v=this._extHostWebview.createNewWebview(c,{},u),A=new d(c,this._proxy,w,t,v,!0);this._webviewViews.set(c,A),await o.resolveWebviewView(A,{state:i},l)}async $onDidChangeWebviewViewVisibility(c,w){this.getWebviewView(c)._setVisible(w)}async $disposeWebviewView(c){const w=this.getWebviewView(c);this._webviewViews.delete(c),w.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const w=this._webviewViews.get(c);if(!w)throw new Error("No webview found");return w}}e.ExtHostWebviewViews=b}),define(be[101],we([0,1,3,5,2,18,8,4,15]),function(Y,e,E,C,I,P,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class An{constructor(k){this._onDidChangeWindowState=new E.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=An.InitialState,this._proxy=k.getProxy(C.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(f=>this.$onDidChangeWindowFocus(f))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:k}),this._onDidChangeWindowState.fire(this._state))}openUri(k,f){let h;if(typeof k=="string"){h=k;try{k=I.URI.parse(k)}catch(r){return Promise.reject(`Invalid uri - '${k}'`)}}return(0,S.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,h,f)}async asExternalUri(k,f){if((0,S.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([P.Schemas.http,P.Schemas.https]).has(k.scheme))return Promise.reject(`Invalid scheme '${k.scheme}'`);const h=await this._proxy.$asExternalUri(k,f);return I.URI.from(h)}};n.InitialState={focused:!0},n=je([Ke(0,y.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(be[213],we([0,1,19,5,27,15]),function(Y,e,E,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let S=class extends E.AbstractLogger{constructor(y,n){super();this._proxy=y.getProxy(C.MainContext.MainThreadLog),this._logFile=n.logFile.toJSON(),this.setLevel(n.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...n){this.getLevel()<=E.LogLevel.Trace&&this._proxy.$log(this._logFile,E.LogLevel.Trace,Array.from(arguments))}debug(y,...n){this.getLevel()<=E.LogLevel.Debug&&this._proxy.$log(this._logFile,E.LogLevel.Debug,Array.from(arguments))}info(y,...n){this.getLevel()<=E.LogLevel.Info&&this._proxy.$log(this._logFile,E.LogLevel.Info,Array.from(arguments))}warn(y,...n){this.getLevel()<=E.LogLevel.Warning&&this._proxy.$log(this._logFile,E.LogLevel.Warning,Array.from(arguments))}error(y,...n){this.getLevel()<=E.LogLevel.Error&&this._proxy.$log(this._logFile,E.LogLevel.Error,Array.from(arguments))}critical(y,...n){this.getLevel()<=E.LogLevel.Critical&&this._proxy.$log(this._logFile,E.LogLevel.Critical,Array.from(arguments))}flush(){}};S=je([Ke(0,P.IExtHostRpcService),Ke(1,I.IExtHostInitDataService)],S),e.ExtHostLogService=S}),define(be[214],we([0,1,14,20,11,3,6,112,186,98,23]),function(Y,e,E,C,I,P,S,D,y,n,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function f(s,o){try{return JSON.stringify(s,o)}catch(u){return"null"}}function h(s,o){return JSON.stringify(s,o)}function r(s){return s?(o,u)=>u&&u.$mid===1?s.transformOutgoing(u):u:null}var a;(function(s){s[s.LocalSide=0]="LocalSide",s[s.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(s){s[s.Responsive=0]="Responsive",s[s.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const d=()=>{},b=Symbol.for("rpcProtocol"),g=Symbol.for("rpcProxy");class c extends S.Disposable{constructor(o,u=null,v=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new P.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=o,this._logger=u,this._uriTransformer=v,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let A=0,m=n.ProxyIdentifier.count;A<m;A++)this._locals[A]=null,this._proxies[A]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new E.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(A=>this._receiveOneMessage(A))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(o=>{this._pendingRPCReplies[o].resolveErr(I.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(o){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(o){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(o){this._responsiveState!==o&&(this._responsiveState=o,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(o){return this._uriTransformer?(0,D.transformIncomingURIs)(o,this._uriTransformer):o}getProxy(o){const{nid:u,sid:v}=o;return this._proxies[u]||(this._proxies[u]=this._createProxy(u,v)),this._proxies[u]}_createProxy(o,u){let v={get:(A,m)=>(typeof m=="string"&&!A[m]&&m.charCodeAt(0)===36&&(A[m]=(..._)=>this._remoteCall(o,m,_)),m===g?u:A[m])};return new Proxy(Object.create(null),v)}set(o,u){return this._locals[o.nid]=u,u}assertRegistered(o){for(let u=0,v=o.length;u<v;u++){const A=o[u];if(!this._locals[A.nid])throw new Error(`Missing actor ${A.sid} (isMain: ${A.isMain})`)}}_receiveOneMessage(o){if(!this._isDisposed){const u=o.byteLength,v=w.read(o,0),A=v.readUInt8(),m=v.readUInt32();switch(A){case 1:case 2:{let{rpcId:_,method:R,args:L}=t.deserializeRequestJSONArgs(v);this._uriTransformer&&(L=(0,D.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(u,m,_,R,L,A===2);break}case 3:case 4:{let{rpcId:_,method:R,args:L}=t.deserializeRequestMixedArgs(v);this._uriTransformer&&(L=(0,D.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(u,m,_,R,L,A===4);break}case 5:{this._logger&&this._logger.logIncoming(u,m,0,"ack"),this._onDidReceiveAcknowledge(m);break}case 6:{this._receiveCancel(u,m);break}case 7:{this._receiveReply(u,m,void 0);break}case 9:{let _=t.deserializeReplyOKJSON(v);this._uriTransformer&&(_=(0,D.transformIncomingURIs)(_,this._uriTransformer)),this._receiveReply(u,m,_);break}case 8:{let _=t.deserializeReplyOKVSBuffer(v);this._receiveReply(u,m,_);break}case 10:{let _=t.deserializeReplyErrError(v);this._uriTransformer&&(_=(0,D.transformIncomingURIs)(_,this._uriTransformer)),this._receiveReplyErr(u,m,_);break}case 11:{this._receiveReplyErr(u,m,void 0);break}default:console.error("received unexpected message"),console.error(o)}}}_receiveRequest(o,u,v,A,m,_){this._logger&&this._logger.logIncoming(o,u,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(v)}.${A}(`,m);const R=String(u);let L,V;if(_){const z=new C.CancellationTokenSource;m.push(z.token),L=this._invokeHandler(v,A,m),V=()=>z.cancel()}else L=this._invokeHandler(v,A,m),V=d;this._cancelInvokedHandlers[R]=V;const he=t.serializeAcknowledged(u);this._logger&&this._logger.logOutgoing(he.byteLength,u,1,"ack"),this._protocol.send(he),L.then(z=>{delete this._cancelInvokedHandlers[R];const W=t.serializeReplyOK(u,z,this._uriReplacer);this._logger&&this._logger.logOutgoing(W.byteLength,u,1,"reply:",z),this._protocol.send(W)},z=>{delete this._cancelInvokedHandlers[R];const W=t.serializeReplyErr(u,z);this._logger&&this._logger.logOutgoing(W.byteLength,u,1,"replyErr:",z),this._protocol.send(W)})}_receiveCancel(o,u){this._logger&&this._logger.logIncoming(o,u,1,"receiveCancel");const v=String(u);this._cancelInvokedHandlers[v]&&this._cancelInvokedHandlers[v]()}_receiveReply(o,u,v){this._logger&&this._logger.logIncoming(o,u,0,"receiveReply:",v);const A=String(u);if(!!this._pendingRPCReplies.hasOwnProperty(A)){const m=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],m.resolveOk(v)}}_receiveReplyErr(o,u,v){this._logger&&this._logger.logIncoming(o,u,0,"receiveReplyErr:",v);const A=String(u);if(!!this._pendingRPCReplies.hasOwnProperty(A)){const m=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A];let _;v&&(v.$isError?(_=new Error,_.name=v.name,_.message=v.message,_.stack=v.stack):_=v),m.resolveErr(_)}}_invokeHandler(o,u,v){try{return Promise.resolve(this._doInvokeHandler(o,u,v))}catch(A){return Promise.reject(A)}}_doInvokeHandler(o,u,v){const A=this._locals[o];if(!A)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(o));let m=A[u];if(typeof m!="function")throw new Error("Unknown method "+u+" on actor "+(0,n.getStringIdentifierForProxy)(o));return m.apply(A,v)}_remoteCall(o,u,v){if(this._isDisposed)return Promise.reject(I.canceled());let A=null;if(v.length>0&&C.CancellationToken.isCancellationToken(v[v.length-1])&&(A=v.pop()),A&&A.isCancellationRequested)return Promise.reject(I.canceled());const m=t.serializeRequestArguments(v,this._uriReplacer),_=++this._lastMessageId,R=String(_),L=new y.LazyPromise;A&&A.onCancellationRequested(()=>{const he=t.serializeCancel(_);this._logger&&this._logger.logOutgoing(he.byteLength,_,0,"cancel"),this._protocol.send(t.serializeCancel(_))}),this._pendingRPCReplies[R]=L,this._onWillSendRequest(_);const V=t.serializeRequest(_,o,u,m,!!A);return this._logger&&this._logger.logOutgoing(V.byteLength,_,0,`request: ${(0,n.getStringIdentifierForProxy)(o)}.${u}(`,v),this._protocol.send(V),L}}e.RPCProtocol=c,k=b,c.UNRESPONSIVE_TIME=3*1e3;class w{constructor(o,u){this._buff=o,this._offset=u}static alloc(o,u,v){let A=new w(T.VSBuffer.alloc(v+1+4),0);return A.writeUInt8(o),A.writeUInt32(u),A}static read(o,u){return new w(o,u)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(o){this._buff.writeUInt8(o,this._offset),this._offset+=1}readUInt8(){const o=this._buff.readUInt8(this._offset);return this._offset+=1,o}writeUInt32(o){this._buff.writeUInt32BE(o,this._offset),this._offset+=4}readUInt32(){const o=this._buff.readUInt32BE(this._offset);return this._offset+=4,o}static sizeShortString(o){return 1+o.byteLength}writeShortString(o){this._buff.writeUInt8(o.byteLength,this._offset),this._offset+=1,this._buff.set(o,this._offset),this._offset+=o.byteLength}readShortString(){const o=this._buff.readUInt8(this._offset);this._offset+=1;const v=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,v}static sizeLongString(o){return 4+o.byteLength}writeLongString(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readLongString(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,v}writeBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}static sizeVSBuffer(o){return 4+o.byteLength}writeVSBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readVSBuffer(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const u=this._buff.slice(this._offset,this._offset+o);return this._offset+=o,u}static sizeMixedArray(o,u){let v=0;v+=1;for(let A=0,m=o.length;A<m;A++){const _=o[A],R=u[A];switch(v+=1,R){case 1:v+=this.sizeLongString(_);break;case 2:v+=this.sizeVSBuffer(_);break;case 3:break}}return v}writeMixedArray(o,u){this._buff.writeUInt8(o.length,this._offset),this._offset+=1;for(let v=0,A=o.length;v<A;v++){const m=o[v];switch(u[v]){case 1:this.writeUInt8(1),this.writeLongString(m);break;case 2:this.writeUInt8(2),this.writeVSBuffer(m);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const o=this._buff.readUInt8(this._offset);this._offset+=1;let u=new Array(o);for(let v=0;v<o;v++)switch(this.readUInt8()){case 1:u[v]=this.readLongString();break;case 2:u[v]=this.readVSBuffer();break;case 3:u[v]=void 0;break}return u}}class t{static _arrayContainsBufferOrUndefined(o){for(let u=0,v=o.length;u<v;u++)if(o[u]instanceof T.VSBuffer||typeof o[u]=="undefined")return!0;return!1}static serializeRequestArguments(o,u){if(this._arrayContainsBufferOrUndefined(o)){let v=[],A=[];for(let m=0,_=o.length;m<_;m++){const R=o[m];R instanceof T.VSBuffer?(v[m]=R,A[m]=2):typeof R=="undefined"?(v[m]=T.VSBuffer.alloc(0),A[m]=3):(v[m]=T.VSBuffer.fromString(h(R,u)),A[m]=1)}return{type:"mixed",args:v,argsType:A}}return{type:"simple",args:h(o,u)}}static serializeRequest(o,u,v,A,m){return A.type==="mixed"?this._requestMixedArgs(o,u,v,A.args,A.argsType,m):this._requestJSONArgs(o,u,v,A.args,m)}static _requestJSONArgs(o,u,v,A,m){const _=T.VSBuffer.fromString(v),R=T.VSBuffer.fromString(A);let L=0;L+=w.sizeUInt8(),L+=w.sizeShortString(_),L+=w.sizeLongString(R);let V=w.alloc(m?2:1,o,L);return V.writeUInt8(u),V.writeShortString(_),V.writeLongString(R),V.buffer}static deserializeRequestJSONArgs(o){const u=o.readUInt8(),v=o.readShortString(),A=o.readLongString();return{rpcId:u,method:v,args:JSON.parse(A)}}static _requestMixedArgs(o,u,v,A,m,_){const R=T.VSBuffer.fromString(v);let L=0;L+=w.sizeUInt8(),L+=w.sizeShortString(R),L+=w.sizeMixedArray(A,m);let V=w.alloc(_?4:3,o,L);return V.writeUInt8(u),V.writeShortString(R),V.writeMixedArray(A,m),V.buffer}static deserializeRequestMixedArgs(o){const u=o.readUInt8(),v=o.readShortString(),A=o.readMixedArray(),m=new Array(A.length);for(let _=0,R=A.length;_<R;_++){const L=A[_];typeof L=="string"?m[_]=JSON.parse(L):m[_]=L}return{rpcId:u,method:v,args:m}}static serializeAcknowledged(o){return w.alloc(5,o,0).buffer}static serializeCancel(o){return w.alloc(6,o,0).buffer}static serializeReplyOK(o,u,v){return typeof u=="undefined"?this._serializeReplyOKEmpty(o):u instanceof T.VSBuffer?this._serializeReplyOKVSBuffer(o,u):this._serializeReplyOKJSON(o,f(u,v))}static _serializeReplyOKEmpty(o){return w.alloc(7,o,0).buffer}static _serializeReplyOKVSBuffer(o,u){let v=0;v+=w.sizeVSBuffer(u);let A=w.alloc(8,o,v);return A.writeVSBuffer(u),A.buffer}static deserializeReplyOKVSBuffer(o){return o.readVSBuffer()}static _serializeReplyOKJSON(o,u){const v=T.VSBuffer.fromString(u);let A=0;A+=w.sizeLongString(v);let m=w.alloc(9,o,A);return m.writeLongString(v),m.buffer}static deserializeReplyOKJSON(o){const u=o.readLongString();return JSON.parse(u)}static serializeReplyErr(o,u){return u?this._serializeReplyErrEror(o,u):this._serializeReplyErrEmpty(o)}static _serializeReplyErrEror(o,u){const v=T.VSBuffer.fromString(f(I.transformErrorForSerialization(u),null));let A=0;A+=w.sizeLongString(v);let m=w.alloc(10,o,A);return m.writeLongString(v),m.buffer}static deserializeReplyErrError(o){const u=o.readLongString();return JSON.parse(u)}static _serializeReplyErrEmpty(o){return w.alloc(11,o,0).buffer}}var i;(function(s){s[s.RequestJSONArgs=1]="RequestJSONArgs",s[s.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",s[s.RequestMixedArgs=3]="RequestMixedArgs",s[s.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",s[s.Acknowledged=5]="Acknowledged",s[s.Cancel=6]="Cancel",s[s.ReplyOKEmpty=7]="ReplyOKEmpty",s[s.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",s[s.ReplyOKJSON=9]="ReplyOKJSON",s[s.ReplyErrError=10]="ReplyErrError",s[s.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var l;(function(s){s[s.String=1]="String",s[s.VSBuffer=2]="VSBuffer",s[s.Undefined=3]="Undefined"})(l||(l={}))}),define(be[215],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const E=function(P){const S=D=>{self.removeEventListener("message",S);const y=D.data;Object.defineProperties(self,{postMessage:{value(n,T){y.postMessage(n,T)}},onmessage:{get(){return y.onmessage},set(n){y.onmessage=n}}}),y.addEventListener("message",n=>{self.dispatchEvent(new MessageEvent("message",{data:n.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(P)};self.addEventListener("message",S)}.toString();class C extends EventTarget{constructor(P,S,D){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${E})('${S}'))`,n=new Blob([y],{type:"application/javascript"}),T=URL.createObjectURL(n),k=new MessageChannel,f=T,h={type:"_newWorker",id:f,port:k.port2,url:T,options:D};P(h,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:f};k.port1.postMessage(r),URL.revokeObjectURL(T),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(r){k.port1.onmessage=r}},onmessageerror:{get(){return k.port1.onmessageerror},set(r){k.port1.onmessageerror=r}}}),k.port1.addEventListener("messageerror",r=>{const a=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(a)}),k.port1.addEventListener("message",r=>{const a=new MessageEvent("message",{data:r.data});this.dispatchEvent(a)}),k.port1.start()}}e.NestedWorker=C}),define(be[216],we([0,1,4]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,E.createDecorator)("remoteAgentService")}),define(be[217],we([0,1,18,13,21,2,4,216]),function(Y,e,E,C,I,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let y=class{constructor(T,k){this.localUserHome=T,this.remoteAgentService=k,this.resolveOS=(async()=>{const f=await this.remoteAgentService.getEnvironment();return(f==null?void 0:f.os)||I.OS})(),this.resolveUserHome=(async()=>{const f=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(f==null?void 0:f.userHome)||T})()}async userHome(T){return(T==null?void 0:T.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(T=>T===1?C.win32:C.posix)}async fileURI(T){let k="";if(await this.resolveOS===1&&(T=T.replace(/\\/g,"/")),T[0]==="/"&&T[1]==="/"){const h=T.indexOf("/",2);h===-1?(k=T.substring(2),T="/"):(k=T.substring(2,h),T=T.substring(h)||"/")}return P.URI.from({scheme:E.Schemas.file,authority:k,path:T,query:"",fragment:""})}};y=je([Ke(1,D.IRemoteAgentService)],y),e.AbstractPathService=y}),define(be[41],we([0,1,12,28,24,37,8,4,13,11]),function(Y,e,E,C,I,P,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const T="\u27EA ",k=" characters skipped \u27EB",f=(T.length+k.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var h;(function(O){O[O.file=0]="file",O[O.text=1]="text"})(h=e.SearchProviderType||(e.SearchProviderType={}));var r;(function(O){O[O.File=1]="File",O[O.Text=2]="Text"})(r=e.QueryType||(e.QueryType={}));function a(O){return!!O.preview}e.resultIsMatch=a;function p(O){return!!O.resource}e.isFileMatch=p;function d(O){return!!O.message}e.isProgressMessage=d;var b;(function(O){O[O.Normal=0]="Normal",O[O.NewSearchStarted=1]="NewSearchStarted"})(b=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(F){this.resource=F,this.results=[]}}e.FileMatch=g;class c{constructor(F,N,B){this.ranges=N;const U=Array.isArray(N)?N:[N];if(B&&B.matchLines===1&&w(U)){F=(0,S.getNLines)(F,B.matchLines);let Q="",Z=0,ne=0;const pe=Math.floor(B.charsPerLine/5),Pe=[];for(const Oe of U){const Te=Math.max(Oe.startColumn-pe,0),xe=Oe.startColumn+B.charsPerLine;if(Te>ne+pe+f){const $=T+(Te-ne)+k;Q+=$+F.slice(Te,xe),Z+=Te-(ne+$.length)}else Q+=F.slice(ne,xe);Pe.push(new i(0,Oe.startColumn-Z,Oe.endColumn-Z)),ne=xe}this.preview={text:Q,matches:Array.isArray(this.ranges)?Pe:Pe[0]}}else{const Q=Array.isArray(N)?N[0].startLineNumber:N.startLineNumber;this.preview={text:F,matches:(0,E.mapArrayOrNot)(N,Z=>new t(Z.startLineNumber-Q,Z.startColumn,Z.endLineNumber-Q,Z.endColumn))}}}}e.TextSearchMatch=c;function w(O){const F=O[0].startLineNumber;for(const N of O)if(N.startLineNumber!==F||N.endLineNumber!==F)return!1;return!0}class t{constructor(F,N,B,U){this.startLineNumber=F,this.startColumn=N,this.endLineNumber=B,this.endColumn=U}}e.SearchRange=t;class i extends t{constructor(F,N,B){super(F,N,F,B)}}e.OneLineRange=i;var l;(function(O){O.Default="default",O.FileNames="fileNames",O.Type="type",O.Modified="modified",O.CountDescending="countDescending",O.CountAscending="countAscending"})(l=e.SearchSortOrder||(e.SearchSortOrder={}));function s(O,F=!0){const N=O&&O.files&&O.files.exclude,B=F&&O&&O.search&&O.search.exclude;if(!(!N&&!B)){if(!N||!B)return N||B;let U=Object.create(null);return U=I.mixin(U,I.deepClone(N)),U=I.mixin(U,I.deepClone(B),!0),U}}e.getExcludes=s;function o(O,F){return O.excludePattern&&C.match(O.excludePattern,F)?!1:O.includePattern||O.usingSearchPaths?O.includePattern&&C.match(O.includePattern,F)?!0:O.usingSearchPaths?!!O.folderQueries&&O.folderQueries.some(N=>{const B=N.folder.fsPath;if(P.isEqualOrParent(F,B)){const U=y.relative(B,F);return!N.includePattern||!!C.match(N.includePattern,U)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var u;(function(O){O[O.unknownEncoding=1]="unknownEncoding",O[O.regexParseError=2]="regexParseError",O[O.globParseError=3]="globParseError",O[O.invalidLiteral=4]="invalidLiteral",O[O.rgProcessError=5]="rgProcessError",O[O.other=6]="other",O[O.canceled=7]="canceled"})(u=e.SearchErrorCode||(e.SearchErrorCode={}));class v extends Error{constructor(F,N){super(F);this.code=N}}e.SearchError=v;function A(O){const F=O.message;if((0,n.isPromiseCanceledError)(O))return new v(F,u.canceled);try{const N=JSON.parse(F);return new v(N.message,N.code)}catch(N){return new v(F,u.other)}}e.deserializeSearchError=A;function m(O){const F={message:O.message,code:O.code};return new Error(JSON.stringify(F))}e.serializeSearchError=m;function _(O){return O.type==="error"?!0:O.type==="success"}e.isSerializedSearchComplete=_;function R(O){return O.type==="success"}e.isSerializedSearchSuccess=R;function L(O){return!!O.path}e.isSerializedFileMatch=L;function V(O,F){const N=O.searchPath?O.searchPath:O.relativePath;return(0,S.fuzzyContains)(N,F)}e.isFilePatternMatch=V;class he{constructor(F){this.path=F,this.results=[]}addMatch(F){this.results.push(F)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=he;function z(O,F){const N=Object.assign(Object.assign({},O||{}),F||{});return Object.keys(N).filter(B=>{const U=N[B];return typeof U=="boolean"&&U})}e.resolvePatternsForProvider=z;class W{constructor(F,N){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},F.excludePattern||{}),N.excludePattern||{}),this._parsedExcludeExpression=C.parse(this._excludeExpression);let B=F.includePattern;N.includePattern&&(B?B=Object.assign(Object.assign({},B),N.includePattern):B=N.includePattern),B&&(this._parsedIncludeExpression=C.parse(B))}includedInQuerySync(F,N,B){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(F,N,B)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(F,N,B))}includedInQuery(F,N,B){return Promise.resolve(this._parsedExcludeExpression(F,N,B)).then(Q=>!!Q).then(Q=>Q?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(F,N,B)).then(Z=>!!Z):Promise.resolve(!0)).then(Q=>Q)}hasSiblingExcludeClauses(){return J(this._excludeExpression)}}e.QueryGlobTester=W;function J(O){for(const F in O)if(typeof O[F]!="boolean")return!0;return!1}}),define(be[31],we([0,1,12,14,20,3,22,18,81,25,8,10,2,137,4,19,152,48,49,27,15,7,41,5]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h,r,a,p,d,b,g,c,w,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function l(R,L,V){return new n.ExtUri(he=>v(he,V)).isEqual(R,L)}function s(R,L,V){return l(R.uri,L.uri,V)?0:(0,T.compare)(R.uri.toString(),L.uri.toString())}function o(R,L,V){return R.index!==L.index?R.index<L.index?-1:1:l(R.uri,L.uri,V)?(0,T.compare)(R.name,L.name):(0,T.compare)(R.uri.toString(),L.uri.toString())}function u(R,L,V,he){const z=R.slice(0).sort((J,O)=>V(J,O,he)),W=L.slice(0).sort((J,O)=>V(J,O,he));return(0,E.delta)(z,W,(J,O)=>V(J,O,he))}function v(R,L){const V=L.getCapabilities(R.scheme);return!(V&&V&1024)}class A extends d.Workspace{constructor(L,V,he,z,W,J){super(L,he.map(O=>new d.WorkspaceFolder(O)),z,J);this._name=V,this._isUntitled=W,this._workspaceFolders=[],this._structure=S.TernarySearchTree.forUris(J),he.forEach(O=>{this._workspaceFolders.push(O),this._structure.set(O.uri,O)})}static toExtHostWorkspace(L,V,he,z){if(!L)return{workspace:null,added:[],removed:[]};const{id:W,name:J,folders:O,configuration:F,isUntitled:N}=L,B=[],U=V;V?O.forEach((pe,Pe)=>{const Oe=f.URI.revive(pe.uri),Te=A._findFolder(he||V,Oe,z);Te?(Te.name=pe.name,Te.index=pe.index,B.push(Te)):B.push({uri:Oe,name:pe.name,index:Pe})}):B.push(...O.map(({uri:pe,name:Pe,index:Oe})=>({uri:f.URI.revive(pe),name:Pe,index:Oe}))),B.sort((pe,Pe)=>pe.index<Pe.index?-1:1);const Q=new A(W,J,B,F?f.URI.revive(F):null,!!N,pe=>v(pe,z)),{added:Z,removed:ne}=u(U?U.workspaceFolders:[],Q.workspaceFolders,s,z);return{workspace:Q,added:Z,removed:ne}}static _findFolder(L,V,he){for(let z=0;z<L.folders.length;z++){const W=L.workspaceFolders[z];if(l(W.uri,V,he))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,V){return V&&this._structure.get(L)&&(L=(0,n.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let m=class{constructor(L,V,he,z){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidReceieveWorkspaceTrust=new P.Emitter,this.onDidReceiveWorkspaceTrust=this._onDidReceieveWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=z,this._extHostFileSystemInfo=he,this._requestIdProvider=new y.Counter,this._barrier=new C.Barrier,this._proxy=L.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(i.MainContext.MainThreadMessageService);const W=V.workspace;this._confirmedWorkspace=W?new A(W.id,W.name,[],W.configuration?f.URI.revive(W.configuration):null,!!W.isUntitled,J=>v(J,he)):void 0}$initializeWorkspace(L,V){this._trusted=V,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?f.URI.from({scheme:D.Schemas.untitled,path:(0,n.basename)((0,n.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,V,he,...z){const W=[];if(Array.isArray(z)&&z.forEach(B=>{f.URI.isUri(B.uri)&&!W.some(U=>l(U.uri,B.uri,this._extHostFileSystemInfo))&&W.push({uri:B.uri,name:B.name||(0,n.basenameOrAuthority)(B.uri)})}),this._unconfirmedWorkspace||[V,he].some(B=>typeof B!="number"||B<0)||he===0&&W.length===0)return!1;const J=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(V+he>J.length)return!1;const O=J.slice(0);O.splice(V,he,...W.map(B=>({uri:B.uri,name:B.name||(0,n.basenameOrAuthority)(B.uri),index:void 0})));for(let B=0;B<O.length;B++){const U=O[B];if(O.some((Q,Z)=>Z!==B&&l(U.uri,Q.uri,this._extHostFileSystemInfo)))return!1}O.forEach((B,U)=>B.index=U);const{added:F,removed:N}=u(J,O,o,this._extHostFileSystemInfo);if(F.length===0&&N.length===0)return!1;if(this._proxy){const B=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(B,V,he,W).then(void 0,U=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,h.localize)(0,null,B,U.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(O),!0}getWorkspaceFolder(L,V){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,V)}async getWorkspaceFolder2(L,V){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,V)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!!this._actualWorkspace){const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}}getRelativePath(L,V){let he,z="";if(typeof L=="string"?(he=f.URI.file(L),z=L):typeof L!="undefined"&&(he=L,z=L.fsPath),!he)return z;const W=this.getWorkspaceFolder(he,!0);if(!W)return z;typeof V=="undefined"&&this._actualWorkspace&&(V=this._actualWorkspace.folders.length>1);let J=(0,n.relativePath)(W.uri,he);return V&&W.name&&(J=`${W.name}/${J}`),J}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=A.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:V,added:he,removed:z}=A.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=V||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:he,removed:z}))}findFiles(L,V,he,z,W=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let J;if(V===null?J=!1:V&&(typeof V=="string"?J=V:J=V.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:O,folder:F}=_(L);return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(O),(0,k.withUndefinedAsNull)(F),(0,k.withUndefinedAsNull)(J),(0,k.withUndefinedAsNull)(he),W).then(N=>Array.isArray(N)?N.map(B=>f.URI.revive(B)):[])}async findTextInFiles(L,V,he,z,W=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const J=this._requestIdProvider.getNext(),O=typeof V.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:V.previewOptions,{includePattern:F,folder:N}=_(V.include),B=typeof V.exclude=="string"?V.exclude:V.exclude?V.exclude.pattern:void 0,U={ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles=="boolean"?!V.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof V.useGlobalIgnoreFiles=="boolean"?!V.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof V.useDefaultExcludes=="boolean"?!V.useDefaultExcludes:!0,fileEncoding:V.encoding,maxResults:V.maxResults,previewOptions:O,afterContext:V.afterContext,beforeContext:V.beforeContext,includePattern:F,excludePattern:B},Q=!1;if(this._activeSearchCallbacks[J]=Z=>{if(!Q){const ne=f.URI.revive(Z.resource);Z.results.forEach(pe=>{(0,t.resultIsMatch)(pe)?he({uri:ne,preview:{text:pe.preview.text,matches:(0,E.mapArrayOrNot)(pe.preview.matches,Pe=>new w.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))},ranges:(0,E.mapArrayOrNot)(pe.ranges,Pe=>new w.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))}):he({uri:ne,text:pe.text,lineNumber:pe.lineNumber})})}},W.isCancellationRequested)return{};try{const Z=await this._proxy.$startTextSearch(L,(0,k.withUndefinedAsNull)(N),U,J,W);return delete this._activeSearchCallbacks[J],Z||{}}catch(Z){throw delete this._activeSearchCallbacks[J],Z}}$handleTextSearchResult(L,V){this._activeSearchCallbacks[V]&&this._activeSearchCallbacks[V](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidReceiveWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidReceieveWorkspaceTrust.fire())}};m=je([Ke(0,c.IExtHostRpcService),Ke(1,g.IExtHostInitDataService),Ke(2,b.IExtHostFileSystemInfo),Ke(3,a.ILogService)],m),e.ExtHostWorkspace=m,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function _(R){let L,V;return R&&(typeof R=="string"?L=R:(L=R.pattern,V=R.baseFolder||f.URI.file(R.base))),{includePattern:L,folder:V}}}),define(be[34],we([0,1,24,3,31,5,7,154,67,10,14,4,15,19,2]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(i,l){if(l){const s=l.split(".");let o=i;for(let u=0;o&&u<s.length;u++)o=o[s[u]];return o}}function p(i){return i instanceof r.URI}function d(i){return i&&i.uri instanceof r.URI&&i.languageId&&typeof i.languageId=="string"}function b(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function g(i){return i&&i.uri instanceof r.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function c(i){if(p(i))return{resource:i};if(d(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(b(i))return{overrideIdentifier:i.languageId};if(g(i))return{resource:i.uri};if(i===null)return{resource:null}}let w=class{constructor(l,s,o){this._proxy=l.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=o,this._barrier=new T.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(l=>this._actual)}$initializeConfiguration(l){this._actual=new t(this._proxy,this._extHostWorkspace,l,this._logService),this._barrier.open()}$acceptConfigurationChanged(l,s){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(l,s))}};w=je([Ke(0,f.IExtHostRpcService),Ke(1,I.IExtHostWorkspace),Ke(2,h.ILogService)],w),e.ExtHostConfiguration=w;class t{constructor(l,s,o,u){this._onDidChangeConfiguration=new C.Emitter,this._proxy=l,this._logService=u,this._extHostWorkspace=s,this._configuration=D.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(l,s){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,o))}getConfiguration(l,s,o){const u=c(s)||{},v=this._toReadonlyValue(l?a(this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace),l):this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace));l&&this._validateConfigurationAccess(l,u,o==null?void 0:o.identifier);function A(_){if(_==null)return null;if(typeof _=="boolean")return _?1:4;switch(_){case S.ConfigurationTarget.Global:return 1;case S.ConfigurationTarget.Workspace:return 4;case S.ConfigurationTarget.WorkspaceFolder:return 5}}const m={has(_){return typeof a(v,_)!="undefined"},get:(_,R)=>{this._validateConfigurationAccess(l?`${l}.${_}`:_,u,o==null?void 0:o.identifier);let L=a(v,_);if(typeof L=="undefined")L=R;else{let V;const he=(z,W)=>{let J;const O=()=>{V=V||(0,E.deepClone)(v),J=J||a(V,W)};return(0,n.isObject)(z)?new Proxy(z,{get:(F,N)=>{if(typeof N=="string"&&N.toLowerCase()==="tojson")return O(),()=>J;if(V)return J=J||a(V,W),J[N];const B=F[N];return typeof N=="string"?he(B,`${W}.${N}`):B},set:(F,N,B)=>(O(),J&&(J[N]=B),!0),deleteProperty:(F,N)=>(O(),J&&delete J[N],!0),defineProperty:(F,N,B)=>(O(),J&&Object.defineProperty(J,N,B),!0)}):z};L=he(L,_)}return L},update:(_,R,L,V)=>{_=l?`${l}.${_}`:_;const he=A(L);return R!==void 0?this._proxy.$updateConfigurationOption(he,_,R,u,V):this._proxy.$removeConfigurationOption(he,_,u,V)},inspect:_=>{var R,L,V,he,z,W,J,O;_=l?`${l}.${_}`:_;const F=(0,E.deepClone)(this._configuration.inspect(_,u,this._extHostWorkspace.workspace));if(F)return{key:_,defaultValue:(R=F.default)===null||R===void 0?void 0:R.value,globalValue:(L=F.user)===null||L===void 0?void 0:L.value,workspaceValue:(V=F.workspace)===null||V===void 0?void 0:V.value,workspaceFolderValue:(he=F.workspaceFolder)===null||he===void 0?void 0:he.value,defaultLanguageValue:(z=F.default)===null||z===void 0?void 0:z.override,globalLanguageValue:(W=F.user)===null||W===void 0?void 0:W.override,workspaceLanguageValue:(J=F.workspace)===null||J===void 0?void 0:J.override,workspaceFolderLanguageValue:(O=F.workspaceFolder)===null||O===void 0?void 0:O.override,languageIds:F.overrideIdentifiers}}};return typeof v=="object"&&(0,E.mixin)(m,v,!1),Object.freeze(m)}_toReadonlyValue(l){const s=o=>(0,n.isObject)(o)?new Proxy(o,{get:(u,v)=>s(u[v]),set:(u,v,A)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(u,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(u,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return s(l)}_validateConfigurationAccess(l,s,o){const u=y.OVERRIDE_PROPERTY_PATTERN.test(l)?4:this._configurationScopes.get(l),v=o?`[${o.value}] `:"";if(u===4){typeof(s==null?void 0:s.resource)=="undefined"&&this._logService.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){(s==null?void 0:s.resource)&&this._logService.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(l,s){const o=new D.ConfigurationChangeEvent(l,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(u,v)=>o.affectsConfiguration(u,c(v))})}_toMap(l){return l.reduce((s,o)=>(s.set(o[0],o[1]),s),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(Y,e,E,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(Y,E):I?I.value=E:e.set(Y,E),E},Me=this&&this.__classPrivateFieldGet||function(Y,e,E,C){if(E==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?C:E==="a"?C.call(Y):C?C.value:e.get(Y)};define(be[102],we([0,1,2,14,3,5,7,31,39,34,20,40,15,27,4,18,21,19,75,171,11]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h,r,a,p,d,b,g,c){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(z){function W(O){if(O!=null)return O}z.from=W;function J(O){if(O!=null)return O}z.to=J})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(z){function W(O){if(O!=null)return O}z.from=W;function J(O){if(O!=null)return O}z.to=J})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var l;(function(z){function W(O){if(O!=null)return O}z.from=W;function J(O){if(O!=null)return O}z.to=J})(l=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(z){function W(F){if(F){const N=F;return N&&!!N.process}else return!1}z.is=W;function J(F){if(F!=null){const N={process:F.process,args:F.args};return F.options&&(N.options=l.from(F.options)),N}}z.from=J;function O(F){if(F!=null)return new S.ProcessExecution(F.process,F.args,F.options)}z.to=O})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(z){function W(O){if(O!=null)return O}z.from=W;function J(O){if(O!=null)return O}z.to=J})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var u;(function(z){function W(F){if(F){const N=F;return N&&(!!N.commandLine||!!N.command)}else return!1}z.is=W;function J(F){if(F!=null){const N={};return F.commandLine!==void 0?N.commandLine=F.commandLine:(N.command=F.command,N.args=F.args),F.options&&(N.options=o.from(F.options)),N}}z.from=J;function O(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new S.ShellExecution(F.commandLine,F.options):new S.ShellExecution(F.command,F.args?F.args:[],F.options)}z.to=O})(u=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var v;(function(z){function W(F){if(F){let N=F;return N&&N.customExecution==="customExecution"}else return!1}z.is=W;function J(F){return{customExecution:"customExecution"}}z.from=J;function O(F,N){return N.get(F)}z.to=O})(v=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var A;(function(z){function W(J,O){let F;return J.scope!==void 0&&typeof J.scope!="number"?F=J.scope.uri:J.scope!==void 0&&typeof J.scope=="number"&&(J.scope===S.TaskScope.Workspace&&O&&O.workspaceFile?F=O.workspaceFile:F=g.USER_TASKS_GROUP_KEY),{id:J._id,workspaceFolder:F}}z.from=W})(A=e.TaskHandleDTO||(e.TaskHandleDTO={}));var m;(function(z){function W(F,N){if(F==null)return[];const B=[];for(let U of F){const Q=J(U,N);Q&&B.push(Q)}return B}z.fromMany=W;function J(F,N){if(F!=null){let B;F.execution instanceof S.ProcessExecution?B=s.from(F.execution):F.execution instanceof S.ShellExecution?B=u.from(F.execution):F.execution&&F.execution instanceof S.CustomExecution&&(B=v.from(F.execution));const U=t.from(F.definition);let Q;if(F.scope?typeof F.scope=="number"?Q=F.scope:Q=F.scope.uri:Q=S.TaskScope.Workspace,!(!U||!Q)){const Z=F.group?F.group.id:void 0;return{_id:F._id,definition:U,name:F.name,source:{extensionId:N.identifier.value,label:F.source,scope:Q},execution:B,isBackground:F.isBackground,group:Z,presentationOptions:i.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}}}z.from=J;async function O(F,N,B){if(F!=null){let U;s.is(F.execution)?U=s.to(F.execution):u.is(F.execution)?U=u.to(F.execution):v.is(F.execution)&&(U=v.to(F._id,B));const Q=t.to(F.definition);let Z;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?Z=F.source.scope:Z=await N.resolveWorkspaceFolder(E.URI.revive(F.source.scope)):Z=S.TaskScope.Workspace),!(!Q||!Z)){const ne=new S.Task(Q,Z,F.name,F.source.label,U,F.problemMatchers);return F.isBackground!==void 0&&(ne.isBackground=F.isBackground),F.group!==void 0&&(ne.group=S.TaskGroup.from(F.group)),F.presentationOptions&&(ne.presentationOptions=i.to(F.presentationOptions)),F._id&&(ne._id=F._id),F.detail&&(ne.detail=F.detail),ne}}}z.to=O})(m=e.TaskDTO||(e.TaskDTO={}));var _;(function(z){function W(O){return O}z.from=W;function J(O){if(!!O)return Object.assign(Object.create(null),O)}z.to=J})(_=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(W,J,O){this._id=J,this._task=O,w.set(this,void 0),tt(this,w,W,"f")}get task(){return this._task}terminate(){Me(this,w,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}w=new WeakMap;var L;(function(z){function W(J){return{id:J._id,task:void 0}}z.from=W})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let V=class{constructor(W,J,O,F,N,B,U,Q){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=W.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=O,this._editorService=F,this._configurationService=N,this._terminalService=B,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=U,this._deprecationService=Q,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,J,O){if(!O)return new S.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:J,provider:O,extension:W}),this._proxy.$registerTaskProvider(F,J),new S.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(W,J){this._proxy.$registerTaskSystem(W,J)}fetchTasks(W){return this._proxy.$fetchTasks(_.from(W)).then(async J=>{const O=[];for(let F of J){const N=await m.to(F,this._workspaceProvider,this._providedCustomExecutions2);N&&O.push(N)}return O})}get taskExecutions(){const W=[];return this._taskExecutions.forEach(J=>W.push(J)),W}terminateTask(W){if(!(W instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,J,O){const F=this._providedCustomExecutions2.get(W.id);if(F){if(this._activeCustomExecutions2.get(W.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(W.id,F),this._terminalService.attachPtyToTerminal(J,await F.callback(O))}this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const J=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:J})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const J=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:J,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const J=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:J,exitCode:W.exitCode})}$provideTasks(W,J){const O=this._handlers.get(W);if(!O)return Promise.reject(new Error("no handler found"));const F=[],N=(0,C.asPromise)(()=>O.provider.provideTasks(T.CancellationToken.None)).then(B=>this.provideTasksInternal(J,F,O,B));return new Promise(B=>{N.then(U=>{Promise.all(F).then(()=>{B(U)})})})}async $resolveTask(W,J){const O=this._handlers.get(W);if(!O)return Promise.reject(new Error("no handler found"));if(J.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${J.definition.type}] cannot be resolved by provider of type [${O.type}].`);const F=await m.to(J,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const N=await O.provider.resolveTask(F,T.CancellationToken.None);if(!!N){this.checkDeprecation(N,O);const B=m.from(N,O.extension);if(!B)throw new Error("Unexpected: Task cannot be resolved.");if(N.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(B.execution)&&await this.addCustomExecution(B,N,!0),await this.resolveTaskInternal(B)}}nextHandle(){return this._handleCounter++}async addCustomExecution(W,J,O){const F=await this._proxy.$createTaskId(W);!O&&!this._providedCustomExecutions2.has(F)&&this._notProvidedCustomExecutions.add(F),this._providedCustomExecutions2.set(F,J.execution)}async getTaskExecution(W,J){if(typeof W=="string"){const N=this._taskExecutionPromises.get(W);if(!N)throw new Error("Unexpected: The specified task is missing an execution");return N}let O=this._taskExecutionPromises.get(W.id);if(O)return O;const F=new Promise(async(N,B)=>{const U=J||await m.to(W.task,this._workspaceProvider,this._providedCustomExecutions2);U?N(new R(this,W.id,U)):B("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(W.id,F),F.then(N=>(this._taskExecutions.set(W.id,N),N),N=>Promise.reject(N))}checkDeprecation(W,J){W._deprecated&&this._deprecationService.report("Task.constructor",J.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let O=this._notProvidedCustomExecutions.values(),F=O.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=O.next()}};V=je([Ke(0,f.IExtHostRpcService),Ke(1,h.IExtHostInitDataService),Ke(2,D.IExtHostWorkspace),Ke(3,y.IExtHostDocumentsAndEditors),Ke(4,n.IExtHostConfiguration),Ke(5,k.IExtHostTerminalService),Ke(6,d.ILogService),Ke(7,b.IExtHostApiDeprecationService)],V),e.ExtHostTaskBase=V;let he=class extends V{constructor(W,J,O,F,N,B,U,Q){super(W,J,O,F,N,B,U,Q);this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(W,J){if(!J.execution)throw new Error("Tasks to execute must include an execution");const O=m.from(J,W);if(O===void 0)throw new Error("Task is not valid");if(v.is(O.execution))await this.addCustomExecution(O,J,!1);else throw new c.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(O),J);return this._proxy.$executeTask(O).catch(N=>{throw new Error(N)}),F}provideTasksInternal(W,J,O,F){const N=[];if(F)for(let B of F){this.checkDeprecation(B,O),(!B.definition||!W[B.definition.type])&&this._logService.warn(`The task [${B.source}, ${B.name}] uses an undefined task type. The task will be ignored in the future.`);const U=m.from(B,O.extension);U&&v.is(U.execution)?(N.push(U),J.push(this.addCustomExecution(U,B,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:N,extension:O.extension}}async resolveTaskInternal(W){if(v.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,J){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(W,J,O){}};he=je([Ke(0,f.IExtHostRpcService),Ke(1,h.IExtHostInitDataService),Ke(2,D.IExtHostWorkspace),Ke(3,y.IExtHostDocumentsAndEditors),Ke(4,n.IExtHostConfiguration),Ke(5,k.IExtHostTerminalService),Ke(6,d.ILogService),Ke(7,b.IExtHostApiDeprecationService)],he),e.WorkerExtHostTask=he,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(Y,e,E,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(Y,E):I?I.value=E:e.set(Y,E),E},Me=this&&this.__classPrivateFieldGet||function(Y,e,E,C){if(E==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?C:E==="a"?C.call(Y):C?C.value:e.get(Y)},$t=this&&this.__rest||function(Y,e){var E={};for(var C in Y)Object.prototype.hasOwnProperty.call(Y,C)&&e.indexOf(C)<0&&(E[C]=Y[C]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function")for(var I=0,C=Object.getOwnPropertySymbols(Y);I<C.length;I++)e.indexOf(C[I])<0&&Object.prototype.propertyIsEnumerable.call(Y,C[I])&&(E[C[I]]=Y[C[I]]);return E};define(be[218],we([0,1,12,14,23,20,3,54,43,6,24,10,2,29,5,39,15,70,9,7,31,182,96]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h,r,a,p,d,b,g,c,w,t){"use strict";var i,l,s,o;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const u=(O,F)=>`${O}:${F.toString()}`;let v=class{constructor(F,N,B){this.documents=N,this.workspace=B,this.resultsChangedEmitter=new S.Emitter,this.controllers=new Map,this.ownedTests=new w.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(r.MainContext.MainThreadTesting),this.runQueue=new A(this.proxy),this.workspaceObservers=new W(this.proxy),this.textDocumentObservers=new J(this.proxy,N)}registerTestController(F,N){const B=(0,h.generateUuid)();this.controllers.set(B,{instance:N,extensionId:F}),this.proxy.$registerTestController(B);const U=[...this.testControllers.keys()];return setTimeout(()=>{var Q;for(const Z of U)(Q=this.testControllers.get(Z))===null||Q===void 0||Q.subscribeFn(B,N)},0),new g.Disposable(()=>{this.controllers.delete(B),this.proxy.$unregisterTestController(B)})}createTextDocumentTestObserver(F){return this.textDocumentObservers.checkout(F.uri)}createWorkspaceTestObserver(F){return this.workspaceObservers.checkout(F.uri)}async runTests(F,N=P.CancellationToken.None){const B=U=>U.map(this.getInternalTestForReference,this).filter(k.isDefined).map(Q=>({src:Q.src,testId:Q.item.extId}));await this.proxy.$runTests({exclude:F.exclude?B(F.exclude).map(U=>U.testId):void 0,tests:B(F.tests),debug:F.debug},N)}createTestRunTask(F,N,B,U=!0){return this.runQueue.createTestRunTask(F,N,B,U)}$publishTestResults(F){this.results=Object.freeze(F.map(N=>(0,T.deepFreeze)(b.TestResults.to(N))).concat(this.results).sort((N,B)=>B.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(F,N){const B=f.URI.revive(N),U=u(F,B);if(!this.testControllers.has(U)){const Q=new P.CancellationTokenSource;let Z;if(F===1){let Oe=this.documents.getDocument(B);if(!Oe){const Te=new n.DisposableStore;Oe=await new Promise(xe=>{Te.add((0,C.disposableTimeout)(()=>xe(void 0),5e3)),Te.add(this.documents.onDidAddDocuments($=>{const G=$.find(ie=>ie.document.uri.toString()===B.toString());G&&xe(G)}))}).finally(()=>Te.dispose())}if(Oe){const Te=await this.workspace.getWorkspaceFolder2(B,!1);Z=xe=>xe.createDocumentTestRoot?xe.createDocumentTestRoot(Oe.document,Q.token):(0,e.createDefaultDocumentTestRoot)(xe,Oe.document,Te,Q.token)}}else{const Oe=await this.workspace.getWorkspaceFolder2(B,!1);Oe&&(Z=Te=>Te.createWorkspaceTestRoot(Oe,Q.token))}if(!!Z){const ne=async(Oe,Te)=>{try{const xe=await Z(Te);xe&&Pe.addRoot(xe,Oe)}catch(xe){console.error(xe)}},pe=new n.DisposableStore,Pe=pe.add(this.ownedTests.createForHierarchy(Oe=>this.proxy.$publishDiff(F,N,Oe)));pe.add((0,n.toDisposable)(()=>Q.dispose(!0)));for(const[Oe,Te]of this.controllers)ne(Oe,Te.instance);Pe.pushDiff([3,-1]),this.testControllers.set(U,{store:pe,collection:Pe,subscribeFn:ne})}}}async $expandTest(F,N){const B=(0,E.mapFind)(this.testControllers.values(),U=>U.collection.treeId===F.src.tree?U:void 0);await(B==null?void 0:B.collection.expand(F.testId,N<0?Infinity:N)),this.flushCollectionDiffs()}$unsubscribeFromTests(F,N){var B;const U=f.URI.revive(N),Q=u(F,U);(B=this.testControllers.get(Q))===null||B===void 0||B.store.dispose(),this.testControllers.delete(Q)}$acceptDiff(F,N,B){F===1?this.textDocumentObservers.acceptDiff(f.URI.revive(N),B):this.workspaceObservers.acceptDiff(f.URI.revive(N),B)}async $runTestsForProvider(F,N){const B=this.controllers.get(F.tests[0].src.controller);if(!!B){const U=F.tests.map(({testId:ne,src:pe})=>this.ownedTests.getTestById(ne,pe==null?void 0:pe.tree)).filter(k.isDefined).map(([ne,pe])=>pe),Q=F.excludeExtIds.map(ne=>this.ownedTests.getTestById(ne)).filter(k.isDefined).filter(([ne,pe])=>U.some(Pe=>ne.comparePositions(Pe,pe)===1));if(!!U.length){const Z={tests:U.map(ne=>L.unwrap(ne.actual)),exclude:Q.map(([,ne])=>L.unwrap(ne.actual)),debug:F.debug};await this.runQueue.enqueueRun({dto:m.fromInternal(F),token:N,extensionId:B.extensionId,req:Z,doRun:()=>B.instance.runTests(Z,N)})}}}$lookupTest(F){const N=this.ownedTests.getTestById(F.testId);if(!N)return Promise.resolve(void 0);const B=N[1],{actual:U,discoverCts:Q,expandLevels:Z}=B,ne=$t(B,["actual","discoverCts","expandLevels"]);return Promise.resolve(ne)}flushCollectionDiffs(){for(const{collection:F}of this.testControllers.values())F.flushDiff()}getInternalTestForReference(F){var N,B;return(B=(N=this.workspaceObservers.getMirroredTestDataByReference(F))!==null&&N!==void 0?N:(0,E.mapFind)(this.testControllers.values(),U=>U.collection.getTestByReference(F)))!==null&&B!==void 0?B:this.textDocumentObservers.getMirroredTestDataByReference(F)}};v=je([Ke(0,p.IExtHostRpcService),Ke(1,a.IExtHostDocumentsAndEditors),Ke(2,c.IExtHostWorkspace)],v),e.ExtHostTesting=v;class A{constructor(F){this.proxy=F,this.state=new Map}enqueueRun(F){let N=this.state.get(F.extensionId);N||(N={queue:[],current:void 0},this.state.set(F.extensionId,N));const B=new C.DeferredPromise,U=()=>{const Q=[],Z=new Set;N.current={publicReq:F.req,factory:ne=>{const pe=new _(ne,F.dto,Z,this.proxy);return Q.push(pe),F.token.onCancellationRequested(()=>pe.end()),pe}},this.invokeRunner(F.extensionId,F.dto.id,F.doRun,Q).finally(()=>B.complete())};return N.queue.push(U),N.queue.length===1&&U(),B.p}createTestRunTask(F,N,B,U){var Q,Z;const ne=this.state.get(F);if((ne==null?void 0:ne.current.publicReq)===N)return ne.current.factory(B);const pe=m.fromPublic(N),Pe=new _(B,pe,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:N.debug,exclude:(Z=(Q=N.exclude)===null||Q===void 0?void 0:Q.map(Oe=>Oe.id))!==null&&Z!==void 0?Z:[],id:pe.id,tests:N.tests.map(Oe=>Oe.id),persist:U}),Pe.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(pe.id)),Pe}invokeRunner(F,N,B,U){try{const Q=B();return(0,C.isThenable)(Q)?Q.then(()=>this.handleInvokeResult(F,N,U,void 0)).catch(Z=>this.handleInvokeResult(F,N,U,Z)):this.handleInvokeResult(F,N,U,void 0)}catch(Q){return this.handleInvokeResult(F,N,U,Q)}}async handleInvokeResult(F,N,B,U){const Q=this.state.get(F);!Q||(Q.queue.shift(),Q.queue.length>0?Q.queue[0]():this.state.delete(F),await Promise.all(B.map(Z=>Z.onEnd.wait())))}}class m{constructor(F,N,B){this.id=F,this.include=N,this.exclude=B}static fromPublic(F){var N,B;return new m((0,h.generateUuid)(),new Set(F.tests.map(U=>U.id)),new Set((B=(N=F.exclude)===null||N===void 0?void 0:N.map(U=>U.id))!==null&&B!==void 0?B:y.Iterable.empty()))}static fromInternal(F){return new m(F.runId,new Set(F.tests.map(N=>N.testId)),new Set(F.excludeExtIds))}isIncluded(F){for(let N=F;N;N=N.parent){if(this.include.has(N.id))return!0;if(this.exclude.has(N.id))return!1}return!0}}class _{constructor(F,N,B,U){this.name=F,i.set(this,void 0),l.set(this,void 0),s.set(this,(0,h.generateUuid)()),o.set(this,void 0),this.onEnd=new C.Barrier,tt(this,i,U,"f"),tt(this,l,N,"f"),tt(this,o,B,"f"),U.$startedTestRunTask(N.id,{id:Me(this,s,"f"),name:F,running:!0})}setState(F,N,B){Me(this,l,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),Me(this,i,"f").$updateTestStateInRun(Me(this,l,"f").id,Me(this,s,"f"),F.id,N,B))}appendMessage(F,N){Me(this,l,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),Me(this,i,"f").$appendTestMessageInRun(Me(this,l,"f").id,Me(this,s,"f"),F.id,b.TestMessage.from(N)))}appendOutput(F){Me(this,i,"f").$appendOutputToRun(Me(this,l,"f").id,Me(this,s,"f"),I.VSBuffer.fromString(F))}end(){Me(this,i,"f").$finishedTestRunTask(Me(this,l,"f").id,Me(this,s,"f")),this.onEnd.open()}ensureTestIsKnown(F){const N=Me(this,o,"f");if(!N.has(F.id)){const B=[];for(;B.unshift(b.TestItem.from(F)),!(N.has(F.id)||(N.add(F.id),!F.parent));)F=F.parent;Me(this,i,"f").$addTestsToRun(Me(this,l,"f").id,B)}}}i=new WeakMap,l=new WeakMap,s=new WeakMap,o=new WeakMap;const R=async(O,F,N,B)=>{if(!!N){const U=await O.createWorkspaceTestRoot(N,B);if(!!U)return B.onCancellationRequested(()=>{L.removeFilter(F)}),L.getWrapperForTestItem(U,F)}};e.createDefaultDocumentTestRoot=R;class L extends g.TestItemImpl{constructor(F,N,B){super(F.id,F.label,F.uri,void 0);if(this.actual=F,this.filterDocument=N,this.actualParent=B,!(F instanceof g.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${F.id} did not`);this.debuggable=F.debuggable,this.runnable=F.runnable,this.description=F.description,this.error=F.error,this.status=F.status;const U=(0,d.getPrivateApiFor)(this);(0,d.getPrivateApiFor)(F).bus.event(Z=>{switch(Z[0]){case 3:this[Z[1]]=Z[2];break;case 0:const ne=L.getWrapperForTestItem(Z[1],this.filterDocument,this);(0,d.getPrivateApiFor)(ne).parent=F,ne.refreshMatch();break;default:U.bus.fire(Z)}})}static removeFilter(F){this.wrapperMap.delete(F)}static getWrapperForTestItem(F,N,B){let U=this.wrapperMap.get(N);if(U==null?void 0:U.has(F))return U.get(F);U||(U=new WeakMap,this.wrapperMap.set(N,U));const Q=new L(F,N,B);return U.set(F,Q),Q}static unwrap(F){return F instanceof L?F.actual:F}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var F;const N=this._cachedMatchesFilter;for(const U of this.actual.children.values()){const Q=L.getWrapperForTestItem(U,this.filterDocument,this);Q.hasNodeMatchingFilter?this.addChild(Q):Q.dispose()}const B=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=B,B!==N&&((F=this.actualParent)===null||F===void 0||F.refreshMatch()),this._cachedMatchesFilter}}e.TestItemFilteredWrapper=L,L.wrapperMap=new WeakMap;class V extends t.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,b.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:N,removed:B}=this;return{get added(){return[...F].map(U=>U.revived)},get updated(){return[...N].map(U=>U.revived)},get removed(){return[...B].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class he extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(F){let N=[];for(const B of F){const U=this.items.get(B);U&&N.push(U.revived)}return N}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,N){return Object.assign(Object.assign({},F),{revived:b.TestItem.toPlain(F.item),depth:N?N.depth+1:0,children:new Set})}createChangeCollector(){return new V(this.changeEmitter)}}e.MirroredTestCollection=he;class z{constructor(){this.resources=new Map}checkout(F){var N,B;const U=F.toString(),Q=(N=this.resources.get(U))!==null&&N!==void 0?N:this.createObserverData(F);return(B=Q.pendingDeletion)===null||B===void 0||B.dispose(),Q.observers++,{onDidChangeTest:Q.tests.onDidChangeTests,onDidDiscoverInitialTests:new S.Emitter().event,get tests(){return Q.tests.rootTestItems},dispose:(0,D.once)(()=>{--Q.observers||(Q.pendingDeletion=this.eventuallyDispose(F))})}}getMirroredTestDataByReference(F){for(const{tests:N}of this.resources.values()){const B=N.getMirroredTestDataByReference(F);if(B)return B}}eventuallyDispose(F){return(0,C.disposableTimeout)(()=>this.unlisten(F),10*1e3)}createObserverData(F){const N=new he,B=this.listen(F,Q=>N.apply(Q)),U={observers:0,tests:N,listener:B};return this.resources.set(F.toString(),U),U}unlisten(F){var N;const B=F.toString(),U=this.resources.get(B);U&&(U.observers=-1,(N=U.pendingDeletion)===null||N===void 0||N.dispose(),U.listener.dispose(),this.resources.delete(B))}}class W extends z{constructor(F){super();this.proxy=F,this.diffListeners=new Map}acceptDiff(F,N){var B;(B=this.diffListeners.get(F.toString()))===null||B===void 0||B(N)}listen(F,N){this.proxy.$subscribeToDiffs(0,F);const B=F.toString();return this.diffListeners.set(B,N),new g.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,F),this.diffListeners.delete(B)})}}class J extends z{constructor(F,N){super();this.proxy=F,this.documents=N,this.diffListeners=new Map}acceptDiff(F,N){var B;(B=this.diffListeners.get(F.toString()))===null||B===void 0||B(N)}listen(F,N){if(!this.documents.getDocument(F))return new g.Disposable(()=>{});const U=F.toString();return this.diffListeners.set(U,N),this.proxy.$subscribeToDiffs(1,F),new g.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,F),this.diffListeners.delete(U)})}}}),define(be[219],we([0,1,12,52,28,59,22,18,13,25,8,10,2,115,140,92,48,174,217,41]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h,r,a,p,d,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let c=class{constructor(A,m,_,R){this.configurationService=A,this.workspaceContextService=m,this.editorGroupsService=_,this.pathService=R}text(A,m,_={}){A=this.getContentPattern(A,_);const R=this.configurationService.getValue(),L=m&&m.some(he=>!this.configurationService.getValue({resource:he}).search.useRipgrep),V=this.commonQuery(m==null?void 0:m.map(p.toWorkspaceFolder),_);return Object.assign(Object.assign({},V),{type:2,contentPattern:A,previewOptions:_.previewOptions,maxFileSize:_.maxFileSize,usePCRE2:R.search.usePCRE2||L||!1,beforeContext:_.beforeContext,afterContext:_.afterContext,userDisabledExcludesAndIgnoreFiles:_.disregardExcludeSettings&&_.disregardIgnoreFiles})}getContentPattern(A,m){const _=this.configurationService.getValue();A.isRegExp&&(A.pattern=A.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},A),{wordSeparators:_.editor.wordSeparators});return this.isCaseSensitive(A,m)&&(R.isCaseSensitive=!0),this.isMultiline(A)&&(R.isMultiline=!0),R}file(A,m={}){const _=this.commonQuery(A,m);return Object.assign(Object.assign({},_),{type:1,filePattern:m.filePattern?m.filePattern.trim():m.filePattern,exists:m.exists,sortByScore:m.sortByScore,cacheKey:m.cacheKey})}handleIncludeExclude(A,m){return A?(A=Array.isArray(A)?A.map(s):s(A),m?this.parseSearchPaths(A):{pattern:t(...Array.isArray(A)?A:[A])}):{}}commonQuery(A=[],m={}){const _=this.handleIncludeExclude(m.includePattern,m.expandPatterns),R=this.handleIncludeExclude(m.excludePattern,m.expandPatterns),L=A.length>1,V=(_.searchPaths&&_.searchPaths.length?_.searchPaths.map(W=>this.getFolderQueryForSearchPath(W,m,R)):A.map(W=>this.getFolderQueryForRoot(W,m,R,L))).filter(W=>!!W),he={_reason:m._reason,folderQueries:V,usingSearchPaths:!!(_.searchPaths&&_.searchPaths.length),extraFileResources:m.extraFileResources,excludePattern:R.pattern,includePattern:_.pattern,onlyOpenEditors:m.onlyOpenEditors,maxResults:m.maxResults};if(m.onlyOpenEditors){const J=E.coalesce(E.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(N=>N.resource)))).filter(F=>(0,g.pathIncludedInQuery)(he,F.fsPath)),O=this.commonQueryFromFileList(J);return Object.assign(Object.assign({},he),O)}const z=m.extraFileResources&&m.extraFileResources.filter(W=>(0,g.pathIncludedInQuery)(he,W.fsPath));return he.extraFileResources=z&&z.length?z:void 0,he}commonQueryFromFileList(A){const m=[],_=new S.ResourceMap,R={};let L=!1;return A.forEach(V=>{var he,z;if(V.scheme!==D.Schemas.walkThrough)if((0,n.isAbsolutePath)(V)){const J=(z=(he=this.workspaceContextService.getWorkspaceFolder(V))===null||he===void 0?void 0:he.uri)!==null&&z!==void 0?z:V.with({path:y.dirname(V.fsPath)});let O=_.get(J);O||(L=!0,O={folder:J,includePattern:{}},m.push(O),_.set(J,O));const F=y.relative(J.fsPath,V.fsPath);(0,k.assertIsDefined)(O.includePattern)[F.replace(/\\/g,"/")]=!0}else V.fsPath&&(L=!0,R[V.fsPath]=!0)}),{folderQueries:m,includePattern:R,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(A,m){if(m.isSmartCase){if(A.isRegExp){if(T.containsUppercaseCharacter(A.pattern,!0))return!0}else if(T.containsUppercaseCharacter(A.pattern))return!0}return!!A.isCaseSensitive}isMultiline(A){return A.isMultiline||A.isRegExp&&(0,h.isMultilineRegexSource)(A.pattern)||A.pattern.indexOf(`
`)>=0?!0:!!A.isMultiline}parseSearchPaths(A){const m=O=>y.isAbsolute(O)||/^\.\.?([\/\\]|$)/.test(O),R=(Array.isArray(A)?A:i(A)).map(O=>{const F=this.pathService.resolvedUserHome;return F?(0,P.untildify)(O,F.scheme===D.Schemas.file?F.fsPath:F.path):O}),L=C.groupBy(R,O=>m(O)?"searchPaths":"exprSegments"),V=(L.exprSegments||[]).map(O=>T.rtrim(O,"/")).map(O=>T.rtrim(O,"\\")).map(O=>(O[0]==="."&&(O="*"+O),l(O))),he={},z=this.expandSearchPathPatterns(L.searchPaths||[]);z&&z.length&&(he.searchPaths=z);const W=E.flatten(V),J=t(...W);return J&&(he.pattern=J),he}getExcludesForFolder(A,m){return m.disregardExcludeSettings?void 0:(0,g.getExcludes)(A,!m.disregardSearchExcludeSettings)}expandSearchPathPatterns(A){if(!A||!A.length)return[];const m=E.flatten(A.map(R=>{let{pathPortion:L,globPortion:V}=w(R);V&&(V=o(V));const he=this.expandOneSearchPath(L);return E.flatten(he.map(z=>this.resolveOneSearchPathPattern(z,V)))})),_=new Map;return m.forEach(R=>{const L=R.searchPath.toString(),V=_.get(L);V?R.pattern&&(V.pattern=V.pattern||{},V.pattern[R.pattern]=!0):_.set(L,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(_.values())}expandOneSearchPath(A){if(y.isAbsolute(A)){const m=this.workspaceContextService.getWorkspace().folders;return m[0]&&m[0].uri.scheme!==D.Schemas.file?[{searchPath:m[0].uri.with({path:A})}]:[{searchPath:f.URI.file(y.normalize(A))}]}if(this.workspaceContextService.getWorkbenchState()===2){const m=this.workspaceContextService.getWorkspace().folders[0].uri;if(A=s(A),A.startsWith("../")||A===".."){const R=y.posix.resolve(m.path,A);return[{searchPath:m.with({path:R})}]}const _=o(A);return[{searchPath:m,pattern:_}]}else{if(A==="./"||A===".\\")return[];{const m=A.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(m){const _=m[1],R=this.workspaceContextService.getWorkspace().folders.filter(L=>L.name===_);if(R.length)return R.map(L=>{const V=m[2];return{searchPath:L.uri,pattern:V&&o(V)}});{const L=r.localize(0,null,_);throw new Error(L)}}}}return[]}resolveOneSearchPathPattern(A,m){const _=A.pattern&&m?`${A.pattern}/${m}`:A.pattern||m,R=[{searchPath:A.searchPath,pattern:_}];return _&&!_.endsWith("**")&&R.push({searchPath:A.searchPath,pattern:_+"/**"}),R}getFolderQueryForSearchPath(A,m,_){const R=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(A.searchPath),m,_,!1);return R?Object.assign(Object.assign({},R),{includePattern:A.pattern}):null}getFolderQueryForRoot(A,m,_,R){let L;const V=f.URI.isUri(A)?A:A.uri;if(_.searchPaths){const O=_.searchPaths.filter(F=>(0,n.isEqual)(F.searchPath,V))[0];if(O&&!O.pattern)return null;O&&(L=O.pattern)}const he=this.configurationService.getValue({resource:V}),z=this.getExcludesForFolder(he,m),W=Object.assign(Object.assign({},z||{}),L||{}),J=f.URI.isUri(A)?(0,n.basename)(A):A.name;return{folder:V,folderName:R?J:void 0,excludePattern:Object.keys(W).length>0?W:void 0,fileEncoding:he.files&&he.files.encoding,disregardIgnoreFiles:typeof m.disregardIgnoreFiles=="boolean"?m.disregardIgnoreFiles:!he.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof m.disregardGlobalIgnoreFiles=="boolean"?m.disregardGlobalIgnoreFiles:!he.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof m.ignoreSymlinks=="boolean"?m.ignoreSymlinks:!he.search.followSymlinks}}};c=je([Ke(0,a.IConfigurationService),Ke(1,p.IWorkspaceContextService),Ke(2,d.IEditorGroupsService),Ke(3,b.IPathService)],c),e.QueryBuilder=c;function w(v){const A=v.match(/[\*\{\}\(\)\[\]\?]/);if(A){const m=A.index,_=v.substr(0,m).match(/[/|\\][^/\\]*$/);if(_){let R=v.substr(0,_.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:v.substr((_.index||0)+1)}}}return{pathPortion:v}}function t(...v){return v.length?v.reduce((A,m)=>(A[m]=!0,A),Object.create(null)):void 0}function i(v){return I.splitGlobAware(v,",").map(A=>A.trim()).filter(A=>!!A.length)}function l(v){return[`**/${v}/**`,`**/${v}`].map(m=>m.replace(/\*\*\/\*\*/g,"**"))}function s(v){return v.replace(/\\/g,"/")}function o(v){return s(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(v,A){v=E.distinct(v,R=>R.toString());const m=[],_=A.getWorkspace();return v&&v.forEach(R=>{let L;if(A.getWorkbenchState()===2)L=(0,n.relativePath)(_.folders[0].uri,R),L&&L!=="."&&(L="./"+L);else{const V=A.getWorkspaceFolder(R);if(V){const he=V.name;if(_.folders.filter(W=>W.name===he).length===1){const W=(0,n.relativePath)(V.uri,R);W===""?L=`./${V.name}`:L=`./${V.name}/${W}`}else L=R.fsPath}}L&&m.push(L)}),m}e.resolveResourcesForSearchIncludes=u}),define(be[220],we([0,1,25,2,20,11,4,219,41,48]),function(Y,e,E,C,I,P,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const T=7e3;function k(a,p){const d=p.activationEvents;if(!d)return Promise.resolve(void 0);const b=[],g=[];for(const s of d)if(/^workspaceContains:/.test(s)){const o=s.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||a.forceUsingSearch?g.push(o):b.push(o)}if(b.length===0&&g.length===0)return Promise.resolve(void 0);let c;const w=new Promise((s,o)=>{c=s}),t=s=>c({activationEvent:s}),i=Promise.all(b.map(s=>f(a,s,t))).then(()=>{}),l=h(a,p.identifier,g,t);return Promise.all([i,l]).then(()=>{c(void 0)}),w}e.checkActivateWorkspaceContainsExtension=k;async function f(a,p,d){for(const b of a.folders)if(await a.exists(E.joinPath(C.URI.revive(b),p))){d(`workspaceContains:${p}`);return}}async function h(a,p,d,b){if(d.length===0)return Promise.resolve(void 0);const g=new I.CancellationTokenSource,c=a.checkExists(a.folders,d,g.token),w=setTimeout(async()=>{g.cancel(),b(`workspaceContainsTimeout:${d.join(",")}`)},T);let t=!1;try{t=await c}catch(i){P.isPromiseCanceledError(i)||P.onUnexpectedError(i)}g.dispose(),clearTimeout(w),t&&b(`workspaceContains:${d.join(",")}`)}function r(a,p,d,b){const g=a.get(S.IInstantiationService),c=a.get(y.ISearchService),t=g.createInstance(D.QueryBuilder).file(p.map(i=>(0,n.toWorkspaceFolder)(C.URI.revive(i))),{_reason:"checkExists",includePattern:d,exists:!0});return c.fileSearch(t,b).then(i=>!!i.limitHit,i=>P.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=r});var tt=this&&this.__classPrivateFieldSet||function(Y,e,E,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(Y,E):I?I.value=E:e.set(Y,E),E},Me=this&&this.__classPrivateFieldGet||function(Y,e,E,C){if(E==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?C:E==="a"?C.call(Y):C?C.value:e.get(Y)};define(be[35],we([0,1,132,13,80,25,14,6,22,2,19,5,34,185,78,31,33,183,11,26,18,23,161,7,68,4,27,79,15,66,71,40,3,220,74,162]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h,r,a,p,d,b,g,c,w,t,i,l,s,o,u,v,A,m,_,R,L,V,he){"use strict";var z,W,J;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let O=class Tn extends D.Disposable{constructor(U,Q,Z,ne,pe,Pe,Oe,Te,xe,$){super();this._onDidChangeRemoteConnectionData=this._register(new R.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Q,this._extHostContext=Z,this._initData=Oe,this._extHostWorkspace=ne,this._extHostConfiguration=pe,this._logService=Pe,this._extHostTunnelService=xe,this._extHostTerminalService=$,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new S.Barrier,this._readyToStartExtensionHost=new S.Barrier,this._readyToRunExtensions=new S.Barrier,this._eagerExtensionsActivated=new S.Barrier,this._registry=new d.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new V.ExtHostSecretState(this._extHostContext),this._storagePath=Te,this._instaService=U.createChild(new A.ServiceCollection([r.IExtHostStorage,this._storage],[V.IExtHostSecretState,this._secretState]));const G=new Set;this._initData.hostExtensions.forEach(ie=>G.add(g.ExtensionIdentifier.toKey(ie))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ie,oe)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ie,oe)},actualActivateExtension:async(ie,oe)=>{if(G.has(g.ExtensionIdentifier.toKey(ie)))return await this._mainThreadExtensionsProxy.$activateExtension(ie,oe),new h.HostExtension;const me=this._registry.getExtensionDescription(ie);return this._activateExtension(me,oe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(U){b.onUnexpectedError(U)}}async deactivateAll(){let U=[];try{U=this._registry.getAllExtensionDescriptions().map(pe=>pe.identifier).filter(pe=>this.isActivated(pe)).map(pe=>this._deactivate(pe))}catch(Q){}await Promise.all(U)}isActivated(U){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(U):!1}_activateByEvent(U,Q){return this._activator.activateByEvent(U,Q)}_activateById(U,Q){return this._activator.activateById(U,Q)}activateByIdWithErrors(U,Q){return this._activateById(U,Q).then(()=>{const Z=this._activator.getActivatedExtension(U);if(Z.activationFailed)return Promise.reject(Z.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(U=>this._registry)}getExtensionExports(U){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(U).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const U=y.TernarySearchTree.forPaths(),Q=this._registry.getAllExtensionDescriptions().map(Z=>{if(!!this._getEntryPoint(Z))return this._hostUtils.realpath(Z.extensionLocation.fsPath).then(ne=>U.set(n.URI.file(ne).fsPath,Z))});this._extensionPathIndex=Promise.all(Q).then(()=>U)}return this._extensionPathIndex}_deactivate(U){let Q=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(U))return Q;const Z=this._activator.getActivatedExtension(U);if(!Z)return Q;try{typeof Z.module.deactivate=="function"&&(Q=Promise.resolve(Z.module.deactivate()).then(void 0,ne=>Promise.resolve(void 0)))}catch(ne){}try{(0,D.dispose)(Z.subscriptions)}catch(ne){}return Q}async _activateExtension(U,Q){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier),this._doActivateExtension(U,Q).then(Z=>{const ne=Z.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(U.identifier,ne.codeLoadingTime,ne.activateCallTime,ne.activateResolvedTime,Q),this._logExtensionActivationTimes(U,Q,"success",ne),Z},Z=>{throw this._logExtensionActivationTimes(U,Q,"failure"),Z})}_logExtensionActivationTimes(U,Q,Z,ne){const pe=F(U,Q);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},pe),ne||{}),{outcome:Z}))}_doActivateExtension(U,Q){const Z=F(U,Q);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Z);const ne=this._getEntryPoint(U);if(!ne)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${U.identifier.value} ${JSON.stringify(Q)}`),this._logService.flush();const pe=new h.ExtensionActivationTimesBuilder(Q.startup);return Promise.all([this._loadCommonJSModule(U.identifier,(0,P.joinPath)(U.extensionLocation,ne),pe),this._loadExtensionContext(U)]).then(Pe=>(I.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),Tn._callActivate(this._logService,U.identifier,Pe[0],Pe[1],pe))).then(Pe=>(I.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),Pe))}_loadExtensionContext(U){const Q=new t.ExtensionGlobalMemento(U,this._storage),Z=new t.ExtensionMemento(U.identifier.value,!1,this._storage),ne=new he.ExtensionSecrets(U,this._secretState),pe=U.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Pe=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([Q.whenReady,Z.whenReady,this._storagePath.whenReady]).then(()=>{const Oe=this;let Te;return Object.freeze({globalState:Q,workspaceState:Z,secrets:ne,subscriptions:[],get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(xe){return C.join(U.extensionLocation.fsPath,xe)},get storagePath(){var xe;return(xe=Oe._storagePath.workspaceValue(U))===null||xe===void 0?void 0:xe.fsPath},get globalStoragePath(){return Oe._storagePath.globalValue(U).fsPath},get logPath(){return C.join(Oe._initData.logsLocation.fsPath,U.identifier.value)},get logUri(){return n.URI.joinPath(Oe._initData.logsLocation,U.identifier.value)},get storageUri(){return Oe._storagePath.workspaceValue(U)},get globalStorageUri(){return Oe._storagePath.globalValue(U)},get extensionMode(){return pe},get extension(){return Te===void 0&&(Te=new N(Oe,U.identifier,U,Pe)),Te},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(U),Oe.extensionRuntime},get environmentVariableCollection(){return Oe._extHostTerminalService.getEnvironmentVariableCollection(U)}})})}static _callActivate(U,Q,Z,ne,pe){return Z=Z||{activate:void 0,deactivate:void 0},this._callActivateOptional(U,Q,Z,ne,pe).then(Pe=>new h.ActivatedExtension(!1,null,pe.build(),Z,Pe,ne.subscriptions))}static _callActivateOptional(U,Q,Z,ne,pe){if(typeof Z.activate=="function")try{pe.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${Q.value}`);const Pe=typeof global=="object"?global:self,Oe=Z.activate.apply(Pe,[ne]);return pe.activateCallStop(),pe.activateResolveStart(),Promise.resolve(Oe).then(Te=>(pe.activateResolveStop(),Te))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(Z)}_activateOneStartupFinished(U,Q){this._activateById(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:Q}).then(void 0,Z=>{this._logService.error(Z)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const U of this._registry.getAllExtensionDescriptions())if(U.activationEvents)for(const Q of U.activationEvents)Q==="onStartupFinished"&&this._activateOneStartupFinished(U,Q)}_handleEagerExtensions(){const U=this._activateByEvent("*",!0).then(void 0,pe=>{this._logService.error(pe)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(pe=>this._handleWorkspaceContainsEagerExtensions(pe.added)));const Q=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Z=this._handleWorkspaceContainsEagerExtensions(Q),ne=Promise.all([U,Z]).then(()=>{});return Promise.race([ne,(0,S.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ne}_handleWorkspaceContainsEagerExtensions(U){return U.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Q=>this._handleWorkspaceContainsEagerExtension(U,Q))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(U,Q){if(!this.isActivated(Q.identifier)){const Z=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ne={folders:U.map(Pe=>Pe.uri),forceUsingSearch:Z,exists:Pe=>this._hostUtils.exists(Pe.fsPath),checkExists:(Pe,Oe,Te)=>this._mainThreadWorkspaceProxy.$checkExists(Pe,Oe,Te)},pe=await(0,L.checkActivateWorkspaceContainsExtension)(ne,Q);if(!!pe)return this._activateById(Q.identifier,{startup:!0,extensionId:Q.identifier,activationEvent:pe.activationEvent}).then(void 0,Pe=>this._logService.error(Pe))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(U){throw console.error(U),U}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:Q}=this._initData.environment;if(!U||!Q||Q.scheme!==c.Schemas.file)throw new Error(E.localize(0,null));const Z=(0,P.originalFSPath)(Q),ne=await this._loadCommonJSModule(null,Q,new h.ExtensionActivationTimesBuilder(!1));if(!ne||typeof ne.run!="function")throw new Error(E.localize(1,null,Z));return new Promise((pe,Pe)=>{const Oe=(xe,$)=>{xe?Pe(xe):pe(typeof $=="number"&&$>0?1:0)},Te=ne.run(Z,Oe);Te&&Te.then&&Te.then(()=>{pe(0)}).catch(xe=>{Pe(xe.toString())})})}async $extensionTestsExit(U){this._logService.info(`extension host terminating: test runner requested exit with code ${U}`),this._logService.info(`exiting with code ${U}`),this._logService.flush(),this._hostUtils.exit(U)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(U,Q){return this._resolvers[U]=Q,(0,D.toDisposable)(()=>{delete this._resolvers[U]})}async $resolveAuthority(U,Q){const Z=U.indexOf("+");if(Z===-1)throw new Error("Not an authority that can be resolved!");const ne=U.substr(0,Z);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ne}`,!1);const pe=this._resolvers[ne];if(!pe)return{type:"error",error:{code:l.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ne}.`,detail:void 0}};try{I.mark(`code/extHost/willResolveAuthority/${ne}`);const Pe=await pe.resolve(U,{resolveAttempt:Q});I.mark(`code/extHost/didResolveAuthorityOK/${ne}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(pe));const Oe={authority:U,host:Pe.host,port:Pe.port,connectionToken:Pe.connectionToken},Te={extensionHostEnv:Pe.extensionHostEnv,trust:Pe.trust};return{type:"ok",value:{authority:Oe,options:Te,tunnelInformation:{environmentTunnels:Pe.environmentTunnels}}}}catch(Pe){if(I.mark(`code/extHost/didResolveAuthorityError/${ne}`),Pe instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:Pe._code,message:Pe._message,detail:Pe._detail}};throw Pe}}$startExtensionHost(U){return this._registry.keepOnly(U),this._startExtensionHost()}$activateByEvent(U,Q){return Q===1?this._activateByEvent(U,!1):this._readyToRunExtensions.wait().then(Z=>this._activateByEvent(U,!1))}async $activate(U,Q){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(U)?(await this._activateById(U,Q),!0):!1}async $deltaExtensions(U,Q){U.forEach(ne=>ne.extensionLocation=n.URI.revive(ne.extensionLocation));const Z=await this.getExtensionPathIndex();return await Promise.all(Q.map(async ne=>{const pe=this._registry.getExtensionDescription(ne);if(!!pe){const Pe=await this._hostUtils.realpath(pe.extensionLocation.fsPath);Z.delete(n.URI.file(Pe).fsPath)}})),await Promise.all(U.map(async ne=>{const pe=await this._hostUtils.realpath(ne.extensionLocation.fsPath);Z.set(n.URI.file(pe).fsPath,ne)})),this._registry.deltaExtensions(U,Q),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){let Q=w.VSBuffer.alloc(U),Z=Math.random()%256;for(let ne=0;ne<U;ne++)Q.writeUInt8(Z,ne);return Q}async $updateRemoteConnectionData(U){this._remoteConnectionData=U,this._onDidChangeRemoteConnectionData.fire()}};O=je([Ke(0,s.IInstantiationService),Ke(1,e.IHostUtils),Ke(2,v.IExtHostRpcService),Ke(3,a.IExtHostWorkspace),Ke(4,f.IExtHostConfiguration),Ke(5,T.ILogService),Ke(6,o.IExtHostInitDataService),Ke(7,u.IExtensionStoragePaths),Ke(8,m.IExtHostTunnelService),Ke(9,_.IExtHostTerminalService)],O),e.AbstractExtHostExtensionService=O;function F(B,U){return{id:B.identifier.value,name:B.name,extensionVersion:B.version,publisherDisplayName:B.publisher,activationEvents:B.activationEvents?B.activationEvents.join(","):null,isBuiltin:B.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class N{constructor(U,Q,Z,ne){z.set(this,void 0),W.set(this,void 0),J.set(this,void 0),tt(this,z,U,"f"),tt(this,W,Q,"f"),tt(this,J,Z.identifier,"f"),this.id=Z.identifier.value,this.extensionUri=Z.extensionLocation,this.extensionPath=C.normalize((0,P.originalFSPath)(Z.extensionLocation)),this.packageJSON=Z,this.extensionKind=ne}get isActive(){return Me(this,z,"f").isActivated(Me(this,J,"f"))}get exports(){if(this.packageJSON.api!=="none")return Me(this,z,"f").getExtensionExports(Me(this,J,"f"))}activate(){return Me(this,z,"f").activateByIdWithErrors(Me(this,J,"f"),{startup:!1,extensionId:Me(this,W,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=N,z=new WeakMap,W=new WeakMap,J=new WeakMap}),define(be[103],we([0,1,13,2,3,14,5,7,169,31,35,39,173,34,170,15,4,10,46]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h,r,a,p,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let g=class{constructor(u,v,A,m,_){this._workspaceService=v,this._extensionService=A,this._editorsService=m,this._configurationService=_,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=u.getProxy(S.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new w(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange(L=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(u,v){const A=u;if(typeof A.sourceReference=="number"&&A.sourceReference>0){let m=`debug:${encodeURIComponent(A.path||"")}`,_="?";return v&&(m+=`${_}session=${encodeURIComponent(v.id)}`,_="&"),m+=`${_}ref=${A.sourceReference}`,C.URI.parse(m)}else{if(A.path)return C.URI.file(A.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(u){const v=[];for(const A of u.getAllExtensionDescriptions())if(A.contributes){const m=A.contributes.debuggers;if(m&&m.length>0)for(const _ of m)(0,r.isDebuggerMainContribution)(_)&&v.push(_.type)}this._debugServiceProxy.$registerDebugTypes(v)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const u=[];return this._breakpoints.forEach(v=>u.push(v)),u}addBreakpoints(u){this.startBreakpoints();const v=u.filter(_=>{const R=_.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,_),!0)});this.fireBreakpointChanges(v,[],[]);const A=[],m=new Map;for(const _ of v)if(_ instanceof D.SourceBreakpoint){let R=m.get(_.location.uri.toString());R||(R={type:"sourceMulti",uri:_.location.uri,lines:[]},m.set(_.location.uri.toString(),R),A.push(R)),R.lines.push({id:_.id,enabled:_.enabled,condition:_.condition,hitCondition:_.hitCondition,logMessage:_.logMessage,line:_.location.range.start.line,character:_.location.range.start.character})}else _ instanceof D.FunctionBreakpoint&&A.push({type:"function",id:_.id,enabled:_.enabled,hitCondition:_.hitCondition,logMessage:_.logMessage,condition:_.condition,functionName:_.functionName});return this._debugServiceProxy.$registerBreakpoints(A)}removeBreakpoints(u){this.startBreakpoints();const v=u.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],v,[]);const A=v.filter(R=>R instanceof D.SourceBreakpoint).map(R=>R.id),m=v.filter(R=>R instanceof D.FunctionBreakpoint).map(R=>R.id),_=v.filter(R=>R instanceof D.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(A,m,_)}startDebugging(u,v,A){return this._debugServiceProxy.$startDebugging(u?u.uri:void 0,v,{parentSessionID:A.parentSession?A.parentSession.id:void 0,repl:A.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:A.noDebug,compact:A.compact})}stopDebugging(u){return this._debugServiceProxy.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,v,A){if(!v)return new D.Disposable(()=>{});const m=this._configProviderHandleCounter++;return this._configProviders.push({type:u,handle:m,provider:v}),this._debugServiceProxy.$registerDebugConfigurationProvider(u,A,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,m),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(_=>_.provider!==v),this._debugServiceProxy.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(u,v,A){if(!A)return new D.Disposable(()=>{});if(!this.definesDebugType(u,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.getAdapterDescriptorFactoryByType(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:v,handle:m,factory:A}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(v,m),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(_=>_.factory!==A),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(u,v){if(!v)return new D.Disposable(()=>{});const A=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:u,handle:A,factory:v}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(m=>m.factory!==v)})}async $runInTerminal(u,v){return Promise.resolve(void 0)}async $substituteVariables(u,v){if(!this._variableResolver){const[_,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(_||[],this._editorsService,R)}let A;const m=await this.getFolder(u);return m&&(A={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(A,v)}createDebugAdapter(u,v){if(u.type==="implementation")return new l(u.implementation)}createSignService(){}async $startDASession(u,v){const A=this,m=await this.getSession(v);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(m.type),m).then(_=>{if(!_)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const R=this.convertToDto(_),L=this.createDebugAdapter(R,m);if(!L)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const V=L;return this._debugAdapters.set(u,V),this.getDebugAdapterTrackers(m).then(he=>(he&&this._debugAdaptersTrackers.set(u,he),V.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const W=z,J={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const O=await this._signService.sign(W.arguments.value);J.body={signature:O},V.sendResponse(J)}else throw new Error("no signer")}catch(O){J.success=!1,J.message=O.message,V.sendResponse(J)}}else he&&he.onDidSendMessage&&he.onDidSendMessage(z),z=(0,r.convertToVSCPaths)(z,!0),A._debugServiceProxy.$acceptDAMessage(u,z)}),V.onError(z=>{he&&he.onError&&he.onError(z),this._debugServiceProxy.$acceptDAError(u,z.name,z.message,z.stack)}),V.onExit(z=>{he&&he.onExit&&he.onExit((0,d.withNullAsUndefined)(z),void 0),this._debugServiceProxy.$acceptDAExit(u,(0,d.withNullAsUndefined)(z),void 0)}),he&&he.onWillStartSession&&he.onWillStartSession(),V.startSession()))})}$sendDAMessage(u,v){v=(0,r.convertToDAPaths)(v,!1);const A=this._debugAdaptersTrackers.get(u);A&&A.onWillReceiveMessage&&A.onWillReceiveMessage(v);const m=this._debugAdapters.get(u);m&&m.sendMessage(v)}$stopDASession(u){const v=this._debugAdaptersTrackers.get(u);this._debugAdaptersTrackers.delete(u),v&&v.onWillStopSession&&v.onWillStopSession();const A=this._debugAdapters.get(u);return this._debugAdapters.delete(u),A?A.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const v=[],A=[],m=[];if(u.added)for(const _ of u.added){const R=_.id;if(R&&!this._breakpoints.has(R)){let L;if(_.type==="function")L=new D.FunctionBreakpoint(_.functionName,_.enabled,_.condition,_.hitCondition,_.logMessage);else if(_.type==="data")L=new D.DataBreakpoint(_.label,_.dataId,_.canPersist,_.enabled,_.hitCondition,_.condition,_.logMessage);else{const V=C.URI.revive(_.uri);L=new D.SourceBreakpoint(new D.Location(V,new D.Position(_.line,_.character)),_.enabled,_.condition,_.hitCondition,_.logMessage)}L._id=R,this._breakpoints.set(R,L),v.push(L)}}if(u.removed)for(const _ of u.removed){const R=this._breakpoints.get(_);R&&(this._breakpoints.delete(_),A.push(R))}if(u.changed){for(const _ of u.changed)if(_.id){const R=this._breakpoints.get(_.id);if(R){if(R instanceof D.FunctionBreakpoint&&_.type==="function"){const L=R;L.enabled=_.enabled,L.condition=_.condition,L.hitCondition=_.hitCondition,L.logMessage=_.logMessage,L.functionName=_.functionName}else if(R instanceof D.SourceBreakpoint&&_.type==="source"){const L=R;L.enabled=_.enabled,L.condition=_.condition,L.hitCondition=_.hitCondition,L.logMessage=_.logMessage,L.location=new D.Location(C.URI.revive(_.uri),new D.Position(_.line,_.character))}m.push(R)}}}this.fireBreakpointChanges(v,A,m)}$provideDebugConfigurations(u,v,A){return(0,P.asPromise)(async()=>{const m=this.getConfigProviderByHandle(u);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const _=await this.getFolder(v);return m.provideDebugConfigurations(_,A)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(u,v,A,m){return(0,P.asPromise)(async()=>{const _=this.getConfigProviderByHandle(u);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(v);return _.resolveDebugConfiguration(R,A,m)})}$resolveDebugConfigurationWithSubstitutedVariables(u,v,A,m){return(0,P.asPromise)(async()=>{const _=this.getConfigProviderByHandle(u);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(v);return _.resolveDebugConfigurationWithSubstitutedVariables(R,A,m)})}async $provideDebugAdapter(u,v){const A=this.getAdapterDescriptorFactoryByHandle(u);if(!A)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.getSession(v);return this.getAdapterDescriptor(A,m).then(_=>{if(!_)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.convertToDto(_)})}async $acceptDebugSessionStarted(u){const v=await this.getSession(u);this._onDidStartDebugSession.fire(v)}async $acceptDebugSessionTerminated(u){const v=await this.getSession(u);v&&(this._onDidTerminateDebugSession.fire(v),this._debugSessions.delete(v.id))}async $acceptDebugSessionActiveChanged(u){this._activeDebugSession=u?await this.getSession(u):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(u,v){const A=await this.getSession(u);A&&A._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(u,v){const m={session:await this.getSession(u),event:v.event,body:v.body};this._onDidReceiveDebugSessionCustomEvent.fire(m)}convertToDto(u){if(u instanceof D.DebugAdapterExecutable)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof D.DebugAdapterServer)return{type:"server",port:u.port,host:u.host};if(u instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:u.path};if(u instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(u){const v=this._adapterFactories.filter(A=>A.type===u);if(v.length>0)return v[0].factory}getAdapterDescriptorFactoryByHandle(u){const v=this._adapterFactories.filter(A=>A.handle===u);if(v.length>0)return v[0].factory}getConfigProviderByHandle(u){const v=this._configProviders.filter(A=>A.handle===u);if(v.length>0)return v[0].provider}definesDebugType(u,v){if(u.contributes){const A=u.contributes.debuggers;if(A&&A.length>0){for(const m of A)if(m.label&&m.type&&m.type===v)return!0}}return!1}getDebugAdapterTrackers(u){const A=u.configuration.type,m=this._trackerFactories.filter(_=>_.type===A||_.type==="*").map(_=>(0,P.asPromise)(()=>_.factory.createDebugAdapterTracker(u)).then(R=>R,R=>null));return Promise.race([Promise.all(m).then(_=>{const R=_.filter(L=>!!L);if(R.length>0)return new i(R)}),new Promise((_,R)=>{const L=setTimeout(()=>{clearTimeout(L),R(new Error("timeout"))},1e3)})]).catch(_=>{})}async getAdapterDescriptor(u,v){const A=v.configuration.debugServer;if(typeof A=="number")return Promise.resolve(new D.DebugAdapterServer(A));if(u){const _=await this._extensionService.getExtensionRegistry();return(0,P.asPromise)(()=>u.createDebugAdapterDescriptor(v,this.daExecutableFromPackage(v,_))).then(R=>{if(R)return R})}const m=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(v,m))}daExecutableFromPackage(u,v){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(u,v,A){(u.length>0||v.length>0||A.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:u,removed:v,changed:A}))}async getSession(u){if(u)if(typeof u=="string"){const v=this._debugSessions.get(u);if(v)return v}else{let v=this._debugSessions.get(u.id);if(!v){const A=await this.getFolder(u.folderUri);v=new c(this._debugServiceProxy,u.id,u.type,u.name,A,u.configuration),this._debugSessions.set(v.id,v),this._debugServiceProxy.$sessionCached(v.id)}return v}throw new Error("cannot find session")}getFolder(u){if(u){const v=C.URI.revive(u);return this._workspaceService.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}};g=je([Ke(0,a.IExtHostRpcService),Ke(1,n.IExtHostWorkspace),Ke(2,T.IExtHostExtensionService),Ke(3,k.IExtHostDocumentsAndEditors),Ke(4,h.IExtHostConfiguration)],g),e.ExtHostDebugServiceBase=g;class c{constructor(u,v,A,m,_,R){this._debugServiceProxy=u,this._id=v,this._type=A,this._name=m,this._workspaceFolder=_,this._configuration=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(u){this._name=u,this._debugServiceProxy.$setDebugSessionName(this._id,u)}_acceptNameChanged(u){this._name=u}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(u,v){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,u,v)}getDebugProtocolBreakpoint(u){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,u.id)}}e.ExtHostDebugSession=c;class w{constructor(u){this.value=Object.freeze({append(v){u.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.ExtHostDebugConsole=w;class t extends f.AbstractVariableResolverService{constructor(u,v,A,m){super({getFolderUri:_=>{const R=u.filter(L=>L.name===_);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>u.length,getConfigurationValue:(_,R)=>A.getConfiguration(void 0,_).get(R),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(v){const _=v.activeEditor();if(_)return E.normalize(_.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(v&&m){const _=v.activeEditor();if(_){const R=m.getWorkspaceFolder(_.document.uri);if(R)return E.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(v){const _=v.activeEditor();if(_&&!_.selection.isEmpty)return _.document.getText(_.selection)}},getLineNumber:()=>{if(v){const _=v.activeEditor();if(_)return String(_.selection.end.line+1)}}},void 0,b.env)}}e.ExtHostVariableResolverService=t;class i{constructor(u){this.trackers=u}onWillStartSession(){this.trackers.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.trackers.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.trackers.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(u):void 0)}onWillStopSession(){this.trackers.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.trackers.forEach(v=>v.onError?v.onError(u):void 0)}onExit(u,v){this.trackers.forEach(A=>A.onExit?A.onExit(u,v):void 0)}}class l extends y.AbstractDebugAdapter{constructor(u){super();this.implementation=u,u.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.implementation.handleMessage(u)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends g{constructor(u,v,A,m,_){super(u,v,A,m,_)}createVariableResolver(u,v,A){return new t(u,v,A)}};s=je([Ke(0,a.IExtHostRpcService),Ke(1,n.IExtHostWorkspace),Ke(2,T.IExtHostExtensionService),Ke(3,k.IExtHostDocumentsAndEditors),Ke(4,h.IExtHostConfiguration)],s),e.WorkerExtHostDebugService=s}),define(be[221],we([0,1,80,2,5,34,33,26,15,27,4,35,46,19]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(g,c,w,t,i,l,s){this._apiFactory=g,this._extensionRegistry=c,this._instaService=w,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=l,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),E.mark("code/extHost/willWaitForConfig");const g=await this._extHostConfiguration.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,c,this._extensionRegistry,g,this._logService)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(d,c,this._initData.environment.appUriScheme))}register(g){if(Array.isArray(g.nodeModuleName))for(let c of g.nodeModuleName)this._factories.set(c,g);else this._factories.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this._alternatives.push(c=>g.alternativeModuleName(c))}};r=je([Ke(2,T.IInstantiationService),Ke(3,P.IExtHostConfiguration),Ke(4,k.IExtHostExtensionService),Ke(5,n.IExtHostInitDataService),Ke(6,h.ILogService)],r),e.RequireInterceptor=r;class a{constructor(g,c,w,t,i){this._apiFactory=g,this._extensionPaths=c,this._extensionRegistry=w,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(g,c){const w=this._extensionPaths.findSubstr(c.fsPath);if(w){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(w.identifier));return t||(t=this._apiFactory(w,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(w.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,l)=>t+=`	${l} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(S.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(g,c){this.nodeModuleName="keytar";const{environment:w}=c,t=g.getProxy(I.MainContext.MainThreadKeytar);if(w.appRoot){let i=w.appRoot.fsPath;f.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,l)=>t.$getPassword(i,l),setPassword:(i,l,s)=>t.$setPassword(i,l,s),deletePassword:(i,l)=>t.$deletePassword(i,l),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(g,c){return this._impl}alternativeModuleName(g){const c=g.length;if(!(c<=7||!this.alternativeNames)){const w=c-7;if((g.charAt(w)==="/"||g.charAt(w)==="\\")&&g.endsWith("keytar")&&(g=g.replace(/\\/g,"/"),this.alternativeNames.has(g)))return"keytar"}}};p=je([Ke(0,y.IExtHostRpcService),Ke(1,n.IExtHostInitDataService)],p);let d=class{constructor(g,c,w){this._extensionPaths=g,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=w.getProxy(I.MainContext.MainThreadTelemetry);const t=w.getProxy(I.MainContext.MainThreadWindow);this._impl=(i,l)=>{const s=C.URI.parse(i);return l?this.callOriginal(i,l):s.scheme==="http"||s.scheme==="https"?t.$openUri(s,i,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?t.$openUri(s,i,{}):this.callOriginal(i,l)}}load(g,c,w){const t=this._extensionPaths.findSubstr(c.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=w(g),this._impl}callOriginal(g,c){return this.sendNoForwardTelemetry(),this._original(g,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};d=je([Ke(2,y.IExtHostRpcService)],d)}),define(be[222],we([0,1,14,11,80,6,2,5,214,19,62,66,27,151,15,72,35,40]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h,r,a,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(c,w,t,i){this._disposables=new P.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const l=new y.RPCProtocol(c,null,i);w=b._transform(w,l);const s=new k.ServiceCollection(...(0,T.getSingletonServiceDescriptors)());s.set(f.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},w)),s.set(r.IExtHostRpcService,new r.ExtHostRpcService(l)),s.set(a.IURITransformerService,new a.URITransformerService(i)),s.set(p.IHostUtils,t);const o=new h.InstantiationService(s,!0),u=o.invokeFunction(_=>_.get(d.IExtHostTerminalService));this._disposables.add(u),this._logService=o.invokeFunction(_=>_.get(n.ILogService)),I.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",w),this._extensionService=o.invokeFunction(_=>_.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const v=new WeakMap;this._extensionService.getExtensionPathIndex().then(_=>{Error.prepareStackTrace=(R,L)=>{let V="",he,z;for(const W of L)V+=`
	at ${W.toString()}`,z=W.getFileName(),!he&&z&&(he=_.findSubstr(z));return v.set(R,he),`${R.name||"Error"}: ${R.message||""}${V}`}});const A=l.getProxy(D.MainContext.MainThreadExtensionService),m=l.getProxy(D.MainContext.MainThreadErrors);C.setUnexpectedErrorHandler(_=>{const R=C.transformErrorForSerialization(_),L=v.get(_);L?A.$onExtensionRuntimeError(L.identifier,R):m.$onUnexpectedError(R)})}terminate(c){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),C.setUnexpectedErrorHandler(t=>{});const w=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,E.timeout)(4e3),w]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(c,w){c.extensions.forEach(i=>i.extensionLocation=S.URI.revive(w.transformIncomingURIs(i.extensionLocation))),c.environment.appRoot=S.URI.revive(w.transformIncomingURIs(c.environment.appRoot));const t=c.environment.extensionDevelopmentLocationURI;return t&&(c.environment.extensionDevelopmentLocationURI=t.map(i=>S.URI.revive(w.transformIncomingURIs(i)))),c.environment.extensionTestsLocationURI=S.URI.revive(w.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=S.URI.revive(w.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=S.URI.revive(w.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=S.URI.revive(w.transformIncomingURIs(c.logsLocation)),c.logFile=S.URI.revive(w.transformIncomingURIs(c.logFile)),c.workspace=w.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=b}),define(be[223],we([0,1,13,20,61,28,25,56,41]),function(Y,e,E,C,I,P,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class n{constructor(f,h,r){this.config=f,this.provider=h,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=f.filePattern,this.includePattern=f.includePattern&&P.parse(f.includePattern),this.maxResults=f.maxResults||void 0,this.exists=f.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=f.excludePattern&&P.parse(f.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(f=>f.cancel()),this.activeCancellationTokens=new Set}search(f){const h=this.config.folderQueries||[];return new Promise((r,a)=>{const p=d=>{this.resultCount++,f(d)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(d=>{const b=d.toString(),g=E.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,g)||this.matchFile(p,{base:d,basename:g})}),Promise.all(h.map(d=>this.searchInFolder(d,p))).then(d=>{r({limitHit:this.isLimitHit,stats:d[0]||void 0})},d=>{a(new Error((0,I.toErrorMessage)(d)))})})}async searchInFolder(f,h){const r=new C.CancellationTokenSource,a=this.getSearchOptionsForFolder(f),p=this.initDirectoryTree(),d=new y.QueryGlobTester(this.config,f),b=!d.hasSiblingExcludeClauses();let g;try{this.activeCancellationTokens.add(r),g=D.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,r.token),w=g.elapsed(),t=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(i=>{const l=E.posix.relative(f.folder.path,i.path);if(b){const s=E.basename(i.path);this.matchFile(h,{base:f.folder,relativePath:l,basename:s});return}this.addDirectoryEntries(p,f.folder,l,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,d,h),{providerTime:w,postProcessTime:t.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(f){const h=(0,y.resolvePatternsForProvider)(this.config.includePattern,f.includePattern),r=(0,y.resolvePatternsForProvider)(this.config.excludePattern,f.excludePattern);return{folder:f.folder,excludes:r,includes:h,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}addDirectoryEntries({pathToEntries:f},h,r,a){if(r===this.filePattern){const d=E.basename(this.filePattern);this.matchFile(a,{base:h,relativePath:this.filePattern,basename:d})}function p(d){const b=E.basename(d),g=E.dirname(d);let c=f[g];c||(c=f[g]=[],p(g)),c.push({base:h,relativePath:d,basename:b})}p(r)}matchDirectoryTree({rootEntries:f,pathToEntries:h},r,a){const p=this,d=this.filePattern;function b(g){const c=P.hasSiblingFn(()=>g.map(w=>w.basename));for(let w=0,t=g.length;w<t;w++){const i=g[w],{relativePath:l,basename:s}=i;if(!!r.includedInQuerySync(l,s,d!==s?c:void 0)){const o=h[l];if(o)b(o);else{if(l===d)continue;p.matchFile(a,i)}if(p.isLimitHit)break}}}b(f)}matchFile(f,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||f(h))}}class T{constructor(){this.sessions=new Map}fileSearch(f,h,r,a){const p=this.getSessionTokenSource(f.cacheKey),d=new n(f,h,p&&p.token);let b=0;const g=c=>{b+=c.length,r(c.map(w=>this.rawMatchToSearchItem(w)))};return this.doSearch(d,T.BATCH_SIZE,g,a).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:c.stats}}))}clearCache(f){const h=this.getSessionTokenSource(f);h&&h.cancel()}getSessionTokenSource(f){if(!!f)return this.sessions.has(f)||this.sessions.set(f,new C.CancellationTokenSource),this.sessions.get(f)}rawMatchToSearchItem(f){return f.relativePath?{resource:S.joinPath(f.base,f.relativePath)}:{resource:f.base}}doSearch(f,h,r,a){a.onCancellationRequested(()=>{f.cancel()});const p=b=>{b&&(d.push(b),h>0&&d.length>=h&&(r(d),d=[]))};let d=[];return f.search(p).then(b=>(d.length&&r(d),b),b=>(d.length&&r(d),Promise.reject(b)))}}e.FileSearchManager=T,T.BATCH_SIZE=512}),define(be[224],we([0,1,13,12,20,61,25,28,2,41,18]),function(Y,e,E,C,I,P,S,D,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(b,g,c){this.query=b,this.provider=g,this.fileUtils=c,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(b,g){const c=this.query.folderQueries||[],w=new I.CancellationTokenSource;return g.onCancellationRequested(()=>w.cancel()),new Promise((t,i)=>{this.collector=new h(b);let l=!1;const s=(o,u)=>{if(!l&&!this.isLimitHit){const v=this.resultSize(o);a(o)&&typeof this.query.maxResults=="number"&&this.resultCount+v>this.query.maxResults&&(this.isLimitHit=!0,l=!0,w.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const A=this.resultSize(o);this.resultCount+=A,(A>0||!a(o))&&this.collector.add(o,u)}};Promise.all(c.map((o,u)=>this.searchInFolder(o,v=>s(v,u),w.token))).then(o=>{w.dispose(),this.collector.flush();const u=o.some(v=>!!v&&!!v.limitHit);t({limitHit:this.isLimitHit||u,stats:{type:"textSearchProvider"}})},o=>{w.dispose();const u=(0,P.toErrorMessage)(o);i(new Error(u))})})}resultSize(b){return a(b)?Array.isArray(b.ranges)?b.ranges.length:1:0}trimResultToSize(b,g){const c=Array.isArray(b.ranges)?b.ranges:[b.ranges],w=Array.isArray(b.preview.matches)?b.preview.matches:[b.preview.matches];return{ranges:c.slice(0,g),preview:{matches:w.slice(0,g),text:b.preview.text},uri:b.uri}}async searchInFolder(b,g,c){const w=new n.QueryGlobTester(this.query,b),t=[],i={report:o=>{if(!!this.validateProviderResult(o)){const u=b.folder.scheme===T.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(o.uri))):void 0,v=S.relativePath(b.folder,o.uri);v&&t.push(w.includedInQuery(v,E.basename(v),u).then(A=>{A&&g(o)}))}}},l=this.getSearchOptionsForFolder(b),s=await this.provider.provideTextSearchResults(f(this.query.contentPattern),l,i,c);return await Promise.all(t),s}validateProviderResult(b){if(a(b)){if(Array.isArray(b.ranges)){if(!Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(b.preview.matches.length!==b.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(b){const g=(0,n.resolvePatternsForProvider)(this.query.includePattern,b.includePattern),c=(0,n.resolvePatternsForProvider)(this.query.excludePattern,b.excludePattern),w={folder:y.URI.from(b.folder),excludes:c,includes:g,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,followSymlinks:!b.ignoreSymlinks,encoding:b.fileEncoding&&this.fileUtils.toCanonicalName(b.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return w.usePCRE2=this.query.usePCRE2,w}}e.TextSearchManager=k;function f(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class h{constructor(b){this._onResult=b,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new p(512,g=>this.sendItems(g))}add(b,g){this._currentFileMatch&&(this._currentFolderIdx!==g||!S.isEqual(this._currentUri,b.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=g,this._currentFileMatch={resource:b.uri,results:[]}),this._currentFileMatch.results.push(r(b))}pushToCollector(){const b=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,b)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(b){this._onResult(b)}}e.TextSearchResultsCollector=h;function r(d){return a(d)?{preview:{matches:(0,C.mapArrayOrNot)(d.preview.matches,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character})),text:d.preview.text},ranges:(0,C.mapArrayOrNot)(d.ranges,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function a(d){return!!d.preview}e.extensionResultIsMatch=a;class p{constructor(b,g){this.maxBatchSize=b,this.cb=g,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(b,g){!b||this.addItemToBatch(b,g)}addItems(b,g){!b||this.addItemsToBatch(b,g)}addItemToBatch(b,g){this.batch.push(b),this.batchSize+=g,this.onUpdate()}addItemsToBatch(b,g){this.batch=this.batch.concat(b),this.batchSize+=g,this.onUpdate()}onUpdate(){this.totalNumberCompleted<p.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},p.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=p,p.TIMEOUT=4e3,p.START_BATCH_AFTER_COUNT=50}),define(be[104],we([0,1,6,5,4,223,15,72,19,2,224]),function(Y,e,E,C,I,P,S,D,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let k=class{constructor(a,p,d){this.extHostRpc=a,this._uriTransformer=p,this._logService=d,this._proxy=this.extHostRpc.getProxy(C.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,p){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const d=this._handlePool++;return this._textSearchProvider.set(d,p),this._proxy.$registerTextSearchProvider(d,this._transformScheme(a)),(0,E.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(d),this._proxy.$unregisterProvider(d)})}registerFileSearchProvider(a,p){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const d=this._handlePool++;return this._fileSearchProvider.set(d,p),this._proxy.$registerFileSearchProvider(d,this._transformScheme(a)),(0,E.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(d),this._proxy.$unregisterProvider(d)})}$provideFileSearchResults(a,p,d,b){const g=f(d),c=this._fileSearchProvider.get(a);if(c)return this._fileSearchManager.fileSearch(g,c,w=>{this._proxy.$handleFileMatch(a,p,w.map(t=>t.resource))},b);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,p,d,b){const g=this._textSearchProvider.get(a);if(!g||!g.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const c=f(d);return this.createTextSearchManager(c,g).search(t=>this._proxy.$handleTextMatch(a,p,t),b)}createTextSearchManager(a,p){return new T.TextSearchManager(a,p,{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d})}};k=je([Ke(0,S.IExtHostRpcService),Ke(1,D.IURITransformerService),Ke(2,y.ILogService)],k),e.ExtHostSearch=k;function f(r){return Object.assign(Object.assign({},r),{folderQueries:r.folderQueries&&r.folderQueries.map(h),extraFileResources:r.extraFileResources&&r.extraFileResources.map(a=>n.URI.revive(a))})}e.reviveQuery=f;function h(r){return Object.assign(Object.assign({},r),{folder:n.URI.revive(r.folder)})}}),define(be[225],we([0,1,129,20,11,3,47,2,122,85,116,60,65,5,190,189,76,191,34,192,193,194,176,195,39,35,196,177,198,199,200,100,180,203,204,205,78,40,206,181,9,7,209,51,101,31,33,52,166,197,93,99,102,103,104,19,72,15,27,201,164,71,75,187,207,163,79,77,212,210,211,188,49,218,208,74,160,94,202,68]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h,r,a,p,d,b,g,c,w,t,i,l,s,o,u,v,A,m,_,R,L,V,he,z,W,J,O,F,N,B,U,Q,Z,ne,pe,Pe,Oe,Te,xe,$,G,ie,oe,me,De,Ne,ge,Ce,Ae,Be,_e,qe,j,te,ve,Ue,He,$e,Ye,H,se,de,K,ee,le,fe,Ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ve(Fe){const We=Fe.get(Ne.IExtHostInitDataService),Qe=Fe.get(H.IExtHostFileSystemInfo),it=Fe.get(ve.IExtHostConsumerFileSystem),at=Fe.get(s.IExtHostExtensionService),Ze=Fe.get(Z.IExtHostWorkspace),nt=Fe.get(le.IExtHostTelemetry),dt=Fe.get(b.IExtHostConfiguration),wt=Fe.get(me.IURITransformerService),ue=Fe.get(De.IExtHostRpcService),Se=Fe.get(z.IExtHostStorage),ae=Fe.get(te.IExtensionStoragePaths),q=Fe.get(oe.ILogService),Le=Fe.get(Ae.IExtHostTunnelService),Ie=Fe.get(Be.IExtHostApiDeprecationService),Xe=Fe.get(Q.IExtHostWindow),et=Fe.get(K.IExtHostSecretState);ue.set(h.ExtHostContext.ExtHostFileSystemInfo,Qe),ue.set(h.ExtHostContext.ExtHostLogService,q),ue.set(h.ExtHostContext.ExtHostWorkspace,Ze),ue.set(h.ExtHostContext.ExtHostConfiguration,dt),ue.set(h.ExtHostContext.ExtHostExtensionService,at),ue.set(h.ExtHostContext.ExtHostStorage,Se),ue.set(h.ExtHostContext.ExtHostTunnelService,Le),ue.set(h.ExtHostContext.ExtHostWindow,Xe),ue.set(h.ExtHostContext.ExtHostSecretState,et),ue.set(h.ExtHostContext.ExtHostTelemetry,nt);const ct=ue.set(h.ExtHostContext.ExtHostDecorations,Fe.get(xe.IExtHostDecorations)),rt=ue.set(h.ExtHostContext.ExtHostDocumentsAndEditors,Fe.get(l.IExtHostDocumentsAndEditors)),Ge=ue.set(h.ExtHostContext.ExtHostCommands,Fe.get(p.IExtHostCommands)),ht=ue.set(h.ExtHostContext.ExtHostTerminalService,Fe.get(W.IExtHostTerminalService)),ot=ue.set(h.ExtHostContext.ExtHostDebugService,Fe.get(G.IExtHostDebugService)),vt=ue.set(h.ExtHostContext.ExtHostSearch,Fe.get(ie.IExtHostSearch)),pt=ue.set(h.ExtHostContext.ExtHostTask,Fe.get($.IExtHostTask)),_t=ue.set(h.ExtHostContext.ExtHostOutputService,Fe.get(_.IExtHostOutputService)),yt=ue.set(h.ExtHostContext.ExtHostEditorTabs,new ee.ExtHostEditorTabs),It=ue.set(h.ExtHostContext.ExtHostUrls,new B.ExtHostUrls(ue)),bt=ue.set(h.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(ue,rt)),Pt=ue.set(h.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(ue,rt,q)),qt=ue.set(h.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(q,bt,ue.getProxy(h.MainContext.MainThreadBulkEdits))),ft=ue.set(h.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(ue,Ge,rt,bt,We.environment,q,ae)),Kt=ue.set(h.ExtHostContext.ExtHostNotebookKernels,new fe.ExtHostNotebookKernels(ue,We,ft)),Et=ue.set(h.ExtHostContext.ExtHostEditors,new J.ExtHostEditors(ue,rt)),Bt=ue.set(h.ExtHostContext.ExtHostTreeViews,new O.ExtHostTreeViews(ue.getProxy(h.MainContext.MainThreadTreeViews),Ge,q)),Gt=ue.set(h.ExtHostContext.ExtHostEditorInsets,new Pe.ExtHostEditorInsets(ue.getProxy(h.MainContext.MainThreadEditorInsets),Et,We.environment)),Wt=ue.set(h.ExtHostContext.ExtHostDiagnostics,new g.ExtHostDiagnostics(ue,q)),lt=ue.set(h.ExtHostContext.ExtHostLanguageFeatures,new v.ExtHostLanguageFeatures(ue,wt,bt,Ge,Wt,q,Ie)),Qt=ue.set(h.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(ue,lt)),At=ue.set(h.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(ue,q,rt)),Ot=ue.set(h.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(ue,Ze,Ge)),un=ue.set(h.ExtHostContext.ExtHostSCM,new V.ExtHostSCM(ue,Ge,q)),pn=ue.set(h.ExtHostContext.ExtHostComments,new d.ExtHostComments(ue,Ge,bt)),cn=ue.set(h.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(ue.getProxy(h.MainContext.MainThreadProgress))),Jt=ue.set(h.ExtHostContext.ExtHosLabelService,new Oe.ExtHostLabelService(ue)),Ht=ue.set(h.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(ue)),Lt=ue.set(h.ExtHostContext.ExtHostAuthentication,new _e.ExtHostAuthentication(ue)),vn=ue.set(h.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(ue,Ge)),Yt=ue.set(h.ExtHostContext.ExtHostWebviews,new U.ExtHostWebviews(ue,We.environment,Ze,q,Ie)),Xt=ue.set(h.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(ue,Yt,Ze)),zt=ue.set(h.ExtHostContext.ExtHostCustomEditors,new He.ExtHostCustomEditors(ue,bt,ae,Yt,Xt)),bn=ue.set(h.ExtHostContext.ExtHostWebviewViews,new Ue.ExtHostWebviewViews(ue,Yt)),Tt=ue.set(h.ExtHostContext.ExtHostTesting,new se.ExtHostTesting(ue,rt,Ze)),Zt=ue.set(h.ExtHostContext.ExtHostUriOpeners,new de.ExtHostUriOpeners(ue)),wn=(0,pe.values)(h.ExtHostContext);ue.assertRegistered(wn);const en=new Ye.ExtHostBulkEdits(ue,rt),tn=new a.ExtHostClipboard(ue),Mt=new m.ExtHostMessageService(ue,q),dn=new c.ExtHostDialogs(ue),hn=new he.ExtHostStatusBar(ue,Ge.converter),Nt=new A.ExtHostLanguages(ue,bt);return r.ExtHostApiCommands.register(Ge),function(Re,nn,rn){const mt=function(){let X=!Re.isUnderDevelopment;function ce(ke){X||(q.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function ke(st){if(Array.isArray(st))st.forEach(ke);else if(typeof st=="string")ce(st);else{const x=st;typeof x.scheme=="undefined"&&ce(st),!Re.enableProposedApi&&typeof x.exclusive=="boolean"&&(0,ne.throwProposedApiError)(Re)}return st}}(),_n={getSession(X,ce,ke){return Lt.getSession(Re,X,ce,ke)},get onDidChangeSessions(){return Lt.onDidChangeSessions},registerAuthenticationProvider(X,ce,ke,st){return Lt.registerAuthenticationProvider(X,ce,ke,st)},get onDidChangeAuthenticationProviders(){return(0,ne.checkProposedApiEnabled)(Re),Lt.onDidChangeAuthenticationProviders},get providers(){return(0,ne.checkProposedApiEnabled)(Re),Lt.providers},logout(X,ce){return(0,ne.checkProposedApiEnabled)(Re),Lt.removeSession(X,ce)}},En={registerCommand(X,ce,ke){return Ge.registerCommand(!0,X,ce,ke)},registerTextEditorCommand(X,ce,ke){return Ge.registerCommand(!0,X,(...st)=>{const x=Et.getActiveTextEditor();if(!x){q.warn("Cannot execute "+X+" because there is no active text editor.");return}return x.edit(M=>{ce.apply(ke,[x,M,...st])}).then(M=>{M||q.warn("Edits from command "+X+" were not applied.")},M=>{q.warn("An error occurred while running command "+X,M)})})},registerDiffInformationCommand:(X,ce,ke)=>((0,ne.checkProposedApiEnabled)(Re),Ge.registerCommand(!0,X,async(...st)=>{const x=rt.activeEditor(!0);if(!x){q.warn("Cannot execute "+X+" because there is no active text editor.");return}const M=await Et.getDiffInformation(x.id);ce.apply(ke,[M,...st])})),executeCommand(X,...ce){return Ge.executeCommand(X,...ce)},getCommands(X=!1){return Ge.getCommands(X)}},Vt={get machineId(){return We.telemetryInfo.machineId},get sessionId(){return We.telemetryInfo.sessionId},get language(){return We.environment.appLanguage},get appName(){return We.environment.appName},get appRoot(){var X,ce;return(ce=(X=We.environment.appRoot)===null||X===void 0?void 0:X.fsPath)!==null&&ce!==void 0?ce:""},get uriScheme(){return We.environment.appUriScheme},get clipboard(){return tn.value},get shell(){return ht.getDefaultShell(!1,rn)},get isTelemetryEnabled(){return nt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return nt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(We.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,ce){return Xe.openUri(X,{allowTunneling:!!We.remote.authority,allowContributedOpeners:ce==null?void 0:ce.allowContributedOpeners})},asExternalUri(X){return X.scheme===We.environment.appUriScheme?It.createAppUri(X):Xe.asExternalUri(X,{allowTunneling:!!We.remote.authority})},get remoteName(){return(0,Te.getRemoteName)(We.remote.authority)},get uiKind(){return We.uiKind}};We.environment.extensionTestsLocationURI||Object.freeze(Vt);const fn=We.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,yn={registerTestController(X){return(0,ne.checkProposedApiEnabled)(Re),Tt.registerTestController(Re.identifier.value,X)},createDocumentTestObserver(X){return(0,ne.checkProposedApiEnabled)(Re),Tt.createTextDocumentTestObserver(X)},createWorkspaceTestObserver(X){return(0,ne.checkProposedApiEnabled)(Re),Tt.createWorkspaceTestObserver(X)},runTests(X){return(0,ne.checkProposedApiEnabled)(Re),Tt.runTests(X)},createTestItem(X,ce){return new N.TestItemImpl(X.id,X.label,X.uri,ce)},createTestRunTask(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),Tt.createTestRunTask(Re.identifier.value,X,ce,ke)},get onDidChangeTestResults(){return(0,ne.checkProposedApiEnabled)(Re),Tt.onResultsChanged},get testResults(){return(0,ne.checkProposedApiEnabled)(Re),Tt.results}},Sn={getExtension(X){const ce=nn.getExtensionDescription(X);if(ce)return new s.Extension(at,Re.identifier,ce,fn)},get all(){return nn.getAllExtensionDescriptions().map(X=>new s.Extension(at,Re.identifier,X,fn))},get onDidChange(){return nn.onDidChange}},Dn={createDiagnosticCollection(X){return Wt.createDiagnosticCollection(Re.identifier,X)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:X=>Wt.getDiagnostics(X),getLanguages(){return Nt.getLanguages()},setTextDocumentLanguage(X,ce){return Nt.changeLanguage(X.uri,ce)},match(X,ce){return(0,k.score)(F.LanguageSelector.from(X),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(X,ce,ke){return lt.registerCodeActionProvider(Re,mt(X),ce,ke)},registerCodeLensProvider(X,ce){return lt.registerCodeLensProvider(Re,mt(X),ce)},registerDefinitionProvider(X,ce){return lt.registerDefinitionProvider(Re,mt(X),ce)},registerDeclarationProvider(X,ce){return lt.registerDeclarationProvider(Re,mt(X),ce)},registerImplementationProvider(X,ce){return lt.registerImplementationProvider(Re,mt(X),ce)},registerTypeDefinitionProvider(X,ce){return lt.registerTypeDefinitionProvider(Re,mt(X),ce)},registerHoverProvider(X,ce){return lt.registerHoverProvider(Re,mt(X),ce,Re.identifier)},registerEvaluatableExpressionProvider(X,ce){return lt.registerEvaluatableExpressionProvider(Re,mt(X),ce,Re.identifier)},registerInlineValuesProvider(X,ce){return lt.registerInlineValuesProvider(Re,mt(X),ce,Re.identifier)},registerDocumentHighlightProvider(X,ce){return lt.registerDocumentHighlightProvider(Re,mt(X),ce)},registerLinkedEditingRangeProvider(X,ce){return lt.registerLinkedEditingRangeProvider(Re,mt(X),ce)},registerReferenceProvider(X,ce){return lt.registerReferenceProvider(Re,mt(X),ce)},registerRenameProvider(X,ce){return lt.registerRenameProvider(Re,mt(X),ce)},registerDocumentSymbolProvider(X,ce,ke){return lt.registerDocumentSymbolProvider(Re,mt(X),ce,ke)},registerWorkspaceSymbolProvider(X){return lt.registerWorkspaceSymbolProvider(Re,X)},registerDocumentFormattingEditProvider(X,ce){return lt.registerDocumentFormattingEditProvider(Re,mt(X),ce)},registerDocumentRangeFormattingEditProvider(X,ce){return lt.registerDocumentRangeFormattingEditProvider(Re,mt(X),ce)},registerOnTypeFormattingEditProvider(X,ce,ke,...st){return lt.registerOnTypeFormattingEditProvider(Re,mt(X),ce,[ke].concat(st))},registerDocumentSemanticTokensProvider(X,ce,ke){return lt.registerDocumentSemanticTokensProvider(Re,mt(X),ce,ke)},registerDocumentRangeSemanticTokensProvider(X,ce,ke){return lt.registerDocumentRangeSemanticTokensProvider(Re,mt(X),ce,ke)},registerSignatureHelpProvider(X,ce,ke,...st){return typeof ke=="object"?lt.registerSignatureHelpProvider(Re,mt(X),ce,ke):lt.registerSignatureHelpProvider(Re,mt(X),ce,typeof ke=="undefined"?[]:[ke,...st])},registerCompletionItemProvider(X,ce,...ke){return lt.registerCompletionItemProvider(Re,mt(X),ce,ke)},registerDocumentLinkProvider(X,ce){return lt.registerDocumentLinkProvider(Re,mt(X),ce)},registerColorProvider(X,ce){return lt.registerColorProvider(Re,mt(X),ce)},registerFoldingRangeProvider(X,ce){return lt.registerFoldingRangeProvider(Re,mt(X),ce)},registerSelectionRangeProvider(X,ce){return lt.registerSelectionRangeProvider(Re,X,ce)},registerCallHierarchyProvider(X,ce){return lt.registerCallHierarchyProvider(Re,X,ce)},setLanguageConfiguration:(X,ce)=>lt.setLanguageConfiguration(Re,X,ce),getTokenInformationAtPosition(X,ce){return(0,ne.checkProposedApiEnabled)(Re),Nt.tokenAtPosition(X,ce)},registerInlineHintsProvider(X,ce){return(0,ne.checkProposedApiEnabled)(Re),lt.registerInlineHintsProvider(Re,X,ce)}},Cn={get activeTextEditor(){return Et.getActiveTextEditor()},get visibleTextEditors(){return Et.getVisibleTextEditors()},get activeTerminal(){return ht.activeTerminal},get terminals(){return ht.terminals},async showTextDocument(X,ce,ke){const st=await(D.URI.isUri(X)?Promise.resolve(sn.openTextDocument(X)):Promise.resolve(X));return Et.showTextDocument(st,ce,ke)},createTextEditorDecorationType(X){return Et.createTextEditorDecorationType(X)},onDidChangeActiveTextEditor(X,ce,ke){return Et.onDidChangeActiveTextEditor(X,ce,ke)},onDidChangeVisibleTextEditors(X,ce,ke){return Et.onDidChangeVisibleTextEditors(X,ce,ke)},onDidChangeTextEditorSelection(X,ce,ke){return Et.onDidChangeTextEditorSelection(X,ce,ke)},onDidChangeTextEditorOptions(X,ce,ke){return Et.onDidChangeTextEditorOptions(X,ce,ke)},onDidChangeTextEditorVisibleRanges(X,ce,ke){return Et.onDidChangeTextEditorVisibleRanges(X,ce,ke)},onDidChangeTextEditorViewColumn(X,ce,ke){return Et.onDidChangeTextEditorViewColumn(X,ce,ke)},onDidCloseTerminal(X,ce,ke){return ht.onDidCloseTerminal(X,ce,ke)},onDidOpenTerminal(X,ce,ke){return ht.onDidOpenTerminal(X,ce,ke)},onDidChangeActiveTerminal(X,ce,ke){return ht.onDidChangeActiveTerminal(X,ce,ke)},onDidChangeTerminalDimensions(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ht.onDidChangeTerminalDimensions(X,ce,ke)},onDidWriteTerminalData(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ht.onDidWriteTerminalData(X,ce,ke)},get state(){return Xe.state},onDidChangeWindowState(X,ce,ke){return Xe.onDidChangeWindowState(X,ce,ke)},showInformationMessage(X,...ce){return Mt.showMessage(Re,S.default.Info,X,ce[0],ce.slice(1))},showWarningMessage(X,...ce){return Mt.showMessage(Re,S.default.Warning,X,ce[0],ce.slice(1))},showErrorMessage(X,...ce){return Mt.showMessage(Re,S.default.Error,X,ce[0],ce.slice(1))},showQuickPick(X,ce,ke){return Ot.showQuickPick(X,!!Re.enableProposedApi,ce,ke)},showWorkspaceFolderPick(X){return Ot.showWorkspaceFolderPick(X)},showInputBox(X,ce){return Ot.showInput(X,ce)},showOpenDialog(X){return dn.showOpenDialog(X)},showSaveDialog(X){return dn.showSaveDialog(X)},createStatusBarItem(X,ce){let ke,st,x,M;return X&&typeof X!="number"?(ke=X.id,st=X.name,x=X.alignment,ce=X.priority,M=X.accessibilityInformation):(ke=Re.identifier.value,st=E.localize(0,null,Re.displayName||Re.name),x=X),hn.createStatusBarEntry(ke,st,x,ce,M)},setStatusBarMessage(X,ce){return hn.setStatusBarMessage(X,ce)},withScmProgress(X){return Ie.report("window.withScmProgress",Re,"Use 'withProgress' instead."),cn.withProgress(Re,{location:N.ProgressLocation.SourceControl},(ce,ke)=>X({report(st){}}))},withProgress(X,ce){return cn.withProgress(Re,X,ce)},createOutputChannel(X){return _t.createOutputChannel(X)},createWebviewPanel(X,ce,ke,st){return Xt.createWebviewPanel(Re,X,ce,ke,st)},createWebviewTextEditorInset(X,ce,ke,st){return(0,ne.checkProposedApiEnabled)(Re),Gt.createWebviewEditorInset(X,ce,ke,st,Re)},createTerminal(X,ce,ke){return typeof X=="object"?"pty"in X?ht.createExtensionTerminal(X):(X.message&&(0,ne.checkProposedApiEnabled)(Re),X.icon&&(0,ne.checkProposedApiEnabled)(Re),ht.createTerminalFromOptions(X)):ht.createTerminal(X,ce,ke)},registerTerminalLinkProvider(X){return ht.registerLinkProvider(X)},registerTreeDataProvider(X,ce){return Bt.registerTreeDataProvider(X,ce,Re)},createTreeView(X,ce){return Bt.createTreeView(X,ce,Re)},registerWebviewPanelSerializer:(X,ce)=>Xt.registerWebviewPanelSerializer(Re,X,ce),registerCustomEditorProvider:(X,ce,ke={})=>zt.registerCustomEditorProvider(Re,X,ce,ke),registerFileDecorationProvider(X){return ct.registerFileDecorationProvider(X,Re.identifier)},registerUriHandler(X){return It.registerUriHandler(Re.identifier,X)},createQuickPick(){return Ot.createQuickPick(Re.identifier,!!Re.enableProposedApi)},createInputBox(){return Ot.createInputBox(Re.identifier)},get activeColorTheme(){return Ht.activeColorTheme},onDidChangeActiveColorTheme(X,ce,ke){return Ht.onDidChangeActiveColorTheme(X,ce,ke)},registerWebviewViewProvider(X,ce,ke){return bn.registerWebviewViewProvider(Re,X,ce,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return(0,ne.checkProposedApiEnabled)(Re),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeActiveNotebookEditor(X,ce,ke)},get visibleNotebookEditors(){return(0,ne.checkProposedApiEnabled)(Re),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookEditorSelection(X,ce,ke)},onDidChangeNotebookEditorVisibleRanges(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookEditorVisibleRanges(X,ce,ke)},showNotebookDocument(X,ce){return(0,ne.checkProposedApiEnabled)(Re),ft.showNotebookDocument(X,ce)},registerExternalUriOpener(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),Zt.registerExternalUriOpener(Re.identifier,X,ce,ke)},get openEditors(){return(0,ne.checkProposedApiEnabled)(Re),yt.tabs},get onDidChangeOpenEditors(){return(0,ne.checkProposedApiEnabled)(Re),yt.onDidChangeTabs}},sn={get rootPath(){return Ie.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(X){throw I.readonly()},getWorkspaceFolder(X){return Ze.getWorkspaceFolder(X)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(X){throw I.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(X){throw I.readonly()},updateWorkspaceFolders:(X,ce,...ke)=>Ze.updateWorkspaceFolders(Re,X,ce||0,...ke),onDidChangeWorkspaceFolders:function(X,ce,ke){return Ze.onDidChangeWorkspace(X,ce,ke)},asRelativePath:(X,ce)=>Ze.getRelativePath(X,ce),findFiles:(X,ce,ke,st)=>Ze.findFiles(F.GlobPattern.from(X),F.GlobPattern.from(ce),ke,Re.identifier,st),findTextInFiles:(X,ce,ke,st)=>{let x,M;return typeof ce=="object"?(x=ce,M=ke):(x={},M=ce,st=ke),Ze.findTextInFiles(X,x||{},M,Re.identifier,st)},saveAll:X=>Ze.saveAll(X),applyEdit(X){return en.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,ce,ke,st)=>At.createFileSystemWatcher(F.GlobPattern.from(X),ce,ke,st),get textDocuments(){return bt.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw I.readonly()},openTextDocument(X){let ce;const ke=X;if(typeof X=="string")ce=Promise.resolve(D.URI.file(X));else if(D.URI.isUri(X))ce=Promise.resolve(X);else if(!ke||typeof ke=="object")ce=bt.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(st=>bt.ensureDocumentData(st).then(x=>x.document))},onDidOpenTextDocument:(X,ce,ke)=>bt.onDidAddDocument(X,ce,ke),onDidCloseTextDocument:(X,ce,ke)=>bt.onDidRemoveDocument(X,ce,ke),onDidChangeTextDocument:(X,ce,ke)=>bt.onDidChangeDocument(X,ce,ke),onDidSaveTextDocument:(X,ce,ke)=>bt.onDidSaveDocument(X,ce,ke),onWillSaveTextDocument:(X,ce,ke)=>qt.getOnWillSaveTextDocumentEvent(Re)(X,ce,ke),onDidChangeConfiguration:(X,ce,ke)=>rn.onDidChangeConfiguration(X,ce,ke),getConfiguration(X,ce){return ce=arguments.length===1?void 0:ce,rn.getConfiguration(X,ce,Re)},registerTextDocumentContentProvider(X,ce){return Pt.registerTextDocumentContentProvider(X,ce)},registerTaskProvider:(X,ce)=>(Ie.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(Re,X,ce)),registerFileSystemProvider(X,ce,ke){return Qt.registerFileSystemProvider(Re.identifier,X,ce,ke)},get fs(){return it.value},registerFileSearchProvider:(X,ce)=>((0,ne.checkProposedApiEnabled)(Re),vt.registerFileSearchProvider(X,ce)),registerTextSearchProvider:(X,ce)=>((0,ne.checkProposedApiEnabled)(Re),vt.registerTextSearchProvider(X,ce)),registerRemoteAuthorityResolver:(X,ce)=>((0,ne.checkProposedApiEnabled)(Re),at.registerRemoteAuthorityResolver(X,ce)),registerResourceLabelFormatter:X=>((0,ne.checkProposedApiEnabled)(Re),Jt.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,ce,ke)=>At.onDidCreateFile(X,ce,ke),onDidDeleteFiles:(X,ce,ke)=>At.onDidDeleteFile(X,ce,ke),onDidRenameFiles:(X,ce,ke)=>At.onDidRenameFile(X,ce,ke),onWillCreateFiles:(X,ce,ke)=>At.getOnWillCreateFileEvent(Re)(X,ce,ke),onWillDeleteFiles:(X,ce,ke)=>At.getOnWillDeleteFileEvent(Re)(X,ce,ke),onWillRenameFiles:(X,ce,ke)=>At.getOnWillRenameFileEvent(Re)(X,ce,ke),openTunnel:X=>((0,ne.checkProposedApiEnabled)(Re),Le.openTunnel(Re,X).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,ne.checkProposedApiEnabled)(Re),Le.getTunnels()},onDidChangeTunnels:(X,ce,ke)=>((0,ne.checkProposedApiEnabled)(Re),Le.onDidChangeTunnels(X,ce,ke)),registerPortAttributesProvider:(X,ce)=>((0,ne.checkProposedApiEnabled)(Re),Le.registerPortsAttributesProvider(X,ce)),registerTimelineProvider:(X,ce)=>((0,ne.checkProposedApiEnabled)(Re),vn.registerTimelineProvider(X,ce,Re.identifier,Ge.converter)),get isTrusted(){return(0,ne.checkProposedApiEnabled)(Re),Ze.trusted},requestWorkspaceTrust:X=>((0,ne.checkProposedApiEnabled)(Re),Ze.requestWorkspaceTrust(X)),onDidReceiveWorkspaceTrust:(X,ce,ke)=>Ze.onDidReceiveWorkspaceTrust(X,ce,ke)},mn={get inputBox(){return Ie.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),un.getLastInputBox(Re)},createSourceControl(X,ce,ke){return un.createSourceControl(Re,X,ce,ke)}},Ut={createCommentController(X,ce){return pn.createCommentController(Re,X,ce)}},jt={get activeDebugSession(){return ot.activeDebugSession},get activeDebugConsole(){return ot.activeDebugConsole},get breakpoints(){return ot.breakpoints},onDidStartDebugSession(X,ce,ke){return ot.onDidStartDebugSession(X,ce,ke)},onDidTerminateDebugSession(X,ce,ke){return ot.onDidTerminateDebugSession(X,ce,ke)},onDidChangeActiveDebugSession(X,ce,ke){return ot.onDidChangeActiveDebugSession(X,ce,ke)},onDidReceiveDebugSessionCustomEvent(X,ce,ke){return ot.onDidReceiveDebugSessionCustomEvent(X,ce,ke)},onDidChangeBreakpoints(X,ce,ke){return ot.onDidChangeBreakpoints(X,ce,ke)},registerDebugConfigurationProvider(X,ce,ke){return ot.registerDebugConfigurationProvider(X,ce,ke||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,ce){return ot.registerDebugAdapterDescriptorFactory(Re,X,ce)},registerDebugAdapterTrackerFactory(X,ce){return ot.registerDebugAdapterTrackerFactory(X,ce)},startDebugging(X,ce,ke){return!ke||typeof ke=="object"&&"configuration"in ke?ot.startDebugging(X,ce,{parentSession:ke}):ot.startDebugging(X,ce,ke||{})},stopDebugging(X){return ot.stopDebugging(X)},addBreakpoints(X){return ot.addBreakpoints(X)},removeBreakpoints(X){return ot.removeBreakpoints(X)},asDebugSourceUri(X,ce){return ot.asDebugSourceUri(X,ce)}},kn={registerTaskProvider:(X,ce)=>pt.registerTaskProvider(Re,X,ce),fetchTasks:X=>pt.fetchTasks(X),executeTask:X=>pt.executeTask(Re,X),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(X,ce,ke)=>pt.onDidStartTask(X,ce,ke),onDidEndTask:(X,ce,ke)=>pt.onDidEndTask(X,ce,ke),onDidStartTaskProcess:(X,ce,ke)=>pt.onDidStartTaskProcess(X,ce,ke),onDidEndTaskProcess:(X,ce,ke)=>pt.onDidEndTaskProcess(X,ce,ke)},on={openNotebookDocument:X=>((0,ne.checkProposedApiEnabled)(Re),ft.openNotebookDocument(X)),get onDidOpenNotebookDocument(){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidSaveNotebookDocument},get notebookDocuments(){return(0,ne.checkProposedApiEnabled)(Re),ft.notebookDocuments.map(X=>X.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeActiveNotebookKernel},registerNotebookSerializer(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.registerNotebookSerializer(Re,X,ce,ke)},registerNotebookContentProvider:(X,ce,ke)=>((0,ne.checkProposedApiEnabled)(Re),ft.registerNotebookContentProvider(Re,X,ce,ke)),registerNotebookKernelProvider:(X,ce)=>((0,ne.checkProposedApiEnabled)(Re),ft.registerNotebookKernelProvider(Re,X,ce)),registerNotebookCellStatusBarItemProvider:(X,ce)=>((0,ne.checkProposedApiEnabled)(Re),ft.registerNotebookCellStatusBarItemProvider(Re,X,ce)),createNotebookEditorDecorationType(X){return(0,ne.checkProposedApiEnabled)(Re),ft.createNotebookEditorDecorationType(X)},onDidChangeNotebookDocumentMetadata(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookDocumentMetadata(X,ce,ke)},onDidChangeNotebookCells(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookCells(X,ce,ke)},onDidChangeCellExecutionState(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookCellExecutionState(X,ce,ke)},onDidChangeCellOutputs(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeCellOutputs(X,ce,ke)},onDidChangeCellMetadata(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeCellMetadata(X,ce,ke)},createConcatTextDocument(X,ce){return(0,ne.checkProposedApiEnabled)(Re),new j.ExtHostNotebookConcatDocument(ft,bt,X,ce)},createNotebookCellExecutionTask(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.createNotebookCellExecution(X,ce,ke)},createNotebookController(X,ce,ke,st,x){return(0,ne.checkProposedApiEnabled)(Re),Kt.createNotebookController(Re,X,ce,ke,st,x)}};return{version:We.version,authentication:_n,commands:En,comments:Ut,debug:jt,env:Vt,extensions:Sn,languages:Dn,notebook:on,scm:mn,tasks:kn,test:yn,window:Cn,workspace:sn,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:I.CancellationError,CancellationTokenSource:C.CancellationTokenSource,CandidatePortSource:h.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,EventEmitter:P.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:f.FileType,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,Hover:N.Hover,IndentAction:T.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:n.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,UIKind:h.UIKind,Uri:D.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlineHint:N.InlineHint,InlineHintKind:N.InlineHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,RemoteTrustOption:Ee.RemoteTrustOption,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookDocumentMetadata:N.NotebookDocumentMetadata,NotebookCellMetadata:N.NotebookCellMetadata,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,LinkedEditingRanges:N.LinkedEditingRanges,TestItemStatus:N.TestItemStatus,TestResultState:N.TestResultState,TestMessage:N.TestMessage,TestMessageSeverity:N.TestMessageSeverity,WorkspaceTrustState:N.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ve}),define(be[226],we([0,1,62,100,31,99,34,76,39,40,102,103,104,79,78,71,75,101,77,49,74,94]),function(Y,e,E,C,I,P,S,D,y,n,T,k,f,h,r,a,p,d,b,g,c,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.registerSingleton)(h.IExtensionStoragePaths,h.ExtensionStoragePaths),(0,E.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,E.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,E.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration),(0,E.registerSingleton)(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),(0,E.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,E.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,E.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,E.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo),(0,E.registerSingleton)(C.IExtHostOutputService,C.ExtHostOutputService),(0,E.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch),(0,E.registerSingleton)(r.IExtHostStorage,r.ExtHostStorage),(0,E.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask),(0,E.registerSingleton)(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),(0,E.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,E.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow),(0,E.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,E.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,E.registerSingleton)(w.IExtHostTelemetry,w.ExtHostTelemetry)}),define(be[227],we([0,1,225,35,221,7,14,5]),function(Y,e,E,C,I,P,S,D){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var n;(function(r){var a;const p=(a=self.trustedTypes)===null||a===void 0?void 0:a.createPolicy("TrustedFunctionWorkaround",{createScript:(b,...g)=>{g.forEach(i=>{var l;if(!((l=self.trustedTypes)===null||l===void 0?void 0:l.isScript(i)))throw new Error("TrustedScripts only, please")});const c=g.slice(0,-1).join(","),w=g.pop().toString();return`(function anonymous(${c}) {
${w}
})`}});function d(...b){return p?self.eval(p.createScript("",...b)):new Function(...b)}r.create=d})(n||(n={}));class T extends I.RequireInterceptor{_installInterceptor(){}getModule(a,p){for(let d of this._alternatives){let b=d(a);if(b){a=b;break}}if(this._factories.has(a))return this._factories.get(a).load(a,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class k extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const a=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);h(a,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(E.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(T,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(a){return a.browser}async _loadCommonJSModule(a,p,d){var b,g,c,w,t,i,l,s;p=p.with({path:f(p.path,".js")}),a&&performance.mark(`code/extHost/willFetchExtensionCode/${a.value}`);const o=await fetch(p.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a.value}`),o.status!==200)throw new Error(o.statusText);const u=await o.text(),v=`${p.toString(!0)}#vscode-extension`,A=`${u}
//# sourceURL=${v}`;let m;try{m=n.create((g=(b=k._ttpExtensionScripts)===null||b===void 0?void 0:b.createScript("module"))!==null&&g!==void 0?g:"module",(w=(c=k._ttpExtensionScripts)===null||c===void 0?void 0:c.createScript("exports"))!==null&&w!==void 0?w:"exports",(i=(t=k._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&i!==void 0?i:"require",(s=(l=k._ttpExtensionScripts)===null||l===void 0?void 0:l.createScript(A))!==null&&s!==void 0?s:A)}catch(V){throw a?console.error(`Loading code for extension ${a.value} failed: ${V.message}`):console.error(`Loading code failed: ${V.message}`),console.error(`${p.toString(!0)}${typeof V.line=="number"?` line ${V.line}`:""}${typeof V.column=="number"?` column ${V.column}`:""}`),console.error(V),V}const _={},R={exports:_},L=V=>{const he=this._fakeModules.getModule(V,p);if(he===void 0)throw new Error(`Cannot load module '${V}'`);return he};try{return d.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a.value}`),m(R,_,L),R.exports!==_?R.exports:_}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a.value}`),d.codeLoadingStop()}}async $setRemoteEnvironment(a){throw new Error("Not supported")}async _waitForDebuggerAttachment(a=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const p=Date.now()+a;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,S.timeout)(10)}}}e.ExtHostExtensionService=k,k._ttpExtensionScripts=(y=self.trustedTypes)===null||y===void 0?void 0:y.createPolicy("ExtensionScripts",{createScript:r=>r});function f(r,a){return r.endsWith(a)?r:r+a}function h(r,a){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(g,c){const w=console[g];console[g]=function(){r.$logExtensionHostMessage({type:"__$console",severity:c,arguments:b(arguments)}),a&&w.apply(console,arguments)}}const d=1e5;function b(g){const c=[],w=[];if(g.length)for(let t=0;t<g.length;t++){if(typeof g[t]=="undefined")g[t]="undefined";else if(g[t]instanceof Error){const i=g[t];i.stack?g[t]=i.stack:g[t]=i.toString()}w.push(g[t])}try{const t=JSON.stringify(w,function(i,l){if(l&&typeof l=="object"){if(c.indexOf(l)!==-1)return"[Circular]";c.push(l)}return l});return t.length>d?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(be[228],we([0,1,62,19,35,227,213]),function(Y,e,E,C,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.registerSingleton)(I.IExtHostExtensionService,P.ExtHostExtensionService),(0,E.registerSingleton)(C.ILogService,S.ExtHostLogService)}),define(be[230],we([0,1,23,3,184,222,215,13,80,226,228]),function(Y,e,E,C,I,P,S,D,y){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0});const T=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const k=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const p=(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("extensionHostWorker",{createScriptURL:b=>b}),d=self.Worker;Worker=function(b,g){const c=`importScripts('${b}');`;g=g||{},g.name=g.name||D.basename(b.toString());const w=new Blob([c],{type:"application/javascript"}),t=URL.createObjectURL(w);return new d(p?p.createScriptURL(t):t,g)}}else self.Worker=class extends S.NestedWorker{constructor(p,d){super(k,p,Object.assign({name:D.basename(p.toString())},d))}};const f=new class{exit(p){T()}async exists(p){return!0}async realpath(p){return p}};class h{constructor(){const d=new MessageChannel,b=new C.Emitter;let g=!1;k(d.port2,[d.port2]),d.port1.onmessage=c=>{const{data:w}=c;if(!(w instanceof ArrayBuffer)){console.warn("UNKNOWN data received",w);return}const t=E.VSBuffer.wrap(new Uint8Array(w,0,w.byteLength));if((0,I.isMessageOfType)(t,2)){g=!0,a("received terminate message from renderer");return}b.fire(t)},this.protocol={onMessage:b.event,send:c=>{if(!g){const w=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);d.port1.postMessage(w,[w])}}}}}function r(p){return new Promise(d=>{const b=p.onMessage(g=>{b.dispose();const c=JSON.parse(g.toString());p.send((0,I.createMessageOfType)(0)),d({protocol:p,initData:c})});p.send((0,I.createMessageOfType)(1))})}let a=p=>T();(function(){const d=new h;y.mark("code/extHost/willConnectToRenderer"),r(d.protocol).then(b=>{y.mark("code/extHost/didWaitForInitData");const g=new P.ExtensionHostMain(b.protocol,b.initData,f,null);a=c=>g.terminate(c)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8aff878db2542eea2dfb571c8bb485118bbb3113/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
